(function() {

    var defaultId = 0;

    SceneJS.Types.addType("objects/vehicles/tank", {

        init:function (params) {

            var id = "vehicles.tank." + (params.id || defaultId++);

            this.addNode(build(id, params));

            var scene = this.getScene();

            this._tankTranslate = scene.getNode(id + ".pos");
            this._tankRotate = scene.getNode(id + ".dir");
            this._gunRotate = scene.getNode(id + ".gunDir");

            if (params.pos) {
                this.setPos(params.pos);
            }
            if (params.dir != undefined) {
                this.setDir(params.dir);
            }
            if (params.gunDir != undefined) {
                this.setGunDir(params.gunDir);
            }
        },

        setPos: function(pos) {
            this._tankTranslate.setXYZ(pos);
        },

        getPos: function() {
            return this._tankTranslate.getXYZ();
        },

        setDir: function(dir) {
            this._tankRotate.setAngle(dir);
        },

        getDir: function() {
            return this._tankRotate.getAngle();
        },

        setGunDir: function(gunDir) {
            this._gunRotate.setAngle(gunDir);
        },

        getGunDir: function() {
            return this._gunRotate.getAngle();
        }
    });

            function build(id, cfg) {
                return {
                    "id": id,
                    "type": "node",
                    "nodes": [{
                            "type": "node",
                            "nodes": [{
                                    "type": "node",
                                    "nodes": [{
                                            "type": "node",
                                            "nodes": [{
                                                    "type": "node",
                                                    "nodes": [

                                                        {
                                                            "type": "translate",
                                                            "id": id + ".pos",
                                                            "x": 0,
                                                            "y": 0,
                                                            "z": 0,
                                                            "nodes": [{
                                                                    "type": "rotate",
                                                                    "id": id + ".dir",
                                                                    "x": 0,
                                                                    "y": 1,
                                                                    "z": 0,
                                                                    "angle": 0,
                                                                    "nodes": [{
                                                                            "type": "translate",
                                                                            "x": 7,
                                                                            "y": 0,
                                                                            "z": 7,
                                                                            "nodes": [{
                                                                                    "type": "rotate",
                                                                                    "x": 1,
                                                                                    "y": 0,
                                                                                    "z": 0,
                                                                                    "angle": 270,
                                                                                    "nodes": [{
                                                                                            "type": "scale",
                                                                                            "x": 0.1,
                                                                                            "y": 0.1,
                                                                                            "z": 0.1,
                                                                                            "nodes": [{
                                                                                                    "type": "node",
                                                                                                    "nodes": [{
                                                                                                            "type": "node",
                                                                                                            "nodes": [{
                                                                                                                    "type": "node",
                                                                                                                    "nodes": [{
                                                                                                                            "type": "node",
                                                                                                                            "nodes": [{
                                                                                                                                    "type": "material",
                                                                                                                                    "baseColor": {
                                                                                                                                        "r": 0.172549,
                                                                                                                                        "g": 0.184314,
                                                                                                                                        "b": 0.2
                                                                                                                                    },
                                                                                                                                    "specularColor": {
                                                                                                                                        "r": 0.33,
                                                                                                                                        "g": 0.33,
                                                                                                                                        "b": 0.33,
                                                                                                                                        "a": 1
                                                                                                                                    },
                                                                                                                                    "shine": 10,
                                                                                                                                    "specular": 1,
                                                                                                                                    "nodes": [{
                                                                                                                                            "type": "geometry",

                                                                                                                                            "positions": [-133.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -97.855244,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -133.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -133.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -97.855244,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -133.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -97.855244,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -133.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -133.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -135.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -133.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -133.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -135.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -135.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -135.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -133.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -135.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -135.956188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -135.956188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -135.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -133.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -133.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -133.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -135.956188,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -133.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -133.711995,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -133.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -133.711995,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -133.484506,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -133.711995,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -133.484506,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -133.289225,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -133.484506,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -133.289225,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -133.13946,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -133.289225,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -133.13946,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -133.045417,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -133.13946,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -133.045417,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -135.956188,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -133.013505,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -135.956188,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -133.045417,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -135.956188,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -133.013505,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -133.045899,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -133.013505,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -133.045899,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -133.140391,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -133.045899,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -133.140391,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -133.290542,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -133.140391,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -133.290542,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -133.486119,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -133.486119,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -133.290542,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -97.385175,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -97.189598,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -97.385175,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -133.290542,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -97.189598,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -59.464986,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -97.385175,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -59.464986,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -97.189598,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -59.615137,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -97.039448,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -59.615137,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -97.189598,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -59.615137,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -97.039448,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -59.709628,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -96.944956,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -59.709628,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -97.039448,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -59.709628,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -96.944956,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -59.742022,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -96.912562,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -59.742022,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -96.944956,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -59.742022,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -96.912562,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -59.71011,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -96.944474,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -59.71011,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -96.912562,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -59.71011,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -96.944474,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -59.616068,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -97.038517,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -59.616068,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -96.944474,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -59.616068,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -97.038517,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -59.466303,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -97.188282,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -59.466303,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -97.038517,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -97.188282,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -97.383562,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -59.466303,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -97.188282,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -133.289225,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -97.383562,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -133.289225,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -97.188282,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -133.13946,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -97.038517,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -133.13946,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -97.188282,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -133.13946,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -97.038517,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -133.045417,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -96.944474,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -133.045417,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -97.038517,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -133.045417,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -96.944474,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -133.013505,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -96.912562,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -133.013505,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -96.944474,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -133.013505,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -96.912562,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -133.045899,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -96.944956,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -133.045899,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -96.912562,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -133.045899,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -96.944956,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -133.140391,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -97.039448,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -133.140391,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -96.944956,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -97.039448,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -97.189598,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -133.140391,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -133.290542,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -133.140391,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -97.189598,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -133.484506,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -97.383562,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -133.289225,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -97.383562,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -133.484506,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -97.611051,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -133.711995,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -97.611051,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -133.484506,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -133.711995,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -133.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -97.611051,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -97.855244,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -97.611051,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -133.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -97.855244,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -58.79934,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -97.611051,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -97.855244,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -58.79934,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -58.79934,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -58.79934,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -22.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -20.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -34.470004,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -34.470004,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -34.470004,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -34.470004,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -28.378577,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -28.378577,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                50.715, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                53.215, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                50.715, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                53.215, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                50.715, -26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -28.378577,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                50.715, -28.378577,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                50.715, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                50.715, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                50.715, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                50.715, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                50.715, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -76.987306,
                                                                                                                                                38.629022,
                                                                                                                                                53.215, -76.987306,
                                                                                                                                                38.629022,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -76.987306,
                                                                                                                                                38.629022,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -76.987306,
                                                                                                                                                38.629022,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                53.215, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                50.715, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                53.215, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                53.215, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                53.215, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                50.715, -86.033799,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                50.715, -95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -86.033799,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                50.715, -95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                50.715, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                50.715, -79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -79.942372,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -79.942372,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -79.942372,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -86.033799,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                53.215, -86.033799,
                                                                                                                                                51.087443,
                                                                                                                                                50.715, -95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -79.942372,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                50.715, -79.942372,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                53.215, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                53.215, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                53.215, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                49.279355, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                49.107311, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                49.279355, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                49.279355, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                49.107311, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                49.107311, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                49.107311, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -65.303973,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -135.956188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -135.956188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -135.956188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -135.956188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -135.956188,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                50.715, -135.956188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -135.957566,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -135.957566,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -138.206188,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -135.956188,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -138.206188,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -135.957566,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -135.956188,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -135.956388,
                                                                                                                                                162.788572,
                                                                                                                                                16.013164, -138.206188,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -135.956388,
                                                                                                                                                162.788572,
                                                                                                                                                16.013164, -135.956188,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -135.957566,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -135.956388,
                                                                                                                                                162.788572,
                                                                                                                                                16.013164, -135.957566,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -135.955704,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -135.956388,
                                                                                                                                                162.788572,
                                                                                                                                                16.013164, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -135.956388,
                                                                                                                                                162.788572,
                                                                                                                                                16.013164, -135.955704,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -135.956188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -135.956079,
                                                                                                                                                87.83307,
                                                                                                                                                4.725, -135.956188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -135.955704,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -135.956188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -135.956388,
                                                                                                                                                162.788572,
                                                                                                                                                16.013164, -135.956188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -95.175013,
                                                                                                                                                49.724827,
                                                                                                                                                29.418523, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -95.175013,
                                                                                                                                                49.724827,
                                                                                                                                                29.418523, -95.175013,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -95.175013,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -95.175013,
                                                                                                                                                49.724827,
                                                                                                                                                29.418523, -133.956188,
                                                                                                                                                66.004096,
                                                                                                                                                0, -133.956188,
                                                                                                                                                66.004096,
                                                                                                                                                0, -95.175013,
                                                                                                                                                49.724827,
                                                                                                                                                29.418523, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -135.956188,
                                                                                                                                                66.004096,
                                                                                                                                                0, -133.956188,
                                                                                                                                                66.004096,
                                                                                                                                                0, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -135.955704,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -133.956188,
                                                                                                                                                66.004096,
                                                                                                                                                0, -135.956188,
                                                                                                                                                66.004096,
                                                                                                                                                0, -133.956188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -133.956188,
                                                                                                                                                66.004096,
                                                                                                                                                0, -135.955704,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -133.956188,
                                                                                                                                                66.004096,
                                                                                                                                                0, -133.956188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -95.175013,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -95.175013,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -95.175013,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -133.956188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -95.175013,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -95.175013,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -61.479571,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -61.479571,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -61.479571,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -95.175013,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -61.479571,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -61.479571,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -22.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -22.698396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -22.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -61.479571,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -22.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -22.698396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -20.69888,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -20.69888,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -22.698396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -22.696534,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -22.696534,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -22.698396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -61.479571,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -58.797478,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -22.696534,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -61.479571,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -58.797478,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -59.041734,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -22.696534,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -58.797478,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -97.857107,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -59.041734,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -58.797478,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -61.479571,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -97.857107,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -95.175013,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -97.857107,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -61.479571,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -97.857107,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -95.175013,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -133.95805,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -95.175013,
                                                                                                                                                114.347958,
                                                                                                                                                27.230529, -133.956188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -133.95805,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -133.956188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -135.955704,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -133.95805,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -133.95805,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -135.955704,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -133.95805,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -133.713793,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -133.713793,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -133.713793,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -138.206188,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -135.956188,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -135.956188,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -138.206188,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -138.206188,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -138.206188,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -138.206188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -138.206188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -138.206188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -138.206188,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -138.206188,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -135.956188,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -138.206188,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -135.956188,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -135.956188,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -138.206188,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -135.956188,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -133.486119,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -133.486119,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -133.713793,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -135.956188,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -133.713793,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -133.486119,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -97.61285,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -97.385175,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -97.61285,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -133.486119,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -97.385175,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -59.269409,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -97.61285,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -59.269409,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -97.385175,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -59.464986,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -59.464986,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -23.364042,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -59.269409,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -23.364042,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -59.464986,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -23.514193,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -59.615137,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -23.514193,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -59.464986,
                                                                                                                                                182.853733,
                                                                                                                                                37.76594, -59.615137,
                                                                                                                                                183.167162,
                                                                                                                                                38.17441, -59.709628,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -23.514193,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -23.608685,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -23.514193,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -59.709628,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -23.608685,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -23.514193,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -23.608685,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -20.698396,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -23.641079,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -20.698396,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -23.608685,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -20.698396,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -23.641079,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -23.609167,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -23.641079,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -23.609167,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -23.515124,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -23.609167,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -23.515124,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -23.365359,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -23.515124,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -23.365359,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -23.170078,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -23.170078,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -23.365359,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -59.271022,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -59.466303,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -59.271022,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -23.365359,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -59.271022,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -59.466303,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -97.383562,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -97.383562,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -97.611051,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -59.271022,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -59.043533,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -59.271022,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -97.611051,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -59.271022,
                                                                                                                                                182.445263,
                                                                                                                                                40.868573, -59.043533,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -23.170078,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -22.94259,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -23.170078,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -59.043533,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -23.170078,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -22.94259,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -22.94259,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -18.448396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -18.448396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -18.448396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -20.698396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -18.448396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -20.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -20.698396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -20.698396,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -22.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -22.698396,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -22.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -20.698396,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -22.698396,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -22.698396,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -58.79934,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -22.698396,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -22.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -58.79934,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -22.698396,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -20.698396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -22.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -20.698396,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -20.698396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -22.698396,
                                                                                                                                                169.725911,
                                                                                                                                                47.565, -22.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -20.698396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -22.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -22.94259,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -22.94259,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -22.94259,
                                                                                                                                                216.841278,
                                                                                                                                                41.100013, -59.043533,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -22.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -58.79934,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -22.698396,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793, -59.043533,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -59.043533,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -97.611051,
                                                                                                                                                181.969591,
                                                                                                                                                41.065604, -58.79934,
                                                                                                                                                181.459131,
                                                                                                                                                38.641437, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -18.448396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -18.448396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -20.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -20.698396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -20.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -20.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -22.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -22.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -34.470004,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -22.698396,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -34.470004,
                                                                                                                                                41.224827,
                                                                                                                                                50.715, -30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                53.215, -35.082627,
                                                                                                                                                40.426442,
                                                                                                                                                50.612745, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -20.698396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -20.698396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -20.698396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                46.93075, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                46.378261, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -138.206188,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -138.206188,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -138.206188,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -138.206188,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -138.206188,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -135.956388,
                                                                                                                                                162.788572,
                                                                                                                                                16.013164, -138.206188,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -135.956388,
                                                                                                                                                162.788572,
                                                                                                                                                16.013164, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -23.170078,
                                                                                                                                                217.316951,
                                                                                                                                                40.902983, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -20.698396,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -18.448396,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -20.698396,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -18.448396,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -18.448396,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -18.448396,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -18.448396,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -18.448396,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -32.112072,
                                                                                                                                                125.529897,
                                                                                                                                                10.666287, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -32.112072,
                                                                                                                                                125.529897,
                                                                                                                                                10.666287, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -20.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -32.112072,
                                                                                                                                                125.529897,
                                                                                                                                                10.666287, -20.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -22.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -22.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -61.479571,
                                                                                                                                                49.724827,
                                                                                                                                                29.418523, -61.479571,
                                                                                                                                                49.724827,
                                                                                                                                                29.418523, -20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                4.725, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -95.175013,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -61.479571,
                                                                                                                                                49.724827,
                                                                                                                                                29.418523, -95.175013,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -95.175013,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -61.479571,
                                                                                                                                                11.678311,
                                                                                                                                                34.532116, -61.479571,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -61.479571,
                                                                                                                                                49.724827,
                                                                                                                                                29.418523, -95.175013,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -61.479571,
                                                                                                                                                66.004096,
                                                                                                                                                27.230529, -22.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -61.479571,
                                                                                                                                                49.724827,
                                                                                                                                                29.418523, -20.69888,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -20.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -22.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -20.698396,
                                                                                                                                                66.004096,
                                                                                                                                                0, -20.69888,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -32.112072,
                                                                                                                                                125.529897,
                                                                                                                                                10.666287, -20.69888,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -32.111917,
                                                                                                                                                162.829169,
                                                                                                                                                19.358173, -32.112072,
                                                                                                                                                125.529897,
                                                                                                                                                10.666287, -20.69888,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                37.222687, -32.111917,
                                                                                                                                                162.829169,
                                                                                                                                                19.358173, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                37.222687, -20.69888,
                                                                                                                                                114.3481,
                                                                                                                                                10.464322, -22.696534,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                37.222687, -22.696534,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -22.940791,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -22.940791,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -22.696534,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -59.041734,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -22.940791,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -59.041734,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -23.168466,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -59.269409,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -23.168466,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -59.041734,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -23.168466,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -59.269409,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -23.364042,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -23.168466,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -23.364042,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -23.364042,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -18.448396,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -20.697018,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -20.697018,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -20.698396,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -18.448396,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -20.698396,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -18.448396,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -18.448396,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -20.698396,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -20.698396,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -18.448396,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -32.111917,
                                                                                                                                                162.829169,
                                                                                                                                                19.358173, -32.111917,
                                                                                                                                                162.829169,
                                                                                                                                                19.358173, -18.448396,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -32.112072,
                                                                                                                                                125.529897,
                                                                                                                                                10.666287, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                4.725, -32.112072,
                                                                                                                                                125.529897,
                                                                                                                                                10.666287, -18.448396,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315, -20.698396,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -32.111917,
                                                                                                                                                162.829169,
                                                                                                                                                19.358173, -20.697018,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -32.111917,
                                                                                                                                                162.829169,
                                                                                                                                                19.358173, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                37.222687, -20.697018,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -20.697018,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                37.222687, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -20.698396,
                                                                                                                                                216.330819,
                                                                                                                                                37.222687, -22.940791,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -22.940791,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -23.168466,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -20.698396,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -20.698396,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -23.168466,
                                                                                                                                                217.316951,
                                                                                                                                                37.486921, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -18.448396,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -18.448396,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -20.698396,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -23.364042,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -23.514193,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -23.364042,
                                                                                                                                                217.72542,
                                                                                                                                                37.80035, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -23.514193,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                38.20882, -18.448396,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -18.448396,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -18.448396,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -20.698396,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -59.041734,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -97.61285,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -59.269409,
                                                                                                                                                182.445263,
                                                                                                                                                37.452511, -97.61285,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -59.041734,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -97.857107,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -97.857107,
                                                                                                                                                181.459131,
                                                                                                                                                33.67133, -133.95805,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -97.61285,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -133.713793,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -97.61285,
                                                                                                                                                181.969591,
                                                                                                                                                37.255481, -133.95805,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -18.448396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -18.448396,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266, -20.698396,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -20.698396,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                197.829904,
                                                                                                                                                42.21, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -18.448396,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078, -18.448396,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -18.448396,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -18.448396,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -18.448396,
                                                                                                                                                0,
                                                                                                                                                31.011023, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -18.448396,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -18.448396,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -18.448396,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -18.448396,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -18.448396,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -18.448396,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                45.578192, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -138.206188,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -95.175013,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -61.479571,
                                                                                                                                                9.540934,
                                                                                                                                                35.084605, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -18.448396,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866, -18.448396,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -18.448396,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -18.448396,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -61.479571,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -18.448396,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -61.479571,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -61.479571,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -18.448396,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -18.448396,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -18.448396,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -61.479571,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -95.175013,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -95.175013,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -95.175013,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -138.206188,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -95.175013,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -138.206188,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -138.206188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -138.206188,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -61.479571,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -95.175013,
                                                                                                                                                7.647598,
                                                                                                                                                35.884674, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                36.897245, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                38.077923, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -138.206188,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -138.206188,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -138.206188,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -95.175013,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -95.175013,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -61.479571,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -61.479571,
                                                                                                                                                3.942483,
                                                                                                                                                40.731433, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                39.374941, -61.479571,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -95.175013,
                                                                                                                                                4.187232,
                                                                                                                                                42.087925, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -138.206188,
                                                                                                                                                7.647598,
                                                                                                                                                39.622, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -95.175013,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -138.206188,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -138.206188,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654, -95.175013,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -61.479571,
                                                                                                                                                4.910749,
                                                                                                                                                43.384943, -18.448396,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341, -61.479571,
                                                                                                                                                6.081312,
                                                                                                                                                44.565621, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -138.206188,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -138.206188,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866, -135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                42.21, -23.365359,
                                                                                                                                                217.72542,
                                                                                                                                                40.589554, -23.515124,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -59.466303,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -59.616068,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -59.466303,
                                                                                                                                                182.853733,
                                                                                                                                                40.555144, -23.515124,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -23.515124,
                                                                                                                                                218.03885,
                                                                                                                                                40.181084, -23.609167,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -59.616068,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -59.71011,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -59.616068,
                                                                                                                                                183.167162,
                                                                                                                                                40.146675, -23.609167,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -23.609167,
                                                                                                                                                218.23588,
                                                                                                                                                39.705412, -23.641079,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -59.71011,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -59.742022,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -59.71011,
                                                                                                                                                183.364192,
                                                                                                                                                39.671002, -23.641079,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -23.641079,
                                                                                                                                                218.303083,
                                                                                                                                                39.194952, -23.608685,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -59.742022,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -59.709628,
                                                                                                                                                183.364192,
                                                                                                                                                38.650083, -59.742022,
                                                                                                                                                183.431396,
                                                                                                                                                39.160542, -23.608685,
                                                                                                                                                218.23588,
                                                                                                                                                38.684492, -135.956188,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686, -135.957566,
                                                                                                                                                216.33096,
                                                                                                                                                33.713832, -135.956188,
                                                                                                                                                216.841278,
                                                                                                                                                37.289891, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                49.279355, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -57.206188,
                                                                                                                                                31.262563,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                53.215, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                53.215,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "normals": [
                                                                                                                                                0.179041,
                                                                                                                                                0.18415,
                                                                                                                                                0.966454,
                                                                                                                                                0.179041,
                                                                                                                                                0.18415,
                                                                                                                                                0.966454,
                                                                                                                                                0.179041,
                                                                                                                                                0.18415,
                                                                                                                                                0.966454,
                                                                                                                                                0.282773, -0.149452,
                                                                                                                                                0.947472,
                                                                                                                                                0.282773, -0.149452,
                                                                                                                                                0.947472,
                                                                                                                                                0.282773, -0.149452,
                                                                                                                                                0.947472,
                                                                                                                                                0.120043,
                                                                                                                                                0.102952,
                                                                                                                                                0.987416,
                                                                                                                                                0.120043,
                                                                                                                                                0.102952,
                                                                                                                                                0.987416,
                                                                                                                                                0.120043,
                                                                                                                                                0.102952,
                                                                                                                                                0.987416,
                                                                                                                                                0,
                                                                                                                                                0.108788,
                                                                                                                                                0.994065,
                                                                                                                                                0,
                                                                                                                                                0.108788,
                                                                                                                                                0.994065,
                                                                                                                                                0,
                                                                                                                                                0.108788,
                                                                                                                                                0.994065,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0, -0.978387,
                                                                                                                                                0.206783, -0.364372, -0.903042,
                                                                                                                                                0.227483, -0.447838, -0.368344,
                                                                                                                                                0.814717, -0.166694, -0.407824,
                                                                                                                                                0.897715, -0.447838, -0.368344,
                                                                                                                                                0.814717, -0.364372, -0.903042,
                                                                                                                                                0.227483, -0.447838, -0.368344,
                                                                                                                                                0.814717, -0.166694, -0.407824,
                                                                                                                                                0.897715, -0.453389,
                                                                                                                                                0.441137,
                                                                                                                                                0.774491,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.453389,
                                                                                                                                                0.441137,
                                                                                                                                                0.774491, -0.166694, -0.407824,
                                                                                                                                                0.897715, -0.453389,
                                                                                                                                                0.441137,
                                                                                                                                                0.774491,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.428745,
                                                                                                                                                0.662903,
                                                                                                                                                0.613789,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.428745,
                                                                                                                                                0.662903,
                                                                                                                                                0.613789,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.428745,
                                                                                                                                                0.662903,
                                                                                                                                                0.613789,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.289515,
                                                                                                                                                0.849355,
                                                                                                                                                0.441336,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.289515,
                                                                                                                                                0.849355,
                                                                                                                                                0.441336,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.289515,
                                                                                                                                                0.849355,
                                                                                                                                                0.441336,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.151347,
                                                                                                                                                0.963066,
                                                                                                                                                0.222708,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.151347,
                                                                                                                                                0.963066,
                                                                                                                                                0.222708,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.151347,
                                                                                                                                                0.963066,
                                                                                                                                                0.222708,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.029325,
                                                                                                                                                0.999352, -0.020873,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.029325,
                                                                                                                                                0.999352, -0.020873,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.029325,
                                                                                                                                                0.999352, -0.020873,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.218296,
                                                                                                                                                0.940633, -0.259917,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.218296,
                                                                                                                                                0.940633, -0.259917,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.218296,
                                                                                                                                                0.940633, -0.259917,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.372095,
                                                                                                                                                0.803724, -0.464298,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.372095,
                                                                                                                                                0.803724, -0.464298,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.372095,
                                                                                                                                                0.803724, -0.464298,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.393434,
                                                                                                                                                0.652475, -0.647677,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.393434,
                                                                                                                                                0.652475, -0.647677,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.393434,
                                                                                                                                                0.652475, -0.647677,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529, -0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311, -0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529, -0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022, -0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529, -0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022, -0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135, -0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022, -0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135, -0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176, -0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135, -0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.313573,
                                                                                                                                                0.782435, -0.538022,
                                                                                                                                                0.247985,
                                                                                                                                                0.623409, -0.741529,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.166733, -0.40798,
                                                                                                                                                0.897637, -0.166694, -0.407824,
                                                                                                                                                0.897715, -0.166733, -0.40798,
                                                                                                                                                0.897637,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.166694, -0.407824,
                                                                                                                                                0.897715, -0.364372, -0.903042,
                                                                                                                                                0.227483, -0.166733, -0.40798,
                                                                                                                                                0.897637, -0.364377, -0.903138,
                                                                                                                                                0.227094, -0.166733, -0.40798,
                                                                                                                                                0.897637, -0.364372, -0.903042,
                                                                                                                                                0.227483, -0.364377, -0.903138,
                                                                                                                                                0.227094,
                                                                                                                                                0.364377, -0.903138,
                                                                                                                                                0.227094, -0.166733, -0.40798,
                                                                                                                                                0.897637,
                                                                                                                                                0,
                                                                                                                                                0.166795,
                                                                                                                                                0.985992,
                                                                                                                                                0,
                                                                                                                                                0.166795,
                                                                                                                                                0.985992,
                                                                                                                                                0,
                                                                                                                                                0.166795,
                                                                                                                                                0.985992,
                                                                                                                                                0,
                                                                                                                                                0.166795,
                                                                                                                                                0.985992,
                                                                                                                                                0,
                                                                                                                                                0.166795,
                                                                                                                                                0.985992,
                                                                                                                                                0,
                                                                                                                                                0.166795,
                                                                                                                                                0.985992, -0.120043,
                                                                                                                                                0.102952,
                                                                                                                                                0.987416, -0.120043,
                                                                                                                                                0.102952,
                                                                                                                                                0.987416, -0.120043,
                                                                                                                                                0.102952,
                                                                                                                                                0.987416,
                                                                                                                                                0,
                                                                                                                                                0.108788,
                                                                                                                                                0.994065,
                                                                                                                                                0,
                                                                                                                                                0.108788,
                                                                                                                                                0.994065,
                                                                                                                                                0,
                                                                                                                                                0.108788,
                                                                                                                                                0.994065,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.793353, -0.608761,
                                                                                                                                                0,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.965926, -0.258819,
                                                                                                                                                0,
                                                                                                                                                0.92388, -0.382683,
                                                                                                                                                0,
                                                                                                                                                0.965926, -0.258819,
                                                                                                                                                0,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.965926, -0.258819,
                                                                                                                                                0,
                                                                                                                                                0.965926, -0.258819,
                                                                                                                                                0,
                                                                                                                                                0.92388, -0.382683,
                                                                                                                                                0,
                                                                                                                                                0.965926, -0.258819,
                                                                                                                                                0,
                                                                                                                                                0.965926, -0.258819,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.965926, -0.258819,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0,
                                                                                                                                                0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0,
                                                                                                                                                0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0,
                                                                                                                                                0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0,
                                                                                                                                                0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0,
                                                                                                                                                0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0,
                                                                                                                                                0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0,
                                                                                                                                                0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0,
                                                                                                                                                0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0,
                                                                                                                                                0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0,
                                                                                                                                                0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0,
                                                                                                                                                0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0,
                                                                                                                                                0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0,
                                                                                                                                                0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0,
                                                                                                                                                0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0,
                                                                                                                                                0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0,
                                                                                                                                                0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0,
                                                                                                                                                0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0,
                                                                                                                                                0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0,
                                                                                                                                                0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0,
                                                                                                                                                0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0,
                                                                                                                                                0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0.707107, -0.707107,
                                                                                                                                                0,
                                                                                                                                                0.707107, -0.707107,
                                                                                                                                                0,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.707107, -0.707107,
                                                                                                                                                0,
                                                                                                                                                0.608761, -0.793353,
                                                                                                                                                0,
                                                                                                                                                0.707107, -0.707107,
                                                                                                                                                0,
                                                                                                                                                0.608761, -0.793353,
                                                                                                                                                0,
                                                                                                                                                0.707107, -0.707107,
                                                                                                                                                0,
                                                                                                                                                0.608761, -0.793353,
                                                                                                                                                0, -0.050022, -0.08156,
                                                                                                                                                0.995412, -0.063038, -0.066683,
                                                                                                                                                0.995781,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839, -0.063038, -0.066683,
                                                                                                                                                0.995781, -0.016443, -0.103258,
                                                                                                                                                0.994519,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839,
                                                                                                                                                0.382683, -0.92388,
                                                                                                                                                0,
                                                                                                                                                0.382683, -0.92388,
                                                                                                                                                0,
                                                                                                                                                0.382683, -0.92388,
                                                                                                                                                0,
                                                                                                                                                0.130526, -0.991445,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0.130526, -0.991445,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0, -0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0, -0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0, -0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1, -0.44644, -0.773258, -0.450293,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1, -0.44644, -0.773258, -0.450293, -0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0, -0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0, -0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0, -0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0, -0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0, -0.258819,
                                                                                                                                                0.965926,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0, -0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0, -0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0, -0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0, -0.5,
                                                                                                                                                0.866025,
                                                                                                                                                0, -0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1, -0.430459, -0.560986, -0.707107, -0.430459, -0.560986, -0.707107,
                                                                                                                                                0,
                                                                                                                                                0, -1, -0.44644, -0.773258, -0.450293, -0.430459, -0.560986, -0.707107, -0.631362, -0.631362, -0.450293, -0.44644, -0.773258, -0.450293, -0.631362, -0.631362, -0.450293,
                                                                                                                                                0,
                                                                                                                                                0, -1, -0.430459, -0.560986, -0.707107,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1, -0.631362, -0.631362, -0.450293, -0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0, -0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0, -0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0, -0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0, -0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0, -0.707107,
                                                                                                                                                0.707107,
                                                                                                                                                0, -0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0, -0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0, -0.92388,
                                                                                                                                                0.382683,
                                                                                                                                                0, -0.92388,
                                                                                                                                                0.382683,
                                                                                                                                                0, -0.92388,
                                                                                                                                                0.382683,
                                                                                                                                                0, -0.866025,
                                                                                                                                                0.5,
                                                                                                                                                0, -0.92388,
                                                                                                                                                0.382683,
                                                                                                                                                0, -0.92388,
                                                                                                                                                0.382683,
                                                                                                                                                0, -0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0, -0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0, -0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0, -0.92388,
                                                                                                                                                0.382683,
                                                                                                                                                0, -0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0, -0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -0.965926,
                                                                                                                                                0.258819,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -0.965926, -0.258819,
                                                                                                                                                0, -0.965926, -0.258819,
                                                                                                                                                0, -0.965926, -0.258819,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -0.965926, -0.258819,
                                                                                                                                                0, -0.92388, -0.382683,
                                                                                                                                                0, -0.965926, -0.258819,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.02668, -0.130718,
                                                                                                                                                0.991061,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.02668, -0.130718,
                                                                                                                                                0.991061,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.02668, -0.130718,
                                                                                                                                                0.991061,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0, -0.134511,
                                                                                                                                                0.990912, -0.02668, -0.130718,
                                                                                                                                                0.991061,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.041574, -0.260129,
                                                                                                                                                0.964678, -0.02668, -0.130718,
                                                                                                                                                0.991061,
                                                                                                                                                0, -0.134511,
                                                                                                                                                0.990912, -0.035668, -0.193566,
                                                                                                                                                0.980439, -0.02668, -0.130718,
                                                                                                                                                0.991061, -0.041574, -0.260129,
                                                                                                                                                0.964678, -0.02668, -0.130718,
                                                                                                                                                0.991061, -0.035668, -0.193566,
                                                                                                                                                0.980439,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972,
                                                                                                                                                0.010319, -0.132627,
                                                                                                                                                0.991112,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972, -0.035668, -0.193566,
                                                                                                                                                0.980439, -0.793353, -0.608761,
                                                                                                                                                0, -0.707107, -0.707107,
                                                                                                                                                0, -0.866025, -0.5,
                                                                                                                                                0, -0.631362, -0.631362, -0.450293, -0.866025, -0.5,
                                                                                                                                                0, -0.707107, -0.707107,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1, -0.631362, -0.631362, -0.450293,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1, -0.866025, -0.5,
                                                                                                                                                0, -0.965926, -0.258819,
                                                                                                                                                0, -0.866025, -0.5,
                                                                                                                                                0, -0.92388, -0.382683,
                                                                                                                                                0, -0.866025, -0.5,
                                                                                                                                                0, -0.965926, -0.258819,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.02668, -0.130718,
                                                                                                                                                0.991061,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.02668, -0.130718,
                                                                                                                                                0.991061, -0.866025, -0.5,
                                                                                                                                                0, -0.793353, -0.608761,
                                                                                                                                                0, -0.866025, -0.5,
                                                                                                                                                0, -0.631362, -0.631362, -0.450293, -0.707107, -0.707107,
                                                                                                                                                0, -0.44644, -0.773258, -0.450293, -0.5, -0.866025,
                                                                                                                                                0, -0.44644, -0.773258, -0.450293, -0.707107, -0.707107,
                                                                                                                                                0, -0.44644, -0.773258, -0.450293, -0.5, -0.866025,
                                                                                                                                                0, -0.258819, -0.965926,
                                                                                                                                                0, -0.258819, -0.965926,
                                                                                                                                                0, -0.258819, -0.965926,
                                                                                                                                                0, -0.5, -0.866025,
                                                                                                                                                0, -0.258819, -0.965926,
                                                                                                                                                0, -0.258819, -0.965926,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0, -0.258819, -0.965926,
                                                                                                                                                0,
                                                                                                                                                0.043842, -0.999038,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0.043842, -0.999038,
                                                                                                                                                0, -0.258819, -0.965926,
                                                                                                                                                0,
                                                                                                                                                0.043842, -0.999038,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0.130526, -0.991445,
                                                                                                                                                0, -0.016443, -0.103258,
                                                                                                                                                0.994519, -0.00019, -0.110417,
                                                                                                                                                0.993885,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839, -0.00019, -0.110417,
                                                                                                                                                0.993885,
                                                                                                                                                0.006208, -0.118434,
                                                                                                                                                0.992942,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839,
                                                                                                                                                0.006208, -0.118434,
                                                                                                                                                0.992942, -0.035668, -0.193566,
                                                                                                                                                0.980439,
                                                                                                                                                0.006208, -0.118434,
                                                                                                                                                0.992942,
                                                                                                                                                0.016436, -0.134325,
                                                                                                                                                0.990801, -0.035668, -0.193566,
                                                                                                                                                0.980439,
                                                                                                                                                0.016436, -0.134325,
                                                                                                                                                0.990801,
                                                                                                                                                0.010319, -0.132627,
                                                                                                                                                0.991112, -0.035668, -0.193566,
                                                                                                                                                0.980439, -0.035668, -0.193566,
                                                                                                                                                0.980439, -0.066111, -0.395955,
                                                                                                                                                0.915887,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839, -0.066111, -0.395955,
                                                                                                                                                0.915887, -0.035668, -0.193566,
                                                                                                                                                0.980439, -0.075284, -0.460528,
                                                                                                                                                0.884447, -0.035668, -0.193566,
                                                                                                                                                0.980439, -0.041574, -0.260129,
                                                                                                                                                0.964678, -0.075284, -0.460528,
                                                                                                                                                0.884447, -0.041574, -0.260129,
                                                                                                                                                0.964678,
                                                                                                                                                0, -0.247586,
                                                                                                                                                0.968866, -0.075284, -0.460528,
                                                                                                                                                0.884447, -0.041574, -0.260129,
                                                                                                                                                0.964678,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                0, -0.247586,
                                                                                                                                                0.968866, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.475487,
                                                                                                                                                0.703633, -0.528026,
                                                                                                                                                0.826537,
                                                                                                                                                0.18159, -0.532787,
                                                                                                                                                0.793327,
                                                                                                                                                0.322447, -0.516391,
                                                                                                                                                0.475487,
                                                                                                                                                0.703633, -0.528026,
                                                                                                                                                0.548409,
                                                                                                                                                0.707269, -0.446115,
                                                                                                                                                0.826537,
                                                                                                                                                0.18159, -0.532787,
                                                                                                                                                0.093233,
                                                                                                                                                0.985654, -0.140693,
                                                                                                                                                0.548409,
                                                                                                                                                0.707269, -0.446115,
                                                                                                                                                0.475487,
                                                                                                                                                0.703633, -0.528026, -0.00012,
                                                                                                                                                0.872388, -0.488813, -0.00012,
                                                                                                                                                0.872388, -0.488813, -0.000066,
                                                                                                                                                0.600804, -0.799397, -0.000066,
                                                                                                                                                0.600804, -0.799397, -0.000066,
                                                                                                                                                0.600804, -0.799397, -0.00012,
                                                                                                                                                0.872388, -0.488813, -0.000066,
                                                                                                                                                0.600804, -0.799397,
                                                                                                                                                0,
                                                                                                                                                0.22695, -0.973906, -0.000066,
                                                                                                                                                0.600804, -0.799397,
                                                                                                                                                1, -0.000066,
                                                                                                                                                0.000266,
                                                                                                                                                1, -0.000066,
                                                                                                                                                0.000266,
                                                                                                                                                1, -0.000066,
                                                                                                                                                0.000266,
                                                                                                                                                0.471524,
                                                                                                                                                0.674881, -0.567627,
                                                                                                                                                0.947843,
                                                                                                                                                0.100049, -0.302629,
                                                                                                                                                0.527197,
                                                                                                                                                0.266731, -0.806795,
                                                                                                                                                0.015725,
                                                                                                                                                0.208311, -0.977936,
                                                                                                                                                0.947843,
                                                                                                                                                0.100049, -0.302629,
                                                                                                                                                0.471524,
                                                                                                                                                0.674881, -0.567627,
                                                                                                                                                0.947843,
                                                                                                                                                0.100049, -0.302629,
                                                                                                                                                0.015725,
                                                                                                                                                0.208311, -0.977936,
                                                                                                                                                1,
                                                                                                                                                0.000002, -0.000012,
                                                                                                                                                1,
                                                                                                                                                0.000002, -0.000012,
                                                                                                                                                1,
                                                                                                                                                0.000002, -0.000012,
                                                                                                                                                0.015725,
                                                                                                                                                0.208311, -0.977936,
                                                                                                                                                0,
                                                                                                                                                0.114223, -0.993455,
                                                                                                                                                0,
                                                                                                                                                0.114223, -0.993455,
                                                                                                                                                0,
                                                                                                                                                0.22695, -0.973906,
                                                                                                                                                0,
                                                                                                                                                0.114223, -0.993455,
                                                                                                                                                0.241057, -0.215922, -0.946187,
                                                                                                                                                0,
                                                                                                                                                0.114223, -0.993455,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0,
                                                                                                                                                0.114223, -0.993455,
                                                                                                                                                0.241057, -0.215922, -0.946187,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0.241057, -0.215922, -0.946187,
                                                                                                                                                0.284728, -0.317067, -0.904654,
                                                                                                                                                0.241057, -0.215922, -0.946187,
                                                                                                                                                0.264677, -0.206919, -0.941876,
                                                                                                                                                0.284728, -0.317067, -0.904654,
                                                                                                                                                0.408378, -0.169148, -0.897004,
                                                                                                                                                0.264677, -0.206919, -0.941876,
                                                                                                                                                0.241057, -0.215922, -0.946187,
                                                                                                                                                0.408378, -0.169148, -0.897004,
                                                                                                                                                0.300938, -0.0637, -0.951514,
                                                                                                                                                0.264677, -0.206919, -0.941876,
                                                                                                                                                0.300938, -0.0637, -0.951514,
                                                                                                                                                0.408378, -0.169148, -0.897004,
                                                                                                                                                0.426648, -0.178389, -0.886651,
                                                                                                                                                0.426648, -0.178389, -0.886651,
                                                                                                                                                0.408378, -0.169148, -0.897004,
                                                                                                                                                0.241057, -0.215922, -0.946187,
                                                                                                                                                0, -0.278743, -0.960366,
                                                                                                                                                0.426648, -0.178389, -0.886651,
                                                                                                                                                0.241057, -0.215922, -0.946187,
                                                                                                                                                0.015725,
                                                                                                                                                0.208311, -0.977936, -0.638448,
                                                                                                                                                0.137511, -0.757281,
                                                                                                                                                0.707102,
                                                                                                                                                0.149593, -0.691106, -0.981758,
                                                                                                                                                0.03097, -0.187594, -0.638448,
                                                                                                                                                0.137511, -0.757281,
                                                                                                                                                0.015725,
                                                                                                                                                0.208311, -0.977936,
                                                                                                                                                0.426648, -0.178389, -0.886651,
                                                                                                                                                0.569639,
                                                                                                                                                0.131736, -0.811269,
                                                                                                                                                0.300938, -0.0637, -0.951514,
                                                                                                                                                0.256185,
                                                                                                                                                0.095376, -0.961911,
                                                                                                                                                0.300938, -0.0637, -0.951514,
                                                                                                                                                0.569639,
                                                                                                                                                0.131736, -0.811269,
                                                                                                                                                0.300938, -0.0637, -0.951514,
                                                                                                                                                0.256185,
                                                                                                                                                0.095376, -0.961911, -0.300938, -0.0637, -0.951514, -0.256185,
                                                                                                                                                0.095376, -0.961911, -0.300938, -0.0637, -0.951514,
                                                                                                                                                0.256185,
                                                                                                                                                0.095376, -0.961911, -0.300938, -0.0637, -0.951514, -0.256185,
                                                                                                                                                0.095376, -0.961911, -0.426648, -0.178389, -0.886651, -0.569639,
                                                                                                                                                0.131736, -0.811269, -0.426648, -0.178389, -0.886651, -0.256185,
                                                                                                                                                0.095376, -0.961911,
                                                                                                                                                0.638448,
                                                                                                                                                0.137511, -0.757281,
                                                                                                                                                0.981758,
                                                                                                                                                0.03097, -0.187594,
                                                                                                                                                0.900608, -0.113974,
                                                                                                                                                0.419422,
                                                                                                                                                0.900608, -0.113974,
                                                                                                                                                0.419422,
                                                                                                                                                0.981758,
                                                                                                                                                0.03097, -0.187594,
                                                                                                                                                0.547287,
                                                                                                                                                0.746228, -0.378974, -0.33642,
                                                                                                                                                0.186625, -0.923034, -0.569639,
                                                                                                                                                0.131736, -0.811269, -0.256185,
                                                                                                                                                0.095376, -0.961911, -0.047195,
                                                                                                                                                0.097295, -0.994136, -0.33642,
                                                                                                                                                0.186625, -0.923034, -0.256185,
                                                                                                                                                0.095376, -0.961911, -0.369843,
                                                                                                                                                0.915946, -0.155754, -0.283797,
                                                                                                                                                0.708129, -0.646539,
                                                                                                                                                0.547287,
                                                                                                                                                0.746228, -0.378974, -0.369843,
                                                                                                                                                0.915946, -0.155754,
                                                                                                                                                0.369843,
                                                                                                                                                0.915946, -0.155754, -0.283797,
                                                                                                                                                0.708129, -0.646539, -0.047195,
                                                                                                                                                0.097295, -0.994136, -0.256185,
                                                                                                                                                0.095376, -0.961911,
                                                                                                                                                0.047195,
                                                                                                                                                0.097295, -0.994136,
                                                                                                                                                0.256185,
                                                                                                                                                0.095376, -0.961911,
                                                                                                                                                0.047195,
                                                                                                                                                0.097295, -0.994136, -0.256185,
                                                                                                                                                0.095376, -0.961911,
                                                                                                                                                0.047195,
                                                                                                                                                0.097295, -0.994136,
                                                                                                                                                0.256185,
                                                                                                                                                0.095376, -0.961911,
                                                                                                                                                0.33642,
                                                                                                                                                0.186625, -0.923034,
                                                                                                                                                0.256185,
                                                                                                                                                0.095376, -0.961911,
                                                                                                                                                0.569639,
                                                                                                                                                0.131736, -0.811269,
                                                                                                                                                0.33642,
                                                                                                                                                0.186625, -0.923034, -0.981758,
                                                                                                                                                0.03097, -0.187594,
                                                                                                                                                0.015725,
                                                                                                                                                0.208311, -0.977936, -0.118422,
                                                                                                                                                0.801515, -0.586131, -0.118422,
                                                                                                                                                0.801515, -0.586131,
                                                                                                                                                0.015725,
                                                                                                                                                0.208311, -0.977936,
                                                                                                                                                0.471524,
                                                                                                                                                0.674881, -0.567627, -0.118422,
                                                                                                                                                0.801515, -0.586131,
                                                                                                                                                0.471524,
                                                                                                                                                0.674881, -0.567627,
                                                                                                                                                0.283781,
                                                                                                                                                0.708074, -0.646606,
                                                                                                                                                0.475487,
                                                                                                                                                0.703633, -0.528026,
                                                                                                                                                0.283781,
                                                                                                                                                0.708074, -0.646606,
                                                                                                                                                0.471524,
                                                                                                                                                0.674881, -0.567627,
                                                                                                                                                0.475487,
                                                                                                                                                0.703633, -0.528026,
                                                                                                                                                0.515849,
                                                                                                                                                0.461037, -0.722042,
                                                                                                                                                0.283781,
                                                                                                                                                0.708074, -0.646606,
                                                                                                                                                0.515849,
                                                                                                                                                0.461037, -0.722042,
                                                                                                                                                0.475487,
                                                                                                                                                0.703633, -0.528026,
                                                                                                                                                0.793327,
                                                                                                                                                0.322447, -0.516391,
                                                                                                                                                0.515849,
                                                                                                                                                0.461037, -0.722042,
                                                                                                                                                0.793327,
                                                                                                                                                0.322447, -0.516391,
                                                                                                                                                0.700422,
                                                                                                                                                0.537399, -0.469693,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.700422,
                                                                                                                                                0.537399, -0.469693,
                                                                                                                                                0.498328,
                                                                                                                                                0.793868, -0.348487,
                                                                                                                                                0.372095,
                                                                                                                                                0.803724, -0.464298,
                                                                                                                                                0.372095,
                                                                                                                                                0.803724, -0.464298,
                                                                                                                                                0.498328,
                                                                                                                                                0.793868, -0.348487,
                                                                                                                                                0.218296,
                                                                                                                                                0.940633, -0.259917,
                                                                                                                                                0.498328,
                                                                                                                                                0.793868, -0.348487,
                                                                                                                                                0.240647,
                                                                                                                                                0.954784, -0.174576,
                                                                                                                                                0.218296,
                                                                                                                                                0.940633, -0.259917,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.240647,
                                                                                                                                                0.954784, -0.174576, -0.055906,
                                                                                                                                                0.997486,
                                                                                                                                                0.043541,
                                                                                                                                                0.029325,
                                                                                                                                                0.999352, -0.020873,
                                                                                                                                                0.029325,
                                                                                                                                                0.999352, -0.020873, -0.055906,
                                                                                                                                                0.997486,
                                                                                                                                                0.043541, -0.151347,
                                                                                                                                                0.963066,
                                                                                                                                                0.222708, -0.055906,
                                                                                                                                                0.997486,
                                                                                                                                                0.043541, -0.313037,
                                                                                                                                                0.916157,
                                                                                                                                                0.250328, -0.151347,
                                                                                                                                                0.963066,
                                                                                                                                                0.222708,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0, -0.676802,
                                                                                                                                                0.438887,
                                                                                                                                                0.591031, -0.724489,
                                                                                                                                                0.235582,
                                                                                                                                                0.647778, -0.453389,
                                                                                                                                                0.441137,
                                                                                                                                                0.774491, -0.724489,
                                                                                                                                                0.235582,
                                                                                                                                                0.647778, -0.447838, -0.368344,
                                                                                                                                                0.814717, -0.453389,
                                                                                                                                                0.441137,
                                                                                                                                                0.774491, -0.724489,
                                                                                                                                                0.235582,
                                                                                                                                                0.647778, -0.514814, -0.604952,
                                                                                                                                                0.607454, -0.447838, -0.368344,
                                                                                                                                                0.814717, -0.514814, -0.604952,
                                                                                                                                                0.607454,
                                                                                                                                                0, -0.978387,
                                                                                                                                                0.206783, -0.447838, -0.368344,
                                                                                                                                                0.814717,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327, -0.676802,
                                                                                                                                                0.438887,
                                                                                                                                                0.591031, -0.453389,
                                                                                                                                                0.441137,
                                                                                                                                                0.774491, -0.428745,
                                                                                                                                                0.662903,
                                                                                                                                                0.613789, -0.58663,
                                                                                                                                                0.635996,
                                                                                                                                                0.501371, -0.676802,
                                                                                                                                                0.438887,
                                                                                                                                                0.591031, -0.428745,
                                                                                                                                                0.662903,
                                                                                                                                                0.613789, -0.497172,
                                                                                                                                                0.762369,
                                                                                                                                                0.414263, -0.58663,
                                                                                                                                                0.635996,
                                                                                                                                                0.501371, -0.428745,
                                                                                                                                                0.662903,
                                                                                                                                                0.613789, -0.289515,
                                                                                                                                                0.849355,
                                                                                                                                                0.441336, -0.497172,
                                                                                                                                                0.762369,
                                                                                                                                                0.414263, -0.428745,
                                                                                                                                                0.662903,
                                                                                                                                                0.613789, -0.313037,
                                                                                                                                                0.916157,
                                                                                                                                                0.250328, -0.497172,
                                                                                                                                                0.762369,
                                                                                                                                                0.414263, -0.289515,
                                                                                                                                                0.849355,
                                                                                                                                                0.441336, -0.151347,
                                                                                                                                                0.963066,
                                                                                                                                                0.222708, -0.313037,
                                                                                                                                                0.916157,
                                                                                                                                                0.250328, -0.289515,
                                                                                                                                                0.849355,
                                                                                                                                                0.441336,
                                                                                                                                                0.218296,
                                                                                                                                                0.940633, -0.259917,
                                                                                                                                                0.240647,
                                                                                                                                                0.954784, -0.174576,
                                                                                                                                                0.029325,
                                                                                                                                                0.999352, -0.020873,
                                                                                                                                                0.393434,
                                                                                                                                                0.652475, -0.647677,
                                                                                                                                                0.700422,
                                                                                                                                                0.537399, -0.469693,
                                                                                                                                                0.372095,
                                                                                                                                                0.803724, -0.464298,
                                                                                                                                                0.393434,
                                                                                                                                                0.652475, -0.647677,
                                                                                                                                                0.515849,
                                                                                                                                                0.461037, -0.722042,
                                                                                                                                                0.700422,
                                                                                                                                                0.537399, -0.469693,
                                                                                                                                                0.515849,
                                                                                                                                                0.461037, -0.722042,
                                                                                                                                                0.393434,
                                                                                                                                                0.652475, -0.647677,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.283781,
                                                                                                                                                0.708074, -0.646606,
                                                                                                                                                0.515849,
                                                                                                                                                0.461037, -0.722042,
                                                                                                                                                0.283781,
                                                                                                                                                0.708074, -0.646606,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.283797,
                                                                                                                                                0.708129, -0.646539,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.283797,
                                                                                                                                                0.708129, -0.646539,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311, -0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.283797,
                                                                                                                                                0.708129, -0.646539, -0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.170031,
                                                                                                                                                0.430746, -0.886311, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.170031,
                                                                                                                                                0.430746, -0.886311, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.313573,
                                                                                                                                                0.782435, -0.538022, -0.313573,
                                                                                                                                                0.782435, -0.538022, -0.313573,
                                                                                                                                                0.782435, -0.538022, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.313573,
                                                                                                                                                0.782435, -0.538022, -0.358375,
                                                                                                                                                0.889289, -0.284135, -0.313573,
                                                                                                                                                0.782435, -0.538022, -0.358375,
                                                                                                                                                0.889289, -0.284135, -0.313573,
                                                                                                                                                0.782435, -0.538022, -0.358375,
                                                                                                                                                0.889289, -0.284135, -0.358375,
                                                                                                                                                0.889289, -0.284135, -0.160666,
                                                                                                                                                0.961746, -0.221882, -0.313573,
                                                                                                                                                0.782435, -0.538022, -0.160666,
                                                                                                                                                0.961746, -0.221882, -0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.026322,
                                                                                                                                                0.999434,
                                                                                                                                                0.020932, -0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.026322,
                                                                                                                                                0.999434,
                                                                                                                                                0.020932, -0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.026322,
                                                                                                                                                0.999434,
                                                                                                                                                0.020932, -0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.195675,
                                                                                                                                                0.945023,
                                                                                                                                                0.261997, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.195675,
                                                                                                                                                0.945023,
                                                                                                                                                0.261997, -0.3745,
                                                                                                                                                0.927227, -0.000176,
                                                                                                                                                0.195675,
                                                                                                                                                0.945023,
                                                                                                                                                0.261997, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.321125,
                                                                                                                                                0.819346,
                                                                                                                                                0.474923, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.321125,
                                                                                                                                                0.819346,
                                                                                                                                                0.474923, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829,
                                                                                                                                                0.321125,
                                                                                                                                                0.819346,
                                                                                                                                                0.474923, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825,
                                                                                                                                                0.337378,
                                                                                                                                                0.667661,
                                                                                                                                                0.66363, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.337378,
                                                                                                                                                0.667661,
                                                                                                                                                0.66363, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.337378,
                                                                                                                                                0.667661,
                                                                                                                                                0.66363, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.166733, -0.40798,
                                                                                                                                                0.897637, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.166733, -0.40798,
                                                                                                                                                0.897637, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295, -0.166733, -0.40798,
                                                                                                                                                0.897637, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.166733, -0.40798,
                                                                                                                                                0.897637, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.166694, -0.407824,
                                                                                                                                                0.897715, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.166733, -0.40798,
                                                                                                                                                0.897637, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.166694, -0.407824,
                                                                                                                                                0.897715,
                                                                                                                                                0.440309,
                                                                                                                                                0.484684,
                                                                                                                                                0.755784,
                                                                                                                                                0.511305, -0.296235,
                                                                                                                                                0.806729,
                                                                                                                                                0.440309,
                                                                                                                                                0.484684,
                                                                                                                                                0.755784,
                                                                                                                                                0.166694, -0.407824,
                                                                                                                                                0.897715,
                                                                                                                                                0.440309,
                                                                                                                                                0.484684,
                                                                                                                                                0.755784,
                                                                                                                                                0.511305, -0.296235,
                                                                                                                                                0.806729,
                                                                                                                                                0.691384,
                                                                                                                                                0.380717,
                                                                                                                                                0.614039,
                                                                                                                                                0.511305, -0.296235,
                                                                                                                                                0.806729,
                                                                                                                                                0.442306, -0.219929,
                                                                                                                                                0.869481,
                                                                                                                                                0.691384,
                                                                                                                                                0.380717,
                                                                                                                                                0.614039,
                                                                                                                                                0.098933, -0.781286,
                                                                                                                                                0.616283,
                                                                                                                                                0.442306, -0.219929,
                                                                                                                                                0.869481,
                                                                                                                                                0.511305, -0.296235,
                                                                                                                                                0.806729,
                                                                                                                                                0,
                                                                                                                                                0.163646,
                                                                                                                                                0.986519,
                                                                                                                                                0.442306, -0.219929,
                                                                                                                                                0.869481,
                                                                                                                                                0.098933, -0.781286,
                                                                                                                                                0.616283, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787,
                                                                                                                                                0, -0.155811,
                                                                                                                                                0.987787, -0.282773, -0.149452,
                                                                                                                                                0.947472, -0.282773, -0.149452,
                                                                                                                                                0.947472, -0.282773, -0.149452,
                                                                                                                                                0.947472, -0.179041,
                                                                                                                                                0.18415,
                                                                                                                                                0.966454, -0.179041,
                                                                                                                                                0.18415,
                                                                                                                                                0.966454, -0.179041,
                                                                                                                                                0.18415,
                                                                                                                                                0.966454,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0,
                                                                                                                                                0.187175,
                                                                                                                                                0.982327,
                                                                                                                                                0.364372, -0.903042,
                                                                                                                                                0.227483,
                                                                                                                                                0.098933, -0.781286,
                                                                                                                                                0.616283,
                                                                                                                                                0.166694, -0.407824,
                                                                                                                                                0.897715,
                                                                                                                                                0.511305, -0.296235,
                                                                                                                                                0.806729,
                                                                                                                                                0.166694, -0.407824,
                                                                                                                                                0.897715,
                                                                                                                                                0.098933, -0.781286,
                                                                                                                                                0.616283,
                                                                                                                                                0.166694, -0.407824,
                                                                                                                                                0.897715,
                                                                                                                                                0.166733, -0.40798,
                                                                                                                                                0.897637,
                                                                                                                                                0.364372, -0.903042,
                                                                                                                                                0.227483,
                                                                                                                                                0.364377, -0.903138,
                                                                                                                                                0.227094,
                                                                                                                                                0.364372, -0.903042,
                                                                                                                                                0.227483,
                                                                                                                                                0.166733, -0.40798,
                                                                                                                                                0.897637,
                                                                                                                                                0.166733, -0.40798,
                                                                                                                                                0.897637, -0.166733, -0.40798,
                                                                                                                                                0.897637,
                                                                                                                                                0.364377, -0.903138,
                                                                                                                                                0.227094,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -0.247586,
                                                                                                                                                0.968866,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                0.063714, -0.282576,
                                                                                                                                                0.957127,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                0.063714, -0.282576,
                                                                                                                                                0.957127,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.063714, -0.282576,
                                                                                                                                                0.957127,
                                                                                                                                                0.051774, -0.196857,
                                                                                                                                                0.979064,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839,
                                                                                                                                                0.051774, -0.196857,
                                                                                                                                                0.979064,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839, -0.050022, -0.08156,
                                                                                                                                                0.995412,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972, -0.050022, -0.08156,
                                                                                                                                                0.995412,
                                                                                                                                                0, -0.063649,
                                                                                                                                                0.997972,
                                                                                                                                                0.793353, -0.608761,
                                                                                                                                                0,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.707107, -0.707107,
                                                                                                                                                0,
                                                                                                                                                0.063693, -0.335803,
                                                                                                                                                0.939776,
                                                                                                                                                0.063714, -0.282576,
                                                                                                                                                0.957127,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839,
                                                                                                                                                0.079637, -0.490481,
                                                                                                                                                0.867806,
                                                                                                                                                0.063714, -0.282576,
                                                                                                                                                0.957127,
                                                                                                                                                0.063693, -0.335803,
                                                                                                                                                0.939776,
                                                                                                                                                0.079637, -0.490481,
                                                                                                                                                0.867806,
                                                                                                                                                0, -0.247586,
                                                                                                                                                0.968866,
                                                                                                                                                0.063714, -0.282576,
                                                                                                                                                0.957127, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.105639, -0.680958,
                                                                                                                                                0.724663,
                                                                                                                                                0.079637, -0.490481,
                                                                                                                                                0.867806,
                                                                                                                                                0.065461, -0.510649,
                                                                                                                                                0.857294,
                                                                                                                                                0.079637, -0.490481,
                                                                                                                                                0.867806,
                                                                                                                                                0.063693, -0.335803,
                                                                                                                                                0.939776,
                                                                                                                                                0.065461, -0.510649,
                                                                                                                                                0.857294,
                                                                                                                                                0.063693, -0.335803,
                                                                                                                                                0.939776, -0.066111, -0.395955,
                                                                                                                                                0.915887,
                                                                                                                                                0.065461, -0.510649,
                                                                                                                                                0.857294,
                                                                                                                                                0.063693, -0.335803,
                                                                                                                                                0.939776,
                                                                                                                                                0.008983, -0.151672,
                                                                                                                                                0.98839, -0.066111, -0.395955,
                                                                                                                                                0.915887, -0.060826, -0.467007,
                                                                                                                                                0.882159,
                                                                                                                                                0.065461, -0.510649,
                                                                                                                                                0.857294, -0.066111, -0.395955,
                                                                                                                                                0.915887, -0.060826, -0.467007,
                                                                                                                                                0.882159, -0.066255, -0.669239,
                                                                                                                                                0.740087,
                                                                                                                                                0.065461, -0.510649,
                                                                                                                                                0.857294, -0.066255, -0.669239,
                                                                                                                                                0.740087, -0.060826, -0.467007,
                                                                                                                                                0.882159, -0.108201, -0.614062,
                                                                                                                                                0.781806, -0.060826, -0.467007,
                                                                                                                                                0.882159, -0.066111, -0.395955,
                                                                                                                                                0.915887, -0.108201, -0.614062,
                                                                                                                                                0.781806, -0.108201, -0.614062,
                                                                                                                                                0.781806, -0.066111, -0.395955,
                                                                                                                                                0.915887, -0.075284, -0.460528,
                                                                                                                                                0.884447,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.22695, -0.973906, -0.000066,
                                                                                                                                                0.600804, -0.799397,
                                                                                                                                                0,
                                                                                                                                                0.22695, -0.973906,
                                                                                                                                                0,
                                                                                                                                                0.22695, -0.973906,
                                                                                                                                                0,
                                                                                                                                                0.22695, -0.973906,
                                                                                                                                                0,
                                                                                                                                                0.114223, -0.993455,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.284728, -0.317067, -0.904654,
                                                                                                                                                0.223931, -0.345446, -0.91133,
                                                                                                                                                0.333182, -0.493685, -0.803284,
                                                                                                                                                0.264677, -0.206919, -0.941876,
                                                                                                                                                0.223931, -0.345446, -0.91133,
                                                                                                                                                0.284728, -0.317067, -0.904654,
                                                                                                                                                0.223931, -0.345446, -0.91133,
                                                                                                                                                0.264677, -0.206919, -0.941876, -0.23578, -0.400178, -0.885588, -0.264677, -0.206919, -0.941876, -0.23578, -0.400178, -0.885588,
                                                                                                                                                0.264677, -0.206919, -0.941876, -0.264677, -0.206919, -0.941876, -0.284728, -0.317067, -0.904654, -0.23578, -0.400178, -0.885588, -0.241864, -0.203078, -0.948821, -0.284728, -0.317067, -0.904654, -0.264677, -0.206919, -0.941876, -0.137086, -0.068965, -0.988156, -0.284728, -0.317067, -0.904654, -0.241864, -0.203078, -0.948821, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.440309,
                                                                                                                                                0.484684,
                                                                                                                                                0.755784,
                                                                                                                                                0.691384,
                                                                                                                                                0.380717,
                                                                                                                                                0.614039,
                                                                                                                                                0.612029,
                                                                                                                                                0.593242,
                                                                                                                                                0.522958,
                                                                                                                                                0.337378,
                                                                                                                                                0.667661,
                                                                                                                                                0.66363,
                                                                                                                                                0.440309,
                                                                                                                                                0.484684,
                                                                                                                                                0.755784,
                                                                                                                                                0.612029,
                                                                                                                                                0.593242,
                                                                                                                                                0.522958,
                                                                                                                                                0.440309,
                                                                                                                                                0.484684,
                                                                                                                                                0.755784,
                                                                                                                                                0.337378,
                                                                                                                                                0.667661,
                                                                                                                                                0.66363, -0.170647,
                                                                                                                                                0.430536,
                                                                                                                                                0.886295,
                                                                                                                                                0.612029,
                                                                                                                                                0.593242,
                                                                                                                                                0.522958,
                                                                                                                                                0.321125,
                                                                                                                                                0.819346,
                                                                                                                                                0.474923,
                                                                                                                                                0.337378,
                                                                                                                                                0.667661,
                                                                                                                                                0.66363,
                                                                                                                                                0.612029,
                                                                                                                                                0.593242,
                                                                                                                                                0.522958,
                                                                                                                                                0.44508,
                                                                                                                                                0.819393,
                                                                                                                                                0.361246,
                                                                                                                                                0.321125,
                                                                                                                                                0.819346,
                                                                                                                                                0.474923, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.44508,
                                                                                                                                                0.819393,
                                                                                                                                                0.361246,
                                                                                                                                                0.225607,
                                                                                                                                                0.958239,
                                                                                                                                                0.175726,
                                                                                                                                                0.195675,
                                                                                                                                                0.945023,
                                                                                                                                                0.261997,
                                                                                                                                                0.225607,
                                                                                                                                                0.958239,
                                                                                                                                                0.175726,
                                                                                                                                                0.026322,
                                                                                                                                                0.999434,
                                                                                                                                                0.020932,
                                                                                                                                                0.195675,
                                                                                                                                                0.945023,
                                                                                                                                                0.261997,
                                                                                                                                                0.225607,
                                                                                                                                                0.958239,
                                                                                                                                                0.175726, -0.059957,
                                                                                                                                                0.997253, -0.043497,
                                                                                                                                                0.026322,
                                                                                                                                                0.999434,
                                                                                                                                                0.020932, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -0.318136,
                                                                                                                                                0.111487, -0.941467, -0.137086, -0.068965, -0.988156, -0.213924,
                                                                                                                                                0.101497, -0.971563, -0.137086, -0.068965, -0.988156, -0.241864, -0.203078, -0.948821, -0.213924,
                                                                                                                                                0.101497, -0.971563,
                                                                                                                                                0.920227,
                                                                                                                                                0.109096,
                                                                                                                                                0.375873,
                                                                                                                                                0.889906,
                                                                                                                                                0.136849,
                                                                                                                                                0.435131,
                                                                                                                                                0.224462, -0.135296,
                                                                                                                                                0.965045,
                                                                                                                                                0, -0.278743, -0.960366, -0.241864, -0.203078, -0.948821, -0.426648, -0.178389, -0.886651, -0.426648, -0.178389, -0.886651, -0.241864, -0.203078, -0.948821, -0.408378, -0.169148, -0.897004, -0.408378, -0.169148, -0.897004, -0.241864, -0.203078, -0.948821, -0.264677, -0.206919, -0.941876, -0.264677, -0.206919, -0.941876,
                                                                                                                                                0.300938, -0.0637, -0.951514, -0.408378, -0.169148, -0.897004,
                                                                                                                                                0.264677, -0.206919, -0.941876,
                                                                                                                                                0.300938, -0.0637, -0.951514, -0.264677, -0.206919, -0.941876, -0.300938, -0.0637, -0.951514, -0.408378, -0.169148, -0.897004,
                                                                                                                                                0.300938, -0.0637, -0.951514, -0.300938, -0.0637, -0.951514, -0.426648, -0.178389, -0.886651, -0.408378, -0.169148, -0.897004,
                                                                                                                                                0.900608, -0.113974,
                                                                                                                                                0.419422,
                                                                                                                                                0.889906,
                                                                                                                                                0.136849,
                                                                                                                                                0.435131,
                                                                                                                                                0.638448,
                                                                                                                                                0.137511, -0.757281,
                                                                                                                                                0.889906,
                                                                                                                                                0.136849,
                                                                                                                                                0.435131,
                                                                                                                                                0.900608, -0.113974,
                                                                                                                                                0.419422,
                                                                                                                                                0.224462, -0.135296,
                                                                                                                                                0.965045,
                                                                                                                                                0.900608, -0.113974,
                                                                                                                                                0.419422, -0.618229, -0.10598,
                                                                                                                                                0.77882,
                                                                                                                                                0.224462, -0.135296,
                                                                                                                                                0.965045,
                                                                                                                                                0.900608, -0.113974,
                                                                                                                                                0.419422, -0.659156,
                                                                                                                                                0.652102, -0.374536, -0.618229, -0.10598,
                                                                                                                                                0.77882, -0.659156,
                                                                                                                                                0.652102, -0.374536,
                                                                                                                                                0.900608, -0.113974,
                                                                                                                                                0.419422,
                                                                                                                                                0.547287,
                                                                                                                                                0.746228, -0.378974, -0.659156,
                                                                                                                                                0.652102, -0.374536,
                                                                                                                                                0.547287,
                                                                                                                                                0.746228, -0.378974, -0.179495,
                                                                                                                                                0.608902, -0.772671, -0.179495,
                                                                                                                                                0.608902, -0.772671,
                                                                                                                                                0.547287,
                                                                                                                                                0.746228, -0.378974, -0.283797,
                                                                                                                                                0.708129, -0.646539, -0.179495,
                                                                                                                                                0.608902, -0.772671, -0.283797,
                                                                                                                                                0.708129, -0.646539, -0.170031,
                                                                                                                                                0.430746, -0.886311, -0.170031,
                                                                                                                                                0.430746, -0.886311, -0.170031,
                                                                                                                                                0.430746, -0.886311, -0.283797,
                                                                                                                                                0.708129, -0.646539, -0.170031,
                                                                                                                                                0.430746, -0.886311, -0.170031,
                                                                                                                                                0.430746, -0.886311, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.170031,
                                                                                                                                                0.430746, -0.886311, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.535998,
                                                                                                                                                0.418828, -0.733001, -0.499872,
                                                                                                                                                0.636133, -0.587761, -0.535998,
                                                                                                                                                0.418828, -0.733001, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.77223,
                                                                                                                                                0.380127, -0.509082, -0.535998,
                                                                                                                                                0.418828, -0.733001, -0.499872,
                                                                                                                                                0.636133, -0.587761, -0.77223,
                                                                                                                                                0.380127, -0.509082, -0.823195,
                                                                                                                                                0.195013, -0.533216, -0.535998,
                                                                                                                                                0.418828, -0.733001, -0.823195,
                                                                                                                                                0.195013, -0.533216, -0.592527,
                                                                                                                                                0.404004, -0.696916, -0.535998,
                                                                                                                                                0.418828, -0.733001, -0.823195,
                                                                                                                                                0.195013, -0.533216, -0.345178,
                                                                                                                                                0.805047, -0.482443, -0.592527,
                                                                                                                                                0.404004, -0.696916, -0.345178,
                                                                                                                                                0.805047, -0.482443, -0.674435,
                                                                                                                                                0.706298, -0.215131, -0.592527,
                                                                                                                                                0.404004, -0.696916, -0.674435,
                                                                                                                                                0.706298, -0.215131, -0.345178,
                                                                                                                                                0.805047, -0.482443, -0.083886,
                                                                                                                                                0.475542, -0.875684,
                                                                                                                                                0.000066,
                                                                                                                                                0.600804, -0.799397, -0.083886,
                                                                                                                                                0.475542, -0.875684, -0.345178,
                                                                                                                                                0.805047, -0.482443,
                                                                                                                                                0.000066,
                                                                                                                                                0.600804, -0.799397, -0.155115,
                                                                                                                                                0.220846, -0.962895, -0.083886,
                                                                                                                                                0.475542, -0.875684, -0.083886,
                                                                                                                                                0.475542, -0.875684, -0.155115,
                                                                                                                                                0.220846, -0.962895, -0.231267,
                                                                                                                                                0.215791, -0.948657, -0.231267,
                                                                                                                                                0.215791, -0.948657, -0.155115,
                                                                                                                                                0.220846, -0.962895, -0.213924,
                                                                                                                                                0.101497, -0.971563, -0.318136,
                                                                                                                                                0.111487, -0.941467, -0.213924,
                                                                                                                                                0.101497, -0.971563, -0.155115,
                                                                                                                                                0.220846, -0.962895, -0.96103,
                                                                                                                                                0.241257, -0.134972, -0.96103,
                                                                                                                                                0.241257, -0.134972, -0.96103,
                                                                                                                                                0.241257, -0.134972, -0.618229, -0.10598,
                                                                                                                                                0.77882, -0.659156,
                                                                                                                                                0.652102, -0.374536, -0.674435,
                                                                                                                                                0.706298, -0.215131, -0.674435,
                                                                                                                                                0.706298, -0.215131, -0.659156,
                                                                                                                                                0.652102, -0.374536, -0.592527,
                                                                                                                                                0.404004, -0.696916, -0.592527,
                                                                                                                                                0.404004, -0.696916, -0.659156,
                                                                                                                                                0.652102, -0.374536, -0.179495,
                                                                                                                                                0.608902, -0.772671, -0.179495,
                                                                                                                                                0.608902, -0.772671, -0.170031,
                                                                                                                                                0.430746, -0.886311, -0.592527,
                                                                                                                                                0.404004, -0.696916, -0.535998,
                                                                                                                                                0.418828, -0.733001, -0.592527,
                                                                                                                                                0.404004, -0.696916, -0.170031,
                                                                                                                                                0.430746, -0.886311, -0.6775,
                                                                                                                                                0.578703, -0.453979, -0.77223,
                                                                                                                                                0.380127, -0.509082, -0.499872,
                                                                                                                                                0.636133, -0.587761, -0.570265,
                                                                                                                                                0.722945, -0.390062, -0.6775,
                                                                                                                                                0.578703, -0.453979, -0.499872,
                                                                                                                                                0.636133, -0.587761, -0.570265,
                                                                                                                                                0.722945, -0.390062, -0.499872,
                                                                                                                                                0.636133, -0.587761, -0.324122,
                                                                                                                                                0.839844, -0.435439, -0.499872,
                                                                                                                                                0.636133, -0.587761, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.324122,
                                                                                                                                                0.839844, -0.435439, -0.313573,
                                                                                                                                                0.782435, -0.538022, -0.324122,
                                                                                                                                                0.839844, -0.435439, -0.247985,
                                                                                                                                                0.623409, -0.741529, -0.324122,
                                                                                                                                                0.839844, -0.435439, -0.313573,
                                                                                                                                                0.782435, -0.538022, -0.160666,
                                                                                                                                                0.961746, -0.221882, -0.347542,
                                                                                                                                                0.904772, -0.246176, -0.324122,
                                                                                                                                                0.839844, -0.435439, -0.160666,
                                                                                                                                                0.961746, -0.221882, -0.347542,
                                                                                                                                                0.904772, -0.246176, -0.570265,
                                                                                                                                                0.722945, -0.390062, -0.324122,
                                                                                                                                                0.839844, -0.435439, -0.059957,
                                                                                                                                                0.997253, -0.043497, -0.347542,
                                                                                                                                                0.904772, -0.246176, -0.160666,
                                                                                                                                                0.961746, -0.221882, -0.059957,
                                                                                                                                                0.997253, -0.043497, -0.160666,
                                                                                                                                                0.961746, -0.221882,
                                                                                                                                                0.026322,
                                                                                                                                                0.999434,
                                                                                                                                                0.020932, -0.283797,
                                                                                                                                                0.708129, -0.646539,
                                                                                                                                                0.283797,
                                                                                                                                                0.708129, -0.646539, -0.170031,
                                                                                                                                                0.430746, -0.886311,
                                                                                                                                                0.283797,
                                                                                                                                                0.708129, -0.646539, -0.283797,
                                                                                                                                                0.708129, -0.646539,
                                                                                                                                                0.369843,
                                                                                                                                                0.915946, -0.155754,
                                                                                                                                                0.369843,
                                                                                                                                                0.915946, -0.155754, -0.118422,
                                                                                                                                                0.801515, -0.586131,
                                                                                                                                                0.283797,
                                                                                                                                                0.708129, -0.646539,
                                                                                                                                                0.283781,
                                                                                                                                                0.708074, -0.646606,
                                                                                                                                                0.283797,
                                                                                                                                                0.708129, -0.646539, -0.118422,
                                                                                                                                                0.801515, -0.586131, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.44508,
                                                                                                                                                0.819393,
                                                                                                                                                0.361246,
                                                                                                                                                0.195675,
                                                                                                                                                0.945023,
                                                                                                                                                0.261997,
                                                                                                                                                0.321125,
                                                                                                                                                0.819346,
                                                                                                                                                0.474923, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.038843, -0.985176,
                                                                                                                                                0.167093,
                                                                                                                                                0.079111, -0.919219,
                                                                                                                                                0.385719,
                                                                                                                                                0.037345, -0.959084,
                                                                                                                                                0.280647,
                                                                                                                                                0.037345, -0.959084,
                                                                                                                                                0.280647,
                                                                                                                                                0.079111, -0.919219,
                                                                                                                                                0.385719,
                                                                                                                                                0.059485, -0.82283,
                                                                                                                                                0.565166,
                                                                                                                                                0.079111, -0.919219,
                                                                                                                                                0.385719,
                                                                                                                                                0.099032, -0.815116,
                                                                                                                                                0.570769,
                                                                                                                                                0.059485, -0.82283,
                                                                                                                                                0.565166, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.099032, -0.815116,
                                                                                                                                                0.570769,
                                                                                                                                                0.105639, -0.680958,
                                                                                                                                                0.724663,
                                                                                                                                                0.066255, -0.669239,
                                                                                                                                                0.740087,
                                                                                                                                                0.066255, -0.669239,
                                                                                                                                                0.740087,
                                                                                                                                                0.105639, -0.680958,
                                                                                                                                                0.724663,
                                                                                                                                                0.065461, -0.510649,
                                                                                                                                                0.857294,
                                                                                                                                                0.066255, -0.669239,
                                                                                                                                                0.740087,
                                                                                                                                                0.065461, -0.510649,
                                                                                                                                                0.857294, -0.066255, -0.669239,
                                                                                                                                                0.740087,
                                                                                                                                                0.066255, -0.669239,
                                                                                                                                                0.740087, -0.066255, -0.669239,
                                                                                                                                                0.740087,
                                                                                                                                                0.059485, -0.82283,
                                                                                                                                                0.565166, -0.059485, -0.82283,
                                                                                                                                                0.565166,
                                                                                                                                                0.059485, -0.82283,
                                                                                                                                                0.565166, -0.066255, -0.669239,
                                                                                                                                                0.740087, -0.059485, -0.82283,
                                                                                                                                                0.565166, -0.039494, -0.946852,
                                                                                                                                                0.319236,
                                                                                                                                                0.059485, -0.82283,
                                                                                                                                                0.565166, -0.079111, -0.919219,
                                                                                                                                                0.385719, -0.039494, -0.946852,
                                                                                                                                                0.319236, -0.059485, -0.82283,
                                                                                                                                                0.565166, -0.079111, -0.919219,
                                                                                                                                                0.385719, -0.040661, -0.984512,
                                                                                                                                                0.170538, -0.039494, -0.946852,
                                                                                                                                                0.319236,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.333182, -0.493685, -0.803284,
                                                                                                                                                0.200629, -0.55762, -0.805486,
                                                                                                                                                0.256299, -0.723161, -0.641364,
                                                                                                                                                0.223931, -0.345446, -0.91133,
                                                                                                                                                0.200629, -0.55762, -0.805486,
                                                                                                                                                0.333182, -0.493685, -0.803284,
                                                                                                                                                0.200629, -0.55762, -0.805486,
                                                                                                                                                0.223931, -0.345446, -0.91133, -0.179541, -0.537767, -0.823755, -0.23578, -0.400178, -0.885588, -0.179541, -0.537767, -0.823755,
                                                                                                                                                0.223931, -0.345446, -0.91133, -0.23578, -0.400178, -0.885588, -0.296993, -0.615316, -0.730193, -0.179541, -0.537767, -0.823755, -0.323137, -0.554025, -0.767228, -0.296993, -0.615316, -0.730193, -0.23578, -0.400178, -0.885588, -0.284728, -0.317067, -0.904654, -0.323137, -0.554025, -0.767228, -0.23578, -0.400178, -0.885588, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -0.296993, -0.615316, -0.730193, -0.235018, -0.740517, -0.629604, -0.179541, -0.537767, -0.823755, -0.179541, -0.537767, -0.823755, -0.235018, -0.740517, -0.629604, -0.140181, -0.624241, -0.768552, -0.140181, -0.624241, -0.768552, -0.235018, -0.740517, -0.629604, -0.106668, -0.851306, -0.513712, -0.235018, -0.740517, -0.629604, -0.113245, -0.936256, -0.332567, -0.106668, -0.851306, -0.513712, -0.113245, -0.936256, -0.332567, -0.078211, -0.964756, -0.251255, -0.106668, -0.851306, -0.513712, -0.106668, -0.851306, -0.513712, -0.078211, -0.964756, -0.251255, -0.05114, -0.940425, -0.336135, -0.05114, -0.940425, -0.336135, -0.078211, -0.964756, -0.251255, -0.005852, -0.999841, -0.016869, -0.078211, -0.964756, -0.251255,
                                                                                                                                                0.014984, -0.998116,
                                                                                                                                                0.059494, -0.005852, -0.999841, -0.016869, -0.005852, -0.999841, -0.016869,
                                                                                                                                                0.014984, -0.998116,
                                                                                                                                                0.059494,
                                                                                                                                                0.037345, -0.959084,
                                                                                                                                                0.280647,
                                                                                                                                                0.014984, -0.998116,
                                                                                                                                                0.059494,
                                                                                                                                                0.038843, -0.985176,
                                                                                                                                                0.167093,
                                                                                                                                                0.037345, -0.959084,
                                                                                                                                                0.280647, -0.005852, -0.999841, -0.016869,
                                                                                                                                                0.037345, -0.959084,
                                                                                                                                                0.280647, -0.003229, -0.999852,
                                                                                                                                                0.01689, -0.039494, -0.946852,
                                                                                                                                                0.319236, -0.003229, -0.999852,
                                                                                                                                                0.01689,
                                                                                                                                                0.037345, -0.959084,
                                                                                                                                                0.280647, -0.040661, -0.984512,
                                                                                                                                                0.170538, -0.003229, -0.999852,
                                                                                                                                                0.01689, -0.039494, -0.946852,
                                                                                                                                                0.319236, -0.040661, -0.984512,
                                                                                                                                                0.170538,
                                                                                                                                                0.017024, -0.998084, -0.059491, -0.003229, -0.999852,
                                                                                                                                                0.01689,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.087268, -0.957207, -0.275935,
                                                                                                                                                0.161213, -0.873021, -0.460267,
                                                                                                                                                0.095277, -0.840174, -0.533882,
                                                                                                                                                0.161213, -0.873021, -0.460267,
                                                                                                                                                0.140999, -0.691502, -0.708481,
                                                                                                                                                0.095277, -0.840174, -0.533882,
                                                                                                                                                0.161213, -0.873021, -0.460267,
                                                                                                                                                0.232649, -0.756999, -0.610595,
                                                                                                                                                0.140999, -0.691502, -0.708481,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.232649, -0.756999, -0.610595,
                                                                                                                                                0.256299, -0.723161, -0.641364,
                                                                                                                                                0.200629, -0.55762, -0.805486,
                                                                                                                                                0.200629, -0.55762, -0.805486,
                                                                                                                                                0.140999, -0.691502, -0.708481,
                                                                                                                                                0.232649, -0.756999, -0.610595,
                                                                                                                                                0.140999, -0.691502, -0.708481,
                                                                                                                                                0.200629, -0.55762, -0.805486, -0.140181, -0.624241, -0.768552, -0.179541, -0.537767, -0.823755, -0.140181, -0.624241, -0.768552,
                                                                                                                                                0.200629, -0.55762, -0.805486,
                                                                                                                                                0.140999, -0.691502, -0.708481, -0.140181, -0.624241, -0.768552,
                                                                                                                                                0.095277, -0.840174, -0.533882, -0.106668, -0.851306, -0.513712,
                                                                                                                                                0.095277, -0.840174, -0.533882, -0.140181, -0.624241, -0.768552, -0.106668, -0.851306, -0.513712, -0.05114, -0.940425, -0.336135,
                                                                                                                                                0.095277, -0.840174, -0.533882,
                                                                                                                                                0.044871, -0.957027, -0.286506,
                                                                                                                                                0.095277, -0.840174, -0.533882, -0.05114, -0.940425, -0.336135,
                                                                                                                                                0.087268, -0.957207, -0.275935,
                                                                                                                                                0.095277, -0.840174, -0.533882,
                                                                                                                                                0.044871, -0.957027, -0.286506,
                                                                                                                                                0.017024, -0.998084, -0.059491,
                                                                                                                                                0.087268, -0.957207, -0.275935,
                                                                                                                                                0.044871, -0.957027, -0.286506,
                                                                                                                                                0.017024, -0.998084, -0.059491,
                                                                                                                                                0.044871, -0.957027, -0.286506, -0.003229, -0.999852,
                                                                                                                                                0.01689, -0.003229, -0.999852,
                                                                                                                                                0.01689,
                                                                                                                                                0.044871, -0.957027, -0.286506, -0.005852, -0.999841, -0.016869, -0.05114, -0.940425, -0.336135, -0.005852, -0.999841, -0.016869,
                                                                                                                                                0.044871, -0.957027, -0.286506,
                                                                                                                                                0.037345, -0.959084,
                                                                                                                                                0.280647,
                                                                                                                                                0.059485, -0.82283,
                                                                                                                                                0.565166, -0.039494, -0.946852,
                                                                                                                                                0.319236,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0, -0.108201, -0.614062,
                                                                                                                                                0.781806, -0.099032, -0.815116,
                                                                                                                                                0.570769, -0.066255, -0.669239,
                                                                                                                                                0.740087, -0.099032, -0.815116,
                                                                                                                                                0.570769, -0.059485, -0.82283,
                                                                                                                                                0.565166, -0.066255, -0.669239,
                                                                                                                                                0.740087, -0.099032, -0.815116,
                                                                                                                                                0.570769, -0.079111, -0.919219,
                                                                                                                                                0.385719, -0.059485, -0.82283,
                                                                                                                                                0.565166,
                                                                                                                                                0.059485, -0.82283,
                                                                                                                                                0.565166,
                                                                                                                                                0.099032, -0.815116,
                                                                                                                                                0.570769,
                                                                                                                                                0.066255, -0.669239,
                                                                                                                                                0.740087,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999,
                                                                                                                                                0, -0.247586,
                                                                                                                                                0.968866,
                                                                                                                                                0,
                                                                                                                                                0.004374,
                                                                                                                                                0.99999, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.248535,
                                                                                                                                                0.623293,
                                                                                                                                                0.741442, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.313999,
                                                                                                                                                0.7824,
                                                                                                                                                0.537825, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.3745,
                                                                                                                                                0.927227, -0.000176, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.3745,
                                                                                                                                                0.927227, -0.000176, -0.358612,
                                                                                                                                                0.889291,
                                                                                                                                                0.283829, -0.3745,
                                                                                                                                                0.927227, -0.000176, -0.3745,
                                                                                                                                                0.927227, -0.000176, -0.358375,
                                                                                                                                                0.889289, -0.284135, -0.3745,
                                                                                                                                                0.927227, -0.000176, -0.358375,
                                                                                                                                                0.889289, -0.284135, -0.3745,
                                                                                                                                                0.927227, -0.000176, -0.358375,
                                                                                                                                                0.889289, -0.284135,
                                                                                                                                                0.471524,
                                                                                                                                                0.674881, -0.567627,
                                                                                                                                                0.093233,
                                                                                                                                                0.985654, -0.140693,
                                                                                                                                                0.475487,
                                                                                                                                                0.703633, -0.528026,
                                                                                                                                                0.043842, -0.999038,
                                                                                                                                                0,
                                                                                                                                                0.130526, -0.991445,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0.382683, -0.92388,
                                                                                                                                                0,
                                                                                                                                                0.382683, -0.92388,
                                                                                                                                                0,
                                                                                                                                                0.382683, -0.92388,
                                                                                                                                                0,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "uv": [-214.35861, -15.144986, -196.653912, -49.888622, -246.846403, -49.719816, -76.288801,
                                                                                                                                                196.333996, -114.705141,
                                                                                                                                                174.666809, -87.46263,
                                                                                                                                                202.567027, -201.445212, -37.18806, -206.447056,
                                                                                                                                                6.632754, -172.072504,
                                                                                                                                                39.157304, -135.956188, -103.916888, -133.956188, -151.197499, -135.956188, -151.197499,
                                                                                                                                                133.956188,
                                                                                                                                                162.269453,
                                                                                                                                                133.956188,
                                                                                                                                                175.064185,
                                                                                                                                                135.956188,
                                                                                                                                                162.269453,
                                                                                                                                                135.956188,
                                                                                                                                                175.064185,
                                                                                                                                                135.956188,
                                                                                                                                                162.269453,
                                                                                                                                                133.956188,
                                                                                                                                                175.064185,
                                                                                                                                                169.725911,
                                                                                                                                                47.565,
                                                                                                                                                197.829904,
                                                                                                                                                42.21,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437, -135.956188, -186.432934, -135.956188, -157.823312, -135.956188, -205.266705, -135.956188, -205.266705, -135.956188, -157.823312, -133.956188, -205.266705, -133.956188, -157.823312, -133.956188, -205.266705, -135.956188, -157.823312,
                                                                                                                                                135.956188,
                                                                                                                                                82.582267,
                                                                                                                                                133.956188,
                                                                                                                                                82.582267,
                                                                                                                                                135.956188,
                                                                                                                                                85.050841,
                                                                                                                                                133.711995,
                                                                                                                                                85.050841,
                                                                                                                                                135.956188,
                                                                                                                                                85.050841,
                                                                                                                                                133.956188,
                                                                                                                                                82.582267, -135.956188, -184.606925, -133.711995, -184.606925, -135.956188, -185.121789, -133.484506, -185.121789, -135.956188, -185.121789, -133.711995, -184.606925, -135.956188, -147.50897, -133.484506, -147.50897, -135.956188, -148.023835, -133.289225, -148.023835, -135.956188, -148.023835, -133.484506, -147.50897, -135.956188, -100.34098, -133.289225, -100.34098, -135.956188, -100.855844, -133.13946, -100.855844, -135.956188, -100.855844, -133.289225, -100.34098, -135.956188, -46.317374, -133.13946, -46.317374, -135.956188, -46.832239, -133.045417, -46.832239, -135.956188, -46.832239, -133.13946, -46.317374, -135.956188,
                                                                                                                                                10.880228, -133.045417,
                                                                                                                                                10.880228, -135.956188,
                                                                                                                                                10.365363, -133.013505,
                                                                                                                                                10.365363, -135.956188,
                                                                                                                                                10.365363, -133.045417,
                                                                                                                                                10.880228, -135.956188,
                                                                                                                                                67.353904, -133.013505,
                                                                                                                                                67.353904, -135.956188,
                                                                                                                                                66.839039, -133.045899,
                                                                                                                                                66.839039, -135.956188,
                                                                                                                                                66.839039, -133.013505,
                                                                                                                                                67.353904, -135.956188,
                                                                                                                                                119.255066, -133.045899,
                                                                                                                                                119.255066, -135.956188,
                                                                                                                                                118.740202, -133.140391,
                                                                                                                                                118.740202, -135.956188,
                                                                                                                                                118.740202, -133.045899,
                                                                                                                                                119.255066, -135.956188,
                                                                                                                                                163.046736, -133.140391,
                                                                                                                                                163.046736, -135.956188,
                                                                                                                                                162.531872, -133.290542,
                                                                                                                                                162.531872, -135.956188,
                                                                                                                                                162.531872, -133.140391,
                                                                                                                                                163.046736, -133.290542,
                                                                                                                                                195.744585, -133.486119,
                                                                                                                                                195.22972, -135.956188,
                                                                                                                                                195.744585, -246.931628,
                                                                                                                                                73.633813, -247.074342,
                                                                                                                                                74.16576, -196.738894,
                                                                                                                                                73.575413, -196.881609,
                                                                                                                                                74.107361, -196.738894,
                                                                                                                                                73.575413, -247.074342,
                                                                                                                                                74.16576, -97.189598,
                                                                                                                                                168.058068, -59.464986,
                                                                                                                                                168.058068, -97.385175,
                                                                                                                                                167.543203, -59.464986,
                                                                                                                                                141.276035, -97.189598,
                                                                                                                                                141.276035, -59.615137,
                                                                                                                                                141.790899, -97.039448,
                                                                                                                                                141.790899, -59.615137,
                                                                                                                                                141.790899, -97.189598,
                                                                                                                                                141.276035, -59.615137,
                                                                                                                                                105.363594, -97.039448,
                                                                                                                                                105.363594, -59.709628,
                                                                                                                                                105.878459, -96.944956,
                                                                                                                                                105.878459, -59.709628,
                                                                                                                                                105.878459, -97.039448,
                                                                                                                                                105.363594, -59.709628,
                                                                                                                                                62.253256, -96.944956,
                                                                                                                                                62.253256, -59.742022,
                                                                                                                                                62.76812, -96.912562,
                                                                                                                                                62.76812, -59.742022,
                                                                                                                                                62.76812, -96.944956,
                                                                                                                                                62.253256, -59.742022,
                                                                                                                                                14.882917, -96.912562,
                                                                                                                                                14.882917, -59.71011,
                                                                                                                                                15.397781, -96.944474,
                                                                                                                                                15.397781, -59.71011,
                                                                                                                                                15.397781, -96.912562,
                                                                                                                                                14.882917, -59.71011, -33.519212, -96.944474, -33.519212, -59.616068, -33.004347, -97.038517, -33.004347, -59.616068, -33.004347, -96.944474, -33.519212, -59.616068, -79.654605, -97.038517, -79.654605, -59.466303, -79.139741, -97.188282, -79.139741, -59.466303, -79.139741, -97.038517, -79.654605, -97.188282, -120.379212, -97.383562, -119.864348, -59.466303, -120.379212, -197.000916, -27.624371, -247.19365, -27.566013, -196.857181, -27.092807, -247.169008, -8.492907, -196.97626, -8.537112, -247.279229, -9.01766, -197.086481, -9.061866, -247.279229, -9.01766, -196.97626, -8.537112, -247.262885,
                                                                                                                                                11.202049, -197.070132,
                                                                                                                                                11.164521, -247.332195,
                                                                                                                                                10.683276, -197.139441,
                                                                                                                                                10.645748, -247.332195,
                                                                                                                                                10.683276, -197.070132,
                                                                                                                                                11.164521, -247.31906,
                                                                                                                                                30.506015, -197.126305,
                                                                                                                                                30.471279, -247.342804,
                                                                                                                                                29.99071, -197.150049,
                                                                                                                                                29.955973, -247.342804,
                                                                                                                                                29.99071, -197.126305,
                                                                                                                                                30.471279, -247.330541,
                                                                                                                                                47.706675, -197.137786,
                                                                                                                                                47.671936, -247.307157,
                                                                                                                                                47.191323, -197.114402,
                                                                                                                                                47.156584, -247.307157,
                                                                                                                                                47.191323, -197.137786,
                                                                                                                                                47.671936, -247.293999,
                                                                                                                                                61.280018, -197.101246,
                                                                                                                                                61.24248, -247.225137,
                                                                                                                                                60.761104, -197.032383,
                                                                                                                                                60.723566, -247.225137,
                                                                                                                                                60.761104, -197.101246,
                                                                                                                                                61.24248, -197.015982,
                                                                                                                                                70.178768, -196.906403,
                                                                                                                                                69.65377, -247.20873,
                                                                                                                                                70.222995, -247.099151,
                                                                                                                                                69.697996, -247.20873,
                                                                                                                                                70.222995, -196.906403,
                                                                                                                                                69.65377, -247.049915, -27.034449, -196.857181, -27.092807, -247.19365, -27.566013, -196.907839, -43.832529, -247.100519, -43.738692, -196.740114, -43.295217, -246.932793, -43.20138, -196.740114, -43.295217, -247.100519, -43.738692,
                                                                                                                                                246.812635,
                                                                                                                                                53.792983,
                                                                                                                                                246.633718,
                                                                                                                                                51.318822,
                                                                                                                                                196.61988,
                                                                                                                                                53.757522,
                                                                                                                                                196.440963,
                                                                                                                                                51.274626,
                                                                                                                                                196.61988,
                                                                                                                                                53.757522,
                                                                                                                                                246.633718,
                                                                                                                                                51.318822,
                                                                                                                                                97.855244,
                                                                                                                                                75.202336,
                                                                                                                                                58.79934,
                                                                                                                                                75.202336,
                                                                                                                                                97.611051,
                                                                                                                                                77.679664, -97.855244, -172.471988, -135.956188, -100.086294, -58.79934, -172.471988, -20.698396, -100.086294, -58.79934, -172.471988, -135.956188, -100.086294,
                                                                                                                                                70.089997, -78.258992,
                                                                                                                                                104.46455, -110.783542,
                                                                                                                                                99.462705, -154.604356, -20.698396, -103.916888, -20.698396, -151.197499, -22.698396, -151.197499, -157.087443,
                                                                                                                                                45.571437, -110.087443,
                                                                                                                                                50.715, -49.724827,
                                                                                                                                                42.21, -110.087443,
                                                                                                                                                50.715, -41.224827,
                                                                                                                                                50.715, -49.724827,
                                                                                                                                                42.21,
                                                                                                                                                20.698396,
                                                                                                                                                41.224827,
                                                                                                                                                20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                22.698396,
                                                                                                                                                41.224827,
                                                                                                                                                22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                22.698396,
                                                                                                                                                41.224827,
                                                                                                                                                20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                22.698396,
                                                                                                                                                41.224827,
                                                                                                                                                22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                34.470004,
                                                                                                                                                41.224827,
                                                                                                                                                26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                34.470004,
                                                                                                                                                41.224827,
                                                                                                                                                22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                34.470004,
                                                                                                                                                41.224827,
                                                                                                                                                26.698396,
                                                                                                                                                51.087443, -18.883164,
                                                                                                                                                50.715, -18.883164,
                                                                                                                                                53.215, -11.721845,
                                                                                                                                                50.715, -31.812977,
                                                                                                                                                53.215, -31.812977,
                                                                                                                                                50.715, -39.980638,
                                                                                                                                                53.215, -36.338632,
                                                                                                                                                50.715, -39.980638,
                                                                                                                                                53.215, -31.812977,
                                                                                                                                                50.715, -39.980638,
                                                                                                                                                50.715, -39.980638,
                                                                                                                                                53.215, -36.338632,
                                                                                                                                                50.715, -50.464143,
                                                                                                                                                53.215, -50.464143,
                                                                                                                                                50.715, -58.631804,
                                                                                                                                                53.215, -58.631804,
                                                                                                                                                50.715, -58.631804,
                                                                                                                                                53.215, -50.464143,
                                                                                                                                                50.715, -65.397955,
                                                                                                                                                53.215, -65.397955,
                                                                                                                                                50.715, -73.565616,
                                                                                                                                                53.215, -73.565616,
                                                                                                                                                50.715, -73.565616,
                                                                                                                                                53.215, -65.397955,
                                                                                                                                                50.715, -75.596698,
                                                                                                                                                53.215, -75.596698,
                                                                                                                                                50.715, -83.764358,
                                                                                                                                                53.215, -83.764358,
                                                                                                                                                50.715, -83.764358,
                                                                                                                                                53.215, -75.596698,
                                                                                                                                                50.715, -80.365344,
                                                                                                                                                53.215, -80.365344,
                                                                                                                                                50.715, -88.533005,
                                                                                                                                                53.215, -88.533005,
                                                                                                                                                50.715, -88.533005,
                                                                                                                                                53.215, -80.365344,
                                                                                                                                                50.715, -79.378919,
                                                                                                                                                50.715, -87.54658,
                                                                                                                                                50.715, -79.378919,
                                                                                                                                                53.215,
                                                                                                                                                41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                35.082627,
                                                                                                                                                84.673564,
                                                                                                                                                30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                30.11047,
                                                                                                                                                78.193723,
                                                                                                                                                26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                26.984841,
                                                                                                                                                70.647789,
                                                                                                                                                22.698396,
                                                                                                                                                51.087443,
                                                                                                                                                25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                25.918748,
                                                                                                                                                62.550003,
                                                                                                                                                28.378577,
                                                                                                                                                51.087443,
                                                                                                                                                26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                26.984841,
                                                                                                                                                54.452218,
                                                                                                                                                28.378577,
                                                                                                                                                51.087443,
                                                                                                                                                30.11047,
                                                                                                                                                46.906283,
                                                                                                                                                26.698396,
                                                                                                                                                51.087443,
                                                                                                                                                49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                41.562468,
                                                                                                                                                89.645721,
                                                                                                                                                20.698396,
                                                                                                                                                110.087443, -72.704646,
                                                                                                                                                50.715, -80.872307,
                                                                                                                                                50.715, -72.704646,
                                                                                                                                                53.215, -80.872307,
                                                                                                                                                53.215, -72.704646,
                                                                                                                                                53.215, -80.872307,
                                                                                                                                                50.715, -49.108403,
                                                                                                                                                92.77135, -41.562468,
                                                                                                                                                89.645721, -41.562468,
                                                                                                                                                35.454285, -41.562468,
                                                                                                                                                35.454285, -41.562468,
                                                                                                                                                89.645721, -35.082627,
                                                                                                                                                40.426442, -41.562468,
                                                                                                                                                89.645721, -35.082627,
                                                                                                                                                84.673564, -35.082627,
                                                                                                                                                40.426442, -87.54658,
                                                                                                                                                53.215, -79.378919,
                                                                                                                                                53.215, -87.54658,
                                                                                                                                                50.715, -35.082627,
                                                                                                                                                84.673564, -30.11047,
                                                                                                                                                78.193723, -35.082627,
                                                                                                                                                40.426442, -35.082627,
                                                                                                                                                40.426442, -30.11047,
                                                                                                                                                78.193723, -30.11047,
                                                                                                                                                46.906283, -30.11047,
                                                                                                                                                78.193723, -26.984841,
                                                                                                                                                70.647789, -30.11047,
                                                                                                                                                46.906283, -30.11047,
                                                                                                                                                46.906283, -26.984841,
                                                                                                                                                70.647789, -26.984841,
                                                                                                                                                54.452218, -25.918748,
                                                                                                                                                62.550003, -26.984841,
                                                                                                                                                54.452218, -26.984841,
                                                                                                                                                70.647789, -10.715503,
                                                                                                                                                53.215, -10.715503,
                                                                                                                                                50.612745, -18.883164,
                                                                                                                                                53.215,
                                                                                                                                                3.222861,
                                                                                                                                                53.215,
                                                                                                                                                11.390521,
                                                                                                                                                53.215,
                                                                                                                                                3.222861,
                                                                                                                                                50.612745,
                                                                                                                                                11.390521,
                                                                                                                                                49.783762,
                                                                                                                                                3.222861,
                                                                                                                                                50.612745,
                                                                                                                                                11.390521,
                                                                                                                                                53.215,
                                                                                                                                                49.880773, -13.94163,
                                                                                                                                                47.381667, -21.761628,
                                                                                                                                                31.703363, -48.674792,
                                                                                                                                                49.319921,
                                                                                                                                                28.39978,
                                                                                                                                                55.800309,
                                                                                                                                                23.402813,
                                                                                                                                                62.407784,
                                                                                                                                                0.136102, -32.998607,
                                                                                                                                                49.279355, -32.998607,
                                                                                                                                                53.215, -24.830946,
                                                                                                                                                49.783762,
                                                                                                                                                44.468537,
                                                                                                                                                53.215,
                                                                                                                                                52.636198,
                                                                                                                                                53.215,
                                                                                                                                                44.468537,
                                                                                                                                                49.279355, -57.206188,
                                                                                                                                                31.262563, -49.108403,
                                                                                                                                                92.77135, -49.108403,
                                                                                                                                                32.328657, -57.206188,
                                                                                                                                                93.837443, -49.108403,
                                                                                                                                                92.77135, -57.206188,
                                                                                                                                                31.262563, -68.965025,
                                                                                                                                                53.215, -60.797364,
                                                                                                                                                53.215, -68.965025,
                                                                                                                                                50.715, -60.797364,
                                                                                                                                                50.715, -68.965025,
                                                                                                                                                50.715, -60.797364,
                                                                                                                                                53.215,
                                                                                                                                                57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                49.108403,
                                                                                                                                                92.77135,
                                                                                                                                                20.698396,
                                                                                                                                                110.087443,
                                                                                                                                                65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                57.206188,
                                                                                                                                                93.837443,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443, -44.468537,
                                                                                                                                                50.715, -52.636198,
                                                                                                                                                50.715, -44.468537,
                                                                                                                                                53.215, -52.636198,
                                                                                                                                                53.215, -44.468537,
                                                                                                                                                53.215, -52.636198,
                                                                                                                                                50.715, -65.303973,
                                                                                                                                                92.77135, -57.206188,
                                                                                                                                                93.837443, -57.206188,
                                                                                                                                                31.262563, -65.303973,
                                                                                                                                                32.328657, -65.303973,
                                                                                                                                                92.77135, -57.206188,
                                                                                                                                                31.262563, -72.849908,
                                                                                                                                                35.454285, -65.303973,
                                                                                                                                                92.77135, -65.303973,
                                                                                                                                                32.328657, -72.849908,
                                                                                                                                                89.645721, -65.303973,
                                                                                                                                                92.77135, -72.849908,
                                                                                                                                                35.454285, -32.998607,
                                                                                                                                                53.215, -24.830946,
                                                                                                                                                53.215, -32.998607,
                                                                                                                                                50.715, -24.830946,
                                                                                                                                                50.715, -32.998607,
                                                                                                                                                50.715, -24.830946,
                                                                                                                                                53.215,
                                                                                                                                                72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                65.303973,
                                                                                                                                                92.77135,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                72.849908,
                                                                                                                                                89.645721,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443, -3.222861,
                                                                                                                                                50.715, -11.390521,
                                                                                                                                                50.715, -3.222861,
                                                                                                                                                53.215, -11.390521,
                                                                                                                                                53.215, -3.222861,
                                                                                                                                                53.215, -11.390521,
                                                                                                                                                50.715, -79.329749,
                                                                                                                                                84.673564, -72.849908,
                                                                                                                                                89.645721, -76.987306,
                                                                                                                                                38.629022, -76.987306,
                                                                                                                                                38.629022, -72.849908,
                                                                                                                                                89.645721, -72.849908,
                                                                                                                                                35.454285,
                                                                                                                                                84.593995,
                                                                                                                                                53.215,
                                                                                                                                                87.54658,
                                                                                                                                                53.215,
                                                                                                                                                79.378919,
                                                                                                                                                53.215, -79.329749,
                                                                                                                                                40.426442, -79.329749,
                                                                                                                                                84.673564, -76.987306,
                                                                                                                                                38.629022, -84.301906,
                                                                                                                                                78.193723, -79.329749,
                                                                                                                                                84.673564, -79.329749,
                                                                                                                                                40.426442,
                                                                                                                                                18.883164,
                                                                                                                                                53.215,
                                                                                                                                                18.883164,
                                                                                                                                                50.715,
                                                                                                                                                10.715503,
                                                                                                                                                53.215,
                                                                                                                                                10.715503,
                                                                                                                                                50.715,
                                                                                                                                                10.715503,
                                                                                                                                                53.215,
                                                                                                                                                18.883164,
                                                                                                                                                50.715,
                                                                                                                                                39.980638,
                                                                                                                                                53.215,
                                                                                                                                                39.980638,
                                                                                                                                                50.715,
                                                                                                                                                35.304769,
                                                                                                                                                53.215,
                                                                                                                                                35.304769,
                                                                                                                                                50.715,
                                                                                                                                                35.304769,
                                                                                                                                                53.215,
                                                                                                                                                39.980638,
                                                                                                                                                50.715,
                                                                                                                                                35.304769,
                                                                                                                                                53.215,
                                                                                                                                                35.304769,
                                                                                                                                                50.715,
                                                                                                                                                31.812977,
                                                                                                                                                53.215,
                                                                                                                                                31.812977,
                                                                                                                                                50.715,
                                                                                                                                                31.812977,
                                                                                                                                                53.215,
                                                                                                                                                35.304769,
                                                                                                                                                50.715,
                                                                                                                                                58.631804,
                                                                                                                                                53.215,
                                                                                                                                                58.631804,
                                                                                                                                                50.715,
                                                                                                                                                50.464143,
                                                                                                                                                53.215,
                                                                                                                                                50.464143,
                                                                                                                                                50.715,
                                                                                                                                                50.464143,
                                                                                                                                                53.215,
                                                                                                                                                58.631804,
                                                                                                                                                50.715,
                                                                                                                                                73.565616,
                                                                                                                                                53.215,
                                                                                                                                                73.565616,
                                                                                                                                                50.715,
                                                                                                                                                65.397955,
                                                                                                                                                53.215,
                                                                                                                                                65.397955,
                                                                                                                                                50.715,
                                                                                                                                                65.397955,
                                                                                                                                                53.215,
                                                                                                                                                73.565616,
                                                                                                                                                50.715,
                                                                                                                                                83.764358,
                                                                                                                                                50.715,
                                                                                                                                                80.122353,
                                                                                                                                                50.715,
                                                                                                                                                83.764358,
                                                                                                                                                53.215,
                                                                                                                                                87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                86.033799,
                                                                                                                                                51.087443,
                                                                                                                                                88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                88.493628,
                                                                                                                                                62.550003,
                                                                                                                                                87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                87.427535,
                                                                                                                                                70.647789,
                                                                                                                                                86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                86.091283,
                                                                                                                                                73.873784,
                                                                                                                                                84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                84.301906,
                                                                                                                                                78.193723,
                                                                                                                                                79.329749,
                                                                                                                                                84.673564,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                135.956188,
                                                                                                                                                41.224827,
                                                                                                                                                95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                135.956188,
                                                                                                                                                110.087443,
                                                                                                                                                135.956188,
                                                                                                                                                22.596655,
                                                                                                                                                95.175013,
                                                                                                                                                53.252493,
                                                                                                                                                135.956188,
                                                                                                                                                53.252493,
                                                                                                                                                80.384844, -43.818431,
                                                                                                                                                99.390022, -20.881116,
                                                                                                                                                111.609922, -70.414525,
                                                                                                                                                95.175013,
                                                                                                                                                47.333639,
                                                                                                                                                95.175013,
                                                                                                                                                17.545769,
                                                                                                                                                79.942372,
                                                                                                                                                47.333639,
                                                                                                                                                79.329749,
                                                                                                                                                46.528732,
                                                                                                                                                79.942372,
                                                                                                                                                47.333639,
                                                                                                                                                95.175013,
                                                                                                                                                17.545769,
                                                                                                                                                81.371687,
                                                                                                                                                50.715,
                                                                                                                                                80.365344,
                                                                                                                                                50.612745,
                                                                                                                                                88.533005,
                                                                                                                                                53.215,
                                                                                                                                                80.365344,
                                                                                                                                                53.215,
                                                                                                                                                88.533005,
                                                                                                                                                53.215,
                                                                                                                                                80.365344,
                                                                                                                                                50.612745, -84.301906,
                                                                                                                                                46.906283, -84.301906,
                                                                                                                                                78.193723, -79.329749,
                                                                                                                                                40.426442, -87.427535,
                                                                                                                                                54.452218, -84.301906,
                                                                                                                                                78.193723, -84.301906,
                                                                                                                                                46.906283, -86.091283,
                                                                                                                                                73.873784, -84.301906,
                                                                                                                                                78.193723, -87.427535,
                                                                                                                                                54.452218, -87.427535,
                                                                                                                                                70.647789, -86.091283,
                                                                                                                                                73.873784, -87.427535,
                                                                                                                                                54.452218, -88.493628,
                                                                                                                                                62.550003, -87.427535,
                                                                                                                                                70.647789, -87.427535,
                                                                                                                                                54.452218,
                                                                                                                                                75.596698,
                                                                                                                                                53.215,
                                                                                                                                                83.764358,
                                                                                                                                                53.215,
                                                                                                                                                75.596698,
                                                                                                                                                50.715,
                                                                                                                                                80.122353,
                                                                                                                                                50.715,
                                                                                                                                                75.596698,
                                                                                                                                                50.715,
                                                                                                                                                83.764358,
                                                                                                                                                53.215,
                                                                                                                                                86.033799,
                                                                                                                                                51.087443,
                                                                                                                                                95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                79.942372,
                                                                                                                                                41.224827,
                                                                                                                                                84.301906,
                                                                                                                                                46.906283,
                                                                                                                                                95.175013,
                                                                                                                                                41.224827,
                                                                                                                                                88.533005,
                                                                                                                                                50.715,
                                                                                                                                                81.371687,
                                                                                                                                                50.715,
                                                                                                                                                88.533005,
                                                                                                                                                53.215,
                                                                                                                                                87.54658,
                                                                                                                                                53.215,
                                                                                                                                                87.54658,
                                                                                                                                                50.612745,
                                                                                                                                                79.378919,
                                                                                                                                                53.215,
                                                                                                                                                79.378919,
                                                                                                                                                49.783762,
                                                                                                                                                79.378919,
                                                                                                                                                53.215,
                                                                                                                                                87.54658,
                                                                                                                                                50.612745,
                                                                                                                                                80.872307,
                                                                                                                                                53.215,
                                                                                                                                                80.872307,
                                                                                                                                                49.783762,
                                                                                                                                                72.704646,
                                                                                                                                                53.215,
                                                                                                                                                72.704646,
                                                                                                                                                49.279355,
                                                                                                                                                72.704646,
                                                                                                                                                53.215,
                                                                                                                                                80.872307,
                                                                                                                                                49.783762,
                                                                                                                                                68.965025,
                                                                                                                                                53.215,
                                                                                                                                                68.965025,
                                                                                                                                                49.279355,
                                                                                                                                                60.797364,
                                                                                                                                                53.215,
                                                                                                                                                60.797364,
                                                                                                                                                53.215,
                                                                                                                                                68.965025,
                                                                                                                                                49.279355,
                                                                                                                                                60.797364,
                                                                                                                                                49.279355,
                                                                                                                                                60.797364,
                                                                                                                                                49.107311,
                                                                                                                                                60.797364,
                                                                                                                                                49.279355,
                                                                                                                                                68.965025,
                                                                                                                                                49.279355,
                                                                                                                                                52.636198,
                                                                                                                                                49.279355,
                                                                                                                                                52.636198,
                                                                                                                                                49.107311,
                                                                                                                                                44.468537,
                                                                                                                                                49.279355,
                                                                                                                                                51.017836,
                                                                                                                                                34.429404,
                                                                                                                                                59.033969,
                                                                                                                                                32.854005,
                                                                                                                                                62.085224,
                                                                                                                                                12.923325,
                                                                                                                                                60.713393,
                                                                                                                                                20.327418,
                                                                                                                                                55.329942,
                                                                                                                                                39.758337,
                                                                                                                                                63.353738,
                                                                                                                                                41.294234,
                                                                                                                                                61.479571,
                                                                                                                                                16.906844,
                                                                                                                                                65.303973,
                                                                                                                                                37.690317,
                                                                                                                                                95.175013,
                                                                                                                                                16.906844,
                                                                                                                                                61.99979,
                                                                                                                                                44.4121,
                                                                                                                                                69.220882,
                                                                                                                                                48.261896,
                                                                                                                                                93.668634,
                                                                                                                                                26.486809,
                                                                                                                                                66.814777,
                                                                                                                                                52.331311,
                                                                                                                                                72.489221,
                                                                                                                                                58.26415,
                                                                                                                                                92.406529,
                                                                                                                                                31.912957,
                                                                                                                                                95.175013,
                                                                                                                                                23.051742,
                                                                                                                                                95.175013,
                                                                                                                                                20.844114,
                                                                                                                                                61.479571,
                                                                                                                                                23.051742,
                                                                                                                                                90.654871, -16.697152,
                                                                                                                                                91.535337, -14.672701,
                                                                                                                                                129.865385, -35.122769,
                                                                                                                                                95.253584,
                                                                                                                                                9.514833,
                                                                                                                                                134.89227, -1.027098,
                                                                                                                                                136.57686, -3.893549,
                                                                                                                                                135.956188,
                                                                                                                                                30.933141,
                                                                                                                                                138.206188,
                                                                                                                                                30.933141,
                                                                                                                                                138.206188,
                                                                                                                                                28.485309, -135.956188, -11.305674, -135.956188, -49.353646, -138.206188, -11.305674,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866,
                                                                                                                                                41.224827,
                                                                                                                                                50.715,
                                                                                                                                                49.724827,
                                                                                                                                                42.21,
                                                                                                                                                110.087443,
                                                                                                                                                50.715,
                                                                                                                                                49.724827,
                                                                                                                                                42.21,
                                                                                                                                                41.224827,
                                                                                                                                                50.715,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437,
                                                                                                                                                49.724827,
                                                                                                                                                42.21,
                                                                                                                                                110.087443,
                                                                                                                                                50.715,
                                                                                                                                                197.829904,
                                                                                                                                                42.21,
                                                                                                                                                49.724827,
                                                                                                                                                42.21,
                                                                                                                                                157.087443,
                                                                                                                                                45.571437,
                                                                                                                                                135.956188,
                                                                                                                                                49.724827,
                                                                                                                                                135.956188,
                                                                                                                                                197.829904,
                                                                                                                                                138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                138.206188,
                                                                                                                                                197.829904,
                                                                                                                                                138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                135.956188,
                                                                                                                                                197.829904, -197.829904,
                                                                                                                                                42.21, -216.330819,
                                                                                                                                                50.715, -49.724827,
                                                                                                                                                42.21, -216.330819,
                                                                                                                                                38.684793, -216.330819,
                                                                                                                                                50.715, -197.829904,
                                                                                                                                                42.21, -216.841278,
                                                                                                                                                38.600117, -216.330819,
                                                                                                                                                50.715, -216.330819,
                                                                                                                                                38.684793, -219.042524,
                                                                                                                                                48.673661, -216.330819,
                                                                                                                                                50.715, -216.841278,
                                                                                                                                                38.600117, -219.042524,
                                                                                                                                                22.026505, -216.841278,
                                                                                                                                                33.799362, -216.330819,
                                                                                                                                                19.985166, -217.316951,
                                                                                                                                                34.04762, -216.841278,
                                                                                                                                                33.799362, -219.042524,
                                                                                                                                                22.026505, -248.873703,
                                                                                                                                                0.687476, -249.591143, -3.402947, -250.041986, -3.112023, -230.067279, -29.113186, -229.798936, -33.359732, -230.306503, -33.259156, -135.932252,
                                                                                                                                                63.939651, -138.180874,
                                                                                                                                                63.940513, -135.930814,
                                                                                                                                                67.551938, -138.176397,
                                                                                                                                                135.167004, -135.927775,
                                                                                                                                                135.166177, -138.176861,
                                                                                                                                                128.279103, -135.926861,
                                                                                                                                                128.278952, -138.176861,
                                                                                                                                                128.279103, -135.927775,
                                                                                                                                                135.166177, -135.956176,
                                                                                                                                                213.69495, -135.956379,
                                                                                                                                                162.175021, -138.206176,
                                                                                                                                                213.69495, -162.779589,
                                                                                                                                                16.049383, -212.955174,
                                                                                                                                                27.741849, -216.321977,
                                                                                                                                                33.750052, -254.408652,
                                                                                                                                                0.838601, -206.633203, -29.121751, -254.4094,
                                                                                                                                                0.837156, -114.351308,
                                                                                                                                                10.45308, -162.79178,
                                                                                                                                                16.001921, -216.334027,
                                                                                                                                                33.703444, -162.788863,
                                                                                                                                                16.011541, -114.348391,
                                                                                                                                                10.462699, -114.348249,
                                                                                                                                                4.723377, -87.833361,
                                                                                                                                                4.723377, -114.348249,
                                                                                                                                                4.723377, -114.348391,
                                                                                                                                                10.462699, -135.956181,
                                                                                                                                                112.436549, -138.206181,
                                                                                                                                                112.436549, -135.956379,
                                                                                                                                                162.175021, -135.956188,
                                                                                                                                                114.347958, -135.956188,
                                                                                                                                                49.724827, -138.206188,
                                                                                                                                                114.347958, -138.206188,
                                                                                                                                                49.724827, -138.206188,
                                                                                                                                                114.347958, -135.956188,
                                                                                                                                                49.724827, -114.347958,
                                                                                                                                                4.725, -49.724827,
                                                                                                                                                4.725, -49.724827,
                                                                                                                                                0, -49.724827,
                                                                                                                                                4.725, -11.678311,
                                                                                                                                                15.767866, -49.724827,
                                                                                                                                                0,
                                                                                                                                                138.206188, -46.436964,
                                                                                                                                                135.956188, -46.436964,
                                                                                                                                                138.206188, -6.820272,
                                                                                                                                                39.521008, -120.374283,
                                                                                                                                                46.395829, -57.5106,
                                                                                                                                                71.647948, -97.084703, -27.919618, -72.609094,
                                                                                                                                                9.222907, -62.907596, -19.082632, -119.457594,
                                                                                                                                                95.175013, -45.362976,
                                                                                                                                                95.175013, -61.788624,
                                                                                                                                                95.175013, -6.974355, -46.934073, -70.301834, -30.945085, -66.539629, -39.643139, -117.124088,
                                                                                                                                                12.561854, -121.514935,
                                                                                                                                                6.501329, -70.547164,
                                                                                                                                                27.539442, -113.328844,
                                                                                                                                                135.956188, -63.388077,
                                                                                                                                                133.956188, -63.388077,
                                                                                                                                                135.956188, -46.436964, -135.955704,
                                                                                                                                                113.973719, -133.956188,
                                                                                                                                                64.51015, -135.956188,
                                                                                                                                                64.51015,
                                                                                                                                                114.347958,
                                                                                                                                                25.141402,
                                                                                                                                                66.004096,
                                                                                                                                                25.141402,
                                                                                                                                                114.3481,
                                                                                                                                                35.795045, -66.004096, -109.629902, -114.347958, -109.629902, -66.004096, -62.243393, -114.347958, -62.243393, -66.004096, -62.243393, -114.347958, -109.629902, -95.175013,
                                                                                                                                                66.004096, -95.175013,
                                                                                                                                                114.347958, -61.479571,
                                                                                                                                                66.004096, -61.479571,
                                                                                                                                                114.347958, -61.479571,
                                                                                                                                                66.004096, -95.175013,
                                                                                                                                                114.347958,
                                                                                                                                                66.004096,
                                                                                                                                                65.962903,
                                                                                                                                                114.347958,
                                                                                                                                                65.962903,
                                                                                                                                                66.004096,
                                                                                                                                                18.576394,
                                                                                                                                                114.347958,
                                                                                                                                                18.576394,
                                                                                                                                                66.004096,
                                                                                                                                                18.576394,
                                                                                                                                                114.347958,
                                                                                                                                                65.962903, -66.004096, -4.260121, -114.347958, -4.260121, -114.3481,
                                                                                                                                                6.393522, -115.425326,
                                                                                                                                                7.759408, -115.551206, -2.893491, -217.331197,
                                                                                                                                                31.428764,
                                                                                                                                                186.052802,
                                                                                                                                                109.693647,
                                                                                                                                                93.784973,
                                                                                                                                                54.70427,
                                                                                                                                                77.264822,
                                                                                                                                                99.117848,
                                                                                                                                                82.704734,
                                                                                                                                                174.873386,
                                                                                                                                                132.896505,
                                                                                                                                                175.190784,
                                                                                                                                                34.441454,
                                                                                                                                                127.722109,
                                                                                                                                                83.759943,
                                                                                                                                                58.716504,
                                                                                                                                                83.938845,
                                                                                                                                                62.34064,
                                                                                                                                                133.952699,
                                                                                                                                                58.760245, -58.797478,
                                                                                                                                                58.920418, -97.857107,
                                                                                                                                                58.920418, -59.041734,
                                                                                                                                                62.540737, -58.797478,
                                                                                                                                                183.84591, -61.479571,
                                                                                                                                                116.426378, -97.857107,
                                                                                                                                                183.84591, -95.175013,
                                                                                                                                                116.426378, -97.857107,
                                                                                                                                                183.84591, -61.479571,
                                                                                                                                                116.426378, -196.057508,
                                                                                                                                                67.758271, -147.794228,
                                                                                                                                                20.606995, -246.249279,
                                                                                                                                                68.07567, -143.997131, -12.848387, -160.517281, -57.261965, -252.78511, -2.272588,
                                                                                                                                                105.677939,
                                                                                                                                                26.393417,
                                                                                                                                                105.552059,
                                                                                                                                                37.046316,
                                                                                                                                                207.45793,
                                                                                                                                                60.715672, -133.95805,
                                                                                                                                                218.412945, -135.955704,
                                                                                                                                                113.81345, -135.956188,
                                                                                                                                                218.412945, -133.95805,
                                                                                                                                                63.953341, -135.956188,
                                                                                                                                                63.953341, -133.713793,
                                                                                                                                                67.564803, -135.956188,
                                                                                                                                                67.564803, -133.713793,
                                                                                                                                                67.564803, -135.956188,
                                                                                                                                                63.953341, -135.956188,
                                                                                                                                                214.605442, -135.956188,
                                                                                                                                                215.120306, -133.713793,
                                                                                                                                                214.605442, -245.311246, -8.017514, -244.852131, -8.250536, -245.899727, -12.085066, -256.337941,
                                                                                                                                                33.418965, -257.540683,
                                                                                                                                                29.48899, -257.885895,
                                                                                                                                                29.940253, -217.72542,
                                                                                                                                                34.442541, -217.316951,
                                                                                                                                                34.04762, -219.042524,
                                                                                                                                                22.026505, -218.03885,
                                                                                                                                                34.957213, -217.72542,
                                                                                                                                                34.442541, -219.042524,
                                                                                                                                                22.026505, -247.592264,
                                                                                                                                                61.315822, -247.799335,
                                                                                                                                                61.881725, -246.110303,
                                                                                                                                                65.457004, -228.641248,
                                                                                                                                                75.268556, -230.571795,
                                                                                                                                                71.817695, -228.742446,
                                                                                                                                                75.773377, -216.331651,
                                                                                                                                                73.844677, -216.413549,
                                                                                                                                                74.470242, -214.367131,
                                                                                                                                                77.734998, -218.23588,
                                                                                                                                                35.55656, -218.03885,
                                                                                                                                                34.957213, -219.042524,
                                                                                                                                                22.026505, -218.303083,
                                                                                                                                                36.199739, -218.23588,
                                                                                                                                                35.55656, -219.042524,
                                                                                                                                                22.026505, -166.953891,
                                                                                                                                                55.658672, -166.96315,
                                                                                                                                                56.305286, -164.734604,
                                                                                                                                                59.316496, -96.23047,
                                                                                                                                                8.199166, -98.446692,
                                                                                                                                                5.178875, -96.242071,
                                                                                                                                                8.713899, -108.235248,
                                                                                                                                                11.83658, -108.244103,
                                                                                                                                                12.4832, -106.013722,
                                                                                                                                                15.361006, -218.303083,
                                                                                                                                                36.199739, -219.042524,
                                                                                                                                                48.673661, -218.23588,
                                                                                                                                                36.842919, -219.042524,
                                                                                                                                                48.673661, -218.303083,
                                                                                                                                                36.199739, -219.042524,
                                                                                                                                                22.026505, -221.342226,
                                                                                                                                                46.356211, -219.042524,
                                                                                                                                                48.673661, -219.042524,
                                                                                                                                                22.026505, -221.342226,
                                                                                                                                                24.343955, -221.342226,
                                                                                                                                                46.356211, -219.042524,
                                                                                                                                                22.026505, -223.182267,
                                                                                                                                                43.810676, -221.342226,
                                                                                                                                                46.356211, -221.342226,
                                                                                                                                                24.343955, -223.182267,
                                                                                                                                                26.88949, -223.182267,
                                                                                                                                                43.810676, -221.342226,
                                                                                                                                                24.343955, -224.524515,
                                                                                                                                                41.089808, -223.182267,
                                                                                                                                                43.810676, -223.182267,
                                                                                                                                                26.88949, -224.524515,
                                                                                                                                                29.610358, -224.524515,
                                                                                                                                                41.089808, -223.182267,
                                                                                                                                                26.88949, -225.341154,
                                                                                                                                                38.249994, -224.524515,
                                                                                                                                                41.089808, -224.524515,
                                                                                                                                                29.610358, -225.341154,
                                                                                                                                                32.450172, -225.341154,
                                                                                                                                                38.249994, -224.524515,
                                                                                                                                                29.610358, -225.61526,
                                                                                                                                                35.350083, -225.341154,
                                                                                                                                                38.249994, -225.341154,
                                                                                                                                                32.450172, -218.23588,
                                                                                                                                                36.842919, -219.042524,
                                                                                                                                                48.673661, -218.03885,
                                                                                                                                                37.442266, -218.03885,
                                                                                                                                                37.442266, -219.042524,
                                                                                                                                                48.673661, -217.72542,
                                                                                                                                                37.956938, -217.72542,
                                                                                                                                                37.956938, -219.042524,
                                                                                                                                                48.673661, -217.316951,
                                                                                                                                                38.351859, -217.316951,
                                                                                                                                                38.351859, -219.042524,
                                                                                                                                                48.673661, -216.841278,
                                                                                                                                                38.600117,
                                                                                                                                                139.618757, -105.380553,
                                                                                                                                                139.186663, -105.062447,
                                                                                                                                                140.559559, -102.111665,
                                                                                                                                                154.902454, -102.812252,
                                                                                                                                                155.688428, -99.542049,
                                                                                                                                                156.134135, -99.799791,
                                                                                                                                                194.056192, -83.343736,
                                                                                                                                                193.551328, -83.230371,
                                                                                                                                                194.388435, -79.996857,
                                                                                                                                                138.206188,
                                                                                                                                                82.582267,
                                                                                                                                                135.956188,
                                                                                                                                                82.582267,
                                                                                                                                                135.956188,
                                                                                                                                                85.050841, -138.206188, -205.266705, -138.206188, -186.432934, -135.956188, -205.266705, -138.206188, -186.432934, -135.956188, -186.432934, -135.956188, -205.266705,
                                                                                                                                                102.515742, -108.382936,
                                                                                                                                                103.776801, -105.223749,
                                                                                                                                                104.115085, -105.611885,
                                                                                                                                                79.803676, -103.219993,
                                                                                                                                                79.488797, -102.747065,
                                                                                                                                                81.236895, -100.067367,
                                                                                                                                                13.972894, -80.989422,
                                                                                                                                                13.79101, -80.414928,
                                                                                                                                                15.623414, -77.476312,
                                                                                                                                                49.474343, -88.280056,
                                                                                                                                                47.830041, -91.420103,
                                                                                                                                                49.260399, -87.811747, -47.235271, -38.897754, -47.308472, -38.271112, -45.219515, -35.407568, -18.536101, -50.956718, -20.52663, -54.005351, -18.627956, -50.450113, -173.024172,
                                                                                                                                                62.790506, -175.237409,
                                                                                                                                                59.636455, -173.036271,
                                                                                                                                                63.305228, -253.423109,
                                                                                                                                                52.132367, -254.903078,
                                                                                                                                                48.371108, -253.659192,
                                                                                                                                                52.589916, -255.797906,
                                                                                                                                                21.541741, -255.434642,
                                                                                                                                                21.176878, -256.826756,
                                                                                                                                                17.632924, -135.956188,
                                                                                                                                                195.22972, -135.956188,
                                                                                                                                                195.744585, -133.486119,
                                                                                                                                                195.22972, -133.486119,
                                                                                                                                                215.120306, -133.713793,
                                                                                                                                                214.605442, -135.956188,
                                                                                                                                                215.120306, -246.714553,
                                                                                                                                                72.739284, -246.880404,
                                                                                                                                                73.277257, -196.521874,
                                                                                                                                                72.645331, -196.687724,
                                                                                                                                                73.183304, -196.521874,
                                                                                                                                                72.645331, -246.880404,
                                                                                                                                                73.277257, -97.385175,
                                                                                                                                                182.8899, -59.269409,
                                                                                                                                                182.8899, -97.61285,
                                                                                                                                                182.375036, -59.269409,
                                                                                                                                                167.543203, -97.385175,
                                                                                                                                                167.543203, -59.464986,
                                                                                                                                                168.058068,
                                                                                                                                                84.106145,
                                                                                                                                                161.959425,
                                                                                                                                                134.298878,
                                                                                                                                                162.017825,
                                                                                                                                                83.96343,
                                                                                                                                                161.427478,
                                                                                                                                                134.365725,
                                                                                                                                                138.031601,
                                                                                                                                                84.172977,
                                                                                                                                                137.987374,
                                                                                                                                                134.475304,
                                                                                                                                                138.556599,
                                                                                                                                                84.282556,
                                                                                                                                                138.512373,
                                                                                                                                                134.475304,
                                                                                                                                                138.556599,
                                                                                                                                                84.172977,
                                                                                                                                                137.987374,
                                                                                                                                                84.326661,
                                                                                                                                                104.206329,
                                                                                                                                                84.395523,
                                                                                                                                                104.725244,
                                                                                                                                                134.519414,
                                                                                                                                                104.243867,
                                                                                                                                                134.588277,
                                                                                                                                                104.762781,
                                                                                                                                                134.519414,
                                                                                                                                                104.243867,
                                                                                                                                                84.395523,
                                                                                                                                                104.725244, -23.608685,
                                                                                                                                                119.255066, -20.698396,
                                                                                                                                                119.255066, -23.514193,
                                                                                                                                                118.740202, -20.698396,
                                                                                                                                                66.839039, -23.608685,
                                                                                                                                                66.839039, -20.698396,
                                                                                                                                                67.353904, -23.641079,
                                                                                                                                                67.353904, -20.698396,
                                                                                                                                                67.353904, -23.608685,
                                                                                                                                                66.839039, -20.698396,
                                                                                                                                                10.365363, -23.641079,
                                                                                                                                                10.365363, -20.698396,
                                                                                                                                                10.880228, -23.609167,
                                                                                                                                                10.880228, -20.698396,
                                                                                                                                                10.880228, -23.641079,
                                                                                                                                                10.365363, -20.698396, -46.832239, -23.609167, -46.832239, -20.698396, -46.317374, -23.515124, -46.317374, -20.698396, -46.317374, -23.609167, -46.832239, -20.698396, -100.855844, -23.515124, -100.855844, -20.698396, -100.34098, -23.365359, -100.34098, -20.698396, -100.34098, -23.515124, -100.855844, -23.365359, -148.023835, -23.170078, -147.50897, -20.698396, -148.023835,
                                                                                                                                                134.47897, -115.023795,
                                                                                                                                                134.622704, -115.555359,
                                                                                                                                                84.286236, -115.082152,
                                                                                                                                                84.429971, -115.613716,
                                                                                                                                                84.286236, -115.082152,
                                                                                                                                                134.622704, -115.555359, -59.271022, -119.864348, -59.466303, -120.379212, -97.383562, -119.864348, -97.383562, -152.917719, -97.611051, -152.402854, -59.271022, -152.917719, -59.043533, -152.402854, -59.271022, -152.917719, -97.611051, -152.402854,
                                                                                                                                                84.424112, -145.269863,
                                                                                                                                                84.256386, -144.73255,
                                                                                                                                                134.616791, -145.176025,
                                                                                                                                                134.449066, -144.638713,
                                                                                                                                                134.616791, -145.176025,
                                                                                                                                                84.256386, -144.73255, -23.170078, -185.121789, -22.94259, -184.606925, -20.698396, -185.121789, -20.698396, -184.606925, -20.698396, -185.121789, -22.94259, -184.606925, -211.224804, -3.670486, -210.778013, -3.41463, -210.452738, -6.983287, -205.066583, -14.531201, -204.109958, -17.755616, -204.540497, -18.075824, -29.30435,
                                                                                                                                                81.287868, -31.611462,
                                                                                                                                                81.201418, -29.421044,
                                                                                                                                                83.753682, -18.448396, -207.083885, -18.448396, -207.60132, -20.698396, -207.083885,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793,
                                                                                                                                                216.330819,
                                                                                                                                                50.715,
                                                                                                                                                216.330819,
                                                                                                                                                38.684793,
                                                                                                                                                197.829904,
                                                                                                                                                42.21,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -18.448396, -205.266705, -20.698396, -205.266705, -18.448396, -186.432934, -20.698396, -186.432934, -18.448396, -186.432934, -20.698396, -205.266705,
                                                                                                                                                20.698396,
                                                                                                                                                197.829904,
                                                                                                                                                20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                18.448396,
                                                                                                                                                197.829904, -197.829904,
                                                                                                                                                42.21, -157.087443,
                                                                                                                                                45.571437, -49.724827,
                                                                                                                                                42.21, -169.725911,
                                                                                                                                                47.565, -157.087443,
                                                                                                                                                45.571437, -197.829904,
                                                                                                                                                42.21,
                                                                                                                                                20.698396,
                                                                                                                                                162.269453,
                                                                                                                                                20.698396,
                                                                                                                                                175.064185,
                                                                                                                                                22.698396,
                                                                                                                                                162.269453,
                                                                                                                                                22.698396,
                                                                                                                                                175.064185,
                                                                                                                                                22.698396,
                                                                                                                                                162.269453,
                                                                                                                                                20.698396,
                                                                                                                                                175.064185,
                                                                                                                                                149.489369,
                                                                                                                                                65.10882,
                                                                                                                                                160.663198,
                                                                                                                                                71.341851,
                                                                                                                                                187.905709,
                                                                                                                                                43.441633,
                                                                                                                                                102.039763, -120.683941,
                                                                                                                                                134.527555, -155.258771,
                                                                                                                                                84.335065, -155.427577, -22.698396, -157.823312, -20.698396, -186.432934, -22.698396, -205.266705, -20.698396, -157.823312, -20.698396, -186.432934, -22.698396, -157.823312, -22.698396, -205.266705, -20.698396, -186.432934, -20.698396, -205.266705,
                                                                                                                                                22.698396,
                                                                                                                                                82.582267,
                                                                                                                                                20.698396,
                                                                                                                                                82.582267,
                                                                                                                                                22.94259,
                                                                                                                                                85.050841,
                                                                                                                                                20.698396,
                                                                                                                                                85.050841,
                                                                                                                                                22.94259,
                                                                                                                                                85.050841,
                                                                                                                                                20.698396,
                                                                                                                                                82.582267, -134.120733,
                                                                                                                                                77.361943, -83.927978,
                                                                                                                                                77.326481, -133.941816,
                                                                                                                                                74.887781, -83.749061,
                                                                                                                                                74.843585, -133.941816,
                                                                                                                                                74.887781, -83.927978,
                                                                                                                                                77.326481,
                                                                                                                                                59.043533,
                                                                                                                                                77.679664,
                                                                                                                                                97.611051,
                                                                                                                                                77.679664,
                                                                                                                                                58.79934,
                                                                                                                                                75.202336,
                                                                                                                                                18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                18.448396,
                                                                                                                                                197.829904,
                                                                                                                                                20.698396,
                                                                                                                                                49.724827,
                                                                                                                                                197.829904,
                                                                                                                                                42.21,
                                                                                                                                                49.724827,
                                                                                                                                                42.21,
                                                                                                                                                49.724827,
                                                                                                                                                50.715,
                                                                                                                                                49.724827,
                                                                                                                                                42.21,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.448396, -11.305674, -18.448396, -49.353646, -20.698396, -11.305674, -20.698396, -49.353646, -20.698396, -11.305674, -18.448396, -49.353646, -11.678311,
                                                                                                                                                42.542866, -49.724827,
                                                                                                                                                42.21, -41.224827,
                                                                                                                                                50.715,
                                                                                                                                                15.05623,
                                                                                                                                                29.731955,
                                                                                                                                                4.344192,
                                                                                                                                                58.455337,
                                                                                                                                                53.062858,
                                                                                                                                                45.154471,
                                                                                                                                                20.698396,
                                                                                                                                                47.333639,
                                                                                                                                                22.698396,
                                                                                                                                                47.333639,
                                                                                                                                                61.479571,
                                                                                                                                                17.545769,
                                                                                                                                                35.082627,
                                                                                                                                                46.528732,
                                                                                                                                                61.479571,
                                                                                                                                                17.545769,
                                                                                                                                                22.698396,
                                                                                                                                                47.333639,
                                                                                                                                                34.470004,
                                                                                                                                                47.333639,
                                                                                                                                                35.082627,
                                                                                                                                                46.528732,
                                                                                                                                                22.698396,
                                                                                                                                                47.333639, -11.721845,
                                                                                                                                                50.715, -18.883164,
                                                                                                                                                53.215, -10.715503,
                                                                                                                                                50.612745,
                                                                                                                                                53.092345,
                                                                                                                                                43.737447,
                                                                                                                                                14.621232,
                                                                                                                                                29.512247,
                                                                                                                                                52.270981,
                                                                                                                                                45.786588,
                                                                                                                                                15.343007,
                                                                                                                                                29.750505,
                                                                                                                                                16.961746,
                                                                                                                                                32.654651,
                                                                                                                                                56.902035,
                                                                                                                                                41.9904,
                                                                                                                                                18.448396,
                                                                                                                                                28.485309,
                                                                                                                                                18.448396,
                                                                                                                                                30.933141,
                                                                                                                                                20.698396,
                                                                                                                                                30.933141,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267,
                                                                                                                                                9.540934,
                                                                                                                                                41.349759,
                                                                                                                                                7.647598,
                                                                                                                                                39.622,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267,
                                                                                                                                                17.092894,
                                                                                                                                                34.462569,
                                                                                                                                                16.808959,
                                                                                                                                                37.009971,
                                                                                                                                                59.63744,
                                                                                                                                                43.244357,
                                                                                                                                                15.238038,
                                                                                                                                                29.528598,
                                                                                                                                                56.712572,
                                                                                                                                                42.051812,
                                                                                                                                                57.217213,
                                                                                                                                                40.059283,
                                                                                                                                                61.479571,
                                                                                                                                                26.840972,
                                                                                                                                                95.175013,
                                                                                                                                                26.840972,
                                                                                                                                                61.479571,
                                                                                                                                                24.785532,
                                                                                                                                                61.479571,
                                                                                                                                                20.844114,
                                                                                                                                                61.479571,
                                                                                                                                                23.051742,
                                                                                                                                                95.175013,
                                                                                                                                                20.844114,
                                                                                                                                                95.175013,
                                                                                                                                                24.785532,
                                                                                                                                                61.479571,
                                                                                                                                                24.785532,
                                                                                                                                                95.175013,
                                                                                                                                                26.840972,
                                                                                                                                                95.175013,
                                                                                                                                                31.167157,
                                                                                                                                                95.175013,
                                                                                                                                                29.30207,
                                                                                                                                                61.479571,
                                                                                                                                                31.167157,
                                                                                                                                                94.338958,
                                                                                                                                                12.916544,
                                                                                                                                                94.666879,
                                                                                                                                                14.752578,
                                                                                                                                                136.744405,
                                                                                                                                                3.952576,
                                                                                                                                                92.827039, -1.91129,
                                                                                                                                                93.416402,
                                                                                                                                                0.057844,
                                                                                                                                                133.720316, -16.570694,
                                                                                                                                                138.058149,
                                                                                                                                                19.489714,
                                                                                                                                                95.616003,
                                                                                                                                                29.468593,
                                                                                                                                                138.298638,
                                                                                                                                                22.041584, -9.540934,
                                                                                                                                                41.349759, -8.267429,
                                                                                                                                                48.326267, -7.647598,
                                                                                                                                                39.622, -11.678311,
                                                                                                                                                50.979179, -8.267429,
                                                                                                                                                48.326267, -9.540934,
                                                                                                                                                41.349759, -49.724827,
                                                                                                                                                50.715, -11.678311,
                                                                                                                                                50.979179, -11.678311,
                                                                                                                                                42.542866, -11.678311,
                                                                                                                                                42.542866, -11.678311,
                                                                                                                                                50.979179, -9.540934,
                                                                                                                                                41.349759, -49.724827,
                                                                                                                                                42.21, -49.724827,
                                                                                                                                                50.715, -11.678311,
                                                                                                                                                42.542866, -216.330819,
                                                                                                                                                50.715, -49.724827,
                                                                                                                                                50.715, -49.724827,
                                                                                                                                                42.21, -216.330819,
                                                                                                                                                19.985166, -163.656057,
                                                                                                                                                16.215315, -114.347958,
                                                                                                                                                0, -212.964156,
                                                                                                                                                27.70563, -163.656057,
                                                                                                                                                16.215315, -216.330819,
                                                                                                                                                19.985166, -138.206178,
                                                                                                                                                163.065749, -138.206176,
                                                                                                                                                213.69495, -135.956379,
                                                                                                                                                162.175021, -138.206178,
                                                                                                                                                163.06575, -135.956379,
                                                                                                                                                162.175021, -138.206181,
                                                                                                                                                112.436549, -163.656057,
                                                                                                                                                16.215315, -114.347958,
                                                                                                                                                4.725, -114.347958,
                                                                                                                                                0, -114.347958,
                                                                                                                                                0, -114.347958,
                                                                                                                                                4.725, -49.724827,
                                                                                                                                                0, -49.724827,
                                                                                                                                                0, -11.678311,
                                                                                                                                                15.767866, -11.678311,
                                                                                                                                                11.042866, -11.678311,
                                                                                                                                                15.767866, -9.540934,
                                                                                                                                                16.960973, -11.678311,
                                                                                                                                                11.042866,
                                                                                                                                                103.29193, -66.821236,
                                                                                                                                                70.228799, -33.11343,
                                                                                                                                                104.579273, -64.739258,
                                                                                                                                                38.485982, -62.722943,
                                                                                                                                                40.324596, -61.501011,
                                                                                                                                                60.428556, -104.223577,
                                                                                                                                                95.175013, -0.456918,
                                                                                                                                                95.175013, -2.664546,
                                                                                                                                                61.479571, -0.456918,
                                                                                                                                                61.479571, -2.664546,
                                                                                                                                                61.479571, -0.456918,
                                                                                                                                                95.175013, -2.664546,
                                                                                                                                                41.395749,
                                                                                                                                                57.473296,
                                                                                                                                                19.453175,
                                                                                                                                                15.972663,
                                                                                                                                                39.557135,
                                                                                                                                                58.695229,
                                                                                                                                                52.40909, -8.69516,
                                                                                                                                                20.28215,
                                                                                                                                                14.59442,
                                                                                                                                                45.534269,
                                                                                                                                                54.168523,
                                                                                                                                                18.448396, -46.436964,
                                                                                                                                                18.448396, -6.820272,
                                                                                                                                                20.698396, -46.436964,
                                                                                                                                                49.724827,
                                                                                                                                                4.725,
                                                                                                                                                49.724827,
                                                                                                                                                0,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866,
                                                                                                                                                114.347958,
                                                                                                                                                0,
                                                                                                                                                49.724827,
                                                                                                                                                0,
                                                                                                                                                49.724827,
                                                                                                                                                4.725,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117,
                                                                                                                                                216.330819,
                                                                                                                                                50.715,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859,
                                                                                                                                                216.841278,
                                                                                                                                                38.600117,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938,
                                                                                                                                                217.316951,
                                                                                                                                                38.351859,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -178.790956, -35.834699, -177.331054, -38.907064, -177.641867, -39.382674, -193.416882, -26.338635, -193.075313, -25.953388, -192.182989, -29.574478, -20.698396, -147.50897, -20.698396, -148.023835, -23.170078, -147.50897, -159.182199, -41.257515, -161.065823, -38.696357, -160.856431, -38.225995, -144.479085, -37.94131, -144.665737, -38.514272, -146.473262, -35.465259,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266,
                                                                                                                                                217.72542,
                                                                                                                                                37.956938,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919,
                                                                                                                                                218.03885,
                                                                                                                                                37.442266,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -101.148882, -20.484634, -101.224905, -21.11094, -103.300673, -18.119695, -54.24529,
                                                                                                                                                9.213981, -56.47548,
                                                                                                                                                11.585758, -56.464379,
                                                                                                                                                12.100503, -48.338017,
                                                                                                                                                14.657825, -48.347275,
                                                                                                                                                14.011211, -50.575821,
                                                                                                                                                17.02242,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739,
                                                                                                                                                218.23588,
                                                                                                                                                36.842919,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661,
                                                                                                                                                218.303083,
                                                                                                                                                36.199739,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656,
                                                                                                                                                218.23588,
                                                                                                                                                35.55656,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213,
                                                                                                                                                218.03885,
                                                                                                                                                34.957213,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541,
                                                                                                                                                217.72542,
                                                                                                                                                34.442541,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762,
                                                                                                                                                217.316951,
                                                                                                                                                34.04762,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362,
                                                                                                                                                216.841278,
                                                                                                                                                33.799362,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686,
                                                                                                                                                216.330819,
                                                                                                                                                33.714686,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563,
                                                                                                                                                212.964156,
                                                                                                                                                27.70563,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315,
                                                                                                                                                163.656057,
                                                                                                                                                16.215315,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166,
                                                                                                                                                114.347958,
                                                                                                                                                4.725,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166,
                                                                                                                                                114.347958,
                                                                                                                                                0,
                                                                                                                                                114.347958,
                                                                                                                                                4.725,
                                                                                                                                                114.347958,
                                                                                                                                                4.725,
                                                                                                                                                114.347958,
                                                                                                                                                0,
                                                                                                                                                49.724827,
                                                                                                                                                4.725,
                                                                                                                                                114.347958,
                                                                                                                                                18.802349,
                                                                                                                                                49.724827,
                                                                                                                                                18.802349,
                                                                                                                                                125.529897,
                                                                                                                                                33.701843, -18.448396,
                                                                                                                                                49.941997, -20.698396,
                                                                                                                                                49.941997, -32.112072,
                                                                                                                                                125.979537, -51.815824,
                                                                                                                                                9.904009, -67.981884,
                                                                                                                                                4.805113, -128.437447,
                                                                                                                                                16.315437,
                                                                                                                                                20.698396, -63.388077,
                                                                                                                                                20.698396, -46.436964,
                                                                                                                                                22.698396, -63.388077,
                                                                                                                                                68.252808, -11.926671,
                                                                                                                                                53.27522, -3.74058,
                                                                                                                                                74.313333,
                                                                                                                                                39.0411,
                                                                                                                                                61.865537,
                                                                                                                                                57.35405,
                                                                                                                                                53.028551,
                                                                                                                                                10.505549,
                                                                                                                                                24.723012,
                                                                                                                                                67.055547,
                                                                                                                                                61.479571, -6.974355,
                                                                                                                                                95.175013, -61.788624,
                                                                                                                                                61.479571, -45.362976,
                                                                                                                                                95.175013, -6.974355,
                                                                                                                                                95.175013, -61.788624,
                                                                                                                                                61.479571, -6.974355,
                                                                                                                                                61.479571, -61.788624,
                                                                                                                                                61.479571, -45.362976,
                                                                                                                                                95.175013, -61.788624,
                                                                                                                                                76.385431,
                                                                                                                                                54.863453,
                                                                                                                                                69.094497,
                                                                                                                                                8.041199,
                                                                                                                                                60.396443,
                                                                                                                                                58.625658, -20.69888,
                                                                                                                                                113.973719, -20.698396,
                                                                                                                                                64.51015, -22.698396,
                                                                                                                                                64.51015,
                                                                                                                                                59.499917,
                                                                                                                                                33.87621,
                                                                                                                                                91.800429,
                                                                                                                                                71.337145,
                                                                                                                                                107.763248,
                                                                                                                                                72.060154,
                                                                                                                                                92.028625,
                                                                                                                                                70.83035,
                                                                                                                                                133.003232,
                                                                                                                                                100.509529,
                                                                                                                                                107.993589,
                                                                                                                                                71.504316,
                                                                                                                                                102.808181,
                                                                                                                                                53.940229,
                                                                                                                                                183.121628,
                                                                                                                                                122.250076,
                                                                                                                                                148.021828,
                                                                                                                                                76.644816, -217.014083,
                                                                                                                                                38.076945, -116.151557,
                                                                                                                                                7.364799, -217.309417,
                                                                                                                                                34.050606, -67.448713,
                                                                                                                                                62.442453, -69.398607,
                                                                                                                                                58.907408, -69.748459,
                                                                                                                                                62.510174,
                                                                                                                                                134.1316,
                                                                                                                                                62.375534,
                                                                                                                                                133.952699,
                                                                                                                                                58.760245,
                                                                                                                                                83.938845,
                                                                                                                                                62.34064,
                                                                                                                                                133.851957,
                                                                                                                                                173.830978,
                                                                                                                                                83.659278,
                                                                                                                                                173.737025,
                                                                                                                                                134.017808,
                                                                                                                                                174.368951,
                                                                                                                                                83.825128,
                                                                                                                                                174.274998,
                                                                                                                                                134.017808,
                                                                                                                                                174.368951,
                                                                                                                                                83.659278,
                                                                                                                                                173.737025,
                                                                                                                                                134.156164,
                                                                                                                                                161.485877,
                                                                                                                                                83.96343,
                                                                                                                                                161.427478,
                                                                                                                                                134.298878,
                                                                                                                                                162.017825, -23.168466,
                                                                                                                                                195.22972, -23.364042,
                                                                                                                                                195.744585, -20.698396,
                                                                                                                                                195.22972, -20.698396,
                                                                                                                                                195.744585, -20.698396,
                                                                                                                                                195.22972, -23.364042,
                                                                                                                                                195.744585,
                                                                                                                                                185.942967,
                                                                                                                                                86.923608,
                                                                                                                                                184.933541,
                                                                                                                                                90.90762,
                                                                                                                                                185.298596,
                                                                                                                                                91.27069,
                                                                                                                                                199.69866,
                                                                                                                                                75.101828,
                                                                                                                                                199.248503,
                                                                                                                                                74.809843,
                                                                                                                                                198.971642,
                                                                                                                                                79.146915,
                                                                                                                                                204.743028,
                                                                                                                                                67.684106,
                                                                                                                                                204.162605,
                                                                                                                                                71.79621,
                                                                                                                                                204.622178,
                                                                                                                                                72.028326,
                                                                                                                                                213.650706,
                                                                                                                                                50.79558,
                                                                                                                                                213.14314,
                                                                                                                                                50.695004,
                                                                                                                                                213.411482,
                                                                                                                                                54.941549, -18.473709,
                                                                                                                                                63.937924, -20.722331,
                                                                                                                                                63.937061, -20.723769,
                                                                                                                                                67.549349, -20.726808,
                                                                                                                                                135.155632, -18.478186,
                                                                                                                                                135.156459, -20.727722,
                                                                                                                                                128.268407, -18.477722,
                                                                                                                                                128.268559, -20.727722,
                                                                                                                                                128.268407, -18.478186,
                                                                                                                                                135.156459, -18.448396,
                                                                                                                                                213.694942, -18.448396,
                                                                                                                                                163.065742, -20.698396,
                                                                                                                                                213.694942,
                                                                                                                                                143.441743,
                                                                                                                                                159.463272,
                                                                                                                                                108.517609,
                                                                                                                                                122.738848,
                                                                                                                                                98.701702,
                                                                                                                                                132.783802,
                                                                                                                                                95.608431,
                                                                                                                                                134.727085,
                                                                                                                                                105.641064,
                                                                                                                                                124.898586,
                                                                                                                                                68.628155,
                                                                                                                                                107.545303,
                                                                                                                                                69.974392,
                                                                                                                                                88.965252,
                                                                                                                                                68.628155,
                                                                                                                                                107.545303,
                                                                                                                                                105.641064,
                                                                                                                                                124.898586,
                                                                                                                                                201.515195,
                                                                                                                                                37.160515,
                                                                                                                                                150.110016,
                                                                                                                                                28.735969,
                                                                                                                                                204.781009,
                                                                                                                                                43.224204,
                                                                                                                                                152.53815,
                                                                                                                                                19.38274,
                                                                                                                                                207.243679,
                                                                                                                                                37.247255,
                                                                                                                                                207.244104,
                                                                                                                                                33.7384,
                                                                                                                                                216.329889,
                                                                                                                                                33.721962,
                                                                                                                                                216.329748,
                                                                                                                                                37.230818,
                                                                                                                                                216.840208,
                                                                                                                                                37.298021, -20.698396,
                                                                                                                                                219.853478, -20.698396,
                                                                                                                                                219.338614, -22.940791,
                                                                                                                                                219.853478, -22.940791,
                                                                                                                                                214.605442, -23.168466,
                                                                                                                                                215.120306, -20.698396,
                                                                                                                                                214.605442, -20.698396,
                                                                                                                                                215.120306, -20.698396,
                                                                                                                                                214.605442, -23.168466,
                                                                                                                                                215.120306,
                                                                                                                                                172.698616,
                                                                                                                                                95.638701,
                                                                                                                                                172.355801,
                                                                                                                                                95.185614,
                                                                                                                                                171.475241,
                                                                                                                                                99.491069,
                                                                                                                                                132.993418,
                                                                                                                                                103.265711,
                                                                                                                                                132.782615,
                                                                                                                                                102.701188,
                                                                                                                                                131.117535,
                                                                                                                                                106.384242,
                                                                                                                                                149.56819,
                                                                                                                                                104.094131,
                                                                                                                                                147.828607,
                                                                                                                                                107.290695,
                                                                                                                                                148.06137,
                                                                                                                                                107.74994, -20.698396,
                                                                                                                                                162.531872, -23.364042,
                                                                                                                                                162.531872, -20.698396,
                                                                                                                                                163.046736, -23.514193,
                                                                                                                                                163.046736, -20.698396,
                                                                                                                                                163.046736, -23.364042,
                                                                                                                                                162.531872, -20.698396,
                                                                                                                                                118.740202, -23.514193,
                                                                                                                                                118.740202, -20.698396,
                                                                                                                                                119.255066,
                                                                                                                                                92.915889,
                                                                                                                                                100.470522,
                                                                                                                                                90.867733,
                                                                                                                                                103.288475,
                                                                                                                                                90.966055,
                                                                                                                                                103.793864,
                                                                                                                                                76.985419,
                                                                                                                                                92.449822,
                                                                                                                                                76.900869,
                                                                                                                                                91.82461,
                                                                                                                                                74.86856,
                                                                                                                                                95.216537,
                                                                                                                                                13.123656,
                                                                                                                                                58.500363,
                                                                                                                                                13.113996,
                                                                                                                                                57.853755,
                                                                                                                                                10.887363,
                                                                                                                                                60.998364,
                                                                                                                                                19.513239,
                                                                                                                                                63.960879,
                                                                                                                                                17.285416,
                                                                                                                                                66.466436,
                                                                                                                                                17.297017,
                                                                                                                                                66.98117, -59.041734,
                                                                                                                                                182.375036, -97.61285,
                                                                                                                                                182.375036, -59.269409,
                                                                                                                                                182.8899, -97.61285,
                                                                                                                                                62.540737, -59.041734,
                                                                                                                                                62.540737, -97.857107,
                                                                                                                                                58.920418, -196.445786,
                                                                                                                                                42.576125, -246.638541,
                                                                                                                                                42.619867, -196.624687,
                                                                                                                                                46.200262, -246.817442,
                                                                                                                                                46.235156, -196.624687,
                                                                                                                                                46.200262, -246.638541,
                                                                                                                                                42.619867,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -114.636904, -29.538735, -116.734682, -27.125754, -116.645976, -26.618589,
                                                                                                                                                216.330819,
                                                                                                                                                50.715,
                                                                                                                                                197.829904,
                                                                                                                                                42.21,
                                                                                                                                                49.724827,
                                                                                                                                                50.715,
                                                                                                                                                49.724827,
                                                                                                                                                50.715,
                                                                                                                                                11.678311,
                                                                                                                                                42.542866,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732,
                                                                                                                                                7.647598,
                                                                                                                                                18.688732,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391,
                                                                                                                                                6.081312,
                                                                                                                                                20.875391,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078,
                                                                                                                                                4.910749,
                                                                                                                                                23.425078,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004,
                                                                                                                                                4.187232,
                                                                                                                                                26.226004,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973,
                                                                                                                                                0,
                                                                                                                                                31.011023,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316,
                                                                                                                                                3.942483,
                                                                                                                                                29.155366,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654,
                                                                                                                                                4.187232,
                                                                                                                                                32.084728,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522,
                                                                                                                                                18.16424,
                                                                                                                                                32.388233,
                                                                                                                                                18.120872,
                                                                                                                                                35.280772,
                                                                                                                                                61.118043,
                                                                                                                                                42.718616,
                                                                                                                                                60.651193,
                                                                                                                                                42.091597,
                                                                                                                                                17.799617,
                                                                                                                                                33.856269,
                                                                                                                                                60.571956,
                                                                                                                                                43.574653,
                                                                                                                                                17.92953,
                                                                                                                                                34.45306,
                                                                                                                                                17.823819,
                                                                                                                                                37.25662,
                                                                                                                                                60.784873,
                                                                                                                                                43.798624,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341,
                                                                                                                                                4.910749,
                                                                                                                                                34.885654,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522,
                                                                                                                                                7.647598,
                                                                                                                                                39.622,
                                                                                                                                                6.081312,
                                                                                                                                                37.435341,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267,
                                                                                                                                                17.603051,
                                                                                                                                                35.266059,
                                                                                                                                                17.418445,
                                                                                                                                                37.949462,
                                                                                                                                                60.334295,
                                                                                                                                                44.016125,
                                                                                                                                                58.843876,
                                                                                                                                                40.27544,
                                                                                                                                                16.438429,
                                                                                                                                                31.311472,
                                                                                                                                                58.515955,
                                                                                                                                                42.111474,
                                                                                                                                                61.479571,
                                                                                                                                                29.30207,
                                                                                                                                                61.479571,
                                                                                                                                                31.167157,
                                                                                                                                                95.175013,
                                                                                                                                                29.30207,
                                                                                                                                                61.479571,
                                                                                                                                                35.929524,
                                                                                                                                                95.175013,
                                                                                                                                                35.929524,
                                                                                                                                                61.479571,
                                                                                                                                                34.266931,
                                                                                                                                                95.175013,
                                                                                                                                                34.266931,
                                                                                                                                                61.479571,
                                                                                                                                                34.266931,
                                                                                                                                                95.175013,
                                                                                                                                                35.929524,
                                                                                                                                                95.175013,
                                                                                                                                                40.280932,
                                                                                                                                                95.175013,
                                                                                                                                                38.795761,
                                                                                                                                                61.479571,
                                                                                                                                                40.280932,
                                                                                                                                                137.912677,
                                                                                                                                                25.536795,
                                                                                                                                                95.061101,
                                                                                                                                                33.772123,
                                                                                                                                                95.140338,
                                                                                                                                                35.255179,
                                                                                                                                                138.252039,
                                                                                                                                                32.936263,
                                                                                                                                                138.208671,
                                                                                                                                                30.043724,
                                                                                                                                                95.254868,
                                                                                                                                                40.374108, -4.910749,
                                                                                                                                                34.885654, -5.374779,
                                                                                                                                                45.314522, -4.187232,
                                                                                                                                                32.084728, -6.081312,
                                                                                                                                                37.435341, -5.374779,
                                                                                                                                                45.314522, -4.910749,
                                                                                                                                                34.885654, -8.267429,
                                                                                                                                                48.326267, -5.374779,
                                                                                                                                                45.314522, -6.081312,
                                                                                                                                                37.435341, -11.678311,
                                                                                                                                                11.042866, -9.540934,
                                                                                                                                                16.960973, -8.267429,
                                                                                                                                                13.695779, -9.540934,
                                                                                                                                                16.960973, -7.647598,
                                                                                                                                                18.688732, -8.267429,
                                                                                                                                                13.695779,
                                                                                                                                                122.772208, -33.497164,
                                                                                                                                                84.114342, -6.684057,
                                                                                                                                                123.531693, -31.049092,
                                                                                                                                                60.674905, -45.525952,
                                                                                                                                                62.011479, -43.964413,
                                                                                                                                                91.152859, -80.898857,
                                                                                                                                                95.175013,
                                                                                                                                                6.923452,
                                                                                                                                                95.175013,
                                                                                                                                                4.868011,
                                                                                                                                                61.479571,
                                                                                                                                                6.923452,
                                                                                                                                                61.479571,
                                                                                                                                                4.868011,
                                                                                                                                                61.479571,
                                                                                                                                                6.923452,
                                                                                                                                                95.175013,
                                                                                                                                                4.868011,
                                                                                                                                                51.224495,
                                                                                                                                                48.162188,
                                                                                                                                                18.658613,
                                                                                                                                                15.550001,
                                                                                                                                                49.923589,
                                                                                                                                                49.753564,
                                                                                                                                                20.7486,
                                                                                                                                                11.366146,
                                                                                                                                                19.955184,
                                                                                                                                                13.803432,
                                                                                                                                                59.819177,
                                                                                                                                                36.932493,
                                                                                                                                                21.760644,
                                                                                                                                                10.502136,
                                                                                                                                                20.473301,
                                                                                                                                                12.584114,
                                                                                                                                                54.823774,
                                                                                                                                                44.209942,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866,
                                                                                                                                                9.540934,
                                                                                                                                                16.960973,
                                                                                                                                                49.724827,
                                                                                                                                                0,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866,
                                                                                                                                                11.678311,
                                                                                                                                                15.767866,
                                                                                                                                                19.840643,
                                                                                                                                                14.101545,
                                                                                                                                                19.409617,
                                                                                                                                                16.75653,
                                                                                                                                                61.210381,
                                                                                                                                                34.980415,
                                                                                                                                                57.092211,
                                                                                                                                                40.739362,
                                                                                                                                                19.021622,
                                                                                                                                                15.638683,
                                                                                                                                                56.310507,
                                                                                                                                                42.432728,
                                                                                                                                                59.781402,
                                                                                                                                                37.632009,
                                                                                                                                                19.412838,
                                                                                                                                                15.751404,
                                                                                                                                                59.376035,
                                                                                                                                                39.244428,
                                                                                                                                                19.166303,
                                                                                                                                                17.706207,
                                                                                                                                                18.985503,
                                                                                                                                                20.505927,
                                                                                                                                                61.500293,
                                                                                                                                                36.595691,
                                                                                                                                                18.807729,
                                                                                                                                                21.869823,
                                                                                                                                                18.744333,
                                                                                                                                                24.761993,
                                                                                                                                                61.673398,
                                                                                                                                                37.000001,
                                                                                                                                                61.430592,
                                                                                                                                                36.011057,
                                                                                                                                                18.889677,
                                                                                                                                                22.485378,
                                                                                                                                                61.309019,
                                                                                                                                                37.491244,
                                                                                                                                                61.61685,
                                                                                                                                                38.609902,
                                                                                                                                                18.650926,
                                                                                                                                                25.249291,
                                                                                                                                                61.603377,
                                                                                                                                                39.988231,
                                                                                                                                                18.537828,
                                                                                                                                                25.821041,
                                                                                                                                                18.532328,
                                                                                                                                                28.760604,
                                                                                                                                                61.552638,
                                                                                                                                                40.376985,
                                                                                                                                                61.216143,
                                                                                                                                                41.312732,
                                                                                                                                                18.235568,
                                                                                                                                                29.550185,
                                                                                                                                                61.204277,
                                                                                                                                                42.691077,
                                                                                                                                                18.368359,
                                                                                                                                                29.412123,
                                                                                                                                                18.363607,
                                                                                                                                                32.351687,
                                                                                                                                                61.386668,
                                                                                                                                                42.389725,
                                                                                                                                                61.479571,
                                                                                                                                                40.784234,
                                                                                                                                                61.479571,
                                                                                                                                                42.162629,
                                                                                                                                                95.175013,
                                                                                                                                                40.784234,
                                                                                                                                                95.175013,
                                                                                                                                                42.162629,
                                                                                                                                                95.175013,
                                                                                                                                                40.784234,
                                                                                                                                                61.479571,
                                                                                                                                                42.162629,
                                                                                                                                                138.260252,
                                                                                                                                                31.290469,
                                                                                                                                                95.256621,
                                                                                                                                                40.076548,
                                                                                                                                                95.266877,
                                                                                                                                                41.454905,
                                                                                                                                                138.265381,
                                                                                                                                                32.063327,
                                                                                                                                                138.259882,
                                                                                                                                                29.123764,
                                                                                                                                                95.239572,
                                                                                                                                                40.740145, -3.942483,
                                                                                                                                                29.155366, -4.187232,
                                                                                                                                                32.084728, -3.060308,
                                                                                                                                                20.015685, -4.187232,
                                                                                                                                                32.084728, -5.374779,
                                                                                                                                                45.314522, -3.060308,
                                                                                                                                                20.015685, -5.374779,
                                                                                                                                                45.314522, -3.060308,
                                                                                                                                                42.00636, -3.060308,
                                                                                                                                                20.015685, -3.060308,
                                                                                                                                                20.015685, -3.060308,
                                                                                                                                                42.00636, -1.37198,
                                                                                                                                                23.551709, -3.060308,
                                                                                                                                                42.00636, -1.37198,
                                                                                                                                                38.470336, -1.37198,
                                                                                                                                                23.551709, -1.37198,
                                                                                                                                                23.551709, -1.37198,
                                                                                                                                                38.470336, -0.344781,
                                                                                                                                                27.242316, -1.37198,
                                                                                                                                                38.470336, -0.344781,
                                                                                                                                                34.77973, -0.344781,
                                                                                                                                                27.242316,
                                                                                                                                                0,
                                                                                                                                                31.011023, -0.344781,
                                                                                                                                                27.242316, -0.344781,
                                                                                                                                                34.77973, -3.942483,
                                                                                                                                                29.155366, -3.060308,
                                                                                                                                                20.015685, -4.187232,
                                                                                                                                                26.226004, -5.374779,
                                                                                                                                                16.707523, -4.187232,
                                                                                                                                                26.226004, -3.060308,
                                                                                                                                                20.015685, -4.910749,
                                                                                                                                                23.425078, -4.187232,
                                                                                                                                                26.226004, -5.374779,
                                                                                                                                                16.707523,
                                                                                                                                                137.307729,
                                                                                                                                                21.34136,
                                                                                                                                                137.244333,
                                                                                                                                                18.44919,
                                                                                                                                                94.378664,
                                                                                                                                                33.579368,
                                                                                                                                                129.374569, -16.378533,
                                                                                                                                                88.229675,
                                                                                                                                                2.105223,
                                                                                                                                                88.604095,
                                                                                                                                                3.725107,
                                                                                                                                                135.402791,
                                                                                                                                                9.745011,
                                                                                                                                                135.205559,
                                                                                                                                                6.9464,
                                                                                                                                                92.789611,
                                                                                                                                                24.532452, -6.081312,
                                                                                                                                                20.875391, -4.910749,
                                                                                                                                                23.425078, -5.374779,
                                                                                                                                                16.707523, -8.267429,
                                                                                                                                                13.695779, -6.081312,
                                                                                                                                                20.875391, -5.374779,
                                                                                                                                                16.707523, -7.647598,
                                                                                                                                                18.688732, -6.081312,
                                                                                                                                                20.875391, -8.267429,
                                                                                                                                                13.695779,
                                                                                                                                                131.196522, -7.693754,
                                                                                                                                                130.765496, -10.348739,
                                                                                                                                                89.395758,
                                                                                                                                                10.530131,
                                                                                                                                                78.657622, -21.926461,
                                                                                                                                                79.439326, -20.233095,
                                                                                                                                                116.728211, -47.02714,
                                                                                                                                                95.175013,
                                                                                                                                                14.924771,
                                                                                                                                                95.175013,
                                                                                                                                                13.059684,
                                                                                                                                                61.479571,
                                                                                                                                                14.924771,
                                                                                                                                                61.479571,
                                                                                                                                                13.059684,
                                                                                                                                                61.479571,
                                                                                                                                                14.924771,
                                                                                                                                                95.175013,
                                                                                                                                                13.059684,
                                                                                                                                                95.175013,
                                                                                                                                                21.920691,
                                                                                                                                                61.479571,
                                                                                                                                                21.920691,
                                                                                                                                                95.175013,
                                                                                                                                                23.583284,
                                                                                                                                                61.479571,
                                                                                                                                                23.583284,
                                                                                                                                                95.175013,
                                                                                                                                                23.583284,
                                                                                                                                                61.479571,
                                                                                                                                                21.920691,
                                                                                                                                                61.479571,
                                                                                                                                                30.861597,
                                                                                                                                                61.479571,
                                                                                                                                                32.346768,
                                                                                                                                                95.175013,
                                                                                                                                                30.861597,
                                                                                                                                                95.175013,
                                                                                                                                                32.346768,
                                                                                                                                                95.175013,
                                                                                                                                                30.861597,
                                                                                                                                                61.479571,
                                                                                                                                                32.346768,
                                                                                                                                                135.537534,
                                                                                                                                                9.801657,
                                                                                                                                                92.996618,
                                                                                                                                                23.327336,
                                                                                                                                                93.118192,
                                                                                                                                                24.807523,
                                                                                                                                                138.060549,
                                                                                                                                                28.432572,
                                                                                                                                                138.054302,
                                                                                                                                                25.49301,
                                                                                                                                                95.037144,
                                                                                                                                                38.687731,
                                                                                                                                                137.852537,
                                                                                                                                                26.806365,
                                                                                                                                                94.860097,
                                                                                                                                                37.190568,
                                                                                                                                                94.871962,
                                                                                                                                                38.568912,
                                                                                                                                                95.175013,
                                                                                                                                                39.384171,
                                                                                                                                                95.175013,
                                                                                                                                                38.005776,
                                                                                                                                                61.479571,
                                                                                                                                                39.384171,
                                                                                                                                                61.479571,
                                                                                                                                                38.005776,
                                                                                                                                                61.479571,
                                                                                                                                                39.384171,
                                                                                                                                                95.175013,
                                                                                                                                                38.005776,
                                                                                                                                                61.479571,
                                                                                                                                                38.795761,
                                                                                                                                                61.479571,
                                                                                                                                                40.280932,
                                                                                                                                                95.175013,
                                                                                                                                                38.795761, -7.647598,
                                                                                                                                                39.622, -8.267429,
                                                                                                                                                48.326267, -6.081312,
                                                                                                                                                37.435341,
                                                                                                                                                138.144245,
                                                                                                                                                27.247429,
                                                                                                                                                137.959639,
                                                                                                                                                24.564026,
                                                                                                                                                95.228395,
                                                                                                                                                33.314092,
                                                                                                                                                137.36397,
                                                                                                                                                15.2881,
                                                                                                                                                94.712209,
                                                                                                                                                23.611397,
                                                                                                                                                94.901966,
                                                                                                                                                25.263126,
                                                                                                                                                138.190649,
                                                                                                                                                31.373894,
                                                                                                                                                138.084937,
                                                                                                                                                28.570335,
                                                                                                                                                95.229595,
                                                                                                                                                37.915899,
                                                                                                                                                59.870313,
                                                                                                                                                41.370469,
                                                                                                                                                17.218552,
                                                                                                                                                33.047172,
                                                                                                                                                59.680556,
                                                                                                                                                43.022198, -216.330819,
                                                                                                                                                33.714686, -212.964156,
                                                                                                                                                27.70563, -216.330819,
                                                                                                                                                19.985166, -216.841278,
                                                                                                                                                33.799362, -216.330819,
                                                                                                                                                33.714686, -216.330819,
                                                                                                                                                19.985166, -138.206188, -49.353646, -138.206188, -11.305674, -135.956188, -49.353646,
                                                                                                                                                134.556001, -76.855879,
                                                                                                                                                134.666222, -77.380632,
                                                                                                                                                84.363253, -76.900084,
                                                                                                                                                84.473474, -77.424837,
                                                                                                                                                84.363253, -76.900084,
                                                                                                                                                134.666222, -77.380632,
                                                                                                                                                134.622166, -32.245299,
                                                                                                                                                134.691476, -32.764072,
                                                                                                                                                84.429413, -32.282826,
                                                                                                                                                84.498722, -32.801599,
                                                                                                                                                84.429413, -32.282826,
                                                                                                                                                134.691476, -32.764072,
                                                                                                                                                134.656168,
                                                                                                                                                15.613472,
                                                                                                                                                134.679912,
                                                                                                                                                15.098166,
                                                                                                                                                84.463413,
                                                                                                                                                15.578736,
                                                                                                                                                84.487157,
                                                                                                                                                15.06343,
                                                                                                                                                84.463413,
                                                                                                                                                15.578736,
                                                                                                                                                134.679912,
                                                                                                                                                15.098166,
                                                                                                                                                134.646988,
                                                                                                                                                62.666604,
                                                                                                                                                134.623604,
                                                                                                                                                62.151251,
                                                                                                                                                84.454233,
                                                                                                                                                62.631864,
                                                                                                                                                84.430849,
                                                                                                                                                62.116512,
                                                                                                                                                84.454233,
                                                                                                                                                62.631864,
                                                                                                                                                134.623604,
                                                                                                                                                62.151251, -174.123244,
                                                                                                                                                59.357481, -174.124624,
                                                                                                                                                59.356619, -174.218999,
                                                                                                                                                62.967674,
                                                                                                                                                52.636198,
                                                                                                                                                49.279355,
                                                                                                                                                44.468537,
                                                                                                                                                49.279355,
                                                                                                                                                52.636198,
                                                                                                                                                53.215, -49.108403,
                                                                                                                                                32.328657, -49.108403,
                                                                                                                                                92.77135, -41.562468,
                                                                                                                                                35.454285, -24.830946,
                                                                                                                                                53.215, -24.830946,
                                                                                                                                                49.783762, -32.998607,
                                                                                                                                                53.215,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "indices": [
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                2,
                                                                                                                                                3,
                                                                                                                                                4,
                                                                                                                                                5,
                                                                                                                                                6,
                                                                                                                                                7,
                                                                                                                                                8,
                                                                                                                                                9,
                                                                                                                                                10,
                                                                                                                                                11,
                                                                                                                                                12,
                                                                                                                                                13,
                                                                                                                                                14,
                                                                                                                                                15,
                                                                                                                                                16,
                                                                                                                                                17,
                                                                                                                                                18,
                                                                                                                                                19,
                                                                                                                                                20,
                                                                                                                                                21,
                                                                                                                                                22,
                                                                                                                                                23,
                                                                                                                                                24,
                                                                                                                                                25,
                                                                                                                                                26,
                                                                                                                                                27,
                                                                                                                                                28,
                                                                                                                                                29,
                                                                                                                                                30,
                                                                                                                                                31,
                                                                                                                                                32,
                                                                                                                                                33,
                                                                                                                                                34,
                                                                                                                                                35,
                                                                                                                                                36,
                                                                                                                                                37,
                                                                                                                                                38,
                                                                                                                                                39,
                                                                                                                                                40,
                                                                                                                                                41,
                                                                                                                                                42,
                                                                                                                                                43,
                                                                                                                                                44,
                                                                                                                                                45,
                                                                                                                                                46,
                                                                                                                                                47,
                                                                                                                                                48,
                                                                                                                                                49,
                                                                                                                                                50,
                                                                                                                                                51,
                                                                                                                                                52,
                                                                                                                                                53,
                                                                                                                                                54,
                                                                                                                                                55,
                                                                                                                                                56,
                                                                                                                                                57,
                                                                                                                                                58,
                                                                                                                                                59,
                                                                                                                                                60,
                                                                                                                                                61,
                                                                                                                                                62,
                                                                                                                                                63,
                                                                                                                                                64,
                                                                                                                                                65,
                                                                                                                                                66,
                                                                                                                                                67,
                                                                                                                                                68,
                                                                                                                                                69,
                                                                                                                                                70,
                                                                                                                                                71,
                                                                                                                                                72,
                                                                                                                                                73,
                                                                                                                                                74,
                                                                                                                                                75,
                                                                                                                                                76,
                                                                                                                                                77,
                                                                                                                                                78,
                                                                                                                                                79,
                                                                                                                                                80,
                                                                                                                                                81,
                                                                                                                                                82,
                                                                                                                                                83,
                                                                                                                                                84,
                                                                                                                                                85,
                                                                                                                                                86,
                                                                                                                                                87,
                                                                                                                                                88,
                                                                                                                                                89,
                                                                                                                                                90,
                                                                                                                                                91,
                                                                                                                                                92,
                                                                                                                                                93,
                                                                                                                                                94,
                                                                                                                                                95,
                                                                                                                                                96,
                                                                                                                                                97,
                                                                                                                                                98,
                                                                                                                                                99,
                                                                                                                                                100,
                                                                                                                                                101,
                                                                                                                                                102,
                                                                                                                                                103,
                                                                                                                                                104,
                                                                                                                                                105,
                                                                                                                                                106,
                                                                                                                                                107,
                                                                                                                                                108,
                                                                                                                                                109,
                                                                                                                                                110,
                                                                                                                                                111,
                                                                                                                                                112,
                                                                                                                                                113,
                                                                                                                                                114,
                                                                                                                                                115,
                                                                                                                                                116,
                                                                                                                                                117,
                                                                                                                                                118,
                                                                                                                                                119,
                                                                                                                                                120,
                                                                                                                                                121,
                                                                                                                                                122,
                                                                                                                                                123,
                                                                                                                                                124,
                                                                                                                                                125,
                                                                                                                                                126,
                                                                                                                                                127,
                                                                                                                                                128,
                                                                                                                                                129,
                                                                                                                                                130,
                                                                                                                                                131,
                                                                                                                                                132,
                                                                                                                                                133,
                                                                                                                                                134,
                                                                                                                                                135,
                                                                                                                                                136,
                                                                                                                                                137,
                                                                                                                                                138,
                                                                                                                                                139,
                                                                                                                                                140,
                                                                                                                                                141,
                                                                                                                                                142,
                                                                                                                                                143,
                                                                                                                                                144,
                                                                                                                                                145,
                                                                                                                                                146,
                                                                                                                                                147,
                                                                                                                                                148,
                                                                                                                                                149,
                                                                                                                                                150,
                                                                                                                                                151,
                                                                                                                                                152,
                                                                                                                                                153,
                                                                                                                                                154,
                                                                                                                                                155,
                                                                                                                                                156,
                                                                                                                                                157,
                                                                                                                                                158,
                                                                                                                                                159,
                                                                                                                                                160,
                                                                                                                                                161,
                                                                                                                                                162,
                                                                                                                                                163,
                                                                                                                                                164,
                                                                                                                                                165,
                                                                                                                                                166,
                                                                                                                                                167,
                                                                                                                                                168,
                                                                                                                                                169,
                                                                                                                                                170,
                                                                                                                                                171,
                                                                                                                                                172,
                                                                                                                                                173,
                                                                                                                                                174,
                                                                                                                                                175,
                                                                                                                                                176,
                                                                                                                                                177,
                                                                                                                                                178,
                                                                                                                                                179,
                                                                                                                                                180,
                                                                                                                                                181,
                                                                                                                                                182,
                                                                                                                                                183,
                                                                                                                                                184,
                                                                                                                                                185,
                                                                                                                                                186,
                                                                                                                                                187,
                                                                                                                                                188,
                                                                                                                                                189,
                                                                                                                                                190,
                                                                                                                                                191,
                                                                                                                                                192,
                                                                                                                                                193,
                                                                                                                                                194,
                                                                                                                                                195,
                                                                                                                                                196,
                                                                                                                                                197,
                                                                                                                                                198,
                                                                                                                                                199,
                                                                                                                                                200,
                                                                                                                                                201,
                                                                                                                                                202,
                                                                                                                                                203,
                                                                                                                                                204,
                                                                                                                                                205,
                                                                                                                                                206,
                                                                                                                                                207,
                                                                                                                                                208,
                                                                                                                                                209,
                                                                                                                                                210,
                                                                                                                                                211,
                                                                                                                                                212,
                                                                                                                                                213,
                                                                                                                                                214,
                                                                                                                                                215,
                                                                                                                                                216,
                                                                                                                                                217,
                                                                                                                                                218,
                                                                                                                                                219,
                                                                                                                                                220,
                                                                                                                                                221,
                                                                                                                                                222,
                                                                                                                                                223,
                                                                                                                                                224,
                                                                                                                                                225,
                                                                                                                                                226,
                                                                                                                                                227,
                                                                                                                                                228,
                                                                                                                                                229,
                                                                                                                                                230,
                                                                                                                                                231,
                                                                                                                                                232,
                                                                                                                                                233,
                                                                                                                                                234,
                                                                                                                                                235,
                                                                                                                                                236,
                                                                                                                                                237,
                                                                                                                                                238,
                                                                                                                                                239,
                                                                                                                                                240,
                                                                                                                                                241,
                                                                                                                                                242,
                                                                                                                                                243,
                                                                                                                                                244,
                                                                                                                                                245,
                                                                                                                                                246,
                                                                                                                                                247,
                                                                                                                                                248,
                                                                                                                                                249,
                                                                                                                                                250,
                                                                                                                                                251,
                                                                                                                                                252,
                                                                                                                                                253,
                                                                                                                                                254,
                                                                                                                                                255,
                                                                                                                                                256,
                                                                                                                                                257,
                                                                                                                                                258,
                                                                                                                                                259,
                                                                                                                                                260,
                                                                                                                                                261,
                                                                                                                                                262,
                                                                                                                                                263,
                                                                                                                                                264,
                                                                                                                                                265,
                                                                                                                                                266,
                                                                                                                                                267,
                                                                                                                                                268,
                                                                                                                                                269,
                                                                                                                                                270,
                                                                                                                                                271,
                                                                                                                                                272,
                                                                                                                                                273,
                                                                                                                                                274,
                                                                                                                                                275,
                                                                                                                                                276,
                                                                                                                                                277,
                                                                                                                                                278,
                                                                                                                                                279,
                                                                                                                                                280,
                                                                                                                                                281,
                                                                                                                                                282,
                                                                                                                                                283,
                                                                                                                                                284,
                                                                                                                                                285,
                                                                                                                                                286,
                                                                                                                                                287,
                                                                                                                                                288,
                                                                                                                                                289,
                                                                                                                                                290,
                                                                                                                                                291,
                                                                                                                                                292,
                                                                                                                                                293,
                                                                                                                                                294,
                                                                                                                                                295,
                                                                                                                                                296,
                                                                                                                                                297,
                                                                                                                                                298,
                                                                                                                                                299,
                                                                                                                                                300,
                                                                                                                                                301,
                                                                                                                                                302,
                                                                                                                                                303,
                                                                                                                                                304,
                                                                                                                                                305,
                                                                                                                                                306,
                                                                                                                                                307,
                                                                                                                                                308,
                                                                                                                                                309,
                                                                                                                                                310,
                                                                                                                                                311,
                                                                                                                                                312,
                                                                                                                                                313,
                                                                                                                                                314,
                                                                                                                                                315,
                                                                                                                                                316,
                                                                                                                                                317,
                                                                                                                                                318,
                                                                                                                                                319,
                                                                                                                                                320,
                                                                                                                                                321,
                                                                                                                                                322,
                                                                                                                                                323,
                                                                                                                                                324,
                                                                                                                                                325,
                                                                                                                                                326,
                                                                                                                                                327,
                                                                                                                                                328,
                                                                                                                                                329,
                                                                                                                                                330,
                                                                                                                                                331,
                                                                                                                                                332,
                                                                                                                                                333,
                                                                                                                                                334,
                                                                                                                                                335,
                                                                                                                                                336,
                                                                                                                                                337,
                                                                                                                                                338,
                                                                                                                                                339,
                                                                                                                                                340,
                                                                                                                                                341,
                                                                                                                                                342,
                                                                                                                                                343,
                                                                                                                                                344,
                                                                                                                                                345,
                                                                                                                                                346,
                                                                                                                                                347,
                                                                                                                                                348,
                                                                                                                                                349,
                                                                                                                                                350,
                                                                                                                                                351,
                                                                                                                                                352,
                                                                                                                                                353,
                                                                                                                                                354,
                                                                                                                                                355,
                                                                                                                                                356,
                                                                                                                                                357,
                                                                                                                                                358,
                                                                                                                                                359,
                                                                                                                                                360,
                                                                                                                                                361,
                                                                                                                                                362,
                                                                                                                                                363,
                                                                                                                                                364,
                                                                                                                                                365,
                                                                                                                                                366,
                                                                                                                                                367,
                                                                                                                                                368,
                                                                                                                                                369,
                                                                                                                                                370,
                                                                                                                                                371,
                                                                                                                                                372,
                                                                                                                                                373,
                                                                                                                                                374,
                                                                                                                                                375,
                                                                                                                                                376,
                                                                                                                                                377,
                                                                                                                                                378,
                                                                                                                                                379,
                                                                                                                                                380,
                                                                                                                                                381,
                                                                                                                                                382,
                                                                                                                                                383,
                                                                                                                                                384,
                                                                                                                                                385,
                                                                                                                                                386,
                                                                                                                                                387,
                                                                                                                                                388,
                                                                                                                                                389,
                                                                                                                                                390,
                                                                                                                                                391,
                                                                                                                                                392,
                                                                                                                                                393,
                                                                                                                                                394,
                                                                                                                                                395,
                                                                                                                                                396,
                                                                                                                                                397,
                                                                                                                                                398,
                                                                                                                                                399,
                                                                                                                                                400,
                                                                                                                                                401,
                                                                                                                                                402,
                                                                                                                                                403,
                                                                                                                                                404,
                                                                                                                                                405,
                                                                                                                                                406,
                                                                                                                                                407,
                                                                                                                                                408,
                                                                                                                                                409,
                                                                                                                                                410,
                                                                                                                                                411,
                                                                                                                                                412,
                                                                                                                                                413,
                                                                                                                                                414,
                                                                                                                                                415,
                                                                                                                                                416,
                                                                                                                                                417,
                                                                                                                                                418,
                                                                                                                                                419,
                                                                                                                                                420,
                                                                                                                                                421,
                                                                                                                                                422,
                                                                                                                                                423,
                                                                                                                                                424,
                                                                                                                                                425,
                                                                                                                                                426,
                                                                                                                                                427,
                                                                                                                                                428,
                                                                                                                                                429,
                                                                                                                                                430,
                                                                                                                                                431,
                                                                                                                                                432,
                                                                                                                                                433,
                                                                                                                                                434,
                                                                                                                                                435,
                                                                                                                                                436,
                                                                                                                                                437,
                                                                                                                                                438,
                                                                                                                                                439,
                                                                                                                                                440,
                                                                                                                                                441,
                                                                                                                                                442,
                                                                                                                                                443,
                                                                                                                                                444,
                                                                                                                                                445,
                                                                                                                                                446,
                                                                                                                                                447,
                                                                                                                                                448,
                                                                                                                                                449,
                                                                                                                                                450,
                                                                                                                                                451,
                                                                                                                                                452,
                                                                                                                                                453,
                                                                                                                                                454,
                                                                                                                                                455,
                                                                                                                                                456,
                                                                                                                                                457,
                                                                                                                                                458,
                                                                                                                                                459,
                                                                                                                                                460,
                                                                                                                                                461,
                                                                                                                                                462,
                                                                                                                                                463,
                                                                                                                                                464,
                                                                                                                                                465,
                                                                                                                                                466,
                                                                                                                                                467,
                                                                                                                                                468,
                                                                                                                                                469,
                                                                                                                                                470,
                                                                                                                                                471,
                                                                                                                                                472,
                                                                                                                                                473,
                                                                                                                                                474,
                                                                                                                                                475,
                                                                                                                                                476,
                                                                                                                                                477,
                                                                                                                                                478,
                                                                                                                                                479,
                                                                                                                                                480,
                                                                                                                                                481,
                                                                                                                                                482,
                                                                                                                                                483,
                                                                                                                                                484,
                                                                                                                                                485,
                                                                                                                                                486,
                                                                                                                                                487,
                                                                                                                                                488,
                                                                                                                                                489,
                                                                                                                                                490,
                                                                                                                                                491,
                                                                                                                                                492,
                                                                                                                                                493,
                                                                                                                                                494,
                                                                                                                                                495,
                                                                                                                                                496,
                                                                                                                                                497,
                                                                                                                                                498,
                                                                                                                                                499,
                                                                                                                                                500,
                                                                                                                                                501,
                                                                                                                                                502,
                                                                                                                                                503,
                                                                                                                                                504,
                                                                                                                                                505,
                                                                                                                                                506,
                                                                                                                                                507,
                                                                                                                                                508,
                                                                                                                                                509,
                                                                                                                                                510,
                                                                                                                                                511,
                                                                                                                                                512,
                                                                                                                                                513,
                                                                                                                                                514,
                                                                                                                                                515,
                                                                                                                                                516,
                                                                                                                                                517,
                                                                                                                                                518,
                                                                                                                                                519,
                                                                                                                                                520,
                                                                                                                                                521,
                                                                                                                                                522,
                                                                                                                                                523,
                                                                                                                                                524,
                                                                                                                                                525,
                                                                                                                                                526,
                                                                                                                                                527,
                                                                                                                                                528,
                                                                                                                                                529,
                                                                                                                                                530,
                                                                                                                                                531,
                                                                                                                                                532,
                                                                                                                                                533,
                                                                                                                                                534,
                                                                                                                                                535,
                                                                                                                                                536,
                                                                                                                                                537,
                                                                                                                                                538,
                                                                                                                                                539,
                                                                                                                                                540,
                                                                                                                                                541,
                                                                                                                                                542,
                                                                                                                                                543,
                                                                                                                                                544,
                                                                                                                                                545,
                                                                                                                                                546,
                                                                                                                                                547,
                                                                                                                                                548,
                                                                                                                                                549,
                                                                                                                                                550,
                                                                                                                                                551,
                                                                                                                                                552,
                                                                                                                                                553,
                                                                                                                                                554,
                                                                                                                                                555,
                                                                                                                                                556,
                                                                                                                                                557,
                                                                                                                                                558,
                                                                                                                                                559,
                                                                                                                                                560,
                                                                                                                                                561,
                                                                                                                                                562,
                                                                                                                                                563,
                                                                                                                                                564,
                                                                                                                                                565,
                                                                                                                                                566,
                                                                                                                                                567,
                                                                                                                                                568,
                                                                                                                                                569,
                                                                                                                                                570,
                                                                                                                                                571,
                                                                                                                                                572,
                                                                                                                                                573,
                                                                                                                                                574,
                                                                                                                                                575,
                                                                                                                                                576,
                                                                                                                                                577,
                                                                                                                                                578,
                                                                                                                                                579,
                                                                                                                                                580,
                                                                                                                                                581,
                                                                                                                                                582,
                                                                                                                                                583,
                                                                                                                                                584,
                                                                                                                                                585,
                                                                                                                                                586,
                                                                                                                                                587,
                                                                                                                                                588,
                                                                                                                                                589,
                                                                                                                                                590,
                                                                                                                                                591,
                                                                                                                                                592,
                                                                                                                                                593,
                                                                                                                                                594,
                                                                                                                                                595,
                                                                                                                                                596,
                                                                                                                                                597,
                                                                                                                                                598,
                                                                                                                                                599,
                                                                                                                                                600,
                                                                                                                                                601,
                                                                                                                                                602,
                                                                                                                                                603,
                                                                                                                                                604,
                                                                                                                                                605,
                                                                                                                                                606,
                                                                                                                                                607,
                                                                                                                                                608,
                                                                                                                                                609,
                                                                                                                                                610,
                                                                                                                                                611,
                                                                                                                                                612,
                                                                                                                                                613,
                                                                                                                                                614,
                                                                                                                                                615,
                                                                                                                                                616,
                                                                                                                                                617,
                                                                                                                                                618,
                                                                                                                                                619,
                                                                                                                                                620,
                                                                                                                                                621,
                                                                                                                                                622,
                                                                                                                                                623,
                                                                                                                                                624,
                                                                                                                                                625,
                                                                                                                                                626,
                                                                                                                                                627,
                                                                                                                                                628,
                                                                                                                                                629,
                                                                                                                                                630,
                                                                                                                                                631,
                                                                                                                                                632,
                                                                                                                                                633,
                                                                                                                                                634,
                                                                                                                                                635,
                                                                                                                                                636,
                                                                                                                                                637,
                                                                                                                                                638,
                                                                                                                                                639,
                                                                                                                                                640,
                                                                                                                                                641,
                                                                                                                                                642,
                                                                                                                                                643,
                                                                                                                                                644,
                                                                                                                                                645,
                                                                                                                                                646,
                                                                                                                                                647,
                                                                                                                                                648,
                                                                                                                                                649,
                                                                                                                                                650,
                                                                                                                                                651,
                                                                                                                                                652,
                                                                                                                                                653,
                                                                                                                                                654,
                                                                                                                                                655,
                                                                                                                                                656,
                                                                                                                                                657,
                                                                                                                                                658,
                                                                                                                                                659,
                                                                                                                                                660,
                                                                                                                                                661,
                                                                                                                                                662,
                                                                                                                                                663,
                                                                                                                                                664,
                                                                                                                                                665,
                                                                                                                                                666,
                                                                                                                                                667,
                                                                                                                                                668,
                                                                                                                                                669,
                                                                                                                                                670,
                                                                                                                                                671,
                                                                                                                                                672,
                                                                                                                                                673,
                                                                                                                                                674,
                                                                                                                                                675,
                                                                                                                                                676,
                                                                                                                                                677,
                                                                                                                                                678,
                                                                                                                                                679,
                                                                                                                                                680,
                                                                                                                                                681,
                                                                                                                                                682,
                                                                                                                                                683,
                                                                                                                                                684,
                                                                                                                                                685,
                                                                                                                                                686,
                                                                                                                                                687,
                                                                                                                                                688,
                                                                                                                                                689,
                                                                                                                                                690,
                                                                                                                                                691,
                                                                                                                                                692,
                                                                                                                                                693,
                                                                                                                                                694,
                                                                                                                                                695,
                                                                                                                                                696,
                                                                                                                                                697,
                                                                                                                                                698,
                                                                                                                                                699,
                                                                                                                                                700,
                                                                                                                                                701,
                                                                                                                                                702,
                                                                                                                                                703,
                                                                                                                                                704,
                                                                                                                                                705,
                                                                                                                                                706,
                                                                                                                                                707,
                                                                                                                                                708,
                                                                                                                                                709,
                                                                                                                                                710,
                                                                                                                                                711,
                                                                                                                                                712,
                                                                                                                                                713,
                                                                                                                                                714,
                                                                                                                                                715,
                                                                                                                                                716,
                                                                                                                                                717,
                                                                                                                                                718,
                                                                                                                                                719,
                                                                                                                                                720,
                                                                                                                                                721,
                                                                                                                                                722,
                                                                                                                                                723,
                                                                                                                                                724,
                                                                                                                                                725,
                                                                                                                                                726,
                                                                                                                                                727,
                                                                                                                                                728,
                                                                                                                                                729,
                                                                                                                                                730,
                                                                                                                                                731,
                                                                                                                                                732,
                                                                                                                                                733,
                                                                                                                                                734,
                                                                                                                                                735,
                                                                                                                                                736,
                                                                                                                                                737,
                                                                                                                                                738,
                                                                                                                                                739,
                                                                                                                                                740,
                                                                                                                                                741,
                                                                                                                                                742,
                                                                                                                                                743,
                                                                                                                                                744,
                                                                                                                                                745,
                                                                                                                                                746,
                                                                                                                                                747,
                                                                                                                                                748,
                                                                                                                                                749,
                                                                                                                                                750,
                                                                                                                                                751,
                                                                                                                                                752,
                                                                                                                                                753,
                                                                                                                                                754,
                                                                                                                                                755,
                                                                                                                                                756,
                                                                                                                                                757,
                                                                                                                                                758,
                                                                                                                                                759,
                                                                                                                                                760,
                                                                                                                                                761,
                                                                                                                                                762,
                                                                                                                                                763,
                                                                                                                                                764,
                                                                                                                                                765,
                                                                                                                                                766,
                                                                                                                                                767,
                                                                                                                                                768,
                                                                                                                                                769,
                                                                                                                                                770,
                                                                                                                                                771,
                                                                                                                                                772,
                                                                                                                                                773,
                                                                                                                                                774,
                                                                                                                                                775,
                                                                                                                                                776,
                                                                                                                                                777,
                                                                                                                                                778,
                                                                                                                                                779,
                                                                                                                                                780,
                                                                                                                                                781,
                                                                                                                                                782,
                                                                                                                                                783,
                                                                                                                                                784,
                                                                                                                                                785,
                                                                                                                                                786,
                                                                                                                                                787,
                                                                                                                                                788,
                                                                                                                                                789,
                                                                                                                                                790,
                                                                                                                                                791,
                                                                                                                                                792,
                                                                                                                                                793,
                                                                                                                                                794,
                                                                                                                                                795,
                                                                                                                                                796,
                                                                                                                                                797,
                                                                                                                                                798,
                                                                                                                                                799,
                                                                                                                                                800,
                                                                                                                                                801,
                                                                                                                                                802,
                                                                                                                                                803,
                                                                                                                                                804,
                                                                                                                                                805,
                                                                                                                                                806,
                                                                                                                                                807,
                                                                                                                                                808,
                                                                                                                                                809,
                                                                                                                                                810,
                                                                                                                                                811,
                                                                                                                                                812,
                                                                                                                                                813,
                                                                                                                                                814,
                                                                                                                                                815,
                                                                                                                                                816,
                                                                                                                                                817,
                                                                                                                                                818,
                                                                                                                                                819,
                                                                                                                                                820,
                                                                                                                                                821,
                                                                                                                                                822,
                                                                                                                                                823,
                                                                                                                                                824,
                                                                                                                                                825,
                                                                                                                                                826,
                                                                                                                                                827,
                                                                                                                                                828,
                                                                                                                                                829,
                                                                                                                                                830,
                                                                                                                                                831,
                                                                                                                                                832,
                                                                                                                                                833,
                                                                                                                                                834,
                                                                                                                                                835,
                                                                                                                                                836,
                                                                                                                                                837,
                                                                                                                                                838,
                                                                                                                                                839,
                                                                                                                                                840,
                                                                                                                                                841,
                                                                                                                                                842,
                                                                                                                                                843,
                                                                                                                                                844,
                                                                                                                                                845,
                                                                                                                                                846,
                                                                                                                                                847,
                                                                                                                                                848,
                                                                                                                                                849,
                                                                                                                                                850,
                                                                                                                                                851,
                                                                                                                                                852,
                                                                                                                                                853,
                                                                                                                                                854,
                                                                                                                                                855,
                                                                                                                                                856,
                                                                                                                                                857,
                                                                                                                                                858,
                                                                                                                                                859,
                                                                                                                                                860,
                                                                                                                                                861,
                                                                                                                                                862,
                                                                                                                                                863,
                                                                                                                                                864,
                                                                                                                                                865,
                                                                                                                                                866,
                                                                                                                                                867,
                                                                                                                                                868,
                                                                                                                                                869,
                                                                                                                                                870,
                                                                                                                                                871,
                                                                                                                                                872,
                                                                                                                                                873,
                                                                                                                                                874,
                                                                                                                                                875,
                                                                                                                                                876,
                                                                                                                                                877,
                                                                                                                                                878,
                                                                                                                                                879,
                                                                                                                                                880,
                                                                                                                                                881,
                                                                                                                                                882,
                                                                                                                                                883,
                                                                                                                                                884,
                                                                                                                                                885,
                                                                                                                                                886,
                                                                                                                                                887,
                                                                                                                                                888,
                                                                                                                                                889,
                                                                                                                                                890,
                                                                                                                                                891,
                                                                                                                                                892,
                                                                                                                                                893,
                                                                                                                                                894,
                                                                                                                                                895,
                                                                                                                                                896,
                                                                                                                                                897,
                                                                                                                                                898,
                                                                                                                                                899,
                                                                                                                                                900,
                                                                                                                                                901,
                                                                                                                                                902,
                                                                                                                                                903,
                                                                                                                                                904,
                                                                                                                                                905,
                                                                                                                                                906,
                                                                                                                                                907,
                                                                                                                                                908,
                                                                                                                                                909,
                                                                                                                                                910,
                                                                                                                                                911,
                                                                                                                                                912,
                                                                                                                                                913,
                                                                                                                                                914,
                                                                                                                                                915,
                                                                                                                                                916,
                                                                                                                                                917,
                                                                                                                                                918,
                                                                                                                                                919,
                                                                                                                                                920,
                                                                                                                                                921,
                                                                                                                                                922,
                                                                                                                                                923,
                                                                                                                                                924,
                                                                                                                                                925,
                                                                                                                                                926,
                                                                                                                                                927,
                                                                                                                                                928,
                                                                                                                                                929,
                                                                                                                                                930,
                                                                                                                                                931,
                                                                                                                                                932,
                                                                                                                                                933,
                                                                                                                                                934,
                                                                                                                                                935,
                                                                                                                                                936,
                                                                                                                                                937,
                                                                                                                                                938,
                                                                                                                                                939,
                                                                                                                                                940,
                                                                                                                                                941,
                                                                                                                                                942,
                                                                                                                                                943,
                                                                                                                                                944,
                                                                                                                                                945,
                                                                                                                                                946,
                                                                                                                                                947,
                                                                                                                                                948,
                                                                                                                                                949,
                                                                                                                                                950,
                                                                                                                                                951,
                                                                                                                                                952,
                                                                                                                                                953,
                                                                                                                                                954,
                                                                                                                                                955,
                                                                                                                                                956,
                                                                                                                                                957,
                                                                                                                                                958,
                                                                                                                                                959,
                                                                                                                                                960,
                                                                                                                                                961,
                                                                                                                                                962,
                                                                                                                                                963,
                                                                                                                                                964,
                                                                                                                                                965,
                                                                                                                                                966,
                                                                                                                                                967,
                                                                                                                                                968,
                                                                                                                                                969,
                                                                                                                                                970,
                                                                                                                                                971,
                                                                                                                                                972,
                                                                                                                                                973,
                                                                                                                                                974,
                                                                                                                                                975,
                                                                                                                                                976,
                                                                                                                                                977,
                                                                                                                                                978,
                                                                                                                                                979,
                                                                                                                                                980,
                                                                                                                                                981,
                                                                                                                                                982,
                                                                                                                                                983,
                                                                                                                                                984,
                                                                                                                                                985,
                                                                                                                                                986,
                                                                                                                                                987,
                                                                                                                                                988,
                                                                                                                                                989,
                                                                                                                                                990,
                                                                                                                                                991,
                                                                                                                                                992,
                                                                                                                                                993,
                                                                                                                                                994,
                                                                                                                                                995,
                                                                                                                                                996,
                                                                                                                                                997,
                                                                                                                                                998,
                                                                                                                                                999,
                                                                                                                                                1000,
                                                                                                                                                1001,
                                                                                                                                                1002,
                                                                                                                                                1003,
                                                                                                                                                1004,
                                                                                                                                                1005,
                                                                                                                                                1006,
                                                                                                                                                1007,
                                                                                                                                                1008,
                                                                                                                                                1009,
                                                                                                                                                1010,
                                                                                                                                                1011,
                                                                                                                                                1012,
                                                                                                                                                1013,
                                                                                                                                                1014,
                                                                                                                                                1015,
                                                                                                                                                1016,
                                                                                                                                                1017,
                                                                                                                                                1018,
                                                                                                                                                1019,
                                                                                                                                                1020,
                                                                                                                                                1021,
                                                                                                                                                1022,
                                                                                                                                                1023,
                                                                                                                                                1024,
                                                                                                                                                1025,
                                                                                                                                                1026,
                                                                                                                                                1027,
                                                                                                                                                1028,
                                                                                                                                                1029,
                                                                                                                                                1030,
                                                                                                                                                1031,
                                                                                                                                                1032,
                                                                                                                                                1033,
                                                                                                                                                1034,
                                                                                                                                                1035,
                                                                                                                                                1036,
                                                                                                                                                1037,
                                                                                                                                                1038,
                                                                                                                                                1039,
                                                                                                                                                1040,
                                                                                                                                                1041,
                                                                                                                                                1042,
                                                                                                                                                1043,
                                                                                                                                                1044,
                                                                                                                                                1045,
                                                                                                                                                1046,
                                                                                                                                                1047,
                                                                                                                                                1048,
                                                                                                                                                1049,
                                                                                                                                                1050,
                                                                                                                                                1051,
                                                                                                                                                1052,
                                                                                                                                                1053,
                                                                                                                                                1054,
                                                                                                                                                1055,
                                                                                                                                                1056,
                                                                                                                                                1057,
                                                                                                                                                1058,
                                                                                                                                                1059,
                                                                                                                                                1060,
                                                                                                                                                1061,
                                                                                                                                                1062,
                                                                                                                                                1063,
                                                                                                                                                1064,
                                                                                                                                                1065,
                                                                                                                                                1066,
                                                                                                                                                1067,
                                                                                                                                                1068,
                                                                                                                                                1069,
                                                                                                                                                1070,
                                                                                                                                                1071,
                                                                                                                                                1072,
                                                                                                                                                1073,
                                                                                                                                                1074,
                                                                                                                                                1075,
                                                                                                                                                1076,
                                                                                                                                                1077,
                                                                                                                                                1078,
                                                                                                                                                1079,
                                                                                                                                                1080,
                                                                                                                                                1081,
                                                                                                                                                1082,
                                                                                                                                                1083,
                                                                                                                                                1084,
                                                                                                                                                1085,
                                                                                                                                                1086,
                                                                                                                                                1087,
                                                                                                                                                1088,
                                                                                                                                                1089,
                                                                                                                                                1090,
                                                                                                                                                1091,
                                                                                                                                                1092,
                                                                                                                                                1093,
                                                                                                                                                1094,
                                                                                                                                                1095,
                                                                                                                                                1096,
                                                                                                                                                1097,
                                                                                                                                                1098,
                                                                                                                                                1099,
                                                                                                                                                1100,
                                                                                                                                                1101,
                                                                                                                                                1102,
                                                                                                                                                1103,
                                                                                                                                                1104,
                                                                                                                                                1105,
                                                                                                                                                1106,
                                                                                                                                                1107,
                                                                                                                                                1108,
                                                                                                                                                1109,
                                                                                                                                                1110,
                                                                                                                                                1111,
                                                                                                                                                1112,
                                                                                                                                                1113,
                                                                                                                                                1114,
                                                                                                                                                1115,
                                                                                                                                                1116,
                                                                                                                                                1117,
                                                                                                                                                1118,
                                                                                                                                                1119,
                                                                                                                                                1120,
                                                                                                                                                1121,
                                                                                                                                                1122,
                                                                                                                                                1123,
                                                                                                                                                1124,
                                                                                                                                                1125,
                                                                                                                                                1126,
                                                                                                                                                1127,
                                                                                                                                                1128,
                                                                                                                                                1129,
                                                                                                                                                1130,
                                                                                                                                                1131,
                                                                                                                                                1132,
                                                                                                                                                1133,
                                                                                                                                                1134,
                                                                                                                                                1135,
                                                                                                                                                1136,
                                                                                                                                                1137,
                                                                                                                                                1138,
                                                                                                                                                1139,
                                                                                                                                                1140,
                                                                                                                                                1141,
                                                                                                                                                1142,
                                                                                                                                                1143,
                                                                                                                                                1144,
                                                                                                                                                1145,
                                                                                                                                                1146,
                                                                                                                                                1147,
                                                                                                                                                1148,
                                                                                                                                                1149,
                                                                                                                                                1150,
                                                                                                                                                1151,
                                                                                                                                                1152,
                                                                                                                                                1153,
                                                                                                                                                1154,
                                                                                                                                                1155,
                                                                                                                                                1156,
                                                                                                                                                1157,
                                                                                                                                                1158,
                                                                                                                                                1159,
                                                                                                                                                1160,
                                                                                                                                                1161,
                                                                                                                                                1162,
                                                                                                                                                1163,
                                                                                                                                                1164,
                                                                                                                                                1165,
                                                                                                                                                1166,
                                                                                                                                                1167,
                                                                                                                                                1168,
                                                                                                                                                1169,
                                                                                                                                                1170,
                                                                                                                                                1171,
                                                                                                                                                1172,
                                                                                                                                                1173,
                                                                                                                                                1174,
                                                                                                                                                1175,
                                                                                                                                                1176,
                                                                                                                                                1177,
                                                                                                                                                1178,
                                                                                                                                                1179,
                                                                                                                                                1180,
                                                                                                                                                1181,
                                                                                                                                                1182,
                                                                                                                                                1183,
                                                                                                                                                1184,
                                                                                                                                                1185,
                                                                                                                                                1186,
                                                                                                                                                1187,
                                                                                                                                                1188,
                                                                                                                                                1189,
                                                                                                                                                1190,
                                                                                                                                                1191,
                                                                                                                                                1192,
                                                                                                                                                1193,
                                                                                                                                                1194,
                                                                                                                                                1195,
                                                                                                                                                1196,
                                                                                                                                                1197,
                                                                                                                                                1198,
                                                                                                                                                1199,
                                                                                                                                                1200,
                                                                                                                                                1201,
                                                                                                                                                1202,
                                                                                                                                                1203,
                                                                                                                                                1204,
                                                                                                                                                1205,
                                                                                                                                                1206,
                                                                                                                                                1207,
                                                                                                                                                1208,
                                                                                                                                                1209,
                                                                                                                                                1210,
                                                                                                                                                1211,
                                                                                                                                                1212,
                                                                                                                                                1213,
                                                                                                                                                1214,
                                                                                                                                                1215,
                                                                                                                                                1216,
                                                                                                                                                1217,
                                                                                                                                                1218,
                                                                                                                                                1219,
                                                                                                                                                1220,
                                                                                                                                                1221,
                                                                                                                                                1222,
                                                                                                                                                1223,
                                                                                                                                                1224,
                                                                                                                                                1225,
                                                                                                                                                1226,
                                                                                                                                                1227,
                                                                                                                                                1228,
                                                                                                                                                1229,
                                                                                                                                                1230,
                                                                                                                                                1231,
                                                                                                                                                1232,
                                                                                                                                                1233,
                                                                                                                                                1234,
                                                                                                                                                1235,
                                                                                                                                                1236,
                                                                                                                                                1237,
                                                                                                                                                1238,
                                                                                                                                                1239,
                                                                                                                                                1240,
                                                                                                                                                1241,
                                                                                                                                                1242,
                                                                                                                                                1243,
                                                                                                                                                1244,
                                                                                                                                                1245,
                                                                                                                                                1246,
                                                                                                                                                1247,
                                                                                                                                                1248,
                                                                                                                                                1249,
                                                                                                                                                1250,
                                                                                                                                                1251,
                                                                                                                                                1252,
                                                                                                                                                1253,
                                                                                                                                                1254,
                                                                                                                                                1255,
                                                                                                                                                1256,
                                                                                                                                                1257,
                                                                                                                                                1258,
                                                                                                                                                1259,
                                                                                                                                                1260,
                                                                                                                                                1261,
                                                                                                                                                1262,
                                                                                                                                                1263,
                                                                                                                                                1264,
                                                                                                                                                1265,
                                                                                                                                                1266,
                                                                                                                                                1267,
                                                                                                                                                1268,
                                                                                                                                                1269,
                                                                                                                                                1270,
                                                                                                                                                1271,
                                                                                                                                                1272,
                                                                                                                                                1273,
                                                                                                                                                1274,
                                                                                                                                                1275,
                                                                                                                                                1276,
                                                                                                                                                1277,
                                                                                                                                                1278,
                                                                                                                                                1279,
                                                                                                                                                1280,
                                                                                                                                                1281,
                                                                                                                                                1282,
                                                                                                                                                1283,
                                                                                                                                                1284,
                                                                                                                                                1285,
                                                                                                                                                1286,
                                                                                                                                                1287,
                                                                                                                                                1288,
                                                                                                                                                1289,
                                                                                                                                                1290,
                                                                                                                                                1291,
                                                                                                                                                1292,
                                                                                                                                                1293,
                                                                                                                                                1294,
                                                                                                                                                1295,
                                                                                                                                                1296,
                                                                                                                                                1297,
                                                                                                                                                1298,
                                                                                                                                                1299,
                                                                                                                                                1300,
                                                                                                                                                1301,
                                                                                                                                                1302,
                                                                                                                                                1303,
                                                                                                                                                1304,
                                                                                                                                                1305,
                                                                                                                                                1306,
                                                                                                                                                1307,
                                                                                                                                                1308,
                                                                                                                                                1309,
                                                                                                                                                1310,
                                                                                                                                                1311,
                                                                                                                                                1312,
                                                                                                                                                1313,
                                                                                                                                                1314,
                                                                                                                                                1315,
                                                                                                                                                1316,
                                                                                                                                                1317,
                                                                                                                                                1318,
                                                                                                                                                1319,
                                                                                                                                                1320,
                                                                                                                                                1321,
                                                                                                                                                1322,
                                                                                                                                                1323,
                                                                                                                                                1324,
                                                                                                                                                1325,
                                                                                                                                                1326,
                                                                                                                                                1327,
                                                                                                                                                1328,
                                                                                                                                                1329,
                                                                                                                                                1330,
                                                                                                                                                1331,
                                                                                                                                                1332,
                                                                                                                                                1333,
                                                                                                                                                1334,
                                                                                                                                                1335,
                                                                                                                                                1336,
                                                                                                                                                1337,
                                                                                                                                                1338,
                                                                                                                                                1339,
                                                                                                                                                1340,
                                                                                                                                                1341,
                                                                                                                                                1342,
                                                                                                                                                1343,
                                                                                                                                                1344,
                                                                                                                                                1345,
                                                                                                                                                1346,
                                                                                                                                                1347,
                                                                                                                                                1348,
                                                                                                                                                1349,
                                                                                                                                                1350,
                                                                                                                                                1351,
                                                                                                                                                1352,
                                                                                                                                                1353,
                                                                                                                                                1354,
                                                                                                                                                1355,
                                                                                                                                                1356,
                                                                                                                                                1357,
                                                                                                                                                1358,
                                                                                                                                                1359,
                                                                                                                                                1360,
                                                                                                                                                1361,
                                                                                                                                                1362,
                                                                                                                                                1363,
                                                                                                                                                1364,
                                                                                                                                                1365,
                                                                                                                                                1366,
                                                                                                                                                1367,
                                                                                                                                                1368,
                                                                                                                                                1369,
                                                                                                                                                1370,
                                                                                                                                                1371,
                                                                                                                                                1372,
                                                                                                                                                1373,
                                                                                                                                                1374,
                                                                                                                                                1375,
                                                                                                                                                1376,
                                                                                                                                                1377,
                                                                                                                                                1378,
                                                                                                                                                1379,
                                                                                                                                                1380,
                                                                                                                                                1381,
                                                                                                                                                1382,
                                                                                                                                                1383,
                                                                                                                                                1384,
                                                                                                                                                1385,
                                                                                                                                                1386,
                                                                                                                                                1387,
                                                                                                                                                1388,
                                                                                                                                                1389,
                                                                                                                                                1390,
                                                                                                                                                1391,
                                                                                                                                                1392,
                                                                                                                                                1393,
                                                                                                                                                1394,
                                                                                                                                                1395,
                                                                                                                                                1396,
                                                                                                                                                1397,
                                                                                                                                                1398,
                                                                                                                                                1399,
                                                                                                                                                1400,
                                                                                                                                                1401,
                                                                                                                                                1402,
                                                                                                                                                1403,
                                                                                                                                                1404,
                                                                                                                                                1405,
                                                                                                                                                1406,
                                                                                                                                                1407,
                                                                                                                                                1408,
                                                                                                                                                1409,
                                                                                                                                                1410,
                                                                                                                                                1411,
                                                                                                                                                1412,
                                                                                                                                                1413,
                                                                                                                                                1414,
                                                                                                                                                1415,
                                                                                                                                                1416,
                                                                                                                                                1417,
                                                                                                                                                1418,
                                                                                                                                                1419,
                                                                                                                                                1420,
                                                                                                                                                1421,
                                                                                                                                                1422,
                                                                                                                                                1423,
                                                                                                                                                1424,
                                                                                                                                                1425,
                                                                                                                                                1426,
                                                                                                                                                1427,
                                                                                                                                                1428,
                                                                                                                                                1429,
                                                                                                                                                1430,
                                                                                                                                                1431,
                                                                                                                                                1432,
                                                                                                                                                1433,
                                                                                                                                                1434,
                                                                                                                                                1435,
                                                                                                                                                1436,
                                                                                                                                                1437,
                                                                                                                                                1438,
                                                                                                                                                1439,
                                                                                                                                                1440,
                                                                                                                                                1441,
                                                                                                                                                1442,
                                                                                                                                                1443,
                                                                                                                                                1444,
                                                                                                                                                1445,
                                                                                                                                                1446,
                                                                                                                                                1447,
                                                                                                                                                1448,
                                                                                                                                                1449,
                                                                                                                                                1450,
                                                                                                                                                1451,
                                                                                                                                                1452,
                                                                                                                                                1453,
                                                                                                                                                1454,
                                                                                                                                                1455,
                                                                                                                                                1456,
                                                                                                                                                1457,
                                                                                                                                                1458,
                                                                                                                                                1459,
                                                                                                                                                1460,
                                                                                                                                                1461,
                                                                                                                                                1462,
                                                                                                                                                1463,
                                                                                                                                                1464,
                                                                                                                                                1465,
                                                                                                                                                1466,
                                                                                                                                                1467,
                                                                                                                                                1468,
                                                                                                                                                1469,
                                                                                                                                                1470,
                                                                                                                                                1471,
                                                                                                                                                1472,
                                                                                                                                                1473,
                                                                                                                                                1474,
                                                                                                                                                1475,
                                                                                                                                                1476,
                                                                                                                                                1477,
                                                                                                                                                1478,
                                                                                                                                                1479,
                                                                                                                                                1480,
                                                                                                                                                1481,
                                                                                                                                                1482,
                                                                                                                                                1483,
                                                                                                                                                1484,
                                                                                                                                                1485,
                                                                                                                                                1486,
                                                                                                                                                1487,
                                                                                                                                                1488,
                                                                                                                                                1489,
                                                                                                                                                1490,
                                                                                                                                                1491,
                                                                                                                                                1492,
                                                                                                                                                1493,
                                                                                                                                                1494,
                                                                                                                                                1495,
                                                                                                                                                1496,
                                                                                                                                                1497,
                                                                                                                                                1498,
                                                                                                                                                1499,
                                                                                                                                                1500,
                                                                                                                                                1501,
                                                                                                                                                1502,
                                                                                                                                                1503,
                                                                                                                                                1504,
                                                                                                                                                1505,
                                                                                                                                                1506,
                                                                                                                                                1507,
                                                                                                                                                1508,
                                                                                                                                                1509,
                                                                                                                                                1510,
                                                                                                                                                1511,
                                                                                                                                                1512,
                                                                                                                                                1513,
                                                                                                                                                1514,
                                                                                                                                                1515,
                                                                                                                                                1516,
                                                                                                                                                1517,
                                                                                                                                                1518,
                                                                                                                                                1519,
                                                                                                                                                1520,
                                                                                                                                                1521,
                                                                                                                                                1522,
                                                                                                                                                1523,
                                                                                                                                                1524,
                                                                                                                                                1525,
                                                                                                                                                1526,
                                                                                                                                                1527,
                                                                                                                                                1528,
                                                                                                                                                1529,
                                                                                                                                                1530,
                                                                                                                                                1531,
                                                                                                                                                1532,
                                                                                                                                                1533,
                                                                                                                                                1534,
                                                                                                                                                1535,
                                                                                                                                                1536,
                                                                                                                                                1537,
                                                                                                                                                1538,
                                                                                                                                                1539,
                                                                                                                                                1540,
                                                                                                                                                1541,
                                                                                                                                                1542,
                                                                                                                                                1543,
                                                                                                                                                1544,
                                                                                                                                                1545,
                                                                                                                                                1546,
                                                                                                                                                1547,
                                                                                                                                                1548,
                                                                                                                                                1549,
                                                                                                                                                1550,
                                                                                                                                                1551,
                                                                                                                                                1552,
                                                                                                                                                1553,
                                                                                                                                                1554,
                                                                                                                                                1555,
                                                                                                                                                1556,
                                                                                                                                                1557,
                                                                                                                                                1558,
                                                                                                                                                1559,
                                                                                                                                                1560,
                                                                                                                                                1561,
                                                                                                                                                1562,
                                                                                                                                                1563,
                                                                                                                                                1564,
                                                                                                                                                1565,
                                                                                                                                                1566,
                                                                                                                                                1567,
                                                                                                                                                1568,
                                                                                                                                                1569,
                                                                                                                                                1570,
                                                                                                                                                1571,
                                                                                                                                                1572,
                                                                                                                                                1573,
                                                                                                                                                1574,
                                                                                                                                                1575,
                                                                                                                                                1576,
                                                                                                                                                1577,
                                                                                                                                                1578,
                                                                                                                                                1579,
                                                                                                                                                1580,
                                                                                                                                                1581,
                                                                                                                                                1582,
                                                                                                                                                1583,
                                                                                                                                                1584,
                                                                                                                                                1585,
                                                                                                                                                1586,
                                                                                                                                                1587,
                                                                                                                                                1588,
                                                                                                                                                1589,
                                                                                                                                                1590,
                                                                                                                                                1591,
                                                                                                                                                1592,
                                                                                                                                                1593,
                                                                                                                                                1594,
                                                                                                                                                1595,
                                                                                                                                                1596,
                                                                                                                                                1597,
                                                                                                                                                1598,
                                                                                                                                                1599,
                                                                                                                                                1600,
                                                                                                                                                1601,
                                                                                                                                                1602,
                                                                                                                                                1603,
                                                                                                                                                1604,
                                                                                                                                                1605,
                                                                                                                                                1606,
                                                                                                                                                1607,
                                                                                                                                                1608,
                                                                                                                                                1609,
                                                                                                                                                1610,
                                                                                                                                                1611,
                                                                                                                                                1612,
                                                                                                                                                1613,
                                                                                                                                                1614,
                                                                                                                                                1615,
                                                                                                                                                1616,
                                                                                                                                                1617,
                                                                                                                                                1618,
                                                                                                                                                1619,
                                                                                                                                                1620,
                                                                                                                                                1621,
                                                                                                                                                1622,
                                                                                                                                                1623,
                                                                                                                                                1624,
                                                                                                                                                1625,
                                                                                                                                                1626,
                                                                                                                                                1627,
                                                                                                                                                1628,
                                                                                                                                                1629,
                                                                                                                                                1630,
                                                                                                                                                1631,
                                                                                                                                                1632,
                                                                                                                                                1633,
                                                                                                                                                1634,
                                                                                                                                                1635,
                                                                                                                                                1636,
                                                                                                                                                1637,
                                                                                                                                                1638,
                                                                                                                                                1639,
                                                                                                                                                1640,
                                                                                                                                                1641,
                                                                                                                                                1642,
                                                                                                                                                1643,
                                                                                                                                                1644,
                                                                                                                                                1645,
                                                                                                                                                1646,
                                                                                                                                                1647,
                                                                                                                                                1648,
                                                                                                                                                1649,
                                                                                                                                                1650,
                                                                                                                                                1651,
                                                                                                                                                1652,
                                                                                                                                                1653,
                                                                                                                                                1654,
                                                                                                                                                1655,
                                                                                                                                                1656,
                                                                                                                                                1657,
                                                                                                                                                1658,
                                                                                                                                                1659,
                                                                                                                                                1660,
                                                                                                                                                1661,
                                                                                                                                                1662,
                                                                                                                                                1663,
                                                                                                                                                1664,
                                                                                                                                                1665,
                                                                                                                                                1666,
                                                                                                                                                1667,
                                                                                                                                                1668,
                                                                                                                                                1669,
                                                                                                                                                1670,
                                                                                                                                                1671,
                                                                                                                                                1672,
                                                                                                                                                1673,
                                                                                                                                                1674,
                                                                                                                                                1675,
                                                                                                                                                1676,
                                                                                                                                                1677,
                                                                                                                                                1678,
                                                                                                                                                1679,
                                                                                                                                                1680,
                                                                                                                                                1681,
                                                                                                                                                1682,
                                                                                                                                                1683,
                                                                                                                                                1684,
                                                                                                                                                1685,
                                                                                                                                                1686,
                                                                                                                                                1687,
                                                                                                                                                1688,
                                                                                                                                                1689,
                                                                                                                                                1690,
                                                                                                                                                1691,
                                                                                                                                                1692,
                                                                                                                                                1693,
                                                                                                                                                1694,
                                                                                                                                                1695,
                                                                                                                                                1696,
                                                                                                                                                1697,
                                                                                                                                                1698,
                                                                                                                                                1699,
                                                                                                                                                1700,
                                                                                                                                                1701,
                                                                                                                                                1702,
                                                                                                                                                1703,
                                                                                                                                                1704,
                                                                                                                                                1705,
                                                                                                                                                1706,
                                                                                                                                                1707,
                                                                                                                                                1708,
                                                                                                                                                1709,
                                                                                                                                                1710,
                                                                                                                                                1711,
                                                                                                                                                1712,
                                                                                                                                                1713,
                                                                                                                                                1714,
                                                                                                                                                1715,
                                                                                                                                                1716,
                                                                                                                                                1717,
                                                                                                                                                1718,
                                                                                                                                                1719,
                                                                                                                                                1720,
                                                                                                                                                1721,
                                                                                                                                                1722,
                                                                                                                                                1723,
                                                                                                                                                1724,
                                                                                                                                                1725,
                                                                                                                                                1726,
                                                                                                                                                1727,
                                                                                                                                                1728,
                                                                                                                                                1729,
                                                                                                                                                1730,
                                                                                                                                                1731,
                                                                                                                                                1732,
                                                                                                                                                1733,
                                                                                                                                                1734,
                                                                                                                                                1735,
                                                                                                                                                1736,
                                                                                                                                                1737,
                                                                                                                                                1738,
                                                                                                                                                1739,
                                                                                                                                                1740,
                                                                                                                                                1741,
                                                                                                                                                1742,
                                                                                                                                                1743,
                                                                                                                                                1744,
                                                                                                                                                1745,
                                                                                                                                                1746,
                                                                                                                                                1747,
                                                                                                                                                1748,
                                                                                                                                                1749,
                                                                                                                                                1750,
                                                                                                                                                1751,
                                                                                                                                                1752,
                                                                                                                                                1753,
                                                                                                                                                1754,
                                                                                                                                                1755,
                                                                                                                                                1756,
                                                                                                                                                1757,
                                                                                                                                                1758,
                                                                                                                                                1759,
                                                                                                                                                1760,
                                                                                                                                                1761,
                                                                                                                                                1762,
                                                                                                                                                1763,
                                                                                                                                                1764,
                                                                                                                                                1765,
                                                                                                                                                1766,
                                                                                                                                                1767,
                                                                                                                                                1768,
                                                                                                                                                1769,
                                                                                                                                                1770,
                                                                                                                                                1771,
                                                                                                                                                1772,
                                                                                                                                                1773,
                                                                                                                                                1774,
                                                                                                                                                1775,
                                                                                                                                                1776,
                                                                                                                                                1777,
                                                                                                                                                1778,
                                                                                                                                                1779,
                                                                                                                                                1780,
                                                                                                                                                1781,
                                                                                                                                                1782,
                                                                                                                                                1783,
                                                                                                                                                1784,
                                                                                                                                                1785,
                                                                                                                                                1786,
                                                                                                                                                1787,
                                                                                                                                                1788,
                                                                                                                                                1789,
                                                                                                                                                1790,
                                                                                                                                                1791
                                                                                                                                            ]
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                }, {
                                                                                                                                    "type": "material",
                                                                                                                                    "baseColor": {
                                                                                                                                        "r": 1,
                                                                                                                                        "g": 1,
                                                                                                                                        "b": 1
                                                                                                                                    },
                                                                                                                                    "specularColor": {
                                                                                                                                        "r": 0.33,
                                                                                                                                        "g": 0.33,
                                                                                                                                        "b": 0.33,
                                                                                                                                        "a": 1
                                                                                                                                    },
                                                                                                                                    "shine": 10,
                                                                                                                                    "specular": 1,
                                                                                                                                    "nodes": [{
                                                                                                                                            "type": "geometry",
                                                                                                                                            "positions": [-41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                49.279355, -49.108403,
                                                                                                                                                32.328657,
                                                                                                                                                49.279355, -41.562468,
                                                                                                                                                35.454285,
                                                                                                                                                49.783762, -144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -15.073396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -12.100072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -18.046721,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -15.073396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -15.073396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -18.046721,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -18.046721,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -15.073396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -12.100072,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -12.100072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -15.073396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                67.52502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                67.52502,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -141.323396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -138.350072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -144.296721,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -141.323396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -141.323396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -144.296721,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -144.296721,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -141.323396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -138.350072,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -138.350072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -141.323396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "normals": [-0.382683,
                                                                                                                                                0.92388,
                                                                                                                                                0, -0.382683,
                                                                                                                                                0.92388,
                                                                                                                                                0, -0.382683,
                                                                                                                                                0.92388,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "uv": [-24.830946,
                                                                                                                                                49.279355, -32.998607,
                                                                                                                                                49.279355, -24.830946,
                                                                                                                                                49.783762,
                                                                                                                                                144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                144.296721,
                                                                                                                                                206.82824,
                                                                                                                                                141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                18.046721,
                                                                                                                                                206.82824,
                                                                                                                                                15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                18.046721,
                                                                                                                                                209.578306, -15.073396, -23.172384, -15.073396, -20.422384, -12.100072, -17.725735, -18.046721, -14.975735, -15.073396, -20.422384, -15.073396, -23.172384, -18.046721, -17.725735, -18.046721, -14.975735, -15.073396, -23.172384, -12.100072, -14.975735, -12.100072, -17.725735, -15.073396, -20.422384,
                                                                                                                                                12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                12.100072,
                                                                                                                                                110.32824,
                                                                                                                                                12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                18.046721,
                                                                                                                                                110.32824,
                                                                                                                                                15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                18.046721,
                                                                                                                                                110.32824,
                                                                                                                                                15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                12.100072,
                                                                                                                                                206.82824,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                18.046721,
                                                                                                                                                62.07824,
                                                                                                                                                15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                18.046721,
                                                                                                                                                62.07824,
                                                                                                                                                15.073396,
                                                                                                                                                67.52502,
                                                                                                                                                15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                15.073396,
                                                                                                                                                67.52502,
                                                                                                                                                12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                15.073396,
                                                                                                                                                70.275086, -141.323396, -23.172384, -141.323396, -20.422384, -138.350072, -17.725735, -144.296721, -14.975735, -141.323396, -20.422384, -141.323396, -23.172384, -144.296721, -17.725735, -144.296721, -14.975735, -141.323396, -23.172384, -138.350072, -14.975735, -138.350072, -17.725735, -141.323396, -20.422384,
                                                                                                                                                138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                144.296721,
                                                                                                                                                62.07824,
                                                                                                                                                141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                144.296721,
                                                                                                                                                62.07824,
                                                                                                                                                141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                144.296721,
                                                                                                                                                110.32824,
                                                                                                                                                141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                144.296721,
                                                                                                                                                110.32824,
                                                                                                                                                141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                138.350072,
                                                                                                                                                206.82824,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "indices": [
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                2,
                                                                                                                                                3,
                                                                                                                                                4,
                                                                                                                                                5,
                                                                                                                                                6,
                                                                                                                                                7,
                                                                                                                                                8,
                                                                                                                                                9,
                                                                                                                                                10,
                                                                                                                                                11,
                                                                                                                                                12,
                                                                                                                                                13,
                                                                                                                                                14,
                                                                                                                                                15,
                                                                                                                                                16,
                                                                                                                                                17,
                                                                                                                                                18,
                                                                                                                                                19,
                                                                                                                                                20,
                                                                                                                                                21,
                                                                                                                                                22,
                                                                                                                                                23,
                                                                                                                                                24,
                                                                                                                                                25,
                                                                                                                                                26,
                                                                                                                                                27,
                                                                                                                                                28,
                                                                                                                                                29,
                                                                                                                                                30,
                                                                                                                                                31,
                                                                                                                                                32,
                                                                                                                                                33,
                                                                                                                                                34,
                                                                                                                                                35,
                                                                                                                                                36,
                                                                                                                                                37,
                                                                                                                                                38,
                                                                                                                                                39,
                                                                                                                                                40,
                                                                                                                                                41,
                                                                                                                                                42,
                                                                                                                                                43,
                                                                                                                                                44,
                                                                                                                                                45,
                                                                                                                                                46,
                                                                                                                                                47,
                                                                                                                                                48,
                                                                                                                                                49,
                                                                                                                                                50,
                                                                                                                                                51,
                                                                                                                                                52,
                                                                                                                                                53,
                                                                                                                                                54,
                                                                                                                                                55,
                                                                                                                                                56,
                                                                                                                                                57,
                                                                                                                                                58,
                                                                                                                                                59,
                                                                                                                                                60,
                                                                                                                                                61,
                                                                                                                                                62,
                                                                                                                                                63,
                                                                                                                                                64,
                                                                                                                                                65,
                                                                                                                                                66,
                                                                                                                                                67,
                                                                                                                                                68,
                                                                                                                                                69,
                                                                                                                                                70,
                                                                                                                                                71,
                                                                                                                                                72,
                                                                                                                                                73,
                                                                                                                                                74,
                                                                                                                                                75,
                                                                                                                                                76,
                                                                                                                                                77,
                                                                                                                                                78,
                                                                                                                                                79,
                                                                                                                                                80,
                                                                                                                                                81,
                                                                                                                                                82,
                                                                                                                                                83,
                                                                                                                                                84,
                                                                                                                                                85,
                                                                                                                                                86,
                                                                                                                                                87,
                                                                                                                                                88,
                                                                                                                                                89,
                                                                                                                                                90,
                                                                                                                                                91,
                                                                                                                                                92,
                                                                                                                                                93,
                                                                                                                                                94,
                                                                                                                                                95,
                                                                                                                                                96,
                                                                                                                                                97,
                                                                                                                                                98,
                                                                                                                                                99,
                                                                                                                                                100,
                                                                                                                                                101,
                                                                                                                                                102,
                                                                                                                                                103,
                                                                                                                                                104,
                                                                                                                                                105,
                                                                                                                                                106,
                                                                                                                                                107,
                                                                                                                                                108,
                                                                                                                                                109,
                                                                                                                                                110,
                                                                                                                                                111,
                                                                                                                                                112,
                                                                                                                                                113,
                                                                                                                                                114,
                                                                                                                                                115,
                                                                                                                                                116,
                                                                                                                                                117,
                                                                                                                                                118,
                                                                                                                                                119,
                                                                                                                                                120,
                                                                                                                                                121,
                                                                                                                                                122,
                                                                                                                                                123
                                                                                                                                            ]
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                }, {
                                                                                                                                    "type": "material",

                                                                                                                                    "baseColor": {
                                                                                                                                        "r": 0.878431,
                                                                                                                                        "g": 0.258824,
                                                                                                                                        "b": 0.133333
                                                                                                                                    },
                                                                                                                                    emit: .05,
                                                                                                                                    "specularColor": {
                                                                                                                                        "r": 0.33,
                                                                                                                                        "g": 0.33,
                                                                                                                                        "b": 0.33,
                                                                                                                                        "a": 1
                                                                                                                                    },
                                                                                                                                    "shine": 10,
                                                                                                                                    "specular": 1,
                                                                                                                                    "nodes": [{
                                                                                                                                            "type": "geometry",
                                                                                                                                            "positions": [-138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -144.456188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -138.206188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -144.456188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -144.456188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -138.206188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -138.206188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -138.206188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -138.206188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -138.206188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -138.206188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -144.296721,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -144.296721,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -144.296721,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -144.296721,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -141.323396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -141.323396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -138.350072,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -138.350072,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -138.350072,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -138.350072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -138.206188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -18.448396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -11.698396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -18.448396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -11.698396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -11.698396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -18.448396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -18.448396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -18.448396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -18.448396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -18.448396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -18.448396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                67.52502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                67.52502,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -12.100072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -15.073396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -18.046721,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -18.046721,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -18.046721,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -15.073396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                20.776416,
                                                                                                                                                50.916006, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -12.100072,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -12.100072,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                48.39039, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                45.373466, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                48.39039, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                45.373466, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                42.059614, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                45.373466, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                42.059614, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                38.517509, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                42.059614, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                38.517509, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                34.820555, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                38.517509, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                34.820555, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -11.698396,
                                                                                                                                                2.393869,
                                                                                                                                                31.045366, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                34.820555, -18.448396,
                                                                                                                                                0,
                                                                                                                                                31.011023, -11.698396,
                                                                                                                                                2.393869,
                                                                                                                                                31.045366, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -18.448396,
                                                                                                                                                0,
                                                                                                                                                31.011023, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                27.270177, -11.698396,
                                                                                                                                                2.393869,
                                                                                                                                                31.045366, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                27.270177, -18.448396,
                                                                                                                                                0,
                                                                                                                                                31.011023, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                23.573223, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                27.270177, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                23.573223, -18.448396,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                20.031118, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                23.573223, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                20.031118, -18.448396,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                16.717266, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                20.031118, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                16.717266, -18.448396,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                13.700341, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                16.717266, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                13.700341, -18.448396,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                13.700341, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -18.448396,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -138.206188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -144.456188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -138.206188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -138.206188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -144.456188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -144.456188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -138.206188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -138.206188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -138.206188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -138.206188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -138.206188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -138.206188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -18.448396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -12.100072,
                                                                                                                                                15.329898,
                                                                                                                                                50.953824, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -12.100072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -138.350072,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                18.079832,
                                                                                                                                                50.93473, -141.323396,
                                                                                                                                                23.526349,
                                                                                                                                                50.896911, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -138.350072,
                                                                                                                                                206.82824,
                                                                                                                                                50.715, -144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                50.715, -141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                50.715,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "normals": [
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0, -0.669329,
                                                                                                                                                0.742966,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0, -0.669329,
                                                                                                                                                0.742966,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0, -0.669329,
                                                                                                                                                0.742966,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.501239,
                                                                                                                                                0,
                                                                                                                                                0.865309, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0, -0.454459, -0.890768,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0, -0.454459, -0.890768,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0, -0.454459, -0.890768,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.096606, -0.995323,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.762437, -0.647063,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.856631, -0.515929,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                0.932635, -0.360822,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.982543, -0.186037,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.982543,
                                                                                                                                                0.186037,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.932635,
                                                                                                                                                0.360822,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.856631,
                                                                                                                                                0.515929,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.762437,
                                                                                                                                                0.647063,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0.657324,
                                                                                                                                                0.753608,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.317073,
                                                                                                                                                0.948401,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0.022826, -0.458528,
                                                                                                                                                0.888387,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0.068314, -0.706542,
                                                                                                                                                0.704366,
                                                                                                                                                0.022826, -0.458528,
                                                                                                                                                0.888387,
                                                                                                                                                0, -0.321251,
                                                                                                                                                0.946994,
                                                                                                                                                0.070676, -0.743326,
                                                                                                                                                0.665186,
                                                                                                                                                0.022826, -0.458528,
                                                                                                                                                0.888387,
                                                                                                                                                0.068314, -0.706542,
                                                                                                                                                0.704366,
                                                                                                                                                0.068314, -0.706542,
                                                                                                                                                0.704366,
                                                                                                                                                0.123507, -0.795133,
                                                                                                                                                0.593725,
                                                                                                                                                0.070676, -0.743326,
                                                                                                                                                0.665186,
                                                                                                                                                0.166765, -0.798027,
                                                                                                                                                0.579087,
                                                                                                                                                0.123507, -0.795133,
                                                                                                                                                0.593725,
                                                                                                                                                0.068314, -0.706542,
                                                                                                                                                0.704366,
                                                                                                                                                0.166765, -0.798027,
                                                                                                                                                0.579087,
                                                                                                                                                0.201621, -0.862565,
                                                                                                                                                0.464037,
                                                                                                                                                0.123507, -0.795133,
                                                                                                                                                0.593725,
                                                                                                                                                0.237854, -0.864636,
                                                                                                                                                0.442528,
                                                                                                                                                0.201621, -0.862565,
                                                                                                                                                0.464037,
                                                                                                                                                0.166765, -0.798027,
                                                                                                                                                0.579087,
                                                                                                                                                0.237854, -0.864636,
                                                                                                                                                0.442528,
                                                                                                                                                0.266241, -0.908058,
                                                                                                                                                0.323336,
                                                                                                                                                0.201621, -0.862565,
                                                                                                                                                0.464037,
                                                                                                                                                0.292458, -0.910183,
                                                                                                                                                0.293317,
                                                                                                                                                0.266241, -0.908058,
                                                                                                                                                0.323336,
                                                                                                                                                0.237854, -0.864636,
                                                                                                                                                0.442528,
                                                                                                                                                0.292458, -0.910183,
                                                                                                                                                0.293317,
                                                                                                                                                0.310551, -0.933917,
                                                                                                                                                0.177081,
                                                                                                                                                0.266241, -0.908058,
                                                                                                                                                0.323336,
                                                                                                                                                0.324604, -0.935898,
                                                                                                                                                0.136849,
                                                                                                                                                0.310551, -0.933917,
                                                                                                                                                0.177081,
                                                                                                                                                0.292458, -0.910183,
                                                                                                                                                0.293317,
                                                                                                                                                0.324604, -0.935898,
                                                                                                                                                0.136849,
                                                                                                                                                0.331028, -0.943182,
                                                                                                                                                0.028788,
                                                                                                                                                0.310551, -0.933917,
                                                                                                                                                0.177081,
                                                                                                                                                0.33131, -0.943244, -0.022909,
                                                                                                                                                0.331028, -0.943182,
                                                                                                                                                0.028788,
                                                                                                                                                0.324604, -0.935898,
                                                                                                                                                0.136849,
                                                                                                                                                0.33131, -0.943244, -0.022909,
                                                                                                                                                0.326495, -0.937571, -0.119838,
                                                                                                                                                0.331028, -0.943182,
                                                                                                                                                0.028788,
                                                                                                                                                0.311946, -0.932328, -0.182906,
                                                                                                                                                0.326495, -0.937571, -0.119838,
                                                                                                                                                0.33131, -0.943244, -0.022909,
                                                                                                                                                0.311946, -0.932328, -0.182906,
                                                                                                                                                0.297409, -0.916514, -0.267488,
                                                                                                                                                0.326495, -0.937571, -0.119838,
                                                                                                                                                0.268086, -0.901575, -0.339548,
                                                                                                                                                0.297409, -0.916514, -0.267488,
                                                                                                                                                0.311946, -0.932328, -0.182906,
                                                                                                                                                0.268086, -0.901575, -0.339548,
                                                                                                                                                0.246064, -0.877519, -0.411599,
                                                                                                                                                0.297409, -0.916514, -0.267488,
                                                                                                                                                0.204103, -0.848888, -0.487577,
                                                                                                                                                0.246064, -0.877519, -0.411599,
                                                                                                                                                0.268086, -0.901575, -0.339548,
                                                                                                                                                0.204103, -0.848888, -0.487577,
                                                                                                                                                0.177476, -0.817775, -0.547491,
                                                                                                                                                0.246064, -0.877519, -0.411599,
                                                                                                                                                0.127714, -0.773741, -0.620495,
                                                                                                                                                0.177476, -0.817775, -0.547491,
                                                                                                                                                0.204103, -0.848888, -0.487577,
                                                                                                                                                0.127714, -0.773741, -0.620495,
                                                                                                                                                0.099958, -0.736363, -0.669162,
                                                                                                                                                0.177476, -0.817775, -0.547491,
                                                                                                                                                0.049376, -0.678793, -0.732668,
                                                                                                                                                0.099958, -0.736363, -0.669162,
                                                                                                                                                0.127714, -0.773741, -0.620495,
                                                                                                                                                0.036478, -0.657514, -0.752559,
                                                                                                                                                0.099958, -0.736363, -0.669162,
                                                                                                                                                0.049376, -0.678793, -0.732668,
                                                                                                                                                0, -0.278743, -0.960366,
                                                                                                                                                0, -0.278743, -0.960366,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0.036478, -0.657514, -0.752559,
                                                                                                                                                0.049376, -0.678793, -0.732668,
                                                                                                                                                0, -0.613941, -0.789352,
                                                                                                                                                0, -0.669329,
                                                                                                                                                0.742966,
                                                                                                                                                0, -0.669329,
                                                                                                                                                0.742966,
                                                                                                                                                0, -0.772611,
                                                                                                                                                0.634879,
                                                                                                                                                0, -0.772611,
                                                                                                                                                0.634879,
                                                                                                                                                0, -0.772611,
                                                                                                                                                0.634879,
                                                                                                                                                0, -0.669329,
                                                                                                                                                0.742966,
                                                                                                                                                0, -0.772611,
                                                                                                                                                0.634879,
                                                                                                                                                0, -0.772611,
                                                                                                                                                0.634879,
                                                                                                                                                0, -0.863834,
                                                                                                                                                0.503777,
                                                                                                                                                0, -0.863834,
                                                                                                                                                0.503777,
                                                                                                                                                0, -0.863834,
                                                                                                                                                0.503777,
                                                                                                                                                0, -0.772611,
                                                                                                                                                0.634879,
                                                                                                                                                0, -0.863834,
                                                                                                                                                0.503777,
                                                                                                                                                0, -0.863834,
                                                                                                                                                0.503777,
                                                                                                                                                0, -0.936439,
                                                                                                                                                0.35083,
                                                                                                                                                0, -0.936439,
                                                                                                                                                0.35083,
                                                                                                                                                0, -0.936439,
                                                                                                                                                0.35083,
                                                                                                                                                0, -0.863834,
                                                                                                                                                0.503777,
                                                                                                                                                0, -0.936439,
                                                                                                                                                0.35083,
                                                                                                                                                0, -0.936439,
                                                                                                                                                0.35083,
                                                                                                                                                0, -0.983602,
                                                                                                                                                0.180352,
                                                                                                                                                0, -0.983602,
                                                                                                                                                0.180352,
                                                                                                                                                0, -0.983602,
                                                                                                                                                0.180352,
                                                                                                                                                0, -0.936439,
                                                                                                                                                0.35083,
                                                                                                                                                0, -0.983602,
                                                                                                                                                0.180352,
                                                                                                                                                0, -0.983602,
                                                                                                                                                0.180352,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -0.983602,
                                                                                                                                                0.180352,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -0.983602, -0.180352,
                                                                                                                                                0, -0.983602, -0.180352,
                                                                                                                                                0, -0.983602, -0.180352,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -0.983602, -0.180352,
                                                                                                                                                0, -0.983602, -0.180352,
                                                                                                                                                0, -0.936439, -0.35083,
                                                                                                                                                0, -0.936439, -0.35083,
                                                                                                                                                0, -0.936439, -0.35083,
                                                                                                                                                0, -0.983602, -0.180352,
                                                                                                                                                0, -0.936439, -0.35083,
                                                                                                                                                0, -0.936439, -0.35083,
                                                                                                                                                0, -0.863834, -0.503777,
                                                                                                                                                0, -0.863834, -0.503777,
                                                                                                                                                0, -0.863834, -0.503777,
                                                                                                                                                0, -0.936439, -0.35083,
                                                                                                                                                0, -0.863834, -0.503777,
                                                                                                                                                0, -0.863834, -0.503777,
                                                                                                                                                0, -0.772611, -0.634879,
                                                                                                                                                0, -0.772611, -0.634879,
                                                                                                                                                0, -0.772611, -0.634879,
                                                                                                                                                0, -0.863834, -0.503777,
                                                                                                                                                0, -0.772611, -0.634879,
                                                                                                                                                0, -0.772611, -0.634879,
                                                                                                                                                0, -0.669329, -0.742966,
                                                                                                                                                0, -0.669329, -0.742966,
                                                                                                                                                0, -0.669329, -0.742966,
                                                                                                                                                0, -0.772611, -0.634879,
                                                                                                                                                0, -0.669329, -0.742966,
                                                                                                                                                0, -0.454459, -0.890768,
                                                                                                                                                0, -0.669329, -0.742966,
                                                                                                                                                0, -0.454459, -0.890768,
                                                                                                                                                0, -0.669329, -0.742966,
                                                                                                                                                0, -0.454459, -0.890768,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0, -0.140773, -0.990042,
                                                                                                                                                0, -0.278743, -0.960366,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0.022826, -0.458528,
                                                                                                                                                0.888387,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0.657324, -0.753608,
                                                                                                                                                0,
                                                                                                                                                0.407211, -0.913334,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.003472,
                                                                                                                                                0.999994,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976,
                                                                                                                                                0,
                                                                                                                                                0.006943,
                                                                                                                                                0.999976, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "uv": [-138.206188, -145.726002, -144.456188, -145.726002, -138.206188, -142.331828, -144.456188, -119.740424, -138.206188, -119.740424, -144.456188, -123.005267, -138.206188, -123.005267, -144.456188, -123.005267, -138.206188, -119.740424, -144.456188, -92.099018, -138.206188, -92.099018, -144.456188, -95.239957, -138.206188, -95.239957, -144.456188, -95.239957, -138.206188, -92.099018, -144.456188, -59.448543, -138.206188, -59.448543, -144.456188, -62.482476, -138.206188, -62.482476, -144.456188, -62.482476, -138.206188, -59.448543, -144.456188, -22.561848, -138.206188, -22.561848, -144.456188, -25.51675, -138.206188, -25.51675, -144.456188, -25.51675, -138.206188, -22.561848, -144.456188,
                                                                                                                                                16.874992, -138.206188,
                                                                                                                                                16.874992, -144.456188,
                                                                                                                                                13.962156, -138.206188,
                                                                                                                                                13.962156, -144.456188,
                                                                                                                                                13.962156, -138.206188,
                                                                                                                                                16.874992, -144.456188,
                                                                                                                                                56.424276, -138.206188,
                                                                                                                                                56.424276, -144.456188,
                                                                                                                                                53.51144, -138.206188,
                                                                                                                                                53.51144, -144.456188,
                                                                                                                                                53.51144, -138.206188,
                                                                                                                                                56.424276, -144.456188,
                                                                                                                                                93.463287, -138.206188,
                                                                                                                                                93.463287, -144.456188,
                                                                                                                                                90.508385, -138.206188,
                                                                                                                                                90.508385, -144.456188,
                                                                                                                                                90.508385, -138.206188,
                                                                                                                                                93.463287, -144.456188,
                                                                                                                                                125.887233, -138.206188,
                                                                                                                                                125.887233, -144.456188,
                                                                                                                                                122.8533, -138.206188,
                                                                                                                                                122.8533, -144.456188,
                                                                                                                                                122.8533, -138.206188,
                                                                                                                                                125.887233, -144.456188,
                                                                                                                                                152.538024, -138.206188,
                                                                                                                                                152.538024, -144.456188,
                                                                                                                                                149.397085, -138.206188,
                                                                                                                                                149.397085, -144.456188,
                                                                                                                                                149.397085, -138.206188,
                                                                                                                                                152.538024, -144.456188,
                                                                                                                                                173.189631, -138.206188,
                                                                                                                                                173.189631, -144.456188,
                                                                                                                                                169.924788, -138.206188,
                                                                                                                                                169.924788, -144.456188,
                                                                                                                                                169.924788, -138.206188,
                                                                                                                                                173.189631, -138.206188,
                                                                                                                                                188.246824, -138.206188,
                                                                                                                                                184.852651, -144.456188,
                                                                                                                                                188.246824,
                                                                                                                                                138.206188,
                                                                                                                                                36.195398,
                                                                                                                                                138.206188,
                                                                                                                                                40.516516,
                                                                                                                                                144.456188,
                                                                                                                                                36.195398,
                                                                                                                                                144.456188,
                                                                                                                                                40.516516,
                                                                                                                                                144.456188,
                                                                                                                                                36.195398,
                                                                                                                                                138.206188,
                                                                                                                                                40.516516, -144.456188, -49.371493, -144.456188, -11.324059, -144.296721, -17.725735, -144.296721, -17.725735, -144.456188, -11.324059, -144.296721, -14.975735, -144.296721, -14.975735, -144.456188, -11.324059, -141.323396, -20.422384, -141.323396, -20.422384, -144.456188, -11.324059, -138.350072, -14.975735, -138.206188, -11.324059, -138.350072, -14.975735, -144.456188, -11.324059, -138.350072, -14.975735, -138.206188, -11.324059, -138.350072, -17.725735, -138.206188, -11.324059, -138.206188, -49.371493, -138.350072, -17.725735,
                                                                                                                                                138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                138.206188,
                                                                                                                                                216.330819,
                                                                                                                                                144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                141.323396,
                                                                                                                                                215.025086,
                                                                                                                                                144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                144.296721,
                                                                                                                                                206.82824,
                                                                                                                                                144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                144.296721,
                                                                                                                                                206.82824,
                                                                                                                                                144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                144.296721,
                                                                                                                                                209.578306,
                                                                                                                                                144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                144.456188,
                                                                                                                                                216.330819, -144.456188, -142.331828, -138.206188, -142.331828, -144.456188, -145.726002, -144.456188,
                                                                                                                                                112.213607, -144.456188,
                                                                                                                                                216.136225, -138.206188,
                                                                                                                                                112.213607, -138.206188,
                                                                                                                                                216.136225, -138.206188,
                                                                                                                                                112.213607, -144.456188,
                                                                                                                                                216.136225, -138.206188,
                                                                                                                                                114.347958, -138.206188,
                                                                                                                                                49.724827, -144.456188,
                                                                                                                                                114.347958, -144.456188,
                                                                                                                                                49.724827, -144.456188,
                                                                                                                                                114.347958, -138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                144.456188, -8.137331,
                                                                                                                                                144.456188, -47.754023,
                                                                                                                                                138.206188, -8.137331,
                                                                                                                                                138.206188, -47.754023,
                                                                                                                                                138.206188, -8.137331,
                                                                                                                                                144.456188, -47.754023, -18.448396,
                                                                                                                                                49.724827, -18.448396,
                                                                                                                                                114.347958, -11.698396,
                                                                                                                                                49.724827, -11.698396,
                                                                                                                                                114.347958, -11.698396,
                                                                                                                                                49.724827, -18.448396,
                                                                                                                                                114.347958, -11.698396,
                                                                                                                                                112.213607, -18.448396,
                                                                                                                                                112.213607, -11.698396,
                                                                                                                                                216.136225, -18.448396,
                                                                                                                                                216.136225, -11.698396,
                                                                                                                                                216.136225, -18.448396,
                                                                                                                                                112.213607, -11.698396,
                                                                                                                                                184.852651, -18.448396,
                                                                                                                                                184.852651, -11.698396,
                                                                                                                                                188.246824, -18.448396,
                                                                                                                                                188.246824, -11.698396,
                                                                                                                                                188.246824, -18.448396,
                                                                                                                                                184.852651, -11.698396,
                                                                                                                                                169.924788, -18.448396,
                                                                                                                                                169.924788, -11.698396,
                                                                                                                                                173.189631, -18.448396,
                                                                                                                                                173.189631, -11.698396,
                                                                                                                                                173.189631, -18.448396,
                                                                                                                                                169.924788, -11.698396,
                                                                                                                                                149.397085, -18.448396,
                                                                                                                                                149.397085, -11.698396,
                                                                                                                                                152.538024, -18.448396,
                                                                                                                                                152.538024, -11.698396,
                                                                                                                                                152.538024, -18.448396,
                                                                                                                                                149.397085, -11.698396,
                                                                                                                                                122.8533, -18.448396,
                                                                                                                                                122.8533, -11.698396,
                                                                                                                                                125.887233, -18.448396,
                                                                                                                                                125.887233, -11.698396,
                                                                                                                                                125.887233, -18.448396,
                                                                                                                                                122.8533, -11.698396,
                                                                                                                                                90.508385, -18.448396,
                                                                                                                                                90.508385, -11.698396,
                                                                                                                                                93.463287, -18.448396,
                                                                                                                                                93.463287, -11.698396,
                                                                                                                                                93.463287, -18.448396,
                                                                                                                                                90.508385, -11.698396,
                                                                                                                                                53.51144, -18.448396,
                                                                                                                                                53.51144, -11.698396,
                                                                                                                                                56.424276, -18.448396,
                                                                                                                                                56.424276, -11.698396,
                                                                                                                                                56.424276, -18.448396,
                                                                                                                                                53.51144, -11.698396,
                                                                                                                                                13.962156, -18.448396,
                                                                                                                                                13.962156, -11.698396,
                                                                                                                                                16.874992, -18.448396,
                                                                                                                                                16.874992, -11.698396,
                                                                                                                                                16.874992, -18.448396,
                                                                                                                                                13.962156, -11.698396, -25.51675, -18.448396, -25.51675, -11.698396, -22.561848, -18.448396, -22.561848, -11.698396, -22.561848, -18.448396, -25.51675, -11.698396, -62.482476, -18.448396, -62.482476, -11.698396, -59.448543, -18.448396, -59.448543, -11.698396, -59.448543, -18.448396, -62.482476, -11.698396, -95.239957, -18.448396, -95.239957, -11.698396, -92.099018, -18.448396, -92.099018, -11.698396, -92.099018, -18.448396, -95.239957, -11.698396, -123.005267, -18.448396, -123.005267, -11.698396, -119.740424, -18.448396, -119.740424, -11.698396, -119.740424, -18.448396, -123.005267, -18.448396, -145.726002, -18.448396, -142.331828, -11.698396, -145.726002, -11.698396, -142.331828, -11.698396, -145.726002, -18.448396, -142.331828,
                                                                                                                                                11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                15.073396,
                                                                                                                                                215.025086,
                                                                                                                                                18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                18.046721,
                                                                                                                                                206.82824,
                                                                                                                                                18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                18.046721,
                                                                                                                                                206.82824,
                                                                                                                                                18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                18.046721,
                                                                                                                                                209.578306,
                                                                                                                                                18.448396,
                                                                                                                                                216.330819,
                                                                                                                                                18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                18.046721,
                                                                                                                                                62.07824,
                                                                                                                                                18.046721,
                                                                                                                                                62.07824,
                                                                                                                                                18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                15.073396,
                                                                                                                                                67.52502,
                                                                                                                                                15.073396,
                                                                                                                                                67.52502,
                                                                                                                                                18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                18.448396,
                                                                                                                                                49.724827,
                                                                                                                                                11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                12.100072,
                                                                                                                                                62.07824, -18.448396, -49.371493, -12.100072, -17.725735, -11.698396, -49.371493, -15.073396, -23.172384, -12.100072, -17.725735, -18.448396, -49.371493, -18.046721, -14.975735, -18.448396, -11.324059, -15.073396, -20.422384, -18.046721, -17.725735, -18.448396, -11.324059, -18.046721, -14.975735, -18.448396, -11.324059, -18.046721, -17.725735, -18.448396, -49.371493, -18.046721, -17.725735, -15.073396, -23.172384, -18.448396, -49.371493, -15.073396, -20.422384, -18.448396, -11.324059, -12.100072, -14.975735, -18.448396, -11.324059, -11.698396, -11.324059, -12.100072, -14.975735,
                                                                                                                                                18.448396,
                                                                                                                                                36.195398,
                                                                                                                                                11.698396,
                                                                                                                                                40.516516,
                                                                                                                                                18.448396,
                                                                                                                                                40.516516,
                                                                                                                                                10.811557,
                                                                                                                                                40.722038,
                                                                                                                                                10.558764,
                                                                                                                                                44.462528,
                                                                                                                                                17.597342,
                                                                                                                                                40.629386,
                                                                                                                                                17.570557,
                                                                                                                                                44.542252,
                                                                                                                                                11.00515,
                                                                                                                                                40.835685,
                                                                                                                                                10.784617,
                                                                                                                                                44.622745,
                                                                                                                                                17.179196,
                                                                                                                                                38.850921,
                                                                                                                                                10.306861,
                                                                                                                                                38.93201,
                                                                                                                                                16.658382,
                                                                                                                                                42.994202,
                                                                                                                                                17.149641,
                                                                                                                                                43.927588,
                                                                                                                                                10.614642,
                                                                                                                                                40.219364,
                                                                                                                                                10.277156,
                                                                                                                                                43.994741,
                                                                                                                                                17.111734,
                                                                                                                                                39.004584,
                                                                                                                                                10.134492,
                                                                                                                                                39.068916,
                                                                                                                                                16.537336,
                                                                                                                                                43.00093,
                                                                                                                                                17.093789,
                                                                                                                                                42.048211,
                                                                                                                                                10.452679,
                                                                                                                                                38.331991,
                                                                                                                                                10.11648,
                                                                                                                                                42.104936,
                                                                                                                                                17.217065,
                                                                                                                                                37.809896,
                                                                                                                                                10.144211,
                                                                                                                                                37.861744,
                                                                                                                                                16.717674,
                                                                                                                                                41.696351,
                                                                                                                                                17.205975,
                                                                                                                                                39.044639,
                                                                                                                                                10.375924,
                                                                                                                                                35.314569,
                                                                                                                                                10.133095,
                                                                                                                                                39.09285,
                                                                                                                                                17.341417,
                                                                                                                                                35.238459,
                                                                                                                                                10.202816,
                                                                                                                                                35.280675,
                                                                                                                                                17.008587,
                                                                                                                                                39.054863,
                                                                                                                                                17.334389,
                                                                                                                                                35.131177,
                                                                                                                                                10.284884,
                                                                                                                                                31.38802,
                                                                                                                                                10.195781,
                                                                                                                                                35.172098,
                                                                                                                                                17.389878,
                                                                                                                                                31.425532,
                                                                                                                                                10.227957,
                                                                                                                                                31.460003,
                                                                                                                                                17.274769,
                                                                                                                                                35.208226,
                                                                                                                                                17.385305,
                                                                                                                                                30.517355,
                                                                                                                                                10.13168,
                                                                                                                                                26.767762,
                                                                                                                                                10.223385,
                                                                                                                                                30.551778,
                                                                                                                                                17.329766,
                                                                                                                                                26.595009,
                                                                                                                                                10.191158,
                                                                                                                                                26.622974,
                                                                                                                                                17.442082,
                                                                                                                                                30.377787,
                                                                                                                                                17.32674,
                                                                                                                                                25.370414,
                                                                                                                                                9.921737,
                                                                                                                                                21.622185,
                                                                                                                                                10.188134,
                                                                                                                                                25.398877,
                                                                                                                                                17.190885,
                                                                                                                                                21.00885,
                                                                                                                                                10.118,
                                                                                                                                                21.031109,
                                                                                                                                                17.498495,
                                                                                                                                                24.827369,
                                                                                                                                                17.188889,
                                                                                                                                                19.823746,
                                                                                                                                                9.713676,
                                                                                                                                                16.080156,
                                                                                                                                                10.116007,
                                                                                                                                                19.846623,
                                                                                                                                                17.064684,
                                                                                                                                                14.964989,
                                                                                                                                                10.087351,
                                                                                                                                                14.981987,
                                                                                                                                                17.49381,
                                                                                                                                                18.859828,
                                                                                                                                                17.063411,
                                                                                                                                                14.013958,
                                                                                                                                                9.618096,
                                                                                                                                                10.270044,
                                                                                                                                                10.08608,
                                                                                                                                                14.031474,
                                                                                                                                                17.10035,
                                                                                                                                                8.808026,
                                                                                                                                                10.227793,
                                                                                                                                                8.819847,
                                                                                                                                                17.537712,
                                                                                                                                                12.821682,
                                                                                                                                                17.099586,
                                                                                                                                                8.122795,
                                                                                                                                                9.792261,
                                                                                                                                                4.366485,
                                                                                                                                                10.227029,
                                                                                                                                                8.134964,
                                                                                                                                                17.491914,
                                                                                                                                                2.902196,
                                                                                                                                                10.705801,
                                                                                                                                                2.908507,
                                                                                                                                                17.791793,
                                                                                                                                                7.067301,
                                                                                                                                                10.424166, -1.387502,
                                                                                                                                                10.705394,
                                                                                                                                                2.398846,
                                                                                                                                                17.491507,
                                                                                                                                                2.392345,
                                                                                                                                                11.698396, -8.137331,
                                                                                                                                                18.448396, -8.137331,
                                                                                                                                                11.698396, -47.754023,
                                                                                                                                                11.698396, -2.438624,
                                                                                                                                                18.448396,
                                                                                                                                                1.882495,
                                                                                                                                                18.448396, -2.438624,
                                                                                                                                                138.206188,
                                                                                                                                                40.580881,
                                                                                                                                                144.456188,
                                                                                                                                                40.580881,
                                                                                                                                                138.206188,
                                                                                                                                                36.404995,
                                                                                                                                                144.456188,
                                                                                                                                                36.404995,
                                                                                                                                                138.206188,
                                                                                                                                                36.404995,
                                                                                                                                                144.456188,
                                                                                                                                                40.580881,
                                                                                                                                                138.206188,
                                                                                                                                                40.210778,
                                                                                                                                                144.456188,
                                                                                                                                                40.210778,
                                                                                                                                                138.206188,
                                                                                                                                                36.173363,
                                                                                                                                                144.456188,
                                                                                                                                                36.173363,
                                                                                                                                                138.206188,
                                                                                                                                                36.173363,
                                                                                                                                                144.456188,
                                                                                                                                                40.210778,
                                                                                                                                                138.206188,
                                                                                                                                                39.225703,
                                                                                                                                                144.456188,
                                                                                                                                                39.225703,
                                                                                                                                                138.206188,
                                                                                                                                                35.307296,
                                                                                                                                                144.456188,
                                                                                                                                                35.307296,
                                                                                                                                                138.206188,
                                                                                                                                                35.307296,
                                                                                                                                                144.456188,
                                                                                                                                                39.225703,
                                                                                                                                                138.206188,
                                                                                                                                                37.429473,
                                                                                                                                                144.456188,
                                                                                                                                                37.429473,
                                                                                                                                                138.206188,
                                                                                                                                                33.598583,
                                                                                                                                                144.456188,
                                                                                                                                                33.598583,
                                                                                                                                                138.206188,
                                                                                                                                                33.598583,
                                                                                                                                                144.456188,
                                                                                                                                                37.429473,
                                                                                                                                                138.206188,
                                                                                                                                                34.666503,
                                                                                                                                                144.456188,
                                                                                                                                                34.666503,
                                                                                                                                                138.206188,
                                                                                                                                                30.882057,
                                                                                                                                                144.456188,
                                                                                                                                                30.882057,
                                                                                                                                                138.206188,
                                                                                                                                                30.882057,
                                                                                                                                                144.456188,
                                                                                                                                                34.666503,
                                                                                                                                                138.206188,
                                                                                                                                                30.882057,
                                                                                                                                                144.456188,
                                                                                                                                                30.882057,
                                                                                                                                                138.206188,
                                                                                                                                                27.097612,
                                                                                                                                                144.456188,
                                                                                                                                                27.097612,
                                                                                                                                                138.206188,
                                                                                                                                                27.097612,
                                                                                                                                                144.456188,
                                                                                                                                                30.882057,
                                                                                                                                                138.206188,
                                                                                                                                                26.152285,
                                                                                                                                                144.456188,
                                                                                                                                                26.152285,
                                                                                                                                                138.206188,
                                                                                                                                                22.321395,
                                                                                                                                                144.456188,
                                                                                                                                                22.321395,
                                                                                                                                                138.206188,
                                                                                                                                                22.321395,
                                                                                                                                                144.456188,
                                                                                                                                                26.152285,
                                                                                                                                                138.206188,
                                                                                                                                                20.662233,
                                                                                                                                                144.456188,
                                                                                                                                                20.662233,
                                                                                                                                                138.206188,
                                                                                                                                                16.743825,
                                                                                                                                                144.456188,
                                                                                                                                                16.743825,
                                                                                                                                                138.206188,
                                                                                                                                                16.743825,
                                                                                                                                                144.456188,
                                                                                                                                                20.662233,
                                                                                                                                                138.206188,
                                                                                                                                                14.646043,
                                                                                                                                                144.456188,
                                                                                                                                                14.646043,
                                                                                                                                                138.206188,
                                                                                                                                                10.608629,
                                                                                                                                                144.456188,
                                                                                                                                                10.608629,
                                                                                                                                                138.206188,
                                                                                                                                                10.608629,
                                                                                                                                                144.456188,
                                                                                                                                                14.646043,
                                                                                                                                                138.206188,
                                                                                                                                                8.326721,
                                                                                                                                                144.456188,
                                                                                                                                                8.326721,
                                                                                                                                                138.206188,
                                                                                                                                                4.150835,
                                                                                                                                                144.456188,
                                                                                                                                                4.150835,
                                                                                                                                                138.206188,
                                                                                                                                                4.150835,
                                                                                                                                                144.456188,
                                                                                                                                                8.326721,
                                                                                                                                                144.456188,
                                                                                                                                                1.882495,
                                                                                                                                                144.456188, -2.438624,
                                                                                                                                                138.206188,
                                                                                                                                                1.882495,
                                                                                                                                                138.206188, -2.438624,
                                                                                                                                                138.206188,
                                                                                                                                                1.882495,
                                                                                                                                                144.456188, -2.438624,
                                                                                                                                                18.448396, -47.754023,
                                                                                                                                                11.698396, -47.754023,
                                                                                                                                                18.448396, -8.137331, -11.698396, -49.371493, -12.100072, -14.975735, -11.698396, -11.324059, -12.100072, -14.975735, -11.698396, -49.371493, -12.100072, -17.725735,
                                                                                                                                                11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                12.100072,
                                                                                                                                                62.07824,
                                                                                                                                                11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                12.100072,
                                                                                                                                                110.32824,
                                                                                                                                                15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                12.100072,
                                                                                                                                                110.32824,
                                                                                                                                                12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                12.100072,
                                                                                                                                                64.828306,
                                                                                                                                                11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                12.100072,
                                                                                                                                                110.32824,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                18.046721,
                                                                                                                                                110.32824,
                                                                                                                                                18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                18.046721,
                                                                                                                                                110.32824,
                                                                                                                                                18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                15.073396,
                                                                                                                                                118.525086,
                                                                                                                                                12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                12.100072,
                                                                                                                                                113.078306,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                12.100072,
                                                                                                                                                158.07824,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                15.073396,
                                                                                                                                                163.52502,
                                                                                                                                                18.046721,
                                                                                                                                                158.07824,
                                                                                                                                                18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                18.046721,
                                                                                                                                                113.078306,
                                                                                                                                                18.046721,
                                                                                                                                                160.828306,
                                                                                                                                                15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                15.073396,
                                                                                                                                                212.27502,
                                                                                                                                                15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                12.100072,
                                                                                                                                                206.82824,
                                                                                                                                                12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                12.100072,
                                                                                                                                                206.82824,
                                                                                                                                                15.073396,
                                                                                                                                                166.275086,
                                                                                                                                                12.100072,
                                                                                                                                                206.82824,
                                                                                                                                                12.100072,
                                                                                                                                                160.828306,
                                                                                                                                                12.100072,
                                                                                                                                                209.578306,
                                                                                                                                                18.046721,
                                                                                                                                                64.828306,
                                                                                                                                                15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                15.073396,
                                                                                                                                                115.77502,
                                                                                                                                                15.073396,
                                                                                                                                                70.275086,
                                                                                                                                                12.100072,
                                                                                                                                                110.32824, -144.456188,
                                                                                                                                                184.852651, -144.456188,
                                                                                                                                                188.246824, -138.206188,
                                                                                                                                                184.852651,
                                                                                                                                                144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                144.296721,
                                                                                                                                                62.07824,
                                                                                                                                                144.296721,
                                                                                                                                                62.07824,
                                                                                                                                                144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                141.323396,
                                                                                                                                                67.52502,
                                                                                                                                                144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                138.206188,
                                                                                                                                                49.724827,
                                                                                                                                                138.350072,
                                                                                                                                                62.07824, -144.456188, -49.371493, -138.350072, -17.725735, -138.206188, -49.371493, -141.323396, -23.172384, -138.350072, -17.725735, -144.456188, -49.371493, -144.296721, -17.725735, -141.323396, -23.172384, -144.456188, -49.371493,
                                                                                                                                                138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                138.350072,
                                                                                                                                                62.07824,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                138.350072,
                                                                                                                                                64.828306,
                                                                                                                                                138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                141.323396,
                                                                                                                                                70.275086,
                                                                                                                                                141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                144.296721,
                                                                                                                                                110.32824,
                                                                                                                                                144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                141.323396,
                                                                                                                                                115.77502,
                                                                                                                                                144.296721,
                                                                                                                                                110.32824,
                                                                                                                                                144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                138.350072,
                                                                                                                                                110.32824,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                138.350072,
                                                                                                                                                113.078306,
                                                                                                                                                138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                141.323396,
                                                                                                                                                118.525086,
                                                                                                                                                141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                141.323396,
                                                                                                                                                163.52502,
                                                                                                                                                144.296721,
                                                                                                                                                158.07824,
                                                                                                                                                144.296721,
                                                                                                                                                64.828306,
                                                                                                                                                144.296721,
                                                                                                                                                113.078306,
                                                                                                                                                138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                138.350072,
                                                                                                                                                158.07824,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                138.350072,
                                                                                                                                                206.82824,
                                                                                                                                                138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                138.350072,
                                                                                                                                                209.578306,
                                                                                                                                                138.350072,
                                                                                                                                                160.828306,
                                                                                                                                                138.350072,
                                                                                                                                                206.82824,
                                                                                                                                                141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                138.350072,
                                                                                                                                                206.82824,
                                                                                                                                                144.296721,
                                                                                                                                                160.828306,
                                                                                                                                                141.323396,
                                                                                                                                                166.275086,
                                                                                                                                                141.323396,
                                                                                                                                                212.27502,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "indices": [
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                2,
                                                                                                                                                3,
                                                                                                                                                4,
                                                                                                                                                5,
                                                                                                                                                6,
                                                                                                                                                7,
                                                                                                                                                8,
                                                                                                                                                9,
                                                                                                                                                10,
                                                                                                                                                11,
                                                                                                                                                12,
                                                                                                                                                13,
                                                                                                                                                14,
                                                                                                                                                15,
                                                                                                                                                16,
                                                                                                                                                17,
                                                                                                                                                18,
                                                                                                                                                19,
                                                                                                                                                20,
                                                                                                                                                21,
                                                                                                                                                22,
                                                                                                                                                23,
                                                                                                                                                24,
                                                                                                                                                25,
                                                                                                                                                26,
                                                                                                                                                27,
                                                                                                                                                28,
                                                                                                                                                29,
                                                                                                                                                30,
                                                                                                                                                31,
                                                                                                                                                32,
                                                                                                                                                33,
                                                                                                                                                34,
                                                                                                                                                35,
                                                                                                                                                36,
                                                                                                                                                37,
                                                                                                                                                38,
                                                                                                                                                39,
                                                                                                                                                40,
                                                                                                                                                41,
                                                                                                                                                42,
                                                                                                                                                43,
                                                                                                                                                44,
                                                                                                                                                45,
                                                                                                                                                46,
                                                                                                                                                47,
                                                                                                                                                48,
                                                                                                                                                49,
                                                                                                                                                50,
                                                                                                                                                51,
                                                                                                                                                52,
                                                                                                                                                53,
                                                                                                                                                54,
                                                                                                                                                55,
                                                                                                                                                56,
                                                                                                                                                57,
                                                                                                                                                58,
                                                                                                                                                59,
                                                                                                                                                60,
                                                                                                                                                61,
                                                                                                                                                62,
                                                                                                                                                63,
                                                                                                                                                64,
                                                                                                                                                65,
                                                                                                                                                66,
                                                                                                                                                67,
                                                                                                                                                68,
                                                                                                                                                69,
                                                                                                                                                70,
                                                                                                                                                71,
                                                                                                                                                72,
                                                                                                                                                73,
                                                                                                                                                74,
                                                                                                                                                75,
                                                                                                                                                76,
                                                                                                                                                77,
                                                                                                                                                78,
                                                                                                                                                79,
                                                                                                                                                80,
                                                                                                                                                81,
                                                                                                                                                82,
                                                                                                                                                83,
                                                                                                                                                84,
                                                                                                                                                85,
                                                                                                                                                86,
                                                                                                                                                87,
                                                                                                                                                88,
                                                                                                                                                89,
                                                                                                                                                90,
                                                                                                                                                91,
                                                                                                                                                92,
                                                                                                                                                93,
                                                                                                                                                94,
                                                                                                                                                95,
                                                                                                                                                96,
                                                                                                                                                97,
                                                                                                                                                98,
                                                                                                                                                99,
                                                                                                                                                100,
                                                                                                                                                101,
                                                                                                                                                102,
                                                                                                                                                103,
                                                                                                                                                104,
                                                                                                                                                105,
                                                                                                                                                106,
                                                                                                                                                107,
                                                                                                                                                108,
                                                                                                                                                109,
                                                                                                                                                110,
                                                                                                                                                111,
                                                                                                                                                112,
                                                                                                                                                113,
                                                                                                                                                114,
                                                                                                                                                115,
                                                                                                                                                116,
                                                                                                                                                117,
                                                                                                                                                118,
                                                                                                                                                119,
                                                                                                                                                120,
                                                                                                                                                121,
                                                                                                                                                122,
                                                                                                                                                123,
                                                                                                                                                124,
                                                                                                                                                125,
                                                                                                                                                126,
                                                                                                                                                127,
                                                                                                                                                128,
                                                                                                                                                129,
                                                                                                                                                130,
                                                                                                                                                131,
                                                                                                                                                132,
                                                                                                                                                133,
                                                                                                                                                134,
                                                                                                                                                135,
                                                                                                                                                136,
                                                                                                                                                137,
                                                                                                                                                138,
                                                                                                                                                139,
                                                                                                                                                140,
                                                                                                                                                141,
                                                                                                                                                142,
                                                                                                                                                143,
                                                                                                                                                144,
                                                                                                                                                145,
                                                                                                                                                146,
                                                                                                                                                147,
                                                                                                                                                148,
                                                                                                                                                149,
                                                                                                                                                150,
                                                                                                                                                151,
                                                                                                                                                152,
                                                                                                                                                153,
                                                                                                                                                154,
                                                                                                                                                155,
                                                                                                                                                156,
                                                                                                                                                157,
                                                                                                                                                158,
                                                                                                                                                159,
                                                                                                                                                160,
                                                                                                                                                161,
                                                                                                                                                162,
                                                                                                                                                163,
                                                                                                                                                164,
                                                                                                                                                165,
                                                                                                                                                166,
                                                                                                                                                167,
                                                                                                                                                168,
                                                                                                                                                169,
                                                                                                                                                170,
                                                                                                                                                171,
                                                                                                                                                172,
                                                                                                                                                173,
                                                                                                                                                174,
                                                                                                                                                175,
                                                                                                                                                176,
                                                                                                                                                177,
                                                                                                                                                178,
                                                                                                                                                179,
                                                                                                                                                180,
                                                                                                                                                181,
                                                                                                                                                182,
                                                                                                                                                183,
                                                                                                                                                184,
                                                                                                                                                185,
                                                                                                                                                186,
                                                                                                                                                187,
                                                                                                                                                188,
                                                                                                                                                189,
                                                                                                                                                190,
                                                                                                                                                191,
                                                                                                                                                192,
                                                                                                                                                193,
                                                                                                                                                194,
                                                                                                                                                195,
                                                                                                                                                196,
                                                                                                                                                197,
                                                                                                                                                198,
                                                                                                                                                199,
                                                                                                                                                200,
                                                                                                                                                201,
                                                                                                                                                202,
                                                                                                                                                203,
                                                                                                                                                204,
                                                                                                                                                205,
                                                                                                                                                206,
                                                                                                                                                207,
                                                                                                                                                208,
                                                                                                                                                209,
                                                                                                                                                210,
                                                                                                                                                211,
                                                                                                                                                212,
                                                                                                                                                213,
                                                                                                                                                214,
                                                                                                                                                215,
                                                                                                                                                216,
                                                                                                                                                217,
                                                                                                                                                218,
                                                                                                                                                219,
                                                                                                                                                220,
                                                                                                                                                221,
                                                                                                                                                222,
                                                                                                                                                223,
                                                                                                                                                224,
                                                                                                                                                225,
                                                                                                                                                226,
                                                                                                                                                227,
                                                                                                                                                228,
                                                                                                                                                229,
                                                                                                                                                230,
                                                                                                                                                231,
                                                                                                                                                232,
                                                                                                                                                233,
                                                                                                                                                234,
                                                                                                                                                235,
                                                                                                                                                236,
                                                                                                                                                237,
                                                                                                                                                238,
                                                                                                                                                239,
                                                                                                                                                240,
                                                                                                                                                241,
                                                                                                                                                242,
                                                                                                                                                243,
                                                                                                                                                244,
                                                                                                                                                245,
                                                                                                                                                246,
                                                                                                                                                247,
                                                                                                                                                248,
                                                                                                                                                249,
                                                                                                                                                250,
                                                                                                                                                251,
                                                                                                                                                252,
                                                                                                                                                253,
                                                                                                                                                254,
                                                                                                                                                255,
                                                                                                                                                256,
                                                                                                                                                257,
                                                                                                                                                258,
                                                                                                                                                259,
                                                                                                                                                260,
                                                                                                                                                261,
                                                                                                                                                262,
                                                                                                                                                263,
                                                                                                                                                264,
                                                                                                                                                265,
                                                                                                                                                266,
                                                                                                                                                267,
                                                                                                                                                268,
                                                                                                                                                269,
                                                                                                                                                270,
                                                                                                                                                271,
                                                                                                                                                272,
                                                                                                                                                273,
                                                                                                                                                274,
                                                                                                                                                275,
                                                                                                                                                276,
                                                                                                                                                277,
                                                                                                                                                278,
                                                                                                                                                279,
                                                                                                                                                280,
                                                                                                                                                281,
                                                                                                                                                282,
                                                                                                                                                283,
                                                                                                                                                284,
                                                                                                                                                285,
                                                                                                                                                286,
                                                                                                                                                287,
                                                                                                                                                288,
                                                                                                                                                289,
                                                                                                                                                290,
                                                                                                                                                291,
                                                                                                                                                292,
                                                                                                                                                293,
                                                                                                                                                294,
                                                                                                                                                295,
                                                                                                                                                296,
                                                                                                                                                297,
                                                                                                                                                298,
                                                                                                                                                299,
                                                                                                                                                300,
                                                                                                                                                301,
                                                                                                                                                302,
                                                                                                                                                303,
                                                                                                                                                304,
                                                                                                                                                305,
                                                                                                                                                306,
                                                                                                                                                307,
                                                                                                                                                308,
                                                                                                                                                309,
                                                                                                                                                310,
                                                                                                                                                311,
                                                                                                                                                312,
                                                                                                                                                313,
                                                                                                                                                314,
                                                                                                                                                315,
                                                                                                                                                316,
                                                                                                                                                317,
                                                                                                                                                318,
                                                                                                                                                319,
                                                                                                                                                320,
                                                                                                                                                321,
                                                                                                                                                322,
                                                                                                                                                323,
                                                                                                                                                324,
                                                                                                                                                325,
                                                                                                                                                326,
                                                                                                                                                327,
                                                                                                                                                328,
                                                                                                                                                329,
                                                                                                                                                330,
                                                                                                                                                331,
                                                                                                                                                332,
                                                                                                                                                333,
                                                                                                                                                334,
                                                                                                                                                335,
                                                                                                                                                336,
                                                                                                                                                337,
                                                                                                                                                338,
                                                                                                                                                339,
                                                                                                                                                340,
                                                                                                                                                341,
                                                                                                                                                342,
                                                                                                                                                343,
                                                                                                                                                344,
                                                                                                                                                345,
                                                                                                                                                346,
                                                                                                                                                347,
                                                                                                                                                348,
                                                                                                                                                349,
                                                                                                                                                350,
                                                                                                                                                351,
                                                                                                                                                352,
                                                                                                                                                353,
                                                                                                                                                354,
                                                                                                                                                355,
                                                                                                                                                356,
                                                                                                                                                357,
                                                                                                                                                358,
                                                                                                                                                359,
                                                                                                                                                360,
                                                                                                                                                361,
                                                                                                                                                362,
                                                                                                                                                363,
                                                                                                                                                364,
                                                                                                                                                365,
                                                                                                                                                366,
                                                                                                                                                367,
                                                                                                                                                368,
                                                                                                                                                369,
                                                                                                                                                370,
                                                                                                                                                371,
                                                                                                                                                372,
                                                                                                                                                373,
                                                                                                                                                374,
                                                                                                                                                375,
                                                                                                                                                376,
                                                                                                                                                377,
                                                                                                                                                378,
                                                                                                                                                379,
                                                                                                                                                380,
                                                                                                                                                381,
                                                                                                                                                382,
                                                                                                                                                383,
                                                                                                                                                384,
                                                                                                                                                385,
                                                                                                                                                386,
                                                                                                                                                387,
                                                                                                                                                388,
                                                                                                                                                389,
                                                                                                                                                390,
                                                                                                                                                391,
                                                                                                                                                392,
                                                                                                                                                393,
                                                                                                                                                394,
                                                                                                                                                395,
                                                                                                                                                396,
                                                                                                                                                397,
                                                                                                                                                398,
                                                                                                                                                399,
                                                                                                                                                400,
                                                                                                                                                401,
                                                                                                                                                402,
                                                                                                                                                403,
                                                                                                                                                404,
                                                                                                                                                405,
                                                                                                                                                406,
                                                                                                                                                407,
                                                                                                                                                408,
                                                                                                                                                409,
                                                                                                                                                410,
                                                                                                                                                411,
                                                                                                                                                412,
                                                                                                                                                413,
                                                                                                                                                414,
                                                                                                                                                415,
                                                                                                                                                416,
                                                                                                                                                417,
                                                                                                                                                418,
                                                                                                                                                419,
                                                                                                                                                420,
                                                                                                                                                421,
                                                                                                                                                422,
                                                                                                                                                423,
                                                                                                                                                424,
                                                                                                                                                425,
                                                                                                                                                426,
                                                                                                                                                427,
                                                                                                                                                428,
                                                                                                                                                429,
                                                                                                                                                430,
                                                                                                                                                431,
                                                                                                                                                432,
                                                                                                                                                433,
                                                                                                                                                434,
                                                                                                                                                435,
                                                                                                                                                436,
                                                                                                                                                437,
                                                                                                                                                438,
                                                                                                                                                439,
                                                                                                                                                440,
                                                                                                                                                441,
                                                                                                                                                442,
                                                                                                                                                443,
                                                                                                                                                444,
                                                                                                                                                445,
                                                                                                                                                446,
                                                                                                                                                447,
                                                                                                                                                448,
                                                                                                                                                449,
                                                                                                                                                450,
                                                                                                                                                451,
                                                                                                                                                452,
                                                                                                                                                453,
                                                                                                                                                454,
                                                                                                                                                455,
                                                                                                                                                456,
                                                                                                                                                457,
                                                                                                                                                458,
                                                                                                                                                459,
                                                                                                                                                460,
                                                                                                                                                461,
                                                                                                                                                462,
                                                                                                                                                463,
                                                                                                                                                464,
                                                                                                                                                465,
                                                                                                                                                466,
                                                                                                                                                467,
                                                                                                                                                468,
                                                                                                                                                469,
                                                                                                                                                470,
                                                                                                                                                471,
                                                                                                                                                472,
                                                                                                                                                473,
                                                                                                                                                474,
                                                                                                                                                475,
                                                                                                                                                476,
                                                                                                                                                477,
                                                                                                                                                478,
                                                                                                                                                479,
                                                                                                                                                480,
                                                                                                                                                481,
                                                                                                                                                482,
                                                                                                                                                483,
                                                                                                                                                484,
                                                                                                                                                485,
                                                                                                                                                486,
                                                                                                                                                487,
                                                                                                                                                488,
                                                                                                                                                489,
                                                                                                                                                490,
                                                                                                                                                491,
                                                                                                                                                492,
                                                                                                                                                493,
                                                                                                                                                494,
                                                                                                                                                495,
                                                                                                                                                496,
                                                                                                                                                497,
                                                                                                                                                498,
                                                                                                                                                499,
                                                                                                                                                500,
                                                                                                                                                501,
                                                                                                                                                502,
                                                                                                                                                503,
                                                                                                                                                504,
                                                                                                                                                505,
                                                                                                                                                506,
                                                                                                                                                507,
                                                                                                                                                508,
                                                                                                                                                509,
                                                                                                                                                510,
                                                                                                                                                511,
                                                                                                                                                512,
                                                                                                                                                513,
                                                                                                                                                514,
                                                                                                                                                515,
                                                                                                                                                516,
                                                                                                                                                517,
                                                                                                                                                518,
                                                                                                                                                519,
                                                                                                                                                520,
                                                                                                                                                521,
                                                                                                                                                522,
                                                                                                                                                523,
                                                                                                                                                524,
                                                                                                                                                525,
                                                                                                                                                526,
                                                                                                                                                527,
                                                                                                                                                528,
                                                                                                                                                529,
                                                                                                                                                530,
                                                                                                                                                531,
                                                                                                                                                532,
                                                                                                                                                533,
                                                                                                                                                534,
                                                                                                                                                535,
                                                                                                                                                536,
                                                                                                                                                537,
                                                                                                                                                538,
                                                                                                                                                539,
                                                                                                                                                540,
                                                                                                                                                541,
                                                                                                                                                542,
                                                                                                                                                543,
                                                                                                                                                544,
                                                                                                                                                545,
                                                                                                                                                546,
                                                                                                                                                547,
                                                                                                                                                548,
                                                                                                                                                549,
                                                                                                                                                550,
                                                                                                                                                551,
                                                                                                                                                552,
                                                                                                                                                553,
                                                                                                                                                554,
                                                                                                                                                555,
                                                                                                                                                556,
                                                                                                                                                557,
                                                                                                                                                558,
                                                                                                                                                559,
                                                                                                                                                560,
                                                                                                                                                561,
                                                                                                                                                562,
                                                                                                                                                563,
                                                                                                                                                564,
                                                                                                                                                565,
                                                                                                                                                566,
                                                                                                                                                567,
                                                                                                                                                568,
                                                                                                                                                569,
                                                                                                                                                570,
                                                                                                                                                571,
                                                                                                                                                572,
                                                                                                                                                573,
                                                                                                                                                574,
                                                                                                                                                575,
                                                                                                                                                576,
                                                                                                                                                577,
                                                                                                                                                578,
                                                                                                                                                579,
                                                                                                                                                580,
                                                                                                                                                581,
                                                                                                                                                582,
                                                                                                                                                583,
                                                                                                                                                584,
                                                                                                                                                585,
                                                                                                                                                586,
                                                                                                                                                587,
                                                                                                                                                588,
                                                                                                                                                589,
                                                                                                                                                590,
                                                                                                                                                591,
                                                                                                                                                592,
                                                                                                                                                593,
                                                                                                                                                594
                                                                                                                                            ]
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                }, {
                                                                                                                                    "type": "material",
                                                                                                                                    "baseColor": {
                                                                                                                                        "r": 0.286275,
                                                                                                                                        "g": 0.27451,
                                                                                                                                        "b": 0.298039
                                                                                                                                    },
                                                                                                                                    "specularColor": {
                                                                                                                                        "r": 0.33,
                                                                                                                                        "g": 0.33,
                                                                                                                                        "b": 0.33,
                                                                                                                                        "a": 1
                                                                                                                                    },
                                                                                                                                    "shine": 10,
                                                                                                                                    "specular": 1,
                                                                                                                                    "nodes": [{
                                                                                                                                            "type": "geometry",
                                                                                                                                            "positions": [-144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -145.812041,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -145.812041,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -145.812041,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -145.812041,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -145.812041,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -145.812041,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -149.098409,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -144.456188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -149.098409,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -144.456188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -149.098409,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -144.456188,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -144.456188,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -145.812041,
                                                                                                                                                218.679224,
                                                                                                                                                27.946354, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -145.812041,
                                                                                                                                                218.679224,
                                                                                                                                                27.946354, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                0, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                0, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -7.056176,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -3.657834,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -7.056176,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -7.056176,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -3.657834,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -3.657834,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -7.056176,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -3.657834,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -7.056176,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -7.056176,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -3.657834,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -3.657834,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -2.413955,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -3.657834,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -2.413955,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -3.657834,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -2.413955,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -2.413955,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -2.413955,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -2.413955,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -2.413955,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -3.895217,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -4.602447,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -5.764868,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -7.358391,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -3.657834,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621,
                                                                                                                                                0,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -3.657834,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621,
                                                                                                                                                0,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -2.413955,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691,
                                                                                                                                                0,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -2.413955,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -2.413955,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -2.413955,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -2.413955,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -2.413955,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -2.413955,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -2.413955,
                                                                                                                                                114.347958,
                                                                                                                                                30.59,
                                                                                                                                                0,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994,
                                                                                                                                                0,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138,
                                                                                                                                                0,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -3.657834,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -3.895217,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -0.345374,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -4.846948,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -6.686989,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -6.686989,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -6.686989,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -4.846948,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -3.5047,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -1.374339,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -4.602447,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -5.764868,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -4.846948,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -3.065572,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -5.384023,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                48.39039, -10.342544,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                48.39039, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                45.373466, -10.342544,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -10.342544,
                                                                                                                                                9.329905,
                                                                                                                                                21.338287, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                13.700341, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                13.700341, -10.342544,
                                                                                                                                                9.329905,
                                                                                                                                                21.338287, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                16.717266, -11.698396,
                                                                                                                                                8.966606,
                                                                                                                                                13.700341, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                16.717266, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                20.031118, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                16.717266, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                20.031118, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                23.573223, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                20.031118, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                23.573223, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                27.270177, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                23.573223, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -11.698396,
                                                                                                                                                2.393869,
                                                                                                                                                31.045366, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                27.270177, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -11.698396,
                                                                                                                                                2.393869,
                                                                                                                                                31.045366, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -7.056176,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -11.698396,
                                                                                                                                                2.393869,
                                                                                                                                                31.045366, -7.056176,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                34.820555, -11.698396,
                                                                                                                                                2.393869,
                                                                                                                                                31.045366, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                34.820555, -7.193229,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                38.517509, -11.698396,
                                                                                                                                                2.667976,
                                                                                                                                                34.820555, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                38.517509, -7.601548,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                42.059614, -11.698396,
                                                                                                                                                3.484615,
                                                                                                                                                38.517509, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -11.698396,
                                                                                                                                                4.826863,
                                                                                                                                                42.059614, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                45.373466, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                45.373466, -8.272672,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -11.698396,
                                                                                                                                                6.666904,
                                                                                                                                                45.373466, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -10.342544,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -10.342544,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -10.342544,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                50.979179, -10.342544,
                                                                                                                                                9.329905,
                                                                                                                                                21.338287, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -9.192693,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -10.342544,
                                                                                                                                                9.329905,
                                                                                                                                                21.338287, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -9.349991,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -8.986691,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -11.698396,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -145.812041,
                                                                                                                                                9.329905,
                                                                                                                                                21.338287, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -145.812041,
                                                                                                                                                9.329905,
                                                                                                                                                21.338287, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                13.695779, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                16.707523, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                20.015685, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                23.551709, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -149.098409,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                27.242316, -144.456188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -149.098409,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -149.098409,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -144.456188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -144.456188,
                                                                                                                                                0,
                                                                                                                                                31.011023, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -144.456188,
                                                                                                                                                0.344781,
                                                                                                                                                34.77973, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -144.456188,
                                                                                                                                                1.37198,
                                                                                                                                                38.470336, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -144.456188,
                                                                                                                                                3.060308,
                                                                                                                                                42.00636, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -145.812041,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -144.456188,
                                                                                                                                                5.374779,
                                                                                                                                                45.314522, -144.456188,
                                                                                                                                                8.267429,
                                                                                                                                                48.326267, -145.812041,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -145.812041,
                                                                                                                                                9.329905,
                                                                                                                                                48.870072, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                46.475687, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                43.845646, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                41.034451, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                38.100361, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -149.098409,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -152.49675,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -149.098409,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -149.098409,
                                                                                                                                                3.637749,
                                                                                                                                                35.104179, -152.49675,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -152.49675,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -148.961355,
                                                                                                                                                3.875132,
                                                                                                                                                32.107998, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -148.553036,
                                                                                                                                                4.582362,
                                                                                                                                                29.173907, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -147.881912,
                                                                                                                                                5.744783,
                                                                                                                                                26.362713, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                23.732671, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                26.362713, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                29.173907, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -153.740629,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -152.49675,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -153.740629,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                32.107998, -152.49675,
                                                                                                                                                7.03609,
                                                                                                                                                35.104179, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -153.740629,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -153.740629,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -153.740629,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -152.259367,
                                                                                                                                                7.173143,
                                                                                                                                                38.100361, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -151.552137,
                                                                                                                                                7.581463,
                                                                                                                                                41.034451, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -150.389716,
                                                                                                                                                8.252587,
                                                                                                                                                43.845646, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                43.845646, -148.796194,
                                                                                                                                                9.172607,
                                                                                                                                                46.475687, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                48.870072, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -144.456188,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                48.870072, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                46.475687, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                48.04125, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                45.005849, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                48.673661, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -145.812041,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                49.094889, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                47.255643, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                46.356211, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                41.034451, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                38.107904, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                43.810676, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                45.235378, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -152.49675,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -149.098409,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -152.49675,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -152.49675,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -149.098409,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -149.098409,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -148.961355,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -148.553036,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -147.167893,
                                                                                                                                                11.678311,
                                                                                                                                                21.338287, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                16.174151, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -149.467595,
                                                                                                                                                114.347958,
                                                                                                                                                16.174151, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -153.089012,
                                                                                                                                                216.330819,
                                                                                                                                                26.88949, -150.389716,
                                                                                                                                                219.756543,
                                                                                                                                                31.805865, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -150.770561,
                                                                                                                                                216.330819,
                                                                                                                                                24.343955, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -147.167893,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -144.456188,
                                                                                                                                                114.347958,
                                                                                                                                                0, -147.167893,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -146.804593,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -147.872936,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -148.796194,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -145.812041,
                                                                                                                                                9.329905,
                                                                                                                                                21.338287, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -144.456188,
                                                                                                                                                11.678311,
                                                                                                                                                11.042866, -145.812041,
                                                                                                                                                9.329905,
                                                                                                                                                21.338287, -146.961891,
                                                                                                                                                7.338305,
                                                                                                                                                23.732671, -146.804593,
                                                                                                                                                10.322458,
                                                                                                                                                21.338287, -149.467595,
                                                                                                                                                11.678311,
                                                                                                                                                23.732671, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -151.307636,
                                                                                                                                                11.678311,
                                                                                                                                                26.362713, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -152.649884,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -153.740629,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -153.466523,
                                                                                                                                                11.678311,
                                                                                                                                                32.107998, -153.740629,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -153.740629,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -153.740629,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -153.740629,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -153.740629,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -153.740629,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -153.740629,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -153.740629,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                41.089808, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                43.075959, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                40.822138, -152.49675,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -156.154584,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -152.49675,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -156.154584,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -153.740629,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                38.249994, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -153.740629,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -156.154584,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -153.740629,
                                                                                                                                                114.347958,
                                                                                                                                                30.59, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -153.740629,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -153.740629,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -156.154584,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -156.154584,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -156.154584,
                                                                                                                                                216.330819,
                                                                                                                                                35.350083, -152.49675,
                                                                                                                                                220.973039,
                                                                                                                                                38.520621, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -152.259367,
                                                                                                                                                220.835986,
                                                                                                                                                36.219105, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -151.552137,
                                                                                                                                                220.427667,
                                                                                                                                                33.965284, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -155.80921,
                                                                                                                                                216.330819,
                                                                                                                                                32.450172, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -154.780245,
                                                                                                                                                216.330819,
                                                                                                                                                29.610358, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                19.508298, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                19.508298, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -152.649884,
                                                                                                                                                114.347958,
                                                                                                                                                23.072096, -153.466523,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -152.649884,
                                                                                                                                                49.724827,
                                                                                                                                                38.107904, -153.466523,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -151.307636,
                                                                                                                                                49.724827,
                                                                                                                                                41.671702, -149.467595,
                                                                                                                                                49.724827,
                                                                                                                                                45.005849, -151.307636,
                                                                                                                                                114.347958,
                                                                                                                                                41.671702, -8.986691,
                                                                                                                                                49.724827,
                                                                                                                                                13.13875, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                0, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                13.13875, -11.698396,
                                                                                                                                                114.347958,
                                                                                                                                                50.715, -11.698396,
                                                                                                                                                49.724827,
                                                                                                                                                50.715, -8.986691,
                                                                                                                                                114.347958,
                                                                                                                                                48.04125, -2.688061,
                                                                                                                                                11.678311,
                                                                                                                                                38.100361, -2.413955,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -2.413955,
                                                                                                                                                11.678311,
                                                                                                                                                35.104179, -2.413955,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                34.388309, -2.413955,
                                                                                                                                                49.724827,
                                                                                                                                                30.59, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                34.388309, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -2.688061,
                                                                                                                                                114.347958,
                                                                                                                                                26.791691, -2.688061,
                                                                                                                                                49.724827,
                                                                                                                                                26.791691, -3.5047,
                                                                                                                                                11.678311,
                                                                                                                                                29.173907, -3.5047,
                                                                                                                                                49.724827,
                                                                                                                                                23.072096, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -8.281648,
                                                                                                                                                216.330819,
                                                                                                                                                22.026505, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                27.946354, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                27.946354, -11.698396,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                27.946354, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                27.946354, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                27.946354, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -9.349991,
                                                                                                                                                217.686671,
                                                                                                                                                27.946354, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -7.358391,
                                                                                                                                                218.836522,
                                                                                                                                                29.785599, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                33.965284, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                36.219105, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -7.056176,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                32.450172, -11.698396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -7.056176,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -7.056176,
                                                                                                                                                224.371381,
                                                                                                                                                38.520621, -11.698396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -11.698396,
                                                                                                                                                225.61526,
                                                                                                                                                35.350083, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -7.193229,
                                                                                                                                                224.133998,
                                                                                                                                                40.822138, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -11.698396,
                                                                                                                                                225.341154,
                                                                                                                                                38.249994, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -7.601548,
                                                                                                                                                223.426767,
                                                                                                                                                43.075959, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -11.698396,
                                                                                                                                                224.524515,
                                                                                                                                                41.089808, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -8.272672,
                                                                                                                                                222.264347,
                                                                                                                                                45.235378, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -11.698396,
                                                                                                                                                223.182267,
                                                                                                                                                43.810676, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -9.192693,
                                                                                                                                                220.670824,
                                                                                                                                                47.255643, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -11.698396,
                                                                                                                                                221.342226,
                                                                                                                                                46.356211, -11.698396,
                                                                                                                                                219.042524,
                                                                                                                                                48.673661, -10.342544,
                                                                                                                                                218.679224,
                                                                                                                                                49.094889, -144.456188,
                                                                                                                                                216.330819,
                                                                                                                                                19.985166, -145.812041,
                                                                                                                                                218.679224,
                                                                                                                                                27.946354, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -145.812041,
                                                                                                                                                218.679224,
                                                                                                                                                27.946354, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -144.456188,
                                                                                                                                                219.042524,
                                                                                                                                                22.026505, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -144.456188,
                                                                                                                                                221.342226,
                                                                                                                                                24.343955, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -146.961891,
                                                                                                                                                220.670824,
                                                                                                                                                29.785599, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -144.456188,
                                                                                                                                                224.524515,
                                                                                                                                                29.610358, -144.456188,
                                                                                                                                                223.182267,
                                                                                                                                                26.88949, -147.881912,
                                                                                                                                                222.264347,
                                                                                                                                                31.805865,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "normals": [-0.220164, -0.652215,
                                                                                                                                                0.725358, -0.478434, -0.316098,
                                                                                                                                                0.819257, -0.330227, -0.599878,
                                                                                                                                                0.728764, -0.330227, -0.599878,
                                                                                                                                                0.728764, -0.478434, -0.316098,
                                                                                                                                                0.819257, -0.57954, -0.334597,
                                                                                                                                                0.743087, -0.57954, -0.334597,
                                                                                                                                                0.743087, -0.478434, -0.316098,
                                                                                                                                                0.819257, -0.674627, -0.063614,
                                                                                                                                                0.735413, -0.478434, -0.316098,
                                                                                                                                                0.819257, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871, -0.674627, -0.063614,
                                                                                                                                                0.735413, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871, -0.501239,
                                                                                                                                                0,
                                                                                                                                                0.865309, -0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376, -0.709207, -0.003661,
                                                                                                                                                0.70499, -0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376, -0.501239,
                                                                                                                                                0,
                                                                                                                                                0.865309, -0.709207, -0.003661,
                                                                                                                                                0.70499, -0.802122, -0.009124,
                                                                                                                                                0.59709, -0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376, -0.802122, -0.009124,
                                                                                                                                                0.59709, -0.709207, -0.003661,
                                                                                                                                                0.70499, -0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076, -0.709207, -0.003661,
                                                                                                                                                0.70499, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428, -0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076, -0.501239,
                                                                                                                                                0,
                                                                                                                                                0.865309, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428, -0.709207, -0.003661,
                                                                                                                                                0.70499, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428, -0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503, -0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428, -0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429, -0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503, -0.312369,
                                                                                                                                                0.264387,
                                                                                                                                                0.912428,
                                                                                                                                                0.057851,
                                                                                                                                                0.656315,
                                                                                                                                                0.752266, -0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429,
                                                                                                                                                0.057851,
                                                                                                                                                0.656315,
                                                                                                                                                0.752266,
                                                                                                                                                0.033648,
                                                                                                                                                0.753459,
                                                                                                                                                0.656633, -0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429, -0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429,
                                                                                                                                                0.033648,
                                                                                                                                                0.753459,
                                                                                                                                                0.656633, -0.236916,
                                                                                                                                                0.647494,
                                                                                                                                                0.724309,
                                                                                                                                                0.033648,
                                                                                                                                                0.753459,
                                                                                                                                                0.656633, -0.239209,
                                                                                                                                                0.761169,
                                                                                                                                                0.602828, -0.236916,
                                                                                                                                                0.647494,
                                                                                                                                                0.724309, -0.011204,
                                                                                                                                                0.863212,
                                                                                                                                                0.504718, -0.239209,
                                                                                                                                                0.761169,
                                                                                                                                                0.602828,
                                                                                                                                                0.033648,
                                                                                                                                                0.753459,
                                                                                                                                                0.656633, -0.011204,
                                                                                                                                                0.863212,
                                                                                                                                                0.504718, -0.303587,
                                                                                                                                                0.844556,
                                                                                                                                                0.44109, -0.239209,
                                                                                                                                                0.761169,
                                                                                                                                                0.602828, -0.075447,
                                                                                                                                                0.935529,
                                                                                                                                                0.3451, -0.303587,
                                                                                                                                                0.844556,
                                                                                                                                                0.44109, -0.011204,
                                                                                                                                                0.863212,
                                                                                                                                                0.504718, -0.075447,
                                                                                                                                                0.935529,
                                                                                                                                                0.3451, -0.37286,
                                                                                                                                                0.895793,
                                                                                                                                                0.241931, -0.303587,
                                                                                                                                                0.844556,
                                                                                                                                                0.44109, -0.165616,
                                                                                                                                                0.973038,
                                                                                                                                                0.160525, -0.37286,
                                                                                                                                                0.895793,
                                                                                                                                                0.241931, -0.075447,
                                                                                                                                                0.935529,
                                                                                                                                                0.3451, -0.165616,
                                                                                                                                                0.973038,
                                                                                                                                                0.160525, -0.444642,
                                                                                                                                                0.895519,
                                                                                                                                                0.018392, -0.37286,
                                                                                                                                                0.895793,
                                                                                                                                                0.241931, -0.165616,
                                                                                                                                                0.973038,
                                                                                                                                                0.160525, -0.286951,
                                                                                                                                                0.957195, -0.037905, -0.444642,
                                                                                                                                                0.895519,
                                                                                                                                                0.018392, -0.286951,
                                                                                                                                                0.957195, -0.037905, -0.518526,
                                                                                                                                                0.83053, -0.203349, -0.444642,
                                                                                                                                                0.895519,
                                                                                                                                                0.018392, -0.286951,
                                                                                                                                                0.957195, -0.037905, -0.440434,
                                                                                                                                                0.868841, -0.226128, -0.518526,
                                                                                                                                                0.83053, -0.203349, -0.440434,
                                                                                                                                                0.868841, -0.226128, -0.595594,
                                                                                                                                                0.701284, -0.391751, -0.518526,
                                                                                                                                                0.83053, -0.203349, -0.440434,
                                                                                                                                                0.868841, -0.226128, -0.616795,
                                                                                                                                                0.697429, -0.364906, -0.595594,
                                                                                                                                                0.701284, -0.391751, -0.674525,
                                                                                                                                                0.523214, -0.520829, -0.595594,
                                                                                                                                                0.701284, -0.391751, -0.616795,
                                                                                                                                                0.697429, -0.364906, -0.674525,
                                                                                                                                                0.523214, -0.520829, -0.446196,
                                                                                                                                                0.740494, -0.502572, -0.595594,
                                                                                                                                                0.701284, -0.391751, -0.446196,
                                                                                                                                                0.740494, -0.502572, -0.674525,
                                                                                                                                                0.523214, -0.520829, -0.257842,
                                                                                                                                                0.821581, -0.508451, -0.798682,
                                                                                                                                                0.302903, -0.519958, -0.257842,
                                                                                                                                                0.821581, -0.508451, -0.674525,
                                                                                                                                                0.523214, -0.520829, -0.257842,
                                                                                                                                                0.821581, -0.508451, -0.798682,
                                                                                                                                                0.302903, -0.519958, -0.270981,
                                                                                                                                                0.856487, -0.439317, -0.857629,
                                                                                                                                                0.274746, -0.434726, -0.270981,
                                                                                                                                                0.856487, -0.439317, -0.798682,
                                                                                                                                                0.302903, -0.519958, -0.668153,
                                                                                                                                                0.581526, -0.464111, -0.270981,
                                                                                                                                                0.856487, -0.439317, -0.857629,
                                                                                                                                                0.274746, -0.434726, -0.668153,
                                                                                                                                                0.581526, -0.464111, -0.480617,
                                                                                                                                                0.664887, -0.57178, -0.270981,
                                                                                                                                                0.856487, -0.439317, -0.668153,
                                                                                                                                                0.581526, -0.464111, -0.889903,
                                                                                                                                                0.063821, -0.451664, -0.480617,
                                                                                                                                                0.664887, -0.57178, -0.978938, -0.029296, -0.202043, -0.92326, -0.049629, -0.380956, -0.889903,
                                                                                                                                                0.063821, -0.451664, -0.978938, -0.029296, -0.202043, -0.942521, -0.242961, -0.2294, -0.92326, -0.049629, -0.380956,
                                                                                                                                                0.889903,
                                                                                                                                                0.063821, -0.451664,
                                                                                                                                                0.867565,
                                                                                                                                                0.0234, -0.496774,
                                                                                                                                                0.978938, -0.029296, -0.202043,
                                                                                                                                                0.867565,
                                                                                                                                                0.0234, -0.496774,
                                                                                                                                                0.889903,
                                                                                                                                                0.063821, -0.451664,
                                                                                                                                                0.480617,
                                                                                                                                                0.664887, -0.57178,
                                                                                                                                                0.480617,
                                                                                                                                                0.664887, -0.57178,
                                                                                                                                                0.889903,
                                                                                                                                                0.063821, -0.451664,
                                                                                                                                                0.668153,
                                                                                                                                                0.581526, -0.464111,
                                                                                                                                                0.430301,
                                                                                                                                                0.235343,
                                                                                                                                                0.871467,
                                                                                                                                                0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429, -0.057851,
                                                                                                                                                0.656315,
                                                                                                                                                0.752266,
                                                                                                                                                0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503,
                                                                                                                                                0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429,
                                                                                                                                                0.430301,
                                                                                                                                                0.235343,
                                                                                                                                                0.871467,
                                                                                                                                                0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429,
                                                                                                                                                0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503,
                                                                                                                                                0.184702,
                                                                                                                                                0.689327,
                                                                                                                                                0.700509,
                                                                                                                                                0.603485,
                                                                                                                                                0.338037,
                                                                                                                                                0.722175,
                                                                                                                                                0.184702,
                                                                                                                                                0.689327,
                                                                                                                                                0.700509,
                                                                                                                                                0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503,
                                                                                                                                                0.184702,
                                                                                                                                                0.689327,
                                                                                                                                                0.700509,
                                                                                                                                                0.603485,
                                                                                                                                                0.338037,
                                                                                                                                                0.722175,
                                                                                                                                                0.245004,
                                                                                                                                                0.783613,
                                                                                                                                                0.570898,
                                                                                                                                                0.685977,
                                                                                                                                                0.440524,
                                                                                                                                                0.579115,
                                                                                                                                                0.245004,
                                                                                                                                                0.783613,
                                                                                                                                                0.570898,
                                                                                                                                                0.603485,
                                                                                                                                                0.338037,
                                                                                                                                                0.722175,
                                                                                                                                                0.245004,
                                                                                                                                                0.783613,
                                                                                                                                                0.570898,
                                                                                                                                                0.685977,
                                                                                                                                                0.440524,
                                                                                                                                                0.579115,
                                                                                                                                                0.313257,
                                                                                                                                                0.859468,
                                                                                                                                                0.403962,
                                                                                                                                                0.748008,
                                                                                                                                                0.5239,
                                                                                                                                                0.407447,
                                                                                                                                                0.313257,
                                                                                                                                                0.859468,
                                                                                                                                                0.403962,
                                                                                                                                                0.685977,
                                                                                                                                                0.440524,
                                                                                                                                                0.579115,
                                                                                                                                                0.313257,
                                                                                                                                                0.859468,
                                                                                                                                                0.403962,
                                                                                                                                                0.748008,
                                                                                                                                                0.5239,
                                                                                                                                                0.407447,
                                                                                                                                                0.387731,
                                                                                                                                                0.89932,
                                                                                                                                                0.202209,
                                                                                                                                                0.773084,
                                                                                                                                                0.60117,
                                                                                                                                                0.202325,
                                                                                                                                                0.387731,
                                                                                                                                                0.89932,
                                                                                                                                                0.202209,
                                                                                                                                                0.748008,
                                                                                                                                                0.5239,
                                                                                                                                                0.407447,
                                                                                                                                                0.387731,
                                                                                                                                                0.89932,
                                                                                                                                                0.202209,
                                                                                                                                                0.773084,
                                                                                                                                                0.60117,
                                                                                                                                                0.202325,
                                                                                                                                                0.467431,
                                                                                                                                                0.883813, -0.019567,
                                                                                                                                                0.747181,
                                                                                                                                                0.664389, -0.01756,
                                                                                                                                                0.467431,
                                                                                                                                                0.883813, -0.019567,
                                                                                                                                                0.773084,
                                                                                                                                                0.60117,
                                                                                                                                                0.202325,
                                                                                                                                                0.467431,
                                                                                                                                                0.883813, -0.019567,
                                                                                                                                                0.747181,
                                                                                                                                                0.664389, -0.01756,
                                                                                                                                                0.554116,
                                                                                                                                                0.798851, -0.234077,
                                                                                                                                                0.666952,
                                                                                                                                                0.710682, -0.223844,
                                                                                                                                                0.554116,
                                                                                                                                                0.798851, -0.234077,
                                                                                                                                                0.747181,
                                                                                                                                                0.664389, -0.01756,
                                                                                                                                                0.554116,
                                                                                                                                                0.798851, -0.234077,
                                                                                                                                                0.666952,
                                                                                                                                                0.710682, -0.223844,
                                                                                                                                                0.647811,
                                                                                                                                                0.643587, -0.407599,
                                                                                                                                                0.541168,
                                                                                                                                                0.74526, -0.38952,
                                                                                                                                                0.647811,
                                                                                                                                                0.643587, -0.407599,
                                                                                                                                                0.666952,
                                                                                                                                                0.710682, -0.223844,
                                                                                                                                                0.647811,
                                                                                                                                                0.643587, -0.407599,
                                                                                                                                                0.541168,
                                                                                                                                                0.74526, -0.38952,
                                                                                                                                                0.738366,
                                                                                                                                                0.439425, -0.511587,
                                                                                                                                                0.384084,
                                                                                                                                                0.77835, -0.49664,
                                                                                                                                                0.738366,
                                                                                                                                                0.439425, -0.511587,
                                                                                                                                                0.541168,
                                                                                                                                                0.74526, -0.38952,
                                                                                                                                                0.384084,
                                                                                                                                                0.77835, -0.49664,
                                                                                                                                                0.210342,
                                                                                                                                                0.817992, -0.535393,
                                                                                                                                                0.738366,
                                                                                                                                                0.439425, -0.511587,
                                                                                                                                                0.555385,
                                                                                                                                                0.55179, -0.622154,
                                                                                                                                                0.210342,
                                                                                                                                                0.817992, -0.535393,
                                                                                                                                                0.384084,
                                                                                                                                                0.77835, -0.49664,
                                                                                                                                                0.555385,
                                                                                                                                                0.55179, -0.622154,
                                                                                                                                                0.480617,
                                                                                                                                                0.664887, -0.57178,
                                                                                                                                                0.210342,
                                                                                                                                                0.817992, -0.535393,
                                                                                                                                                0.480617,
                                                                                                                                                0.664887, -0.57178,
                                                                                                                                                0.555385,
                                                                                                                                                0.55179, -0.622154,
                                                                                                                                                0.867565,
                                                                                                                                                0.0234, -0.496774,
                                                                                                                                                0.820173,
                                                                                                                                                0.020548, -0.571746,
                                                                                                                                                0.867565,
                                                                                                                                                0.0234, -0.496774,
                                                                                                                                                0.555385,
                                                                                                                                                0.55179, -0.622154,
                                                                                                                                                0.867565,
                                                                                                                                                0.0234, -0.496774,
                                                                                                                                                0.820173,
                                                                                                                                                0.020548, -0.571746,
                                                                                                                                                0.92326, -0.049629, -0.380956,
                                                                                                                                                0.815283, -0.072677, -0.574484,
                                                                                                                                                0.92326, -0.049629, -0.380956,
                                                                                                                                                0.820173,
                                                                                                                                                0.020548, -0.571746,
                                                                                                                                                0.815283, -0.072677, -0.574484,
                                                                                                                                                0.847158, -0.156631, -0.50773,
                                                                                                                                                0.92326, -0.049629, -0.380956,
                                                                                                                                                0.786707, -0.148669, -0.599157,
                                                                                                                                                0.847158, -0.156631, -0.50773,
                                                                                                                                                0.815283, -0.072677, -0.574484,
                                                                                                                                                0.847158, -0.156631, -0.50773,
                                                                                                                                                0.786707, -0.148669, -0.599157,
                                                                                                                                                0.754453, -0.435584, -0.490987,
                                                                                                                                                0.66899, -0.386242, -0.635035,
                                                                                                                                                0.754453, -0.435584, -0.490987,
                                                                                                                                                0.786707, -0.148669, -0.599157,
                                                                                                                                                0.66899, -0.386242, -0.635035,
                                                                                                                                                0.854729, -0.25733, -0.450799,
                                                                                                                                                0.754453, -0.435584, -0.490987,
                                                                                                                                                0.854729, -0.25733, -0.450799,
                                                                                                                                                0.66899, -0.386242, -0.635035,
                                                                                                                                                0.777052, -0.469869, -0.418823,
                                                                                                                                                0.748014, -0.431866, -0.503951,
                                                                                                                                                0.777052, -0.469869, -0.418823,
                                                                                                                                                0.66899, -0.386242, -0.635035,
                                                                                                                                                0.777052, -0.469869, -0.418823,
                                                                                                                                                0.748014, -0.431866, -0.503951,
                                                                                                                                                0.669471, -0.667637, -0.325683,
                                                                                                                                                0.810929, -0.46819, -0.350987,
                                                                                                                                                0.669471, -0.667637, -0.325683,
                                                                                                                                                0.748014, -0.431866, -0.503951,
                                                                                                                                                0.669471, -0.667637, -0.325683,
                                                                                                                                                0.810929, -0.46819, -0.350987,
                                                                                                                                                0.520633, -0.837802, -0.164405,
                                                                                                                                                0.851809, -0.491792, -0.180447,
                                                                                                                                                0.520633, -0.837802, -0.164405,
                                                                                                                                                0.810929, -0.46819, -0.350987,
                                                                                                                                                0.520633, -0.837802, -0.164405,
                                                                                                                                                0.851809, -0.491792, -0.180447,
                                                                                                                                                0.500957, -0.865472, -0.000902,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.500957, -0.865472, -0.000902,
                                                                                                                                                0.851809, -0.491792, -0.180447,
                                                                                                                                                0.500957, -0.865472, -0.000902,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.392387, -0.90621,
                                                                                                                                                0.157529,
                                                                                                                                                0.851809, -0.491792,
                                                                                                                                                0.180447,
                                                                                                                                                0.392387, -0.90621,
                                                                                                                                                0.157529,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.392387, -0.90621,
                                                                                                                                                0.157529,
                                                                                                                                                0.851809, -0.491792,
                                                                                                                                                0.180447,
                                                                                                                                                0.328005, -0.887806,
                                                                                                                                                0.32282,
                                                                                                                                                0.810929, -0.46819,
                                                                                                                                                0.350987,
                                                                                                                                                0.328005, -0.887806,
                                                                                                                                                0.32282,
                                                                                                                                                0.851809, -0.491792,
                                                                                                                                                0.180447,
                                                                                                                                                0.328005, -0.887806,
                                                                                                                                                0.32282,
                                                                                                                                                0.810929, -0.46819,
                                                                                                                                                0.350987,
                                                                                                                                                0.226726, -0.8479,
                                                                                                                                                0.47923,
                                                                                                                                                0.748014, -0.431866,
                                                                                                                                                0.503951,
                                                                                                                                                0.226726, -0.8479,
                                                                                                                                                0.47923,
                                                                                                                                                0.810929, -0.46819,
                                                                                                                                                0.350987,
                                                                                                                                                0.226726, -0.8479,
                                                                                                                                                0.47923,
                                                                                                                                                0.748014, -0.431866,
                                                                                                                                                0.503951,
                                                                                                                                                0.275971, -0.725981,
                                                                                                                                                0.629914,
                                                                                                                                                0.66899, -0.386242,
                                                                                                                                                0.635035,
                                                                                                                                                0.275971, -0.725981,
                                                                                                                                                0.629914,
                                                                                                                                                0.748014, -0.431866,
                                                                                                                                                0.503951,
                                                                                                                                                0.66899, -0.386242,
                                                                                                                                                0.635035,
                                                                                                                                                0.57954, -0.334597,
                                                                                                                                                0.743087,
                                                                                                                                                0.275971, -0.725981,
                                                                                                                                                0.629914,
                                                                                                                                                0.66899, -0.386242,
                                                                                                                                                0.635035,
                                                                                                                                                0.775732, -0.069317,
                                                                                                                                                0.627244,
                                                                                                                                                0.57954, -0.334597,
                                                                                                                                                0.743087,
                                                                                                                                                0.775732, -0.069317,
                                                                                                                                                0.627244,
                                                                                                                                                0.66899, -0.386242,
                                                                                                                                                0.635035,
                                                                                                                                                0.863708, -0.075807,
                                                                                                                                                0.498259,
                                                                                                                                                0.748014, -0.431866,
                                                                                                                                                0.503951,
                                                                                                                                                0.863708, -0.075807,
                                                                                                                                                0.498259,
                                                                                                                                                0.66899, -0.386242,
                                                                                                                                                0.635035,
                                                                                                                                                0.863708, -0.075807,
                                                                                                                                                0.498259,
                                                                                                                                                0.748014, -0.431866,
                                                                                                                                                0.503951,
                                                                                                                                                0.933022, -0.083501,
                                                                                                                                                0.349996,
                                                                                                                                                0.810929, -0.46819,
                                                                                                                                                0.350987,
                                                                                                                                                0.933022, -0.083501,
                                                                                                                                                0.349996,
                                                                                                                                                0.748014, -0.431866,
                                                                                                                                                0.503951,
                                                                                                                                                0.933022, -0.083501,
                                                                                                                                                0.349996,
                                                                                                                                                0.810929, -0.46819,
                                                                                                                                                0.350987,
                                                                                                                                                0.978076, -0.0926,
                                                                                                                                                0.18653,
                                                                                                                                                0.851809, -0.491792,
                                                                                                                                                0.180447,
                                                                                                                                                0.978076, -0.0926,
                                                                                                                                                0.18653,
                                                                                                                                                0.810929, -0.46819,
                                                                                                                                                0.350987,
                                                                                                                                                0.978076, -0.0926,
                                                                                                                                                0.18653,
                                                                                                                                                0.851809, -0.491792,
                                                                                                                                                0.180447,
                                                                                                                                                0.994571, -0.103036,
                                                                                                                                                0.01457,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.994571, -0.103036,
                                                                                                                                                0.01457,
                                                                                                                                                0.851809, -0.491792,
                                                                                                                                                0.180447,
                                                                                                                                                0.866025, -0.5,
                                                                                                                                                0,
                                                                                                                                                0.851809, -0.491792, -0.180447,
                                                                                                                                                0.994571, -0.103036,
                                                                                                                                                0.01457,
                                                                                                                                                0.980871, -0.114462, -0.157453,
                                                                                                                                                0.994571, -0.103036,
                                                                                                                                                0.01457,
                                                                                                                                                0.851809, -0.491792, -0.180447,
                                                                                                                                                0.994571, -0.103036,
                                                                                                                                                0.01457,
                                                                                                                                                0.980871, -0.114462, -0.157453,
                                                                                                                                                0.99983, -0.002472, -0.01827,
                                                                                                                                                0.99983, -0.002472, -0.01827,
                                                                                                                                                0.980871, -0.114462, -0.157453,
                                                                                                                                                0.985526, -0.016431, -0.168723,
                                                                                                                                                0.980871, -0.114462, -0.157453,
                                                                                                                                                0.93858, -0.126324, -0.321106,
                                                                                                                                                0.985526, -0.016431, -0.168723,
                                                                                                                                                0.93858, -0.126324, -0.321106,
                                                                                                                                                0.980871, -0.114462, -0.157453,
                                                                                                                                                0.810929, -0.46819, -0.350987,
                                                                                                                                                0.851809, -0.491792, -0.180447,
                                                                                                                                                0.810929, -0.46819, -0.350987,
                                                                                                                                                0.980871, -0.114462, -0.157453,
                                                                                                                                                0.810929, -0.46819, -0.350987,
                                                                                                                                                0.748014, -0.431866, -0.503951,
                                                                                                                                                0.93858, -0.126324, -0.321106,
                                                                                                                                                0.871987, -0.137954, -0.469689,
                                                                                                                                                0.93858, -0.126324, -0.321106,
                                                                                                                                                0.748014, -0.431866, -0.503951,
                                                                                                                                                0.93858, -0.126324, -0.321106,
                                                                                                                                                0.871987, -0.137954, -0.469689,
                                                                                                                                                0.948841, -0.033486, -0.313973,
                                                                                                                                                0.948841, -0.033486, -0.313973,
                                                                                                                                                0.871987, -0.137954, -0.469689,
                                                                                                                                                0.891357, -0.052625, -0.450238,
                                                                                                                                                0.871987, -0.137954, -0.469689,
                                                                                                                                                0.786707, -0.148669, -0.599157,
                                                                                                                                                0.891357, -0.052625, -0.450238,
                                                                                                                                                0.786707, -0.148669, -0.599157,
                                                                                                                                                0.871987, -0.137954, -0.469689,
                                                                                                                                                0.66899, -0.386242, -0.635035,
                                                                                                                                                0.748014, -0.431866, -0.503951,
                                                                                                                                                0.66899, -0.386242, -0.635035,
                                                                                                                                                0.871987, -0.137954, -0.469689,
                                                                                                                                                0.891357, -0.052625, -0.450238,
                                                                                                                                                0.786707, -0.148669, -0.599157,
                                                                                                                                                0.815283, -0.072677, -0.574484,
                                                                                                                                                0.891357, -0.052625, -0.450238,
                                                                                                                                                0.815283, -0.072677, -0.574484,
                                                                                                                                                0.897326,
                                                                                                                                                0.009249, -0.441271,
                                                                                                                                                0.820173,
                                                                                                                                                0.020548, -0.571746,
                                                                                                                                                0.897326,
                                                                                                                                                0.009249, -0.441271,
                                                                                                                                                0.815283, -0.072677, -0.574484,
                                                                                                                                                0.897326,
                                                                                                                                                0.009249, -0.441271,
                                                                                                                                                0.820173,
                                                                                                                                                0.020548, -0.571746,
                                                                                                                                                0.698033,
                                                                                                                                                0.481846, -0.529693,
                                                                                                                                                0.698033,
                                                                                                                                                0.481846, -0.529693,
                                                                                                                                                0.820173,
                                                                                                                                                0.020548, -0.571746,
                                                                                                                                                0.555385,
                                                                                                                                                0.55179, -0.622154,
                                                                                                                                                0.698033,
                                                                                                                                                0.481846, -0.529693,
                                                                                                                                                0.555385,
                                                                                                                                                0.55179, -0.622154,
                                                                                                                                                0.384084,
                                                                                                                                                0.77835, -0.49664,
                                                                                                                                                0.698033,
                                                                                                                                                0.481846, -0.529693,
                                                                                                                                                0.384084,
                                                                                                                                                0.77835, -0.49664,
                                                                                                                                                0.541168,
                                                                                                                                                0.74526, -0.38952,
                                                                                                                                                0.820834,
                                                                                                                                                0.420581, -0.38645,
                                                                                                                                                0.698033,
                                                                                                                                                0.481846, -0.529693,
                                                                                                                                                0.541168,
                                                                                                                                                0.74526, -0.38952,
                                                                                                                                                0.820834,
                                                                                                                                                0.420581, -0.38645,
                                                                                                                                                0.897326,
                                                                                                                                                0.009249, -0.441271,
                                                                                                                                                0.698033,
                                                                                                                                                0.481846, -0.529693,
                                                                                                                                                0.955313, -0.00106, -0.295593,
                                                                                                                                                0.897326,
                                                                                                                                                0.009249, -0.441271,
                                                                                                                                                0.820834,
                                                                                                                                                0.420581, -0.38645,
                                                                                                                                                0.897326,
                                                                                                                                                0.009249, -0.441271,
                                                                                                                                                0.955313, -0.00106, -0.295593,
                                                                                                                                                0.891357, -0.052625, -0.450238,
                                                                                                                                                0.948841, -0.033486, -0.313973,
                                                                                                                                                0.891357, -0.052625, -0.450238,
                                                                                                                                                0.955313, -0.00106, -0.295593,
                                                                                                                                                0.955313, -0.00106, -0.295593,
                                                                                                                                                0.990316, -0.009426, -0.138512,
                                                                                                                                                0.948841, -0.033486, -0.313973,
                                                                                                                                                0.990316, -0.009426, -0.138512,
                                                                                                                                                0.955313, -0.00106, -0.295593,
                                                                                                                                                0.909635,
                                                                                                                                                0.363492, -0.201092,
                                                                                                                                                0.909635,
                                                                                                                                                0.363492, -0.201092,
                                                                                                                                                0.955313, -0.00106, -0.295593,
                                                                                                                                                0.820834,
                                                                                                                                                0.420581, -0.38645,
                                                                                                                                                0.909635,
                                                                                                                                                0.363492, -0.201092,
                                                                                                                                                0.820834,
                                                                                                                                                0.420581, -0.38645,
                                                                                                                                                0.666952,
                                                                                                                                                0.710682, -0.223844,
                                                                                                                                                0.820834,
                                                                                                                                                0.420581, -0.38645,
                                                                                                                                                0.541168,
                                                                                                                                                0.74526, -0.38952,
                                                                                                                                                0.666952,
                                                                                                                                                0.710682, -0.223844,
                                                                                                                                                0.909635,
                                                                                                                                                0.363492, -0.201092,
                                                                                                                                                0.666952,
                                                                                                                                                0.710682, -0.223844,
                                                                                                                                                0.747181,
                                                                                                                                                0.664389, -0.01756,
                                                                                                                                                0.951447,
                                                                                                                                                0.307672,
                                                                                                                                                0.009333,
                                                                                                                                                0.909635,
                                                                                                                                                0.363492, -0.201092,
                                                                                                                                                0.747181,
                                                                                                                                                0.664389, -0.01756,
                                                                                                                                                0.951447,
                                                                                                                                                0.307672,
                                                                                                                                                0.009333,
                                                                                                                                                0.990316, -0.009426, -0.138512,
                                                                                                                                                0.909635,
                                                                                                                                                0.363492, -0.201092,
                                                                                                                                                0.999606, -0.015026,
                                                                                                                                                0.023718,
                                                                                                                                                0.990316, -0.009426, -0.138512,
                                                                                                                                                0.951447,
                                                                                                                                                0.307672,
                                                                                                                                                0.009333,
                                                                                                                                                0.990316, -0.009426, -0.138512,
                                                                                                                                                0.999606, -0.015026,
                                                                                                                                                0.023718,
                                                                                                                                                0.985526, -0.016431, -0.168723,
                                                                                                                                                0.99983, -0.002472, -0.01827,
                                                                                                                                                0.985526, -0.016431, -0.168723,
                                                                                                                                                0.999606, -0.015026,
                                                                                                                                                0.023718,
                                                                                                                                                0.999606, -0.015026,
                                                                                                                                                0.023718,
                                                                                                                                                0.982837, -0.01745,
                                                                                                                                                0.183648,
                                                                                                                                                0.99983, -0.002472, -0.01827,
                                                                                                                                                0.982837, -0.01745,
                                                                                                                                                0.183648,
                                                                                                                                                0.999606, -0.015026,
                                                                                                                                                0.023718,
                                                                                                                                                0.941759,
                                                                                                                                                0.253272,
                                                                                                                                                0.221231,
                                                                                                                                                0.941759,
                                                                                                                                                0.253272,
                                                                                                                                                0.221231,
                                                                                                                                                0.999606, -0.015026,
                                                                                                                                                0.023718,
                                                                                                                                                0.951447,
                                                                                                                                                0.307672,
                                                                                                                                                0.009333,
                                                                                                                                                0.941759,
                                                                                                                                                0.253272,
                                                                                                                                                0.221231,
                                                                                                                                                0.951447,
                                                                                                                                                0.307672,
                                                                                                                                                0.009333,
                                                                                                                                                0.773084,
                                                                                                                                                0.60117,
                                                                                                                                                0.202325,
                                                                                                                                                0.773084,
                                                                                                                                                0.60117,
                                                                                                                                                0.202325,
                                                                                                                                                0.951447,
                                                                                                                                                0.307672,
                                                                                                                                                0.009333,
                                                                                                                                                0.747181,
                                                                                                                                                0.664389, -0.01756,
                                                                                                                                                0.748008,
                                                                                                                                                0.5239,
                                                                                                                                                0.407447,
                                                                                                                                                0.941759,
                                                                                                                                                0.253272,
                                                                                                                                                0.221231,
                                                                                                                                                0.773084,
                                                                                                                                                0.60117,
                                                                                                                                                0.202325,
                                                                                                                                                0.887919,
                                                                                                                                                0.2024,
                                                                                                                                                0.413079,
                                                                                                                                                0.941759,
                                                                                                                                                0.253272,
                                                                                                                                                0.221231,
                                                                                                                                                0.748008,
                                                                                                                                                0.5239,
                                                                                                                                                0.407447,
                                                                                                                                                0.887919,
                                                                                                                                                0.2024,
                                                                                                                                                0.413079,
                                                                                                                                                0.982837, -0.01745,
                                                                                                                                                0.183648,
                                                                                                                                                0.941759,
                                                                                                                                                0.253272,
                                                                                                                                                0.221231,
                                                                                                                                                0.942105, -0.016844,
                                                                                                                                                0.334894,
                                                                                                                                                0.982837, -0.01745,
                                                                                                                                                0.183648,
                                                                                                                                                0.887919,
                                                                                                                                                0.2024,
                                                                                                                                                0.413079,
                                                                                                                                                0.982837, -0.01745,
                                                                                                                                                0.183648,
                                                                                                                                                0.942105, -0.016844,
                                                                                                                                                0.334894,
                                                                                                                                                0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089,
                                                                                                                                                0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951,
                                                                                                                                                0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089,
                                                                                                                                                0.942105, -0.016844,
                                                                                                                                                0.334894,
                                                                                                                                                0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951,
                                                                                                                                                0.978076, -0.0926,
                                                                                                                                                0.18653,
                                                                                                                                                0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089,
                                                                                                                                                0.933022, -0.083501,
                                                                                                                                                0.349996,
                                                                                                                                                0.978076, -0.0926,
                                                                                                                                                0.18653,
                                                                                                                                                0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951,
                                                                                                                                                0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258,
                                                                                                                                                0.933022, -0.083501,
                                                                                                                                                0.349996,
                                                                                                                                                0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951,
                                                                                                                                                0.863708, -0.075807,
                                                                                                                                                0.498259,
                                                                                                                                                0.933022, -0.083501,
                                                                                                                                                0.349996,
                                                                                                                                                0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258,
                                                                                                                                                0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613,
                                                                                                                                                0.863708, -0.075807,
                                                                                                                                                0.498259,
                                                                                                                                                0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258,
                                                                                                                                                0.775732, -0.069317,
                                                                                                                                                0.627244,
                                                                                                                                                0.863708, -0.075807,
                                                                                                                                                0.498259,
                                                                                                                                                0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613,
                                                                                                                                                0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376,
                                                                                                                                                0.775732, -0.069317,
                                                                                                                                                0.627244,
                                                                                                                                                0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613,
                                                                                                                                                0.674627, -0.063614,
                                                                                                                                                0.735413,
                                                                                                                                                0.775732, -0.069317,
                                                                                                                                                0.627244,
                                                                                                                                                0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376,
                                                                                                                                                0.674627, -0.063614,
                                                                                                                                                0.735413,
                                                                                                                                                0.57954, -0.334597,
                                                                                                                                                0.743087,
                                                                                                                                                0.775732, -0.069317,
                                                                                                                                                0.627244,
                                                                                                                                                0.57954, -0.334597,
                                                                                                                                                0.743087,
                                                                                                                                                0.674627, -0.063614,
                                                                                                                                                0.735413,
                                                                                                                                                0.431604, -0.349377,
                                                                                                                                                0.831657,
                                                                                                                                                0.431604, -0.349377,
                                                                                                                                                0.831657,
                                                                                                                                                0.674627, -0.063614,
                                                                                                                                                0.735413,
                                                                                                                                                0.67373,
                                                                                                                                                0.007008,
                                                                                                                                                0.738944,
                                                                                                                                                0.674627, -0.063614,
                                                                                                                                                0.735413,
                                                                                                                                                0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376,
                                                                                                                                                0.67373,
                                                                                                                                                0.007008,
                                                                                                                                                0.738944,
                                                                                                                                                0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376,
                                                                                                                                                0.709207, -0.003661,
                                                                                                                                                0.70499,
                                                                                                                                                0.67373,
                                                                                                                                                0.007008,
                                                                                                                                                0.738944,
                                                                                                                                                0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376,
                                                                                                                                                0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613,
                                                                                                                                                0.709207, -0.003661,
                                                                                                                                                0.70499,
                                                                                                                                                0.802122, -0.009124,
                                                                                                                                                0.59709,
                                                                                                                                                0.709207, -0.003661,
                                                                                                                                                0.70499,
                                                                                                                                                0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613,
                                                                                                                                                0.709207, -0.003661,
                                                                                                                                                0.70499,
                                                                                                                                                0.802122, -0.009124,
                                                                                                                                                0.59709,
                                                                                                                                                0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076,
                                                                                                                                                0.802122, -0.009124,
                                                                                                                                                0.59709,
                                                                                                                                                0.725137,
                                                                                                                                                0.095379,
                                                                                                                                                0.681967,
                                                                                                                                                0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076,
                                                                                                                                                0.802122, -0.009124,
                                                                                                                                                0.59709,
                                                                                                                                                0.88074, -0.013801,
                                                                                                                                                0.4734,
                                                                                                                                                0.725137,
                                                                                                                                                0.095379,
                                                                                                                                                0.681967,
                                                                                                                                                0.88074, -0.013801,
                                                                                                                                                0.4734,
                                                                                                                                                0.802122, -0.009124,
                                                                                                                                                0.59709,
                                                                                                                                                0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258,
                                                                                                                                                0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613,
                                                                                                                                                0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258,
                                                                                                                                                0.802122, -0.009124,
                                                                                                                                                0.59709,
                                                                                                                                                0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258,
                                                                                                                                                0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951,
                                                                                                                                                0.88074, -0.013801,
                                                                                                                                                0.4734,
                                                                                                                                                0.942105, -0.016844,
                                                                                                                                                0.334894,
                                                                                                                                                0.88074, -0.013801,
                                                                                                                                                0.4734,
                                                                                                                                                0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951,
                                                                                                                                                0.88074, -0.013801,
                                                                                                                                                0.4734,
                                                                                                                                                0.942105, -0.016844,
                                                                                                                                                0.334894,
                                                                                                                                                0.804418,
                                                                                                                                                0.157224,
                                                                                                                                                0.57288,
                                                                                                                                                0.804418,
                                                                                                                                                0.157224,
                                                                                                                                                0.57288,
                                                                                                                                                0.942105, -0.016844,
                                                                                                                                                0.334894,
                                                                                                                                                0.887919,
                                                                                                                                                0.2024,
                                                                                                                                                0.413079,
                                                                                                                                                0.804418,
                                                                                                                                                0.157224,
                                                                                                                                                0.57288,
                                                                                                                                                0.887919,
                                                                                                                                                0.2024,
                                                                                                                                                0.413079,
                                                                                                                                                0.685977,
                                                                                                                                                0.440524,
                                                                                                                                                0.579115,
                                                                                                                                                0.685977,
                                                                                                                                                0.440524,
                                                                                                                                                0.579115,
                                                                                                                                                0.887919,
                                                                                                                                                0.2024,
                                                                                                                                                0.413079,
                                                                                                                                                0.748008,
                                                                                                                                                0.5239,
                                                                                                                                                0.407447,
                                                                                                                                                0.603485,
                                                                                                                                                0.338037,
                                                                                                                                                0.722175,
                                                                                                                                                0.804418,
                                                                                                                                                0.157224,
                                                                                                                                                0.57288,
                                                                                                                                                0.685977,
                                                                                                                                                0.440524,
                                                                                                                                                0.579115,
                                                                                                                                                0.725137,
                                                                                                                                                0.095379,
                                                                                                                                                0.681967,
                                                                                                                                                0.804418,
                                                                                                                                                0.157224,
                                                                                                                                                0.57288,
                                                                                                                                                0.603485,
                                                                                                                                                0.338037,
                                                                                                                                                0.722175,
                                                                                                                                                0.725137,
                                                                                                                                                0.095379,
                                                                                                                                                0.681967,
                                                                                                                                                0.88074, -0.013801,
                                                                                                                                                0.4734,
                                                                                                                                                0.804418,
                                                                                                                                                0.157224,
                                                                                                                                                0.57288,
                                                                                                                                                0.725137,
                                                                                                                                                0.095379,
                                                                                                                                                0.681967,
                                                                                                                                                0.603485,
                                                                                                                                                0.338037,
                                                                                                                                                0.722175,
                                                                                                                                                0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076,
                                                                                                                                                0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076,
                                                                                                                                                0.603485,
                                                                                                                                                0.338037,
                                                                                                                                                0.722175,
                                                                                                                                                0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503,
                                                                                                                                                0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076,
                                                                                                                                                0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503,
                                                                                                                                                0.430301,
                                                                                                                                                0.235343,
                                                                                                                                                0.871467,
                                                                                                                                                0.709207, -0.003661,
                                                                                                                                                0.70499,
                                                                                                                                                0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076,
                                                                                                                                                0.430301,
                                                                                                                                                0.235343,
                                                                                                                                                0.871467,
                                                                                                                                                0.709207, -0.003661,
                                                                                                                                                0.70499,
                                                                                                                                                0.430301,
                                                                                                                                                0.235343,
                                                                                                                                                0.871467,
                                                                                                                                                0.702106,
                                                                                                                                                0,
                                                                                                                                                0.712073, -0.036168, -0.744789,
                                                                                                                                                0.666319,
                                                                                                                                                0.173449, -0.677368,
                                                                                                                                                0.714904,
                                                                                                                                                0.431604, -0.349377,
                                                                                                                                                0.831657, -0.036168, -0.744789,
                                                                                                                                                0.666319, -0.02065, -0.828876,
                                                                                                                                                0.559051,
                                                                                                                                                0.173449, -0.677368,
                                                                                                                                                0.714904,
                                                                                                                                                0.883591, -0.297279, -0.36179,
                                                                                                                                                0.973055, -0.0734, -0.21858,
                                                                                                                                                0.940076, -0.250932, -0.230845,
                                                                                                                                                0.854729, -0.25733, -0.450799,
                                                                                                                                                0.973055, -0.0734, -0.21858,
                                                                                                                                                0.883591, -0.297279, -0.36179,
                                                                                                                                                0.854729, -0.25733, -0.450799,
                                                                                                                                                0.887156, -0.329655, -0.322926,
                                                                                                                                                0.973055, -0.0734, -0.21858,
                                                                                                                                                0.777052, -0.469869, -0.418823,
                                                                                                                                                0.887156, -0.329655, -0.322926,
                                                                                                                                                0.854729, -0.25733, -0.450799,
                                                                                                                                                0.777052, -0.469869, -0.418823,
                                                                                                                                                0.728413, -0.599122, -0.332365,
                                                                                                                                                0.887156, -0.329655, -0.322926,
                                                                                                                                                0.669471, -0.667637, -0.325683,
                                                                                                                                                0.728413, -0.599122, -0.332365,
                                                                                                                                                0.777052, -0.469869, -0.418823,
                                                                                                                                                0.53799, -0.805145, -0.249617,
                                                                                                                                                0.728413, -0.599122, -0.332365,
                                                                                                                                                0.669471, -0.667637, -0.325683,
                                                                                                                                                0.53799, -0.805145, -0.249617,
                                                                                                                                                0.669471, -0.667637, -0.325683,
                                                                                                                                                0.520633, -0.837802, -0.164405,
                                                                                                                                                0.385885, -0.913126, -0.131504,
                                                                                                                                                0.53799, -0.805145, -0.249617,
                                                                                                                                                0.520633, -0.837802, -0.164405,
                                                                                                                                                0.264676, -0.964337, -0.000281,
                                                                                                                                                0.385885, -0.913126, -0.131504,
                                                                                                                                                0.520633, -0.837802, -0.164405,
                                                                                                                                                0.264676, -0.964337, -0.000281,
                                                                                                                                                0.520633, -0.837802, -0.164405,
                                                                                                                                                0.500957, -0.865472, -0.000902,
                                                                                                                                                0.264676, -0.964337, -0.000281,
                                                                                                                                                0.500957, -0.865472, -0.000902,
                                                                                                                                                0.392387, -0.90621,
                                                                                                                                                0.157529,
                                                                                                                                                0.140252, -0.974153,
                                                                                                                                                0.177072,
                                                                                                                                                0.264676, -0.964337, -0.000281,
                                                                                                                                                0.392387, -0.90621,
                                                                                                                                                0.157529,
                                                                                                                                                0.140252, -0.974153,
                                                                                                                                                0.177072,
                                                                                                                                                0.392387, -0.90621,
                                                                                                                                                0.157529,
                                                                                                                                                0.328005, -0.887806,
                                                                                                                                                0.32282,
                                                                                                                                                0.068594, -0.945405,
                                                                                                                                                0.318597,
                                                                                                                                                0.140252, -0.974153,
                                                                                                                                                0.177072,
                                                                                                                                                0.328005, -0.887806,
                                                                                                                                                0.32282,
                                                                                                                                                0.068594, -0.945405,
                                                                                                                                                0.318597,
                                                                                                                                                0.328005, -0.887806,
                                                                                                                                                0.32282,
                                                                                                                                                0.226726, -0.8479,
                                                                                                                                                0.47923,
                                                                                                                                                0.023506, -0.90678,
                                                                                                                                                0.420947,
                                                                                                                                                0.068594, -0.945405,
                                                                                                                                                0.318597,
                                                                                                                                                0.226726, -0.8479,
                                                                                                                                                0.47923,
                                                                                                                                                0.023506, -0.90678,
                                                                                                                                                0.420947,
                                                                                                                                                0.226726, -0.8479,
                                                                                                                                                0.47923, -0.02065, -0.828876,
                                                                                                                                                0.559051, -0.02065, -0.828876,
                                                                                                                                                0.559051,
                                                                                                                                                0.226726, -0.8479,
                                                                                                                                                0.47923,
                                                                                                                                                0.275971, -0.725981,
                                                                                                                                                0.629914, -0.02065, -0.828876,
                                                                                                                                                0.559051,
                                                                                                                                                0.275971, -0.725981,
                                                                                                                                                0.629914,
                                                                                                                                                0.173449, -0.677368,
                                                                                                                                                0.714904,
                                                                                                                                                0.173449, -0.677368,
                                                                                                                                                0.714904,
                                                                                                                                                0.275971, -0.725981,
                                                                                                                                                0.629914,
                                                                                                                                                0.57954, -0.334597,
                                                                                                                                                0.743087,
                                                                                                                                                0.173449, -0.677368,
                                                                                                                                                0.714904,
                                                                                                                                                0.57954, -0.334597,
                                                                                                                                                0.743087,
                                                                                                                                                0.431604, -0.349377,
                                                                                                                                                0.831657,
                                                                                                                                                0.883591, -0.297279, -0.36179,
                                                                                                                                                0.754453, -0.435584, -0.490987,
                                                                                                                                                0.854729, -0.25733, -0.450799,
                                                                                                                                                0.883591, -0.297279, -0.36179,
                                                                                                                                                0.940076, -0.250932, -0.230845,
                                                                                                                                                0.754453, -0.435584, -0.490987,
                                                                                                                                                0.847158, -0.156631, -0.50773,
                                                                                                                                                0.754453, -0.435584, -0.490987,
                                                                                                                                                0.940076, -0.250932, -0.230845,
                                                                                                                                                0.847158, -0.156631, -0.50773,
                                                                                                                                                0.940076, -0.250932, -0.230845,
                                                                                                                                                0.92326, -0.049629, -0.380956,
                                                                                                                                                0.92326, -0.049629, -0.380956,
                                                                                                                                                0.940076, -0.250932, -0.230845,
                                                                                                                                                0.978938, -0.029296, -0.202043, -0.976503, -0.033608, -0.212869, -0.883471, -0.293087, -0.365484, -0.942521, -0.242961, -0.2294, -0.976503, -0.033608, -0.212869, -0.861044, -0.239473, -0.448615, -0.883471, -0.293087, -0.365484, -0.925541, -0.233321, -0.298219, -0.861044, -0.239473, -0.448615, -0.976503, -0.033608, -0.212869, -0.925541, -0.233321, -0.298219, -0.816723, -0.410365, -0.405666, -0.861044, -0.239473, -0.448615, -0.925541, -0.233321, -0.298219, -0.851252, -0.430337, -0.3003, -0.816723, -0.410365, -0.405666, -0.851252, -0.430337, -0.3003, -0.767828, -0.560442, -0.310394, -0.816723, -0.410365, -0.405666, -0.851252, -0.430337, -0.3003, -0.768088, -0.596796, -0.232113, -0.767828, -0.560442, -0.310394, -0.768088, -0.596796, -0.232113, -0.716849, -0.675019, -0.174579, -0.767828, -0.560442, -0.310394, -0.768088, -0.596796, -0.232113, -0.683941, -0.720454, -0.114768, -0.716849, -0.675019, -0.174579, -0.716849, -0.675019, -0.174579, -0.683941, -0.720454, -0.114768, -0.663196, -0.748324, -0.013519, -0.683941, -0.720454, -0.114768, -0.601054, -0.798563,
                                                                                                                                                0.032105, -0.663196, -0.748324, -0.013519, -0.663196, -0.748324, -0.013519, -0.601054, -0.798563,
                                                                                                                                                0.032105, -0.605047, -0.780414,
                                                                                                                                                0.157708, -0.601054, -0.798563,
                                                                                                                                                0.032105, -0.519485, -0.83261,
                                                                                                                                                0.192084, -0.605047, -0.780414,
                                                                                                                                                0.157708, -0.605047, -0.780414,
                                                                                                                                                0.157708, -0.519485, -0.83261,
                                                                                                                                                0.192084, -0.541515, -0.774962,
                                                                                                                                                0.325876, -0.519485, -0.83261,
                                                                                                                                                0.192084, -0.439285, -0.826656,
                                                                                                                                                0.351666, -0.541515, -0.774962,
                                                                                                                                                0.325876, -0.541515, -0.774962,
                                                                                                                                                0.325876, -0.439285, -0.826656,
                                                                                                                                                0.351666, -0.47331, -0.738124,
                                                                                                                                                0.480782, -0.439285, -0.826656,
                                                                                                                                                0.351666, -0.3611, -0.786854,
                                                                                                                                                0.500468, -0.47331, -0.738124,
                                                                                                                                                0.480782, -0.47331, -0.738124,
                                                                                                                                                0.480782, -0.3611, -0.786854,
                                                                                                                                                0.500468, -0.402216, -0.677322,
                                                                                                                                                0.616001, -0.3611, -0.786854,
                                                                                                                                                0.500468, -0.285897, -0.720636,
                                                                                                                                                0.631622, -0.402216, -0.677322,
                                                                                                                                                0.616001, -0.402216, -0.677322,
                                                                                                                                                0.616001, -0.285897, -0.720636,
                                                                                                                                                0.631622, -0.330227, -0.599878,
                                                                                                                                                0.728764, -0.285897, -0.720636,
                                                                                                                                                0.631622, -0.220164, -0.652215,
                                                                                                                                                0.725358, -0.330227, -0.599878,
                                                                                                                                                0.728764, -0.330227, -0.599878,
                                                                                                                                                0.728764, -0.57954, -0.334597,
                                                                                                                                                0.743087, -0.402216, -0.677322,
                                                                                                                                                0.616001, -0.66899, -0.386242,
                                                                                                                                                0.635035, -0.402216, -0.677322,
                                                                                                                                                0.616001, -0.57954, -0.334597,
                                                                                                                                                0.743087, -0.402216, -0.677322,
                                                                                                                                                0.616001, -0.66899, -0.386242,
                                                                                                                                                0.635035, -0.47331, -0.738124,
                                                                                                                                                0.480782, -0.748014, -0.431866,
                                                                                                                                                0.503951, -0.47331, -0.738124,
                                                                                                                                                0.480782, -0.66899, -0.386242,
                                                                                                                                                0.635035, -0.47331, -0.738124,
                                                                                                                                                0.480782, -0.748014, -0.431866,
                                                                                                                                                0.503951, -0.541515, -0.774962,
                                                                                                                                                0.325876, -0.810929, -0.46819,
                                                                                                                                                0.350987, -0.541515, -0.774962,
                                                                                                                                                0.325876, -0.748014, -0.431866,
                                                                                                                                                0.503951, -0.541515, -0.774962,
                                                                                                                                                0.325876, -0.810929, -0.46819,
                                                                                                                                                0.350987, -0.605047, -0.780414,
                                                                                                                                                0.157708, -0.851809, -0.491792,
                                                                                                                                                0.180447, -0.605047, -0.780414,
                                                                                                                                                0.157708, -0.810929, -0.46819,
                                                                                                                                                0.350987, -0.605047, -0.780414,
                                                                                                                                                0.157708, -0.851809, -0.491792,
                                                                                                                                                0.180447, -0.663196, -0.748324, -0.013519, -0.866025, -0.5,
                                                                                                                                                0, -0.663196, -0.748324, -0.013519, -0.851809, -0.491792,
                                                                                                                                                0.180447, -0.663196, -0.748324, -0.013519, -0.866025, -0.5,
                                                                                                                                                0, -0.716849, -0.675019, -0.174579, -0.851809, -0.491792, -0.180447, -0.716849, -0.675019, -0.174579, -0.866025, -0.5,
                                                                                                                                                0, -0.716849, -0.675019, -0.174579, -0.851809, -0.491792, -0.180447, -0.767828, -0.560442, -0.310394, -0.810929, -0.46819, -0.350987, -0.767828, -0.560442, -0.310394, -0.851809, -0.491792, -0.180447, -0.767828, -0.560442, -0.310394, -0.810929, -0.46819, -0.350987, -0.816723, -0.410365, -0.405666, -0.748014, -0.431866, -0.503951, -0.816723, -0.410365, -0.405666, -0.810929, -0.46819, -0.350987, -0.816723, -0.410365, -0.405666, -0.748014, -0.431866, -0.503951, -0.861044, -0.239473, -0.448615, -0.66899, -0.386242, -0.635035, -0.861044, -0.239473, -0.448615, -0.748014, -0.431866, -0.503951, -0.66899, -0.386242, -0.635035, -0.754453, -0.435584, -0.490987, -0.861044, -0.239473, -0.448615, -0.66899, -0.386242, -0.635035, -0.786707, -0.148669, -0.599157, -0.754453, -0.435584, -0.490987, -0.786707, -0.148669, -0.599157, -0.66899, -0.386242, -0.635035, -0.871987, -0.137954, -0.469689, -0.748014, -0.431866, -0.503951, -0.871987, -0.137954, -0.469689, -0.66899, -0.386242, -0.635035, -0.871987, -0.137954, -0.469689, -0.748014, -0.431866, -0.503951, -0.93858, -0.126324, -0.321106, -0.810929, -0.46819, -0.350987, -0.93858, -0.126324, -0.321106, -0.748014, -0.431866, -0.503951, -0.93858, -0.126324, -0.321106, -0.810929, -0.46819, -0.350987, -0.980871, -0.114462, -0.157453, -0.851809, -0.491792, -0.180447, -0.980871, -0.114462, -0.157453, -0.810929, -0.46819, -0.350987, -0.980871, -0.114462, -0.157453, -0.851809, -0.491792, -0.180447, -0.994571, -0.103036,
                                                                                                                                                0.01457, -0.866025, -0.5,
                                                                                                                                                0, -0.994571, -0.103036,
                                                                                                                                                0.01457, -0.851809, -0.491792, -0.180447, -0.866025, -0.5,
                                                                                                                                                0, -0.851809, -0.491792,
                                                                                                                                                0.180447, -0.994571, -0.103036,
                                                                                                                                                0.01457, -0.978076, -0.0926,
                                                                                                                                                0.18653, -0.994571, -0.103036,
                                                                                                                                                0.01457, -0.851809, -0.491792,
                                                                                                                                                0.180447, -0.994571, -0.103036,
                                                                                                                                                0.01457, -0.978076, -0.0926,
                                                                                                                                                0.18653, -0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089, -0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089, -0.978076, -0.0926,
                                                                                                                                                0.18653, -0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951, -0.978076, -0.0926,
                                                                                                                                                0.18653, -0.933022, -0.083501,
                                                                                                                                                0.349996, -0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951, -0.933022, -0.083501,
                                                                                                                                                0.349996, -0.978076, -0.0926,
                                                                                                                                                0.18653, -0.810929, -0.46819,
                                                                                                                                                0.350987, -0.851809, -0.491792,
                                                                                                                                                0.180447, -0.810929, -0.46819,
                                                                                                                                                0.350987, -0.978076, -0.0926,
                                                                                                                                                0.18653, -0.810929, -0.46819,
                                                                                                                                                0.350987, -0.748014, -0.431866,
                                                                                                                                                0.503951, -0.933022, -0.083501,
                                                                                                                                                0.349996, -0.863708, -0.075807,
                                                                                                                                                0.498259, -0.933022, -0.083501,
                                                                                                                                                0.349996, -0.748014, -0.431866,
                                                                                                                                                0.503951, -0.933022, -0.083501,
                                                                                                                                                0.349996, -0.863708, -0.075807,
                                                                                                                                                0.498259, -0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258, -0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258, -0.863708, -0.075807,
                                                                                                                                                0.498259, -0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613, -0.863708, -0.075807,
                                                                                                                                                0.498259, -0.775732, -0.069317,
                                                                                                                                                0.627244, -0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613, -0.775732, -0.069317,
                                                                                                                                                0.627244, -0.863708, -0.075807,
                                                                                                                                                0.498259, -0.66899, -0.386242,
                                                                                                                                                0.635035, -0.748014, -0.431866,
                                                                                                                                                0.503951, -0.66899, -0.386242,
                                                                                                                                                0.635035, -0.863708, -0.075807,
                                                                                                                                                0.498259, -0.66899, -0.386242,
                                                                                                                                                0.635035, -0.57954, -0.334597,
                                                                                                                                                0.743087, -0.775732, -0.069317,
                                                                                                                                                0.627244, -0.674627, -0.063614,
                                                                                                                                                0.735413, -0.775732, -0.069317,
                                                                                                                                                0.627244, -0.57954, -0.334597,
                                                                                                                                                0.743087, -0.775732, -0.069317,
                                                                                                                                                0.627244, -0.674627, -0.063614,
                                                                                                                                                0.735413, -0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376, -0.431965,
                                                                                                                                                0.005979,
                                                                                                                                                0.901871, -0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376, -0.674627, -0.063614,
                                                                                                                                                0.735413, -0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613, -0.775732, -0.069317,
                                                                                                                                                0.627244, -0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376, -0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613, -0.745538,
                                                                                                                                                0.010809,
                                                                                                                                                0.666376, -0.802122, -0.009124,
                                                                                                                                                0.59709, -0.802122, -0.009124,
                                                                                                                                                0.59709, -0.88074, -0.013801,
                                                                                                                                                0.4734, -0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613, -0.88074, -0.013801,
                                                                                                                                                0.4734, -0.802122, -0.009124,
                                                                                                                                                0.59709, -0.720212,
                                                                                                                                                0.12389,
                                                                                                                                                0.682602, -0.802122, -0.009124,
                                                                                                                                                0.59709, -0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076, -0.720212,
                                                                                                                                                0.12389,
                                                                                                                                                0.682602, -0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076, -0.579717,
                                                                                                                                                0.345738,
                                                                                                                                                0.73783, -0.720212,
                                                                                                                                                0.12389,
                                                                                                                                                0.682602, -0.615455,
                                                                                                                                                0.089485,
                                                                                                                                                0.783076, -0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503, -0.579717,
                                                                                                                                                0.345738,
                                                                                                                                                0.73783, -0.579717,
                                                                                                                                                0.345738,
                                                                                                                                                0.73783, -0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503, -0.236916,
                                                                                                                                                0.647494,
                                                                                                                                                0.724309, -0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429, -0.236916,
                                                                                                                                                0.647494,
                                                                                                                                                0.724309, -0.485593,
                                                                                                                                                0.298885,
                                                                                                                                                0.821503, -0.236916,
                                                                                                                                                0.647494,
                                                                                                                                                0.724309, -0.239209,
                                                                                                                                                0.761169,
                                                                                                                                                0.602828, -0.579717,
                                                                                                                                                0.345738,
                                                                                                                                                0.73783, -0.6662,
                                                                                                                                                0.42617,
                                                                                                                                                0.61201, -0.579717,
                                                                                                                                                0.345738,
                                                                                                                                                0.73783, -0.239209,
                                                                                                                                                0.761169,
                                                                                                                                                0.602828, -0.720212,
                                                                                                                                                0.12389,
                                                                                                                                                0.682602, -0.579717,
                                                                                                                                                0.345738,
                                                                                                                                                0.73783, -0.6662,
                                                                                                                                                0.42617,
                                                                                                                                                0.61201, -0.818277,
                                                                                                                                                0.165721,
                                                                                                                                                0.550418, -0.720212,
                                                                                                                                                0.12389,
                                                                                                                                                0.682602, -0.6662,
                                                                                                                                                0.42617,
                                                                                                                                                0.61201, -0.818277,
                                                                                                                                                0.165721,
                                                                                                                                                0.550418, -0.88074, -0.013801,
                                                                                                                                                0.4734, -0.720212,
                                                                                                                                                0.12389,
                                                                                                                                                0.682602, -0.942105, -0.016844,
                                                                                                                                                0.334894, -0.88074, -0.013801,
                                                                                                                                                0.4734, -0.818277,
                                                                                                                                                0.165721,
                                                                                                                                                0.550418, -0.88074, -0.013801,
                                                                                                                                                0.4734, -0.942105, -0.016844,
                                                                                                                                                0.334894, -0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258, -0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951, -0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258, -0.942105, -0.016844,
                                                                                                                                                0.334894, -0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951, -0.933022, -0.083501,
                                                                                                                                                0.349996, -0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258, -0.942105, -0.016844,
                                                                                                                                                0.334894, -0.982837, -0.01745,
                                                                                                                                                0.183648, -0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951, -0.982837, -0.01745,
                                                                                                                                                0.183648, -0.942105, -0.016844,
                                                                                                                                                0.334894, -0.898442,
                                                                                                                                                0.215062,
                                                                                                                                                0.382818, -0.898442,
                                                                                                                                                0.215062,
                                                                                                                                                0.382818, -0.942105, -0.016844,
                                                                                                                                                0.334894, -0.818277,
                                                                                                                                                0.165721,
                                                                                                                                                0.550418, -0.898442,
                                                                                                                                                0.215062,
                                                                                                                                                0.382818, -0.818277,
                                                                                                                                                0.165721,
                                                                                                                                                0.550418, -0.736129,
                                                                                                                                                0.50889,
                                                                                                                                                0.446257, -0.818277,
                                                                                                                                                0.165721,
                                                                                                                                                0.550418, -0.6662,
                                                                                                                                                0.42617,
                                                                                                                                                0.61201, -0.736129,
                                                                                                                                                0.50889,
                                                                                                                                                0.446257, -0.6662,
                                                                                                                                                0.42617,
                                                                                                                                                0.61201, -0.239209,
                                                                                                                                                0.761169,
                                                                                                                                                0.602828, -0.736129,
                                                                                                                                                0.50889,
                                                                                                                                                0.446257, -0.303587,
                                                                                                                                                0.844556,
                                                                                                                                                0.44109, -0.736129,
                                                                                                                                                0.50889,
                                                                                                                                                0.446257, -0.239209,
                                                                                                                                                0.761169,
                                                                                                                                                0.602828, -0.736129,
                                                                                                                                                0.50889,
                                                                                                                                                0.446257, -0.303587,
                                                                                                                                                0.844556,
                                                                                                                                                0.44109, -0.772813,
                                                                                                                                                0.586148,
                                                                                                                                                0.24329, -0.37286,
                                                                                                                                                0.895793,
                                                                                                                                                0.241931, -0.772813,
                                                                                                                                                0.586148,
                                                                                                                                                0.24329, -0.303587,
                                                                                                                                                0.844556,
                                                                                                                                                0.44109, -0.772813,
                                                                                                                                                0.586148,
                                                                                                                                                0.24329, -0.37286,
                                                                                                                                                0.895793,
                                                                                                                                                0.241931, -0.760818,
                                                                                                                                                0.648659,
                                                                                                                                                0.019942, -0.444642,
                                                                                                                                                0.895519,
                                                                                                                                                0.018392, -0.760818,
                                                                                                                                                0.648659,
                                                                                                                                                0.019942, -0.37286,
                                                                                                                                                0.895793,
                                                                                                                                                0.241931, -0.760818,
                                                                                                                                                0.648659,
                                                                                                                                                0.019942, -0.444642,
                                                                                                                                                0.895519,
                                                                                                                                                0.018392, -0.695477,
                                                                                                                                                0.691467, -0.19541, -0.518526,
                                                                                                                                                0.83053, -0.203349, -0.695477,
                                                                                                                                                0.691467, -0.19541, -0.444642,
                                                                                                                                                0.895519,
                                                                                                                                                0.018392, -0.695477,
                                                                                                                                                0.691467, -0.19541, -0.518526,
                                                                                                                                                0.83053, -0.203349, -0.585696,
                                                                                                                                                0.718458, -0.375204, -0.595594,
                                                                                                                                                0.701284, -0.391751, -0.585696,
                                                                                                                                                0.718458, -0.375204, -0.518526,
                                                                                                                                                0.83053, -0.203349, -0.585696,
                                                                                                                                                0.718458, -0.375204, -0.595594,
                                                                                                                                                0.701284, -0.391751, -0.446196,
                                                                                                                                                0.740494, -0.502572, -0.446196,
                                                                                                                                                0.740494, -0.502572, -0.793153,
                                                                                                                                                0.446605, -0.414069, -0.585696,
                                                                                                                                                0.718458, -0.375204, -0.665068,
                                                                                                                                                0.51466, -0.541118, -0.793153,
                                                                                                                                                0.446605, -0.414069, -0.446196,
                                                                                                                                                0.740494, -0.502572, -0.665068,
                                                                                                                                                0.51466, -0.541118, -0.897326,
                                                                                                                                                0.009249, -0.441271, -0.793153,
                                                                                                                                                0.446605, -0.414069, -0.820173,
                                                                                                                                                0.020548, -0.571746, -0.897326,
                                                                                                                                                0.009249, -0.441271, -0.665068,
                                                                                                                                                0.51466, -0.541118, -0.897326,
                                                                                                                                                0.009249, -0.441271, -0.820173,
                                                                                                                                                0.020548, -0.571746, -0.891357, -0.052625, -0.450238, -0.815283, -0.072677, -0.574484, -0.891357, -0.052625, -0.450238, -0.820173,
                                                                                                                                                0.020548, -0.571746, -0.815283, -0.072677, -0.574484, -0.786707, -0.148669, -0.599157, -0.891357, -0.052625, -0.450238, -0.847158, -0.156631, -0.50773, -0.786707, -0.148669, -0.599157, -0.815283, -0.072677, -0.574484, -0.847158, -0.156631, -0.50773, -0.754453, -0.435584, -0.490987, -0.786707, -0.148669, -0.599157, -0.754453, -0.435584, -0.490987, -0.847158, -0.156631, -0.50773, -0.942521, -0.242961, -0.2294, -0.942521, -0.242961, -0.2294, -0.847158, -0.156631, -0.50773, -0.92326, -0.049629, -0.380956, -0.92326, -0.049629, -0.380956, -0.847158, -0.156631, -0.50773, -0.815283, -0.072677, -0.574484, -0.92326, -0.049629, -0.380956, -0.815283, -0.072677, -0.574484, -0.867565,
                                                                                                                                                0.0234, -0.496774, -0.820173,
                                                                                                                                                0.020548, -0.571746, -0.867565,
                                                                                                                                                0.0234, -0.496774, -0.815283, -0.072677, -0.574484, -0.867565,
                                                                                                                                                0.0234, -0.496774, -0.820173,
                                                                                                                                                0.020548, -0.571746, -0.637653,
                                                                                                                                                0.454291, -0.622108, -0.637653,
                                                                                                                                                0.454291, -0.622108, -0.820173,
                                                                                                                                                0.020548, -0.571746, -0.665068,
                                                                                                                                                0.51466, -0.541118, -0.637653,
                                                                                                                                                0.454291, -0.622108, -0.665068,
                                                                                                                                                0.51466, -0.541118, -0.257842,
                                                                                                                                                0.821581, -0.508451, -0.257842,
                                                                                                                                                0.821581, -0.508451, -0.665068,
                                                                                                                                                0.51466, -0.541118, -0.446196,
                                                                                                                                                0.740494, -0.502572, -0.480617,
                                                                                                                                                0.664887, -0.57178, -0.637653,
                                                                                                                                                0.454291, -0.622108, -0.257842,
                                                                                                                                                0.821581, -0.508451, -0.480617,
                                                                                                                                                0.664887, -0.57178, -0.867565,
                                                                                                                                                0.0234, -0.496774, -0.637653,
                                                                                                                                                0.454291, -0.622108, -0.889903,
                                                                                                                                                0.063821, -0.451664, -0.867565,
                                                                                                                                                0.0234, -0.496774, -0.480617,
                                                                                                                                                0.664887, -0.57178, -0.867565,
                                                                                                                                                0.0234, -0.496774, -0.889903,
                                                                                                                                                0.063821, -0.451664, -0.92326, -0.049629, -0.380956, -0.270981,
                                                                                                                                                0.856487, -0.439317, -0.480617,
                                                                                                                                                0.664887, -0.57178, -0.257842,
                                                                                                                                                0.821581, -0.508451, -0.883471, -0.293087, -0.365484, -0.754453, -0.435584, -0.490987, -0.942521, -0.242961, -0.2294, -0.883471, -0.293087, -0.365484, -0.861044, -0.239473, -0.448615, -0.754453, -0.435584, -0.490987, -0.786707, -0.148669, -0.599157, -0.871987, -0.137954, -0.469689, -0.891357, -0.052625, -0.450238, -0.891357, -0.052625, -0.450238, -0.871987, -0.137954, -0.469689, -0.948841, -0.033486, -0.313973, -0.871987, -0.137954, -0.469689, -0.93858, -0.126324, -0.321106, -0.948841, -0.033486, -0.313973, -0.948841, -0.033486, -0.313973, -0.93858, -0.126324, -0.321106, -0.985526, -0.016431, -0.168723, -0.93858, -0.126324, -0.321106, -0.980871, -0.114462, -0.157453, -0.985526, -0.016431, -0.168723, -0.985526, -0.016431, -0.168723, -0.980871, -0.114462, -0.157453, -0.99983, -0.002472, -0.01827, -0.980871, -0.114462, -0.157453, -0.994571, -0.103036,
                                                                                                                                                0.01457, -0.99983, -0.002472, -0.01827, -0.99983, -0.002472, -0.01827, -0.994571, -0.103036,
                                                                                                                                                0.01457, -0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089, -0.99983, -0.002472, -0.01827, -0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089, -0.999606, -0.015026,
                                                                                                                                                0.023718, -0.982837, -0.01745,
                                                                                                                                                0.183648, -0.999606, -0.015026,
                                                                                                                                                0.023718, -0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089, -0.999606, -0.015026,
                                                                                                                                                0.023718, -0.982837, -0.01745,
                                                                                                                                                0.183648, -0.945193,
                                                                                                                                                0.270078,
                                                                                                                                                0.183489, -0.945193,
                                                                                                                                                0.270078,
                                                                                                                                                0.183489, -0.982837, -0.01745,
                                                                                                                                                0.183648, -0.898442,
                                                                                                                                                0.215062,
                                                                                                                                                0.382818, -0.945193,
                                                                                                                                                0.270078,
                                                                                                                                                0.183489, -0.898442,
                                                                                                                                                0.215062,
                                                                                                                                                0.382818, -0.772813,
                                                                                                                                                0.586148,
                                                                                                                                                0.24329, -0.898442,
                                                                                                                                                0.215062,
                                                                                                                                                0.382818, -0.736129,
                                                                                                                                                0.50889,
                                                                                                                                                0.446257, -0.772813,
                                                                                                                                                0.586148,
                                                                                                                                                0.24329, -0.945193,
                                                                                                                                                0.270078,
                                                                                                                                                0.183489, -0.772813,
                                                                                                                                                0.586148,
                                                                                                                                                0.24329, -0.760818,
                                                                                                                                                0.648659,
                                                                                                                                                0.019942, -0.94425,
                                                                                                                                                0.327658, -0.032133, -0.945193,
                                                                                                                                                0.270078,
                                                                                                                                                0.183489, -0.760818,
                                                                                                                                                0.648659,
                                                                                                                                                0.019942, -0.94425,
                                                                                                                                                0.327658, -0.032133, -0.999606, -0.015026,
                                                                                                                                                0.023718, -0.945193,
                                                                                                                                                0.270078,
                                                                                                                                                0.183489, -0.990316, -0.009426, -0.138512, -0.999606, -0.015026,
                                                                                                                                                0.023718, -0.94425,
                                                                                                                                                0.327658, -0.032133, -0.999606, -0.015026,
                                                                                                                                                0.023718, -0.990316, -0.009426, -0.138512, -0.99983, -0.002472, -0.01827, -0.985526, -0.016431, -0.168723, -0.99983, -0.002472, -0.01827, -0.990316, -0.009426, -0.138512, -0.990316, -0.009426, -0.138512, -0.955313, -0.00106, -0.295593, -0.985526, -0.016431, -0.168723, -0.955313, -0.00106, -0.295593, -0.990316, -0.009426, -0.138512, -0.890951,
                                                                                                                                                0.385921, -0.239314, -0.890951,
                                                                                                                                                0.385921, -0.239314, -0.990316, -0.009426, -0.138512, -0.94425,
                                                                                                                                                0.327658, -0.032133, -0.890951,
                                                                                                                                                0.385921, -0.239314, -0.94425,
                                                                                                                                                0.327658, -0.032133, -0.695477,
                                                                                                                                                0.691467, -0.19541, -0.695477,
                                                                                                                                                0.691467, -0.19541, -0.94425,
                                                                                                                                                0.327658, -0.032133, -0.760818,
                                                                                                                                                0.648659,
                                                                                                                                                0.019942, -0.585696,
                                                                                                                                                0.718458, -0.375204, -0.890951,
                                                                                                                                                0.385921, -0.239314, -0.695477,
                                                                                                                                                0.691467, -0.19541, -0.793153,
                                                                                                                                                0.446605, -0.414069, -0.890951,
                                                                                                                                                0.385921, -0.239314, -0.585696,
                                                                                                                                                0.718458, -0.375204, -0.793153,
                                                                                                                                                0.446605, -0.414069, -0.955313, -0.00106, -0.295593, -0.890951,
                                                                                                                                                0.385921, -0.239314, -0.897326,
                                                                                                                                                0.009249, -0.441271, -0.955313, -0.00106, -0.295593, -0.793153,
                                                                                                                                                0.446605, -0.414069, -0.955313, -0.00106, -0.295593, -0.897326,
                                                                                                                                                0.009249, -0.441271, -0.948841, -0.033486, -0.313973, -0.891357, -0.052625, -0.450238, -0.948841, -0.033486, -0.313973, -0.897326,
                                                                                                                                                0.009249, -0.441271, -0.948841, -0.033486, -0.313973, -0.985526, -0.016431, -0.168723, -0.955313, -0.00106, -0.295593, -0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089, -0.959624,
                                                                                                                                                0.013758,
                                                                                                                                                0.280951, -0.982837, -0.01745,
                                                                                                                                                0.183648, -0.906801,
                                                                                                                                                0.015897,
                                                                                                                                                0.421258, -0.834632,
                                                                                                                                                0.014645,
                                                                                                                                                0.550613, -0.88074, -0.013801,
                                                                                                                                                0.4734,
                                                                                                                                                0.92326, -0.049629, -0.380956,
                                                                                                                                                0.978938, -0.029296, -0.202043,
                                                                                                                                                0.867565,
                                                                                                                                                0.0234, -0.496774,
                                                                                                                                                0.702106,
                                                                                                                                                0,
                                                                                                                                                0.712073,
                                                                                                                                                0.67373,
                                                                                                                                                0.007008,
                                                                                                                                                0.738944,
                                                                                                                                                0.709207, -0.003661,
                                                                                                                                                0.70499,
                                                                                                                                                0.978076, -0.0926,
                                                                                                                                                0.18653,
                                                                                                                                                0.994571, -0.103036,
                                                                                                                                                0.01457,
                                                                                                                                                0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089,
                                                                                                                                                0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089,
                                                                                                                                                0.994571, -0.103036,
                                                                                                                                                0.01457,
                                                                                                                                                0.99983, -0.002472, -0.01827,
                                                                                                                                                0.991074,
                                                                                                                                                0.007687,
                                                                                                                                                0.133089,
                                                                                                                                                0.99983, -0.002472, -0.01827,
                                                                                                                                                0.982837, -0.01745,
                                                                                                                                                0.183648,
                                                                                                                                                0.985526, -0.016431, -0.168723,
                                                                                                                                                0.948841, -0.033486, -0.313973,
                                                                                                                                                0.990316, -0.009426, -0.138512,
                                                                                                                                                0.985526, -0.016431, -0.168723,
                                                                                                                                                0.93858, -0.126324, -0.321106,
                                                                                                                                                0.948841, -0.033486, -0.313973,
                                                                                                                                                0.480617,
                                                                                                                                                0.664887, -0.57178,
                                                                                                                                                0.270981,
                                                                                                                                                0.856487, -0.439317,
                                                                                                                                                0.210342,
                                                                                                                                                0.817992, -0.535393,
                                                                                                                                                0.480617,
                                                                                                                                                0.664887, -0.57178,
                                                                                                                                                0.668153,
                                                                                                                                                0.581526, -0.464111,
                                                                                                                                                0.270981,
                                                                                                                                                0.856487, -0.439317,
                                                                                                                                                0.270981,
                                                                                                                                                0.856487, -0.439317,
                                                                                                                                                0.668153,
                                                                                                                                                0.581526, -0.464111,
                                                                                                                                                0.857505,
                                                                                                                                                0.297619, -0.419653,
                                                                                                                                                0.857505,
                                                                                                                                                0.297619, -0.419653,
                                                                                                                                                0.668153,
                                                                                                                                                0.581526, -0.464111,
                                                                                                                                                0.960609,
                                                                                                                                                0.183445, -0.208755,
                                                                                                                                                0.857505,
                                                                                                                                                0.297619, -0.419653,
                                                                                                                                                0.960609,
                                                                                                                                                0.183445, -0.208755,
                                                                                                                                                0.909731,
                                                                                                                                                0.16887, -0.379306,
                                                                                                                                                0.752994,
                                                                                                                                                0.233675, -0.615139,
                                                                                                                                                0.857505,
                                                                                                                                                0.297619, -0.419653,
                                                                                                                                                0.909731,
                                                                                                                                                0.16887, -0.379306,
                                                                                                                                                0.857505,
                                                                                                                                                0.297619, -0.419653,
                                                                                                                                                0.752994,
                                                                                                                                                0.233675, -0.615139,
                                                                                                                                                0.270981,
                                                                                                                                                0.856487, -0.439317,
                                                                                                                                                0.210342,
                                                                                                                                                0.817992, -0.535393,
                                                                                                                                                0.270981,
                                                                                                                                                0.856487, -0.439317,
                                                                                                                                                0.752994,
                                                                                                                                                0.233675, -0.615139,
                                                                                                                                                0.752994,
                                                                                                                                                0.233675, -0.615139,
                                                                                                                                                0.738366,
                                                                                                                                                0.439425, -0.511587,
                                                                                                                                                0.210342,
                                                                                                                                                0.817992, -0.535393,
                                                                                                                                                0.752994,
                                                                                                                                                0.233675, -0.615139,
                                                                                                                                                0.909731,
                                                                                                                                                0.16887, -0.379306,
                                                                                                                                                0.738366,
                                                                                                                                                0.439425, -0.511587,
                                                                                                                                                0.738366,
                                                                                                                                                0.439425, -0.511587,
                                                                                                                                                0.909731,
                                                                                                                                                0.16887, -0.379306,
                                                                                                                                                0.704722,
                                                                                                                                                0.575289, -0.415221,
                                                                                                                                                0.738366,
                                                                                                                                                0.439425, -0.511587,
                                                                                                                                                0.704722,
                                                                                                                                                0.575289, -0.415221,
                                                                                                                                                0.647811,
                                                                                                                                                0.643587, -0.407599,
                                                                                                                                                0.704722,
                                                                                                                                                0.575289, -0.415221,
                                                                                                                                                0.52936,
                                                                                                                                                0.786798, -0.317375,
                                                                                                                                                0.647811,
                                                                                                                                                0.643587, -0.407599,
                                                                                                                                                0.647811,
                                                                                                                                                0.643587, -0.407599,
                                                                                                                                                0.52936,
                                                                                                                                                0.786798, -0.317375,
                                                                                                                                                0.554116,
                                                                                                                                                0.798851, -0.234077,
                                                                                                                                                0.52936,
                                                                                                                                                0.786798, -0.317375,
                                                                                                                                                0.368399,
                                                                                                                                                0.91714, -0.152104,
                                                                                                                                                0.554116,
                                                                                                                                                0.798851, -0.234077,
                                                                                                                                                0.554116,
                                                                                                                                                0.798851, -0.234077,
                                                                                                                                                0.368399,
                                                                                                                                                0.91714, -0.152104,
                                                                                                                                                0.467431,
                                                                                                                                                0.883813, -0.019567,
                                                                                                                                                0.368399,
                                                                                                                                                0.91714, -0.152104,
                                                                                                                                                0.237343,
                                                                                                                                                0.970668,
                                                                                                                                                0.038367,
                                                                                                                                                0.467431,
                                                                                                                                                0.883813, -0.019567,
                                                                                                                                                0.467431,
                                                                                                                                                0.883813, -0.019567,
                                                                                                                                                0.237343,
                                                                                                                                                0.970668,
                                                                                                                                                0.038367,
                                                                                                                                                0.387731,
                                                                                                                                                0.89932,
                                                                                                                                                0.202209,
                                                                                                                                                0.237343,
                                                                                                                                                0.970668,
                                                                                                                                                0.038367,
                                                                                                                                                0.136572,
                                                                                                                                                0.964224,
                                                                                                                                                0.227199,
                                                                                                                                                0.387731,
                                                                                                                                                0.89932,
                                                                                                                                                0.202209,
                                                                                                                                                0.387731,
                                                                                                                                                0.89932,
                                                                                                                                                0.202209,
                                                                                                                                                0.136572,
                                                                                                                                                0.964224,
                                                                                                                                                0.227199,
                                                                                                                                                0.313257,
                                                                                                                                                0.859468,
                                                                                                                                                0.403962,
                                                                                                                                                0.136572,
                                                                                                                                                0.964224,
                                                                                                                                                0.227199,
                                                                                                                                                0.061727,
                                                                                                                                                0.91474,
                                                                                                                                                0.3993,
                                                                                                                                                0.313257,
                                                                                                                                                0.859468,
                                                                                                                                                0.403962,
                                                                                                                                                0.313257,
                                                                                                                                                0.859468,
                                                                                                                                                0.403962,
                                                                                                                                                0.061727,
                                                                                                                                                0.91474,
                                                                                                                                                0.3993,
                                                                                                                                                0.245004,
                                                                                                                                                0.783613,
                                                                                                                                                0.570898,
                                                                                                                                                0.061727,
                                                                                                                                                0.91474,
                                                                                                                                                0.3993,
                                                                                                                                                0.007706,
                                                                                                                                                0.836796,
                                                                                                                                                0.547461,
                                                                                                                                                0.245004,
                                                                                                                                                0.783613,
                                                                                                                                                0.570898,
                                                                                                                                                0.245004,
                                                                                                                                                0.783613,
                                                                                                                                                0.570898,
                                                                                                                                                0.007706,
                                                                                                                                                0.836796,
                                                                                                                                                0.547461,
                                                                                                                                                0.184702,
                                                                                                                                                0.689327,
                                                                                                                                                0.700509,
                                                                                                                                                0.007706,
                                                                                                                                                0.836796,
                                                                                                                                                0.547461, -0.030299,
                                                                                                                                                0.741864,
                                                                                                                                                0.669866,
                                                                                                                                                0.184702,
                                                                                                                                                0.689327,
                                                                                                                                                0.700509,
                                                                                                                                                0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429,
                                                                                                                                                0.184702,
                                                                                                                                                0.689327,
                                                                                                                                                0.700509, -0.030299,
                                                                                                                                                0.741864,
                                                                                                                                                0.669866, -0.030299,
                                                                                                                                                0.741864,
                                                                                                                                                0.669866, -0.057851,
                                                                                                                                                0.656315,
                                                                                                                                                0.752266,
                                                                                                                                                0.132867,
                                                                                                                                                0.588602,
                                                                                                                                                0.797429, -0.668153,
                                                                                                                                                0.581526, -0.464111, -0.857629,
                                                                                                                                                0.274746, -0.434726, -0.958314,
                                                                                                                                                0.068808, -0.277308, -0.958314,
                                                                                                                                                0.068808, -0.277308, -0.857629,
                                                                                                                                                0.274746, -0.434726, -0.798682,
                                                                                                                                                0.302903, -0.519958, -0.958314,
                                                                                                                                                0.068808, -0.277308, -0.798682,
                                                                                                                                                0.302903, -0.519958, -0.848523,
                                                                                                                                                0.404826, -0.34077, -0.848523,
                                                                                                                                                0.404826, -0.34077, -0.798682,
                                                                                                                                                0.302903, -0.519958, -0.790942,
                                                                                                                                                0.455378, -0.408708, -0.798682,
                                                                                                                                                0.302903, -0.519958, -0.674525,
                                                                                                                                                0.523214, -0.520829, -0.790942,
                                                                                                                                                0.455378, -0.408708, -0.616795,
                                                                                                                                                0.697429, -0.364906, -0.790942,
                                                                                                                                                0.455378, -0.408708, -0.674525,
                                                                                                                                                0.523214, -0.520829,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "uv": [
                                                                                                                                                141.673731,
                                                                                                                                                7.407802,
                                                                                                                                                142.556532,
                                                                                                                                                11.637781,
                                                                                                                                                143.258373,
                                                                                                                                                8.274881,
                                                                                                                                                109.701922, -44.518206,
                                                                                                                                                110.403763, -41.155306,
                                                                                                                                                111.105604, -44.518206,
                                                                                                                                                47.966554, -77.716737,
                                                                                                                                                48.668395, -74.353837,
                                                                                                                                                49.370235, -77.716737,
                                                                                                                                                10.388271, -82.803776,
                                                                                                                                                48.433271, -83.234066,
                                                                                                                                                10.364063, -86.239048,
                                                                                                                                                49.724827, -67.255979,
                                                                                                                                                114.347958, -67.255979,
                                                                                                                                                49.724827, -71.064165,
                                                                                                                                                114.347958, -71.064165,
                                                                                                                                                49.724827, -71.064165,
                                                                                                                                                114.347958, -67.255979,
                                                                                                                                                114.347958, -50.579937,
                                                                                                                                                114.347958, -54.388124,
                                                                                                                                                49.724827, -50.579937,
                                                                                                                                                116.075678, -53.575572,
                                                                                                                                                116.048977, -49.767479,
                                                                                                                                                218.033149, -48.974081,
                                                                                                                                                116.875415, -99.973864,
                                                                                                                                                218.796144, -94.761288,
                                                                                                                                                218.85522, -98.740955,
                                                                                                                                                114.347958, -67.255979,
                                                                                                                                                216.330819, -67.255979,
                                                                                                                                                114.347958, -71.064165,
                                                                                                                                                171.571512, -139.608596,
                                                                                                                                                172.273353, -142.688454,
                                                                                                                                                170.687193, -143.489217,
                                                                                                                                                50.823039, -190.288083,
                                                                                                                                                51.52488, -193.367941,
                                                                                                                                                50.121198, -193.367941, -173.95695, -123.231951, -174.345419, -126.603821, -175.635242, -125.908038, -153.169062, -115.437593, -153.26177, -118.70112, -154.509167, -114.844401, -166.568112, -110.485332, -165.480135, -114.390019, -167.907857, -113.107647, -147.332036, -98.754801, -150.7695, -100.178176, -149.828765, -97.612588, -151.667139, -92.355458, -155.061062, -90.597838, -151.607053, -89.215093, -135.641436, -71.804049, -139.72563, -72.642565, -139.100355, -70.178067, -137.935053, -64.243819, -142.061795, -62.029319, -137.97368, -61.210131, -119.873142, -35.999091, -124.394334, -36.281061, -124.063186, -33.906834, -120.42646, -28.96368, -125.032161, -26.288385, -120.510748, -26.00998, -96.933438,
                                                                                                                                                10.018405, -101.675773,
                                                                                                                                                10.290752, -101.588482,
                                                                                                                                                12.606889, -96.644744,
                                                                                                                                                15.064992, -96.590111,
                                                                                                                                                12.152668, -101.387111,
                                                                                                                                                15.336778, -61.178334,
                                                                                                                                                65.439189, -65.919676,
                                                                                                                                                66.314147, -65.969958,
                                                                                                                                                68.631383, -62.505431,
                                                                                                                                                58.380433, -62.595295,
                                                                                                                                                55.468984, -67.247229,
                                                                                                                                                59.252913, -3.025673,
                                                                                                                                                121.640226, -7.514329,
                                                                                                                                                123.251613, -7.485623,
                                                                                                                                                125.648649, -13.17893,
                                                                                                                                                96.18941, -13.585273,
                                                                                                                                                93.26258, -17.685171,
                                                                                                                                                97.750946,
                                                                                                                                                81.63956,
                                                                                                                                                154.816205,
                                                                                                                                                82.130278,
                                                                                                                                                157.310982,
                                                                                                                                                85.542189,
                                                                                                                                                152.279734,
                                                                                                                                                52.596324,
                                                                                                                                                161.994753,
                                                                                                                                                49.049753,
                                                                                                                                                161.994753,
                                                                                                                                                52.943723,
                                                                                                                                                164.51349,
                                                                                                                                                49.049753,
                                                                                                                                                196.761138,
                                                                                                                                                52.596324,
                                                                                                                                                196.761138,
                                                                                                                                                49.525991,
                                                                                                                                                194.070334,
                                                                                                                                                52.120086,
                                                                                                                                                194.070334,
                                                                                                                                                49.525991,
                                                                                                                                                194.070334,
                                                                                                                                                52.596324,
                                                                                                                                                196.761138,
                                                                                                                                                49.525991,
                                                                                                                                                219.224522,
                                                                                                                                                52.120086,
                                                                                                                                                219.224522,
                                                                                                                                                50.121198,
                                                                                                                                                216.340569,
                                                                                                                                                51.52488,
                                                                                                                                                216.340569,
                                                                                                                                                50.121198,
                                                                                                                                                216.340569,
                                                                                                                                                52.120086,
                                                                                                                                                219.224522,
                                                                                                                                                50.823039,
                                                                                                                                                98.714843,
                                                                                                                                                50.121198,
                                                                                                                                                107.09585,
                                                                                                                                                51.52488,
                                                                                                                                                107.09585, -116.847175,
                                                                                                                                                66.290562, -120.238154,
                                                                                                                                                68.374429, -119.011658,
                                                                                                                                                74.417607,
                                                                                                                                                160.533644,
                                                                                                                                                183.915522,
                                                                                                                                                63.630379,
                                                                                                                                                146.369979,
                                                                                                                                                159.468759,
                                                                                                                                                187.750526,
                                                                                                                                                49.724827,
                                                                                                                                                29.198891,
                                                                                                                                                49.724827,
                                                                                                                                                42.614557,
                                                                                                                                                114.347958,
                                                                                                                                                29.198891,
                                                                                                                                                58.273856,
                                                                                                                                                28.496634,
                                                                                                                                                20.295421,
                                                                                                                                                39.771419,
                                                                                                                                                58.436007,
                                                                                                                                                41.91132, -114.347958, -2.364594, -114.347958,
                                                                                                                                                11.051073, -49.724827, -2.364594, -114.440456,
                                                                                                                                                11.307234, -114.470482, -2.108399, -216.409257,
                                                                                                                                                20.382287, -208.136853,
                                                                                                                                                62.140486, -112.298472,
                                                                                                                                                20.759939, -209.201738,
                                                                                                                                                58.305482,
                                                                                                                                                19.413001, -141.036756,
                                                                                                                                                21.091293, -143.712843,
                                                                                                                                                19.80147, -144.408626, -160.539163, -99.461506, -161.942845, -99.461506, -161.241004, -96.381648, -161.942845, -82.15883, -160.539163, -82.15883, -162.538052, -85.042782, -159.943957, -85.042782, -162.538052, -85.042782, -160.539163, -82.15883, -162.538052, -63.293626, -159.943957, -63.293626, -163.014289, -65.98443, -159.467719, -65.98443, -163.014289, -65.98443, -159.943957, -63.293626, -163.014289, -39.106732, -159.467719, -39.106732, -163.361689, -41.625469, -159.12032, -41.625469, -163.361689, -41.625469, -159.467719, -39.106732, -163.361689, -9.756121, -159.12032, -9.756121, -163.57305, -12.143994, -158.908958, -12.143994, -163.57305, -12.143994, -159.12032, -9.756121, -163.57305,
                                                                                                                                                23.023117, -158.908958,
                                                                                                                                                23.023117, -163.643994,
                                                                                                                                                20.706421, -158.838014,
                                                                                                                                                20.706421, -163.643994,
                                                                                                                                                20.706421, -158.908958,
                                                                                                                                                23.023117, -163.643994,
                                                                                                                                                55.830036, -158.838014,
                                                                                                                                                55.830036, -163.57305,
                                                                                                                                                53.513341, -158.908958,
                                                                                                                                                53.513341, -163.57305,
                                                                                                                                                53.513341, -158.838014,
                                                                                                                                                55.830036, -163.57305,
                                                                                                                                                84.860262, -158.908958,
                                                                                                                                                84.860262, -163.361689,
                                                                                                                                                82.47239, -159.12032,
                                                                                                                                                82.47239, -163.361689,
                                                                                                                                                82.47239, -158.908958,
                                                                                                                                                84.860262, -163.361689,
                                                                                                                                                107.676171, -159.12032,
                                                                                                                                                107.676171, -163.014289,
                                                                                                                                                105.157435, -159.467719,
                                                                                                                                                105.157435, -163.014289,
                                                                                                                                                105.157435, -159.12032,
                                                                                                                                                107.676171, -159.467719,
                                                                                                                                                123.827301, -159.943957,
                                                                                                                                                121.136497, -163.014289,
                                                                                                                                                123.827301, -6.336816,
                                                                                                                                                112.336727, -8.3222,
                                                                                                                                                118.323914, -6.732746,
                                                                                                                                                120.546719, -64.555511,
                                                                                                                                                90.072108, -67.341847,
                                                                                                                                                87.621978, -67.141812,
                                                                                                                                                95.825299, -216.053805,
                                                                                                                                                24.497447, -215.759619,
                                                                                                                                                28.19613, -114.66949,
                                                                                                                                                10.312464, -114.536963,
                                                                                                                                                12.169359, -114.647032,
                                                                                                                                                8.362763, -216.340585,
                                                                                                                                                22.41484, -114.347958,
                                                                                                                                                5.045619, -114.347958,
                                                                                                                                                8.853806, -49.724827,
                                                                                                                                                5.045619, -49.724827,
                                                                                                                                                8.853806, -49.724827,
                                                                                                                                                5.045619, -114.347958,
                                                                                                                                                8.853806, -47.997387,
                                                                                                                                                4.202995, -10.077524,
                                                                                                                                                10.651124, -47.626802,
                                                                                                                                                0.412882, -10.218024,
                                                                                                                                                11.253067, -9.786996,
                                                                                                                                                7.961271, -47.590294,
                                                                                                                                                0.861625, -8.954455,
                                                                                                                                                7.68365, -9.549662,
                                                                                                                                                10.949754, -7.550773,
                                                                                                                                                7.68365, -6.955567,
                                                                                                                                                10.949754, -7.550773,
                                                                                                                                                7.68365, -9.549662,
                                                                                                                                                10.949754, -1.282845,
                                                                                                                                                9.448406,
                                                                                                                                                1.31125,
                                                                                                                                                9.448406, -0.687638,
                                                                                                                                                6.182302,
                                                                                                                                                1.31125,
                                                                                                                                                13.118627, -1.282845,
                                                                                                                                                13.118627,
                                                                                                                                                1.787488,
                                                                                                                                                16.292909, -1.759083,
                                                                                                                                                16.292909,
                                                                                                                                                1.787488,
                                                                                                                                                16.292909, -1.282845,
                                                                                                                                                13.118627,
                                                                                                                                                1.787488,
                                                                                                                                                19.788294, -1.759083,
                                                                                                                                                19.788294,
                                                                                                                                                2.134887,
                                                                                                                                                22.884059, -2.106482,
                                                                                                                                                22.884059,
                                                                                                                                                2.134887,
                                                                                                                                                22.884059, -1.759083,
                                                                                                                                                19.788294,
                                                                                                                                                2.134887,
                                                                                                                                                25.936762, -2.106482,
                                                                                                                                                25.936762,
                                                                                                                                                2.346249,
                                                                                                                                                28.975036, -2.317844,
                                                                                                                                                28.975036,
                                                                                                                                                2.346249,
                                                                                                                                                28.975036, -2.106482,
                                                                                                                                                25.936762,
                                                                                                                                                2.346249,
                                                                                                                                                31.294435, -2.317844,
                                                                                                                                                31.294435,
                                                                                                                                                2.417193,
                                                                                                                                                34.302292, -2.388788,
                                                                                                                                                34.302292,
                                                                                                                                                2.417193,
                                                                                                                                                34.302292, -2.317844,
                                                                                                                                                31.294435,
                                                                                                                                                2.417193,
                                                                                                                                                35.633537, -2.388788,
                                                                                                                                                35.633537,
                                                                                                                                                2.346249,
                                                                                                                                                38.641394, -2.317844,
                                                                                                                                                38.641394,
                                                                                                                                                2.346249,
                                                                                                                                                38.641394, -2.388788,
                                                                                                                                                35.633537,
                                                                                                                                                2.346249,
                                                                                                                                                38.825839, -2.317844,
                                                                                                                                                38.825839,
                                                                                                                                                2.134887,
                                                                                                                                                41.864113, -2.106482,
                                                                                                                                                41.864113,
                                                                                                                                                2.134887,
                                                                                                                                                41.864113, -2.317844,
                                                                                                                                                38.825839,
                                                                                                                                                2.134887,
                                                                                                                                                40.870582, -2.106482,
                                                                                                                                                40.870582,
                                                                                                                                                1.787488,
                                                                                                                                                43.966347, -1.759083,
                                                                                                                                                43.966347,
                                                                                                                                                1.787488,
                                                                                                                                                43.966347, -2.106482,
                                                                                                                                                40.870582,
                                                                                                                                                1.787488,
                                                                                                                                                41.878006, -1.759083,
                                                                                                                                                41.878006,
                                                                                                                                                1.31125,
                                                                                                                                                45.052288, -1.282845,
                                                                                                                                                45.052288,
                                                                                                                                                1.31125,
                                                                                                                                                45.052288, -1.759083,
                                                                                                                                                41.878006, -1.282845,
                                                                                                                                                42.02142, -0.687638,
                                                                                                                                                45.287524,
                                                                                                                                                1.31125,
                                                                                                                                                42.02142, -6.955567,
                                                                                                                                                40.520072, -9.549662,
                                                                                                                                                40.520072, -7.550773,
                                                                                                                                                43.786176, -9.549662,
                                                                                                                                                43.816278, -6.955567,
                                                                                                                                                43.816278, -10.025899,
                                                                                                                                                40.641996, -6.479329,
                                                                                                                                                40.641996, -10.025899,
                                                                                                                                                40.641996, -6.955567,
                                                                                                                                                43.816278, -10.025899,
                                                                                                                                                43.041852, -6.479329,
                                                                                                                                                43.041852, -10.373299,
                                                                                                                                                39.946087, -6.13193,
                                                                                                                                                39.946087, -10.373299,
                                                                                                                                                39.946087, -6.479329,
                                                                                                                                                43.041852, -10.373299,
                                                                                                                                                41.290997, -6.13193,
                                                                                                                                                41.290997, -10.58466,
                                                                                                                                                38.252722, -5.920568,
                                                                                                                                                38.252722, -10.58466,
                                                                                                                                                38.252722, -6.13193,
                                                                                                                                                41.290997, -10.58466,
                                                                                                                                                38.447081, -5.920568,
                                                                                                                                                38.447081, -10.655604,
                                                                                                                                                35.439224, -5.849624,
                                                                                                                                                35.439224, -10.655604,
                                                                                                                                                35.439224, -5.920568,
                                                                                                                                                38.447081, -5.849624,
                                                                                                                                                34.496605, -5.920568,
                                                                                                                                                31.488748, -10.655604,
                                                                                                                                                34.496605, -10.58466,
                                                                                                                                                31.488748, -10.655604,
                                                                                                                                                34.496605, -5.920568,
                                                                                                                                                31.488748, -11.651422,
                                                                                                                                                34.726764, -11.648447,
                                                                                                                                                31.718072, -49.695697,
                                                                                                                                                30.193736, -49.697959,
                                                                                                                                                30.300842, -11.650612,
                                                                                                                                                31.822787, -49.695195,
                                                                                                                                                26.492656, -11.565026,
                                                                                                                                                30.092597, -11.53329,
                                                                                                                                                27.047145, -49.582802,
                                                                                                                                                24.574513, -10.373299,
                                                                                                                                                26.509878, -10.58466,
                                                                                                                                                29.548153, -6.13193,
                                                                                                                                                26.509878, -5.920568,
                                                                                                                                                29.548153, -6.13193,
                                                                                                                                                26.509878, -10.58466,
                                                                                                                                                29.548153, -6.13193,
                                                                                                                                                23.808553, -6.479329,
                                                                                                                                                20.712789, -10.373299,
                                                                                                                                                23.808553, -10.025899,
                                                                                                                                                20.712789, -10.373299,
                                                                                                                                                23.808553, -6.479329,
                                                                                                                                                20.712789, -11.376633,
                                                                                                                                                24.455826, -11.274151,
                                                                                                                                                21.342317, -49.312091,
                                                                                                                                                17.697828, -49.373488,
                                                                                                                                                19.183526, -11.323389,
                                                                                                                                                22.698796, -49.28262,
                                                                                                                                                15.376423, -10.980505,
                                                                                                                                                18.081799, -10.7504,
                                                                                                                                                14.880249, -48.728353,
                                                                                                                                                9.737919, -9.549662,
                                                                                                                                                14.354636, -10.025899,
                                                                                                                                                17.528918, -6.955567,
                                                                                                                                                14.354636, -6.479329,
                                                                                                                                                17.528918, -6.955567,
                                                                                                                                                14.354636, -10.025899,
                                                                                                                                                17.528918, -48.900383,
                                                                                                                                                12.179786, -10.87996,
                                                                                                                                                16.998075, -48.699845,
                                                                                                                                                8.376884, -49.724827,
                                                                                                                                                14.737971, -49.724827,
                                                                                                                                                10.929785, -114.347958,
                                                                                                                                                14.737971, -114.347958,
                                                                                                                                                10.929785, -114.347958,
                                                                                                                                                14.737971, -49.724827,
                                                                                                                                                10.929785, -114.427999,
                                                                                                                                                15.981268, -114.469344,
                                                                                                                                                12.173306, -216.345082,
                                                                                                                                                24.411401, -216.12423,
                                                                                                                                                26.580439, -114.543151,
                                                                                                                                                12.098678, -216.263518,
                                                                                                                                                23.140153, -95.953197,
                                                                                                                                                95.853782, -98.045522,
                                                                                                                                                93.119345, -99.864886,
                                                                                                                                                101.134995, -75.261656,
                                                                                                                                                111.03366, -78.951481,
                                                                                                                                                116.4722, -78.080561,
                                                                                                                                                118.86097, -124.024782,
                                                                                                                                                86.939075, -125.416618,
                                                                                                                                                84.053563, -129.00877,
                                                                                                                                                91.557525, -216.286751,
                                                                                                                                                27.566592, -114.43802,
                                                                                                                                                15.673299, -216.333277,
                                                                                                                                                24.363277, -114.358767,
                                                                                                                                                20.487474, -114.363139,
                                                                                                                                                16.679289, -216.334147,
                                                                                                                                                27.474094, -114.347958,
                                                                                                                                                16.547988, -114.347958,
                                                                                                                                                20.356174, -49.724827,
                                                                                                                                                16.547988, -49.724827,
                                                                                                                                                20.356174, -49.724827,
                                                                                                                                                16.547988, -114.347958,
                                                                                                                                                20.356174, -114.347958,
                                                                                                                                                21.7838, -114.347958,
                                                                                                                                                25.591987, -49.724827,
                                                                                                                                                21.7838, -114.312301,
                                                                                                                                                25.327577, -114.30349,
                                                                                                                                                21.5194, -216.314501,
                                                                                                                                                31.120814, -216.331034,
                                                                                                                                                30.564019, -114.355848,
                                                                                                                                                20.589315, -216.333443,
                                                                                                                                                27.543537, -146.422836,
                                                                                                                                                69.387629, -147.181393,
                                                                                                                                                66.463949, -152.083801,
                                                                                                                                                73.267866, -127.51168,
                                                                                                                                                82.937228, -132.525153,
                                                                                                                                                87.523656, -132.189765,
                                                                                                                                                89.897287, -159.432732,
                                                                                                                                                49.113664, -165.151652,
                                                                                                                                                52.907966, -165.091782,
                                                                                                                                                55.224975, -163.266617,
                                                                                                                                                47.913865, -163.493204,
                                                                                                                                                45.002263, -169.1699,
                                                                                                                                                51.097185, -216.301862,
                                                                                                                                                34.683552, -114.288673,
                                                                                                                                                26.064692, -216.296212,
                                                                                                                                                31.763152, -114.275403,
                                                                                                                                                30.169981, -114.269839,
                                                                                                                                                26.361798, -216.28625,
                                                                                                                                                34.942437, -114.347958,
                                                                                                                                                26.528717, -114.347958,
                                                                                                                                                30.336904, -49.724827,
                                                                                                                                                26.528717, -49.724827,
                                                                                                                                                30.336904, -49.724827,
                                                                                                                                                26.528717, -114.347958,
                                                                                                                                                30.336904, -114.347958,
                                                                                                                                                30.684408, -114.347958,
                                                                                                                                                34.492595, -49.724827,
                                                                                                                                                30.684408, -114.241131,
                                                                                                                                                34.703945, -114.248175,
                                                                                                                                                30.895765, -216.250515,
                                                                                                                                                38.575666, -216.228377,
                                                                                                                                                38.769766, -114.228616,
                                                                                                                                                31.055683, -216.238467,
                                                                                                                                                35.849378, -175.765661,
                                                                                                                                                25.939309, -175.563866,
                                                                                                                                                23.025885, -181.495942,
                                                                                                                                                28.52344, -184.022254,
                                                                                                                                                26.137837, -178.102183,
                                                                                                                                                20.627356, -184.000343,
                                                                                                                                                23.820158, -195.22459,
                                                                                                                                                5.603748, -189.580981,
                                                                                                                                                0.470868, -195.240457,
                                                                                                                                                3.206592, -185.212041,
                                                                                                                                                6.253043, -184.674735,
                                                                                                                                                3.280734, -190.391632,
                                                                                                                                                8.331859, -216.134953,
                                                                                                                                                41.803246, -114.172501,
                                                                                                                                                34.675955, -216.172682,
                                                                                                                                                38.782999, -114.209669,
                                                                                                                                                38.642187, -114.231963,
                                                                                                                                                34.834066, -216.212679,
                                                                                                                                                41.695061, -114.347958,
                                                                                                                                                34.164753, -114.347958,
                                                                                                                                                37.972939, -49.724827,
                                                                                                                                                34.164753, -49.724827,
                                                                                                                                                37.972939, -49.724827,
                                                                                                                                                34.164753, -114.347958,
                                                                                                                                                37.972939, -49.788479,
                                                                                                                                                37.744685, -11.733199,
                                                                                                                                                37.736963, -49.77099,
                                                                                                                                                33.936539, -11.75065,
                                                                                                                                                40.404778, -11.733171,
                                                                                                                                                37.35921, -49.78845,
                                                                                                                                                37.36704, -49.844334,
                                                                                                                                                40.199152, -11.774904,
                                                                                                                                                39.518237, -49.805464,
                                                                                                                                                36.391164, -11.806152,
                                                                                                                                                41.519448, -11.769546,
                                                                                                                                                38.404468, -49.838517,
                                                                                                                                                39.110581, -49.910884,
                                                                                                                                                41.879348, -11.825275,
                                                                                                                                                40.554344, -49.85289,
                                                                                                                                                38.071602, -11.85472,
                                                                                                                                                41.735835, -11.805005,
                                                                                                                                                38.526412, -49.887347,
                                                                                                                                                39.942201, -49.966462,
                                                                                                                                                42.843172, -11.86895,
                                                                                                                                                40.879338, -49.89918,
                                                                                                                                                39.035579, -11.863743,
                                                                                                                                                41.303749, -11.815637,
                                                                                                                                                37.984202, -49.901934,
                                                                                                                                                40.154679, -8.954455,
                                                                                                                                                43.786176, -7.550773,
                                                                                                                                                43.786176, -9.549662,
                                                                                                                                                40.520072, -7.550773,
                                                                                                                                                39.765109, -8.954455,
                                                                                                                                                39.765109, -8.252614,
                                                                                                                                                43.128009, -11.782278,
                                                                                                                                                40.45035, -11.75807,
                                                                                                                                                37.015078, -49.827278,
                                                                                                                                                40.02006, -11.873962,
                                                                                                                                                40.529397, -49.911196,
                                                                                                                                                39.349063, -49.971093,
                                                                                                                                                43.156779, -49.724827,
                                                                                                                                                40.129222, -114.347958,
                                                                                                                                                40.129222, -49.724827,
                                                                                                                                                43.937409, -49.724827,
                                                                                                                                                43.719272, -49.724827,
                                                                                                                                                39.911086, -114.347958,
                                                                                                                                                43.719272, -114.347958,
                                                                                                                                                39.911086, -114.347958,
                                                                                                                                                43.719272, -49.724827,
                                                                                                                                                39.911086, -114.235908,
                                                                                                                                                44.521335, -114.26261,
                                                                                                                                                40.713242, -216.22008,
                                                                                                                                                45.314733, -114.102738,
                                                                                                                                                35.954433, -216.079957,
                                                                                                                                                38.115869, -215.995,
                                                                                                                                                41.825261, -114.190631,
                                                                                                                                                43.744532, -114.227578,
                                                                                                                                                39.936524, -216.179093,
                                                                                                                                                45.286812, -114.347958,
                                                                                                                                                38.826394, -114.347958,
                                                                                                                                                42.634581, -49.724827,
                                                                                                                                                38.826394, -49.724827,
                                                                                                                                                42.634581, -49.724827,
                                                                                                                                                38.826394, -114.347958,
                                                                                                                                                42.634581, -49.724827,
                                                                                                                                                40.705813, -49.724827,
                                                                                                                                                36.897626, -114.347958,
                                                                                                                                                40.705813, -114.347958,
                                                                                                                                                36.897626, -114.347958,
                                                                                                                                                40.705813, -49.724827,
                                                                                                                                                36.897626, -114.188273,
                                                                                                                                                41.728098, -114.222311,
                                                                                                                                                37.920064, -216.183511,
                                                                                                                                                44.013662, -216.046286,
                                                                                                                                                43.287955, -114.124008,
                                                                                                                                                36.574722, -216.112302,
                                                                                                                                                40.084983, -192.622346, -9.033449, -191.831, -12.137826, -196.912947, -7.407934, -202.200341, -6.926998, -197.257558, -11.802135, -202.326503, -9.466447, -206.762459, -13.078197, -202.877162, -17.712753, -207.045848, -15.796084, -198.71269, -18.888922, -197.74203, -22.192372, -201.814822, -17.721689, -215.989542,
                                                                                                                                                43.225454, -114.094436,
                                                                                                                                                36.891082, -216.074271,
                                                                                                                                                39.783393, -206.599496, -19.276178, -209.606552, -17.882168, -207.53011, -15.684415, -205.278647, -22.776979, -207.295885, -25.029195, -206.92471, -22.107948, -211.102973, -15.210641, -212.689133, -14.409878, -211.987292, -11.33002, -114.175484,
                                                                                                                                                34.052798, -216.15529,
                                                                                                                                                35.285707, -216.096214,
                                                                                                                                                39.265374, -114.347958,
                                                                                                                                                40.129222, -216.330819,
                                                                                                                                                43.937409, -114.347958,
                                                                                                                                                43.937409,
                                                                                                                                                12.552737,
                                                                                                                                                39.08005,
                                                                                                                                                11.241062,
                                                                                                                                                39.772816,
                                                                                                                                                12.829597,
                                                                                                                                                42.818836,
                                                                                                                                                11.713891,
                                                                                                                                                43.908053,
                                                                                                                                                11.709913,
                                                                                                                                                40.114579,
                                                                                                                                                10.358669,
                                                                                                                                                44.511204, -7.507789,
                                                                                                                                                19.109671, -6.92709,
                                                                                                                                                11.365556, -9.602094,
                                                                                                                                                8.67114, -9.930904,
                                                                                                                                                22.206951, -12.28614,
                                                                                                                                                12.00742, -12.188323,
                                                                                                                                                19.772661, -3.241721,
                                                                                                                                                19.596571, -1.658879,
                                                                                                                                                12.286314, -3.781959,
                                                                                                                                                9.142591, -5.657695,
                                                                                                                                                22.039098, -6.543833,
                                                                                                                                                11.800188, -7.24148,
                                                                                                                                                19.247236,
                                                                                                                                                0.51222,
                                                                                                                                                21.729703,
                                                                                                                                                3.333138,
                                                                                                                                                15.043173,
                                                                                                                                                1.877105,
                                                                                                                                                11.543554, -0.411026,
                                                                                                                                                23.6826,
                                                                                                                                                1.324289,
                                                                                                                                                13.81228, -1.113782,
                                                                                                                                                20.647707,
                                                                                                                                                7.044105,
                                                                                                                                                19.745562,
                                                                                                                                                6.214656,
                                                                                                                                                16.049597,
                                                                                                                                                3.144749,
                                                                                                                                                25.589524,
                                                                                                                                                7.344502,
                                                                                                                                                20.121251,
                                                                                                                                                3.396127,
                                                                                                                                                25.932207,
                                                                                                                                                3.487459,
                                                                                                                                                28.976454,
                                                                                                                                                9.23878,
                                                                                                                                                25.27408,
                                                                                                                                                8.870565,
                                                                                                                                                21.505953,
                                                                                                                                                4.673266,
                                                                                                                                                30.205038,
                                                                                                                                                10.273045,
                                                                                                                                                30.55586,
                                                                                                                                                10.183437,
                                                                                                                                                26.771794,
                                                                                                                                                5.531173,
                                                                                                                                                31.620991,
                                                                                                                                                10.243884,
                                                                                                                                                30.371194,
                                                                                                                                                5.502413,
                                                                                                                                                31.438112,
                                                                                                                                                5.451778,
                                                                                                                                                34.44638,
                                                                                                                                                11.041404,
                                                                                                                                                31.321501,
                                                                                                                                                6.248236,
                                                                                                                                                35.395437,
                                                                                                                                                6.338312,
                                                                                                                                                38.402782,
                                                                                                                                                10.875806,
                                                                                                                                                35.092023,
                                                                                                                                                10.933446,
                                                                                                                                                31.307335,
                                                                                                                                                6.217528,
                                                                                                                                                38.380081,
                                                                                                                                                11.434149,
                                                                                                                                                34.654553,
                                                                                                                                                6.843776,
                                                                                                                                                38.036766,
                                                                                                                                                7.19149,
                                                                                                                                                41.06247,
                                                                                                                                                11.140603,
                                                                                                                                                38.692949,
                                                                                                                                                11.247663,
                                                                                                                                                34.908387,
                                                                                                                                                6.935201,
                                                                                                                                                41.269536,
                                                                                                                                                11.655259,
                                                                                                                                                36.952315,
                                                                                                                                                7.545394,
                                                                                                                                                39.678709,
                                                                                                                                                8.202366,
                                                                                                                                                42.723842,
                                                                                                                                                11.330626,
                                                                                                                                                41.335558,
                                                                                                                                                11.424867,
                                                                                                                                                37.548837,
                                                                                                                                                7.848908,
                                                                                                                                                43.244933,
                                                                                                                                                11.799626,
                                                                                                                                                38.993322,
                                                                                                                                                8.394464,
                                                                                                                                                41.036099,
                                                                                                                                                11.83925,
                                                                                                                                                42.783546,
                                                                                                                                                11.690147,
                                                                                                                                                42.262814,
                                                                                                                                                8.265565,
                                                                                                                                                40.476095,
                                                                                                                                                9.183615,
                                                                                                                                                43.551815,
                                                                                                                                                12.197656,
                                                                                                                                                39.13325,
                                                                                                                                                9.754215,
                                                                                                                                                40.538175,
                                                                                                                                                11.060837,
                                                                                                                                                43.590133,
                                                                                                                                                0.716044,
                                                                                                                                                45.287524,
                                                                                                                                                1.31125,
                                                                                                                                                42.02142, -0.687638,
                                                                                                                                                45.287524,
                                                                                                                                                0.716044,
                                                                                                                                                41.484474, -0.687638,
                                                                                                                                                41.484474,
                                                                                                                                                0.014203,
                                                                                                                                                44.847374,
                                                                                                                                                0.716044,
                                                                                                                                                6.182302, -0.687638,
                                                                                                                                                6.182302,
                                                                                                                                                1.31125,
                                                                                                                                                9.448406,
                                                                                                                                                0.716044,
                                                                                                                                                17.249738,
                                                                                                                                                0.014203,
                                                                                                                                                6.626347, -0.687638,
                                                                                                                                                17.249738, -8.954455,
                                                                                                                                                17.794014, -7.550773,
                                                                                                                                                17.794014, -8.252614,
                                                                                                                                                7.170622, -11.150241,
                                                                                                                                                18.186547, -10.996561,
                                                                                                                                                7.541106, -49.135609,
                                                                                                                                                9.708246, -49.098473,
                                                                                                                                                10.458398, -10.957887,
                                                                                                                                                8.318497, -48.936322, -2.956288,
                                                                                                                                                26.05405,
                                                                                                                                                35.857826,
                                                                                                                                                27.275922,
                                                                                                                                                43.596182,
                                                                                                                                                29.438792,
                                                                                                                                                33.171642, -35.123241,
                                                                                                                                                42.348578, -36.756355,
                                                                                                                                                52.605964, -34.512704,
                                                                                                                                                50.158979,
                                                                                                                                                45.099179,
                                                                                                                                                51.392443,
                                                                                                                                                47.67887,
                                                                                                                                                58.660997,
                                                                                                                                                47.879103,
                                                                                                                                                48.276348,
                                                                                                                                                6.494492,
                                                                                                                                                63.998406,
                                                                                                                                                6.891042,
                                                                                                                                                74.242327,
                                                                                                                                                8.477384,
                                                                                                                                                71.451918,
                                                                                                                                                67.439577,
                                                                                                                                                53.084096,
                                                                                                                                                65.353681,
                                                                                                                                                56.540938,
                                                                                                                                                69.25747,
                                                                                                                                                63.173221,
                                                                                                                                                51.792854,
                                                                                                                                                65.013701,
                                                                                                                                                54.612205,
                                                                                                                                                74.761783,
                                                                                                                                                55.478716,
                                                                                                                                                71.769526,
                                                                                                                                                84.954263,
                                                                                                                                                50.038459,
                                                                                                                                                83.567879,
                                                                                                                                                53.703409,
                                                                                                                                                88.542184,
                                                                                                                                                59.530596,
                                                                                                                                                85.975459,
                                                                                                                                                51.42938,
                                                                                                                                                90.647804,
                                                                                                                                                60.257832,
                                                                                                                                                90.980242,
                                                                                                                                                57.230412,
                                                                                                                                                98.946849,
                                                                                                                                                42.660839,
                                                                                                                                                98.191775,
                                                                                                                                                46.416578,
                                                                                                                                                103.841279,
                                                                                                                                                51.36813,
                                                                                                                                                112.548456,
                                                                                                                                                40.670695,
                                                                                                                                                106.841359,
                                                                                                                                                35.785634,
                                                                                                                                                112.489415,
                                                                                                                                                43.678809,
                                                                                                                                                109.518024,
                                                                                                                                                33.681817,
                                                                                                                                                109.292571,
                                                                                                                                                37.459541,
                                                                                                                                                115.18351,
                                                                                                                                                41.562491,
                                                                                                                                                125.002062,
                                                                                                                                                27.569756,
                                                                                                                                                119.116142,
                                                                                                                                                23.459609,
                                                                                                                                                125.023347,
                                                                                                                                                30.578375,
                                                                                                                                                117.442893,
                                                                                                                                                24.686821,
                                                                                                                                                117.643647,
                                                                                                                                                28.465938,
                                                                                                                                                123.361943,
                                                                                                                                                31.795742,
                                                                                                                                                132.411526,
                                                                                                                                                18.382515,
                                                                                                                                                126.762978,
                                                                                                                                                14.935719,
                                                                                                                                                132.394318,
                                                                                                                                                21.428084,
                                                                                                                                                123.53377,
                                                                                                                                                16.522568,
                                                                                                                                                124.068325,
                                                                                                                                                20.315978,
                                                                                                                                                129.2374,
                                                                                                                                                22.951518,
                                                                                                                                                137.036159,
                                                                                                                                                12.363355,
                                                                                                                                                131.975979,
                                                                                                                                                9.524345,
                                                                                                                                                136.908478,
                                                                                                                                                15.475933,
                                                                                                                                                128.421565,
                                                                                                                                                9.697377,
                                                                                                                                                129.209012,
                                                                                                                                                13.535846,
                                                                                                                                                133.491363,
                                                                                                                                                15.532451,
                                                                                                                                                140.03589,
                                                                                                                                                8.846876,
                                                                                                                                                135.873469,
                                                                                                                                                6.610984,
                                                                                                                                                139.751185,
                                                                                                                                                12.044032,
                                                                                                                                                132.544005,
                                                                                                                                                4.587117,
                                                                                                                                                133.510212,
                                                                                                                                                8.507214,
                                                                                                                                                136.606829,
                                                                                                                                                9.883168,
                                                                                                                                                142.009955,
                                                                                                                                                7.484086,
                                                                                                                                                139.019367,
                                                                                                                                                5.890765,
                                                                                                                                                141.533385,
                                                                                                                                                10.769597,
                                                                                                                                                136.187257,
                                                                                                                                                1.541208,
                                                                                                                                                137.257859,
                                                                                                                                                5.577523,
                                                                                                                                                138.910663,
                                                                                                                                                6.306326,
                                                                                                                                                109.701922, -29.809906,
                                                                                                                                                111.105604, -29.809906,
                                                                                                                                                109.106715, -33.07601,
                                                                                                                                                111.70081, -33.07601,
                                                                                                                                                109.106715, -33.07601,
                                                                                                                                                111.105604, -29.809906,
                                                                                                                                                109.106715, -16.77291,
                                                                                                                                                111.70081, -16.77291,
                                                                                                                                                108.630478, -19.947192,
                                                                                                                                                112.177048, -19.947192,
                                                                                                                                                108.630478, -19.947192,
                                                                                                                                                111.70081, -16.77291,
                                                                                                                                                108.630478, -2.276902,
                                                                                                                                                112.177048, -2.276902,
                                                                                                                                                108.283078, -5.372667,
                                                                                                                                                112.524447, -5.372667,
                                                                                                                                                108.283078, -5.372667,
                                                                                                                                                112.177048, -2.276902,
                                                                                                                                                108.283078,
                                                                                                                                                13.196823,
                                                                                                                                                112.524447,
                                                                                                                                                13.196823,
                                                                                                                                                108.071716,
                                                                                                                                                10.158549,
                                                                                                                                                112.735809,
                                                                                                                                                10.158549,
                                                                                                                                                108.071716,
                                                                                                                                                10.158549,
                                                                                                                                                112.524447,
                                                                                                                                                13.196823,
                                                                                                                                                108.071716,
                                                                                                                                                28.921857,
                                                                                                                                                112.735809,
                                                                                                                                                28.921857,
                                                                                                                                                108.000773,
                                                                                                                                                25.913999,
                                                                                                                                                112.806753,
                                                                                                                                                25.913999,
                                                                                                                                                108.000773,
                                                                                                                                                25.913999,
                                                                                                                                                112.735809,
                                                                                                                                                28.921857,
                                                                                                                                                108.000773,
                                                                                                                                                44.021829,
                                                                                                                                                112.806753,
                                                                                                                                                44.021829,
                                                                                                                                                108.071716,
                                                                                                                                                41.013972,
                                                                                                                                                112.735809,
                                                                                                                                                41.013972,
                                                                                                                                                108.071716,
                                                                                                                                                41.013972,
                                                                                                                                                112.806753,
                                                                                                                                                44.021829,
                                                                                                                                                108.071716,
                                                                                                                                                57.642327,
                                                                                                                                                112.735809,
                                                                                                                                                57.642327,
                                                                                                                                                108.283078,
                                                                                                                                                54.604052,
                                                                                                                                                112.524447,
                                                                                                                                                54.604052,
                                                                                                                                                108.283078,
                                                                                                                                                54.604052,
                                                                                                                                                112.735809,
                                                                                                                                                57.642327,
                                                                                                                                                108.283078,
                                                                                                                                                69.127308,
                                                                                                                                                112.524447,
                                                                                                                                                69.127308,
                                                                                                                                                108.630478,
                                                                                                                                                66.031543,
                                                                                                                                                112.177048,
                                                                                                                                                66.031543,
                                                                                                                                                108.630478,
                                                                                                                                                66.031543,
                                                                                                                                                112.524447,
                                                                                                                                                69.127308,
                                                                                                                                                108.630478,
                                                                                                                                                78.118107,
                                                                                                                                                112.177048,
                                                                                                                                                78.118107,
                                                                                                                                                109.106715,
                                                                                                                                                74.943825,
                                                                                                                                                111.70081,
                                                                                                                                                74.943825,
                                                                                                                                                109.106715,
                                                                                                                                                74.943825,
                                                                                                                                                112.177048,
                                                                                                                                                78.118107,
                                                                                                                                                111.70081,
                                                                                                                                                84.545836,
                                                                                                                                                111.105604,
                                                                                                                                                81.279732,
                                                                                                                                                109.106715,
                                                                                                                                                84.545836,
                                                                                                                                                47.371347,
                                                                                                                                                113.53475,
                                                                                                                                                49.965442,
                                                                                                                                                113.53475,
                                                                                                                                                47.966554,
                                                                                                                                                110.268647,
                                                                                                                                                49.965442,
                                                                                                                                                98.809427,
                                                                                                                                                47.371347,
                                                                                                                                                98.809427,
                                                                                                                                                50.44168,
                                                                                                                                                101.983709,
                                                                                                                                                46.895109,
                                                                                                                                                101.983709,
                                                                                                                                                50.44168,
                                                                                                                                                101.983709,
                                                                                                                                                47.371347,
                                                                                                                                                98.809427,
                                                                                                                                                50.44168,
                                                                                                                                                83.882242,
                                                                                                                                                46.895109,
                                                                                                                                                83.882242,
                                                                                                                                                50.789079,
                                                                                                                                                86.978007,
                                                                                                                                                46.54771,
                                                                                                                                                86.978007,
                                                                                                                                                50.789079,
                                                                                                                                                86.978007,
                                                                                                                                                46.895109,
                                                                                                                                                83.882242,
                                                                                                                                                50.789079,
                                                                                                                                                65.670125,
                                                                                                                                                46.54771,
                                                                                                                                                65.670125,
                                                                                                                                                51.000441,
                                                                                                                                                68.708399,
                                                                                                                                                46.336348,
                                                                                                                                                68.708399,
                                                                                                                                                51.000441,
                                                                                                                                                68.708399,
                                                                                                                                                46.54771,
                                                                                                                                                65.670125,
                                                                                                                                                51.000441,
                                                                                                                                                44.765883,
                                                                                                                                                46.336348,
                                                                                                                                                44.765883,
                                                                                                                                                51.071385,
                                                                                                                                                47.77374,
                                                                                                                                                46.265404,
                                                                                                                                                47.77374,
                                                                                                                                                51.071385,
                                                                                                                                                47.77374,
                                                                                                                                                46.336348,
                                                                                                                                                44.765883,
                                                                                                                                                46.265404,
                                                                                                                                                22.162089,
                                                                                                                                                46.336348,
                                                                                                                                                25.169946,
                                                                                                                                                51.071385,
                                                                                                                                                22.162089,
                                                                                                                                                51.000441,
                                                                                                                                                25.169946,
                                                                                                                                                51.071385,
                                                                                                                                                22.162089,
                                                                                                                                                46.336348,
                                                                                                                                                25.169946,
                                                                                                                                                10.305632,
                                                                                                                                                20.943308,
                                                                                                                                                10.308079,
                                                                                                                                                23.952001,
                                                                                                                                                48.353079,
                                                                                                                                                20.224448,
                                                                                                                                                46.426817,
                                                                                                                                                0.465284,
                                                                                                                                                8.389026,
                                                                                                                                                4.265708,
                                                                                                                                                46.444306,
                                                                                                                                                4.273431,
                                                                                                                                                8.390816, -4.492928,
                                                                                                                                                8.408296, -1.447361,
                                                                                                                                                46.446096, -4.485099,
                                                                                                                                                50.789079,
                                                                                                                                                2.13075,
                                                                                                                                                51.000441, -0.907524,
                                                                                                                                                46.54771,
                                                                                                                                                2.13075,
                                                                                                                                                46.336348, -0.907524,
                                                                                                                                                46.54771,
                                                                                                                                                2.13075,
                                                                                                                                                51.000441, -0.907524,
                                                                                                                                                46.54771, -23.223366,
                                                                                                                                                46.895109, -20.127601,
                                                                                                                                                50.789079, -23.223366,
                                                                                                                                                50.44168, -20.127601,
                                                                                                                                                50.789079, -23.223366,
                                                                                                                                                46.895109, -20.127601,
                                                                                                                                                7.51093, -28.832637,
                                                                                                                                                7.547536, -25.717656,
                                                                                                                                                45.579901, -28.126523,
                                                                                                                                                44.931189, -37.313013,
                                                                                                                                                6.903575, -34.830271,
                                                                                                                                                44.989184, -33.505268,
                                                                                                                                                7.585943, -50.935486,
                                                                                                                                                7.635658, -47.726063,
                                                                                                                                                45.668285, -49.519698,
                                                                                                                                                49.965442, -40.638512,
                                                                                                                                                50.44168, -43.812794,
                                                                                                                                                47.371347, -40.638512,
                                                                                                                                                46.895109, -43.812794,
                                                                                                                                                47.371347, -40.638512,
                                                                                                                                                50.44168, -43.812794,
                                                                                                                                                47.371347, -62.064925,
                                                                                                                                                47.966554, -58.798821,
                                                                                                                                                49.965442, -62.064925,
                                                                                                                                                49.370235, -58.798821,
                                                                                                                                                49.965442, -62.064925,
                                                                                                                                                47.966554, -58.798821,
                                                                                                                                                8.549127, -70.148587,
                                                                                                                                                8.597234, -66.82904,
                                                                                                                                                46.635425, -67.97811,
                                                                                                                                                46.521905, -67.996108,
                                                                                                                                                46.462008, -71.803823,
                                                                                                                                                8.424774, -70.623489,
                                                                                                                                                45.330623, -55.197623,
                                                                                                                                                7.300393, -53.353864,
                                                                                                                                                45.397905, -51.39003,
                                                                                                                                                49.724827, -54.388124,
                                                                                                                                                49.724827, -50.579937,
                                                                                                                                                114.347958, -54.388124,
                                                                                                                                                114.347958, -32.816245,
                                                                                                                                                114.347958, -36.624431,
                                                                                                                                                49.724827, -32.816245,
                                                                                                                                                117.363119, -35.48743,
                                                                                                                                                117.326171, -31.679422,
                                                                                                                                                219.314633, -30.137142,
                                                                                                                                                118.681141, -85.922267,
                                                                                                                                                220.573403, -80.05144,
                                                                                                                                                220.65836, -83.760831,
                                                                                                                                                157.378769, -128.666765,
                                                                                                                                                159.455211, -130.864517,
                                                                                                                                                156.448155, -132.258527,
                                                                                                                                                150.05201, -136.254655,
                                                                                                                                                151.698073, -135.585623,
                                                                                                                                                152.069249, -138.50687,
                                                                                                                                                49.525991, -170.091334,
                                                                                                                                                50.121198, -167.207381,
                                                                                                                                                52.120086, -170.091334,
                                                                                                                                                51.52488, -167.207381,
                                                                                                                                                52.120086, -170.091334,
                                                                                                                                                50.121198, -167.207381,
                                                                                                                                                52.120086, -136.227463,
                                                                                                                                                52.596324, -138.918267,
                                                                                                                                                49.525991, -136.227463,
                                                                                                                                                49.049753, -138.918267,
                                                                                                                                                49.525991, -136.227463,
                                                                                                                                                52.596324, -138.918267,
                                                                                                                                                138.442749, -116.201947,
                                                                                                                                                141.527277, -114.988958,
                                                                                                                                                141.736992, -117.713521,
                                                                                                                                                142.2454, -110.623412,
                                                                                                                                                143.123381, -107.29413,
                                                                                                                                                146.438188, -108.760057,
                                                                                                                                                221.781064, -65.25637,
                                                                                                                                                119.801229, -68.148681,
                                                                                                                                                221.696335, -61.814309,
                                                                                                                                                118.182192, -17.08558,
                                                                                                                                                118.148154, -13.277546,
                                                                                                                                                220.143392, -10.991982,
                                                                                                                                                114.347958, -14.333027,
                                                                                                                                                114.347958, -18.141214,
                                                                                                                                                49.724827, -14.333027,
                                                                                                                                                49.724827, -18.141214,
                                                                                                                                                49.724827, -14.333027,
                                                                                                                                                114.347958, -18.141214,
                                                                                                                                                45.28344, -18.604385,
                                                                                                                                                7.25288, -15.477312,
                                                                                                                                                45.322309, -14.796397,
                                                                                                                                                114.347958,
                                                                                                                                                4.486679,
                                                                                                                                                114.347958,
                                                                                                                                                0.678493,
                                                                                                                                                49.724827,
                                                                                                                                                4.486679,
                                                                                                                                                118.494783,
                                                                                                                                                1.372187,
                                                                                                                                                118.47249,
                                                                                                                                                5.180309,
                                                                                                                                                220.475499,
                                                                                                                                                8.233182,
                                                                                                                                                222.20766, -42.242092,
                                                                                                                                                120.219366, -45.752353,
                                                                                                                                                222.141644, -39.03912,
                                                                                                                                                126.798204, -78.216149,
                                                                                                                                                127.53821, -75.099134,
                                                                                                                                                131.894529, -75.940823,
                                                                                                                                                125.119404, -85.942778,
                                                                                                                                                129.390284, -84.266131,
                                                                                                                                                129.471225, -86.807424,
                                                                                                                                                49.049753, -95.944051,
                                                                                                                                                52.596324, -95.944051,
                                                                                                                                                48.702354, -98.462787,
                                                                                                                                                52.943723, -98.462787,
                                                                                                                                                48.702354, -98.462787,
                                                                                                                                                52.596324, -95.944051,
                                                                                                                                                48.702354, -46.231728,
                                                                                                                                                52.943723, -46.231728,
                                                                                                                                                48.490992, -48.619601,
                                                                                                                                                53.155085, -48.619601,
                                                                                                                                                48.490992, -48.619601,
                                                                                                                                                52.943723, -46.231728,
                                                                                                                                                48.490992,
                                                                                                                                                10.403859,
                                                                                                                                                53.155085,
                                                                                                                                                10.403859,
                                                                                                                                                48.420048,
                                                                                                                                                8.087163,
                                                                                                                                                53.226029,
                                                                                                                                                8.087163,
                                                                                                                                                48.420048,
                                                                                                                                                8.087163,
                                                                                                                                                53.155085,
                                                                                                                                                10.403859,
                                                                                                                                                48.420048,
                                                                                                                                                68.449295,
                                                                                                                                                53.226029,
                                                                                                                                                68.449295,
                                                                                                                                                48.490992,
                                                                                                                                                66.132599,
                                                                                                                                                53.155085,
                                                                                                                                                66.132599,
                                                                                                                                                48.490992,
                                                                                                                                                66.132599,
                                                                                                                                                53.226029,
                                                                                                                                                68.449295,
                                                                                                                                                48.490992,
                                                                                                                                                121.335869,
                                                                                                                                                53.155085,
                                                                                                                                                121.335869,
                                                                                                                                                48.702354,
                                                                                                                                                118.947997,
                                                                                                                                                52.943723,
                                                                                                                                                118.947997,
                                                                                                                                                48.702354,
                                                                                                                                                118.947997,
                                                                                                                                                53.155085,
                                                                                                                                                121.335869,
                                                                                                                                                48.702354,
                                                                                                                                                164.51349,
                                                                                                                                                52.943723,
                                                                                                                                                164.51349,
                                                                                                                                                49.049753,
                                                                                                                                                161.994753, -37.859997,
                                                                                                                                                149.234928, -43.312148,
                                                                                                                                                146.763768, -38.606452,
                                                                                                                                                151.665467, -20.898428,
                                                                                                                                                105.672067, -22.351692,
                                                                                                                                                108.527135, -16.826739,
                                                                                                                                                110.830931,
                                                                                                                                                212.037461,
                                                                                                                                                106.744775,
                                                                                                                                                110.142204,
                                                                                                                                                98.054797,
                                                                                                                                                211.990935,
                                                                                                                                                109.94809,
                                                                                                                                                110.960544,
                                                                                                                                                87.590481,
                                                                                                                                                110.919198,
                                                                                                                                                91.398443,
                                                                                                                                                212.836282,
                                                                                                                                                99.828576,
                                                                                                                                                114.347958,
                                                                                                                                                90.188797,
                                                                                                                                                114.347958,
                                                                                                                                                86.38061,
                                                                                                                                                49.724827,
                                                                                                                                                90.188797,
                                                                                                                                                49.724827,
                                                                                                                                                86.38061,
                                                                                                                                                49.724827,
                                                                                                                                                90.188797,
                                                                                                                                                114.347958,
                                                                                                                                                86.38061,
                                                                                                                                                65.718478,
                                                                                                                                                83.035099,
                                                                                                                                                27.898593,
                                                                                                                                                91.65629,
                                                                                                                                                65.919016,
                                                                                                                                                86.838002,
                                                                                                                                                39.054714,
                                                                                                                                                113.221073,
                                                                                                                                                39.485742,
                                                                                                                                                116.512869,
                                                                                                                                                76.858013,
                                                                                                                                                106.121428,
                                                                                                                                                49.370235,
                                                                                                                                                110.268647,
                                                                                                                                                47.966554,
                                                                                                                                                110.268647,
                                                                                                                                                49.965442,
                                                                                                                                                113.53475,
                                                                                                                                                47.966554,
                                                                                                                                                54.983617,
                                                                                                                                                49.370235,
                                                                                                                                                54.983617,
                                                                                                                                                48.668395,
                                                                                                                                                44.360226,
                                                                                                                                                19.846269,
                                                                                                                                                47.190488,
                                                                                                                                                19.999949,
                                                                                                                                                57.835929,
                                                                                                                                                57.985317,
                                                                                                                                                49.357627,
                                                                                                                                                72.790319,
                                                                                                                                                92.701375,
                                                                                                                                                35.241041,
                                                                                                                                                102.939616,
                                                                                                                                                73.160904,
                                                                                                                                                96.491487,
                                                                                                                                                49.724827,
                                                                                                                                                99.344829,
                                                                                                                                                49.724827,
                                                                                                                                                103.153015,
                                                                                                                                                114.347958,
                                                                                                                                                99.344829,
                                                                                                                                                114.347958,
                                                                                                                                                103.153015,
                                                                                                                                                114.347958,
                                                                                                                                                99.344829,
                                                                                                                                                49.724827,
                                                                                                                                                103.153015,
                                                                                                                                                107.173168,
                                                                                                                                                102.485277,
                                                                                                                                                107.063099,
                                                                                                                                                106.291873,
                                                                                                                                                208.866721,
                                                                                                                                                116.537354,
                                                                                                                                                206.882049,
                                                                                                                                                127.994857,
                                                                                                                                                105.161682,
                                                                                                                                                116.953382,
                                                                                                                                                206.74276,
                                                                                                                                                131.435142, -68.234839,
                                                                                                                                                98.599795, -70.415167,
                                                                                                                                                101.264591, -65.526148,
                                                                                                                                                104.296386, -107.570683,
                                                                                                                                                148.260004, -112.240233,
                                                                                                                                                144.900005, -108.975503,
                                                                                                                                                150.603869, -82.815322,
                                                                                                                                                101.535148, -85.601657,
                                                                                                                                                103.985277, -83.015357,
                                                                                                                                                109.738469,
                                                                                                                                                200.199942,
                                                                                                                                                145.571178,
                                                                                                                                                98.815627,
                                                                                                                                                131.386195,
                                                                                                                                                199.905755,
                                                                                                                                                149.269861,
                                                                                                                                                112.741422,
                                                                                                                                                29.451294,
                                                                                                                                                112.711396,
                                                                                                                                                42.866927,
                                                                                                                                                214.680197,
                                                                                                                                                51.94198,
                                                                                                                                                114.347958,
                                                                                                                                                42.614557,
                                                                                                                                                114.347958,
                                                                                                                                                29.198891,
                                                                                                                                                49.724827,
                                                                                                                                                42.614557, -205.212979,
                                                                                                                                                70.031007, -205.826695,
                                                                                                                                                63.895239, -207.457385,
                                                                                                                                                71.937337,
                                                                                                                                                109.701922,
                                                                                                                                                44.474418,
                                                                                                                                                111.105604,
                                                                                                                                                44.474418,
                                                                                                                                                110.403763,
                                                                                                                                                33.851026,
                                                                                                                                                109.701922,
                                                                                                                                                81.279732,
                                                                                                                                                109.106715,
                                                                                                                                                84.545836,
                                                                                                                                                111.105604,
                                                                                                                                                81.279732,
                                                                                                                                                30.27816,
                                                                                                                                                103.224157,
                                                                                                                                                30.508265,
                                                                                                                                                106.425707,
                                                                                                                                                68.256114,
                                                                                                                                                98.081827,
                                                                                                                                                59.854018,
                                                                                                                                                70.178621,
                                                                                                                                                21.894786,
                                                                                                                                                77.500994,
                                                                                                                                                59.944886,
                                                                                                                                                73.985723,
                                                                                                                                                23.196748,
                                                                                                                                                88.268822,
                                                                                                                                                23.299231,
                                                                                                                                                91.382331,
                                                                                                                                                61.234689,
                                                                                                                                                84.624333,
                                                                                                                                                55.065657,
                                                                                                                                                54.856092,
                                                                                                                                                17.042704,
                                                                                                                                                61.103056,
                                                                                                                                                55.094394,
                                                                                                                                                58.66417,
                                                                                                                                                17.601747,
                                                                                                                                                68.856812,
                                                                                                                                                17.633483,
                                                                                                                                                71.902264,
                                                                                                                                                55.651259,
                                                                                                                                                66.38418,
                                                                                                                                                51.269746,
                                                                                                                                                37.731245,
                                                                                                                                                13.225164,
                                                                                                                                                43.061376,
                                                                                                                                                51.27251,
                                                                                                                                                41.539431,
                                                                                                                                                13.343347,
                                                                                                                                                45.942837,
                                                                                                                                                13.346322,
                                                                                                                                                48.951529,
                                                                                                                                                51.390598,
                                                                                                                                                44.418501,
                                                                                                                                                48.406672,
                                                                                                                                                19.414851,
                                                                                                                                                10.36155,
                                                                                                                                                23.940769,
                                                                                                                                                48.409019,
                                                                                                                                                23.223037,
                                                                                                                                                49.724827,
                                                                                                                                                19.444679,
                                                                                                                                                49.724827,
                                                                                                                                                23.252866,
                                                                                                                                                114.347958,
                                                                                                                                                19.444679,
                                                                                                                                                114.347958,
                                                                                                                                                23.252866,
                                                                                                                                                114.347958,
                                                                                                                                                19.444679,
                                                                                                                                                49.724827,
                                                                                                                                                23.252866,
                                                                                                                                                118.260646,
                                                                                                                                                19.663438,
                                                                                                                                                118.253603,
                                                                                                                                                23.471618,
                                                                                                                                                220.262987,
                                                                                                                                                27.343339,
                                                                                                                                                221.898387, -14.345637,
                                                                                                                                                119.898206, -18.452681,
                                                                                                                                                221.860658, -11.32539,
                                                                                                                                                108.763963, -36.266858,
                                                                                                                                                109.280932, -33.290945,
                                                                                                                                                114.442747, -33.571444,
                                                                                                                                                108.663774, -44.077099,
                                                                                                                                                113.829716, -41.964594,
                                                                                                                                                113.825359, -44.361798,
                                                                                                                                                87.016089,
                                                                                                                                                8.30203,
                                                                                                                                                92.743641,
                                                                                                                                                10.892204,
                                                                                                                                                92.718858,
                                                                                                                                                8.574555,
                                                                                                                                                86.561486,
                                                                                                                                                10.752323,
                                                                                                                                                86.760794,
                                                                                                                                                13.665919,
                                                                                                                                                92.463593,
                                                                                                                                                13.937824,
                                                                                                                                                220.800784,
                                                                                                                                                17.397812,
                                                                                                                                                118.790933,
                                                                                                                                                12.604117,
                                                                                                                                                220.790694,
                                                                                                                                                20.3182,
                                                                                                                                                117.439414,
                                                                                                                                                37.596908,
                                                                                                                                                117.444978,
                                                                                                                                                41.40509,
                                                                                                                                                219.455825,
                                                                                                                                                46.177547,
                                                                                                                                                114.347958,
                                                                                                                                                41.576632,
                                                                                                                                                114.347958,
                                                                                                                                                37.768446,
                                                                                                                                                49.724827,
                                                                                                                                                41.576632,
                                                                                                                                                49.724827,
                                                                                                                                                37.768446,
                                                                                                                                                49.724827,
                                                                                                                                                41.576632,
                                                                                                                                                114.347958,
                                                                                                                                                37.768446,
                                                                                                                                                114.347958,
                                                                                                                                                59.078246,
                                                                                                                                                114.347958,
                                                                                                                                                55.27006,
                                                                                                                                                49.724827,
                                                                                                                                                59.078246,
                                                                                                                                                115.988254,
                                                                                                                                                55.001852,
                                                                                                                                                115.997064,
                                                                                                                                                58.810028,
                                                                                                                                                217.999264,
                                                                                                                                                64.603266,
                                                                                                                                                218.851068,
                                                                                                                                                50.225463,
                                                                                                                                                116.843529,
                                                                                                                                                44.527003,
                                                                                                                                                218.856719,
                                                                                                                                                53.145863,
                                                                                                                                                58.363371,
                                                                                                                                                55.401613,
                                                                                                                                                58.134105,
                                                                                                                                                58.313005,
                                                                                                                                                64.089209,
                                                                                                                                                59.185468,
                                                                                                                                                63.043417,
                                                                                                                                                66.164212,
                                                                                                                                                57.088672,
                                                                                                                                                65.289305,
                                                                                                                                                62.987262,
                                                                                                                                                68.481313,
                                                                                                                                                20.602624,
                                                                                                                                                117.599713,
                                                                                                                                                14.716673,
                                                                                                                                                116.000345,
                                                                                                                                                20.308999,
                                                                                                                                                119.978871,
                                                                                                                                                22.547447,
                                                                                                                                                89.471605,
                                                                                                                                                21.76438,
                                                                                                                                                92.388816,
                                                                                                                                                27.661837,
                                                                                                                                                93.945221,
                                                                                                                                                215.967977,
                                                                                                                                                80.739273,
                                                                                                                                                113.990382,
                                                                                                                                                73.785051,
                                                                                                                                                215.965569,
                                                                                                                                                83.759755,
                                                                                                                                                113.854525,
                                                                                                                                                71.717582,
                                                                                                                                                113.850154,
                                                                                                                                                75.525766,
                                                                                                                                                215.825534,
                                                                                                                                                82.512387,
                                                                                                                                                114.347958,
                                                                                                                                                75.395015,
                                                                                                                                                114.347958,
                                                                                                                                                71.586828,
                                                                                                                                                49.724827,
                                                                                                                                                75.395015,
                                                                                                                                                49.724827,
                                                                                                                                                71.586828,
                                                                                                                                                49.724827,
                                                                                                                                                75.395015,
                                                                                                                                                114.347958,
                                                                                                                                                71.586828,
                                                                                                                                                49.724827,
                                                                                                                                                55.27006,
                                                                                                                                                49.724827,
                                                                                                                                                59.078246,
                                                                                                                                                114.347958,
                                                                                                                                                55.27006,
                                                                                                                                                49.724827,
                                                                                                                                                0.678493,
                                                                                                                                                49.724827,
                                                                                                                                                4.486679,
                                                                                                                                                114.347958,
                                                                                                                                                0.678493,
                                                                                                                                                49.724827, -36.624431,
                                                                                                                                                49.724827, -32.816245,
                                                                                                                                                114.347958, -36.624431, -49.724827,
                                                                                                                                                11.051073, -49.724827, -2.364594, -114.347958,
                                                                                                                                                11.051073, -114.347958,
                                                                                                                                                43.937409, -49.724827,
                                                                                                                                                43.937409, -114.347958,
                                                                                                                                                40.129222, -11.701838,
                                                                                                                                                38.177306, -11.699391,
                                                                                                                                                35.168613, -49.746839,
                                                                                                                                                34.449753, -49.74602,
                                                                                                                                                34.461944, -11.698551,
                                                                                                                                                35.179676, -49.743673,
                                                                                                                                                30.653758, -49.724827,
                                                                                                                                                34.492595, -49.724827,
                                                                                                                                                30.684408, -114.347958,
                                                                                                                                                34.492595, -49.724827,
                                                                                                                                                25.591987, -49.724827,
                                                                                                                                                21.7838, -114.347958,
                                                                                                                                                25.591987, -49.59944,
                                                                                                                                                25.218423, -11.54775,
                                                                                                                                                27.657309, -49.570703,
                                                                                                                                                21.410345,
                                                                                                                                                56.82594,
                                                                                                                                                76.180991,
                                                                                                                                                56.212224,
                                                                                                                                                82.316759,
                                                                                                                                                58.45663,
                                                                                                                                                84.223089, -34.738665,
                                                                                                                                                64.52682, -38.129643,
                                                                                                                                                62.442953, -35.965161,
                                                                                                                                                70.569998, -160.539163,
                                                                                                                                                72.587054, -161.241004,
                                                                                                                                                64.206048, -161.942845,
                                                                                                                                                72.587054, -217.450551,
                                                                                                                                                32.669546, -215.353873,
                                                                                                                                                24.524745, -218.029487,
                                                                                                                                                26.613165, -215.886308,
                                                                                                                                                34.840609, -216.529302,
                                                                                                                                                28.790693, -218.776531,
                                                                                                                                                31.159061, -217.39819,
                                                                                                                                                10.268345, -215.269334,
                                                                                                                                                8.233787, -217.724414,
                                                                                                                                                4.248844, -161.942845,
                                                                                                                                                131.292018, -162.538052,
                                                                                                                                                134.17597, -160.539163,
                                                                                                                                                131.292018, -159.943957,
                                                                                                                                                134.17597, -160.539163,
                                                                                                                                                131.292018, -162.538052,
                                                                                                                                                134.17597, -162.538052,
                                                                                                                                                121.136497, -163.014289,
                                                                                                                                                123.827301, -159.943957,
                                                                                                                                                121.136497, -220.718531,
                                                                                                                                                23.734782, -221.403855,
                                                                                                                                                17.745529, -222.306912,
                                                                                                                                                25.958353, -181.470828,
                                                                                                                                                80.869372, -182.822145,
                                                                                                                                                72.718302, -184.282823,
                                                                                                                                                75.498935, -200.077773,
                                                                                                                                                73.449784, -202.497965,
                                                                                                                                                67.891765, -200.788426,
                                                                                                                                                75.891032, -147.771511,
                                                                                                                                                85.545204, -148.605085,
                                                                                                                                                88.462378, -144.712291,
                                                                                                                                                93.131505, -139.575103,
                                                                                                                                                91.091181, -143.516302,
                                                                                                                                                86.46284, -139.670171,
                                                                                                                                                93.486504, -112.200199,
                                                                                                                                                77.059878, -112.570366,
                                                                                                                                                79.991503, -108.007424,
                                                                                                                                                83.882284, -85.035069,
                                                                                                                                                60.175762, -89.678109,
                                                                                                                                                56.380924, -84.989573,
                                                                                                                                                62.493097, -82.200714,
                                                                                                                                                51.093307, -82.2872,
                                                                                                                                                54.004859, -77.48964,
                                                                                                                                                57.188125, -48.768328,
                                                                                                                                                13.796463, -53.561069,
                                                                                                                                                10.605947, -48.858716,
                                                                                                                                                16.112482, -58.648604,
                                                                                                                                                15.119919, -58.591249,
                                                                                                                                                18.032191, -53.933219,
                                                                                                                                                20.615299, -25.148434, -30.521138, -29.735914, -33.227559, -25.498709, -28.149658, -40.331143, -24.110715, -40.227032, -21.157648, -36.023664, -19.092289, -8.956739, -68.264267, -13.060171, -70.521667, -9.620799, -65.809936, -25.744959, -61.792494, -25.660849, -58.759727, -22.184337, -57.171709,
                                                                                                                                                2.952083, -99.173494, -0.422965, -100.967091,
                                                                                                                                                1.952834, -96.630125, -13.590276, -95.173628, -13.574675, -92.032727, -11.063369, -90.92293,
                                                                                                                                                11.167254, -121.40811,
                                                                                                                                                12.506999, -124.030425,
                                                                                                                                                10.079277, -125.312797, -2.765875, -123.13346, -2.858583, -119.869933, -1.518478, -119.276742,
                                                                                                                                                189.961904,
                                                                                                                                                57.056092,
                                                                                                                                                192.058581,
                                                                                                                                                65.200893,
                                                                                                                                                192.637518,
                                                                                                                                                59.144512,
                                                                                                                                                254.248783,
                                                                                                                                                36.359651,
                                                                                                                                                254.34906,
                                                                                                                                                42.442814,
                                                                                                                                                256.607246,
                                                                                                                                                44.3328,
                                                                                                                                                147.367165,
                                                                                                                                                97.462547,
                                                                                                                                                147.916405,
                                                                                                                                                105.75904,
                                                                                                                                                149.492943,
                                                                                                                                                99.940505,
                                                                                                                                                125.378314,
                                                                                                                                                98.992159,
                                                                                                                                                123.590939,
                                                                                                                                                104.749425,
                                                                                                                                                126.994571,
                                                                                                                                                101.685338,
                                                                                                                                                178.904956,
                                                                                                                                                129.665496,
                                                                                                                                                180.230803,
                                                                                                                                                132.054922,
                                                                                                                                                181.94479,
                                                                                                                                                126.240186,
                                                                                                                                                53.433843,
                                                                                                                                                115.004286,
                                                                                                                                                52.496364,
                                                                                                                                                112.118826,
                                                                                                                                                49.403567,
                                                                                                                                                117.332607,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "indices": [
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                2,
                                                                                                                                                3,
                                                                                                                                                4,
                                                                                                                                                5,
                                                                                                                                                6,
                                                                                                                                                7,
                                                                                                                                                8,
                                                                                                                                                9,
                                                                                                                                                10,
                                                                                                                                                11,
                                                                                                                                                12,
                                                                                                                                                13,
                                                                                                                                                14,
                                                                                                                                                15,
                                                                                                                                                16,
                                                                                                                                                17,
                                                                                                                                                18,
                                                                                                                                                19,
                                                                                                                                                20,
                                                                                                                                                21,
                                                                                                                                                22,
                                                                                                                                                23,
                                                                                                                                                24,
                                                                                                                                                25,
                                                                                                                                                26,
                                                                                                                                                27,
                                                                                                                                                28,
                                                                                                                                                29,
                                                                                                                                                30,
                                                                                                                                                31,
                                                                                                                                                32,
                                                                                                                                                33,
                                                                                                                                                34,
                                                                                                                                                35,
                                                                                                                                                36,
                                                                                                                                                37,
                                                                                                                                                38,
                                                                                                                                                39,
                                                                                                                                                40,
                                                                                                                                                41,
                                                                                                                                                42,
                                                                                                                                                43,
                                                                                                                                                44,
                                                                                                                                                45,
                                                                                                                                                46,
                                                                                                                                                47,
                                                                                                                                                48,
                                                                                                                                                49,
                                                                                                                                                50,
                                                                                                                                                51,
                                                                                                                                                52,
                                                                                                                                                53,
                                                                                                                                                54,
                                                                                                                                                55,
                                                                                                                                                56,
                                                                                                                                                57,
                                                                                                                                                58,
                                                                                                                                                59,
                                                                                                                                                60,
                                                                                                                                                61,
                                                                                                                                                62,
                                                                                                                                                63,
                                                                                                                                                64,
                                                                                                                                                65,
                                                                                                                                                66,
                                                                                                                                                67,
                                                                                                                                                68,
                                                                                                                                                69,
                                                                                                                                                70,
                                                                                                                                                71,
                                                                                                                                                72,
                                                                                                                                                73,
                                                                                                                                                74,
                                                                                                                                                75,
                                                                                                                                                76,
                                                                                                                                                77,
                                                                                                                                                78,
                                                                                                                                                79,
                                                                                                                                                80,
                                                                                                                                                81,
                                                                                                                                                82,
                                                                                                                                                83,
                                                                                                                                                84,
                                                                                                                                                85,
                                                                                                                                                86,
                                                                                                                                                87,
                                                                                                                                                88,
                                                                                                                                                89,
                                                                                                                                                90,
                                                                                                                                                91,
                                                                                                                                                92,
                                                                                                                                                93,
                                                                                                                                                94,
                                                                                                                                                95,
                                                                                                                                                96,
                                                                                                                                                97,
                                                                                                                                                98,
                                                                                                                                                99,
                                                                                                                                                100,
                                                                                                                                                101,
                                                                                                                                                102,
                                                                                                                                                103,
                                                                                                                                                104,
                                                                                                                                                105,
                                                                                                                                                106,
                                                                                                                                                107,
                                                                                                                                                108,
                                                                                                                                                109,
                                                                                                                                                110,
                                                                                                                                                111,
                                                                                                                                                112,
                                                                                                                                                113,
                                                                                                                                                114,
                                                                                                                                                115,
                                                                                                                                                116,
                                                                                                                                                117,
                                                                                                                                                118,
                                                                                                                                                119,
                                                                                                                                                120,
                                                                                                                                                121,
                                                                                                                                                122,
                                                                                                                                                123,
                                                                                                                                                124,
                                                                                                                                                125,
                                                                                                                                                126,
                                                                                                                                                127,
                                                                                                                                                128,
                                                                                                                                                129,
                                                                                                                                                130,
                                                                                                                                                131,
                                                                                                                                                132,
                                                                                                                                                133,
                                                                                                                                                134,
                                                                                                                                                135,
                                                                                                                                                136,
                                                                                                                                                137,
                                                                                                                                                138,
                                                                                                                                                139,
                                                                                                                                                140,
                                                                                                                                                141,
                                                                                                                                                142,
                                                                                                                                                143,
                                                                                                                                                144,
                                                                                                                                                145,
                                                                                                                                                146,
                                                                                                                                                147,
                                                                                                                                                148,
                                                                                                                                                149,
                                                                                                                                                150,
                                                                                                                                                151,
                                                                                                                                                152,
                                                                                                                                                153,
                                                                                                                                                154,
                                                                                                                                                155,
                                                                                                                                                156,
                                                                                                                                                157,
                                                                                                                                                158,
                                                                                                                                                159,
                                                                                                                                                160,
                                                                                                                                                161,
                                                                                                                                                162,
                                                                                                                                                163,
                                                                                                                                                164,
                                                                                                                                                165,
                                                                                                                                                166,
                                                                                                                                                167,
                                                                                                                                                168,
                                                                                                                                                169,
                                                                                                                                                170,
                                                                                                                                                171,
                                                                                                                                                172,
                                                                                                                                                173,
                                                                                                                                                174,
                                                                                                                                                175,
                                                                                                                                                176,
                                                                                                                                                177,
                                                                                                                                                178,
                                                                                                                                                179,
                                                                                                                                                180,
                                                                                                                                                181,
                                                                                                                                                182,
                                                                                                                                                183,
                                                                                                                                                184,
                                                                                                                                                185,
                                                                                                                                                186,
                                                                                                                                                187,
                                                                                                                                                188,
                                                                                                                                                189,
                                                                                                                                                190,
                                                                                                                                                191,
                                                                                                                                                192,
                                                                                                                                                193,
                                                                                                                                                194,
                                                                                                                                                195,
                                                                                                                                                196,
                                                                                                                                                197,
                                                                                                                                                198,
                                                                                                                                                199,
                                                                                                                                                200,
                                                                                                                                                201,
                                                                                                                                                202,
                                                                                                                                                203,
                                                                                                                                                204,
                                                                                                                                                205,
                                                                                                                                                206,
                                                                                                                                                207,
                                                                                                                                                208,
                                                                                                                                                209,
                                                                                                                                                210,
                                                                                                                                                211,
                                                                                                                                                212,
                                                                                                                                                213,
                                                                                                                                                214,
                                                                                                                                                215,
                                                                                                                                                216,
                                                                                                                                                217,
                                                                                                                                                218,
                                                                                                                                                219,
                                                                                                                                                220,
                                                                                                                                                221,
                                                                                                                                                222,
                                                                                                                                                223,
                                                                                                                                                224,
                                                                                                                                                225,
                                                                                                                                                226,
                                                                                                                                                227,
                                                                                                                                                228,
                                                                                                                                                229,
                                                                                                                                                230,
                                                                                                                                                231,
                                                                                                                                                232,
                                                                                                                                                233,
                                                                                                                                                234,
                                                                                                                                                235,
                                                                                                                                                236,
                                                                                                                                                237,
                                                                                                                                                238,
                                                                                                                                                239,
                                                                                                                                                240,
                                                                                                                                                241,
                                                                                                                                                242,
                                                                                                                                                243,
                                                                                                                                                244,
                                                                                                                                                245,
                                                                                                                                                246,
                                                                                                                                                247,
                                                                                                                                                248,
                                                                                                                                                249,
                                                                                                                                                250,
                                                                                                                                                251,
                                                                                                                                                252,
                                                                                                                                                253,
                                                                                                                                                254,
                                                                                                                                                255,
                                                                                                                                                256,
                                                                                                                                                257,
                                                                                                                                                258,
                                                                                                                                                259,
                                                                                                                                                260,
                                                                                                                                                261,
                                                                                                                                                262,
                                                                                                                                                263,
                                                                                                                                                264,
                                                                                                                                                265,
                                                                                                                                                266,
                                                                                                                                                267,
                                                                                                                                                268,
                                                                                                                                                269,
                                                                                                                                                270,
                                                                                                                                                271,
                                                                                                                                                272,
                                                                                                                                                273,
                                                                                                                                                274,
                                                                                                                                                275,
                                                                                                                                                276,
                                                                                                                                                277,
                                                                                                                                                278,
                                                                                                                                                279,
                                                                                                                                                280,
                                                                                                                                                281,
                                                                                                                                                282,
                                                                                                                                                283,
                                                                                                                                                284,
                                                                                                                                                285,
                                                                                                                                                286,
                                                                                                                                                287,
                                                                                                                                                288,
                                                                                                                                                289,
                                                                                                                                                290,
                                                                                                                                                291,
                                                                                                                                                292,
                                                                                                                                                293,
                                                                                                                                                294,
                                                                                                                                                295,
                                                                                                                                                296,
                                                                                                                                                297,
                                                                                                                                                298,
                                                                                                                                                299,
                                                                                                                                                300,
                                                                                                                                                301,
                                                                                                                                                302,
                                                                                                                                                303,
                                                                                                                                                304,
                                                                                                                                                305,
                                                                                                                                                306,
                                                                                                                                                307,
                                                                                                                                                308,
                                                                                                                                                309,
                                                                                                                                                310,
                                                                                                                                                311,
                                                                                                                                                312,
                                                                                                                                                313,
                                                                                                                                                314,
                                                                                                                                                315,
                                                                                                                                                316,
                                                                                                                                                317,
                                                                                                                                                318,
                                                                                                                                                319,
                                                                                                                                                320,
                                                                                                                                                321,
                                                                                                                                                322,
                                                                                                                                                323,
                                                                                                                                                324,
                                                                                                                                                325,
                                                                                                                                                326,
                                                                                                                                                327,
                                                                                                                                                328,
                                                                                                                                                329,
                                                                                                                                                330,
                                                                                                                                                331,
                                                                                                                                                332,
                                                                                                                                                333,
                                                                                                                                                334,
                                                                                                                                                335,
                                                                                                                                                336,
                                                                                                                                                337,
                                                                                                                                                338,
                                                                                                                                                339,
                                                                                                                                                340,
                                                                                                                                                341,
                                                                                                                                                342,
                                                                                                                                                343,
                                                                                                                                                344,
                                                                                                                                                345,
                                                                                                                                                346,
                                                                                                                                                347,
                                                                                                                                                348,
                                                                                                                                                349,
                                                                                                                                                350,
                                                                                                                                                351,
                                                                                                                                                352,
                                                                                                                                                353,
                                                                                                                                                354,
                                                                                                                                                355,
                                                                                                                                                356,
                                                                                                                                                357,
                                                                                                                                                358,
                                                                                                                                                359,
                                                                                                                                                360,
                                                                                                                                                361,
                                                                                                                                                362,
                                                                                                                                                363,
                                                                                                                                                364,
                                                                                                                                                365,
                                                                                                                                                366,
                                                                                                                                                367,
                                                                                                                                                368,
                                                                                                                                                369,
                                                                                                                                                370,
                                                                                                                                                371,
                                                                                                                                                372,
                                                                                                                                                373,
                                                                                                                                                374,
                                                                                                                                                375,
                                                                                                                                                376,
                                                                                                                                                377,
                                                                                                                                                378,
                                                                                                                                                379,
                                                                                                                                                380,
                                                                                                                                                381,
                                                                                                                                                382,
                                                                                                                                                383,
                                                                                                                                                384,
                                                                                                                                                385,
                                                                                                                                                386,
                                                                                                                                                387,
                                                                                                                                                388,
                                                                                                                                                389,
                                                                                                                                                390,
                                                                                                                                                391,
                                                                                                                                                392,
                                                                                                                                                393,
                                                                                                                                                394,
                                                                                                                                                395,
                                                                                                                                                396,
                                                                                                                                                397,
                                                                                                                                                398,
                                                                                                                                                399,
                                                                                                                                                400,
                                                                                                                                                401,
                                                                                                                                                402,
                                                                                                                                                403,
                                                                                                                                                404,
                                                                                                                                                405,
                                                                                                                                                406,
                                                                                                                                                407,
                                                                                                                                                408,
                                                                                                                                                409,
                                                                                                                                                410,
                                                                                                                                                411,
                                                                                                                                                412,
                                                                                                                                                413,
                                                                                                                                                414,
                                                                                                                                                415,
                                                                                                                                                416,
                                                                                                                                                417,
                                                                                                                                                418,
                                                                                                                                                419,
                                                                                                                                                420,
                                                                                                                                                421,
                                                                                                                                                422,
                                                                                                                                                423,
                                                                                                                                                424,
                                                                                                                                                425,
                                                                                                                                                426,
                                                                                                                                                427,
                                                                                                                                                428,
                                                                                                                                                429,
                                                                                                                                                430,
                                                                                                                                                431,
                                                                                                                                                432,
                                                                                                                                                433,
                                                                                                                                                434,
                                                                                                                                                435,
                                                                                                                                                436,
                                                                                                                                                437,
                                                                                                                                                438,
                                                                                                                                                439,
                                                                                                                                                440,
                                                                                                                                                441,
                                                                                                                                                442,
                                                                                                                                                443,
                                                                                                                                                444,
                                                                                                                                                445,
                                                                                                                                                446,
                                                                                                                                                447,
                                                                                                                                                448,
                                                                                                                                                449,
                                                                                                                                                450,
                                                                                                                                                451,
                                                                                                                                                452,
                                                                                                                                                453,
                                                                                                                                                454,
                                                                                                                                                455,
                                                                                                                                                456,
                                                                                                                                                457,
                                                                                                                                                458,
                                                                                                                                                459,
                                                                                                                                                460,
                                                                                                                                                461,
                                                                                                                                                462,
                                                                                                                                                463,
                                                                                                                                                464,
                                                                                                                                                465,
                                                                                                                                                466,
                                                                                                                                                467,
                                                                                                                                                468,
                                                                                                                                                469,
                                                                                                                                                470,
                                                                                                                                                471,
                                                                                                                                                472,
                                                                                                                                                473,
                                                                                                                                                474,
                                                                                                                                                475,
                                                                                                                                                476,
                                                                                                                                                477,
                                                                                                                                                478,
                                                                                                                                                479,
                                                                                                                                                480,
                                                                                                                                                481,
                                                                                                                                                482,
                                                                                                                                                483,
                                                                                                                                                484,
                                                                                                                                                485,
                                                                                                                                                486,
                                                                                                                                                487,
                                                                                                                                                488,
                                                                                                                                                489,
                                                                                                                                                490,
                                                                                                                                                491,
                                                                                                                                                492,
                                                                                                                                                493,
                                                                                                                                                494,
                                                                                                                                                495,
                                                                                                                                                496,
                                                                                                                                                497,
                                                                                                                                                498,
                                                                                                                                                499,
                                                                                                                                                500,
                                                                                                                                                501,
                                                                                                                                                502,
                                                                                                                                                503,
                                                                                                                                                504,
                                                                                                                                                505,
                                                                                                                                                506,
                                                                                                                                                507,
                                                                                                                                                508,
                                                                                                                                                509,
                                                                                                                                                510,
                                                                                                                                                511,
                                                                                                                                                512,
                                                                                                                                                513,
                                                                                                                                                514,
                                                                                                                                                515,
                                                                                                                                                516,
                                                                                                                                                517,
                                                                                                                                                518,
                                                                                                                                                519,
                                                                                                                                                520,
                                                                                                                                                521,
                                                                                                                                                522,
                                                                                                                                                523,
                                                                                                                                                524,
                                                                                                                                                525,
                                                                                                                                                526,
                                                                                                                                                527,
                                                                                                                                                528,
                                                                                                                                                529,
                                                                                                                                                530,
                                                                                                                                                531,
                                                                                                                                                532,
                                                                                                                                                533,
                                                                                                                                                534,
                                                                                                                                                535,
                                                                                                                                                536,
                                                                                                                                                537,
                                                                                                                                                538,
                                                                                                                                                539,
                                                                                                                                                540,
                                                                                                                                                541,
                                                                                                                                                542,
                                                                                                                                                543,
                                                                                                                                                544,
                                                                                                                                                545,
                                                                                                                                                546,
                                                                                                                                                547,
                                                                                                                                                548,
                                                                                                                                                549,
                                                                                                                                                550,
                                                                                                                                                551,
                                                                                                                                                552,
                                                                                                                                                553,
                                                                                                                                                554,
                                                                                                                                                555,
                                                                                                                                                556,
                                                                                                                                                557,
                                                                                                                                                558,
                                                                                                                                                559,
                                                                                                                                                560,
                                                                                                                                                561,
                                                                                                                                                562,
                                                                                                                                                563,
                                                                                                                                                564,
                                                                                                                                                565,
                                                                                                                                                566,
                                                                                                                                                567,
                                                                                                                                                568,
                                                                                                                                                569,
                                                                                                                                                570,
                                                                                                                                                571,
                                                                                                                                                572,
                                                                                                                                                573,
                                                                                                                                                574,
                                                                                                                                                575,
                                                                                                                                                576,
                                                                                                                                                577,
                                                                                                                                                578,
                                                                                                                                                579,
                                                                                                                                                580,
                                                                                                                                                581,
                                                                                                                                                582,
                                                                                                                                                583,
                                                                                                                                                584,
                                                                                                                                                585,
                                                                                                                                                586,
                                                                                                                                                587,
                                                                                                                                                588,
                                                                                                                                                589,
                                                                                                                                                590,
                                                                                                                                                591,
                                                                                                                                                592,
                                                                                                                                                593,
                                                                                                                                                594,
                                                                                                                                                595,
                                                                                                                                                596,
                                                                                                                                                597,
                                                                                                                                                598,
                                                                                                                                                599,
                                                                                                                                                600,
                                                                                                                                                601,
                                                                                                                                                602,
                                                                                                                                                603,
                                                                                                                                                604,
                                                                                                                                                605,
                                                                                                                                                606,
                                                                                                                                                607,
                                                                                                                                                608,
                                                                                                                                                609,
                                                                                                                                                610,
                                                                                                                                                611,
                                                                                                                                                612,
                                                                                                                                                613,
                                                                                                                                                614,
                                                                                                                                                615,
                                                                                                                                                616,
                                                                                                                                                617,
                                                                                                                                                618,
                                                                                                                                                619,
                                                                                                                                                620,
                                                                                                                                                621,
                                                                                                                                                622,
                                                                                                                                                623,
                                                                                                                                                624,
                                                                                                                                                625,
                                                                                                                                                626,
                                                                                                                                                627,
                                                                                                                                                628,
                                                                                                                                                629,
                                                                                                                                                630,
                                                                                                                                                631,
                                                                                                                                                632,
                                                                                                                                                633,
                                                                                                                                                634,
                                                                                                                                                635,
                                                                                                                                                636,
                                                                                                                                                637,
                                                                                                                                                638,
                                                                                                                                                639,
                                                                                                                                                640,
                                                                                                                                                641,
                                                                                                                                                642,
                                                                                                                                                643,
                                                                                                                                                644,
                                                                                                                                                645,
                                                                                                                                                646,
                                                                                                                                                647,
                                                                                                                                                648,
                                                                                                                                                649,
                                                                                                                                                650,
                                                                                                                                                651,
                                                                                                                                                652,
                                                                                                                                                653,
                                                                                                                                                654,
                                                                                                                                                655,
                                                                                                                                                656,
                                                                                                                                                657,
                                                                                                                                                658,
                                                                                                                                                659,
                                                                                                                                                660,
                                                                                                                                                661,
                                                                                                                                                662,
                                                                                                                                                663,
                                                                                                                                                664,
                                                                                                                                                665,
                                                                                                                                                666,
                                                                                                                                                667,
                                                                                                                                                668,
                                                                                                                                                669,
                                                                                                                                                670,
                                                                                                                                                671,
                                                                                                                                                672,
                                                                                                                                                673,
                                                                                                                                                674,
                                                                                                                                                675,
                                                                                                                                                676,
                                                                                                                                                677,
                                                                                                                                                678,
                                                                                                                                                679,
                                                                                                                                                680,
                                                                                                                                                681,
                                                                                                                                                682,
                                                                                                                                                683,
                                                                                                                                                684,
                                                                                                                                                685,
                                                                                                                                                686,
                                                                                                                                                687,
                                                                                                                                                688,
                                                                                                                                                689,
                                                                                                                                                690,
                                                                                                                                                691,
                                                                                                                                                692,
                                                                                                                                                693,
                                                                                                                                                694,
                                                                                                                                                695,
                                                                                                                                                696,
                                                                                                                                                697,
                                                                                                                                                698,
                                                                                                                                                699,
                                                                                                                                                700,
                                                                                                                                                701,
                                                                                                                                                702,
                                                                                                                                                703,
                                                                                                                                                704,
                                                                                                                                                705,
                                                                                                                                                706,
                                                                                                                                                707,
                                                                                                                                                708,
                                                                                                                                                709,
                                                                                                                                                710,
                                                                                                                                                711,
                                                                                                                                                712,
                                                                                                                                                713,
                                                                                                                                                714,
                                                                                                                                                715,
                                                                                                                                                716,
                                                                                                                                                717,
                                                                                                                                                718,
                                                                                                                                                719,
                                                                                                                                                720,
                                                                                                                                                721,
                                                                                                                                                722,
                                                                                                                                                723,
                                                                                                                                                724,
                                                                                                                                                725,
                                                                                                                                                726,
                                                                                                                                                727,
                                                                                                                                                728,
                                                                                                                                                729,
                                                                                                                                                730,
                                                                                                                                                731,
                                                                                                                                                732,
                                                                                                                                                733,
                                                                                                                                                734,
                                                                                                                                                735,
                                                                                                                                                736,
                                                                                                                                                737,
                                                                                                                                                738,
                                                                                                                                                739,
                                                                                                                                                740,
                                                                                                                                                741,
                                                                                                                                                742,
                                                                                                                                                743,
                                                                                                                                                744,
                                                                                                                                                745,
                                                                                                                                                746,
                                                                                                                                                747,
                                                                                                                                                748,
                                                                                                                                                749,
                                                                                                                                                750,
                                                                                                                                                751,
                                                                                                                                                752,
                                                                                                                                                753,
                                                                                                                                                754,
                                                                                                                                                755,
                                                                                                                                                756,
                                                                                                                                                757,
                                                                                                                                                758,
                                                                                                                                                759,
                                                                                                                                                760,
                                                                                                                                                761,
                                                                                                                                                762,
                                                                                                                                                763,
                                                                                                                                                764,
                                                                                                                                                765,
                                                                                                                                                766,
                                                                                                                                                767,
                                                                                                                                                768,
                                                                                                                                                769,
                                                                                                                                                770,
                                                                                                                                                771,
                                                                                                                                                772,
                                                                                                                                                773,
                                                                                                                                                774,
                                                                                                                                                775,
                                                                                                                                                776,
                                                                                                                                                777,
                                                                                                                                                778,
                                                                                                                                                779,
                                                                                                                                                780,
                                                                                                                                                781,
                                                                                                                                                782,
                                                                                                                                                783,
                                                                                                                                                784,
                                                                                                                                                785,
                                                                                                                                                786,
                                                                                                                                                787,
                                                                                                                                                788,
                                                                                                                                                789,
                                                                                                                                                790,
                                                                                                                                                791,
                                                                                                                                                792,
                                                                                                                                                793,
                                                                                                                                                794,
                                                                                                                                                795,
                                                                                                                                                796,
                                                                                                                                                797,
                                                                                                                                                798,
                                                                                                                                                799,
                                                                                                                                                800,
                                                                                                                                                801,
                                                                                                                                                802,
                                                                                                                                                803,
                                                                                                                                                804,
                                                                                                                                                805,
                                                                                                                                                806,
                                                                                                                                                807,
                                                                                                                                                808,
                                                                                                                                                809,
                                                                                                                                                810,
                                                                                                                                                811,
                                                                                                                                                812,
                                                                                                                                                813,
                                                                                                                                                814,
                                                                                                                                                815,
                                                                                                                                                816,
                                                                                                                                                817,
                                                                                                                                                818,
                                                                                                                                                819,
                                                                                                                                                820,
                                                                                                                                                821,
                                                                                                                                                822,
                                                                                                                                                823,
                                                                                                                                                824,
                                                                                                                                                825,
                                                                                                                                                826,
                                                                                                                                                827,
                                                                                                                                                828,
                                                                                                                                                829,
                                                                                                                                                830,
                                                                                                                                                831,
                                                                                                                                                832,
                                                                                                                                                833,
                                                                                                                                                834,
                                                                                                                                                835,
                                                                                                                                                836,
                                                                                                                                                837,
                                                                                                                                                838,
                                                                                                                                                839,
                                                                                                                                                840,
                                                                                                                                                841,
                                                                                                                                                842,
                                                                                                                                                843,
                                                                                                                                                844,
                                                                                                                                                845,
                                                                                                                                                846,
                                                                                                                                                847,
                                                                                                                                                848,
                                                                                                                                                849,
                                                                                                                                                850,
                                                                                                                                                851,
                                                                                                                                                852,
                                                                                                                                                853,
                                                                                                                                                854,
                                                                                                                                                855,
                                                                                                                                                856,
                                                                                                                                                857,
                                                                                                                                                858,
                                                                                                                                                859,
                                                                                                                                                860,
                                                                                                                                                861,
                                                                                                                                                862,
                                                                                                                                                863,
                                                                                                                                                864,
                                                                                                                                                865,
                                                                                                                                                866,
                                                                                                                                                867,
                                                                                                                                                868,
                                                                                                                                                869,
                                                                                                                                                870,
                                                                                                                                                871,
                                                                                                                                                872,
                                                                                                                                                873,
                                                                                                                                                874,
                                                                                                                                                875,
                                                                                                                                                876,
                                                                                                                                                877,
                                                                                                                                                878,
                                                                                                                                                879,
                                                                                                                                                880,
                                                                                                                                                881,
                                                                                                                                                882,
                                                                                                                                                883,
                                                                                                                                                884,
                                                                                                                                                885,
                                                                                                                                                886,
                                                                                                                                                887,
                                                                                                                                                888,
                                                                                                                                                889,
                                                                                                                                                890,
                                                                                                                                                891,
                                                                                                                                                892,
                                                                                                                                                893,
                                                                                                                                                894,
                                                                                                                                                895,
                                                                                                                                                896,
                                                                                                                                                897,
                                                                                                                                                898,
                                                                                                                                                899,
                                                                                                                                                900,
                                                                                                                                                901,
                                                                                                                                                902,
                                                                                                                                                903,
                                                                                                                                                904,
                                                                                                                                                905,
                                                                                                                                                906,
                                                                                                                                                907,
                                                                                                                                                908,
                                                                                                                                                909,
                                                                                                                                                910,
                                                                                                                                                911,
                                                                                                                                                912,
                                                                                                                                                913,
                                                                                                                                                914,
                                                                                                                                                915,
                                                                                                                                                916,
                                                                                                                                                917,
                                                                                                                                                918,
                                                                                                                                                919,
                                                                                                                                                920,
                                                                                                                                                921,
                                                                                                                                                922,
                                                                                                                                                923,
                                                                                                                                                924,
                                                                                                                                                925,
                                                                                                                                                926,
                                                                                                                                                927,
                                                                                                                                                928,
                                                                                                                                                929,
                                                                                                                                                930,
                                                                                                                                                931,
                                                                                                                                                932,
                                                                                                                                                933,
                                                                                                                                                934,
                                                                                                                                                935,
                                                                                                                                                936,
                                                                                                                                                937,
                                                                                                                                                938,
                                                                                                                                                939,
                                                                                                                                                940,
                                                                                                                                                941,
                                                                                                                                                942,
                                                                                                                                                943,
                                                                                                                                                944,
                                                                                                                                                945,
                                                                                                                                                946,
                                                                                                                                                947,
                                                                                                                                                948,
                                                                                                                                                949,
                                                                                                                                                950,
                                                                                                                                                951,
                                                                                                                                                952,
                                                                                                                                                953,
                                                                                                                                                954,
                                                                                                                                                955,
                                                                                                                                                956,
                                                                                                                                                957,
                                                                                                                                                958,
                                                                                                                                                959,
                                                                                                                                                960,
                                                                                                                                                961,
                                                                                                                                                962,
                                                                                                                                                963,
                                                                                                                                                964,
                                                                                                                                                965,
                                                                                                                                                966,
                                                                                                                                                967,
                                                                                                                                                968,
                                                                                                                                                969,
                                                                                                                                                970,
                                                                                                                                                971,
                                                                                                                                                972,
                                                                                                                                                973,
                                                                                                                                                974,
                                                                                                                                                975,
                                                                                                                                                976,
                                                                                                                                                977,
                                                                                                                                                978,
                                                                                                                                                979,
                                                                                                                                                980,
                                                                                                                                                981,
                                                                                                                                                982,
                                                                                                                                                983,
                                                                                                                                                984,
                                                                                                                                                985,
                                                                                                                                                986,
                                                                                                                                                987,
                                                                                                                                                988,
                                                                                                                                                989,
                                                                                                                                                990,
                                                                                                                                                991,
                                                                                                                                                992,
                                                                                                                                                993,
                                                                                                                                                994,
                                                                                                                                                995,
                                                                                                                                                996,
                                                                                                                                                997,
                                                                                                                                                998,
                                                                                                                                                999,
                                                                                                                                                1000,
                                                                                                                                                1001,
                                                                                                                                                1002,
                                                                                                                                                1003,
                                                                                                                                                1004,
                                                                                                                                                1005,
                                                                                                                                                1006,
                                                                                                                                                1007,
                                                                                                                                                1008,
                                                                                                                                                1009,
                                                                                                                                                1010,
                                                                                                                                                1011,
                                                                                                                                                1012,
                                                                                                                                                1013,
                                                                                                                                                1014,
                                                                                                                                                1015,
                                                                                                                                                1016,
                                                                                                                                                1017,
                                                                                                                                                1018,
                                                                                                                                                1019,
                                                                                                                                                1020,
                                                                                                                                                1021,
                                                                                                                                                1022,
                                                                                                                                                1023,
                                                                                                                                                1024,
                                                                                                                                                1025,
                                                                                                                                                1026,
                                                                                                                                                1027,
                                                                                                                                                1028,
                                                                                                                                                1029,
                                                                                                                                                1030,
                                                                                                                                                1031,
                                                                                                                                                1032,
                                                                                                                                                1033,
                                                                                                                                                1034,
                                                                                                                                                1035,
                                                                                                                                                1036,
                                                                                                                                                1037,
                                                                                                                                                1038,
                                                                                                                                                1039,
                                                                                                                                                1040,
                                                                                                                                                1041,
                                                                                                                                                1042,
                                                                                                                                                1043,
                                                                                                                                                1044,
                                                                                                                                                1045,
                                                                                                                                                1046,
                                                                                                                                                1047,
                                                                                                                                                1048,
                                                                                                                                                1049,
                                                                                                                                                1050,
                                                                                                                                                1051,
                                                                                                                                                1052,
                                                                                                                                                1053,
                                                                                                                                                1054,
                                                                                                                                                1055,
                                                                                                                                                1056,
                                                                                                                                                1057,
                                                                                                                                                1058,
                                                                                                                                                1059,
                                                                                                                                                1060,
                                                                                                                                                1061,
                                                                                                                                                1062,
                                                                                                                                                1063,
                                                                                                                                                1064,
                                                                                                                                                1065,
                                                                                                                                                1066,
                                                                                                                                                1067,
                                                                                                                                                1068,
                                                                                                                                                1069,
                                                                                                                                                1070,
                                                                                                                                                1071,
                                                                                                                                                1072,
                                                                                                                                                1073,
                                                                                                                                                1074,
                                                                                                                                                1075,
                                                                                                                                                1076,
                                                                                                                                                1077,
                                                                                                                                                1078,
                                                                                                                                                1079,
                                                                                                                                                1080,
                                                                                                                                                1081,
                                                                                                                                                1082,
                                                                                                                                                1083,
                                                                                                                                                1084,
                                                                                                                                                1085,
                                                                                                                                                1086,
                                                                                                                                                1087,
                                                                                                                                                1088,
                                                                                                                                                1089,
                                                                                                                                                1090,
                                                                                                                                                1091,
                                                                                                                                                1092,
                                                                                                                                                1093,
                                                                                                                                                1094,
                                                                                                                                                1095,
                                                                                                                                                1096,
                                                                                                                                                1097,
                                                                                                                                                1098,
                                                                                                                                                1099,
                                                                                                                                                1100,
                                                                                                                                                1101,
                                                                                                                                                1102,
                                                                                                                                                1103,
                                                                                                                                                1104,
                                                                                                                                                1105,
                                                                                                                                                1106,
                                                                                                                                                1107,
                                                                                                                                                1108,
                                                                                                                                                1109,
                                                                                                                                                1110,
                                                                                                                                                1111,
                                                                                                                                                1112,
                                                                                                                                                1113,
                                                                                                                                                1114,
                                                                                                                                                1115,
                                                                                                                                                1116,
                                                                                                                                                1117,
                                                                                                                                                1118,
                                                                                                                                                1119,
                                                                                                                                                1120,
                                                                                                                                                1121,
                                                                                                                                                1122,
                                                                                                                                                1123,
                                                                                                                                                1124,
                                                                                                                                                1125,
                                                                                                                                                1126,
                                                                                                                                                1127,
                                                                                                                                                1128,
                                                                                                                                                1129,
                                                                                                                                                1130,
                                                                                                                                                1131,
                                                                                                                                                1132,
                                                                                                                                                1133,
                                                                                                                                                1134,
                                                                                                                                                1135,
                                                                                                                                                1136,
                                                                                                                                                1137,
                                                                                                                                                1138,
                                                                                                                                                1139,
                                                                                                                                                1140,
                                                                                                                                                1141,
                                                                                                                                                1142,
                                                                                                                                                1143,
                                                                                                                                                1144,
                                                                                                                                                1145,
                                                                                                                                                1146,
                                                                                                                                                1147,
                                                                                                                                                1148,
                                                                                                                                                1149,
                                                                                                                                                1150,
                                                                                                                                                1151,
                                                                                                                                                1152,
                                                                                                                                                1153,
                                                                                                                                                1154,
                                                                                                                                                1155,
                                                                                                                                                1156,
                                                                                                                                                1157,
                                                                                                                                                1158,
                                                                                                                                                1159,
                                                                                                                                                1160,
                                                                                                                                                1161,
                                                                                                                                                1162,
                                                                                                                                                1163,
                                                                                                                                                1164,
                                                                                                                                                1165,
                                                                                                                                                1166,
                                                                                                                                                1167,
                                                                                                                                                1168,
                                                                                                                                                1169,
                                                                                                                                                1170,
                                                                                                                                                1171,
                                                                                                                                                1172,
                                                                                                                                                1173,
                                                                                                                                                1174,
                                                                                                                                                1175,
                                                                                                                                                1176,
                                                                                                                                                1177,
                                                                                                                                                1178,
                                                                                                                                                1179,
                                                                                                                                                1180,
                                                                                                                                                1181,
                                                                                                                                                1182,
                                                                                                                                                1183,
                                                                                                                                                1184,
                                                                                                                                                1185,
                                                                                                                                                1186,
                                                                                                                                                1187,
                                                                                                                                                1188,
                                                                                                                                                1189,
                                                                                                                                                1190,
                                                                                                                                                1191,
                                                                                                                                                1192,
                                                                                                                                                1193,
                                                                                                                                                1194,
                                                                                                                                                1195,
                                                                                                                                                1196,
                                                                                                                                                1197,
                                                                                                                                                1198,
                                                                                                                                                1199,
                                                                                                                                                1200,
                                                                                                                                                1201,
                                                                                                                                                1202,
                                                                                                                                                1203,
                                                                                                                                                1204,
                                                                                                                                                1205,
                                                                                                                                                1206,
                                                                                                                                                1207,
                                                                                                                                                1208,
                                                                                                                                                1209,
                                                                                                                                                1210,
                                                                                                                                                1211,
                                                                                                                                                1212,
                                                                                                                                                1213,
                                                                                                                                                1214,
                                                                                                                                                1215,
                                                                                                                                                1216,
                                                                                                                                                1217,
                                                                                                                                                1218,
                                                                                                                                                1219,
                                                                                                                                                1220,
                                                                                                                                                1221,
                                                                                                                                                1222,
                                                                                                                                                1223,
                                                                                                                                                1224
                                                                                                                                            ]
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        }
                                                                                                                    ]
                                                                                                                }, {
                                                                                                                    "type": "node",
                                                                                                                    "nodes": [{
                                                                                                                            "type": "node",
                                                                                                                            "nodes": [{
                                                                                                                                    "type": "material",
                                                                                                                                    "baseColor": {
                                                                                                                                        "r": 1,
                                                                                                                                        "g": 1,
                                                                                                                                        "b": 1
                                                                                                                                    },
                                                                                                                                    "specularColor": {
                                                                                                                                        "r": 0.33,
                                                                                                                                        "g": 0.33,
                                                                                                                                        "b": 0.33,
                                                                                                                                        "a": 1
                                                                                                                                    },
                                                                                                                                    "shine": 10,
                                                                                                                                    "specular": 1,
                                                                                                                                    "nodes": [{
                                                                                                                                            "type": "geometry",
                                                                                                                                            "positions": [-22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529, -22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594, -133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594, -133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594, -133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594, -133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594, -133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529, -22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594, -133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "normals": [
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "uv": [-25.800003,
                                                                                                                                                37.76594, -25.800003,
                                                                                                                                                22.980529, -181.459131,
                                                                                                                                                37.76594,
                                                                                                                                                22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594, -181.459131,
                                                                                                                                                22.980529, -181.459131,
                                                                                                                                                37.76594, -25.800003,
                                                                                                                                                22.980529,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "indices": [
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                2,
                                                                                                                                                3,
                                                                                                                                                4,
                                                                                                                                                5,
                                                                                                                                                6,
                                                                                                                                                7,
                                                                                                                                                8,
                                                                                                                                                9,
                                                                                                                                                10,
                                                                                                                                                11,
                                                                                                                                                12,
                                                                                                                                                13,
                                                                                                                                                14,
                                                                                                                                                15,
                                                                                                                                                16,
                                                                                                                                                17,
                                                                                                                                                18
                                                                                                                                            ]
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                }, {
                                                                                                                                    "type": "material",
                                                                                                                                    "baseColor": {
                                                                                                                                        "r": 0.172549,
                                                                                                                                        "g": 0.184314,
                                                                                                                                        "b": 0.2
                                                                                                                                    },
                                                                                                                                    "specularColor": {
                                                                                                                                        "r": 0.33,
                                                                                                                                        "g": 0.33,
                                                                                                                                        "b": 0.33,
                                                                                                                                        "a": 1
                                                                                                                                    },
                                                                                                                                    "shine": 10,
                                                                                                                                    "specular": 1,
                                                                                                                                    "nodes": [{
                                                                                                                                            "type": "geometry",
                                                                                                                                            "positions": [-22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594, -133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594, -133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529, -22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529, -22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529, -22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                181.459131,
                                                                                                                                                22.980529, -22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529, -22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                25.800003,
                                                                                                                                                37.76594,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "normals": [
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                0,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                0, -1,
                                                                                                                                                0,
                                                                                                                                                null,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "uv": [
                                                                                                                                                22.696534,
                                                                                                                                                37.76594,
                                                                                                                                                133.957963,
                                                                                                                                                37.76594,
                                                                                                                                                22.696534,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                37.76594, -133.957963,
                                                                                                                                                22.980529, -22.696534,
                                                                                                                                                22.980529, -133.957963,
                                                                                                                                                22.980529, -22.696534,
                                                                                                                                                37.76594, -22.696534,
                                                                                                                                                181.459131, -22.696534,
                                                                                                                                                25.800003, -133.957963,
                                                                                                                                                181.459131, -133.957963,
                                                                                                                                                25.800003, -133.957963,
                                                                                                                                                181.459131, -22.696534,
                                                                                                                                                25.800003,
                                                                                                                                                133.957963,
                                                                                                                                                22.980529,
                                                                                                                                                22.696534,
                                                                                                                                                22.980529,
                                                                                                                                                133.957963,
                                                                                                                                                37.76594,
                                                                                                                                                null,
                                                                                                                                                null
                                                                                                                                            ],
                                                                                                                                            "indices": [
                                                                                                                                                0,
                                                                                                                                                1,
                                                                                                                                                2,
                                                                                                                                                3,
                                                                                                                                                4,
                                                                                                                                                5,
                                                                                                                                                6,
                                                                                                                                                7,
                                                                                                                                                8,
                                                                                                                                                9,
                                                                                                                                                10,
                                                                                                                                                11,
                                                                                                                                                12,
                                                                                                                                                13,
                                                                                                                                                14,
                                                                                                                                                15,
                                                                                                                                                16,
                                                                                                                                                17,
                                                                                                                                                18
                                                                                                                                            ]
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        }
                                                                                                                    ]
                                                                                                                }
                                                                                                            ]
                                                                                                        }
                                                                                                    ]
                                                                                                }, {
                                                                                                    "type": "node",
                                                                                                    "nodes": [{
                                                                                                            "type": "translate",
                                                                                                            "x": -30,
                                                                                                            "y": 140,
                                                                                                            "z": 42,
                                                                                                            "nodes": [{
                                                                                                                    "type": "node",
                                                                                                                    "nodes": [{
                                                                                                                            "type": "node",
                                                                                                                            "nodes": [{
                                                                                                                                    "type": "node",
                                                                                                                                    "nodes": [{
                                                                                                                                            "type": "material",

                                                                                                                                            "baseColor": {
                                                                                                                                                "r": 0.878431,
                                                                                                                                                "g": 0.258824,
                                                                                                                                                "b": 0.133333
                                                                                                                                            },
                                                                                                                                            emit: 0.05,
                                                                                                                                            "specularColor": {
                                                                                                                                                "r": 0.33,
                                                                                                                                                "g": 0.33,
                                                                                                                                                "b": 0.33,
                                                                                                                                                "a": 1
                                                                                                                                            },
                                                                                                                                            "shine": 10,
                                                                                                                                            "specular": 1,
                                                                                                                                            "nodes": [{
                                                                                                                                                    "type": "geometry",
                                                                                                                                                    "positions": [-29.453081,
                                                                                                                                                        9.294615,
                                                                                                                                                        5.669175, -29.336535,
                                                                                                                                                        9.344596,
                                                                                                                                                        6.087207, -30.535237,
                                                                                                                                                        13.154607,
                                                                                                                                                        5.667366, -29.336535,
                                                                                                                                                        9.344596,
                                                                                                                                                        6.087207, -29.453081,
                                                                                                                                                        9.294615,
                                                                                                                                                        5.669175, -27.309087,
                                                                                                                                                        5.924678,
                                                                                                                                                        6.08881, -27.408758,
                                                                                                                                                        5.846232,
                                                                                                                                                        5.670792, -27.309087,
                                                                                                                                                        5.924678,
                                                                                                                                                        6.08881, -29.453081,
                                                                                                                                                        9.294615,
                                                                                                                                                        5.669175, -27.408758,
                                                                                                                                                        5.846232,
                                                                                                                                                        5.670792, -24.541587,
                                                                                                                                                        3.044459,
                                                                                                                                                        5.672105, -27.309087,
                                                                                                                                                        5.924678,
                                                                                                                                                        6.08881, -24.541587,
                                                                                                                                                        3.044459,
                                                                                                                                                        5.672105, -27.408758,
                                                                                                                                                        5.846232,
                                                                                                                                                        5.670792, -24.594294,
                                                                                                                                                        2.973975,
                                                                                                                                                        5.238533, -27.477879,
                                                                                                                                                        5.791787,
                                                                                                                                                        5.237212, -24.594294,
                                                                                                                                                        2.973975,
                                                                                                                                                        5.238533, -27.408758,
                                                                                                                                                        5.846232,
                                                                                                                                                        5.670792, -29.67026,
                                                                                                                                                        21.07966,
                                                                                                                                                        5.230045, -30.668765,
                                                                                                                                                        17.173496,
                                                                                                                                                        5.231876, -29.58866,
                                                                                                                                                        21.047086,
                                                                                                                                                        5.663666, -30.581481,
                                                                                                                                                        17.163156,
                                                                                                                                                        5.665486, -29.58866,
                                                                                                                                                        21.047086,
                                                                                                                                                        5.663666, -30.668765,
                                                                                                                                                        17.173496,
                                                                                                                                                        5.231876, -29.58866,
                                                                                                                                                        21.047086,
                                                                                                                                                        5.663666, -30.581481,
                                                                                                                                                        17.163156,
                                                                                                                                                        5.665486, -29.470995,
                                                                                                                                                        21.000053,
                                                                                                                                                        6.081743, -30.455621,
                                                                                                                                                        17.148185,
                                                                                                                                                        6.083549, -29.470995,
                                                                                                                                                        21.000053,
                                                                                                                                                        6.081743, -30.581481,
                                                                                                                                                        17.163156,
                                                                                                                                                        5.665486, -29.470995,
                                                                                                                                                        21.000053,
                                                                                                                                                        6.081743, -30.455621,
                                                                                                                                                        17.148185,
                                                                                                                                                        6.083549, -29.318815,
                                                                                                                                                        20.939183,
                                                                                                                                                        6.47877, -30.292841,
                                                                                                                                                        17.128779,
                                                                                                                                                        6.480556, -29.318815,
                                                                                                                                                        20.939183,
                                                                                                                                                        6.47877, -30.455621,
                                                                                                                                                        17.148185,
                                                                                                                                                        6.083549, -29.318815,
                                                                                                                                                        20.939183,
                                                                                                                                                        6.47877, -30.292841,
                                                                                                                                                        17.128779,
                                                                                                                                                        6.480556, -29.134126,
                                                                                                                                                        20.865275,
                                                                                                                                                        6.849517, -30.095288,
                                                                                                                                                        17.105195,
                                                                                                                                                        6.851279, -29.134126,
                                                                                                                                                        20.865275,
                                                                                                                                                        6.849517, -30.292841,
                                                                                                                                                        17.128779,
                                                                                                                                                        6.480556, -29.134126,
                                                                                                                                                        20.865275,
                                                                                                                                                        6.849517, -30.095288,
                                                                                                                                                        17.105195,
                                                                                                                                                        6.851279, -28.919359,
                                                                                                                                                        20.779305,
                                                                                                                                                        7.189099, -29.865562,
                                                                                                                                                        17.077743,
                                                                                                                                                        7.190835, -28.919359,
                                                                                                                                                        20.779305,
                                                                                                                                                        7.189099, -30.095288,
                                                                                                                                                        17.105195,
                                                                                                                                                        6.851279, -28.919359,
                                                                                                                                                        20.779305,
                                                                                                                                                        7.189099, -29.865562,
                                                                                                                                                        17.077743,
                                                                                                                                                        7.190835, -28.677343,
                                                                                                                                                        20.682404,
                                                                                                                                                        7.493045, -29.606691,
                                                                                                                                                        17.046786,
                                                                                                                                                        7.494749, -28.677343,
                                                                                                                                                        20.682404,
                                                                                                                                                        7.493045, -29.865562,
                                                                                                                                                        17.077743,
                                                                                                                                                        7.190835, -29.606691,
                                                                                                                                                        17.046786,
                                                                                                                                                        7.494749, -29.322083,
                                                                                                                                                        17.012729,
                                                                                                                                                        7.759019, -28.677343,
                                                                                                                                                        20.682404,
                                                                                                                                                        7.493045, -29.606691,
                                                                                                                                                        17.046786,
                                                                                                                                                        7.494749, -29.563403,
                                                                                                                                                        13.294515,
                                                                                                                                                        7.496508, -29.322083,
                                                                                                                                                        17.012729,
                                                                                                                                                        7.759019, -29.606691,
                                                                                                                                                        17.046786,
                                                                                                                                                        7.494749, -29.865562,
                                                                                                                                                        17.077743,
                                                                                                                                                        7.190835, -29.563403,
                                                                                                                                                        13.294515,
                                                                                                                                                        7.496508, -29.82149,
                                                                                                                                                        13.257414,
                                                                                                                                                        7.192626, -29.563403,
                                                                                                                                                        13.294515,
                                                                                                                                                        7.496508, -29.865562,
                                                                                                                                                        17.077743,
                                                                                                                                                        7.190835, -29.563403,
                                                                                                                                                        13.294515,
                                                                                                                                                        7.496508, -29.82149,
                                                                                                                                                        13.257414,
                                                                                                                                                        7.192626, -28.550432,
                                                                                                                                                        9.681303,
                                                                                                                                                        7.498202, -28.790145,
                                                                                                                                                        9.578665,
                                                                                                                                                        7.19435, -28.550432,
                                                                                                                                                        9.681303,
                                                                                                                                                        7.498202, -29.82149,
                                                                                                                                                        13.257414,
                                                                                                                                                        7.192626, -28.550432,
                                                                                                                                                        9.681303,
                                                                                                                                                        7.498202, -28.790145,
                                                                                                                                                        9.578665,
                                                                                                                                                        7.19435, -26.636809,
                                                                                                                                                        6.453385,
                                                                                                                                                        7.499715, -26.841813,
                                                                                                                                                        6.292199,
                                                                                                                                                        7.195891, -26.636809,
                                                                                                                                                        6.453385,
                                                                                                                                                        7.499715, -28.790145,
                                                                                                                                                        9.578665,
                                                                                                                                                        7.19435, -26.841813,
                                                                                                                                                        6.292199,
                                                                                                                                                        7.195891, -24.109268,
                                                                                                                                                        3.621982,
                                                                                                                                                        7.197143, -26.636809,
                                                                                                                                                        6.453385,
                                                                                                                                                        7.499715, -24.109268,
                                                                                                                                                        3.621982,
                                                                                                                                                        7.197143, -26.841813,
                                                                                                                                                        6.292199,
                                                                                                                                                        7.195891, -24.247991,
                                                                                                                                                        3.436709,
                                                                                                                                                        6.857687, -27.023735,
                                                                                                                                                        6.14914,
                                                                                                                                                        6.856416, -24.247991,
                                                                                                                                                        3.436709,
                                                                                                                                                        6.857687, -26.841813,
                                                                                                                                                        6.292199,
                                                                                                                                                        7.195891, -24.247991,
                                                                                                                                                        3.436709,
                                                                                                                                                        6.857687, -27.023735,
                                                                                                                                                        6.14914,
                                                                                                                                                        6.856416, -24.367287,
                                                                                                                                                        3.27736,
                                                                                                                                                        6.48705, -27.180181,
                                                                                                                                                        6.026093,
                                                                                                                                                        6.485761, -24.367287,
                                                                                                                                                        3.27736,
                                                                                                                                                        6.48705, -27.023735,
                                                                                                                                                        6.14914,
                                                                                                                                                        6.856416, -24.367287,
                                                                                                                                                        3.27736,
                                                                                                                                                        6.48705, -27.180181,
                                                                                                                                                        6.026093,
                                                                                                                                                        6.485761, -24.465584,
                                                                                                                                                        3.146033,
                                                                                                                                                        6.090113, -27.309087,
                                                                                                                                                        5.924678,
                                                                                                                                                        6.08881, -24.465584,
                                                                                                                                                        3.146033,
                                                                                                                                                        6.090113, -27.180181,
                                                                                                                                                        6.026093,
                                                                                                                                                        6.485761, -24.465584,
                                                                                                                                                        3.146033,
                                                                                                                                                        6.090113, -27.309087,
                                                                                                                                                        5.924678,
                                                                                                                                                        6.08881, -24.541587,
                                                                                                                                                        3.044459,
                                                                                                                                                        5.672105, -24.541587,
                                                                                                                                                        3.044459,
                                                                                                                                                        5.672105, -21.046959,
                                                                                                                                                        1.080233,
                                                                                                                                                        5.673026, -24.465584,
                                                                                                                                                        3.146033,
                                                                                                                                                        6.090113, -21.046959,
                                                                                                                                                        1.080233,
                                                                                                                                                        5.673026, -24.541587,
                                                                                                                                                        3.044459,
                                                                                                                                                        5.672105, -21.079662,
                                                                                                                                                        0.998504,
                                                                                                                                                        5.239459, -24.594294,
                                                                                                                                                        2.973975,
                                                                                                                                                        5.238533, -21.079662,
                                                                                                                                                        0.998504,
                                                                                                                                                        5.239459, -24.541587,
                                                                                                                                                        3.044459,
                                                                                                                                                        5.672105, -21.408853,
                                                                                                                                                        29.533902,
                                                                                                                                                        5.226081, -24.876977,
                                                                                                                                                        27.477877,
                                                                                                                                                        5.227045, -21.374277,
                                                                                                                                                        29.453206,
                                                                                                                                                        5.659725, -24.82266,
                                                                                                                                                        27.408884,
                                                                                                                                                        5.660683, -21.374277,
                                                                                                                                                        29.453206,
                                                                                                                                                        5.659725, -24.876977,
                                                                                                                                                        27.477877,
                                                                                                                                                        5.227045, -21.374277,
                                                                                                                                                        29.453206,
                                                                                                                                                        5.659725, -24.82266,
                                                                                                                                                        27.408884,
                                                                                                                                                        5.660683, -21.324419,
                                                                                                                                                        29.336784,
                                                                                                                                                        6.077835, -24.744337,
                                                                                                                                                        27.309337,
                                                                                                                                                        6.078785, -21.324419,
                                                                                                                                                        29.336784,
                                                                                                                                                        6.077835, -24.82266,
                                                                                                                                                        27.408884,
                                                                                                                                                        5.660683, -21.324419,
                                                                                                                                                        29.336784,
                                                                                                                                                        6.077835, -24.744337,
                                                                                                                                                        27.309337,
                                                                                                                                                        6.078785, -21.259937,
                                                                                                                                                        29.186169,
                                                                                                                                                        6.474904, -24.64304,
                                                                                                                                                        27.180547,
                                                                                                                                                        6.475844, -21.259937,
                                                                                                                                                        29.186169,
                                                                                                                                                        6.474904, -24.744337,
                                                                                                                                                        27.309337,
                                                                                                                                                        6.078785, -21.259937,
                                                                                                                                                        29.186169,
                                                                                                                                                        6.474904, -24.64304,
                                                                                                                                                        27.180547,
                                                                                                                                                        6.475844, -21.181679,
                                                                                                                                                        29.003345,
                                                                                                                                                        6.845702, -24.520102,
                                                                                                                                                        27.024211,
                                                                                                                                                        6.846629, -21.181679,
                                                                                                                                                        29.003345,
                                                                                                                                                        6.845702, -24.64304,
                                                                                                                                                        27.180547,
                                                                                                                                                        6.475844, -21.181679,
                                                                                                                                                        29.003345,
                                                                                                                                                        6.845702, -24.520102,
                                                                                                                                                        27.024211,
                                                                                                                                                        6.846629, -21.090677,
                                                                                                                                                        28.790721,
                                                                                                                                                        7.185343, -24.377144,
                                                                                                                                                        26.842389,
                                                                                                                                                        7.186257, -21.090677,
                                                                                                                                                        28.790721,
                                                                                                                                                        7.185343, -24.520102,
                                                                                                                                                        27.024211,
                                                                                                                                                        6.846629, -21.090677,
                                                                                                                                                        28.790721,
                                                                                                                                                        7.185343, -24.377144,
                                                                                                                                                        26.842389,
                                                                                                                                                        7.186257, -20.988129,
                                                                                                                                                        28.551098,
                                                                                                                                                        7.489356, -24.216048,
                                                                                                                                                        26.637475,
                                                                                                                                                        7.490253, -20.988129,
                                                                                                                                                        28.551098,
                                                                                                                                                        7.489356, -24.377144,
                                                                                                                                                        26.842389,
                                                                                                                                                        7.186257, -24.216048,
                                                                                                                                                        26.637475,
                                                                                                                                                        7.490253, -24.038936,
                                                                                                                                                        26.412168,
                                                                                                                                                        7.754613, -20.988129,
                                                                                                                                                        28.551098,
                                                                                                                                                        7.489356, -24.038936,
                                                                                                                                                        26.412168,
                                                                                                                                                        7.754613, -24.216048,
                                                                                                                                                        26.637475,
                                                                                                                                                        7.490253, -26.609285,
                                                                                                                                                        23.781823,
                                                                                                                                                        7.755846, -26.838696,
                                                                                                                                                        23.95361,
                                                                                                                                                        7.491511, -26.609285,
                                                                                                                                                        23.781823,
                                                                                                                                                        7.755846, -24.216048,
                                                                                                                                                        26.637475,
                                                                                                                                                        7.490253, -26.609285,
                                                                                                                                                        23.781823,
                                                                                                                                                        7.755846, -26.838696,
                                                                                                                                                        23.95361,
                                                                                                                                                        7.491511, -28.411268,
                                                                                                                                                        20.575849,
                                                                                                                                                        7.757349, -28.677343,
                                                                                                                                                        20.682404,
                                                                                                                                                        7.493045, -28.411268,
                                                                                                                                                        20.575849,
                                                                                                                                                        7.757349, -26.838696,
                                                                                                                                                        23.95361,
                                                                                                                                                        7.491511, -28.411268,
                                                                                                                                                        20.575849,
                                                                                                                                                        7.757349, -28.677343,
                                                                                                                                                        20.682404,
                                                                                                                                                        7.493045, -29.322083,
                                                                                                                                                        17.012729,
                                                                                                                                                        7.759019, -29.322083,
                                                                                                                                                        17.012729,
                                                                                                                                                        7.759019, -29.015488,
                                                                                                                                                        16.976024,
                                                                                                                                                        7.980164, -28.411268,
                                                                                                                                                        20.575849,
                                                                                                                                                        7.757349, -29.322083,
                                                                                                                                                        17.012729,
                                                                                                                                                        7.759019, -29.279659,
                                                                                                                                                        13.335284,
                                                                                                                                                        7.760743, -29.015488,
                                                                                                                                                        16.976024,
                                                                                                                                                        7.980164, -29.279659,
                                                                                                                                                        13.335284,
                                                                                                                                                        7.760743, -29.322083,
                                                                                                                                                        17.012729,
                                                                                                                                                        7.759019, -29.563403,
                                                                                                                                                        13.294515,
                                                                                                                                                        7.496508, -29.563403,
                                                                                                                                                        13.294515,
                                                                                                                                                        7.496508, -28.550432,
                                                                                                                                                        9.681303,
                                                                                                                                                        7.498202, -29.279659,
                                                                                                                                                        13.335284,
                                                                                                                                                        7.760743, -28.286887,
                                                                                                                                                        9.794124,
                                                                                                                                                        7.762403, -29.279659,
                                                                                                                                                        13.335284,
                                                                                                                                                        7.760743, -28.550432,
                                                                                                                                                        9.681303,
                                                                                                                                                        7.498202, -29.279659,
                                                                                                                                                        13.335284,
                                                                                                                                                        7.760743, -28.286887,
                                                                                                                                                        9.794124,
                                                                                                                                                        7.762403, -28.973994,
                                                                                                                                                        13.379183,
                                                                                                                                                        7.981851, -28.002983,
                                                                                                                                                        9.915642,
                                                                                                                                                        7.983474, -28.973994,
                                                                                                                                                        13.379183,
                                                                                                                                                        7.981851, -28.286887,
                                                                                                                                                        9.794124,
                                                                                                                                                        7.762403, -28.973994,
                                                                                                                                                        13.379183,
                                                                                                                                                        7.981851, -28.002983,
                                                                                                                                                        9.915642,
                                                                                                                                                        7.983474, -28.650435,
                                                                                                                                                        13.425635,
                                                                                                                                                        8.156917, -27.702458,
                                                                                                                                                        10.044256,
                                                                                                                                                        8.158503, -28.650435,
                                                                                                                                                        13.425635,
                                                                                                                                                        8.156917, -28.002983,
                                                                                                                                                        9.915642,
                                                                                                                                                        7.983474, -28.650435,
                                                                                                                                                        13.425635,
                                                                                                                                                        8.156917, -27.702458,
                                                                                                                                                        10.044256,
                                                                                                                                                        8.158503, -28.313244,
                                                                                                                                                        13.474028,
                                                                                                                                                        8.283638, -27.389273,
                                                                                                                                                        10.178273,
                                                                                                                                                        8.285183, -28.313244,
                                                                                                                                                        13.474028,
                                                                                                                                                        8.283638, -27.702458,
                                                                                                                                                        10.044256,
                                                                                                                                                        8.158503, -28.313244,
                                                                                                                                                        13.474028,
                                                                                                                                                        8.283638, -27.389273,
                                                                                                                                                        10.178273,
                                                                                                                                                        8.285183, -27.966864,
                                                                                                                                                        13.523724,
                                                                                                                                                        8.360342, -27.067551,
                                                                                                                                                        10.315926,
                                                                                                                                                        8.361846, -27.966864,
                                                                                                                                                        13.523724,
                                                                                                                                                        8.360342, -27.389273,
                                                                                                                                                        10.178273,
                                                                                                                                                        8.285183, -27.966864,
                                                                                                                                                        13.523724,
                                                                                                                                                        8.360342, -27.067551,
                                                                                                                                                        10.315926,
                                                                                                                                                        8.361846, -27.615855,
                                                                                                                                                        13.574069,
                                                                                                                                                        8.386021, -26.741531,
                                                                                                                                                        10.455403,
                                                                                                                                                        8.387483, -27.615855,
                                                                                                                                                        13.574069,
                                                                                                                                                        8.386021, -27.067551,
                                                                                                                                                        10.315926,
                                                                                                                                                        8.361846, -27.615855,
                                                                                                                                                        13.574069,
                                                                                                                                                        8.386021, -26.741531,
                                                                                                                                                        10.455403,
                                                                                                                                                        8.387483, -26.851072,
                                                                                                                                                        19.950766,
                                                                                                                                                        8.383031, -26.851072,
                                                                                                                                                        19.950766,
                                                                                                                                                        8.383031, -26.741531,
                                                                                                                                                        10.455403,
                                                                                                                                                        8.387483, -25.264082,
                                                                                                                                                        22.774237,
                                                                                                                                                        8.381708, -26.741531,
                                                                                                                                                        10.455403,
                                                                                                                                                        8.387483, -25.089828,
                                                                                                                                                        7.669295,
                                                                                                                                                        8.388789, -25.264082,
                                                                                                                                                        22.774237,
                                                                                                                                                        8.381708, -25.089828,
                                                                                                                                                        7.669295,
                                                                                                                                                        8.388789, -26.741531,
                                                                                                                                                        10.455403,
                                                                                                                                                        8.387483, -25.368642,
                                                                                                                                                        7.45019,
                                                                                                                                                        8.36319, -27.067551,
                                                                                                                                                        10.315926,
                                                                                                                                                        8.361846, -25.368642,
                                                                                                                                                        7.45019,
                                                                                                                                                        8.36319, -26.741531,
                                                                                                                                                        10.455403,
                                                                                                                                                        8.387483, -25.368642,
                                                                                                                                                        7.45019,
                                                                                                                                                        8.36319, -27.067551,
                                                                                                                                                        10.315926,
                                                                                                                                                        8.361846, -25.64378,
                                                                                                                                                        7.233958,
                                                                                                                                                        8.286563, -27.389273,
                                                                                                                                                        10.178273,
                                                                                                                                                        8.285183, -25.64378,
                                                                                                                                                        7.233958,
                                                                                                                                                        8.286563, -27.067551,
                                                                                                                                                        10.315926,
                                                                                                                                                        8.361846, -25.64378,
                                                                                                                                                        7.233958,
                                                                                                                                                        8.286563, -27.389273,
                                                                                                                                                        10.178273,
                                                                                                                                                        8.285183, -25.911618,
                                                                                                                                                        7.023449,
                                                                                                                                                        8.159919, -27.702458,
                                                                                                                                                        10.044256,
                                                                                                                                                        8.158503, -25.911618,
                                                                                                                                                        7.023449,
                                                                                                                                                        8.159919, -27.389273,
                                                                                                                                                        10.178273,
                                                                                                                                                        8.285183, -25.911618,
                                                                                                                                                        7.023449,
                                                                                                                                                        8.159919, -27.702458,
                                                                                                                                                        10.044256,
                                                                                                                                                        8.158503, -26.168628,
                                                                                                                                                        6.821434,
                                                                                                                                                        7.984925, -28.002983,
                                                                                                                                                        9.915642,
                                                                                                                                                        7.983474, -26.168628,
                                                                                                                                                        6.821434,
                                                                                                                                                        7.984925, -27.702458,
                                                                                                                                                        10.044256,
                                                                                                                                                        8.158503, -26.168628,
                                                                                                                                                        6.821434,
                                                                                                                                                        7.984925, -28.002983,
                                                                                                                                                        9.915642,
                                                                                                                                                        7.983474, -26.411424,
                                                                                                                                                        6.630574,
                                                                                                                                                        7.763886, -28.286887,
                                                                                                                                                        9.794124,
                                                                                                                                                        7.762403, -26.411424,
                                                                                                                                                        6.630574,
                                                                                                                                                        7.763886, -28.002983,
                                                                                                                                                        9.915642,
                                                                                                                                                        7.983474, -26.411424,
                                                                                                                                                        6.630574,
                                                                                                                                                        7.763886, -28.286887,
                                                                                                                                                        9.794124,
                                                                                                                                                        7.762403, -26.636809,
                                                                                                                                                        6.453385,
                                                                                                                                                        7.499715, -28.550432,
                                                                                                                                                        9.681303,
                                                                                                                                                        7.498202, -26.636809,
                                                                                                                                                        6.453385,
                                                                                                                                                        7.499715, -28.286887,
                                                                                                                                                        9.794124,
                                                                                                                                                        7.762403, -26.636809,
                                                                                                                                                        6.453385,
                                                                                                                                                        7.499715, -23.952944,
                                                                                                                                                        3.830737,
                                                                                                                                                        7.500945, -26.411424,
                                                                                                                                                        6.630574,
                                                                                                                                                        7.763886, -23.952944,
                                                                                                                                                        3.830737,
                                                                                                                                                        7.500945, -26.636809,
                                                                                                                                                        6.453385,
                                                                                                                                                        7.499715, -24.109268,
                                                                                                                                                        3.621982,
                                                                                                                                                        7.197143, -24.109268,
                                                                                                                                                        3.621982,
                                                                                                                                                        7.197143, -20.778729,
                                                                                                                                                        1.749985,
                                                                                                                                                        7.19802, -23.952944,
                                                                                                                                                        3.830737,
                                                                                                                                                        7.500945, -20.778729,
                                                                                                                                                        1.749985,
                                                                                                                                                        7.19802, -24.109268,
                                                                                                                                                        3.621982,
                                                                                                                                                        7.197143, -20.864799,
                                                                                                                                                        1.535117,
                                                                                                                                                        6.858579, -24.247991,
                                                                                                                                                        3.436709,
                                                                                                                                                        6.857687, -20.864799,
                                                                                                                                                        1.535117,
                                                                                                                                                        6.858579, -24.109268,
                                                                                                                                                        3.621982,
                                                                                                                                                        7.197143, -20.864799,
                                                                                                                                                        1.535117,
                                                                                                                                                        6.858579, -24.247991,
                                                                                                                                                        3.436709,
                                                                                                                                                        6.857687, -20.938816,
                                                                                                                                                        1.350318,
                                                                                                                                                        6.487953, -24.367287,
                                                                                                                                                        3.27736,
                                                                                                                                                        6.48705, -20.938816,
                                                                                                                                                        1.350318,
                                                                                                                                                        6.487953, -24.247991,
                                                                                                                                                        3.436709,
                                                                                                                                                        6.857687, -20.938816,
                                                                                                                                                        1.350318,
                                                                                                                                                        6.487953, -24.367287,
                                                                                                                                                        3.27736,
                                                                                                                                                        6.48705, -20.999804,
                                                                                                                                                        1.198021,
                                                                                                                                                        6.091026, -24.465584,
                                                                                                                                                        3.146033,
                                                                                                                                                        6.090113, -20.999804,
                                                                                                                                                        1.198021,
                                                                                                                                                        6.091026, -24.367287,
                                                                                                                                                        3.27736,
                                                                                                                                                        6.48705, -20.999804,
                                                                                                                                                        1.198021,
                                                                                                                                                        6.091026, -24.465584,
                                                                                                                                                        3.146033,
                                                                                                                                                        6.090113, -21.046959,
                                                                                                                                                        1.080233,
                                                                                                                                                        5.673026, -21.046959,
                                                                                                                                                        1.080233,
                                                                                                                                                        5.673026, -17.16303,
                                                                                                                                                        0.087412,
                                                                                                                                                        5.673492, -20.999804,
                                                                                                                                                        1.198021,
                                                                                                                                                        6.091026, -17.16303,
                                                                                                                                                        0.087412,
                                                                                                                                                        5.673492, -21.046959,
                                                                                                                                                        1.080233,
                                                                                                                                                        5.673026, -17.173498,
                                                                                                                                                        0,
                                                                                                                                                        5.239927, -21.079662,
                                                                                                                                                        0.998504,
                                                                                                                                                        5.239459, -17.173498,
                                                                                                                                                        0,
                                                                                                                                                        5.239927, -21.046959,
                                                                                                                                                        1.080233,
                                                                                                                                                        5.673026, -5.791788,
                                                                                                                                                        3.190885,
                                                                                                                                                        5.238431, -2.973975,
                                                                                                                                                        6.07447,
                                                                                                                                                        5.237079, -5.846104,
                                                                                                                                                        3.260135,
                                                                                                                                                        5.672004, -3.044331,
                                                                                                                                                        6.127306,
                                                                                                                                                        5.67066, -5.846104,
                                                                                                                                                        3.260135,
                                                                                                                                                        5.672004, -2.973975,
                                                                                                                                                        6.07447,
                                                                                                                                                        5.237079, -5.846104,
                                                                                                                                                        3.260135,
                                                                                                                                                        5.672004, -3.044331,
                                                                                                                                                        6.127306,
                                                                                                                                                        5.67066, -5.924427,
                                                                                                                                                        3.359929,
                                                                                                                                                        6.090013, -3.145782,
                                                                                                                                                        6.203432,
                                                                                                                                                        6.08868, -5.924427,
                                                                                                                                                        3.359929,
                                                                                                                                                        6.090013, -3.044331,
                                                                                                                                                        6.127306,
                                                                                                                                                        5.67066, -5.924427,
                                                                                                                                                        3.359929,
                                                                                                                                                        6.090013, -3.145782,
                                                                                                                                                        6.203432,
                                                                                                                                                        6.08868, -6.025725,
                                                                                                                                                        3.488953,
                                                                                                                                                        6.486951, -3.276992,
                                                                                                                                                        6.301846,
                                                                                                                                                        6.485632, -6.025725,
                                                                                                                                                        3.488953,
                                                                                                                                                        6.486951, -3.145782,
                                                                                                                                                        6.203432,
                                                                                                                                                        6.08868, -6.025725,
                                                                                                                                                        3.488953,
                                                                                                                                                        6.486951, -3.276992,
                                                                                                                                                        6.301846,
                                                                                                                                                        6.485632, -6.148663,
                                                                                                                                                        3.645507,
                                                                                                                                                        6.857589, -3.436231,
                                                                                                                                                        6.421251,
                                                                                                                                                        6.856288, -6.148663,
                                                                                                                                                        3.645507,
                                                                                                                                                        6.857589, -3.276992,
                                                                                                                                                        6.301846,
                                                                                                                                                        6.485632, -6.148663,
                                                                                                                                                        3.645507,
                                                                                                                                                        6.857589, -3.436231,
                                                                                                                                                        6.421251,
                                                                                                                                                        6.856288, -6.291621,
                                                                                                                                                        3.82753,
                                                                                                                                                        7.197046, -3.621404,
                                                                                                                                                        6.560075,
                                                                                                                                                        7.195765, -6.291621,
                                                                                                                                                        3.82753,
                                                                                                                                                        7.197046, -3.436231,
                                                                                                                                                        6.421251,
                                                                                                                                                        6.856288, -3.621404,
                                                                                                                                                        6.560075,
                                                                                                                                                        7.195765, -3.830069,
                                                                                                                                                        6.716489,
                                                                                                                                                        7.499592, -6.291621,
                                                                                                                                                        3.82753,
                                                                                                                                                        7.197046, -3.621404,
                                                                                                                                                        6.560075,
                                                                                                                                                        7.195765, -1.749406,
                                                                                                                                                        9.890614,
                                                                                                                                                        7.194204, -3.830069,
                                                                                                                                                        6.716489,
                                                                                                                                                        7.499592, -1.749406,
                                                                                                                                                        9.890614,
                                                                                                                                                        7.194204, -3.621404,
                                                                                                                                                        6.560075,
                                                                                                                                                        7.195765, -1.534639,
                                                                                                                                                        9.804443,
                                                                                                                                                        6.854702, -3.436231,
                                                                                                                                                        6.421251,
                                                                                                                                                        6.856288, -1.534639,
                                                                                                                                                        9.804443,
                                                                                                                                                        6.854702, -3.621404,
                                                                                                                                                        6.560075,
                                                                                                                                                        7.195765, -1.534639,
                                                                                                                                                        9.804443,
                                                                                                                                                        6.854702, -3.436231,
                                                                                                                                                        6.421251,
                                                                                                                                                        6.856288, -1.34995,
                                                                                                                                                        9.730317,
                                                                                                                                                        6.484025, -3.276992,
                                                                                                                                                        6.301846,
                                                                                                                                                        6.485632, -1.34995,
                                                                                                                                                        9.730317,
                                                                                                                                                        6.484025, -3.436231,
                                                                                                                                                        6.421251,
                                                                                                                                                        6.856288, -1.34995,
                                                                                                                                                        9.730317,
                                                                                                                                                        6.484025, -3.276992,
                                                                                                                                                        6.301846,
                                                                                                                                                        6.485632, -1.19777,
                                                                                                                                                        9.669212,
                                                                                                                                                        6.087055, -3.145782,
                                                                                                                                                        6.203432,
                                                                                                                                                        6.08868, -1.19777,
                                                                                                                                                        9.669212,
                                                                                                                                                        6.087055, -3.276992,
                                                                                                                                                        6.301846,
                                                                                                                                                        6.485632, -1.19777,
                                                                                                                                                        9.669212,
                                                                                                                                                        6.087055, -3.145782,
                                                                                                                                                        6.203432,
                                                                                                                                                        6.08868, -1.080105,
                                                                                                                                                        9.621933,
                                                                                                                                                        5.669022, -3.044331,
                                                                                                                                                        6.127306,
                                                                                                                                                        5.67066, -1.080105,
                                                                                                                                                        9.621933,
                                                                                                                                                        5.669022, -3.145782,
                                                                                                                                                        6.203432,
                                                                                                                                                        6.08868, -1.080105,
                                                                                                                                                        9.621933,
                                                                                                                                                        5.669022, -3.044331,
                                                                                                                                                        6.127306,
                                                                                                                                                        5.67066, -0.998505,
                                                                                                                                                        9.589102,
                                                                                                                                                        5.235432, -2.973975,
                                                                                                                                                        6.07447,
                                                                                                                                                        5.237079, -0.998505,
                                                                                                                                                        9.589102,
                                                                                                                                                        5.235432, -3.044331,
                                                                                                                                                        6.127306,
                                                                                                                                                        5.67066, -0.998505,
                                                                                                                                                        9.589102,
                                                                                                                                                        5.235432,
                                                                                                                                                        0,
                                                                                                                                                        13.495266,
                                                                                                                                                        5.2336, -1.080105,
                                                                                                                                                        9.621933,
                                                                                                                                                        5.669022, -0.087284,
                                                                                                                                                        13.505862,
                                                                                                                                                        5.667201, -1.080105,
                                                                                                                                                        9.621933,
                                                                                                                                                        5.669022,
                                                                                                                                                        0,
                                                                                                                                                        13.495266,
                                                                                                                                                        5.2336, -1.080105,
                                                                                                                                                        9.621933,
                                                                                                                                                        5.669022, -0.087284,
                                                                                                                                                        13.505862,
                                                                                                                                                        5.667201, -1.19777,
                                                                                                                                                        9.669212,
                                                                                                                                                        6.087055, -0.213144,
                                                                                                                                                        13.521081,
                                                                                                                                                        6.085249, -1.19777,
                                                                                                                                                        9.669212,
                                                                                                                                                        6.087055, -0.087284,
                                                                                                                                                        13.505862,
                                                                                                                                                        5.667201, -1.19777,
                                                                                                                                                        9.669212,
                                                                                                                                                        6.087055, -0.213144,
                                                                                                                                                        13.521081,
                                                                                                                                                        6.085249, -1.34995,
                                                                                                                                                        9.730317,
                                                                                                                                                        6.484025, -0.375923,
                                                                                                                                                        13.540721,
                                                                                                                                                        6.482239, -1.34995,
                                                                                                                                                        9.730317,
                                                                                                                                                        6.484025, -0.213144,
                                                                                                                                                        13.521081,
                                                                                                                                                        6.085249, -1.34995,
                                                                                                                                                        9.730317,
                                                                                                                                                        6.484025, -0.375923,
                                                                                                                                                        13.540721,
                                                                                                                                                        6.482239, -1.534639,
                                                                                                                                                        9.804443,
                                                                                                                                                        6.854702, -0.573477,
                                                                                                                                                        13.564523,
                                                                                                                                                        6.852939, -1.534639,
                                                                                                                                                        9.804443,
                                                                                                                                                        6.854702, -0.375923,
                                                                                                                                                        13.540721,
                                                                                                                                                        6.482239, -1.534639,
                                                                                                                                                        9.804443,
                                                                                                                                                        6.854702, -0.573477,
                                                                                                                                                        13.564523,
                                                                                                                                                        6.852939, -1.749406,
                                                                                                                                                        9.890614,
                                                                                                                                                        7.194204, -0.803203,
                                                                                                                                                        13.592176,
                                                                                                                                                        7.192469, -1.749406,
                                                                                                                                                        9.890614,
                                                                                                                                                        7.194204, -0.573477,
                                                                                                                                                        13.564523,
                                                                                                                                                        6.852939, -1.749406,
                                                                                                                                                        9.890614,
                                                                                                                                                        7.194204, -0.803203,
                                                                                                                                                        13.592176,
                                                                                                                                                        7.192469, -1.991421,
                                                                                                                                                        9.987694,
                                                                                                                                                        7.498058, -1.062074,
                                                                                                                                                        13.623313,
                                                                                                                                                        7.496354, -1.991421,
                                                                                                                                                        9.987694,
                                                                                                                                                        7.498058, -0.803203,
                                                                                                                                                        13.592176,
                                                                                                                                                        7.192469, -1.062074,
                                                                                                                                                        13.623313,
                                                                                                                                                        7.496354, -1.346682,
                                                                                                                                                        13.657525,
                                                                                                                                                        7.760592, -1.991421,
                                                                                                                                                        9.987694,
                                                                                                                                                        7.498058, -1.062074,
                                                                                                                                                        13.623313,
                                                                                                                                                        7.496354, -1.105361,
                                                                                                                                                        17.375584,
                                                                                                                                                        7.494595, -1.346682,
                                                                                                                                                        13.657525,
                                                                                                                                                        7.760592, -1.105361,
                                                                                                                                                        17.375584,
                                                                                                                                                        7.494595, -1.062074,
                                                                                                                                                        13.623313,
                                                                                                                                                        7.496354, -0.847275,
                                                                                                                                                        17.412505,
                                                                                                                                                        7.190678, -0.803203,
                                                                                                                                                        13.592176,
                                                                                                                                                        7.192469, -0.847275,
                                                                                                                                                        17.412505,
                                                                                                                                                        7.190678, -1.062074,
                                                                                                                                                        13.623313,
                                                                                                                                                        7.496354, -0.847275,
                                                                                                                                                        17.412505,
                                                                                                                                                        7.190678, -0.803203,
                                                                                                                                                        13.592176,
                                                                                                                                                        7.192469, -0.618246,
                                                                                                                                                        17.445249,
                                                                                                                                                        6.85112, -0.573477,
                                                                                                                                                        13.564523,
                                                                                                                                                        6.852939, -0.618246,
                                                                                                                                                        17.445249,
                                                                                                                                                        6.85112, -0.803203,
                                                                                                                                                        13.592176,
                                                                                                                                                        7.192469, -0.618246,
                                                                                                                                                        17.445249,
                                                                                                                                                        6.85112, -0.573477,
                                                                                                                                                        13.564523,
                                                                                                                                                        6.852939, -0.421292,
                                                                                                                                                        17.473384,
                                                                                                                                                        6.480395, -0.375923,
                                                                                                                                                        13.540721,
                                                                                                                                                        6.482239, -0.421292,
                                                                                                                                                        17.473384,
                                                                                                                                                        6.480395, -0.573477,
                                                                                                                                                        13.564523,
                                                                                                                                                        6.852939, -0.421292,
                                                                                                                                                        17.473384,
                                                                                                                                                        6.480395, -0.375923,
                                                                                                                                                        13.540721,
                                                                                                                                                        6.482239, -0.259006,
                                                                                                                                                        17.49654,
                                                                                                                                                        6.083386, -0.213144,
                                                                                                                                                        13.521081,
                                                                                                                                                        6.085249, -0.259006,
                                                                                                                                                        17.49654,
                                                                                                                                                        6.083386, -0.375923,
                                                                                                                                                        13.540721,
                                                                                                                                                        6.482239, -0.259006,
                                                                                                                                                        17.49654,
                                                                                                                                                        6.083386, -0.213144,
                                                                                                                                                        13.521081,
                                                                                                                                                        6.085249, -0.133527,
                                                                                                                                                        17.514411,
                                                                                                                                                        5.665322, -0.087284,
                                                                                                                                                        13.505862,
                                                                                                                                                        5.667201, -0.133527,
                                                                                                                                                        17.514411,
                                                                                                                                                        5.665322, -0.213144,
                                                                                                                                                        13.521081,
                                                                                                                                                        6.085249, -0.133527,
                                                                                                                                                        17.514411,
                                                                                                                                                        5.665322, -0.087284,
                                                                                                                                                        13.505862,
                                                                                                                                                        5.667201, -0.046508,
                                                                                                                                                        17.526762,
                                                                                                                                                        5.23171,
                                                                                                                                                        0,
                                                                                                                                                        13.495266,
                                                                                                                                                        5.2336, -0.046508,
                                                                                                                                                        17.526762,
                                                                                                                                                        5.23171, -0.087284,
                                                                                                                                                        13.505862,
                                                                                                                                                        5.667201, -17.526764,
                                                                                                                                                        30.622254,
                                                                                                                                                        5.225571, -21.408853,
                                                                                                                                                        29.533902,
                                                                                                                                                        5.226081, -17.514284,
                                                                                                                                                        30.535363,
                                                                                                                                                        5.659217, -21.374277,
                                                                                                                                                        29.453206,
                                                                                                                                                        5.659725, -17.514284,
                                                                                                                                                        30.535363,
                                                                                                                                                        5.659217, -21.408853,
                                                                                                                                                        29.533902,
                                                                                                                                                        5.226081, -17.514284,
                                                                                                                                                        30.535363,
                                                                                                                                                        5.659217, -21.374277,
                                                                                                                                                        29.453206,
                                                                                                                                                        5.659725, -17.49629,
                                                                                                                                                        30.410007,
                                                                                                                                                        6.077332, -21.324419,
                                                                                                                                                        29.336784,
                                                                                                                                                        6.077835, -17.49629,
                                                                                                                                                        30.410007,
                                                                                                                                                        6.077332, -21.374277,
                                                                                                                                                        29.453206,
                                                                                                                                                        5.659725, -17.49629,
                                                                                                                                                        30.410007,
                                                                                                                                                        6.077332, -21.324419,
                                                                                                                                                        29.336784,
                                                                                                                                                        6.077835, -17.473017,
                                                                                                                                                        30.247839,
                                                                                                                                                        6.474406, -21.259937,
                                                                                                                                                        29.186169,
                                                                                                                                                        6.474904, -17.473017,
                                                                                                                                                        30.247839,
                                                                                                                                                        6.474406, -21.324419,
                                                                                                                                                        29.336784,
                                                                                                                                                        6.077835, -17.473017,
                                                                                                                                                        30.247839,
                                                                                                                                                        6.474406, -21.259937,
                                                                                                                                                        29.186169,
                                                                                                                                                        6.474904, -17.444773,
                                                                                                                                                        30.050994,
                                                                                                                                                        6.84521, -21.181679,
                                                                                                                                                        29.003345,
                                                                                                                                                        6.845702, -17.444773,
                                                                                                                                                        30.050994,
                                                                                                                                                        6.84521, -21.259937,
                                                                                                                                                        29.186169,
                                                                                                                                                        6.474904, -17.444773,
                                                                                                                                                        30.050994,
                                                                                                                                                        6.84521, -21.181679,
                                                                                                                                                        29.003345,
                                                                                                                                                        6.845702, -17.411928,
                                                                                                                                                        29.822066,
                                                                                                                                                        7.18486, -21.090677,
                                                                                                                                                        28.790721,
                                                                                                                                                        7.185343, -17.411928,
                                                                                                                                                        29.822066,
                                                                                                                                                        7.18486, -21.181679,
                                                                                                                                                        29.003345,
                                                                                                                                                        6.845702, -17.411928,
                                                                                                                                                        29.822066,
                                                                                                                                                        7.18486, -21.090677,
                                                                                                                                                        28.790721,
                                                                                                                                                        7.185343, -17.374917,
                                                                                                                                                        29.564069,
                                                                                                                                                        7.488881, -20.988129,
                                                                                                                                                        28.551098,
                                                                                                                                                        7.489356, -17.374917,
                                                                                                                                                        29.564069,
                                                                                                                                                        7.488881, -21.090677,
                                                                                                                                                        28.790721,
                                                                                                                                                        7.185343, -20.988129,
                                                                                                                                                        28.551098,
                                                                                                                                                        7.489356, -20.875386,
                                                                                                                                                        28.287631,
                                                                                                                                                        7.753733, -17.374917,
                                                                                                                                                        29.564069,
                                                                                                                                                        7.488881, -20.875386,
                                                                                                                                                        28.287631,
                                                                                                                                                        7.753733, -20.988129,
                                                                                                                                                        28.551098,
                                                                                                                                                        7.489356, -24.038936,
                                                                                                                                                        26.412168,
                                                                                                                                                        7.754613, -24.038936,
                                                                                                                                                        26.412168,
                                                                                                                                                        7.754613, -23.848142,
                                                                                                                                                        26.169437,
                                                                                                                                                        7.975854, -20.875386,
                                                                                                                                                        28.287631,
                                                                                                                                                        7.753733, -23.848142,
                                                                                                                                                        26.169437,
                                                                                                                                                        7.975854, -24.038936,
                                                                                                                                                        26.412168,
                                                                                                                                                        7.754613, -26.362152,
                                                                                                                                                        23.596746,
                                                                                                                                                        7.977061, -26.609285,
                                                                                                                                                        23.781823,
                                                                                                                                                        7.755846, -26.362152,
                                                                                                                                                        23.596746,
                                                                                                                                                        7.977061, -24.038936,
                                                                                                                                                        26.412168,
                                                                                                                                                        7.754613, -26.362152,
                                                                                                                                                        23.596746,
                                                                                                                                                        7.977061, -26.609285,
                                                                                                                                                        23.781823,
                                                                                                                                                        7.755846, -28.124637,
                                                                                                                                                        20.461044,
                                                                                                                                                        7.978531, -28.411268,
                                                                                                                                                        20.575849,
                                                                                                                                                        7.757349, -28.124637,
                                                                                                                                                        20.461044,
                                                                                                                                                        7.978531, -26.609285,
                                                                                                                                                        23.781823,
                                                                                                                                                        7.755846, -28.124637,
                                                                                                                                                        20.461044,
                                                                                                                                                        7.978531, -28.411268,
                                                                                                                                                        20.575849,
                                                                                                                                                        7.757349, -29.015488,
                                                                                                                                                        16.976024,
                                                                                                                                                        7.980164, -29.015488,
                                                                                                                                                        16.976024,
                                                                                                                                                        7.980164, -28.690945,
                                                                                                                                                        16.937151,
                                                                                                                                                        8.155271, -28.124637,
                                                                                                                                                        20.461044,
                                                                                                                                                        7.978531, -29.015488,
                                                                                                                                                        16.976024,
                                                                                                                                                        7.980164, -28.973994,
                                                                                                                                                        13.379183,
                                                                                                                                                        7.981851, -28.690945,
                                                                                                                                                        16.937151,
                                                                                                                                                        8.155271, -28.973994,
                                                                                                                                                        13.379183,
                                                                                                                                                        7.981851, -29.015488,
                                                                                                                                                        16.976024,
                                                                                                                                                        7.980164, -29.279659,
                                                                                                                                                        13.335284,
                                                                                                                                                        7.760743, -28.650435,
                                                                                                                                                        13.425635,
                                                                                                                                                        8.156917, -28.690945,
                                                                                                                                                        16.937151,
                                                                                                                                                        8.155271, -28.973994,
                                                                                                                                                        13.379183,
                                                                                                                                                        7.981851, -28.690945,
                                                                                                                                                        16.937151,
                                                                                                                                                        8.155271, -28.650435,
                                                                                                                                                        13.425635,
                                                                                                                                                        8.156917, -28.352728,
                                                                                                                                                        16.896625,
                                                                                                                                                        8.282033, -28.313244,
                                                                                                                                                        13.474028,
                                                                                                                                                        8.283638, -28.352728,
                                                                                                                                                        16.896625,
                                                                                                                                                        8.282033, -28.650435,
                                                                                                                                                        13.425635,
                                                                                                                                                        8.156917, -28.352728,
                                                                                                                                                        16.896625,
                                                                                                                                                        8.282033, -28.313244,
                                                                                                                                                        13.474028,
                                                                                                                                                        8.283638, -28.005294,
                                                                                                                                                        16.854979,
                                                                                                                                                        8.358781, -27.966864,
                                                                                                                                                        13.523724,
                                                                                                                                                        8.360342, -28.005294,
                                                                                                                                                        16.854979,
                                                                                                                                                        8.358781, -28.313244,
                                                                                                                                                        13.474028,
                                                                                                                                                        8.283638, -28.005294,
                                                                                                                                                        16.854979,
                                                                                                                                                        8.358781, -27.966864,
                                                                                                                                                        13.523724,
                                                                                                                                                        8.360342, -27.653218,
                                                                                                                                                        16.81276,
                                                                                                                                                        8.384502, -27.615855,
                                                                                                                                                        13.574069,
                                                                                                                                                        8.386021, -27.653218,
                                                                                                                                                        16.81276,
                                                                                                                                                        8.384502, -27.966864,
                                                                                                                                                        13.523724,
                                                                                                                                                        8.360342, -27.653218,
                                                                                                                                                        16.81276,
                                                                                                                                                        8.384502, -27.615855,
                                                                                                                                                        13.574069,
                                                                                                                                                        8.386021, -26.851072,
                                                                                                                                                        19.950766,
                                                                                                                                                        8.383031, -26.851072,
                                                                                                                                                        19.950766,
                                                                                                                                                        8.383031, -27.180222,
                                                                                                                                                        20.08267,
                                                                                                                                                        8.357268, -27.653218,
                                                                                                                                                        16.81276,
                                                                                                                                                        8.384502, -27.180222,
                                                                                                                                                        20.08267,
                                                                                                                                                        8.357268, -26.851072,
                                                                                                                                                        19.950766,
                                                                                                                                                        8.383031, -25.547876,
                                                                                                                                                        22.986836,
                                                                                                                                                        8.355906, -25.264082,
                                                                                                                                                        22.774237,
                                                                                                                                                        8.381708, -25.547876,
                                                                                                                                                        22.986836,
                                                                                                                                                        8.355906, -26.851072,
                                                                                                                                                        19.950766,
                                                                                                                                                        8.383031, -25.547876,
                                                                                                                                                        22.986836,
                                                                                                                                                        8.355906, -25.264082,
                                                                                                                                                        22.774237,
                                                                                                                                                        8.381708, -23.219498,
                                                                                                                                                        25.369563,
                                                                                                                                                        8.354789, -23.000401,
                                                                                                                                                        25.090757,
                                                                                                                                                        8.380622, -23.219498,
                                                                                                                                                        25.369563,
                                                                                                                                                        8.354789, -25.264082,
                                                                                                                                                        22.774237,
                                                                                                                                                        8.381708, -23.219498,
                                                                                                                                                        25.369563,
                                                                                                                                                        8.354789, -23.000401,
                                                                                                                                                        25.090757,
                                                                                                                                                        8.380622, -20.353761,
                                                                                                                                                        27.068472,
                                                                                                                                                        8.353993, -20.214292,
                                                                                                                                                        26.742459,
                                                                                                                                                        8.379847, -20.353761,
                                                                                                                                                        27.068472,
                                                                                                                                                        8.353993, -23.000401,
                                                                                                                                                        25.090757,
                                                                                                                                                        8.380622, -20.353761,
                                                                                                                                                        27.068472,
                                                                                                                                                        8.353993, -20.214292,
                                                                                                                                                        26.742459,
                                                                                                                                                        8.379847, -17.145963,
                                                                                                                                                        27.967784,
                                                                                                                                                        8.353571, -17.095626,
                                                                                                                                                        27.616784,
                                                                                                                                                        8.379437, -17.145963,
                                                                                                                                                        27.967784,
                                                                                                                                                        8.353571, -20.214292,
                                                                                                                                                        26.742459,
                                                                                                                                                        8.379847, -17.095626,
                                                                                                                                                        27.616784,
                                                                                                                                                        8.379437, -13.856934,
                                                                                                                                                        27.654146,
                                                                                                                                                        8.37942, -17.145963,
                                                                                                                                                        27.967784,
                                                                                                                                                        8.353571, -17.095626,
                                                                                                                                                        27.616784,
                                                                                                                                                        8.379437, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -13.856934,
                                                                                                                                                        27.654146,
                                                                                                                                                        8.37942, -16.811831,
                                                                                                                                                        3.016478,
                                                                                                                                                        8.39097, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -17.095626,
                                                                                                                                                        27.616784,
                                                                                                                                                        8.379437, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -16.811831,
                                                                                                                                                        3.016478,
                                                                                                                                                        8.39097, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -16.811831,
                                                                                                                                                        3.016478,
                                                                                                                                                        8.39097, -13.573139,
                                                                                                                                                        3.05384,
                                                                                                                                                        8.390953, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -16.811831,
                                                                                                                                                        3.016478,
                                                                                                                                                        8.39097, -16.854057,
                                                                                                                                                        2.664394,
                                                                                                                                                        8.365433, -13.573139,
                                                                                                                                                        3.05384,
                                                                                                                                                        8.390953, -16.811831,
                                                                                                                                                        3.016478,
                                                                                                                                                        8.39097, -19.949837,
                                                                                                                                                        3.818624,
                                                                                                                                                        8.390594, -16.854057,
                                                                                                                                                        2.664394,
                                                                                                                                                        8.365433, -19.949837,
                                                                                                                                                        3.818624,
                                                                                                                                                        8.390594, -16.811831,
                                                                                                                                                        3.016478,
                                                                                                                                                        8.39097, -17.095626,
                                                                                                                                                        27.616784,
                                                                                                                                                        8.379437, -20.214292,
                                                                                                                                                        26.742459,
                                                                                                                                                        8.379847, -19.949837,
                                                                                                                                                        3.818624,
                                                                                                                                                        8.390594, -17.095626,
                                                                                                                                                        27.616784,
                                                                                                                                                        8.379437, -22.773308,
                                                                                                                                                        5.405613,
                                                                                                                                                        8.38985, -19.949837,
                                                                                                                                                        3.818624,
                                                                                                                                                        8.390594, -20.214292,
                                                                                                                                                        26.742459,
                                                                                                                                                        8.379847, -19.949837,
                                                                                                                                                        3.818624,
                                                                                                                                                        8.390594, -22.773308,
                                                                                                                                                        5.405613,
                                                                                                                                                        8.38985, -20.081748,
                                                                                                                                                        3.489466,
                                                                                                                                                        8.365046, -22.985915,
                                                                                                                                                        5.121811,
                                                                                                                                                        8.364281, -20.081748,
                                                                                                                                                        3.489466,
                                                                                                                                                        8.365046, -22.773308,
                                                                                                                                                        5.405613,
                                                                                                                                                        8.38985, -20.081748,
                                                                                                                                                        3.489466,
                                                                                                                                                        8.365046, -22.985915,
                                                                                                                                                        5.121811,
                                                                                                                                                        8.364281, -20.21192,
                                                                                                                                                        3.164632,
                                                                                                                                                        8.288471, -23.195719,
                                                                                                                                                        4.841736,
                                                                                                                                                        8.287685, -20.21192,
                                                                                                                                                        3.164632,
                                                                                                                                                        8.288471, -22.985915,
                                                                                                                                                        5.121811,
                                                                                                                                                        8.364281, -20.21192,
                                                                                                                                                        3.164632,
                                                                                                                                                        8.288471, -23.195719,
                                                                                                                                                        4.841736,
                                                                                                                                                        8.287685, -20.338639,
                                                                                                                                                        2.848401,
                                                                                                                                                        8.161876, -23.399956,
                                                                                                                                                        4.569077,
                                                                                                                                                        8.161069, -20.338639,
                                                                                                                                                        2.848401,
                                                                                                                                                        8.161876, -23.195719,
                                                                                                                                                        4.841736,
                                                                                                                                                        8.287685, -20.338639,
                                                                                                                                                        2.848401,
                                                                                                                                                        8.161876, -23.399956,
                                                                                                                                                        4.569077,
                                                                                                                                                        8.161069, -20.460234,
                                                                                                                                                        2.544939,
                                                                                                                                                        7.98693, -23.595937,
                                                                                                                                                        4.307424,
                                                                                                                                                        7.986103, -20.460234,
                                                                                                                                                        2.544939,
                                                                                                                                                        7.98693, -23.399956,
                                                                                                                                                        4.569077,
                                                                                                                                                        8.161069, -20.460234,
                                                                                                                                                        2.544939,
                                                                                                                                                        7.98693, -23.595937,
                                                                                                                                                        4.307424,
                                                                                                                                                        7.986103, -20.575105,
                                                                                                                                                        2.258243,
                                                                                                                                                        7.765936, -23.781079,
                                                                                                                                                        4.060226,
                                                                                                                                                        7.765091, -20.575105,
                                                                                                                                                        2.258243,
                                                                                                                                                        7.765936, -23.595937,
                                                                                                                                                        4.307424,
                                                                                                                                                        7.986103, -20.575105,
                                                                                                                                                        2.258243,
                                                                                                                                                        7.765936, -23.781079,
                                                                                                                                                        4.060226,
                                                                                                                                                        7.765091, -20.681738,
                                                                                                                                                        1.992089,
                                                                                                                                                        7.501807, -23.952944,
                                                                                                                                                        3.830737,
                                                                                                                                                        7.500945, -20.681738,
                                                                                                                                                        1.992089,
                                                                                                                                                        7.501807, -23.781079,
                                                                                                                                                        4.060226,
                                                                                                                                                        7.765091, -20.681738,
                                                                                                                                                        1.992089,
                                                                                                                                                        7.501807, -23.952944,
                                                                                                                                                        3.830737,
                                                                                                                                                        7.500945, -20.778729,
                                                                                                                                                        1.749985,
                                                                                                                                                        7.19802, -20.778729,
                                                                                                                                                        1.749985,
                                                                                                                                                        7.19802, -17.077166,
                                                                                                                                                        0.803781,
                                                                                                                                                        7.198464, -20.681738,
                                                                                                                                                        1.992089,
                                                                                                                                                        7.501807, -17.077166,
                                                                                                                                                        0.803781,
                                                                                                                                                        7.198464, -20.778729,
                                                                                                                                                        1.749985,
                                                                                                                                                        7.19802, -17.104718,
                                                                                                                                                        0.573955,
                                                                                                                                                        6.859029, -20.864799,
                                                                                                                                                        1.535117,
                                                                                                                                                        6.858579, -17.104718,
                                                                                                                                                        0.573955,
                                                                                                                                                        6.859029, -20.778729,
                                                                                                                                                        1.749985,
                                                                                                                                                        7.19802, -17.104718,
                                                                                                                                                        0.573955,
                                                                                                                                                        6.859029, -20.864799,
                                                                                                                                                        1.535117,
                                                                                                                                                        6.858579, -17.128412,
                                                                                                                                                        0.376292,
                                                                                                                                                        6.48841, -20.938816,
                                                                                                                                                        1.350318,
                                                                                                                                                        6.487953, -17.128412,
                                                                                                                                                        0.376292,
                                                                                                                                                        6.48841, -20.864799,
                                                                                                                                                        1.535117,
                                                                                                                                                        6.858579, -17.128412,
                                                                                                                                                        0.376292,
                                                                                                                                                        6.48841, -20.938816,
                                                                                                                                                        1.350318,
                                                                                                                                                        6.487953, -17.147935,
                                                                                                                                                        0.213396,
                                                                                                                                                        6.091488, -20.999804,
                                                                                                                                                        1.198021,
                                                                                                                                                        6.091026, -17.147935,
                                                                                                                                                        0.213396,
                                                                                                                                                        6.091488, -20.938816,
                                                                                                                                                        1.350318,
                                                                                                                                                        6.487953, -17.147935,
                                                                                                                                                        0.213396,
                                                                                                                                                        6.091488, -20.999804,
                                                                                                                                                        1.198021,
                                                                                                                                                        6.091026, -17.16303,
                                                                                                                                                        0.087412,
                                                                                                                                                        5.673492, -17.147935,
                                                                                                                                                        0.213396,
                                                                                                                                                        6.091488, -17.16303,
                                                                                                                                                        0.087412,
                                                                                                                                                        5.673492, -13.172475,
                                                                                                                                                        0.259258,
                                                                                                                                                        6.091466, -13.15448,
                                                                                                                                                        0.133655,
                                                                                                                                                        5.67347, -13.172475,
                                                                                                                                                        0.259258,
                                                                                                                                                        6.091466, -17.16303,
                                                                                                                                                        0.087412,
                                                                                                                                                        5.673492, -13.172475,
                                                                                                                                                        0.259258,
                                                                                                                                                        6.091466, -13.15448,
                                                                                                                                                        0.133655,
                                                                                                                                                        5.67347, -9.344346,
                                                                                                                                                        1.332481,
                                                                                                                                                        6.090963, -9.294488,
                                                                                                                                                        1.215812,
                                                                                                                                                        5.672963, -9.344346,
                                                                                                                                                        1.332481,
                                                                                                                                                        6.090963, -13.15448,
                                                                                                                                                        0.133655,
                                                                                                                                                        5.67347, -9.344346,
                                                                                                                                                        1.332481,
                                                                                                                                                        6.090963, -9.294488,
                                                                                                                                                        1.215812,
                                                                                                                                                        5.672963, -5.924427,
                                                                                                                                                        3.359929,
                                                                                                                                                        6.090013, -5.846104,
                                                                                                                                                        3.260135,
                                                                                                                                                        5.672004, -5.924427,
                                                                                                                                                        3.359929,
                                                                                                                                                        6.090013, -9.294488,
                                                                                                                                                        1.215812,
                                                                                                                                                        5.672963, -9.294488,
                                                                                                                                                        1.215812,
                                                                                                                                                        5.672963, -9.259912,
                                                                                                                                                        1.13486,
                                                                                                                                                        5.239395, -5.846104,
                                                                                                                                                        3.260135,
                                                                                                                                                        5.672004, -9.259912,
                                                                                                                                                        1.13486,
                                                                                                                                                        5.239395, -9.294488,
                                                                                                                                                        1.215812,
                                                                                                                                                        5.672963, -13.142001,
                                                                                                                                                        0.046508,
                                                                                                                                                        5.239905, -13.15448,
                                                                                                                                                        0.133655,
                                                                                                                                                        5.67347, -13.142001,
                                                                                                                                                        0.046508,
                                                                                                                                                        5.239905, -9.294488,
                                                                                                                                                        1.215812,
                                                                                                                                                        5.672963, -13.142001,
                                                                                                                                                        0.046508,
                                                                                                                                                        5.239905, -13.15448,
                                                                                                                                                        0.133655,
                                                                                                                                                        5.67347, -17.173498,
                                                                                                                                                        0,
                                                                                                                                                        5.239927, -17.16303,
                                                                                                                                                        0.087412,
                                                                                                                                                        5.673492, -17.173498,
                                                                                                                                                        0,
                                                                                                                                                        5.239927, -13.15448,
                                                                                                                                                        0.133655,
                                                                                                                                                        5.67347, -5.791788,
                                                                                                                                                        3.190885,
                                                                                                                                                        5.238431, -5.846104,
                                                                                                                                                        3.260135,
                                                                                                                                                        5.672004, -9.259912,
                                                                                                                                                        1.13486,
                                                                                                                                                        5.239395, -5.924427,
                                                                                                                                                        3.359929,
                                                                                                                                                        6.090013, -6.025725,
                                                                                                                                                        3.488953,
                                                                                                                                                        6.486951, -9.344346,
                                                                                                                                                        1.332481,
                                                                                                                                                        6.090963, -9.408828,
                                                                                                                                                        1.483331,
                                                                                                                                                        6.487891, -9.344346,
                                                                                                                                                        1.332481,
                                                                                                                                                        6.090963, -6.025725,
                                                                                                                                                        3.488953,
                                                                                                                                                        6.486951, -9.344346,
                                                                                                                                                        1.332481,
                                                                                                                                                        6.090963, -9.408828,
                                                                                                                                                        1.483331,
                                                                                                                                                        6.487891, -13.172475,
                                                                                                                                                        0.259258,
                                                                                                                                                        6.091466, -13.195748,
                                                                                                                                                        0.42166,
                                                                                                                                                        6.488389, -13.172475,
                                                                                                                                                        0.259258,
                                                                                                                                                        6.091466, -9.408828,
                                                                                                                                                        1.483331,
                                                                                                                                                        6.487891, -13.172475,
                                                                                                                                                        0.259258,
                                                                                                                                                        6.091466, -13.195748,
                                                                                                                                                        0.42166,
                                                                                                                                                        6.488389, -17.147935,
                                                                                                                                                        0.213396,
                                                                                                                                                        6.091488, -17.128412,
                                                                                                                                                        0.376292,
                                                                                                                                                        6.48841, -17.147935,
                                                                                                                                                        0.213396,
                                                                                                                                                        6.091488, -13.195748,
                                                                                                                                                        0.42166,
                                                                                                                                                        6.488389, -13.195748,
                                                                                                                                                        0.42166,
                                                                                                                                                        6.488389, -13.223992,
                                                                                                                                                        0.618724,
                                                                                                                                                        6.859008, -17.128412,
                                                                                                                                                        0.376292,
                                                                                                                                                        6.48841, -13.223992,
                                                                                                                                                        0.618724,
                                                                                                                                                        6.859008, -13.195748,
                                                                                                                                                        0.42166,
                                                                                                                                                        6.488389, -9.487086,
                                                                                                                                                        1.666373,
                                                                                                                                                        6.858517, -9.408828,
                                                                                                                                                        1.483331,
                                                                                                                                                        6.487891, -9.487086,
                                                                                                                                                        1.666373,
                                                                                                                                                        6.858517, -13.195748,
                                                                                                                                                        0.42166,
                                                                                                                                                        6.488389, -9.487086,
                                                                                                                                                        1.666373,
                                                                                                                                                        6.858517, -9.408828,
                                                                                                                                                        1.483331,
                                                                                                                                                        6.487891, -6.148663,
                                                                                                                                                        3.645507,
                                                                                                                                                        6.857589, -6.025725,
                                                                                                                                                        3.488953,
                                                                                                                                                        6.486951, -6.148663,
                                                                                                                                                        3.645507,
                                                                                                                                                        6.857589, -9.408828,
                                                                                                                                                        1.483331,
                                                                                                                                                        6.487891, -6.148663,
                                                                                                                                                        3.645507,
                                                                                                                                                        6.857589, -6.291621,
                                                                                                                                                        3.82753,
                                                                                                                                                        7.197046, -9.487086,
                                                                                                                                                        1.666373,
                                                                                                                                                        6.858517, -9.578088,
                                                                                                                                                        1.879198,
                                                                                                                                                        7.19796, -9.487086,
                                                                                                                                                        1.666373,
                                                                                                                                                        6.858517, -6.291621,
                                                                                                                                                        3.82753,
                                                                                                                                                        7.197046, -9.487086,
                                                                                                                                                        1.666373,
                                                                                                                                                        6.858517, -9.578088,
                                                                                                                                                        1.879198,
                                                                                                                                                        7.19796, -13.223992,
                                                                                                                                                        0.618724,
                                                                                                                                                        6.859008, -13.256836,
                                                                                                                                                        0.847853,
                                                                                                                                                        7.198443, -13.223992,
                                                                                                                                                        0.618724,
                                                                                                                                                        6.859008, -9.578088,
                                                                                                                                                        1.879198,
                                                                                                                                                        7.19796, -13.223992,
                                                                                                                                                        0.618724,
                                                                                                                                                        6.859008, -13.256836,
                                                                                                                                                        0.847853,
                                                                                                                                                        7.198443, -17.104718,
                                                                                                                                                        0.573955,
                                                                                                                                                        6.859029, -17.077166,
                                                                                                                                                        0.803781,
                                                                                                                                                        7.198464, -17.104718,
                                                                                                                                                        0.573955,
                                                                                                                                                        6.859029, -13.256836,
                                                                                                                                                        0.847853,
                                                                                                                                                        7.198443, -13.256836,
                                                                                                                                                        0.847853,
                                                                                                                                                        7.198443, -13.293848,
                                                                                                                                                        1.10603,
                                                                                                                                                        7.502222, -17.077166,
                                                                                                                                                        0.803781,
                                                                                                                                                        7.198464, -13.293848,
                                                                                                                                                        1.10603,
                                                                                                                                                        7.502222, -13.256836,
                                                                                                                                                        0.847853,
                                                                                                                                                        7.198443, -9.680636,
                                                                                                                                                        2.119001,
                                                                                                                                                        7.501747, -9.578088,
                                                                                                                                                        1.879198,
                                                                                                                                                        7.19796, -9.680636,
                                                                                                                                                        2.119001,
                                                                                                                                                        7.501747, -13.256836,
                                                                                                                                                        0.847853,
                                                                                                                                                        7.198443, -9.680636,
                                                                                                                                                        2.119001,
                                                                                                                                                        7.501747, -9.578088,
                                                                                                                                                        1.879198,
                                                                                                                                                        7.19796, -6.452717,
                                                                                                                                                        4.032624,
                                                                                                                                                        7.50085, -6.291621,
                                                                                                                                                        3.82753,
                                                                                                                                                        7.197046, -6.452717,
                                                                                                                                                        4.032624,
                                                                                                                                                        7.50085, -9.578088,
                                                                                                                                                        1.879198,
                                                                                                                                                        7.19796, -6.452717,
                                                                                                                                                        4.032624,
                                                                                                                                                        7.50085, -6.291621,
                                                                                                                                                        3.82753,
                                                                                                                                                        7.197046, -3.830069,
                                                                                                                                                        6.716489,
                                                                                                                                                        7.499592, -3.830069,
                                                                                                                                                        6.716489,
                                                                                                                                                        7.499592, -4.05948,
                                                                                                                                                        6.888432,
                                                                                                                                                        7.763766, -6.452717,
                                                                                                                                                        4.032624,
                                                                                                                                                        7.50085, -4.05948,
                                                                                                                                                        6.888432,
                                                                                                                                                        7.763766, -3.830069,
                                                                                                                                                        6.716489,
                                                                                                                                                        7.499592, -2.257497,
                                                                                                                                                        10.094405,
                                                                                                                                                        7.762263, -1.991421,
                                                                                                                                                        9.987694,
                                                                                                                                                        7.498058, -2.257497,
                                                                                                                                                        10.094405,
                                                                                                                                                        7.762263, -3.830069,
                                                                                                                                                        6.716489,
                                                                                                                                                        7.499592, -2.257497,
                                                                                                                                                        10.094405,
                                                                                                                                                        7.762263, -1.991421,
                                                                                                                                                        9.987694,
                                                                                                                                                        7.498058, -1.346682,
                                                                                                                                                        13.657525,
                                                                                                                                                        7.760592, -1.346682,
                                                                                                                                                        13.657525,
                                                                                                                                                        7.760592, -1.653277,
                                                                                                                                                        13.694362,
                                                                                                                                                        7.981703, -2.257497,
                                                                                                                                                        10.094405,
                                                                                                                                                        7.762263, -1.346682,
                                                                                                                                                        13.657525,
                                                                                                                                                        7.760592, -1.389106,
                                                                                                                                                        17.334971,
                                                                                                                                                        7.758868, -1.653277,
                                                                                                                                                        13.694362,
                                                                                                                                                        7.981703, -1.389106,
                                                                                                                                                        17.334971,
                                                                                                                                                        7.758868, -1.346682,
                                                                                                                                                        13.657525,
                                                                                                                                                        7.760592, -1.105361,
                                                                                                                                                        17.375584,
                                                                                                                                                        7.494595, -1.105361,
                                                                                                                                                        17.375584,
                                                                                                                                                        7.494595, -2.118333,
                                                                                                                                                        20.988796,
                                                                                                                                                        7.492901, -1.389106,
                                                                                                                                                        17.334971,
                                                                                                                                                        7.758868, -1.105361,
                                                                                                                                                        17.375584,
                                                                                                                                                        7.494595, -0.847275,
                                                                                                                                                        17.412505,
                                                                                                                                                        7.190678, -2.118333,
                                                                                                                                                        20.988796,
                                                                                                                                                        7.492901, -1.87862,
                                                                                                                                                        21.091254,
                                                                                                                                                        7.188953, -2.118333,
                                                                                                                                                        20.988796,
                                                                                                                                                        7.492901, -0.847275,
                                                                                                                                                        17.412505,
                                                                                                                                                        7.190678, -2.118333,
                                                                                                                                                        20.988796,
                                                                                                                                                        7.492901, -1.87862,
                                                                                                                                                        21.091254,
                                                                                                                                                        7.188953, -4.031956,
                                                                                                                                                        24.216714,
                                                                                                                                                        7.491388, -3.826952,
                                                                                                                                                        24.37772,
                                                                                                                                                        7.187412, -4.031956,
                                                                                                                                                        24.216714,
                                                                                                                                                        7.491388, -1.87862,
                                                                                                                                                        21.091254,
                                                                                                                                                        7.188953, -3.826952,
                                                                                                                                                        24.37772,
                                                                                                                                                        7.187412, -6.559497,
                                                                                                                                                        27.047937,
                                                                                                                                                        7.18616, -4.031956,
                                                                                                                                                        24.216714,
                                                                                                                                                        7.491388, -3.826952,
                                                                                                                                                        24.37772,
                                                                                                                                                        7.187412, -3.645029,
                                                                                                                                                        24.520578,
                                                                                                                                                        6.847803, -6.559497,
                                                                                                                                                        27.047937,
                                                                                                                                                        7.18616, -3.645029,
                                                                                                                                                        24.520578,
                                                                                                                                                        6.847803, -3.826952,
                                                                                                                                                        24.37772,
                                                                                                                                                        7.187412, -1.665895,
                                                                                                                                                        21.182156,
                                                                                                                                                        6.849368, -1.87862,
                                                                                                                                                        21.091254,
                                                                                                                                                        7.188953, -1.665895,
                                                                                                                                                        21.182156,
                                                                                                                                                        6.849368, -3.826952,
                                                                                                                                                        24.37772,
                                                                                                                                                        7.187412, -1.665895,
                                                                                                                                                        21.182156,
                                                                                                                                                        6.849368, -1.87862,
                                                                                                                                                        21.091254,
                                                                                                                                                        7.188953, -0.618246,
                                                                                                                                                        17.445249,
                                                                                                                                                        6.85112, -0.847275,
                                                                                                                                                        17.412505,
                                                                                                                                                        7.190678, -0.618246,
                                                                                                                                                        17.445249,
                                                                                                                                                        6.85112, -1.87862,
                                                                                                                                                        21.091254,
                                                                                                                                                        7.188953, -0.618246,
                                                                                                                                                        17.445249,
                                                                                                                                                        6.85112, -0.421292,
                                                                                                                                                        17.473384,
                                                                                                                                                        6.480395, -1.665895,
                                                                                                                                                        21.182156,
                                                                                                                                                        6.849368, -1.482962,
                                                                                                                                                        21.260304,
                                                                                                                                                        6.47862, -1.665895,
                                                                                                                                                        21.182156,
                                                                                                                                                        6.849368, -0.421292,
                                                                                                                                                        17.473384,
                                                                                                                                                        6.480395, -1.665895,
                                                                                                                                                        21.182156,
                                                                                                                                                        6.849368, -1.482962,
                                                                                                                                                        21.260304,
                                                                                                                                                        6.47862, -3.645029,
                                                                                                                                                        24.520578,
                                                                                                                                                        6.847803, -3.488584,
                                                                                                                                                        24.643406,
                                                                                                                                                        6.477034, -3.645029,
                                                                                                                                                        24.520578,
                                                                                                                                                        6.847803, -1.482962,
                                                                                                                                                        21.260304,
                                                                                                                                                        6.47862, -3.645029,
                                                                                                                                                        24.520578,
                                                                                                                                                        6.847803, -3.488584,
                                                                                                                                                        24.643406,
                                                                                                                                                        6.477034, -6.420774,
                                                                                                                                                        27.233009,
                                                                                                                                                        6.846531, -6.301478,
                                                                                                                                                        27.39214,
                                                                                                                                                        6.475745, -6.420774,
                                                                                                                                                        27.233009,
                                                                                                                                                        6.846531, -3.488584,
                                                                                                                                                        24.643406,
                                                                                                                                                        6.477034, -6.420774,
                                                                                                                                                        27.233009,
                                                                                                                                                        6.846531, -6.301478,
                                                                                                                                                        27.39214,
                                                                                                                                                        6.475745, -9.803966,
                                                                                                                                                        29.134601,
                                                                                                                                                        6.84564, -9.729949,
                                                                                                                                                        29.319181,
                                                                                                                                                        6.474841, -9.803966,
                                                                                                                                                        29.134601,
                                                                                                                                                        6.84564, -6.301478,
                                                                                                                                                        27.39214,
                                                                                                                                                        6.475745, -9.803966,
                                                                                                                                                        29.134601,
                                                                                                                                                        6.84564, -9.729949,
                                                                                                                                                        29.319181,
                                                                                                                                                        6.474841, -13.564046,
                                                                                                                                                        30.095763,
                                                                                                                                                        6.845189, -13.540353,
                                                                                                                                                        30.293208,
                                                                                                                                                        6.474385, -13.564046,
                                                                                                                                                        30.095763,
                                                                                                                                                        6.845189, -9.729949,
                                                                                                                                                        29.319181,
                                                                                                                                                        6.474841, -13.540353,
                                                                                                                                                        30.293208,
                                                                                                                                                        6.474385, -17.473017,
                                                                                                                                                        30.247839,
                                                                                                                                                        6.474406, -13.564046,
                                                                                                                                                        30.095763,
                                                                                                                                                        6.845189, -17.473017,
                                                                                                                                                        30.247839,
                                                                                                                                                        6.474406, -13.540353,
                                                                                                                                                        30.293208,
                                                                                                                                                        6.474385, -17.49629,
                                                                                                                                                        30.410007,
                                                                                                                                                        6.077332, -13.52083,
                                                                                                                                                        30.455869,
                                                                                                                                                        6.07731, -17.49629,
                                                                                                                                                        30.410007,
                                                                                                                                                        6.077332, -13.540353,
                                                                                                                                                        30.293208,
                                                                                                                                                        6.474385, -17.49629,
                                                                                                                                                        30.410007,
                                                                                                                                                        6.077332, -13.52083,
                                                                                                                                                        30.455869,
                                                                                                                                                        6.07731, -17.514284,
                                                                                                                                                        30.535363,
                                                                                                                                                        5.659217, -13.505735,
                                                                                                                                                        30.581606,
                                                                                                                                                        5.659196, -17.514284,
                                                                                                                                                        30.535363,
                                                                                                                                                        5.659217, -13.52083,
                                                                                                                                                        30.455869,
                                                                                                                                                        6.07731, -17.514284,
                                                                                                                                                        30.535363,
                                                                                                                                                        5.659217, -13.505735,
                                                                                                                                                        30.581606,
                                                                                                                                                        5.659196, -17.526764,
                                                                                                                                                        30.622254,
                                                                                                                                                        5.225571, -13.495267,
                                                                                                                                                        30.668762,
                                                                                                                                                        5.225549, -17.526764,
                                                                                                                                                        30.622254,
                                                                                                                                                        5.225571, -13.505735,
                                                                                                                                                        30.581606,
                                                                                                                                                        5.659196, -13.495267,
                                                                                                                                                        30.668762,
                                                                                                                                                        5.225549, -13.505735,
                                                                                                                                                        30.581606,
                                                                                                                                                        5.659196, -9.589103,
                                                                                                                                                        29.670258,
                                                                                                                                                        5.226017, -9.621805,
                                                                                                                                                        29.588785,
                                                                                                                                                        5.659661, -9.589103,
                                                                                                                                                        29.670258,
                                                                                                                                                        5.226017, -13.505735,
                                                                                                                                                        30.581606,
                                                                                                                                                        5.659196, -9.589103,
                                                                                                                                                        29.670258,
                                                                                                                                                        5.226017, -9.621805,
                                                                                                                                                        29.588785,
                                                                                                                                                        5.659661, -6.074471,
                                                                                                                                                        27.694787,
                                                                                                                                                        5.226944, -6.127178,
                                                                                                                                                        27.624559,
                                                                                                                                                        5.660582, -6.074471,
                                                                                                                                                        27.694787,
                                                                                                                                                        5.226944, -9.621805,
                                                                                                                                                        29.588785,
                                                                                                                                                        5.659661, -6.074471,
                                                                                                                                                        27.694787,
                                                                                                                                                        5.226944, -6.127178,
                                                                                                                                                        27.624559,
                                                                                                                                                        5.660582, -3.190886,
                                                                                                                                                        24.876975,
                                                                                                                                                        5.228265, -3.260007,
                                                                                                                                                        24.822786,
                                                                                                                                                        5.661896, -3.190886,
                                                                                                                                                        24.876975,
                                                                                                                                                        5.228265, -6.127178,
                                                                                                                                                        27.624559,
                                                                                                                                                        5.660582, -3.190886,
                                                                                                                                                        24.876975,
                                                                                                                                                        5.228265, -3.260007,
                                                                                                                                                        24.822786,
                                                                                                                                                        5.661896, -1.13486,
                                                                                                                                                        21.408851,
                                                                                                                                                        5.22989, -1.215684,
                                                                                                                                                        21.374403,
                                                                                                                                                        5.663512, -1.13486,
                                                                                                                                                        21.408851,
                                                                                                                                                        5.22989, -3.260007,
                                                                                                                                                        24.822786,
                                                                                                                                                        5.661896, -1.13486,
                                                                                                                                                        21.408851,
                                                                                                                                                        5.22989, -1.215684,
                                                                                                                                                        21.374403,
                                                                                                                                                        5.663512, -0.046508,
                                                                                                                                                        17.526762,
                                                                                                                                                        5.23171, -0.133527,
                                                                                                                                                        17.514411,
                                                                                                                                                        5.665322, -0.046508,
                                                                                                                                                        17.526762,
                                                                                                                                                        5.23171, -1.215684,
                                                                                                                                                        21.374403,
                                                                                                                                                        5.663512, -1.215684,
                                                                                                                                                        21.374403,
                                                                                                                                                        5.663512, -1.33223,
                                                                                                                                                        21.324669,
                                                                                                                                                        6.081591, -0.133527,
                                                                                                                                                        17.514411,
                                                                                                                                                        5.665322, -1.33223,
                                                                                                                                                        21.324669,
                                                                                                                                                        6.081591, -1.215684,
                                                                                                                                                        21.374403,
                                                                                                                                                        5.663512, -3.359677,
                                                                                                                                                        24.744587,
                                                                                                                                                        6.079988, -3.260007,
                                                                                                                                                        24.822786,
                                                                                                                                                        5.661896, -3.359677,
                                                                                                                                                        24.744587,
                                                                                                                                                        6.079988, -1.215684,
                                                                                                                                                        21.374403,
                                                                                                                                                        5.663512, -3.359677,
                                                                                                                                                        24.744587,
                                                                                                                                                        6.079988, -3.260007,
                                                                                                                                                        24.822786,
                                                                                                                                                        5.661896, -6.203181,
                                                                                                                                                        27.523232,
                                                                                                                                                        6.078685, -6.127178,
                                                                                                                                                        27.624559,
                                                                                                                                                        5.660582, -6.203181,
                                                                                                                                                        27.523232,
                                                                                                                                                        6.078685, -3.260007,
                                                                                                                                                        24.822786,
                                                                                                                                                        5.661896, -6.203181,
                                                                                                                                                        27.523232,
                                                                                                                                                        6.078685, -6.127178,
                                                                                                                                                        27.624559,
                                                                                                                                                        5.660582, -9.668961,
                                                                                                                                                        29.471244,
                                                                                                                                                        6.077772, -9.621805,
                                                                                                                                                        29.588785,
                                                                                                                                                        5.659661, -9.668961,
                                                                                                                                                        29.471244,
                                                                                                                                                        6.077772, -6.127178,
                                                                                                                                                        27.624559,
                                                                                                                                                        5.660582, -9.668961,
                                                                                                                                                        29.471244,
                                                                                                                                                        6.077772, -9.621805,
                                                                                                                                                        29.588785,
                                                                                                                                                        5.659661, -13.52083,
                                                                                                                                                        30.455869,
                                                                                                                                                        6.07731, -13.505735,
                                                                                                                                                        30.581606,
                                                                                                                                                        5.659196, -13.52083,
                                                                                                                                                        30.455869,
                                                                                                                                                        6.07731, -9.621805,
                                                                                                                                                        29.588785,
                                                                                                                                                        5.659661, -13.52083,
                                                                                                                                                        30.455869,
                                                                                                                                                        6.07731, -13.540353,
                                                                                                                                                        30.293208,
                                                                                                                                                        6.474385, -9.668961,
                                                                                                                                                        29.471244,
                                                                                                                                                        6.077772, -9.729949,
                                                                                                                                                        29.319181,
                                                                                                                                                        6.474841, -9.668961,
                                                                                                                                                        29.471244,
                                                                                                                                                        6.077772, -13.540353,
                                                                                                                                                        30.293208,
                                                                                                                                                        6.474385, -9.668961,
                                                                                                                                                        29.471244,
                                                                                                                                                        6.077772, -9.729949,
                                                                                                                                                        29.319181,
                                                                                                                                                        6.474841, -6.203181,
                                                                                                                                                        27.523232,
                                                                                                                                                        6.078685, -6.301478,
                                                                                                                                                        27.39214,
                                                                                                                                                        6.475745, -6.203181,
                                                                                                                                                        27.523232,
                                                                                                                                                        6.078685, -9.729949,
                                                                                                                                                        29.319181,
                                                                                                                                                        6.474841, -6.203181,
                                                                                                                                                        27.523232,
                                                                                                                                                        6.078685, -6.301478,
                                                                                                                                                        27.39214,
                                                                                                                                                        6.475745, -3.359677,
                                                                                                                                                        24.744587,
                                                                                                                                                        6.079988, -3.488584,
                                                                                                                                                        24.643406,
                                                                                                                                                        6.477034, -3.359677,
                                                                                                                                                        24.744587,
                                                                                                                                                        6.079988, -6.301478,
                                                                                                                                                        27.39214,
                                                                                                                                                        6.475745, -3.359677,
                                                                                                                                                        24.744587,
                                                                                                                                                        6.079988, -3.488584,
                                                                                                                                                        24.643406,
                                                                                                                                                        6.477034, -1.33223,
                                                                                                                                                        21.324669,
                                                                                                                                                        6.081591, -1.482962,
                                                                                                                                                        21.260304,
                                                                                                                                                        6.47862, -1.33223,
                                                                                                                                                        21.324669,
                                                                                                                                                        6.081591, -3.488584,
                                                                                                                                                        24.643406,
                                                                                                                                                        6.477034, -1.33223,
                                                                                                                                                        21.324669,
                                                                                                                                                        6.081591, -1.482962,
                                                                                                                                                        21.260304,
                                                                                                                                                        6.47862, -0.259006,
                                                                                                                                                        17.49654,
                                                                                                                                                        6.083386, -0.421292,
                                                                                                                                                        17.473384,
                                                                                                                                                        6.480395, -0.259006,
                                                                                                                                                        17.49654,
                                                                                                                                                        6.083386, -1.482962,
                                                                                                                                                        21.260304,
                                                                                                                                                        6.47862, -0.259006,
                                                                                                                                                        17.49654,
                                                                                                                                                        6.083386, -0.133527,
                                                                                                                                                        17.514411,
                                                                                                                                                        5.665322, -1.33223,
                                                                                                                                                        21.324669,
                                                                                                                                                        6.081591, -17.444773,
                                                                                                                                                        30.050994,
                                                                                                                                                        6.84521, -13.564046,
                                                                                                                                                        30.095763,
                                                                                                                                                        6.845189, -17.473017,
                                                                                                                                                        30.247839,
                                                                                                                                                        6.474406, -13.564046,
                                                                                                                                                        30.095763,
                                                                                                                                                        6.845189, -17.444773,
                                                                                                                                                        30.050994,
                                                                                                                                                        6.84521, -13.591598,
                                                                                                                                                        29.866138,
                                                                                                                                                        7.184839, -17.411928,
                                                                                                                                                        29.822066,
                                                                                                                                                        7.18486, -13.591598,
                                                                                                                                                        29.866138,
                                                                                                                                                        7.184839, -17.444773,
                                                                                                                                                        30.050994,
                                                                                                                                                        6.84521, -13.591598,
                                                                                                                                                        29.866138,
                                                                                                                                                        7.184839, -17.411928,
                                                                                                                                                        29.822066,
                                                                                                                                                        7.18486, -13.622646,
                                                                                                                                                        29.607356,
                                                                                                                                                        7.48886, -17.374917,
                                                                                                                                                        29.564069,
                                                                                                                                                        7.488881, -13.622646,
                                                                                                                                                        29.607356,
                                                                                                                                                        7.48886, -17.411928,
                                                                                                                                                        29.822066,
                                                                                                                                                        7.18486, -13.622646,
                                                                                                                                                        29.607356,
                                                                                                                                                        7.48886, -17.374917,
                                                                                                                                                        29.564069,
                                                                                                                                                        7.488881, -13.65678,
                                                                                                                                                        29.322826,
                                                                                                                                                        7.753248, -17.334226,
                                                                                                                                                        29.280403,
                                                                                                                                                        7.753268, -13.65678,
                                                                                                                                                        29.322826,
                                                                                                                                                        7.753248, -17.374917,
                                                                                                                                                        29.564069,
                                                                                                                                                        7.488881, -13.65678,
                                                                                                                                                        29.322826,
                                                                                                                                                        7.753248, -17.334226,
                                                                                                                                                        29.280403,
                                                                                                                                                        7.753268, -13.693551,
                                                                                                                                                        29.016297,
                                                                                                                                                        7.97452, -17.290392,
                                                                                                                                                        28.974803,
                                                                                                                                                        7.974539, -13.693551,
                                                                                                                                                        29.016297,
                                                                                                                                                        7.97452, -17.334226,
                                                                                                                                                        29.280403,
                                                                                                                                                        7.753268, -13.693551,
                                                                                                                                                        29.016297,
                                                                                                                                                        7.97452, -17.290392,
                                                                                                                                                        28.974803,
                                                                                                                                                        7.974539, -13.732475,
                                                                                                                                                        28.691806,
                                                                                                                                                        8.149761, -17.243992,
                                                                                                                                                        28.651296,
                                                                                                                                                        8.14978, -13.732475,
                                                                                                                                                        28.691806,
                                                                                                                                                        8.149761, -17.290392,
                                                                                                                                                        28.974803,
                                                                                                                                                        7.974539, -13.732475,
                                                                                                                                                        28.691806,
                                                                                                                                                        8.149761, -17.243992,
                                                                                                                                                        28.651296,
                                                                                                                                                        8.14978, -13.773039,
                                                                                                                                                        28.353626,
                                                                                                                                                        8.276662, -17.195636,
                                                                                                                                                        28.314143,
                                                                                                                                                        8.276681, -13.773039,
                                                                                                                                                        28.353626,
                                                                                                                                                        8.276662, -17.243992,
                                                                                                                                                        28.651296,
                                                                                                                                                        8.14978, -13.773039,
                                                                                                                                                        28.353626,
                                                                                                                                                        8.276662, -17.195636,
                                                                                                                                                        28.314143,
                                                                                                                                                        8.276681, -13.814708,
                                                                                                                                                        28.006215,
                                                                                                                                                        8.353553, -17.145963,
                                                                                                                                                        27.967784,
                                                                                                                                                        8.353571, -13.814708,
                                                                                                                                                        28.006215,
                                                                                                                                                        8.353553, -17.195636,
                                                                                                                                                        28.314143,
                                                                                                                                                        8.276681, -13.814708,
                                                                                                                                                        28.006215,
                                                                                                                                                        8.353553, -17.145963,
                                                                                                                                                        27.967784,
                                                                                                                                                        8.353571, -13.856934,
                                                                                                                                                        27.654146,
                                                                                                                                                        8.37942, -13.856934,
                                                                                                                                                        27.654146,
                                                                                                                                                        8.37942, -10.718928,
                                                                                                                                                        26.852,
                                                                                                                                                        8.379796, -13.814708,
                                                                                                                                                        28.006215,
                                                                                                                                                        8.353553, -13.856934,
                                                                                                                                                        27.654146,
                                                                                                                                                        8.37942, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -10.718928,
                                                                                                                                                        26.852,
                                                                                                                                                        8.379796, -10.718928,
                                                                                                                                                        26.852,
                                                                                                                                                        8.379796, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -7.895457,
                                                                                                                                                        25.265011,
                                                                                                                                                        8.38054, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -7.895457,
                                                                                                                                                        25.265011,
                                                                                                                                                        8.38054, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -7.668364,
                                                                                                                                                        5.579867,
                                                                                                                                                        8.389769, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -10.454473,
                                                                                                                                                        3.928165,
                                                                                                                                                        8.390543, -7.668364,
                                                                                                                                                        5.579867,
                                                                                                                                                        8.389769, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -10.454473,
                                                                                                                                                        3.928165,
                                                                                                                                                        8.390543, -10.315003,
                                                                                                                                                        3.602137,
                                                                                                                                                        8.364994, -7.668364,
                                                                                                                                                        5.579867,
                                                                                                                                                        8.389769, -10.315003,
                                                                                                                                                        3.602137,
                                                                                                                                                        8.364994, -10.454473,
                                                                                                                                                        3.928165,
                                                                                                                                                        8.390543, -13.522802,
                                                                                                                                                        2.702824,
                                                                                                                                                        8.365415, -13.573139,
                                                                                                                                                        3.05384,
                                                                                                                                                        8.390953, -13.522802,
                                                                                                                                                        2.702824,
                                                                                                                                                        8.365415, -10.454473,
                                                                                                                                                        3.928165,
                                                                                                                                                        8.390543, -13.522802,
                                                                                                                                                        2.702824,
                                                                                                                                                        8.365415, -13.573139,
                                                                                                                                                        3.05384,
                                                                                                                                                        8.390953, -16.854057,
                                                                                                                                                        2.664394,
                                                                                                                                                        8.365433, -16.854057,
                                                                                                                                                        2.664394,
                                                                                                                                                        8.365433, -16.895726,
                                                                                                                                                        2.316937,
                                                                                                                                                        8.288868, -13.522802,
                                                                                                                                                        2.702824,
                                                                                                                                                        8.365415, -16.854057,
                                                                                                                                                        2.664394,
                                                                                                                                                        8.365433, -20.081748,
                                                                                                                                                        3.489466,
                                                                                                                                                        8.365046, -16.895726,
                                                                                                                                                        2.316937,
                                                                                                                                                        8.288868, -20.081748,
                                                                                                                                                        3.489466,
                                                                                                                                                        8.365046, -16.854057,
                                                                                                                                                        2.664394,
                                                                                                                                                        8.365433, -19.949837,
                                                                                                                                                        3.818624,
                                                                                                                                                        8.390594, -20.21192,
                                                                                                                                                        3.164632,
                                                                                                                                                        8.288471, -16.895726,
                                                                                                                                                        2.316937,
                                                                                                                                                        8.288868, -20.081748,
                                                                                                                                                        3.489466,
                                                                                                                                                        8.365046, -16.895726,
                                                                                                                                                        2.316937,
                                                                                                                                                        8.288868, -20.21192,
                                                                                                                                                        3.164632,
                                                                                                                                                        8.288471, -16.93629,
                                                                                                                                                        1.978683,
                                                                                                                                                        8.162284, -20.338639,
                                                                                                                                                        2.848401,
                                                                                                                                                        8.161876, -16.93629,
                                                                                                                                                        1.978683,
                                                                                                                                                        8.162284, -20.21192,
                                                                                                                                                        3.164632,
                                                                                                                                                        8.288471, -16.93629,
                                                                                                                                                        1.978683,
                                                                                                                                                        8.162284, -20.338639,
                                                                                                                                                        2.848401,
                                                                                                                                                        8.161876, -16.975214,
                                                                                                                                                        1.654088,
                                                                                                                                                        7.987347, -20.460234,
                                                                                                                                                        2.544939,
                                                                                                                                                        7.98693, -16.975214,
                                                                                                                                                        1.654088,
                                                                                                                                                        7.987347, -20.338639,
                                                                                                                                                        2.848401,
                                                                                                                                                        8.161876, -16.975214,
                                                                                                                                                        1.654088,
                                                                                                                                                        7.987347, -20.460234,
                                                                                                                                                        2.544939,
                                                                                                                                                        7.98693, -17.011985,
                                                                                                                                                        1.347428,
                                                                                                                                                        7.766363, -20.575105,
                                                                                                                                                        2.258243,
                                                                                                                                                        7.765936, -17.011985,
                                                                                                                                                        1.347428,
                                                                                                                                                        7.766363, -20.460234,
                                                                                                                                                        2.544939,
                                                                                                                                                        7.98693, -17.011985,
                                                                                                                                                        1.347428,
                                                                                                                                                        7.766363, -20.575105,
                                                                                                                                                        2.258243,
                                                                                                                                                        7.765936, -17.046119,
                                                                                                                                                        1.062742,
                                                                                                                                                        7.502242, -20.681738,
                                                                                                                                                        1.992089,
                                                                                                                                                        7.501807, -17.046119,
                                                                                                                                                        1.062742,
                                                                                                                                                        7.502242, -20.575105,
                                                                                                                                                        2.258243,
                                                                                                                                                        7.765936, -17.046119,
                                                                                                                                                        1.062742,
                                                                                                                                                        7.502242, -20.681738,
                                                                                                                                                        1.992089,
                                                                                                                                                        7.501807, -17.077166,
                                                                                                                                                        0.803781,
                                                                                                                                                        7.198464, -17.046119,
                                                                                                                                                        1.062742,
                                                                                                                                                        7.502242, -17.077166,
                                                                                                                                                        0.803781,
                                                                                                                                                        7.198464, -13.293848,
                                                                                                                                                        1.10603,
                                                                                                                                                        7.502222, -13.293848,
                                                                                                                                                        1.10603,
                                                                                                                                                        7.502222, -13.334539,
                                                                                                                                                        1.389852,
                                                                                                                                                        7.766343, -17.046119,
                                                                                                                                                        1.062742,
                                                                                                                                                        7.502242, -13.334539,
                                                                                                                                                        1.389852,
                                                                                                                                                        7.766343, -13.293848,
                                                                                                                                                        1.10603,
                                                                                                                                                        7.502222, -9.793378,
                                                                                                                                                        2.382623,
                                                                                                                                                        7.765878, -9.680636,
                                                                                                                                                        2.119001,
                                                                                                                                                        7.501747, -9.793378,
                                                                                                                                                        2.382623,
                                                                                                                                                        7.765878, -13.293848,
                                                                                                                                                        1.10603,
                                                                                                                                                        7.502222, -9.793378,
                                                                                                                                                        2.382623,
                                                                                                                                                        7.765878, -9.680636,
                                                                                                                                                        2.119001,
                                                                                                                                                        7.501747, -6.629829,
                                                                                                                                                        4.258087,
                                                                                                                                                        7.764999, -6.452717,
                                                                                                                                                        4.032624,
                                                                                                                                                        7.50085, -6.629829,
                                                                                                                                                        4.258087,
                                                                                                                                                        7.764999, -9.680636,
                                                                                                                                                        2.119001,
                                                                                                                                                        7.501747, -6.629829,
                                                                                                                                                        4.258087,
                                                                                                                                                        7.764999, -6.452717,
                                                                                                                                                        4.032624,
                                                                                                                                                        7.50085, -4.05948,
                                                                                                                                                        6.888432,
                                                                                                                                                        7.763766, -4.05948,
                                                                                                                                                        6.888432,
                                                                                                                                                        7.763766, -4.306613,
                                                                                                                                                        7.073639,
                                                                                                                                                        7.984807, -6.629829,
                                                                                                                                                        4.258087,
                                                                                                                                                        7.764999, -4.306613,
                                                                                                                                                        7.073639,
                                                                                                                                                        7.984807, -4.05948,
                                                                                                                                                        6.888432,
                                                                                                                                                        7.763766, -2.544128,
                                                                                                                                                        10.209341,
                                                                                                                                                        7.983337, -2.257497,
                                                                                                                                                        10.094405,
                                                                                                                                                        7.762263, -2.544128,
                                                                                                                                                        10.209341,
                                                                                                                                                        7.983337, -4.05948,
                                                                                                                                                        6.888432,
                                                                                                                                                        7.763766, -2.544128,
                                                                                                                                                        10.209341,
                                                                                                                                                        7.983337, -2.257497,
                                                                                                                                                        10.094405,
                                                                                                                                                        7.762263, -1.653277,
                                                                                                                                                        13.694362,
                                                                                                                                                        7.981703, -1.653277,
                                                                                                                                                        13.694362,
                                                                                                                                                        7.981703, -1.97782,
                                                                                                                                                        13.733337,
                                                                                                                                                        8.156773, -2.544128,
                                                                                                                                                        10.209341,
                                                                                                                                                        7.983337, -1.653277,
                                                                                                                                                        13.694362,
                                                                                                                                                        7.981703, -1.694771,
                                                                                                                                                        17.291202,
                                                                                                                                                        7.980017, -1.97782,
                                                                                                                                                        13.733337,
                                                                                                                                                        8.156773, -1.694771,
                                                                                                                                                        17.291202,
                                                                                                                                                        7.980017, -1.653277,
                                                                                                                                                        13.694362,
                                                                                                                                                        7.981703, -1.389106,
                                                                                                                                                        17.334971,
                                                                                                                                                        7.758868, -1.389106,
                                                                                                                                                        17.334971,
                                                                                                                                                        7.758868, -2.381877,
                                                                                                                                                        20.876131,
                                                                                                                                                        7.757208, -1.694771,
                                                                                                                                                        17.291202,
                                                                                                                                                        7.980017, -2.381877,
                                                                                                                                                        20.876131,
                                                                                                                                                        7.757208, -1.389106,
                                                                                                                                                        17.334971,
                                                                                                                                                        7.758868, -2.118333,
                                                                                                                                                        20.988796,
                                                                                                                                                        7.492901, -2.118333,
                                                                                                                                                        20.988796,
                                                                                                                                                        7.492901, -4.031956,
                                                                                                                                                        24.216714,
                                                                                                                                                        7.491388, -2.381877,
                                                                                                                                                        20.876131,
                                                                                                                                                        7.757208, -4.257341,
                                                                                                                                                        24.03968,
                                                                                                                                                        7.755725, -2.381877,
                                                                                                                                                        20.876131,
                                                                                                                                                        7.757208, -4.031956,
                                                                                                                                                        24.216714,
                                                                                                                                                        7.491388, -2.381877,
                                                                                                                                                        20.876131,
                                                                                                                                                        7.757208, -4.257341,
                                                                                                                                                        24.03968,
                                                                                                                                                        7.755725, -2.665782,
                                                                                                                                                        20.754743,
                                                                                                                                                        7.978393, -4.500137,
                                                                                                                                                        23.848952,
                                                                                                                                                        7.976942, -2.665782,
                                                                                                                                                        20.754743,
                                                                                                                                                        7.978393, -4.257341,
                                                                                                                                                        24.03968,
                                                                                                                                                        7.755725, -2.665782,
                                                                                                                                                        20.754743,
                                                                                                                                                        7.978393, -4.500137,
                                                                                                                                                        23.848952,
                                                                                                                                                        7.976942, -2.966306,
                                                                                                                                                        20.626233,
                                                                                                                                                        8.153542, -4.757147,
                                                                                                                                                        23.64704,
                                                                                                                                                        8.152126, -2.966306,
                                                                                                                                                        20.626233,
                                                                                                                                                        8.153542, -4.500137,
                                                                                                                                                        23.848952,
                                                                                                                                                        7.976942, -2.966306,
                                                                                                                                                        20.626233,
                                                                                                                                                        8.153542, -4.757147,
                                                                                                                                                        23.64704,
                                                                                                                                                        8.152126, -3.279492,
                                                                                                                                                        20.492291,
                                                                                                                                                        8.280348, -5.024985,
                                                                                                                                                        23.436605,
                                                                                                                                                        8.278967, -3.279492,
                                                                                                                                                        20.492291,
                                                                                                                                                        8.280348, -4.757147,
                                                                                                                                                        23.64704,
                                                                                                                                                        8.152126, -3.279492,
                                                                                                                                                        20.492291,
                                                                                                                                                        8.280348, -5.024985,
                                                                                                                                                        23.436605,
                                                                                                                                                        8.278967, -3.601214,
                                                                                                                                                        20.354683,
                                                                                                                                                        8.35714, -5.300123,
                                                                                                                                                        23.220419,
                                                                                                                                                        8.355797, -3.601214,
                                                                                                                                                        20.354683,
                                                                                                                                                        8.35714, -5.024985,
                                                                                                                                                        23.436605,
                                                                                                                                                        8.278967, -3.601214,
                                                                                                                                                        20.354683,
                                                                                                                                                        8.35714, -5.300123,
                                                                                                                                                        23.220419,
                                                                                                                                                        8.355797, -3.927234,
                                                                                                                                                        20.215221,
                                                                                                                                                        8.382907, -5.578937,
                                                                                                                                                        23.001329,
                                                                                                                                                        8.381601, -3.927234,
                                                                                                                                                        20.215221,
                                                                                                                                                        8.382907, -5.300123,
                                                                                                                                                        23.220419,
                                                                                                                                                        8.355797, -5.578937,
                                                                                                                                                        23.001329,
                                                                                                                                                        8.381601, -5.404682,
                                                                                                                                                        7.896387,
                                                                                                                                                        8.388683, -3.927234,
                                                                                                                                                        20.215221,
                                                                                                                                                        8.382907, -7.668364,
                                                                                                                                                        5.579867,
                                                                                                                                                        8.389769, -5.404682,
                                                                                                                                                        7.896387,
                                                                                                                                                        8.388683, -5.578937,
                                                                                                                                                        23.001329,
                                                                                                                                                        8.381601, -7.668364,
                                                                                                                                                        5.579867,
                                                                                                                                                        8.389769, -7.449267,
                                                                                                                                                        5.301046,
                                                                                                                                                        8.364197, -5.404682,
                                                                                                                                                        7.896387,
                                                                                                                                                        8.388683, -7.449267,
                                                                                                                                                        5.301046,
                                                                                                                                                        8.364197, -7.668364,
                                                                                                                                                        5.579867,
                                                                                                                                                        8.389769, -10.315003,
                                                                                                                                                        3.602137,
                                                                                                                                                        8.364994, -10.315003,
                                                                                                                                                        3.602137,
                                                                                                                                                        8.364994, -10.177373,
                                                                                                                                                        3.280393,
                                                                                                                                                        8.288417, -7.449267,
                                                                                                                                                        5.301046,
                                                                                                                                                        8.364197, -10.177373,
                                                                                                                                                        3.280393,
                                                                                                                                                        8.288417, -10.315003,
                                                                                                                                                        3.602137,
                                                                                                                                                        8.364994, -13.473129,
                                                                                                                                                        2.356421,
                                                                                                                                                        8.28885, -13.522802,
                                                                                                                                                        2.702824,
                                                                                                                                                        8.365415, -13.473129,
                                                                                                                                                        2.356421,
                                                                                                                                                        8.28885, -10.315003,
                                                                                                                                                        3.602137,
                                                                                                                                                        8.364994, -13.473129,
                                                                                                                                                        2.356421,
                                                                                                                                                        8.28885, -13.522802,
                                                                                                                                                        2.702824,
                                                                                                                                                        8.365415, -16.895726,
                                                                                                                                                        2.316937,
                                                                                                                                                        8.288868, -16.895726,
                                                                                                                                                        2.316937,
                                                                                                                                                        8.288868, -16.93629,
                                                                                                                                                        1.978683,
                                                                                                                                                        8.162284, -13.473129,
                                                                                                                                                        2.356421,
                                                                                                                                                        8.28885, -13.424773,
                                                                                                                                                        2.019193,
                                                                                                                                                        8.162265, -13.473129,
                                                                                                                                                        2.356421,
                                                                                                                                                        8.28885, -16.93629,
                                                                                                                                                        1.978683,
                                                                                                                                                        8.162284, -13.473129,
                                                                                                                                                        2.356421,
                                                                                                                                                        8.28885, -13.424773,
                                                                                                                                                        2.019193,
                                                                                                                                                        8.162265, -10.177373,
                                                                                                                                                        3.280393,
                                                                                                                                                        8.288417, -10.043394,
                                                                                                                                                        2.967169,
                                                                                                                                                        8.16182, -10.177373,
                                                                                                                                                        3.280393,
                                                                                                                                                        8.288417, -13.424773,
                                                                                                                                                        2.019193,
                                                                                                                                                        8.162265, -10.177373,
                                                                                                                                                        3.280393,
                                                                                                                                                        8.288417, -10.043394,
                                                                                                                                                        2.967169,
                                                                                                                                                        8.16182, -7.233058,
                                                                                                                                                        5.025885,
                                                                                                                                                        8.287598, -7.022586,
                                                                                                                                                        4.75801,
                                                                                                                                                        8.160981, -7.233058,
                                                                                                                                                        5.025885,
                                                                                                                                                        8.287598, -10.043394,
                                                                                                                                                        2.967169,
                                                                                                                                                        8.16182, -7.233058,
                                                                                                                                                        5.025885,
                                                                                                                                                        8.287598, -7.022586,
                                                                                                                                                        4.75801,
                                                                                                                                                        8.160981, -4.840836,
                                                                                                                                                        7.473946,
                                                                                                                                                        8.286451, -4.568214,
                                                                                                                                                        7.269671,
                                                                                                                                                        8.159803, -4.840836,
                                                                                                                                                        7.473946,
                                                                                                                                                        8.286451, -7.022586,
                                                                                                                                                        4.75801,
                                                                                                                                                        8.160981, -4.840836,
                                                                                                                                                        7.473946,
                                                                                                                                                        8.286451, -4.568214,
                                                                                                                                                        7.269671,
                                                                                                                                                        8.159803, -3.163731,
                                                                                                                                                        10.457744,
                                                                                                                                                        8.285052, -2.847538,
                                                                                                                                                        10.330988,
                                                                                                                                                        8.158368, -3.163731,
                                                                                                                                                        10.457744,
                                                                                                                                                        8.285052, -4.568214,
                                                                                                                                                        7.269671,
                                                                                                                                                        8.159803, -3.163731,
                                                                                                                                                        10.457744,
                                                                                                                                                        8.285052, -2.847538,
                                                                                                                                                        10.330988,
                                                                                                                                                        8.158368, -2.316036,
                                                                                                                                                        13.773938,
                                                                                                                                                        8.283497, -1.97782,
                                                                                                                                                        13.733337,
                                                                                                                                                        8.156773, -2.316036,
                                                                                                                                                        13.773938,
                                                                                                                                                        8.283497, -2.847538,
                                                                                                                                                        10.330988,
                                                                                                                                                        8.158368, -1.97782,
                                                                                                                                                        13.733337,
                                                                                                                                                        8.156773, -2.01833,
                                                                                                                                                        17.244853,
                                                                                                                                                        8.155127, -2.316036,
                                                                                                                                                        13.773938,
                                                                                                                                                        8.283497, -2.01833,
                                                                                                                                                        17.244853,
                                                                                                                                                        8.155127, -1.97782,
                                                                                                                                                        13.733337,
                                                                                                                                                        8.156773, -1.694771,
                                                                                                                                                        17.291202,
                                                                                                                                                        7.980017, -1.694771,
                                                                                                                                                        17.291202,
                                                                                                                                                        7.980017, -2.665782,
                                                                                                                                                        20.754743,
                                                                                                                                                        7.978393, -2.01833,
                                                                                                                                                        17.244853,
                                                                                                                                                        8.155127, -2.665782,
                                                                                                                                                        20.754743,
                                                                                                                                                        7.978393, -1.694771,
                                                                                                                                                        17.291202,
                                                                                                                                                        7.980017, -2.381877,
                                                                                                                                                        20.876131,
                                                                                                                                                        7.757208, -2.966306,
                                                                                                                                                        20.626233,
                                                                                                                                                        8.153542, -2.01833,
                                                                                                                                                        17.244853,
                                                                                                                                                        8.155127, -2.665782,
                                                                                                                                                        20.754743,
                                                                                                                                                        7.978393, -2.01833,
                                                                                                                                                        17.244853,
                                                                                                                                                        8.155127, -2.966306,
                                                                                                                                                        20.626233,
                                                                                                                                                        8.153542, -2.35552,
                                                                                                                                                        17.196535,
                                                                                                                                                        8.281893, -3.279492,
                                                                                                                                                        20.492291,
                                                                                                                                                        8.280348, -2.35552,
                                                                                                                                                        17.196535,
                                                                                                                                                        8.281893, -2.966306,
                                                                                                                                                        20.626233,
                                                                                                                                                        8.153542, -2.35552,
                                                                                                                                                        17.196535,
                                                                                                                                                        8.281893, -3.279492,
                                                                                                                                                        20.492291,
                                                                                                                                                        8.280348, -2.701901,
                                                                                                                                                        17.146885,
                                                                                                                                                        8.358644, -3.601214,
                                                                                                                                                        20.354683,
                                                                                                                                                        8.35714, -2.701901,
                                                                                                                                                        17.146885,
                                                                                                                                                        8.358644, -3.279492,
                                                                                                                                                        20.492291,
                                                                                                                                                        8.280348, -2.701901,
                                                                                                                                                        17.146885,
                                                                                                                                                        8.358644, -3.601214,
                                                                                                                                                        20.354683,
                                                                                                                                                        8.35714, -3.05291,
                                                                                                                                                        17.096555,
                                                                                                                                                        8.384369, -3.927234,
                                                                                                                                                        20.215221,
                                                                                                                                                        8.382907, -3.05291,
                                                                                                                                                        17.096555,
                                                                                                                                                        8.384369, -3.601214,
                                                                                                                                                        20.354683,
                                                                                                                                                        8.35714, -3.927234,
                                                                                                                                                        20.215221,
                                                                                                                                                        8.382907, -3.817693,
                                                                                                                                                        10.719858,
                                                                                                                                                        8.387359, -3.05291,
                                                                                                                                                        17.096555,
                                                                                                                                                        8.384369, -5.404682,
                                                                                                                                                        7.896387,
                                                                                                                                                        8.388683, -3.817693,
                                                                                                                                                        10.719858,
                                                                                                                                                        8.387359, -3.927234,
                                                                                                                                                        20.215221,
                                                                                                                                                        8.382907, -5.404682,
                                                                                                                                                        7.896387,
                                                                                                                                                        8.388683, -5.120889,
                                                                                                                                                        7.683773,
                                                                                                                                                        8.36308, -3.817693,
                                                                                                                                                        10.719858,
                                                                                                                                                        8.387359, -5.120889,
                                                                                                                                                        7.683773,
                                                                                                                                                        8.36308, -5.404682,
                                                                                                                                                        7.896387,
                                                                                                                                                        8.388683, -7.449267,
                                                                                                                                                        5.301046,
                                                                                                                                                        8.364197, -7.449267,
                                                                                                                                                        5.301046,
                                                                                                                                                        8.364197, -7.233058,
                                                                                                                                                        5.025885,
                                                                                                                                                        8.287598, -5.120889,
                                                                                                                                                        7.683773,
                                                                                                                                                        8.36308, -7.233058,
                                                                                                                                                        5.025885,
                                                                                                                                                        8.287598, -7.449267,
                                                                                                                                                        5.301046,
                                                                                                                                                        8.364197, -10.177373,
                                                                                                                                                        3.280393,
                                                                                                                                                        8.288417, -4.840836,
                                                                                                                                                        7.473946,
                                                                                                                                                        8.286451, -5.120889,
                                                                                                                                                        7.683773,
                                                                                                                                                        8.36308, -7.233058,
                                                                                                                                                        5.025885,
                                                                                                                                                        8.287598, -5.120889,
                                                                                                                                                        7.683773,
                                                                                                                                                        8.36308, -4.840836,
                                                                                                                                                        7.473946,
                                                                                                                                                        8.286451, -3.488543,
                                                                                                                                                        10.587939,
                                                                                                                                                        8.361719, -3.163731,
                                                                                                                                                        10.457744,
                                                                                                                                                        8.285052, -3.488543,
                                                                                                                                                        10.587939,
                                                                                                                                                        8.361719, -4.840836,
                                                                                                                                                        7.473946,
                                                                                                                                                        8.286451, -3.488543,
                                                                                                                                                        10.587939,
                                                                                                                                                        8.361719, -3.163731,
                                                                                                                                                        10.457744,
                                                                                                                                                        8.285052, -2.663471,
                                                                                                                                                        13.81563,
                                                                                                                                                        8.360206, -2.316036,
                                                                                                                                                        13.773938,
                                                                                                                                                        8.283497, -2.663471,
                                                                                                                                                        13.81563,
                                                                                                                                                        8.360206, -3.163731,
                                                                                                                                                        10.457744,
                                                                                                                                                        8.285052, -2.316036,
                                                                                                                                                        13.773938,
                                                                                                                                                        8.283497, -2.35552,
                                                                                                                                                        17.196535,
                                                                                                                                                        8.281893, -2.663471,
                                                                                                                                                        13.81563,
                                                                                                                                                        8.360206, -2.35552,
                                                                                                                                                        17.196535,
                                                                                                                                                        8.281893, -2.316036,
                                                                                                                                                        13.773938,
                                                                                                                                                        8.283497, -2.01833,
                                                                                                                                                        17.244853,
                                                                                                                                                        8.155127, -2.701901,
                                                                                                                                                        17.146885,
                                                                                                                                                        8.358644, -2.663471,
                                                                                                                                                        13.81563,
                                                                                                                                                        8.360206, -2.35552,
                                                                                                                                                        17.196535,
                                                                                                                                                        8.281893, -2.663471,
                                                                                                                                                        13.81563,
                                                                                                                                                        8.360206, -2.701901,
                                                                                                                                                        17.146885,
                                                                                                                                                        8.358644, -3.015547,
                                                                                                                                                        13.857864,
                                                                                                                                                        8.385888, -3.05291,
                                                                                                                                                        17.096555,
                                                                                                                                                        8.384369, -3.015547,
                                                                                                                                                        13.857864,
                                                                                                                                                        8.385888, -2.701901,
                                                                                                                                                        17.146885,
                                                                                                                                                        8.358644, -3.015547,
                                                                                                                                                        13.857864,
                                                                                                                                                        8.385888, -3.05291,
                                                                                                                                                        17.096555,
                                                                                                                                                        8.384369, -3.817693,
                                                                                                                                                        10.719858,
                                                                                                                                                        8.387359, -3.817693,
                                                                                                                                                        10.719858,
                                                                                                                                                        8.387359, -3.488543,
                                                                                                                                                        10.587939,
                                                                                                                                                        8.361719, -3.015547,
                                                                                                                                                        13.857864,
                                                                                                                                                        8.385888, -3.488543,
                                                                                                                                                        10.587939,
                                                                                                                                                        8.361719, -3.817693,
                                                                                                                                                        10.719858,
                                                                                                                                                        8.387359, -5.120889,
                                                                                                                                                        7.683773,
                                                                                                                                                        8.36308, -2.663471,
                                                                                                                                                        13.81563,
                                                                                                                                                        8.360206, -3.015547,
                                                                                                                                                        13.857864,
                                                                                                                                                        8.385888, -3.488543,
                                                                                                                                                        10.587939,
                                                                                                                                                        8.361719, -2.847538,
                                                                                                                                                        10.330988,
                                                                                                                                                        8.158368, -2.544128,
                                                                                                                                                        10.209341,
                                                                                                                                                        7.983337, -1.97782,
                                                                                                                                                        13.733337,
                                                                                                                                                        8.156773, -2.544128,
                                                                                                                                                        10.209341,
                                                                                                                                                        7.983337, -2.847538,
                                                                                                                                                        10.330988,
                                                                                                                                                        8.158368, -4.306613,
                                                                                                                                                        7.073639,
                                                                                                                                                        7.984807, -4.568214,
                                                                                                                                                        7.269671,
                                                                                                                                                        8.159803, -4.306613,
                                                                                                                                                        7.073639,
                                                                                                                                                        7.984807, -2.847538,
                                                                                                                                                        10.330988,
                                                                                                                                                        8.158368, -4.306613,
                                                                                                                                                        7.073639,
                                                                                                                                                        7.984807, -4.568214,
                                                                                                                                                        7.269671,
                                                                                                                                                        8.159803, -6.820623,
                                                                                                                                                        4.500948,
                                                                                                                                                        7.986013, -7.022586,
                                                                                                                                                        4.75801,
                                                                                                                                                        8.160981, -6.820623,
                                                                                                                                                        4.500948,
                                                                                                                                                        7.986013, -4.568214,
                                                                                                                                                        7.269671,
                                                                                                                                                        8.159803, -6.820623,
                                                                                                                                                        4.500948,
                                                                                                                                                        7.986013, -7.022586,
                                                                                                                                                        4.75801,
                                                                                                                                                        8.160981, -9.914831,
                                                                                                                                                        2.666593,
                                                                                                                                                        7.986873, -10.043394,
                                                                                                                                                        2.967169,
                                                                                                                                                        8.16182, -9.914831,
                                                                                                                                                        2.666593,
                                                                                                                                                        7.986873, -7.022586,
                                                                                                                                                        4.75801,
                                                                                                                                                        8.160981, -9.914831,
                                                                                                                                                        2.666593,
                                                                                                                                                        7.986873, -10.043394,
                                                                                                                                                        2.967169,
                                                                                                                                                        8.16182, -13.378373,
                                                                                                                                                        1.695582,
                                                                                                                                                        7.987328, -13.424773,
                                                                                                                                                        2.019193,
                                                                                                                                                        8.162265, -13.378373,
                                                                                                                                                        1.695582,
                                                                                                                                                        7.987328, -10.043394,
                                                                                                                                                        2.967169,
                                                                                                                                                        8.16182, -13.378373,
                                                                                                                                                        1.695582,
                                                                                                                                                        7.987328, -13.424773,
                                                                                                                                                        2.019193,
                                                                                                                                                        8.162265, -16.975214,
                                                                                                                                                        1.654088,
                                                                                                                                                        7.987347, -16.93629,
                                                                                                                                                        1.978683,
                                                                                                                                                        8.162284, -16.975214,
                                                                                                                                                        1.654088,
                                                                                                                                                        7.987347, -13.424773,
                                                                                                                                                        2.019193,
                                                                                                                                                        8.162265, -16.975214,
                                                                                                                                                        1.654088,
                                                                                                                                                        7.987347, -17.011985,
                                                                                                                                                        1.347428,
                                                                                                                                                        7.766363, -13.378373,
                                                                                                                                                        1.695582,
                                                                                                                                                        7.987328, -13.334539,
                                                                                                                                                        1.389852,
                                                                                                                                                        7.766343, -13.378373,
                                                                                                                                                        1.695582,
                                                                                                                                                        7.987328, -17.011985,
                                                                                                                                                        1.347428,
                                                                                                                                                        7.766363, -13.378373,
                                                                                                                                                        1.695582,
                                                                                                                                                        7.987328, -13.334539,
                                                                                                                                                        1.389852,
                                                                                                                                                        7.766343, -9.914831,
                                                                                                                                                        2.666593,
                                                                                                                                                        7.986873, -9.793378,
                                                                                                                                                        2.382623,
                                                                                                                                                        7.765878, -9.914831,
                                                                                                                                                        2.666593,
                                                                                                                                                        7.986873, -13.334539,
                                                                                                                                                        1.389852,
                                                                                                                                                        7.766343, -9.914831,
                                                                                                                                                        2.666593,
                                                                                                                                                        7.986873, -9.793378,
                                                                                                                                                        2.382623,
                                                                                                                                                        7.765878, -6.820623,
                                                                                                                                                        4.500948,
                                                                                                                                                        7.986013, -6.629829,
                                                                                                                                                        4.258087,
                                                                                                                                                        7.764999, -6.820623,
                                                                                                                                                        4.500948,
                                                                                                                                                        7.986013, -9.793378,
                                                                                                                                                        2.382623,
                                                                                                                                                        7.765878, -6.820623,
                                                                                                                                                        4.500948,
                                                                                                                                                        7.986013, -6.629829,
                                                                                                                                                        4.258087,
                                                                                                                                                        7.764999, -4.306613,
                                                                                                                                                        7.073639,
                                                                                                                                                        7.984807, -17.011985,
                                                                                                                                                        1.347428,
                                                                                                                                                        7.766363, -17.046119,
                                                                                                                                                        1.062742,
                                                                                                                                                        7.502242, -13.334539,
                                                                                                                                                        1.389852,
                                                                                                                                                        7.766343, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -7.668364,
                                                                                                                                                        5.579867,
                                                                                                                                                        8.389769, -5.578937,
                                                                                                                                                        23.001329,
                                                                                                                                                        8.381601, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -5.578937,
                                                                                                                                                        23.001329,
                                                                                                                                                        8.381601, -5.578937,
                                                                                                                                                        23.001329,
                                                                                                                                                        8.381601, -7.895457,
                                                                                                                                                        25.265011,
                                                                                                                                                        8.38054, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -7.895457,
                                                                                                                                                        25.265011,
                                                                                                                                                        8.38054, -5.578937,
                                                                                                                                                        23.001329,
                                                                                                                                                        8.381601, -7.68285,
                                                                                                                                                        25.548797,
                                                                                                                                                        8.354705, -5.300123,
                                                                                                                                                        23.220419,
                                                                                                                                                        8.355797, -7.68285,
                                                                                                                                                        25.548797,
                                                                                                                                                        8.354705, -5.578937,
                                                                                                                                                        23.001329,
                                                                                                                                                        8.381601, -7.68285,
                                                                                                                                                        25.548797,
                                                                                                                                                        8.354705, -5.300123,
                                                                                                                                                        23.220419,
                                                                                                                                                        8.355797, -7.473046,
                                                                                                                                                        25.828827,
                                                                                                                                                        8.277846, -5.024985,
                                                                                                                                                        23.436605,
                                                                                                                                                        8.278967, -7.473046,
                                                                                                                                                        25.828827,
                                                                                                                                                        8.277846, -5.300123,
                                                                                                                                                        23.220419,
                                                                                                                                                        8.355797, -7.473046,
                                                                                                                                                        25.828827,
                                                                                                                                                        8.277846, -5.024985,
                                                                                                                                                        23.436605,
                                                                                                                                                        8.278967, -7.268809,
                                                                                                                                                        26.101412,
                                                                                                                                                        8.150975, -4.757147,
                                                                                                                                                        23.64704,
                                                                                                                                                        8.152126, -7.268809,
                                                                                                                                                        26.101412,
                                                                                                                                                        8.150975, -5.024985,
                                                                                                                                                        23.436605,
                                                                                                                                                        8.278967, -7.268809,
                                                                                                                                                        26.101412,
                                                                                                                                                        8.150975, -4.757147,
                                                                                                                                                        23.64704,
                                                                                                                                                        8.152126, -7.072828,
                                                                                                                                                        26.362961,
                                                                                                                                                        7.975764, -4.500137,
                                                                                                                                                        23.848952,
                                                                                                                                                        7.976942, -7.072828,
                                                                                                                                                        26.362961,
                                                                                                                                                        7.975764, -4.757147,
                                                                                                                                                        23.64704,
                                                                                                                                                        8.152126, -7.072828,
                                                                                                                                                        26.362961,
                                                                                                                                                        7.975764, -4.500137,
                                                                                                                                                        23.848952,
                                                                                                                                                        7.976942, -6.887686,
                                                                                                                                                        26.610029,
                                                                                                                                                        7.75452, -4.257341,
                                                                                                                                                        24.03968,
                                                                                                                                                        7.755725, -6.887686,
                                                                                                                                                        26.610029,
                                                                                                                                                        7.75452, -4.500137,
                                                                                                                                                        23.848952,
                                                                                                                                                        7.976942, -6.887686,
                                                                                                                                                        26.610029,
                                                                                                                                                        7.75452, -4.257341,
                                                                                                                                                        24.03968,
                                                                                                                                                        7.755725, -6.715821,
                                                                                                                                                        26.839361,
                                                                                                                                                        7.490158, -4.031956,
                                                                                                                                                        24.216714,
                                                                                                                                                        7.491388, -6.715821,
                                                                                                                                                        26.839361,
                                                                                                                                                        7.490158, -4.257341,
                                                                                                                                                        24.03968,
                                                                                                                                                        7.755725, -6.715821,
                                                                                                                                                        26.839361,
                                                                                                                                                        7.490158, -4.031956,
                                                                                                                                                        24.216714,
                                                                                                                                                        7.491388, -6.559497,
                                                                                                                                                        27.047937,
                                                                                                                                                        7.18616, -6.715821,
                                                                                                                                                        26.839361,
                                                                                                                                                        7.490158, -6.559497,
                                                                                                                                                        27.047937,
                                                                                                                                                        7.18616, -9.987027,
                                                                                                                                                        28.678009,
                                                                                                                                                        7.489296, -9.890036,
                                                                                                                                                        28.919935,
                                                                                                                                                        7.185283, -9.987027,
                                                                                                                                                        28.678009,
                                                                                                                                                        7.489296, -6.559497,
                                                                                                                                                        27.047937,
                                                                                                                                                        7.18616, -9.987027,
                                                                                                                                                        28.678009,
                                                                                                                                                        7.489296, -9.890036,
                                                                                                                                                        28.919935,
                                                                                                                                                        7.185283, -13.622646,
                                                                                                                                                        29.607356,
                                                                                                                                                        7.48886, -13.591598,
                                                                                                                                                        29.866138,
                                                                                                                                                        7.184839, -13.622646,
                                                                                                                                                        29.607356,
                                                                                                                                                        7.48886, -9.890036,
                                                                                                                                                        28.919935,
                                                                                                                                                        7.185283, -9.890036,
                                                                                                                                                        28.919935,
                                                                                                                                                        7.185283, -9.803966,
                                                                                                                                                        29.134601,
                                                                                                                                                        6.84564, -13.591598,
                                                                                                                                                        29.866138,
                                                                                                                                                        7.184839, -9.803966,
                                                                                                                                                        29.134601,
                                                                                                                                                        6.84564, -9.890036,
                                                                                                                                                        28.919935,
                                                                                                                                                        7.185283, -6.420774,
                                                                                                                                                        27.233009,
                                                                                                                                                        6.846531, -6.559497,
                                                                                                                                                        27.047937,
                                                                                                                                                        7.18616, -6.420774,
                                                                                                                                                        27.233009,
                                                                                                                                                        6.846531, -9.890036,
                                                                                                                                                        28.919935,
                                                                                                                                                        7.185283, -6.420774,
                                                                                                                                                        27.233009,
                                                                                                                                                        6.846531, -6.559497,
                                                                                                                                                        27.047937,
                                                                                                                                                        7.18616, -3.645029,
                                                                                                                                                        24.520578,
                                                                                                                                                        6.847803, -13.564046,
                                                                                                                                                        30.095763,
                                                                                                                                                        6.845189, -13.591598,
                                                                                                                                                        29.866138,
                                                                                                                                                        7.184839, -9.803966,
                                                                                                                                                        29.134601,
                                                                                                                                                        6.84564, -9.987027,
                                                                                                                                                        28.678009,
                                                                                                                                                        7.489296, -13.622646,
                                                                                                                                                        29.607356,
                                                                                                                                                        7.48886, -10.09366,
                                                                                                                                                        28.412012,
                                                                                                                                                        7.753675, -13.65678,
                                                                                                                                                        29.322826,
                                                                                                                                                        7.753248, -10.09366,
                                                                                                                                                        28.412012,
                                                                                                                                                        7.753675, -13.622646,
                                                                                                                                                        29.607356,
                                                                                                                                                        7.48886, -10.09366,
                                                                                                                                                        28.412012,
                                                                                                                                                        7.753675, -13.65678,
                                                                                                                                                        29.322826,
                                                                                                                                                        7.753248, -10.208531,
                                                                                                                                                        28.125446,
                                                                                                                                                        7.974937, -13.693551,
                                                                                                                                                        29.016297,
                                                                                                                                                        7.97452, -10.208531,
                                                                                                                                                        28.125446,
                                                                                                                                                        7.974937, -13.65678,
                                                                                                                                                        29.322826,
                                                                                                                                                        7.753248, -10.208531,
                                                                                                                                                        28.125446,
                                                                                                                                                        7.974937, -13.693551,
                                                                                                                                                        29.016297,
                                                                                                                                                        7.97452, -10.330126,
                                                                                                                                                        27.822088,
                                                                                                                                                        8.150168, -13.732475,
                                                                                                                                                        28.691806,
                                                                                                                                                        8.149761, -10.330126,
                                                                                                                                                        27.822088,
                                                                                                                                                        8.150168, -13.693551,
                                                                                                                                                        29.016297,
                                                                                                                                                        7.97452, -10.330126,
                                                                                                                                                        27.822088,
                                                                                                                                                        8.150168, -13.732475,
                                                                                                                                                        28.691806,
                                                                                                                                                        8.149761, -10.456844,
                                                                                                                                                        27.505932,
                                                                                                                                                        8.27706, -13.773039,
                                                                                                                                                        28.353626,
                                                                                                                                                        8.276662, -10.456844,
                                                                                                                                                        27.505932,
                                                                                                                                                        8.27706, -13.732475,
                                                                                                                                                        28.691806,
                                                                                                                                                        8.149761, -10.456844,
                                                                                                                                                        27.505932,
                                                                                                                                                        8.27706, -13.773039,
                                                                                                                                                        28.353626,
                                                                                                                                                        8.276662, -10.587017,
                                                                                                                                                        27.181143,
                                                                                                                                                        8.35394, -13.814708,
                                                                                                                                                        28.006215,
                                                                                                                                                        8.353553, -10.587017,
                                                                                                                                                        27.181143,
                                                                                                                                                        8.35394, -13.773039,
                                                                                                                                                        28.353626,
                                                                                                                                                        8.276662, -10.587017,
                                                                                                                                                        27.181143,
                                                                                                                                                        8.35394, -13.814708,
                                                                                                                                                        28.006215,
                                                                                                                                                        8.353553, -10.718928,
                                                                                                                                                        26.852,
                                                                                                                                                        8.379796, -10.718928,
                                                                                                                                                        26.852,
                                                                                                                                                        8.379796, -7.895457,
                                                                                                                                                        25.265011,
                                                                                                                                                        8.38054, -10.587017,
                                                                                                                                                        27.181143,
                                                                                                                                                        8.35394, -7.68285,
                                                                                                                                                        25.548797,
                                                                                                                                                        8.354705, -10.587017,
                                                                                                                                                        27.181143,
                                                                                                                                                        8.35394, -7.895457,
                                                                                                                                                        25.265011,
                                                                                                                                                        8.38054, -10.587017,
                                                                                                                                                        27.181143,
                                                                                                                                                        8.35394, -7.68285,
                                                                                                                                                        25.548797,
                                                                                                                                                        8.354705, -10.456844,
                                                                                                                                                        27.505932,
                                                                                                                                                        8.27706, -7.473046,
                                                                                                                                                        25.828827,
                                                                                                                                                        8.277846, -10.456844,
                                                                                                                                                        27.505932,
                                                                                                                                                        8.27706, -7.68285,
                                                                                                                                                        25.548797,
                                                                                                                                                        8.354705, -10.456844,
                                                                                                                                                        27.505932,
                                                                                                                                                        8.27706, -7.473046,
                                                                                                                                                        25.828827,
                                                                                                                                                        8.277846, -10.330126,
                                                                                                                                                        27.822088,
                                                                                                                                                        8.150168, -7.268809,
                                                                                                                                                        26.101412,
                                                                                                                                                        8.150975, -10.330126,
                                                                                                                                                        27.822088,
                                                                                                                                                        8.150168, -7.473046,
                                                                                                                                                        25.828827,
                                                                                                                                                        8.277846, -10.330126,
                                                                                                                                                        27.822088,
                                                                                                                                                        8.150168, -7.268809,
                                                                                                                                                        26.101412,
                                                                                                                                                        8.150975, -10.208531,
                                                                                                                                                        28.125446,
                                                                                                                                                        7.974937, -7.072828,
                                                                                                                                                        26.362961,
                                                                                                                                                        7.975764, -10.208531,
                                                                                                                                                        28.125446,
                                                                                                                                                        7.974937, -7.268809,
                                                                                                                                                        26.101412,
                                                                                                                                                        8.150975, -10.208531,
                                                                                                                                                        28.125446,
                                                                                                                                                        7.974937, -7.072828,
                                                                                                                                                        26.362961,
                                                                                                                                                        7.975764, -10.09366,
                                                                                                                                                        28.412012,
                                                                                                                                                        7.753675, -6.887686,
                                                                                                                                                        26.610029,
                                                                                                                                                        7.75452, -10.09366,
                                                                                                                                                        28.412012,
                                                                                                                                                        7.753675, -7.072828,
                                                                                                                                                        26.362961,
                                                                                                                                                        7.975764, -10.09366,
                                                                                                                                                        28.412012,
                                                                                                                                                        7.753675, -6.887686,
                                                                                                                                                        26.610029,
                                                                                                                                                        7.75452, -9.987027,
                                                                                                                                                        28.678009,
                                                                                                                                                        7.489296, -6.715821,
                                                                                                                                                        26.839361,
                                                                                                                                                        7.490158, -9.987027,
                                                                                                                                                        28.678009,
                                                                                                                                                        7.489296, -6.887686,
                                                                                                                                                        26.610029,
                                                                                                                                                        7.75452, -13.573139,
                                                                                                                                                        3.05384,
                                                                                                                                                        8.390953, -10.454473,
                                                                                                                                                        3.928165,
                                                                                                                                                        8.390543, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -17.145963,
                                                                                                                                                        27.967784,
                                                                                                                                                        8.353571, -17.195636,
                                                                                                                                                        28.314143,
                                                                                                                                                        8.276681, -20.353761,
                                                                                                                                                        27.068472,
                                                                                                                                                        8.353993, -20.491392,
                                                                                                                                                        27.390171,
                                                                                                                                                        8.277114, -20.353761,
                                                                                                                                                        27.068472,
                                                                                                                                                        8.353993, -17.195636,
                                                                                                                                                        28.314143,
                                                                                                                                                        8.276681, -20.353761,
                                                                                                                                                        27.068472,
                                                                                                                                                        8.353993, -20.491392,
                                                                                                                                                        27.390171,
                                                                                                                                                        8.277114, -23.219498,
                                                                                                                                                        25.369563,
                                                                                                                                                        8.354789, -23.435706,
                                                                                                                                                        25.644678,
                                                                                                                                                        8.277932, -23.219498,
                                                                                                                                                        25.369563,
                                                                                                                                                        8.354789, -20.491392,
                                                                                                                                                        27.390171,
                                                                                                                                                        8.277114, -23.219498,
                                                                                                                                                        25.369563,
                                                                                                                                                        8.354789, -23.435706,
                                                                                                                                                        25.644678,
                                                                                                                                                        8.277932, -25.547876,
                                                                                                                                                        22.986836,
                                                                                                                                                        8.355906, -25.827929,
                                                                                                                                                        23.196617,
                                                                                                                                                        8.27908, -25.547876,
                                                                                                                                                        22.986836,
                                                                                                                                                        8.355906, -23.435706,
                                                                                                                                                        25.644678,
                                                                                                                                                        8.277932, -25.547876,
                                                                                                                                                        22.986836,
                                                                                                                                                        8.355906, -25.827929,
                                                                                                                                                        23.196617,
                                                                                                                                                        8.27908, -27.180222,
                                                                                                                                                        20.08267,
                                                                                                                                                        8.357268, -27.505034,
                                                                                                                                                        20.212819,
                                                                                                                                                        8.280479, -27.180222,
                                                                                                                                                        20.08267,
                                                                                                                                                        8.357268, -25.827929,
                                                                                                                                                        23.196617,
                                                                                                                                                        8.27908, -27.180222,
                                                                                                                                                        20.08267,
                                                                                                                                                        8.357268, -27.505034,
                                                                                                                                                        20.212819,
                                                                                                                                                        8.280479, -28.005294,
                                                                                                                                                        16.854979,
                                                                                                                                                        8.358781, -28.352728,
                                                                                                                                                        16.896625,
                                                                                                                                                        8.282033, -28.005294,
                                                                                                                                                        16.854979,
                                                                                                                                                        8.358781, -27.505034,
                                                                                                                                                        20.212819,
                                                                                                                                                        8.280479, -27.505034,
                                                                                                                                                        20.212819,
                                                                                                                                                        8.280479, -27.821227,
                                                                                                                                                        20.3395,
                                                                                                                                                        8.153676, -28.352728,
                                                                                                                                                        16.896625,
                                                                                                                                                        8.282033, -27.821227,
                                                                                                                                                        20.3395,
                                                                                                                                                        8.153676, -27.505034,
                                                                                                                                                        20.212819,
                                                                                                                                                        8.280479, -26.100551,
                                                                                                                                                        23.400817,
                                                                                                                                                        8.152241, -25.827929,
                                                                                                                                                        23.196617,
                                                                                                                                                        8.27908, -26.100551,
                                                                                                                                                        23.400817,
                                                                                                                                                        8.152241, -27.505034,
                                                                                                                                                        20.212819,
                                                                                                                                                        8.280479, -26.100551,
                                                                                                                                                        23.400817,
                                                                                                                                                        8.152241, -25.827929,
                                                                                                                                                        23.196617,
                                                                                                                                                        8.27908, -23.646179,
                                                                                                                                                        25.912479,
                                                                                                                                                        8.151064, -23.435706,
                                                                                                                                                        25.644678,
                                                                                                                                                        8.277932, -23.646179,
                                                                                                                                                        25.912479,
                                                                                                                                                        8.151064, -25.827929,
                                                                                                                                                        23.196617,
                                                                                                                                                        8.27908, -23.646179,
                                                                                                                                                        25.912479,
                                                                                                                                                        8.151064, -23.435706,
                                                                                                                                                        25.644678,
                                                                                                                                                        8.277932, -20.625371,
                                                                                                                                                        27.703319,
                                                                                                                                                        8.150224, -20.491392,
                                                                                                                                                        27.390171,
                                                                                                                                                        8.277114, -20.625371,
                                                                                                                                                        27.703319,
                                                                                                                                                        8.150224, -23.435706,
                                                                                                                                                        25.644678,
                                                                                                                                                        8.277932, -20.625371,
                                                                                                                                                        27.703319,
                                                                                                                                                        8.150224, -20.491392,
                                                                                                                                                        27.390171,
                                                                                                                                                        8.277114, -17.243992,
                                                                                                                                                        28.651296,
                                                                                                                                                        8.14978, -17.195636,
                                                                                                                                                        28.314143,
                                                                                                                                                        8.276681, -17.243992,
                                                                                                                                                        28.651296,
                                                                                                                                                        8.14978, -20.491392,
                                                                                                                                                        27.390171,
                                                                                                                                                        8.277114, -17.243992,
                                                                                                                                                        28.651296,
                                                                                                                                                        8.14978, -17.290392,
                                                                                                                                                        28.974803,
                                                                                                                                                        7.974539, -20.625371,
                                                                                                                                                        27.703319,
                                                                                                                                                        8.150224, -20.753934,
                                                                                                                                                        28.003792,
                                                                                                                                                        7.974994, -20.625371,
                                                                                                                                                        27.703319,
                                                                                                                                                        8.150224, -17.290392,
                                                                                                                                                        28.974803,
                                                                                                                                                        7.974539, -20.625371,
                                                                                                                                                        27.703319,
                                                                                                                                                        8.150224, -20.753934,
                                                                                                                                                        28.003792,
                                                                                                                                                        7.974994, -23.646179,
                                                                                                                                                        25.912479,
                                                                                                                                                        8.151064, -23.848142,
                                                                                                                                                        26.169437,
                                                                                                                                                        7.975854, -23.646179,
                                                                                                                                                        25.912479,
                                                                                                                                                        8.151064, -20.753934,
                                                                                                                                                        28.003792,
                                                                                                                                                        7.974994, -23.646179,
                                                                                                                                                        25.912479,
                                                                                                                                                        8.151064, -23.848142,
                                                                                                                                                        26.169437,
                                                                                                                                                        7.975854, -26.100551,
                                                                                                                                                        23.400817,
                                                                                                                                                        8.152241, -26.362152,
                                                                                                                                                        23.596746,
                                                                                                                                                        7.977061, -26.100551,
                                                                                                                                                        23.400817,
                                                                                                                                                        8.152241, -23.848142,
                                                                                                                                                        26.169437,
                                                                                                                                                        7.975854, -26.100551,
                                                                                                                                                        23.400817,
                                                                                                                                                        8.152241, -26.362152,
                                                                                                                                                        23.596746,
                                                                                                                                                        7.977061, -27.821227,
                                                                                                                                                        20.3395,
                                                                                                                                                        8.153676, -28.124637,
                                                                                                                                                        20.461044,
                                                                                                                                                        7.978531, -27.821227,
                                                                                                                                                        20.3395,
                                                                                                                                                        8.153676, -26.362152,
                                                                                                                                                        23.596746,
                                                                                                                                                        7.977061, -27.821227,
                                                                                                                                                        20.3395,
                                                                                                                                                        8.153676, -28.124637,
                                                                                                                                                        20.461044,
                                                                                                                                                        7.978531, -28.690945,
                                                                                                                                                        16.937151,
                                                                                                                                                        8.155271, -28.690945,
                                                                                                                                                        16.937151,
                                                                                                                                                        8.155271, -28.352728,
                                                                                                                                                        16.896625,
                                                                                                                                                        8.282033, -27.821227,
                                                                                                                                                        20.3395,
                                                                                                                                                        8.153676, -20.753934,
                                                                                                                                                        28.003792,
                                                                                                                                                        7.974994, -20.875386,
                                                                                                                                                        28.287631,
                                                                                                                                                        7.753733, -23.848142,
                                                                                                                                                        26.169437,
                                                                                                                                                        7.975854, -20.875386,
                                                                                                                                                        28.287631,
                                                                                                                                                        7.753733, -20.753934,
                                                                                                                                                        28.003792,
                                                                                                                                                        7.974994, -17.334226,
                                                                                                                                                        29.280403,
                                                                                                                                                        7.753268, -17.290392,
                                                                                                                                                        28.974803,
                                                                                                                                                        7.974539, -17.334226,
                                                                                                                                                        29.280403,
                                                                                                                                                        7.753268, -20.753934,
                                                                                                                                                        28.003792,
                                                                                                                                                        7.974994, -17.334226,
                                                                                                                                                        29.280403,
                                                                                                                                                        7.753268, -17.374917,
                                                                                                                                                        29.564069,
                                                                                                                                                        7.488881, -20.875386,
                                                                                                                                                        28.287631,
                                                                                                                                                        7.753733, -28.005294,
                                                                                                                                                        16.854979,
                                                                                                                                                        8.358781, -27.653218,
                                                                                                                                                        16.81276,
                                                                                                                                                        8.384502, -27.180222,
                                                                                                                                                        20.08267,
                                                                                                                                                        8.357268, -1.991421,
                                                                                                                                                        9.987694,
                                                                                                                                                        7.498058, -3.830069,
                                                                                                                                                        6.716489,
                                                                                                                                                        7.499592, -1.749406,
                                                                                                                                                        9.890614,
                                                                                                                                                        7.194204, -17.104718,
                                                                                                                                                        0.573955,
                                                                                                                                                        6.859029, -17.128412,
                                                                                                                                                        0.376292,
                                                                                                                                                        6.48841, -13.223992,
                                                                                                                                                        0.618724,
                                                                                                                                                        6.859008, -23.781079,
                                                                                                                                                        4.060226,
                                                                                                                                                        7.765091, -26.411424,
                                                                                                                                                        6.630574,
                                                                                                                                                        7.763886, -23.952944,
                                                                                                                                                        3.830737,
                                                                                                                                                        7.500945, -26.411424,
                                                                                                                                                        6.630574,
                                                                                                                                                        7.763886, -23.781079,
                                                                                                                                                        4.060226,
                                                                                                                                                        7.765091, -26.168628,
                                                                                                                                                        6.821434,
                                                                                                                                                        7.984925, -23.595937,
                                                                                                                                                        4.307424,
                                                                                                                                                        7.986103, -26.168628,
                                                                                                                                                        6.821434,
                                                                                                                                                        7.984925, -23.781079,
                                                                                                                                                        4.060226,
                                                                                                                                                        7.765091, -26.168628,
                                                                                                                                                        6.821434,
                                                                                                                                                        7.984925, -23.595937,
                                                                                                                                                        4.307424,
                                                                                                                                                        7.986103, -25.911618,
                                                                                                                                                        7.023449,
                                                                                                                                                        8.159919, -23.399956,
                                                                                                                                                        4.569077,
                                                                                                                                                        8.161069, -25.911618,
                                                                                                                                                        7.023449,
                                                                                                                                                        8.159919, -23.595937,
                                                                                                                                                        4.307424,
                                                                                                                                                        7.986103, -25.911618,
                                                                                                                                                        7.023449,
                                                                                                                                                        8.159919, -23.399956,
                                                                                                                                                        4.569077,
                                                                                                                                                        8.161069, -25.64378,
                                                                                                                                                        7.233958,
                                                                                                                                                        8.286563, -23.195719,
                                                                                                                                                        4.841736,
                                                                                                                                                        8.287685, -25.64378,
                                                                                                                                                        7.233958,
                                                                                                                                                        8.286563, -23.399956,
                                                                                                                                                        4.569077,
                                                                                                                                                        8.161069, -25.64378,
                                                                                                                                                        7.233958,
                                                                                                                                                        8.286563, -23.195719,
                                                                                                                                                        4.841736,
                                                                                                                                                        8.287685, -25.368642,
                                                                                                                                                        7.45019,
                                                                                                                                                        8.36319, -22.985915,
                                                                                                                                                        5.121811,
                                                                                                                                                        8.364281, -25.368642,
                                                                                                                                                        7.45019,
                                                                                                                                                        8.36319, -23.195719,
                                                                                                                                                        4.841736,
                                                                                                                                                        8.287685, -25.368642,
                                                                                                                                                        7.45019,
                                                                                                                                                        8.36319, -22.985915,
                                                                                                                                                        5.121811,
                                                                                                                                                        8.364281, -25.089828,
                                                                                                                                                        7.669295,
                                                                                                                                                        8.388789, -22.773308,
                                                                                                                                                        5.405613,
                                                                                                                                                        8.38985, -25.089828,
                                                                                                                                                        7.669295,
                                                                                                                                                        8.388789, -22.985915,
                                                                                                                                                        5.121811,
                                                                                                                                                        8.364281, -25.089828,
                                                                                                                                                        7.669295,
                                                                                                                                                        8.388789, -22.773308,
                                                                                                                                                        5.405613,
                                                                                                                                                        8.38985, -23.000401,
                                                                                                                                                        25.090757,
                                                                                                                                                        8.380622, -23.000401,
                                                                                                                                                        25.090757,
                                                                                                                                                        8.380622, -22.773308,
                                                                                                                                                        5.405613,
                                                                                                                                                        8.38985, -20.214292,
                                                                                                                                                        26.742459,
                                                                                                                                                        8.379847, -25.264082,
                                                                                                                                                        22.774237,
                                                                                                                                                        8.381708, -25.089828,
                                                                                                                                                        7.669295,
                                                                                                                                                        8.388789, -23.000401,
                                                                                                                                                        25.090757,
                                                                                                                                                        8.380622, -28.677343,
                                                                                                                                                        20.682404,
                                                                                                                                                        7.493045, -26.838696,
                                                                                                                                                        23.95361,
                                                                                                                                                        7.491511, -28.919359,
                                                                                                                                                        20.779305,
                                                                                                                                                        7.189099, -27.047361,
                                                                                                                                                        24.109844,
                                                                                                                                                        7.187538, -28.919359,
                                                                                                                                                        20.779305,
                                                                                                                                                        7.189099, -26.838696,
                                                                                                                                                        23.95361,
                                                                                                                                                        7.491511, -28.919359,
                                                                                                                                                        20.779305,
                                                                                                                                                        7.189099, -27.047361,
                                                                                                                                                        24.109844,
                                                                                                                                                        7.187538, -29.134126,
                                                                                                                                                        20.865275,
                                                                                                                                                        6.849517, -27.232534,
                                                                                                                                                        24.248467,
                                                                                                                                                        6.847931, -29.134126,
                                                                                                                                                        20.865275,
                                                                                                                                                        6.849517, -27.047361,
                                                                                                                                                        24.109844,
                                                                                                                                                        7.187538, -29.134126,
                                                                                                                                                        20.865275,
                                                                                                                                                        6.849517, -27.232534,
                                                                                                                                                        24.248467,
                                                                                                                                                        6.847931, -29.318815,
                                                                                                                                                        20.939183,
                                                                                                                                                        6.47877, -27.391773,
                                                                                                                                                        24.367654,
                                                                                                                                                        6.477163, -29.318815,
                                                                                                                                                        20.939183,
                                                                                                                                                        6.47877, -27.232534,
                                                                                                                                                        24.248467,
                                                                                                                                                        6.847931, -29.318815,
                                                                                                                                                        20.939183,
                                                                                                                                                        6.47877, -27.391773,
                                                                                                                                                        24.367654,
                                                                                                                                                        6.477163, -29.470995,
                                                                                                                                                        21.000053,
                                                                                                                                                        6.081743, -27.522983,
                                                                                                                                                        24.465833,
                                                                                                                                                        6.080118, -29.470995,
                                                                                                                                                        21.000053,
                                                                                                                                                        6.081743, -27.391773,
                                                                                                                                                        24.367654,
                                                                                                                                                        6.477163, -29.470995,
                                                                                                                                                        21.000053,
                                                                                                                                                        6.081743, -27.522983,
                                                                                                                                                        24.465833,
                                                                                                                                                        6.080118, -29.58866,
                                                                                                                                                        21.047086,
                                                                                                                                                        5.663666, -27.624434,
                                                                                                                                                        24.541712,
                                                                                                                                                        5.662027, -29.58866,
                                                                                                                                                        21.047086,
                                                                                                                                                        5.663666, -27.522983,
                                                                                                                                                        24.465833,
                                                                                                                                                        6.080118, -29.58866,
                                                                                                                                                        21.047086,
                                                                                                                                                        5.663666, -27.624434,
                                                                                                                                                        24.541712,
                                                                                                                                                        5.662027, -29.67026,
                                                                                                                                                        21.07966,
                                                                                                                                                        5.230045, -27.694789,
                                                                                                                                                        24.594292,
                                                                                                                                                        5.228397, -29.67026,
                                                                                                                                                        21.07966,
                                                                                                                                                        5.230045, -27.624434,
                                                                                                                                                        24.541712,
                                                                                                                                                        5.662027, -24.876977,
                                                                                                                                                        27.477877,
                                                                                                                                                        5.227045, -27.694789,
                                                                                                                                                        24.594292,
                                                                                                                                                        5.228397, -24.82266,
                                                                                                                                                        27.408884,
                                                                                                                                                        5.660683, -27.624434,
                                                                                                                                                        24.541712,
                                                                                                                                                        5.662027, -24.82266,
                                                                                                                                                        27.408884,
                                                                                                                                                        5.660683, -27.694789,
                                                                                                                                                        24.594292,
                                                                                                                                                        5.228397, -24.82266,
                                                                                                                                                        27.408884,
                                                                                                                                                        5.660683, -27.624434,
                                                                                                                                                        24.541712,
                                                                                                                                                        5.662027, -24.744337,
                                                                                                                                                        27.309337,
                                                                                                                                                        6.078785, -27.522983,
                                                                                                                                                        24.465833,
                                                                                                                                                        6.080118, -24.744337,
                                                                                                                                                        27.309337,
                                                                                                                                                        6.078785, -27.624434,
                                                                                                                                                        24.541712,
                                                                                                                                                        5.662027, -24.744337,
                                                                                                                                                        27.309337,
                                                                                                                                                        6.078785, -27.522983,
                                                                                                                                                        24.465833,
                                                                                                                                                        6.080118, -24.64304,
                                                                                                                                                        27.180547,
                                                                                                                                                        6.475844, -27.391773,
                                                                                                                                                        24.367654,
                                                                                                                                                        6.477163, -24.64304,
                                                                                                                                                        27.180547,
                                                                                                                                                        6.475844, -27.522983,
                                                                                                                                                        24.465833,
                                                                                                                                                        6.080118, -24.64304,
                                                                                                                                                        27.180547,
                                                                                                                                                        6.475844, -27.391773,
                                                                                                                                                        24.367654,
                                                                                                                                                        6.477163, -24.520102,
                                                                                                                                                        27.024211,
                                                                                                                                                        6.846629, -27.232534,
                                                                                                                                                        24.248467,
                                                                                                                                                        6.847931, -24.520102,
                                                                                                                                                        27.024211,
                                                                                                                                                        6.846629, -27.391773,
                                                                                                                                                        24.367654,
                                                                                                                                                        6.477163, -24.520102,
                                                                                                                                                        27.024211,
                                                                                                                                                        6.846629, -27.232534,
                                                                                                                                                        24.248467,
                                                                                                                                                        6.847931, -24.377144,
                                                                                                                                                        26.842389,
                                                                                                                                                        7.186257, -27.047361,
                                                                                                                                                        24.109844,
                                                                                                                                                        7.187538, -24.377144,
                                                                                                                                                        26.842389,
                                                                                                                                                        7.186257, -27.232534,
                                                                                                                                                        24.248467,
                                                                                                                                                        6.847931, -27.047361,
                                                                                                                                                        24.109844,
                                                                                                                                                        7.187538, -26.838696,
                                                                                                                                                        23.95361,
                                                                                                                                                        7.491511, -24.377144,
                                                                                                                                                        26.842389,
                                                                                                                                                        7.186257, -24.216048,
                                                                                                                                                        26.637475,
                                                                                                                                                        7.490253, -24.377144,
                                                                                                                                                        26.842389,
                                                                                                                                                        7.186257, -26.838696,
                                                                                                                                                        23.95361,
                                                                                                                                                        7.491511, -27.309087,
                                                                                                                                                        5.924678,
                                                                                                                                                        6.08881, -27.180181,
                                                                                                                                                        6.026093,
                                                                                                                                                        6.485761, -29.336535,
                                                                                                                                                        9.344596,
                                                                                                                                                        6.087207, -29.185803,
                                                                                                                                                        9.409196,
                                                                                                                                                        6.484175, -29.336535,
                                                                                                                                                        9.344596,
                                                                                                                                                        6.087207, -27.180181,
                                                                                                                                                        6.026093,
                                                                                                                                                        6.485761, -29.336535,
                                                                                                                                                        9.344596,
                                                                                                                                                        6.087207, -29.185803,
                                                                                                                                                        9.409196,
                                                                                                                                                        6.484175, -30.409759,
                                                                                                                                                        13.172725,
                                                                                                                                                        6.085413, -30.247473,
                                                                                                                                                        13.196115,
                                                                                                                                                        6.4824, -30.409759,
                                                                                                                                                        13.172725,
                                                                                                                                                        6.085413, -29.185803,
                                                                                                                                                        9.409196,
                                                                                                                                                        6.484175, -30.409759,
                                                                                                                                                        13.172725,
                                                                                                                                                        6.085413, -30.247473,
                                                                                                                                                        13.196115,
                                                                                                                                                        6.4824, -30.455621,
                                                                                                                                                        17.148185,
                                                                                                                                                        6.083549, -30.292841,
                                                                                                                                                        17.128779,
                                                                                                                                                        6.480556, -30.455621,
                                                                                                                                                        17.148185,
                                                                                                                                                        6.083549, -30.247473,
                                                                                                                                                        13.196115,
                                                                                                                                                        6.4824, -30.247473,
                                                                                                                                                        13.196115,
                                                                                                                                                        6.4824, -30.050519,
                                                                                                                                                        13.224469,
                                                                                                                                                        6.853099, -30.292841,
                                                                                                                                                        17.128779,
                                                                                                                                                        6.480556, -30.050519,
                                                                                                                                                        13.224469,
                                                                                                                                                        6.853099, -30.247473,
                                                                                                                                                        13.196115,
                                                                                                                                                        6.4824, -29.00287,
                                                                                                                                                        9.487563,
                                                                                                                                                        6.854851, -29.185803,
                                                                                                                                                        9.409196,
                                                                                                                                                        6.484175, -29.00287,
                                                                                                                                                        9.487563,
                                                                                                                                                        6.854851, -30.247473,
                                                                                                                                                        13.196115,
                                                                                                                                                        6.4824, -29.00287,
                                                                                                                                                        9.487563,
                                                                                                                                                        6.854851, -29.185803,
                                                                                                                                                        9.409196,
                                                                                                                                                        6.484175, -27.023735,
                                                                                                                                                        6.14914,
                                                                                                                                                        6.856416, -27.180181,
                                                                                                                                                        6.026093,
                                                                                                                                                        6.485761, -27.023735,
                                                                                                                                                        6.14914,
                                                                                                                                                        6.856416, -29.185803,
                                                                                                                                                        9.409196,
                                                                                                                                                        6.484175, -27.023735,
                                                                                                                                                        6.14914,
                                                                                                                                                        6.856416, -26.841813,
                                                                                                                                                        6.292199,
                                                                                                                                                        7.195891, -29.00287,
                                                                                                                                                        9.487563,
                                                                                                                                                        6.854851, -28.790145,
                                                                                                                                                        9.578665,
                                                                                                                                                        7.19435, -29.00287,
                                                                                                                                                        9.487563,
                                                                                                                                                        6.854851, -26.841813,
                                                                                                                                                        6.292199,
                                                                                                                                                        7.195891, -29.00287,
                                                                                                                                                        9.487563,
                                                                                                                                                        6.854851, -28.790145,
                                                                                                                                                        9.578665,
                                                                                                                                                        7.19435, -30.050519,
                                                                                                                                                        13.224469,
                                                                                                                                                        6.853099, -29.82149,
                                                                                                                                                        13.257414,
                                                                                                                                                        7.192626, -30.050519,
                                                                                                                                                        13.224469,
                                                                                                                                                        6.853099, -28.790145,
                                                                                                                                                        9.578665,
                                                                                                                                                        7.19435, -30.050519,
                                                                                                                                                        13.224469,
                                                                                                                                                        6.853099, -29.82149,
                                                                                                                                                        13.257414,
                                                                                                                                                        7.192626, -30.095288,
                                                                                                                                                        17.105195,
                                                                                                                                                        6.851279, -29.865562,
                                                                                                                                                        17.077743,
                                                                                                                                                        7.190835, -30.095288,
                                                                                                                                                        17.105195,
                                                                                                                                                        6.851279, -29.82149,
                                                                                                                                                        13.257414,
                                                                                                                                                        7.192626, -30.095288,
                                                                                                                                                        17.105195,
                                                                                                                                                        6.851279, -30.292841,
                                                                                                                                                        17.128779,
                                                                                                                                                        6.480556, -30.050519,
                                                                                                                                                        13.224469,
                                                                                                                                                        6.853099, -30.455621,
                                                                                                                                                        17.148185,
                                                                                                                                                        6.083549, -30.581481,
                                                                                                                                                        17.163156,
                                                                                                                                                        5.665486, -30.409759,
                                                                                                                                                        13.172725,
                                                                                                                                                        6.085413, -30.535237,
                                                                                                                                                        13.154607,
                                                                                                                                                        5.667366, -30.409759,
                                                                                                                                                        13.172725,
                                                                                                                                                        6.085413, -30.581481,
                                                                                                                                                        17.163156,
                                                                                                                                                        5.665486, -30.409759,
                                                                                                                                                        13.172725,
                                                                                                                                                        6.085413, -30.535237,
                                                                                                                                                        13.154607,
                                                                                                                                                        5.667366, -29.336535,
                                                                                                                                                        9.344596,
                                                                                                                                                        6.087207, -30.581481,
                                                                                                                                                        17.163156,
                                                                                                                                                        5.665486, -30.668765,
                                                                                                                                                        17.173496,
                                                                                                                                                        5.231876, -30.535237,
                                                                                                                                                        13.154607,
                                                                                                                                                        5.667366, -30.622257,
                                                                                                                                                        13.142,
                                                                                                                                                        5.233766, -30.535237,
                                                                                                                                                        13.154607,
                                                                                                                                                        5.667366, -30.668765,
                                                                                                                                                        17.173496,
                                                                                                                                                        5.231876, -30.535237,
                                                                                                                                                        13.154607,
                                                                                                                                                        5.667366, -30.622257,
                                                                                                                                                        13.142,
                                                                                                                                                        5.233766, -29.453081,
                                                                                                                                                        9.294615,
                                                                                                                                                        5.669175, -29.533905,
                                                                                                                                                        9.259911,
                                                                                                                                                        5.235586, -29.453081,
                                                                                                                                                        9.294615,
                                                                                                                                                        5.669175, -30.622257,
                                                                                                                                                        13.142,
                                                                                                                                                        5.233766, -29.453081,
                                                                                                                                                        9.294615,
                                                                                                                                                        5.669175, -29.533905,
                                                                                                                                                        9.259911,
                                                                                                                                                        5.235586, -27.408758,
                                                                                                                                                        5.846232,
                                                                                                                                                        5.670792, -27.477879,
                                                                                                                                                        5.791787,
                                                                                                                                                        5.237212, -27.408758,
                                                                                                                                                        5.846232,
                                                                                                                                                        5.670792, -29.533905,
                                                                                                                                                        9.259911,
                                                                                                                                                        5.235586,
                                                                                                                                                        null,
                                                                                                                                                        null,
                                                                                                                                                        null
                                                                                                                                                    ],
                                                                                                                                                    "normals": [-0.891463, -0.381248,
                                                                                                                                                        0.244833, -0.865857, -0.370252,
                                                                                                                                                        0.336461, -0.959781, -0.137525,
                                                                                                                                                        0.244759, -0.865857, -0.370252,
                                                                                                                                                        0.336461, -0.891463, -0.381248,
                                                                                                                                                        0.244833, -0.740494, -0.581737,
                                                                                                                                                        0.336527, -0.76239, -0.598987,
                                                                                                                                                        0.2449, -0.740494, -0.581737,
                                                                                                                                                        0.336527, -0.891463, -0.381248,
                                                                                                                                                        0.244833, -0.76239, -0.598987,
                                                                                                                                                        0.2449, -0.581358, -0.7759,
                                                                                                                                                        0.244954, -0.740494, -0.581737,
                                                                                                                                                        0.336527, -0.581358, -0.7759,
                                                                                                                                                        0.244954, -0.76239, -0.598987,
                                                                                                                                                        0.2449, -0.58763, -0.784293,
                                                                                                                                                        0.198935, -0.770616, -0.605473,
                                                                                                                                                        0.198881, -0.58763, -0.784293,
                                                                                                                                                        0.198935, -0.76239, -0.598987,
                                                                                                                                                        0.2449, -0.909713,
                                                                                                                                                        0.364671,
                                                                                                                                                        0.198588, -0.973083,
                                                                                                                                                        0.116798,
                                                                                                                                                        0.198663, -0.899996,
                                                                                                                                                        0.360798,
                                                                                                                                                        0.244606, -0.962691,
                                                                                                                                                        0.115574,
                                                                                                                                                        0.244681, -0.899996,
                                                                                                                                                        0.360798,
                                                                                                                                                        0.244606, -0.973083,
                                                                                                                                                        0.116798,
                                                                                                                                                        0.198663, -0.899996,
                                                                                                                                                        0.360798,
                                                                                                                                                        0.244606, -0.962691,
                                                                                                                                                        0.115574,
                                                                                                                                                        0.244681, -0.874135,
                                                                                                                                                        0.350477,
                                                                                                                                                        0.336234, -0.935032,
                                                                                                                                                        0.112299,
                                                                                                                                                        0.336309, -0.874135,
                                                                                                                                                        0.350477,
                                                                                                                                                        0.336234, -0.962691,
                                                                                                                                                        0.115574,
                                                                                                                                                        0.244681, -0.874135,
                                                                                                                                                        0.350477,
                                                                                                                                                        0.336234, -0.935032,
                                                                                                                                                        0.112299,
                                                                                                                                                        0.336309, -0.838956,
                                                                                                                                                        0.336421,
                                                                                                                                                        0.427754, -0.897405,
                                                                                                                                                        0.107829,
                                                                                                                                                        0.427829, -0.838956,
                                                                                                                                                        0.336421,
                                                                                                                                                        0.427754, -0.935032,
                                                                                                                                                        0.112299,
                                                                                                                                                        0.336309, -0.838956,
                                                                                                                                                        0.336421,
                                                                                                                                                        0.427754, -0.897405,
                                                                                                                                                        0.107829,
                                                                                                                                                        0.427829, -0.793546,
                                                                                                                                                        0.318265,
                                                                                                                                                        0.518644, -0.848833,
                                                                                                                                                        0.102046,
                                                                                                                                                        0.518718, -0.793546,
                                                                                                                                                        0.318265,
                                                                                                                                                        0.518644, -0.897405,
                                                                                                                                                        0.107829,
                                                                                                                                                        0.427829, -0.793546,
                                                                                                                                                        0.318265,
                                                                                                                                                        0.518644, -0.848833,
                                                                                                                                                        0.102046,
                                                                                                                                                        0.518718, -0.736878,
                                                                                                                                                        0.295597,
                                                                                                                                                        0.607975, -0.788218,
                                                                                                                                                        0.094818,
                                                                                                                                                        0.608048, -0.736878,
                                                                                                                                                        0.295597,
                                                                                                                                                        0.607975, -0.848833,
                                                                                                                                                        0.102046,
                                                                                                                                                        0.518718, -0.736878,
                                                                                                                                                        0.295597,
                                                                                                                                                        0.607975, -0.788218,
                                                                                                                                                        0.094818,
                                                                                                                                                        0.608048, -0.667927,
                                                                                                                                                        0.268004,
                                                                                                                                                        0.694297, -0.714464,
                                                                                                                                                        0.086013,
                                                                                                                                                        0.694366, -0.667927,
                                                                                                                                                        0.268004,
                                                                                                                                                        0.694297, -0.788218,
                                                                                                                                                        0.094818,
                                                                                                                                                        0.608048, -0.714464,
                                                                                                                                                        0.086013,
                                                                                                                                                        0.694366, -0.626689,
                                                                                                                                                        0.075524,
                                                                                                                                                        0.775601, -0.667927,
                                                                                                                                                        0.268004,
                                                                                                                                                        0.694297, -0.714464,
                                                                                                                                                        0.086013,
                                                                                                                                                        0.694366, -0.712312, -0.101826,
                                                                                                                                                        0.694437, -0.626689,
                                                                                                                                                        0.075524,
                                                                                                                                                        0.775601, -0.714464,
                                                                                                                                                        0.086013,
                                                                                                                                                        0.694366, -0.788218,
                                                                                                                                                        0.094818,
                                                                                                                                                        0.608048, -0.712312, -0.101826,
                                                                                                                                                        0.694437, -0.785844, -0.112411,
                                                                                                                                                        0.608122, -0.712312, -0.101826,
                                                                                                                                                        0.694437, -0.788218,
                                                                                                                                                        0.094818,
                                                                                                                                                        0.608048, -0.712312, -0.101826,
                                                                                                                                                        0.694437, -0.785844, -0.112411,
                                                                                                                                                        0.608122, -0.661617, -0.282711,
                                                                                                                                                        0.694505, -0.729915, -0.311969,
                                                                                                                                                        0.608194, -0.661617, -0.282711,
                                                                                                                                                        0.694505, -0.785844, -0.112411,
                                                                                                                                                        0.608122, -0.661617, -0.282711,
                                                                                                                                                        0.694505, -0.729915, -0.311969,
                                                                                                                                                        0.608194, -0.565829, -0.444314,
                                                                                                                                                        0.694567, -0.624238, -0.490254,
                                                                                                                                                        0.608258, -0.565829, -0.444314,
                                                                                                                                                        0.694567, -0.729915, -0.311969,
                                                                                                                                                        0.608194, -0.624238, -0.490254,
                                                                                                                                                        0.608258, -0.476014, -0.635114,
                                                                                                                                                        0.60831, -0.565829, -0.444314,
                                                                                                                                                        0.694567, -0.476014, -0.635114,
                                                                                                                                                        0.60831, -0.624238, -0.490254,
                                                                                                                                                        0.608258, -0.512617, -0.684015,
                                                                                                                                                        0.518987, -0.67224, -0.528017,
                                                                                                                                                        0.518934, -0.512617, -0.684015,
                                                                                                                                                        0.518987, -0.624238, -0.490254,
                                                                                                                                                        0.608258, -0.512617, -0.684015,
                                                                                                                                                        0.518987, -0.67224, -0.528017,
                                                                                                                                                        0.518934, -0.541945, -0.723205,
                                                                                                                                                        0.428101, -0.710701, -0.558283,
                                                                                                                                                        0.428047, -0.541945, -0.723205,
                                                                                                                                                        0.428101, -0.67224, -0.528017,
                                                                                                                                                        0.518934, -0.541945, -0.723205,
                                                                                                                                                        0.428101, -0.710701, -0.558283,
                                                                                                                                                        0.428047, -0.564662, -0.753571,
                                                                                                                                                        0.336582, -0.740494, -0.581737,
                                                                                                                                                        0.336527, -0.564662, -0.753571,
                                                                                                                                                        0.336582, -0.710701, -0.558283,
                                                                                                                                                        0.428047, -0.564662, -0.753571,
                                                                                                                                                        0.336582, -0.740494, -0.581737,
                                                                                                                                                        0.336527, -0.581358, -0.7759,
                                                                                                                                                        0.244954, -0.581358, -0.7759,
                                                                                                                                                        0.244954, -0.360703, -0.899929,
                                                                                                                                                        0.244992, -0.564662, -0.753571,
                                                                                                                                                        0.336582, -0.360703, -0.899929,
                                                                                                                                                        0.244992, -0.581358, -0.7759,
                                                                                                                                                        0.244954, -0.364594, -0.90966,
                                                                                                                                                        0.198973, -0.58763, -0.784293,
                                                                                                                                                        0.198935, -0.364594, -0.90966,
                                                                                                                                                        0.198973, -0.581358, -0.7759,
                                                                                                                                                        0.244954, -0.385461,
                                                                                                                                                        0.901136,
                                                                                                                                                        0.198426, -0.605537,
                                                                                                                                                        0.770673,
                                                                                                                                                        0.198465, -0.381342,
                                                                                                                                                        0.89153,
                                                                                                                                                        0.244444, -0.599067,
                                                                                                                                                        0.762461,
                                                                                                                                                        0.244483, -0.381342,
                                                                                                                                                        0.89153,
                                                                                                                                                        0.244444, -0.605537,
                                                                                                                                                        0.770673,
                                                                                                                                                        0.198465, -0.381342,
                                                                                                                                                        0.89153,
                                                                                                                                                        0.244444, -0.599067,
                                                                                                                                                        0.762461,
                                                                                                                                                        0.244483, -0.370382,
                                                                                                                                                        0.865952,
                                                                                                                                                        0.336071, -0.58185,
                                                                                                                                                        0.740594,
                                                                                                                                                        0.336111, -0.370382,
                                                                                                                                                        0.865952,
                                                                                                                                                        0.336071, -0.599067,
                                                                                                                                                        0.762461,
                                                                                                                                                        0.244483, -0.370382,
                                                                                                                                                        0.865952,
                                                                                                                                                        0.336071, -0.58185,
                                                                                                                                                        0.740594,
                                                                                                                                                        0.336111, -0.355474,
                                                                                                                                                        0.831146,
                                                                                                                                                        0.427592, -0.558431,
                                                                                                                                                        0.710835,
                                                                                                                                                        0.427631, -0.355474,
                                                                                                                                                        0.831146,
                                                                                                                                                        0.427592, -0.58185,
                                                                                                                                                        0.740594,
                                                                                                                                                        0.336111, -0.355474,
                                                                                                                                                        0.831146,
                                                                                                                                                        0.427592, -0.558431,
                                                                                                                                                        0.710835,
                                                                                                                                                        0.427631, -0.336231,
                                                                                                                                                        0.786208,
                                                                                                                                                        0.518484, -0.528203,
                                                                                                                                                        0.67241,
                                                                                                                                                        0.518523, -0.336231,
                                                                                                                                                        0.786208,
                                                                                                                                                        0.518484, -0.558431,
                                                                                                                                                        0.710835,
                                                                                                                                                        0.427631, -0.336231,
                                                                                                                                                        0.786208,
                                                                                                                                                        0.518484, -0.528203,
                                                                                                                                                        0.67241,
                                                                                                                                                        0.518523, -0.312219,
                                                                                                                                                        0.73012,
                                                                                                                                                        0.607819, -0.490482,
                                                                                                                                                        0.62445,
                                                                                                                                                        0.607857, -0.312219,
                                                                                                                                                        0.73012,
                                                                                                                                                        0.607819, -0.528203,
                                                                                                                                                        0.67241,
                                                                                                                                                        0.518523, -0.312219,
                                                                                                                                                        0.73012,
                                                                                                                                                        0.607819, -0.490482,
                                                                                                                                                        0.62445,
                                                                                                                                                        0.607857, -0.283004,
                                                                                                                                                        0.661867,
                                                                                                                                                        0.694147, -0.444586,
                                                                                                                                                        0.566085,
                                                                                                                                                        0.694184, -0.283004,
                                                                                                                                                        0.661867,
                                                                                                                                                        0.694147, -0.490482,
                                                                                                                                                        0.62445,
                                                                                                                                                        0.607857, -0.444586,
                                                                                                                                                        0.566085,
                                                                                                                                                        0.694184, -0.389967,
                                                                                                                                                        0.496618,
                                                                                                                                                        0.775433, -0.283004,
                                                                                                                                                        0.661867,
                                                                                                                                                        0.694147, -0.389967,
                                                                                                                                                        0.496618,
                                                                                                                                                        0.775433, -0.444586,
                                                                                                                                                        0.566085,
                                                                                                                                                        0.694184, -0.505127,
                                                                                                                                                        0.378783,
                                                                                                                                                        0.77548, -0.575876,
                                                                                                                                                        0.431747,
                                                                                                                                                        0.694235, -0.505127,
                                                                                                                                                        0.378783,
                                                                                                                                                        0.77548, -0.444586,
                                                                                                                                                        0.566085,
                                                                                                                                                        0.694184, -0.505127,
                                                                                                                                                        0.378783,
                                                                                                                                                        0.77548, -0.575876,
                                                                                                                                                        0.431747,
                                                                                                                                                        0.694235, -0.585869,
                                                                                                                                                        0.235157,
                                                                                                                                                        0.775538, -0.667927,
                                                                                                                                                        0.268004,
                                                                                                                                                        0.694297, -0.585869,
                                                                                                                                                        0.235157,
                                                                                                                                                        0.775538, -0.575876,
                                                                                                                                                        0.431747,
                                                                                                                                                        0.694235, -0.585869,
                                                                                                                                                        0.235157,
                                                                                                                                                        0.775538, -0.667927,
                                                                                                                                                        0.268004,
                                                                                                                                                        0.694297, -0.626689,
                                                                                                                                                        0.075524,
                                                                                                                                                        0.775601, -0.626689,
                                                                                                                                                        0.075524,
                                                                                                                                                        0.775601, -0.524518,
                                                                                                                                                        0.063305,
                                                                                                                                                        0.849043, -0.585869,
                                                                                                                                                        0.235157,
                                                                                                                                                        0.775538, -0.626689,
                                                                                                                                                        0.075524,
                                                                                                                                                        0.775601, -0.624801, -0.089238,
                                                                                                                                                        0.775667, -0.524518,
                                                                                                                                                        0.063305,
                                                                                                                                                        0.849043, -0.624801, -0.089238,
                                                                                                                                                        0.775667, -0.626689,
                                                                                                                                                        0.075524,
                                                                                                                                                        0.775601, -0.712312, -0.101826,
                                                                                                                                                        0.694437, -0.712312, -0.101826,
                                                                                                                                                        0.694437, -0.661617, -0.282711,
                                                                                                                                                        0.694505, -0.624801, -0.089238,
                                                                                                                                                        0.775667, -0.580334, -0.247901,
                                                                                                                                                        0.775731, -0.624801, -0.089238,
                                                                                                                                                        0.775667, -0.661617, -0.282711,
                                                                                                                                                        0.694505, -0.624801, -0.089238,
                                                                                                                                                        0.775667, -0.580334, -0.247901,
                                                                                                                                                        0.775731, -0.522938, -0.074595,
                                                                                                                                                        0.849101, -0.485719, -0.20739,
                                                                                                                                                        0.849156, -0.522938, -0.074595,
                                                                                                                                                        0.849101, -0.580334, -0.247901,
                                                                                                                                                        0.775731, -0.522938, -0.074595,
                                                                                                                                                        0.849101, -0.485719, -0.20739,
                                                                                                                                                        0.849156, -0.407204, -0.057969,
                                                                                                                                                        0.911496, -0.378221, -0.161374,
                                                                                                                                                        0.911541, -0.407204, -0.057969,
                                                                                                                                                        0.911496, -0.485719, -0.20739,
                                                                                                                                                        0.849156, -0.407204, -0.057969,
                                                                                                                                                        0.911496, -0.378221, -0.161374,
                                                                                                                                                        0.911541, -0.279267, -0.039599,
                                                                                                                                                        0.959397, -0.259389, -0.110515,
                                                                                                                                                        0.959429, -0.279267, -0.039599,
                                                                                                                                                        0.959397, -0.378221, -0.161374,
                                                                                                                                                        0.911541, -0.279267, -0.039599,
                                                                                                                                                        0.959397, -0.259389, -0.110515,
                                                                                                                                                        0.959429, -0.14214, -0.01992,
                                                                                                                                                        0.989646, -0.132022, -0.056014,
                                                                                                                                                        0.989663, -0.14214, -0.01992,
                                                                                                                                                        0.989646, -0.259389, -0.110515,
                                                                                                                                                        0.959429, -0.14214, -0.01992,
                                                                                                                                                        0.989646, -0.132022, -0.056014,
                                                                                                                                                        0.989663, -0.047734, -0.006377,
                                                                                                                                                        0.99884, -0.044336, -0.018498,
                                                                                                                                                        0.998845, -0.047734, -0.006377,
                                                                                                                                                        0.99884, -0.132022, -0.056014,
                                                                                                                                                        0.989663, -0.047734, -0.006377,
                                                                                                                                                        0.99884, -0.044336, -0.018498,
                                                                                                                                                        0.998845, -0.044761,
                                                                                                                                                        0.018407,
                                                                                                                                                        0.998828, -0.044761,
                                                                                                                                                        0.018407,
                                                                                                                                                        0.998828, -0.044336, -0.018498,
                                                                                                                                                        0.998845, -0.038593,
                                                                                                                                                        0.029381,
                                                                                                                                                        0.998823, -0.044336, -0.018498,
                                                                                                                                                        0.998845, -0.037916, -0.029327,
                                                                                                                                                        0.99885, -0.038593,
                                                                                                                                                        0.029381,
                                                                                                                                                        0.998823, -0.037916, -0.029327,
                                                                                                                                                        0.99885, -0.044336, -0.018498,
                                                                                                                                                        0.998845, -0.112907, -0.08826,
                                                                                                                                                        0.989678, -0.132022, -0.056014,
                                                                                                                                                        0.989663, -0.112907, -0.08826,
                                                                                                                                                        0.989678, -0.044336, -0.018498,
                                                                                                                                                        0.998845, -0.112907, -0.08826,
                                                                                                                                                        0.989678, -0.132022, -0.056014,
                                                                                                                                                        0.989663, -0.221833, -0.173871,
                                                                                                                                                        0.959458, -0.259389, -0.110515,
                                                                                                                                                        0.959429, -0.221833, -0.173871,
                                                                                                                                                        0.959458, -0.132022, -0.056014,
                                                                                                                                                        0.989663, -0.221833, -0.173871,
                                                                                                                                                        0.959458, -0.259389, -0.110515,
                                                                                                                                                        0.959429, -0.323461, -0.253755,
                                                                                                                                                        0.911582, -0.378221, -0.161374,
                                                                                                                                                        0.911541, -0.323461, -0.253755,
                                                                                                                                                        0.911582, -0.259389, -0.110515,
                                                                                                                                                        0.959429, -0.323461, -0.253755,
                                                                                                                                                        0.911582, -0.378221, -0.161374,
                                                                                                                                                        0.911541, -0.415396, -0.326029,
                                                                                                                                                        0.849206, -0.485719, -0.20739,
                                                                                                                                                        0.849156, -0.415396, -0.326029,
                                                                                                                                                        0.849206, -0.378221, -0.161374,
                                                                                                                                                        0.911541, -0.415396, -0.326029,
                                                                                                                                                        0.849206, -0.485719, -0.20739,
                                                                                                                                                        0.849156, -0.496313, -0.38965,
                                                                                                                                                        0.775787, -0.580334, -0.247901,
                                                                                                                                                        0.775731, -0.496313, -0.38965,
                                                                                                                                                        0.775787, -0.485719, -0.20739,
                                                                                                                                                        0.849156, -0.496313, -0.38965,
                                                                                                                                                        0.775787, -0.580334, -0.247901,
                                                                                                                                                        0.775731, -0.565829, -0.444314,
                                                                                                                                                        0.694567, -0.661617, -0.282711,
                                                                                                                                                        0.694505, -0.565829, -0.444314,
                                                                                                                                                        0.694567, -0.580334, -0.247901,
                                                                                                                                                        0.775731, -0.565829, -0.444314,
                                                                                                                                                        0.694567, -0.431474, -0.57562,
                                                                                                                                                        0.694616, -0.496313, -0.38965,
                                                                                                                                                        0.775787, -0.431474, -0.57562,
                                                                                                                                                        0.694616, -0.565829, -0.444314,
                                                                                                                                                        0.694567, -0.476014, -0.635114,
                                                                                                                                                        0.60831, -0.476014, -0.635114,
                                                                                                                                                        0.60831, -0.295344, -0.736672,
                                                                                                                                                        0.608347, -0.431474, -0.57562,
                                                                                                                                                        0.694616, -0.295344, -0.736672,
                                                                                                                                                        0.608347, -0.476014, -0.635114,
                                                                                                                                                        0.60831, -0.318055, -0.793382,
                                                                                                                                                        0.519025, -0.512617, -0.684015,
                                                                                                                                                        0.518987, -0.318055, -0.793382,
                                                                                                                                                        0.519025, -0.476014, -0.635114,
                                                                                                                                                        0.60831, -0.318055, -0.793382,
                                                                                                                                                        0.519025, -0.512617, -0.684015,
                                                                                                                                                        0.518987, -0.336251, -0.838828,
                                                                                                                                                        0.428139, -0.541945, -0.723205,
                                                                                                                                                        0.428101, -0.336251, -0.838828,
                                                                                                                                                        0.428139, -0.512617, -0.684015,
                                                                                                                                                        0.518987, -0.336251, -0.838828,
                                                                                                                                                        0.428139, -0.541945, -0.723205,
                                                                                                                                                        0.428101, -0.350345, -0.87404,
                                                                                                                                                        0.33662, -0.564662, -0.753571,
                                                                                                                                                        0.336582, -0.350345, -0.87404,
                                                                                                                                                        0.33662, -0.541945, -0.723205,
                                                                                                                                                        0.428101, -0.350345, -0.87404,
                                                                                                                                                        0.33662, -0.564662, -0.753571,
                                                                                                                                                        0.336582, -0.360703, -0.899929,
                                                                                                                                                        0.244992, -0.360703, -0.899929,
                                                                                                                                                        0.244992, -0.115465, -0.96262,
                                                                                                                                                        0.245011, -0.350345, -0.87404,
                                                                                                                                                        0.33662, -0.115465, -0.96262,
                                                                                                                                                        0.245011, -0.360703, -0.899929,
                                                                                                                                                        0.244992, -0.11671, -0.973027,
                                                                                                                                                        0.198992, -0.364594, -0.90966,
                                                                                                                                                        0.198973, -0.11671, -0.973027,
                                                                                                                                                        0.198992, -0.360703, -0.899929,
                                                                                                                                                        0.244992,
                                                                                                                                                        0.605569, -0.770528,
                                                                                                                                                        0.198931,
                                                                                                                                                        0.784381, -0.587533,
                                                                                                                                                        0.198876,
                                                                                                                                                        0.599105, -0.762281,
                                                                                                                                                        0.24495,
                                                                                                                                                        0.776008, -0.581239,
                                                                                                                                                        0.244894,
                                                                                                                                                        0.599105, -0.762281,
                                                                                                                                                        0.24495,
                                                                                                                                                        0.784381, -0.587533,
                                                                                                                                                        0.198876,
                                                                                                                                                        0.599105, -0.762281,
                                                                                                                                                        0.24495,
                                                                                                                                                        0.776008, -0.581239,
                                                                                                                                                        0.244894,
                                                                                                                                                        0.5819, -0.740344,
                                                                                                                                                        0.336577,
                                                                                                                                                        0.75372, -0.564499,
                                                                                                                                                        0.336522,
                                                                                                                                                        0.5819, -0.740344,
                                                                                                                                                        0.336577,
                                                                                                                                                        0.776008, -0.581239,
                                                                                                                                                        0.244894,
                                                                                                                                                        0.5819, -0.740344,
                                                                                                                                                        0.336577,
                                                                                                                                                        0.75372, -0.564499,
                                                                                                                                                        0.336522,
                                                                                                                                                        0.558489, -0.710509,
                                                                                                                                                        0.428097,
                                                                                                                                                        0.723395, -0.541738,
                                                                                                                                                        0.428041,
                                                                                                                                                        0.558489, -0.710509,
                                                                                                                                                        0.428097,
                                                                                                                                                        0.75372, -0.564499,
                                                                                                                                                        0.336522,
                                                                                                                                                        0.558489, -0.710509,
                                                                                                                                                        0.428097,
                                                                                                                                                        0.723395, -0.541738,
                                                                                                                                                        0.428041,
                                                                                                                                                        0.528266, -0.672006,
                                                                                                                                                        0.518983,
                                                                                                                                                        0.684246, -0.512367,
                                                                                                                                                        0.518928,
                                                                                                                                                        0.528266, -0.672006,
                                                                                                                                                        0.518983,
                                                                                                                                                        0.723395, -0.541738,
                                                                                                                                                        0.428041,
                                                                                                                                                        0.528266, -0.672006,
                                                                                                                                                        0.518983,
                                                                                                                                                        0.684246, -0.512367,
                                                                                                                                                        0.518928,
                                                                                                                                                        0.490545, -0.623963,
                                                                                                                                                        0.608306,
                                                                                                                                                        0.635387, -0.475722,
                                                                                                                                                        0.608253,
                                                                                                                                                        0.490545, -0.623963,
                                                                                                                                                        0.608306,
                                                                                                                                                        0.684246, -0.512367,
                                                                                                                                                        0.518928,
                                                                                                                                                        0.635387, -0.475722,
                                                                                                                                                        0.608253,
                                                                                                                                                        0.575935, -0.431142,
                                                                                                                                                        0.694562,
                                                                                                                                                        0.490545, -0.623963,
                                                                                                                                                        0.608306,
                                                                                                                                                        0.635387, -0.475722,
                                                                                                                                                        0.608253,
                                                                                                                                                        0.736923, -0.295047,
                                                                                                                                                        0.608188,
                                                                                                                                                        0.575935, -0.431142,
                                                                                                                                                        0.694562,
                                                                                                                                                        0.736923, -0.295047,
                                                                                                                                                        0.608188,
                                                                                                                                                        0.635387, -0.475722,
                                                                                                                                                        0.608253,
                                                                                                                                                        0.793591, -0.317799,
                                                                                                                                                        0.518862,
                                                                                                                                                        0.684246, -0.512367,
                                                                                                                                                        0.518928,
                                                                                                                                                        0.793591, -0.317799,
                                                                                                                                                        0.518862,
                                                                                                                                                        0.635387, -0.475722,
                                                                                                                                                        0.608253,
                                                                                                                                                        0.793591, -0.317799,
                                                                                                                                                        0.518862,
                                                                                                                                                        0.684246, -0.512367,
                                                                                                                                                        0.518928,
                                                                                                                                                        0.838997, -0.336039,
                                                                                                                                                        0.427974,
                                                                                                                                                        0.723395, -0.541738,
                                                                                                                                                        0.428041,
                                                                                                                                                        0.838997, -0.336039,
                                                                                                                                                        0.427974,
                                                                                                                                                        0.684246, -0.512367,
                                                                                                                                                        0.518928,
                                                                                                                                                        0.838997, -0.336039,
                                                                                                                                                        0.427974,
                                                                                                                                                        0.723395, -0.541738,
                                                                                                                                                        0.428041,
                                                                                                                                                        0.87417, -0.350178,
                                                                                                                                                        0.336454,
                                                                                                                                                        0.75372, -0.564499,
                                                                                                                                                        0.336522,
                                                                                                                                                        0.87417, -0.350178,
                                                                                                                                                        0.336454,
                                                                                                                                                        0.723395, -0.541738,
                                                                                                                                                        0.428041,
                                                                                                                                                        0.87417, -0.350178,
                                                                                                                                                        0.336454,
                                                                                                                                                        0.75372, -0.564499,
                                                                                                                                                        0.336522,
                                                                                                                                                        0.900023, -0.360581,
                                                                                                                                                        0.244827,
                                                                                                                                                        0.776008, -0.581239,
                                                                                                                                                        0.244894,
                                                                                                                                                        0.900023, -0.360581,
                                                                                                                                                        0.244827,
                                                                                                                                                        0.75372, -0.564499,
                                                                                                                                                        0.336522,
                                                                                                                                                        0.900023, -0.360581,
                                                                                                                                                        0.244827,
                                                                                                                                                        0.776008, -0.581239,
                                                                                                                                                        0.244894,
                                                                                                                                                        0.909735, -0.364495,
                                                                                                                                                        0.198808,
                                                                                                                                                        0.784381, -0.587533,
                                                                                                                                                        0.198876,
                                                                                                                                                        0.909735, -0.364495,
                                                                                                                                                        0.198808,
                                                                                                                                                        0.776008, -0.581239,
                                                                                                                                                        0.244894,
                                                                                                                                                        0.909735, -0.364495,
                                                                                                                                                        0.198808,
                                                                                                                                                        0.973091, -0.116614,
                                                                                                                                                        0.198733,
                                                                                                                                                        0.900023, -0.360581,
                                                                                                                                                        0.244827,
                                                                                                                                                        0.9627, -0.115347,
                                                                                                                                                        0.244752,
                                                                                                                                                        0.900023, -0.360581,
                                                                                                                                                        0.244827,
                                                                                                                                                        0.973091, -0.116614,
                                                                                                                                                        0.198733,
                                                                                                                                                        0.900023, -0.360581,
                                                                                                                                                        0.244827,
                                                                                                                                                        0.9627, -0.115347,
                                                                                                                                                        0.244752,
                                                                                                                                                        0.87417, -0.350178,
                                                                                                                                                        0.336454,
                                                                                                                                                        0.935044, -0.111987,
                                                                                                                                                        0.336379,
                                                                                                                                                        0.87417, -0.350178,
                                                                                                                                                        0.336454,
                                                                                                                                                        0.9627, -0.115347,
                                                                                                                                                        0.244752,
                                                                                                                                                        0.87417, -0.350178,
                                                                                                                                                        0.336454,
                                                                                                                                                        0.935044, -0.111987,
                                                                                                                                                        0.336379,
                                                                                                                                                        0.838997, -0.336039,
                                                                                                                                                        0.427974,
                                                                                                                                                        0.897419, -0.107432,
                                                                                                                                                        0.427899,
                                                                                                                                                        0.838997, -0.336039,
                                                                                                                                                        0.427974,
                                                                                                                                                        0.935044, -0.111987,
                                                                                                                                                        0.336379,
                                                                                                                                                        0.838997, -0.336039,
                                                                                                                                                        0.427974,
                                                                                                                                                        0.897419, -0.107432,
                                                                                                                                                        0.427899,
                                                                                                                                                        0.793591, -0.317799,
                                                                                                                                                        0.518862,
                                                                                                                                                        0.848849, -0.101564,
                                                                                                                                                        0.518788,
                                                                                                                                                        0.793591, -0.317799,
                                                                                                                                                        0.518862,
                                                                                                                                                        0.897419, -0.107432,
                                                                                                                                                        0.427899,
                                                                                                                                                        0.793591, -0.317799,
                                                                                                                                                        0.518862,
                                                                                                                                                        0.848849, -0.101564,
                                                                                                                                                        0.518788,
                                                                                                                                                        0.736923, -0.295047,
                                                                                                                                                        0.608188,
                                                                                                                                                        0.788233, -0.094252,
                                                                                                                                                        0.608116,
                                                                                                                                                        0.736923, -0.295047,
                                                                                                                                                        0.608188,
                                                                                                                                                        0.848849, -0.101564,
                                                                                                                                                        0.518788,
                                                                                                                                                        0.736923, -0.295047,
                                                                                                                                                        0.608188,
                                                                                                                                                        0.788233, -0.094252,
                                                                                                                                                        0.608116,
                                                                                                                                                        0.667969, -0.267372,
                                                                                                                                                        0.694499,
                                                                                                                                                        0.714478, -0.085366,
                                                                                                                                                        0.694431,
                                                                                                                                                        0.667969, -0.267372,
                                                                                                                                                        0.694499,
                                                                                                                                                        0.788233, -0.094252,
                                                                                                                                                        0.608116,
                                                                                                                                                        0.714478, -0.085366,
                                                                                                                                                        0.694431,
                                                                                                                                                        0.626701, -0.0748,
                                                                                                                                                        0.775662,
                                                                                                                                                        0.667969, -0.267372,
                                                                                                                                                        0.694499,
                                                                                                                                                        0.714478, -0.085366,
                                                                                                                                                        0.694431,
                                                                                                                                                        0.712295,
                                                                                                                                                        0.102472,
                                                                                                                                                        0.694359,
                                                                                                                                                        0.626701, -0.0748,
                                                                                                                                                        0.775662,
                                                                                                                                                        0.712295,
                                                                                                                                                        0.102472,
                                                                                                                                                        0.694359,
                                                                                                                                                        0.714478, -0.085366,
                                                                                                                                                        0.694431,
                                                                                                                                                        0.785826,
                                                                                                                                                        0.112977,
                                                                                                                                                        0.608041,
                                                                                                                                                        0.788233, -0.094252,
                                                                                                                                                        0.608116,
                                                                                                                                                        0.785826,
                                                                                                                                                        0.112977,
                                                                                                                                                        0.608041,
                                                                                                                                                        0.714478, -0.085366,
                                                                                                                                                        0.694431,
                                                                                                                                                        0.785826,
                                                                                                                                                        0.112977,
                                                                                                                                                        0.608041,
                                                                                                                                                        0.788233, -0.094252,
                                                                                                                                                        0.608116,
                                                                                                                                                        0.846257,
                                                                                                                                                        0.121601,
                                                                                                                                                        0.518711,
                                                                                                                                                        0.848849, -0.101564,
                                                                                                                                                        0.518788,
                                                                                                                                                        0.846257,
                                                                                                                                                        0.121601,
                                                                                                                                                        0.518711,
                                                                                                                                                        0.788233, -0.094252,
                                                                                                                                                        0.608116,
                                                                                                                                                        0.846257,
                                                                                                                                                        0.121601,
                                                                                                                                                        0.518711,
                                                                                                                                                        0.848849, -0.101564,
                                                                                                                                                        0.518788,
                                                                                                                                                        0.894682,
                                                                                                                                                        0.128503,
                                                                                                                                                        0.427822,
                                                                                                                                                        0.897419, -0.107432,
                                                                                                                                                        0.427899,
                                                                                                                                                        0.894682,
                                                                                                                                                        0.128503,
                                                                                                                                                        0.427822,
                                                                                                                                                        0.848849, -0.101564,
                                                                                                                                                        0.518788,
                                                                                                                                                        0.894682,
                                                                                                                                                        0.128503,
                                                                                                                                                        0.427822,
                                                                                                                                                        0.897419, -0.107432,
                                                                                                                                                        0.427899,
                                                                                                                                                        0.932195,
                                                                                                                                                        0.13384,
                                                                                                                                                        0.336302,
                                                                                                                                                        0.935044, -0.111987,
                                                                                                                                                        0.336379,
                                                                                                                                                        0.932195,
                                                                                                                                                        0.13384,
                                                                                                                                                        0.336302,
                                                                                                                                                        0.897419, -0.107432,
                                                                                                                                                        0.427899,
                                                                                                                                                        0.932195,
                                                                                                                                                        0.13384,
                                                                                                                                                        0.336302,
                                                                                                                                                        0.935044, -0.111987,
                                                                                                                                                        0.336379,
                                                                                                                                                        0.95977,
                                                                                                                                                        0.137751,
                                                                                                                                                        0.244674,
                                                                                                                                                        0.9627, -0.115347,
                                                                                                                                                        0.244752,
                                                                                                                                                        0.95977,
                                                                                                                                                        0.137751,
                                                                                                                                                        0.244674,
                                                                                                                                                        0.935044, -0.111987,
                                                                                                                                                        0.336379,
                                                                                                                                                        0.95977,
                                                                                                                                                        0.137751,
                                                                                                                                                        0.244674,
                                                                                                                                                        0.9627, -0.115347,
                                                                                                                                                        0.244752,
                                                                                                                                                        0.970131,
                                                                                                                                                        0.139216,
                                                                                                                                                        0.198656,
                                                                                                                                                        0.973091, -0.116614,
                                                                                                                                                        0.198733,
                                                                                                                                                        0.970131,
                                                                                                                                                        0.139216,
                                                                                                                                                        0.198656,
                                                                                                                                                        0.9627, -0.115347,
                                                                                                                                                        0.244752, -0.139119,
                                                                                                                                                        0.970197,
                                                                                                                                                        0.198405, -0.385461,
                                                                                                                                                        0.901136,
                                                                                                                                                        0.198426, -0.137633,
                                                                                                                                                        0.959851,
                                                                                                                                                        0.244423, -0.381342,
                                                                                                                                                        0.89153,
                                                                                                                                                        0.244444, -0.137633,
                                                                                                                                                        0.959851,
                                                                                                                                                        0.244423, -0.385461,
                                                                                                                                                        0.901136,
                                                                                                                                                        0.198426, -0.137633,
                                                                                                                                                        0.959851,
                                                                                                                                                        0.244423, -0.381342,
                                                                                                                                                        0.89153,
                                                                                                                                                        0.244444, -0.133677,
                                                                                                                                                        0.932309,
                                                                                                                                                        0.33605, -0.370382,
                                                                                                                                                        0.865952,
                                                                                                                                                        0.336071, -0.133677,
                                                                                                                                                        0.932309,
                                                                                                                                                        0.33605, -0.381342,
                                                                                                                                                        0.89153,
                                                                                                                                                        0.244444, -0.133677,
                                                                                                                                                        0.932309,
                                                                                                                                                        0.33605, -0.370382,
                                                                                                                                                        0.865952,
                                                                                                                                                        0.336071, -0.128296,
                                                                                                                                                        0.894831,
                                                                                                                                                        0.427571, -0.355474,
                                                                                                                                                        0.831146,
                                                                                                                                                        0.427592, -0.128296,
                                                                                                                                                        0.894831,
                                                                                                                                                        0.427571, -0.370382,
                                                                                                                                                        0.865952,
                                                                                                                                                        0.336071, -0.128296,
                                                                                                                                                        0.894831,
                                                                                                                                                        0.427571, -0.355474,
                                                                                                                                                        0.831146,
                                                                                                                                                        0.427592, -0.121351,
                                                                                                                                                        0.846445,
                                                                                                                                                        0.518463, -0.336231,
                                                                                                                                                        0.786208,
                                                                                                                                                        0.518484, -0.121351,
                                                                                                                                                        0.846445,
                                                                                                                                                        0.518463, -0.355474,
                                                                                                                                                        0.831146,
                                                                                                                                                        0.427592, -0.121351,
                                                                                                                                                        0.846445,
                                                                                                                                                        0.518463, -0.336231,
                                                                                                                                                        0.786208,
                                                                                                                                                        0.518484, -0.112685,
                                                                                                                                                        0.786055,
                                                                                                                                                        0.607799, -0.312219,
                                                                                                                                                        0.73012,
                                                                                                                                                        0.607819, -0.112685,
                                                                                                                                                        0.786055,
                                                                                                                                                        0.607799, -0.336231,
                                                                                                                                                        0.786208,
                                                                                                                                                        0.518484, -0.112685,
                                                                                                                                                        0.786055,
                                                                                                                                                        0.607799, -0.312219,
                                                                                                                                                        0.73012,
                                                                                                                                                        0.607819, -0.10214,
                                                                                                                                                        0.712568,
                                                                                                                                                        0.694128, -0.283004,
                                                                                                                                                        0.661867,
                                                                                                                                                        0.694147, -0.10214,
                                                                                                                                                        0.712568,
                                                                                                                                                        0.694128, -0.312219,
                                                                                                                                                        0.73012,
                                                                                                                                                        0.607819, -0.283004,
                                                                                                                                                        0.661867,
                                                                                                                                                        0.694147, -0.248236,
                                                                                                                                                        0.580633,
                                                                                                                                                        0.7754, -0.10214,
                                                                                                                                                        0.712568,
                                                                                                                                                        0.694128, -0.248236,
                                                                                                                                                        0.580633,
                                                                                                                                                        0.7754, -0.283004,
                                                                                                                                                        0.661867,
                                                                                                                                                        0.694147, -0.389967,
                                                                                                                                                        0.496618,
                                                                                                                                                        0.775433, -0.389967,
                                                                                                                                                        0.496618,
                                                                                                                                                        0.775433, -0.326391,
                                                                                                                                                        0.415749,
                                                                                                                                                        0.848895, -0.248236,
                                                                                                                                                        0.580633,
                                                                                                                                                        0.7754, -0.326391,
                                                                                                                                                        0.415749,
                                                                                                                                                        0.848895, -0.389967,
                                                                                                                                                        0.496618,
                                                                                                                                                        0.775433, -0.422776,
                                                                                                                                                        0.317124,
                                                                                                                                                        0.848936, -0.505127,
                                                                                                                                                        0.378783,
                                                                                                                                                        0.77548, -0.422776,
                                                                                                                                                        0.317124,
                                                                                                                                                        0.848936, -0.389967,
                                                                                                                                                        0.496618,
                                                                                                                                                        0.775433, -0.422776,
                                                                                                                                                        0.317124,
                                                                                                                                                        0.848936, -0.505127,
                                                                                                                                                        0.378783,
                                                                                                                                                        0.77548, -0.490354,
                                                                                                                                                        0.196913,
                                                                                                                                                        0.848986, -0.585869,
                                                                                                                                                        0.235157,
                                                                                                                                                        0.775538, -0.490354,
                                                                                                                                                        0.196913,
                                                                                                                                                        0.848986, -0.505127,
                                                                                                                                                        0.378783,
                                                                                                                                                        0.77548, -0.490354,
                                                                                                                                                        0.196913,
                                                                                                                                                        0.848986, -0.585869,
                                                                                                                                                        0.235157,
                                                                                                                                                        0.775538, -0.524518,
                                                                                                                                                        0.063305,
                                                                                                                                                        0.849043, -0.524518,
                                                                                                                                                        0.063305,
                                                                                                                                                        0.849043, -0.408436,
                                                                                                                                                        0.049412,
                                                                                                                                                        0.911449, -0.490354,
                                                                                                                                                        0.196913,
                                                                                                                                                        0.848986, -0.524518,
                                                                                                                                                        0.063305,
                                                                                                                                                        0.849043, -0.522938, -0.074595,
                                                                                                                                                        0.849101, -0.408436,
                                                                                                                                                        0.049412,
                                                                                                                                                        0.911449, -0.522938, -0.074595,
                                                                                                                                                        0.849101, -0.524518,
                                                                                                                                                        0.063305,
                                                                                                                                                        0.849043, -0.624801, -0.089238,
                                                                                                                                                        0.775667, -0.407204, -0.057969,
                                                                                                                                                        0.911496, -0.408436,
                                                                                                                                                        0.049412,
                                                                                                                                                        0.911449, -0.522938, -0.074595,
                                                                                                                                                        0.849101, -0.408436,
                                                                                                                                                        0.049412,
                                                                                                                                                        0.911449, -0.407204, -0.057969,
                                                                                                                                                        0.911496, -0.280113,
                                                                                                                                                        0.034045,
                                                                                                                                                        0.959363, -0.279267, -0.039599,
                                                                                                                                                        0.959397, -0.280113,
                                                                                                                                                        0.034045,
                                                                                                                                                        0.959363, -0.407204, -0.057969,
                                                                                                                                                        0.911496, -0.280113,
                                                                                                                                                        0.034045,
                                                                                                                                                        0.959363, -0.279267, -0.039599,
                                                                                                                                                        0.959397, -0.142572,
                                                                                                                                                        0.017563,
                                                                                                                                                        0.989629, -0.14214, -0.01992,
                                                                                                                                                        0.989646, -0.142572,
                                                                                                                                                        0.017563,
                                                                                                                                                        0.989629, -0.279267, -0.039599,
                                                                                                                                                        0.959397, -0.142572,
                                                                                                                                                        0.017563,
                                                                                                                                                        0.989629, -0.14214, -0.01992,
                                                                                                                                                        0.989646, -0.047879,
                                                                                                                                                        0.006211,
                                                                                                                                                        0.998834, -0.047734, -0.006377,
                                                                                                                                                        0.99884, -0.047879,
                                                                                                                                                        0.006211,
                                                                                                                                                        0.998834, -0.14214, -0.01992,
                                                                                                                                                        0.989646, -0.047879,
                                                                                                                                                        0.006211,
                                                                                                                                                        0.998834, -0.047734, -0.006377,
                                                                                                                                                        0.99884, -0.044761,
                                                                                                                                                        0.018407,
                                                                                                                                                        0.998828, -0.044761,
                                                                                                                                                        0.018407,
                                                                                                                                                        0.998828, -0.133287,
                                                                                                                                                        0.05388,
                                                                                                                                                        0.989612, -0.047879,
                                                                                                                                                        0.006211,
                                                                                                                                                        0.998834, -0.133287,
                                                                                                                                                        0.05388,
                                                                                                                                                        0.989612, -0.044761,
                                                                                                                                                        0.018407,
                                                                                                                                                        0.998828, -0.114919,
                                                                                                                                                        0.086557,
                                                                                                                                                        0.989597, -0.038593,
                                                                                                                                                        0.029381,
                                                                                                                                                        0.998823, -0.114919,
                                                                                                                                                        0.086557,
                                                                                                                                                        0.989597, -0.044761,
                                                                                                                                                        0.018407,
                                                                                                                                                        0.998828, -0.114919,
                                                                                                                                                        0.086557,
                                                                                                                                                        0.989597, -0.038593,
                                                                                                                                                        0.029381,
                                                                                                                                                        0.998823, -0.088721,
                                                                                                                                                        0.113366,
                                                                                                                                                        0.989584, -0.029795,
                                                                                                                                                        0.038384,
                                                                                                                                                        0.998819, -0.088721,
                                                                                                                                                        0.113366,
                                                                                                                                                        0.989584, -0.038593,
                                                                                                                                                        0.029381,
                                                                                                                                                        0.998823, -0.088721,
                                                                                                                                                        0.113366,
                                                                                                                                                        0.989584, -0.029795,
                                                                                                                                                        0.038384,
                                                                                                                                                        0.998819, -0.056476,
                                                                                                                                                        0.132481,
                                                                                                                                                        0.989575, -0.018966,
                                                                                                                                                        0.044803,
                                                                                                                                                        0.998816, -0.056476,
                                                                                                                                                        0.132481,
                                                                                                                                                        0.989575, -0.029795,
                                                                                                                                                        0.038384,
                                                                                                                                                        0.998819, -0.056476,
                                                                                                                                                        0.132481,
                                                                                                                                                        0.989575, -0.018966,
                                                                                                                                                        0.044803,
                                                                                                                                                        0.998816, -0.020383,
                                                                                                                                                        0.142599,
                                                                                                                                                        0.989571, -0.006845,
                                                                                                                                                        0.048201,
                                                                                                                                                        0.998814, -0.020383,
                                                                                                                                                        0.142599,
                                                                                                                                                        0.989571, -0.018966,
                                                                                                                                                        0.044803,
                                                                                                                                                        0.998816, -0.006845,
                                                                                                                                                        0.048201,
                                                                                                                                                        0.998814,
                                                                                                                                                        0.005742,
                                                                                                                                                        0.048347,
                                                                                                                                                        0.998814, -0.020383,
                                                                                                                                                        0.142599,
                                                                                                                                                        0.989571, -0.006845,
                                                                                                                                                        0.048201,
                                                                                                                                                        0.998814,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.005742,
                                                                                                                                                        0.048347,
                                                                                                                                                        0.998814, -0.005742, -0.047411,
                                                                                                                                                        0.998859,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1, -0.006845,
                                                                                                                                                        0.048201,
                                                                                                                                                        0.998814,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1, -0.005742, -0.047411,
                                                                                                                                                        0.998859,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1, -0.005742, -0.047411,
                                                                                                                                                        0.998859,
                                                                                                                                                        0.006845, -0.047266,
                                                                                                                                                        0.998859,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1, -0.005742, -0.047411,
                                                                                                                                                        0.998859, -0.0171, -0.142112,
                                                                                                                                                        0.989703,
                                                                                                                                                        0.006845, -0.047266,
                                                                                                                                                        0.998859, -0.005742, -0.047411,
                                                                                                                                                        0.998859, -0.017939, -0.044294,
                                                                                                                                                        0.998857, -0.0171, -0.142112,
                                                                                                                                                        0.989703, -0.017939, -0.044294,
                                                                                                                                                        0.998857, -0.005742, -0.047411,
                                                                                                                                                        0.998859, -0.006845,
                                                                                                                                                        0.048201,
                                                                                                                                                        0.998814, -0.018966,
                                                                                                                                                        0.044803,
                                                                                                                                                        0.998816, -0.017939, -0.044294,
                                                                                                                                                        0.998857, -0.006845,
                                                                                                                                                        0.048201,
                                                                                                                                                        0.998814, -0.028913, -0.038125,
                                                                                                                                                        0.998855, -0.017939, -0.044294,
                                                                                                                                                        0.998857, -0.018966,
                                                                                                                                                        0.044803,
                                                                                                                                                        0.998816, -0.017939, -0.044294,
                                                                                                                                                        0.998857, -0.028913, -0.038125,
                                                                                                                                                        0.998855, -0.053418, -0.132828,
                                                                                                                                                        0.989699, -0.086096, -0.11446,
                                                                                                                                                        0.98969, -0.053418, -0.132828,
                                                                                                                                                        0.989699, -0.028913, -0.038125,
                                                                                                                                                        0.998855, -0.053418, -0.132828,
                                                                                                                                                        0.989699, -0.086096, -0.11446,
                                                                                                                                                        0.98969, -0.104954, -0.261437,
                                                                                                                                                        0.959498, -0.169158, -0.225348,
                                                                                                                                                        0.959481, -0.104954, -0.261437,
                                                                                                                                                        0.959498, -0.086096, -0.11446,
                                                                                                                                                        0.98969, -0.104954, -0.261437,
                                                                                                                                                        0.959498, -0.169158, -0.225348,
                                                                                                                                                        0.959481, -0.153038, -0.38144,
                                                                                                                                                        0.911638, -0.246655, -0.328816,
                                                                                                                                                        0.911615, -0.153038, -0.38144,
                                                                                                                                                        0.911638, -0.169158, -0.225348,
                                                                                                                                                        0.959481, -0.153038, -0.38144,
                                                                                                                                                        0.911638, -0.246655, -0.328816,
                                                                                                                                                        0.911615, -0.196535, -0.490006,
                                                                                                                                                        0.849275, -0.316761, -0.422425,
                                                                                                                                                        0.849247, -0.196535, -0.490006,
                                                                                                                                                        0.849275, -0.246655, -0.328816,
                                                                                                                                                        0.911615, -0.196535, -0.490006,
                                                                                                                                                        0.849275, -0.316761, -0.422425,
                                                                                                                                                        0.849247, -0.23482, -0.58557,
                                                                                                                                                        0.775866, -0.378465, -0.504824,
                                                                                                                                                        0.775833, -0.23482, -0.58557,
                                                                                                                                                        0.775866, -0.316761, -0.422425,
                                                                                                                                                        0.849247, -0.23482, -0.58557,
                                                                                                                                                        0.775866, -0.378465, -0.504824,
                                                                                                                                                        0.775833, -0.267709, -0.667676,
                                                                                                                                                        0.694651, -0.431474, -0.57562,
                                                                                                                                                        0.694616, -0.267709, -0.667676,
                                                                                                                                                        0.694651, -0.378465, -0.504824,
                                                                                                                                                        0.775833, -0.267709, -0.667676,
                                                                                                                                                        0.694651, -0.431474, -0.57562,
                                                                                                                                                        0.694616, -0.295344, -0.736672,
                                                                                                                                                        0.608347, -0.295344, -0.736672,
                                                                                                                                                        0.608347, -0.094543, -0.788006,
                                                                                                                                                        0.608365, -0.267709, -0.667676,
                                                                                                                                                        0.694651, -0.094543, -0.788006,
                                                                                                                                                        0.608365, -0.295344, -0.736672,
                                                                                                                                                        0.608347, -0.101813, -0.848663,
                                                                                                                                                        0.519043, -0.318055, -0.793382,
                                                                                                                                                        0.519025, -0.101813, -0.848663,
                                                                                                                                                        0.519043, -0.295344, -0.736672,
                                                                                                                                                        0.608347, -0.101813, -0.848663,
                                                                                                                                                        0.519043, -0.318055, -0.793382,
                                                                                                                                                        0.519025, -0.107637, -0.897271,
                                                                                                                                                        0.428158, -0.336251, -0.838828,
                                                                                                                                                        0.428139, -0.107637, -0.897271,
                                                                                                                                                        0.428158, -0.318055, -0.793382,
                                                                                                                                                        0.519025, -0.107637, -0.897271,
                                                                                                                                                        0.428158, -0.336251, -0.838828,
                                                                                                                                                        0.428139, -0.112149, -0.934931,
                                                                                                                                                        0.336639, -0.350345, -0.87404,
                                                                                                                                                        0.33662, -0.112149, -0.934931,
                                                                                                                                                        0.336639, -0.336251, -0.838828,
                                                                                                                                                        0.428139, -0.112149, -0.934931,
                                                                                                                                                        0.336639, -0.350345, -0.87404,
                                                                                                                                                        0.33662, -0.115465, -0.96262,
                                                                                                                                                        0.245011, -0.112149, -0.934931,
                                                                                                                                                        0.336639, -0.115465, -0.96262,
                                                                                                                                                        0.245011,
                                                                                                                                                        0.133691, -0.932095,
                                                                                                                                                        0.336638,
                                                                                                                                                        0.137644, -0.9597,
                                                                                                                                                        0.24501,
                                                                                                                                                        0.133691, -0.932095,
                                                                                                                                                        0.336638, -0.115465, -0.96262,
                                                                                                                                                        0.245011,
                                                                                                                                                        0.133691, -0.932095,
                                                                                                                                                        0.336638,
                                                                                                                                                        0.137644, -0.9597,
                                                                                                                                                        0.24501,
                                                                                                                                                        0.370419, -0.865724,
                                                                                                                                                        0.336617,
                                                                                                                                                        0.381371, -0.891368,
                                                                                                                                                        0.244989,
                                                                                                                                                        0.370419, -0.865724,
                                                                                                                                                        0.336617,
                                                                                                                                                        0.137644, -0.9597,
                                                                                                                                                        0.24501,
                                                                                                                                                        0.370419, -0.865724,
                                                                                                                                                        0.336617,
                                                                                                                                                        0.381371, -0.891368,
                                                                                                                                                        0.244989,
                                                                                                                                                        0.5819, -0.740344,
                                                                                                                                                        0.336577,
                                                                                                                                                        0.599105, -0.762281,
                                                                                                                                                        0.24495,
                                                                                                                                                        0.5819, -0.740344,
                                                                                                                                                        0.336577,
                                                                                                                                                        0.381371, -0.891368,
                                                                                                                                                        0.244989,
                                                                                                                                                        0.381371, -0.891368,
                                                                                                                                                        0.244989,
                                                                                                                                                        0.385485, -0.901006,
                                                                                                                                                        0.19897,
                                                                                                                                                        0.599105, -0.762281,
                                                                                                                                                        0.24495,
                                                                                                                                                        0.385485, -0.901006,
                                                                                                                                                        0.19897,
                                                                                                                                                        0.381371, -0.891368,
                                                                                                                                                        0.244989,
                                                                                                                                                        0.139128, -0.970075,
                                                                                                                                                        0.198991,
                                                                                                                                                        0.137644, -0.9597,
                                                                                                                                                        0.24501,
                                                                                                                                                        0.139128, -0.970075,
                                                                                                                                                        0.198991,
                                                                                                                                                        0.381371, -0.891368,
                                                                                                                                                        0.244989,
                                                                                                                                                        0.139128, -0.970075,
                                                                                                                                                        0.198991,
                                                                                                                                                        0.137644, -0.9597,
                                                                                                                                                        0.24501, -0.11671, -0.973027,
                                                                                                                                                        0.198992, -0.115465, -0.96262,
                                                                                                                                                        0.245011, -0.11671, -0.973027,
                                                                                                                                                        0.198992,
                                                                                                                                                        0.137644, -0.9597,
                                                                                                                                                        0.24501,
                                                                                                                                                        0.605569, -0.770528,
                                                                                                                                                        0.198931,
                                                                                                                                                        0.599105, -0.762281,
                                                                                                                                                        0.24495,
                                                                                                                                                        0.385485, -0.901006,
                                                                                                                                                        0.19897,
                                                                                                                                                        0.5819, -0.740344,
                                                                                                                                                        0.336577,
                                                                                                                                                        0.558489, -0.710509,
                                                                                                                                                        0.428097,
                                                                                                                                                        0.370419, -0.865724,
                                                                                                                                                        0.336617,
                                                                                                                                                        0.355517, -0.830847,
                                                                                                                                                        0.428136,
                                                                                                                                                        0.370419, -0.865724,
                                                                                                                                                        0.336617,
                                                                                                                                                        0.558489, -0.710509,
                                                                                                                                                        0.428097,
                                                                                                                                                        0.370419, -0.865724,
                                                                                                                                                        0.336617,
                                                                                                                                                        0.355517, -0.830847,
                                                                                                                                                        0.428136,
                                                                                                                                                        0.133691, -0.932095,
                                                                                                                                                        0.336638,
                                                                                                                                                        0.128313, -0.894549,
                                                                                                                                                        0.428157,
                                                                                                                                                        0.133691, -0.932095,
                                                                                                                                                        0.336638,
                                                                                                                                                        0.355517, -0.830847,
                                                                                                                                                        0.428136,
                                                                                                                                                        0.133691, -0.932095,
                                                                                                                                                        0.336638,
                                                                                                                                                        0.128313, -0.894549,
                                                                                                                                                        0.428157, -0.112149, -0.934931,
                                                                                                                                                        0.336639, -0.107637, -0.897271,
                                                                                                                                                        0.428158, -0.112149, -0.934931,
                                                                                                                                                        0.336639,
                                                                                                                                                        0.128313, -0.894549,
                                                                                                                                                        0.428157,
                                                                                                                                                        0.128313, -0.894549,
                                                                                                                                                        0.428157,
                                                                                                                                                        0.121369, -0.846088,
                                                                                                                                                        0.519043, -0.107637, -0.897271,
                                                                                                                                                        0.428158,
                                                                                                                                                        0.121369, -0.846088,
                                                                                                                                                        0.519043,
                                                                                                                                                        0.128313, -0.894549,
                                                                                                                                                        0.428157,
                                                                                                                                                        0.336278, -0.785833,
                                                                                                                                                        0.519022,
                                                                                                                                                        0.355517, -0.830847,
                                                                                                                                                        0.428136,
                                                                                                                                                        0.336278, -0.785833,
                                                                                                                                                        0.519022,
                                                                                                                                                        0.128313, -0.894549,
                                                                                                                                                        0.428157,
                                                                                                                                                        0.336278, -0.785833,
                                                                                                                                                        0.519022,
                                                                                                                                                        0.355517, -0.830847,
                                                                                                                                                        0.428136,
                                                                                                                                                        0.528266, -0.672006,
                                                                                                                                                        0.518983,
                                                                                                                                                        0.558489, -0.710509,
                                                                                                                                                        0.428097,
                                                                                                                                                        0.528266, -0.672006,
                                                                                                                                                        0.518983,
                                                                                                                                                        0.355517, -0.830847,
                                                                                                                                                        0.428136,
                                                                                                                                                        0.528266, -0.672006,
                                                                                                                                                        0.518983,
                                                                                                                                                        0.490545, -0.623963,
                                                                                                                                                        0.608306,
                                                                                                                                                        0.336278, -0.785833,
                                                                                                                                                        0.519022,
                                                                                                                                                        0.312267, -0.729662,
                                                                                                                                                        0.608344,
                                                                                                                                                        0.336278, -0.785833,
                                                                                                                                                        0.519022,
                                                                                                                                                        0.490545, -0.623963,
                                                                                                                                                        0.608306,
                                                                                                                                                        0.336278, -0.785833,
                                                                                                                                                        0.519022,
                                                                                                                                                        0.312267, -0.729662,
                                                                                                                                                        0.608344,
                                                                                                                                                        0.121369, -0.846088,
                                                                                                                                                        0.519043,
                                                                                                                                                        0.112703, -0.785615,
                                                                                                                                                        0.608364,
                                                                                                                                                        0.121369, -0.846088,
                                                                                                                                                        0.519043,
                                                                                                                                                        0.312267, -0.729662,
                                                                                                                                                        0.608344,
                                                                                                                                                        0.121369, -0.846088,
                                                                                                                                                        0.519043,
                                                                                                                                                        0.112703, -0.785615,
                                                                                                                                                        0.608364, -0.101813, -0.848663,
                                                                                                                                                        0.519043, -0.094543, -0.788006,
                                                                                                                                                        0.608365, -0.101813, -0.848663,
                                                                                                                                                        0.519043,
                                                                                                                                                        0.112703, -0.785615,
                                                                                                                                                        0.608364,
                                                                                                                                                        0.112703, -0.785615,
                                                                                                                                                        0.608364,
                                                                                                                                                        0.102158, -0.712039,
                                                                                                                                                        0.694668, -0.094543, -0.788006,
                                                                                                                                                        0.608365,
                                                                                                                                                        0.102158, -0.712039,
                                                                                                                                                        0.694668,
                                                                                                                                                        0.112703, -0.785615,
                                                                                                                                                        0.608364,
                                                                                                                                                        0.283048, -0.661322,
                                                                                                                                                        0.694649,
                                                                                                                                                        0.312267, -0.729662,
                                                                                                                                                        0.608344,
                                                                                                                                                        0.283048, -0.661322,
                                                                                                                                                        0.694649,
                                                                                                                                                        0.112703, -0.785615,
                                                                                                                                                        0.608364,
                                                                                                                                                        0.283048, -0.661322,
                                                                                                                                                        0.694649,
                                                                                                                                                        0.312267, -0.729662,
                                                                                                                                                        0.608344,
                                                                                                                                                        0.444645, -0.565512,
                                                                                                                                                        0.694612,
                                                                                                                                                        0.490545, -0.623963,
                                                                                                                                                        0.608306,
                                                                                                                                                        0.444645, -0.565512,
                                                                                                                                                        0.694612,
                                                                                                                                                        0.312267, -0.729662,
                                                                                                                                                        0.608344,
                                                                                                                                                        0.444645, -0.565512,
                                                                                                                                                        0.694612,
                                                                                                                                                        0.490545, -0.623963,
                                                                                                                                                        0.608306,
                                                                                                                                                        0.575935, -0.431142,
                                                                                                                                                        0.694562,
                                                                                                                                                        0.575935, -0.431142,
                                                                                                                                                        0.694562,
                                                                                                                                                        0.505178, -0.378096,
                                                                                                                                                        0.775783,
                                                                                                                                                        0.444645, -0.565512,
                                                                                                                                                        0.694612,
                                                                                                                                                        0.505178, -0.378096,
                                                                                                                                                        0.775783,
                                                                                                                                                        0.575935, -0.431142,
                                                                                                                                                        0.694562,
                                                                                                                                                        0.585906, -0.234446,
                                                                                                                                                        0.775725,
                                                                                                                                                        0.667969, -0.267372,
                                                                                                                                                        0.694499,
                                                                                                                                                        0.585906, -0.234446,
                                                                                                                                                        0.775725,
                                                                                                                                                        0.575935, -0.431142,
                                                                                                                                                        0.694562,
                                                                                                                                                        0.585906, -0.234446,
                                                                                                                                                        0.775725,
                                                                                                                                                        0.667969, -0.267372,
                                                                                                                                                        0.694499,
                                                                                                                                                        0.626701, -0.0748,
                                                                                                                                                        0.775662,
                                                                                                                                                        0.626701, -0.0748,
                                                                                                                                                        0.775662,
                                                                                                                                                        0.524528, -0.062511,
                                                                                                                                                        0.849095,
                                                                                                                                                        0.585906, -0.234446,
                                                                                                                                                        0.775725,
                                                                                                                                                        0.626701, -0.0748,
                                                                                                                                                        0.775662,
                                                                                                                                                        0.624787,
                                                                                                                                                        0.089961,
                                                                                                                                                        0.775596,
                                                                                                                                                        0.524528, -0.062511,
                                                                                                                                                        0.849095,
                                                                                                                                                        0.624787,
                                                                                                                                                        0.089961,
                                                                                                                                                        0.775596,
                                                                                                                                                        0.626701, -0.0748,
                                                                                                                                                        0.775662,
                                                                                                                                                        0.712295,
                                                                                                                                                        0.102472,
                                                                                                                                                        0.694359,
                                                                                                                                                        0.712295,
                                                                                                                                                        0.102472,
                                                                                                                                                        0.694359,
                                                                                                                                                        0.661572,
                                                                                                                                                        0.283341,
                                                                                                                                                        0.694291,
                                                                                                                                                        0.624787,
                                                                                                                                                        0.089961,
                                                                                                                                                        0.775596,
                                                                                                                                                        0.712295,
                                                                                                                                                        0.102472,
                                                                                                                                                        0.694359,
                                                                                                                                                        0.785826,
                                                                                                                                                        0.112977,
                                                                                                                                                        0.608041,
                                                                                                                                                        0.661572,
                                                                                                                                                        0.283341,
                                                                                                                                                        0.694291,
                                                                                                                                                        0.729867,
                                                                                                                                                        0.312517,
                                                                                                                                                        0.607969,
                                                                                                                                                        0.661572,
                                                                                                                                                        0.283341,
                                                                                                                                                        0.694291,
                                                                                                                                                        0.785826,
                                                                                                                                                        0.112977,
                                                                                                                                                        0.608041,
                                                                                                                                                        0.661572,
                                                                                                                                                        0.283341,
                                                                                                                                                        0.694291,
                                                                                                                                                        0.729867,
                                                                                                                                                        0.312517,
                                                                                                                                                        0.607969,
                                                                                                                                                        0.565769,
                                                                                                                                                        0.444917,
                                                                                                                                                        0.69423,
                                                                                                                                                        0.624174,
                                                                                                                                                        0.490772,
                                                                                                                                                        0.607905,
                                                                                                                                                        0.565769,
                                                                                                                                                        0.444917,
                                                                                                                                                        0.69423,
                                                                                                                                                        0.729867,
                                                                                                                                                        0.312517,
                                                                                                                                                        0.607969,
                                                                                                                                                        0.624174,
                                                                                                                                                        0.490772,
                                                                                                                                                        0.607905,
                                                                                                                                                        0.475951,
                                                                                                                                                        0.635598,
                                                                                                                                                        0.607853,
                                                                                                                                                        0.565769,
                                                                                                                                                        0.444917,
                                                                                                                                                        0.69423,
                                                                                                                                                        0.624174,
                                                                                                                                                        0.490772,
                                                                                                                                                        0.607905,
                                                                                                                                                        0.672177,
                                                                                                                                                        0.528452,
                                                                                                                                                        0.518572,
                                                                                                                                                        0.475951,
                                                                                                                                                        0.635598,
                                                                                                                                                        0.607853,
                                                                                                                                                        0.672177,
                                                                                                                                                        0.528452,
                                                                                                                                                        0.518572,
                                                                                                                                                        0.624174,
                                                                                                                                                        0.490772,
                                                                                                                                                        0.607905,
                                                                                                                                                        0.785997,
                                                                                                                                                        0.336487,
                                                                                                                                                        0.518638,
                                                                                                                                                        0.729867,
                                                                                                                                                        0.312517,
                                                                                                                                                        0.607969,
                                                                                                                                                        0.785997,
                                                                                                                                                        0.336487,
                                                                                                                                                        0.518638,
                                                                                                                                                        0.624174,
                                                                                                                                                        0.490772,
                                                                                                                                                        0.607905,
                                                                                                                                                        0.785997,
                                                                                                                                                        0.336487,
                                                                                                                                                        0.518638,
                                                                                                                                                        0.729867,
                                                                                                                                                        0.312517,
                                                                                                                                                        0.607969,
                                                                                                                                                        0.846257,
                                                                                                                                                        0.121601,
                                                                                                                                                        0.518711,
                                                                                                                                                        0.785826,
                                                                                                                                                        0.112977,
                                                                                                                                                        0.608041,
                                                                                                                                                        0.846257,
                                                                                                                                                        0.121601,
                                                                                                                                                        0.518711,
                                                                                                                                                        0.729867,
                                                                                                                                                        0.312517,
                                                                                                                                                        0.607969,
                                                                                                                                                        0.846257,
                                                                                                                                                        0.121601,
                                                                                                                                                        0.518711,
                                                                                                                                                        0.894682,
                                                                                                                                                        0.128503,
                                                                                                                                                        0.427822,
                                                                                                                                                        0.785997,
                                                                                                                                                        0.336487,
                                                                                                                                                        0.518638,
                                                                                                                                                        0.830975,
                                                                                                                                                        0.355686,
                                                                                                                                                        0.427748,
                                                                                                                                                        0.785997,
                                                                                                                                                        0.336487,
                                                                                                                                                        0.518638,
                                                                                                                                                        0.894682,
                                                                                                                                                        0.128503,
                                                                                                                                                        0.427822,
                                                                                                                                                        0.785997,
                                                                                                                                                        0.336487,
                                                                                                                                                        0.518638,
                                                                                                                                                        0.830975,
                                                                                                                                                        0.355686,
                                                                                                                                                        0.427748,
                                                                                                                                                        0.672177,
                                                                                                                                                        0.528452,
                                                                                                                                                        0.518572,
                                                                                                                                                        0.710643,
                                                                                                                                                        0.558637,
                                                                                                                                                        0.427681,
                                                                                                                                                        0.672177,
                                                                                                                                                        0.528452,
                                                                                                                                                        0.518572,
                                                                                                                                                        0.830975,
                                                                                                                                                        0.355686,
                                                                                                                                                        0.427748,
                                                                                                                                                        0.672177,
                                                                                                                                                        0.528452,
                                                                                                                                                        0.518572,
                                                                                                                                                        0.710643,
                                                                                                                                                        0.558637,
                                                                                                                                                        0.427681,
                                                                                                                                                        0.512555,
                                                                                                                                                        0.684416,
                                                                                                                                                        0.518519,
                                                                                                                                                        0.541888,
                                                                                                                                                        0.723528,
                                                                                                                                                        0.427627,
                                                                                                                                                        0.512555,
                                                                                                                                                        0.684416,
                                                                                                                                                        0.518519,
                                                                                                                                                        0.710643,
                                                                                                                                                        0.558637,
                                                                                                                                                        0.427681,
                                                                                                                                                        0.512555,
                                                                                                                                                        0.684416,
                                                                                                                                                        0.518519,
                                                                                                                                                        0.541888,
                                                                                                                                                        0.723528,
                                                                                                                                                        0.427627,
                                                                                                                                                        0.31801,
                                                                                                                                                        0.793755,
                                                                                                                                                        0.518481,
                                                                                                                                                        0.33621,
                                                                                                                                                        0.839125,
                                                                                                                                                        0.427589,
                                                                                                                                                        0.31801,
                                                                                                                                                        0.793755,
                                                                                                                                                        0.518481,
                                                                                                                                                        0.541888,
                                                                                                                                                        0.723528,
                                                                                                                                                        0.427627,
                                                                                                                                                        0.31801,
                                                                                                                                                        0.793755,
                                                                                                                                                        0.518481,
                                                                                                                                                        0.33621,
                                                                                                                                                        0.839125,
                                                                                                                                                        0.427589,
                                                                                                                                                        0.101797,
                                                                                                                                                        0.849019,
                                                                                                                                                        0.518463,
                                                                                                                                                        0.107623,
                                                                                                                                                        0.897553,
                                                                                                                                                        0.42757,
                                                                                                                                                        0.101797,
                                                                                                                                                        0.849019,
                                                                                                                                                        0.518463,
                                                                                                                                                        0.33621,
                                                                                                                                                        0.839125,
                                                                                                                                                        0.427589,
                                                                                                                                                        0.107623,
                                                                                                                                                        0.897553,
                                                                                                                                                        0.42757, -0.128296,
                                                                                                                                                        0.894831,
                                                                                                                                                        0.427571,
                                                                                                                                                        0.101797,
                                                                                                                                                        0.849019,
                                                                                                                                                        0.518463, -0.128296,
                                                                                                                                                        0.894831,
                                                                                                                                                        0.427571,
                                                                                                                                                        0.107623,
                                                                                                                                                        0.897553,
                                                                                                                                                        0.42757, -0.133677,
                                                                                                                                                        0.932309,
                                                                                                                                                        0.33605,
                                                                                                                                                        0.112137,
                                                                                                                                                        0.935145,
                                                                                                                                                        0.336049, -0.133677,
                                                                                                                                                        0.932309,
                                                                                                                                                        0.33605,
                                                                                                                                                        0.107623,
                                                                                                                                                        0.897553,
                                                                                                                                                        0.42757, -0.133677,
                                                                                                                                                        0.932309,
                                                                                                                                                        0.33605,
                                                                                                                                                        0.112137,
                                                                                                                                                        0.935145,
                                                                                                                                                        0.336049, -0.137633,
                                                                                                                                                        0.959851,
                                                                                                                                                        0.244423,
                                                                                                                                                        0.115455,
                                                                                                                                                        0.962771,
                                                                                                                                                        0.244422, -0.137633,
                                                                                                                                                        0.959851,
                                                                                                                                                        0.244423,
                                                                                                                                                        0.112137,
                                                                                                                                                        0.935145,
                                                                                                                                                        0.336049, -0.137633,
                                                                                                                                                        0.959851,
                                                                                                                                                        0.244423,
                                                                                                                                                        0.115455,
                                                                                                                                                        0.962771,
                                                                                                                                                        0.244422, -0.139119,
                                                                                                                                                        0.970197,
                                                                                                                                                        0.198405,
                                                                                                                                                        0.116702,
                                                                                                                                                        0.973148,
                                                                                                                                                        0.198404, -0.139119,
                                                                                                                                                        0.970197,
                                                                                                                                                        0.198405,
                                                                                                                                                        0.115455,
                                                                                                                                                        0.962771,
                                                                                                                                                        0.244422,
                                                                                                                                                        0.116702,
                                                                                                                                                        0.973148,
                                                                                                                                                        0.198404,
                                                                                                                                                        0.115455,
                                                                                                                                                        0.962771,
                                                                                                                                                        0.244422,
                                                                                                                                                        0.364572,
                                                                                                                                                        0.909789,
                                                                                                                                                        0.198423,
                                                                                                                                                        0.360676,
                                                                                                                                                        0.90009,
                                                                                                                                                        0.244441,
                                                                                                                                                        0.364572,
                                                                                                                                                        0.909789,
                                                                                                                                                        0.198423,
                                                                                                                                                        0.115455,
                                                                                                                                                        0.962771,
                                                                                                                                                        0.244422,
                                                                                                                                                        0.364572,
                                                                                                                                                        0.909789,
                                                                                                                                                        0.198423,
                                                                                                                                                        0.360676,
                                                                                                                                                        0.90009,
                                                                                                                                                        0.244441,
                                                                                                                                                        0.587599,
                                                                                                                                                        0.784437,
                                                                                                                                                        0.198461,
                                                                                                                                                        0.58132,
                                                                                                                                                        0.776078,
                                                                                                                                                        0.244479,
                                                                                                                                                        0.587599,
                                                                                                                                                        0.784437,
                                                                                                                                                        0.198461,
                                                                                                                                                        0.360676,
                                                                                                                                                        0.90009,
                                                                                                                                                        0.244441,
                                                                                                                                                        0.587599,
                                                                                                                                                        0.784437,
                                                                                                                                                        0.198461,
                                                                                                                                                        0.58132,
                                                                                                                                                        0.776078,
                                                                                                                                                        0.244479,
                                                                                                                                                        0.770585,
                                                                                                                                                        0.605633,
                                                                                                                                                        0.198515,
                                                                                                                                                        0.762352,
                                                                                                                                                        0.599185,
                                                                                                                                                        0.244533,
                                                                                                                                                        0.770585,
                                                                                                                                                        0.605633,
                                                                                                                                                        0.198515,
                                                                                                                                                        0.58132,
                                                                                                                                                        0.776078,
                                                                                                                                                        0.244479,
                                                                                                                                                        0.770585,
                                                                                                                                                        0.605633,
                                                                                                                                                        0.198515,
                                                                                                                                                        0.762352,
                                                                                                                                                        0.599185,
                                                                                                                                                        0.244533,
                                                                                                                                                        0.90106,
                                                                                                                                                        0.38556,
                                                                                                                                                        0.198582,
                                                                                                                                                        0.891435,
                                                                                                                                                        0.381464,
                                                                                                                                                        0.2446,
                                                                                                                                                        0.90106,
                                                                                                                                                        0.38556,
                                                                                                                                                        0.198582,
                                                                                                                                                        0.762352,
                                                                                                                                                        0.599185,
                                                                                                                                                        0.244533,
                                                                                                                                                        0.90106,
                                                                                                                                                        0.38556,
                                                                                                                                                        0.198582,
                                                                                                                                                        0.891435,
                                                                                                                                                        0.381464,
                                                                                                                                                        0.2446,
                                                                                                                                                        0.970131,
                                                                                                                                                        0.139216,
                                                                                                                                                        0.198656,
                                                                                                                                                        0.95977,
                                                                                                                                                        0.137751,
                                                                                                                                                        0.244674,
                                                                                                                                                        0.970131,
                                                                                                                                                        0.139216,
                                                                                                                                                        0.198656,
                                                                                                                                                        0.891435,
                                                                                                                                                        0.381464,
                                                                                                                                                        0.2446,
                                                                                                                                                        0.891435,
                                                                                                                                                        0.381464,
                                                                                                                                                        0.2446,
                                                                                                                                                        0.86582,
                                                                                                                                                        0.370549,
                                                                                                                                                        0.336227,
                                                                                                                                                        0.95977,
                                                                                                                                                        0.137751,
                                                                                                                                                        0.244674,
                                                                                                                                                        0.86582,
                                                                                                                                                        0.370549,
                                                                                                                                                        0.336227,
                                                                                                                                                        0.891435,
                                                                                                                                                        0.381464,
                                                                                                                                                        0.2446,
                                                                                                                                                        0.740444,
                                                                                                                                                        0.582012,
                                                                                                                                                        0.336161,
                                                                                                                                                        0.762352,
                                                                                                                                                        0.599185,
                                                                                                                                                        0.244533,
                                                                                                                                                        0.740444,
                                                                                                                                                        0.582012,
                                                                                                                                                        0.336161,
                                                                                                                                                        0.891435,
                                                                                                                                                        0.381464,
                                                                                                                                                        0.2446,
                                                                                                                                                        0.740444,
                                                                                                                                                        0.582012,
                                                                                                                                                        0.336161,
                                                                                                                                                        0.762352,
                                                                                                                                                        0.599185,
                                                                                                                                                        0.244533,
                                                                                                                                                        0.564613,
                                                                                                                                                        0.75382,
                                                                                                                                                        0.336106,
                                                                                                                                                        0.58132,
                                                                                                                                                        0.776078,
                                                                                                                                                        0.244479,
                                                                                                                                                        0.564613,
                                                                                                                                                        0.75382,
                                                                                                                                                        0.336106,
                                                                                                                                                        0.762352,
                                                                                                                                                        0.599185,
                                                                                                                                                        0.244533,
                                                                                                                                                        0.564613,
                                                                                                                                                        0.75382,
                                                                                                                                                        0.336106,
                                                                                                                                                        0.58132,
                                                                                                                                                        0.776078,
                                                                                                                                                        0.244479,
                                                                                                                                                        0.35031,
                                                                                                                                                        0.874266,
                                                                                                                                                        0.336069,
                                                                                                                                                        0.360676,
                                                                                                                                                        0.90009,
                                                                                                                                                        0.244441,
                                                                                                                                                        0.35031,
                                                                                                                                                        0.874266,
                                                                                                                                                        0.336069,
                                                                                                                                                        0.58132,
                                                                                                                                                        0.776078,
                                                                                                                                                        0.244479,
                                                                                                                                                        0.35031,
                                                                                                                                                        0.874266,
                                                                                                                                                        0.336069,
                                                                                                                                                        0.360676,
                                                                                                                                                        0.90009,
                                                                                                                                                        0.244441,
                                                                                                                                                        0.112137,
                                                                                                                                                        0.935145,
                                                                                                                                                        0.336049,
                                                                                                                                                        0.115455,
                                                                                                                                                        0.962771,
                                                                                                                                                        0.244422,
                                                                                                                                                        0.112137,
                                                                                                                                                        0.935145,
                                                                                                                                                        0.336049,
                                                                                                                                                        0.360676,
                                                                                                                                                        0.90009,
                                                                                                                                                        0.244441,
                                                                                                                                                        0.112137,
                                                                                                                                                        0.935145,
                                                                                                                                                        0.336049,
                                                                                                                                                        0.107623,
                                                                                                                                                        0.897553,
                                                                                                                                                        0.42757,
                                                                                                                                                        0.35031,
                                                                                                                                                        0.874266,
                                                                                                                                                        0.336069,
                                                                                                                                                        0.33621,
                                                                                                                                                        0.839125,
                                                                                                                                                        0.427589,
                                                                                                                                                        0.35031,
                                                                                                                                                        0.874266,
                                                                                                                                                        0.336069,
                                                                                                                                                        0.107623,
                                                                                                                                                        0.897553,
                                                                                                                                                        0.42757,
                                                                                                                                                        0.35031,
                                                                                                                                                        0.874266,
                                                                                                                                                        0.336069,
                                                                                                                                                        0.33621,
                                                                                                                                                        0.839125,
                                                                                                                                                        0.427589,
                                                                                                                                                        0.564613,
                                                                                                                                                        0.75382,
                                                                                                                                                        0.336106,
                                                                                                                                                        0.541888,
                                                                                                                                                        0.723528,
                                                                                                                                                        0.427627,
                                                                                                                                                        0.564613,
                                                                                                                                                        0.75382,
                                                                                                                                                        0.336106,
                                                                                                                                                        0.33621,
                                                                                                                                                        0.839125,
                                                                                                                                                        0.427589,
                                                                                                                                                        0.564613,
                                                                                                                                                        0.75382,
                                                                                                                                                        0.336106,
                                                                                                                                                        0.541888,
                                                                                                                                                        0.723528,
                                                                                                                                                        0.427627,
                                                                                                                                                        0.740444,
                                                                                                                                                        0.582012,
                                                                                                                                                        0.336161,
                                                                                                                                                        0.710643,
                                                                                                                                                        0.558637,
                                                                                                                                                        0.427681,
                                                                                                                                                        0.740444,
                                                                                                                                                        0.582012,
                                                                                                                                                        0.336161,
                                                                                                                                                        0.541888,
                                                                                                                                                        0.723528,
                                                                                                                                                        0.427627,
                                                                                                                                                        0.740444,
                                                                                                                                                        0.582012,
                                                                                                                                                        0.336161,
                                                                                                                                                        0.710643,
                                                                                                                                                        0.558637,
                                                                                                                                                        0.427681,
                                                                                                                                                        0.86582,
                                                                                                                                                        0.370549,
                                                                                                                                                        0.336227,
                                                                                                                                                        0.830975,
                                                                                                                                                        0.355686,
                                                                                                                                                        0.427748,
                                                                                                                                                        0.86582,
                                                                                                                                                        0.370549,
                                                                                                                                                        0.336227,
                                                                                                                                                        0.710643,
                                                                                                                                                        0.558637,
                                                                                                                                                        0.427681,
                                                                                                                                                        0.86582,
                                                                                                                                                        0.370549,
                                                                                                                                                        0.336227,
                                                                                                                                                        0.830975,
                                                                                                                                                        0.355686,
                                                                                                                                                        0.427748,
                                                                                                                                                        0.932195,
                                                                                                                                                        0.13384,
                                                                                                                                                        0.336302,
                                                                                                                                                        0.894682,
                                                                                                                                                        0.128503,
                                                                                                                                                        0.427822,
                                                                                                                                                        0.932195,
                                                                                                                                                        0.13384,
                                                                                                                                                        0.336302,
                                                                                                                                                        0.830975,
                                                                                                                                                        0.355686,
                                                                                                                                                        0.427748,
                                                                                                                                                        0.932195,
                                                                                                                                                        0.13384,
                                                                                                                                                        0.336302,
                                                                                                                                                        0.95977,
                                                                                                                                                        0.137751,
                                                                                                                                                        0.244674,
                                                                                                                                                        0.86582,
                                                                                                                                                        0.370549,
                                                                                                                                                        0.336227, -0.121351,
                                                                                                                                                        0.846445,
                                                                                                                                                        0.518463,
                                                                                                                                                        0.101797,
                                                                                                                                                        0.849019,
                                                                                                                                                        0.518463, -0.128296,
                                                                                                                                                        0.894831,
                                                                                                                                                        0.427571,
                                                                                                                                                        0.101797,
                                                                                                                                                        0.849019,
                                                                                                                                                        0.518463, -0.121351,
                                                                                                                                                        0.846445,
                                                                                                                                                        0.518463,
                                                                                                                                                        0.094527,
                                                                                                                                                        0.788445,
                                                                                                                                                        0.607798, -0.112685,
                                                                                                                                                        0.786055,
                                                                                                                                                        0.607799,
                                                                                                                                                        0.094527,
                                                                                                                                                        0.788445,
                                                                                                                                                        0.607798, -0.121351,
                                                                                                                                                        0.846445,
                                                                                                                                                        0.518463,
                                                                                                                                                        0.094527,
                                                                                                                                                        0.788445,
                                                                                                                                                        0.607798, -0.112685,
                                                                                                                                                        0.786055,
                                                                                                                                                        0.607799,
                                                                                                                                                        0.085682,
                                                                                                                                                        0.714735,
                                                                                                                                                        0.694127, -0.10214,
                                                                                                                                                        0.712568,
                                                                                                                                                        0.694128,
                                                                                                                                                        0.085682,
                                                                                                                                                        0.714735,
                                                                                                                                                        0.694127, -0.112685,
                                                                                                                                                        0.786055,
                                                                                                                                                        0.607799,
                                                                                                                                                        0.085682,
                                                                                                                                                        0.714735,
                                                                                                                                                        0.694127, -0.10214,
                                                                                                                                                        0.712568,
                                                                                                                                                        0.694128,
                                                                                                                                                        0.075156,
                                                                                                                                                        0.627005,
                                                                                                                                                        0.775381, -0.089592,
                                                                                                                                                        0.625105,
                                                                                                                                                        0.775382,
                                                                                                                                                        0.075156,
                                                                                                                                                        0.627005,
                                                                                                                                                        0.775381, -0.10214,
                                                                                                                                                        0.712568,
                                                                                                                                                        0.694128,
                                                                                                                                                        0.075156,
                                                                                                                                                        0.627005,
                                                                                                                                                        0.775381, -0.089592,
                                                                                                                                                        0.625105,
                                                                                                                                                        0.775382,
                                                                                                                                                        0.062903,
                                                                                                                                                        0.52488,
                                                                                                                                                        0.848849, -0.074986,
                                                                                                                                                        0.523289,
                                                                                                                                                        0.848849,
                                                                                                                                                        0.062903,
                                                                                                                                                        0.52488,
                                                                                                                                                        0.848849, -0.089592,
                                                                                                                                                        0.625105,
                                                                                                                                                        0.775382,
                                                                                                                                                        0.062903,
                                                                                                                                                        0.52488,
                                                                                                                                                        0.848849, -0.074986,
                                                                                                                                                        0.523289,
                                                                                                                                                        0.848849,
                                                                                                                                                        0.048983,
                                                                                                                                                        0.408839,
                                                                                                                                                        0.911291, -0.058391,
                                                                                                                                                        0.407601,
                                                                                                                                                        0.911291,
                                                                                                                                                        0.048983,
                                                                                                                                                        0.408839,
                                                                                                                                                        0.911291, -0.074986,
                                                                                                                                                        0.523289,
                                                                                                                                                        0.848849,
                                                                                                                                                        0.048983,
                                                                                                                                                        0.408839,
                                                                                                                                                        0.911291, -0.058391,
                                                                                                                                                        0.407601,
                                                                                                                                                        0.911291,
                                                                                                                                                        0.033594,
                                                                                                                                                        0.28055,
                                                                                                                                                        0.959251, -0.040046,
                                                                                                                                                        0.279701,
                                                                                                                                                        0.959252,
                                                                                                                                                        0.033594,
                                                                                                                                                        0.28055,
                                                                                                                                                        0.959251, -0.058391,
                                                                                                                                                        0.407601,
                                                                                                                                                        0.911291,
                                                                                                                                                        0.033594,
                                                                                                                                                        0.28055,
                                                                                                                                                        0.959251, -0.040046,
                                                                                                                                                        0.279701,
                                                                                                                                                        0.959252,
                                                                                                                                                        0.017099,
                                                                                                                                                        0.143032,
                                                                                                                                                        0.98957, -0.020383,
                                                                                                                                                        0.142599,
                                                                                                                                                        0.989571,
                                                                                                                                                        0.017099,
                                                                                                                                                        0.143032,
                                                                                                                                                        0.98957, -0.040046,
                                                                                                                                                        0.279701,
                                                                                                                                                        0.959252,
                                                                                                                                                        0.017099,
                                                                                                                                                        0.143032,
                                                                                                                                                        0.98957, -0.020383,
                                                                                                                                                        0.142599,
                                                                                                                                                        0.989571,
                                                                                                                                                        0.005742,
                                                                                                                                                        0.048347,
                                                                                                                                                        0.998814,
                                                                                                                                                        0.005742,
                                                                                                                                                        0.048347,
                                                                                                                                                        0.998814,
                                                                                                                                                        0.017938,
                                                                                                                                                        0.045229,
                                                                                                                                                        0.998816,
                                                                                                                                                        0.017099,
                                                                                                                                                        0.143032,
                                                                                                                                                        0.98957,
                                                                                                                                                        0.005742,
                                                                                                                                                        0.048347,
                                                                                                                                                        0.998814,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.017938,
                                                                                                                                                        0.045229,
                                                                                                                                                        0.998816,
                                                                                                                                                        0.017938,
                                                                                                                                                        0.045229,
                                                                                                                                                        0.998816,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.028912,
                                                                                                                                                        0.039061,
                                                                                                                                                        0.998818,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.028912,
                                                                                                                                                        0.039061,
                                                                                                                                                        0.998818,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.029795, -0.037448,
                                                                                                                                                        0.998854,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.018967, -0.043868,
                                                                                                                                                        0.998857,
                                                                                                                                                        0.029795, -0.037448,
                                                                                                                                                        0.998854,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.018967, -0.043868,
                                                                                                                                                        0.998857,
                                                                                                                                                        0.056479, -0.13156,
                                                                                                                                                        0.989698,
                                                                                                                                                        0.029795, -0.037448,
                                                                                                                                                        0.998854,
                                                                                                                                                        0.056479, -0.13156,
                                                                                                                                                        0.989698,
                                                                                                                                                        0.018967, -0.043868,
                                                                                                                                                        0.998857,
                                                                                                                                                        0.020384, -0.14168,
                                                                                                                                                        0.989703,
                                                                                                                                                        0.006845, -0.047266,
                                                                                                                                                        0.998859,
                                                                                                                                                        0.020384, -0.14168,
                                                                                                                                                        0.989703,
                                                                                                                                                        0.018967, -0.043868,
                                                                                                                                                        0.998857,
                                                                                                                                                        0.020384, -0.14168,
                                                                                                                                                        0.989703,
                                                                                                                                                        0.006845, -0.047266,
                                                                                                                                                        0.998859, -0.0171, -0.142112,
                                                                                                                                                        0.989703, -0.0171, -0.142112,
                                                                                                                                                        0.989703, -0.033597, -0.279678,
                                                                                                                                                        0.959506,
                                                                                                                                                        0.020384, -0.14168,
                                                                                                                                                        0.989703, -0.0171, -0.142112,
                                                                                                                                                        0.989703, -0.053418, -0.132828,
                                                                                                                                                        0.989699, -0.033597, -0.279678,
                                                                                                                                                        0.959506, -0.053418, -0.132828,
                                                                                                                                                        0.989699, -0.0171, -0.142112,
                                                                                                                                                        0.989703, -0.017939, -0.044294,
                                                                                                                                                        0.998857, -0.104954, -0.261437,
                                                                                                                                                        0.959498, -0.033597, -0.279678,
                                                                                                                                                        0.959506, -0.053418, -0.132828,
                                                                                                                                                        0.989699, -0.033597, -0.279678,
                                                                                                                                                        0.959506, -0.104954, -0.261437,
                                                                                                                                                        0.959498, -0.048989, -0.408039,
                                                                                                                                                        0.911649, -0.153038, -0.38144,
                                                                                                                                                        0.911638, -0.048989, -0.408039,
                                                                                                                                                        0.911649, -0.104954, -0.261437,
                                                                                                                                                        0.959498, -0.048989, -0.408039,
                                                                                                                                                        0.911649, -0.153038, -0.38144,
                                                                                                                                                        0.911638, -0.062913, -0.524166,
                                                                                                                                                        0.849289, -0.196535, -0.490006,
                                                                                                                                                        0.849275, -0.062913, -0.524166,
                                                                                                                                                        0.849289, -0.153038, -0.38144,
                                                                                                                                                        0.911638, -0.062913, -0.524166,
                                                                                                                                                        0.849289, -0.196535, -0.490006,
                                                                                                                                                        0.849275, -0.075168, -0.626384,
                                                                                                                                                        0.775882, -0.23482, -0.58557,
                                                                                                                                                        0.775866, -0.075168, -0.626384,
                                                                                                                                                        0.775882, -0.196535, -0.490006,
                                                                                                                                                        0.849275, -0.075168, -0.626384,
                                                                                                                                                        0.775882, -0.23482, -0.58557,
                                                                                                                                                        0.775866, -0.085697, -0.714207,
                                                                                                                                                        0.694669, -0.267709, -0.667676,
                                                                                                                                                        0.694651, -0.085697, -0.714207,
                                                                                                                                                        0.694669, -0.23482, -0.58557,
                                                                                                                                                        0.775866, -0.085697, -0.714207,
                                                                                                                                                        0.694669, -0.267709, -0.667676,
                                                                                                                                                        0.694651, -0.094543, -0.788006,
                                                                                                                                                        0.608365, -0.085697, -0.714207,
                                                                                                                                                        0.694669, -0.094543, -0.788006,
                                                                                                                                                        0.608365,
                                                                                                                                                        0.102158, -0.712039,
                                                                                                                                                        0.694668,
                                                                                                                                                        0.102158, -0.712039,
                                                                                                                                                        0.694668,
                                                                                                                                                        0.089607, -0.624483,
                                                                                                                                                        0.775881, -0.085697, -0.714207,
                                                                                                                                                        0.694669,
                                                                                                                                                        0.089607, -0.624483,
                                                                                                                                                        0.775881,
                                                                                                                                                        0.102158, -0.712039,
                                                                                                                                                        0.694668,
                                                                                                                                                        0.248274, -0.579997,
                                                                                                                                                        0.775863,
                                                                                                                                                        0.283048, -0.661322,
                                                                                                                                                        0.694649,
                                                                                                                                                        0.248274, -0.579997,
                                                                                                                                                        0.775863,
                                                                                                                                                        0.102158, -0.712039,
                                                                                                                                                        0.694668,
                                                                                                                                                        0.248274, -0.579997,
                                                                                                                                                        0.775863,
                                                                                                                                                        0.283048, -0.661322,
                                                                                                                                                        0.694649,
                                                                                                                                                        0.390018, -0.495958,
                                                                                                                                                        0.77583,
                                                                                                                                                        0.444645, -0.565512,
                                                                                                                                                        0.694612,
                                                                                                                                                        0.390018, -0.495958,
                                                                                                                                                        0.77583,
                                                                                                                                                        0.283048, -0.661322,
                                                                                                                                                        0.694649,
                                                                                                                                                        0.390018, -0.495958,
                                                                                                                                                        0.77583,
                                                                                                                                                        0.444645, -0.565512,
                                                                                                                                                        0.694612,
                                                                                                                                                        0.505178, -0.378096,
                                                                                                                                                        0.775783,
                                                                                                                                                        0.505178, -0.378096,
                                                                                                                                                        0.775783,
                                                                                                                                                        0.422816, -0.316359,
                                                                                                                                                        0.849202,
                                                                                                                                                        0.390018, -0.495958,
                                                                                                                                                        0.77583,
                                                                                                                                                        0.422816, -0.316359,
                                                                                                                                                        0.849202,
                                                                                                                                                        0.505178, -0.378096,
                                                                                                                                                        0.775783,
                                                                                                                                                        0.490382, -0.196129,
                                                                                                                                                        0.849152,
                                                                                                                                                        0.585906, -0.234446,
                                                                                                                                                        0.775725,
                                                                                                                                                        0.490382, -0.196129,
                                                                                                                                                        0.849152,
                                                                                                                                                        0.505178, -0.378096,
                                                                                                                                                        0.775783,
                                                                                                                                                        0.490382, -0.196129,
                                                                                                                                                        0.849152,
                                                                                                                                                        0.585906, -0.234446,
                                                                                                                                                        0.775725,
                                                                                                                                                        0.524528, -0.062511,
                                                                                                                                                        0.849095,
                                                                                                                                                        0.524528, -0.062511,
                                                                                                                                                        0.849095,
                                                                                                                                                        0.408442, -0.048559,
                                                                                                                                                        0.911492,
                                                                                                                                                        0.490382, -0.196129,
                                                                                                                                                        0.849152,
                                                                                                                                                        0.524528, -0.062511,
                                                                                                                                                        0.849095,
                                                                                                                                                        0.522926,
                                                                                                                                                        0.075388,
                                                                                                                                                        0.849038,
                                                                                                                                                        0.408442, -0.048559,
                                                                                                                                                        0.911492,
                                                                                                                                                        0.522926,
                                                                                                                                                        0.075388,
                                                                                                                                                        0.849038,
                                                                                                                                                        0.524528, -0.062511,
                                                                                                                                                        0.849095,
                                                                                                                                                        0.624787,
                                                                                                                                                        0.089961,
                                                                                                                                                        0.775596,
                                                                                                                                                        0.624787,
                                                                                                                                                        0.089961,
                                                                                                                                                        0.775596,
                                                                                                                                                        0.580296,
                                                                                                                                                        0.24861,
                                                                                                                                                        0.775532,
                                                                                                                                                        0.522926,
                                                                                                                                                        0.075388,
                                                                                                                                                        0.849038,
                                                                                                                                                        0.580296,
                                                                                                                                                        0.24861,
                                                                                                                                                        0.775532,
                                                                                                                                                        0.624787,
                                                                                                                                                        0.089961,
                                                                                                                                                        0.775596,
                                                                                                                                                        0.661572,
                                                                                                                                                        0.283341,
                                                                                                                                                        0.694291,
                                                                                                                                                        0.661572,
                                                                                                                                                        0.283341,
                                                                                                                                                        0.694291,
                                                                                                                                                        0.565769,
                                                                                                                                                        0.444917,
                                                                                                                                                        0.69423,
                                                                                                                                                        0.580296,
                                                                                                                                                        0.24861,
                                                                                                                                                        0.775532,
                                                                                                                                                        0.496262,
                                                                                                                                                        0.390335,
                                                                                                                                                        0.775476,
                                                                                                                                                        0.580296,
                                                                                                                                                        0.24861,
                                                                                                                                                        0.775532,
                                                                                                                                                        0.565769,
                                                                                                                                                        0.444917,
                                                                                                                                                        0.69423,
                                                                                                                                                        0.580296,
                                                                                                                                                        0.24861,
                                                                                                                                                        0.775532,
                                                                                                                                                        0.496262,
                                                                                                                                                        0.390335,
                                                                                                                                                        0.775476,
                                                                                                                                                        0.485689,
                                                                                                                                                        0.208172,
                                                                                                                                                        0.848982,
                                                                                                                                                        0.415357,
                                                                                                                                                        0.326793,
                                                                                                                                                        0.848932,
                                                                                                                                                        0.485689,
                                                                                                                                                        0.208172,
                                                                                                                                                        0.848982,
                                                                                                                                                        0.496262,
                                                                                                                                                        0.390335,
                                                                                                                                                        0.775476,
                                                                                                                                                        0.485689,
                                                                                                                                                        0.208172,
                                                                                                                                                        0.848982,
                                                                                                                                                        0.415357,
                                                                                                                                                        0.326793,
                                                                                                                                                        0.848932,
                                                                                                                                                        0.378202,
                                                                                                                                                        0.162219,
                                                                                                                                                        0.911399,
                                                                                                                                                        0.323435,
                                                                                                                                                        0.254588,
                                                                                                                                                        0.911359,
                                                                                                                                                        0.378202,
                                                                                                                                                        0.162219,
                                                                                                                                                        0.911399,
                                                                                                                                                        0.415357,
                                                                                                                                                        0.326793,
                                                                                                                                                        0.848932,
                                                                                                                                                        0.378202,
                                                                                                                                                        0.162219,
                                                                                                                                                        0.911399,
                                                                                                                                                        0.323435,
                                                                                                                                                        0.254588,
                                                                                                                                                        0.911359,
                                                                                                                                                        0.259379,
                                                                                                                                                        0.11141,
                                                                                                                                                        0.959328,
                                                                                                                                                        0.221819,
                                                                                                                                                        0.174759,
                                                                                                                                                        0.959299,
                                                                                                                                                        0.259379,
                                                                                                                                                        0.11141,
                                                                                                                                                        0.959328,
                                                                                                                                                        0.323435,
                                                                                                                                                        0.254588,
                                                                                                                                                        0.911359,
                                                                                                                                                        0.259379,
                                                                                                                                                        0.11141,
                                                                                                                                                        0.959328,
                                                                                                                                                        0.221819,
                                                                                                                                                        0.174759,
                                                                                                                                                        0.959299,
                                                                                                                                                        0.132019,
                                                                                                                                                        0.056941,
                                                                                                                                                        0.98961,
                                                                                                                                                        0.112903,
                                                                                                                                                        0.089185,
                                                                                                                                                        0.989595,
                                                                                                                                                        0.132019,
                                                                                                                                                        0.056941,
                                                                                                                                                        0.98961,
                                                                                                                                                        0.221819,
                                                                                                                                                        0.174759,
                                                                                                                                                        0.959299,
                                                                                                                                                        0.132019,
                                                                                                                                                        0.056941,
                                                                                                                                                        0.98961,
                                                                                                                                                        0.112903,
                                                                                                                                                        0.089185,
                                                                                                                                                        0.989595,
                                                                                                                                                        0.044335,
                                                                                                                                                        0.019435,
                                                                                                                                                        0.998828,
                                                                                                                                                        0.037916,
                                                                                                                                                        0.030263,
                                                                                                                                                        0.998823,
                                                                                                                                                        0.044335,
                                                                                                                                                        0.019435,
                                                                                                                                                        0.998828,
                                                                                                                                                        0.112903,
                                                                                                                                                        0.089185,
                                                                                                                                                        0.989595,
                                                                                                                                                        0.037916,
                                                                                                                                                        0.030263,
                                                                                                                                                        0.998823,
                                                                                                                                                        0.038594, -0.028444,
                                                                                                                                                        0.99885,
                                                                                                                                                        0.044335,
                                                                                                                                                        0.019435,
                                                                                                                                                        0.998828,
                                                                                                                                                        0.029795, -0.037448,
                                                                                                                                                        0.998854,
                                                                                                                                                        0.038594, -0.028444,
                                                                                                                                                        0.99885,
                                                                                                                                                        0.037916,
                                                                                                                                                        0.030263,
                                                                                                                                                        0.998823,
                                                                                                                                                        0.029795, -0.037448,
                                                                                                                                                        0.998854,
                                                                                                                                                        0.088725, -0.112443,
                                                                                                                                                        0.989689,
                                                                                                                                                        0.038594, -0.028444,
                                                                                                                                                        0.99885,
                                                                                                                                                        0.088725, -0.112443,
                                                                                                                                                        0.989689,
                                                                                                                                                        0.029795, -0.037448,
                                                                                                                                                        0.998854,
                                                                                                                                                        0.056479, -0.13156,
                                                                                                                                                        0.989698,
                                                                                                                                                        0.056479, -0.13156,
                                                                                                                                                        0.989698,
                                                                                                                                                        0.110968, -0.258946,
                                                                                                                                                        0.959496,
                                                                                                                                                        0.088725, -0.112443,
                                                                                                                                                        0.989689,
                                                                                                                                                        0.110968, -0.258946,
                                                                                                                                                        0.959496,
                                                                                                                                                        0.056479, -0.13156,
                                                                                                                                                        0.989698,
                                                                                                                                                        0.04005, -0.278828,
                                                                                                                                                        0.959505,
                                                                                                                                                        0.020384, -0.14168,
                                                                                                                                                        0.989703,
                                                                                                                                                        0.04005, -0.278828,
                                                                                                                                                        0.959505,
                                                                                                                                                        0.056479, -0.13156,
                                                                                                                                                        0.989698,
                                                                                                                                                        0.04005, -0.278828,
                                                                                                                                                        0.959505,
                                                                                                                                                        0.020384, -0.14168,
                                                                                                                                                        0.989703, -0.033597, -0.279678,
                                                                                                                                                        0.959506, -0.033597, -0.279678,
                                                                                                                                                        0.959506, -0.048989, -0.408039,
                                                                                                                                                        0.911649,
                                                                                                                                                        0.04005, -0.278828,
                                                                                                                                                        0.959505,
                                                                                                                                                        0.058399, -0.4068,
                                                                                                                                                        0.911649,
                                                                                                                                                        0.04005, -0.278828,
                                                                                                                                                        0.959505, -0.048989, -0.408039,
                                                                                                                                                        0.911649,
                                                                                                                                                        0.04005, -0.278828,
                                                                                                                                                        0.959505,
                                                                                                                                                        0.058399, -0.4068,
                                                                                                                                                        0.911649,
                                                                                                                                                        0.110968, -0.258946,
                                                                                                                                                        0.959496,
                                                                                                                                                        0.161806, -0.377807,
                                                                                                                                                        0.911636,
                                                                                                                                                        0.110968, -0.258946,
                                                                                                                                                        0.959496,
                                                                                                                                                        0.058399, -0.4068,
                                                                                                                                                        0.911649,
                                                                                                                                                        0.110968, -0.258946,
                                                                                                                                                        0.959496,
                                                                                                                                                        0.161806, -0.377807,
                                                                                                                                                        0.911636,
                                                                                                                                                        0.174322, -0.221385,
                                                                                                                                                        0.959479,
                                                                                                                                                        0.254185, -0.323038,
                                                                                                                                                        0.911612,
                                                                                                                                                        0.174322, -0.221385,
                                                                                                                                                        0.959479,
                                                                                                                                                        0.161806, -0.377807,
                                                                                                                                                        0.911636,
                                                                                                                                                        0.174322, -0.221385,
                                                                                                                                                        0.959479,
                                                                                                                                                        0.254185, -0.323038,
                                                                                                                                                        0.911612,
                                                                                                                                                        0.225795, -0.168707,
                                                                                                                                                        0.959455,
                                                                                                                                                        0.329239, -0.246225,
                                                                                                                                                        0.911578,
                                                                                                                                                        0.225795, -0.168707,
                                                                                                                                                        0.959455,
                                                                                                                                                        0.254185, -0.323038,
                                                                                                                                                        0.911612,
                                                                                                                                                        0.225795, -0.168707,
                                                                                                                                                        0.959455,
                                                                                                                                                        0.329239, -0.246225,
                                                                                                                                                        0.911578,
                                                                                                                                                        0.261879, -0.104502,
                                                                                                                                                        0.959426,
                                                                                                                                                        0.381853, -0.152605,
                                                                                                                                                        0.911537,
                                                                                                                                                        0.261879, -0.104502,
                                                                                                                                                        0.959426,
                                                                                                                                                        0.329239, -0.246225,
                                                                                                                                                        0.911578,
                                                                                                                                                        0.261879, -0.104502,
                                                                                                                                                        0.959426,
                                                                                                                                                        0.381853, -0.152605,
                                                                                                                                                        0.911537,
                                                                                                                                                        0.280116, -0.033146,
                                                                                                                                                        0.959394,
                                                                                                                                                        0.408442, -0.048559,
                                                                                                                                                        0.911492,
                                                                                                                                                        0.280116, -0.033146,
                                                                                                                                                        0.959394,
                                                                                                                                                        0.381853, -0.152605,
                                                                                                                                                        0.911537,
                                                                                                                                                        0.408442, -0.048559,
                                                                                                                                                        0.911492,
                                                                                                                                                        0.407197,
                                                                                                                                                        0.058821,
                                                                                                                                                        0.911444,
                                                                                                                                                        0.280116, -0.033146,
                                                                                                                                                        0.959394,
                                                                                                                                                        0.407197,
                                                                                                                                                        0.058821,
                                                                                                                                                        0.911444,
                                                                                                                                                        0.408442, -0.048559,
                                                                                                                                                        0.911492,
                                                                                                                                                        0.522926,
                                                                                                                                                        0.075388,
                                                                                                                                                        0.849038,
                                                                                                                                                        0.522926,
                                                                                                                                                        0.075388,
                                                                                                                                                        0.849038,
                                                                                                                                                        0.485689,
                                                                                                                                                        0.208172,
                                                                                                                                                        0.848982,
                                                                                                                                                        0.407197,
                                                                                                                                                        0.058821,
                                                                                                                                                        0.911444,
                                                                                                                                                        0.485689,
                                                                                                                                                        0.208172,
                                                                                                                                                        0.848982,
                                                                                                                                                        0.522926,
                                                                                                                                                        0.075388,
                                                                                                                                                        0.849038,
                                                                                                                                                        0.580296,
                                                                                                                                                        0.24861,
                                                                                                                                                        0.775532,
                                                                                                                                                        0.378202,
                                                                                                                                                        0.162219,
                                                                                                                                                        0.911399,
                                                                                                                                                        0.407197,
                                                                                                                                                        0.058821,
                                                                                                                                                        0.911444,
                                                                                                                                                        0.485689,
                                                                                                                                                        0.208172,
                                                                                                                                                        0.848982,
                                                                                                                                                        0.407197,
                                                                                                                                                        0.058821,
                                                                                                                                                        0.911444,
                                                                                                                                                        0.378202,
                                                                                                                                                        0.162219,
                                                                                                                                                        0.911399,
                                                                                                                                                        0.279263,
                                                                                                                                                        0.040498,
                                                                                                                                                        0.95936,
                                                                                                                                                        0.259379,
                                                                                                                                                        0.11141,
                                                                                                                                                        0.959328,
                                                                                                                                                        0.279263,
                                                                                                                                                        0.040498,
                                                                                                                                                        0.95936,
                                                                                                                                                        0.378202,
                                                                                                                                                        0.162219,
                                                                                                                                                        0.911399,
                                                                                                                                                        0.279263,
                                                                                                                                                        0.040498,
                                                                                                                                                        0.95936,
                                                                                                                                                        0.259379,
                                                                                                                                                        0.11141,
                                                                                                                                                        0.959328,
                                                                                                                                                        0.142139,
                                                                                                                                                        0.020848,
                                                                                                                                                        0.989627,
                                                                                                                                                        0.132019,
                                                                                                                                                        0.056941,
                                                                                                                                                        0.98961,
                                                                                                                                                        0.142139,
                                                                                                                                                        0.020848,
                                                                                                                                                        0.989627,
                                                                                                                                                        0.259379,
                                                                                                                                                        0.11141,
                                                                                                                                                        0.959328,
                                                                                                                                                        0.142139,
                                                                                                                                                        0.020848,
                                                                                                                                                        0.989627,
                                                                                                                                                        0.132019,
                                                                                                                                                        0.056941,
                                                                                                                                                        0.98961,
                                                                                                                                                        0.047734,
                                                                                                                                                        0.007314,
                                                                                                                                                        0.998833,
                                                                                                                                                        0.044335,
                                                                                                                                                        0.019435,
                                                                                                                                                        0.998828,
                                                                                                                                                        0.047734,
                                                                                                                                                        0.007314,
                                                                                                                                                        0.998833,
                                                                                                                                                        0.132019,
                                                                                                                                                        0.056941,
                                                                                                                                                        0.98961,
                                                                                                                                                        0.044335,
                                                                                                                                                        0.019435,
                                                                                                                                                        0.998828,
                                                                                                                                                        0.044762, -0.01747,
                                                                                                                                                        0.998845,
                                                                                                                                                        0.047734,
                                                                                                                                                        0.007314,
                                                                                                                                                        0.998833,
                                                                                                                                                        0.038594, -0.028444,
                                                                                                                                                        0.99885,
                                                                                                                                                        0.044762, -0.01747,
                                                                                                                                                        0.998845,
                                                                                                                                                        0.044335,
                                                                                                                                                        0.019435,
                                                                                                                                                        0.998828,
                                                                                                                                                        0.038594, -0.028444,
                                                                                                                                                        0.99885,
                                                                                                                                                        0.114923, -0.085632,
                                                                                                                                                        0.989677,
                                                                                                                                                        0.044762, -0.01747,
                                                                                                                                                        0.998845,
                                                                                                                                                        0.114923, -0.085632,
                                                                                                                                                        0.989677,
                                                                                                                                                        0.038594, -0.028444,
                                                                                                                                                        0.99885,
                                                                                                                                                        0.088725, -0.112443,
                                                                                                                                                        0.989689,
                                                                                                                                                        0.088725, -0.112443,
                                                                                                                                                        0.989689,
                                                                                                                                                        0.174322, -0.221385,
                                                                                                                                                        0.959479,
                                                                                                                                                        0.114923, -0.085632,
                                                                                                                                                        0.989677,
                                                                                                                                                        0.174322, -0.221385,
                                                                                                                                                        0.959479,
                                                                                                                                                        0.088725, -0.112443,
                                                                                                                                                        0.989689,
                                                                                                                                                        0.110968, -0.258946,
                                                                                                                                                        0.959496,
                                                                                                                                                        0.225795, -0.168707,
                                                                                                                                                        0.959455,
                                                                                                                                                        0.114923, -0.085632,
                                                                                                                                                        0.989677,
                                                                                                                                                        0.174322, -0.221385,
                                                                                                                                                        0.959479,
                                                                                                                                                        0.114923, -0.085632,
                                                                                                                                                        0.989677,
                                                                                                                                                        0.225795, -0.168707,
                                                                                                                                                        0.959455,
                                                                                                                                                        0.13329, -0.052954,
                                                                                                                                                        0.989661,
                                                                                                                                                        0.261879, -0.104502,
                                                                                                                                                        0.959426,
                                                                                                                                                        0.13329, -0.052954,
                                                                                                                                                        0.989661,
                                                                                                                                                        0.225795, -0.168707,
                                                                                                                                                        0.959455,
                                                                                                                                                        0.13329, -0.052954,
                                                                                                                                                        0.989661,
                                                                                                                                                        0.261879, -0.104502,
                                                                                                                                                        0.959426,
                                                                                                                                                        0.142573, -0.016635,
                                                                                                                                                        0.989645,
                                                                                                                                                        0.280116, -0.033146,
                                                                                                                                                        0.959394,
                                                                                                                                                        0.142573, -0.016635,
                                                                                                                                                        0.989645,
                                                                                                                                                        0.261879, -0.104502,
                                                                                                                                                        0.959426,
                                                                                                                                                        0.280116, -0.033146,
                                                                                                                                                        0.959394,
                                                                                                                                                        0.279263,
                                                                                                                                                        0.040498,
                                                                                                                                                        0.95936,
                                                                                                                                                        0.142573, -0.016635,
                                                                                                                                                        0.989645,
                                                                                                                                                        0.279263,
                                                                                                                                                        0.040498,
                                                                                                                                                        0.95936,
                                                                                                                                                        0.280116, -0.033146,
                                                                                                                                                        0.959394,
                                                                                                                                                        0.407197,
                                                                                                                                                        0.058821,
                                                                                                                                                        0.911444,
                                                                                                                                                        0.142139,
                                                                                                                                                        0.020848,
                                                                                                                                                        0.989627,
                                                                                                                                                        0.142573, -0.016635,
                                                                                                                                                        0.989645,
                                                                                                                                                        0.279263,
                                                                                                                                                        0.040498,
                                                                                                                                                        0.95936,
                                                                                                                                                        0.142573, -0.016635,
                                                                                                                                                        0.989645,
                                                                                                                                                        0.142139,
                                                                                                                                                        0.020848,
                                                                                                                                                        0.989627,
                                                                                                                                                        0.047879, -0.005274,
                                                                                                                                                        0.998839,
                                                                                                                                                        0.047734,
                                                                                                                                                        0.007314,
                                                                                                                                                        0.998833,
                                                                                                                                                        0.047879, -0.005274,
                                                                                                                                                        0.998839,
                                                                                                                                                        0.142139,
                                                                                                                                                        0.020848,
                                                                                                                                                        0.989627,
                                                                                                                                                        0.047879, -0.005274,
                                                                                                                                                        0.998839,
                                                                                                                                                        0.047734,
                                                                                                                                                        0.007314,
                                                                                                                                                        0.998833,
                                                                                                                                                        0.044762, -0.01747,
                                                                                                                                                        0.998845,
                                                                                                                                                        0.044762, -0.01747,
                                                                                                                                                        0.998845,
                                                                                                                                                        0.13329, -0.052954,
                                                                                                                                                        0.989661,
                                                                                                                                                        0.047879, -0.005274,
                                                                                                                                                        0.998839,
                                                                                                                                                        0.13329, -0.052954,
                                                                                                                                                        0.989661,
                                                                                                                                                        0.044762, -0.01747,
                                                                                                                                                        0.998845,
                                                                                                                                                        0.114923, -0.085632,
                                                                                                                                                        0.989677,
                                                                                                                                                        0.142573, -0.016635,
                                                                                                                                                        0.989645,
                                                                                                                                                        0.047879, -0.005274,
                                                                                                                                                        0.998839,
                                                                                                                                                        0.13329, -0.052954,
                                                                                                                                                        0.989661,
                                                                                                                                                        0.381853, -0.152605,
                                                                                                                                                        0.911537,
                                                                                                                                                        0.490382, -0.196129,
                                                                                                                                                        0.849152,
                                                                                                                                                        0.408442, -0.048559,
                                                                                                                                                        0.911492,
                                                                                                                                                        0.490382, -0.196129,
                                                                                                                                                        0.849152,
                                                                                                                                                        0.381853, -0.152605,
                                                                                                                                                        0.911537,
                                                                                                                                                        0.422816, -0.316359,
                                                                                                                                                        0.849202,
                                                                                                                                                        0.329239, -0.246225,
                                                                                                                                                        0.911578,
                                                                                                                                                        0.422816, -0.316359,
                                                                                                                                                        0.849202,
                                                                                                                                                        0.381853, -0.152605,
                                                                                                                                                        0.911537,
                                                                                                                                                        0.422816, -0.316359,
                                                                                                                                                        0.849202,
                                                                                                                                                        0.329239, -0.246225,
                                                                                                                                                        0.911578,
                                                                                                                                                        0.326431, -0.415004,
                                                                                                                                                        0.849244,
                                                                                                                                                        0.254185, -0.323038,
                                                                                                                                                        0.911612,
                                                                                                                                                        0.326431, -0.415004,
                                                                                                                                                        0.849244,
                                                                                                                                                        0.329239, -0.246225,
                                                                                                                                                        0.911578,
                                                                                                                                                        0.326431, -0.415004,
                                                                                                                                                        0.849244,
                                                                                                                                                        0.254185, -0.323038,
                                                                                                                                                        0.911612,
                                                                                                                                                        0.207796, -0.485341,
                                                                                                                                                        0.849273,
                                                                                                                                                        0.161806, -0.377807,
                                                                                                                                                        0.911636,
                                                                                                                                                        0.207796, -0.485341,
                                                                                                                                                        0.849273,
                                                                                                                                                        0.254185, -0.323038,
                                                                                                                                                        0.911612,
                                                                                                                                                        0.207796, -0.485341,
                                                                                                                                                        0.849273,
                                                                                                                                                        0.161806, -0.377807,
                                                                                                                                                        0.911636,
                                                                                                                                                        0.074998, -0.522574,
                                                                                                                                                        0.849289,
                                                                                                                                                        0.058399, -0.4068,
                                                                                                                                                        0.911649,
                                                                                                                                                        0.074998, -0.522574,
                                                                                                                                                        0.849289,
                                                                                                                                                        0.161806, -0.377807,
                                                                                                                                                        0.911636,
                                                                                                                                                        0.074998, -0.522574,
                                                                                                                                                        0.849289,
                                                                                                                                                        0.058399, -0.4068,
                                                                                                                                                        0.911649, -0.062913, -0.524166,
                                                                                                                                                        0.849289, -0.048989, -0.408039,
                                                                                                                                                        0.911649, -0.062913, -0.524166,
                                                                                                                                                        0.849289,
                                                                                                                                                        0.058399, -0.4068,
                                                                                                                                                        0.911649, -0.062913, -0.524166,
                                                                                                                                                        0.849289, -0.075168, -0.626384,
                                                                                                                                                        0.775882,
                                                                                                                                                        0.074998, -0.522574,
                                                                                                                                                        0.849289,
                                                                                                                                                        0.089607, -0.624483,
                                                                                                                                                        0.775881,
                                                                                                                                                        0.074998, -0.522574,
                                                                                                                                                        0.849289, -0.075168, -0.626384,
                                                                                                                                                        0.775882,
                                                                                                                                                        0.074998, -0.522574,
                                                                                                                                                        0.849289,
                                                                                                                                                        0.089607, -0.624483,
                                                                                                                                                        0.775881,
                                                                                                                                                        0.207796, -0.485341,
                                                                                                                                                        0.849273,
                                                                                                                                                        0.248274, -0.579997,
                                                                                                                                                        0.775863,
                                                                                                                                                        0.207796, -0.485341,
                                                                                                                                                        0.849273,
                                                                                                                                                        0.089607, -0.624483,
                                                                                                                                                        0.775881,
                                                                                                                                                        0.207796, -0.485341,
                                                                                                                                                        0.849273,
                                                                                                                                                        0.248274, -0.579997,
                                                                                                                                                        0.775863,
                                                                                                                                                        0.326431, -0.415004,
                                                                                                                                                        0.849244,
                                                                                                                                                        0.390018, -0.495958,
                                                                                                                                                        0.77583,
                                                                                                                                                        0.326431, -0.415004,
                                                                                                                                                        0.849244,
                                                                                                                                                        0.248274, -0.579997,
                                                                                                                                                        0.775863,
                                                                                                                                                        0.326431, -0.415004,
                                                                                                                                                        0.849244,
                                                                                                                                                        0.390018, -0.495958,
                                                                                                                                                        0.77583,
                                                                                                                                                        0.422816, -0.316359,
                                                                                                                                                        0.849202, -0.075168, -0.626384,
                                                                                                                                                        0.775882, -0.085697, -0.714207,
                                                                                                                                                        0.694669,
                                                                                                                                                        0.089607, -0.624483,
                                                                                                                                                        0.775881,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.029795, -0.037448,
                                                                                                                                                        0.998854,
                                                                                                                                                        0.037916,
                                                                                                                                                        0.030263,
                                                                                                                                                        0.998823,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.037916,
                                                                                                                                                        0.030263,
                                                                                                                                                        0.998823,
                                                                                                                                                        0.037916,
                                                                                                                                                        0.030263,
                                                                                                                                                        0.998823,
                                                                                                                                                        0.028912,
                                                                                                                                                        0.039061,
                                                                                                                                                        0.998818,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.028912,
                                                                                                                                                        0.039061,
                                                                                                                                                        0.998818,
                                                                                                                                                        0.037916,
                                                                                                                                                        0.030263,
                                                                                                                                                        0.998823,
                                                                                                                                                        0.086092,
                                                                                                                                                        0.115382,
                                                                                                                                                        0.989583,
                                                                                                                                                        0.112903,
                                                                                                                                                        0.089185,
                                                                                                                                                        0.989595,
                                                                                                                                                        0.086092,
                                                                                                                                                        0.115382,
                                                                                                                                                        0.989583,
                                                                                                                                                        0.037916,
                                                                                                                                                        0.030263,
                                                                                                                                                        0.998823,
                                                                                                                                                        0.086092,
                                                                                                                                                        0.115382,
                                                                                                                                                        0.989583,
                                                                                                                                                        0.112903,
                                                                                                                                                        0.089185,
                                                                                                                                                        0.989595,
                                                                                                                                                        0.169145,
                                                                                                                                                        0.226229,
                                                                                                                                                        0.959276,
                                                                                                                                                        0.221819,
                                                                                                                                                        0.174759,
                                                                                                                                                        0.959299,
                                                                                                                                                        0.169145,
                                                                                                                                                        0.226229,
                                                                                                                                                        0.959276,
                                                                                                                                                        0.112903,
                                                                                                                                                        0.089185,
                                                                                                                                                        0.989595,
                                                                                                                                                        0.169145,
                                                                                                                                                        0.226229,
                                                                                                                                                        0.959276,
                                                                                                                                                        0.221819,
                                                                                                                                                        0.174759,
                                                                                                                                                        0.959299,
                                                                                                                                                        0.24663,
                                                                                                                                                        0.329635,
                                                                                                                                                        0.911326,
                                                                                                                                                        0.323435,
                                                                                                                                                        0.254588,
                                                                                                                                                        0.911359,
                                                                                                                                                        0.24663,
                                                                                                                                                        0.329635,
                                                                                                                                                        0.911326,
                                                                                                                                                        0.221819,
                                                                                                                                                        0.174759,
                                                                                                                                                        0.959299,
                                                                                                                                                        0.24663,
                                                                                                                                                        0.329635,
                                                                                                                                                        0.911326,
                                                                                                                                                        0.323435,
                                                                                                                                                        0.254588,
                                                                                                                                                        0.911359,
                                                                                                                                                        0.316722,
                                                                                                                                                        0.423167,
                                                                                                                                                        0.848891,
                                                                                                                                                        0.415357,
                                                                                                                                                        0.326793,
                                                                                                                                                        0.848932,
                                                                                                                                                        0.316722,
                                                                                                                                                        0.423167,
                                                                                                                                                        0.848891,
                                                                                                                                                        0.323435,
                                                                                                                                                        0.254588,
                                                                                                                                                        0.911359,
                                                                                                                                                        0.316722,
                                                                                                                                                        0.423167,
                                                                                                                                                        0.848891,
                                                                                                                                                        0.415357,
                                                                                                                                                        0.326793,
                                                                                                                                                        0.848932,
                                                                                                                                                        0.378414,
                                                                                                                                                        0.505481,
                                                                                                                                                        0.77543,
                                                                                                                                                        0.496262,
                                                                                                                                                        0.390335,
                                                                                                                                                        0.775476,
                                                                                                                                                        0.378414,
                                                                                                                                                        0.505481,
                                                                                                                                                        0.77543,
                                                                                                                                                        0.415357,
                                                                                                                                                        0.326793,
                                                                                                                                                        0.848932,
                                                                                                                                                        0.378414,
                                                                                                                                                        0.505481,
                                                                                                                                                        0.77543,
                                                                                                                                                        0.496262,
                                                                                                                                                        0.390335,
                                                                                                                                                        0.775476,
                                                                                                                                                        0.431415,
                                                                                                                                                        0.57619,
                                                                                                                                                        0.69418,
                                                                                                                                                        0.565769,
                                                                                                                                                        0.444917,
                                                                                                                                                        0.69423,
                                                                                                                                                        0.431415,
                                                                                                                                                        0.57619,
                                                                                                                                                        0.69418,
                                                                                                                                                        0.496262,
                                                                                                                                                        0.390335,
                                                                                                                                                        0.775476,
                                                                                                                                                        0.431415,
                                                                                                                                                        0.57619,
                                                                                                                                                        0.69418,
                                                                                                                                                        0.565769,
                                                                                                                                                        0.444917,
                                                                                                                                                        0.69423,
                                                                                                                                                        0.475951,
                                                                                                                                                        0.635598,
                                                                                                                                                        0.607853,
                                                                                                                                                        0.431415,
                                                                                                                                                        0.57619,
                                                                                                                                                        0.69418,
                                                                                                                                                        0.475951,
                                                                                                                                                        0.635598,
                                                                                                                                                        0.607853,
                                                                                                                                                        0.267667,
                                                                                                                                                        0.668219,
                                                                                                                                                        0.694145,
                                                                                                                                                        0.295299,
                                                                                                                                                        0.737128,
                                                                                                                                                        0.607817,
                                                                                                                                                        0.267667,
                                                                                                                                                        0.668219,
                                                                                                                                                        0.694145,
                                                                                                                                                        0.475951,
                                                                                                                                                        0.635598,
                                                                                                                                                        0.607853,
                                                                                                                                                        0.267667,
                                                                                                                                                        0.668219,
                                                                                                                                                        0.694145,
                                                                                                                                                        0.295299,
                                                                                                                                                        0.737128,
                                                                                                                                                        0.607817,
                                                                                                                                                        0.085682,
                                                                                                                                                        0.714735,
                                                                                                                                                        0.694127,
                                                                                                                                                        0.094527,
                                                                                                                                                        0.788445,
                                                                                                                                                        0.607798,
                                                                                                                                                        0.085682,
                                                                                                                                                        0.714735,
                                                                                                                                                        0.694127,
                                                                                                                                                        0.295299,
                                                                                                                                                        0.737128,
                                                                                                                                                        0.607817,
                                                                                                                                                        0.295299,
                                                                                                                                                        0.737128,
                                                                                                                                                        0.607817,
                                                                                                                                                        0.31801,
                                                                                                                                                        0.793755,
                                                                                                                                                        0.518481,
                                                                                                                                                        0.094527,
                                                                                                                                                        0.788445,
                                                                                                                                                        0.607798,
                                                                                                                                                        0.31801,
                                                                                                                                                        0.793755,
                                                                                                                                                        0.518481,
                                                                                                                                                        0.295299,
                                                                                                                                                        0.737128,
                                                                                                                                                        0.607817,
                                                                                                                                                        0.512555,
                                                                                                                                                        0.684416,
                                                                                                                                                        0.518519,
                                                                                                                                                        0.475951,
                                                                                                                                                        0.635598,
                                                                                                                                                        0.607853,
                                                                                                                                                        0.512555,
                                                                                                                                                        0.684416,
                                                                                                                                                        0.518519,
                                                                                                                                                        0.295299,
                                                                                                                                                        0.737128,
                                                                                                                                                        0.607817,
                                                                                                                                                        0.512555,
                                                                                                                                                        0.684416,
                                                                                                                                                        0.518519,
                                                                                                                                                        0.475951,
                                                                                                                                                        0.635598,
                                                                                                                                                        0.607853,
                                                                                                                                                        0.672177,
                                                                                                                                                        0.528452,
                                                                                                                                                        0.518572,
                                                                                                                                                        0.101797,
                                                                                                                                                        0.849019,
                                                                                                                                                        0.518463,
                                                                                                                                                        0.094527,
                                                                                                                                                        0.788445,
                                                                                                                                                        0.607798,
                                                                                                                                                        0.31801,
                                                                                                                                                        0.793755,
                                                                                                                                                        0.518481,
                                                                                                                                                        0.267667,
                                                                                                                                                        0.668219,
                                                                                                                                                        0.694145,
                                                                                                                                                        0.085682,
                                                                                                                                                        0.714735,
                                                                                                                                                        0.694127,
                                                                                                                                                        0.234783,
                                                                                                                                                        0.586204,
                                                                                                                                                        0.775397,
                                                                                                                                                        0.075156,
                                                                                                                                                        0.627005,
                                                                                                                                                        0.775381,
                                                                                                                                                        0.234783,
                                                                                                                                                        0.586204,
                                                                                                                                                        0.775397,
                                                                                                                                                        0.085682,
                                                                                                                                                        0.714735,
                                                                                                                                                        0.694127,
                                                                                                                                                        0.234783,
                                                                                                                                                        0.586204,
                                                                                                                                                        0.775397,
                                                                                                                                                        0.075156,
                                                                                                                                                        0.627005,
                                                                                                                                                        0.775381,
                                                                                                                                                        0.196507,
                                                                                                                                                        0.490731,
                                                                                                                                                        0.848863,
                                                                                                                                                        0.062903,
                                                                                                                                                        0.52488,
                                                                                                                                                        0.848849,
                                                                                                                                                        0.196507,
                                                                                                                                                        0.490731,
                                                                                                                                                        0.848863,
                                                                                                                                                        0.075156,
                                                                                                                                                        0.627005,
                                                                                                                                                        0.775381,
                                                                                                                                                        0.196507,
                                                                                                                                                        0.490731,
                                                                                                                                                        0.848863,
                                                                                                                                                        0.062903,
                                                                                                                                                        0.52488,
                                                                                                                                                        0.848849,
                                                                                                                                                        0.153019,
                                                                                                                                                        0.382247,
                                                                                                                                                        0.911302,
                                                                                                                                                        0.048983,
                                                                                                                                                        0.408839,
                                                                                                                                                        0.911291,
                                                                                                                                                        0.153019,
                                                                                                                                                        0.382247,
                                                                                                                                                        0.911302,
                                                                                                                                                        0.062903,
                                                                                                                                                        0.52488,
                                                                                                                                                        0.848849,
                                                                                                                                                        0.153019,
                                                                                                                                                        0.382247,
                                                                                                                                                        0.911302,
                                                                                                                                                        0.048983,
                                                                                                                                                        0.408839,
                                                                                                                                                        0.911291,
                                                                                                                                                        0.104945,
                                                                                                                                                        0.262312,
                                                                                                                                                        0.95926,
                                                                                                                                                        0.033594,
                                                                                                                                                        0.28055,
                                                                                                                                                        0.959251,
                                                                                                                                                        0.104945,
                                                                                                                                                        0.262312,
                                                                                                                                                        0.95926,
                                                                                                                                                        0.048983,
                                                                                                                                                        0.408839,
                                                                                                                                                        0.911291,
                                                                                                                                                        0.104945,
                                                                                                                                                        0.262312,
                                                                                                                                                        0.95926,
                                                                                                                                                        0.033594,
                                                                                                                                                        0.28055,
                                                                                                                                                        0.959251,
                                                                                                                                                        0.053415,
                                                                                                                                                        0.133749,
                                                                                                                                                        0.989575,
                                                                                                                                                        0.017099,
                                                                                                                                                        0.143032,
                                                                                                                                                        0.98957,
                                                                                                                                                        0.053415,
                                                                                                                                                        0.133749,
                                                                                                                                                        0.989575,
                                                                                                                                                        0.033594,
                                                                                                                                                        0.28055,
                                                                                                                                                        0.959251,
                                                                                                                                                        0.053415,
                                                                                                                                                        0.133749,
                                                                                                                                                        0.989575,
                                                                                                                                                        0.017099,
                                                                                                                                                        0.143032,
                                                                                                                                                        0.98957,
                                                                                                                                                        0.017938,
                                                                                                                                                        0.045229,
                                                                                                                                                        0.998816,
                                                                                                                                                        0.017938,
                                                                                                                                                        0.045229,
                                                                                                                                                        0.998816,
                                                                                                                                                        0.028912,
                                                                                                                                                        0.039061,
                                                                                                                                                        0.998818,
                                                                                                                                                        0.053415,
                                                                                                                                                        0.133749,
                                                                                                                                                        0.989575,
                                                                                                                                                        0.086092,
                                                                                                                                                        0.115382,
                                                                                                                                                        0.989583,
                                                                                                                                                        0.053415,
                                                                                                                                                        0.133749,
                                                                                                                                                        0.989575,
                                                                                                                                                        0.028912,
                                                                                                                                                        0.039061,
                                                                                                                                                        0.998818,
                                                                                                                                                        0.053415,
                                                                                                                                                        0.133749,
                                                                                                                                                        0.989575,
                                                                                                                                                        0.086092,
                                                                                                                                                        0.115382,
                                                                                                                                                        0.989583,
                                                                                                                                                        0.104945,
                                                                                                                                                        0.262312,
                                                                                                                                                        0.95926,
                                                                                                                                                        0.169145,
                                                                                                                                                        0.226229,
                                                                                                                                                        0.959276,
                                                                                                                                                        0.104945,
                                                                                                                                                        0.262312,
                                                                                                                                                        0.95926,
                                                                                                                                                        0.086092,
                                                                                                                                                        0.115382,
                                                                                                                                                        0.989583,
                                                                                                                                                        0.104945,
                                                                                                                                                        0.262312,
                                                                                                                                                        0.95926,
                                                                                                                                                        0.169145,
                                                                                                                                                        0.226229,
                                                                                                                                                        0.959276,
                                                                                                                                                        0.153019,
                                                                                                                                                        0.382247,
                                                                                                                                                        0.911302,
                                                                                                                                                        0.24663,
                                                                                                                                                        0.329635,
                                                                                                                                                        0.911326,
                                                                                                                                                        0.153019,
                                                                                                                                                        0.382247,
                                                                                                                                                        0.911302,
                                                                                                                                                        0.169145,
                                                                                                                                                        0.226229,
                                                                                                                                                        0.959276,
                                                                                                                                                        0.153019,
                                                                                                                                                        0.382247,
                                                                                                                                                        0.911302,
                                                                                                                                                        0.24663,
                                                                                                                                                        0.329635,
                                                                                                                                                        0.911326,
                                                                                                                                                        0.196507,
                                                                                                                                                        0.490731,
                                                                                                                                                        0.848863,
                                                                                                                                                        0.316722,
                                                                                                                                                        0.423167,
                                                                                                                                                        0.848891,
                                                                                                                                                        0.196507,
                                                                                                                                                        0.490731,
                                                                                                                                                        0.848863,
                                                                                                                                                        0.24663,
                                                                                                                                                        0.329635,
                                                                                                                                                        0.911326,
                                                                                                                                                        0.196507,
                                                                                                                                                        0.490731,
                                                                                                                                                        0.848863,
                                                                                                                                                        0.316722,
                                                                                                                                                        0.423167,
                                                                                                                                                        0.848891,
                                                                                                                                                        0.234783,
                                                                                                                                                        0.586204,
                                                                                                                                                        0.775397,
                                                                                                                                                        0.378414,
                                                                                                                                                        0.505481,
                                                                                                                                                        0.77543,
                                                                                                                                                        0.234783,
                                                                                                                                                        0.586204,
                                                                                                                                                        0.775397,
                                                                                                                                                        0.316722,
                                                                                                                                                        0.423167,
                                                                                                                                                        0.848891,
                                                                                                                                                        0.234783,
                                                                                                                                                        0.586204,
                                                                                                                                                        0.775397,
                                                                                                                                                        0.378414,
                                                                                                                                                        0.505481,
                                                                                                                                                        0.77543,
                                                                                                                                                        0.267667,
                                                                                                                                                        0.668219,
                                                                                                                                                        0.694145,
                                                                                                                                                        0.431415,
                                                                                                                                                        0.57619,
                                                                                                                                                        0.69418,
                                                                                                                                                        0.267667,
                                                                                                                                                        0.668219,
                                                                                                                                                        0.694145,
                                                                                                                                                        0.378414,
                                                                                                                                                        0.505481,
                                                                                                                                                        0.77543,
                                                                                                                                                        0.006845, -0.047266,
                                                                                                                                                        0.998859,
                                                                                                                                                        0.018967, -0.043868,
                                                                                                                                                        0.998857,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1, -0.020383,
                                                                                                                                                        0.142599,
                                                                                                                                                        0.989571, -0.040046,
                                                                                                                                                        0.279701,
                                                                                                                                                        0.959252, -0.056476,
                                                                                                                                                        0.132481,
                                                                                                                                                        0.989575, -0.110958,
                                                                                                                                                        0.259822,
                                                                                                                                                        0.959261, -0.056476,
                                                                                                                                                        0.132481,
                                                                                                                                                        0.989575, -0.040046,
                                                                                                                                                        0.279701,
                                                                                                                                                        0.959252, -0.056476,
                                                                                                                                                        0.132481,
                                                                                                                                                        0.989575, -0.110958,
                                                                                                                                                        0.259822,
                                                                                                                                                        0.959261, -0.088721,
                                                                                                                                                        0.113366,
                                                                                                                                                        0.989584, -0.174309,
                                                                                                                                                        0.222267,
                                                                                                                                                        0.959278, -0.088721,
                                                                                                                                                        0.113366,
                                                                                                                                                        0.989584, -0.110958,
                                                                                                                                                        0.259822,
                                                                                                                                                        0.959261, -0.088721,
                                                                                                                                                        0.113366,
                                                                                                                                                        0.989584, -0.174309,
                                                                                                                                                        0.222267,
                                                                                                                                                        0.959278, -0.114919,
                                                                                                                                                        0.086557,
                                                                                                                                                        0.989597, -0.225782,
                                                                                                                                                        0.169596,
                                                                                                                                                        0.959302, -0.114919,
                                                                                                                                                        0.086557,
                                                                                                                                                        0.989597, -0.174309,
                                                                                                                                                        0.222267,
                                                                                                                                                        0.959278, -0.114919,
                                                                                                                                                        0.086557,
                                                                                                                                                        0.989597, -0.225782,
                                                                                                                                                        0.169596,
                                                                                                                                                        0.959302, -0.133287,
                                                                                                                                                        0.05388,
                                                                                                                                                        0.989612, -0.26187,
                                                                                                                                                        0.105397,
                                                                                                                                                        0.959331, -0.133287,
                                                                                                                                                        0.05388,
                                                                                                                                                        0.989612, -0.225782,
                                                                                                                                                        0.169596,
                                                                                                                                                        0.959302, -0.133287,
                                                                                                                                                        0.05388,
                                                                                                                                                        0.989612, -0.26187,
                                                                                                                                                        0.105397,
                                                                                                                                                        0.959331, -0.142572,
                                                                                                                                                        0.017563,
                                                                                                                                                        0.989629, -0.280113,
                                                                                                                                                        0.034045,
                                                                                                                                                        0.959363, -0.142572,
                                                                                                                                                        0.017563,
                                                                                                                                                        0.989629, -0.26187,
                                                                                                                                                        0.105397,
                                                                                                                                                        0.959331, -0.26187,
                                                                                                                                                        0.105397,
                                                                                                                                                        0.959331, -0.381834,
                                                                                                                                                        0.153452,
                                                                                                                                                        0.911403, -0.280113,
                                                                                                                                                        0.034045,
                                                                                                                                                        0.959363, -0.381834,
                                                                                                                                                        0.153452,
                                                                                                                                                        0.911403, -0.26187,
                                                                                                                                                        0.105397,
                                                                                                                                                        0.959331, -0.329213,
                                                                                                                                                        0.24706,
                                                                                                                                                        0.911362, -0.225782,
                                                                                                                                                        0.169596,
                                                                                                                                                        0.959302, -0.329213,
                                                                                                                                                        0.24706,
                                                                                                                                                        0.911362, -0.26187,
                                                                                                                                                        0.105397,
                                                                                                                                                        0.959331, -0.329213,
                                                                                                                                                        0.24706,
                                                                                                                                                        0.911362, -0.225782,
                                                                                                                                                        0.169596,
                                                                                                                                                        0.959302, -0.254159,
                                                                                                                                                        0.323858,
                                                                                                                                                        0.911328, -0.174309,
                                                                                                                                                        0.222267,
                                                                                                                                                        0.959278, -0.254159,
                                                                                                                                                        0.323858,
                                                                                                                                                        0.911328, -0.225782,
                                                                                                                                                        0.169596,
                                                                                                                                                        0.959302, -0.254159,
                                                                                                                                                        0.323858,
                                                                                                                                                        0.911328, -0.174309,
                                                                                                                                                        0.222267,
                                                                                                                                                        0.959278, -0.161787,
                                                                                                                                                        0.378616,
                                                                                                                                                        0.911304, -0.110958,
                                                                                                                                                        0.259822,
                                                                                                                                                        0.959261, -0.161787,
                                                                                                                                                        0.378616,
                                                                                                                                                        0.911304, -0.174309,
                                                                                                                                                        0.222267,
                                                                                                                                                        0.959278, -0.161787,
                                                                                                                                                        0.378616,
                                                                                                                                                        0.911304, -0.110958,
                                                                                                                                                        0.259822,
                                                                                                                                                        0.959261, -0.058391,
                                                                                                                                                        0.407601,
                                                                                                                                                        0.911291, -0.040046,
                                                                                                                                                        0.279701,
                                                                                                                                                        0.959252, -0.058391,
                                                                                                                                                        0.407601,
                                                                                                                                                        0.911291, -0.110958,
                                                                                                                                                        0.259822,
                                                                                                                                                        0.959261, -0.058391,
                                                                                                                                                        0.407601,
                                                                                                                                                        0.911291, -0.074986,
                                                                                                                                                        0.523289,
                                                                                                                                                        0.848849, -0.161787,
                                                                                                                                                        0.378616,
                                                                                                                                                        0.911304, -0.207767,
                                                                                                                                                        0.486067,
                                                                                                                                                        0.848865, -0.161787,
                                                                                                                                                        0.378616,
                                                                                                                                                        0.911304, -0.074986,
                                                                                                                                                        0.523289,
                                                                                                                                                        0.848849, -0.161787,
                                                                                                                                                        0.378616,
                                                                                                                                                        0.911304, -0.207767,
                                                                                                                                                        0.486067,
                                                                                                                                                        0.848865, -0.254159,
                                                                                                                                                        0.323858,
                                                                                                                                                        0.911328, -0.326391,
                                                                                                                                                        0.415749,
                                                                                                                                                        0.848895, -0.254159,
                                                                                                                                                        0.323858,
                                                                                                                                                        0.911328, -0.207767,
                                                                                                                                                        0.486067,
                                                                                                                                                        0.848865, -0.254159,
                                                                                                                                                        0.323858,
                                                                                                                                                        0.911328, -0.326391,
                                                                                                                                                        0.415749,
                                                                                                                                                        0.848895, -0.329213,
                                                                                                                                                        0.24706,
                                                                                                                                                        0.911362, -0.422776,
                                                                                                                                                        0.317124,
                                                                                                                                                        0.848936, -0.329213,
                                                                                                                                                        0.24706,
                                                                                                                                                        0.911362, -0.326391,
                                                                                                                                                        0.415749,
                                                                                                                                                        0.848895, -0.329213,
                                                                                                                                                        0.24706,
                                                                                                                                                        0.911362, -0.422776,
                                                                                                                                                        0.317124,
                                                                                                                                                        0.848936, -0.381834,
                                                                                                                                                        0.153452,
                                                                                                                                                        0.911403, -0.490354,
                                                                                                                                                        0.196913,
                                                                                                                                                        0.848986, -0.381834,
                                                                                                                                                        0.153452,
                                                                                                                                                        0.911403, -0.422776,
                                                                                                                                                        0.317124,
                                                                                                                                                        0.848936, -0.381834,
                                                                                                                                                        0.153452,
                                                                                                                                                        0.911403, -0.490354,
                                                                                                                                                        0.196913,
                                                                                                                                                        0.848986, -0.408436,
                                                                                                                                                        0.049412,
                                                                                                                                                        0.911449, -0.408436,
                                                                                                                                                        0.049412,
                                                                                                                                                        0.911449, -0.280113,
                                                                                                                                                        0.034045,
                                                                                                                                                        0.959363, -0.381834,
                                                                                                                                                        0.153452,
                                                                                                                                                        0.911403, -0.207767,
                                                                                                                                                        0.486067,
                                                                                                                                                        0.848865, -0.248236,
                                                                                                                                                        0.580633,
                                                                                                                                                        0.7754, -0.326391,
                                                                                                                                                        0.415749,
                                                                                                                                                        0.848895, -0.248236,
                                                                                                                                                        0.580633,
                                                                                                                                                        0.7754, -0.207767,
                                                                                                                                                        0.486067,
                                                                                                                                                        0.848865, -0.089592,
                                                                                                                                                        0.625105,
                                                                                                                                                        0.775382, -0.074986,
                                                                                                                                                        0.523289,
                                                                                                                                                        0.848849, -0.089592,
                                                                                                                                                        0.625105,
                                                                                                                                                        0.775382, -0.207767,
                                                                                                                                                        0.486067,
                                                                                                                                                        0.848865, -0.089592,
                                                                                                                                                        0.625105,
                                                                                                                                                        0.775382, -0.10214,
                                                                                                                                                        0.712568,
                                                                                                                                                        0.694128, -0.248236,
                                                                                                                                                        0.580633,
                                                                                                                                                        0.7754, -0.142572,
                                                                                                                                                        0.017563,
                                                                                                                                                        0.989629, -0.047879,
                                                                                                                                                        0.006211,
                                                                                                                                                        0.998834, -0.133287,
                                                                                                                                                        0.05388,
                                                                                                                                                        0.989612,
                                                                                                                                                        0.667969, -0.267372,
                                                                                                                                                        0.694499,
                                                                                                                                                        0.575935, -0.431142,
                                                                                                                                                        0.694562,
                                                                                                                                                        0.736923, -0.295047,
                                                                                                                                                        0.608188, -0.101813, -0.848663,
                                                                                                                                                        0.519043, -0.107637, -0.897271,
                                                                                                                                                        0.428158,
                                                                                                                                                        0.121369, -0.846088,
                                                                                                                                                        0.519043, -0.378465, -0.504824,
                                                                                                                                                        0.775833, -0.496313, -0.38965,
                                                                                                                                                        0.775787, -0.431474, -0.57562,
                                                                                                                                                        0.694616, -0.496313, -0.38965,
                                                                                                                                                        0.775787, -0.378465, -0.504824,
                                                                                                                                                        0.775833, -0.415396, -0.326029,
                                                                                                                                                        0.849206, -0.316761, -0.422425,
                                                                                                                                                        0.849247, -0.415396, -0.326029,
                                                                                                                                                        0.849206, -0.378465, -0.504824,
                                                                                                                                                        0.775833, -0.415396, -0.326029,
                                                                                                                                                        0.849206, -0.316761, -0.422425,
                                                                                                                                                        0.849247, -0.323461, -0.253755,
                                                                                                                                                        0.911582, -0.246655, -0.328816,
                                                                                                                                                        0.911615, -0.323461, -0.253755,
                                                                                                                                                        0.911582, -0.316761, -0.422425,
                                                                                                                                                        0.849247, -0.323461, -0.253755,
                                                                                                                                                        0.911582, -0.246655, -0.328816,
                                                                                                                                                        0.911615, -0.221833, -0.173871,
                                                                                                                                                        0.959458, -0.169158, -0.225348,
                                                                                                                                                        0.959481, -0.221833, -0.173871,
                                                                                                                                                        0.959458, -0.246655, -0.328816,
                                                                                                                                                        0.911615, -0.221833, -0.173871,
                                                                                                                                                        0.959458, -0.169158, -0.225348,
                                                                                                                                                        0.959481, -0.112907, -0.08826,
                                                                                                                                                        0.989678, -0.086096, -0.11446,
                                                                                                                                                        0.98969, -0.112907, -0.08826,
                                                                                                                                                        0.989678, -0.169158, -0.225348,
                                                                                                                                                        0.959481, -0.112907, -0.08826,
                                                                                                                                                        0.989678, -0.086096, -0.11446,
                                                                                                                                                        0.98969, -0.037916, -0.029327,
                                                                                                                                                        0.99885, -0.028913, -0.038125,
                                                                                                                                                        0.998855, -0.037916, -0.029327,
                                                                                                                                                        0.99885, -0.086096, -0.11446,
                                                                                                                                                        0.98969, -0.037916, -0.029327,
                                                                                                                                                        0.99885, -0.028913, -0.038125,
                                                                                                                                                        0.998855, -0.029795,
                                                                                                                                                        0.038384,
                                                                                                                                                        0.998819, -0.029795,
                                                                                                                                                        0.038384,
                                                                                                                                                        0.998819, -0.028913, -0.038125,
                                                                                                                                                        0.998855, -0.018966,
                                                                                                                                                        0.044803,
                                                                                                                                                        0.998816, -0.038593,
                                                                                                                                                        0.029381,
                                                                                                                                                        0.998823, -0.037916, -0.029327,
                                                                                                                                                        0.99885, -0.029795,
                                                                                                                                                        0.038384,
                                                                                                                                                        0.998819, -0.667927,
                                                                                                                                                        0.268004,
                                                                                                                                                        0.694297, -0.575876,
                                                                                                                                                        0.431747,
                                                                                                                                                        0.694235, -0.736878,
                                                                                                                                                        0.295597,
                                                                                                                                                        0.607975, -0.635325,
                                                                                                                                                        0.476243,
                                                                                                                                                        0.607911, -0.736878,
                                                                                                                                                        0.295597,
                                                                                                                                                        0.607975, -0.575876,
                                                                                                                                                        0.431747,
                                                                                                                                                        0.694235, -0.736878,
                                                                                                                                                        0.295597,
                                                                                                                                                        0.607975, -0.635325,
                                                                                                                                                        0.476243,
                                                                                                                                                        0.607911, -0.793546,
                                                                                                                                                        0.318265,
                                                                                                                                                        0.518644, -0.684184,
                                                                                                                                                        0.512805,
                                                                                                                                                        0.518578, -0.793546,
                                                                                                                                                        0.318265,
                                                                                                                                                        0.518644, -0.635325,
                                                                                                                                                        0.476243,
                                                                                                                                                        0.607911, -0.793546,
                                                                                                                                                        0.318265,
                                                                                                                                                        0.518644, -0.684184,
                                                                                                                                                        0.512805,
                                                                                                                                                        0.518578, -0.838956,
                                                                                                                                                        0.336421,
                                                                                                                                                        0.427754, -0.723338,
                                                                                                                                                        0.542095,
                                                                                                                                                        0.427687, -0.838956,
                                                                                                                                                        0.336421,
                                                                                                                                                        0.427754, -0.684184,
                                                                                                                                                        0.512805,
                                                                                                                                                        0.518578, -0.838956,
                                                                                                                                                        0.336421,
                                                                                                                                                        0.427754, -0.723338,
                                                                                                                                                        0.542095,
                                                                                                                                                        0.427687, -0.874135,
                                                                                                                                                        0.350477,
                                                                                                                                                        0.336234, -0.753671,
                                                                                                                                                        0.564776,
                                                                                                                                                        0.336166, -0.874135,
                                                                                                                                                        0.350477,
                                                                                                                                                        0.336234, -0.723338,
                                                                                                                                                        0.542095,
                                                                                                                                                        0.427687, -0.874135,
                                                                                                                                                        0.350477,
                                                                                                                                                        0.336234, -0.753671,
                                                                                                                                                        0.564776,
                                                                                                                                                        0.336166, -0.899996,
                                                                                                                                                        0.360798,
                                                                                                                                                        0.244606, -0.77597,
                                                                                                                                                        0.581439,
                                                                                                                                                        0.244539, -0.899996,
                                                                                                                                                        0.360798,
                                                                                                                                                        0.244606, -0.753671,
                                                                                                                                                        0.564776,
                                                                                                                                                        0.336166, -0.899996,
                                                                                                                                                        0.360798,
                                                                                                                                                        0.244606, -0.77597,
                                                                                                                                                        0.581439,
                                                                                                                                                        0.244539, -0.909713,
                                                                                                                                                        0.364671,
                                                                                                                                                        0.198588, -0.784349,
                                                                                                                                                        0.587695,
                                                                                                                                                        0.19852, -0.909713,
                                                                                                                                                        0.364671,
                                                                                                                                                        0.198588, -0.77597,
                                                                                                                                                        0.581439,
                                                                                                                                                        0.244539, -0.605537,
                                                                                                                                                        0.770673,
                                                                                                                                                        0.198465, -0.784349,
                                                                                                                                                        0.587695,
                                                                                                                                                        0.19852, -0.599067,
                                                                                                                                                        0.762461,
                                                                                                                                                        0.244483, -0.77597,
                                                                                                                                                        0.581439,
                                                                                                                                                        0.244539, -0.599067,
                                                                                                                                                        0.762461,
                                                                                                                                                        0.244483, -0.784349,
                                                                                                                                                        0.587695,
                                                                                                                                                        0.19852, -0.599067,
                                                                                                                                                        0.762461,
                                                                                                                                                        0.244483, -0.77597,
                                                                                                                                                        0.581439,
                                                                                                                                                        0.244539, -0.58185,
                                                                                                                                                        0.740594,
                                                                                                                                                        0.336111, -0.753671,
                                                                                                                                                        0.564776,
                                                                                                                                                        0.336166, -0.58185,
                                                                                                                                                        0.740594,
                                                                                                                                                        0.336111, -0.77597,
                                                                                                                                                        0.581439,
                                                                                                                                                        0.244539, -0.58185,
                                                                                                                                                        0.740594,
                                                                                                                                                        0.336111, -0.753671,
                                                                                                                                                        0.564776,
                                                                                                                                                        0.336166, -0.558431,
                                                                                                                                                        0.710835,
                                                                                                                                                        0.427631, -0.723338,
                                                                                                                                                        0.542095,
                                                                                                                                                        0.427687, -0.558431,
                                                                                                                                                        0.710835,
                                                                                                                                                        0.427631, -0.753671,
                                                                                                                                                        0.564776,
                                                                                                                                                        0.336166, -0.558431,
                                                                                                                                                        0.710835,
                                                                                                                                                        0.427631, -0.723338,
                                                                                                                                                        0.542095,
                                                                                                                                                        0.427687, -0.528203,
                                                                                                                                                        0.67241,
                                                                                                                                                        0.518523, -0.684184,
                                                                                                                                                        0.512805,
                                                                                                                                                        0.518578, -0.528203,
                                                                                                                                                        0.67241,
                                                                                                                                                        0.518523, -0.723338,
                                                                                                                                                        0.542095,
                                                                                                                                                        0.427687, -0.528203,
                                                                                                                                                        0.67241,
                                                                                                                                                        0.518523, -0.684184,
                                                                                                                                                        0.512805,
                                                                                                                                                        0.518578, -0.490482,
                                                                                                                                                        0.62445,
                                                                                                                                                        0.607857, -0.635325,
                                                                                                                                                        0.476243,
                                                                                                                                                        0.607911, -0.490482,
                                                                                                                                                        0.62445,
                                                                                                                                                        0.607857, -0.684184,
                                                                                                                                                        0.512805,
                                                                                                                                                        0.518578, -0.635325,
                                                                                                                                                        0.476243,
                                                                                                                                                        0.607911, -0.575876,
                                                                                                                                                        0.431747,
                                                                                                                                                        0.694235, -0.490482,
                                                                                                                                                        0.62445,
                                                                                                                                                        0.607857, -0.444586,
                                                                                                                                                        0.566085,
                                                                                                                                                        0.694184, -0.490482,
                                                                                                                                                        0.62445,
                                                                                                                                                        0.607857, -0.575876,
                                                                                                                                                        0.431747,
                                                                                                                                                        0.694235, -0.740494, -0.581737,
                                                                                                                                                        0.336527, -0.710701, -0.558283,
                                                                                                                                                        0.428047, -0.865857, -0.370252,
                                                                                                                                                        0.336461, -0.831018, -0.355305,
                                                                                                                                                        0.42798, -0.865857, -0.370252,
                                                                                                                                                        0.336461, -0.710701, -0.558283,
                                                                                                                                                        0.428047, -0.865857, -0.370252,
                                                                                                                                                        0.336461, -0.831018, -0.355305,
                                                                                                                                                        0.42798, -0.93221, -0.133528,
                                                                                                                                                        0.336386, -0.894698, -0.128106,
                                                                                                                                                        0.427906, -0.93221, -0.133528,
                                                                                                                                                        0.336386, -0.831018, -0.355305,
                                                                                                                                                        0.42798, -0.93221, -0.133528,
                                                                                                                                                        0.336386, -0.894698, -0.128106,
                                                                                                                                                        0.427906, -0.935032,
                                                                                                                                                        0.112299,
                                                                                                                                                        0.336309, -0.897405,
                                                                                                                                                        0.107829,
                                                                                                                                                        0.427829, -0.935032,
                                                                                                                                                        0.112299,
                                                                                                                                                        0.336309, -0.894698, -0.128106,
                                                                                                                                                        0.427906, -0.894698, -0.128106,
                                                                                                                                                        0.427906, -0.846276, -0.121119,
                                                                                                                                                        0.518794, -0.897405,
                                                                                                                                                        0.107829,
                                                                                                                                                        0.427829, -0.846276, -0.121119,
                                                                                                                                                        0.518794, -0.894698, -0.128106,
                                                                                                                                                        0.427906, -0.786044, -0.336023,
                                                                                                                                                        0.518868, -0.831018, -0.355305,
                                                                                                                                                        0.42798, -0.786044, -0.336023,
                                                                                                                                                        0.518868, -0.894698, -0.128106,
                                                                                                                                                        0.427906, -0.786044, -0.336023,
                                                                                                                                                        0.518868, -0.831018, -0.355305,
                                                                                                                                                        0.42798, -0.67224, -0.528017,
                                                                                                                                                        0.518934, -0.710701, -0.558283,
                                                                                                                                                        0.428047, -0.67224, -0.528017,
                                                                                                                                                        0.518934, -0.831018, -0.355305,
                                                                                                                                                        0.42798, -0.67224, -0.528017,
                                                                                                                                                        0.518934, -0.624238, -0.490254,
                                                                                                                                                        0.608258, -0.786044, -0.336023,
                                                                                                                                                        0.518868, -0.729915, -0.311969,
                                                                                                                                                        0.608194, -0.786044, -0.336023,
                                                                                                                                                        0.518868, -0.624238, -0.490254,
                                                                                                                                                        0.608258, -0.786044, -0.336023,
                                                                                                                                                        0.518868, -0.729915, -0.311969,
                                                                                                                                                        0.608194, -0.846276, -0.121119,
                                                                                                                                                        0.518794, -0.785844, -0.112411,
                                                                                                                                                        0.608122, -0.846276, -0.121119,
                                                                                                                                                        0.518794, -0.729915, -0.311969,
                                                                                                                                                        0.608194, -0.846276, -0.121119,
                                                                                                                                                        0.518794, -0.785844, -0.112411,
                                                                                                                                                        0.608122, -0.848833,
                                                                                                                                                        0.102046,
                                                                                                                                                        0.518718, -0.788218,
                                                                                                                                                        0.094818,
                                                                                                                                                        0.608048, -0.848833,
                                                                                                                                                        0.102046,
                                                                                                                                                        0.518718, -0.785844, -0.112411,
                                                                                                                                                        0.608122, -0.848833,
                                                                                                                                                        0.102046,
                                                                                                                                                        0.518718, -0.897405,
                                                                                                                                                        0.107829,
                                                                                                                                                        0.427829, -0.846276, -0.121119,
                                                                                                                                                        0.518794, -0.935032,
                                                                                                                                                        0.112299,
                                                                                                                                                        0.336309, -0.962691,
                                                                                                                                                        0.115574,
                                                                                                                                                        0.244681, -0.93221, -0.133528,
                                                                                                                                                        0.336386, -0.959781, -0.137525,
                                                                                                                                                        0.244759, -0.93221, -0.133528,
                                                                                                                                                        0.336386, -0.962691,
                                                                                                                                                        0.115574,
                                                                                                                                                        0.244681, -0.93221, -0.133528,
                                                                                                                                                        0.336386, -0.959781, -0.137525,
                                                                                                                                                        0.244759, -0.865857, -0.370252,
                                                                                                                                                        0.336461, -0.962691,
                                                                                                                                                        0.115574,
                                                                                                                                                        0.244681, -0.973083,
                                                                                                                                                        0.116798,
                                                                                                                                                        0.198663, -0.959781, -0.137525,
                                                                                                                                                        0.244759, -0.97014, -0.139032,
                                                                                                                                                        0.19874, -0.959781, -0.137525,
                                                                                                                                                        0.244759, -0.973083,
                                                                                                                                                        0.116798,
                                                                                                                                                        0.198663, -0.959781, -0.137525,
                                                                                                                                                        0.244759, -0.97014, -0.139032,
                                                                                                                                                        0.19874, -0.891463, -0.381248,
                                                                                                                                                        0.244833, -0.901083, -0.385385,
                                                                                                                                                        0.198814, -0.891463, -0.381248,
                                                                                                                                                        0.244833, -0.97014, -0.139032,
                                                                                                                                                        0.19874, -0.891463, -0.381248,
                                                                                                                                                        0.244833, -0.901083, -0.385385,
                                                                                                                                                        0.198814, -0.76239, -0.598987,
                                                                                                                                                        0.2449, -0.770616, -0.605473,
                                                                                                                                                        0.198881, -0.76239, -0.598987,
                                                                                                                                                        0.2449, -0.901083, -0.385385,
                                                                                                                                                        0.198814,
                                                                                                                                                        null,
                                                                                                                                                        null,
                                                                                                                                                        null
                                                                                                                                                    ],
                                                                                                                                                    "uv": [
                                                                                                                                                        16.896742, -2.016036,
                                                                                                                                                        16.913424, -1.579512,
                                                                                                                                                        20.905558, -2.017926,
                                                                                                                                                        22.996104, -0.067929,
                                                                                                                                                        23.012528, -0.504463,
                                                                                                                                                        19.02038, -0.066255,
                                                                                                                                                        19.003712, -0.502775,
                                                                                                                                                        19.02038, -0.066255,
                                                                                                                                                        23.012528, -0.504463,
                                                                                                                                                        23.68767,
                                                                                                                                                        1.115305,
                                                                                                                                                        19.678854,
                                                                                                                                                        1.116677,
                                                                                                                                                        23.671223,
                                                                                                                                                        1.551834,
                                                                                                                                                        19.679343,
                                                                                                                                                        2.606222,
                                                                                                                                                        23.688159,
                                                                                                                                                        2.604882,
                                                                                                                                                        19.667774,
                                                                                                                                                        2.163958,
                                                                                                                                                        23.699538,
                                                                                                                                                        2.162611,
                                                                                                                                                        19.667774,
                                                                                                                                                        2.163958,
                                                                                                                                                        23.688159,
                                                                                                                                                        2.604882,
                                                                                                                                                        13.071749, -1.563772,
                                                                                                                                                        9.039984, -1.561904,
                                                                                                                                                        13.060406, -1.121485,
                                                                                                                                                        9.051591, -1.119628,
                                                                                                                                                        13.060406, -1.121485,
                                                                                                                                                        9.039984, -1.561904,
                                                                                                                                                        13.058873, -4.327803,
                                                                                                                                                        9.050058, -4.325902,
                                                                                                                                                        13.042464, -3.891252,
                                                                                                                                                        9.06674, -3.889366,
                                                                                                                                                        13.042464, -3.891252,
                                                                                                                                                        9.050058, -4.325902,
                                                                                                                                                        13.040796, -7.159339,
                                                                                                                                                        9.065072, -7.157388,
                                                                                                                                                        13.019541, -6.730337,
                                                                                                                                                        9.086615, -6.728407,
                                                                                                                                                        13.019541, -6.730337,
                                                                                                                                                        9.065072, -7.157388,
                                                                                                                                                        13.017669, -10.059219,
                                                                                                                                                        9.084743, -10.057195,
                                                                                                                                                        12.991852, -9.639267,
                                                                                                                                                        9.110868, -9.637271,
                                                                                                                                                        12.991852, -9.639267,
                                                                                                                                                        9.084743, -10.057195,
                                                                                                                                                        12.989676, -13.018169,
                                                                                                                                                        9.108692, -13.016042,
                                                                                                                                                        12.959643, -12.608376,
                                                                                                                                                        9.13906, -12.606282,
                                                                                                                                                        12.959643, -12.608376,
                                                                                                                                                        9.108692, -13.016042,
                                                                                                                                                        12.957007, -16.012247,
                                                                                                                                                        9.136424, -16.009969,
                                                                                                                                                        12.923162, -15.61325,
                                                                                                                                                        9.170642, -15.611013,
                                                                                                                                                        12.923162, -15.61325,
                                                                                                                                                        9.136424, -16.009969,
                                                                                                                                                        9.167282, -18.9953,
                                                                                                                                                        9.204911, -18.607248,
                                                                                                                                                        12.919802, -18.997803,
                                                                                                                                                        17.37235, -16.439479,
                                                                                                                                                        13.61983, -16.436895,
                                                                                                                                                        17.335157, -16.051385,
                                                                                                                                                        17.375451, -13.349603,
                                                                                                                                                        17.40929, -13.748591,
                                                                                                                                                        13.622931, -13.347293,
                                                                                                                                                        13.588706, -13.74624,
                                                                                                                                                        13.622931, -13.347293,
                                                                                                                                                        17.40929, -13.748591,
                                                                                                                                                        20.771884, -10.415524,
                                                                                                                                                        20.80573, -10.814503,
                                                                                                                                                        17.019364, -10.4133,
                                                                                                                                                        16.985147, -10.812238,
                                                                                                                                                        17.019364, -10.4133,
                                                                                                                                                        20.80573, -10.814503,
                                                                                                                                                        22.880609, -7.010676,
                                                                                                                                                        22.914475, -7.409644,
                                                                                                                                                        19.128088, -7.008689,
                                                                                                                                                        19.093891, -7.407621,
                                                                                                                                                        19.128088, -7.008689,
                                                                                                                                                        22.914475, -7.409644,
                                                                                                                                                        23.591368, -3.766065,
                                                                                                                                                        19.770784, -3.764421,
                                                                                                                                                        23.557471, -3.367106,
                                                                                                                                                        19.771603, -2.025355,
                                                                                                                                                        23.592187, -2.026866,
                                                                                                                                                        19.741282, -2.435088,
                                                                                                                                                        23.622266, -2.436623,
                                                                                                                                                        19.741282, -2.435088,
                                                                                                                                                        23.592187, -2.026866,
                                                                                                                                                        19.741963, -0.757887,
                                                                                                                                                        23.622947, -0.759327,
                                                                                                                                                        19.715882, -1.177786,
                                                                                                                                                        23.648807, -1.179246,
                                                                                                                                                        19.715882, -1.177786,
                                                                                                                                                        23.622947, -0.759327,
                                                                                                                                                        19.716472,
                                                                                                                                                        0.433997,
                                                                                                                                                        23.649398,
                                                                                                                                                        0.432604,
                                                                                                                                                        19.694969,
                                                                                                                                                        0.005038,
                                                                                                                                                        23.670693,
                                                                                                                                                        0.003631,
                                                                                                                                                        19.694969,
                                                                                                                                                        0.005038,
                                                                                                                                                        23.649398,
                                                                                                                                                        0.432604,
                                                                                                                                                        19.695499,
                                                                                                                                                        1.553194,
                                                                                                                                                        23.671223,
                                                                                                                                                        1.551834,
                                                                                                                                                        19.678854,
                                                                                                                                                        1.116677,
                                                                                                                                                        22.884839,
                                                                                                                                                        2.730799,
                                                                                                                                                        18.876024,
                                                                                                                                                        2.731761,
                                                                                                                                                        22.868363,
                                                                                                                                                        3.167323,
                                                                                                                                                        18.876238,
                                                                                                                                                        3.712236,
                                                                                                                                                        22.885054,
                                                                                                                                                        3.711297,
                                                                                                                                                        18.864697,
                                                                                                                                                        3.269974,
                                                                                                                                                        22.896462,
                                                                                                                                                        3.269029,
                                                                                                                                                        18.864697,
                                                                                                                                                        3.269974,
                                                                                                                                                        22.885054,
                                                                                                                                                        3.711297, -3.356628, -2.024749, -7.388393, -2.023766, -3.368033, -1.582456, -7.376849, -1.581478, -3.368033, -1.582456, -7.388393, -2.023766, -3.368896, -5.002275, -7.377712, -5.001275, -3.38537, -4.565715, -7.361094, -4.564723, -3.38537, -4.565715, -7.377712, -5.001275, -3.386309, -8.047533, -7.362033, -8.046506, -3.407632, -7.618521, -7.340558, -7.617505, -3.407632, -7.618521, -7.362033, -8.046506, -3.408686, -11.160598, -7.341612, -11.159533, -3.434576, -10.740634, -7.315561, -10.739584, -3.434576, -10.740634, -7.341612, -11.159533, -3.435802, -14.330605, -7.316786, -14.329486, -3.465914, -13.9208, -7.286498, -13.919698, -3.465914, -13.9208, -7.316786, -14.329486, -3.467399, -17.530889, -7.287983, -17.529691, -3.501332, -17.131881, -7.253853, -17.130704, -3.501332, -17.131881, -7.287983, -17.529691, -7.255747, -20.712316, -7.218219, -20.324232, -3.503226, -20.713633,
                                                                                                                                                        2.076686, -20.821468,
                                                                                                                                                        2.113943, -21.209578, -1.601005, -20.819658, -1.638578, -21.207731, -1.601005, -20.819658,
                                                                                                                                                        2.113943, -21.209578,
                                                                                                                                                        7.678217, -20.236446,
                                                                                                                                                        7.715439, -20.624553,
                                                                                                                                                        4.000527, -20.234239,
                                                                                                                                                        3.962919, -20.622301,
                                                                                                                                                        4.000527, -20.234239,
                                                                                                                                                        7.715439, -20.624553,
                                                                                                                                                        12.882601, -18.609701,
                                                                                                                                                        12.919802, -18.997803,
                                                                                                                                                        9.204911, -18.607248,
                                                                                                                                                        9.200333, -21.904187,
                                                                                                                                                        9.240894, -21.526553,
                                                                                                                                                        12.878023, -21.90704,
                                                                                                                                                        17.330936, -19.075551,
                                                                                                                                                        13.653246, -19.072607,
                                                                                                                                                        17.290895, -18.697862,
                                                                                                                                                        13.657466, -16.048853,
                                                                                                                                                        17.335157, -16.051385,
                                                                                                                                                        13.61983, -16.436895,
                                                                                                                                                        20.769358, -13.123318,
                                                                                                                                                        17.016838, -13.12083,
                                                                                                                                                        20.732156, -12.735234,
                                                                                                                                                        17.054466, -12.732796,
                                                                                                                                                        20.732156, -12.735234,
                                                                                                                                                        17.016838, -13.12083,
                                                                                                                                                        20.728722, -15.405039,
                                                                                                                                                        17.051033, -15.402203,
                                                                                                                                                        20.688671, -15.027358,
                                                                                                                                                        17.091592, -15.024585,
                                                                                                                                                        20.688671, -15.027358,
                                                                                                                                                        17.051033, -15.402203,
                                                                                                                                                        20.683553, -17.590855,
                                                                                                                                                        17.086474, -17.587438,
                                                                                                                                                        20.641208, -17.222475,
                                                                                                                                                        17.12946, -17.21914,
                                                                                                                                                        20.641208, -17.222475,
                                                                                                                                                        17.086474, -17.587438,
                                                                                                                                                        20.632393, -19.594041,
                                                                                                                                                        17.120646, -19.589528,
                                                                                                                                                        20.588373, -19.233265,
                                                                                                                                                        17.165551, -19.228866,
                                                                                                                                                        20.588373, -19.233265,
                                                                                                                                                        17.120646, -19.589528,
                                                                                                                                                        20.568525, -21.321394,
                                                                                                                                                        17.145707, -21.314235,
                                                                                                                                                        20.523581, -20.965988,
                                                                                                                                                        17.192112, -20.959021,
                                                                                                                                                        20.523581, -20.965988,
                                                                                                                                                        17.145707, -21.314235,
                                                                                                                                                        20.426792, -22.734142,
                                                                                                                                                        17.09538, -22.713482,
                                                                                                                                                        20.38269, -22.381359,
                                                                                                                                                        17.143845, -22.361273,
                                                                                                                                                        20.38269, -22.381359,
                                                                                                                                                        17.09538, -22.713482,
                                                                                                                                                        27.615855,
                                                                                                                                                        13.570136,
                                                                                                                                                        26.741531,
                                                                                                                                                        10.451469,
                                                                                                                                                        26.851072,
                                                                                                                                                        19.946834,
                                                                                                                                                        26.851072,
                                                                                                                                                        19.946834,
                                                                                                                                                        26.741531,
                                                                                                                                                        10.451469,
                                                                                                                                                        25.264082,
                                                                                                                                                        22.770305,
                                                                                                                                                        26.741531,
                                                                                                                                                        10.451469,
                                                                                                                                                        25.089828,
                                                                                                                                                        7.665361,
                                                                                                                                                        25.264082,
                                                                                                                                                        22.770305,
                                                                                                                                                        19.293763, -17.121634,
                                                                                                                                                        22.53262, -17.139606,
                                                                                                                                                        19.245527, -17.473874,
                                                                                                                                                        22.576952, -17.492359,
                                                                                                                                                        19.245527, -17.473874,
                                                                                                                                                        22.53262, -17.139606,
                                                                                                                                                        19.312633, -15.8289,
                                                                                                                                                        22.644103, -15.835128,
                                                                                                                                                        19.266306, -16.184122,
                                                                                                                                                        22.689125, -16.190521,
                                                                                                                                                        19.266306, -16.184122,
                                                                                                                                                        22.644103, -15.835128,
                                                                                                                                                        19.280106, -14.309678,
                                                                                                                                                        22.702929, -14.313609,
                                                                                                                                                        19.235248, -14.670341,
                                                                                                                                                        22.746996, -14.674374,
                                                                                                                                                        19.235248, -14.670341,
                                                                                                                                                        22.702929, -14.313609,
                                                                                                                                                        19.2414, -12.596403,
                                                                                                                                                        22.753149, -12.599384,
                                                                                                                                                        19.198448, -12.9647,
                                                                                                                                                        22.795527, -12.967752,
                                                                                                                                                        19.198448, -12.9647,
                                                                                                                                                        22.753149, -12.599384,
                                                                                                                                                        19.202033, -10.765079,
                                                                                                                                                        22.799112, -10.767557,
                                                                                                                                                        19.161501, -11.142693,
                                                                                                                                                        22.839191, -11.145227,
                                                                                                                                                        19.161501, -11.142693,
                                                                                                                                                        22.799112, -10.767557,
                                                                                                                                                        19.163913, -8.884718,
                                                                                                                                                        22.841603, -8.886897,
                                                                                                                                                        19.126308, -9.272747,
                                                                                                                                                        22.878828, -9.27497,
                                                                                                                                                        19.126308, -9.272747,
                                                                                                                                                        22.841603, -8.886897,
                                                                                                                                                        23.556439, -5.156709,
                                                                                                                                                        19.803918, -5.154903,
                                                                                                                                                        23.519178, -4.768646,
                                                                                                                                                        19.804951, -3.365492,
                                                                                                                                                        23.557471, -3.367106,
                                                                                                                                                        19.770784, -3.764421,
                                                                                                                                                        22.789899, -0.132381,
                                                                                                                                                        18.969315, -0.131229,
                                                                                                                                                        22.755962,
                                                                                                                                                        0.266567,
                                                                                                                                                        18.969663,
                                                                                                                                                        1.113883,
                                                                                                                                                        22.790248,
                                                                                                                                                        1.112823,
                                                                                                                                                        18.939379,
                                                                                                                                                        0.704152,
                                                                                                                                                        22.820363,
                                                                                                                                                        0.703076,
                                                                                                                                                        18.939379,
                                                                                                                                                        0.704152,
                                                                                                                                                        22.790248,
                                                                                                                                                        1.112823,
                                                                                                                                                        18.939672,
                                                                                                                                                        1.876551,
                                                                                                                                                        22.820656,
                                                                                                                                                        1.875541,
                                                                                                                                                        18.913623,
                                                                                                                                                        1.456654,
                                                                                                                                                        22.846549,
                                                                                                                                                        1.45563,
                                                                                                                                                        18.913623,
                                                                                                                                                        1.456654,
                                                                                                                                                        22.820656,
                                                                                                                                                        1.875541,
                                                                                                                                                        18.913879,
                                                                                                                                                        2.559144,
                                                                                                                                                        22.846805,
                                                                                                                                                        2.558168,
                                                                                                                                                        18.892407,
                                                                                                                                                        2.130187,
                                                                                                                                                        22.868132,
                                                                                                                                                        2.1292,
                                                                                                                                                        18.892407,
                                                                                                                                                        2.130187,
                                                                                                                                                        22.846805,
                                                                                                                                                        2.558168,
                                                                                                                                                        18.892639,
                                                                                                                                                        3.168277,
                                                                                                                                                        22.868363,
                                                                                                                                                        3.167323,
                                                                                                                                                        18.876024,
                                                                                                                                                        2.731761,
                                                                                                                                                        20.658671,
                                                                                                                                                        4.231594,
                                                                                                                                                        16.649855,
                                                                                                                                                        4.23208,
                                                                                                                                                        20.64216,
                                                                                                                                                        4.668113,
                                                                                                                                                        16.649903,
                                                                                                                                                        4.739688,
                                                                                                                                                        20.658719,
                                                                                                                                                        4.739214,
                                                                                                                                                        16.638395,
                                                                                                                                                        4.297426,
                                                                                                                                                        20.67016,
                                                                                                                                                        4.296948,
                                                                                                                                                        16.638395,
                                                                                                                                                        4.297426,
                                                                                                                                                        20.658719,
                                                                                                                                                        4.739214,
                                                                                                                                                        1.765294,
                                                                                                                                                        6.392626, -2.266471,
                                                                                                                                                        6.391247,
                                                                                                                                                        1.753722,
                                                                                                                                                        6.83489, -2.255094,
                                                                                                                                                        6.833519,
                                                                                                                                                        1.753722,
                                                                                                                                                        6.83489, -2.266471,
                                                                                                                                                        6.391247,
                                                                                                                                                        1.753506,
                                                                                                                                                        7.292638, -2.25531,
                                                                                                                                                        7.291234,
                                                                                                                                                        1.736859,
                                                                                                                                                        7.729155, -2.238865,
                                                                                                                                                        7.727763,
                                                                                                                                                        1.736859,
                                                                                                                                                        7.729155, -2.25531,
                                                                                                                                                        7.291234,
                                                                                                                                                        1.736619,
                                                                                                                                                        8.132122, -2.239105,
                                                                                                                                                        8.130681,
                                                                                                                                                        1.715113,
                                                                                                                                                        8.561081, -2.217812,
                                                                                                                                                        8.559656,
                                                                                                                                                        1.715113,
                                                                                                                                                        8.561081, -2.239105,
                                                                                                                                                        8.130681,
                                                                                                                                                        1.714836,
                                                                                                                                                        8.897473, -2.21809,
                                                                                                                                                        8.895979,
                                                                                                                                                        1.688751,
                                                                                                                                                        9.317373, -2.192233,
                                                                                                                                                        9.315899,
                                                                                                                                                        1.688751,
                                                                                                                                                        9.317373, -2.21809,
                                                                                                                                                        8.895979,
                                                                                                                                                        1.688417,
                                                                                                                                                        9.571176, -2.192567,
                                                                                                                                                        9.569606,
                                                                                                                                                        1.658093,
                                                                                                                                                        9.980909, -2.162491,
                                                                                                                                                        9.979363,
                                                                                                                                                        1.658093,
                                                                                                                                                        9.980909, -2.192567,
                                                                                                                                                        9.569606, -2.162912,
                                                                                                                                                        10.129663, -2.129018,
                                                                                                                                                        10.528622,
                                                                                                                                                        1.657672,
                                                                                                                                                        10.131345, -3.946462,
                                                                                                                                                        9.60824, -7.767046,
                                                                                                                                                        9.60619, -3.980662,
                                                                                                                                                        10.007173, -7.76659,
                                                                                                                                                        9.526939, -3.946006,
                                                                                                                                                        9.528823, -7.79664,
                                                                                                                                                        9.117172, -3.915656,
                                                                                                                                                        9.119086, -7.79664,
                                                                                                                                                        9.117172, -3.946006,
                                                                                                                                                        9.528823, -7.79628,
                                                                                                                                                        8.936005, -3.915295,
                                                                                                                                                        8.937801, -7.822112,
                                                                                                                                                        8.516077, -3.889186,
                                                                                                                                                        8.517898, -7.822112,
                                                                                                                                                        8.516077, -3.915295,
                                                                                                                                                        8.937801, -7.821814,
                                                                                                                                                        8.252891, -3.888888,
                                                                                                                                                        8.254628, -7.843084,
                                                                                                                                                        7.823909, -3.86736,
                                                                                                                                                        7.825665, -7.843084,
                                                                                                                                                        7.823909, -3.888888,
                                                                                                                                                        8.254628, -7.842826,
                                                                                                                                                        7.494205, -3.867103,
                                                                                                                                                        7.495901, -7.859249,
                                                                                                                                                        7.05767, -3.850434,
                                                                                                                                                        7.059381, -7.859249,
                                                                                                                                                        7.05767, -3.867103,
                                                                                                                                                        7.495901, -7.859019,
                                                                                                                                                        6.672997, -3.850203,
                                                                                                                                                        6.674668, -7.870375,
                                                                                                                                                        6.230721, -3.83861,
                                                                                                                                                        6.232402, -7.870375,
                                                                                                                                                        6.230721, -3.850203,
                                                                                                                                                        6.674668, -9.043391,
                                                                                                                                                        5.791407, -13.075155,
                                                                                                                                                        5.789539, -9.054997,
                                                                                                                                                        6.233677, -13.063813,
                                                                                                                                                        6.231819, -9.054997,
                                                                                                                                                        6.233677, -13.075155,
                                                                                                                                                        5.789539, -9.055152,
                                                                                                                                                        6.416093, -13.063968,
                                                                                                                                                        6.414192, -9.071835,
                                                                                                                                                        6.852618, -13.047559,
                                                                                                                                                        6.850732, -9.071835,
                                                                                                                                                        6.852618, -13.063968,
                                                                                                                                                        6.414192, -9.07201,
                                                                                                                                                        6.979668, -13.047734,
                                                                                                                                                        6.977716, -9.093553,
                                                                                                                                                        7.408636, -13.026479,
                                                                                                                                                        7.406705, -9.093553,
                                                                                                                                                        7.408636, -13.047734,
                                                                                                                                                        6.977716, -9.093761,
                                                                                                                                                        7.469473, -13.026686,
                                                                                                                                                        7.467449, -9.119885,
                                                                                                                                                        7.889382, -13.000869,
                                                                                                                                                        7.887386, -9.119885,
                                                                                                                                                        7.889382, -13.026686,
                                                                                                                                                        7.467449, -9.12014,
                                                                                                                                                        7.869984, -13.001124,
                                                                                                                                                        7.867856, -9.150508,
                                                                                                                                                        8.279727, -12.971091,
                                                                                                                                                        8.277633, -9.150508,
                                                                                                                                                        8.279727, -13.001124,
                                                                                                                                                        7.867856, -9.150837,
                                                                                                                                                        8.162719, -12.97142,
                                                                                                                                                        8.160441, -9.185055,
                                                                                                                                                        8.561658, -12.937576,
                                                                                                                                                        8.559421, -9.185055,
                                                                                                                                                        8.561658, -12.97142,
                                                                                                                                                        8.160441, -12.938025,
                                                                                                                                                        8.324162, -12.900824,
                                                                                                                                                        8.712247, -9.185505,
                                                                                                                                                        8.326666, -13.635112,
                                                                                                                                                        5.762265, -17.387633,
                                                                                                                                                        5.759681, -13.672749,
                                                                                                                                                        6.150308, -17.387538,
                                                                                                                                                        6.290535, -13.635018,
                                                                                                                                                        6.292844, -17.421377,
                                                                                                                                                        5.891546, -13.600793,
                                                                                                                                                        5.893897, -17.421377,
                                                                                                                                                        5.891546, -13.635018,
                                                                                                                                                        6.292844, -17.421324,
                                                                                                                                                        6.317106, -13.600741,
                                                                                                                                                        6.319268, -17.451352,
                                                                                                                                                        5.907321, -13.570368,
                                                                                                                                                        5.909516, -17.451352,
                                                                                                                                                        5.907321, -13.600741,
                                                                                                                                                        6.319268, -17.451324,
                                                                                                                                                        6.241965, -13.57034,
                                                                                                                                                        6.244026, -17.477136,
                                                                                                                                                        5.82202, -13.54421,
                                                                                                                                                        5.824109, -17.477136,
                                                                                                                                                        5.82202, -13.57034,
                                                                                                                                                        6.244026, -17.477123,
                                                                                                                                                        6.079179, -13.544198,
                                                                                                                                                        6.081171, -17.498374,
                                                                                                                                                        5.650183, -13.52265,
                                                                                                                                                        5.652197, -17.498374,
                                                                                                                                                        5.650183, -13.544198,
                                                                                                                                                        6.081171, -17.498371,
                                                                                                                                                        5.841575, -13.522648,
                                                                                                                                                        5.843521, -17.514776,
                                                                                                                                                        5.405029, -13.505961,
                                                                                                                                                        5.406991, -17.514776,
                                                                                                                                                        5.405029, -13.522648,
                                                                                                                                                        5.843521, -17.514779,
                                                                                                                                                        5.540404, -13.505964,
                                                                                                                                                        5.542321, -17.526118,
                                                                                                                                                        5.09812, -13.494353,
                                                                                                                                                        5.100048, -17.526118,
                                                                                                                                                        5.09812, -13.505964,
                                                                                                                                                        5.542321, -8.610668, -1.609691, -12.642433, -1.60917, -8.622106, -1.167396, -12.630922, -1.166879, -8.622106, -1.167396, -12.642433, -1.60917, -8.622536, -4.395884, -12.631352, -4.395354, -8.639044, -3.959324, -12.614768, -3.958798, -8.639044, -3.959324, -12.631352, -4.395354, -8.639512, -7.249435, -12.615236, -7.248892, -8.660871, -6.820422, -12.593797, -6.819885, -8.660871, -6.820422, -12.615236, -7.248892, -8.661396, -10.171087, -12.594322, -10.170524, -8.687324, -9.751124, -12.568309, -9.750568, -8.687324, -9.751124, -12.594322, -10.170524, -8.687935, -13.151375, -12.568919, -13.150783, -8.718088, -12.741571, -12.538672, -12.740988, -8.718088, -12.741571, -12.568919, -13.150783, -8.718828, -16.16603, -12.539412, -16.165395, -8.752807, -15.767023, -12.505328, -15.7664, -8.752807, -15.767023, -12.539412, -16.165395, -12.506271, -19.170186, -12.468796, -18.782092, -8.75375, -19.170883, -3.540529, -20.325522, -3.503226, -20.713633, -7.218219, -20.324232, -7.220801, -23.803668, -7.180361, -23.426, -3.54311, -23.805169,
                                                                                                                                                        2.032878, -23.976734,
                                                                                                                                                        2.072994, -24.354437, -1.564202, -23.974675, -1.604696, -24.352332, -1.564202, -23.974675,
                                                                                                                                                        2.072994, -24.354437,
                                                                                                                                                        7.633742, -23.329575,
                                                                                                                                                        7.673818, -23.707277,
                                                                                                                                                        4.036663, -23.327066,
                                                                                                                                                        3.996128, -23.70471,
                                                                                                                                                        4.036663, -23.327066,
                                                                                                                                                        7.673818, -23.707277,
                                                                                                                                                        12.837973, -21.529343,
                                                                                                                                                        12.878023, -21.90704,
                                                                                                                                                        9.240894, -21.526553,
                                                                                                                                                        9.234049, -24.64279,
                                                                                                                                                        9.277036, -24.274478,
                                                                                                                                                        12.831127, -24.646227,
                                                                                                                                                        17.284591, -21.573986,
                                                                                                                                                        13.687512, -21.570439,
                                                                                                                                                        17.242259, -21.205598,
                                                                                                                                                        13.693816, -18.694982,
                                                                                                                                                        17.290895, -18.697862,
                                                                                                                                                        13.653246, -19.072607,
                                                                                                                                                        13.73051, -21.202135,
                                                                                                                                                        17.242259, -21.205598,
                                                                                                                                                        13.687512, -21.570439,
                                                                                                                                                        17.231382, -23.83181,
                                                                                                                                                        13.719635, -23.827125,
                                                                                                                                                        17.187379, -23.471026,
                                                                                                                                                        13.764557, -23.466459,
                                                                                                                                                        17.187379, -23.471026,
                                                                                                                                                        13.719635, -23.827125,
                                                                                                                                                        17.162844, -25.738813,
                                                                                                                                                        13.740027, -25.731382,
                                                                                                                                                        17.117928, -25.3834,
                                                                                                                                                        13.786459, -25.376168,
                                                                                                                                                        17.117928, -25.3834,
                                                                                                                                                        13.740027, -25.731382,
                                                                                                                                                        16.998234, -27.234844,
                                                                                                                                                        13.666826, -27.213424,
                                                                                                                                                        16.954212, -26.88205,
                                                                                                                                                        13.715371, -26.861225,
                                                                                                                                                        16.954212, -26.88205,
                                                                                                                                                        13.666826, -27.213424,
                                                                                                                                                        27.653218,
                                                                                                                                                        16.808828,
                                                                                                                                                        27.615855,
                                                                                                                                                        13.570136,
                                                                                                                                                        26.851072,
                                                                                                                                                        19.946834,
                                                                                                                                                        12.487067, -30.338555,
                                                                                                                                                        12.531162, -30.691341,
                                                                                                                                                        9.248222, -30.318411,
                                                                                                                                                        4.002169, -32.855676,
                                                                                                                                                        4.050418, -32.503434,
                                                                                                                                                        7.333594, -32.87429,
                                                                                                                                                        7.289275, -32.521531,
                                                                                                                                                        7.333594, -32.87429,
                                                                                                                                                        4.050418, -32.503434, -1.571686, -33.626829, -1.523792, -33.274538,
                                                                                                                                                        1.759755, -33.642081,
                                                                                                                                                        1.715082, -33.289366,
                                                                                                                                                        1.759755, -33.642081, -1.523792, -33.274538, -7.145476, -32.93772, -7.098045, -32.585365, -3.814017, -32.948583, -3.859154, -32.595927, -3.814017, -32.948583, -7.098045, -32.585365, -12.345444, -30.838922, -12.298552, -30.486494, -9.013972, -30.844669, -9.05965, -30.492082, -9.013972, -30.844669, -12.298552, -30.486494, -16.77796, -27.121067, -13.539052, -27.121305, -16.82427, -27.473572,
                                                                                                                                                        17.095626,
                                                                                                                                                        27.612852,
                                                                                                                                                        15.417729,
                                                                                                                                                        26.069663,
                                                                                                                                                        13.856934,
                                                                                                                                                        27.650215,
                                                                                                                                                        16.811831,
                                                                                                                                                        3.012544,
                                                                                                                                                        15.417729,
                                                                                                                                                        26.069663,
                                                                                                                                                        17.095626,
                                                                                                                                                        27.612852,
                                                                                                                                                        15.417729,
                                                                                                                                                        26.069663,
                                                                                                                                                        16.811831,
                                                                                                                                                        3.012544,
                                                                                                                                                        15.417728,
                                                                                                                                                        19.909663,
                                                                                                                                                        16.811831,
                                                                                                                                                        3.012544,
                                                                                                                                                        13.573139,
                                                                                                                                                        3.049906,
                                                                                                                                                        15.417728,
                                                                                                                                                        19.909663,
                                                                                                                                                        16.775677,
                                                                                                                                                        3.810913,
                                                                                                                                                        16.821988,
                                                                                                                                                        3.458417,
                                                                                                                                                        13.536769,
                                                                                                                                                        3.810671,
                                                                                                                                                        17.033149, -0.656974,
                                                                                                                                                        20.272052, -0.662164,
                                                                                                                                                        16.9863, -1.009399,
                                                                                                                                                        19.949837,
                                                                                                                                                        3.81469,
                                                                                                                                                        16.811831,
                                                                                                                                                        3.012544,
                                                                                                                                                        17.095626,
                                                                                                                                                        27.612852,
                                                                                                                                                        20.214292,
                                                                                                                                                        26.738528,
                                                                                                                                                        19.949837,
                                                                                                                                                        3.81469,
                                                                                                                                                        17.095626,
                                                                                                                                                        27.612852,
                                                                                                                                                        22.773308,
                                                                                                                                                        5.401679,
                                                                                                                                                        19.949837,
                                                                                                                                                        3.81469,
                                                                                                                                                        20.214292,
                                                                                                                                                        26.738528,
                                                                                                                                                        19.241555, -5.881458,
                                                                                                                                                        22.480446, -5.891719,
                                                                                                                                                        19.194156, -6.23381,
                                                                                                                                                        22.525616, -6.244364,
                                                                                                                                                        19.194156, -6.23381,
                                                                                                                                                        22.480446, -5.891719,
                                                                                                                                                        19.208646, -4.854323,
                                                                                                                                                        22.540121, -4.857873,
                                                                                                                                                        19.1626, -5.209576,
                                                                                                                                                        22.585423, -5.213224,
                                                                                                                                                        19.1626, -5.209576,
                                                                                                                                                        22.540121, -4.857873,
                                                                                                                                                        19.165663, -3.791917,
                                                                                                                                                        22.588488, -3.794157,
                                                                                                                                                        19.120975, -4.152595,
                                                                                                                                                        22.632725, -4.154893,
                                                                                                                                                        19.120975, -4.152595,
                                                                                                                                                        22.588488, -3.794157,
                                                                                                                                                        19.122379, -2.714591,
                                                                                                                                                        22.634128, -2.716289,
                                                                                                                                                        19.07955, -3.082893,
                                                                                                                                                        22.67663, -3.084633,
                                                                                                                                                        19.07955, -3.082893,
                                                                                                                                                        22.634128, -2.716289,
                                                                                                                                                        19.080389, -1.66072,
                                                                                                                                                        22.677468, -1.662132,
                                                                                                                                                        19.039954, -2.038335,
                                                                                                                                                        22.717644, -2.039779,
                                                                                                                                                        19.039954, -2.038335,
                                                                                                                                                        22.677468, -1.662132,
                                                                                                                                                        19.040531, -0.660262,
                                                                                                                                                        22.718221, -0.661503,
                                                                                                                                                        19.003007, -1.048289,
                                                                                                                                                        22.755528, -1.049555,
                                                                                                                                                        19.003007, -1.048289,
                                                                                                                                                        22.718221, -0.661503,
                                                                                                                                                        19.003441,
                                                                                                                                                        0.267699,
                                                                                                                                                        22.755962,
                                                                                                                                                        0.266567,
                                                                                                                                                        18.969315, -0.131229,
                                                                                                                                                        20.564471,
                                                                                                                                                        3.243247,
                                                                                                                                                        16.743887,
                                                                                                                                                        3.243829,
                                                                                                                                                        20.530487,
                                                                                                                                                        3.642187,
                                                                                                                                                        16.743957,
                                                                                                                                                        4.030053,
                                                                                                                                                        20.564541,
                                                                                                                                                        4.029518,
                                                                                                                                                        16.713714,
                                                                                                                                                        3.620321,
                                                                                                                                                        20.594699,
                                                                                                                                                        3.619777,
                                                                                                                                                        16.713714,
                                                                                                                                                        3.620321,
                                                                                                                                                        20.564541,
                                                                                                                                                        4.029518,
                                                                                                                                                        16.713776,
                                                                                                                                                        4.323776,
                                                                                                                                                        20.59476,
                                                                                                                                                        4.323265,
                                                                                                                                                        16.687766,
                                                                                                                                                        3.903878,
                                                                                                                                                        20.620691,
                                                                                                                                                        3.90336,
                                                                                                                                                        16.687766,
                                                                                                                                                        3.903878,
                                                                                                                                                        20.59476,
                                                                                                                                                        4.323265,
                                                                                                                                                        16.687821,
                                                                                                                                                        4.533268,
                                                                                                                                                        20.620747,
                                                                                                                                                        4.532774,
                                                                                                                                                        16.666385,
                                                                                                                                                        4.104311,
                                                                                                                                                        20.642109,
                                                                                                                                                        4.103812,
                                                                                                                                                        16.666385,
                                                                                                                                                        4.104311,
                                                                                                                                                        20.620747,
                                                                                                                                                        4.532774,
                                                                                                                                                        16.666436,
                                                                                                                                                        4.668595,
                                                                                                                                                        20.64216,
                                                                                                                                                        4.668113,
                                                                                                                                                        16.649855,
                                                                                                                                                        4.23208,
                                                                                                                                                        17.144331,
                                                                                                                                                        5.95155,
                                                                                                                                                        17.160879,
                                                                                                                                                        5.515033,
                                                                                                                                                        13.168607,
                                                                                                                                                        5.951528,
                                                                                                                                                        13.152063,
                                                                                                                                                        5.515011,
                                                                                                                                                        13.168607,
                                                                                                                                                        5.951528,
                                                                                                                                                        17.160879,
                                                                                                                                                        5.515033,
                                                                                                                                                        12.613329,
                                                                                                                                                        6.929846,
                                                                                                                                                        12.629913,
                                                                                                                                                        6.493331,
                                                                                                                                                        8.637605,
                                                                                                                                                        6.929321,
                                                                                                                                                        8.621097,
                                                                                                                                                        6.492801,
                                                                                                                                                        8.637605,
                                                                                                                                                        6.929321,
                                                                                                                                                        12.629913,
                                                                                                                                                        6.493331,
                                                                                                                                                        7.358074,
                                                                                                                                                        7.536151,
                                                                                                                                                        7.374691,
                                                                                                                                                        7.099636,
                                                                                                                                                        3.382349,
                                                                                                                                                        7.535159,
                                                                                                                                                        3.365876,
                                                                                                                                                        7.098635,
                                                                                                                                                        3.382349,
                                                                                                                                                        7.535159,
                                                                                                                                                        7.374691,
                                                                                                                                                        7.099636,
                                                                                                                                                        7.374829,
                                                                                                                                                        6.703113,
                                                                                                                                                        7.386373,
                                                                                                                                                        6.26085,
                                                                                                                                                        3.366013,
                                                                                                                                                        6.702136,
                                                                                                                                                        8.609706,
                                                                                                                                                        5.845352,
                                                                                                                                                        8.621144,
                                                                                                                                                        6.287618,
                                                                                                                                                        12.641471,
                                                                                                                                                        5.845873,
                                                                                                                                                        12.62996,
                                                                                                                                                        6.288135,
                                                                                                                                                        12.641471,
                                                                                                                                                        5.845873,
                                                                                                                                                        8.621144,
                                                                                                                                                        6.287618,
                                                                                                                                                        13.14059,
                                                                                                                                                        5.175942,
                                                                                                                                                        13.152063,
                                                                                                                                                        5.618206,
                                                                                                                                                        17.172355,
                                                                                                                                                        5.175964,
                                                                                                                                                        17.160879,
                                                                                                                                                        5.618228,
                                                                                                                                                        17.172355,
                                                                                                                                                        5.175964,
                                                                                                                                                        13.152063,
                                                                                                                                                        5.618206,
                                                                                                                                                        3.354608,
                                                                                                                                                        6.259867,
                                                                                                                                                        3.366013,
                                                                                                                                                        6.702136,
                                                                                                                                                        7.386373,
                                                                                                                                                        6.26085,
                                                                                                                                                        3.382196,
                                                                                                                                                        7.876763,
                                                                                                                                                        3.403519,
                                                                                                                                                        8.305731,
                                                                                                                                                        7.35792,
                                                                                                                                                        7.87779,
                                                                                                                                                        7.336445,
                                                                                                                                                        8.306747,
                                                                                                                                                        7.35792,
                                                                                                                                                        7.87779,
                                                                                                                                                        3.403519,
                                                                                                                                                        8.305731,
                                                                                                                                                        8.637553,
                                                                                                                                                        7.079244,
                                                                                                                                                        8.658912,
                                                                                                                                                        7.508206,
                                                                                                                                                        12.613277,
                                                                                                                                                        7.079787,
                                                                                                                                                        12.591838,
                                                                                                                                                        7.508744,
                                                                                                                                                        12.613277,
                                                                                                                                                        7.079787,
                                                                                                                                                        8.658912,
                                                                                                                                                        7.508206,
                                                                                                                                                        13.168607,
                                                                                                                                                        5.792463,
                                                                                                                                                        13.190004,
                                                                                                                                                        6.221422,
                                                                                                                                                        17.144331,
                                                                                                                                                        5.792486,
                                                                                                                                                        17.12293,
                                                                                                                                                        6.221445,
                                                                                                                                                        17.144331,
                                                                                                                                                        5.792486,
                                                                                                                                                        13.190004,
                                                                                                                                                        6.221422,
                                                                                                                                                        13.190004,
                                                                                                                                                        5.996651,
                                                                                                                                                        13.215973,
                                                                                                                                                        6.416551,
                                                                                                                                                        17.12293,
                                                                                                                                                        5.996675,
                                                                                                                                                        12.565762,
                                                                                                                                                        8.01242,
                                                                                                                                                        12.591776,
                                                                                                                                                        7.592522,
                                                                                                                                                        8.684778,
                                                                                                                                                        8.011863,
                                                                                                                                                        8.65885,
                                                                                                                                                        7.591958,
                                                                                                                                                        8.684778,
                                                                                                                                                        8.011863,
                                                                                                                                                        12.591776,
                                                                                                                                                        7.592522,
                                                                                                                                                        7.310215,
                                                                                                                                                        9.001824,
                                                                                                                                                        7.336267,
                                                                                                                                                        8.581927,
                                                                                                                                                        3.429231,
                                                                                                                                                        9.000773,
                                                                                                                                                        3.403341,
                                                                                                                                                        8.580862,
                                                                                                                                                        3.429231,
                                                                                                                                                        9.000773,
                                                                                                                                                        7.336267,
                                                                                                                                                        8.581927,
                                                                                                                                                        3.429015,
                                                                                                                                                        9.193864,
                                                                                                                                                        3.459127,
                                                                                                                                                        9.603613,
                                                                                                                                                        7.31,
                                                                                                                                                        9.194984,
                                                                                                                                                        7.279711,
                                                                                                                                                        9.604715,
                                                                                                                                                        7.31,
                                                                                                                                                        9.194984,
                                                                                                                                                        3.459127,
                                                                                                                                                        9.603613,
                                                                                                                                                        8.684702,
                                                                                                                                                        8.015282,
                                                                                                                                                        8.714856,
                                                                                                                                                        8.425023,
                                                                                                                                                        12.565687,
                                                                                                                                                        8.015875,
                                                                                                                                                        12.53544,
                                                                                                                                                        8.425606,
                                                                                                                                                        12.565687,
                                                                                                                                                        8.015875,
                                                                                                                                                        8.714856,
                                                                                                                                                        8.425023,
                                                                                                                                                        13.215972,
                                                                                                                                                        6.114164,
                                                                                                                                                        13.24617,
                                                                                                                                                        6.523899,
                                                                                                                                                        17.096957,
                                                                                                                                                        6.11419,
                                                                                                                                                        17.066755,
                                                                                                                                                        6.523924,
                                                                                                                                                        17.096957,
                                                                                                                                                        6.11419,
                                                                                                                                                        13.24617,
                                                                                                                                                        6.523899,
                                                                                                                                                        13.246169,
                                                                                                                                                        6.130143,
                                                                                                                                                        13.280199,
                                                                                                                                                        6.529077,
                                                                                                                                                        17.066754,
                                                                                                                                                        6.13017,
                                                                                                                                                        12.501259,
                                                                                                                                                        8.730063,
                                                                                                                                                        12.535343,
                                                                                                                                                        8.331134,
                                                                                                                                                        8.748738,
                                                                                                                                                        8.72944,
                                                                                                                                                        8.714758,
                                                                                                                                                        8.330499,
                                                                                                                                                        8.748738,
                                                                                                                                                        8.72944,
                                                                                                                                                        12.535343,
                                                                                                                                                        8.331134,
                                                                                                                                                        7.245309,
                                                                                                                                                        10.094783,
                                                                                                                                                        7.279439,
                                                                                                                                                        9.695855,
                                                                                                                                                        3.492788,
                                                                                                                                                        10.093605,
                                                                                                                                                        3.458855,
                                                                                                                                                        9.694656,
                                                                                                                                                        3.492788,
                                                                                                                                                        10.093605,
                                                                                                                                                        7.279439,
                                                                                                                                                        9.695855,
                                                                                                                                                        1.623503,
                                                                                                                                                        10.530274,
                                                                                                                                                        1.657672,
                                                                                                                                                        10.131345, -2.129018,
                                                                                                                                                        10.528622, -2.129579,
                                                                                                                                                        10.549942, -2.092322,
                                                                                                                                                        10.938006,
                                                                                                                                                        1.622942,
                                                                                                                                                        10.551791, -4.018879,
                                                                                                                                                        10.348556, -3.981271,
                                                                                                                                                        9.960526, -7.69657,
                                                                                                                                                        10.346348, -7.733792,
                                                                                                                                                        9.958273, -7.69657,
                                                                                                                                                        10.346348, -3.981271,
                                                                                                                                                        9.960526, -9.223134,
                                                                                                                                                        8.714701, -9.185505,
                                                                                                                                                        8.326666, -12.900824,
                                                                                                                                                        8.712247, -12.901481,
                                                                                                                                                        8.336734, -12.861432,
                                                                                                                                                        8.714416, -9.223792,
                                                                                                                                                        8.339588, -13.67292,
                                                                                                                                                        5.500756, -17.35061,
                                                                                                                                                        5.497811, -13.713489,
                                                                                                                                                        5.878381, -17.350439,
                                                                                                                                                        6.147776, -13.672749,
                                                                                                                                                        6.150308, -17.387633,
                                                                                                                                                        5.759681, -17.027156,
                                                                                                                                                        2.44269, -20.779676,
                                                                                                                                                        2.440203, -17.064784,
                                                                                                                                                        2.830743, -17.027524,
                                                                                                                                                        3.355863, -16.993307,
                                                                                                                                                        2.956906, -20.780045,
                                                                                                                                                        3.353639, -20.813891,
                                                                                                                                                        2.954642, -20.780045,
                                                                                                                                                        3.353639, -16.993307,
                                                                                                                                                        2.956906, -19.131774, -0.048847, -19.097577, -0.447814, -22.884295, -0.050833, -22.91816, -0.449837, -22.884295, -0.050833, -19.097577, -0.447814, -19.770646, -4.088251, -23.59123, -4.089894, -19.804813, -3.689274, -19.771493, -2.305933, -19.741172, -2.715713, -23.592077, -2.307443, -22.948857,
                                                                                                                                                        0.427945, -22.918806,
                                                                                                                                                        0.837744, -19.067873,
                                                                                                                                                        0.429833, -19.098222,
                                                                                                                                                        0.839603, -19.067873,
                                                                                                                                                        0.429833, -22.918806,
                                                                                                                                                        0.837744, -20.844232,
                                                                                                                                                        3.36962, -20.814198,
                                                                                                                                                        3.779413, -16.963248,
                                                                                                                                                        3.371734, -16.993614,
                                                                                                                                                        3.781494, -16.963248,
                                                                                                                                                        3.371734, -20.814198,
                                                                                                                                                        3.779413, -16.963515,
                                                                                                                                                        4.114254, -16.937391,
                                                                                                                                                        3.694328, -20.844498,
                                                                                                                                                        4.112269, -20.870316,
                                                                                                                                                        3.692317, -20.844498,
                                                                                                                                                        4.112269, -16.937391,
                                                                                                                                                        3.694328, -19.068415,
                                                                                                                                                        1.645428, -19.042308,
                                                                                                                                                        1.225494, -22.949399,
                                                                                                                                                        1.643655, -22.975234,
                                                                                                                                                        1.223698, -22.949399,
                                                                                                                                                        1.643655, -19.042308,
                                                                                                                                                        1.225494, -19.741876, -0.994216, -19.715795, -1.414158, -23.62286, -0.995656, -23.64872, -1.415618, -23.62286, -0.995656, -19.715795, -1.414158, -18.938241, -3.62503, -18.912192, -4.04498, -22.819225, -3.62604, -22.845118, -4.046004, -22.819225, -3.62604, -18.912192, -4.04498, -16.712409, -6.068135, -16.686399, -6.488091, -20.593394, -6.068645, -20.619325, -6.488608, -20.593394, -6.068645, -16.686399, -6.488091, -13.190093, -8.577458, -17.123019, -8.577434, -13.216062, -8.157497, -17.122999, -5.535088, -13.190073, -5.535111, -17.1444, -5.964099, -13.168676, -5.964122, -17.1444, -5.964099, -13.190073, -5.535111, -17.144382, -2.982821, -13.168658, -2.982843, -17.160929, -3.41938, -13.152113, -3.419402, -17.160929, -3.41938, -13.168658, -2.982843, -17.160913, -0.499162, -13.152097, -0.499184, -17.172389, -0.941455, -13.140624, -0.941478, -17.172389, -0.941455, -13.152097, -0.499184, -20.669644, -0.065956, -20.658203,
                                                                                                                                                        0.376338, -16.637879, -0.065479, -16.649387,
                                                                                                                                                        0.376812, -16.637879, -0.065479, -20.658203,
                                                                                                                                                        0.376338, -22.895921,
                                                                                                                                                        0.957964, -22.884513,
                                                                                                                                                        1.400258, -18.864156,
                                                                                                                                                        0.958909, -18.875697,
                                                                                                                                                        1.401198, -18.864156,
                                                                                                                                                        0.958909, -22.884513,
                                                                                                                                                        1.400258, -23.699505,
                                                                                                                                                        2.060881, -23.688126,
                                                                                                                                                        2.503174, -19.66774,
                                                                                                                                                        2.062229, -19.67931,
                                                                                                                                                        2.504514, -19.66774,
                                                                                                                                                        2.062229, -23.688126,
                                                                                                                                                        2.503174, -23.025583,
                                                                                                                                                        3.167941, -23.014226,
                                                                                                                                                        3.610232, -18.993819,
                                                                                                                                                        3.1696, -19.00541,
                                                                                                                                                        3.611881, -18.993819,
                                                                                                                                                        3.1696, -23.014226,
                                                                                                                                                        3.610232, -20.919992,
                                                                                                                                                        4.203884, -20.908648,
                                                                                                                                                        4.646172, -16.888227,
                                                                                                                                                        4.205741, -16.899833,
                                                                                                                                                        4.648018, -16.888227,
                                                                                                                                                        4.205741, -20.908648,
                                                                                                                                                        4.646172, -20.908441,
                                                                                                                                                        4.099278, -20.892032,
                                                                                                                                                        4.535829, -16.899626,
                                                                                                                                                        4.101167, -19.021682,
                                                                                                                                                        3.024333, -19.005014,
                                                                                                                                                        2.587791, -22.997405,
                                                                                                                                                        3.022659, -23.01383,
                                                                                                                                                        2.586103, -22.997405,
                                                                                                                                                        3.022659, -19.005014,
                                                                                                                                                        2.587791, -19.695449,
                                                                                                                                                        1.406537, -19.678805,
                                                                                                                                                        0.96999, -23.671173,
                                                                                                                                                        1.405177, -23.687621,
                                                                                                                                                        0.968618, -23.671173,
                                                                                                                                                        1.405177, -19.678805,
                                                                                                                                                        0.96999, -18.89183, -0.205633, -18.875215, -0.642185, -22.867554, -0.206586, -22.884031, -0.643146, -22.867554, -0.206586, -18.875215, -0.642185, -16.665664, -1.702639, -16.649083, -2.139196, -20.641388, -1.703121, -20.657899, -2.139681, -20.641388, -1.703121, -16.649083, -2.139196, -20.641058, -4.279486, -20.619695, -3.850473, -16.665334, -4.278987, -16.68677, -3.84998, -16.665334, -4.278987, -20.619695, -3.850473, -22.86703, -2.309504, -22.845704, -1.880491, -18.891306, -2.308517, -18.912778, -1.879515, -18.891306, -2.308517, -22.845704, -1.880491, -23.670626, -0.187989, -23.649331,
                                                                                                                                                        0.241022, -19.694902, -0.186581, -19.716405,
                                                                                                                                                        0.242415, -19.694902, -0.186581, -23.649331,
                                                                                                                                                        0.241022, -22.996979,
                                                                                                                                                        1.940843, -22.975707,
                                                                                                                                                        2.369851, -19.021255,
                                                                                                                                                        1.942576, -19.042782,
                                                                                                                                                        2.371565, -19.021255,
                                                                                                                                                        1.942576, -22.975707,
                                                                                                                                                        2.369851, -20.891812,
                                                                                                                                                        3.932132, -20.870555,
                                                                                                                                                        4.361134, -16.916088,
                                                                                                                                                        3.934071, -16.93763,
                                                                                                                                                        4.363052, -16.916088,
                                                                                                                                                        3.934071, -20.870555,
                                                                                                                                                        4.361134, -16.916308,
                                                                                                                                                        4.537703, -16.899626,
                                                                                                                                                        4.101167, -20.892032,
                                                                                                                                                        4.535829, -17.097047, -8.157473, -13.216062, -8.157497, -17.123019, -8.577434, -13.216086, -11.252207, -17.09707, -11.252181, -13.246284, -10.842406, -17.066868, -10.842381, -13.246284, -10.842406, -17.09707, -11.252181, -13.246312, -13.967969, -17.066896, -13.967942, -13.280342, -13.568967, -17.032862, -13.56894, -13.280342, -13.568967, -17.066896, -13.967942, -13.280378, -16.68648, -17.032899, -16.68645, -13.31779, -16.298377, -16.995481, -16.298348, -13.31779, -16.298377, -17.032899, -16.68645, -13.317839, -19.347384, -16.99553, -19.34735, -13.358142, -18.969694, -16.955222, -18.969661, -13.358142, -18.969694, -16.99553, -19.34735, -13.358215, -21.866253, -16.955295, -21.866212, -13.400876, -21.497879, -16.912626, -21.497839, -13.400876, -21.497879, -16.955295, -21.866212, -13.401003, -24.137394, -16.912753, -24.13734, -13.44546, -23.776648, -16.868285, -23.776595, -13.44546, -23.776648, -16.912753, -24.13734, -13.445746, -26.043758, -16.868571, -26.043673, -13.491411, -25.68843, -16.822888, -25.688347, -13.491411, -25.68843, -16.868571, -26.043673, -13.492794, -27.473817, -16.82427, -27.473572, -13.539052, -27.121305, -20.237165, -22.715016, -16.998261, -22.70989, -20.282892, -23.067597,
                                                                                                                                                        13.856934,
                                                                                                                                                        27.650215,
                                                                                                                                                        15.417729,
                                                                                                                                                        26.069663,
                                                                                                                                                        10.718928,
                                                                                                                                                        26.848069,
                                                                                                                                                        10.718928,
                                                                                                                                                        26.848069,
                                                                                                                                                        15.417729,
                                                                                                                                                        26.069663,
                                                                                                                                                        7.895457,
                                                                                                                                                        25.261079,
                                                                                                                                                        15.417729,
                                                                                                                                                        26.069663,
                                                                                                                                                        7.36598,
                                                                                                                                                        14.66473,
                                                                                                                                                        7.895457,
                                                                                                                                                        25.261079,
                                                                                                                                                        15.417728,
                                                                                                                                                        19.909663,
                                                                                                                                                        7.668364,
                                                                                                                                                        5.575933,
                                                                                                                                                        7.365982,
                                                                                                                                                        8.504729,
                                                                                                                                                        10.454473,
                                                                                                                                                        3.924231,
                                                                                                                                                        7.668364,
                                                                                                                                                        5.575933,
                                                                                                                                                        15.417728,
                                                                                                                                                        19.909663,
                                                                                                                                                        6.961064,
                                                                                                                                                        9.318696,
                                                                                                                                                        7.008508,
                                                                                                                                                        8.96635,
                                                                                                                                                        3.722174,
                                                                                                                                                        9.308017,
                                                                                                                                                        8.948788,
                                                                                                                                                        6.858161,
                                                                                                                                                        8.994458,
                                                                                                                                                        7.210741,
                                                                                                                                                        12.280259,
                                                                                                                                                        6.863979,
                                                                                                                                                        12.23336,
                                                                                                                                                        7.216397,
                                                                                                                                                        12.280259,
                                                                                                                                                        6.863979,
                                                                                                                                                        8.994458,
                                                                                                                                                        7.210741,
                                                                                                                                                        13.490511,
                                                                                                                                                        3.458168,
                                                                                                                                                        13.536769,
                                                                                                                                                        3.810671,
                                                                                                                                                        16.821988,
                                                                                                                                                        3.458417,
                                                                                                                                                        16.82213,
                                                                                                                                                        4.594576,
                                                                                                                                                        16.867813,
                                                                                                                                                        4.239276,
                                                                                                                                                        13.490654,
                                                                                                                                                        4.594492,
                                                                                                                                                        16.988027,
                                                                                                                                                        0.238839,
                                                                                                                                                        20.319503,
                                                                                                                                                        0.237045,
                                                                                                                                                        16.942165, -0.116438,
                                                                                                                                                        20.317773, -1.014737,
                                                                                                                                                        16.9863, -1.009399,
                                                                                                                                                        20.272052, -0.662164,
                                                                                                                                                        20.364989, -0.118282,
                                                                                                                                                        16.942165, -0.116438,
                                                                                                                                                        20.319503,
                                                                                                                                                        0.237045,
                                                                                                                                                        16.942586,
                                                                                                                                                        1.08781,
                                                                                                                                                        20.365411,
                                                                                                                                                        1.086678,
                                                                                                                                                        16.898009,
                                                                                                                                                        0.72712,
                                                                                                                                                        20.409759,
                                                                                                                                                        0.725958,
                                                                                                                                                        16.898009,
                                                                                                                                                        0.72712,
                                                                                                                                                        20.365411,
                                                                                                                                                        1.086678,
                                                                                                                                                        16.898225,
                                                                                                                                                        1.86954,
                                                                                                                                                        20.409975,
                                                                                                                                                        1.868682,
                                                                                                                                                        16.855478,
                                                                                                                                                        1.50123,
                                                                                                                                                        20.452558,
                                                                                                                                                        1.500351,
                                                                                                                                                        16.855478,
                                                                                                                                                        1.50123,
                                                                                                                                                        20.409975,
                                                                                                                                                        1.868682,
                                                                                                                                                        16.855619,
                                                                                                                                                        2.562487,
                                                                                                                                                        20.452699,
                                                                                                                                                        2.561773,
                                                                                                                                                        16.815248,
                                                                                                                                                        2.184867,
                                                                                                                                                        20.492939,
                                                                                                                                                        2.184137,
                                                                                                                                                        16.815248,
                                                                                                                                                        2.184867,
                                                                                                                                                        20.452699,
                                                                                                                                                        2.561773,
                                                                                                                                                        16.815353,
                                                                                                                                                        3.15464,
                                                                                                                                                        20.493044,
                                                                                                                                                        3.154013,
                                                                                                                                                        16.777883,
                                                                                                                                                        2.766611,
                                                                                                                                                        20.530404,
                                                                                                                                                        2.765971,
                                                                                                                                                        16.777883,
                                                                                                                                                        2.766611,
                                                                                                                                                        20.493044,
                                                                                                                                                        3.154013,
                                                                                                                                                        16.777967,
                                                                                                                                                        3.642759,
                                                                                                                                                        20.530487,
                                                                                                                                                        3.642187,
                                                                                                                                                        16.743887,
                                                                                                                                                        3.243829,
                                                                                                                                                        17.03272,
                                                                                                                                                        6.529104,
                                                                                                                                                        17.066754,
                                                                                                                                                        6.13017,
                                                                                                                                                        13.280199,
                                                                                                                                                        6.529077,
                                                                                                                                                        13.280197,
                                                                                                                                                        6.029106,
                                                                                                                                                        13.31761,
                                                                                                                                                        6.417142,
                                                                                                                                                        17.032718,
                                                                                                                                                        6.029136,
                                                                                                                                                        12.463651,
                                                                                                                                                        8.904983,
                                                                                                                                                        12.501126,
                                                                                                                                                        8.516954,
                                                                                                                                                        8.785961,
                                                                                                                                                        8.904299,
                                                                                                                                                        8.748605,
                                                                                                                                                        8.516256,
                                                                                                                                                        8.785961,
                                                                                                                                                        8.904299,
                                                                                                                                                        12.501126,
                                                                                                                                                        8.516954,
                                                                                                                                                        7.207417,
                                                                                                                                                        10.447568,
                                                                                                                                                        7.244945,
                                                                                                                                                        10.059541,
                                                                                                                                                        3.529727,
                                                                                                                                                        10.446276,
                                                                                                                                                        3.492425,
                                                                                                                                                        10.058223,
                                                                                                                                                        3.529727,
                                                                                                                                                        10.446276,
                                                                                                                                                        7.244945,
                                                                                                                                                        10.059541,
                                                                                                                                                        1.585368,
                                                                                                                                                        10.939817,
                                                                                                                                                        1.622942,
                                                                                                                                                        10.551791, -2.092322,
                                                                                                                                                        10.938006, -2.093122,
                                                                                                                                                        10.801011, -2.053006,
                                                                                                                                                        11.17867,
                                                                                                                                                        1.584568,
                                                                                                                                                        10.803118, -4.060288,
                                                                                                                                                        10.526032, -4.019753,
                                                                                                                                                        10.148418, -7.657368,
                                                                                                                                                        10.523521, -7.697443,
                                                                                                                                                        10.14585, -7.657368,
                                                                                                                                                        10.523521, -4.019753,
                                                                                                                                                        10.148418, -9.264353,
                                                                                                                                                        8.717207, -9.223792,
                                                                                                                                                        8.339588, -12.861432,
                                                                                                                                                        8.714416, -12.862488,
                                                                                                                                                        8.177123, -12.820146,
                                                                                                                                                        8.545503, -9.26541,
                                                                                                                                                        8.180561, -13.713814,
                                                                                                                                                        5.099042, -17.310892,
                                                                                                                                                        5.095494, -13.756812,
                                                                                                                                                        5.467346, -17.310568,
                                                                                                                                                        5.875502, -13.713489,
                                                                                                                                                        5.878381, -17.35061,
                                                                                                                                                        5.497811, -17.064316,
                                                                                                                                                        1.826116, -20.742006,
                                                                                                                                                        1.823281, -17.104876,
                                                                                                                                                        2.203751, -20.742474,
                                                                                                                                                        2.828305, -17.064784,
                                                                                                                                                        2.830743, -20.779676,
                                                                                                                                                        2.440203, -19.130969, -1.405495, -22.883489, -1.407717, -19.168574, -1.017432, -22.846264, -1.01961, -19.168574, -1.017432, -22.883489, -1.407717, -19.167502, -2.433499, -22.845192, -2.436032, -19.208034, -2.055853, -22.805114, -2.05833, -19.208034, -2.055853, -22.845192, -2.436032, -19.206474, -3.512159, -22.803553, -3.51521, -19.249425, -3.143836, -22.761174, -3.146814, -19.249425, -3.143836, -22.803553, -3.51521, -19.246808, -4.611091, -22.758556, -4.615119, -19.291665, -4.250406, -22.714488, -4.254332, -19.291665, -4.250406, -22.758556, -4.615119, -19.285941, -5.693089, -22.70876, -5.699474, -19.332267, -5.337854, -22.663737, -5.344068, -19.332267, -5.337854, -22.70876, -5.699474, -19.305232, -6.757361, -22.636658, -6.775726, -19.353456, -6.405115, -22.592314, -6.42297, -19.353456, -6.405115, -22.636658, -6.775726,
                                                                                                                                                        5.578937,
                                                                                                                                                        22.997397,
                                                                                                                                                        5.404682,
                                                                                                                                                        7.892454,
                                                                                                                                                        3.927234,
                                                                                                                                                        20.211289,
                                                                                                                                                        7.668364,
                                                                                                                                                        5.575933,
                                                                                                                                                        5.404682,
                                                                                                                                                        7.892454,
                                                                                                                                                        5.578937,
                                                                                                                                                        22.997397,
                                                                                                                                                        1.325381,
                                                                                                                                                        9.974751,
                                                                                                                                                        1.37329,
                                                                                                                                                        9.622468, -1.913492,
                                                                                                                                                        9.95979,
                                                                                                                                                        3.67705,
                                                                                                                                                        8.955367,
                                                                                                                                                        3.722174,
                                                                                                                                                        9.308017,
                                                                                                                                                        7.008508,
                                                                                                                                                        8.96635,
                                                                                                                                                        7.026976,
                                                                                                                                                        9.972828,
                                                                                                                                                        7.073037,
                                                                                                                                                        9.617576,
                                                                                                                                                        3.695501,
                                                                                                                                                        9.969133,
                                                                                                                                                        8.910636,
                                                                                                                                                        7.558386,
                                                                                                                                                        8.956106,
                                                                                                                                                        7.913714,
                                                                                                                                                        12.333461,
                                                                                                                                                        7.560395,
                                                                                                                                                        12.287582,
                                                                                                                                                        7.91567,
                                                                                                                                                        12.333461,
                                                                                                                                                        7.560395,
                                                                                                                                                        8.956106,
                                                                                                                                                        7.913714,
                                                                                                                                                        13.444988,
                                                                                                                                                        4.23919,
                                                                                                                                                        13.490654,
                                                                                                                                                        4.594492,
                                                                                                                                                        16.867813,
                                                                                                                                                        4.239276,
                                                                                                                                                        16.867839,
                                                                                                                                                        5.261038,
                                                                                                                                                        16.912306,
                                                                                                                                                        4.900334,
                                                                                                                                                        13.445014,
                                                                                                                                                        5.260985,
                                                                                                                                                        13.400556,
                                                                                                                                                        4.90028,
                                                                                                                                                        13.445014,
                                                                                                                                                        5.260985,
                                                                                                                                                        16.912306,
                                                                                                                                                        4.900334,
                                                                                                                                                        12.334855,
                                                                                                                                                        8.443172,
                                                                                                                                                        12.379441,
                                                                                                                                                        8.082482,
                                                                                                                                                        8.91203,
                                                                                                                                                        8.441937,
                                                                                                                                                        8.867691,
                                                                                                                                                        8.081216,
                                                                                                                                                        8.91203,
                                                                                                                                                        8.441937,
                                                                                                                                                        12.379441,
                                                                                                                                                        8.082482,
                                                                                                                                                        7.076607,
                                                                                                                                                        10.415506,
                                                                                                                                                        7.121304,
                                                                                                                                                        10.054829,
                                                                                                                                                        3.653783,
                                                                                                                                                        10.413174,
                                                                                                                                                        3.609555,
                                                                                                                                                        10.052437,
                                                                                                                                                        3.653783,
                                                                                                                                                        10.413174,
                                                                                                                                                        7.121304,
                                                                                                                                                        10.054829,
                                                                                                                                                        1.452841,
                                                                                                                                                        11.043665,
                                                                                                                                                        1.497633,
                                                                                                                                                        10.682996, -1.969982,
                                                                                                                                                        11.040396, -2.014116,
                                                                                                                                                        10.679642, -1.969982,
                                                                                                                                                        11.040396,
                                                                                                                                                        1.497633,
                                                                                                                                                        10.682996, -4.151994,
                                                                                                                                                        10.285618, -4.107131,
                                                                                                                                                        9.924955, -7.574817,
                                                                                                                                                        10.281635, -7.618878,
                                                                                                                                                        9.920868, -7.574817,
                                                                                                                                                        10.281635, -4.107131,
                                                                                                                                                        9.924955, -9.355268,
                                                                                                                                                        8.194336, -9.31036,
                                                                                                                                                        7.833674, -12.77809,
                                                                                                                                                        8.18991, -12.822107,
                                                                                                                                                        7.829133, -12.77809,
                                                                                                                                                        8.18991, -9.31036,
                                                                                                                                                        7.833674, -13.7575,
                                                                                                                                                        4.553158, -17.269247,
                                                                                                                                                        4.548473, -13.802422,
                                                                                                                                                        4.913824, -17.26856,
                                                                                                                                                        5.463883, -13.756812,
                                                                                                                                                        5.467346, -17.310892,
                                                                                                                                                        5.095494, -17.104234,
                                                                                                                                                        1.110696, -20.701313,
                                                                                                                                                        1.107281, -17.14722,
                                                                                                                                                        1.479009, -20.701955,
                                                                                                                                                        2.200979, -17.104876,
                                                                                                                                                        2.203751, -20.742006,
                                                                                                                                                        1.823281, -20.658968,
                                                                                                                                                        1.475675, -17.14722,
                                                                                                                                                        1.479009, -20.701313,
                                                                                                                                                        1.107281, -17.146218,
                                                                                                                                                        0.308239, -20.657965,
                                                                                                                                                        0.303728, -17.191123,
                                                                                                                                                        0.668912, -20.613945,
                                                                                                                                                        0.664516, -17.191123,
                                                                                                                                                        0.668912, -20.657965,
                                                                                                                                                        0.303728, -17.189111, -0.562762, -20.611929, -0.569913, -17.235515, -0.207541, -20.566984, -0.214501, -17.235515, -0.207541, -20.611929, -0.569913, -17.226864, -1.517115, -20.558277, -1.537704, -17.275322, -1.164903, -20.514167, -1.18492, -17.275322, -1.164903, -20.558277, -1.537704,
                                                                                                                                                        3.927234,
                                                                                                                                                        20.211289,
                                                                                                                                                        3.817693,
                                                                                                                                                        10.715924,
                                                                                                                                                        3.05291,
                                                                                                                                                        17.092623,
                                                                                                                                                        5.404682,
                                                                                                                                                        7.892454,
                                                                                                                                                        3.817693,
                                                                                                                                                        10.715924,
                                                                                                                                                        3.927234,
                                                                                                                                                        20.211289, -4.283442,
                                                                                                                                                        9.143714, -4.23518,
                                                                                                                                                        8.791478, -7.522299,
                                                                                                                                                        9.125504, -1.958151,
                                                                                                                                                        9.607079, -1.913492,
                                                                                                                                                        9.95979,
                                                                                                                                                        1.37329,
                                                                                                                                                        9.622468,
                                                                                                                                                        1.401202,
                                                                                                                                                        10.625918,
                                                                                                                                                        1.44742,
                                                                                                                                                        10.270684, -1.93027,
                                                                                                                                                        10.620738,
                                                                                                                                                        3.650214,
                                                                                                                                                        9.61378,
                                                                                                                                                        3.695501,
                                                                                                                                                        9.969133,
                                                                                                                                                        7.073037,
                                                                                                                                                        9.617576, -1.975401,
                                                                                                                                                        10.265362, -1.93027,
                                                                                                                                                        10.620738,
                                                                                                                                                        1.44742,
                                                                                                                                                        10.270684, -4.204316,
                                                                                                                                                        9.83171, -4.15798,
                                                                                                                                                        9.476489, -7.535787,
                                                                                                                                                        9.825398, -7.580799,
                                                                                                                                                        9.470005, -7.535787,
                                                                                                                                                        9.825398, -4.15798,
                                                                                                                                                        9.476489, -9.406437,
                                                                                                                                                        7.646473, -9.360028,
                                                                                                                                                        7.291259, -12.737906,
                                                                                                                                                        7.639462, -12.782846,
                                                                                                                                                        7.284056, -12.737906,
                                                                                                                                                        7.639462, -9.360028,
                                                                                                                                                        7.291259, -13.804279,
                                                                                                                                                        3.866351, -17.227096,
                                                                                                                                                        3.858921, -13.850711,
                                                                                                                                                        4.221565, -17.225244,
                                                                                                                                                        4.909257, -13.802422,
                                                                                                                                                        4.913824, -17.269247,
                                                                                                                                                        4.548473, -17.18218,
                                                                                                                                                        4.214333, -13.850711,
                                                                                                                                                        4.221565, -17.227096,
                                                                                                                                                        3.858921, -13.861205,
                                                                                                                                                        3.018295, -17.192612,
                                                                                                                                                        2.996878, -13.90975,
                                                                                                                                                        3.370494, -17.148591,
                                                                                                                                                        3.349673, -13.90975,
                                                                                                                                                        3.370494, -17.192612,
                                                                                                                                                        2.996878,
                                                                                                                                                        3.015547,
                                                                                                                                                        13.853931,
                                                                                                                                                        3.05291,
                                                                                                                                                        17.092623,
                                                                                                                                                        3.817693,
                                                                                                                                                        10.715924, -9.479769,
                                                                                                                                                        6.888653, -9.431291,
                                                                                                                                                        6.536446, -12.718614,
                                                                                                                                                        6.868445, -7.566604,
                                                                                                                                                        8.772747, -7.522299,
                                                                                                                                                        9.125504, -4.23518,
                                                                                                                                                        8.791478, -12.762702,
                                                                                                                                                        6.515661, -12.718614,
                                                                                                                                                        6.868445, -9.431291,
                                                                                                                                                        6.536446, -9.308397,
                                                                                                                                                        8.54886, -9.26541,
                                                                                                                                                        8.180561, -12.820146,
                                                                                                                                                        8.545503, -7.658744,
                                                                                                                                                        10.141233, -7.616369,
                                                                                                                                                        10.509603, -4.061665,
                                                                                                                                                        10.144327, -4.10462,
                                                                                                                                                        10.512623, -4.061665,
                                                                                                                                                        10.144327, -7.616369,
                                                                                                                                                        10.509603, -2.054262,
                                                                                                                                                        10.852888, -2.011835,
                                                                                                                                                        11.221246,
                                                                                                                                                        1.542817,
                                                                                                                                                        10.855427,
                                                                                                                                                        1.499914,
                                                                                                                                                        11.223724,
                                                                                                                                                        1.542817,
                                                                                                                                                        10.855427, -2.011835,
                                                                                                                                                        11.221246,
                                                                                                                                                        3.568556,
                                                                                                                                                        10.262636,
                                                                                                                                                        3.611051,
                                                                                                                                                        10.630981,
                                                                                                                                                        7.165635,
                                                                                                                                                        10.264447,
                                                                                                                                                        7.1228,
                                                                                                                                                        10.632748,
                                                                                                                                                        7.165635,
                                                                                                                                                        10.264447,
                                                                                                                                                        3.611051,
                                                                                                                                                        10.630981,
                                                                                                                                                        8.825691,
                                                                                                                                                        8.410136,
                                                                                                                                                        8.868266,
                                                                                                                                                        8.778468,
                                                                                                                                                        12.422771,
                                                                                                                                                        8.411094,
                                                                                                                                                        12.380016,
                                                                                                                                                        8.779403,
                                                                                                                                                        12.422771,
                                                                                                                                                        8.411094,
                                                                                                                                                        8.868266,
                                                                                                                                                        8.778468,
                                                                                                                                                        13.357905,
                                                                                                                                                        5.421605,
                                                                                                                                                        13.400566,
                                                                                                                                                        5.789925,
                                                                                                                                                        16.954985,
                                                                                                                                                        5.421646,
                                                                                                                                                        16.912316,
                                                                                                                                                        5.789965,
                                                                                                                                                        16.954985,
                                                                                                                                                        5.421646,
                                                                                                                                                        13.400566,
                                                                                                                                                        5.789925,
                                                                                                                                                        16.95499,
                                                                                                                                                        6.174227,
                                                                                                                                                        16.995298,
                                                                                                                                                        5.796601,
                                                                                                                                                        13.35791,
                                                                                                                                                        6.174194,
                                                                                                                                                        13.317607,
                                                                                                                                                        5.796567,
                                                                                                                                                        13.35791,
                                                                                                                                                        6.174194,
                                                                                                                                                        16.995298,
                                                                                                                                                        5.796601,
                                                                                                                                                        12.423081,
                                                                                                                                                        8.928313,
                                                                                                                                                        12.463458,
                                                                                                                                                        8.550694,
                                                                                                                                                        8.826001,
                                                                                                                                                        8.927535,
                                                                                                                                                        8.785767,
                                                                                                                                                        8.549899,
                                                                                                                                                        8.826001,
                                                                                                                                                        8.927535,
                                                                                                                                                        12.463458,
                                                                                                                                                        8.550694,
                                                                                                                                                        7.166456,
                                                                                                                                                        10.635931,
                                                                                                                                                        7.206896,
                                                                                                                                                        10.258317,
                                                                                                                                                        3.569377,
                                                                                                                                                        10.634462,
                                                                                                                                                        3.529206,
                                                                                                                                                        10.256814,
                                                                                                                                                        3.569377,
                                                                                                                                                        10.634462,
                                                                                                                                                        7.206896,
                                                                                                                                                        10.258317,
                                                                                                                                                        1.544074,
                                                                                                                                                        11.180731,
                                                                                                                                                        1.584568,
                                                                                                                                                        10.803118, -2.053006,
                                                                                                                                                        11.17867,
                                                                                                                                                        16.995301,
                                                                                                                                                        6.417171,
                                                                                                                                                        17.032718,
                                                                                                                                                        6.029136,
                                                                                                                                                        13.31761,
                                                                                                                                                        6.417142,
                                                                                                                                                        7.365982,
                                                                                                                                                        8.504729,
                                                                                                                                                        7.668364,
                                                                                                                                                        5.575933,
                                                                                                                                                        5.578937,
                                                                                                                                                        22.997397,
                                                                                                                                                        7.36598,
                                                                                                                                                        14.66473,
                                                                                                                                                        7.365982,
                                                                                                                                                        8.504729,
                                                                                                                                                        5.578937,
                                                                                                                                                        22.997397,
                                                                                                                                                        5.578937,
                                                                                                                                                        22.997397,
                                                                                                                                                        7.895457,
                                                                                                                                                        25.261079,
                                                                                                                                                        7.36598,
                                                                                                                                                        14.66473, -23.248523, -12.007793, -20.009648, -11.993305, -23.293233, -12.360503, -19.96179, -12.345601, -23.293233, -12.360503, -20.009648, -11.993305, -23.331918, -10.824867, -20.000445, -10.819819, -23.377063, -11.180259, -19.954242, -11.175073, -23.377063, -11.180259, -20.000445, -10.819819, -23.385122, -9.512115, -19.962299, -9.508926, -23.429264, -9.872896, -19.917516, -9.869624, -23.429264, -9.872896, -19.962299, -9.508926, -23.432886, -8.088594, -19.921137, -8.086175, -23.475319, -8.456989, -19.878239, -8.454511, -23.475319, -8.456989, -19.921137, -8.086175, -23.477444, -6.612181, -19.880365, -6.610169, -23.517565, -6.989883, -19.839875, -6.987826, -23.517565, -6.989883, -19.880365, -6.610169, -23.519005, -5.133755, -19.841314, -5.131986, -23.556265, -5.521866, -19.803745, -5.520061, -23.556265, -5.521866, -19.841314, -5.131986, -23.557333, -3.690887, -19.804813, -3.689274, -23.59123, -4.089894, -19.001155, -7.317643, -18.967029, -7.71663, -22.753676, -7.318774, -22.787613, -7.717782, -22.753676, -7.318774, -18.967029, -7.71663, -16.775783, -10.687216, -16.741703, -11.086212, -20.528304, -10.687788, -20.562288, -11.086794, -20.528304, -10.687788, -16.741703, -11.086212, -16.742223, -8.352477, -16.71198, -8.762273, -20.562807, -8.353013, -22.818547, -5.851888, -22.788431, -5.442083, -18.937562, -5.850812, -18.967847, -5.441024, -18.937562, -5.850812, -22.788431, -5.442083, -23.622156, -2.717247, -23.592077, -2.307443, -19.741172, -2.715713, -20.592964, -8.762817, -20.562807, -8.353013, -16.71198, -8.762273, -16.775123, -13.429391, -20.527643, -13.43003, -16.812592, -13.041296, -20.490283, -13.041923, -16.812592, -13.041296, -20.527643, -13.43003, -16.811695, -15.742264, -20.489386, -15.742993, -16.852066, -15.364584, -20.449146, -15.365297, -16.852066, -15.364584, -20.489386, -15.742993, -16.850729, -17.954236, -20.447809, -17.955114, -16.893477, -17.585874, -20.405227, -17.586732, -16.893477, -17.585874, -20.447809, -17.955114, -16.891176, -19.975741, -20.402926, -19.9769, -16.935752, -19.615011, -20.358577, -19.61614, -16.935752, -19.615011, -20.402926, -19.9769, -16.93058, -21.707003, -20.353405, -21.708839, -16.976442, -21.351701, -20.307918, -21.353488, -16.976442, -21.351701, -20.353405, -21.708839, -16.95142, -23.062324, -20.282892, -23.067597, -16.998261, -22.70989, -22.444087, -17.562572, -19.205195, -17.552425, -22.489269, -17.915223, -19.157809, -17.904786, -22.489269, -17.915223, -19.205195, -17.552425, -22.528007, -16.284656, -19.196533, -16.281119, -22.573311, -16.64003, -19.150488, -16.636396, -22.573311, -16.64003, -19.196533, -16.281119, -22.581337, -14.751297, -19.158513, -14.749062, -22.625575, -15.112069, -19.113826, -15.109776, -22.625575, -15.112069, -19.158513, -14.749062, -22.629158, -13.013457, -19.117408, -13.011761, -22.67166, -13.381847, -19.07458, -13.38011, -22.67166, -13.381847, -19.117408, -13.011761, -22.673749, -11.150682, -19.076669, -11.149272, -22.713925, -11.528383, -19.036234, -11.526941, -22.713925, -11.528383, -19.076669, -11.149272, -22.715331, -9.23413, -19.03764, -9.23289, -22.752638, -9.622241, -19.000117, -9.620975, -22.752638, -9.622241, -19.03764, -9.23289,
                                                                                                                                                        13.573139,
                                                                                                                                                        3.049906,
                                                                                                                                                        10.454473,
                                                                                                                                                        3.924231,
                                                                                                                                                        15.417728,
                                                                                                                                                        19.909663, -8.977712, -28.997831, -8.932242, -29.353184, -12.309188, -28.995882, -12.355067, -29.351182, -12.309188, -28.995882, -8.932242, -29.353184, -3.740878, -31.055536, -3.695589, -31.410911, -7.072352, -31.051854, -7.118412, -31.407129, -7.072352, -31.051854, -3.695589, -31.410911,
                                                                                                                                                        1.864573, -31.721267,
                                                                                                                                                        1.909706, -32.076661, -1.466899, -31.716102, -1.513115, -32.071354, -1.466899, -31.716102,
                                                                                                                                                        1.909706, -32.076661,
                                                                                                                                                        7.458663, -30.948408,
                                                                                                                                                        7.503677, -31.303814,
                                                                                                                                                        4.127193, -30.942109,
                                                                                                                                                        4.080858, -31.297343,
                                                                                                                                                        4.127193, -30.942109,
                                                                                                                                                        7.503677, -31.303814,
                                                                                                                                                        12.661312, -28.787507,
                                                                                                                                                        12.706252, -29.14292,
                                                                                                                                                        9.329842, -28.780503,
                                                                                                                                                        9.283434, -29.135724,
                                                                                                                                                        9.329842, -28.780503,
                                                                                                                                                        12.706252, -29.14292,
                                                                                                                                                        12.732944, -26.738816,
                                                                                                                                                        12.776962, -27.099603,
                                                                                                                                                        9.310122, -26.734392,
                                                                                                                                                        4.061669, -29.171917,
                                                                                                                                                        4.106532, -28.811233,
                                                                                                                                                        7.573417, -29.175999,
                                                                                                                                                        7.529355, -28.815212,
                                                                                                                                                        7.573417, -29.175999,
                                                                                                                                                        4.106532, -28.811233, -1.536362, -29.917631, -1.491571, -29.556934,
                                                                                                                                                        1.975387, -29.92098,
                                                                                                                                                        1.931252, -29.560198,
                                                                                                                                                        1.975387, -29.92098, -1.491571, -29.556934, -7.148056, -29.282689, -7.10336, -28.921977, -3.636307, -29.285076, -3.680536, -28.924303, -3.636307, -29.285076, -7.10336, -28.921977, -12.392181, -27.311129, -12.347595, -26.9504, -8.880431, -27.312392, -8.92477, -26.951631, -8.880431, -27.312392, -12.347595, -26.9504, -8.877118, -24.482103, -8.834543, -24.850486, -12.388868, -24.481169, -12.431623, -24.849529, -12.388868, -24.481169, -8.834543, -24.850486, -3.629637, -26.335696, -3.587142, -26.704086, -7.141387, -26.33393, -7.184222, -26.702278, -7.141387, -26.33393, -3.587142, -26.704086,
                                                                                                                                                        1.984929, -26.932314,
                                                                                                                                                        2.027356, -27.300709, -1.526821, -26.929839, -1.569723, -27.298174, -1.526821, -26.929839,
                                                                                                                                                        2.027356, -27.300709,
                                                                                                                                                        7.584787, -26.23074,
                                                                                                                                                        7.627162, -26.599136,
                                                                                                                                                        4.073038, -26.227722,
                                                                                                                                                        4.030083, -26.596044,
                                                                                                                                                        4.073038, -26.227722,
                                                                                                                                                        7.627162, -26.599136,
                                                                                                                                                        12.788785, -24.277833,
                                                                                                                                                        12.831127, -24.646227,
                                                                                                                                                        9.277036, -24.274478,
                                                                                                                                                        9.265215, -27.095065,
                                                                                                                                                        9.310122, -26.734392,
                                                                                                                                                        12.776962, -27.099603, -3.583281, -23.427468, -3.54311, -23.805169, -7.180361, -23.426, -12.47008, -22.096556, -12.429703, -21.718877, -8.792389, -22.09735, -8.832624, -21.719654, -8.792389, -22.09735, -12.429703, -21.718877, -8.791105, -18.782775, -8.75375, -19.170883, -12.468796, -18.782092,
                                                                                                                                                        9.19975, -30.670621,
                                                                                                                                                        9.248222, -30.318411,
                                                                                                                                                        12.531162, -30.691341, -7.733182,
                                                                                                                                                        10.005159, -3.980662,
                                                                                                                                                        10.007173, -7.767046,
                                                                                                                                                        9.60619,
                                                                                                                                                        17.096957,
                                                                                                                                                        6.416575,
                                                                                                                                                        17.12293,
                                                                                                                                                        5.996675,
                                                                                                                                                        13.215973,
                                                                                                                                                        6.416551,
                                                                                                                                                        19.841488, -4.766876,
                                                                                                                                                        23.519178, -4.768646,
                                                                                                                                                        19.803918, -5.154903,
                                                                                                                                                        23.517787, -6.586434,
                                                                                                                                                        19.840097, -6.584375,
                                                                                                                                                        23.477667, -6.208775,
                                                                                                                                                        19.880587, -6.206762,
                                                                                                                                                        23.477667, -6.208775,
                                                                                                                                                        19.840097, -6.584375,
                                                                                                                                                        23.475613, -8.019758,
                                                                                                                                                        19.878534, -8.017277,
                                                                                                                                                        23.433181, -7.651402,
                                                                                                                                                        19.921432, -7.64898,
                                                                                                                                                        23.433181, -7.651402,
                                                                                                                                                        19.878534, -8.017277,
                                                                                                                                                        23.429682, -9.408106,
                                                                                                                                                        19.917933, -9.404828,
                                                                                                                                                        23.385541, -9.047354,
                                                                                                                                                        19.962717, -9.044159,
                                                                                                                                                        23.385541, -9.047354,
                                                                                                                                                        19.917933, -9.404828,
                                                                                                                                                        23.377749, -10.695895,
                                                                                                                                                        19.954927, -10.690694,
                                                                                                                                                        23.332605, -10.340521,
                                                                                                                                                        20.001132, -10.335459,
                                                                                                                                                        23.332605, -10.340521,
                                                                                                                                                        19.954927, -10.690694,
                                                                                                                                                        23.294958, -11.866746,
                                                                                                                                                        19.963515, -11.851707,
                                                                                                                                                        23.250262, -11.51404,
                                                                                                                                                        20.011387, -11.499418,
                                                                                                                                                        23.250262, -11.51404,
                                                                                                                                                        19.963515, -11.851707,
                                                                                                                                                        25.089828,
                                                                                                                                                        7.665361,
                                                                                                                                                        22.773308,
                                                                                                                                                        5.401679,
                                                                                                                                                        23.000401,
                                                                                                                                                        25.086825,
                                                                                                                                                        23.000401,
                                                                                                                                                        25.086825,
                                                                                                                                                        22.773308,
                                                                                                                                                        5.401679,
                                                                                                                                                        20.214292,
                                                                                                                                                        26.738528,
                                                                                                                                                        25.264082,
                                                                                                                                                        22.770305,
                                                                                                                                                        25.089828,
                                                                                                                                                        7.665361,
                                                                                                                                                        23.000401,
                                                                                                                                                        25.086825,
                                                                                                                                                        3.966146, -17.050706,
                                                                                                                                                        7.718666, -17.052719,
                                                                                                                                                        3.931946, -17.449672,
                                                                                                                                                        7.75253, -17.451722,
                                                                                                                                                        3.931946, -17.449672,
                                                                                                                                                        7.718666, -17.052719,
                                                                                                                                                        3.934477, -13.850347,
                                                                                                                                                        7.75506, -13.852231,
                                                                                                                                                        3.904126, -14.260117,
                                                                                                                                                        7.78511, -14.262031,
                                                                                                                                                        3.904126, -14.260117,
                                                                                                                                                        7.75506, -13.852231,
                                                                                                                                                        3.906214, -10.68127,
                                                                                                                                                        7.787198, -10.683067,
                                                                                                                                                        3.880105, -11.101203,
                                                                                                                                                        7.81303, -11.103024,
                                                                                                                                                        3.880105, -11.101203,
                                                                                                                                                        7.787198, -10.683067,
                                                                                                                                                        3.8819, -7.570451,
                                                                                                                                                        7.814826, -7.572188,
                                                                                                                                                        3.860372, -7.99944,
                                                                                                                                                        7.836096, -8.001195,
                                                                                                                                                        3.860372, -7.99944,
                                                                                                                                                        7.814826, -7.572188,
                                                                                                                                                        3.861972, -4.529056,
                                                                                                                                                        7.837695, -4.530752,
                                                                                                                                                        3.845303, -4.965597,
                                                                                                                                                        7.854118, -4.967307,
                                                                                                                                                        3.845303, -4.965597,
                                                                                                                                                        7.837695, -4.530752,
                                                                                                                                                        3.846772, -1.557274,
                                                                                                                                                        7.855588, -1.558945,
                                                                                                                                                        3.835179, -1.999555,
                                                                                                                                                        7.866944, -2.001235,
                                                                                                                                                        3.835179, -1.999555,
                                                                                                                                                        7.855588, -1.558945,
                                                                                                                                                        2.263548, -2.158361, -1.768217, -2.156982,
                                                                                                                                                        2.252171, -1.716068, -1.756645, -1.714697,
                                                                                                                                                        2.252171, -1.716068, -1.768217, -2.156982,
                                                                                                                                                        2.250938, -5.197244, -1.757878, -5.195841,
                                                                                                                                                        2.234493, -4.760686, -1.741231, -4.759294,
                                                                                                                                                        2.234493, -4.760686, -1.757878, -5.195841,
                                                                                                                                                        2.233151, -8.304018, -1.742573, -8.302578,
                                                                                                                                                        2.211858, -7.875007, -1.721067, -7.873582,
                                                                                                                                                        2.211858, -7.875007, -1.742573, -8.302578,
                                                                                                                                                        2.210352, -11.478546, -1.722573, -11.477052,
                                                                                                                                                        2.184495, -11.058584, -1.696489, -11.057111,
                                                                                                                                                        2.184495, -11.058584, -1.722573, -11.477052,
                                                                                                                                                        2.182743, -14.709522, -1.698241, -14.707951,
                                                                                                                                                        2.152667, -14.299718, -1.667917, -14.298173,
                                                                                                                                                        2.152667, -14.299718, -1.698241, -14.707951, -1.67004, -17.96784, -1.63587, -17.568864,
                                                                                                                                                        2.150544, -17.969522,
                                                                                                                                                        2.11665, -17.570515,
                                                                                                                                                        2.150544, -17.969522, -1.63587, -17.568864,
                                                                                                                                                        19.019481, -2.125947,
                                                                                                                                                        19.041008, -1.696985,
                                                                                                                                                        22.995205, -2.127679,
                                                                                                                                                        22.973934, -1.698699,
                                                                                                                                                        22.995205, -2.127679,
                                                                                                                                                        19.041008, -1.696985,
                                                                                                                                                        16.91216, -4.11733,
                                                                                                                                                        16.933702, -3.688363,
                                                                                                                                                        20.887884, -4.11927,
                                                                                                                                                        20.866628, -3.690281,
                                                                                                                                                        20.887884, -4.11927,
                                                                                                                                                        16.933702, -3.688363,
                                                                                                                                                        13.516832, -5.833393,
                                                                                                                                                        13.53838, -5.40442,
                                                                                                                                                        17.492556, -5.835407,
                                                                                                                                                        17.471305, -5.406412,
                                                                                                                                                        17.492556, -5.835407,
                                                                                                                                                        13.53838, -5.40442,
                                                                                                                                                        13.536649, -8.415714,
                                                                                                                                                        13.562778, -7.995797,
                                                                                                                                                        17.469574, -8.417802,
                                                                                                                                                        20.839394, -5.870304,
                                                                                                                                                        20.865212, -6.29024,
                                                                                                                                                        16.95841, -5.86832,
                                                                                                                                                        16.932286, -6.288229,
                                                                                                                                                        16.95841, -5.86832,
                                                                                                                                                        20.865212, -6.29024,
                                                                                                                                                        22.947094, -3.401373,
                                                                                                                                                        22.972928, -3.821299,
                                                                                                                                                        19.06611, -3.3996,
                                                                                                                                                        19.040003, -3.819503,
                                                                                                                                                        19.06611, -3.3996,
                                                                                                                                                        22.972928, -3.821299,
                                                                                                                                                        19.064946, -5.583004,
                                                                                                                                                        19.095295, -5.173268,
                                                                                                                                                        22.94593, -5.584893,
                                                                                                                                                        22.915879, -5.175127,
                                                                                                                                                        22.94593, -5.584893,
                                                                                                                                                        19.095295, -5.173268,
                                                                                                                                                        16.956767, -8.5248,
                                                                                                                                                        16.987133, -8.115057,
                                                                                                                                                        20.83775, -8.526914,
                                                                                                                                                        20.807717, -8.117138,
                                                                                                                                                        20.83775, -8.526914,
                                                                                                                                                        16.987133, -8.115057,
                                                                                                                                                        13.560767, -11.059984,
                                                                                                                                                        13.59114, -10.650234,
                                                                                                                                                        17.441751, -11.06218,
                                                                                                                                                        17.411724, -10.652395,
                                                                                                                                                        17.441751, -11.06218,
                                                                                                                                                        13.59114, -10.650234,
                                                                                                                                                        17.443762, -7.997858,
                                                                                                                                                        17.469574, -8.417802,
                                                                                                                                                        13.562778, -7.995797,
                                                                                                                                                        17.4941, -2.885388,
                                                                                                                                                        17.510504, -3.321934,
                                                                                                                                                        13.518376, -2.883442,
                                                                                                                                                        13.501689, -3.319972,
                                                                                                                                                        13.518376, -2.883442,
                                                                                                                                                        17.510504, -3.321934,
                                                                                                                                                        20.889148, -1.581386,
                                                                                                                                                        20.905558, -2.017926,
                                                                                                                                                        16.913424, -1.579512,
                                                                                                                                                        17.511923, -0.433147,
                                                                                                                                                        17.523261, -0.875431,
                                                                                                                                                        13.503108, -0.43123,
                                                                                                                                                        13.491497, -0.873503,
                                                                                                                                                        13.503108, -0.43123,
                                                                                                                                                        17.523261, -0.875431,
                                                                                                                                                        20.90672,
                                                                                                                                                        0.459461,
                                                                                                                                                        20.918064,
                                                                                                                                                        0.017181,
                                                                                                                                                        16.897905,
                                                                                                                                                        0.461307,
                                                                                                                                                        16.886299,
                                                                                                                                                        0.019038,
                                                                                                                                                        16.897905,
                                                                                                                                                        0.461307,
                                                                                                                                                        20.918064,
                                                                                                                                                        0.017181,
                                                                                                                                                        23.013356,
                                                                                                                                                        1.495679,
                                                                                                                                                        23.024713,
                                                                                                                                                        1.053403,
                                                                                                                                                        19.00454,
                                                                                                                                                        1.497328,
                                                                                                                                                        18.992948,
                                                                                                                                                        1.055062,
                                                                                                                                                        19.00454,
                                                                                                                                                        1.497328,
                                                                                                                                                        23.024713,
                                                                                                                                                        1.053403,
                                                                                                                                                        null,
                                                                                                                                                        null
                                                                                                                                                    ],
                                                                                                                                                    "indices": [
                                                                                                                                                        0,
                                                                                                                                                        1,
                                                                                                                                                        2,
                                                                                                                                                        3,
                                                                                                                                                        4,
                                                                                                                                                        5,
                                                                                                                                                        6,
                                                                                                                                                        7,
                                                                                                                                                        8,
                                                                                                                                                        9,
                                                                                                                                                        10,
                                                                                                                                                        11,
                                                                                                                                                        12,
                                                                                                                                                        13,
                                                                                                                                                        14,
                                                                                                                                                        15,
                                                                                                                                                        16,
                                                                                                                                                        17,
                                                                                                                                                        18,
                                                                                                                                                        19,
                                                                                                                                                        20,
                                                                                                                                                        21,
                                                                                                                                                        22,
                                                                                                                                                        23,
                                                                                                                                                        24,
                                                                                                                                                        25,
                                                                                                                                                        26,
                                                                                                                                                        27,
                                                                                                                                                        28,
                                                                                                                                                        29,
                                                                                                                                                        30,
                                                                                                                                                        31,
                                                                                                                                                        32,
                                                                                                                                                        33,
                                                                                                                                                        34,
                                                                                                                                                        35,
                                                                                                                                                        36,
                                                                                                                                                        37,
                                                                                                                                                        38,
                                                                                                                                                        39,
                                                                                                                                                        40,
                                                                                                                                                        41,
                                                                                                                                                        42,
                                                                                                                                                        43,
                                                                                                                                                        44,
                                                                                                                                                        45,
                                                                                                                                                        46,
                                                                                                                                                        47,
                                                                                                                                                        48,
                                                                                                                                                        49,
                                                                                                                                                        50,
                                                                                                                                                        51,
                                                                                                                                                        52,
                                                                                                                                                        53,
                                                                                                                                                        54,
                                                                                                                                                        55,
                                                                                                                                                        56,
                                                                                                                                                        57,
                                                                                                                                                        58,
                                                                                                                                                        59,
                                                                                                                                                        60,
                                                                                                                                                        61,
                                                                                                                                                        62,
                                                                                                                                                        63,
                                                                                                                                                        64,
                                                                                                                                                        65,
                                                                                                                                                        66,
                                                                                                                                                        67,
                                                                                                                                                        68,
                                                                                                                                                        69,
                                                                                                                                                        70,
                                                                                                                                                        71,
                                                                                                                                                        72,
                                                                                                                                                        73,
                                                                                                                                                        74,
                                                                                                                                                        75,
                                                                                                                                                        76,
                                                                                                                                                        77,
                                                                                                                                                        78,
                                                                                                                                                        79,
                                                                                                                                                        80,
                                                                                                                                                        81,
                                                                                                                                                        82,
                                                                                                                                                        83,
                                                                                                                                                        84,
                                                                                                                                                        85,
                                                                                                                                                        86,
                                                                                                                                                        87,
                                                                                                                                                        88,
                                                                                                                                                        89,
                                                                                                                                                        90,
                                                                                                                                                        91,
                                                                                                                                                        92,
                                                                                                                                                        93,
                                                                                                                                                        94,
                                                                                                                                                        95,
                                                                                                                                                        96,
                                                                                                                                                        97,
                                                                                                                                                        98,
                                                                                                                                                        99,
                                                                                                                                                        100,
                                                                                                                                                        101,
                                                                                                                                                        102,
                                                                                                                                                        103,
                                                                                                                                                        104,
                                                                                                                                                        105,
                                                                                                                                                        106,
                                                                                                                                                        107,
                                                                                                                                                        108,
                                                                                                                                                        109,
                                                                                                                                                        110,
                                                                                                                                                        111,
                                                                                                                                                        112,
                                                                                                                                                        113,
                                                                                                                                                        114,
                                                                                                                                                        115,
                                                                                                                                                        116,
                                                                                                                                                        117,
                                                                                                                                                        118,
                                                                                                                                                        119,
                                                                                                                                                        120,
                                                                                                                                                        121,
                                                                                                                                                        122,
                                                                                                                                                        123,
                                                                                                                                                        124,
                                                                                                                                                        125,
                                                                                                                                                        126,
                                                                                                                                                        127,
                                                                                                                                                        128,
                                                                                                                                                        129,
                                                                                                                                                        130,
                                                                                                                                                        131,
                                                                                                                                                        132,
                                                                                                                                                        133,
                                                                                                                                                        134,
                                                                                                                                                        135,
                                                                                                                                                        136,
                                                                                                                                                        137,
                                                                                                                                                        138,
                                                                                                                                                        139,
                                                                                                                                                        140,
                                                                                                                                                        141,
                                                                                                                                                        142,
                                                                                                                                                        143,
                                                                                                                                                        144,
                                                                                                                                                        145,
                                                                                                                                                        146,
                                                                                                                                                        147,
                                                                                                                                                        148,
                                                                                                                                                        149,
                                                                                                                                                        150,
                                                                                                                                                        151,
                                                                                                                                                        152,
                                                                                                                                                        153,
                                                                                                                                                        154,
                                                                                                                                                        155,
                                                                                                                                                        156,
                                                                                                                                                        157,
                                                                                                                                                        158,
                                                                                                                                                        159,
                                                                                                                                                        160,
                                                                                                                                                        161,
                                                                                                                                                        162,
                                                                                                                                                        163,
                                                                                                                                                        164,
                                                                                                                                                        165,
                                                                                                                                                        166,
                                                                                                                                                        167,
                                                                                                                                                        168,
                                                                                                                                                        169,
                                                                                                                                                        170,
                                                                                                                                                        171,
                                                                                                                                                        172,
                                                                                                                                                        173,
                                                                                                                                                        174,
                                                                                                                                                        175,
                                                                                                                                                        176,
                                                                                                                                                        177,
                                                                                                                                                        178,
                                                                                                                                                        179,
                                                                                                                                                        180,
                                                                                                                                                        181,
                                                                                                                                                        182,
                                                                                                                                                        183,
                                                                                                                                                        184,
                                                                                                                                                        185,
                                                                                                                                                        186,
                                                                                                                                                        187,
                                                                                                                                                        188,
                                                                                                                                                        189,
                                                                                                                                                        190,
                                                                                                                                                        191,
                                                                                                                                                        192,
                                                                                                                                                        193,
                                                                                                                                                        194,
                                                                                                                                                        195,
                                                                                                                                                        196,
                                                                                                                                                        197,
                                                                                                                                                        198,
                                                                                                                                                        199,
                                                                                                                                                        200,
                                                                                                                                                        201,
                                                                                                                                                        202,
                                                                                                                                                        203,
                                                                                                                                                        204,
                                                                                                                                                        205,
                                                                                                                                                        206,
                                                                                                                                                        207,
                                                                                                                                                        208,
                                                                                                                                                        209,
                                                                                                                                                        210,
                                                                                                                                                        211,
                                                                                                                                                        212,
                                                                                                                                                        213,
                                                                                                                                                        214,
                                                                                                                                                        215,
                                                                                                                                                        216,
                                                                                                                                                        217,
                                                                                                                                                        218,
                                                                                                                                                        219,
                                                                                                                                                        220,
                                                                                                                                                        221,
                                                                                                                                                        222,
                                                                                                                                                        223,
                                                                                                                                                        224,
                                                                                                                                                        225,
                                                                                                                                                        226,
                                                                                                                                                        227,
                                                                                                                                                        228,
                                                                                                                                                        229,
                                                                                                                                                        230,
                                                                                                                                                        231,
                                                                                                                                                        232,
                                                                                                                                                        233,
                                                                                                                                                        234,
                                                                                                                                                        235,
                                                                                                                                                        236,
                                                                                                                                                        237,
                                                                                                                                                        238,
                                                                                                                                                        239,
                                                                                                                                                        240,
                                                                                                                                                        241,
                                                                                                                                                        242,
                                                                                                                                                        243,
                                                                                                                                                        244,
                                                                                                                                                        245,
                                                                                                                                                        246,
                                                                                                                                                        247,
                                                                                                                                                        248,
                                                                                                                                                        249,
                                                                                                                                                        250,
                                                                                                                                                        251,
                                                                                                                                                        252,
                                                                                                                                                        253,
                                                                                                                                                        254,
                                                                                                                                                        255,
                                                                                                                                                        256,
                                                                                                                                                        257,
                                                                                                                                                        258,
                                                                                                                                                        259,
                                                                                                                                                        260,
                                                                                                                                                        261,
                                                                                                                                                        262,
                                                                                                                                                        263,
                                                                                                                                                        264,
                                                                                                                                                        265,
                                                                                                                                                        266,
                                                                                                                                                        267,
                                                                                                                                                        268,
                                                                                                                                                        269,
                                                                                                                                                        270,
                                                                                                                                                        271,
                                                                                                                                                        272,
                                                                                                                                                        273,
                                                                                                                                                        274,
                                                                                                                                                        275,
                                                                                                                                                        276,
                                                                                                                                                        277,
                                                                                                                                                        278,
                                                                                                                                                        279,
                                                                                                                                                        280,
                                                                                                                                                        281,
                                                                                                                                                        282,
                                                                                                                                                        283,
                                                                                                                                                        284,
                                                                                                                                                        285,
                                                                                                                                                        286,
                                                                                                                                                        287,
                                                                                                                                                        288,
                                                                                                                                                        289,
                                                                                                                                                        290,
                                                                                                                                                        291,
                                                                                                                                                        292,
                                                                                                                                                        293,
                                                                                                                                                        294,
                                                                                                                                                        295,
                                                                                                                                                        296,
                                                                                                                                                        297,
                                                                                                                                                        298,
                                                                                                                                                        299,
                                                                                                                                                        300,
                                                                                                                                                        301,
                                                                                                                                                        302,
                                                                                                                                                        303,
                                                                                                                                                        304,
                                                                                                                                                        305,
                                                                                                                                                        306,
                                                                                                                                                        307,
                                                                                                                                                        308,
                                                                                                                                                        309,
                                                                                                                                                        310,
                                                                                                                                                        311,
                                                                                                                                                        312,
                                                                                                                                                        313,
                                                                                                                                                        314,
                                                                                                                                                        315,
                                                                                                                                                        316,
                                                                                                                                                        317,
                                                                                                                                                        318,
                                                                                                                                                        319,
                                                                                                                                                        320,
                                                                                                                                                        321,
                                                                                                                                                        322,
                                                                                                                                                        323,
                                                                                                                                                        324,
                                                                                                                                                        325,
                                                                                                                                                        326,
                                                                                                                                                        327,
                                                                                                                                                        328,
                                                                                                                                                        329,
                                                                                                                                                        330,
                                                                                                                                                        331,
                                                                                                                                                        332,
                                                                                                                                                        333,
                                                                                                                                                        334,
                                                                                                                                                        335,
                                                                                                                                                        336,
                                                                                                                                                        337,
                                                                                                                                                        338,
                                                                                                                                                        339,
                                                                                                                                                        340,
                                                                                                                                                        341,
                                                                                                                                                        342,
                                                                                                                                                        343,
                                                                                                                                                        344,
                                                                                                                                                        345,
                                                                                                                                                        346,
                                                                                                                                                        347,
                                                                                                                                                        348,
                                                                                                                                                        349,
                                                                                                                                                        350,
                                                                                                                                                        351,
                                                                                                                                                        352,
                                                                                                                                                        353,
                                                                                                                                                        354,
                                                                                                                                                        355,
                                                                                                                                                        356,
                                                                                                                                                        357,
                                                                                                                                                        358,
                                                                                                                                                        359,
                                                                                                                                                        360,
                                                                                                                                                        361,
                                                                                                                                                        362,
                                                                                                                                                        363,
                                                                                                                                                        364,
                                                                                                                                                        365,
                                                                                                                                                        366,
                                                                                                                                                        367,
                                                                                                                                                        368,
                                                                                                                                                        369,
                                                                                                                                                        370,
                                                                                                                                                        371,
                                                                                                                                                        372,
                                                                                                                                                        373,
                                                                                                                                                        374,
                                                                                                                                                        375,
                                                                                                                                                        376,
                                                                                                                                                        377,
                                                                                                                                                        378,
                                                                                                                                                        379,
                                                                                                                                                        380,
                                                                                                                                                        381,
                                                                                                                                                        382,
                                                                                                                                                        383,
                                                                                                                                                        384,
                                                                                                                                                        385,
                                                                                                                                                        386,
                                                                                                                                                        387,
                                                                                                                                                        388,
                                                                                                                                                        389,
                                                                                                                                                        390,
                                                                                                                                                        391,
                                                                                                                                                        392,
                                                                                                                                                        393,
                                                                                                                                                        394,
                                                                                                                                                        395,
                                                                                                                                                        396,
                                                                                                                                                        397,
                                                                                                                                                        398,
                                                                                                                                                        399,
                                                                                                                                                        400,
                                                                                                                                                        401,
                                                                                                                                                        402,
                                                                                                                                                        403,
                                                                                                                                                        404,
                                                                                                                                                        405,
                                                                                                                                                        406,
                                                                                                                                                        407,
                                                                                                                                                        408,
                                                                                                                                                        409,
                                                                                                                                                        410,
                                                                                                                                                        411,
                                                                                                                                                        412,
                                                                                                                                                        413,
                                                                                                                                                        414,
                                                                                                                                                        415,
                                                                                                                                                        416,
                                                                                                                                                        417,
                                                                                                                                                        418,
                                                                                                                                                        419,
                                                                                                                                                        420,
                                                                                                                                                        421,
                                                                                                                                                        422,
                                                                                                                                                        423,
                                                                                                                                                        424,
                                                                                                                                                        425,
                                                                                                                                                        426,
                                                                                                                                                        427,
                                                                                                                                                        428,
                                                                                                                                                        429,
                                                                                                                                                        430,
                                                                                                                                                        431,
                                                                                                                                                        432,
                                                                                                                                                        433,
                                                                                                                                                        434,
                                                                                                                                                        435,
                                                                                                                                                        436,
                                                                                                                                                        437,
                                                                                                                                                        438,
                                                                                                                                                        439,
                                                                                                                                                        440,
                                                                                                                                                        441,
                                                                                                                                                        442,
                                                                                                                                                        443,
                                                                                                                                                        444,
                                                                                                                                                        445,
                                                                                                                                                        446,
                                                                                                                                                        447,
                                                                                                                                                        448,
                                                                                                                                                        449,
                                                                                                                                                        450,
                                                                                                                                                        451,
                                                                                                                                                        452,
                                                                                                                                                        453,
                                                                                                                                                        454,
                                                                                                                                                        455,
                                                                                                                                                        456,
                                                                                                                                                        457,
                                                                                                                                                        458,
                                                                                                                                                        459,
                                                                                                                                                        460,
                                                                                                                                                        461,
                                                                                                                                                        462,
                                                                                                                                                        463,
                                                                                                                                                        464,
                                                                                                                                                        465,
                                                                                                                                                        466,
                                                                                                                                                        467,
                                                                                                                                                        468,
                                                                                                                                                        469,
                                                                                                                                                        470,
                                                                                                                                                        471,
                                                                                                                                                        472,
                                                                                                                                                        473,
                                                                                                                                                        474,
                                                                                                                                                        475,
                                                                                                                                                        476,
                                                                                                                                                        477,
                                                                                                                                                        478,
                                                                                                                                                        479,
                                                                                                                                                        480,
                                                                                                                                                        481,
                                                                                                                                                        482,
                                                                                                                                                        483,
                                                                                                                                                        484,
                                                                                                                                                        485,
                                                                                                                                                        486,
                                                                                                                                                        487,
                                                                                                                                                        488,
                                                                                                                                                        489,
                                                                                                                                                        490,
                                                                                                                                                        491,
                                                                                                                                                        492,
                                                                                                                                                        493,
                                                                                                                                                        494,
                                                                                                                                                        495,
                                                                                                                                                        496,
                                                                                                                                                        497,
                                                                                                                                                        498,
                                                                                                                                                        499,
                                                                                                                                                        500,
                                                                                                                                                        501,
                                                                                                                                                        502,
                                                                                                                                                        503,
                                                                                                                                                        504,
                                                                                                                                                        505,
                                                                                                                                                        506,
                                                                                                                                                        507,
                                                                                                                                                        508,
                                                                                                                                                        509,
                                                                                                                                                        510,
                                                                                                                                                        511,
                                                                                                                                                        512,
                                                                                                                                                        513,
                                                                                                                                                        514,
                                                                                                                                                        515,
                                                                                                                                                        516,
                                                                                                                                                        517,
                                                                                                                                                        518,
                                                                                                                                                        519,
                                                                                                                                                        520,
                                                                                                                                                        521,
                                                                                                                                                        522,
                                                                                                                                                        523,
                                                                                                                                                        524,
                                                                                                                                                        525,
                                                                                                                                                        526,
                                                                                                                                                        527,
                                                                                                                                                        528,
                                                                                                                                                        529,
                                                                                                                                                        530,
                                                                                                                                                        531,
                                                                                                                                                        532,
                                                                                                                                                        533,
                                                                                                                                                        534,
                                                                                                                                                        535,
                                                                                                                                                        536,
                                                                                                                                                        537,
                                                                                                                                                        538,
                                                                                                                                                        539,
                                                                                                                                                        540,
                                                                                                                                                        541,
                                                                                                                                                        542,
                                                                                                                                                        543,
                                                                                                                                                        544,
                                                                                                                                                        545,
                                                                                                                                                        546,
                                                                                                                                                        547,
                                                                                                                                                        548,
                                                                                                                                                        549,
                                                                                                                                                        550,
                                                                                                                                                        551,
                                                                                                                                                        552,
                                                                                                                                                        553,
                                                                                                                                                        554,
                                                                                                                                                        555,
                                                                                                                                                        556,
                                                                                                                                                        557,
                                                                                                                                                        558,
                                                                                                                                                        559,
                                                                                                                                                        560,
                                                                                                                                                        561,
                                                                                                                                                        562,
                                                                                                                                                        563,
                                                                                                                                                        564,
                                                                                                                                                        565,
                                                                                                                                                        566,
                                                                                                                                                        567,
                                                                                                                                                        568,
                                                                                                                                                        569,
                                                                                                                                                        570,
                                                                                                                                                        571,
                                                                                                                                                        572,
                                                                                                                                                        573,
                                                                                                                                                        574,
                                                                                                                                                        575,
                                                                                                                                                        576,
                                                                                                                                                        577,
                                                                                                                                                        578,
                                                                                                                                                        579,
                                                                                                                                                        580,
                                                                                                                                                        581,
                                                                                                                                                        582,
                                                                                                                                                        583,
                                                                                                                                                        584,
                                                                                                                                                        585,
                                                                                                                                                        586,
                                                                                                                                                        587,
                                                                                                                                                        588,
                                                                                                                                                        589,
                                                                                                                                                        590,
                                                                                                                                                        591,
                                                                                                                                                        592,
                                                                                                                                                        593,
                                                                                                                                                        594,
                                                                                                                                                        595,
                                                                                                                                                        596,
                                                                                                                                                        597,
                                                                                                                                                        598,
                                                                                                                                                        599,
                                                                                                                                                        600,
                                                                                                                                                        601,
                                                                                                                                                        602,
                                                                                                                                                        603,
                                                                                                                                                        604,
                                                                                                                                                        605,
                                                                                                                                                        606,
                                                                                                                                                        607,
                                                                                                                                                        608,
                                                                                                                                                        609,
                                                                                                                                                        610,
                                                                                                                                                        611,
                                                                                                                                                        612,
                                                                                                                                                        613,
                                                                                                                                                        614,
                                                                                                                                                        615,
                                                                                                                                                        616,
                                                                                                                                                        617,
                                                                                                                                                        618,
                                                                                                                                                        619,
                                                                                                                                                        620,
                                                                                                                                                        621,
                                                                                                                                                        622,
                                                                                                                                                        623,
                                                                                                                                                        624,
                                                                                                                                                        625,
                                                                                                                                                        626,
                                                                                                                                                        627,
                                                                                                                                                        628,
                                                                                                                                                        629,
                                                                                                                                                        630,
                                                                                                                                                        631,
                                                                                                                                                        632,
                                                                                                                                                        633,
                                                                                                                                                        634,
                                                                                                                                                        635,
                                                                                                                                                        636,
                                                                                                                                                        637,
                                                                                                                                                        638,
                                                                                                                                                        639,
                                                                                                                                                        640,
                                                                                                                                                        641,
                                                                                                                                                        642,
                                                                                                                                                        643,
                                                                                                                                                        644,
                                                                                                                                                        645,
                                                                                                                                                        646,
                                                                                                                                                        647,
                                                                                                                                                        648,
                                                                                                                                                        649,
                                                                                                                                                        650,
                                                                                                                                                        651,
                                                                                                                                                        652,
                                                                                                                                                        653,
                                                                                                                                                        654,
                                                                                                                                                        655,
                                                                                                                                                        656,
                                                                                                                                                        657,
                                                                                                                                                        658,
                                                                                                                                                        659,
                                                                                                                                                        660,
                                                                                                                                                        661,
                                                                                                                                                        662,
                                                                                                                                                        663,
                                                                                                                                                        664,
                                                                                                                                                        665,
                                                                                                                                                        666,
                                                                                                                                                        667,
                                                                                                                                                        668,
                                                                                                                                                        669,
                                                                                                                                                        670,
                                                                                                                                                        671,
                                                                                                                                                        672,
                                                                                                                                                        673,
                                                                                                                                                        674,
                                                                                                                                                        675,
                                                                                                                                                        676,
                                                                                                                                                        677,
                                                                                                                                                        678,
                                                                                                                                                        679,
                                                                                                                                                        680,
                                                                                                                                                        681,
                                                                                                                                                        682,
                                                                                                                                                        683,
                                                                                                                                                        684,
                                                                                                                                                        685,
                                                                                                                                                        686,
                                                                                                                                                        687,
                                                                                                                                                        688,
                                                                                                                                                        689,
                                                                                                                                                        690,
                                                                                                                                                        691,
                                                                                                                                                        692,
                                                                                                                                                        693,
                                                                                                                                                        694,
                                                                                                                                                        695,
                                                                                                                                                        696,
                                                                                                                                                        697,
                                                                                                                                                        698,
                                                                                                                                                        699,
                                                                                                                                                        700,
                                                                                                                                                        701,
                                                                                                                                                        702,
                                                                                                                                                        703,
                                                                                                                                                        704,
                                                                                                                                                        705,
                                                                                                                                                        706,
                                                                                                                                                        707,
                                                                                                                                                        708,
                                                                                                                                                        709,
                                                                                                                                                        710,
                                                                                                                                                        711,
                                                                                                                                                        712,
                                                                                                                                                        713,
                                                                                                                                                        714,
                                                                                                                                                        715,
                                                                                                                                                        716,
                                                                                                                                                        717,
                                                                                                                                                        718,
                                                                                                                                                        719,
                                                                                                                                                        720,
                                                                                                                                                        721,
                                                                                                                                                        722,
                                                                                                                                                        723,
                                                                                                                                                        724,
                                                                                                                                                        725,
                                                                                                                                                        726,
                                                                                                                                                        727,
                                                                                                                                                        728,
                                                                                                                                                        729,
                                                                                                                                                        730,
                                                                                                                                                        731,
                                                                                                                                                        732,
                                                                                                                                                        733,
                                                                                                                                                        734,
                                                                                                                                                        735,
                                                                                                                                                        736,
                                                                                                                                                        737,
                                                                                                                                                        738,
                                                                                                                                                        739,
                                                                                                                                                        740,
                                                                                                                                                        741,
                                                                                                                                                        742,
                                                                                                                                                        743,
                                                                                                                                                        744,
                                                                                                                                                        745,
                                                                                                                                                        746,
                                                                                                                                                        747,
                                                                                                                                                        748,
                                                                                                                                                        749,
                                                                                                                                                        750,
                                                                                                                                                        751,
                                                                                                                                                        752,
                                                                                                                                                        753,
                                                                                                                                                        754,
                                                                                                                                                        755,
                                                                                                                                                        756,
                                                                                                                                                        757,
                                                                                                                                                        758,
                                                                                                                                                        759,
                                                                                                                                                        760,
                                                                                                                                                        761,
                                                                                                                                                        762,
                                                                                                                                                        763,
                                                                                                                                                        764,
                                                                                                                                                        765,
                                                                                                                                                        766,
                                                                                                                                                        767,
                                                                                                                                                        768,
                                                                                                                                                        769,
                                                                                                                                                        770,
                                                                                                                                                        771,
                                                                                                                                                        772,
                                                                                                                                                        773,
                                                                                                                                                        774,
                                                                                                                                                        775,
                                                                                                                                                        776,
                                                                                                                                                        777,
                                                                                                                                                        778,
                                                                                                                                                        779,
                                                                                                                                                        780,
                                                                                                                                                        781,
                                                                                                                                                        782,
                                                                                                                                                        783,
                                                                                                                                                        784,
                                                                                                                                                        785,
                                                                                                                                                        786,
                                                                                                                                                        787,
                                                                                                                                                        788,
                                                                                                                                                        789,
                                                                                                                                                        790,
                                                                                                                                                        791,
                                                                                                                                                        792,
                                                                                                                                                        793,
                                                                                                                                                        794,
                                                                                                                                                        795,
                                                                                                                                                        796,
                                                                                                                                                        797,
                                                                                                                                                        798,
                                                                                                                                                        799,
                                                                                                                                                        800,
                                                                                                                                                        801,
                                                                                                                                                        802,
                                                                                                                                                        803,
                                                                                                                                                        804,
                                                                                                                                                        805,
                                                                                                                                                        806,
                                                                                                                                                        807,
                                                                                                                                                        808,
                                                                                                                                                        809,
                                                                                                                                                        810,
                                                                                                                                                        811,
                                                                                                                                                        812,
                                                                                                                                                        813,
                                                                                                                                                        814,
                                                                                                                                                        815,
                                                                                                                                                        816,
                                                                                                                                                        817,
                                                                                                                                                        818,
                                                                                                                                                        819,
                                                                                                                                                        820,
                                                                                                                                                        821,
                                                                                                                                                        822,
                                                                                                                                                        823,
                                                                                                                                                        824,
                                                                                                                                                        825,
                                                                                                                                                        826,
                                                                                                                                                        827,
                                                                                                                                                        828,
                                                                                                                                                        829,
                                                                                                                                                        830,
                                                                                                                                                        831,
                                                                                                                                                        832,
                                                                                                                                                        833,
                                                                                                                                                        834,
                                                                                                                                                        835,
                                                                                                                                                        836,
                                                                                                                                                        837,
                                                                                                                                                        838,
                                                                                                                                                        839,
                                                                                                                                                        840,
                                                                                                                                                        841,
                                                                                                                                                        842,
                                                                                                                                                        843,
                                                                                                                                                        844,
                                                                                                                                                        845,
                                                                                                                                                        846,
                                                                                                                                                        847,
                                                                                                                                                        848,
                                                                                                                                                        849,
                                                                                                                                                        850,
                                                                                                                                                        851,
                                                                                                                                                        852,
                                                                                                                                                        853,
                                                                                                                                                        854,
                                                                                                                                                        855,
                                                                                                                                                        856,
                                                                                                                                                        857,
                                                                                                                                                        858,
                                                                                                                                                        859,
                                                                                                                                                        860,
                                                                                                                                                        861,
                                                                                                                                                        862,
                                                                                                                                                        863,
                                                                                                                                                        864,
                                                                                                                                                        865,
                                                                                                                                                        866,
                                                                                                                                                        867,
                                                                                                                                                        868,
                                                                                                                                                        869,
                                                                                                                                                        870,
                                                                                                                                                        871,
                                                                                                                                                        872,
                                                                                                                                                        873,
                                                                                                                                                        874,
                                                                                                                                                        875,
                                                                                                                                                        876,
                                                                                                                                                        877,
                                                                                                                                                        878,
                                                                                                                                                        879,
                                                                                                                                                        880,
                                                                                                                                                        881,
                                                                                                                                                        882,
                                                                                                                                                        883,
                                                                                                                                                        884,
                                                                                                                                                        885,
                                                                                                                                                        886,
                                                                                                                                                        887,
                                                                                                                                                        888,
                                                                                                                                                        889,
                                                                                                                                                        890,
                                                                                                                                                        891,
                                                                                                                                                        892,
                                                                                                                                                        893,
                                                                                                                                                        894,
                                                                                                                                                        895,
                                                                                                                                                        896,
                                                                                                                                                        897,
                                                                                                                                                        898,
                                                                                                                                                        899,
                                                                                                                                                        900,
                                                                                                                                                        901,
                                                                                                                                                        902,
                                                                                                                                                        903,
                                                                                                                                                        904,
                                                                                                                                                        905,
                                                                                                                                                        906,
                                                                                                                                                        907,
                                                                                                                                                        908,
                                                                                                                                                        909,
                                                                                                                                                        910,
                                                                                                                                                        911,
                                                                                                                                                        912,
                                                                                                                                                        913,
                                                                                                                                                        914,
                                                                                                                                                        915,
                                                                                                                                                        916,
                                                                                                                                                        917,
                                                                                                                                                        918,
                                                                                                                                                        919,
                                                                                                                                                        920,
                                                                                                                                                        921,
                                                                                                                                                        922,
                                                                                                                                                        923,
                                                                                                                                                        924,
                                                                                                                                                        925,
                                                                                                                                                        926,
                                                                                                                                                        927,
                                                                                                                                                        928,
                                                                                                                                                        929,
                                                                                                                                                        930,
                                                                                                                                                        931,
                                                                                                                                                        932,
                                                                                                                                                        933,
                                                                                                                                                        934,
                                                                                                                                                        935,
                                                                                                                                                        936,
                                                                                                                                                        937,
                                                                                                                                                        938,
                                                                                                                                                        939,
                                                                                                                                                        940,
                                                                                                                                                        941,
                                                                                                                                                        942,
                                                                                                                                                        943,
                                                                                                                                                        944,
                                                                                                                                                        945,
                                                                                                                                                        946,
                                                                                                                                                        947,
                                                                                                                                                        948,
                                                                                                                                                        949,
                                                                                                                                                        950,
                                                                                                                                                        951,
                                                                                                                                                        952,
                                                                                                                                                        953,
                                                                                                                                                        954,
                                                                                                                                                        955,
                                                                                                                                                        956,
                                                                                                                                                        957,
                                                                                                                                                        958,
                                                                                                                                                        959,
                                                                                                                                                        960,
                                                                                                                                                        961,
                                                                                                                                                        962,
                                                                                                                                                        963,
                                                                                                                                                        964,
                                                                                                                                                        965,
                                                                                                                                                        966,
                                                                                                                                                        967,
                                                                                                                                                        968,
                                                                                                                                                        969,
                                                                                                                                                        970,
                                                                                                                                                        971,
                                                                                                                                                        972,
                                                                                                                                                        973,
                                                                                                                                                        974,
                                                                                                                                                        975,
                                                                                                                                                        976,
                                                                                                                                                        977,
                                                                                                                                                        978,
                                                                                                                                                        979,
                                                                                                                                                        980,
                                                                                                                                                        981,
                                                                                                                                                        982,
                                                                                                                                                        983,
                                                                                                                                                        984,
                                                                                                                                                        985,
                                                                                                                                                        986,
                                                                                                                                                        987,
                                                                                                                                                        988,
                                                                                                                                                        989,
                                                                                                                                                        990,
                                                                                                                                                        991,
                                                                                                                                                        992,
                                                                                                                                                        993,
                                                                                                                                                        994,
                                                                                                                                                        995,
                                                                                                                                                        996,
                                                                                                                                                        997,
                                                                                                                                                        998,
                                                                                                                                                        999,
                                                                                                                                                        1000,
                                                                                                                                                        1001,
                                                                                                                                                        1002,
                                                                                                                                                        1003,
                                                                                                                                                        1004,
                                                                                                                                                        1005,
                                                                                                                                                        1006,
                                                                                                                                                        1007,
                                                                                                                                                        1008,
                                                                                                                                                        1009,
                                                                                                                                                        1010,
                                                                                                                                                        1011,
                                                                                                                                                        1012,
                                                                                                                                                        1013,
                                                                                                                                                        1014,
                                                                                                                                                        1015,
                                                                                                                                                        1016,
                                                                                                                                                        1017,
                                                                                                                                                        1018,
                                                                                                                                                        1019,
                                                                                                                                                        1020,
                                                                                                                                                        1021,
                                                                                                                                                        1022,
                                                                                                                                                        1023,
                                                                                                                                                        1024,
                                                                                                                                                        1025,
                                                                                                                                                        1026,
                                                                                                                                                        1027,
                                                                                                                                                        1028,
                                                                                                                                                        1029,
                                                                                                                                                        1030,
                                                                                                                                                        1031,
                                                                                                                                                        1032,
                                                                                                                                                        1033,
                                                                                                                                                        1034,
                                                                                                                                                        1035,
                                                                                                                                                        1036,
                                                                                                                                                        1037,
                                                                                                                                                        1038,
                                                                                                                                                        1039,
                                                                                                                                                        1040,
                                                                                                                                                        1041,
                                                                                                                                                        1042,
                                                                                                                                                        1043,
                                                                                                                                                        1044,
                                                                                                                                                        1045,
                                                                                                                                                        1046,
                                                                                                                                                        1047,
                                                                                                                                                        1048,
                                                                                                                                                        1049,
                                                                                                                                                        1050,
                                                                                                                                                        1051,
                                                                                                                                                        1052,
                                                                                                                                                        1053,
                                                                                                                                                        1054,
                                                                                                                                                        1055,
                                                                                                                                                        1056,
                                                                                                                                                        1057,
                                                                                                                                                        1058,
                                                                                                                                                        1059,
                                                                                                                                                        1060,
                                                                                                                                                        1061,
                                                                                                                                                        1062,
                                                                                                                                                        1063,
                                                                                                                                                        1064,
                                                                                                                                                        1065,
                                                                                                                                                        1066,
                                                                                                                                                        1067,
                                                                                                                                                        1068,
                                                                                                                                                        1069,
                                                                                                                                                        1070,
                                                                                                                                                        1071,
                                                                                                                                                        1072,
                                                                                                                                                        1073,
                                                                                                                                                        1074,
                                                                                                                                                        1075,
                                                                                                                                                        1076,
                                                                                                                                                        1077,
                                                                                                                                                        1078,
                                                                                                                                                        1079,
                                                                                                                                                        1080,
                                                                                                                                                        1081,
                                                                                                                                                        1082,
                                                                                                                                                        1083,
                                                                                                                                                        1084,
                                                                                                                                                        1085,
                                                                                                                                                        1086,
                                                                                                                                                        1087,
                                                                                                                                                        1088,
                                                                                                                                                        1089,
                                                                                                                                                        1090,
                                                                                                                                                        1091,
                                                                                                                                                        1092,
                                                                                                                                                        1093,
                                                                                                                                                        1094,
                                                                                                                                                        1095,
                                                                                                                                                        1096,
                                                                                                                                                        1097,
                                                                                                                                                        1098,
                                                                                                                                                        1099,
                                                                                                                                                        1100,
                                                                                                                                                        1101,
                                                                                                                                                        1102,
                                                                                                                                                        1103,
                                                                                                                                                        1104,
                                                                                                                                                        1105,
                                                                                                                                                        1106,
                                                                                                                                                        1107,
                                                                                                                                                        1108,
                                                                                                                                                        1109,
                                                                                                                                                        1110,
                                                                                                                                                        1111,
                                                                                                                                                        1112,
                                                                                                                                                        1113,
                                                                                                                                                        1114,
                                                                                                                                                        1115,
                                                                                                                                                        1116,
                                                                                                                                                        1117,
                                                                                                                                                        1118,
                                                                                                                                                        1119,
                                                                                                                                                        1120,
                                                                                                                                                        1121,
                                                                                                                                                        1122,
                                                                                                                                                        1123,
                                                                                                                                                        1124,
                                                                                                                                                        1125,
                                                                                                                                                        1126,
                                                                                                                                                        1127,
                                                                                                                                                        1128,
                                                                                                                                                        1129,
                                                                                                                                                        1130,
                                                                                                                                                        1131,
                                                                                                                                                        1132,
                                                                                                                                                        1133,
                                                                                                                                                        1134,
                                                                                                                                                        1135,
                                                                                                                                                        1136,
                                                                                                                                                        1137,
                                                                                                                                                        1138,
                                                                                                                                                        1139,
                                                                                                                                                        1140,
                                                                                                                                                        1141,
                                                                                                                                                        1142,
                                                                                                                                                        1143,
                                                                                                                                                        1144,
                                                                                                                                                        1145,
                                                                                                                                                        1146,
                                                                                                                                                        1147,
                                                                                                                                                        1148,
                                                                                                                                                        1149,
                                                                                                                                                        1150,
                                                                                                                                                        1151,
                                                                                                                                                        1152,
                                                                                                                                                        1153,
                                                                                                                                                        1154,
                                                                                                                                                        1155,
                                                                                                                                                        1156,
                                                                                                                                                        1157,
                                                                                                                                                        1158,
                                                                                                                                                        1159,
                                                                                                                                                        1160,
                                                                                                                                                        1161,
                                                                                                                                                        1162,
                                                                                                                                                        1163,
                                                                                                                                                        1164,
                                                                                                                                                        1165,
                                                                                                                                                        1166,
                                                                                                                                                        1167,
                                                                                                                                                        1168,
                                                                                                                                                        1169,
                                                                                                                                                        1170,
                                                                                                                                                        1171,
                                                                                                                                                        1172,
                                                                                                                                                        1173,
                                                                                                                                                        1174,
                                                                                                                                                        1175,
                                                                                                                                                        1176,
                                                                                                                                                        1177,
                                                                                                                                                        1178,
                                                                                                                                                        1179,
                                                                                                                                                        1180,
                                                                                                                                                        1181,
                                                                                                                                                        1182,
                                                                                                                                                        1183,
                                                                                                                                                        1184,
                                                                                                                                                        1185,
                                                                                                                                                        1186,
                                                                                                                                                        1187,
                                                                                                                                                        1188,
                                                                                                                                                        1189,
                                                                                                                                                        1190,
                                                                                                                                                        1191,
                                                                                                                                                        1192,
                                                                                                                                                        1193,
                                                                                                                                                        1194,
                                                                                                                                                        1195,
                                                                                                                                                        1196,
                                                                                                                                                        1197,
                                                                                                                                                        1198,
                                                                                                                                                        1199,
                                                                                                                                                        1200,
                                                                                                                                                        1201,
                                                                                                                                                        1202,
                                                                                                                                                        1203,
                                                                                                                                                        1204,
                                                                                                                                                        1205,
                                                                                                                                                        1206,
                                                                                                                                                        1207,
                                                                                                                                                        1208,
                                                                                                                                                        1209,
                                                                                                                                                        1210,
                                                                                                                                                        1211,
                                                                                                                                                        1212,
                                                                                                                                                        1213,
                                                                                                                                                        1214,
                                                                                                                                                        1215,
                                                                                                                                                        1216,
                                                                                                                                                        1217,
                                                                                                                                                        1218,
                                                                                                                                                        1219,
                                                                                                                                                        1220,
                                                                                                                                                        1221,
                                                                                                                                                        1222,
                                                                                                                                                        1223,
                                                                                                                                                        1224,
                                                                                                                                                        1225,
                                                                                                                                                        1226,
                                                                                                                                                        1227,
                                                                                                                                                        1228,
                                                                                                                                                        1229,
                                                                                                                                                        1230,
                                                                                                                                                        1231,
                                                                                                                                                        1232,
                                                                                                                                                        1233,
                                                                                                                                                        1234,
                                                                                                                                                        1235,
                                                                                                                                                        1236,
                                                                                                                                                        1237,
                                                                                                                                                        1238,
                                                                                                                                                        1239,
                                                                                                                                                        1240,
                                                                                                                                                        1241,
                                                                                                                                                        1242,
                                                                                                                                                        1243,
                                                                                                                                                        1244,
                                                                                                                                                        1245,
                                                                                                                                                        1246,
                                                                                                                                                        1247,
                                                                                                                                                        1248,
                                                                                                                                                        1249,
                                                                                                                                                        1250,
                                                                                                                                                        1251,
                                                                                                                                                        1252,
                                                                                                                                                        1253,
                                                                                                                                                        1254,
                                                                                                                                                        1255,
                                                                                                                                                        1256,
                                                                                                                                                        1257,
                                                                                                                                                        1258,
                                                                                                                                                        1259,
                                                                                                                                                        1260,
                                                                                                                                                        1261,
                                                                                                                                                        1262,
                                                                                                                                                        1263,
                                                                                                                                                        1264,
                                                                                                                                                        1265,
                                                                                                                                                        1266,
                                                                                                                                                        1267,
                                                                                                                                                        1268,
                                                                                                                                                        1269,
                                                                                                                                                        1270,
                                                                                                                                                        1271,
                                                                                                                                                        1272,
                                                                                                                                                        1273,
                                                                                                                                                        1274,
                                                                                                                                                        1275,
                                                                                                                                                        1276,
                                                                                                                                                        1277,
                                                                                                                                                        1278,
                                                                                                                                                        1279,
                                                                                                                                                        1280,
                                                                                                                                                        1281,
                                                                                                                                                        1282,
                                                                                                                                                        1283,
                                                                                                                                                        1284,
                                                                                                                                                        1285,
                                                                                                                                                        1286,
                                                                                                                                                        1287,
                                                                                                                                                        1288,
                                                                                                                                                        1289,
                                                                                                                                                        1290,
                                                                                                                                                        1291,
                                                                                                                                                        1292,
                                                                                                                                                        1293,
                                                                                                                                                        1294,
                                                                                                                                                        1295,
                                                                                                                                                        1296,
                                                                                                                                                        1297,
                                                                                                                                                        1298,
                                                                                                                                                        1299,
                                                                                                                                                        1300,
                                                                                                                                                        1301,
                                                                                                                                                        1302,
                                                                                                                                                        1303,
                                                                                                                                                        1304,
                                                                                                                                                        1305,
                                                                                                                                                        1306,
                                                                                                                                                        1307,
                                                                                                                                                        1308,
                                                                                                                                                        1309,
                                                                                                                                                        1310,
                                                                                                                                                        1311,
                                                                                                                                                        1312,
                                                                                                                                                        1313,
                                                                                                                                                        1314,
                                                                                                                                                        1315,
                                                                                                                                                        1316,
                                                                                                                                                        1317,
                                                                                                                                                        1318,
                                                                                                                                                        1319,
                                                                                                                                                        1320,
                                                                                                                                                        1321,
                                                                                                                                                        1322,
                                                                                                                                                        1323,
                                                                                                                                                        1324,
                                                                                                                                                        1325,
                                                                                                                                                        1326,
                                                                                                                                                        1327,
                                                                                                                                                        1328,
                                                                                                                                                        1329,
                                                                                                                                                        1330,
                                                                                                                                                        1331,
                                                                                                                                                        1332,
                                                                                                                                                        1333,
                                                                                                                                                        1334,
                                                                                                                                                        1335,
                                                                                                                                                        1336,
                                                                                                                                                        1337,
                                                                                                                                                        1338,
                                                                                                                                                        1339,
                                                                                                                                                        1340,
                                                                                                                                                        1341,
                                                                                                                                                        1342,
                                                                                                                                                        1343,
                                                                                                                                                        1344,
                                                                                                                                                        1345,
                                                                                                                                                        1346,
                                                                                                                                                        1347,
                                                                                                                                                        1348,
                                                                                                                                                        1349,
                                                                                                                                                        1350,
                                                                                                                                                        1351,
                                                                                                                                                        1352,
                                                                                                                                                        1353,
                                                                                                                                                        1354,
                                                                                                                                                        1355,
                                                                                                                                                        1356,
                                                                                                                                                        1357,
                                                                                                                                                        1358,
                                                                                                                                                        1359,
                                                                                                                                                        1360,
                                                                                                                                                        1361,
                                                                                                                                                        1362,
                                                                                                                                                        1363,
                                                                                                                                                        1364,
                                                                                                                                                        1365,
                                                                                                                                                        1366,
                                                                                                                                                        1367,
                                                                                                                                                        1368,
                                                                                                                                                        1369,
                                                                                                                                                        1370,
                                                                                                                                                        1371,
                                                                                                                                                        1372,
                                                                                                                                                        1373,
                                                                                                                                                        1374,
                                                                                                                                                        1375,
                                                                                                                                                        1376,
                                                                                                                                                        1377,
                                                                                                                                                        1378,
                                                                                                                                                        1379,
                                                                                                                                                        1380,
                                                                                                                                                        1381,
                                                                                                                                                        1382,
                                                                                                                                                        1383,
                                                                                                                                                        1384,
                                                                                                                                                        1385,
                                                                                                                                                        1386,
                                                                                                                                                        1387,
                                                                                                                                                        1388,
                                                                                                                                                        1389,
                                                                                                                                                        1390,
                                                                                                                                                        1391,
                                                                                                                                                        1392,
                                                                                                                                                        1393,
                                                                                                                                                        1394,
                                                                                                                                                        1395,
                                                                                                                                                        1396,
                                                                                                                                                        1397,
                                                                                                                                                        1398,
                                                                                                                                                        1399,
                                                                                                                                                        1400,
                                                                                                                                                        1401,
                                                                                                                                                        1402,
                                                                                                                                                        1403,
                                                                                                                                                        1404,
                                                                                                                                                        1405,
                                                                                                                                                        1406,
                                                                                                                                                        1407,
                                                                                                                                                        1408,
                                                                                                                                                        1409,
                                                                                                                                                        1410,
                                                                                                                                                        1411,
                                                                                                                                                        1412,
                                                                                                                                                        1413,
                                                                                                                                                        1414,
                                                                                                                                                        1415,
                                                                                                                                                        1416,
                                                                                                                                                        1417,
                                                                                                                                                        1418,
                                                                                                                                                        1419,
                                                                                                                                                        1420,
                                                                                                                                                        1421,
                                                                                                                                                        1422,
                                                                                                                                                        1423,
                                                                                                                                                        1424,
                                                                                                                                                        1425,
                                                                                                                                                        1426,
                                                                                                                                                        1427,
                                                                                                                                                        1428,
                                                                                                                                                        1429,
                                                                                                                                                        1430,
                                                                                                                                                        1431,
                                                                                                                                                        1432,
                                                                                                                                                        1433,
                                                                                                                                                        1434,
                                                                                                                                                        1435,
                                                                                                                                                        1436,
                                                                                                                                                        1437,
                                                                                                                                                        1438,
                                                                                                                                                        1439,
                                                                                                                                                        1440,
                                                                                                                                                        1441,
                                                                                                                                                        1442,
                                                                                                                                                        1443,
                                                                                                                                                        1444,
                                                                                                                                                        1445,
                                                                                                                                                        1446,
                                                                                                                                                        1447,
                                                                                                                                                        1448,
                                                                                                                                                        1449,
                                                                                                                                                        1450,
                                                                                                                                                        1451,
                                                                                                                                                        1452,
                                                                                                                                                        1453,
                                                                                                                                                        1454,
                                                                                                                                                        1455,
                                                                                                                                                        1456,
                                                                                                                                                        1457,
                                                                                                                                                        1458,
                                                                                                                                                        1459,
                                                                                                                                                        1460,
                                                                                                                                                        1461,
                                                                                                                                                        1462,
                                                                                                                                                        1463,
                                                                                                                                                        1464,
                                                                                                                                                        1465,
                                                                                                                                                        1466,
                                                                                                                                                        1467,
                                                                                                                                                        1468,
                                                                                                                                                        1469,
                                                                                                                                                        1470,
                                                                                                                                                        1471,
                                                                                                                                                        1472,
                                                                                                                                                        1473,
                                                                                                                                                        1474,
                                                                                                                                                        1475,
                                                                                                                                                        1476,
                                                                                                                                                        1477,
                                                                                                                                                        1478,
                                                                                                                                                        1479,
                                                                                                                                                        1480,
                                                                                                                                                        1481,
                                                                                                                                                        1482,
                                                                                                                                                        1483,
                                                                                                                                                        1484,
                                                                                                                                                        1485,
                                                                                                                                                        1486,
                                                                                                                                                        1487,
                                                                                                                                                        1488,
                                                                                                                                                        1489,
                                                                                                                                                        1490,
                                                                                                                                                        1491,
                                                                                                                                                        1492,
                                                                                                                                                        1493,
                                                                                                                                                        1494,
                                                                                                                                                        1495,
                                                                                                                                                        1496,
                                                                                                                                                        1497,
                                                                                                                                                        1498,
                                                                                                                                                        1499,
                                                                                                                                                        1500,
                                                                                                                                                        1501,
                                                                                                                                                        1502,
                                                                                                                                                        1503,
                                                                                                                                                        1504,
                                                                                                                                                        1505,
                                                                                                                                                        1506,
                                                                                                                                                        1507,
                                                                                                                                                        1508,
                                                                                                                                                        1509,
                                                                                                                                                        1510,
                                                                                                                                                        1511,
                                                                                                                                                        1512,
                                                                                                                                                        1513,
                                                                                                                                                        1514,
                                                                                                                                                        1515,
                                                                                                                                                        1516,
                                                                                                                                                        1517,
                                                                                                                                                        1518,
                                                                                                                                                        1519,
                                                                                                                                                        1520,
                                                                                                                                                        1521,
                                                                                                                                                        1522,
                                                                                                                                                        1523,
                                                                                                                                                        1524,
                                                                                                                                                        1525,
                                                                                                                                                        1526,
                                                                                                                                                        1527,
                                                                                                                                                        1528,
                                                                                                                                                        1529,
                                                                                                                                                        1530,
                                                                                                                                                        1531,
                                                                                                                                                        1532,
                                                                                                                                                        1533,
                                                                                                                                                        1534,
                                                                                                                                                        1535,
                                                                                                                                                        1536,
                                                                                                                                                        1537,
                                                                                                                                                        1538,
                                                                                                                                                        1539,
                                                                                                                                                        1540,
                                                                                                                                                        1541,
                                                                                                                                                        1542,
                                                                                                                                                        1543,
                                                                                                                                                        1544,
                                                                                                                                                        1545,
                                                                                                                                                        1546,
                                                                                                                                                        1547,
                                                                                                                                                        1548,
                                                                                                                                                        1549,
                                                                                                                                                        1550,
                                                                                                                                                        1551,
                                                                                                                                                        1552,
                                                                                                                                                        1553,
                                                                                                                                                        1554,
                                                                                                                                                        1555,
                                                                                                                                                        1556,
                                                                                                                                                        1557,
                                                                                                                                                        1558,
                                                                                                                                                        1559,
                                                                                                                                                        1560,
                                                                                                                                                        1561,
                                                                                                                                                        1562,
                                                                                                                                                        1563,
                                                                                                                                                        1564,
                                                                                                                                                        1565,
                                                                                                                                                        1566,
                                                                                                                                                        1567,
                                                                                                                                                        1568,
                                                                                                                                                        1569,
                                                                                                                                                        1570,
                                                                                                                                                        1571,
                                                                                                                                                        1572,
                                                                                                                                                        1573,
                                                                                                                                                        1574,
                                                                                                                                                        1575,
                                                                                                                                                        1576,
                                                                                                                                                        1577,
                                                                                                                                                        1578,
                                                                                                                                                        1579,
                                                                                                                                                        1580,
                                                                                                                                                        1581,
                                                                                                                                                        1582,
                                                                                                                                                        1583,
                                                                                                                                                        1584,
                                                                                                                                                        1585,
                                                                                                                                                        1586,
                                                                                                                                                        1587,
                                                                                                                                                        1588,
                                                                                                                                                        1589,
                                                                                                                                                        1590,
                                                                                                                                                        1591,
                                                                                                                                                        1592,
                                                                                                                                                        1593,
                                                                                                                                                        1594,
                                                                                                                                                        1595,
                                                                                                                                                        1596,
                                                                                                                                                        1597,
                                                                                                                                                        1598,
                                                                                                                                                        1599,
                                                                                                                                                        1600,
                                                                                                                                                        1601,
                                                                                                                                                        1602,
                                                                                                                                                        1603,
                                                                                                                                                        1604,
                                                                                                                                                        1605,
                                                                                                                                                        1606,
                                                                                                                                                        1607,
                                                                                                                                                        1608,
                                                                                                                                                        1609,
                                                                                                                                                        1610,
                                                                                                                                                        1611,
                                                                                                                                                        1612,
                                                                                                                                                        1613,
                                                                                                                                                        1614,
                                                                                                                                                        1615,
                                                                                                                                                        1616,
                                                                                                                                                        1617,
                                                                                                                                                        1618,
                                                                                                                                                        1619,
                                                                                                                                                        1620,
                                                                                                                                                        1621,
                                                                                                                                                        1622,
                                                                                                                                                        1623,
                                                                                                                                                        1624,
                                                                                                                                                        1625,
                                                                                                                                                        1626,
                                                                                                                                                        1627,
                                                                                                                                                        1628,
                                                                                                                                                        1629,
                                                                                                                                                        1630,
                                                                                                                                                        1631,
                                                                                                                                                        1632,
                                                                                                                                                        1633,
                                                                                                                                                        1634,
                                                                                                                                                        1635,
                                                                                                                                                        1636,
                                                                                                                                                        1637,
                                                                                                                                                        1638,
                                                                                                                                                        1639,
                                                                                                                                                        1640,
                                                                                                                                                        1641,
                                                                                                                                                        1642,
                                                                                                                                                        1643,
                                                                                                                                                        1644,
                                                                                                                                                        1645,
                                                                                                                                                        1646,
                                                                                                                                                        1647,
                                                                                                                                                        1648,
                                                                                                                                                        1649,
                                                                                                                                                        1650,
                                                                                                                                                        1651,
                                                                                                                                                        1652,
                                                                                                                                                        1653,
                                                                                                                                                        1654,
                                                                                                                                                        1655,
                                                                                                                                                        1656,
                                                                                                                                                        1657,
                                                                                                                                                        1658,
                                                                                                                                                        1659,
                                                                                                                                                        1660,
                                                                                                                                                        1661,
                                                                                                                                                        1662,
                                                                                                                                                        1663,
                                                                                                                                                        1664,
                                                                                                                                                        1665,
                                                                                                                                                        1666,
                                                                                                                                                        1667,
                                                                                                                                                        1668,
                                                                                                                                                        1669,
                                                                                                                                                        1670,
                                                                                                                                                        1671,
                                                                                                                                                        1672,
                                                                                                                                                        1673,
                                                                                                                                                        1674,
                                                                                                                                                        1675,
                                                                                                                                                        1676,
                                                                                                                                                        1677,
                                                                                                                                                        1678,
                                                                                                                                                        1679,
                                                                                                                                                        1680,
                                                                                                                                                        1681,
                                                                                                                                                        1682,
                                                                                                                                                        1683,
                                                                                                                                                        1684,
                                                                                                                                                        1685,
                                                                                                                                                        1686,
                                                                                                                                                        1687,
                                                                                                                                                        1688,
                                                                                                                                                        1689,
                                                                                                                                                        1690,
                                                                                                                                                        1691,
                                                                                                                                                        1692,
                                                                                                                                                        1693,
                                                                                                                                                        1694,
                                                                                                                                                        1695,
                                                                                                                                                        1696,
                                                                                                                                                        1697,
                                                                                                                                                        1698,
                                                                                                                                                        1699,
                                                                                                                                                        1700,
                                                                                                                                                        1701,
                                                                                                                                                        1702,
                                                                                                                                                        1703,
                                                                                                                                                        1704,
                                                                                                                                                        1705,
                                                                                                                                                        1706,
                                                                                                                                                        1707,
                                                                                                                                                        1708,
                                                                                                                                                        1709,
                                                                                                                                                        1710,
                                                                                                                                                        1711,
                                                                                                                                                        1712,
                                                                                                                                                        1713,
                                                                                                                                                        1714,
                                                                                                                                                        1715,
                                                                                                                                                        1716,
                                                                                                                                                        1717,
                                                                                                                                                        1718,
                                                                                                                                                        1719,
                                                                                                                                                        1720,
                                                                                                                                                        1721,
                                                                                                                                                        1722,
                                                                                                                                                        1723,
                                                                                                                                                        1724,
                                                                                                                                                        1725,
                                                                                                                                                        1726,
                                                                                                                                                        1727,
                                                                                                                                                        1728,
                                                                                                                                                        1729,
                                                                                                                                                        1730,
                                                                                                                                                        1731,
                                                                                                                                                        1732,
                                                                                                                                                        1733,
                                                                                                                                                        1734,
                                                                                                                                                        1735,
                                                                                                                                                        1736,
                                                                                                                                                        1737,
                                                                                                                                                        1738,
                                                                                                                                                        1739,
                                                                                                                                                        1740,
                                                                                                                                                        1741,
                                                                                                                                                        1742,
                                                                                                                                                        1743,
                                                                                                                                                        1744,
                                                                                                                                                        1745,
                                                                                                                                                        1746,
                                                                                                                                                        1747,
                                                                                                                                                        1748,
                                                                                                                                                        1749,
                                                                                                                                                        1750,
                                                                                                                                                        1751,
                                                                                                                                                        1752,
                                                                                                                                                        1753,
                                                                                                                                                        1754,
                                                                                                                                                        1755,
                                                                                                                                                        1756,
                                                                                                                                                        1757,
                                                                                                                                                        1758,
                                                                                                                                                        1759,
                                                                                                                                                        1760,
                                                                                                                                                        1761,
                                                                                                                                                        1762,
                                                                                                                                                        1763,
                                                                                                                                                        1764,
                                                                                                                                                        1765,
                                                                                                                                                        1766,
                                                                                                                                                        1767,
                                                                                                                                                        1768,
                                                                                                                                                        1769,
                                                                                                                                                        1770,
                                                                                                                                                        1771,
                                                                                                                                                        1772,
                                                                                                                                                        1773,
                                                                                                                                                        1774,
                                                                                                                                                        1775,
                                                                                                                                                        1776,
                                                                                                                                                        1777,
                                                                                                                                                        1778,
                                                                                                                                                        1779,
                                                                                                                                                        1780,
                                                                                                                                                        1781,
                                                                                                                                                        1782,
                                                                                                                                                        1783,
                                                                                                                                                        1784,
                                                                                                                                                        1785,
                                                                                                                                                        1786,
                                                                                                                                                        1787,
                                                                                                                                                        1788,
                                                                                                                                                        1789,
                                                                                                                                                        1790,
                                                                                                                                                        1791,
                                                                                                                                                        1792,
                                                                                                                                                        1793,
                                                                                                                                                        1794,
                                                                                                                                                        1795,
                                                                                                                                                        1796,
                                                                                                                                                        1797,
                                                                                                                                                        1798,
                                                                                                                                                        1799,
                                                                                                                                                        1800,
                                                                                                                                                        1801,
                                                                                                                                                        1802,
                                                                                                                                                        1803,
                                                                                                                                                        1804,
                                                                                                                                                        1805,
                                                                                                                                                        1806,
                                                                                                                                                        1807,
                                                                                                                                                        1808,
                                                                                                                                                        1809,
                                                                                                                                                        1810,
                                                                                                                                                        1811,
                                                                                                                                                        1812
                                                                                                                                                    ]
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        }, {
                                                                                                                                            "type": "material",
                                                                                                                                            "baseColor": {
                                                                                                                                                "r": 0.172549,
                                                                                                                                                "g": 0.184314,
                                                                                                                                                "b": 0.2
                                                                                                                                            },
                                                                                                                                            "specularColor": {
                                                                                                                                                "r": 0.33,
                                                                                                                                                "g": 0.33,
                                                                                                                                                "b": 0.33,
                                                                                                                                                "a": 1
                                                                                                                                            },
                                                                                                                                            "shine": 10,
                                                                                                                                            "specular": 1,
                                                                                                                                            "nodes": [{
                                                                                                                                                    "type": "geometry",
                                                                                                                                                    "positions": [-27.477879,
                                                                                                                                                        5.791787,
                                                                                                                                                        5.237212, -26.08084,
                                                                                                                                                        6.889284,
                                                                                                                                                        4.267012, -24.594294,
                                                                                                                                                        2.973975,
                                                                                                                                                        5.238533, -26.08084,
                                                                                                                                                        6.889284,
                                                                                                                                                        4.267012, -27.477879,
                                                                                                                                                        5.791787,
                                                                                                                                                        5.237212, -27.900332,
                                                                                                                                                        9.95842,
                                                                                                                                                        4.265386, -29.533905,
                                                                                                                                                        9.259911,
                                                                                                                                                        5.235586, -27.900332,
                                                                                                                                                        9.95842,
                                                                                                                                                        4.265386, -27.477879,
                                                                                                                                                        5.791787,
                                                                                                                                                        5.237212, -27.900332,
                                                                                                                                                        9.95842,
                                                                                                                                                        4.265386, -29.533905,
                                                                                                                                                        9.259911,
                                                                                                                                                        5.235586, -28.863475,
                                                                                                                                                        13.393897,
                                                                                                                                                        4.263566, -30.622257,
                                                                                                                                                        13.142,
                                                                                                                                                        5.233766, -28.863475,
                                                                                                                                                        13.393897,
                                                                                                                                                        4.263566, -29.533905,
                                                                                                                                                        9.259911,
                                                                                                                                                        5.235586, -28.863475,
                                                                                                                                                        13.393897,
                                                                                                                                                        4.263566, -30.622257,
                                                                                                                                                        13.142,
                                                                                                                                                        5.233766, -28.904632,
                                                                                                                                                        16.961593,
                                                                                                                                                        4.261676, -30.668765,
                                                                                                                                                        17.173496,
                                                                                                                                                        5.231876, -28.904632,
                                                                                                                                                        16.961593,
                                                                                                                                                        4.261676, -30.622257,
                                                                                                                                                        13.142,
                                                                                                                                                        5.233766, -30.668765,
                                                                                                                                                        17.173496,
                                                                                                                                                        5.231876, -29.67026,
                                                                                                                                                        21.07966,
                                                                                                                                                        5.230045, -28.904632,
                                                                                                                                                        16.961593,
                                                                                                                                                        4.261676, -24.594294,
                                                                                                                                                        2.973975,
                                                                                                                                                        5.238533, -23.528995,
                                                                                                                                                        4.395645,
                                                                                                                                                        4.268333, -21.079662,
                                                                                                                                                        0.998504,
                                                                                                                                                        5.239459, -23.528995,
                                                                                                                                                        4.395645,
                                                                                                                                                        4.268333, -24.594294,
                                                                                                                                                        2.973975,
                                                                                                                                                        5.238533, -26.08084,
                                                                                                                                                        6.889284,
                                                                                                                                                        4.267012, -23.528995,
                                                                                                                                                        4.395645,
                                                                                                                                                        4.268333, -26.08084,
                                                                                                                                                        6.889284,
                                                                                                                                                        4.267012, -23.528995,
                                                                                                                                                        4.395277,
                                                                                                                                                        3.164784, -26.08084,
                                                                                                                                                        6.888825,
                                                                                                                                                        2.891896, -23.528995,
                                                                                                                                                        4.395277,
                                                                                                                                                        3.164784, -26.08084,
                                                                                                                                                        6.889284,
                                                                                                                                                        4.267012, -26.08084,
                                                                                                                                                        6.888825,
                                                                                                                                                        2.891896, -26.08084,
                                                                                                                                                        6.889284,
                                                                                                                                                        4.267012, -27.900332,
                                                                                                                                                        9.95785,
                                                                                                                                                        2.55603, -27.900332,
                                                                                                                                                        9.95842,
                                                                                                                                                        4.265386, -27.900332,
                                                                                                                                                        9.95785,
                                                                                                                                                        2.55603, -26.08084,
                                                                                                                                                        6.889284,
                                                                                                                                                        4.267012, -27.900332,
                                                                                                                                                        9.95785,
                                                                                                                                                        2.55603, -27.900332,
                                                                                                                                                        9.95842,
                                                                                                                                                        4.265386, -28.863475,
                                                                                                                                                        13.393202,
                                                                                                                                                        2.180073, -28.863475,
                                                                                                                                                        13.393897,
                                                                                                                                                        4.263566, -28.863475,
                                                                                                                                                        13.393202,
                                                                                                                                                        2.180073, -27.900332,
                                                                                                                                                        9.95842,
                                                                                                                                                        4.265386, -28.863475,
                                                                                                                                                        13.393202,
                                                                                                                                                        2.180073, -28.863475,
                                                                                                                                                        13.393897,
                                                                                                                                                        4.263566, -28.904632,
                                                                                                                                                        16.960768,
                                                                                                                                                        1.789648, -28.904632,
                                                                                                                                                        16.961593,
                                                                                                                                                        4.261676, -28.904632,
                                                                                                                                                        16.960768,
                                                                                                                                                        1.789648, -28.863475,
                                                                                                                                                        13.393897,
                                                                                                                                                        4.263566, -28.904632,
                                                                                                                                                        16.960768,
                                                                                                                                                        1.789648, -28.904632,
                                                                                                                                                        16.961593,
                                                                                                                                                        4.261676, -28.021,
                                                                                                                                                        20.417424,
                                                                                                                                                        1.41136, -28.021,
                                                                                                                                                        20.418375,
                                                                                                                                                        4.259845, -28.021,
                                                                                                                                                        20.417424,
                                                                                                                                                        1.41136, -28.904632,
                                                                                                                                                        16.961593,
                                                                                                                                                        4.261676, -28.021,
                                                                                                                                                        20.417424,
                                                                                                                                                        1.41136, -28.021,
                                                                                                                                                        20.418375,
                                                                                                                                                        4.259845, -26.272796,
                                                                                                                                                        23.527605,
                                                                                                                                                        1.070989, -26.272796,
                                                                                                                                                        23.528669,
                                                                                                                                                        4.258197, -26.272796,
                                                                                                                                                        23.527605,
                                                                                                                                                        1.070989, -28.021,
                                                                                                                                                        20.418375,
                                                                                                                                                        4.259845, -26.272796,
                                                                                                                                                        23.527605,
                                                                                                                                                        1.070989, -26.272796,
                                                                                                                                                        23.528669,
                                                                                                                                                        4.258197, -23.779157,
                                                                                                                                                        26.079357,
                                                                                                                                                        0.791732, -23.779157,
                                                                                                                                                        26.080514,
                                                                                                                                                        4.256845, -23.779157,
                                                                                                                                                        26.079357,
                                                                                                                                                        0.791732, -26.272796,
                                                                                                                                                        23.528669,
                                                                                                                                                        4.258197, -23.779157,
                                                                                                                                                        26.080514,
                                                                                                                                                        4.256845, -20.71002,
                                                                                                                                                        27.900005,
                                                                                                                                                        4.255881, -23.779157,
                                                                                                                                                        26.079357,
                                                                                                                                                        0.791732, -20.71002,
                                                                                                                                                        27.900005,
                                                                                                                                                        4.255881, -23.779157,
                                                                                                                                                        26.080514,
                                                                                                                                                        4.256845, -21.408853,
                                                                                                                                                        29.533902,
                                                                                                                                                        5.226081, -24.876977,
                                                                                                                                                        27.477877,
                                                                                                                                                        5.227045, -21.408853,
                                                                                                                                                        29.533902,
                                                                                                                                                        5.226081, -23.779157,
                                                                                                                                                        26.080514,
                                                                                                                                                        4.256845, -21.079662,
                                                                                                                                                        0.998504,
                                                                                                                                                        5.239459, -20.4187,
                                                                                                                                                        2.647441,
                                                                                                                                                        4.269259, -17.173498,
                                                                                                                                                        0,
                                                                                                                                                        5.239927, -20.4187,
                                                                                                                                                        2.647441,
                                                                                                                                                        4.269259, -21.079662,
                                                                                                                                                        0.998504,
                                                                                                                                                        5.239459, -23.528995,
                                                                                                                                                        4.395645,
                                                                                                                                                        4.268333, -20.4187,
                                                                                                                                                        2.647441,
                                                                                                                                                        4.269259, -23.528995,
                                                                                                                                                        4.395645,
                                                                                                                                                        4.268333, -20.4187,
                                                                                                                                                        2.647136,
                                                                                                                                                        3.356096, -23.528995,
                                                                                                                                                        4.395277,
                                                                                                                                                        3.164784, -20.4187,
                                                                                                                                                        2.647136,
                                                                                                                                                        3.356096, -23.528995,
                                                                                                                                                        4.395645,
                                                                                                                                                        4.268333, -20.4187,
                                                                                                                                                        2.647136,
                                                                                                                                                        3.356096, -16.961918,
                                                                                                                                                        1.763536,
                                                                                                                                                        3.452795, -20.4187,
                                                                                                                                                        2.647441,
                                                                                                                                                        4.269259, -16.961918,
                                                                                                                                                        1.763809,
                                                                                                                                                        4.269727, -20.4187,
                                                                                                                                                        2.647441,
                                                                                                                                                        4.269259, -16.961918,
                                                                                                                                                        1.763536,
                                                                                                                                                        3.452795, -16.961918,
                                                                                                                                                        1.763809,
                                                                                                                                                        4.269727, -17.173498,
                                                                                                                                                        0,
                                                                                                                                                        5.239927, -20.4187,
                                                                                                                                                        2.647441,
                                                                                                                                                        4.269259, -16.961918,
                                                                                                                                                        1.763809,
                                                                                                                                                        4.269727, -13.394222,
                                                                                                                                                        1.804966,
                                                                                                                                                        4.269705, -17.173498,
                                                                                                                                                        0,
                                                                                                                                                        5.239927, -16.961918,
                                                                                                                                                        1.763809,
                                                                                                                                                        4.269727, -16.961918,
                                                                                                                                                        1.763536,
                                                                                                                                                        3.452795, -13.394222,
                                                                                                                                                        1.804966,
                                                                                                                                                        4.269705, -13.394222,
                                                                                                                                                        1.804692,
                                                                                                                                                        3.448291, -13.394222,
                                                                                                                                                        1.804966,
                                                                                                                                                        4.269705, -16.961918,
                                                                                                                                                        1.763536,
                                                                                                                                                        3.452795, -13.394222,
                                                                                                                                                        1.804966,
                                                                                                                                                        4.269705, -13.394222,
                                                                                                                                                        1.804692,
                                                                                                                                                        3.448291, -9.958745,
                                                                                                                                                        2.768109,
                                                                                                                                                        4.269195, -9.958745,
                                                                                                                                                        2.7678,
                                                                                                                                                        3.342891, -9.958745,
                                                                                                                                                        2.768109,
                                                                                                                                                        4.269195, -13.394222,
                                                                                                                                                        1.804692,
                                                                                                                                                        3.448291, -9.958745,
                                                                                                                                                        2.768109,
                                                                                                                                                        4.269195, -9.958745,
                                                                                                                                                        2.7678,
                                                                                                                                                        3.342891, -6.889608,
                                                                                                                                                        4.587601,
                                                                                                                                                        4.268231, -6.889608,
                                                                                                                                                        4.587226,
                                                                                                                                                        3.143778, -6.889608,
                                                                                                                                                        4.587601,
                                                                                                                                                        4.268231, -9.958745,
                                                                                                                                                        2.7678,
                                                                                                                                                        3.342891, -6.889608,
                                                                                                                                                        4.587226,
                                                                                                                                                        3.143778, -4.395969,
                                                                                                                                                        7.138978,
                                                                                                                                                        2.86452, -6.889608,
                                                                                                                                                        4.587601,
                                                                                                                                                        4.268231, -4.395969,
                                                                                                                                                        7.139446,
                                                                                                                                                        4.266879, -6.889608,
                                                                                                                                                        4.587601,
                                                                                                                                                        4.268231, -4.395969,
                                                                                                                                                        7.138978,
                                                                                                                                                        2.86452, -6.889608,
                                                                                                                                                        4.587601,
                                                                                                                                                        4.268231, -4.395969,
                                                                                                                                                        7.139446,
                                                                                                                                                        4.266879, -5.791788,
                                                                                                                                                        3.190885,
                                                                                                                                                        5.238431, -2.973975,
                                                                                                                                                        6.07447,
                                                                                                                                                        5.237079, -5.791788,
                                                                                                                                                        3.190885,
                                                                                                                                                        5.238431, -4.395969,
                                                                                                                                                        7.139446,
                                                                                                                                                        4.266879, -0.998505,
                                                                                                                                                        9.589102,
                                                                                                                                                        5.235432, -2.973975,
                                                                                                                                                        6.07447,
                                                                                                                                                        5.237079, -2.647765,
                                                                                                                                                        10.24974,
                                                                                                                                                        4.265232, -4.395969,
                                                                                                                                                        7.139446,
                                                                                                                                                        4.266879, -2.647765,
                                                                                                                                                        10.24974,
                                                                                                                                                        4.265232, -2.973975,
                                                                                                                                                        6.07447,
                                                                                                                                                        5.237079, -2.647765,
                                                                                                                                                        10.24974,
                                                                                                                                                        4.265232, -4.395969,
                                                                                                                                                        7.139446,
                                                                                                                                                        4.266879, -2.647765,
                                                                                                                                                        10.249159,
                                                                                                                                                        2.52415, -4.395969,
                                                                                                                                                        7.138978,
                                                                                                                                                        2.86452, -2.647765,
                                                                                                                                                        10.249159,
                                                                                                                                                        2.52415, -4.395969,
                                                                                                                                                        7.139446,
                                                                                                                                                        4.266879, -2.647765,
                                                                                                                                                        10.249159,
                                                                                                                                                        2.52415, -1.764132,
                                                                                                                                                        13.705815,
                                                                                                                                                        2.145862, -2.647765,
                                                                                                                                                        10.24974,
                                                                                                                                                        4.265232, -1.764132,
                                                                                                                                                        13.706522,
                                                                                                                                                        4.2634, -2.647765,
                                                                                                                                                        10.24974,
                                                                                                                                                        4.265232, -1.764132,
                                                                                                                                                        13.705815,
                                                                                                                                                        2.145862, -2.647765,
                                                                                                                                                        10.24974,
                                                                                                                                                        4.265232, -1.764132,
                                                                                                                                                        13.706522,
                                                                                                                                                        4.2634, -0.998505,
                                                                                                                                                        9.589102,
                                                                                                                                                        5.235432,
                                                                                                                                                        0,
                                                                                                                                                        13.495266,
                                                                                                                                                        5.2336, -0.998505,
                                                                                                                                                        9.589102,
                                                                                                                                                        5.235432, -1.764132,
                                                                                                                                                        13.706522,
                                                                                                                                                        4.2634,
                                                                                                                                                        0,
                                                                                                                                                        13.495266,
                                                                                                                                                        5.2336, -1.764132,
                                                                                                                                                        13.706522,
                                                                                                                                                        4.2634, -0.046508,
                                                                                                                                                        17.526762,
                                                                                                                                                        5.23171, -1.80529,
                                                                                                                                                        17.274217,
                                                                                                                                                        4.26151, -0.046508,
                                                                                                                                                        17.526762,
                                                                                                                                                        5.23171, -1.764132,
                                                                                                                                                        13.706522,
                                                                                                                                                        4.2634, -0.046508,
                                                                                                                                                        17.526762,
                                                                                                                                                        5.23171, -1.80529,
                                                                                                                                                        17.274217,
                                                                                                                                                        4.26151, -1.13486,
                                                                                                                                                        21.408851,
                                                                                                                                                        5.22989, -2.768433,
                                                                                                                                                        20.709695,
                                                                                                                                                        4.259691, -1.13486,
                                                                                                                                                        21.408851,
                                                                                                                                                        5.22989, -1.80529,
                                                                                                                                                        17.274217,
                                                                                                                                                        4.26151, -1.13486,
                                                                                                                                                        21.408851,
                                                                                                                                                        5.22989, -2.768433,
                                                                                                                                                        20.709695,
                                                                                                                                                        4.259691, -3.190886,
                                                                                                                                                        24.876975,
                                                                                                                                                        5.228265, -4.587925,
                                                                                                                                                        23.778831,
                                                                                                                                                        4.258065, -3.190886,
                                                                                                                                                        24.876975,
                                                                                                                                                        5.228265, -2.768433,
                                                                                                                                                        20.709695,
                                                                                                                                                        4.259691, -3.190886,
                                                                                                                                                        24.876975,
                                                                                                                                                        5.228265, -4.587925,
                                                                                                                                                        23.778831,
                                                                                                                                                        4.258065, -6.074471,
                                                                                                                                                        27.694787,
                                                                                                                                                        5.226944, -7.13977,
                                                                                                                                                        26.27247,
                                                                                                                                                        4.256744, -6.074471,
                                                                                                                                                        27.694787,
                                                                                                                                                        5.226944, -4.587925,
                                                                                                                                                        23.778831,
                                                                                                                                                        4.258065, -6.074471,
                                                                                                                                                        27.694787,
                                                                                                                                                        5.226944, -7.13977,
                                                                                                                                                        26.27247,
                                                                                                                                                        4.256744, -9.589103,
                                                                                                                                                        29.670258,
                                                                                                                                                        5.226017, -10.250064,
                                                                                                                                                        28.020674,
                                                                                                                                                        4.255818, -9.589103,
                                                                                                                                                        29.670258,
                                                                                                                                                        5.226017, -7.13977,
                                                                                                                                                        26.27247,
                                                                                                                                                        4.256744, -9.589103,
                                                                                                                                                        29.670258,
                                                                                                                                                        5.226017, -10.250064,
                                                                                                                                                        28.020674,
                                                                                                                                                        4.255818, -13.495267,
                                                                                                                                                        30.668762,
                                                                                                                                                        5.225549, -13.706847,
                                                                                                                                                        28.904306,
                                                                                                                                                        4.255349, -13.495267,
                                                                                                                                                        30.668762,
                                                                                                                                                        5.225549, -10.250064,
                                                                                                                                                        28.020674,
                                                                                                                                                        4.255818, -13.495267,
                                                                                                                                                        30.668762,
                                                                                                                                                        5.225549, -13.706847,
                                                                                                                                                        28.904306,
                                                                                                                                                        4.255349, -17.526764,
                                                                                                                                                        30.622254,
                                                                                                                                                        5.225571, -17.274543,
                                                                                                                                                        28.863148,
                                                                                                                                                        4.255371, -17.526764,
                                                                                                                                                        30.622254,
                                                                                                                                                        5.225571, -13.706847,
                                                                                                                                                        28.904306,
                                                                                                                                                        4.255349, -17.274543,
                                                                                                                                                        28.863148,
                                                                                                                                                        4.255371, -20.71002,
                                                                                                                                                        27.900005,
                                                                                                                                                        4.255881, -17.526764,
                                                                                                                                                        30.622254,
                                                                                                                                                        5.225571, -20.71002,
                                                                                                                                                        27.900005,
                                                                                                                                                        4.255881, -17.274543,
                                                                                                                                                        28.863148,
                                                                                                                                                        4.255371, -20.71002,
                                                                                                                                                        27.89868,
                                                                                                                                                        0.285542, -17.274543,
                                                                                                                                                        28.861732,
                                                                                                                                                        0.011702, -20.71002,
                                                                                                                                                        27.89868,
                                                                                                                                                        0.285542, -17.274543,
                                                                                                                                                        28.863148,
                                                                                                                                                        4.255371, -17.274543,
                                                                                                                                                        28.863148,
                                                                                                                                                        4.255371, -13.706847,
                                                                                                                                                        28.904306,
                                                                                                                                                        4.255349, -17.274543,
                                                                                                                                                        28.861732,
                                                                                                                                                        0.011702, -13.706847,
                                                                                                                                                        28.902886,
                                                                                                                                                        0, -17.274543,
                                                                                                                                                        28.861732,
                                                                                                                                                        0.011702, -13.706847,
                                                                                                                                                        28.904306,
                                                                                                                                                        4.255349, -13.706847,
                                                                                                                                                        28.902886,
                                                                                                                                                        0, -13.706847,
                                                                                                                                                        28.904306,
                                                                                                                                                        4.255349, -10.250064,
                                                                                                                                                        28.019338,
                                                                                                                                                        0.251234, -10.250064,
                                                                                                                                                        28.020674,
                                                                                                                                                        4.255818, -10.250064,
                                                                                                                                                        28.019338,
                                                                                                                                                        0.251234, -13.706847,
                                                                                                                                                        28.904306,
                                                                                                                                                        4.255349, -10.250064,
                                                                                                                                                        28.019338,
                                                                                                                                                        0.251234, -10.250064,
                                                                                                                                                        28.020674,
                                                                                                                                                        4.255818, -7.13977,
                                                                                                                                                        26.271299,
                                                                                                                                                        0.748282, -7.13977,
                                                                                                                                                        26.27247,
                                                                                                                                                        4.256744, -7.13977,
                                                                                                                                                        26.271299,
                                                                                                                                                        0.748282, -10.250064,
                                                                                                                                                        28.020674,
                                                                                                                                                        4.255818, -7.13977,
                                                                                                                                                        26.271299,
                                                                                                                                                        0.748282, -7.13977,
                                                                                                                                                        26.27247,
                                                                                                                                                        4.256744, -7.008443,
                                                                                                                                                        26.142979,
                                                                                                                                                        0.784769, -4.587925,
                                                                                                                                                        23.777758,
                                                                                                                                                        1.043613, -7.008443,
                                                                                                                                                        26.142979,
                                                                                                                                                        0.784769, -7.13977,
                                                                                                                                                        26.27247,
                                                                                                                                                        4.256744, -4.587925,
                                                                                                                                                        23.778831,
                                                                                                                                                        4.258065, -4.587925,
                                                                                                                                                        23.777758,
                                                                                                                                                        1.043613, -7.13977,
                                                                                                                                                        26.27247,
                                                                                                                                                        4.256744, -4.587925,
                                                                                                                                                        23.778831,
                                                                                                                                                        4.258065, -2.768433,
                                                                                                                                                        20.709695,
                                                                                                                                                        4.259691, -4.587925,
                                                                                                                                                        23.777758,
                                                                                                                                                        1.043613, -2.768433,
                                                                                                                                                        20.708733,
                                                                                                                                                        1.37948, -4.587925,
                                                                                                                                                        23.777758,
                                                                                                                                                        1.043613, -2.768433,
                                                                                                                                                        20.709695,
                                                                                                                                                        4.259691, -2.768433,
                                                                                                                                                        20.709695,
                                                                                                                                                        4.259691, -1.80529,
                                                                                                                                                        17.274217,
                                                                                                                                                        4.26151, -2.768433,
                                                                                                                                                        20.708733,
                                                                                                                                                        1.37948, -1.80529,
                                                                                                                                                        17.273381,
                                                                                                                                                        1.755436, -2.768433,
                                                                                                                                                        20.708733,
                                                                                                                                                        1.37948, -1.80529,
                                                                                                                                                        17.274217,
                                                                                                                                                        4.26151, -1.80529,
                                                                                                                                                        17.274217,
                                                                                                                                                        4.26151, -1.764132,
                                                                                                                                                        13.706522,
                                                                                                                                                        4.2634, -1.80529,
                                                                                                                                                        17.273381,
                                                                                                                                                        1.755436, -1.764132,
                                                                                                                                                        13.705815,
                                                                                                                                                        2.145862, -1.80529,
                                                                                                                                                        17.273381,
                                                                                                                                                        1.755436, -1.764132,
                                                                                                                                                        13.706522,
                                                                                                                                                        4.2634, -20.71002,
                                                                                                                                                        27.89868,
                                                                                                                                                        0.285542, -23.671835,
                                                                                                                                                        26.142979,
                                                                                                                                                        0.784769, -20.71002,
                                                                                                                                                        27.900005,
                                                                                                                                                        4.255881, -23.779157,
                                                                                                                                                        26.079357,
                                                                                                                                                        0.791732, -20.71002,
                                                                                                                                                        27.900005,
                                                                                                                                                        4.255881, -23.671835,
                                                                                                                                                        26.142979,
                                                                                                                                                        0.784769, -21.408853,
                                                                                                                                                        29.533902,
                                                                                                                                                        5.226081, -17.526764,
                                                                                                                                                        30.622254,
                                                                                                                                                        5.225571, -20.71002,
                                                                                                                                                        27.900005,
                                                                                                                                                        4.255881, -13.142001,
                                                                                                                                                        0.046508,
                                                                                                                                                        5.239905, -17.173498,
                                                                                                                                                        0,
                                                                                                                                                        5.239927, -13.394222,
                                                                                                                                                        1.804966,
                                                                                                                                                        4.269705, -13.394222,
                                                                                                                                                        1.804966,
                                                                                                                                                        4.269705, -9.958745,
                                                                                                                                                        2.768109,
                                                                                                                                                        4.269195, -13.142001,
                                                                                                                                                        0.046508,
                                                                                                                                                        5.239905, -9.259912,
                                                                                                                                                        1.13486,
                                                                                                                                                        5.239395, -13.142001,
                                                                                                                                                        0.046508,
                                                                                                                                                        5.239905, -9.958745,
                                                                                                                                                        2.768109,
                                                                                                                                                        4.269195, -9.958745,
                                                                                                                                                        2.768109,
                                                                                                                                                        4.269195, -6.889608,
                                                                                                                                                        4.587601,
                                                                                                                                                        4.268231, -9.259912,
                                                                                                                                                        1.13486,
                                                                                                                                                        5.239395, -5.791788,
                                                                                                                                                        3.190885,
                                                                                                                                                        5.238431, -9.259912,
                                                                                                                                                        1.13486,
                                                                                                                                                        5.239395, -6.889608,
                                                                                                                                                        4.587601,
                                                                                                                                                        4.268231, -29.67026,
                                                                                                                                                        21.07966,
                                                                                                                                                        5.230045, -27.694789,
                                                                                                                                                        24.594292,
                                                                                                                                                        5.228397, -28.021,
                                                                                                                                                        20.418375,
                                                                                                                                                        4.259845, -26.272796,
                                                                                                                                                        23.528669,
                                                                                                                                                        4.258197, -28.021,
                                                                                                                                                        20.418375,
                                                                                                                                                        4.259845, -27.694789,
                                                                                                                                                        24.594292,
                                                                                                                                                        5.228397, -27.694789,
                                                                                                                                                        24.594292,
                                                                                                                                                        5.228397, -24.876977,
                                                                                                                                                        27.477877,
                                                                                                                                                        5.227045, -26.272796,
                                                                                                                                                        23.528669,
                                                                                                                                                        4.258197, -23.779157,
                                                                                                                                                        26.080514,
                                                                                                                                                        4.256845, -26.272796,
                                                                                                                                                        23.528669,
                                                                                                                                                        4.258197, -24.876977,
                                                                                                                                                        27.477877,
                                                                                                                                                        5.227045, -28.021,
                                                                                                                                                        20.418375,
                                                                                                                                                        4.259845, -28.904632,
                                                                                                                                                        16.961593,
                                                                                                                                                        4.261676, -29.67026,
                                                                                                                                                        21.07966,
                                                                                                                                                        5.230045,
                                                                                                                                                        null,
                                                                                                                                                        null,
                                                                                                                                                        null
                                                                                                                                                    ],
                                                                                                                                                    "normals": [-0.376652, -0.296409, -0.877653, -0.376652, -0.296409, -0.877653, -0.287174, -0.383757, -0.877646, -0.376652, -0.296409, -0.877653, -0.376652, -0.296409, -0.877653, -0.440497, -0.188871, -0.877662, -0.440497, -0.188871, -0.877662, -0.440497, -0.188871, -0.877662, -0.376652, -0.296409, -0.877653, -0.440497, -0.188871, -0.877662, -0.440497, -0.188871, -0.877662, -0.474349, -0.068453, -0.877672, -0.474349, -0.068453, -0.877672, -0.474349, -0.068453, -0.877672, -0.440497, -0.188871, -0.877662, -0.474349, -0.068453, -0.877672, -0.474349, -0.068453, -0.877672, -0.475884,
                                                                                                                                                        0.056646, -0.877682, -0.475884,
                                                                                                                                                        0.056646, -0.877682, -0.475884,
                                                                                                                                                        0.056646, -0.877682, -0.474349, -0.068453, -0.877672, -0.475884,
                                                                                                                                                        0.056646, -0.877682, -0.44498,
                                                                                                                                                        0.177902, -0.877692, -0.475884,
                                                                                                                                                        0.056646, -0.877682, -0.287174, -0.383757, -0.877646, -0.287174, -0.383757, -0.877646, -0.178159, -0.444979, -0.87764, -0.287174, -0.383757, -0.877646, -0.287174, -0.383757, -0.877646, -0.376652, -0.296409, -0.877653, -0.599569, -0.800323,
                                                                                                                                                        0.000267, -0.786278, -0.617873,
                                                                                                                                                        0.000206, -0.599569, -0.800323,
                                                                                                                                                        0.000267, -0.786278, -0.617873,
                                                                                                                                                        0.000206, -0.599569, -0.800323,
                                                                                                                                                        0.000267, -0.786278, -0.617873,
                                                                                                                                                        0.000206, -0.786278, -0.617873,
                                                                                                                                                        0.000206, -0.786278, -0.617873,
                                                                                                                                                        0.000206, -0.919404, -0.393315,
                                                                                                                                                        0.000131, -0.919404, -0.393315,
                                                                                                                                                        0.000131, -0.919404, -0.393315,
                                                                                                                                                        0.000131, -0.786278, -0.617873,
                                                                                                                                                        0.000206, -0.919404, -0.393315,
                                                                                                                                                        0.000131, -0.919404, -0.393315,
                                                                                                                                                        0.000131, -0.989873, -0.141954,
                                                                                                                                                        0.000047, -0.989873, -0.141954,
                                                                                                                                                        0.000047, -0.989873, -0.141954,
                                                                                                                                                        0.000047, -0.919404, -0.393315,
                                                                                                                                                        0.000131, -0.989873, -0.141954,
                                                                                                                                                        0.000047, -0.989873, -0.141954,
                                                                                                                                                        0.000047, -0.992885,
                                                                                                                                                        0.119081, -0.00004, -0.992885,
                                                                                                                                                        0.119081, -0.00004, -0.992885,
                                                                                                                                                        0.119081, -0.00004, -0.989873, -0.141954,
                                                                                                                                                        0.000047, -0.992885,
                                                                                                                                                        0.119081, -0.00004, -0.992885,
                                                                                                                                                        0.119081, -0.00004, -0.928233,
                                                                                                                                                        0.372001, -0.000124, -0.928233,
                                                                                                                                                        0.372001, -0.000124, -0.928233,
                                                                                                                                                        0.372001, -0.000124, -0.992885,
                                                                                                                                                        0.119081, -0.00004, -0.928233,
                                                                                                                                                        0.372001, -0.000124, -0.928233,
                                                                                                                                                        0.372001, -0.000124, -0.800323,
                                                                                                                                                        0.599569, -0.0002, -0.800323,
                                                                                                                                                        0.599569, -0.0002, -0.800323,
                                                                                                                                                        0.599569, -0.0002, -0.928233,
                                                                                                                                                        0.372001, -0.000124, -0.800323,
                                                                                                                                                        0.599569, -0.0002, -0.800323,
                                                                                                                                                        0.599569, -0.0002, -0.617873,
                                                                                                                                                        0.786278, -0.000262, -0.617873,
                                                                                                                                                        0.786278, -0.000262, -0.617873,
                                                                                                                                                        0.786278, -0.000262, -0.800323,
                                                                                                                                                        0.599569, -0.0002, -0.617873,
                                                                                                                                                        0.786278, -0.000262, -0.393315,
                                                                                                                                                        0.919404, -0.000307, -0.617873,
                                                                                                                                                        0.786278, -0.000262, -0.188626,
                                                                                                                                                        0.440498, -0.877714, -0.296289,
                                                                                                                                                        0.376616, -0.877709, -0.188626,
                                                                                                                                                        0.440498, -0.877714, -0.296289,
                                                                                                                                                        0.376616, -0.877709, -0.188626,
                                                                                                                                                        0.440498, -0.877714, -0.296289,
                                                                                                                                                        0.376616, -0.877709, -0.178159, -0.444979, -0.87764, -0.178159, -0.444979, -0.87764, -0.057028, -0.47592, -0.877638, -0.178159, -0.444979, -0.87764, -0.178159, -0.444979, -0.87764, -0.287174, -0.383757, -0.877646, -0.372001, -0.928232,
                                                                                                                                                        0.00031, -0.599569, -0.800323,
                                                                                                                                                        0.000267, -0.372001, -0.928232,
                                                                                                                                                        0.00031, -0.599569, -0.800323,
                                                                                                                                                        0.000267, -0.372001, -0.928232,
                                                                                                                                                        0.00031, -0.599569, -0.800323,
                                                                                                                                                        0.000267, -0.372001, -0.928232,
                                                                                                                                                        0.00031, -0.119081, -0.992885,
                                                                                                                                                        0.000331, -0.372001, -0.928232,
                                                                                                                                                        0.00031, -0.119081, -0.992885,
                                                                                                                                                        0.000331, -0.372001, -0.928232,
                                                                                                                                                        0.00031, -0.119081, -0.992885,
                                                                                                                                                        0.000331, -0.057028, -0.47592, -0.877638, -0.057028, -0.47592, -0.877638, -0.178159, -0.444979, -0.87764, -0.057028, -0.47592, -0.877638,
                                                                                                                                                        0.067982, -0.474479, -0.877638, -0.057028, -0.47592, -0.877638, -0.119081, -0.992885,
                                                                                                                                                        0.000331, -0.119081, -0.992885,
                                                                                                                                                        0.000331,
                                                                                                                                                        0.141954, -0.989873,
                                                                                                                                                        0.00033,
                                                                                                                                                        0.141954, -0.989873,
                                                                                                                                                        0.00033,
                                                                                                                                                        0.141954, -0.989873,
                                                                                                                                                        0.00033, -0.119081, -0.992885,
                                                                                                                                                        0.000331,
                                                                                                                                                        0.141954, -0.989873,
                                                                                                                                                        0.00033,
                                                                                                                                                        0.141954, -0.989873,
                                                                                                                                                        0.00033,
                                                                                                                                                        0.393315, -0.919404,
                                                                                                                                                        0.000307,
                                                                                                                                                        0.393315, -0.919404,
                                                                                                                                                        0.000307,
                                                                                                                                                        0.393315, -0.919404,
                                                                                                                                                        0.000307,
                                                                                                                                                        0.141954, -0.989873,
                                                                                                                                                        0.00033,
                                                                                                                                                        0.393315, -0.919404,
                                                                                                                                                        0.000307,
                                                                                                                                                        0.393315, -0.919404,
                                                                                                                                                        0.000307,
                                                                                                                                                        0.617873, -0.786278,
                                                                                                                                                        0.000262,
                                                                                                                                                        0.617873, -0.786278,
                                                                                                                                                        0.000262,
                                                                                                                                                        0.617873, -0.786278,
                                                                                                                                                        0.000262,
                                                                                                                                                        0.393315, -0.919404,
                                                                                                                                                        0.000307,
                                                                                                                                                        0.617873, -0.786278,
                                                                                                                                                        0.000262,
                                                                                                                                                        0.800323, -0.599569,
                                                                                                                                                        0.0002,
                                                                                                                                                        0.617873, -0.786278,
                                                                                                                                                        0.000262,
                                                                                                                                                        0.800323, -0.599569,
                                                                                                                                                        0.0002,
                                                                                                                                                        0.617873, -0.786278,
                                                                                                                                                        0.000262,
                                                                                                                                                        0.800323, -0.599569,
                                                                                                                                                        0.0002,
                                                                                                                                                        0.295944, -0.377034, -0.877646,
                                                                                                                                                        0.383386, -0.287645, -0.877653,
                                                                                                                                                        0.295944, -0.377034, -0.877646,
                                                                                                                                                        0.383386, -0.287645, -0.877653,
                                                                                                                                                        0.295944, -0.377034, -0.877646,
                                                                                                                                                        0.383386, -0.287645, -0.877653,
                                                                                                                                                        0.444734, -0.178661, -0.877663,
                                                                                                                                                        0.383386, -0.287645, -0.877653,
                                                                                                                                                        0.444734, -0.178661, -0.877663,
                                                                                                                                                        0.383386, -0.287645, -0.877653,
                                                                                                                                                        0.444734, -0.178661, -0.877663,
                                                                                                                                                        0.383386, -0.287645, -0.877653,
                                                                                                                                                        0.928233, -0.372001,
                                                                                                                                                        0.000124,
                                                                                                                                                        0.800323, -0.599569,
                                                                                                                                                        0.0002,
                                                                                                                                                        0.928233, -0.372001,
                                                                                                                                                        0.000124,
                                                                                                                                                        0.800323, -0.599569,
                                                                                                                                                        0.0002,
                                                                                                                                                        0.928233, -0.372001,
                                                                                                                                                        0.000124,
                                                                                                                                                        0.800323, -0.599569,
                                                                                                                                                        0.0002,
                                                                                                                                                        0.928233, -0.372001,
                                                                                                                                                        0.000124,
                                                                                                                                                        0.992885, -0.119081,
                                                                                                                                                        0.00004,
                                                                                                                                                        0.928233, -0.372001,
                                                                                                                                                        0.000124,
                                                                                                                                                        0.992885, -0.119081,
                                                                                                                                                        0.00004,
                                                                                                                                                        0.928233, -0.372001,
                                                                                                                                                        0.000124,
                                                                                                                                                        0.992885, -0.119081,
                                                                                                                                                        0.00004,
                                                                                                                                                        0.444734, -0.178661, -0.877663,
                                                                                                                                                        0.4758, -0.057493, -0.877673,
                                                                                                                                                        0.444734, -0.178661, -0.877663,
                                                                                                                                                        0.4758, -0.057493, -0.877673,
                                                                                                                                                        0.444734, -0.178661, -0.877663,
                                                                                                                                                        0.4758, -0.057493, -0.877673,
                                                                                                                                                        0.4758, -0.057493, -0.877673,
                                                                                                                                                        0.4758, -0.057493, -0.877673,
                                                                                                                                                        0.474449,
                                                                                                                                                        0.06761, -0.877683,
                                                                                                                                                        0.474449,
                                                                                                                                                        0.06761, -0.877683,
                                                                                                                                                        0.474449,
                                                                                                                                                        0.06761, -0.877683,
                                                                                                                                                        0.4758, -0.057493, -0.877673,
                                                                                                                                                        0.474449,
                                                                                                                                                        0.06761, -0.877683,
                                                                                                                                                        0.474449,
                                                                                                                                                        0.06761, -0.877683,
                                                                                                                                                        0.440754,
                                                                                                                                                        0.188123, -0.877693,
                                                                                                                                                        0.440754,
                                                                                                                                                        0.188123, -0.877693,
                                                                                                                                                        0.440754,
                                                                                                                                                        0.188123, -0.877693,
                                                                                                                                                        0.474449,
                                                                                                                                                        0.06761, -0.877683,
                                                                                                                                                        0.440754,
                                                                                                                                                        0.188123, -0.877693,
                                                                                                                                                        0.440754,
                                                                                                                                                        0.188123, -0.877693,
                                                                                                                                                        0.376998,
                                                                                                                                                        0.295824, -0.877702,
                                                                                                                                                        0.376998,
                                                                                                                                                        0.295824, -0.877702,
                                                                                                                                                        0.376998,
                                                                                                                                                        0.295824, -0.877702,
                                                                                                                                                        0.440754,
                                                                                                                                                        0.188123, -0.877693,
                                                                                                                                                        0.376998,
                                                                                                                                                        0.295824, -0.877702,
                                                                                                                                                        0.376998,
                                                                                                                                                        0.295824, -0.877702,
                                                                                                                                                        0.287515,
                                                                                                                                                        0.383355, -0.877709,
                                                                                                                                                        0.287515,
                                                                                                                                                        0.383355, -0.877709,
                                                                                                                                                        0.287515,
                                                                                                                                                        0.383355, -0.877709,
                                                                                                                                                        0.376998,
                                                                                                                                                        0.295824, -0.877702,
                                                                                                                                                        0.287515,
                                                                                                                                                        0.383355, -0.877709,
                                                                                                                                                        0.287515,
                                                                                                                                                        0.383355, -0.877709,
                                                                                                                                                        0.178405,
                                                                                                                                                        0.444735, -0.877714,
                                                                                                                                                        0.178405,
                                                                                                                                                        0.444735, -0.877714,
                                                                                                                                                        0.178405,
                                                                                                                                                        0.444735, -0.877714,
                                                                                                                                                        0.287515,
                                                                                                                                                        0.383355, -0.877709,
                                                                                                                                                        0.178405,
                                                                                                                                                        0.444735, -0.877714,
                                                                                                                                                        0.178405,
                                                                                                                                                        0.444735, -0.877714,
                                                                                                                                                        0.057112,
                                                                                                                                                        0.475764, -0.877717,
                                                                                                                                                        0.057112,
                                                                                                                                                        0.475764, -0.877717,
                                                                                                                                                        0.057112,
                                                                                                                                                        0.475764, -0.877717,
                                                                                                                                                        0.178405,
                                                                                                                                                        0.444735, -0.877714,
                                                                                                                                                        0.057112,
                                                                                                                                                        0.475764, -0.877717,
                                                                                                                                                        0.057112,
                                                                                                                                                        0.475764, -0.877717, -0.068082,
                                                                                                                                                        0.474318, -0.877717, -0.068082,
                                                                                                                                                        0.474318, -0.877717, -0.068082,
                                                                                                                                                        0.474318, -0.877717,
                                                                                                                                                        0.057112,
                                                                                                                                                        0.475764, -0.877717, -0.068082,
                                                                                                                                                        0.474318, -0.877717, -0.188626,
                                                                                                                                                        0.440498, -0.877714, -0.068082,
                                                                                                                                                        0.474318, -0.877717, -0.393315,
                                                                                                                                                        0.919404, -0.000307, -0.141954,
                                                                                                                                                        0.989873, -0.00033, -0.393315,
                                                                                                                                                        0.919404, -0.000307, -0.141954,
                                                                                                                                                        0.989873, -0.00033, -0.393315,
                                                                                                                                                        0.919404, -0.000307, -0.141954,
                                                                                                                                                        0.989873, -0.00033, -0.141954,
                                                                                                                                                        0.989873, -0.00033,
                                                                                                                                                        0.119081,
                                                                                                                                                        0.992885, -0.000331, -0.141954,
                                                                                                                                                        0.989873, -0.00033,
                                                                                                                                                        0.119081,
                                                                                                                                                        0.992885, -0.000331, -0.141954,
                                                                                                                                                        0.989873, -0.00033,
                                                                                                                                                        0.119081,
                                                                                                                                                        0.992885, -0.000331,
                                                                                                                                                        0.119081,
                                                                                                                                                        0.992885, -0.000331,
                                                                                                                                                        0.119081,
                                                                                                                                                        0.992885, -0.000331,
                                                                                                                                                        0.372001,
                                                                                                                                                        0.928232, -0.00031,
                                                                                                                                                        0.372001,
                                                                                                                                                        0.928232, -0.00031,
                                                                                                                                                        0.372001,
                                                                                                                                                        0.928232, -0.00031,
                                                                                                                                                        0.119081,
                                                                                                                                                        0.992885, -0.000331,
                                                                                                                                                        0.372001,
                                                                                                                                                        0.928232, -0.00031,
                                                                                                                                                        0.372001,
                                                                                                                                                        0.928232, -0.00031,
                                                                                                                                                        0.599569,
                                                                                                                                                        0.800323, -0.000267,
                                                                                                                                                        0.599569,
                                                                                                                                                        0.800323, -0.000267,
                                                                                                                                                        0.599569,
                                                                                                                                                        0.800323, -0.000267,
                                                                                                                                                        0.372001,
                                                                                                                                                        0.928232, -0.00031,
                                                                                                                                                        0.599569,
                                                                                                                                                        0.800323, -0.000267,
                                                                                                                                                        0.599569,
                                                                                                                                                        0.800323, -0.000267,
                                                                                                                                                        0.698903,
                                                                                                                                                        0.715216, -0.000239,
                                                                                                                                                        0.786278,
                                                                                                                                                        0.617873, -0.000206,
                                                                                                                                                        0.698903,
                                                                                                                                                        0.715216, -0.000239,
                                                                                                                                                        0.599569,
                                                                                                                                                        0.800323, -0.000267,
                                                                                                                                                        0.786278,
                                                                                                                                                        0.617873, -0.000206,
                                                                                                                                                        0.786278,
                                                                                                                                                        0.617873, -0.000206,
                                                                                                                                                        0.599569,
                                                                                                                                                        0.800323, -0.000267,
                                                                                                                                                        0.786278,
                                                                                                                                                        0.617873, -0.000206,
                                                                                                                                                        0.919404,
                                                                                                                                                        0.393315, -0.000131,
                                                                                                                                                        0.786278,
                                                                                                                                                        0.617873, -0.000206,
                                                                                                                                                        0.919404,
                                                                                                                                                        0.393315, -0.000131,
                                                                                                                                                        0.786278,
                                                                                                                                                        0.617873, -0.000206,
                                                                                                                                                        0.919404,
                                                                                                                                                        0.393315, -0.000131,
                                                                                                                                                        0.919404,
                                                                                                                                                        0.393315, -0.000131,
                                                                                                                                                        0.989873,
                                                                                                                                                        0.141954, -0.000047,
                                                                                                                                                        0.919404,
                                                                                                                                                        0.393315, -0.000131,
                                                                                                                                                        0.989873,
                                                                                                                                                        0.141954, -0.000047,
                                                                                                                                                        0.919404,
                                                                                                                                                        0.393315, -0.000131,
                                                                                                                                                        0.989873,
                                                                                                                                                        0.141954, -0.000047,
                                                                                                                                                        0.989873,
                                                                                                                                                        0.141954, -0.000047,
                                                                                                                                                        0.992885, -0.119081,
                                                                                                                                                        0.00004,
                                                                                                                                                        0.989873,
                                                                                                                                                        0.141954, -0.000047,
                                                                                                                                                        0.992885, -0.119081,
                                                                                                                                                        0.00004,
                                                                                                                                                        0.989873,
                                                                                                                                                        0.141954, -0.000047,
                                                                                                                                                        0.992885, -0.119081,
                                                                                                                                                        0.00004, -0.393315,
                                                                                                                                                        0.919404, -0.000307, -0.509957,
                                                                                                                                                        0.8602, -0.000287, -0.393315,
                                                                                                                                                        0.919404, -0.000307, -0.617873,
                                                                                                                                                        0.786278, -0.000262, -0.393315,
                                                                                                                                                        0.919404, -0.000307, -0.509957,
                                                                                                                                                        0.8602, -0.000287, -0.188626,
                                                                                                                                                        0.440498, -0.877714, -0.068082,
                                                                                                                                                        0.474318, -0.877717, -0.188626,
                                                                                                                                                        0.440498, -0.877714,
                                                                                                                                                        0.067982, -0.474479, -0.877638, -0.057028, -0.47592, -0.877638,
                                                                                                                                                        0.067982, -0.474479, -0.877638,
                                                                                                                                                        0.067982, -0.474479, -0.877638,
                                                                                                                                                        0.188368, -0.440754, -0.877641,
                                                                                                                                                        0.067982, -0.474479, -0.877638,
                                                                                                                                                        0.188368, -0.440754, -0.877641,
                                                                                                                                                        0.067982, -0.474479, -0.877638,
                                                                                                                                                        0.188368, -0.440754, -0.877641,
                                                                                                                                                        0.188368, -0.440754, -0.877641,
                                                                                                                                                        0.295944, -0.377034, -0.877646,
                                                                                                                                                        0.188368, -0.440754, -0.877641,
                                                                                                                                                        0.295944, -0.377034, -0.877646,
                                                                                                                                                        0.188368, -0.440754, -0.877641,
                                                                                                                                                        0.295944, -0.377034, -0.877646, -0.44498,
                                                                                                                                                        0.177902, -0.877692, -0.383727,
                                                                                                                                                        0.287044, -0.877701, -0.44498,
                                                                                                                                                        0.177902, -0.877692, -0.383727,
                                                                                                                                                        0.287044, -0.877701, -0.44498,
                                                                                                                                                        0.177902, -0.877692, -0.383727,
                                                                                                                                                        0.287044, -0.877701, -0.383727,
                                                                                                                                                        0.287044, -0.877701, -0.296289,
                                                                                                                                                        0.376616, -0.877709, -0.383727,
                                                                                                                                                        0.287044, -0.877701, -0.296289,
                                                                                                                                                        0.376616, -0.877709, -0.383727,
                                                                                                                                                        0.287044, -0.877701, -0.296289,
                                                                                                                                                        0.376616, -0.877709, -0.44498,
                                                                                                                                                        0.177902, -0.877692, -0.475884,
                                                                                                                                                        0.056646, -0.877682, -0.44498,
                                                                                                                                                        0.177902, -0.877692,
                                                                                                                                                        null,
                                                                                                                                                        null,
                                                                                                                                                        null
                                                                                                                                                    ],
                                                                                                                                                    "uv": [
                                                                                                                                                        23.709998,
                                                                                                                                                        15.706704,
                                                                                                                                                        23.476748,
                                                                                                                                                        13.695957,
                                                                                                                                                        19.678234,
                                                                                                                                                        15.709562,
                                                                                                                                                        19.240902,
                                                                                                                                                        18.619291,
                                                                                                                                                        19.010628,
                                                                                                                                                        20.63038,
                                                                                                                                                        22.808834,
                                                                                                                                                        18.616088,
                                                                                                                                                        23.042391,
                                                                                                                                                        20.626863,
                                                                                                                                                        22.808834,
                                                                                                                                                        18.616088,
                                                                                                                                                        19.010628,
                                                                                                                                                        20.63038,
                                                                                                                                                        17.141196,
                                                                                                                                                        23.221492,
                                                                                                                                                        16.911119,
                                                                                                                                                        25.232668,
                                                                                                                                                        20.709128,
                                                                                                                                                        23.217906,
                                                                                                                                                        20.942882,
                                                                                                                                                        25.22873,
                                                                                                                                                        20.709128,
                                                                                                                                                        23.217906,
                                                                                                                                                        16.911119,
                                                                                                                                                        25.232668,
                                                                                                                                                        13.751783,
                                                                                                                                                        27.191552,
                                                                                                                                                        13.521776,
                                                                                                                                                        29.202808,
                                                                                                                                                        17.319715,
                                                                                                                                                        27.187829,
                                                                                                                                                        17.553539,
                                                                                                                                                        29.198719,
                                                                                                                                                        17.319715,
                                                                                                                                                        27.187829,
                                                                                                                                                        13.521776,
                                                                                                                                                        29.202808,
                                                                                                                                                        9.072693,
                                                                                                                                                        32.2698,
                                                                                                                                                        13.104456,
                                                                                                                                                        32.265838,
                                                                                                                                                        9.302759,
                                                                                                                                                        30.258476,
                                                                                                                                                        22.901066,
                                                                                                                                                        10.803072,
                                                                                                                                                        22.668215,
                                                                                                                                                        8.792331,
                                                                                                                                                        18.869302,
                                                                                                                                                        10.805075,
                                                                                                                                                        19.908815,
                                                                                                                                                        13.69856,
                                                                                                                                                        19.678234,
                                                                                                                                                        15.709562,
                                                                                                                                                        23.476748,
                                                                                                                                                        13.695957,
                                                                                                                                                        19.900455,
                                                                                                                                                        4.265159,
                                                                                                                                                        23.468388,
                                                                                                                                                        4.263838,
                                                                                                                                                        19.900198,
                                                                                                                                                        3.16161,
                                                                                                                                                        23.468067,
                                                                                                                                                        2.888722,
                                                                                                                                                        19.900198,
                                                                                                                                                        3.16161,
                                                                                                                                                        23.468388,
                                                                                                                                                        4.263838,
                                                                                                                                                        19.225867,
                                                                                                                                                        2.888676,
                                                                                                                                                        19.226262,
                                                                                                                                                        4.263792,
                                                                                                                                                        22.793704,
                                                                                                                                                        2.55281,
                                                                                                                                                        22.794195,
                                                                                                                                                        4.262166,
                                                                                                                                                        22.793704,
                                                                                                                                                        2.55281,
                                                                                                                                                        19.226262,
                                                                                                                                                        4.263792,
                                                                                                                                                        17.119707,
                                                                                                                                                        2.553852,
                                                                                                                                                        17.120256,
                                                                                                                                                        4.263208,
                                                                                                                                                        20.68752,
                                                                                                                                                        2.177896,
                                                                                                                                                        20.68819,
                                                                                                                                                        4.261388,
                                                                                                                                                        20.68752,
                                                                                                                                                        2.177896,
                                                                                                                                                        17.120256,
                                                                                                                                                        4.263208,
                                                                                                                                                        13.725265,
                                                                                                                                                        2.179963,
                                                                                                                                                        13.72596,
                                                                                                                                                        4.263456,
                                                                                                                                                        17.293068,
                                                                                                                                                        1.789537,
                                                                                                                                                        17.293893,
                                                                                                                                                        4.261566,
                                                                                                                                                        17.293068,
                                                                                                                                                        1.789537,
                                                                                                                                                        13.72596,
                                                                                                                                                        4.263456,
                                                                                                                                                        9.273888,
                                                                                                                                                        1.792309,
                                                                                                                                                        9.274688,
                                                                                                                                                        4.264337,
                                                                                                                                                        12.8417,
                                                                                                                                                        1.414021,
                                                                                                                                                        12.842621,
                                                                                                                                                        4.262506,
                                                                                                                                                        12.8417,
                                                                                                                                                        1.414021,
                                                                                                                                                        9.274688,
                                                                                                                                                        4.264337,
                                                                                                                                                        4.068958,
                                                                                                                                                        1.416989,
                                                                                                                                                        4.069786,
                                                                                                                                                        4.265474,
                                                                                                                                                        7.636792,
                                                                                                                                                        1.076619,
                                                                                                                                                        7.637719,
                                                                                                                                                        4.263826,
                                                                                                                                                        7.636792,
                                                                                                                                                        1.076619,
                                                                                                                                                        4.069786,
                                                                                                                                                        4.265474, -1.5348,
                                                                                                                                                        1.079206, -1.534039,
                                                                                                                                                        4.266414,
                                                                                                                                                        2.033067,
                                                                                                                                                        0.799949,
                                                                                                                                                        2.033894,
                                                                                                                                                        4.265062,
                                                                                                                                                        2.033067,
                                                                                                                                                        0.799949, -1.534039,
                                                                                                                                                        4.266414, -7.154896,
                                                                                                                                                        4.266765, -3.586963,
                                                                                                                                                        4.265801, -7.155486,
                                                                                                                                                        0.801652, -3.571104,
                                                                                                                                                        32.328496, -7.139037,
                                                                                                                                                        32.330395, -3.338215,
                                                                                                                                                        34.339724, -7.369979,
                                                                                                                                                        34.341809, -3.338215,
                                                                                                                                                        34.339724, -7.139037,
                                                                                                                                                        32.330395,
                                                                                                                                                        20.671207,
                                                                                                                                                        6.249329,
                                                                                                                                                        20.438818,
                                                                                                                                                        4.238571,
                                                                                                                                                        16.639442,
                                                                                                                                                        6.250341,
                                                                                                                                                        19.100282,
                                                                                                                                                        8.794156,
                                                                                                                                                        18.869302,
                                                                                                                                                        10.805075,
                                                                                                                                                        22.668215,
                                                                                                                                                        8.792331,
                                                                                                                                                        19.09689,
                                                                                                                                                        4.26702,
                                                                                                                                                        22.664824,
                                                                                                                                                        4.266094,
                                                                                                                                                        19.096741,
                                                                                                                                                        3.353857,
                                                                                                                                                        22.664643,
                                                                                                                                                        3.162545,
                                                                                                                                                        19.096741,
                                                                                                                                                        3.353857,
                                                                                                                                                        22.664824,
                                                                                                                                                        4.266094,
                                                                                                                                                        20.438188,
                                                                                                                                                        3.35529,
                                                                                                                                                        16.870262,
                                                                                                                                                        3.451989,
                                                                                                                                                        20.438263,
                                                                                                                                                        4.268453,
                                                                                                                                                        16.87033,
                                                                                                                                                        4.268921,
                                                                                                                                                        20.438263,
                                                                                                                                                        4.268453,
                                                                                                                                                        16.870262,
                                                                                                                                                        3.451989,
                                                                                                                                                        16.870885,
                                                                                                                                                        4.239494,
                                                                                                                                                        16.639442,
                                                                                                                                                        6.250341,
                                                                                                                                                        20.438818,
                                                                                                                                                        4.238571,
                                                                                                                                                        16.940464,
                                                                                                                                                        0.344085,
                                                                                                                                                        13.37253,
                                                                                                                                                        0.344042,
                                                                                                                                                        17.172357,
                                                                                                                                                        2.354881,
                                                                                                                                                        16.940443,
                                                                                                                                                        4.270381,
                                                                                                                                                        16.940446,
                                                                                                                                                        3.453449,
                                                                                                                                                        13.37251,
                                                                                                                                                        4.270359,
                                                                                                                                                        13.372513,
                                                                                                                                                        3.448945,
                                                                                                                                                        13.37251,
                                                                                                                                                        4.270359,
                                                                                                                                                        16.940446,
                                                                                                                                                        3.453449,
                                                                                                                                                        12.409734,
                                                                                                                                                        4.271425,
                                                                                                                                                        12.409808,
                                                                                                                                                        3.450011,
                                                                                                                                                        8.841801,
                                                                                                                                                        4.270915,
                                                                                                                                                        8.841884,
                                                                                                                                                        3.344611,
                                                                                                                                                        8.841801,
                                                                                                                                                        4.270915,
                                                                                                                                                        12.409808,
                                                                                                                                                        3.450011,
                                                                                                                                                        7.154896,
                                                                                                                                                        4.271336,
                                                                                                                                                        7.155054,
                                                                                                                                                        3.345032,
                                                                                                                                                        3.586963,
                                                                                                                                                        4.270372,
                                                                                                                                                        3.587154,
                                                                                                                                                        3.145919,
                                                                                                                                                        3.586963,
                                                                                                                                                        4.270372,
                                                                                                                                                        7.155054,
                                                                                                                                                        3.345032,
                                                                                                                                                        1.534307,
                                                                                                                                                        3.145674, -2.03356,
                                                                                                                                                        2.866417,
                                                                                                                                                        1.534039,
                                                                                                                                                        4.270128, -2.033894,
                                                                                                                                                        4.268776,
                                                                                                                                                        1.534039,
                                                                                                                                                        4.270128, -2.03356,
                                                                                                                                                        2.866417,
                                                                                                                                                        1.539273, -5.064332, -2.028659, -5.066995,
                                                                                                                                                        1.769824, -3.053322, -2.26194, -3.056247,
                                                                                                                                                        1.769824, -3.053322, -2.028659, -5.066995, -7.865547, -2.35738, -3.833783, -2.353815, -7.631967, -4.368158, -4.064035, -4.364912, -7.631967, -4.368158, -3.833783, -2.353815, -7.637719,
                                                                                                                                                        4.26643, -4.069786,
                                                                                                                                                        4.268078, -7.637213,
                                                                                                                                                        2.525348, -4.069378,
                                                                                                                                                        2.865719, -7.637213,
                                                                                                                                                        2.525348, -4.069786,
                                                                                                                                                        4.268078, -9.274125,
                                                                                                                                                        2.524571, -12.841936,
                                                                                                                                                        2.146284, -9.274688,
                                                                                                                                                        4.265653, -12.842621,
                                                                                                                                                        4.263822, -9.274688,
                                                                                                                                                        4.265653, -12.841936,
                                                                                                                                                        2.146284, -9.270235, -2.419827, -12.838167, -2.423435, -9.040168, -0.408643, -13.071931, -0.412605, -9.040168, -0.408643, -12.838167, -2.423435, -13.494503,
                                                                                                                                                        2.650557, -13.724509,
                                                                                                                                                        0.639295, -17.526265,
                                                                                                                                                        2.646468, -17.292441,
                                                                                                                                                        0.635571, -17.526265,
                                                                                                                                                        2.646468, -13.724509,
                                                                                                                                                        0.639295, -16.892707,
                                                                                                                                                        6.616099, -17.122784,
                                                                                                                                                        4.60477, -20.924469,
                                                                                                                                                        6.612162, -20.690716,
                                                                                                                                                        4.601184, -20.924469,
                                                                                                                                                        6.612162, -17.122784,
                                                                                                                                                        4.60477, -19.002314,
                                                                                                                                                        11.218183, -19.232587,
                                                                                                                                                        9.206804, -23.034077,
                                                                                                                                                        11.214665, -22.800519,
                                                                                                                                                        9.203601, -23.034077,
                                                                                                                                                        11.214665, -19.232587,
                                                                                                                                                        9.206804, -19.678548,
                                                                                                                                                        16.143163, -19.90913,
                                                                                                                                                        14.131755, -23.710312,
                                                                                                                                                        16.140304, -23.477062,
                                                                                                                                                        14.129152, -23.710312,
                                                                                                                                                        16.140304, -19.90913,
                                                                                                                                                        14.131755, -18.874463,
                                                                                                                                                        21.054929, -19.105444,
                                                                                                                                                        19.043515, -22.906228,
                                                                                                                                                        21.052925, -22.673377,
                                                                                                                                                        19.04169, -22.906228,
                                                                                                                                                        21.052925, -19.105444,
                                                                                                                                                        19.043515, -16.644371,
                                                                                                                                                        25.617939, -16.875814,
                                                                                                                                                        23.606542, -20.676135,
                                                                                                                                                        25.616926, -20.443747,
                                                                                                                                                        23.605619, -20.676135,
                                                                                                                                                        25.616926, -16.875814,
                                                                                                                                                        23.606542, -13.14027,
                                                                                                                                                        29.520305, -13.372208,
                                                                                                                                                        27.508946, -17.172035,
                                                                                                                                                        29.520352, -16.940142,
                                                                                                                                                        27.508989, -17.172035,
                                                                                                                                                        29.520352, -13.372208,
                                                                                                                                                        27.508946, -8.833917,
                                                                                                                                                        30.483994, -12.401851,
                                                                                                                                                        30.484999, -8.601486,
                                                                                                                                                        32.495295, -12.409734,
                                                                                                                                                        4.266309, -8.841801,
                                                                                                                                                        4.265798, -12.410092,
                                                                                                                                                        0.295969, -8.842183,
                                                                                                                                                        0.022129, -12.410092,
                                                                                                                                                        0.295969, -8.841801,
                                                                                                                                                        4.265798, -16.940443,
                                                                                                                                                        4.265067, -13.37251,
                                                                                                                                                        4.265045, -16.94046,
                                                                                                                                                        0.021398, -13.372526,
                                                                                                                                                        0.009696, -16.94046,
                                                                                                                                                        0.021398, -13.37251,
                                                                                                                                                        4.265045, -20.437912,
                                                                                                                                                        0.007955, -20.438263,
                                                                                                                                                        4.263305, -16.869999,
                                                                                                                                                        0.259189, -16.87033,
                                                                                                                                                        4.263773, -16.869999,
                                                                                                                                                        0.259189, -20.438263,
                                                                                                                                                        4.263305, -22.664169,
                                                                                                                                                        0.256878, -22.664824,
                                                                                                                                                        4.261462, -19.096317,
                                                                                                                                                        0.753926, -19.09689,
                                                                                                                                                        4.262388, -19.096317,
                                                                                                                                                        0.753926, -22.664824,
                                                                                                                                                        4.261462, -23.46757,
                                                                                                                                                        0.751575, -23.468388,
                                                                                                                                                        4.260037, -23.283959,
                                                                                                                                                        0.788063, -19.899705,
                                                                                                                                                        1.046907, -23.283959,
                                                                                                                                                        0.788063, -23.468388,
                                                                                                                                                        4.260037, -19.900455,
                                                                                                                                                        4.261358, -19.899705,
                                                                                                                                                        1.046907, -23.468388,
                                                                                                                                                        4.260037, -22.794195,
                                                                                                                                                        4.259456, -19.226262,
                                                                                                                                                        4.261082, -22.793272,
                                                                                                                                                        1.045005, -19.225435,
                                                                                                                                                        1.380872, -22.793272,
                                                                                                                                                        1.045005, -19.226262,
                                                                                                                                                        4.261082, -20.68819,
                                                                                                                                                        4.259954, -17.120256,
                                                                                                                                                        4.261774, -20.687264,
                                                                                                                                                        1.379743, -17.119451,
                                                                                                                                                        1.7557, -20.687264,
                                                                                                                                                        1.379743, -17.120256,
                                                                                                                                                        4.261774, -17.293893,
                                                                                                                                                        4.261504, -13.72596,
                                                                                                                                                        4.263394, -17.293057,
                                                                                                                                                        1.75543, -13.725253,
                                                                                                                                                        2.145856, -17.293057,
                                                                                                                                                        1.75543, -13.72596,
                                                                                                                                                        4.263394, -3.587639,
                                                                                                                                                        0.295462, -7.030724,
                                                                                                                                                        0.794689, -3.586963,
                                                                                                                                                        4.265801, -7.155486,
                                                                                                                                                        0.801652, -3.586963,
                                                                                                                                                        4.265801, -7.030724,
                                                                                                                                                        0.794689, -12.633251,
                                                                                                                                                        32.496399, -8.601486,
                                                                                                                                                        32.495295, -12.401851,
                                                                                                                                                        30.484999,
                                                                                                                                                        13.140592,
                                                                                                                                                        2.354833,
                                                                                                                                                        17.172357,
                                                                                                                                                        2.354881,
                                                                                                                                                        13.37253,
                                                                                                                                                        0.344042,
                                                                                                                                                        12.411034, -2.626516,
                                                                                                                                                        8.843101, -2.627521,
                                                                                                                                                        12.642435, -0.615663,
                                                                                                                                                        8.61067, -0.616766,
                                                                                                                                                        12.642435, -0.615663,
                                                                                                                                                        8.843101, -2.627521,
                                                                                                                                                        7.158319, -4.471234,
                                                                                                                                                        3.590386, -4.473132,
                                                                                                                                                        7.389261, -2.460307,
                                                                                                                                                        3.357497, -2.462392,
                                                                                                                                                        7.389261, -2.460307,
                                                                                                                                                        3.590386, -4.473132,
                                                                                                                                                        3.866541,
                                                                                                                                                        34.223842,
                                                                                                                                                        7.898304,
                                                                                                                                                        34.220277,
                                                                                                                                                        4.096792,
                                                                                                                                                        32.212467,
                                                                                                                                                        7.664725,
                                                                                                                                                        32.20922,
                                                                                                                                                        4.096792,
                                                                                                                                                        32.212467,
                                                                                                                                                        7.898304,
                                                                                                                                                        34.220277, -1.741913,
                                                                                                                                                        34.930843,
                                                                                                                                                        2.28985,
                                                                                                                                                        34.927918, -1.511363,
                                                                                                                                                        32.919438,
                                                                                                                                                        2.056569,
                                                                                                                                                        32.916774, -1.511363,
                                                                                                                                                        32.919438,
                                                                                                                                                        2.28985,
                                                                                                                                                        34.927918,
                                                                                                                                                        12.870691,
                                                                                                                                                        30.254868,
                                                                                                                                                        9.302759,
                                                                                                                                                        30.258476,
                                                                                                                                                        13.104456,
                                                                                                                                                        32.265838,
                                                                                                                                                        null,
                                                                                                                                                        null
                                                                                                                                                    ],
                                                                                                                                                    "indices": [
                                                                                                                                                        0,
                                                                                                                                                        1,
                                                                                                                                                        2,
                                                                                                                                                        3,
                                                                                                                                                        4,
                                                                                                                                                        5,
                                                                                                                                                        6,
                                                                                                                                                        7,
                                                                                                                                                        8,
                                                                                                                                                        9,
                                                                                                                                                        10,
                                                                                                                                                        11,
                                                                                                                                                        12,
                                                                                                                                                        13,
                                                                                                                                                        14,
                                                                                                                                                        15,
                                                                                                                                                        16,
                                                                                                                                                        17,
                                                                                                                                                        18,
                                                                                                                                                        19,
                                                                                                                                                        20,
                                                                                                                                                        21,
                                                                                                                                                        22,
                                                                                                                                                        23,
                                                                                                                                                        24,
                                                                                                                                                        25,
                                                                                                                                                        26,
                                                                                                                                                        27,
                                                                                                                                                        28,
                                                                                                                                                        29,
                                                                                                                                                        30,
                                                                                                                                                        31,
                                                                                                                                                        32,
                                                                                                                                                        33,
                                                                                                                                                        34,
                                                                                                                                                        35,
                                                                                                                                                        36,
                                                                                                                                                        37,
                                                                                                                                                        38,
                                                                                                                                                        39,
                                                                                                                                                        40,
                                                                                                                                                        41,
                                                                                                                                                        42,
                                                                                                                                                        43,
                                                                                                                                                        44,
                                                                                                                                                        45,
                                                                                                                                                        46,
                                                                                                                                                        47,
                                                                                                                                                        48,
                                                                                                                                                        49,
                                                                                                                                                        50,
                                                                                                                                                        51,
                                                                                                                                                        52,
                                                                                                                                                        53,
                                                                                                                                                        54,
                                                                                                                                                        55,
                                                                                                                                                        56,
                                                                                                                                                        57,
                                                                                                                                                        58,
                                                                                                                                                        59,
                                                                                                                                                        60,
                                                                                                                                                        61,
                                                                                                                                                        62,
                                                                                                                                                        63,
                                                                                                                                                        64,
                                                                                                                                                        65,
                                                                                                                                                        66,
                                                                                                                                                        67,
                                                                                                                                                        68,
                                                                                                                                                        69,
                                                                                                                                                        70,
                                                                                                                                                        71,
                                                                                                                                                        72,
                                                                                                                                                        73,
                                                                                                                                                        74,
                                                                                                                                                        75,
                                                                                                                                                        76,
                                                                                                                                                        77,
                                                                                                                                                        78,
                                                                                                                                                        79,
                                                                                                                                                        80,
                                                                                                                                                        81,
                                                                                                                                                        82,
                                                                                                                                                        83,
                                                                                                                                                        84,
                                                                                                                                                        85,
                                                                                                                                                        86,
                                                                                                                                                        87,
                                                                                                                                                        88,
                                                                                                                                                        89,
                                                                                                                                                        90,
                                                                                                                                                        91,
                                                                                                                                                        92,
                                                                                                                                                        93,
                                                                                                                                                        94,
                                                                                                                                                        95,
                                                                                                                                                        96,
                                                                                                                                                        97,
                                                                                                                                                        98,
                                                                                                                                                        99,
                                                                                                                                                        100,
                                                                                                                                                        101,
                                                                                                                                                        102,
                                                                                                                                                        103,
                                                                                                                                                        104,
                                                                                                                                                        105,
                                                                                                                                                        106,
                                                                                                                                                        107,
                                                                                                                                                        108,
                                                                                                                                                        109,
                                                                                                                                                        110,
                                                                                                                                                        111,
                                                                                                                                                        112,
                                                                                                                                                        113,
                                                                                                                                                        114,
                                                                                                                                                        115,
                                                                                                                                                        116,
                                                                                                                                                        117,
                                                                                                                                                        118,
                                                                                                                                                        119,
                                                                                                                                                        120,
                                                                                                                                                        121,
                                                                                                                                                        122,
                                                                                                                                                        123,
                                                                                                                                                        124,
                                                                                                                                                        125,
                                                                                                                                                        126,
                                                                                                                                                        127,
                                                                                                                                                        128,
                                                                                                                                                        129,
                                                                                                                                                        130,
                                                                                                                                                        131,
                                                                                                                                                        132,
                                                                                                                                                        133,
                                                                                                                                                        134,
                                                                                                                                                        135,
                                                                                                                                                        136,
                                                                                                                                                        137,
                                                                                                                                                        138,
                                                                                                                                                        139,
                                                                                                                                                        140,
                                                                                                                                                        141,
                                                                                                                                                        142,
                                                                                                                                                        143,
                                                                                                                                                        144,
                                                                                                                                                        145,
                                                                                                                                                        146,
                                                                                                                                                        147,
                                                                                                                                                        148,
                                                                                                                                                        149,
                                                                                                                                                        150,
                                                                                                                                                        151,
                                                                                                                                                        152,
                                                                                                                                                        153,
                                                                                                                                                        154,
                                                                                                                                                        155,
                                                                                                                                                        156,
                                                                                                                                                        157,
                                                                                                                                                        158,
                                                                                                                                                        159,
                                                                                                                                                        160,
                                                                                                                                                        161,
                                                                                                                                                        162,
                                                                                                                                                        163,
                                                                                                                                                        164,
                                                                                                                                                        165,
                                                                                                                                                        166,
                                                                                                                                                        167,
                                                                                                                                                        168,
                                                                                                                                                        169,
                                                                                                                                                        170,
                                                                                                                                                        171,
                                                                                                                                                        172,
                                                                                                                                                        173,
                                                                                                                                                        174,
                                                                                                                                                        175,
                                                                                                                                                        176,
                                                                                                                                                        177,
                                                                                                                                                        178,
                                                                                                                                                        179,
                                                                                                                                                        180,
                                                                                                                                                        181,
                                                                                                                                                        182,
                                                                                                                                                        183,
                                                                                                                                                        184,
                                                                                                                                                        185,
                                                                                                                                                        186,
                                                                                                                                                        187,
                                                                                                                                                        188,
                                                                                                                                                        189,
                                                                                                                                                        190,
                                                                                                                                                        191,
                                                                                                                                                        192,
                                                                                                                                                        193,
                                                                                                                                                        194,
                                                                                                                                                        195,
                                                                                                                                                        196,
                                                                                                                                                        197,
                                                                                                                                                        198,
                                                                                                                                                        199,
                                                                                                                                                        200,
                                                                                                                                                        201,
                                                                                                                                                        202,
                                                                                                                                                        203,
                                                                                                                                                        204,
                                                                                                                                                        205,
                                                                                                                                                        206,
                                                                                                                                                        207,
                                                                                                                                                        208,
                                                                                                                                                        209,
                                                                                                                                                        210,
                                                                                                                                                        211,
                                                                                                                                                        212,
                                                                                                                                                        213,
                                                                                                                                                        214,
                                                                                                                                                        215,
                                                                                                                                                        216,
                                                                                                                                                        217,
                                                                                                                                                        218,
                                                                                                                                                        219,
                                                                                                                                                        220,
                                                                                                                                                        221,
                                                                                                                                                        222,
                                                                                                                                                        223,
                                                                                                                                                        224,
                                                                                                                                                        225,
                                                                                                                                                        226,
                                                                                                                                                        227,
                                                                                                                                                        228,
                                                                                                                                                        229,
                                                                                                                                                        230,
                                                                                                                                                        231,
                                                                                                                                                        232,
                                                                                                                                                        233,
                                                                                                                                                        234,
                                                                                                                                                        235,
                                                                                                                                                        236,
                                                                                                                                                        237,
                                                                                                                                                        238,
                                                                                                                                                        239,
                                                                                                                                                        240,
                                                                                                                                                        241,
                                                                                                                                                        242,
                                                                                                                                                        243,
                                                                                                                                                        244,
                                                                                                                                                        245,
                                                                                                                                                        246,
                                                                                                                                                        247,
                                                                                                                                                        248,
                                                                                                                                                        249,
                                                                                                                                                        250,
                                                                                                                                                        251,
                                                                                                                                                        252,
                                                                                                                                                        253,
                                                                                                                                                        254,
                                                                                                                                                        255,
                                                                                                                                                        256,
                                                                                                                                                        257,
                                                                                                                                                        258,
                                                                                                                                                        259,
                                                                                                                                                        260,
                                                                                                                                                        261,
                                                                                                                                                        262,
                                                                                                                                                        263,
                                                                                                                                                        264,
                                                                                                                                                        265,
                                                                                                                                                        266,
                                                                                                                                                        267,
                                                                                                                                                        268,
                                                                                                                                                        269,
                                                                                                                                                        270,
                                                                                                                                                        271,
                                                                                                                                                        272,
                                                                                                                                                        273,
                                                                                                                                                        274,
                                                                                                                                                        275,
                                                                                                                                                        276,
                                                                                                                                                        277,
                                                                                                                                                        278,
                                                                                                                                                        279,
                                                                                                                                                        280,
                                                                                                                                                        281,
                                                                                                                                                        282,
                                                                                                                                                        283,
                                                                                                                                                        284,
                                                                                                                                                        285,
                                                                                                                                                        286,
                                                                                                                                                        287,
                                                                                                                                                        288,
                                                                                                                                                        289,
                                                                                                                                                        290,
                                                                                                                                                        291,
                                                                                                                                                        292,
                                                                                                                                                        293,
                                                                                                                                                        294
                                                                                                                                                    ]
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        }, {
                                                                                                                                            "type": "material",
                                                                                                                                            "baseColor": {
                                                                                                                                                "r": 1,
                                                                                                                                                "g": 1,
                                                                                                                                                "b": 1
                                                                                                                                            },
                                                                                                                                            "specularColor": {
                                                                                                                                                "r": 0.33,
                                                                                                                                                "g": 0.33,
                                                                                                                                                "b": 0.33,
                                                                                                                                                "a": 1
                                                                                                                                            },
                                                                                                                                            "shine": 10,
                                                                                                                                            "specular": 1,
                                                                                                                                            "nodes": [{
                                                                                                                                                    "type": "geometry",
                                                                                                                                                    "positions": [-7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -15.416815,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973037, -15.417361,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.107649, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -7.366331,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.113808, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -15.417361,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.107649, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -7.366331,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.113808, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -7.366331,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.113808, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -7.366331,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.113808, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -7.366331,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.113808, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -7.366331,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.113808, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -7.366331,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.113808, -7.366331,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.113808, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -15.417361,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.107649, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -7.366331,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.113808, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -15.417361,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.107649, -15.416815,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973037, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -15.416815,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973037, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -15.416815,
                                                                                                                                                        19.913595,
                                                                                                                                                        7.973037, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -15.416815,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973037, -15.416815,
                                                                                                                                                        19.913595,
                                                                                                                                                        7.973037, -7.365785,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979196, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -15.416815,
                                                                                                                                                        19.913595,
                                                                                                                                                        7.973037, -15.416815,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973037, -7.365785,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979196, -7.365785,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.979196, -7.365785,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979196, -15.416815,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973037, -7.365785,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.979196, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -7.365785,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979196, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -7.365785,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.979196, -15.416815,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973037, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -7.365785,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979196, -7.36598,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -7.365785,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979196, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -7.365982,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -15.417361,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.107649, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -15.417361,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.107649, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -23.090154,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.113808, -23.090522,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -23.090154,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.113808, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -23.090154,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.113808, -23.090522,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -23.090154,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.113808, -23.090521,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -23.090154,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.113808, -23.090522,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -23.090154,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.113808, -23.090521,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -23.090521,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -15.417361,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.107649, -15.417361,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.107649, -15.417361,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.107649, -23.090154,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.113808, -23.090154,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.113808, -23.090154,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.113808, -15.417361,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.107649, -23.090521,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -23.090728,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979195, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -23.090728,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979195, -23.090521,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -23.090728,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.979195, -23.090522,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -23.090728,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.979195, -23.090521,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.388395, -23.090728,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.979195, -23.090522,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -15.417935,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973036, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -15.417935,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973036, -23.090522,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.385508, -15.417935,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973036, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -15.417935,
                                                                                                                                                        19.913595,
                                                                                                                                                        7.973036, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -15.417935,
                                                                                                                                                        19.913595,
                                                                                                                                                        7.973036, -15.417729,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.380161, -15.417935,
                                                                                                                                                        19.913595,
                                                                                                                                                        7.973036, -15.417728,
                                                                                                                                                        19.913595,
                                                                                                                                                        8.383049, -23.090728,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979195, -23.090728,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.979195, -23.090728,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.979195, -15.417935,
                                                                                                                                                        19.913595,
                                                                                                                                                        7.973036, -15.417935,
                                                                                                                                                        26.073595,
                                                                                                                                                        7.973036, -15.417935,
                                                                                                                                                        19.913595,
                                                                                                                                                        7.973036, -23.090728,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.979195,
                                                                                                                                                        null,
                                                                                                                                                        null,
                                                                                                                                                        null
                                                                                                                                                    ],
                                                                                                                                                    "normals": [
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0.816925,
                                                                                                                                                        0.576741,
                                                                                                                                                        0.001835,
                                                                                                                                                        0.816925,
                                                                                                                                                        0.576741,
                                                                                                                                                        0.001835,
                                                                                                                                                        0.816925,
                                                                                                                                                        0.576741,
                                                                                                                                                        0.001835,
                                                                                                                                                        0.816927,
                                                                                                                                                        0.576741, -0.000413,
                                                                                                                                                        0.816927,
                                                                                                                                                        0.576741, -0.000413,
                                                                                                                                                        0.816927,
                                                                                                                                                        0.576741, -0.000413,
                                                                                                                                                        0.816951,
                                                                                                                                                        0.576707,
                                                                                                                                                        0.000394,
                                                                                                                                                        0.816951,
                                                                                                                                                        0.576707,
                                                                                                                                                        0.000394,
                                                                                                                                                        0.816951,
                                                                                                                                                        0.576707,
                                                                                                                                                        0.000394,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482, -0.816927, -0.576741, -0.000394, -0.816927, -0.576741, -0.000394, -0.816927, -0.576741, -0.000394, -0.816951, -0.576706,
                                                                                                                                                        0.000413, -0.816951, -0.576706,
                                                                                                                                                        0.000413, -0.816951, -0.576706,
                                                                                                                                                        0.000413, -0.000765,
                                                                                                                                                        0,
                                                                                                                                                        1, -0.000765,
                                                                                                                                                        0,
                                                                                                                                                        1, -0.000765,
                                                                                                                                                        0,
                                                                                                                                                        1, -0.000765,
                                                                                                                                                        0,
                                                                                                                                                        1, -0.000765,
                                                                                                                                                        0,
                                                                                                                                                        1, -0.000765,
                                                                                                                                                        0,
                                                                                                                                                        1, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -0.999997, -0.000325, -0.002246, -0.999997, -0.000325, -0.002246, -0.999997, -0.000325, -0.002246, -1,
                                                                                                                                                        0.000048, -0.000368, -1,
                                                                                                                                                        0.000048, -0.000368, -1,
                                                                                                                                                        0.000048, -0.000368, -1,
                                                                                                                                                        0.000048, -0.000368, -1,
                                                                                                                                                        0.000048, -0.000368, -1,
                                                                                                                                                        0.000048, -0.000368, -0.81695, -0.576706, -0.001819, -0.81695, -0.576706, -0.001819, -0.81695, -0.576706, -0.001819,
                                                                                                                                                        0.000765,
                                                                                                                                                        0, -1,
                                                                                                                                                        0.000765,
                                                                                                                                                        0, -1,
                                                                                                                                                        0.000765,
                                                                                                                                                        0, -1,
                                                                                                                                                        0.000765,
                                                                                                                                                        0, -1,
                                                                                                                                                        0.000765,
                                                                                                                                                        0, -1,
                                                                                                                                                        0.000765,
                                                                                                                                                        0, -1,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        0.816951,
                                                                                                                                                        0.576707,
                                                                                                                                                        0.000394,
                                                                                                                                                        0.816951,
                                                                                                                                                        0.576707,
                                                                                                                                                        0.000394,
                                                                                                                                                        0.816951,
                                                                                                                                                        0.576707,
                                                                                                                                                        0.000394,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000482, -0.816927, -0.576741, -0.000394, -0.816927, -0.576741, -0.000394, -0.816927, -0.576741, -0.000394,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        0,
                                                                                                                                                        0.000469,
                                                                                                                                                        1,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        0.000803,
                                                                                                                                                        0,
                                                                                                                                                        1,
                                                                                                                                                        0.000803,
                                                                                                                                                        0,
                                                                                                                                                        1,
                                                                                                                                                        0.000803,
                                                                                                                                                        0,
                                                                                                                                                        1,
                                                                                                                                                        0.000803,
                                                                                                                                                        0,
                                                                                                                                                        1,
                                                                                                                                                        0.000803,
                                                                                                                                                        0,
                                                                                                                                                        1,
                                                                                                                                                        0.000803,
                                                                                                                                                        0,
                                                                                                                                                        1,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        0.829709, -0.558196, -0.00042, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -1,
                                                                                                                                                        0,
                                                                                                                                                        0.000506, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042, -0.829709,
                                                                                                                                                        0.558196,
                                                                                                                                                        0.00042,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        1,
                                                                                                                                                        0, -0.000506,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        0.829709, -0.558196, -0.00042,
                                                                                                                                                        0.829709, -0.558196, -0.00042, -0.000803,
                                                                                                                                                        0, -1, -0.000803,
                                                                                                                                                        0, -1, -0.000803,
                                                                                                                                                        0, -1, -0.000803,
                                                                                                                                                        0, -1, -0.000803,
                                                                                                                                                        0, -1, -0.000803,
                                                                                                                                                        0, -1,
                                                                                                                                                        null,
                                                                                                                                                        null,
                                                                                                                                                        null
                                                                                                                                                    ],
                                                                                                                                                    "uv": [
                                                                                                                                                        7.36598,
                                                                                                                                                        14.66473,
                                                                                                                                                        15.417729,
                                                                                                                                                        26.069663,
                                                                                                                                                        7.365982,
                                                                                                                                                        8.504729, -30.19226,
                                                                                                                                                        8.375665, -16.231489,
                                                                                                                                                        8.381011, -30.191733,
                                                                                                                                                        7.96854, -30.19205,
                                                                                                                                                        9.108657, -16.231491,
                                                                                                                                                        8.386516, -30.192262,
                                                                                                                                                        8.381169, -16.231795,
                                                                                                                                                        9.112846, -16.231593,
                                                                                                                                                        8.384546, -30.192152,
                                                                                                                                                        9.106687, -14.668663,
                                                                                                                                                        8.389056, -14.668663,
                                                                                                                                                        9.117356, -8.508663,
                                                                                                                                                        8.391944, -8.508663,
                                                                                                                                                        9.117356, -8.508663,
                                                                                                                                                        8.391944, -14.668663,
                                                                                                                                                        9.117356,
                                                                                                                                                        11.199221,
                                                                                                                                                        8.388832,
                                                                                                                                                        11.199422,
                                                                                                                                                        9.114244,
                                                                                                                                                        25.15999,
                                                                                                                                                        8.383485,
                                                                                                                                                        25.159943,
                                                                                                                                                        8.382589,
                                                                                                                                                        11.199375,
                                                                                                                                                        9.113348,
                                                                                                                                                        25.159732,
                                                                                                                                                        9.107189,
                                                                                                                                                        7.359357,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.359357,
                                                                                                                                                        14.668663,
                                                                                                                                                        15.41039,
                                                                                                                                                        19.913595,
                                                                                                                                                        15.41039,
                                                                                                                                                        26.073595,
                                                                                                                                                        15.41039,
                                                                                                                                                        19.913595,
                                                                                                                                                        7.359357,
                                                                                                                                                        14.668663,
                                                                                                                                                        26.073595,
                                                                                                                                                        8.372365,
                                                                                                                                                        19.913595,
                                                                                                                                                        9.099853,
                                                                                                                                                        26.073595,
                                                                                                                                                        9.099853,
                                                                                                                                                        26.078604,
                                                                                                                                                        8.007629,
                                                                                                                                                        19.918604,
                                                                                                                                                        9.142244,
                                                                                                                                                        26.078604,
                                                                                                                                                        8.414754,
                                                                                                                                                        19.912851,
                                                                                                                                                        9.113325,
                                                                                                                                                        26.072851,
                                                                                                                                                        7.978713,
                                                                                                                                                        19.912851,
                                                                                                                                                        8.388725,
                                                                                                                                                        19.912851,
                                                                                                                                                        7.978713,
                                                                                                                                                        19.912851,
                                                                                                                                                        8.388725,
                                                                                                                                                        26.072851,
                                                                                                                                                        7.978713,
                                                                                                                                                        25.159418,
                                                                                                                                                        7.975044,
                                                                                                                                                        11.199061,
                                                                                                                                                        7.981203,
                                                                                                                                                        25.159944,
                                                                                                                                                        8.385057, -15.410711,
                                                                                                                                                        19.913595, -15.410711,
                                                                                                                                                        26.073595, -7.359679,
                                                                                                                                                        8.508663, -7.359679,
                                                                                                                                                        14.668663, -7.359679,
                                                                                                                                                        8.508663, -15.410711,
                                                                                                                                                        26.073595, -14.668663,
                                                                                                                                                        7.982744, -14.668663,
                                                                                                                                                        8.389056, -8.508663,
                                                                                                                                                        7.982744, -16.231593,
                                                                                                                                                        8.384546, -16.23148,
                                                                                                                                                        7.978234, -30.191837,
                                                                                                                                                        7.972075, -8.508663,
                                                                                                                                                        8.391944, -8.508663,
                                                                                                                                                        7.982744, -14.668663,
                                                                                                                                                        8.389056,
                                                                                                                                                        11.199107,
                                                                                                                                                        7.979632,
                                                                                                                                                        11.199221,
                                                                                                                                                        8.388832,
                                                                                                                                                        25.15999,
                                                                                                                                                        8.383485,
                                                                                                                                                        15.417728,
                                                                                                                                                        19.909663,
                                                                                                                                                        7.365982,
                                                                                                                                                        8.504729,
                                                                                                                                                        15.417729,
                                                                                                                                                        26.069663, -26.073595,
                                                                                                                                                        8.372365, -26.073595,
                                                                                                                                                        9.099853, -19.913595,
                                                                                                                                                        8.375252,
                                                                                                                                                        13.027588,
                                                                                                                                                        9.096176,
                                                                                                                                                        13.027383,
                                                                                                                                                        8.368688, -0.71811,
                                                                                                                                                        9.102335, -0.718316,
                                                                                                                                                        8.374035, -0.71811,
                                                                                                                                                        9.102335,
                                                                                                                                                        13.027383,
                                                                                                                                                        8.368688,
                                                                                                                                                        14.668663,
                                                                                                                                                        9.102132,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.373832,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.102132,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.37672,
                                                                                                                                                        8.508663,
                                                                                                                                                        9.102132,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.373832,
                                                                                                                                                        5.829118,
                                                                                                                                                        9.103778,
                                                                                                                                                        5.829323,
                                                                                                                                                        8.378365, -7.91658,
                                                                                                                                                        9.097619, -7.916375,
                                                                                                                                                        8.373019, -7.91658,
                                                                                                                                                        9.097619,
                                                                                                                                                        5.829323,
                                                                                                                                                        8.378365, -19.913595,
                                                                                                                                                        9.099853, -19.913595,
                                                                                                                                                        8.375252, -26.073595,
                                                                                                                                                        9.099853,
                                                                                                                                                        15.424667,
                                                                                                                                                        19.913595,
                                                                                                                                                        15.424667,
                                                                                                                                                        26.073595,
                                                                                                                                                        23.097462,
                                                                                                                                                        8.508663,
                                                                                                                                                        23.097462,
                                                                                                                                                        14.668663,
                                                                                                                                                        23.097462,
                                                                                                                                                        8.508663,
                                                                                                                                                        15.424667,
                                                                                                                                                        26.073595,
                                                                                                                                                        5.829323,
                                                                                                                                                        8.378365,
                                                                                                                                                        5.829439,
                                                                                                                                                        7.969165, -7.916375,
                                                                                                                                                        8.373019,
                                                                                                                                                        8.508663,
                                                                                                                                                        7.967519,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.37672,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.967519,
                                                                                                                                                        14.668663,
                                                                                                                                                        8.373832,
                                                                                                                                                        14.668663,
                                                                                                                                                        7.967519,
                                                                                                                                                        8.508663,
                                                                                                                                                        8.37672, -0.718431,
                                                                                                                                                        7.967722, -0.718316,
                                                                                                                                                        8.374035,
                                                                                                                                                        13.027268,
                                                                                                                                                        7.961564,
                                                                                                                                                        13.027383,
                                                                                                                                                        8.368688,
                                                                                                                                                        13.027268,
                                                                                                                                                        7.961564, -0.718316,
                                                                                                                                                        8.374035, -26.073595,
                                                                                                                                                        7.96524, -26.073595,
                                                                                                                                                        8.372365, -19.913595,
                                                                                                                                                        7.96524, -19.913595,
                                                                                                                                                        8.375252, -19.913595,
                                                                                                                                                        7.96524, -26.073595,
                                                                                                                                                        8.372365, -7.91626,
                                                                                                                                                        7.963006, -7.916375,
                                                                                                                                                        8.373019,
                                                                                                                                                        5.829439,
                                                                                                                                                        7.969165, -23.097125,
                                                                                                                                                        8.508663, -23.097125,
                                                                                                                                                        14.668663, -15.42433,
                                                                                                                                                        19.913595, -15.42433,
                                                                                                                                                        26.073595, -15.42433,
                                                                                                                                                        19.913595, -23.097125,
                                                                                                                                                        14.668663,
                                                                                                                                                        null,
                                                                                                                                                        null
                                                                                                                                                    ],
                                                                                                                                                    "indices": [
                                                                                                                                                        0,
                                                                                                                                                        1,
                                                                                                                                                        2,
                                                                                                                                                        3,
                                                                                                                                                        4,
                                                                                                                                                        5,
                                                                                                                                                        6,
                                                                                                                                                        7,
                                                                                                                                                        8,
                                                                                                                                                        9,
                                                                                                                                                        10,
                                                                                                                                                        11,
                                                                                                                                                        12,
                                                                                                                                                        13,
                                                                                                                                                        14,
                                                                                                                                                        15,
                                                                                                                                                        16,
                                                                                                                                                        17,
                                                                                                                                                        18,
                                                                                                                                                        19,
                                                                                                                                                        20,
                                                                                                                                                        21,
                                                                                                                                                        22,
                                                                                                                                                        23,
                                                                                                                                                        24,
                                                                                                                                                        25,
                                                                                                                                                        26,
                                                                                                                                                        27,
                                                                                                                                                        28,
                                                                                                                                                        29,
                                                                                                                                                        30,
                                                                                                                                                        31,
                                                                                                                                                        32,
                                                                                                                                                        33,
                                                                                                                                                        34,
                                                                                                                                                        35,
                                                                                                                                                        36,
                                                                                                                                                        37,
                                                                                                                                                        38,
                                                                                                                                                        39,
                                                                                                                                                        40,
                                                                                                                                                        41,
                                                                                                                                                        42,
                                                                                                                                                        43,
                                                                                                                                                        44,
                                                                                                                                                        45,
                                                                                                                                                        46,
                                                                                                                                                        47,
                                                                                                                                                        48,
                                                                                                                                                        49,
                                                                                                                                                        50,
                                                                                                                                                        51,
                                                                                                                                                        52,
                                                                                                                                                        53,
                                                                                                                                                        54,
                                                                                                                                                        55,
                                                                                                                                                        56,
                                                                                                                                                        57,
                                                                                                                                                        58,
                                                                                                                                                        59,
                                                                                                                                                        60,
                                                                                                                                                        61,
                                                                                                                                                        62,
                                                                                                                                                        63,
                                                                                                                                                        64,
                                                                                                                                                        65,
                                                                                                                                                        66,
                                                                                                                                                        67,
                                                                                                                                                        68,
                                                                                                                                                        69,
                                                                                                                                                        70,
                                                                                                                                                        71,
                                                                                                                                                        72,
                                                                                                                                                        73,
                                                                                                                                                        74,
                                                                                                                                                        75,
                                                                                                                                                        76,
                                                                                                                                                        77,
                                                                                                                                                        78,
                                                                                                                                                        79,
                                                                                                                                                        80,
                                                                                                                                                        81,
                                                                                                                                                        82,
                                                                                                                                                        83,
                                                                                                                                                        84,
                                                                                                                                                        85,
                                                                                                                                                        86,
                                                                                                                                                        87,
                                                                                                                                                        88,
                                                                                                                                                        89,
                                                                                                                                                        90,
                                                                                                                                                        91,
                                                                                                                                                        92,
                                                                                                                                                        93,
                                                                                                                                                        94,
                                                                                                                                                        95,
                                                                                                                                                        96,
                                                                                                                                                        97,
                                                                                                                                                        98,
                                                                                                                                                        99,
                                                                                                                                                        100,
                                                                                                                                                        101,
                                                                                                                                                        102,
                                                                                                                                                        103,
                                                                                                                                                        104,
                                                                                                                                                        105,
                                                                                                                                                        106,
                                                                                                                                                        107,
                                                                                                                                                        108,
                                                                                                                                                        109,
                                                                                                                                                        110,
                                                                                                                                                        111,
                                                                                                                                                        112,
                                                                                                                                                        113,
                                                                                                                                                        114,
                                                                                                                                                        115,
                                                                                                                                                        116,
                                                                                                                                                        117,
                                                                                                                                                        118,
                                                                                                                                                        119,
                                                                                                                                                        120,
                                                                                                                                                        121,
                                                                                                                                                        122,
                                                                                                                                                        123,
                                                                                                                                                        124,
                                                                                                                                                        125,
                                                                                                                                                        126
                                                                                                                                                    ]
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        }
                                                                                                                    ]
                                                                                                                }
                                                                                                            ]
                                                                                                        }
                                                                                                    ]
                                                                                                }, {
                                                                                                    "type": "node",
                                                                                                    "nodes": [{
                                                                                                            "type": "translate",
                                                                                                            "x": -57,
                                                                                                            "y": 63,
                                                                                                            "z": 0,
                                                                                                            "nodes": [{
                                                                                                                    "type": "rotate",
                                                                                                                    "id": id + ".gunDir",
                                                                                                                    "x": 0,
                                                                                                                    "y": 0,
                                                                                                                    "z": 1,
                                                                                                                    "angle": 0,
                                                                                                                    "nodes": [{
                                                                                                                            "type": "translate",
                                                                                                                            "x": 39,
                                                                                                                            "y": -76.5,
                                                                                                                            "z": 52,
                                                                                                                            "nodes": [{
                                                                                                                                    "type": "node",
                                                                                                                                    "nodes": [{
                                                                                                                                            "type": "node",
                                                                                                                                            "nodes": [{
                                                                                                                                                    "type": "node",
                                                                                                                                                    "nodes": [{
                                                                                                                                                            "type": "material",
                                                                                                                                                            "baseColor": {
                                                                                                                                                                "r": 0.172549,
                                                                                                                                                                "g": 0.184314,
                                                                                                                                                                "b": 0.2
                                                                                                                                                            },
                                                                                                                                                            "specularColor": {
                                                                                                                                                                "r": 0.33,
                                                                                                                                                                "g": 0.33,
                                                                                                                                                                "b": 0.33,
                                                                                                                                                                "a": 1
                                                                                                                                                            },
                                                                                                                                                            "shine": 10,
                                                                                                                                                            "specular": 1,
                                                                                                                                                            "nodes": [{
                                                                                                                                                                    "type": "geometry",
                                                                                                                                                                    "positions": [-89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -94.560137,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -94.560137,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -94.560137,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -94.560137,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -94.560137,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -96.876744,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -96.876744,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -96.876744,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -94.560137,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -96.876744,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -96.923915,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.993085, -96.876744,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -96.876744,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -96.923915,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.993085, -94.560137,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -96.876744,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -94.560137,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        17.107689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689, -92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        16.357689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -82.013362,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -82.013362,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -79.886618,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -82.203225,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -79.886618,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -79.513362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -79.513362,
                                                                                                                                                                        88.876998,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        18.857689, -79.513362,
                                                                                                                                                                        88.876998,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -81.299099,
                                                                                                                                                                        88.626203,
                                                                                                                                                                        18.537632, -66.838759,
                                                                                                                                                                        80.465397,
                                                                                                                                                                        18.537632, -79.26625,
                                                                                                                                                                        88.652615,
                                                                                                                                                                        16.504782, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        18.857689, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        22.107689, -94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        18.857689, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        22.107689, -82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        18.857689, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        22.107689, -94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        18.857689, -84.050312,
                                                                                                                                                                        89.994086,
                                                                                                                                                                        22.107689, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        22.107689, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        22.107689, -84.050312,
                                                                                                                                                                        89.994086,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        22.107689, -84.050312,
                                                                                                                                                                        34.740805,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        22.107689, -84.050312,
                                                                                                                                                                        89.994086,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        45.002883,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        22.107689, -84.050312,
                                                                                                                                                                        34.740805,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        45.002883,
                                                                                                                                                                        22.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        19.857689, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        19.857689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        19.857689, -66.612606,
                                                                                                                                                                        45.002883,
                                                                                                                                                                        22.107689, -39.566018,
                                                                                                                                                                        60.919782,
                                                                                                                                                                        19.245435, -81.80311,
                                                                                                                                                                        36.063282,
                                                                                                                                                                        19.514448, -39.566018,
                                                                                                                                                                        60.919782,
                                                                                                                                                                        17.941327, -66.632456,
                                                                                                                                                                        44.991201,
                                                                                                                                                                        21.45093, -81.80311,
                                                                                                                                                                        36.063282,
                                                                                                                                                                        19.514448, -39.566018,
                                                                                                                                                                        60.919782,
                                                                                                                                                                        19.245435, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        20.247152, -81.80311,
                                                                                                                                                                        36.063282,
                                                                                                                                                                        19.514448, -66.632456,
                                                                                                                                                                        44.991201,
                                                                                                                                                                        21.45093, -81.80311,
                                                                                                                                                                        36.063282,
                                                                                                                                                                        19.514448, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        20.247152, -94.960252,
                                                                                                                                                                        28.320312,
                                                                                                                                                                        19.514448, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        20.247152, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        17.208074, -94.960252,
                                                                                                                                                                        28.320312,
                                                                                                                                                                        19.514448, -84.050312,
                                                                                                                                                                        34.740805,
                                                                                                                                                                        22.107689, -84.050312,
                                                                                                                                                                        89.994086,
                                                                                                                                                                        22.107689, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689, -84.050312,
                                                                                                                                                                        89.994086,
                                                                                                                                                                        22.107689, -98.799325,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        20.195923, -98.799325,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        17.311016, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689, -94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        18.857689, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249, -97.25,
                                                                                                                                                                        97.443433,
                                                                                                                                                                        16.357689, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249, -94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        18.857689, -97.25,
                                                                                                                                                                        97.443433,
                                                                                                                                                                        16.357689, -97.25,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        16.357689, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249, -97.25,
                                                                                                                                                                        97.443433,
                                                                                                                                                                        16.357689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -97.25,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        16.357689, -98.828898,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.357689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -97.25,
                                                                                                                                                                        97.443433,
                                                                                                                                                                        16.357689, -98.828898,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.357689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -98.828898,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.357689, -98.099624,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.734692, -98.099624,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.734692, -98.586,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.77945, -98.099624,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.734692, -98.099624,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.734692, -97.618237,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.817342, -97.618237,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.817342, -97.618237,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.817342, -98.099624,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.734692, -97.618237,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.817342, -97.618237,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.817342, -97.174644,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.021768, -97.174644,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.021768, -97.174644,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.021768, -97.618237,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.817342, -97.174644,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.021768, -97.174644,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.021768, -96.799076,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.334038, -96.799076,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.334038, -96.799076,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.334038, -97.174644,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.021768, -96.799076,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.334038, -96.517126,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.732873, -96.799076,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.334038, -98.828898,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.357689, -98.828898,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.357689, -98.483905,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.230361, -98.483905,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.230361, -98.483905,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.230361, -98.828898,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.357689, -98.483905,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.230361, -98.483905,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.230361, -98.117712,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.196663, -98.117712,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.196663, -98.117712,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.196663, -98.483905,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.230361, -98.117712,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.196663, -98.117712,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.196663, -97.755276,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.25889, -97.755276,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.25889, -97.755276,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.25889, -98.117712,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.196663, -97.755276,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.25889, -97.755276,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.25889, -97.421294,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.412802, -97.421294,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.412802, -97.421294,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.412802, -97.755276,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.25889, -97.421294,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.412802, -97.421294,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.412802, -97.138529,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.647911, -97.138529,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.647911, -97.138529,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.647911, -97.421294,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.412802, -97.138529,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.647911, -96.926249,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.948194, -97.138529,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.647911, -96.926249,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.948194, -97.138529,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.647911, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -97.138529,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.647911, -97.421294,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.412802, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -97.421294,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.412802, -98.828898,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.357689, -97.421294,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.412802, -97.755276,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.25889, -98.828898,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.357689, -98.828898,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.357689, -97.755276,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.25889, -98.483905,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.230361, -98.117712,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.196663, -98.483905,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.230361, -97.755276,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.25889, -98.828898,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.357689, -97.25,
                                                                                                                                                                        97.443433,
                                                                                                                                                                        16.357689, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -97.25,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -97.25,
                                                                                                                                                                        97.443433,
                                                                                                                                                                        16.357689, -97.516753,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.850843, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -97.25,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -97.516753,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.850843, -97.21647,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.638563, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -96.923915,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.993085, -96.923915,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.993085, -96.902598,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.978016, -96.923915,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.993085, -96.876744,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -96.923915,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.993085, -82.203225,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        18.39932, -94.560137,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -93.877859,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        18.857689, -93.877859,
                                                                                                                                                                        96.541783,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -97.25,
                                                                                                                                                                        97.443433,
                                                                                                                                                                        16.357689, -97.25,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -97.25,
                                                                                                                                                                        97.443433,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        18.857689, -93.877859,
                                                                                                                                                                        96.541783,
                                                                                                                                                                        18.857689, -96.902598,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.978016, -96.902598,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.978016, -96.923915,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.993085, -96.902598,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.978016, -96.902598,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.978016, -96.590327,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.602447, -96.590327,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.602447, -96.590327,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.602447, -96.902598,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.978016, -96.590327,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.602447, -96.385901,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.158854, -96.590327,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.602447, -96.590327,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.602447, -94.769826,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.334263, -96.385901,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.158854, -95.070637,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -94.769826,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.334263, -96.590327,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.602447, -94.769826,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.334263, -95.070637,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -94.769826,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.334263, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -94.769826,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.334263, -95.070637,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -94.769826,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.334263, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -94.558366,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.868074, -94.558366,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.868074, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -94.444881,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.368906, -94.444881,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.368906, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -94.433999,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.857117, -94.433999,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.857117, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -94.526164,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.353576, -94.526164,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.353576, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -94.717618,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.878821, -94.717618,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.878821, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -95.000552,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.452212, -95.000552,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.452212, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -95.363428,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.091147, -95.363428,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.091147, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -95.791447,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.81035, -95.791447,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.81035, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -96.267154,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.621274, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -97.282878,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -96.267154,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.621274, -94.877842,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        16.114781, -94.942794,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        15.991368, -94.877842,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        16.114781, -97.41072,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        11.302162, -94.942794,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        15.991368, -94.877842,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        16.114781, -97.41072,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        11.302162, -97.779953,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        10.600598, -97.41072,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        11.302162, -97.779953,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        10.600598, -97.41072,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        11.302162, -94.877842,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        16.114781, -94.75,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -94.75,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        16.357689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        17.107689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        17.107689, -91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        17.107689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        16.357689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        16.357689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        16.357689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        17.107689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        16.357689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        17.107689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        16.357689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        16.357689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        17.107689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        17.107689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        16.357689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        16.357689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        17.107689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        16.357689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        16.357689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -81.804968,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -81.851105,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        16.049391, -81.854982,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        16.056759, -81.851105,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.049391, -81.854982,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        16.056759, -81.851105,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        16.049391, -79.013946,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        10.65862, -81.851105,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        16.049391, -79.322104,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        11.244139, -79.013946,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        10.65862, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -80.52494,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.574274, -79.480484,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -81.019272,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.752184, -80.52494,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.574274, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -81.019272,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.752184, -81.019272,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.752184, -80.52494,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.574274, -81.019272,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.752184, -81.019272,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.752184, -81.465191,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.029981, -81.465191,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.029981, -81.465191,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.029981, -81.019272,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.752184, -81.465191,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.029981, -81.465191,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.029981, -81.842793,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.395265, -81.842793,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.395265, -81.842793,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.395265, -81.465191,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.029981, -81.842793,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.395265, -82.135222,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.831729, -81.842793,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.395265, -82.135222,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.831729, -81.842793,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.395265, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -81.842793,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.395265, -81.465191,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.029981, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -81.465191,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.029981, -81.019272,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.752184, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -82.329423,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.31989, -82.135222,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.831729, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -82.135222,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.831729, -82.329423,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.31989, -82.135222,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.831729, -82.329423,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.31989, -82.135222,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.831729, -82.329423,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.31989, -82.329423,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.31989, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -82.135222,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.831729, -82.416728,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.837957, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -82.329423,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.31989, -82.393239,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.362804, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -82.416728,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.837957, -82.260005,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.871001, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -82.393239,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.362804, -82.022973,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.339863, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -82.260005,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.871001, -81.692725,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -82.022973,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.339863, -82.013362,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -81.692725,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -81.692725,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -82.022973,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.339863, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -82.022973,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.339863, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -82.022973,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.339863, -82.022973,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.339863, -82.260005,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.871001, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -82.022973,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.339863, -82.022973,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.339863, -82.260005,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.871001, -82.260005,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.871001, -82.260005,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.871001, -82.022973,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.339863, -82.260005,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.871001, -82.393239,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.362804, -82.260005,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.871001, -82.393239,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.362804, -82.260005,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.871001, -82.393239,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.362804, -82.260005,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.871001, -82.393239,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.362804, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -82.393239,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.362804, -82.416728,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.837957, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -82.416728,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.837957, -82.393239,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.362804, -82.416728,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.837957, -82.393239,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.362804, -82.416728,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.837957, -82.393239,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.362804, -82.416728,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.837957, -82.329423,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.31989, -82.416728,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.837957, -82.329423,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.31989, -82.416728,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.837957, -82.329423,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.31989, -82.416728,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.837957, -82.329423,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.31989, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -82.135222,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.831729, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -81.842793,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.395265, -81.842793,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.395265, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -81.465191,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.029981, -81.465191,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.029981, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -81.019272,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.752184, -81.019272,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.752184, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -80.52494,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.574274, -80.52494,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.574274, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -79.480484,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -79.480484,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -78.855567,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -78.855567,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -79.886618,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -79.886618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.082713, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -79.513362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -76.355567,
                                                                                                                                                                        90.558974,
                                                                                                                                                                        10.357689, -79.513362,
                                                                                                                                                                        88.876998,
                                                                                                                                                                        16.357689, -76.355567,
                                                                                                                                                                        90.558974,
                                                                                                                                                                        10.357689, -79.513362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -79.26625,
                                                                                                                                                                        88.652615,
                                                                                                                                                                        16.504782, -73.256302,
                                                                                                                                                                        88.687459,
                                                                                                                                                                        10.569728, -76.033713,
                                                                                                                                                                        90.374401,
                                                                                                                                                                        10.362769, -72.784134,
                                                                                                                                                                        86.945353,
                                                                                                                                                                        13.125602, -73.256302,
                                                                                                                                                                        88.687459,
                                                                                                                                                                        10.569728, -79.26625,
                                                                                                                                                                        88.652615,
                                                                                                                                                                        16.504782, -69.868303,
                                                                                                                                                                        84.783772,
                                                                                                                                                                        14.019355, -72.784134,
                                                                                                                                                                        86.945353,
                                                                                                                                                                        13.125602, -79.26625,
                                                                                                                                                                        88.652615,
                                                                                                                                                                        16.504782, -66.583144,
                                                                                                                                                                        82.406986,
                                                                                                                                                                        14.924838, -69.868303,
                                                                                                                                                                        84.783772,
                                                                                                                                                                        14.019355, -79.26625,
                                                                                                                                                                        88.652615,
                                                                                                                                                                        16.504782, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        18.857689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -66.247696,
                                                                                                                                                                        82.367812,
                                                                                                                                                                        14.664789, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        18.857689, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        22.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        19.857689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        19.857689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -32.198546,
                                                                                                                                                                        51.261593,
                                                                                                                                                                        15.098225, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -32.226303,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -32.226303,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        16.226418, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        16.226418, -33.863822,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        16.559911, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -34.69372,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -35.955,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -34.69372,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -35.955,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -35.955,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -34.69372,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -35.955,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -35.955,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -35.955,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -37.423792,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        13.941489, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -45.801454,
                                                                                                                                                                        51.261593,
                                                                                                                                                                        15.098225, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -45.801454,
                                                                                                                                                                        51.261593,
                                                                                                                                                                        15.098225, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -45.801454,
                                                                                                                                                                        51.261593,
                                                                                                                                                                        15.098225, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        14.621443, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        14.621443, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        25.107689, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        25.107689, -43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        25.107689, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        25.107689, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        13.941489, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        13.941489, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        13.941489, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        25.107689, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        13.941489, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        25.107689, -40.576208,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        26.357689, -40.576208,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        25.107689, -40.576208,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        58.8597,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        58.8597,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        26.357689, -38.211896,
                                                                                                                                                                        58.755944,
                                                                                                                                                                        26.357689, -38.211896,
                                                                                                                                                                        58.755944,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        26.357689, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        25.107689, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        26.357689, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        25.107689, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        13.941489, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        13.941489, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        13.941489, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        25.107689, -37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -35.955,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -35.955,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -35.955,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        17.074959, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        25.107689, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        17.074959, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        25.107689, -37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        58.8597,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        25.107689, -38.211896,
                                                                                                                                                                        58.755944,
                                                                                                                                                                        26.357689, -37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        58.8597,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        25.107689, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        58.8597,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        17.074959, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        17.074959, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        16.559911, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        16.559911, -44.136178,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -39.566018,
                                                                                                                                                                        60.919782,
                                                                                                                                                                        17.941327, -81.80311,
                                                                                                                                                                        36.063282,
                                                                                                                                                                        19.514448, -43.972613,
                                                                                                                                                                        58.326503,
                                                                                                                                                                        17.336396, -81.80311,
                                                                                                                                                                        36.063282,
                                                                                                                                                                        19.514448, -79.076577,
                                                                                                                                                                        37.667844,
                                                                                                                                                                        16.787915, -43.972613,
                                                                                                                                                                        58.326503,
                                                                                                                                                                        17.336396, -97.41973,
                                                                                                                                                                        26.872911,
                                                                                                                                                                        17.054971, -94.960252,
                                                                                                                                                                        28.320312,
                                                                                                                                                                        19.514448, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        17.208074, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923, -98.799325,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        17.311016, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        16.649249, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249, -97.25,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        28.444045,
                                                                                                                                                                        18.857689, -97.25,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -97.25,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -97.25,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -97.25,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -97.25,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -97.25,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -104.006681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -104.006681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -97.25,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -97.25,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -97.25,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -97.25,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        16.357689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -97.25,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -100.407795,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.695398, -100.407795,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059, -78.855567,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -78.855567,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -97.907795,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -98.610491,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.788489, -97.907795,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -97.282878,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -97.907795,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -98.610491,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.788489, -97.282878,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -96.771149,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.531628, -97.282878,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -96.771149,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.531628, -97.282878,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -96.267154,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.621274, -96.267154,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.621274, -97.282878,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -98.610491,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.788489, -98.586,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.77945, -96.267154,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.621274, -98.610491,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.788489, -95.791447,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.81035, -96.267154,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.621274, -98.586,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.77945, -96.267154,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.621274, -95.791447,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.81035, -96.267154,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.621274, -95.791447,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.81035, -96.267154,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.621274, -95.791447,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.81035, -95.791447,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.81035, -95.363428,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.091147, -95.791447,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.81035, -95.363428,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.091147, -95.791447,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.81035, -98.586,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.77945, -98.099624,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.734692, -95.363428,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.091147, -98.586,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.77945, -95.000552,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.452212, -95.363428,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.091147, -98.099624,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.734692, -95.363428,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.091147, -95.000552,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.452212, -95.363428,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.091147, -95.000552,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.452212, -95.363428,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.091147, -95.000552,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.452212, -95.000552,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.452212, -94.717618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.878821, -95.000552,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.452212, -95.000552,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.452212, -98.099624,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.734692, -94.717618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.878821, -97.618237,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.817342, -94.717618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.878821, -98.099624,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.734692, -97.174644,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.021768, -94.717618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.878821, -97.618237,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.817342, -94.526164,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.353576, -94.717618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.878821, -97.174644,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.021768, -94.717618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.878821, -94.526164,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.353576, -94.717618,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.878821, -94.526164,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.353576, -94.717618,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.878821, -94.526164,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.353576, -94.526164,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.353576, -94.433999,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.857117, -94.526164,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.353576, -94.433999,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.857117, -94.526164,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.353576, -96.517126,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.732873, -96.517126,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.732873, -94.526164,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.353576, -96.799076,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.334038, -96.799076,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.334038, -94.526164,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.353576, -97.174644,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.021768, -96.517126,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.732873, -96.799076,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.334038, -96.517126,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.732873, -96.517126,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.732873, -96.348009,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.191091, -96.517126,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.732873, -96.926249,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.948194, -97.138529,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.647911, -96.926249,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.948194, -96.926249,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.948194, -96.798921,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.293187, -96.926249,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.948194, -96.798921,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.293187, -96.926249,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        13.948194, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -96.765222,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.659379, -96.798921,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.293187, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -96.798921,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.293187, -96.765222,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.659379, -96.798921,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.293187, -96.765222,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.659379, -96.798921,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.293187, -96.765222,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.659379, -96.303251,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.677467, -96.385901,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.158854, -96.303251,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.677467, -96.385901,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.158854, -96.303251,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.677467, -96.385901,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.158854, -96.385901,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.158854, -94.558366,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.868074, -96.303251,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.677467, -94.769826,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.334263, -94.558366,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.868074, -96.385901,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.158854, -94.558366,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.868074, -94.769826,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.334263, -94.558366,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.868074, -94.769826,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.334263, -94.558366,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.868074, -94.769826,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.334263, -94.558366,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.868074, -94.444881,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.368906, -94.558366,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.868074, -94.444881,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.368906, -94.558366,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.868074, -94.444881,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.368906, -94.558366,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.868074, -94.444881,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.368906, -96.303251,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.677467, -96.303251,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.677467, -94.444881,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.368906, -96.348009,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.191091, -94.444881,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.368906, -94.433999,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.857117, -96.348009,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.191091, -94.433999,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.857117, -94.444881,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.368906, -94.433999,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.857117, -94.444881,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        14.368906, -94.433999,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.857117, -94.444881,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.368906, -94.433999,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.857117, -94.526164,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        13.353576, -94.433999,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.857117, -96.348009,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.191091, -94.433999,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.857117, -96.517126,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.732873, -96.348009,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.191091, -96.517126,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        13.732873, -96.348009,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.191091, -96.348009,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.191091, -96.303251,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.677467, -96.348009,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.191091, -96.798921,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.293187, -96.926249,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.948194, -96.798921,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.293187, -96.303251,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.677467, -96.348009,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        14.191091, -96.303251,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.677467, -96.385901,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.158854, -96.590327,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.602447, -96.385901,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.158854, -96.981362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.355797, -96.827449,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.021816, -96.981362,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.355797, -96.827449,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.021816, -96.981362,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.355797, -96.827449,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.021816, -96.981362,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.355797, -96.827449,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.021816, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -96.827449,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.021816, -96.765222,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.659379, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -96.765222,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        14.659379, -96.827449,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.021816, -96.765222,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.659379, -96.827449,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.021816, -96.765222,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.659379, -96.827449,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.021816, -97.21647,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.638563, -96.981362,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.355797, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -97.21647,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.638563, -97.21647,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.638563, -96.981362,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.355797, -97.21647,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.638563, -97.516753,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.850843, -97.21647,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.638563, -96.981362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.355797, -96.981362,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        15.355797, -97.21647,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.638563, -94.717618,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.878821, -95.000552,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.452212, -94.717618,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.878821, -95.363428,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.091147, -95.791447,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.81035, -95.363428,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.091147, -98.586,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.77945, -98.586,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.77945, -98.099624,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.734692, -98.586,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.77945, -98.586,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.77945, -98.610491,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.788489, -98.610491,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.788489, -98.610491,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.788489, -98.586,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.77945, -98.610491,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.788489, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -98.610491,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.788489, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -98.610491,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.788489, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -96.267154,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.621274, -96.771149,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.531628, -96.267154,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.621274, -96.771149,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.531628, -96.267154,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.621274, -97.282878,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -96.771149,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.531628, -97.282878,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -96.771149,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.531628, -96.771149,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.531628, -96.267154,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.621274, -96.771149,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.531628, -97.779953,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        10.600598, -97.41072,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        11.302162, -97.779953,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        10.600598, -97.907795,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -79.013946,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        10.65862, -79.322104,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        11.244139, -79.013946,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        10.65862, -79.322104,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        11.244139, -79.013946,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        10.65862, -79.322104,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        11.244139, -79.480484,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -79.480484,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -80.004263,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.504193, -80.004263,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.504193, -80.004263,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.504193, -79.480484,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -80.004263,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.504193, -80.004263,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.504193, -80.52494,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.574274, -80.52494,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.574274, -80.52494,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.574274, -80.004263,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.504193, -80.52494,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.574274, -80.52494,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.574274, -81.019272,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.752184, -80.004263,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.504193, -79.480484,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -80.52494,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.574274, -79.480484,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -80.004263,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.504193, -80.52494,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.574274, -81.854982,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.056759, -81.851105,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.049391, -81.854982,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        16.056759, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -78.855567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -95.102845,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        16.844122, -97.038545,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        13.312205, -95.102845,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        16.844122, -97.038545,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        13.312205, -95.102845,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        16.844122, -97.038545,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        13.312205, -96.380845,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        12.951746, -96.380845,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        12.951746, -96.380845,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        13.312205, -97.101763,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.636346, -96.380845,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        12.951746, -97.759463,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.996804, -97.038545,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        13.312205, -97.759463,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.996804, -96.380845,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        13.312205, -97.759463,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.996804, -97.038545,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        13.312205, -95.102845,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        16.844122, -97.038545,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        13.312205, -95.102845,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        16.844122, -97.038545,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        13.312205, -96.380845,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        12.951746, -96.380845,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        12.951746, -96.380845,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        13.312205, -97.101763,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.636346, -96.380845,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        12.951746, -97.759463,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.996804, -97.038545,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        13.312205, -97.759463,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.996804, -96.380845,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        13.312205, -97.759463,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.996804, -97.038545,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        13.312205, -95.102845,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        16.844122, -97.038545,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        13.312205, -95.102845,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        16.844122, -97.038545,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        13.312205, -96.380845,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        12.951746, -96.380845,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        12.951746, -96.380845,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        13.312205, -97.101763,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.636346, -96.380845,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        12.951746, -97.759463,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.996804, -97.038545,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        13.312205, -97.759463,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.996804, -96.380845,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        13.312205, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -97.759463,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.996804, -95.102845,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        16.844122, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -97.038545,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        13.312205, -94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -94.75,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -94.75,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -94.75,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -93.603703,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -93.603703,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        17.107689, -92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -92.595242,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.595242,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -94.701709,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -94.701709,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -94.701709,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        17.107689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        16.357689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        16.357689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        16.357689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        16.357689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        17.107689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        17.107689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        16.357689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        16.357689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        17.107689, -90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -88.273781,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -88.273781,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -88.273781,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -88.273781,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        17.107689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        17.107689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -83.077628,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -83.077628,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -81.703818,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        16.92313, -78.206716,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        10.542249, -79.043525,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.069107, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -79.043525,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.069107, -78.206716,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        10.542249, -79.043525,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.069107, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -79.043525,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.069107, -79.920459,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        11.588495, -79.920459,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        11.588495, -79.920459,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        11.588495, -79.043525,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.069107, -79.920459,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        11.588495, -79.043525,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.903895, -79.764443,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        13.384507, -80.641376,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.903895, -79.043525,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        13.384507, -79.764443,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        13.384507, -80.641376,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.903895, -79.764443,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        13.384507, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -79.764443,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        13.384507, -79.764443,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        13.384507, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -79.764443,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        13.384507, -79.764443,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        13.384507, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -79.764443,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.069107, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -79.764443,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        13.384507, -79.764443,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        13.384507, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -79.043525,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        13.384507, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -79.764443,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.069107, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -79.764443,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        13.384507, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -79.043525,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.069107, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -79.043525,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.069107, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -79.043525,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.069107, -79.920459,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        11.588495, -79.920459,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        11.588495, -79.920459,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        11.588495, -79.043525,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.069107, -79.920459,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        11.588495, -79.043525,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.903895, -79.764443,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        13.384507, -80.641376,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.903895, -79.043525,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        13.384507, -79.764443,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        13.384507, -80.641376,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.903895, -80.641376,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.903895, -80.641376,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.903895, -79.764443,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        13.384507, -79.920459,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.903895, -79.043525,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.903895, -79.764443,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.069107, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -79.043525,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.069107, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -79.043525,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.069107, -79.920459,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        11.588495, -79.920459,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        11.588495, -79.920459,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        11.588495, -79.043525,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.069107, -79.920459,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        11.588495, -79.043525,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.903895, -79.764443,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        13.384507, -80.641376,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.903895, -79.043525,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        13.384507, -79.764443,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        13.384507, -80.641376,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.903895, -80.641376,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.903895, -80.641376,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.903895, -79.764443,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        13.384507, -79.920459,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.903895, -79.043525,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.903895, -79.764443,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        13.384507, -79.764443,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.069107, -79.043525,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.069107, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -81.804968,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689, -78.855567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -82.013362,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -78.855567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -82.013362,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -83.077628,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        207.652108,
                                                                                                                                                                        17.107689, -83.077628,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -83.571263,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        207.082108,
                                                                                                                                                                        16.857689, -84.097373,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        206.474608,
                                                                                                                                                                        16.357689, -84.097373,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        207.082108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        206.474608,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        202.829608,
                                                                                                                                                                        16.357689, -84.097373,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -87.254036,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        202.829608,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        206.474608,
                                                                                                                                                                        16.357689, -87.254036,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        16.357689, -87.780146,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        202.829608,
                                                                                                                                                                        16.357689, -87.254036,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        16.357689, -87.254036,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -87.780146,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -87.254036,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -87.254036,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        206.474608,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        206.474608,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        207.082108,
                                                                                                                                                                        16.857689, -87.254036,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -87.780146,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -87.254036,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        207.082108,
                                                                                                                                                                        16.857689, -87.780146,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -87.780146,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -87.254036,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -88.273781,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        207.652108,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -83.077628,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -83.077628,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -83.571263,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -83.571263,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -84.097373,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        16.357689, -84.097373,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -84.097373,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        16.357689, -83.571263,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -84.097373,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        16.357689, -84.097373,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        202.829608,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        202.829608,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        202.222108,
                                                                                                                                                                        16.857689, -84.097373,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        202.222108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        202.829608,
                                                                                                                                                                        16.357689, -87.780146,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -83.571263,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -84.097373,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        16.357689, -85.675705,
                                                                                                                                                                        202.222108,
                                                                                                                                                                        16.857689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        16.357689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        16.357689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        16.357689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        16.357689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        16.357689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -83.159659,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -78.855567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -83.159659,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -80.570267,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -83.159659,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -78.855567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -95.217529,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -93.248106,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -94.807379,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -92.95612,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -94.807379,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -93.248106,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -92.95612,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -93.835758,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -94.807379,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -92.601962,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -93.835758,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -92.95612,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -93.835758,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -92.601962,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -93.835758,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        12.185546, -92.601962,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        14.529833, -93.835758,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        12.185546, -92.601962,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -92.601962,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        14.529833, -92.601962,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -84.1614,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        14.529833, -84.1614,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -84.1614,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        14.529833, -92.601962,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -84.1614,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -84.1614,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        14.529833, -84.1614,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -83.807242,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -92.601962,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -83.807242,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -84.1614,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -83.807242,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -92.601962,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        14.529833, -92.95612,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -92.95612,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -93.248106,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -83.807242,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -83.515256,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -83.807242,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -93.248106,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -83.515256,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -81.545833,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -83.807242,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -93.603703,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -83.159659,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -81.955983,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -83.807242,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -81.545833,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -83.807242,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        15.11644, -81.955983,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -94.807379,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -81.955983,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -94.807379,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -93.835758,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -93.835758,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -93.835758,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        12.185546, -82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -82.927603,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        12.185546, -82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -93.835758,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        12.185546, -82.927603,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        12.185546, -84.1614,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        14.529833, -82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        12.185546, -94.807379,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -81.955983,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -95.217529,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -81.545833,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -95.217529,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -81.955983,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        11.598939, -93.603703,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -96.193095,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -94.75,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -97.907795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -94.75,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -96.193095,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -94.75,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689, -97.907795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -97.907795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -97.907795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -80.570267,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -96.193095,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -80.570267,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -97.907795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -98.513345,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        10.621257, -97.759463,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.996804, -95.102845,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        16.844122, -97.759463,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.996804, -98.513345,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        10.621257, -97.759463,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.996804, -95.102845,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        16.844122, -97.038545,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        13.312205, -97.038545,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        13.312205, -96.380845,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        12.951746, -97.759463,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.996804, -97.101763,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.996804, -96.380845,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        12.951746, -97.101763,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.636346, -97.101763,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.996804, -97.101763,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.996804, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -97.759463,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.996804, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -97.759463,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.996804, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -97.759463,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.996804, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -97.759463,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.996804, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -97.759463,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.996804, -97.101763,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.636346, -97.101763,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.636346, -97.101763,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.996804, -97.101763,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.996804, -96.380845,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        13.312205, -96.380845,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        12.951746, -97.759463,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.996804, -97.759463,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.996804, -97.101763,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.636346, -97.101763,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.636346, -97.101763,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.996804, -97.101763,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.996804, -96.380845,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        13.312205, -96.380845,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        12.951746, -97.759463,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.996804, -81.703818,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        16.92313, -79.764443,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        13.384507, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -79.764443,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        13.384507, -81.703818,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        16.92313, -79.043525,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.903895, -79.920459,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.903895, -79.043525,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.903895, -80.641376,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.903895, -79.764443,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        13.384507, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -76.813936,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -76.355567,
                                                                                                                                                                        91.569337,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        90.558974,
                                                                                                                                                                        10.357689, -76.355567,
                                                                                                                                                                        91.569337,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -76.033713,
                                                                                                                                                                        90.374401,
                                                                                                                                                                        10.362769, -73.256302,
                                                                                                                                                                        88.687459,
                                                                                                                                                                        10.569728, -76.033713,
                                                                                                                                                                        91.202911,
                                                                                                                                                                        8.927747, -75.16602,
                                                                                                                                                                        90.713221,
                                                                                                                                                                        8.927747, -76.033713,
                                                                                                                                                                        91.202911,
                                                                                                                                                                        8.927747, -73.256302,
                                                                                                                                                                        88.687459,
                                                                                                                                                                        10.569728, -74.989594,
                                                                                                                                                                        90.798439,
                                                                                                                                                                        8.607689, -72.954242,
                                                                                                                                                                        88.63941,
                                                                                                                                                                        10.357689, -72.774991,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -70.410741,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -72.774991,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -72.954242,
                                                                                                                                                                        88.63941,
                                                                                                                                                                        10.357689, -72.774991,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -70.410741,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -66.577164,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -64.646763,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -66.577164,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -70.410741,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -66.577164,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -64.646763,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -58.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -57.135,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -58.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -64.646763,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -58.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -57.135,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -49.093943,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -48.387367,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -49.093943,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -57.135,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -49.093943,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -48.387367,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        115.644964,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        112.914964,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        115.644964,
                                                                                                                                                                        8.607689, -48.387367,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        112.914964,
                                                                                                                                                                        10.357689, -29.612633,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        115.644964,
                                                                                                                                                                        8.607689, -29.612633,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -20.865,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -28.906057,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -19.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -28.906057,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -20.865,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -28.906057,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -19.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -19.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -19.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -11.422836,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -11.422836,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -19.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -13.353237,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -20.865,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -13.353237,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -19.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -3.96587,
                                                                                                                                                                        86.032331,
                                                                                                                                                                        10.357689, -2.73,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        10.357689, -1.328893,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        0,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -2.73,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        0,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        0,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -2.73,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        10.357689, -1.328893,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -3.96587,
                                                                                                                                                                        67.257597,
                                                                                                                                                                        10.357689, -1.328893,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -2.73,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        10.357689, -1.328893,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -3.96587,
                                                                                                                                                                        67.257597,
                                                                                                                                                                        10.357689, -5.225009,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -7.589259,
                                                                                                                                                                        58.509964,
                                                                                                                                                                        10.357689, -5.225009,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -3.96587,
                                                                                                                                                                        67.257597,
                                                                                                                                                                        10.357689, -5.225009,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -7.589259,
                                                                                                                                                                        58.509964,
                                                                                                                                                                        10.357689, -11.422836,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -13.353237,
                                                                                                                                                                        50.998201,
                                                                                                                                                                        10.357689, -11.422836,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -7.589259,
                                                                                                                                                                        58.509964,
                                                                                                                                                                        10.357689, -11.422836,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -13.353237,
                                                                                                                                                                        50.998201,
                                                                                                                                                                        10.357689, -19.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -20.865,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -19.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -13.353237,
                                                                                                                                                                        50.998201,
                                                                                                                                                                        10.357689, -19.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -20.865,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -28.906057,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -29.612633,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -28.906057,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -20.865,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -28.906057,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -29.612633,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        37.644964,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        40.374964,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        37.644964,
                                                                                                                                                                        8.607689, -29.612633,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        37.644964,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        40.374964,
                                                                                                                                                                        10.357689, -49.093943,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -48.387367,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -49.093943,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        40.374964,
                                                                                                                                                                        10.357689, -48.387367,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -57.135,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -49.093943,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -45.773697,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -45.773697,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -45.773697,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -44.882488,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -45.09,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        26.357689, -44.882488,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -45.09,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        26.357689, -44.882488,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -44.882488,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -45.09,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        26.357689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -44.882488,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -44.882488,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -44.882488,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -44.274095,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -44.274095,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -44.274095,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -44.274095,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -43.30628,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -43.30628,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -42.045,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -42.045,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -42.045,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -42.045,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -42.045,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -40.576208,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -42.045,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        25.107689, -42.045,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -40.576208,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -40.576208,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -40.576208,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -40.576208,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        58.8597,
                                                                                                                                                                        26.357689, -40.576208,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -39,
                                                                                                                                                                        58.8597,
                                                                                                                                                                        26.357689, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        25.107689, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -40.576208,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -42.045,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -40.576208,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -42.045,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -42.045,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -40.576208,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        26.357689, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        25.107689, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -42.045,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -43.30628,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -42.045,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        26.357689, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -43.30628,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -44.136178,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        16.226418, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -44.136178,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        16.226418, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        16.226418, -43.972613,
                                                                                                                                                                        58.326503,
                                                                                                                                                                        17.336396, -79.076577,
                                                                                                                                                                        37.667844,
                                                                                                                                                                        16.787915, -48.643316,
                                                                                                                                                                        55.577798,
                                                                                                                                                                        16.504471, -48.643316,
                                                                                                                                                                        55.577798,
                                                                                                                                                                        16.504471, -79.076577,
                                                                                                                                                                        37.667844,
                                                                                                                                                                        16.787915, -52.580957,
                                                                                                                                                                        53.260499,
                                                                                                                                                                        15.578558, -52.580957,
                                                                                                                                                                        53.260499,
                                                                                                                                                                        15.578558, -79.076577,
                                                                                                                                                                        37.667844,
                                                                                                                                                                        16.787915, -60.472398,
                                                                                                                                                                        48.616391,
                                                                                                                                                                        13.423946, -60.472398,
                                                                                                                                                                        48.616391,
                                                                                                                                                                        13.423946, -79.076577,
                                                                                                                                                                        37.667844,
                                                                                                                                                                        16.787915, -61.518039,
                                                                                                                                                                        48.001032,
                                                                                                                                                                        10.817456, -79.076577,
                                                                                                                                                                        37.667844,
                                                                                                                                                                        16.787915, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        10.542366, -61.518039,
                                                                                                                                                                        48.001032,
                                                                                                                                                                        10.817456, -79.513362,
                                                                                                                                                                        37.410797,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        35.939548,
                                                                                                                                                                        18.857689, -79.513362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -79.513362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        35.939548,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -79.513362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -82.013362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -95.046681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -95.046681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        22.107689, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        22.107689, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -82.013362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        35.939548,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        28.444045,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        35.939548,
                                                                                                                                                                        18.857689, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        18.857689, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -104.006681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -104.006681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -104.006681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -104.006681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -102.919181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -104.006681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -102.919181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -100.704306,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -100.704306,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -102.919181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -102.919181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -95.046681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -95.046681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -95.046681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -95.046681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -101.864466,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398, -100.407795,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -78,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -78,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        91.569337,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        91.569337,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -99.949426,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -76.355567,
                                                                                                                                                                        91.569337,
                                                                                                                                                                        8.607689, -74.989594,
                                                                                                                                                                        90.798439,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -74.989594,
                                                                                                                                                                        90.798439,
                                                                                                                                                                        8.607689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -74.989594,
                                                                                                                                                                        90.798439,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -74.989594,
                                                                                                                                                                        90.798439,
                                                                                                                                                                        8.607689, -72.982465,
                                                                                                                                                                        89.967059,
                                                                                                                                                                        8.607689, -74.989594,
                                                                                                                                                                        90.798439,
                                                                                                                                                                        8.607689, -72.774991,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -72.982465,
                                                                                                                                                                        89.967059,
                                                                                                                                                                        8.607689, -72.982465,
                                                                                                                                                                        89.967059,
                                                                                                                                                                        8.607689, -72.774991,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -72.774991,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -66.577164,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -66.577164,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -66.577164,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -58.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -58.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -58.5,
                                                                                                                                                                        110.419955,
                                                                                                                                                                        8.607689, -49.093943,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -49.093943,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -49.093943,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        8.607689, -49.093943,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        115.644964,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        115.644964,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        115.644964,
                                                                                                                                                                        8.607689, -28.906057,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -28.906057,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        115.644964,
                                                                                                                                                                        8.607689, -29.612633,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -28.906057,
                                                                                                                                                                        114.316071,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -23.35628,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -23.35628,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -16.876439,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -16.876439,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -16.876439,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -11.904282,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -11.904282,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -11.904282,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -8.778653,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -8.778653,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -8.778653,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -11.422836,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -11.422836,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -5.225009,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -5.225009,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -11.422836,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -7.589259,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -13.353237,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -7.589259,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -11.422836,
                                                                                                                                                                        104.222129,
                                                                                                                                                                        8.607689, -7.589259,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -3.96587,
                                                                                                                                                                        86.032331,
                                                                                                                                                                        10.357689, -5.225009,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -5.225009,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -3.96587,
                                                                                                                                                                        86.032331,
                                                                                                                                                                        10.357689, -5.225009,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -5.225009,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -1.328893,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -5.225009,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -11.422836,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -11.422836,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -5.225009,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -19.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -11.422836,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -19.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -16.876439,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -23.35628,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -16.876439,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -16.876439,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -23.35628,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -16.876439,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        1.505434, -23.35628,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        0.676451, -16.876439,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        1.505434, -23.35628,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -23.35628,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -30.902215,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -23.35628,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        0.676451, -30.902215,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -23.35628,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -23.35628,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -28.906057,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -28.906057,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -19.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        37.644964,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -28.906057,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        37.644964,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        7.107689, -30.902215,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        45.357524,
                                                                                                                                                                        4.107689, -30.902215,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        7.107689, -30.902215,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        45.357524,
                                                                                                                                                                        4.107689, -30.902215,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        0.172044, -39,
                                                                                                                                                                        45.357524,
                                                                                                                                                                        0, -30.902215,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        0.172044, -39,
                                                                                                                                                                        45.357524,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        45.357524,
                                                                                                                                                                        0, -39,
                                                                                                                                                                        45.357524,
                                                                                                                                                                        4.107689, -47.097785,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        0.172044, -47.097785,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -47.097785,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        0.172044, -39,
                                                                                                                                                                        45.357524,
                                                                                                                                                                        4.107689, -47.097785,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        0.172044, -47.097785,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        0.676451, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        0.676451, -47.097785,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        0.676451, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        1.505434, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        1.505434, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        1.505434, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -62.271903,
                                                                                                                                                                        48.502633,
                                                                                                                                                                        7.107689, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -58.781118,
                                                                                                                                                                        52.723983,
                                                                                                                                                                        4.107689, -62.271903,
                                                                                                                                                                        48.502633,
                                                                                                                                                                        7.107689, -58.781118,
                                                                                                                                                                        52.723983,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -58.781118,
                                                                                                                                                                        52.723983,
                                                                                                                                                                        4.107689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -47.097785,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -54.64372,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        4.107689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -47.097785,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        45.357524,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        7.107689, -47.097785,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -49.093943,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -49.093943,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        37.644964,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        37.644964,
                                                                                                                                                                        8.607689, -58.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -49.093943,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -62.271903,
                                                                                                                                                                        48.502633,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -58.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -62.271903,
                                                                                                                                                                        48.502633,
                                                                                                                                                                        8.607689, -63.594438,
                                                                                                                                                                        46.779073,
                                                                                                                                                                        8.607689, -63.594438,
                                                                                                                                                                        46.779073,
                                                                                                                                                                        8.607689, -62.271903,
                                                                                                                                                                        48.502633,
                                                                                                                                                                        8.607689, -58.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -63.594438,
                                                                                                                                                                        46.779073,
                                                                                                                                                                        8.607689, -58.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -61.078149,
                                                                                                                                                                        48.259907,
                                                                                                                                                                        10.357689, -57.135,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -61.078149,
                                                                                                                                                                        48.259907,
                                                                                                                                                                        10.357689, -58.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -61.518039,
                                                                                                                                                                        48.001032,
                                                                                                                                                                        10.817456, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        10.542366, -63.751076,
                                                                                                                                                                        46.686891,
                                                                                                                                                                        9.264448, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        9.264448, -63.751076,
                                                                                                                                                                        46.686891,
                                                                                                                                                                        9.264448, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        10.542366, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        10.357689, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        10.357689, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -98.269189,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -98.269189,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -98.269189,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -98.269189,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -98.269189,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -99.430136,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -99.430136,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -98.269189,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -99.430136,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -99.430136,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -99.430136,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -99.430136,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -99.430136,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -97.106617,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -98.269189,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -97.106617,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -98.269189,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -98.269189,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -98.269189,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -97.106617,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -98.269189,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -97.106617,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -97.106617,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -97.106617,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -97.106617,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -97.106617,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -97.106617,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -74.656745,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -74.656745,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -74.656745,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -74.656745,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -73.494173,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -74.656745,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -73.494173,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -74.656745,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -74.656745,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -74.656745,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -73.494173,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        12.891169, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -73.494173,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -73.494173,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -73.494173,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -73.494173,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -72.333226,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -72.333226,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -72.333226,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -72.333226,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -72.333226,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -72.333226,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -71.059056,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -71.059056,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -71.059056,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -71.059056,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -71.059056,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -71.059056,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -68.844181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -68.844181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -68.844181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -67.756681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -67.756681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -67.756681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -67.756681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -67.756681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -67.756681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -79.513362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -79.513362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -79.513362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -79.513362,
                                                                                                                                                                        37.410797,
                                                                                                                                                                        16.357689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        10.357689, -79.513362,
                                                                                                                                                                        37.410797,
                                                                                                                                                                        16.357689, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -67.756681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -79.513362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -67.756681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -67.756681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -67.756681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -67.756681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -68.844181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -68.844181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -68.844181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.318495, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.318495, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.318495, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.318495, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.318495, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.318495, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.014854, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.014854, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.014854, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.014854, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.014854, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.014854, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -74.767533,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -73.494173,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -73.494173,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -73.494173,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -73.494173,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -73.494173,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -72.333226,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -72.333226,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -73.644575,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.875106, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -73.644575,
                                                                                                                                                                        0,
                                                                                                                                                                        14.875106, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.939668, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -71.059056,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -72.333226,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -71.059056,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -72.333226,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -72.333226,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.175581, -72.333226,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -72.523187,
                                                                                                                                                                        0,
                                                                                                                                                                        15.175581, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -71.059056,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -71.059056,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -71.059056,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -71.059056,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -68.844181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -71.292433,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.157227, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -71.292433,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        17.157227, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        16.520142, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.520142, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        18.16748, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        18.16748, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        18.16748, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        18.16748, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        18.16748, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        18.16748, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.318495, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.318495, -93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.318495, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.117634, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.16748, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.996245, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.555289, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.674742, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.560699, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        17.014854, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        16.873287, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        16.548472, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        16.031766, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        15.939668, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        16.853829, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.853829, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        17.555289, -93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        18.16748, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        18.16748, -93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        18.16748, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        17.996245, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        15.358382, -96.995829,
                                                                                                                                                                        0,
                                                                                                                                                                        14.57421, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        17.674742, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        20.581764, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        20.581764, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        20.581764, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        20.581764, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        20.581764, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        20.581764, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        19.318495, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        19.664162, -93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        20.581764, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        20.581764, -93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        20.581764, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        20.348388, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        19.117634, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        18.560699, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -95.046681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -95.046681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -95.046681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.605189, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -99.819181,
                                                                                                                                                                        5,
                                                                                                                                                                        20.985652, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        22.107689, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        22.107689, -97.79929,
                                                                                                                                                                        5,
                                                                                                                                                                        21.822318, -95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        22.107689, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.107689, -76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        22.107689, -95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        22.107689, -76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        22.107689, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        22.107689, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        21.822318, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        19.654709, -101.5537,
                                                                                                                                                                        5,
                                                                                                                                                                        19.654709, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        20.985652, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -100.613379,
                                                                                                                                                                        3.25,
                                                                                                                                                                        19.299388, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        18.575717, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        18.575717, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        19.664162, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -98.982931,
                                                                                                                                                                        3.25,
                                                                                                                                                                        20.550474, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.348388, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        20.581764, -97.084234,
                                                                                                                                                                        3.25,
                                                                                                                                                                        21.33694, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        17.668939, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -69.11243,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        17.920189, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -68.042052,
                                                                                                                                                                        5,
                                                                                                                                                                        15.900299, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        17.920189, -68.042052,
                                                                                                                                                                        22.5,
                                                                                                                                                                        15.900299, -79.513362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        16.357689, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -100.704306,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -99.430136,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -100.704306,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -100.704306,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -100.704306,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        15.50536, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.50536, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        15.770242, -100.704306,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -100.704306,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -100.704306,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -100.704306,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -100.704306,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -100.470929,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.960018, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -100.470929,
                                                                                                                                                                        0,
                                                                                                                                                                        11.960018, -99.786704,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -98.698258,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -98.698258,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -97.279768,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        6.883614, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        6.883614, -95.627902,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        6.883614, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        6.883614, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        6.883614, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        6.883614, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -69.898896,
                                                                                                                                                                        3.25,
                                                                                                                                                                        9.796439, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -68.878718,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -68.878718,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -70.209662,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.357689, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.357689, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.357689, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.357689, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.357689, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.357689, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.357689, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -99.819181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -71.944181,
                                                                                                                                                                        22.5,
                                                                                                                                                                        6.479727, -97.79929,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.357689, -95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.357689, -73.964071,
                                                                                                                                                                        22.5,
                                                                                                                                                                        5.643061, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        5.357689, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -73.964071,
                                                                                                                                                                        5,
                                                                                                                                                                        5.643061, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -70.209662,
                                                                                                                                                                        5,
                                                                                                                                                                        7.81067, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -71.944181,
                                                                                                                                                                        5,
                                                                                                                                                                        6.479727, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -73.065104,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.889662, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -71.149983,
                                                                                                                                                                        3.25,
                                                                                                                                                                        8.165991, -74.483593,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.801216, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -72.780431,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.914904, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -76.13546,
                                                                                                                                                                        2.5,
                                                                                                                                                                        7.116991, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -74.679128,
                                                                                                                                                                        3.25,
                                                                                                                                                                        6.128438, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        6.883614, -76.716681,
                                                                                                                                                                        3.25,
                                                                                                                                                                        5.860189, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -102.884644,
                                                                                                                                                                        22.5,
                                                                                                                                                                        9.545189, -101.5537,
                                                                                                                                                                        22.5,
                                                                                                                                                                        7.81067, -102.884644,
                                                                                                                                                                        5,
                                                                                                                                                                        9.545189, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -78,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -78,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        86.738907,
                                                                                                                                                                        8.607689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -69.221347,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -69.221347,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -67.885095,
                                                                                                                                                                        87.968745,
                                                                                                                                                                        4.107689, -66.095718,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -67.885095,
                                                                                                                                                                        87.968745,
                                                                                                                                                                        4.107689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -66.095718,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -66.095718,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        1.607689, -67.885095,
                                                                                                                                                                        87.968745,
                                                                                                                                                                        4.107689, -66.095718,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        1.607689, -66.095718,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        1.607689, -61.123561,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        1.607689, -66.095718,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -54.64372,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        1.607689, -54.64372,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -61.123561,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -66.095718,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -61.123561,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -66.095718,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -54.64372,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -47.097785,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -54.64372,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -54.64372,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -47.097785,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -54.64372,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        1.607689, -47.097785,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        1.607689, -54.64372,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        1.607689, -47.097785,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -47.097785,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        107.932404,
                                                                                                                                                                        4.107689, -47.097785,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        1.607689, -47.097785,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        107.932404,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        107.932404,
                                                                                                                                                                        4.107689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        107.932404,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        7.107689, -30.902215,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -30.902215,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        7.107689, -30.902215,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -23.35628,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -30.902215,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -23.35628,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -30.902215,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        1.607689, -23.35628,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        1.607689, -30.902215,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        1.607689, -23.35628,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -23.35628,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -16.876439,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -23.35628,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        1.607689, -16.876439,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        1.607689, -23.35628,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        1.607689, -16.876439,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -16.876439,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        1.607689, -16.876439,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -11.904282,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        1.607689, -11.904282,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -11.904282,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        1.607689, -16.876439,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        4.107689, -11.904282,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        1.607689, -11.904282,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -8.778653,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        1.607689, -8.778653,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -8.778653,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        1.607689, -11.904282,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        4.107689, -8.778653,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        1.607689, -8.778653,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        1.607689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        1.607689, -8.778653,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        1.607689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        1.607689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        1.607689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        1.607689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -10.172389,
                                                                                                                                                                        65.182404,
                                                                                                                                                                        1.607689, -10.172389,
                                                                                                                                                                        65.182404,
                                                                                                                                                                        1.607689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        1.607689, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        1.607689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        1.607689, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -16.263816,
                                                                                                                                                                        55.319788,
                                                                                                                                                                        1.607689, -16.263816,
                                                                                                                                                                        55.319788,
                                                                                                                                                                        1.607689, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -16.876439,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        1.505434, -16.876439,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -16.876439,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        1.505434, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -16.876439,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        4.107689, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -11.904282,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -8.778653,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -7.71256,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -30.902215,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        1.607689, -39,
                                                                                                                                                                        107.932404,
                                                                                                                                                                        1.607689, -30.902215,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        107.932404,
                                                                                                                                                                        4.107689, -30.902215,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        4.107689, -39,
                                                                                                                                                                        107.932404,
                                                                                                                                                                        1.607689, -39,
                                                                                                                                                                        107.932404,
                                                                                                                                                                        1.607689, -47.097785,
                                                                                                                                                                        106.866311,
                                                                                                                                                                        1.607689, -39,
                                                                                                                                                                        107.932404,
                                                                                                                                                                        4.107689, -54.64372,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        1.607689, -61.123561,
                                                                                                                                                                        98.768525,
                                                                                                                                                                        1.607689, -54.64372,
                                                                                                                                                                        103.740682,
                                                                                                                                                                        4.107689, -67.885095,
                                                                                                                                                                        87.968745,
                                                                                                                                                                        1.607689, -67.885095,
                                                                                                                                                                        87.968745,
                                                                                                                                                                        4.107689, -66.095718,
                                                                                                                                                                        92.288684,
                                                                                                                                                                        1.607689, -67.885095,
                                                                                                                                                                        87.968745,
                                                                                                                                                                        4.107689, -67.885095,
                                                                                                                                                                        87.968745,
                                                                                                                                                                        1.607689, -69.221347,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -69.221347,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        1.607689, -69.221347,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -67.885095,
                                                                                                                                                                        87.968745,
                                                                                                                                                                        1.607689, -69.221347,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -69.221347,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        1.607689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        1.607689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -69.221347,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        1.607689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        1.607689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        1.607689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        1.607689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        1.607689, -67.827611,
                                                                                                                                                                        65.182404,
                                                                                                                                                                        1.607689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -67.827611,
                                                                                                                                                                        65.182404,
                                                                                                                                                                        1.607689, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        1.607689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        1.607689, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -66.577164,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -66.577164,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -63.594438,
                                                                                                                                                                        46.779073,
                                                                                                                                                                        8.607689, -63.594438,
                                                                                                                                                                        46.779073,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        8.607689, -66.577164,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -72.774991,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -66.577164,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        8.607689, -72.774991,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -66.577164,
                                                                                                                                                                        49.0678,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -72.774991,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -69.221347,
                                                                                                                                                                        84.74275,
                                                                                                                                                                        4.107689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -70.28744,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        4.107689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -69.221347,
                                                                                                                                                                        68.547179,
                                                                                                                                                                        4.107689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -76.671107,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -72.774991,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -72.774991,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -76.671107,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        8.607689, -62.271903,
                                                                                                                                                                        48.502633,
                                                                                                                                                                        7.107689, -58.781118,
                                                                                                                                                                        52.723983,
                                                                                                                                                                        4.107689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        1.607689, -61.736184,
                                                                                                                                                                        55.319788,
                                                                                                                                                                        1.607689, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -61.736184,
                                                                                                                                                                        55.319788,
                                                                                                                                                                        1.607689, -61.123561,
                                                                                                                                                                        54.521403,
                                                                                                                                                                        1.505434, -66.095718,
                                                                                                                                                                        61.001244,
                                                                                                                                                                        4.107689, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -71.976658,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.308152, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -73.966078,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -71.976658,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -73.080122,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -74.786992,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -73.080122,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -74.085531,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -75.609054,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -74.085531,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -75.092348,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -96.671014,
                                                                                                                                                                        0,
                                                                                                                                                                        12.106996, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -98.118787,
                                                                                                                                                                        0,
                                                                                                                                                                        12.590273, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -99.430136,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -98.118787,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.590273, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -99.430136,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -99.430136,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -99.430136,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -99.430136,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -100.704306,
                                                                                                                                                                        0,
                                                                                                                                                                        13.732689, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -99.240175,
                                                                                                                                                                        0,
                                                                                                                                                                        12.289798, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -99.240175,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.289798, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -98.68324,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.945237, -98.68324,
                                                                                                                                                                        0,
                                                                                                                                                                        10.945237, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -99.786704,
                                                                                                                                                                        0,
                                                                                                                                                                        10.308152, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -96.642683,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.146884, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.146884, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.146884, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.146884, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.146884, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.146884, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.450525, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.450525, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.450525, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.450525, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.450525, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.450525, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -94.696752,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -97.677831,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.525711, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -96.97637,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -96.97637,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.61155, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        9.297899, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        9.297899, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        9.297899, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        9.297899, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        9.297899, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        9.297899, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        9.297899, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -76.765715,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        10.450525, -96.06221,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -75.701152,
                                                                                                                                                                        0,
                                                                                                                                                                        9.91009, -93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        9.297899, -78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        9.297899, -94.997647,
                                                                                                                                                                        0,
                                                                                                                                                                        9.469134, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -97.797284,
                                                                                                                                                                        0,
                                                                                                                                                                        9.790636, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.297899, -96.06221,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -97.797284,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -94.997647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -75.120679,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -96.642683,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.90468, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -76.465239,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.146884, -93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.146884, -77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.146884, -95.298123,
                                                                                                                                                                        2.5,
                                                                                                                                                                        8.347745, -96.154308,
                                                                                                                                                                        0,
                                                                                                                                                                        11.433612, -97.677831,
                                                                                                                                                                        0,
                                                                                                                                                                        11.525711, -95.480924,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -76.282438,
                                                                                                                                                                        0,
                                                                                                                                                                        10.916907, -77.06661,
                                                                                                                                                                        0,
                                                                                                                                                                        10.592092, -74.786992,
                                                                                                                                                                        0,
                                                                                                                                                                        10.61155, -75.701152,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.91009, -76.765715,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.469134, -73.966078,
                                                                                                                                                                        2.5,
                                                                                                                                                                        9.790636, -75.120679,
                                                                                                                                                                        0,
                                                                                                                                                                        8.90468, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -73.065104,
                                                                                                                                                                        0,
                                                                                                                                                                        8.889662, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -76.465239,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -95.298123,
                                                                                                                                                                        0,
                                                                                                                                                                        8.347745, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        8.146884, -74.483593,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -97.279768,
                                                                                                                                                                        0,
                                                                                                                                                                        7.801216, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -76.13546,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        6.883614, -93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        6.883614, -77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        6.883614, -95.627902,
                                                                                                                                                                        0,
                                                                                                                                                                        7.116991, -58.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        8.607689, -49.093943,
                                                                                                                                                                        38.973857,
                                                                                                                                                                        8.607689, -57.135,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -30.902215,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        0.172044, -23.35628,
                                                                                                                                                                        49.549246,
                                                                                                                                                                        0.676451, -30.902215,
                                                                                                                                                                        46.423618,
                                                                                                                                                                        4.107689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -5.225009,
                                                                                                                                                                        96.144964,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -104.006681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -104.006681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -102.919181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -102.650932,
                                                                                                                                                                        3.25,
                                                                                                                                                                        11.695136, -102.919181,
                                                                                                                                                                        3.25,
                                                                                                                                                                        13.732689, -103.72131,
                                                                                                                                                                        5,
                                                                                                                                                                        11.56508, -104.006681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        13.732689, -103.72131,
                                                                                                                                                                        22.5,
                                                                                                                                                                        11.56508, -104.006681,
                                                                                                                                                                        5,
                                                                                                                                                                        13.732689, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -44.274095,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -44.882488,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -44.274095,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -44.882488,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -44.882488,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -44.274095,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -44.882488,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -44.274095,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -44.274095,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -44.274095,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -44.274095,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -43.30628,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -44.274095,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -43.30628,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -32.198546,
                                                                                                                                                                        51.261593,
                                                                                                                                                                        15.098225, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -33.725905,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -33.117512,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -33.725905,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -33.725905,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -33.117512,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -33.117512,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -32.91,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        26.357689, -33.117512,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -33.117512,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -32.91,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        26.357689, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -33.117512,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -32.91,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        26.357689, -33.117512,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        25.107689, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -33.117512,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        26.357689, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -33.117512,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        25.107689, -33.117512,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -33.725905,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -33.725905,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        25.107689, -33.725905,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -34.69372,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -34.69372,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        25.107689, -33.863822,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        16.559911, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        25.107689, -33.863822,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -34.69372,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -34.69372,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -33.725905,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -35.955,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -34.69372,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -34.69372,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        26.357689, -34.69372,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -35.955,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        25.107689, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        25.107689, -35.955,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        26.357689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        25.107689, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        25.107689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        25.107689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        14.621443, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        14.621443, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        25.107689, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -34.69372,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -33.725905,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -34.69372,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        25.107689, -34.69372,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        26.357689, -33.725905,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -33.725905,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -33.725905,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        26.357689, -33.725905,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        26.357689, -33.117512,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        26.357689, -47.795475,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -54.392081,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -54.392081,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -62.260957,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        14.762562, -66.247696,
                                                                                                                                                                        82.367812,
                                                                                                                                                                        14.664789, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        14.762562, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -62.260957,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -47.795475,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -66.838759,
                                                                                                                                                                        80.465397,
                                                                                                                                                                        18.537632, -66.583144,
                                                                                                                                                                        82.406986,
                                                                                                                                                                        14.924838, -79.26625,
                                                                                                                                                                        88.652615,
                                                                                                                                                                        16.504782, -82.135222,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.831729, -81.842793,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        12.395265, -82.135222,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        12.831729, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        16.357689, -89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        16.357689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        16.357689, -94.942794,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        15.991368, -94.877842,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        16.114781, -94.942794,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        15.991368, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -95.070637,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -96.902598,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.978016, -96.902598,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.978016, -95.070637,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -96.590327,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.602447, -96.923915,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.993085, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -96.902598,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.978016, -84.029668,
                                                                                                                                                                        34.752953,
                                                                                                                                                                        21.45093, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        20.247152, -66.632456,
                                                                                                                                                                        44.991201,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        null,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "normals": [
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.967683,
                                                                                                                                                                        0.25217,
                                                                                                                                                                        0, -0.967683,
                                                                                                                                                                        0.25217,
                                                                                                                                                                        0, -0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0, -0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0, -0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0, -0.967683,
                                                                                                                                                                        0.25217,
                                                                                                                                                                        0, -0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0, -0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0, -0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0, -0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0, -0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0, -0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0, -0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0, -0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0, -0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0, -0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0, -0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0, -0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0, -0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0, -0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0, -0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.967683,
                                                                                                                                                                        0.25217,
                                                                                                                                                                        0,
                                                                                                                                                                        0.967683,
                                                                                                                                                                        0.25217,
                                                                                                                                                                        0,
                                                                                                                                                                        0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.042262,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999107,
                                                                                                                                                                        0.040641,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999174, -0.042262,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999107,
                                                                                                                                                                        0.040641,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999174, -0.042262,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999107,
                                                                                                                                                                        0.040641,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999174,
                                                                                                                                                                        0.040641,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999174, -0.042262,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999107,
                                                                                                                                                                        0.040641,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999174,
                                                                                                                                                                        0.040641,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999174,
                                                                                                                                                                        0.081215,
                                                                                                                                                                        0,
                                                                                                                                                                        0.996697,
                                                                                                                                                                        0.081215,
                                                                                                                                                                        0,
                                                                                                                                                                        0.996697,
                                                                                                                                                                        0.081215,
                                                                                                                                                                        0,
                                                                                                                                                                        0.996697,
                                                                                                                                                                        0.040641,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999174,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0, -0.042262,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999107, -0.042262,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999107, -0.084449,
                                                                                                                                                                        0,
                                                                                                                                                                        0.996428, -0.084449,
                                                                                                                                                                        0,
                                                                                                                                                                        0.996428, -0.084449,
                                                                                                                                                                        0,
                                                                                                                                                                        0.996428, -0.042262,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999107, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0,
                                                                                                                                                                        0.49149,
                                                                                                                                                                        0.870883,
                                                                                                                                                                        0, -0.184939,
                                                                                                                                                                        0, -0.98275, -0.184939,
                                                                                                                                                                        0, -0.98275, -0.184939,
                                                                                                                                                                        0, -0.98275, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901,
                                                                                                                                                                        0.346245,
                                                                                                                                                                        0,
                                                                                                                                                                        0.938144,
                                                                                                                                                                        0.346245,
                                                                                                                                                                        0,
                                                                                                                                                                        0.938144,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312,
                                                                                                                                                                        0.346245,
                                                                                                                                                                        0,
                                                                                                                                                                        0.938144,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95506, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8458, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.577256,
                                                                                                                                                                        0, -0.816563, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.577256,
                                                                                                                                                                        0, -0.816563, -0.577256,
                                                                                                                                                                        0, -0.816563, -0.577256,
                                                                                                                                                                        0, -0.816563, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.577256,
                                                                                                                                                                        0, -0.816563, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.95506,
                                                                                                                                                                        0, -0.296412, -0.8458,
                                                                                                                                                                        0, -0.533499,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.864329,
                                                                                                                                                                        0, -0.502928, -0.809129,
                                                                                                                                                                        0, -0.587631, -0.864329,
                                                                                                                                                                        0, -0.502928, -0.809129,
                                                                                                                                                                        0, -0.587631, -0.864329,
                                                                                                                                                                        0, -0.502928, -0.809129,
                                                                                                                                                                        0, -0.587631,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.979673, -0.200602,
                                                                                                                                                                        0,
                                                                                                                                                                        0.979673, -0.200602,
                                                                                                                                                                        0,
                                                                                                                                                                        0.979673, -0.200602,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0, -0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0, -0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0, -0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0, -0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0, -0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0, -0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0, -0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0, -0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0,
                                                                                                                                                                        0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0,
                                                                                                                                                                        0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0,
                                                                                                                                                                        0.236974,
                                                                                                                                                                        0.971516,
                                                                                                                                                                        0,
                                                                                                                                                                        0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0,
                                                                                                                                                                        0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0,
                                                                                                                                                                        0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0,
                                                                                                                                                                        0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0,
                                                                                                                                                                        0.460448,
                                                                                                                                                                        0.887687,
                                                                                                                                                                        0,
                                                                                                                                                                        0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0,
                                                                                                                                                                        0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0,
                                                                                                                                                                        0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0,
                                                                                                                                                                        0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0,
                                                                                                                                                                        0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0,
                                                                                                                                                                        0.657691,
                                                                                                                                                                        0.753288,
                                                                                                                                                                        0,
                                                                                                                                                                        0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0,
                                                                                                                                                                        0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0,
                                                                                                                                                                        0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0,
                                                                                                                                                                        0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0,
                                                                                                                                                                        0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0,
                                                                                                                                                                        0.817467,
                                                                                                                                                                        0.575975,
                                                                                                                                                                        0,
                                                                                                                                                                        0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0,
                                                                                                                                                                        0.930674,
                                                                                                                                                                        0.365851,
                                                                                                                                                                        0,
                                                                                                                                                                        0.967683,
                                                                                                                                                                        0.25217,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.798641, -0.601807,
                                                                                                                                                                        0,
                                                                                                                                                                        0.798641, -0.601807,
                                                                                                                                                                        0,
                                                                                                                                                                        0.798641, -0.601807,
                                                                                                                                                                        0, -0.798641, -0.601807,
                                                                                                                                                                        0, -0.798641, -0.601807,
                                                                                                                                                                        0, -0.798641, -0.601807,
                                                                                                                                                                        0, -0.798641, -0.601807,
                                                                                                                                                                        0, -0.798641, -0.601807,
                                                                                                                                                                        0, -0.798641, -0.601807,
                                                                                                                                                                        0, -0.979673, -0.200602,
                                                                                                                                                                        0, -0.979673, -0.200602,
                                                                                                                                                                        0, -0.979673, -0.200602,
                                                                                                                                                                        0, -0.979673, -0.200602,
                                                                                                                                                                        0, -0.979673, -0.200602,
                                                                                                                                                                        0, -0.979673, -0.200602,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.43614,
                                                                                                                                                                        0,
                                                                                                                                                                        0.899879,
                                                                                                                                                                        0.43614,
                                                                                                                                                                        0,
                                                                                                                                                                        0.899879,
                                                                                                                                                                        0.237342,
                                                                                                                                                                        0,
                                                                                                                                                                        0.971426,
                                                                                                                                                                        0.43614,
                                                                                                                                                                        0,
                                                                                                                                                                        0.899879,
                                                                                                                                                                        0.43614,
                                                                                                                                                                        0,
                                                                                                                                                                        0.899879,
                                                                                                                                                                        0.615468,
                                                                                                                                                                        0,
                                                                                                                                                                        0.788162,
                                                                                                                                                                        0.615468,
                                                                                                                                                                        0,
                                                                                                                                                                        0.788162,
                                                                                                                                                                        0.615468,
                                                                                                                                                                        0,
                                                                                                                                                                        0.788162,
                                                                                                                                                                        0.43614,
                                                                                                                                                                        0,
                                                                                                                                                                        0.899879,
                                                                                                                                                                        0.615468,
                                                                                                                                                                        0,
                                                                                                                                                                        0.788162,
                                                                                                                                                                        0.615468,
                                                                                                                                                                        0,
                                                                                                                                                                        0.788162,
                                                                                                                                                                        0.767323,
                                                                                                                                                                        0,
                                                                                                                                                                        0.641261,
                                                                                                                                                                        0.767323,
                                                                                                                                                                        0,
                                                                                                                                                                        0.641261,
                                                                                                                                                                        0.767323,
                                                                                                                                                                        0,
                                                                                                                                                                        0.641261,
                                                                                                                                                                        0.615468,
                                                                                                                                                                        0,
                                                                                                                                                                        0.788162,
                                                                                                                                                                        0.767323,
                                                                                                                                                                        0,
                                                                                                                                                                        0.641261,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.767323,
                                                                                                                                                                        0,
                                                                                                                                                                        0.641261,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.963023,
                                                                                                                                                                        0,
                                                                                                                                                                        0.269419,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.963023,
                                                                                                                                                                        0,
                                                                                                                                                                        0.269419,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.963023,
                                                                                                                                                                        0,
                                                                                                                                                                        0.269419,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.777729,
                                                                                                                                                                        0, -0.628599,
                                                                                                                                                                        0.839783,
                                                                                                                                                                        0, -0.542922,
                                                                                                                                                                        0.777729,
                                                                                                                                                                        0, -0.628599,
                                                                                                                                                                        0.839783,
                                                                                                                                                                        0, -0.542922,
                                                                                                                                                                        0.777729,
                                                                                                                                                                        0, -0.628599,
                                                                                                                                                                        0.839783,
                                                                                                                                                                        0, -0.542922,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.839783,
                                                                                                                                                                        0, -0.542922,
                                                                                                                                                                        0.839783,
                                                                                                                                                                        0, -0.542922,
                                                                                                                                                                        0.935106,
                                                                                                                                                                        0, -0.354367,
                                                                                                                                                                        0.935106,
                                                                                                                                                                        0, -0.354367,
                                                                                                                                                                        0.935106,
                                                                                                                                                                        0, -0.354367,
                                                                                                                                                                        0.839783,
                                                                                                                                                                        0, -0.542922,
                                                                                                                                                                        0.935106,
                                                                                                                                                                        0, -0.354367,
                                                                                                                                                                        0.988687,
                                                                                                                                                                        0, -0.149994,
                                                                                                                                                                        0.935106,
                                                                                                                                                                        0, -0.354367,
                                                                                                                                                                        0.988687,
                                                                                                                                                                        0, -0.149994,
                                                                                                                                                                        0.935106,
                                                                                                                                                                        0, -0.354367,
                                                                                                                                                                        0.988687,
                                                                                                                                                                        0, -0.149994,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.998133,
                                                                                                                                                                        0,
                                                                                                                                                                        0.061076,
                                                                                                                                                                        0.988687,
                                                                                                                                                                        0, -0.149994,
                                                                                                                                                                        0.998133,
                                                                                                                                                                        0,
                                                                                                                                                                        0.061076,
                                                                                                                                                                        0.988687,
                                                                                                                                                                        0, -0.149994,
                                                                                                                                                                        0.998133,
                                                                                                                                                                        0,
                                                                                                                                                                        0.061076,
                                                                                                                                                                        0.988687,
                                                                                                                                                                        0, -0.149994,
                                                                                                                                                                        0.998133,
                                                                                                                                                                        0,
                                                                                                                                                                        0.061076,
                                                                                                                                                                        0.963023,
                                                                                                                                                                        0,
                                                                                                                                                                        0.269419,
                                                                                                                                                                        0.998133,
                                                                                                                                                                        0,
                                                                                                                                                                        0.061076,
                                                                                                                                                                        0.963023,
                                                                                                                                                                        0,
                                                                                                                                                                        0.269419,
                                                                                                                                                                        0.998133,
                                                                                                                                                                        0,
                                                                                                                                                                        0.061076,
                                                                                                                                                                        0.963023,
                                                                                                                                                                        0,
                                                                                                                                                                        0.269419,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.998002, -0.019632,
                                                                                                                                                                        0.06006,
                                                                                                                                                                        0.99868, -0.041662,
                                                                                                                                                                        0.030051,
                                                                                                                                                                        0.99868, -0.041662,
                                                                                                                                                                        0.030051,
                                                                                                                                                                        0.999807, -0.019668,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999807, -0.019668,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999807, -0.019668,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999807, -0.019668,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999807, -0.019668,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999807, -0.019668,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.991445, -0.130526,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.991445,
                                                                                                                                                                        0.130526,
                                                                                                                                                                        0,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.991445,
                                                                                                                                                                        0.130526,
                                                                                                                                                                        0,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.793353,
                                                                                                                                                                        0.608761,
                                                                                                                                                                        0,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.29762, -0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.29762, -0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.29762, -0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.47538, -0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.246075, -0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.47538, -0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.47538, -0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.246075, -0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.246075, -0.918364,
                                                                                                                                                                        0.309928, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.991445, -0.130526,
                                                                                                                                                                        0, -0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928, -0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928, -0.991445, -0.130526,
                                                                                                                                                                        0, -0.918364, -0.246075,
                                                                                                                                                                        0.309928, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.918364, -0.246075,
                                                                                                                                                                        0.309928, -0.991445, -0.130526,
                                                                                                                                                                        0, -0.918364, -0.246075,
                                                                                                                                                                        0.309928, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.823382, -0.47538,
                                                                                                                                                                        0.309928, -0.866025, -0.5,
                                                                                                                                                                        0, -0.823382, -0.47538,
                                                                                                                                                                        0.309928, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.823382, -0.47538,
                                                                                                                                                                        0.309928, -0.672289, -0.672289,
                                                                                                                                                                        0.309928, -0.823382, -0.47538,
                                                                                                                                                                        0.309928, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.672289, -0.672289,
                                                                                                                                                                        0.309928, -0.420898, -0.420898,
                                                                                                                                                                        0.803548, -0.823382, -0.47538,
                                                                                                                                                                        0.309928, -0.672289, -0.672289,
                                                                                                                                                                        0.309928, -0.47538, -0.823382,
                                                                                                                                                                        0.309928, -0.420898, -0.420898,
                                                                                                                                                                        0.803548, -0.672289, -0.672289,
                                                                                                                                                                        0.309928, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.47538, -0.823382,
                                                                                                                                                                        0.309928, -0.5, -0.866025,
                                                                                                                                                                        0, -0.47538, -0.823382,
                                                                                                                                                                        0.309928, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.47538, -0.823382,
                                                                                                                                                                        0.309928, -0.5, -0.866025,
                                                                                                                                                                        0, -0.246075, -0.918364,
                                                                                                                                                                        0.309928, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.246075, -0.918364,
                                                                                                                                                                        0.309928, -0.5, -0.866025,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.246075, -0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0, -0.95076,
                                                                                                                                                                        0.309928, -0.246075, -0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.246075, -0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0, -0.95076,
                                                                                                                                                                        0.309928, -0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0, -0.59524,
                                                                                                                                                                        0.803548, -0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0, -0.95076,
                                                                                                                                                                        0.309928, -0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0, -0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0, -0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.05944,
                                                                                                                                                                        0.451488,
                                                                                                                                                                        0.890295,
                                                                                                                                                                        0.05944,
                                                                                                                                                                        0.451488,
                                                                                                                                                                        0.890295,
                                                                                                                                                                        0, -0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0, -0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0, -0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.246075, -0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0, -0.95076,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.246075, -0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0, -0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.246075, -0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0, -0.95076,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.95076,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.05944,
                                                                                                                                                                        0.451488,
                                                                                                                                                                        0.890295,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0.309928, -0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.793353,
                                                                                                                                                                        0.608761,
                                                                                                                                                                        0, -0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.184939,
                                                                                                                                                                        0, -0.98275, -0.184939,
                                                                                                                                                                        0, -0.98275, -0.184939,
                                                                                                                                                                        0, -0.98275, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.026258,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999655, -0.074814,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997198,
                                                                                                                                                                        0.026258,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999655,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.273638,
                                                                                                                                                                        0,
                                                                                                                                                                        0.961833, -0.461303,
                                                                                                                                                                        0,
                                                                                                                                                                        0.887243, -0.273638,
                                                                                                                                                                        0,
                                                                                                                                                                        0.961833, -0.461303,
                                                                                                                                                                        0,
                                                                                                                                                                        0.887243, -0.273638,
                                                                                                                                                                        0,
                                                                                                                                                                        0.961833, -0.461303,
                                                                                                                                                                        0,
                                                                                                                                                                        0.887243, -0.461303,
                                                                                                                                                                        0,
                                                                                                                                                                        0.887243, -0.630155,
                                                                                                                                                                        0,
                                                                                                                                                                        0.77647, -0.461303,
                                                                                                                                                                        0,
                                                                                                                                                                        0.887243,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.630155,
                                                                                                                                                                        0,
                                                                                                                                                                        0.77647, -0.773308,
                                                                                                                                                                        0,
                                                                                                                                                                        0.634031, -0.630155,
                                                                                                                                                                        0,
                                                                                                                                                                        0.77647, -0.773308,
                                                                                                                                                                        0,
                                                                                                                                                                        0.634031, -0.630155,
                                                                                                                                                                        0,
                                                                                                                                                                        0.77647, -0.773308,
                                                                                                                                                                        0,
                                                                                                                                                                        0.634031, -0.773308,
                                                                                                                                                                        0,
                                                                                                                                                                        0.634031, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.773308,
                                                                                                                                                                        0,
                                                                                                                                                                        0.634031,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.960452,
                                                                                                                                                                        0,
                                                                                                                                                                        0.278446, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.960452,
                                                                                                                                                                        0,
                                                                                                                                                                        0.278446, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.960452,
                                                                                                                                                                        0,
                                                                                                                                                                        0.278446, -0.960452,
                                                                                                                                                                        0,
                                                                                                                                                                        0.278446, -0.996811,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079801, -0.960452,
                                                                                                                                                                        0,
                                                                                                                                                                        0.278446,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.73423,
                                                                                                                                                                        0,
                                                                                                                                                                        0.678901, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.95506,
                                                                                                                                                                        0, -0.296412, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.95506,
                                                                                                                                                                        0, -0.296412, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.95506,
                                                                                                                                                                        0, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.947749,
                                                                                                                                                                        0, -0.319018, -0.864329,
                                                                                                                                                                        0, -0.502928, -0.947749,
                                                                                                                                                                        0, -0.319018, -0.864329,
                                                                                                                                                                        0, -0.502928, -0.947749,
                                                                                                                                                                        0, -0.319018, -0.864329,
                                                                                                                                                                        0, -0.502928, -0.947749,
                                                                                                                                                                        0, -0.319018, -0.992518,
                                                                                                                                                                        0, -0.122098, -0.947749,
                                                                                                                                                                        0, -0.319018, -0.992518,
                                                                                                                                                                        0, -0.122098, -0.947749,
                                                                                                                                                                        0, -0.319018, -0.992518,
                                                                                                                                                                        0, -0.122098,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.996811,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079801, -0.992518,
                                                                                                                                                                        0, -0.122098, -0.996811,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079801, -0.992518,
                                                                                                                                                                        0, -0.122098, -0.996811,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079801, -0.992518,
                                                                                                                                                                        0, -0.122098, -0.996811,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079801, -0.960452,
                                                                                                                                                                        0,
                                                                                                                                                                        0.278446, -0.996811,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079801,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.975312,
                                                                                                                                                                        0,
                                                                                                                                                                        0.22083, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.95506,
                                                                                                                                                                        0, -0.296412, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.95506,
                                                                                                                                                                        0, -0.296412, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.95506,
                                                                                                                                                                        0, -0.296412, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.95506,
                                                                                                                                                                        0, -0.296412, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.95506,
                                                                                                                                                                        0, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.95506,
                                                                                                                                                                        0, -0.296412, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.95506,
                                                                                                                                                                        0, -0.296412, -0.999234,
                                                                                                                                                                        0, -0.039124, -0.95506,
                                                                                                                                                                        0, -0.296412,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.577256,
                                                                                                                                                                        0, -0.816563, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.8458,
                                                                                                                                                                        0, -0.533499, -0.678901,
                                                                                                                                                                        0, -0.73423, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.773308,
                                                                                                                                                                        0,
                                                                                                                                                                        0.634031, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.630155,
                                                                                                                                                                        0,
                                                                                                                                                                        0.77647, -0.461303,
                                                                                                                                                                        0,
                                                                                                                                                                        0.887243, -0.630155,
                                                                                                                                                                        0,
                                                                                                                                                                        0.77647,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312, -0.039124,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999234,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312,
                                                                                                                                                                        0.346245,
                                                                                                                                                                        0,
                                                                                                                                                                        0.938144,
                                                                                                                                                                        0.346245,
                                                                                                                                                                        0,
                                                                                                                                                                        0.938144,
                                                                                                                                                                        0.346245,
                                                                                                                                                                        0,
                                                                                                                                                                        0.938144,
                                                                                                                                                                        0.22083,
                                                                                                                                                                        0,
                                                                                                                                                                        0.975312, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.273638,
                                                                                                                                                                        0,
                                                                                                                                                                        0.961833, -0.074814,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997198, -0.273638,
                                                                                                                                                                        0,
                                                                                                                                                                        0.961833,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.074814,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997198,
                                                                                                                                                                        0.026258,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999655, -0.074814,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997198, -0.074814,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997198, -0.273638,
                                                                                                                                                                        0,
                                                                                                                                                                        0.961833, -0.074814,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997198, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.077806,
                                                                                                                                                                        0,
                                                                                                                                                                        0.996969, -0.077806,
                                                                                                                                                                        0,
                                                                                                                                                                        0.996969,
                                                                                                                                                                        0.02795,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999609,
                                                                                                                                                                        0.02795,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999609,
                                                                                                                                                                        0.02795,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999609, -0.077806,
                                                                                                                                                                        0,
                                                                                                                                                                        0.996969,
                                                                                                                                                                        0.02795,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999609,
                                                                                                                                                                        0.02795,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999609,
                                                                                                                                                                        0.237342,
                                                                                                                                                                        0,
                                                                                                                                                                        0.971426,
                                                                                                                                                                        0.237342,
                                                                                                                                                                        0,
                                                                                                                                                                        0.971426,
                                                                                                                                                                        0.237342,
                                                                                                                                                                        0,
                                                                                                                                                                        0.971426,
                                                                                                                                                                        0.02795,
                                                                                                                                                                        0,
                                                                                                                                                                        0.999609,
                                                                                                                                                                        0.237342,
                                                                                                                                                                        0,
                                                                                                                                                                        0.971426,
                                                                                                                                                                        0.237342,
                                                                                                                                                                        0,
                                                                                                                                                                        0.971426,
                                                                                                                                                                        0.43614,
                                                                                                                                                                        0,
                                                                                                                                                                        0.899879,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934, -0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0, -0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0, -0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0, -0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0, -0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0, -0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0, -0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0, -0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0, -0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0, -0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0, -0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0, -0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0, -0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0, -0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0, -0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0, -0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0, -0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0,
                                                                                                                                                                        0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0,
                                                                                                                                                                        0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0,
                                                                                                                                                                        0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0,
                                                                                                                                                                        0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0,
                                                                                                                                                                        0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0,
                                                                                                                                                                        0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0,
                                                                                                                                                                        0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0,
                                                                                                                                                                        0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0,
                                                                                                                                                                        0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0,
                                                                                                                                                                        0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0,
                                                                                                                                                                        0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0,
                                                                                                                                                                        0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0,
                                                                                                                                                                        0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0,
                                                                                                                                                                        0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0,
                                                                                                                                                                        0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0,
                                                                                                                                                                        0.96333,
                                                                                                                                                                        0.26832,
                                                                                                                                                                        0,
                                                                                                                                                                        0.96333,
                                                                                                                                                                        0.26832,
                                                                                                                                                                        0,
                                                                                                                                                                        0.96333,
                                                                                                                                                                        0.26832,
                                                                                                                                                                        0,
                                                                                                                                                                        0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0,
                                                                                                                                                                        0.234018,
                                                                                                                                                                        0.972232,
                                                                                                                                                                        0,
                                                                                                                                                                        0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.798641, -0.601807,
                                                                                                                                                                        0,
                                                                                                                                                                        0.798641, -0.601807,
                                                                                                                                                                        0,
                                                                                                                                                                        0.798641, -0.601807,
                                                                                                                                                                        0,
                                                                                                                                                                        0.979673, -0.200602,
                                                                                                                                                                        0,
                                                                                                                                                                        0.979673, -0.200602,
                                                                                                                                                                        0,
                                                                                                                                                                        0.979673, -0.200602,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.344445, -0.596597,
                                                                                                                                                                        0.724865, -0.344445, -0.596597,
                                                                                                                                                                        0.724865, -0.344445, -0.596597,
                                                                                                                                                                        0.724865, -0.344445, -0.596597,
                                                                                                                                                                        0.724865, -0.344445, -0.596597,
                                                                                                                                                                        0.724865, -0.344445, -0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.344445, -0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445, -0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445, -0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445, -0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445, -0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445, -0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865, -0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865, -0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865, -0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865, -0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865, -0.688891,
                                                                                                                                                                        0,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865, -0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865, -0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865,
                                                                                                                                                                        0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865, -0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865, -0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865, -0.344445,
                                                                                                                                                                        0.596597,
                                                                                                                                                                        0.724865, -0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0, -0.650791,
                                                                                                                                                                        0.759257,
                                                                                                                                                                        0, -0.45504,
                                                                                                                                                                        0.890471,
                                                                                                                                                                        0, -0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0, -0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0, -0.8104,
                                                                                                                                                                        0.585877,
                                                                                                                                                                        0, -0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0, -0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0, -0.96333,
                                                                                                                                                                        0.26832,
                                                                                                                                                                        0, -0.96333,
                                                                                                                                                                        0.26832,
                                                                                                                                                                        0, -0.96333,
                                                                                                                                                                        0.26832,
                                                                                                                                                                        0, -0.925003,
                                                                                                                                                                        0.37996,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755,
                                                                                                                                                                        0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755,
                                                                                                                                                                        0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755,
                                                                                                                                                                        0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755,
                                                                                                                                                                        0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755,
                                                                                                                                                                        0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755, -0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281, -0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281, -0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281, -0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281, -0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281, -0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0, -0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0, -0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0, -0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0, -0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0, -0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0, -0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1, -0.884924,
                                                                                                                                                                        0, -0.465735, -0.884924,
                                                                                                                                                                        0, -0.465735, -0.884924,
                                                                                                                                                                        0, -0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032,
                                                                                                                                                                        0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032,
                                                                                                                                                                        0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032,
                                                                                                                                                                        0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032,
                                                                                                                                                                        0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032,
                                                                                                                                                                        0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032,
                                                                                                                                                                        0.988983,
                                                                                                                                                                        0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281,
                                                                                                                                                                        0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281,
                                                                                                                                                                        0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745,
                                                                                                                                                                        0.996815,
                                                                                                                                                                        0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281,
                                                                                                                                                                        0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281,
                                                                                                                                                                        0.81756,
                                                                                                                                                                        0.382692,
                                                                                                                                                                        0.430281,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.884924,
                                                                                                                                                                        0, -0.465735, -0.884924,
                                                                                                                                                                        0, -0.465735, -0.884924,
                                                                                                                                                                        0, -0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032, -0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032, -0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032, -0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032, -0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032, -0.988983,
                                                                                                                                                                        0,
                                                                                                                                                                        0.148032, -0.988983, -0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755, -0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755, -0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755, -0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755, -0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755, -0.869761,
                                                                                                                                                                        0.184325,
                                                                                                                                                                        0.457755,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745, -0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745, -0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745, -0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745, -0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745, -0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        0.079745, -0.996815,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217, -0.501624,
                                                                                                                                                                        0.20778,
                                                                                                                                                                        0.839762, -0.501624,
                                                                                                                                                                        0.20778,
                                                                                                                                                                        0.839762, -0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879, -0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879, -0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879, -0.501624,
                                                                                                                                                                        0.20778,
                                                                                                                                                                        0.839762, -0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879, -0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879, -0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879, -0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879, -0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879, -0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879, -0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879, -0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879, -0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879, -0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879, -0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879, -0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879, -0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879, -0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879, -0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879, -0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879, -0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879, -0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879, -0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879, -0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0.841879, -0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277, -0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277, -0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277, -0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277, -0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277, -0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365, -0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365, -0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365, -0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277, -0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365, -0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365, -0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602, -0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602, -0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602, -0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365, -0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602, -0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602, -0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833, -0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833, -0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833, -0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602, -0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833, -0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833, -0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676, -0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676, -0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676, -0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.269833, -0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676, -0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676, -0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0, -0.539666,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0, -0.539666,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0, -0.539666,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676, -0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0, -0.539666,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0, -0.539666,
                                                                                                                                                                        0.841879, -0.139676, -0.521277,
                                                                                                                                                                        0.841879, -0.139676, -0.521277,
                                                                                                                                                                        0.841879, -0.139676, -0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0, -0.539666,
                                                                                                                                                                        0.841879, -0.139676, -0.521277,
                                                                                                                                                                        0.841879, -0.269833, -0.467365,
                                                                                                                                                                        0.841879, -0.139676, -0.521277,
                                                                                                                                                                        0.841879, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.991445,
                                                                                                                                                                        0.130526,
                                                                                                                                                                        0, -0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928, -0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928, -0.991445,
                                                                                                                                                                        0.130526,
                                                                                                                                                                        0, -0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928, -0.991445,
                                                                                                                                                                        0.130526,
                                                                                                                                                                        0, -0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928, -0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928, -0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548, -0.59524,
                                                                                                                                                                        0,
                                                                                                                                                                        0.803548, -0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548, -0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928, -0.59524,
                                                                                                                                                                        0,
                                                                                                                                                                        0.803548, -0.574958, -0.154059,
                                                                                                                                                                        0.803548, -0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548, -0.59524,
                                                                                                                                                                        0,
                                                                                                                                                                        0.803548, -0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928, -0.574958, -0.154059,
                                                                                                                                                                        0.803548, -0.918364, -0.246075,
                                                                                                                                                                        0.309928, -0.574958, -0.154059,
                                                                                                                                                                        0.803548, -0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928, -0.574958, -0.154059,
                                                                                                                                                                        0.803548, -0.918364, -0.246075,
                                                                                                                                                                        0.309928, -0.515493, -0.29762,
                                                                                                                                                                        0.803548, -0.823382, -0.47538,
                                                                                                                                                                        0.309928, -0.515493, -0.29762,
                                                                                                                                                                        0.803548, -0.918364, -0.246075,
                                                                                                                                                                        0.309928, -0.515493, -0.29762,
                                                                                                                                                                        0.803548, -0.823382, -0.47538,
                                                                                                                                                                        0.309928, -0.420898, -0.420898,
                                                                                                                                                                        0.803548, -0.515493, -0.29762,
                                                                                                                                                                        0.803548, -0.420898, -0.420898,
                                                                                                                                                                        0.803548, -0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548, -0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548, -0.420898, -0.420898,
                                                                                                                                                                        0.803548, -0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548, -0.420898, -0.420898,
                                                                                                                                                                        0.803548, -0.29762, -0.515493,
                                                                                                                                                                        0.803548, -0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548, -0.29762, -0.515493,
                                                                                                                                                                        0.803548, -0.420898, -0.420898,
                                                                                                                                                                        0.803548, -0.47538, -0.823382,
                                                                                                                                                                        0.309928, -0.47538, -0.823382,
                                                                                                                                                                        0.309928, -0.246075, -0.918364,
                                                                                                                                                                        0.309928, -0.29762, -0.515493,
                                                                                                                                                                        0.803548, -0.154059, -0.574958,
                                                                                                                                                                        0.803548, -0.29762, -0.515493,
                                                                                                                                                                        0.803548, -0.246075, -0.918364,
                                                                                                                                                                        0.309928, -0.29762, -0.515493,
                                                                                                                                                                        0.803548, -0.154059, -0.574958,
                                                                                                                                                                        0.803548, -0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548, -0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548, -0.154059, -0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0.803548, -0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0.803548, -0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928, -0.246075,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.309928, -0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928, -0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548, -0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548, -0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548, -0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928, -0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548, -0.29762, -0.515493,
                                                                                                                                                                        0.803548, -0.154059,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.803548, -0.47538,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.309928, -0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928, -0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548, -0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548, -0.29762,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.803548, -0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928, -0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928, -0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928, -0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548, -0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928, -0.793353,
                                                                                                                                                                        0.608761,
                                                                                                                                                                        0, -0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928, -0.793353,
                                                                                                                                                                        0.608761,
                                                                                                                                                                        0, -0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.836256, -0.258745,
                                                                                                                                                                        0.483454,
                                                                                                                                                                        0.686105, -0.238846,
                                                                                                                                                                        0.687177,
                                                                                                                                                                        0.836256, -0.258745,
                                                                                                                                                                        0.483454,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.836256, -0.258745,
                                                                                                                                                                        0.483454,
                                                                                                                                                                        0.686105, -0.238846,
                                                                                                                                                                        0.687177,
                                                                                                                                                                        0.555959, -0.766064,
                                                                                                                                                                        0.322575,
                                                                                                                                                                        0.47267, -0.741834,
                                                                                                                                                                        0.475673,
                                                                                                                                                                        0.555959, -0.766064,
                                                                                                                                                                        0.322575,
                                                                                                                                                                        0.686105, -0.238846,
                                                                                                                                                                        0.687177,
                                                                                                                                                                        0.47267, -0.741834,
                                                                                                                                                                        0.475673,
                                                                                                                                                                        0.262628, -0.927456,
                                                                                                                                                                        0.266181,
                                                                                                                                                                        0.555959, -0.766064,
                                                                                                                                                                        0.322575,
                                                                                                                                                                        0.262628, -0.927456,
                                                                                                                                                                        0.266181,
                                                                                                                                                                        0.47267, -0.741834,
                                                                                                                                                                        0.475673,
                                                                                                                                                                        0.207842, -0.906444,
                                                                                                                                                                        0.367642,
                                                                                                                                                                        0.352407, -0.704281,
                                                                                                                                                                        0.616278,
                                                                                                                                                                        0.207842, -0.906444,
                                                                                                                                                                        0.367642,
                                                                                                                                                                        0.47267, -0.741834,
                                                                                                                                                                        0.475673,
                                                                                                                                                                        0.207842, -0.906444,
                                                                                                                                                                        0.367642,
                                                                                                                                                                        0.352407, -0.704281,
                                                                                                                                                                        0.616278,
                                                                                                                                                                        0.122551, -0.869249,
                                                                                                                                                                        0.478944,
                                                                                                                                                                        0.193158, -0.64901,
                                                                                                                                                                        0.73585,
                                                                                                                                                                        0.122551, -0.869249,
                                                                                                                                                                        0.478944,
                                                                                                                                                                        0.352407, -0.704281,
                                                                                                                                                                        0.616278,
                                                                                                                                                                        0.122551, -0.869249,
                                                                                                                                                                        0.478944,
                                                                                                                                                                        0.193158, -0.64901,
                                                                                                                                                                        0.73585,
                                                                                                                                                                        0.035258, -0.825223,
                                                                                                                                                                        0.563705,
                                                                                                                                                                        0.051572, -0.593163,
                                                                                                                                                                        0.803429,
                                                                                                                                                                        0.035258, -0.825223,
                                                                                                                                                                        0.563705,
                                                                                                                                                                        0.193158, -0.64901,
                                                                                                                                                                        0.73585,
                                                                                                                                                                        0.051572, -0.593163,
                                                                                                                                                                        0.803429, -0.051572, -0.593163,
                                                                                                                                                                        0.803429,
                                                                                                                                                                        0.035258, -0.825223,
                                                                                                                                                                        0.563705, -0.051572, -0.593163,
                                                                                                                                                                        0.803429,
                                                                                                                                                                        0.051572, -0.593163,
                                                                                                                                                                        0.803429, -0.064491, -0.148958,
                                                                                                                                                                        0.986738,
                                                                                                                                                                        0.064491, -0.148958,
                                                                                                                                                                        0.986738, -0.064491, -0.148958,
                                                                                                                                                                        0.986738,
                                                                                                                                                                        0.051572, -0.593163,
                                                                                                                                                                        0.803429,
                                                                                                                                                                        0.064491, -0.148958,
                                                                                                                                                                        0.986738,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.064491, -0.148958,
                                                                                                                                                                        0.986738,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.064491, -0.148958,
                                                                                                                                                                        0.986738,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.253873, -0.177627,
                                                                                                                                                                        0.950788,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.064491, -0.148958,
                                                                                                                                                                        0.986738,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.253873, -0.177627,
                                                                                                                                                                        0.950788,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.48794, -0.211478,
                                                                                                                                                                        0.846872,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.253873, -0.177627,
                                                                                                                                                                        0.950788,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.48794, -0.211478,
                                                                                                                                                                        0.846872,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.686105, -0.238846,
                                                                                                                                                                        0.687177,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.48794, -0.211478,
                                                                                                                                                                        0.846872,
                                                                                                                                                                        0.686105, -0.238846,
                                                                                                                                                                        0.687177,
                                                                                                                                                                        0.48794, -0.211478,
                                                                                                                                                                        0.846872,
                                                                                                                                                                        0.47267, -0.741834,
                                                                                                                                                                        0.475673,
                                                                                                                                                                        0.352407, -0.704281,
                                                                                                                                                                        0.616278,
                                                                                                                                                                        0.47267, -0.741834,
                                                                                                                                                                        0.475673,
                                                                                                                                                                        0.48794, -0.211478,
                                                                                                                                                                        0.846872,
                                                                                                                                                                        0.48794, -0.211478,
                                                                                                                                                                        0.846872,
                                                                                                                                                                        0.253873, -0.177627,
                                                                                                                                                                        0.950788,
                                                                                                                                                                        0.352407, -0.704281,
                                                                                                                                                                        0.616278,
                                                                                                                                                                        0.193158, -0.64901,
                                                                                                                                                                        0.73585,
                                                                                                                                                                        0.352407, -0.704281,
                                                                                                                                                                        0.616278,
                                                                                                                                                                        0.253873, -0.177627,
                                                                                                                                                                        0.950788,
                                                                                                                                                                        0.253873, -0.177627,
                                                                                                                                                                        0.950788,
                                                                                                                                                                        0.064491, -0.148958,
                                                                                                                                                                        0.986738,
                                                                                                                                                                        0.193158, -0.64901,
                                                                                                                                                                        0.73585,
                                                                                                                                                                        0.051572, -0.593163,
                                                                                                                                                                        0.803429,
                                                                                                                                                                        0.193158, -0.64901,
                                                                                                                                                                        0.73585,
                                                                                                                                                                        0.064491, -0.148958,
                                                                                                                                                                        0.986738,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.686105, -0.238846,
                                                                                                                                                                        0.687177, -0.836256, -0.258745,
                                                                                                                                                                        0.483454, -0.686105, -0.238846,
                                                                                                                                                                        0.687177, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.686105, -0.238846,
                                                                                                                                                                        0.687177, -0.836256, -0.258745,
                                                                                                                                                                        0.483454, -0.47267, -0.741834,
                                                                                                                                                                        0.475673, -0.555959, -0.766064,
                                                                                                                                                                        0.322575, -0.47267, -0.741834,
                                                                                                                                                                        0.475673, -0.836256, -0.258745,
                                                                                                                                                                        0.483454, -0.47267, -0.741834,
                                                                                                                                                                        0.475673, -0.555959, -0.766064,
                                                                                                                                                                        0.322575, -0.262628, -0.927456,
                                                                                                                                                                        0.266181, -0.296456, -0.939263,
                                                                                                                                                                        0.172912, -0.262628, -0.927456,
                                                                                                                                                                        0.266181, -0.555959, -0.766064,
                                                                                                                                                                        0.322575, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.773258, -0.450293,
                                                                                                                                                                        0.44644, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293,
                                                                                                                                                                        0.44644, -0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095, -0.773258, -0.450293,
                                                                                                                                                                        0.44644, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.773258, -0.450293,
                                                                                                                                                                        0.44644, -0.314879, -0.945308,
                                                                                                                                                                        0.085112, -0.296456, -0.939263,
                                                                                                                                                                        0.172912, -0.604708, -0.779645,
                                                                                                                                                                        0.162734, -0.555959, -0.766064,
                                                                                                                                                                        0.322575, -0.604708, -0.779645,
                                                                                                                                                                        0.162734, -0.296456, -0.939263,
                                                                                                                                                                        0.172912, -0.604708, -0.779645,
                                                                                                                                                                        0.162734, -0.555959, -0.766064,
                                                                                                                                                                        0.322575, -0.92977, -0.270761,
                                                                                                                                                                        0.249434, -0.836256, -0.258745,
                                                                                                                                                                        0.483454, -0.92977, -0.270761,
                                                                                                                                                                        0.249434, -0.555959, -0.766064,
                                                                                                                                                                        0.322575, -0.92977, -0.270761,
                                                                                                                                                                        0.249434, -0.836256, -0.258745,
                                                                                                                                                                        0.483454, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.836256, -0.258745,
                                                                                                                                                                        0.483454, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.92977, -0.270761,
                                                                                                                                                                        0.249434, -0.961509, -0.274772,
                                                                                                                                                                        0, -0.92977, -0.270761,
                                                                                                                                                                        0.249434, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.92977, -0.270761,
                                                                                                                                                                        0.249434, -0.961509, -0.274772,
                                                                                                                                                                        0, -0.604708, -0.779645,
                                                                                                                                                                        0.162734, -0.620736, -0.78402,
                                                                                                                                                                        0, -0.604708, -0.779645,
                                                                                                                                                                        0.162734, -0.961509, -0.274772,
                                                                                                                                                                        0, -0.620736, -0.78402,
                                                                                                                                                                        0, -0.32073, -0.947171,
                                                                                                                                                                        0, -0.604708, -0.779645,
                                                                                                                                                                        0.162734, -0.32073, -0.947171,
                                                                                                                                                                        0, -0.620736, -0.78402,
                                                                                                                                                                        0, -0.314879, -0.945308, -0.085112, -0.604708, -0.779645, -0.162734, -0.314879, -0.945308, -0.085112, -0.620736, -0.78402,
                                                                                                                                                                        0, -0.314879, -0.945308, -0.085112, -0.604708, -0.779645, -0.162734, -0.296456, -0.939263, -0.172912, -0.555959, -0.766064, -0.322575, -0.296456, -0.939263, -0.172912, -0.604708, -0.779645, -0.162734, -0.296456, -0.939263, -0.172912, -0.555959, -0.766064, -0.322575, -0.262628, -0.927456, -0.266181, -0.47267, -0.741834, -0.475673, -0.262628, -0.927456, -0.266181, -0.555959, -0.766064, -0.322575, -0.262628, -0.927456, -0.266181, -0.47267, -0.741834, -0.475673, -0.207842, -0.906444, -0.367642, -0.352407, -0.704281, -0.616278, -0.207842, -0.906444, -0.367642, -0.47267, -0.741834, -0.475673, -0.207842, -0.906444, -0.367642, -0.352407, -0.704281, -0.616278, -0.122551, -0.869249, -0.478944, -0.193158, -0.64901, -0.73585, -0.122551, -0.869249, -0.478944, -0.352407, -0.704281, -0.616278, -0.122551, -0.869249, -0.478944, -0.193158, -0.64901, -0.73585, -0.035258, -0.825223, -0.563705, -0.051572, -0.593163, -0.803429, -0.035258, -0.825223, -0.563705, -0.193158, -0.64901, -0.73585, -0.051572, -0.593163, -0.803429,
                                                                                                                                                                        0.051572, -0.593163, -0.803429, -0.035258, -0.825223, -0.563705, -0.051572, -0.593163, -0.803429, -0.064491, -0.148958, -0.986738,
                                                                                                                                                                        0.051572, -0.593163, -0.803429, -0.051572, -0.593163, -0.803429, -0.193158, -0.64901, -0.73585, -0.064491, -0.148958, -0.986738, -0.253873, -0.177627, -0.950788, -0.064491, -0.148958, -0.986738, -0.193158, -0.64901, -0.73585, -0.253873, -0.177627, -0.950788, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.064491, -0.148958, -0.986738, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.253873, -0.177627, -0.950788, -0.5,
                                                                                                                                                                        0, -0.866025, -0.48794, -0.211478, -0.846872, -0.5,
                                                                                                                                                                        0, -0.866025, -0.253873, -0.177627, -0.950788, -0.5,
                                                                                                                                                                        0, -0.866025, -0.48794, -0.211478, -0.846872, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.686105, -0.238846, -0.687177, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.48794, -0.211478, -0.846872, -0.686105, -0.238846, -0.687177, -0.836256, -0.258745, -0.483454, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.836256, -0.258745, -0.483454, -0.686105, -0.238846, -0.687177, -0.555959, -0.766064, -0.322575, -0.47267, -0.741834, -0.475673, -0.555959, -0.766064, -0.322575, -0.686105, -0.238846, -0.687177, -0.686105, -0.238846, -0.687177, -0.48794, -0.211478, -0.846872, -0.47267, -0.741834, -0.475673, -0.352407, -0.704281, -0.616278, -0.47267, -0.741834, -0.475673, -0.48794, -0.211478, -0.846872, -0.48794, -0.211478, -0.846872, -0.253873, -0.177627, -0.950788, -0.352407, -0.704281, -0.616278, -0.193158, -0.64901, -0.73585, -0.352407, -0.704281, -0.616278, -0.253873, -0.177627, -0.950788, -0.555959, -0.766064, -0.322575, -0.604708, -0.779645, -0.162734, -0.836256, -0.258745, -0.483454, -0.92977, -0.270761, -0.249434, -0.836256, -0.258745, -0.483454, -0.604708, -0.779645, -0.162734, -0.836256, -0.258745, -0.483454, -0.92977, -0.270761, -0.249434, -0.866025,
                                                                                                                                                                        0, -0.5, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.866025,
                                                                                                                                                                        0, -0.5, -0.92977, -0.270761, -0.249434,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0.539666,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0.238713,
                                                                                                                                                                        0.413463, -0.878672,
                                                                                                                                                                        0.238713,
                                                                                                                                                                        0.413463, -0.878672,
                                                                                                                                                                        0.123567,
                                                                                                                                                                        0.461158, -0.878672,
                                                                                                                                                                        0.238713,
                                                                                                                                                                        0.413463, -0.878672,
                                                                                                                                                                        0.238713,
                                                                                                                                                                        0.413463, -0.878672,
                                                                                                                                                                        0.337591,
                                                                                                                                                                        0.337591, -0.878672,
                                                                                                                                                                        0.337591,
                                                                                                                                                                        0.337591, -0.878672,
                                                                                                                                                                        0.337591,
                                                                                                                                                                        0.337591, -0.878672,
                                                                                                                                                                        0.238713,
                                                                                                                                                                        0.413463, -0.878672,
                                                                                                                                                                        0.337591,
                                                                                                                                                                        0.337591, -0.878672,
                                                                                                                                                                        0.337591,
                                                                                                                                                                        0.337591, -0.878672,
                                                                                                                                                                        0.413463,
                                                                                                                                                                        0.238713, -0.878672,
                                                                                                                                                                        0.413463,
                                                                                                                                                                        0.238713, -0.878672,
                                                                                                                                                                        0.413463,
                                                                                                                                                                        0.238713, -0.878672,
                                                                                                                                                                        0.337591,
                                                                                                                                                                        0.337591, -0.878672,
                                                                                                                                                                        0.413463,
                                                                                                                                                                        0.238713, -0.878672,
                                                                                                                                                                        0.413463,
                                                                                                                                                                        0.238713, -0.878672,
                                                                                                                                                                        0.461158,
                                                                                                                                                                        0.123567, -0.878672,
                                                                                                                                                                        0.461158,
                                                                                                                                                                        0.123567, -0.878672,
                                                                                                                                                                        0.461158,
                                                                                                                                                                        0.123567, -0.878672,
                                                                                                                                                                        0.413463,
                                                                                                                                                                        0.238713, -0.878672,
                                                                                                                                                                        0.461158,
                                                                                                                                                                        0.123567, -0.878672,
                                                                                                                                                                        0.461158,
                                                                                                                                                                        0.123567, -0.878672,
                                                                                                                                                                        0.477426,
                                                                                                                                                                        0, -0.878672,
                                                                                                                                                                        0.477426,
                                                                                                                                                                        0, -0.878672,
                                                                                                                                                                        0.477426,
                                                                                                                                                                        0, -0.878672,
                                                                                                                                                                        0.461158,
                                                                                                                                                                        0.123567, -0.878672,
                                                                                                                                                                        0.477426,
                                                                                                                                                                        0, -0.878672,
                                                                                                                                                                        0.461158, -0.123567, -0.878672,
                                                                                                                                                                        0.477426,
                                                                                                                                                                        0, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.381602,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.467365,
                                                                                                                                                                        0.269833,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.521277,
                                                                                                                                                                        0.139676,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0.337591, -0.337591, -0.878672,
                                                                                                                                                                        0.238713, -0.413463, -0.878672,
                                                                                                                                                                        0.337591, -0.337591, -0.878672,
                                                                                                                                                                        0.238713, -0.413463, -0.878672,
                                                                                                                                                                        0.337591, -0.337591, -0.878672,
                                                                                                                                                                        0.238713, -0.413463, -0.878672,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.123567, -0.461158, -0.878672,
                                                                                                                                                                        0.238713, -0.413463, -0.878672,
                                                                                                                                                                        0.123567, -0.461158, -0.878672,
                                                                                                                                                                        0.238713, -0.413463, -0.878672,
                                                                                                                                                                        0.123567, -0.461158, -0.878672,
                                                                                                                                                                        0.238713, -0.413463, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0.123567, -0.461158, -0.878672,
                                                                                                                                                                        0, -0.477426, -0.878672,
                                                                                                                                                                        0.123567, -0.461158, -0.878672,
                                                                                                                                                                        0, -0.477426, -0.878672,
                                                                                                                                                                        0.123567, -0.461158, -0.878672,
                                                                                                                                                                        0, -0.477426, -0.878672,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.5, -0.866025,
                                                                                                                                                                        0, -0.429238, -0.743462, -0.512854, -0.5, -0.866025,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.5, -0.866025,
                                                                                                                                                                        0, -0.429238, -0.743462, -0.512854, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.607034, -0.607034, -0.512854, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.429238, -0.743462, -0.512854, -0.607034, -0.607034, -0.512854, -0.866025, -0.5,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.607034, -0.607034, -0.512854, -0.337591, -0.337591, -0.878672, -0.413463, -0.238713, -0.878672, -0.337591, -0.337591, -0.878672, -0.607034, -0.607034, -0.512854, -0.292569, -0.381283, -0.876942, -0.607034, -0.607034, -0.512854, -0.523782, -0.682606, -0.509609, -0.292569, -0.381283, -0.876942, -0.523782, -0.682606, -0.509609, -0.607034, -0.607034, -0.512854, -0.429238, -0.743462, -0.512854, -0.429238, -0.743462, -0.512854, -0.238713, -0.413463, -0.878672, -0.523782, -0.682606, -0.509609, -0.238713, -0.413463, -0.878672, -0.429238, -0.743462, -0.512854, -0.123567, -0.461158, -0.878672, -0.123567, -0.461158, -0.878672, -0.123567, -0.461158, -0.878672, -0.429238, -0.743462, -0.512854, -0.123567, -0.461158, -0.878672, -0.123567, -0.461158, -0.878672,
                                                                                                                                                                        0, -0.477426, -0.878672,
                                                                                                                                                                        0, -0.477426, -0.878672,
                                                                                                                                                                        0, -0.477426, -0.878672, -0.123567, -0.461158, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1, -0.33053, -0.430755,
                                                                                                                                                                        0.839762, -0.269833, -0.467365,
                                                                                                                                                                        0.841879, -0.33053, -0.430755,
                                                                                                                                                                        0.839762, -0.269833, -0.467365,
                                                                                                                                                                        0.841879, -0.33053, -0.430755,
                                                                                                                                                                        0.839762, -0.269833, -0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.836256, -0.258745, -0.483454,
                                                                                                                                                                        0.92977, -0.270761, -0.249434,
                                                                                                                                                                        0.836256, -0.258745, -0.483454,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.836256, -0.258745, -0.483454,
                                                                                                                                                                        0.92977, -0.270761, -0.249434,
                                                                                                                                                                        0.555959, -0.766064, -0.322575,
                                                                                                                                                                        0.604708, -0.779645, -0.162734,
                                                                                                                                                                        0.555959, -0.766064, -0.322575,
                                                                                                                                                                        0.92977, -0.270761, -0.249434,
                                                                                                                                                                        0.555959, -0.766064, -0.322575,
                                                                                                                                                                        0.604708, -0.779645, -0.162734,
                                                                                                                                                                        0.296456, -0.939263, -0.172912,
                                                                                                                                                                        0.314879, -0.945308, -0.085112,
                                                                                                                                                                        0.296456, -0.939263, -0.172912,
                                                                                                                                                                        0.604708, -0.779645, -0.162734,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293, -0.231095, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293, -0.231095, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.892881, -0.450293,
                                                                                                                                                                        0, -0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293, -0.231095, -0.892881, -0.450293,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.773258, -0.450293,
                                                                                                                                                                        0.44644, -0.862457, -0.450293,
                                                                                                                                                                        0.231095, -0.773258, -0.450293,
                                                                                                                                                                        0.44644, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.773258, -0.450293,
                                                                                                                                                                        0.44644, -0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095, -0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.892881, -0.450293,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0.32073, -0.947171,
                                                                                                                                                                        0,
                                                                                                                                                                        0.314879, -0.945308, -0.085112,
                                                                                                                                                                        0.620736, -0.78402,
                                                                                                                                                                        0,
                                                                                                                                                                        0.604708, -0.779645, -0.162734,
                                                                                                                                                                        0.620736, -0.78402,
                                                                                                                                                                        0,
                                                                                                                                                                        0.314879, -0.945308, -0.085112,
                                                                                                                                                                        0.620736, -0.78402,
                                                                                                                                                                        0,
                                                                                                                                                                        0.604708, -0.779645, -0.162734,
                                                                                                                                                                        0.961509, -0.274772,
                                                                                                                                                                        0,
                                                                                                                                                                        0.92977, -0.270761, -0.249434,
                                                                                                                                                                        0.961509, -0.274772,
                                                                                                                                                                        0,
                                                                                                                                                                        0.604708, -0.779645, -0.162734,
                                                                                                                                                                        0.961509, -0.274772,
                                                                                                                                                                        0,
                                                                                                                                                                        0.92977, -0.270761, -0.249434,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.92977, -0.270761, -0.249434,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.805112,
                                                                                                                                                                        0,
                                                                                                                                                                        0.593122,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.961509, -0.274772,
                                                                                                                                                                        0,
                                                                                                                                                                        0.92977, -0.270761,
                                                                                                                                                                        0.249434,
                                                                                                                                                                        0.961509, -0.274772,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.961509, -0.274772,
                                                                                                                                                                        0,
                                                                                                                                                                        0.92977, -0.270761,
                                                                                                                                                                        0.249434,
                                                                                                                                                                        0.620736, -0.78402,
                                                                                                                                                                        0,
                                                                                                                                                                        0.604708, -0.779645,
                                                                                                                                                                        0.162734,
                                                                                                                                                                        0.620736, -0.78402,
                                                                                                                                                                        0,
                                                                                                                                                                        0.92977, -0.270761,
                                                                                                                                                                        0.249434,
                                                                                                                                                                        0.604708, -0.779645,
                                                                                                                                                                        0.162734,
                                                                                                                                                                        0.314879, -0.945308,
                                                                                                                                                                        0.085112,
                                                                                                                                                                        0.620736, -0.78402,
                                                                                                                                                                        0,
                                                                                                                                                                        0.314879, -0.945308,
                                                                                                                                                                        0.085112,
                                                                                                                                                                        0.604708, -0.779645,
                                                                                                                                                                        0.162734,
                                                                                                                                                                        0.296456, -0.939263,
                                                                                                                                                                        0.172912,
                                                                                                                                                                        0.555959, -0.766064,
                                                                                                                                                                        0.322575,
                                                                                                                                                                        0.296456, -0.939263,
                                                                                                                                                                        0.172912,
                                                                                                                                                                        0.604708, -0.779645,
                                                                                                                                                                        0.162734,
                                                                                                                                                                        0.296456, -0.939263,
                                                                                                                                                                        0.172912,
                                                                                                                                                                        0.555959, -0.766064,
                                                                                                                                                                        0.322575,
                                                                                                                                                                        0.262628, -0.927456,
                                                                                                                                                                        0.266181,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.5,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.866025, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.5,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.866025, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.5,
                                                                                                                                                                        0, -0.866025, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859, -0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.773258, -0.450293,
                                                                                                                                                                        0.44644, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.5,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.866025, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.5,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.866025, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.5,
                                                                                                                                                                        0, -0.866025, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.866025,
                                                                                                                                                                        0, -0.5, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.866025,
                                                                                                                                                                        0, -0.5, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.866025,
                                                                                                                                                                        0, -0.5, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.866025,
                                                                                                                                                                        0, -0.5, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0, -0.5, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.866025,
                                                                                                                                                                        0, -0.5, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.866025,
                                                                                                                                                                        0, -0.5, -0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0.32073, -0.947171,
                                                                                                                                                                        0,
                                                                                                                                                                        0.620736, -0.78402,
                                                                                                                                                                        0,
                                                                                                                                                                        0.314879, -0.945308,
                                                                                                                                                                        0.085112,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.862457, -0.450293,
                                                                                                                                                                        0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644, -0.866025,
                                                                                                                                                                        0, -0.5, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.866025,
                                                                                                                                                                        0, -0.5, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.866025,
                                                                                                                                                                        0, -0.5, -0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.058473, -0.447981,
                                                                                                                                                                        0.892129, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.058473, -0.447981,
                                                                                                                                                                        0.892129, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.5,
                                                                                                                                                                        0, -0.866025, -0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0.773258, -0.450293,
                                                                                                                                                                        0.44644,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.058473, -0.447981,
                                                                                                                                                                        0.892129, -0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.058473, -0.447981,
                                                                                                                                                                        0.892129, -0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.058473, -0.447981,
                                                                                                                                                                        0.892129, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457, -0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.44644, -0.450293,
                                                                                                                                                                        0.773258, -0.058473, -0.447981,
                                                                                                                                                                        0.892129, -0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0.058473, -0.447981,
                                                                                                                                                                        0.892129, -0.058473, -0.447981,
                                                                                                                                                                        0.892129,
                                                                                                                                                                        0.231095, -0.450293,
                                                                                                                                                                        0.862457,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.035258, -0.825223,
                                                                                                                                                                        0.563705,
                                                                                                                                                                        0.035258, -0.825223,
                                                                                                                                                                        0.563705, -0.051572, -0.593163,
                                                                                                                                                                        0.803429, -0.051572, -0.593163,
                                                                                                                                                                        0.803429, -0.193158, -0.64901,
                                                                                                                                                                        0.73585, -0.035258, -0.825223,
                                                                                                                                                                        0.563705, -0.051572, -0.593163,
                                                                                                                                                                        0.803429, -0.064491, -0.148958,
                                                                                                                                                                        0.986738, -0.193158, -0.64901,
                                                                                                                                                                        0.73585, -0.253873, -0.177627,
                                                                                                                                                                        0.950788, -0.193158, -0.64901,
                                                                                                                                                                        0.73585, -0.064491, -0.148958,
                                                                                                                                                                        0.986738, -0.193158, -0.64901,
                                                                                                                                                                        0.73585, -0.253873, -0.177627,
                                                                                                                                                                        0.950788, -0.352407, -0.704281,
                                                                                                                                                                        0.616278, -0.48794, -0.211478,
                                                                                                                                                                        0.846872, -0.352407, -0.704281,
                                                                                                                                                                        0.616278, -0.253873, -0.177627,
                                                                                                                                                                        0.950788, -0.352407, -0.704281,
                                                                                                                                                                        0.616278, -0.48794, -0.211478,
                                                                                                                                                                        0.846872, -0.47267, -0.741834,
                                                                                                                                                                        0.475673, -0.686105, -0.238846,
                                                                                                                                                                        0.687177, -0.47267, -0.741834,
                                                                                                                                                                        0.475673, -0.48794, -0.211478,
                                                                                                                                                                        0.846872, -0.48794, -0.211478,
                                                                                                                                                                        0.846872, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.686105, -0.238846,
                                                                                                                                                                        0.687177, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.48794, -0.211478,
                                                                                                                                                                        0.846872, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.253873, -0.177627,
                                                                                                                                                                        0.950788, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.48794, -0.211478,
                                                                                                                                                                        0.846872, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.253873, -0.177627,
                                                                                                                                                                        0.950788, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.064491, -0.148958,
                                                                                                                                                                        0.986738, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.253873, -0.177627,
                                                                                                                                                                        0.950788, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.064491, -0.148958,
                                                                                                                                                                        0.986738,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.686105, -0.238846,
                                                                                                                                                                        0.687177, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.352407, -0.704281,
                                                                                                                                                                        0.616278, -0.47267, -0.741834,
                                                                                                                                                                        0.475673, -0.207842, -0.906444,
                                                                                                                                                                        0.367642, -0.262628, -0.927456,
                                                                                                                                                                        0.266181, -0.207842, -0.906444,
                                                                                                                                                                        0.367642, -0.47267, -0.741834,
                                                                                                                                                                        0.475673, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.631362, -0.450293,
                                                                                                                                                                        0.631362, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.207842, -0.906444,
                                                                                                                                                                        0.367642, -0.122551, -0.869249,
                                                                                                                                                                        0.478944, -0.352407, -0.704281,
                                                                                                                                                                        0.616278, -0.193158, -0.64901,
                                                                                                                                                                        0.73585, -0.352407, -0.704281,
                                                                                                                                                                        0.616278, -0.122551, -0.869249,
                                                                                                                                                                        0.478944, -0.122551, -0.869249,
                                                                                                                                                                        0.478944, -0.035258, -0.825223,
                                                                                                                                                                        0.563705, -0.193158, -0.64901,
                                                                                                                                                                        0.73585,
                                                                                                                                                                        0.555959, -0.766064,
                                                                                                                                                                        0.322575,
                                                                                                                                                                        0.604708, -0.779645,
                                                                                                                                                                        0.162734,
                                                                                                                                                                        0.836256, -0.258745,
                                                                                                                                                                        0.483454,
                                                                                                                                                                        0.92977, -0.270761,
                                                                                                                                                                        0.249434,
                                                                                                                                                                        0.836256, -0.258745,
                                                                                                                                                                        0.483454,
                                                                                                                                                                        0.604708, -0.779645,
                                                                                                                                                                        0.162734,
                                                                                                                                                                        0.836256, -0.258745,
                                                                                                                                                                        0.483454,
                                                                                                                                                                        0.92977, -0.270761,
                                                                                                                                                                        0.249434,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.92977, -0.270761,
                                                                                                                                                                        0.249434,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095, -0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.892881, -0.450293,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.862457, -0.450293,
                                                                                                                                                                        0.231095, -0.314879, -0.945308,
                                                                                                                                                                        0.085112, -0.604708, -0.779645,
                                                                                                                                                                        0.162734, -0.32073, -0.947171,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.892881, -0.450293,
                                                                                                                                                                        0, -0.862457, -0.450293, -0.231095, -0.892881, -0.450293,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.892881, -0.450293,
                                                                                                                                                                        0, -0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293, -0.231095, -0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293, -0.44644, -0.862457, -0.450293, -0.231095, -0.866025,
                                                                                                                                                                        0, -0.5, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.866025,
                                                                                                                                                                        0, -0.5, -0.862457, -0.450293, -0.231095, -0.866025,
                                                                                                                                                                        0, -0.5, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.773258, -0.450293, -0.44644, -0.631362, -0.450293, -0.631362, -0.773258, -0.450293, -0.44644, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.773258, -0.450293, -0.44644, -0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293, -0.631362, -0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293, -0.631362, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.44644, -0.450293, -0.773258, -0.5,
                                                                                                                                                                        0, -0.866025, -0.44644, -0.450293, -0.773258, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.44644, -0.450293, -0.773258, -0.5,
                                                                                                                                                                        0, -0.866025, -0.231095, -0.450293, -0.862457, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.231095, -0.450293, -0.862457, -0.5,
                                                                                                                                                                        0, -0.866025, -0.231095, -0.450293, -0.862457, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.058473, -0.447981, -0.892129, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.058473, -0.447981, -0.892129, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.058473, -0.447981, -0.892129, -0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.058473, -0.447981, -0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.058473, -0.447981, -0.892129, -0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.058473, -0.447981, -0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0.296456, -0.939263, -0.172912,
                                                                                                                                                                        0.262628, -0.927456, -0.266181,
                                                                                                                                                                        0.555959, -0.766064, -0.322575,
                                                                                                                                                                        0.47267, -0.741834, -0.475673,
                                                                                                                                                                        0.555959, -0.766064, -0.322575,
                                                                                                                                                                        0.262628, -0.927456, -0.266181,
                                                                                                                                                                        0.555959, -0.766064, -0.322575,
                                                                                                                                                                        0.47267, -0.741834, -0.475673,
                                                                                                                                                                        0.836256, -0.258745, -0.483454,
                                                                                                                                                                        0.686105, -0.238846, -0.687177,
                                                                                                                                                                        0.836256, -0.258745, -0.483454,
                                                                                                                                                                        0.47267, -0.741834, -0.475673,
                                                                                                                                                                        0.836256, -0.258745, -0.483454,
                                                                                                                                                                        0.686105, -0.238846, -0.687177,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.686105, -0.238846, -0.687177,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.686105, -0.238846, -0.687177,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.48794, -0.211478, -0.846872,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.686105, -0.238846, -0.687177,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.48794, -0.211478, -0.846872,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.253873, -0.177627, -0.950788,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.48794, -0.211478, -0.846872,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.253873, -0.177627, -0.950788,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.064491, -0.148958, -0.986738,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.253873, -0.177627, -0.950788,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.064491, -0.148958, -0.986738, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.064491, -0.148958, -0.986738, -0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.064491, -0.148958, -0.986738, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.064491, -0.148958, -0.986738, -0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.064491, -0.148958, -0.986738,
                                                                                                                                                                        0.051572, -0.593163, -0.803429, -0.064491, -0.148958, -0.986738,
                                                                                                                                                                        0.051572, -0.593163, -0.803429,
                                                                                                                                                                        0.064491, -0.148958, -0.986738,
                                                                                                                                                                        0.193158, -0.64901, -0.73585,
                                                                                                                                                                        0.253873, -0.177627, -0.950788,
                                                                                                                                                                        0.193158, -0.64901, -0.73585,
                                                                                                                                                                        0.064491, -0.148958, -0.986738,
                                                                                                                                                                        0.193158, -0.64901, -0.73585,
                                                                                                                                                                        0.253873, -0.177627, -0.950788,
                                                                                                                                                                        0.352407, -0.704281, -0.616278,
                                                                                                                                                                        0.48794, -0.211478, -0.846872,
                                                                                                                                                                        0.352407, -0.704281, -0.616278,
                                                                                                                                                                        0.253873, -0.177627, -0.950788,
                                                                                                                                                                        0.352407, -0.704281, -0.616278,
                                                                                                                                                                        0.48794, -0.211478, -0.846872,
                                                                                                                                                                        0.47267, -0.741834, -0.475673,
                                                                                                                                                                        0.686105, -0.238846, -0.687177,
                                                                                                                                                                        0.47267, -0.741834, -0.475673,
                                                                                                                                                                        0.48794, -0.211478, -0.846872,
                                                                                                                                                                        0.352407, -0.704281, -0.616278,
                                                                                                                                                                        0.47267, -0.741834, -0.475673,
                                                                                                                                                                        0.207842, -0.906444, -0.367642,
                                                                                                                                                                        0.262628, -0.927456, -0.266181,
                                                                                                                                                                        0.207842, -0.906444, -0.367642,
                                                                                                                                                                        0.47267, -0.741834, -0.475673,
                                                                                                                                                                        0.207842, -0.906444, -0.367642,
                                                                                                                                                                        0.122551, -0.869249, -0.478944,
                                                                                                                                                                        0.352407, -0.704281, -0.616278,
                                                                                                                                                                        0.193158, -0.64901, -0.73585,
                                                                                                                                                                        0.352407, -0.704281, -0.616278,
                                                                                                                                                                        0.122551, -0.869249, -0.478944,
                                                                                                                                                                        0.122551, -0.869249, -0.478944,
                                                                                                                                                                        0.035258, -0.825223, -0.563705,
                                                                                                                                                                        0.193158, -0.64901, -0.73585,
                                                                                                                                                                        0.051572, -0.593163, -0.803429,
                                                                                                                                                                        0.193158, -0.64901, -0.73585,
                                                                                                                                                                        0.035258, -0.825223, -0.563705,
                                                                                                                                                                        0.035258, -0.825223, -0.563705, -0.035258, -0.825223, -0.563705,
                                                                                                                                                                        0.051572, -0.593163, -0.803429,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0, -0.5, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.836256, -0.258745, -0.483454,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1, -0.461158,
                                                                                                                                                                        0.123567, -0.878672, -0.413463,
                                                                                                                                                                        0.238713, -0.878672, -0.461158,
                                                                                                                                                                        0.123567, -0.878672, -0.461158,
                                                                                                                                                                        0.123567, -0.878672, -0.413463,
                                                                                                                                                                        0.238713, -0.878672, -0.444014,
                                                                                                                                                                        0.183916, -0.876942, -0.413463,
                                                                                                                                                                        0.238713, -0.878672, -0.444014,
                                                                                                                                                                        0.183916, -0.876942, -0.413463,
                                                                                                                                                                        0.238713, -0.878672, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.92388,
                                                                                                                                                                        0.382683,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.238713,
                                                                                                                                                                        0.413463, -0.878672, -0.337591,
                                                                                                                                                                        0.337591, -0.878672, -0.238713,
                                                                                                                                                                        0.413463, -0.878672, -0.337591,
                                                                                                                                                                        0.337591, -0.878672, -0.238713,
                                                                                                                                                                        0.413463, -0.878672, -0.337591,
                                                                                                                                                                        0.337591, -0.878672, -0.413463,
                                                                                                                                                                        0.238713, -0.878672, -0.337591,
                                                                                                                                                                        0.337591, -0.878672, -0.413463,
                                                                                                                                                                        0.238713, -0.878672, -0.337591,
                                                                                                                                                                        0.337591, -0.878672, -0.413463,
                                                                                                                                                                        0.238713, -0.878672, -0.337591,
                                                                                                                                                                        0.337591, -0.878672, -0.238713,
                                                                                                                                                                        0.413463, -0.878672, -0.123567,
                                                                                                                                                                        0.461158, -0.878672, -0.238713,
                                                                                                                                                                        0.413463, -0.878672, -0.123567,
                                                                                                                                                                        0.461158, -0.878672, -0.238713,
                                                                                                                                                                        0.413463, -0.878672, -0.123567,
                                                                                                                                                                        0.461158, -0.878672, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.123567,
                                                                                                                                                                        0.461158, -0.878672, -0.123567,
                                                                                                                                                                        0.461158, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0.477426, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0.477426, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0.477426, -0.878672, -0.123567,
                                                                                                                                                                        0.461158, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0.477426, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0.477426, -0.878672,
                                                                                                                                                                        0.123567,
                                                                                                                                                                        0.461158, -0.878672,
                                                                                                                                                                        0.123567,
                                                                                                                                                                        0.461158, -0.878672,
                                                                                                                                                                        0.123567,
                                                                                                                                                                        0.461158, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0.477426, -0.878672,
                                                                                                                                                                        0.123567,
                                                                                                                                                                        0.461158, -0.878672,
                                                                                                                                                                        0.123567,
                                                                                                                                                                        0.461158, -0.878672,
                                                                                                                                                                        0.238713,
                                                                                                                                                                        0.413463, -0.878672,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.92388, -0.382683,
                                                                                                                                                                        0,
                                                                                                                                                                        0.92388, -0.382683,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.793353, -0.608761,
                                                                                                                                                                        0,
                                                                                                                                                                        0.793353, -0.608761,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.337591, -0.337591, -0.878672,
                                                                                                                                                                        0.413463, -0.238713, -0.878672,
                                                                                                                                                                        0.337591, -0.337591, -0.878672,
                                                                                                                                                                        0.413463, -0.238713, -0.878672,
                                                                                                                                                                        0.337591, -0.337591, -0.878672,
                                                                                                                                                                        0.413463, -0.238713, -0.878672,
                                                                                                                                                                        0.413463, -0.238713, -0.878672,
                                                                                                                                                                        0.461158, -0.123567, -0.878672,
                                                                                                                                                                        0.413463, -0.238713, -0.878672,
                                                                                                                                                                        0.461158, -0.123567, -0.878672,
                                                                                                                                                                        0.413463, -0.238713, -0.878672,
                                                                                                                                                                        0.461158, -0.123567, -0.878672,
                                                                                                                                                                        0.461158, -0.123567, -0.878672,
                                                                                                                                                                        0.477426,
                                                                                                                                                                        0, -0.878672,
                                                                                                                                                                        0.461158, -0.123567, -0.878672,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.92388,
                                                                                                                                                                        0.382683,
                                                                                                                                                                        0, -0.92388,
                                                                                                                                                                        0.382683,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.92388,
                                                                                                                                                                        0.382683,
                                                                                                                                                                        0, -0.92388,
                                                                                                                                                                        0.382683,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.92388,
                                                                                                                                                                        0.382683,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.92388, -0.382683,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.92388, -0.382683,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.413463, -0.238713, -0.878672, -0.413463, -0.238713, -0.878672, -0.461158, -0.123567, -0.878672, -0.413463, -0.238713, -0.878672, -0.413463, -0.238713, -0.878672, -0.337591, -0.337591, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1, -0.477426,
                                                                                                                                                                        0, -0.878672, -0.477426,
                                                                                                                                                                        0, -0.878672, -0.461158, -0.123567, -0.878672, -0.477426,
                                                                                                                                                                        0, -0.878672, -0.461158,
                                                                                                                                                                        0.123567, -0.878672, -0.477426,
                                                                                                                                                                        0, -0.878672, -0.461158,
                                                                                                                                                                        0.123567, -0.878672, -0.477426,
                                                                                                                                                                        0, -0.878672, -0.461158,
                                                                                                                                                                        0.123567, -0.878672, -0.461158, -0.123567, -0.878672, -0.461158, -0.123567, -0.878672, -0.477426,
                                                                                                                                                                        0, -0.878672, -0.461158, -0.123567, -0.878672, -0.461158, -0.123567, -0.878672, -0.413463, -0.238713, -0.878672,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1, -0.292569, -0.381283, -0.876942, -0.523782, -0.682606, -0.509609, -0.238713, -0.413463, -0.878672, -0.866025, -0.5,
                                                                                                                                                                        0, -0.793353, -0.608761,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.793353, -0.608761,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293, -0.44644, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293, -0.44644, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293, -0.44644, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.773258, -0.450293, -0.44644, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.862457, -0.450293, -0.231095, -0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293, -0.44644, -0.862457, -0.450293, -0.231095, -0.866025,
                                                                                                                                                                        0, -0.5, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.866025,
                                                                                                                                                                        0, -0.5, -0.862457, -0.450293, -0.231095,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.892881, -0.450293,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293, -0.631362, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.065403,
                                                                                                                                                                        0,
                                                                                                                                                                        0.997859, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293, -0.44644, -0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.631362, -0.450293, -0.631362, -0.773258, -0.450293, -0.44644, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.866025,
                                                                                                                                                                        0, -0.5, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.773258, -0.450293, -0.44644, -0.631362, -0.450293, -0.631362, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.44644, -0.450293, -0.773258, -0.5,
                                                                                                                                                                        0, -0.866025, -0.44644, -0.450293, -0.773258, -0.707107,
                                                                                                                                                                        0, -0.707107, -0.44644, -0.450293, -0.773258, -0.5,
                                                                                                                                                                        0, -0.866025, -0.231095, -0.450293, -0.862457, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.231095, -0.450293, -0.862457, -0.5,
                                                                                                                                                                        0, -0.866025, -0.231095, -0.450293, -0.862457, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.058473, -0.447981, -0.892129, -0.065403,
                                                                                                                                                                        0, -0.997859, -0.058473, -0.447981, -0.892129, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.058473, -0.447981, -0.892129, -0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.058473, -0.447981, -0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.058473, -0.447981, -0.892129, -0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.058473, -0.447981, -0.892129,
                                                                                                                                                                        0.065403,
                                                                                                                                                                        0, -0.997859,
                                                                                                                                                                        0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.231095, -0.450293, -0.862457, -0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.058473, -0.447981, -0.892129, -0.44644, -0.450293, -0.773258, -0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.44644, -0.450293, -0.773258, -0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.44644, -0.450293, -0.773258, -0.058473, -0.447981, -0.892129,
                                                                                                                                                                        0.058473, -0.447981, -0.892129, -0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.773258, -0.450293, -0.44644,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0.631362, -0.450293, -0.631362,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.44644, -0.450293, -0.773258, -0.44644, -0.450293, -0.773258,
                                                                                                                                                                        0.231095, -0.450293, -0.862457, -0.44644, -0.450293, -0.773258, -0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.231095, -0.450293, -0.862457, -0.231095, -0.450293, -0.862457,
                                                                                                                                                                        0.058473, -0.447981, -0.892129, -0.058473, -0.447981, -0.892129,
                                                                                                                                                                        0.058473, -0.447981, -0.892129, -0.231095, -0.450293, -0.862457, -0.269833, -0.467365,
                                                                                                                                                                        0.841879, -0.139676, -0.521277,
                                                                                                                                                                        0.841879, -0.269833, -0.467365,
                                                                                                                                                                        0.841879,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1, -0.92977, -0.270761, -0.249434, -0.961509, -0.274772,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.961509, -0.274772,
                                                                                                                                                                        0, -0.92977, -0.270761, -0.249434, -0.620736, -0.78402,
                                                                                                                                                                        0, -0.604708, -0.779645, -0.162734, -0.620736, -0.78402,
                                                                                                                                                                        0, -0.92977, -0.270761, -0.249434, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.961509, -0.274772,
                                                                                                                                                                        0, -0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928, -0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928, -0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548, -0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548, -0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548, -0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928, -0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548, -0.574958, -0.154059,
                                                                                                                                                                        0.803548, -0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548, -0.574958, -0.154059,
                                                                                                                                                                        0.803548, -0.515493, -0.29762,
                                                                                                                                                                        0.803548, -0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548, -0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548, -0.515493, -0.29762,
                                                                                                                                                                        0.803548, -0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548, -0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548, -0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548, -0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.991445, -0.130526,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.918364, -0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.918364, -0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.823382, -0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.823382, -0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.918364, -0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.515493, -0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.574958, -0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.515493, -0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.918364, -0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.515493, -0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.574958, -0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.574958, -0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.59524,
                                                                                                                                                                        0,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.574958, -0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.918364, -0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.574958, -0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.95076,
                                                                                                                                                                        0,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.918364,
                                                                                                                                                                        0.246075,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.823382,
                                                                                                                                                                        0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.793353,
                                                                                                                                                                        0.608761,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.793353,
                                                                                                                                                                        0.608761,
                                                                                                                                                                        0,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.420898, -0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.29762, -0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.420898, -0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.420898, -0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.29762, -0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.672289, -0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.47538, -0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.672289, -0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.29762, -0.515493,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.672289, -0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.47538, -0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.47538, -0.823382,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.672289, -0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.823382, -0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.823382, -0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.823382, -0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.672289, -0.672289,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.823382, -0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.420898, -0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.515493, -0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.420898, -0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.823382, -0.47538,
                                                                                                                                                                        0.309928,
                                                                                                                                                                        0.420898, -0.420898,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.515493, -0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.515493,
                                                                                                                                                                        0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.515493, -0.29762,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0.574958,
                                                                                                                                                                        0.154059,
                                                                                                                                                                        0.803548,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.99868, -0.041662,
                                                                                                                                                                        0.030051,
                                                                                                                                                                        0.997973, -0.063635,
                                                                                                                                                                        0,
                                                                                                                                                                        0.99868, -0.041662,
                                                                                                                                                                        0.030051,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.767323,
                                                                                                                                                                        0,
                                                                                                                                                                        0.641261,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        null,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "uv": [-128.272387,
                                                                                                                                                                        17.107689, -128.272387,
                                                                                                                                                                        16.357689, -150.522387,
                                                                                                                                                                        17.107689, -89.077129,
                                                                                                                                                                        17.107689, -82.203225,
                                                                                                                                                                        18.39932, -89.077129,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        17.107689, -82.203225,
                                                                                                                                                                        18.39932, -89.077129,
                                                                                                                                                                        17.107689, -94.560137,
                                                                                                                                                                        18.39932, -82.203225,
                                                                                                                                                                        18.39932, -92.827129,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        94.560137,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        94.560137,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        126.022387, -53.85383,
                                                                                                                                                                        128.272387, -53.85383,
                                                                                                                                                                        126.022387, -57.130007,
                                                                                                                                                                        128.272387, -57.130007,
                                                                                                                                                                        126.022387, -57.130007,
                                                                                                                                                                        128.272387, -53.85383,
                                                                                                                                                                        128.272387, -30.886903,
                                                                                                                                                                        128.272387, -30.988186,
                                                                                                                                                                        126.022387, -30.886903, -96.876744,
                                                                                                                                                                        16.082713, -94.75,
                                                                                                                                                                        16.357689, -96.923915,
                                                                                                                                                                        15.993085, -94.560137,
                                                                                                                                                                        18.39932, -94.75,
                                                                                                                                                                        16.357689, -96.876744,
                                                                                                                                                                        16.082713, -92.827129,
                                                                                                                                                                        17.107689, -94.75,
                                                                                                                                                                        16.357689, -94.560137,
                                                                                                                                                                        18.39932, -92.827129,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        16.357689, -92.827129,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        122.249761,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        122.249761,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        122.701413,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        122.701413,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        122.701413,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        122.249761,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        88.924802,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        88.924802,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        89.376454,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        89.376454,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        89.376454,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        88.924802,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        50.521111,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        50.521111,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        50.972763,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        50.972763,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        50.972763,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        50.521111,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        9.226468,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        9.67812,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        9.226468,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        128.272387, -168.120515,
                                                                                                                                                                        17.107689, -168.120515,
                                                                                                                                                                        16.357689, -168.572167,
                                                                                                                                                                        17.107689, -150.522387,
                                                                                                                                                                        16.357689, -150.522387,
                                                                                                                                                                        17.107689, -128.272387,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        172.949491, -89.077129,
                                                                                                                                                                        16.357689, -82.203225,
                                                                                                                                                                        18.39932, -82.013362,
                                                                                                                                                                        16.357689, -82.203225,
                                                                                                                                                                        18.39932, -79.886618,
                                                                                                                                                                        16.082713, -82.013362,
                                                                                                                                                                        16.357689, -128.272387,
                                                                                                                                                                        67.860565, -128.272387,
                                                                                                                                                                        71.136742, -126.022387,
                                                                                                                                                                        67.860565, -126.022387,
                                                                                                                                                                        71.136742, -126.022387,
                                                                                                                                                                        67.860565, -128.272387,
                                                                                                                                                                        71.136742, -126.022387,
                                                                                                                                                                        67.791071, -126.022387,
                                                                                                                                                                        71.326604, -88.876998,
                                                                                                                                                                        67.791071, -88.844517,
                                                                                                                                                                        71.326604, -88.876998,
                                                                                                                                                                        67.791071, -126.022387,
                                                                                                                                                                        71.326604, -114.360906, -0.160349, -97.756683, -0.160349, -112.603512, -2.435699, -97.327811,
                                                                                                                                                                        18.857689, -115.090244,
                                                                                                                                                                        18.857689, -97.327811,
                                                                                                                                                                        22.107689, -129.715209,
                                                                                                                                                                        18.857689, -97.327811,
                                                                                                                                                                        22.107689, -115.090244,
                                                                                                                                                                        18.857689, -134.364884,
                                                                                                                                                                        20.857689, -97.327811,
                                                                                                                                                                        22.107689, -129.715209,
                                                                                                                                                                        18.857689, -117.429191,
                                                                                                                                                                        22.107689, -97.327811,
                                                                                                                                                                        22.107689, -134.364884,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        84.050312,
                                                                                                                                                                        89.994086,
                                                                                                                                                                        66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        84.050312,
                                                                                                                                                                        34.740805,
                                                                                                                                                                        66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        84.050312,
                                                                                                                                                                        89.994086,
                                                                                                                                                                        66.612606,
                                                                                                                                                                        45.002883,
                                                                                                                                                                        66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        84.050312,
                                                                                                                                                                        34.740805, -76.644964,
                                                                                                                                                                        68.18804, -45.002883,
                                                                                                                                                                        68.18804, -76.644964,
                                                                                                                                                                        40.483916, -61.252883,
                                                                                                                                                                        40.483916, -76.644964,
                                                                                                                                                                        40.483916, -45.002883,
                                                                                                                                                                        68.18804,
                                                                                                                                                                        3.201515,
                                                                                                                                                                        19.245435,
                                                                                                                                                                        52.209857,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        3.201515,
                                                                                                                                                                        17.941327,
                                                                                                                                                                        34.607116,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        52.209857,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        3.201515,
                                                                                                                                                                        19.245435,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        20.247152,
                                                                                                                                                                        52.209857,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        34.607116,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        52.209857,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        20.247152,
                                                                                                                                                                        67.47629,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        20.247152,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        17.208074,
                                                                                                                                                                        67.47629,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        34.740805, -81.883105,
                                                                                                                                                                        89.994086, -81.883105,
                                                                                                                                                                        26.061021, -96.684992,
                                                                                                                                                                        98.317806, -96.684992,
                                                                                                                                                                        26.061021, -96.684992,
                                                                                                                                                                        89.994086, -81.883105,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        20.195923,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        17.311016,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923, -134.364884,
                                                                                                                                                                        20.857689, -129.715209,
                                                                                                                                                                        18.857689, -134.364884,
                                                                                                                                                                        16.649249, -132.585858,
                                                                                                                                                                        16.357689, -134.364884,
                                                                                                                                                                        16.649249, -129.715209,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        97.443433,
                                                                                                                                                                        98.597613,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        98.597613,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        100.174132,
                                                                                                                                                                        97.443433, -30.817408,
                                                                                                                                                                        126.022387, -37.59765,
                                                                                                                                                                        26.972797, -30.817408,
                                                                                                                                                                        114.022387, -34.207529,
                                                                                                                                                                        126.022387, -37.59765,
                                                                                                                                                                        97.443433, -30.817408,
                                                                                                                                                                        126.022387, -34.207529,
                                                                                                                                                                        126.022387, -37.59765,
                                                                                                                                                                        114.022387, -34.207529, -126.022387,
                                                                                                                                                                        98.853838, -128.272387,
                                                                                                                                                                        98.853838, -126.022387,
                                                                                                                                                                        99.342268,
                                                                                                                                                                        128.272387, -94.530034,
                                                                                                                                                                        126.022387, -94.530034,
                                                                                                                                                                        128.272387, -94.041603,
                                                                                                                                                                        126.022387, -94.041603,
                                                                                                                                                                        128.272387, -94.041603,
                                                                                                                                                                        126.022387, -94.530034,
                                                                                                                                                                        128.272387, -83.292376,
                                                                                                                                                                        126.022387, -83.292376,
                                                                                                                                                                        128.272387, -82.803945,
                                                                                                                                                                        126.022387, -82.803945,
                                                                                                                                                                        128.272387, -82.803945,
                                                                                                                                                                        126.022387, -83.292376,
                                                                                                                                                                        128.272387, -66.395124,
                                                                                                                                                                        126.022387, -66.395124,
                                                                                                                                                                        128.272387, -65.906693,
                                                                                                                                                                        126.022387, -65.906693,
                                                                                                                                                                        128.272387, -65.906693,
                                                                                                                                                                        126.022387, -66.395124,
                                                                                                                                                                        126.022387, -44.989796,
                                                                                                                                                                        126.022387, -44.501366,
                                                                                                                                                                        128.272387, -44.989796, -126.022387,
                                                                                                                                                                        97.340789, -114.022387,
                                                                                                                                                                        97.340789, -126.022387,
                                                                                                                                                                        96.973049, -114.022387,
                                                                                                                                                                        96.973049, -126.022387,
                                                                                                                                                                        96.973049, -114.022387,
                                                                                                                                                                        97.340789, -126.022387,
                                                                                                                                                                        99.281923, -114.022387,
                                                                                                                                                                        99.281923, -126.022387,
                                                                                                                                                                        98.914183, -114.022387,
                                                                                                                                                                        98.914183, -126.022387,
                                                                                                                                                                        98.914183, -114.022387,
                                                                                                                                                                        99.281923,
                                                                                                                                                                        126.022387, -94.469688,
                                                                                                                                                                        114.022387, -94.469688,
                                                                                                                                                                        126.022387, -94.101948,
                                                                                                                                                                        114.022387, -94.101948,
                                                                                                                                                                        126.022387, -94.101948,
                                                                                                                                                                        114.022387, -94.469688,
                                                                                                                                                                        126.022387, -83.232031,
                                                                                                                                                                        114.022387, -83.232031,
                                                                                                                                                                        126.022387, -82.864291,
                                                                                                                                                                        114.022387, -82.864291,
                                                                                                                                                                        126.022387, -82.864291,
                                                                                                                                                                        114.022387, -83.232031,
                                                                                                                                                                        126.022387, -66.334778,
                                                                                                                                                                        114.022387, -66.334778,
                                                                                                                                                                        126.022387, -65.967039,
                                                                                                                                                                        114.022387, -65.967039,
                                                                                                                                                                        126.022387, -65.967039,
                                                                                                                                                                        114.022387, -66.334778,
                                                                                                                                                                        114.022387, -44.929451,
                                                                                                                                                                        114.022387, -44.561711,
                                                                                                                                                                        126.022387, -44.929451, -96.926249,
                                                                                                                                                                        13.948194, -97.138529,
                                                                                                                                                                        13.647911, -97.516753,
                                                                                                                                                                        15.850843, -97.138529,
                                                                                                                                                                        13.647911, -97.421294,
                                                                                                                                                                        13.412802, -97.516753,
                                                                                                                                                                        15.850843, -97.516753,
                                                                                                                                                                        15.850843, -97.421294,
                                                                                                                                                                        13.412802, -98.828898,
                                                                                                                                                                        13.357689, -97.421294,
                                                                                                                                                                        13.412802, -97.755276,
                                                                                                                                                                        13.25889, -98.828898,
                                                                                                                                                                        13.357689, -98.828898,
                                                                                                                                                                        13.357689, -97.755276,
                                                                                                                                                                        13.25889, -98.483905,
                                                                                                                                                                        13.230361, -98.117712,
                                                                                                                                                                        13.196663, -98.483905,
                                                                                                                                                                        13.230361, -97.755276,
                                                                                                                                                                        13.25889,
                                                                                                                                                                        114.022387, -34.207529,
                                                                                                                                                                        97.443433, -30.817408,
                                                                                                                                                                        114.022387, -31.390165,
                                                                                                                                                                        126.022387, -30.817408,
                                                                                                                                                                        114.022387, -31.390165,
                                                                                                                                                                        97.443433, -30.817408,
                                                                                                                                                                        126.022387, -31.390165,
                                                                                                                                                                        114.022387, -31.390165,
                                                                                                                                                                        126.022387, -30.817408,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        88.778572,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        88.410832,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        88.778572,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        88.376592,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        88.376592,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        88.350486,
                                                                                                                                                                        126.022387, -30.988186,
                                                                                                                                                                        126.022387, -30.886903,
                                                                                                                                                                        128.272387, -30.988186,
                                                                                                                                                                        82.203225,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        82.203225,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        94.560137,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        93.877859,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        93.877859,
                                                                                                                                                                        96.541783,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        96.032538, -53.663967,
                                                                                                                                                                        126.022387, -53.663967,
                                                                                                                                                                        97.443433, -57.199501,
                                                                                                                                                                        126.022387, -57.199501,
                                                                                                                                                                        97.443433, -57.199501,
                                                                                                                                                                        126.022387, -53.663967,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        93.877859,
                                                                                                                                                                        96.541783,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        88.350486,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        88.350486,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        88.376592,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        74.239117,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        74.239117,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        73.750687,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        73.750687,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        73.750687,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        74.239117,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        54.596687,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        54.108257,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        54.596687, -96.590327,
                                                                                                                                                                        15.602447, -94.769826,
                                                                                                                                                                        15.334263, -96.385901,
                                                                                                                                                                        15.158854, -95.070637,
                                                                                                                                                                        15.74846, -94.769826,
                                                                                                                                                                        15.334263, -96.590327,
                                                                                                                                                                        15.602447,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        68.097051,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        68.608956,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        68.097051,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        68.608956,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        68.097051,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        68.608956,
                                                                                                                                                                        94.769826,
                                                                                                                                                                        15.334263,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        94.558366,
                                                                                                                                                                        14.868074,
                                                                                                                                                                        94.558366,
                                                                                                                                                                        14.868074,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        94.444881,
                                                                                                                                                                        14.368906,
                                                                                                                                                                        94.444881,
                                                                                                                                                                        14.368906,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        94.433999,
                                                                                                                                                                        13.857117,
                                                                                                                                                                        94.433999,
                                                                                                                                                                        13.857117,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        94.526164,
                                                                                                                                                                        13.353576,
                                                                                                                                                                        94.526164,
                                                                                                                                                                        13.353576,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        94.717618,
                                                                                                                                                                        12.878821,
                                                                                                                                                                        94.717618,
                                                                                                                                                                        12.878821,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        95.000552,
                                                                                                                                                                        12.452212,
                                                                                                                                                                        95.000552,
                                                                                                                                                                        12.452212,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        95.363428,
                                                                                                                                                                        12.091147,
                                                                                                                                                                        95.363428,
                                                                                                                                                                        12.091147,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        95.791447,
                                                                                                                                                                        11.81035,
                                                                                                                                                                        95.791447,
                                                                                                                                                                        11.81035,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        96.267154,
                                                                                                                                                                        11.621274,
                                                                                                                                                                        95.070637,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        97.282878,
                                                                                                                                                                        11.54507,
                                                                                                                                                                        96.267154,
                                                                                                                                                                        11.621274,
                                                                                                                                                                        193.422316, -29.927567,
                                                                                                                                                                        159.296883, -30.067029,
                                                                                                                                                                        128.546883, -29.927567,
                                                                                                                                                                        159.296883, -35.366021,
                                                                                                                                                                        159.296883, -30.067029,
                                                                                                                                                                        193.422316, -29.927567,
                                                                                                                                                                        159.296883, -35.366021,
                                                                                                                                                                        193.422316, -36.158816,
                                                                                                                                                                        128.546883, -35.366021,
                                                                                                                                                                        193.422316, -36.158816,
                                                                                                                                                                        159.296883, -35.366021,
                                                                                                                                                                        193.422316, -29.927567,
                                                                                                                                                                        94.75,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        97.907795,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        94.75,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        16.357689, -150.839748,
                                                                                                                                                                        17.107689, -150.839748,
                                                                                                                                                                        16.357689, -154.559402,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        92.827129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        94.75,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        92.713236,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.499016,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        92.196673,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        9.67812,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        9.226468,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        9.67812,
                                                                                                                                                                        17.107689, -32.606653,
                                                                                                                                                                        17.107689, -32.155001,
                                                                                                                                                                        17.107689, -32.606653,
                                                                                                                                                                        16.357689, -32.155001,
                                                                                                                                                                        16.357689, -32.606653,
                                                                                                                                                                        16.357689, -32.155001,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        91.823431,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        91.400553,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534, -72.143451,
                                                                                                                                                                        16.357689, -72.595103,
                                                                                                                                                                        16.357689, -72.143451,
                                                                                                                                                                        17.107689, -72.595103,
                                                                                                                                                                        17.107689, -72.143451,
                                                                                                                                                                        17.107689, -72.595103,
                                                                                                                                                                        16.357689, -108.460821,
                                                                                                                                                                        17.107689, -108.009169,
                                                                                                                                                                        17.107689, -108.460821,
                                                                                                                                                                        16.357689, -108.009169,
                                                                                                                                                                        16.357689, -108.460821,
                                                                                                                                                                        16.357689, -108.009169,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        90.952129,
                                                                                                                                                                        152.159439,
                                                                                                                                                                        90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        90.503705,
                                                                                                                                                                        152.105539,
                                                                                                                                                                        90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534, -137.708955,
                                                                                                                                                                        16.357689, -138.160607,
                                                                                                                                                                        16.357689, -137.708955,
                                                                                                                                                                        17.107689, -138.160607,
                                                                                                                                                                        17.107689, -137.708955,
                                                                                                                                                                        17.107689, -138.160607,
                                                                                                                                                                        16.357689, -160.002525,
                                                                                                                                                                        17.107689, -159.550873,
                                                                                                                                                                        17.107689, -160.002525,
                                                                                                                                                                        16.357689, -159.550873,
                                                                                                                                                                        16.357689, -160.002525,
                                                                                                                                                                        16.357689, -159.550873,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        90.080826,
                                                                                                                                                                        151.946909,
                                                                                                                                                                        89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        89.707584,
                                                                                                                                                                        151.692587,
                                                                                                                                                                        89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534, -172.742284,
                                                                                                                                                                        16.357689, -172.742284,
                                                                                                                                                                        17.107689, -172.290632,
                                                                                                                                                                        16.357689, -172.290632,
                                                                                                                                                                        17.107689, -172.290632,
                                                                                                                                                                        16.357689, -172.742284,
                                                                                                                                                                        17.107689, -175.654125,
                                                                                                                                                                        16.357689, -175.654125,
                                                                                                                                                                        17.107689, -175.202473,
                                                                                                                                                                        16.357689, -175.202473,
                                                                                                                                                                        17.107689, -175.202473,
                                                                                                                                                                        16.357689, -175.654125,
                                                                                                                                                                        17.107689, -168.572167,
                                                                                                                                                                        16.357689, -168.572167,
                                                                                                                                                                        17.107689, -168.120515,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        89.077129,
                                                                                                                                                                        150.522387,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.196812, -91.465361,
                                                                                                                                                                        16.357689, -91.465361,
                                                                                                                                                                        17.107689, -85.701474,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        197.957121,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        197.957121,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        192.193235,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        192.193235,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        192.193235,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        197.957121,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        190.056655,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        190.056655,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        186.337002,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        186.337002,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        186.337002,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        190.056655,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        81.804968,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        128.272387, -159.362451,
                                                                                                                                                                        52.323416, -193.356748,
                                                                                                                                                                        52.331742, -128.612451,
                                                                                                                                                                        52.323416, -193.356748,
                                                                                                                                                                        52.331742, -159.362451,
                                                                                                                                                                        52.323416, -193.356748,
                                                                                                                                                                        46.231629, -159.362451,
                                                                                                                                                                        52.323416, -159.362451,
                                                                                                                                                                        46.893288, -193.356748,
                                                                                                                                                                        46.231629,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        80.52494,
                                                                                                                                                                        11.574274,
                                                                                                                                                                        79.480484,
                                                                                                                                                                        11.54507,
                                                                                                                                                                        81.019272,
                                                                                                                                                                        11.752184,
                                                                                                                                                                        80.52494,
                                                                                                                                                                        11.574274,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846, -159.022387,
                                                                                                                                                                        80.21216, -128.272387,
                                                                                                                                                                        80.21216, -159.022387,
                                                                                                                                                                        79.686788, -128.272387,
                                                                                                                                                                        74.98081, -159.022387,
                                                                                                                                                                        74.98081, -128.272387,
                                                                                                                                                                        75.506182, -159.022387,
                                                                                                                                                                        75.506182, -128.272387,
                                                                                                                                                                        75.506182, -159.022387,
                                                                                                                                                                        74.98081, -128.272387,
                                                                                                                                                                        66.916001, -159.022387,
                                                                                                                                                                        66.916001, -128.272387,
                                                                                                                                                                        67.441373, -159.022387,
                                                                                                                                                                        67.441373, -128.272387,
                                                                                                                                                                        67.441373, -159.022387,
                                                                                                                                                                        66.916001, -159.022387,
                                                                                                                                                                        55.852368, -159.022387,
                                                                                                                                                                        56.37774, -128.272387,
                                                                                                                                                                        55.852368,
                                                                                                                                                                        82.135222,
                                                                                                                                                                        12.831729,
                                                                                                                                                                        81.842793,
                                                                                                                                                                        12.395265,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        81.842793,
                                                                                                                                                                        12.395265,
                                                                                                                                                                        81.465191,
                                                                                                                                                                        12.029981,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        81.465191,
                                                                                                                                                                        12.029981,
                                                                                                                                                                        81.019272,
                                                                                                                                                                        11.752184,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        82.329423,
                                                                                                                                                                        13.31989,
                                                                                                                                                                        82.135222,
                                                                                                                                                                        12.831729,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846, -159.022387,
                                                                                                                                                                        42.283788, -159.022387,
                                                                                                                                                                        42.80916, -128.272387,
                                                                                                                                                                        42.283788, -128.272387,
                                                                                                                                                                        42.80916, -128.272387,
                                                                                                                                                                        42.283788, -159.022387,
                                                                                                                                                                        42.80916, -82.329423,
                                                                                                                                                                        13.31989, -79.886618,
                                                                                                                                                                        16.082713, -82.135222,
                                                                                                                                                                        12.831729, -82.416728,
                                                                                                                                                                        13.837957, -79.886618,
                                                                                                                                                                        16.082713, -82.329423,
                                                                                                                                                                        13.31989, -82.393239,
                                                                                                                                                                        14.362804, -79.886618,
                                                                                                                                                                        16.082713, -82.416728,
                                                                                                                                                                        13.837957, -82.260005,
                                                                                                                                                                        14.871001, -79.886618,
                                                                                                                                                                        16.082713, -82.393239,
                                                                                                                                                                        14.362804, -82.022973,
                                                                                                                                                                        15.339863, -79.886618,
                                                                                                                                                                        16.082713, -82.260005,
                                                                                                                                                                        14.871001, -81.692725,
                                                                                                                                                                        15.74846, -79.886618,
                                                                                                                                                                        16.082713, -82.022973,
                                                                                                                                                                        15.339863, -82.013362,
                                                                                                                                                                        16.357689, -79.886618,
                                                                                                                                                                        16.082713, -81.692725,
                                                                                                                                                                        15.74846, -128.272387, -39.103938, -128.272387, -39.62931, -159.022387, -39.103938, -159.022387, -39.62931, -159.022387, -39.103938, -128.272387, -39.62931,
                                                                                                                                                                        82.022973,
                                                                                                                                                                        15.339863,
                                                                                                                                                                        82.260005,
                                                                                                                                                                        14.871001,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846, -159.022387, -23.316365, -128.272387, -23.316365, -159.022387, -23.841737, -128.272387, -23.841737, -159.022387, -23.841737, -128.272387, -23.316365, -128.272387, -6.476236, -128.272387, -7.001608, -159.022387, -6.476236, -159.022387, -7.001608, -159.022387, -6.476236, -128.272387, -7.001608,
                                                                                                                                                                        82.260005,
                                                                                                                                                                        14.871001,
                                                                                                                                                                        82.393239,
                                                                                                                                                                        14.362804,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846,
                                                                                                                                                                        82.393239,
                                                                                                                                                                        14.362804,
                                                                                                                                                                        82.416728,
                                                                                                                                                                        13.837957,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846, -159.022387,
                                                                                                                                                                        10.139344, -159.022387,
                                                                                                                                                                        10.664716, -128.272387,
                                                                                                                                                                        10.139344, -128.272387,
                                                                                                                                                                        10.664716, -128.272387,
                                                                                                                                                                        10.139344, -159.022387,
                                                                                                                                                                        10.664716, -128.272387,
                                                                                                                                                                        27.341327, -128.272387,
                                                                                                                                                                        26.815955, -159.022387,
                                                                                                                                                                        27.341327, -159.022387,
                                                                                                                                                                        26.815955, -159.022387,
                                                                                                                                                                        27.341327, -128.272387,
                                                                                                                                                                        26.815955,
                                                                                                                                                                        82.416728,
                                                                                                                                                                        13.837957,
                                                                                                                                                                        82.329423,
                                                                                                                                                                        13.31989,
                                                                                                                                                                        81.692725,
                                                                                                                                                                        15.74846, -82.135222,
                                                                                                                                                                        12.831729, -79.886618,
                                                                                                                                                                        16.082713, -81.842793,
                                                                                                                                                                        12.395265, -81.842793,
                                                                                                                                                                        12.395265, -79.886618,
                                                                                                                                                                        16.082713, -81.465191,
                                                                                                                                                                        12.029981, -81.465191,
                                                                                                                                                                        12.029981, -79.886618,
                                                                                                                                                                        16.082713, -81.019272,
                                                                                                                                                                        11.752184, -81.019272,
                                                                                                                                                                        11.752184, -79.886618,
                                                                                                                                                                        16.082713, -80.52494,
                                                                                                                                                                        11.574274, -80.52494,
                                                                                                                                                                        11.574274, -79.886618,
                                                                                                                                                                        16.082713, -79.480484,
                                                                                                                                                                        11.54507, -79.480484,
                                                                                                                                                                        11.54507, -79.886618,
                                                                                                                                                                        16.082713, -78.855567,
                                                                                                                                                                        10.357689, -79.886618,
                                                                                                                                                                        16.082713, -76.813936,
                                                                                                                                                                        10.244433, -78.855567,
                                                                                                                                                                        10.357689, -128.272387,
                                                                                                                                                                        44.840483, -128.272387,
                                                                                                                                                                        51.437974, -126.022387,
                                                                                                                                                                        44.840483, -126.022387,
                                                                                                                                                                        51.437974, -126.022387,
                                                                                                                                                                        44.840483, -128.272387,
                                                                                                                                                                        51.437974, -126.022387,
                                                                                                                                                                        44.727227, -126.022387,
                                                                                                                                                                        51.507468, -90.558974,
                                                                                                                                                                        44.727227, -88.876998,
                                                                                                                                                                        51.507468, -90.558974,
                                                                                                                                                                        44.727227, -126.022387,
                                                                                                                                                                        51.507468, -112.603512, -2.435699, -107.386674, -9.078753, -110.63459, -9.3104, -106.119243, -6.217986, -107.386674, -9.078753, -112.603512, -2.435699, -102.5175, -5.217616, -106.119243, -6.217986, -112.603512, -2.435699, -98.488344, -4.204117, -102.5175, -5.217616, -112.603512, -2.435699, -78.790175,
                                                                                                                                                                        22.914196, -75.320006,
                                                                                                                                                                        22.914196, -81.048924,
                                                                                                                                                                        18.713712, -78.790175,
                                                                                                                                                                        18.857689, -78.790175,
                                                                                                                                                                        22.107689, -75.320006,
                                                                                                                                                                        18.857689, -75.320006,
                                                                                                                                                                        22.107689, -75.320006,
                                                                                                                                                                        18.857689, -78.790175,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        22.107689, -39,
                                                                                                                                                                        19.857689, -66.612606,
                                                                                                                                                                        18.857689, -39,
                                                                                                                                                                        19.857689, -39,
                                                                                                                                                                        18.857689, -66.612606,
                                                                                                                                                                        18.857689, -48.14141,
                                                                                                                                                                        15.432602, -48.14141,
                                                                                                                                                                        25.107689, -46.620289,
                                                                                                                                                                        15.098225, -56.495086,
                                                                                                                                                                        25.107689, -56.495086,
                                                                                                                                                                        15.432602, -58.322453,
                                                                                                                                                                        25.107689, -58.228858,
                                                                                                                                                                        15.857689, -58.322453,
                                                                                                                                                                        25.107689, -56.495086,
                                                                                                                                                                        15.432602, -58.322453,
                                                                                                                                                                        15.875072, -58.322453,
                                                                                                                                                                        25.107689, -58.228858,
                                                                                                                                                                        15.857689, -62.763816,
                                                                                                                                                                        25.107689, -62.763816,
                                                                                                                                                                        15.875072, -64.591183,
                                                                                                                                                                        25.107689, -64.591183,
                                                                                                                                                                        16.226418, -64.591183,
                                                                                                                                                                        25.107689, -62.763816,
                                                                                                                                                                        15.875072, -64.69303,
                                                                                                                                                                        16.226418, -66.214151,
                                                                                                                                                                        16.508918, -64.69303,
                                                                                                                                                                        25.107689, -62.151255,
                                                                                                                                                                        16.559911, -63.978622,
                                                                                                                                                                        16.80835, -62.151255,
                                                                                                                                                                        25.107689, -63.978622,
                                                                                                                                                                        25.107689, -62.151255,
                                                                                                                                                                        25.107689, -63.978622,
                                                                                                                                                                        16.80835, -62.151255,
                                                                                                                                                                        5.690244, -63.978622,
                                                                                                                                                                        5.690244, -62.270034,
                                                                                                                                                                        7.231831, -63.859843,
                                                                                                                                                                        7.231831, -62.270034,
                                                                                                                                                                        7.231831, -63.978622,
                                                                                                                                                                        5.690244,
                                                                                                                                                                        35.955,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        35.955,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        34.69372,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        37.423792,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        35.955,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        35.955,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        15.042307,
                                                                                                                                                                        55.105806,
                                                                                                                                                                        16.632116,
                                                                                                                                                                        55.105806,
                                                                                                                                                                        14.923528,
                                                                                                                                                                        53.564219,
                                                                                                                                                                        16.750895,
                                                                                                                                                                        53.564219,
                                                                                                                                                                        14.923528,
                                                                                                                                                                        53.564219,
                                                                                                                                                                        16.632116,
                                                                                                                                                                        55.105806,
                                                                                                                                                                        14.923528,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        16.750895,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        14.923528,
                                                                                                                                                                        14.061539,
                                                                                                                                                                        16.750895,
                                                                                                                                                                        13.941489,
                                                                                                                                                                        14.923528,
                                                                                                                                                                        14.061539,
                                                                                                                                                                        16.750895,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        58.322453,
                                                                                                                                                                        15.432602,
                                                                                                                                                                        56.801332,
                                                                                                                                                                        15.098225,
                                                                                                                                                                        58.322453,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        58.322453,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        56.801332,
                                                                                                                                                                        15.098225,
                                                                                                                                                                        56.495086,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        56.495086,
                                                                                                                                                                        15.02314,
                                                                                                                                                                        56.495086,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        56.801332,
                                                                                                                                                                        15.098225,
                                                                                                                                                                        64.591183,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        64.591183,
                                                                                                                                                                        15.02314,
                                                                                                                                                                        62.763816,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        62.763816,
                                                                                                                                                                        14.621443,
                                                                                                                                                                        62.763816,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        64.591183,
                                                                                                                                                                        15.02314,
                                                                                                                                                                        66.520397,
                                                                                                                                                                        14.621443,
                                                                                                                                                                        64.69303,
                                                                                                                                                                        14.293459,
                                                                                                                                                                        66.520397,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        64.69303,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        66.520397,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        64.69303,
                                                                                                                                                                        14.293459,
                                                                                                                                                                        64.69303,
                                                                                                                                                                        16.9895,
                                                                                                                                                                        64.811809,
                                                                                                                                                                        18.531088,
                                                                                                                                                                        66.520397,
                                                                                                                                                                        16.9895,
                                                                                                                                                                        63.978622,
                                                                                                                                                                        26.903612,
                                                                                                                                                                        62.151255,
                                                                                                                                                                        26.903612,
                                                                                                                                                                        63.859843,
                                                                                                                                                                        28.445199,
                                                                                                                                                                        63.978622,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        63.978622,
                                                                                                                                                                        14.293459,
                                                                                                                                                                        62.151255,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        62.151255,
                                                                                                                                                                        14.061539,
                                                                                                                                                                        62.151255,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        63.978622,
                                                                                                                                                                        14.293459,
                                                                                                                                                                        57.139075,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        57.139075,
                                                                                                                                                                        14.061539,
                                                                                                                                                                        55.311708,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        55.311708,
                                                                                                                                                                        13.941489,
                                                                                                                                                                        55.311708,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        57.139075,
                                                                                                                                                                        14.061539,
                                                                                                                                                                        46.467861,
                                                                                                                                                                        13.941489,
                                                                                                                                                                        44.640494,
                                                                                                                                                                        13.941489,
                                                                                                                                                                        46.467861,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        44.640494,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        46.467861,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        44.640494,
                                                                                                                                                                        13.941489,
                                                                                                                                                                        46.467861,
                                                                                                                                                                        43.93698,
                                                                                                                                                                        44.640494,
                                                                                                                                                                        43.93698,
                                                                                                                                                                        46.349082,
                                                                                                                                                                        45.478567,
                                                                                                                                                                        44.759273,
                                                                                                                                                                        45.478567,
                                                                                                                                                                        46.349082,
                                                                                                                                                                        45.478567,
                                                                                                                                                                        44.640494,
                                                                                                                                                                        43.93698,
                                                                                                                                                                        40.576208,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        39,
                                                                                                                                                                        58.8597,
                                                                                                                                                                        39,
                                                                                                                                                                        58.8597,
                                                                                                                                                                        39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        38.211896,
                                                                                                                                                                        58.755944,
                                                                                                                                                                        38.211896,
                                                                                                                                                                        58.755944,
                                                                                                                                                                        39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        39,
                                                                                                                                                                        46.6797,
                                                                                                                                                                        37.423792,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        30.983617,
                                                                                                                                                                        51.437028,
                                                                                                                                                                        32.573426,
                                                                                                                                                                        51.437028,
                                                                                                                                                                        30.864838,
                                                                                                                                                                        49.895441,
                                                                                                                                                                        32.692205,
                                                                                                                                                                        49.895441,
                                                                                                                                                                        30.864838,
                                                                                                                                                                        49.895441,
                                                                                                                                                                        32.573426,
                                                                                                                                                                        51.437028,
                                                                                                                                                                        30.864838,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        32.692205,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        30.864838,
                                                                                                                                                                        13.941489,
                                                                                                                                                                        32.692205,
                                                                                                                                                                        13.941489,
                                                                                                                                                                        30.864838,
                                                                                                                                                                        13.941489,
                                                                                                                                                                        32.692205,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        37.423792,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        37.423792,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        35.955,
                                                                                                                                                                        58.043795, -57.020296, -1.959452, -55.430487, -1.959452, -57.139075, -3.50104, -55.311708, -3.50104, -57.139075, -3.50104, -55.430487, -1.959452, -57.139075,
                                                                                                                                                                        25.107689, -55.311708,
                                                                                                                                                                        25.107689, -57.139075,
                                                                                                                                                                        16.984023, -55.311708,
                                                                                                                                                                        16.80835, -57.139075,
                                                                                                                                                                        16.984023, -55.311708,
                                                                                                                                                                        25.107689, -44.640494,
                                                                                                                                                                        16.984023, -46.467861,
                                                                                                                                                                        17.074959, -44.640494,
                                                                                                                                                                        25.107689, -46.467861,
                                                                                                                                                                        25.107689, -44.640494,
                                                                                                                                                                        25.107689, -46.467861,
                                                                                                                                                                        17.074959, -44.640494, -11.343124, -46.467861, -11.343124, -44.759273, -9.801537, -46.349082, -9.801537, -44.759273, -9.801537, -46.467861, -11.343124, -45.554178, -9.801537, -44.759273, -9.801537, -46.349082, -9.801537, -30.864838, -17.301585, -32.692205, -17.301585, -30.983617, -15.759998, -30.864838,
                                                                                                                                                                        25.107689, -30.864838,
                                                                                                                                                                        17.074959, -32.692205,
                                                                                                                                                                        25.107689, -32.692205,
                                                                                                                                                                        16.984023, -32.692205,
                                                                                                                                                                        25.107689, -30.864838,
                                                                                                                                                                        17.074959, -14.923528,
                                                                                                                                                                        25.107689, -14.923528,
                                                                                                                                                                        16.984023, -16.750895,
                                                                                                                                                                        25.107689, -16.750895,
                                                                                                                                                                        16.80835, -16.750895,
                                                                                                                                                                        25.107689, -14.923528,
                                                                                                                                                                        16.984023,
                                                                                                                                                                        2.097061,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        2.097061,
                                                                                                                                                                        16.80835,
                                                                                                                                                                        0.269695,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        0.269695,
                                                                                                                                                                        16.559911,
                                                                                                                                                                        0.269695,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        2.097061,
                                                                                                                                                                        16.80835,
                                                                                                                                                                        19.037006,
                                                                                                                                                                        16.559911,
                                                                                                                                                                        18.73076,
                                                                                                                                                                        16.508918,
                                                                                                                                                                        19.037006,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        3.201515,
                                                                                                                                                                        17.941327,
                                                                                                                                                                        52.209857,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        8.314555,
                                                                                                                                                                        17.336396,
                                                                                                                                                                        52.209857,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        49.046219,
                                                                                                                                                                        16.787915,
                                                                                                                                                                        8.314555,
                                                                                                                                                                        17.336396,
                                                                                                                                                                        70.330059,
                                                                                                                                                                        17.054971,
                                                                                                                                                                        67.47629,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        17.208074,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        17.311016,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        100.174132,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        100.174132,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        98.597613,
                                                                                                                                                                        28.444045, -53.663967,
                                                                                                                                                                        26.972797, -57.199501,
                                                                                                                                                                        22.5, -53.663967,
                                                                                                                                                                        22.5, -57.199501,
                                                                                                                                                                        22.5, -53.663967,
                                                                                                                                                                        26.972797, -57.199501, -94.75,
                                                                                                                                                                        18.857689, -97.25,
                                                                                                                                                                        16.357689, -102.884644,
                                                                                                                                                                        17.920189, -102.884644,
                                                                                                                                                                        17.920189, -97.25,
                                                                                                                                                                        16.357689, -103.72131,
                                                                                                                                                                        15.900299, -103.72131,
                                                                                                                                                                        15.900299, -97.25,
                                                                                                                                                                        16.357689, -104.006681,
                                                                                                                                                                        13.732689, -104.006681,
                                                                                                                                                                        13.732689, -97.25,
                                                                                                                                                                        16.357689, -103.72131,
                                                                                                                                                                        11.56508, -97.25,
                                                                                                                                                                        16.357689, -100.407795,
                                                                                                                                                                        10.357689, -103.72131,
                                                                                                                                                                        11.56508,
                                                                                                                                                                        22.5, -37.59765,
                                                                                                                                                                        22.5, -30.817408,
                                                                                                                                                                        126.022387, -37.59765,
                                                                                                                                                                        26.972797, -30.817408,
                                                                                                                                                                        126.022387, -37.59765,
                                                                                                                                                                        22.5, -30.817408,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.695398,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.26998,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.244433,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        9.316059,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        10.244433, -76.813936,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        9.316059, -78.855567,
                                                                                                                                                                        10.357689, -76.813936,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        10.244433, -78.855567,
                                                                                                                                                                        10.357689, -99.949426,
                                                                                                                                                                        10.244433, -97.907795,
                                                                                                                                                                        10.357689, -98.610491,
                                                                                                                                                                        12.788489, -97.907795,
                                                                                                                                                                        10.357689, -99.949426,
                                                                                                                                                                        10.244433, -97.282878,
                                                                                                                                                                        11.54507, -97.907795,
                                                                                                                                                                        10.357689, -98.610491,
                                                                                                                                                                        12.788489, -128.272387,
                                                                                                                                                                        97.552485, -128.272387,
                                                                                                                                                                        97.040579, -159.022387,
                                                                                                                                                                        97.552485, -96.771149,
                                                                                                                                                                        11.531628, -97.282878,
                                                                                                                                                                        11.54507, -96.267154,
                                                                                                                                                                        11.621274, -96.267154,
                                                                                                                                                                        11.621274, -97.282878,
                                                                                                                                                                        11.54507, -98.610491,
                                                                                                                                                                        12.788489, -98.586,
                                                                                                                                                                        12.77945, -96.267154,
                                                                                                                                                                        11.621274, -98.610491,
                                                                                                                                                                        12.788489, -95.791447,
                                                                                                                                                                        11.81035, -96.267154,
                                                                                                                                                                        11.621274, -98.586,
                                                                                                                                                                        12.77945,
                                                                                                                                                                        128.272387, -85.167423,
                                                                                                                                                                        128.272387, -84.655517,
                                                                                                                                                                        159.022387, -85.167423,
                                                                                                                                                                        159.022387, -84.655517,
                                                                                                                                                                        159.022387, -85.167423,
                                                                                                                                                                        128.272387, -84.655517,
                                                                                                                                                                        128.272387, -73.615702,
                                                                                                                                                                        128.272387, -73.103797,
                                                                                                                                                                        159.022387, -73.615702, -95.363428,
                                                                                                                                                                        12.091147, -95.791447,
                                                                                                                                                                        11.81035, -98.586,
                                                                                                                                                                        12.77945, -98.099624,
                                                                                                                                                                        12.734692, -95.363428,
                                                                                                                                                                        12.091147, -98.586,
                                                                                                                                                                        12.77945, -95.000552,
                                                                                                                                                                        12.452212, -95.363428,
                                                                                                                                                                        12.091147, -98.099624,
                                                                                                                                                                        12.734692,
                                                                                                                                                                        128.272387, -59.072247,
                                                                                                                                                                        128.272387, -58.560341,
                                                                                                                                                                        159.022387, -59.072247,
                                                                                                                                                                        159.022387, -58.560341,
                                                                                                                                                                        159.022387, -59.072247,
                                                                                                                                                                        128.272387, -58.560341,
                                                                                                                                                                        128.272387, -42.130163,
                                                                                                                                                                        128.272387, -41.618258,
                                                                                                                                                                        159.022387, -42.130163, -95.000552,
                                                                                                                                                                        12.452212, -98.099624,
                                                                                                                                                                        12.734692, -94.717618,
                                                                                                                                                                        12.878821, -97.618237,
                                                                                                                                                                        12.817342, -94.717618,
                                                                                                                                                                        12.878821, -98.099624,
                                                                                                                                                                        12.734692, -97.174644,
                                                                                                                                                                        13.021768, -94.717618,
                                                                                                                                                                        12.878821, -97.618237,
                                                                                                                                                                        12.817342, -94.526164,
                                                                                                                                                                        13.353576, -94.717618,
                                                                                                                                                                        12.878821, -97.174644,
                                                                                                                                                                        13.021768,
                                                                                                                                                                        128.272387, -23.480378,
                                                                                                                                                                        128.272387, -22.968473,
                                                                                                                                                                        159.022387, -23.480378,
                                                                                                                                                                        159.022387, -22.968473,
                                                                                                                                                                        159.022387, -23.480378,
                                                                                                                                                                        128.272387, -22.968473,
                                                                                                                                                                        128.272387, -3.883462,
                                                                                                                                                                        128.272387, -3.371556,
                                                                                                                                                                        159.022387, -3.883462, -94.433999,
                                                                                                                                                                        13.857117, -94.526164,
                                                                                                                                                                        13.353576, -96.517126,
                                                                                                                                                                        13.732873, -96.517126,
                                                                                                                                                                        13.732873, -94.526164,
                                                                                                                                                                        13.353576, -96.799076,
                                                                                                                                                                        13.334038, -96.799076,
                                                                                                                                                                        13.334038, -94.526164,
                                                                                                                                                                        13.353576, -97.174644,
                                                                                                                                                                        13.021768,
                                                                                                                                                                        128.272387, -44.501366,
                                                                                                                                                                        128.272387, -44.989796,
                                                                                                                                                                        126.022387, -44.501366,
                                                                                                                                                                        126.022387, -20.535132,
                                                                                                                                                                        126.022387, -20.046701,
                                                                                                                                                                        128.272387, -20.535132,
                                                                                                                                                                        126.022387, -44.561711,
                                                                                                                                                                        126.022387, -44.929451,
                                                                                                                                                                        114.022387, -44.561711,
                                                                                                                                                                        114.022387, -20.474786,
                                                                                                                                                                        114.022387, -20.107046,
                                                                                                                                                                        126.022387, -20.474786, -96.798921,
                                                                                                                                                                        14.293187, -96.926249,
                                                                                                                                                                        13.948194, -97.516753,
                                                                                                                                                                        15.850843, -96.765222,
                                                                                                                                                                        14.659379, -96.798921,
                                                                                                                                                                        14.293187, -97.516753,
                                                                                                                                                                        15.850843,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        5.362671,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        5.730411,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        5.362671,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        5.730411,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        5.362671,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        5.730411,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        30.761795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        31.250226,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        30.761795,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        31.250226,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        30.761795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        31.250226, -96.385901,
                                                                                                                                                                        15.158854, -94.558366,
                                                                                                                                                                        14.868074, -96.303251,
                                                                                                                                                                        14.677467, -94.769826,
                                                                                                                                                                        15.334263, -94.558366,
                                                                                                                                                                        14.868074, -96.385901,
                                                                                                                                                                        15.158854,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        52.600794,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        53.1127,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        52.600794,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        53.1127,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        52.600794,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        53.1127,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        35.460855,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        34.94895,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        35.460855,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        34.94895,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        35.460855,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        34.94895, -94.558366,
                                                                                                                                                                        14.868074, -94.444881,
                                                                                                                                                                        14.368906, -96.303251,
                                                                                                                                                                        14.677467, -96.303251,
                                                                                                                                                                        14.677467, -94.444881,
                                                                                                                                                                        14.368906, -96.348009,
                                                                                                                                                                        14.191091, -94.444881,
                                                                                                                                                                        14.368906, -94.433999,
                                                                                                                                                                        13.857117, -96.348009,
                                                                                                                                                                        14.191091,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.86139,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.373296,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.86139,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        16.373296,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.86139,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.373296,
                                                                                                                                                                        159.022387, -3.371556,
                                                                                                                                                                        159.022387, -3.883462,
                                                                                                                                                                        128.272387, -3.371556, -96.348009,
                                                                                                                                                                        14.191091, -94.433999,
                                                                                                                                                                        13.857117, -96.517126,
                                                                                                                                                                        13.732873,
                                                                                                                                                                        128.272387, -20.046701,
                                                                                                                                                                        128.272387, -20.535132,
                                                                                                                                                                        126.022387, -20.046701,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        5.302326,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        5.790756,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        5.302326,
                                                                                                                                                                        126.022387, -20.107046,
                                                                                                                                                                        126.022387, -20.474786,
                                                                                                                                                                        114.022387, -20.107046,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        5.790756,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        5.302326,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        5.790756,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        54.108257,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        54.596687,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        54.108257,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        54.536342,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        54.168602,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        54.536342,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        54.168602,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        54.536342,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        54.168602, -96.981362,
                                                                                                                                                                        15.355797, -96.827449,
                                                                                                                                                                        15.021816, -97.516753,
                                                                                                                                                                        15.850843, -96.827449,
                                                                                                                                                                        15.021816, -96.765222,
                                                                                                                                                                        14.659379, -97.516753,
                                                                                                                                                                        15.850843,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        30.822141,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        31.189881,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        30.822141,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        31.189881,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        30.822141,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        31.189881, -97.21647,
                                                                                                                                                                        15.638563, -96.981362,
                                                                                                                                                                        15.355797, -97.516753,
                                                                                                                                                                        15.850843,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        74.178772,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        74.178772,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        73.811032,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        88.410832,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        88.778572,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        88.410832,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        73.811032,
                                                                                                                                                                        114.022387,
                                                                                                                                                                        73.811032,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        74.178772,
                                                                                                                                                                        159.022387, -41.618258,
                                                                                                                                                                        159.022387, -42.130163,
                                                                                                                                                                        128.272387, -41.618258,
                                                                                                                                                                        159.022387, -73.103797,
                                                                                                                                                                        159.022387, -73.615702,
                                                                                                                                                                        128.272387, -73.103797, -128.272387,
                                                                                                                                                                        99.342268, -126.022387,
                                                                                                                                                                        99.342268, -128.272387,
                                                                                                                                                                        98.853838, -126.022387,
                                                                                                                                                                        96.912704, -128.272387,
                                                                                                                                                                        96.912704, -126.022387,
                                                                                                                                                                        96.93881, -128.272387,
                                                                                                                                                                        96.93881, -126.022387,
                                                                                                                                                                        96.93881, -128.272387,
                                                                                                                                                                        96.912704,
                                                                                                                                                                        128.272387, -34.609508,
                                                                                                                                                                        128.272387, -37.484394,
                                                                                                                                                                        126.022387, -34.609508,
                                                                                                                                                                        126.022387, -37.484394,
                                                                                                                                                                        126.022387, -34.609508,
                                                                                                                                                                        128.272387, -37.484394,
                                                                                                                                                                        159.022387, -92.744404,
                                                                                                                                                                        159.022387, -93.25631,
                                                                                                                                                                        128.272387, -92.744404,
                                                                                                                                                                        96.771149,
                                                                                                                                                                        11.531628,
                                                                                                                                                                        96.267154,
                                                                                                                                                                        11.621274,
                                                                                                                                                                        97.282878,
                                                                                                                                                                        11.54507, -159.022387,
                                                                                                                                                                        97.040579, -159.022387,
                                                                                                                                                                        97.552485, -128.272387,
                                                                                                                                                                        97.040579,
                                                                                                                                                                        128.272387, -93.25631,
                                                                                                                                                                        128.272387, -92.744404,
                                                                                                                                                                        159.022387, -93.25631,
                                                                                                                                                                        128.546883, -36.158816,
                                                                                                                                                                        128.546883, -35.366021,
                                                                                                                                                                        193.422316, -36.158816, -97.907795,
                                                                                                                                                                        128.272387, -97.907795,
                                                                                                                                                                        193.696812, -78.855567,
                                                                                                                                                                        128.272387, -78.855567,
                                                                                                                                                                        193.696812, -78.855567,
                                                                                                                                                                        128.272387, -97.907795,
                                                                                                                                                                        193.696812, -193.356748,
                                                                                                                                                                        46.231629, -159.362451,
                                                                                                                                                                        46.893288, -128.612451,
                                                                                                                                                                        46.231629, -128.612451,
                                                                                                                                                                        46.893288, -128.612451,
                                                                                                                                                                        46.231629, -159.362451,
                                                                                                                                                                        46.893288,
                                                                                                                                                                        128.272387, -78.341272,
                                                                                                                                                                        159.022387, -78.341272,
                                                                                                                                                                        128.272387, -78.866644,
                                                                                                                                                                        159.022387, -78.866644,
                                                                                                                                                                        128.272387, -78.866644,
                                                                                                                                                                        159.022387, -78.341272, -128.272387,
                                                                                                                                                                        80.823861, -159.022387,
                                                                                                                                                                        80.823861, -128.272387,
                                                                                                                                                                        81.349233, -159.022387,
                                                                                                                                                                        81.349233, -128.272387,
                                                                                                                                                                        81.349233, -159.022387,
                                                                                                                                                                        80.823861, -128.272387,
                                                                                                                                                                        79.686788, -159.022387,
                                                                                                                                                                        79.686788, -128.272387,
                                                                                                                                                                        80.21216,
                                                                                                                                                                        80.004263,
                                                                                                                                                                        11.504193,
                                                                                                                                                                        79.480484,
                                                                                                                                                                        11.54507,
                                                                                                                                                                        80.52494,
                                                                                                                                                                        11.574274, -79.480484,
                                                                                                                                                                        11.54507, -80.004263,
                                                                                                                                                                        11.504193, -80.52494,
                                                                                                                                                                        11.574274, -128.612451,
                                                                                                                                                                        52.331742, -128.612451,
                                                                                                                                                                        52.323416, -193.356748,
                                                                                                                                                                        52.331742,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        78.855567,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        78.105567,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        78.855567,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        97.907795,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        78.105567,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        97.907795,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        98.657795,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        78.105567,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        98.657795,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        97.907795,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        211.646256, -30.936364,
                                                                                                                                                                        195.693209, -34.963941,
                                                                                                                                                                        193.997368, -30.936364,
                                                                                                                                                                        198.943209, -34.963941,
                                                                                                                                                                        195.693209, -34.963941,
                                                                                                                                                                        211.646256, -30.936364,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        91.494355,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        91.494355,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        91.494355,
                                                                                                                                                                        97.101763,
                                                                                                                                                                        11.636346,
                                                                                                                                                                        96.380845,
                                                                                                                                                                        12.951746,
                                                                                                                                                                        97.759463,
                                                                                                                                                                        11.996804,
                                                                                                                                                                        97.038545,
                                                                                                                                                                        13.312205,
                                                                                                                                                                        97.759463,
                                                                                                                                                                        11.996804,
                                                                                                                                                                        96.380845,
                                                                                                                                                                        12.951746,
                                                                                                                                                                        198.943209, -34.963941,
                                                                                                                                                                        201.335011, -36.463941,
                                                                                                                                                                        198.943209, -36.463941,
                                                                                                                                                                        201.335011, -36.463941,
                                                                                                                                                                        198.943209, -34.963941,
                                                                                                                                                                        201.335011, -34.963941,
                                                                                                                                                                        201.335011, -34.963941,
                                                                                                                                                                        198.943209, -34.963941,
                                                                                                                                                                        211.646256, -30.936364,
                                                                                                                                                                        204.585011, -34.963941,
                                                                                                                                                                        201.335011, -34.963941,
                                                                                                                                                                        211.646256, -30.936364,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        91.494355,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        91.494355,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        91.494355,
                                                                                                                                                                        97.101763,
                                                                                                                                                                        11.636346,
                                                                                                                                                                        96.380845,
                                                                                                                                                                        12.951746,
                                                                                                                                                                        97.759463,
                                                                                                                                                                        11.996804,
                                                                                                                                                                        97.038545,
                                                                                                                                                                        13.312205,
                                                                                                                                                                        97.759463,
                                                                                                                                                                        11.996804,
                                                                                                                                                                        96.380845,
                                                                                                                                                                        12.951746,
                                                                                                                                                                        204.585011, -34.963941,
                                                                                                                                                                        206.767114, -36.463941,
                                                                                                                                                                        204.585011, -36.463941,
                                                                                                                                                                        206.767114, -36.463941,
                                                                                                                                                                        204.585011, -34.963941,
                                                                                                                                                                        206.767114, -34.963941,
                                                                                                                                                                        206.767114, -34.963941,
                                                                                                                                                                        204.585011, -34.963941,
                                                                                                                                                                        211.646256, -30.936364,
                                                                                                                                                                        210.017114, -34.963941,
                                                                                                                                                                        206.767114, -34.963941,
                                                                                                                                                                        211.646256, -30.936364,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        91.494355,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        91.494355,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        91.494355,
                                                                                                                                                                        97.101763,
                                                                                                                                                                        11.636346,
                                                                                                                                                                        96.380845,
                                                                                                                                                                        12.951746,
                                                                                                                                                                        97.759463,
                                                                                                                                                                        11.996804,
                                                                                                                                                                        97.038545,
                                                                                                                                                                        13.312205,
                                                                                                                                                                        97.759463,
                                                                                                                                                                        11.996804,
                                                                                                                                                                        96.380845,
                                                                                                                                                                        12.951746,
                                                                                                                                                                        210.017114, -34.963941,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        210.017114, -36.463941,
                                                                                                                                                                        211.646256, -30.936364,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        210.017114, -34.963941, -94.958394,
                                                                                                                                                                        17.107689, -94.75,
                                                                                                                                                                        16.357689, -98.657795,
                                                                                                                                                                        10.357689, -92.412129,
                                                                                                                                                                        17.107689, -94.75,
                                                                                                                                                                        16.357689, -94.958394,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        16.357689, -92.412129,
                                                                                                                                                                        17.107689, -94.75, -209.967373, -92.412129, -209.967373, -93.603703, -216.738938, -92.412129, -209.967373, -90.662129, -209.967373, -93.603703, -216.738938,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        132.176254,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        132.176254,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        132.384911,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        86.967706,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        86.967706,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        86.759049,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        86.759049,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        86.759049,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        86.967706,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        36.726488,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        36.517831,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        36.726488,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812, -15.548565,
                                                                                                                                                                        16.357689, -15.757222,
                                                                                                                                                                        16.357689, -15.548565,
                                                                                                                                                                        17.107689, -15.757222,
                                                                                                                                                                        17.107689, -15.548565,
                                                                                                                                                                        17.107689, -15.757222,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        92.595242,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.595242,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        94.701709,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        94.701709,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        94.701709,
                                                                                                                                                                        211.690127, -67.162982,
                                                                                                                                                                        17.107689, -66.954325,
                                                                                                                                                                        17.107689, -67.162982,
                                                                                                                                                                        16.357689, -66.954325,
                                                                                                                                                                        16.357689, -67.162982,
                                                                                                                                                                        16.357689, -66.954325,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812, -114.63594,
                                                                                                                                                                        16.357689, -114.844597,
                                                                                                                                                                        16.357689, -114.63594,
                                                                                                                                                                        17.107689, -114.844597,
                                                                                                                                                                        17.107689, -114.63594,
                                                                                                                                                                        17.107689, -114.844597,
                                                                                                                                                                        16.357689, -155.94538,
                                                                                                                                                                        16.357689, -156.154037,
                                                                                                                                                                        16.357689, -155.94538,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812, -188.5885,
                                                                                                                                                                        16.357689, -188.797157,
                                                                                                                                                                        16.357689, -188.5885,
                                                                                                                                                                        17.107689, -188.797157,
                                                                                                                                                                        17.107689, -188.5885,
                                                                                                                                                                        17.107689, -188.797157,
                                                                                                                                                                        16.357689, -210.752443,
                                                                                                                                                                        17.107689, -210.752443,
                                                                                                                                                                        16.357689, -210.961101,
                                                                                                                                                                        17.107689, -210.961101,
                                                                                                                                                                        16.357689, -210.961101,
                                                                                                                                                                        17.107689, -210.752443,
                                                                                                                                                                        16.357689, -221.206321,
                                                                                                                                                                        17.107689, -221.206321,
                                                                                                                                                                        16.357689, -221.414978,
                                                                                                                                                                        17.107689, -221.414978,
                                                                                                                                                                        16.357689, -221.414978,
                                                                                                                                                                        17.107689, -221.206321,
                                                                                                                                                                        16.357689, -219.36957,
                                                                                                                                                                        17.107689, -219.36957,
                                                                                                                                                                        16.357689, -219.578227,
                                                                                                                                                                        17.107689, -219.578227,
                                                                                                                                                                        16.357689, -219.578227,
                                                                                                                                                                        17.107689, -219.36957,
                                                                                                                                                                        16.357689, -202.196812,
                                                                                                                                                                        17.107689, -202.196812,
                                                                                                                                                                        16.357689, -211.946812,
                                                                                                                                                                        17.107689, -211.946812,
                                                                                                                                                                        16.357689, -211.946812,
                                                                                                                                                                        17.107689, -202.196812,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812, -156.154037,
                                                                                                                                                                        17.107689, -155.94538,
                                                                                                                                                                        17.107689, -156.154037,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        88.273781,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        88.273781,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        88.273781,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        88.273781,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        201.652108, -85.701474,
                                                                                                                                                                        17.107689, -85.701474,
                                                                                                                                                                        16.357689, -91.465361,
                                                                                                                                                                        17.107689, -154.559402,
                                                                                                                                                                        16.357689, -154.559402,
                                                                                                                                                                        17.107689, -150.839748,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        83.077628,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        83.077628,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        193.953497, -193.907272,
                                                                                                                                                                        54.10827, -193.907272,
                                                                                                                                                                        46.831914, -197.149134,
                                                                                                                                                                        48.573046, -211.736351,
                                                                                                                                                                        46.831914, -197.149134,
                                                                                                                                                                        48.573046, -193.907272,
                                                                                                                                                                        46.831914, -200.399134,
                                                                                                                                                                        48.573046, -197.149134,
                                                                                                                                                                        48.573046, -211.736351,
                                                                                                                                                                        46.831914,
                                                                                                                                                                        197.149134, -63.515363,
                                                                                                                                                                        200.399134, -63.515363,
                                                                                                                                                                        197.149134, -64.515363,
                                                                                                                                                                        200.399134, -64.515363,
                                                                                                                                                                        197.149134, -64.515363,
                                                                                                                                                                        200.399134, -63.515363,
                                                                                                                                                                        79.920459,
                                                                                                                                                                        11.588495,
                                                                                                                                                                        79.043525,
                                                                                                                                                                        12.069107,
                                                                                                                                                                        80.641376,
                                                                                                                                                                        12.903895,
                                                                                                                                                                        79.764443,
                                                                                                                                                                        13.384507,
                                                                                                                                                                        80.641376,
                                                                                                                                                                        12.903895,
                                                                                                                                                                        79.043525,
                                                                                                                                                                        12.069107, -200.399134, -63.515363, -197.149134, -63.515363, -200.399134, -64.515363, -200.399134,
                                                                                                                                                                        50.073046, -211.736351,
                                                                                                                                                                        54.10827, -197.149134,
                                                                                                                                                                        50.073046, -202.141638,
                                                                                                                                                                        50.073046, -211.736351,
                                                                                                                                                                        54.10827, -200.399134,
                                                                                                                                                                        50.073046, -205.391638,
                                                                                                                                                                        50.073046, -211.736351,
                                                                                                                                                                        54.10827, -202.141638,
                                                                                                                                                                        50.073046, -205.391638,
                                                                                                                                                                        48.573046, -211.736351,
                                                                                                                                                                        54.10827, -205.391638,
                                                                                                                                                                        50.073046, -207.202139,
                                                                                                                                                                        50.073046, -211.736351,
                                                                                                                                                                        54.10827, -205.391638,
                                                                                                                                                                        48.573046, -210.452139,
                                                                                                                                                                        50.073046, -211.736351,
                                                                                                                                                                        54.10827, -207.202139,
                                                                                                                                                                        50.073046, -210.452139,
                                                                                                                                                                        48.573046, -211.736351,
                                                                                                                                                                        54.10827, -210.452139,
                                                                                                                                                                        50.073046, -211.736351,
                                                                                                                                                                        54.10827, -210.452139,
                                                                                                                                                                        48.573046, -211.736351,
                                                                                                                                                                        46.831914, -210.452139,
                                                                                                                                                                        48.573046, -207.202139,
                                                                                                                                                                        48.573046, -211.736351,
                                                                                                                                                                        46.831914,
                                                                                                                                                                        207.202139, -63.515363,
                                                                                                                                                                        210.452139, -63.515363,
                                                                                                                                                                        207.202139, -64.515363,
                                                                                                                                                                        210.452139, -64.515363,
                                                                                                                                                                        207.202139, -64.515363,
                                                                                                                                                                        210.452139, -63.515363,
                                                                                                                                                                        79.920459,
                                                                                                                                                                        11.588495,
                                                                                                                                                                        79.043525,
                                                                                                                                                                        12.069107,
                                                                                                                                                                        80.641376,
                                                                                                                                                                        12.903895,
                                                                                                                                                                        79.764443,
                                                                                                                                                                        13.384507,
                                                                                                                                                                        80.641376,
                                                                                                                                                                        12.903895,
                                                                                                                                                                        79.043525,
                                                                                                                                                                        12.069107, -210.452139, -63.515363, -207.202139, -63.515363, -210.452139, -64.515363, -207.202139, -64.515363, -210.452139, -64.515363, -207.202139, -63.515363, -79.920459,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        12.903895, -79.043525,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        12.903895, -207.202139,
                                                                                                                                                                        50.073046, -205.391638,
                                                                                                                                                                        48.573046, -207.202139,
                                                                                                                                                                        48.573046, -207.202139,
                                                                                                                                                                        48.573046, -205.391638,
                                                                                                                                                                        48.573046, -211.736351,
                                                                                                                                                                        46.831914, -205.391638,
                                                                                                                                                                        48.573046, -202.141638,
                                                                                                                                                                        48.573046, -211.736351,
                                                                                                                                                                        46.831914,
                                                                                                                                                                        202.141638, -63.515363,
                                                                                                                                                                        205.391638, -63.515363,
                                                                                                                                                                        202.141638, -64.515363,
                                                                                                                                                                        205.391638, -64.515363,
                                                                                                                                                                        202.141638, -64.515363,
                                                                                                                                                                        205.391638, -63.515363,
                                                                                                                                                                        79.920459,
                                                                                                                                                                        11.588495,
                                                                                                                                                                        79.043525,
                                                                                                                                                                        12.069107,
                                                                                                                                                                        80.641376,
                                                                                                                                                                        12.903895,
                                                                                                                                                                        79.764443,
                                                                                                                                                                        13.384507,
                                                                                                                                                                        80.641376,
                                                                                                                                                                        12.903895,
                                                                                                                                                                        79.043525,
                                                                                                                                                                        12.069107, -205.391638, -63.515363, -202.141638, -63.515363, -205.391638, -64.515363, -202.141638, -64.515363, -205.391638, -64.515363, -202.141638, -63.515363, -79.920459,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        12.903895, -79.043525,
                                                                                                                                                                        12.069107, -79.764443,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        12.903895, -202.141638,
                                                                                                                                                                        50.073046, -200.399134,
                                                                                                                                                                        48.573046, -202.141638,
                                                                                                                                                                        48.573046, -200.399134,
                                                                                                                                                                        48.573046, -202.141638,
                                                                                                                                                                        50.073046, -200.399134,
                                                                                                                                                                        50.073046, -202.141638,
                                                                                                                                                                        48.573046, -200.399134,
                                                                                                                                                                        48.573046, -211.736351,
                                                                                                                                                                        46.831914,
                                                                                                                                                                        81.804968,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        78.105567,
                                                                                                                                                                        10.357689, -193.696812,
                                                                                                                                                                        10.357689, -193.696812,
                                                                                                                                                                        8.857689, -211.946812,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        78.105567,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        98.657795,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        78.105567,
                                                                                                                                                                        8.857689,
                                                                                                                                                                        98.657795,
                                                                                                                                                                        8.857689,
                                                                                                                                                                        78.105567,
                                                                                                                                                                        8.857689,
                                                                                                                                                                        98.657795,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        193.696812, -98.657795,
                                                                                                                                                                        211.946812, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        8.857689,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        8.857689,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        8.857689, -78.855567,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        10.357689, -81.804968,
                                                                                                                                                                        17.107689, -82.013362,
                                                                                                                                                                        16.357689, -81.804968,
                                                                                                                                                                        17.107689, -78.855567,
                                                                                                                                                                        10.357689, -90.662129,
                                                                                                                                                                        16.357689, -81.804968,
                                                                                                                                                                        17.107689, -82.013362,
                                                                                                                                                                        16.357689, -90.662129,
                                                                                                                                                                        17.107689, -81.804968,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        83.077628,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        207.652108,
                                                                                                                                                                        83.077628,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        175.308391,
                                                                                                                                                                        110.557579,
                                                                                                                                                                        177.738391,
                                                                                                                                                                        110.557579,
                                                                                                                                                                        175.612141,
                                                                                                                                                                        109.831774,
                                                                                                                                                                        177.434641,
                                                                                                                                                                        109.831774,
                                                                                                                                                                        175.612141,
                                                                                                                                                                        109.831774,
                                                                                                                                                                        177.738391,
                                                                                                                                                                        110.557579,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        206.474608,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        202.829608,
                                                                                                                                                                        84.097373,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        87.254036,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        202.829608,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        206.474608, -177.434641, -85.006298, -177.738391, -84.280494, -175.612141, -85.006298, -203.740858,
                                                                                                                                                                        74.516075, -205.563358,
                                                                                                                                                                        74.516075, -203.437108,
                                                                                                                                                                        75.241879,
                                                                                                                                                                        87.254036,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        87.254036,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        206.474608, -29.039967,
                                                                                                                                                                        171.935111, -29.343717,
                                                                                                                                                                        172.660916, -27.217467,
                                                                                                                                                                        171.935111, -26.913717,
                                                                                                                                                                        172.660916, -27.217467,
                                                                                                                                                                        171.935111, -29.343717,
                                                                                                                                                                        172.660916, -205.867108,
                                                                                                                                                                        75.241879, -203.437108,
                                                                                                                                                                        75.241879, -205.563358,
                                                                                                                                                                        74.516075,
                                                                                                                                                                        88.273781,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        207.652108,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        83.077628,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        83.077628,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        203.437108, -48.964794,
                                                                                                                                                                        205.867108, -48.964794,
                                                                                                                                                                        203.740858, -49.690599,
                                                                                                                                                                        205.563358, -49.690599,
                                                                                                                                                                        203.740858, -49.690599,
                                                                                                                                                                        205.867108, -48.964794,
                                                                                                                                                                        84.097373,
                                                                                                                                                                        203.740858,
                                                                                                                                                                        84.097373,
                                                                                                                                                                        205.563358,
                                                                                                                                                                        85.675705,
                                                                                                                                                                        202.829608,
                                                                                                                                                                        27.217467, -147.109635,
                                                                                                                                                                        26.913717, -146.383831,
                                                                                                                                                                        29.039967, -147.109635, -175.308391, -84.280494, -175.612141, -85.006298, -177.738391, -84.280494,
                                                                                                                                                                        29.343717, -146.383831,
                                                                                                                                                                        29.039967, -147.109635,
                                                                                                                                                                        26.913717, -146.383831,
                                                                                                                                                                        36.517831,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        36.726488,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        36.517831,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        132.384911,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        132.384911,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        132.176254,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        170.247172,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        170.247172,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        170.45583,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        170.45583,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        170.45583,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        170.247172,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        90.718115,
                                                                                                                                                                        201.995806, -82.013362, -209.967373, -83.159659, -216.738938, -90.662129, -209.967373, -224.344938,
                                                                                                                                                                        31.155361, -223.69026,
                                                                                                                                                                        24.406801, -231.185932,
                                                                                                                                                                        30.547991, -230.649096,
                                                                                                                                                                        25.014171, -231.185932,
                                                                                                                                                                        30.547991, -223.69026,
                                                                                                                                                                        24.406801,
                                                                                                                                                                        157.70418, -66.631022,
                                                                                                                                                                        158.539106, -62.485631,
                                                                                                                                                                        158.557327, -66.50666,
                                                                                                                                                                        159.342158, -62.609993,
                                                                                                                                                                        158.557327, -66.50666,
                                                                                                                                                                        158.539106, -62.485631, -92.95612,
                                                                                                                                                                        15.11644, -93.835758,
                                                                                                                                                                        12.185546, -94.807379,
                                                                                                                                                                        11.598939, -92.601962,
                                                                                                                                                                        14.529833, -93.835758,
                                                                                                                                                                        12.185546, -92.95612,
                                                                                                                                                                        15.11644, -219.446812, -32.919308, -219.446812, -30.270169, -211.946812, -32.919308, -211.946812, -30.270169, -211.946812, -32.919308, -219.446812, -30.270169, -92.601962,
                                                                                                                                                                        211.946812, -92.601962,
                                                                                                                                                                        219.446812, -84.1614,
                                                                                                                                                                        211.946812, -84.1614,
                                                                                                                                                                        219.446812, -84.1614,
                                                                                                                                                                        211.946812, -92.601962,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        52.054708,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        49.405569,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        52.054708, -84.1614,
                                                                                                                                                                        14.529833, -83.807242,
                                                                                                                                                                        15.11644, -82.927603,
                                                                                                                                                                        12.185546, -92.601962,
                                                                                                                                                                        14.529833, -83.807242,
                                                                                                                                                                        15.11644, -84.1614,
                                                                                                                                                                        14.529833, -83.807242,
                                                                                                                                                                        15.11644, -92.601962,
                                                                                                                                                                        14.529833, -92.95612,
                                                                                                                                                                        15.11644, -92.95612, -214.791365, -93.248106, -214.03301, -83.807242, -214.791365, -83.515256, -214.03301, -83.807242, -214.791365, -93.248106, -214.03301, -233.47695,
                                                                                                                                                                        6.399166, -232.642024,
                                                                                                                                                                        2.253776, -234.280002,
                                                                                                                                                                        6.274804, -93.603703, -216.738938, -90.662129, -209.967373, -83.159659, -216.738938, -233.495171,
                                                                                                                                                                        2.378137, -234.280002,
                                                                                                                                                                        6.274804, -232.642024,
                                                                                                                                                                        2.253776, -83.807242,
                                                                                                                                                                        15.11644, -81.955983,
                                                                                                                                                                        11.598939, -82.927603,
                                                                                                                                                                        12.185546, -94.807379,
                                                                                                                                                                        11.598939, -82.927603,
                                                                                                                                                                        12.185546, -81.955983,
                                                                                                                                                                        11.598939, -82.927603,
                                                                                                                                                                        12.185546, -94.807379,
                                                                                                                                                                        11.598939, -93.835758,
                                                                                                                                                                        12.185546,
                                                                                                                                                                        93.835758,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        93.835758,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        82.927603,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        82.927603,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        93.835758,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        49.405569,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        52.054708,
                                                                                                                                                                        219.446812,
                                                                                                                                                                        49.405569, -94.807379,
                                                                                                                                                                        218.746091, -81.955983,
                                                                                                                                                                        218.746091, -95.217529,
                                                                                                                                                                        217.987735, -81.545833,
                                                                                                                                                                        217.987735, -95.217529,
                                                                                                                                                                        217.987735, -81.955983,
                                                                                                                                                                        218.746091,
                                                                                                                                                                        194.539131, -48.608249,
                                                                                                                                                                        194.002295, -54.142069,
                                                                                                                                                                        187.698137, -48.000879,
                                                                                                                                                                        187.043459, -54.749439,
                                                                                                                                                                        187.698137, -48.000879,
                                                                                                                                                                        194.002295, -54.142069, -94.75,
                                                                                                                                                                        16.357689, -97.907795,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        10.357689, -97.907795,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        10.357689, -78.855567,
                                                                                                                                                                        212.097796, -97.907795,
                                                                                                                                                                        212.097796, -80.570267,
                                                                                                                                                                        218.869362, -96.193095,
                                                                                                                                                                        218.869362, -80.570267,
                                                                                                                                                                        218.869362, -97.907795,
                                                                                                                                                                        212.097796, -78.105567,
                                                                                                                                                                        8.857689, -98.657795,
                                                                                                                                                                        8.857689, -78.105567,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        211.946812, -78.105567,
                                                                                                                                                                        193.696812, -98.657795,
                                                                                                                                                                        211.946812, -211.946812,
                                                                                                                                                                        8.857689, -211.946812,
                                                                                                                                                                        10.357689, -193.696812,
                                                                                                                                                                        8.857689,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        193.997368, -38.032529,
                                                                                                                                                                        195.693209, -36.463941,
                                                                                                                                                                        193.997368, -30.936364,
                                                                                                                                                                        195.693209, -36.463941,
                                                                                                                                                                        193.997368, -38.032529,
                                                                                                                                                                        195.693209, -36.463941,
                                                                                                                                                                        193.997368, -30.936364,
                                                                                                                                                                        195.693209, -34.963941, -97.038545,
                                                                                                                                                                        13.312205, -96.380845,
                                                                                                                                                                        12.951746, -97.759463,
                                                                                                                                                                        11.996804, -97.101763,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        11.996804, -96.380845,
                                                                                                                                                                        12.951746, -195.693209,
                                                                                                                                                                        90.744355, -198.943209,
                                                                                                                                                                        90.744355, -195.693209,
                                                                                                                                                                        91.494355, -198.943209,
                                                                                                                                                                        91.494355, -195.693209,
                                                                                                                                                                        91.494355, -198.943209,
                                                                                                                                                                        90.744355,
                                                                                                                                                                        198.943209, -36.463941,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        195.693209, -36.463941,
                                                                                                                                                                        201.335011, -36.463941,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        198.943209, -36.463941,
                                                                                                                                                                        204.585011, -36.463941,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        201.335011, -36.463941,
                                                                                                                                                                        206.767114, -36.463941,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        204.585011, -36.463941,
                                                                                                                                                                        210.017114, -36.463941,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        206.767114, -36.463941, -210.017114,
                                                                                                                                                                        91.494355, -206.767114,
                                                                                                                                                                        91.494355, -210.017114,
                                                                                                                                                                        90.744355, -206.767114,
                                                                                                                                                                        90.744355, -210.017114,
                                                                                                                                                                        90.744355, -206.767114,
                                                                                                                                                                        91.494355, -97.101763,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        11.996804, -96.380845,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        13.312205, -96.380845,
                                                                                                                                                                        12.951746, -97.759463,
                                                                                                                                                                        11.996804, -204.585011,
                                                                                                                                                                        91.494355, -201.335011,
                                                                                                                                                                        91.494355, -204.585011,
                                                                                                                                                                        90.744355, -201.335011,
                                                                                                                                                                        90.744355, -204.585011,
                                                                                                                                                                        90.744355, -201.335011,
                                                                                                                                                                        91.494355, -97.101763,
                                                                                                                                                                        11.636346, -97.759463,
                                                                                                                                                                        11.996804, -96.380845,
                                                                                                                                                                        12.951746, -97.038545,
                                                                                                                                                                        13.312205, -96.380845,
                                                                                                                                                                        12.951746, -97.759463,
                                                                                                                                                                        11.996804, -193.907272,
                                                                                                                                                                        54.10827, -197.149134,
                                                                                                                                                                        50.073046, -211.736351,
                                                                                                                                                                        54.10827, -197.149134,
                                                                                                                                                                        50.073046, -193.907272,
                                                                                                                                                                        54.10827, -197.149134,
                                                                                                                                                                        48.573046, -79.764443,
                                                                                                                                                                        13.384507, -79.043525,
                                                                                                                                                                        12.069107, -80.641376,
                                                                                                                                                                        12.903895, -79.920459,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        12.903895, -79.043525,
                                                                                                                                                                        12.069107, -197.149134, -64.515363, -200.399134, -64.515363, -197.149134, -63.515363, -76.813936,
                                                                                                                                                                        9.316059, -99.949426,
                                                                                                                                                                        9.316059, -76.813936,
                                                                                                                                                                        10.244433, -76.813936,
                                                                                                                                                                        128.272387, -76.813936,
                                                                                                                                                                        126.022387, -99.949426,
                                                                                                                                                                        128.272387, -128.272387,
                                                                                                                                                                        9.316059, -128.272387,
                                                                                                                                                                        10.244433, -126.022387,
                                                                                                                                                                        9.316059, -126.022387,
                                                                                                                                                                        10.244433, -126.022387,
                                                                                                                                                                        9.316059, -128.272387,
                                                                                                                                                                        10.244433, -126.022387,
                                                                                                                                                                        8.607689, -126.022387,
                                                                                                                                                                        10.357689, -91.569337,
                                                                                                                                                                        8.607689, -90.558974,
                                                                                                                                                                        10.357689, -91.569337,
                                                                                                                                                                        8.607689, -126.022387,
                                                                                                                                                                        10.357689, -110.63459, -9.3104, -107.386674, -9.078753, -111.041794, -10.916607, -110.045457, -10.916607, -111.041794, -10.916607, -107.386674, -9.078753,
                                                                                                                                                                        55.189544, -82.685555,
                                                                                                                                                                        53.973757, -79.462447,
                                                                                                                                                                        60.976581, -82.685555,
                                                                                                                                                                        60.620245, -79.462447,
                                                                                                                                                                        60.976581, -82.685555,
                                                                                                                                                                        53.973757, -79.462447,
                                                                                                                                                                        31.974321, -92.96191,
                                                                                                                                                                        32.330658, -89.738802,
                                                                                                                                                                        42.155364, -92.96191,
                                                                                                                                                                        41.799028, -89.738802,
                                                                                                                                                                        42.155364, -92.96191,
                                                                                                                                                                        32.330658, -89.738802,
                                                                                                                                                                        10.627196, -98.797381,
                                                                                                                                                                        10.983533, -95.574273,
                                                                                                                                                                        20.808239, -98.797381,
                                                                                                                                                                        20.451903, -95.574273,
                                                                                                                                                                        20.808239, -98.797381,
                                                                                                                                                                        10.983533, -95.574273, -11.791065, -99.794291, -11.434729, -96.571183, -1.610022, -99.794291, -1.966359, -96.571183, -1.610022, -99.794291, -11.434729, -96.571183, -33.752696, -95.884702, -33.396359, -92.661594, -23.571653, -95.884702, -23.927989, -92.661594, -23.571653, -95.884702, -33.396359, -92.661594, -53.40471, -84.111938, -43.93634, -84.111938, -53.761046, -87.335046, -70.096245, -71.50486, -60.627875, -71.50486, -70.452581, -74.727968, -60.271538, -74.727968, -70.452581, -74.727968, -60.627875, -71.50486, -28.906057,
                                                                                                                                                                        114.316071, -19.5,
                                                                                                                                                                        110.419955, -20.595623,
                                                                                                                                                                        108.522279, -20.595623,
                                                                                                                                                                        108.522279, -19.5,
                                                                                                                                                                        110.419955, -12.972281,
                                                                                                                                                                        102.672683, -19.5,
                                                                                                                                                                        110.419955, -11.422836,
                                                                                                                                                                        104.222129, -12.972281,
                                                                                                                                                                        102.672683, -72.508757, -58.922619, -82.6898, -58.922619, -72.865093, -55.699511, -82.333463, -55.699511, -72.865093, -55.699511, -82.6898, -58.922619, -85.813962, -0.50444, -76.345592, -0.50444, -86.170299, -3.727548, -75.989256, -3.727548, -86.170299, -3.727548, -76.345592, -0.50444,
                                                                                                                                                                        0,
                                                                                                                                                                        76.644964, -1.328893,
                                                                                                                                                                        66.551021, -1.328893,
                                                                                                                                                                        86.738907, -75.989256,
                                                                                                                                                                        13.074711, -75.632919,
                                                                                                                                                                        16.297818, -65.808213,
                                                                                                                                                                        13.074711, -66.164549,
                                                                                                                                                                        16.297818, -65.808213,
                                                                                                                                                                        13.074711, -75.632919,
                                                                                                                                                                        16.297818, -60.976581,
                                                                                                                                                                        27.091632, -60.620245,
                                                                                                                                                                        30.31474, -50.795538,
                                                                                                                                                                        27.091632, -51.151875,
                                                                                                                                                                        30.31474, -50.795538,
                                                                                                                                                                        27.091632, -60.620245,
                                                                                                                                                                        30.31474, -42.155364,
                                                                                                                                                                        37.367987, -41.799028,
                                                                                                                                                                        40.591095, -31.974321,
                                                                                                                                                                        37.367987, -32.330658,
                                                                                                                                                                        40.591095, -31.974321,
                                                                                                                                                                        37.367987, -41.799028,
                                                                                                                                                                        40.591095, -20.808239,
                                                                                                                                                                        43.203458, -20.451903,
                                                                                                                                                                        46.426566, -10.627196,
                                                                                                                                                                        43.203458, -10.983533,
                                                                                                                                                                        46.426566, -10.627196,
                                                                                                                                                                        43.203458, -20.451903,
                                                                                                                                                                        46.426566,
                                                                                                                                                                        1.610022,
                                                                                                                                                                        44.200368,
                                                                                                                                                                        1.966359,
                                                                                                                                                                        47.423476,
                                                                                                                                                                        11.791065,
                                                                                                                                                                        44.200368,
                                                                                                                                                                        11.434729,
                                                                                                                                                                        47.423476,
                                                                                                                                                                        11.791065,
                                                                                                                                                                        44.200368,
                                                                                                                                                                        1.966359,
                                                                                                                                                                        47.423476,
                                                                                                                                                                        23.571653,
                                                                                                                                                                        40.290779,
                                                                                                                                                                        23.927989,
                                                                                                                                                                        43.513887,
                                                                                                                                                                        33.752696,
                                                                                                                                                                        40.290779,
                                                                                                                                                                        33.396359,
                                                                                                                                                                        43.513887,
                                                                                                                                                                        33.752696,
                                                                                                                                                                        40.290779,
                                                                                                                                                                        23.927989,
                                                                                                                                                                        43.513887,
                                                                                                                                                                        43.580003,
                                                                                                                                                                        31.741123,
                                                                                                                                                                        43.93634,
                                                                                                                                                                        34.964231,
                                                                                                                                                                        53.761046,
                                                                                                                                                                        31.741123,
                                                                                                                                                                        53.40471,
                                                                                                                                                                        34.964231,
                                                                                                                                                                        53.761046,
                                                                                                                                                                        31.741123,
                                                                                                                                                                        43.93634,
                                                                                                                                                                        34.964231,
                                                                                                                                                                        60.627875,
                                                                                                                                                                        22.357153,
                                                                                                                                                                        70.096245,
                                                                                                                                                                        22.357153,
                                                                                                                                                                        60.271538,
                                                                                                                                                                        19.134045,
                                                                                                                                                                        48.14141,
                                                                                                                                                                        15.875072,
                                                                                                                                                                        48.047815,
                                                                                                                                                                        15.857689,
                                                                                                                                                                        48.14141,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        48.14141,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        48.047815,
                                                                                                                                                                        15.857689,
                                                                                                                                                                        46.314043,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        46.314043,
                                                                                                                                                                        15.432602,
                                                                                                                                                                        46.314043,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        48.047815,
                                                                                                                                                                        15.857689,
                                                                                                                                                                        48.14141, -10.363679,
                                                                                                                                                                        46.314043, -10.363679,
                                                                                                                                                                        48.022631, -8.822092,
                                                                                                                                                                        46.432822, -8.822092,
                                                                                                                                                                        48.022631, -8.822092,
                                                                                                                                                                        46.314043, -10.363679,
                                                                                                                                                                        45.09,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        44.882488,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        44.882488,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        58.203674, -0.759881,
                                                                                                                                                                        58.322453, -2.301469,
                                                                                                                                                                        56.613865, -0.759881,
                                                                                                                                                                        56.495086, -2.301469,
                                                                                                                                                                        56.613865, -0.759881,
                                                                                                                                                                        58.322453, -2.301469,
                                                                                                                                                                        64.472404,
                                                                                                                                                                        8.569779,
                                                                                                                                                                        64.591183,
                                                                                                                                                                        7.028191,
                                                                                                                                                                        62.882595,
                                                                                                                                                                        8.569779,
                                                                                                                                                                        62.763816,
                                                                                                                                                                        7.028191,
                                                                                                                                                                        62.882595,
                                                                                                                                                                        8.569779,
                                                                                                                                                                        64.591183,
                                                                                                                                                                        7.028191,
                                                                                                                                                                        66.401618,
                                                                                                                                                                        18.531088,
                                                                                                                                                                        66.520397,
                                                                                                                                                                        16.9895,
                                                                                                                                                                        64.811809,
                                                                                                                                                                        18.531088,
                                                                                                                                                                        44.274095,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        43.30628,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        43.30628,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        42.045,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        43.30628,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        42.045,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        42.045,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        62.270034,
                                                                                                                                                                        28.445199,
                                                                                                                                                                        63.859843,
                                                                                                                                                                        28.445199,
                                                                                                                                                                        62.151255,
                                                                                                                                                                        26.903612,
                                                                                                                                                                        57.139075,
                                                                                                                                                                        36.094895,
                                                                                                                                                                        55.311708,
                                                                                                                                                                        36.094895,
                                                                                                                                                                        57.020296,
                                                                                                                                                                        37.636483,
                                                                                                                                                                        55.430487,
                                                                                                                                                                        37.636483,
                                                                                                                                                                        57.020296,
                                                                                                                                                                        37.636483,
                                                                                                                                                                        55.311708,
                                                                                                                                                                        36.094895,
                                                                                                                                                                        42.045,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        40.576208,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        40.576208,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        40.576208,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        40.576208,
                                                                                                                                                                        46.887212,
                                                                                                                                                                        39,
                                                                                                                                                                        58.8597, -32.573426, -15.759998, -30.983617, -15.759998, -32.692205, -17.301585, -14.923528, -20.970363, -16.750895, -20.970363, -15.042307, -19.428776, -16.632116, -19.428776, -15.042307, -19.428776, -16.750895, -20.970363,
                                                                                                                                                                        42.045,
                                                                                                                                                                        58.043795,
                                                                                                                                                                        42.045,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        40.576208,
                                                                                                                                                                        58.652189,
                                                                                                                                                                        2.097061, -22.099436,
                                                                                                                                                                        0.269695, -22.099436,
                                                                                                                                                                        1.978282, -20.557849,
                                                                                                                                                                        0.388473, -20.557849,
                                                                                                                                                                        1.978282, -20.557849,
                                                                                                                                                                        0.269695, -22.099436,
                                                                                                                                                                        19.037006, -20.611861,
                                                                                                                                                                        17.209639, -20.611861,
                                                                                                                                                                        18.918227, -19.070274,
                                                                                                                                                                        19.037006,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        18.73076,
                                                                                                                                                                        16.508918,
                                                                                                                                                                        17.209639,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        17.209639,
                                                                                                                                                                        16.226418,
                                                                                                                                                                        17.209639,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        18.73076,
                                                                                                                                                                        16.508918,
                                                                                                                                                                        34.741875,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        34.741875,
                                                                                                                                                                        16.226418,
                                                                                                                                                                        32.914509,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        32.914509,
                                                                                                                                                                        15.875072,
                                                                                                                                                                        32.914509,
                                                                                                                                                                        25.107689,
                                                                                                                                                                        34.741875,
                                                                                                                                                                        16.226418,
                                                                                                                                                                        8.314555,
                                                                                                                                                                        17.336396,
                                                                                                                                                                        49.046219,
                                                                                                                                                                        16.787915,
                                                                                                                                                                        13.734043,
                                                                                                                                                                        16.504471,
                                                                                                                                                                        13.734043,
                                                                                                                                                                        16.504471,
                                                                                                                                                                        49.046219,
                                                                                                                                                                        16.787915,
                                                                                                                                                                        18.302948,
                                                                                                                                                                        15.578558,
                                                                                                                                                                        18.302948,
                                                                                                                                                                        15.578558,
                                                                                                                                                                        49.046219,
                                                                                                                                                                        16.787915,
                                                                                                                                                                        27.459507,
                                                                                                                                                                        13.423946,
                                                                                                                                                                        27.459507,
                                                                                                                                                                        13.423946,
                                                                                                                                                                        49.046219,
                                                                                                                                                                        16.787915,
                                                                                                                                                                        28.67278,
                                                                                                                                                                        10.817456,
                                                                                                                                                                        49.046219,
                                                                                                                                                                        16.787915,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        10.542366,
                                                                                                                                                                        28.67278,
                                                                                                                                                                        10.817456, -37.410797,
                                                                                                                                                                        67.791071, -35.939548,
                                                                                                                                                                        71.326604, -22.5,
                                                                                                                                                                        67.791071, -22.5,
                                                                                                                                                                        71.326604, -22.5,
                                                                                                                                                                        67.791071, -35.939548,
                                                                                                                                                                        71.326604, -82.013362,
                                                                                                                                                                        18.857689, -68.878718,
                                                                                                                                                                        17.920189, -79.513362,
                                                                                                                                                                        16.357689, -70.209662,
                                                                                                                                                                        19.654709, -68.878718,
                                                                                                                                                                        17.920189, -82.013362,
                                                                                                                                                                        18.857689, -22.5,
                                                                                                                                                                        56.147749, -22.5,
                                                                                                                                                                        58.334063, -5,
                                                                                                                                                                        56.147749, -5,
                                                                                                                                                                        58.334063, -5,
                                                                                                                                                                        56.147749, -22.5,
                                                                                                                                                                        58.334063,
                                                                                                                                                                        35.128334,
                                                                                                                                                                        46.874504,
                                                                                                                                                                        35.886525,
                                                                                                                                                                        48.925142,
                                                                                                                                                                        37.147779,
                                                                                                                                                                        46.577464,
                                                                                                                                                                        37.860478,
                                                                                                                                                                        48.505063,
                                                                                                                                                                        37.147779,
                                                                                                                                                                        46.577464,
                                                                                                                                                                        35.886525,
                                                                                                                                                                        48.925142,
                                                                                                                                                                        67.137502,
                                                                                                                                                                        24.010633,
                                                                                                                                                                        69.187908,
                                                                                                                                                                        23.269201,
                                                                                                                                                                        65.940369,
                                                                                                                                                                        22.340169,
                                                                                                                                                                        70.038038,
                                                                                                                                                                        24.219015,
                                                                                                                                                                        67.995273,
                                                                                                                                                                        24.981246,
                                                                                                                                                                        71.410079,
                                                                                                                                                                        25.365458,
                                                                                                                                                                        69.572331,
                                                                                                                                                                        26.298996,
                                                                                                                                                                        71.410079,
                                                                                                                                                                        25.365458,
                                                                                                                                                                        67.995273,
                                                                                                                                                                        24.981246,
                                                                                                                                                                        72.625483,
                                                                                                                                                                        24.866547,
                                                                                                                                                                        70.810195,
                                                                                                                                                                        25.843042,
                                                                                                                                                                        74.246761,
                                                                                                                                                                        25.620393,
                                                                                                                                                                        72.673733,
                                                                                                                                                                        26.709532,
                                                                                                                                                                        74.246761,
                                                                                                                                                                        25.620393,
                                                                                                                                                                        70.810195,
                                                                                                                                                                        25.843042,
                                                                                                                                                                        75.662015,
                                                                                                                                                                        21.919976,
                                                                                                                                                                        74.148228,
                                                                                                                                                                        23.090057,
                                                                                                                                                                        77.428516,
                                                                                                                                                                        22.196208,
                                                                                                                                                                        76.178688,
                                                                                                                                                                        23.407564,
                                                                                                                                                                        77.428516,
                                                                                                                                                                        22.196208,
                                                                                                                                                                        74.148228,
                                                                                                                                                                        23.090057,
                                                                                                                                                                        76.716681,
                                                                                                                                                                        19.347766,
                                                                                                                                                                        95.046681,
                                                                                                                                                                        19.347766,
                                                                                                                                                                        77.908131,
                                                                                                                                                                        18.078948,
                                                                                                                                                                        95.046681,
                                                                                                                                                                        9.086595,
                                                                                                                                                                        76.716681,
                                                                                                                                                                        9.086595,
                                                                                                                                                                        95.631681,
                                                                                                                                                                        10.907311,
                                                                                                                                                                        76.131681,
                                                                                                                                                                        10.907311,
                                                                                                                                                                        95.631681,
                                                                                                                                                                        10.907311,
                                                                                                                                                                        76.716681,
                                                                                                                                                                        9.086595,
                                                                                                                                                                        76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        76.131681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        95.631681,
                                                                                                                                                                        5, -22.5,
                                                                                                                                                                        78.365996, -5,
                                                                                                                                                                        78.365996, -22.5,
                                                                                                                                                                        76.179683, -5,
                                                                                                                                                                        76.179683, -22.5,
                                                                                                                                                                        76.179683, -5,
                                                                                                                                                                        78.365996, -22.5,
                                                                                                                                                                        76.684931, -5,
                                                                                                                                                                        76.684931, -22.5,
                                                                                                                                                                        74.498618, -5,
                                                                                                                                                                        74.498618, -22.5,
                                                                                                                                                                        74.498618, -5,
                                                                                                                                                                        76.684931, -22.5,
                                                                                                                                                                        69.852412, -5,
                                                                                                                                                                        69.852412, -22.5,
                                                                                                                                                                        67.666098, -5,
                                                                                                                                                                        67.666098, -22.5,
                                                                                                                                                                        67.666098, -5,
                                                                                                                                                                        69.852412,
                                                                                                                                                                        40.023532,
                                                                                                                                                                        55.061998,
                                                                                                                                                                        41.108673,
                                                                                                                                                                        56.960006,
                                                                                                                                                                        41.977042,
                                                                                                                                                                        54.555287,
                                                                                                                                                                        42.997074,
                                                                                                                                                                        56.339416,
                                                                                                                                                                        41.977042,
                                                                                                                                                                        54.555287,
                                                                                                                                                                        41.108673,
                                                                                                                                                                        56.960006,
                                                                                                                                                                        49.349221,
                                                                                                                                                                        55.830066,
                                                                                                                                                                        50.8302,
                                                                                                                                                                        57.438379,
                                                                                                                                                                        51.152385,
                                                                                                                                                                        54.993529,
                                                                                                                                                                        52.544505,
                                                                                                                                                                        56.505343,
                                                                                                                                                                        51.152385,
                                                                                                                                                                        54.993529,
                                                                                                                                                                        50.8302,
                                                                                                                                                                        57.438379,
                                                                                                                                                                        66.884455,
                                                                                                                                                                        37.441408,
                                                                                                                                                                        68.898721,
                                                                                                                                                                        38.291525,
                                                                                                                                                                        68.195436,
                                                                                                                                                                        35.995473,
                                                                                                                                                                        70.088846,
                                                                                                                                                                        36.794583,
                                                                                                                                                                        68.195436,
                                                                                                                                                                        35.995473,
                                                                                                                                                                        68.898721,
                                                                                                                                                                        38.291525, -71.944181,
                                                                                                                                                                        20.985652, -70.209662,
                                                                                                                                                                        19.654709, -101.5537,
                                                                                                                                                                        19.654709, -70.209662,
                                                                                                                                                                        19.654709, -94.75,
                                                                                                                                                                        18.857689, -101.5537,
                                                                                                                                                                        19.654709, -94.75,
                                                                                                                                                                        18.857689, -70.209662,
                                                                                                                                                                        19.654709, -82.013362,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        22.5,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        35.939548,
                                                                                                                                                                        94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        94.75,
                                                                                                                                                                        28.444045,
                                                                                                                                                                        94.75,
                                                                                                                                                                        22.5,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        35.939548, -101.5537,
                                                                                                                                                                        19.654709, -94.75,
                                                                                                                                                                        18.857689, -102.884644,
                                                                                                                                                                        17.920189,
                                                                                                                                                                        22.5, -46.228847,
                                                                                                                                                                        22.5, -48.415161,
                                                                                                                                                                        5, -46.228847,
                                                                                                                                                                        5, -48.415161,
                                                                                                                                                                        5, -46.228847,
                                                                                                                                                                        22.5, -48.415161,
                                                                                                                                                                        61.960871, -26.378437,
                                                                                                                                                                        62.719062, -28.429075,
                                                                                                                                                                        59.986918, -26.798516,
                                                                                                                                                                        60.699617, -28.726116,
                                                                                                                                                                        59.986918, -26.798516,
                                                                                                                                                                        62.719062, -28.429075,
                                                                                                                                                                        97.218538,
                                                                                                                                                                        13.154515,
                                                                                                                                                                        98.415672,
                                                                                                                                                                        11.484051,
                                                                                                                                                                        95.168132,
                                                                                                                                                                        12.413083,
                                                                                                                                                                        96.209638,
                                                                                                                                                                        10.959779,
                                                                                                                                                                        95.168132,
                                                                                                                                                                        12.413083,
                                                                                                                                                                        98.415672,
                                                                                                                                                                        11.484051,
                                                                                                                                                                        2.5, -45.346586,
                                                                                                                                                                        2.5, -47.134553,
                                                                                                                                                                        0, -45.346586,
                                                                                                                                                                        0, -47.134553,
                                                                                                                                                                        0, -45.346586,
                                                                                                                                                                        2.5, -47.134553,
                                                                                                                                                                        98.698258,
                                                                                                                                                                        18.575717,
                                                                                                                                                                        99.786704,
                                                                                                                                                                        17.157227,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        99.786704,
                                                                                                                                                                        17.157227,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        99.786704,
                                                                                                                                                                        17.157227,
                                                                                                                                                                        100.470929,
                                                                                                                                                                        15.50536,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        0, -24.123475,
                                                                                                                                                                        0, -22.335508,
                                                                                                                                                                        2.5, -24.123475,
                                                                                                                                                                        2.5, -22.335508,
                                                                                                                                                                        2.5, -24.123475,
                                                                                                                                                                        0, -22.335508,
                                                                                                                                                                        96.257622,
                                                                                                                                                                        11.6826,
                                                                                                                                                                        95.60739,
                                                                                                                                                                        13.348141,
                                                                                                                                                                        98.562779,
                                                                                                                                                                        11.949675,
                                                                                                                                                                        97.815385,
                                                                                                                                                                        13.864089,
                                                                                                                                                                        98.562779,
                                                                                                                                                                        11.949675,
                                                                                                                                                                        95.60739,
                                                                                                                                                                        13.348141,
                                                                                                                                                                        58.217404, -12.951329,
                                                                                                                                                                        57.792318, -10.940637,
                                                                                                                                                                        60.268295, -12.813601,
                                                                                                                                                                        59.816076, -10.674567,
                                                                                                                                                                        60.268295, -12.813601,
                                                                                                                                                                        57.792318, -10.940637,
                                                                                                                                                                        5, -25.002466,
                                                                                                                                                                        5, -22.816152,
                                                                                                                                                                        22.5, -25.002466,
                                                                                                                                                                        22.5, -22.816152,
                                                                                                                                                                        22.5, -25.002466,
                                                                                                                                                                        5, -22.816152,
                                                                                                                                                                        22.5,
                                                                                                                                                                        2.225922,
                                                                                                                                                                        22.5,
                                                                                                                                                                        0.039608,
                                                                                                                                                                        5,
                                                                                                                                                                        2.225922,
                                                                                                                                                                        5,
                                                                                                                                                                        0.039608,
                                                                                                                                                                        5,
                                                                                                                                                                        2.225922,
                                                                                                                                                                        22.5,
                                                                                                                                                                        0.039608,
                                                                                                                                                                        58.992545,
                                                                                                                                                                        6.305123,
                                                                                                                                                                        59.143169,
                                                                                                                                                                        4.124004,
                                                                                                                                                                        56.941205,
                                                                                                                                                                        6.174256,
                                                                                                                                                                        57.082791,
                                                                                                                                                                        4.124004,
                                                                                                                                                                        56.941205,
                                                                                                                                                                        6.174256,
                                                                                                                                                                        59.143169,
                                                                                                                                                                        4.124004,
                                                                                                                                                                        98.524387,
                                                                                                                                                                        12.457753,
                                                                                                                                                                        96.185975,
                                                                                                                                                                        12.457753,
                                                                                                                                                                        98.270309,
                                                                                                                                                                        14.497121,
                                                                                                                                                                        96.185975,
                                                                                                                                                                        14.983174,
                                                                                                                                                                        98.524387,
                                                                                                                                                                        14.983174,
                                                                                                                                                                        95.964927,
                                                                                                                                                                        13.208924,
                                                                                                                                                                        98.270309,
                                                                                                                                                                        12.943806,
                                                                                                                                                                        95.964927,
                                                                                                                                                                        13.208924,
                                                                                                                                                                        98.524387,
                                                                                                                                                                        14.983174,
                                                                                                                                                                        96.257622,
                                                                                                                                                                        15.557289,
                                                                                                                                                                        98.562779,
                                                                                                                                                                        15.290214,
                                                                                                                                                                        95.60739,
                                                                                                                                                                        13.891749,
                                                                                                                                                                        97.815385,
                                                                                                                                                                        13.3758,
                                                                                                                                                                        95.60739,
                                                                                                                                                                        13.891749,
                                                                                                                                                                        98.562779,
                                                                                                                                                                        15.290214,
                                                                                                                                                                        96.209638,
                                                                                                                                                                        15.847664,
                                                                                                                                                                        98.415672,
                                                                                                                                                                        15.323393,
                                                                                                                                                                        95.168132,
                                                                                                                                                                        14.39436,
                                                                                                                                                                        97.218538,
                                                                                                                                                                        13.652928,
                                                                                                                                                                        95.168132,
                                                                                                                                                                        14.39436,
                                                                                                                                                                        98.415672,
                                                                                                                                                                        15.323393,
                                                                                                                                                                        96.100865,
                                                                                                                                                                        15.54729,
                                                                                                                                                                        98.143631,
                                                                                                                                                                        14.785058,
                                                                                                                                                                        94.728825,
                                                                                                                                                                        14.400847,
                                                                                                                                                                        96.566572,
                                                                                                                                                                        13.467308,
                                                                                                                                                                        94.728825,
                                                                                                                                                                        14.400847,
                                                                                                                                                                        98.143631,
                                                                                                                                                                        14.785058,
                                                                                                                                                                        95.957288,
                                                                                                                                                                        13.8722,
                                                                                                                                                                        97.772576,
                                                                                                                                                                        12.895705,
                                                                                                                                                                        94.33601,
                                                                                                                                                                        13.118354,
                                                                                                                                                                        95.909037,
                                                                                                                                                                        12.029215,
                                                                                                                                                                        94.33601,
                                                                                                                                                                        13.118354,
                                                                                                                                                                        97.772576,
                                                                                                                                                                        12.895705,
                                                                                                                                                                        95.503435,
                                                                                                                                                                        8.945042,
                                                                                                                                                                        97.017222,
                                                                                                                                                                        7.774962,
                                                                                                                                                                        93.736935,
                                                                                                                                                                        8.668811,
                                                                                                                                                                        94.986762,
                                                                                                                                                                        7.457455,
                                                                                                                                                                        93.736935,
                                                                                                                                                                        8.668811,
                                                                                                                                                                        97.017222,
                                                                                                                                                                        7.774962,
                                                                                                                                                                        95.046681,
                                                                                                                                                                        2.805733,
                                                                                                                                                                        76.716681,
                                                                                                                                                                        2.805733,
                                                                                                                                                                        93.855231,
                                                                                                                                                                        4.074551,
                                                                                                                                                                        95.046681, -1.506416,
                                                                                                                                                                        95.631681, -3.327131,
                                                                                                                                                                        76.716681, -1.506416,
                                                                                                                                                                        89.523448,
                                                                                                                                                                        32.19834,
                                                                                                                                                                        91.416858,
                                                                                                                                                                        32.99745,
                                                                                                                                                                        90.713573,
                                                                                                                                                                        30.701398,
                                                                                                                                                                        92.727839,
                                                                                                                                                                        31.551516,
                                                                                                                                                                        90.713573,
                                                                                                                                                                        30.701398,
                                                                                                                                                                        91.416858,
                                                                                                                                                                        32.99745,
                                                                                                                                                                        5,
                                                                                                                                                                        97.699171,
                                                                                                                                                                        22.5,
                                                                                                                                                                        97.699171,
                                                                                                                                                                        5,
                                                                                                                                                                        95.512857,
                                                                                                                                                                        22.5,
                                                                                                                                                                        92.514269,
                                                                                                                                                                        5,
                                                                                                                                                                        92.514269,
                                                                                                                                                                        22.5,
                                                                                                                                                                        94.700582,
                                                                                                                                                                        5,
                                                                                                                                                                        94.700582,
                                                                                                                                                                        22.5,
                                                                                                                                                                        94.700582,
                                                                                                                                                                        5,
                                                                                                                                                                        92.514269,
                                                                                                                                                                        22.5,
                                                                                                                                                                        83.136488,
                                                                                                                                                                        5,
                                                                                                                                                                        83.136488,
                                                                                                                                                                        22.5,
                                                                                                                                                                        85.322802,
                                                                                                                                                                        5,
                                                                                                                                                                        85.322802,
                                                                                                                                                                        22.5,
                                                                                                                                                                        85.322802,
                                                                                                                                                                        5,
                                                                                                                                                                        83.136488,
                                                                                                                                                                        5,
                                                                                                                                                                        68.018597,
                                                                                                                                                                        5,
                                                                                                                                                                        70.204911,
                                                                                                                                                                        22.5,
                                                                                                                                                                        68.018597,
                                                                                                                                                                        62.719062,
                                                                                                                                                                        51.660497,
                                                                                                                                                                        61.960871,
                                                                                                                                                                        49.60986,
                                                                                                                                                                        60.699617,
                                                                                                                                                                        51.957538,
                                                                                                                                                                        59.986918,
                                                                                                                                                                        50.029939,
                                                                                                                                                                        60.699617,
                                                                                                                                                                        51.957538,
                                                                                                                                                                        61.960871,
                                                                                                                                                                        49.60986,
                                                                                                                                                                        67.434144,
                                                                                                                                                                        59.729375,
                                                                                                                                                                        66.349004,
                                                                                                                                                                        57.831366,
                                                                                                                                                                        65.480634,
                                                                                                                                                                        60.236085,
                                                                                                                                                                        64.460602,
                                                                                                                                                                        58.451957,
                                                                                                                                                                        65.480634,
                                                                                                                                                                        60.236085,
                                                                                                                                                                        66.349004,
                                                                                                                                                                        57.831366,
                                                                                                                                                                        76.58726,
                                                                                                                                                                        58.210743,
                                                                                                                                                                        75.106281,
                                                                                                                                                                        56.602431,
                                                                                                                                                                        74.784096,
                                                                                                                                                                        59.04728,
                                                                                                                                                                        73.391976,
                                                                                                                                                                        57.535466,
                                                                                                                                                                        74.784096,
                                                                                                                                                                        59.04728,
                                                                                                                                                                        75.106281,
                                                                                                                                                                        56.602431,
                                                                                                                                                                        57.792318,
                                                                                                                                                                        36.876207,
                                                                                                                                                                        58.217404,
                                                                                                                                                                        38.886899,
                                                                                                                                                                        59.816076,
                                                                                                                                                                        36.610137,
                                                                                                                                                                        60.268295,
                                                                                                                                                                        38.749171,
                                                                                                                                                                        59.816076,
                                                                                                                                                                        36.610137,
                                                                                                                                                                        58.217404,
                                                                                                                                                                        38.886899,
                                                                                                                                                                        5,
                                                                                                                                                                        48.190854,
                                                                                                                                                                        5,
                                                                                                                                                                        50.377167,
                                                                                                                                                                        22.5,
                                                                                                                                                                        48.190854,
                                                                                                                                                                        22.5,
                                                                                                                                                                        50.377167,
                                                                                                                                                                        22.5,
                                                                                                                                                                        48.190854,
                                                                                                                                                                        5,
                                                                                                                                                                        50.377167, -103.72131,
                                                                                                                                                                        11.56508, -100.407795,
                                                                                                                                                                        10.357689, -102.884644,
                                                                                                                                                                        9.545189, -100.407795,
                                                                                                                                                                        10.357689, -100.407795,
                                                                                                                                                                        8.607689, -102.884644,
                                                                                                                                                                        9.545189,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        126.022387, -78,
                                                                                                                                                                        76.644964, -100.407795,
                                                                                                                                                                        22.5, -78,
                                                                                                                                                                        76.644964, -100.407795,
                                                                                                                                                                        126.022387, -76.671107,
                                                                                                                                                                        86.738907, -76.671107,
                                                                                                                                                                        86.738907, -100.407795,
                                                                                                                                                                        126.022387, -76.355567,
                                                                                                                                                                        91.569337, -76.355567,
                                                                                                                                                                        126.022387, -76.355567,
                                                                                                                                                                        91.569337, -100.407795,
                                                                                                                                                                        126.022387, -99.949426,
                                                                                                                                                                        126.022387, -99.949426,
                                                                                                                                                                        128.272387, -76.813936,
                                                                                                                                                                        126.022387, -76.355567,
                                                                                                                                                                        91.569337, -74.989594,
                                                                                                                                                                        90.798439, -76.671107,
                                                                                                                                                                        86.738907, -76.671107,
                                                                                                                                                                        86.738907, -74.989594,
                                                                                                                                                                        90.798439, -75.808753,
                                                                                                                                                                        76.644964, -75.808753,
                                                                                                                                                                        76.644964, -74.989594,
                                                                                                                                                                        90.798439, -74.554525,
                                                                                                                                                                        86.17177, -74.554525,
                                                                                                                                                                        86.17177, -74.989594,
                                                                                                                                                                        90.798439, -72.982465,
                                                                                                                                                                        89.967059, -74.989594,
                                                                                                                                                                        90.798439, -72.774991,
                                                                                                                                                                        96.144964, -72.982465,
                                                                                                                                                                        89.967059, -72.982465,
                                                                                                                                                                        89.967059, -72.774991,
                                                                                                                                                                        96.144964, -70.877315,
                                                                                                                                                                        95.049341, -72.774991,
                                                                                                                                                                        96.144964, -66.577164,
                                                                                                                                                                        104.222129, -70.877315,
                                                                                                                                                                        95.049341, -70.877315,
                                                                                                                                                                        95.049341, -66.577164,
                                                                                                                                                                        104.222129, -65.027719,
                                                                                                                                                                        102.672683, -66.577164,
                                                                                                                                                                        104.222129, -58.5,
                                                                                                                                                                        110.419955, -65.027719,
                                                                                                                                                                        102.672683, -65.027719,
                                                                                                                                                                        102.672683, -58.5,
                                                                                                                                                                        110.419955, -57.404377,
                                                                                                                                                                        108.522279, -58.5,
                                                                                                                                                                        110.419955, -49.093943,
                                                                                                                                                                        114.316071, -57.404377,
                                                                                                                                                                        108.522279, -57.404377,
                                                                                                                                                                        108.522279, -49.093943,
                                                                                                                                                                        114.316071, -48.526806,
                                                                                                                                                                        112.199489, -48.526806,
                                                                                                                                                                        112.199489, -49.093943,
                                                                                                                                                                        114.316071, -39,
                                                                                                                                                                        113.453717, -49.093943,
                                                                                                                                                                        114.316071, -39,
                                                                                                                                                                        115.644964, -39,
                                                                                                                                                                        113.453717, -39,
                                                                                                                                                                        113.453717, -39,
                                                                                                                                                                        115.644964, -29.473194,
                                                                                                                                                                        112.199489, -39,
                                                                                                                                                                        115.644964, -28.906057,
                                                                                                                                                                        114.316071, -29.473194,
                                                                                                                                                                        112.199489, -43.580003, -87.335046, -53.761046, -87.335046, -43.93634, -84.111938, -29.473194,
                                                                                                                                                                        112.199489, -28.906057,
                                                                                                                                                                        114.316071, -20.595623,
                                                                                                                                                                        108.522279, -60.557553,
                                                                                                                                                                        84.42772, -61.278229,
                                                                                                                                                                        78.185483, -70.166566,
                                                                                                                                                                        84.42772, -81.683109,
                                                                                                                                                                        61.680374, -82.403785,
                                                                                                                                                                        67.922611, -73.515448,
                                                                                                                                                                        61.680374, -72.794772,
                                                                                                                                                                        67.922611, -73.515448,
                                                                                                                                                                        61.680374, -82.403785,
                                                                                                                                                                        67.922611, -88.632064,
                                                                                                                                                                        42.960192, -89.35274,
                                                                                                                                                                        49.202429, -80.464404,
                                                                                                                                                                        42.960192, -79.743728,
                                                                                                                                                                        49.202429, -80.464404,
                                                                                                                                                                        42.960192, -89.35274,
                                                                                                                                                                        49.202429, -89.819198,
                                                                                                                                                                        23.300686, -90.539874,
                                                                                                                                                                        29.542923, -81.651537,
                                                                                                                                                                        23.300686, -80.930861,
                                                                                                                                                                        29.542923, -81.651537,
                                                                                                                                                                        23.300686, -90.539874,
                                                                                                                                                                        29.542923, -85.163608,
                                                                                                                                                                        4.041618, -85.884284,
                                                                                                                                                                        10.283855, -76.995947,
                                                                                                                                                                        4.041618, -76.275271,
                                                                                                                                                                        10.283855, -76.995947,
                                                                                                                                                                        4.041618, -85.884284,
                                                                                                                                                                        10.283855, -75.703241, -7.2623, -66.094228, -7.2623, -74.982565, -13.504537, -12.972281,
                                                                                                                                                                        102.672683, -11.422836,
                                                                                                                                                                        104.222129, -7.122685,
                                                                                                                                                                        95.049341, -11.422836,
                                                                                                                                                                        104.222129, -5.225009,
                                                                                                                                                                        96.144964, -7.122685,
                                                                                                                                                                        95.049341, -79.457713, -40.996108, -89.638756, -40.996108, -79.814049, -37.773, -89.282419, -37.773, -79.814049, -37.773, -89.638756, -40.996108, -90.469552, -18.946989, -81.001183, -18.946989, -90.825889, -22.170097, -80.644846, -22.170097, -90.825889, -22.170097, -81.001183, -18.946989, -5.225009,
                                                                                                                                                                        96.144964, -1.328893,
                                                                                                                                                                        86.738907, -3.445475,
                                                                                                                                                                        86.17177, -3.445475,
                                                                                                                                                                        86.17177, -1.328893,
                                                                                                                                                                        86.738907, -2.191247,
                                                                                                                                                                        76.644964, -2.191247,
                                                                                                                                                                        76.644964, -1.328893,
                                                                                                                                                                        86.738907, -1.328893,
                                                                                                                                                                        66.551021, -2.191247,
                                                                                                                                                                        76.644964, -1.328893,
                                                                                                                                                                        66.551021, -3.445475,
                                                                                                                                                                        67.118158, -5.225009,
                                                                                                                                                                        57.144964, -3.445475,
                                                                                                                                                                        67.118158, -1.328893,
                                                                                                                                                                        66.551021, -7.122685,
                                                                                                                                                                        58.240588, -3.445475,
                                                                                                                                                                        67.118158, -5.225009,
                                                                                                                                                                        57.144964, -12.972281,
                                                                                                                                                                        50.617245, -7.122685,
                                                                                                                                                                        58.240588, -11.422836,
                                                                                                                                                                        49.0678, -11.422836,
                                                                                                                                                                        49.0678, -7.122685,
                                                                                                                                                                        58.240588, -5.225009,
                                                                                                                                                                        57.144964, -19.5,
                                                                                                                                                                        42.869973, -12.972281,
                                                                                                                                                                        50.617245, -11.422836,
                                                                                                                                                                        49.0678, -20.595623,
                                                                                                                                                                        44.767649, -12.972281,
                                                                                                                                                                        50.617245, -19.5,
                                                                                                                                                                        42.869973, -20.522224, -38.724956, -10.913211, -38.724956, -19.801548, -44.967193, -11.633887, -44.967193, -19.801548, -44.967193, -10.913211, -38.724956, -19.801548,
                                                                                                                                                                        4.107689, -11.633887,
                                                                                                                                                                        4.107689, -19.801548,
                                                                                                                                                                        1.505434, -11.633887,
                                                                                                                                                                        0.676451, -19.801548,
                                                                                                                                                                        1.505434, -11.633887,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        2.616713,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        10.784374,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        2.616713,
                                                                                                                                                                        0.676451,
                                                                                                                                                                        10.784374, -46.00824,
                                                                                                                                                                        2.616713, -46.00824,
                                                                                                                                                                        11.50505, -39.766002,
                                                                                                                                                                        1.896037, -39.766002,
                                                                                                                                                                        11.50505, -39.766002,
                                                                                                                                                                        2.616713, -46.00824, -29.473194,
                                                                                                                                                                        41.090439, -20.595623,
                                                                                                                                                                        44.767649, -28.906057,
                                                                                                                                                                        38.973857, -28.906057,
                                                                                                                                                                        38.973857, -20.595623,
                                                                                                                                                                        44.767649, -19.5,
                                                                                                                                                                        42.869973, -39,
                                                                                                                                                                        37.644964, -29.473194,
                                                                                                                                                                        41.090439, -28.906057,
                                                                                                                                                                        38.973857, -39,
                                                                                                                                                                        39.836211, -29.473194,
                                                                                                                                                                        41.090439, -39,
                                                                                                                                                                        37.644964,
                                                                                                                                                                        23.857668, -35.683322,
                                                                                                                                                                        33.466681, -35.683322,
                                                                                                                                                                        24.578344, -41.925559,
                                                                                                                                                                        32.746005, -41.925559,
                                                                                                                                                                        24.578344, -41.925559,
                                                                                                                                                                        33.466681, -35.683322,
                                                                                                                                                                        24.578344,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        32.746005,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        24.578344,
                                                                                                                                                                        0.172044,
                                                                                                                                                                        32.746005,
                                                                                                                                                                        0,
                                                                                                                                                                        24.578344,
                                                                                                                                                                        0.172044,
                                                                                                                                                                        32.746005,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        44.586694,
                                                                                                                                                                        0,
                                                                                                                                                                        44.586694,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        52.754355,
                                                                                                                                                                        0.172044,
                                                                                                                                                                        52.754355,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        52.754355,
                                                                                                                                                                        0.172044,
                                                                                                                                                                        44.586694,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        61.278229,
                                                                                                                                                                        0.172044,
                                                                                                                                                                        61.278229,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        69.44589,
                                                                                                                                                                        0.676451,
                                                                                                                                                                        69.44589,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        69.44589,
                                                                                                                                                                        0.676451,
                                                                                                                                                                        61.278229,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        73.515448,
                                                                                                                                                                        0.676451,
                                                                                                                                                                        73.515448,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        81.683109,
                                                                                                                                                                        1.505434,
                                                                                                                                                                        81.683109,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        81.683109,
                                                                                                                                                                        1.505434,
                                                                                                                                                                        73.515448,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        80.464404,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        88.632064,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        80.464404,
                                                                                                                                                                        1.505434,
                                                                                                                                                                        80.464404,
                                                                                                                                                                        15.393151,
                                                                                                                                                                        79.743728,
                                                                                                                                                                        21.635388,
                                                                                                                                                                        88.632064,
                                                                                                                                                                        15.393151,
                                                                                                                                                                        82.403785,
                                                                                                                                                                        2.915206,
                                                                                                                                                                        81.683109, -3.327031,
                                                                                                                                                                        78.930155,
                                                                                                                                                                        2.915206,
                                                                                                                                                                        81.683109, -3.327031,
                                                                                                                                                                        78.730523, -3.327031,
                                                                                                                                                                        78.930155,
                                                                                                                                                                        2.915206,
                                                                                                                                                                        78.730523,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        81.683109,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        73.515448,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        73.515448, -3.327031,
                                                                                                                                                                        72.794772,
                                                                                                                                                                        2.915206,
                                                                                                                                                                        78.730523, -3.327031,
                                                                                                                                                                        70.166566, -13.589903,
                                                                                                                                                                        69.44589, -19.83214,
                                                                                                                                                                        60.557553, -13.589903,
                                                                                                                                                                        61.278229, -19.83214,
                                                                                                                                                                        60.557553, -13.589903,
                                                                                                                                                                        69.44589, -19.83214,
                                                                                                                                                                        53.475031, -26.755142,
                                                                                                                                                                        52.754355, -32.997379,
                                                                                                                                                                        43.866019, -26.755142,
                                                                                                                                                                        44.586694, -32.997379,
                                                                                                                                                                        43.866019, -26.755142,
                                                                                                                                                                        52.754355, -32.997379, -57.404377,
                                                                                                                                                                        44.767649, -48.526806,
                                                                                                                                                                        41.090439, -49.093943,
                                                                                                                                                                        38.973857, -49.093943,
                                                                                                                                                                        38.973857, -48.526806,
                                                                                                                                                                        41.090439, -39,
                                                                                                                                                                        37.644964, -48.526806,
                                                                                                                                                                        41.090439, -39,
                                                                                                                                                                        39.836211, -39,
                                                                                                                                                                        37.644964, -58.5,
                                                                                                                                                                        42.869973, -57.404377,
                                                                                                                                                                        44.767649, -49.093943,
                                                                                                                                                                        38.973857, -62.271903,
                                                                                                                                                                        48.502633, -57.404377,
                                                                                                                                                                        44.767649, -58.5,
                                                                                                                                                                        42.869973, -65.027719,
                                                                                                                                                                        50.617245, -62.271903,
                                                                                                                                                                        48.502633, -63.594438,
                                                                                                                                                                        46.779073, -63.594438,
                                                                                                                                                                        46.779073, -62.271903,
                                                                                                                                                                        48.502633, -58.5,
                                                                                                                                                                        42.869973,
                                                                                                                                                                        78.930155,
                                                                                                                                                                        3.328696,
                                                                                                                                                                        72.508757,
                                                                                                                                                                        3.328696,
                                                                                                                                                                        77.835323,
                                                                                                                                                                        6.551804,
                                                                                                                                                                        72.865093,
                                                                                                                                                                        6.551804,
                                                                                                                                                                        77.835323,
                                                                                                                                                                        6.551804,
                                                                                                                                                                        72.508757,
                                                                                                                                                                        3.328696,
                                                                                                                                                                        28.67278,
                                                                                                                                                                        10.817456,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        10.542366,
                                                                                                                                                                        31.263807,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        31.263807,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        10.542366, -39.269157,
                                                                                                                                                                        8.607689, -39.269157,
                                                                                                                                                                        10.357689, -22.5,
                                                                                                                                                                        8.607689, -22.5,
                                                                                                                                                                        10.357689, -22.5,
                                                                                                                                                                        8.607689, -39.269157,
                                                                                                                                                                        10.357689, -76.355567,
                                                                                                                                                                        10.357689, -68.878718,
                                                                                                                                                                        9.545189, -76.355567,
                                                                                                                                                                        8.607689, -68.042052,
                                                                                                                                                                        11.56508, -68.878718,
                                                                                                                                                                        9.545189, -76.355567,
                                                                                                                                                                        10.357689, -22.5, -17.540139, -22.5, -15.353825, -5, -17.540139, -5, -15.353825, -5, -17.540139, -22.5, -15.353825,
                                                                                                                                                                        33.022376, -10.946474,
                                                                                                                                                                        32.570156, -8.807441,
                                                                                                                                                                        35.046134, -10.680405,
                                                                                                                                                                        34.621047, -8.669713,
                                                                                                                                                                        35.046134, -10.680405,
                                                                                                                                                                        32.570156, -8.807441,
                                                                                                                                                                        65.414592,
                                                                                                                                                                        6.538714,
                                                                                                                                                                        64.667199,
                                                                                                                                                                        8.453129,
                                                                                                                                                                        67.622587,
                                                                                                                                                                        7.054663,
                                                                                                                                                                        66.972355,
                                                                                                                                                                        8.720203,
                                                                                                                                                                        67.622587,
                                                                                                                                                                        7.054663,
                                                                                                                                                                        64.667199,
                                                                                                                                                                        8.453129, -2.5, -18.020784, -2.5, -16.232817,
                                                                                                                                                                        0, -18.020784,
                                                                                                                                                                        0, -16.232817,
                                                                                                                                                                        0, -18.020784, -2.5, -16.232817,
                                                                                                                                                                        71.292433,
                                                                                                                                                                        11.960018,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        71.976658,
                                                                                                                                                                        10.308152,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        71.292433,
                                                                                                                                                                        11.960018,
                                                                                                                                                                        0, -17.854471,
                                                                                                                                                                        0, -16.399129,
                                                                                                                                                                        2.5, -17.854471,
                                                                                                                                                                        2.5, -16.399129,
                                                                                                                                                                        2.5, -17.854471,
                                                                                                                                                                        0, -16.399129,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        12.289798, -2.5, -17.702937, -2.5, -16.550663,
                                                                                                                                                                        0, -17.702937,
                                                                                                                                                                        0, -16.550663,
                                                                                                                                                                        0, -17.702937, -2.5, -16.550663,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        0, -17.551191,
                                                                                                                                                                        0, -16.702409,
                                                                                                                                                                        2.5, -17.551191,
                                                                                                                                                                        2.5, -16.702409,
                                                                                                                                                                        2.5, -17.551191,
                                                                                                                                                                        0, -16.702409, -2.5,
                                                                                                                                                                        48.179802, -2.5,
                                                                                                                                                                        49.028584,
                                                                                                                                                                        0,
                                                                                                                                                                        48.179802,
                                                                                                                                                                        0,
                                                                                                                                                                        49.028584,
                                                                                                                                                                        0,
                                                                                                                                                                        48.179802, -2.5,
                                                                                                                                                                        49.028584,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        98.269189,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        0,
                                                                                                                                                                        25.289633,
                                                                                                                                                                        0,
                                                                                                                                                                        26.441907,
                                                                                                                                                                        2.5,
                                                                                                                                                                        25.289633,
                                                                                                                                                                        2.5,
                                                                                                                                                                        26.441907,
                                                                                                                                                                        2.5,
                                                                                                                                                                        25.289633,
                                                                                                                                                                        0,
                                                                                                                                                                        26.441907,
                                                                                                                                                                        98.269189,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        99.430136,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        99.430136,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        98.269189,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        99.430136,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        14.875106, -2.5,
                                                                                                                                                                        0.636967, -2.5,
                                                                                                                                                                        2.092309,
                                                                                                                                                                        0,
                                                                                                                                                                        0.636967,
                                                                                                                                                                        0,
                                                                                                                                                                        2.092309,
                                                                                                                                                                        0,
                                                                                                                                                                        0.636967, -2.5,
                                                                                                                                                                        2.092309,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        100.470929,
                                                                                                                                                                        15.50536,
                                                                                                                                                                        99.430136,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        100.470929,
                                                                                                                                                                        15.50536,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        0, -22.50182,
                                                                                                                                                                        0, -23.957162, -2.5, -22.50182, -2.5, -23.957162, -2.5, -22.50182,
                                                                                                                                                                        0, -23.957162,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        2.5, -22.653354,
                                                                                                                                                                        2.5, -23.805628,
                                                                                                                                                                        0, -22.653354,
                                                                                                                                                                        0, -23.805628,
                                                                                                                                                                        0, -22.653354,
                                                                                                                                                                        2.5, -23.805628,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        97.106617,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        98.269189,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        97.106617,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        0,
                                                                                                                                                                        0.788501,
                                                                                                                                                                        0,
                                                                                                                                                                        1.940776,
                                                                                                                                                                        2.5,
                                                                                                                                                                        0.788501,
                                                                                                                                                                        2.5,
                                                                                                                                                                        1.940776,
                                                                                                                                                                        2.5,
                                                                                                                                                                        0.788501,
                                                                                                                                                                        0,
                                                                                                                                                                        1.940776,
                                                                                                                                                                        97.106617,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        98.269189,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        0,
                                                                                                                                                                        26.290161,
                                                                                                                                                                        0,
                                                                                                                                                                        25.441379, -2.5,
                                                                                                                                                                        26.290161, -2.5,
                                                                                                                                                                        25.441379, -2.5,
                                                                                                                                                                        26.290161,
                                                                                                                                                                        0,
                                                                                                                                                                        25.441379, -2.5,
                                                                                                                                                                        0.940247, -2.5,
                                                                                                                                                                        1.789029,
                                                                                                                                                                        0,
                                                                                                                                                                        0.940247,
                                                                                                                                                                        0,
                                                                                                                                                                        1.789029,
                                                                                                                                                                        0,
                                                                                                                                                                        0.940247, -2.5,
                                                                                                                                                                        1.789029, -2.5, -23.653882, -2.5, -22.8051,
                                                                                                                                                                        0, -23.653882,
                                                                                                                                                                        2.5,
                                                                                                                                                                        24.208647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        23.359865,
                                                                                                                                                                        0,
                                                                                                                                                                        24.208647,
                                                                                                                                                                        0,
                                                                                                                                                                        23.359865,
                                                                                                                                                                        0,
                                                                                                                                                                        24.208647,
                                                                                                                                                                        2.5,
                                                                                                                                                                        23.359865,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        74.656745,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        73.494173,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        74.656745,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        73.494173,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        0,
                                                                                                                                                                        3.021762,
                                                                                                                                                                        0,
                                                                                                                                                                        3.870544,
                                                                                                                                                                        2.5,
                                                                                                                                                                        3.021762,
                                                                                                                                                                        2.5,
                                                                                                                                                                        3.870544,
                                                                                                                                                                        2.5,
                                                                                                                                                                        3.021762,
                                                                                                                                                                        0,
                                                                                                                                                                        3.870544,
                                                                                                                                                                        73.494173,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        0,
                                                                                                                                                                        4.02229,
                                                                                                                                                                        0,
                                                                                                                                                                        2.870016, -2.5,
                                                                                                                                                                        4.02229, -2.5,
                                                                                                                                                                        2.870016, -2.5,
                                                                                                                                                                        4.02229,
                                                                                                                                                                        0,
                                                                                                                                                                        2.870016,
                                                                                                                                                                        73.494173,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        72.333226,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        72.333226,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        2.5,
                                                                                                                                                                        4.173824,
                                                                                                                                                                        2.5,
                                                                                                                                                                        2.718482,
                                                                                                                                                                        0,
                                                                                                                                                                        4.173824,
                                                                                                                                                                        0,
                                                                                                                                                                        2.718482,
                                                                                                                                                                        0,
                                                                                                                                                                        4.173824,
                                                                                                                                                                        2.5,
                                                                                                                                                                        2.718482,
                                                                                                                                                                        72.333226,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        71.059056,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        71.059056,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        71.292433,
                                                                                                                                                                        11.960018,
                                                                                                                                                                        0,
                                                                                                                                                                        4.340136,
                                                                                                                                                                        0,
                                                                                                                                                                        2.552169, -2.5,
                                                                                                                                                                        4.340136, -2.5,
                                                                                                                                                                        2.552169, -2.5,
                                                                                                                                                                        4.340136,
                                                                                                                                                                        0,
                                                                                                                                                                        2.552169,
                                                                                                                                                                        66.503216,
                                                                                                                                                                        12.659083,
                                                                                                                                                                        66.724263,
                                                                                                                                                                        10.884832,
                                                                                                                                                                        64.164804,
                                                                                                                                                                        12.659083,
                                                                                                                                                                        64.418881,
                                                                                                                                                                        10.619714,
                                                                                                                                                                        64.164804,
                                                                                                                                                                        12.659083,
                                                                                                                                                                        66.724263,
                                                                                                                                                                        10.884832,
                                                                                                                                                                        33.576634,
                                                                                                                                                                        6.958992,
                                                                                                                                                                        33.71822,
                                                                                                                                                                        4.90874,
                                                                                                                                                                        31.516256,
                                                                                                                                                                        6.958992,
                                                                                                                                                                        31.666879,
                                                                                                                                                                        4.777873,
                                                                                                                                                                        31.516256,
                                                                                                                                                                        6.958992,
                                                                                                                                                                        33.71822,
                                                                                                                                                                        4.90874, -5,
                                                                                                                                                                        4.771183, -5,
                                                                                                                                                                        2.584869, -22.5,
                                                                                                                                                                        4.771183, -22.5,
                                                                                                                                                                        2.584869, -22.5,
                                                                                                                                                                        4.771183, -5,
                                                                                                                                                                        2.584869, -67.756681,
                                                                                                                                                                        13.732689, -68.042052,
                                                                                                                                                                        11.56508, -79.513362,
                                                                                                                                                                        16.357689, -79.513362,
                                                                                                                                                                        16.357689, -68.042052,
                                                                                                                                                                        11.56508, -76.355567,
                                                                                                                                                                        10.357689, -22.5,
                                                                                                                                                                        51.507468, -22.5,
                                                                                                                                                                        44.727227, -37.410797,
                                                                                                                                                                        51.507468, -39.269157,
                                                                                                                                                                        44.727227, -37.410797,
                                                                                                                                                                        51.507468, -22.5,
                                                                                                                                                                        44.727227, -68.042052,
                                                                                                                                                                        15.900299, -67.756681,
                                                                                                                                                                        13.732689, -79.513362,
                                                                                                                                                                        16.357689, -22.5,
                                                                                                                                                                        22.459226, -22.5,
                                                                                                                                                                        24.64554, -5,
                                                                                                                                                                        22.459226, -5,
                                                                                                                                                                        24.64554, -5,
                                                                                                                                                                        22.459226, -22.5,
                                                                                                                                                                        24.64554,
                                                                                                                                                                        31.516256,
                                                                                                                                                                        20.33627,
                                                                                                                                                                        31.666879,
                                                                                                                                                                        22.51739,
                                                                                                                                                                        33.576634,
                                                                                                                                                                        20.33627,
                                                                                                                                                                        33.71822,
                                                                                                                                                                        22.386522,
                                                                                                                                                                        33.576634,
                                                                                                                                                                        20.33627,
                                                                                                                                                                        31.666879,
                                                                                                                                                                        22.51739,
                                                                                                                                                                        64.418881,
                                                                                                                                                                        16.821213,
                                                                                                                                                                        66.724263,
                                                                                                                                                                        16.556095,
                                                                                                                                                                        64.164804,
                                                                                                                                                                        14.781844,
                                                                                                                                                                        66.972355,
                                                                                                                                                                        18.519686,
                                                                                                                                                                        64.667199,
                                                                                                                                                                        18.78676,
                                                                                                                                                                        67.622587,
                                                                                                                                                                        20.185226,
                                                                                                                                                                        65.414592,
                                                                                                                                                                        20.701175,
                                                                                                                                                                        67.622587,
                                                                                                                                                                        20.185226,
                                                                                                                                                                        64.667199,
                                                                                                                                                                        18.78676,
                                                                                                                                                                        68.146402,
                                                                                                                                                                        21.815897,
                                                                                                                                                                        65.940369,
                                                                                                                                                                        22.340169,
                                                                                                                                                                        69.187908,
                                                                                                                                                                        23.269201, -2.5,
                                                                                                                                                                        57.428356, -2.5,
                                                                                                                                                                        59.216324,
                                                                                                                                                                        0,
                                                                                                                                                                        57.428356,
                                                                                                                                                                        0,
                                                                                                                                                                        59.216324,
                                                                                                                                                                        0,
                                                                                                                                                                        57.428356, -2.5,
                                                                                                                                                                        59.216324,
                                                                                                                                                                        73.065104,
                                                                                                                                                                        18.575717,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        71.976658,
                                                                                                                                                                        17.157227,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        73.065104,
                                                                                                                                                                        18.575717,
                                                                                                                                                                        0,
                                                                                                                                                                        70.896279,
                                                                                                                                                                        2.5,
                                                                                                                                                                        70.896279,
                                                                                                                                                                        0,
                                                                                                                                                                        69.440936,
                                                                                                                                                                        2.5,
                                                                                                                                                                        76.505329,
                                                                                                                                                                        0,
                                                                                                                                                                        76.505329,
                                                                                                                                                                        2.5,
                                                                                                                                                                        77.960671,
                                                                                                                                                                        0,
                                                                                                                                                                        77.960671,
                                                                                                                                                                        2.5,
                                                                                                                                                                        77.960671,
                                                                                                                                                                        0,
                                                                                                                                                                        76.505329,
                                                                                                                                                                        2.5,
                                                                                                                                                                        78.306421,
                                                                                                                                                                        0,
                                                                                                                                                                        78.306421,
                                                                                                                                                                        2.5,
                                                                                                                                                                        79.845276,
                                                                                                                                                                        0,
                                                                                                                                                                        79.845276,
                                                                                                                                                                        2.5,
                                                                                                                                                                        79.845276,
                                                                                                                                                                        0,
                                                                                                                                                                        78.306421, -77.99093,
                                                                                                                                                                        2.5, -77.99093,
                                                                                                                                                                        0, -93.772432,
                                                                                                                                                                        2.5, -93.772432,
                                                                                                                                                                        0, -93.772432,
                                                                                                                                                                        2.5, -77.99093,
                                                                                                                                                                        0, -2.5, -90.448626,
                                                                                                                                                                        0, -90.448626, -2.5, -91.987482,
                                                                                                                                                                        0, -91.987482, -2.5, -91.987482,
                                                                                                                                                                        0, -90.448626, -2.5, -80.727983,
                                                                                                                                                                        0, -80.727983, -2.5, -82.183325,
                                                                                                                                                                        0, -82.183325, -2.5, -82.183325,
                                                                                                                                                                        0, -80.727983, -2.5, -65.372758,
                                                                                                                                                                        0, -65.372758, -2.5, -66.8281,
                                                                                                                                                                        0, -66.8281, -2.5, -66.8281,
                                                                                                                                                                        0, -65.372758,
                                                                                                                                                                        0, -45.512898,
                                                                                                                                                                        0, -46.968241, -2.5, -45.512898, -2.5, -46.968241, -2.5, -45.512898,
                                                                                                                                                                        0, -46.968241,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        2.5, -45.664432,
                                                                                                                                                                        2.5, -46.816707,
                                                                                                                                                                        0, -45.664432,
                                                                                                                                                                        0, -46.816707,
                                                                                                                                                                        0, -45.664432,
                                                                                                                                                                        2.5, -46.816707,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        0, -45.816179,
                                                                                                                                                                        0, -46.664961, -2.5, -45.816179, -2.5, -46.664961, -2.5, -45.816179,
                                                                                                                                                                        0, -46.664961, -2.5, -65.676038,
                                                                                                                                                                        0, -65.676038, -2.5, -66.52482,
                                                                                                                                                                        0, -81.880045, -2.5, -81.880045,
                                                                                                                                                                        0, -81.031263, -2.5, -81.031263,
                                                                                                                                                                        0, -81.031263, -2.5, -81.880045,
                                                                                                                                                                        0, -91.684202, -2.5, -91.684202,
                                                                                                                                                                        0, -90.599615, -2.5, -90.599615,
                                                                                                                                                                        0, -90.599615, -2.5, -91.684202, -93.621443,
                                                                                                                                                                        0, -93.621443,
                                                                                                                                                                        2.5, -78.141919,
                                                                                                                                                                        0, -78.141919,
                                                                                                                                                                        2.5, -78.141919,
                                                                                                                                                                        0, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        0,
                                                                                                                                                                        79.694288,
                                                                                                                                                                        2.5,
                                                                                                                                                                        79.694288,
                                                                                                                                                                        0,
                                                                                                                                                                        78.609701,
                                                                                                                                                                        2.5,
                                                                                                                                                                        78.609701,
                                                                                                                                                                        0,
                                                                                                                                                                        78.609701,
                                                                                                                                                                        2.5,
                                                                                                                                                                        79.694288,
                                                                                                                                                                        0,
                                                                                                                                                                        77.657391,
                                                                                                                                                                        2.5,
                                                                                                                                                                        77.657391,
                                                                                                                                                                        0,
                                                                                                                                                                        76.808609,
                                                                                                                                                                        2.5,
                                                                                                                                                                        76.808609,
                                                                                                                                                                        0,
                                                                                                                                                                        76.808609,
                                                                                                                                                                        2.5,
                                                                                                                                                                        77.657391,
                                                                                                                                                                        0,
                                                                                                                                                                        70.592999,
                                                                                                                                                                        2.5,
                                                                                                                                                                        70.592999,
                                                                                                                                                                        0,
                                                                                                                                                                        69.744217,
                                                                                                                                                                        2.5,
                                                                                                                                                                        69.744217,
                                                                                                                                                                        0,
                                                                                                                                                                        69.744217,
                                                                                                                                                                        2.5,
                                                                                                                                                                        70.592999,
                                                                                                                                                                        2.5,
                                                                                                                                                                        58.746731,
                                                                                                                                                                        2.5,
                                                                                                                                                                        57.897949,
                                                                                                                                                                        0,
                                                                                                                                                                        58.746731,
                                                                                                                                                                        0,
                                                                                                                                                                        57.897949,
                                                                                                                                                                        0,
                                                                                                                                                                        58.746731,
                                                                                                                                                                        2.5,
                                                                                                                                                                        57.897949,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        0,
                                                                                                                                                                        42.077111,
                                                                                                                                                                        0,
                                                                                                                                                                        42.925893,
                                                                                                                                                                        2.5,
                                                                                                                                                                        42.077111,
                                                                                                                                                                        2.5,
                                                                                                                                                                        42.925893,
                                                                                                                                                                        2.5,
                                                                                                                                                                        42.077111,
                                                                                                                                                                        0,
                                                                                                                                                                        42.925893,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        73.494173,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        0,
                                                                                                                                                                        24.360393,
                                                                                                                                                                        0,
                                                                                                                                                                        23.208119, -2.5,
                                                                                                                                                                        24.360393, -2.5,
                                                                                                                                                                        23.208119, -2.5,
                                                                                                                                                                        24.360393,
                                                                                                                                                                        0,
                                                                                                                                                                        23.208119,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        73.494173,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        72.333226,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        72.333226,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        73.644575,
                                                                                                                                                                        14.875106,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        15.175581, -2.5,
                                                                                                                                                                        41.925365, -2.5,
                                                                                                                                                                        43.077639,
                                                                                                                                                                        0,
                                                                                                                                                                        41.925365,
                                                                                                                                                                        0,
                                                                                                                                                                        43.077639,
                                                                                                                                                                        0,
                                                                                                                                                                        41.925365, -2.5,
                                                                                                                                                                        43.077639, -2.5,
                                                                                                                                                                        57.746203, -2.5,
                                                                                                                                                                        58.898477,
                                                                                                                                                                        0,
                                                                                                                                                                        57.746203,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        2.5,
                                                                                                                                                                        43.229173,
                                                                                                                                                                        2.5,
                                                                                                                                                                        41.773831,
                                                                                                                                                                        0,
                                                                                                                                                                        43.229173,
                                                                                                                                                                        0,
                                                                                                                                                                        41.773831,
                                                                                                                                                                        0,
                                                                                                                                                                        43.229173,
                                                                                                                                                                        2.5,
                                                                                                                                                                        41.773831,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        71.292433,
                                                                                                                                                                        15.50536,
                                                                                                                                                                        71.292433,
                                                                                                                                                                        15.50536,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        71.059056,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        72.523187,
                                                                                                                                                                        15.175581,
                                                                                                                                                                        72.333226,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        71.059056,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        0,
                                                                                                                                                                        23.056585,
                                                                                                                                                                        0,
                                                                                                                                                                        24.511927,
                                                                                                                                                                        2.5,
                                                                                                                                                                        23.056585,
                                                                                                                                                                        2.5,
                                                                                                                                                                        24.511927,
                                                                                                                                                                        2.5,
                                                                                                                                                                        23.056585,
                                                                                                                                                                        0,
                                                                                                                                                                        24.511927,
                                                                                                                                                                        0,
                                                                                                                                                                        24.67824,
                                                                                                                                                                        0,
                                                                                                                                                                        22.890272, -2.5,
                                                                                                                                                                        24.67824, -2.5,
                                                                                                                                                                        22.890272, -2.5,
                                                                                                                                                                        24.67824,
                                                                                                                                                                        0,
                                                                                                                                                                        22.890272,
                                                                                                                                                                        66.503216,
                                                                                                                                                                        14.781844,
                                                                                                                                                                        64.164804,
                                                                                                                                                                        14.781844,
                                                                                                                                                                        66.724263,
                                                                                                                                                                        16.556095, -2.5,
                                                                                                                                                                        41.607518, -2.5,
                                                                                                                                                                        43.395485,
                                                                                                                                                                        0,
                                                                                                                                                                        41.607518,
                                                                                                                                                                        0,
                                                                                                                                                                        43.395485,
                                                                                                                                                                        0,
                                                                                                                                                                        41.607518, -2.5,
                                                                                                                                                                        43.395485,
                                                                                                                                                                        71.976658,
                                                                                                                                                                        17.157227,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        71.292433,
                                                                                                                                                                        15.50536,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        71.976658,
                                                                                                                                                                        17.157227,
                                                                                                                                                                        0,
                                                                                                                                                                        57.594669,
                                                                                                                                                                        0,
                                                                                                                                                                        59.050011,
                                                                                                                                                                        2.5,
                                                                                                                                                                        57.594669,
                                                                                                                                                                        2.5,
                                                                                                                                                                        59.050011,
                                                                                                                                                                        2.5,
                                                                                                                                                                        57.594669,
                                                                                                                                                                        0,
                                                                                                                                                                        59.050011,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        16.520142,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        17.674742, -2.5,
                                                                                                                                                                        70.744745,
                                                                                                                                                                        0,
                                                                                                                                                                        70.744745, -2.5,
                                                                                                                                                                        69.59247,
                                                                                                                                                                        0,
                                                                                                                                                                        76.656863, -2.5,
                                                                                                                                                                        76.656863,
                                                                                                                                                                        0,
                                                                                                                                                                        77.809137, -2.5,
                                                                                                                                                                        77.809137,
                                                                                                                                                                        0,
                                                                                                                                                                        77.809137, -2.5,
                                                                                                                                                                        76.656863,
                                                                                                                                                                        0,
                                                                                                                                                                        78.457955, -2.5,
                                                                                                                                                                        78.457955,
                                                                                                                                                                        0,
                                                                                                                                                                        79.769835, -2.5,
                                                                                                                                                                        79.769835,
                                                                                                                                                                        0,
                                                                                                                                                                        79.769835, -2.5,
                                                                                                                                                                        78.457955,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        0,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        0,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        2.5,
                                                                                                                                                                        0, -90.524068,
                                                                                                                                                                        2.5, -90.524068,
                                                                                                                                                                        0, -91.835948,
                                                                                                                                                                        2.5, -91.835948,
                                                                                                                                                                        0, -91.835948,
                                                                                                                                                                        2.5, -90.524068,
                                                                                                                                                                        0, -80.879517,
                                                                                                                                                                        2.5, -80.879517,
                                                                                                                                                                        0, -82.031791,
                                                                                                                                                                        2.5, -82.031791,
                                                                                                                                                                        0, -82.031791,
                                                                                                                                                                        2.5, -80.879517,
                                                                                                                                                                        0, -65.524292,
                                                                                                                                                                        2.5, -65.524292,
                                                                                                                                                                        0, -66.676566,
                                                                                                                                                                        2.5, -66.676566,
                                                                                                                                                                        0, -66.676566,
                                                                                                                                                                        2.5, -65.524292,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        18.16748,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        18.16748,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        18.16748,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        18.16748,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        19.318495,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        19.318495,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        19.318495,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        18.16748,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        2.5,
                                                                                                                                                                        69.440936,
                                                                                                                                                                        0,
                                                                                                                                                                        69.440936,
                                                                                                                                                                        2.5,
                                                                                                                                                                        70.896279,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        0, -66.52482, -2.5, -66.52482,
                                                                                                                                                                        0, -65.676038,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        17.014854,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        17.014854,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        17.014854,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        17.014854,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        17.014854,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        16.853829,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        15.939668,
                                                                                                                                                                        0,
                                                                                                                                                                        58.898477,
                                                                                                                                                                        0,
                                                                                                                                                                        57.746203, -2.5,
                                                                                                                                                                        58.898477,
                                                                                                                                                                        0,
                                                                                                                                                                        69.59247, -2.5,
                                                                                                                                                                        69.59247,
                                                                                                                                                                        0,
                                                                                                                                                                        70.744745,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        17.555289,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        18.16748,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        18.16748,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        18.16748,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        17.996245,
                                                                                                                                                                        0, -22.8051,
                                                                                                                                                                        0, -23.653882, -2.5, -22.8051,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        98.698258,
                                                                                                                                                                        18.575717,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        17.674742,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        98.698258,
                                                                                                                                                                        18.575717,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        98.698258,
                                                                                                                                                                        18.575717,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        0, -65.206446,
                                                                                                                                                                        2.5, -65.206446,
                                                                                                                                                                        0, -66.994413,
                                                                                                                                                                        2.5, -82.349638,
                                                                                                                                                                        0, -82.349638,
                                                                                                                                                                        2.5, -80.561671,
                                                                                                                                                                        0, -80.561671,
                                                                                                                                                                        2.5, -80.561671,
                                                                                                                                                                        0, -82.349638,
                                                                                                                                                                        2.5, -92.153795,
                                                                                                                                                                        0, -92.153795,
                                                                                                                                                                        2.5, -90.365827,
                                                                                                                                                                        0, -90.365827,
                                                                                                                                                                        2.5, -90.365827,
                                                                                                                                                                        0, -92.153795,
                                                                                                                                                                        93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        93.855231,
                                                                                                                                                                        0,
                                                                                                                                                                        77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        77.908131,
                                                                                                                                                                        0,
                                                                                                                                                                        77.908131,
                                                                                                                                                                        2.5,
                                                                                                                                                                        93.855231,
                                                                                                                                                                        0, -2.5,
                                                                                                                                                                        79.928075,
                                                                                                                                                                        0,
                                                                                                                                                                        79.928075, -2.5,
                                                                                                                                                                        78.140108,
                                                                                                                                                                        0,
                                                                                                                                                                        78.140108, -2.5,
                                                                                                                                                                        78.140108,
                                                                                                                                                                        0,
                                                                                                                                                                        79.928075, -2.5,
                                                                                                                                                                        78.126984,
                                                                                                                                                                        0,
                                                                                                                                                                        78.126984, -2.5,
                                                                                                                                                                        76.339017,
                                                                                                                                                                        0,
                                                                                                                                                                        76.339017, -2.5,
                                                                                                                                                                        76.339017,
                                                                                                                                                                        0,
                                                                                                                                                                        78.126984, -2.5,
                                                                                                                                                                        71.062591,
                                                                                                                                                                        0,
                                                                                                                                                                        71.062591, -2.5,
                                                                                                                                                                        69.274624,
                                                                                                                                                                        0,
                                                                                                                                                                        69.274624, -2.5,
                                                                                                                                                                        69.274624,
                                                                                                                                                                        0,
                                                                                                                                                                        71.062591,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        73.065104,
                                                                                                                                                                        18.575717,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        19.318495,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        19.318495,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        19.318495,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        19.318495,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        19.318495,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        95.627902,
                                                                                                                                                                        20.348388,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        76.13546,
                                                                                                                                                                        20.348388,
                                                                                                                                                                        95.627902,
                                                                                                                                                                        20.348388,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        19.664162,
                                                                                                                                                                        93.855231,
                                                                                                                                                                        20.581764,
                                                                                                                                                                        95.627902,
                                                                                                                                                                        20.348388,
                                                                                                                                                                        76.13546,
                                                                                                                                                                        20.348388,
                                                                                                                                                                        77.908131,
                                                                                                                                                                        20.581764,
                                                                                                                                                                        93.855231,
                                                                                                                                                                        20.581764,
                                                                                                                                                                        76.13546,
                                                                                                                                                                        20.348388,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        19.117634,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        18.560699,
                                                                                                                                                                        73.065104,
                                                                                                                                                                        18.575717,
                                                                                                                                                                        93.855231,
                                                                                                                                                                        18.078948,
                                                                                                                                                                        77.908131,
                                                                                                                                                                        18.078948,
                                                                                                                                                                        95.046681,
                                                                                                                                                                        19.347766,
                                                                                                                                                                        94.986762,
                                                                                                                                                                        15.746914,
                                                                                                                                                                        97.017222,
                                                                                                                                                                        15.429406,
                                                                                                                                                                        93.736935,
                                                                                                                                                                        14.535558,
                                                                                                                                                                        89.523448, -22.978639,
                                                                                                                                                                        90.713573, -21.481697,
                                                                                                                                                                        91.416858, -23.777749,
                                                                                                                                                                        92.727839, -22.331815,
                                                                                                                                                                        91.416858, -23.777749,
                                                                                                                                                                        90.713573, -21.481697,
                                                                                                                                                                        73.391976, -43.247603,
                                                                                                                                                                        75.106281, -42.314568,
                                                                                                                                                                        74.784096, -44.759417,
                                                                                                                                                                        76.58726, -43.922881,
                                                                                                                                                                        74.784096, -44.759417,
                                                                                                                                                                        75.106281, -42.314568,
                                                                                                                                                                        64.460602, -39.19237,
                                                                                                                                                                        66.349004, -38.571779,
                                                                                                                                                                        65.480634, -40.976498,
                                                                                                                                                                        67.434144, -40.469788,
                                                                                                                                                                        65.480634, -40.976498,
                                                                                                                                                                        66.349004, -38.571779,
                                                                                                                                                                        5, -66.416625,
                                                                                                                                                                        22.5, -66.416625,
                                                                                                                                                                        5, -68.602939,
                                                                                                                                                                        22.5, -84.190037,
                                                                                                                                                                        5, -84.190037,
                                                                                                                                                                        22.5, -82.003723,
                                                                                                                                                                        5, -82.003723,
                                                                                                                                                                        22.5, -82.003723,
                                                                                                                                                                        5, -84.190037,
                                                                                                                                                                        22.5, -94.11422,
                                                                                                                                                                        5, -94.11422,
                                                                                                                                                                        22.5, -91.927906,
                                                                                                                                                                        5, -91.927906,
                                                                                                                                                                        22.5, -91.927906,
                                                                                                                                                                        5, -94.11422,
                                                                                                                                                                        95.631681,
                                                                                                                                                                        22.5,
                                                                                                                                                                        95.631681,
                                                                                                                                                                        5,
                                                                                                                                                                        76.131681,
                                                                                                                                                                        22.5, -95.631681,
                                                                                                                                                                        22.107689, -76.131681,
                                                                                                                                                                        22.107689, -97.79929,
                                                                                                                                                                        21.822318, -76.131681,
                                                                                                                                                                        22.107689, -73.964071,
                                                                                                                                                                        21.822318, -97.79929,
                                                                                                                                                                        21.822318, -97.79929,
                                                                                                                                                                        21.822318, -73.964071,
                                                                                                                                                                        21.822318, -99.819181,
                                                                                                                                                                        20.985652, -73.964071,
                                                                                                                                                                        21.822318, -71.944181,
                                                                                                                                                                        20.985652, -99.819181,
                                                                                                                                                                        20.985652, -99.819181,
                                                                                                                                                                        20.985652, -71.944181,
                                                                                                                                                                        20.985652, -101.5537,
                                                                                                                                                                        19.654709,
                                                                                                                                                                        22.5, -68.602939,
                                                                                                                                                                        5, -68.602939,
                                                                                                                                                                        22.5, -66.416625,
                                                                                                                                                                        96.566572,
                                                                                                                                                                        12.608628,
                                                                                                                                                                        98.143631,
                                                                                                                                                                        11.290878,
                                                                                                                                                                        94.728825,
                                                                                                                                                                        11.675089,
                                                                                                                                                                        96.100865,
                                                                                                                                                                        10.528647,
                                                                                                                                                                        94.728825,
                                                                                                                                                                        11.675089,
                                                                                                                                                                        98.143631,
                                                                                                                                                                        11.290878,
                                                                                                                                                                        2.5, -66.994413,
                                                                                                                                                                        0, -66.994413,
                                                                                                                                                                        2.5, -65.206446,
                                                                                                                                                                        95.957288,
                                                                                                                                                                        11.056649,
                                                                                                                                                                        94.33601,
                                                                                                                                                                        11.810495,
                                                                                                                                                                        97.772576,
                                                                                                                                                                        12.033144,
                                                                                                                                                                        95.909037,
                                                                                                                                                                        12.899634,
                                                                                                                                                                        97.772576,
                                                                                                                                                                        12.033144,
                                                                                                                                                                        94.33601,
                                                                                                                                                                        11.810495,
                                                                                                                                                                        95.503435,
                                                                                                                                                                        14.259326,
                                                                                                                                                                        93.736935,
                                                                                                                                                                        14.535558,
                                                                                                                                                                        97.017222,
                                                                                                                                                                        15.429406,
                                                                                                                                                                        35.046134,
                                                                                                                                                                        36.615975,
                                                                                                                                                                        34.621047,
                                                                                                                                                                        34.605283,
                                                                                                                                                                        33.022376,
                                                                                                                                                                        36.882045,
                                                                                                                                                                        32.570156,
                                                                                                                                                                        34.743011,
                                                                                                                                                                        33.022376,
                                                                                                                                                                        36.882045,
                                                                                                                                                                        34.621047,
                                                                                                                                                                        34.605283, -5,
                                                                                                                                                                        42.914841, -5,
                                                                                                                                                                        40.728527, -22.5,
                                                                                                                                                                        42.914841, -22.5,
                                                                                                                                                                        40.728527, -22.5,
                                                                                                                                                                        42.914841, -5,
                                                                                                                                                                        40.728527, -68.878718,
                                                                                                                                                                        17.920189, -68.042052,
                                                                                                                                                                        15.900299, -79.513362,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        100.470929,
                                                                                                                                                                        15.50536,
                                                                                                                                                                        100.704306,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        99.430136,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        0,
                                                                                                                                                                        0.470655,
                                                                                                                                                                        0,
                                                                                                                                                                        2.258622,
                                                                                                                                                                        2.5,
                                                                                                                                                                        0.470655,
                                                                                                                                                                        2.5,
                                                                                                                                                                        2.258622,
                                                                                                                                                                        2.5,
                                                                                                                                                                        0.470655,
                                                                                                                                                                        0,
                                                                                                                                                                        2.258622,
                                                                                                                                                                        95.964927,
                                                                                                                                                                        14.232003,
                                                                                                                                                                        98.270309,
                                                                                                                                                                        14.497121,
                                                                                                                                                                        96.185975,
                                                                                                                                                                        12.457753,
                                                                                                                                                                        2.5,
                                                                                                                                                                        26.759754,
                                                                                                                                                                        2.5,
                                                                                                                                                                        24.971787,
                                                                                                                                                                        0,
                                                                                                                                                                        26.759754,
                                                                                                                                                                        0,
                                                                                                                                                                        24.971787,
                                                                                                                                                                        0,
                                                                                                                                                                        26.759754,
                                                                                                                                                                        2.5,
                                                                                                                                                                        24.971787,
                                                                                                                                                                        100.704306,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        100.470929,
                                                                                                                                                                        11.960018,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        100.470929,
                                                                                                                                                                        11.960018,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        100.470929,
                                                                                                                                                                        11.960018,
                                                                                                                                                                        99.786704,
                                                                                                                                                                        10.308152,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        0,
                                                                                                                                                                        47.710209,
                                                                                                                                                                        0,
                                                                                                                                                                        49.498176,
                                                                                                                                                                        2.5,
                                                                                                                                                                        47.710209,
                                                                                                                                                                        2.5,
                                                                                                                                                                        49.498176,
                                                                                                                                                                        2.5,
                                                                                                                                                                        47.710209,
                                                                                                                                                                        0,
                                                                                                                                                                        49.498176,
                                                                                                                                                                        2.5,
                                                                                                                                                                        68.924303,
                                                                                                                                                                        2.5,
                                                                                                                                                                        67.136336,
                                                                                                                                                                        0,
                                                                                                                                                                        68.924303,
                                                                                                                                                                        0,
                                                                                                                                                                        67.136336,
                                                                                                                                                                        0,
                                                                                                                                                                        68.924303,
                                                                                                                                                                        2.5,
                                                                                                                                                                        67.136336,
                                                                                                                                                                        99.786704,
                                                                                                                                                                        10.308152,
                                                                                                                                                                        98.698258,
                                                                                                                                                                        8.889662,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        98.698258,
                                                                                                                                                                        8.889662,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        98.698258,
                                                                                                                                                                        8.889662,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        0,
                                                                                                                                                                        83.714276,
                                                                                                                                                                        2.5,
                                                                                                                                                                        83.714276,
                                                                                                                                                                        0,
                                                                                                                                                                        81.926309,
                                                                                                                                                                        2.5,
                                                                                                                                                                        81.926309,
                                                                                                                                                                        0,
                                                                                                                                                                        81.926309,
                                                                                                                                                                        2.5,
                                                                                                                                                                        83.714276,
                                                                                                                                                                        0,
                                                                                                                                                                        92.860183,
                                                                                                                                                                        2.5,
                                                                                                                                                                        92.860183,
                                                                                                                                                                        0,
                                                                                                                                                                        91.072216,
                                                                                                                                                                        2.5,
                                                                                                                                                                        91.072216,
                                                                                                                                                                        0,
                                                                                                                                                                        91.072216,
                                                                                                                                                                        2.5,
                                                                                                                                                                        92.860183,
                                                                                                                                                                        0,
                                                                                                                                                                        95.738746,
                                                                                                                                                                        2.5,
                                                                                                                                                                        95.738746,
                                                                                                                                                                        0,
                                                                                                                                                                        93.950778,
                                                                                                                                                                        2.5,
                                                                                                                                                                        93.950778,
                                                                                                                                                                        0,
                                                                                                                                                                        93.950778,
                                                                                                                                                                        2.5,
                                                                                                                                                                        95.738746, -93.855231,
                                                                                                                                                                        0, -93.855231,
                                                                                                                                                                        2.5, -77.908131,
                                                                                                                                                                        0, -77.908131,
                                                                                                                                                                        2.5, -77.908131,
                                                                                                                                                                        0, -93.855231,
                                                                                                                                                                        2.5,
                                                                                                                                                                        0, -76.343124, -2.5, -76.343124,
                                                                                                                                                                        0, -74.555157, -2.5, -74.555157,
                                                                                                                                                                        0, -74.555157, -2.5, -76.343124,
                                                                                                                                                                        0, -67.616439, -2.5, -67.616439,
                                                                                                                                                                        0, -65.828471, -2.5, -65.828471,
                                                                                                                                                                        0, -65.828471, -2.5, -67.616439,
                                                                                                                                                                        0, -54.342728, -2.5, -54.342728,
                                                                                                                                                                        0, -52.554761, -2.5, -52.554761,
                                                                                                                                                                        0, -52.554761, -2.5, -54.342728, -2.5, -37.426574, -2.5, -35.638606,
                                                                                                                                                                        0, -37.426574,
                                                                                                                                                                        68.146402,
                                                                                                                                                                        4.991547,
                                                                                                                                                                        69.187908,
                                                                                                                                                                        3.538243,
                                                                                                                                                                        65.940369,
                                                                                                                                                                        4.467275,
                                                                                                                                                                        67.137502,
                                                                                                                                                                        2.796811,
                                                                                                                                                                        65.940369,
                                                                                                                                                                        4.467275,
                                                                                                                                                                        69.187908,
                                                                                                                                                                        3.538243,
                                                                                                                                                                        37.147779, -23.346041,
                                                                                                                                                                        37.860478, -25.273641,
                                                                                                                                                                        35.128334, -23.643082,
                                                                                                                                                                        35.886525, -25.69372,
                                                                                                                                                                        35.128334, -23.643082,
                                                                                                                                                                        37.860478, -25.273641, -5, -34.357999, -5, -36.544313, -22.5, -34.357999, -22.5, -36.544313, -22.5, -34.357999, -5, -36.544313, -68.878718,
                                                                                                                                                                        9.545189, -70.209662,
                                                                                                                                                                        7.81067, -76.355567,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        8.607689, -70.209662,
                                                                                                                                                                        7.81067, -101.5537,
                                                                                                                                                                        7.81067, -101.5537,
                                                                                                                                                                        7.81067, -70.209662,
                                                                                                                                                                        7.81067, -99.819181,
                                                                                                                                                                        6.479727, -70.209662,
                                                                                                                                                                        7.81067, -71.944181,
                                                                                                                                                                        6.479727, -99.819181,
                                                                                                                                                                        6.479727, -22.5, -50.946235, -5, -50.946235, -22.5, -53.132549, -5, -53.132549, -22.5, -53.132549, -5, -50.946235, -22.5, -63.988072, -5, -63.988072, -22.5, -66.174386, -5, -66.174386, -22.5, -66.174386, -5, -63.988072, -22.5, -72.594731, -5, -72.594731, -22.5, -74.781045, -5, -74.781045, -22.5, -74.781045, -5, -72.594731, -76.131681,
                                                                                                                                                                        22.5, -76.131681,
                                                                                                                                                                        5, -95.631681,
                                                                                                                                                                        22.5, -95.631681,
                                                                                                                                                                        5, -95.631681,
                                                                                                                                                                        22.5, -76.131681,
                                                                                                                                                                        5,
                                                                                                                                                                        22.5,
                                                                                                                                                                        95.512857,
                                                                                                                                                                        5,
                                                                                                                                                                        95.512857,
                                                                                                                                                                        22.5,
                                                                                                                                                                        97.699171, -97.79929,
                                                                                                                                                                        5.643061, -73.964071,
                                                                                                                                                                        5.643061, -95.631681,
                                                                                                                                                                        5.357689, -71.944181,
                                                                                                                                                                        6.479727, -73.964071,
                                                                                                                                                                        5.643061, -97.79929,
                                                                                                                                                                        5.643061, -99.819181,
                                                                                                                                                                        6.479727, -71.944181,
                                                                                                                                                                        6.479727, -97.79929,
                                                                                                                                                                        5.643061, -76.131681,
                                                                                                                                                                        5.357689, -95.631681,
                                                                                                                                                                        5.357689, -73.964071,
                                                                                                                                                                        5.643061,
                                                                                                                                                                        76.131681, -3.327131,
                                                                                                                                                                        76.716681, -1.506416,
                                                                                                                                                                        95.631681, -3.327131,
                                                                                                                                                                        70.088846, -27.574882,
                                                                                                                                                                        68.898721, -29.071824,
                                                                                                                                                                        68.195436, -26.775772,
                                                                                                                                                                        66.884455, -28.221706,
                                                                                                                                                                        68.195436, -26.775772,
                                                                                                                                                                        68.898721, -29.071824,
                                                                                                                                                                        52.544505, -42.21748,
                                                                                                                                                                        50.8302, -43.150516,
                                                                                                                                                                        51.152385, -40.705667,
                                                                                                                                                                        49.349221, -41.542203,
                                                                                                                                                                        51.152385, -40.705667,
                                                                                                                                                                        50.8302, -43.150516,
                                                                                                                                                                        42.997074, -37.079828,
                                                                                                                                                                        41.108673, -37.700419,
                                                                                                                                                                        41.977042, -35.2957,
                                                                                                                                                                        40.023532, -35.80241,
                                                                                                                                                                        41.977042, -35.2957,
                                                                                                                                                                        41.108673, -37.700419,
                                                                                                                                                                        69.572331, -0.22306,
                                                                                                                                                                        67.995273,
                                                                                                                                                                        1.09469,
                                                                                                                                                                        71.410079,
                                                                                                                                                                        0.710479,
                                                                                                                                                                        70.038038,
                                                                                                                                                                        1.856921,
                                                                                                                                                                        71.410079,
                                                                                                                                                                        0.710479,
                                                                                                                                                                        67.995273,
                                                                                                                                                                        1.09469,
                                                                                                                                                                        72.625483,
                                                                                                                                                                        0.062302,
                                                                                                                                                                        74.246761, -0.691544,
                                                                                                                                                                        70.810195, -0.914193,
                                                                                                                                                                        72.673733, -1.780683,
                                                                                                                                                                        70.810195, -0.914193,
                                                                                                                                                                        74.246761, -0.691544,
                                                                                                                                                                        75.662015,
                                                                                                                                                                        1.284392,
                                                                                                                                                                        77.428516,
                                                                                                                                                                        1.008161,
                                                                                                                                                                        74.148228,
                                                                                                                                                                        0.114312,
                                                                                                                                                                        76.178688, -0.203196,
                                                                                                                                                                        74.148228,
                                                                                                                                                                        0.114312,
                                                                                                                                                                        77.428516,
                                                                                                                                                                        1.008161,
                                                                                                                                                                        77.908131,
                                                                                                                                                                        4.074551,
                                                                                                                                                                        93.855231,
                                                                                                                                                                        4.074551,
                                                                                                                                                                        76.716681,
                                                                                                                                                                        2.805733, -76.355567,
                                                                                                                                                                        8.607689, -101.5537,
                                                                                                                                                                        7.81067, -100.407795,
                                                                                                                                                                        8.607689, -102.884644,
                                                                                                                                                                        9.545189, -100.407795,
                                                                                                                                                                        8.607689, -101.5537,
                                                                                                                                                                        7.81067,
                                                                                                                                                                        22.5,
                                                                                                                                                                        70.204911,
                                                                                                                                                                        22.5,
                                                                                                                                                                        68.018597,
                                                                                                                                                                        5,
                                                                                                                                                                        70.204911, -100.407795,
                                                                                                                                                                        22.5, -76.671107,
                                                                                                                                                                        66.551021, -76.355567,
                                                                                                                                                                        22.5, -78,
                                                                                                                                                                        76.644964, -76.671107,
                                                                                                                                                                        66.551021, -100.407795,
                                                                                                                                                                        22.5, -78,
                                                                                                                                                                        76.644964, -76.671107,
                                                                                                                                                                        86.738907, -76.671107,
                                                                                                                                                                        66.551021, -76.671107,
                                                                                                                                                                        86.738907, -75.808753,
                                                                                                                                                                        76.644964, -76.671107,
                                                                                                                                                                        66.551021, -75.808753,
                                                                                                                                                                        76.644964, -74.554525,
                                                                                                                                                                        67.118158, -76.671107,
                                                                                                                                                                        66.551021,
                                                                                                                                                                        51.081553,
                                                                                                                                                                        92.737618,
                                                                                                                                                                        60.690566,
                                                                                                                                                                        92.737618,
                                                                                                                                                                        51.802229,
                                                                                                                                                                        86.495381,
                                                                                                                                                                        51.802229,
                                                                                                                                                                        86.495381,
                                                                                                                                                                        60.690566,
                                                                                                                                                                        92.737618,
                                                                                                                                                                        55.294022,
                                                                                                                                                                        86.495381,
                                                                                                                                                                        59.96989,
                                                                                                                                                                        86.495381,
                                                                                                                                                                        55.294022,
                                                                                                                                                                        86.495381,
                                                                                                                                                                        60.690566,
                                                                                                                                                                        92.737618,
                                                                                                                                                                        59.96989,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        59.96989,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        55.294022,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        32.981012,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        32.981012,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        41.148673,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        41.148673,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        41.148673,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        32.981012,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        11.633887,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        19.801548,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        11.633887,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        19.801548,
                                                                                                                                                                        103.320536,
                                                                                                                                                                        11.633887,
                                                                                                                                                                        103.320536,
                                                                                                                                                                        20.522224,
                                                                                                                                                                        109.562773,
                                                                                                                                                                        10.913211,
                                                                                                                                                                        109.562773,
                                                                                                                                                                        20.522224,
                                                                                                                                                                        109.562773,
                                                                                                                                                                        11.633887,
                                                                                                                                                                        103.320536,
                                                                                                                                                                        32.260336,
                                                                                                                                                                        103.468944,
                                                                                                                                                                        41.869349,
                                                                                                                                                                        103.468944,
                                                                                                                                                                        32.981012,
                                                                                                                                                                        97.226707,
                                                                                                                                                                        41.148673,
                                                                                                                                                                        97.226707,
                                                                                                                                                                        32.981012,
                                                                                                                                                                        97.226707,
                                                                                                                                                                        41.869349,
                                                                                                                                                                        103.468944, -11.50505,
                                                                                                                                                                        110.60382, -1.896037,
                                                                                                                                                                        110.60382, -10.784374,
                                                                                                                                                                        104.361583, -2.616713,
                                                                                                                                                                        104.361583, -10.784374,
                                                                                                                                                                        104.361583, -1.896037,
                                                                                                                                                                        110.60382, -10.784374,
                                                                                                                                                                        4.107689, -2.616713,
                                                                                                                                                                        4.107689, -10.784374,
                                                                                                                                                                        1.607689, -2.616713,
                                                                                                                                                                        1.607689, -10.784374,
                                                                                                                                                                        1.607689, -2.616713,
                                                                                                                                                                        4.107689, -32.746005,
                                                                                                                                                                        4.107689, -24.578344,
                                                                                                                                                                        4.107689, -32.746005,
                                                                                                                                                                        1.607689, -32.746005,
                                                                                                                                                                        100.278902, -33.466681,
                                                                                                                                                                        106.521139, -24.578344,
                                                                                                                                                                        100.278902, -23.857668,
                                                                                                                                                                        106.521139, -24.578344,
                                                                                                                                                                        100.278902, -33.466681,
                                                                                                                                                                        106.521139, -52.754355,
                                                                                                                                                                        91.350722, -53.475031,
                                                                                                                                                                        97.592959, -44.586694,
                                                                                                                                                                        91.350722, -43.866019,
                                                                                                                                                                        97.592959, -44.586694,
                                                                                                                                                                        91.350722, -53.475031,
                                                                                                                                                                        97.592959, -69.44589,
                                                                                                                                                                        78.185483, -70.166566,
                                                                                                                                                                        84.42772, -61.278229,
                                                                                                                                                                        78.185483, -69.44589,
                                                                                                                                                                        4.107689, -61.278229,
                                                                                                                                                                        4.107689, -69.44589,
                                                                                                                                                                        1.607689, -61.278229,
                                                                                                                                                                        1.607689, -69.44589,
                                                                                                                                                                        1.607689, -61.278229,
                                                                                                                                                                        4.107689, -81.683109,
                                                                                                                                                                        4.107689, -73.515448,
                                                                                                                                                                        4.107689, -81.683109,
                                                                                                                                                                        1.607689, -73.515448,
                                                                                                                                                                        1.607689, -81.683109,
                                                                                                                                                                        1.607689, -73.515448,
                                                                                                                                                                        4.107689, -88.632064,
                                                                                                                                                                        1.607689, -88.632064,
                                                                                                                                                                        4.107689, -80.464404,
                                                                                                                                                                        1.607689, -80.464404,
                                                                                                                                                                        4.107689, -80.464404,
                                                                                                                                                                        1.607689, -88.632064,
                                                                                                                                                                        4.107689, -89.819198,
                                                                                                                                                                        1.607689, -89.819198,
                                                                                                                                                                        4.107689, -81.651537,
                                                                                                                                                                        1.607689, -81.651537,
                                                                                                                                                                        4.107689, -81.651537,
                                                                                                                                                                        1.607689, -89.819198,
                                                                                                                                                                        4.107689, -85.163608,
                                                                                                                                                                        1.607689, -85.163608,
                                                                                                                                                                        4.107689, -76.995947,
                                                                                                                                                                        1.607689, -76.995947,
                                                                                                                                                                        4.107689, -76.995947,
                                                                                                                                                                        1.607689, -85.163608,
                                                                                                                                                                        4.107689, -74.982565,
                                                                                                                                                                        1.607689, -74.982565,
                                                                                                                                                                        4.107689, -66.814904,
                                                                                                                                                                        1.607689, -66.814904,
                                                                                                                                                                        4.107689, -66.814904,
                                                                                                                                                                        1.607689, -74.982565,
                                                                                                                                                                        4.107689, -59.96989,
                                                                                                                                                                        1.607689, -59.96989,
                                                                                                                                                                        4.107689, -56.327885,
                                                                                                                                                                        1.607689, -56.327885,
                                                                                                                                                                        1.607689, -59.96989,
                                                                                                                                                                        4.107689, -51.802229,
                                                                                                                                                                        1.607689, -51.802229,
                                                                                                                                                                        4.107689, -51.802229,
                                                                                                                                                                        1.607689, -59.96989,
                                                                                                                                                                        4.107689, -41.148673,
                                                                                                                                                                        1.607689, -41.148673,
                                                                                                                                                                        4.107689, -33.987354,
                                                                                                                                                                        1.607689, -33.987354,
                                                                                                                                                                        1.607689, -41.148673,
                                                                                                                                                                        4.107689, -32.981012,
                                                                                                                                                                        1.505434, -32.981012,
                                                                                                                                                                        4.107689, -32.981012,
                                                                                                                                                                        1.505434, -41.148673,
                                                                                                                                                                        4.107689, -32.981012, -38.873364, -41.148673, -38.873364, -32.260336, -32.631127, -41.869349, -32.631127, -32.260336, -32.631127, -41.148673, -38.873364, -51.802229, -28.142038, -59.96989, -28.142038, -51.081553, -21.899801, -60.690566, -21.899801, -51.081553, -21.899801, -59.96989, -28.142038, -66.814904, -13.504537, -74.982565, -13.504537, -66.094228, -7.2623, -44.586694,
                                                                                                                                                                        1.607689, -52.754355,
                                                                                                                                                                        1.607689, -44.586694,
                                                                                                                                                                        4.107689, -52.754355,
                                                                                                                                                                        4.107689, -44.586694,
                                                                                                                                                                        4.107689, -52.754355,
                                                                                                                                                                        1.607689, -24.578344,
                                                                                                                                                                        1.607689, -32.746005,
                                                                                                                                                                        1.607689, -24.578344,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        19.801548,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        11.633887,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        19.801548,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        55.294022,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        55.294022,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        59.96989,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        55.294022,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        55.294022,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        51.802229,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        51.802229,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        51.802229,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        55.294022,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        74.982565,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        74.982565,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        66.814904,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        66.814904,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        66.814904,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        74.982565,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        85.163608,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        85.163608,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        76.995947,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        76.995947,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        76.995947,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        85.163608,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        89.819198,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        86.177192,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        89.819198,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        86.177192,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        81.651537,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        89.819198,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        81.651537,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        89.819198,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        81.651537,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        81.651537,
                                                                                                                                                                        35.052657,
                                                                                                                                                                        80.930861,
                                                                                                                                                                        41.294894,
                                                                                                                                                                        89.819198,
                                                                                                                                                                        35.052657,
                                                                                                                                                                        89.35274,
                                                                                                                                                                        21.635388,
                                                                                                                                                                        88.632064,
                                                                                                                                                                        15.393151,
                                                                                                                                                                        79.743728,
                                                                                                                                                                        21.635388, -70.877315,
                                                                                                                                                                        58.240588, -65.027719,
                                                                                                                                                                        50.617245, -66.577164,
                                                                                                                                                                        49.0678, -66.577164,
                                                                                                                                                                        49.0678, -65.027719,
                                                                                                                                                                        50.617245, -63.594438,
                                                                                                                                                                        46.779073, -63.594438,
                                                                                                                                                                        46.779073, -76.355567,
                                                                                                                                                                        39.269157, -66.577164,
                                                                                                                                                                        49.0678, -72.774991,
                                                                                                                                                                        57.144964, -66.577164,
                                                                                                                                                                        49.0678, -76.355567,
                                                                                                                                                                        39.269157, -72.774991,
                                                                                                                                                                        57.144964, -70.877315,
                                                                                                                                                                        58.240588, -66.577164,
                                                                                                                                                                        49.0678, -74.554525,
                                                                                                                                                                        67.118158, -70.877315,
                                                                                                                                                                        58.240588, -72.774991,
                                                                                                                                                                        57.144964,
                                                                                                                                                                        85.884284,
                                                                                                                                                                        60.553962,
                                                                                                                                                                        85.163608,
                                                                                                                                                                        54.311725,
                                                                                                                                                                        76.275271,
                                                                                                                                                                        60.553962,
                                                                                                                                                                        66.094228,
                                                                                                                                                                        78.100117,
                                                                                                                                                                        75.703241,
                                                                                                                                                                        78.100117,
                                                                                                                                                                        66.814904,
                                                                                                                                                                        71.85788,
                                                                                                                                                                        74.982565,
                                                                                                                                                                        71.85788,
                                                                                                                                                                        66.814904,
                                                                                                                                                                        71.85788,
                                                                                                                                                                        75.703241,
                                                                                                                                                                        78.100117,
                                                                                                                                                                        76.995947,
                                                                                                                                                                        54.311725,
                                                                                                                                                                        76.275271,
                                                                                                                                                                        60.553962,
                                                                                                                                                                        85.163608,
                                                                                                                                                                        54.311725,
                                                                                                                                                                        90.539874,
                                                                                                                                                                        41.294894,
                                                                                                                                                                        89.819198,
                                                                                                                                                                        35.052657,
                                                                                                                                                                        80.930861,
                                                                                                                                                                        41.294894, -76.671107,
                                                                                                                                                                        66.551021, -74.554525,
                                                                                                                                                                        67.118158, -72.774991,
                                                                                                                                                                        57.144964, -76.671107,
                                                                                                                                                                        66.551021, -72.774991,
                                                                                                                                                                        57.144964, -76.355567,
                                                                                                                                                                        39.269157, -76.355567,
                                                                                                                                                                        22.5, -76.671107,
                                                                                                                                                                        66.551021, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        78.930155,
                                                                                                                                                                        2.915206,
                                                                                                                                                                        78.730523, -3.327031,
                                                                                                                                                                        72.794772,
                                                                                                                                                                        2.915206,
                                                                                                                                                                        88.632064,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        81.470746,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        88.632064,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        81.470746,
                                                                                                                                                                        1.607689,
                                                                                                                                                                        80.464404,
                                                                                                                                                                        1.505434,
                                                                                                                                                                        88.632064,
                                                                                                                                                                        4.107689,
                                                                                                                                                                        0, -35.638606,
                                                                                                                                                                        0, -37.426574, -2.5, -35.638606,
                                                                                                                                                                        71.976658,
                                                                                                                                                                        10.308152,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        73.065104,
                                                                                                                                                                        8.889662,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        71.976658,
                                                                                                                                                                        10.308152,
                                                                                                                                                                        0, -52.721073,
                                                                                                                                                                        2.5, -52.721073,
                                                                                                                                                                        0, -54.176415,
                                                                                                                                                                        0, -37.260261,
                                                                                                                                                                        0, -35.804919,
                                                                                                                                                                        2.5, -37.260261,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        71.976658,
                                                                                                                                                                        10.308152,
                                                                                                                                                                        2.5, -35.804919,
                                                                                                                                                                        2.5, -37.260261,
                                                                                                                                                                        0, -35.804919,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        10.945237, -2.5, -52.872607,
                                                                                                                                                                        0, -52.872607, -2.5, -54.024881, -2.5, -37.108727, -2.5, -35.956453,
                                                                                                                                                                        0, -37.108727,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        73.080122,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        0, -35.956453,
                                                                                                                                                                        0, -37.108727, -2.5, -35.956453,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        0, -53.024353,
                                                                                                                                                                        2.5, -53.024353,
                                                                                                                                                                        0, -53.873135,
                                                                                                                                                                        0, -36.956981,
                                                                                                                                                                        0, -36.108199,
                                                                                                                                                                        2.5, -36.956981,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        74.085531,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        2.5, -36.108199,
                                                                                                                                                                        2.5, -36.956981,
                                                                                                                                                                        0, -36.108199, -2.5,
                                                                                                                                                                        67.605929, -2.5,
                                                                                                                                                                        68.454711,
                                                                                                                                                                        0,
                                                                                                                                                                        67.605929,
                                                                                                                                                                        0,
                                                                                                                                                                        68.454711,
                                                                                                                                                                        0,
                                                                                                                                                                        67.605929, -2.5,
                                                                                                                                                                        68.454711,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        0,
                                                                                                                                                                        48.028055,
                                                                                                                                                                        0,
                                                                                                                                                                        49.18033,
                                                                                                                                                                        2.5,
                                                                                                                                                                        48.028055,
                                                                                                                                                                        2.5,
                                                                                                                                                                        49.18033,
                                                                                                                                                                        2.5,
                                                                                                                                                                        48.028055,
                                                                                                                                                                        0,
                                                                                                                                                                        49.18033,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        12.590273,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        99.430136,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        98.118787,
                                                                                                                                                                        12.590273, -2.5,
                                                                                                                                                                        25.138099, -2.5,
                                                                                                                                                                        26.593441,
                                                                                                                                                                        0,
                                                                                                                                                                        25.138099,
                                                                                                                                                                        0,
                                                                                                                                                                        26.593441,
                                                                                                                                                                        0,
                                                                                                                                                                        25.138099, -2.5,
                                                                                                                                                                        26.593441,
                                                                                                                                                                        99.430136,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        100.704306,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        0,
                                                                                                                                                                        49.331864,
                                                                                                                                                                        0,
                                                                                                                                                                        47.876522, -2.5,
                                                                                                                                                                        49.331864, -2.5,
                                                                                                                                                                        47.876522, -2.5,
                                                                                                                                                                        49.331864,
                                                                                                                                                                        0,
                                                                                                                                                                        47.876522,
                                                                                                                                                                        99.240175,
                                                                                                                                                                        12.289798,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        9.91009, -2.5,
                                                                                                                                                                        67.302648, -2.5,
                                                                                                                                                                        68.757991,
                                                                                                                                                                        0,
                                                                                                                                                                        67.302648,
                                                                                                                                                                        0,
                                                                                                                                                                        68.757991,
                                                                                                                                                                        0,
                                                                                                                                                                        67.302648, -2.5,
                                                                                                                                                                        68.757991,
                                                                                                                                                                        98.68324,
                                                                                                                                                                        10.945237,
                                                                                                                                                                        99.786704,
                                                                                                                                                                        10.308152,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        99.786704,
                                                                                                                                                                        10.308152,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        0,
                                                                                                                                                                        82.092622, -2.5,
                                                                                                                                                                        82.092622,
                                                                                                                                                                        0,
                                                                                                                                                                        83.547964, -2.5,
                                                                                                                                                                        92.693871,
                                                                                                                                                                        0,
                                                                                                                                                                        92.693871, -2.5,
                                                                                                                                                                        91.238529,
                                                                                                                                                                        0,
                                                                                                                                                                        91.238529, -2.5,
                                                                                                                                                                        91.238529,
                                                                                                                                                                        0,
                                                                                                                                                                        92.693871, -2.5,
                                                                                                                                                                        95.572433,
                                                                                                                                                                        0,
                                                                                                                                                                        95.572433, -2.5,
                                                                                                                                                                        94.033578,
                                                                                                                                                                        0,
                                                                                                                                                                        94.033578, -2.5,
                                                                                                                                                                        94.033578,
                                                                                                                                                                        0,
                                                                                                                                                                        95.572433,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        2.5,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        0,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        2.5,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        0,
                                                                                                                                                                        2.5, -76.260325,
                                                                                                                                                                        0, -76.260325,
                                                                                                                                                                        2.5, -74.721469,
                                                                                                                                                                        0, -74.721469,
                                                                                                                                                                        2.5, -74.721469,
                                                                                                                                                                        0, -76.260325,
                                                                                                                                                                        2.5, -67.450126,
                                                                                                                                                                        0, -67.450126,
                                                                                                                                                                        2.5, -65.994784,
                                                                                                                                                                        0, -65.994784,
                                                                                                                                                                        2.5, -65.994784,
                                                                                                                                                                        0, -67.450126,
                                                                                                                                                                        2.5, -54.176415,
                                                                                                                                                                        0, -54.176415,
                                                                                                                                                                        2.5, -52.721073,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        9.297899,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        9.297899,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        9.790636, -2.5, -74.873003,
                                                                                                                                                                        0, -74.873003, -2.5, -76.184884,
                                                                                                                                                                        0, -67.298592, -2.5, -67.298592,
                                                                                                                                                                        0, -66.146318, -2.5, -66.146318,
                                                                                                                                                                        0, -66.146318, -2.5, -67.298592,
                                                                                                                                                                        0, -54.024881, -2.5, -54.024881,
                                                                                                                                                                        0, -52.872607,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        0, -75.024749,
                                                                                                                                                                        2.5, -75.024749,
                                                                                                                                                                        0, -76.109336,
                                                                                                                                                                        2.5, -67.146846,
                                                                                                                                                                        0, -67.146846,
                                                                                                                                                                        2.5, -66.298064,
                                                                                                                                                                        0, -66.298064,
                                                                                                                                                                        2.5, -66.298064,
                                                                                                                                                                        0, -67.146846,
                                                                                                                                                                        2.5, -53.873135,
                                                                                                                                                                        0, -53.873135,
                                                                                                                                                                        2.5, -53.024353, -2.5,
                                                                                                                                                                        83.244684,
                                                                                                                                                                        0,
                                                                                                                                                                        83.244684, -2.5,
                                                                                                                                                                        82.395902,
                                                                                                                                                                        0,
                                                                                                                                                                        82.395902, -2.5,
                                                                                                                                                                        82.395902,
                                                                                                                                                                        0,
                                                                                                                                                                        83.244684, -2.5,
                                                                                                                                                                        92.390591,
                                                                                                                                                                        0,
                                                                                                                                                                        92.390591, -2.5,
                                                                                                                                                                        91.541809,
                                                                                                                                                                        0,
                                                                                                                                                                        91.541809, -2.5,
                                                                                                                                                                        91.541809,
                                                                                                                                                                        0,
                                                                                                                                                                        92.390591, -2.5,
                                                                                                                                                                        95.269153,
                                                                                                                                                                        0,
                                                                                                                                                                        95.269153, -2.5,
                                                                                                                                                                        94.184566,
                                                                                                                                                                        0,
                                                                                                                                                                        94.184566, -2.5,
                                                                                                                                                                        94.184566,
                                                                                                                                                                        0,
                                                                                                                                                                        95.269153,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        0,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        0,
                                                                                                                                                                        2.5, -76.109336,
                                                                                                                                                                        0, -76.109336,
                                                                                                                                                                        2.5, -75.024749,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        96.97637,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        0,
                                                                                                                                                                        67.454182,
                                                                                                                                                                        0,
                                                                                                                                                                        68.606457,
                                                                                                                                                                        2.5,
                                                                                                                                                                        67.454182,
                                                                                                                                                                        2.5,
                                                                                                                                                                        68.606457,
                                                                                                                                                                        2.5,
                                                                                                                                                                        67.454182,
                                                                                                                                                                        0,
                                                                                                                                                                        68.606457,
                                                                                                                                                                        0,
                                                                                                                                                                        83.39643,
                                                                                                                                                                        2.5,
                                                                                                                                                                        83.39643,
                                                                                                                                                                        0,
                                                                                                                                                                        82.244156,
                                                                                                                                                                        2.5,
                                                                                                                                                                        82.244156,
                                                                                                                                                                        0,
                                                                                                                                                                        82.244156,
                                                                                                                                                                        2.5,
                                                                                                                                                                        83.39643,
                                                                                                                                                                        0,
                                                                                                                                                                        92.542337,
                                                                                                                                                                        2.5,
                                                                                                                                                                        92.542337,
                                                                                                                                                                        0,
                                                                                                                                                                        91.390063,
                                                                                                                                                                        2.5,
                                                                                                                                                                        91.390063,
                                                                                                                                                                        0,
                                                                                                                                                                        91.390063,
                                                                                                                                                                        2.5,
                                                                                                                                                                        92.542337,
                                                                                                                                                                        0,
                                                                                                                                                                        95.420899,
                                                                                                                                                                        2.5,
                                                                                                                                                                        95.420899,
                                                                                                                                                                        0,
                                                                                                                                                                        94.109019,
                                                                                                                                                                        2.5,
                                                                                                                                                                        94.109019,
                                                                                                                                                                        0,
                                                                                                                                                                        94.109019,
                                                                                                                                                                        2.5,
                                                                                                                                                                        95.420899, -93.69699,
                                                                                                                                                                        0, -93.69699,
                                                                                                                                                                        2.5, -78.066372,
                                                                                                                                                                        0, -78.066372,
                                                                                                                                                                        2.5, -78.066372,
                                                                                                                                                                        0, -93.69699,
                                                                                                                                                                        2.5,
                                                                                                                                                                        0, -76.184884, -2.5, -76.184884,
                                                                                                                                                                        0, -74.873003,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        9.297899,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        9.297899,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        9.297899,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        9.297899,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        78.066372,
                                                                                                                                                                        9.297899,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        9.297899,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        9.297899, -2.5,
                                                                                                                                                                        83.547964,
                                                                                                                                                                        0,
                                                                                                                                                                        83.547964, -2.5,
                                                                                                                                                                        82.092622,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        93.69699,
                                                                                                                                                                        9.297899,
                                                                                                                                                                        96.06221,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        97.797284,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        94.997647,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        96.642683,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        8.146884,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        8.146884,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        8.146884,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        97.677831,
                                                                                                                                                                        11.525711,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        74.786992,
                                                                                                                                                                        10.61155,
                                                                                                                                                                        75.701152,
                                                                                                                                                                        9.91009,
                                                                                                                                                                        76.765715,
                                                                                                                                                                        9.469134,
                                                                                                                                                                        73.966078,
                                                                                                                                                                        9.790636,
                                                                                                                                                                        75.120679,
                                                                                                                                                                        8.90468,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        73.065104,
                                                                                                                                                                        8.889662,
                                                                                                                                                                        73.065104,
                                                                                                                                                                        8.889662,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        8.146884,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        76.465239,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        8.146884,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        77.99093,
                                                                                                                                                                        8.146884,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        8.146884,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        95.298123,
                                                                                                                                                                        8.347745,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        93.772432,
                                                                                                                                                                        8.146884,
                                                                                                                                                                        74.483593,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        76.13546,
                                                                                                                                                                        7.116991,
                                                                                                                                                                        97.279768,
                                                                                                                                                                        7.801216,
                                                                                                                                                                        95.627902,
                                                                                                                                                                        7.116991,
                                                                                                                                                                        76.13546,
                                                                                                                                                                        7.116991,
                                                                                                                                                                        76.13546,
                                                                                                                                                                        7.116991,
                                                                                                                                                                        95.627902,
                                                                                                                                                                        7.116991,
                                                                                                                                                                        77.908131,
                                                                                                                                                                        6.883614,
                                                                                                                                                                        93.855231,
                                                                                                                                                                        6.883614,
                                                                                                                                                                        77.908131,
                                                                                                                                                                        6.883614,
                                                                                                                                                                        95.627902,
                                                                                                                                                                        7.116991,
                                                                                                                                                                        70.452581,
                                                                                                                                                                        19.134045,
                                                                                                                                                                        60.271538,
                                                                                                                                                                        19.134045,
                                                                                                                                                                        70.096245,
                                                                                                                                                                        22.357153,
                                                                                                                                                                        10.784374,
                                                                                                                                                                        0.172044,
                                                                                                                                                                        2.616713,
                                                                                                                                                                        0.676451,
                                                                                                                                                                        10.784374,
                                                                                                                                                                        4.107689, -7.122685,
                                                                                                                                                                        95.049341, -5.225009,
                                                                                                                                                                        96.144964, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        5,
                                                                                                                                                                        25.004487,
                                                                                                                                                                        5,
                                                                                                                                                                        27.1908,
                                                                                                                                                                        22.5,
                                                                                                                                                                        25.004487,
                                                                                                                                                                        59.143169,
                                                                                                                                                                        23.171258,
                                                                                                                                                                        58.992545,
                                                                                                                                                                        20.990139,
                                                                                                                                                                        57.082791,
                                                                                                                                                                        23.171258,
                                                                                                                                                                        56.941205,
                                                                                                                                                                        21.121006,
                                                                                                                                                                        57.082791,
                                                                                                                                                                        23.171258,
                                                                                                                                                                        58.992545,
                                                                                                                                                                        20.990139,
                                                                                                                                                                        22.5,
                                                                                                                                                                        27.1908,
                                                                                                                                                                        22.5,
                                                                                                                                                                        25.004487,
                                                                                                                                                                        5,
                                                                                                                                                                        27.1908,
                                                                                                                                                                        34.741875, -16.609013,
                                                                                                                                                                        32.914509, -16.609013,
                                                                                                                                                                        34.623097, -15.067425,
                                                                                                                                                                        33.033288, -15.067425,
                                                                                                                                                                        34.623097, -15.067425,
                                                                                                                                                                        32.914509, -16.609013,
                                                                                                                                                                        44.882488,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        44.882488,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        44.274095,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        44.882488,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        44.274095,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        44.274095,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        44.274095,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        44.274095,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        43.30628,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        17.328418, -19.070274,
                                                                                                                                                                        18.918227, -19.070274,
                                                                                                                                                                        17.209639, -20.611861, -46.620289,
                                                                                                                                                                        15.098225, -48.14141,
                                                                                                                                                                        25.107689, -46.314043,
                                                                                                                                                                        15.02314, -46.314043,
                                                                                                                                                                        25.107689, -46.314043,
                                                                                                                                                                        15.02314, -48.14141,
                                                                                                                                                                        25.107689, -34.741875,
                                                                                                                                                                        25.107689, -32.914509,
                                                                                                                                                                        25.107689, -34.741875,
                                                                                                                                                                        15.02314, -32.914509,
                                                                                                                                                                        49.202868, -34.741875,
                                                                                                                                                                        49.202868, -33.033288,
                                                                                                                                                                        50.744456, -34.623097,
                                                                                                                                                                        50.744456, -33.033288,
                                                                                                                                                                        50.744456, -34.741875,
                                                                                                                                                                        49.202868,
                                                                                                                                                                        33.725905,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        33.117512,
                                                                                                                                                                        51.193492,
                                                                                                                                                                        33.117512,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        32.91,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        33.117512,
                                                                                                                                                                        54.345908,
                                                                                                                                                                        33.117512,
                                                                                                                                                                        51.193492, -56.613865,
                                                                                                                                                                        36.436912, -56.495086,
                                                                                                                                                                        34.895325, -58.203674,
                                                                                                                                                                        36.436912, -48.022631,
                                                                                                                                                                        44.499122, -46.432822,
                                                                                                                                                                        44.499122, -48.14141,
                                                                                                                                                                        42.957535, -46.314043,
                                                                                                                                                                        42.957535, -48.14141,
                                                                                                                                                                        42.957535, -46.432822,
                                                                                                                                                                        44.499122, -58.322453,
                                                                                                                                                                        34.895325, -58.203674,
                                                                                                                                                                        36.436912, -56.495086,
                                                                                                                                                                        34.895325, -62.882595,
                                                                                                                                                                        27.107252, -62.763816,
                                                                                                                                                                        25.565664, -64.472404,
                                                                                                                                                                        27.107252, -64.591183,
                                                                                                                                                                        25.565664, -64.472404,
                                                                                                                                                                        27.107252, -62.763816,
                                                                                                                                                                        25.565664, -64.811809,
                                                                                                                                                                        17.145943, -64.69303,
                                                                                                                                                                        15.604355, -66.401618,
                                                                                                                                                                        17.145943, -66.520397,
                                                                                                                                                                        15.604355, -66.401618,
                                                                                                                                                                        17.145943, -64.69303,
                                                                                                                                                                        15.604355, -66.520397,
                                                                                                                                                                        25.107689, -64.69303,
                                                                                                                                                                        25.107689, -66.214151,
                                                                                                                                                                        16.508918, -66.520397,
                                                                                                                                                                        16.559911, -66.520397,
                                                                                                                                                                        25.107689, -66.214151,
                                                                                                                                                                        16.508918,
                                                                                                                                                                        34.69372,
                                                                                                                                                                        57.075981,
                                                                                                                                                                        34.69372,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        33.725905,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        35.955,
                                                                                                                                                                        47.495606,
                                                                                                                                                                        34.69372,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        34.69372,
                                                                                                                                                                        57.075981, -1.978282,
                                                                                                                                                                        56.234879, -0.388473,
                                                                                                                                                                        56.234879, -2.097061,
                                                                                                                                                                        54.693292, -0.269695,
                                                                                                                                                                        54.693292, -2.097061,
                                                                                                                                                                        54.693292, -0.388473,
                                                                                                                                                                        56.234879, -2.097061,
                                                                                                                                                                        25.107689, -0.269695,
                                                                                                                                                                        25.107689, -2.097061,
                                                                                                                                                                        14.293459, -0.269695,
                                                                                                                                                                        14.061539, -2.097061,
                                                                                                                                                                        14.293459, -0.269695,
                                                                                                                                                                        25.107689, -17.209639,
                                                                                                                                                                        25.107689, -17.209639,
                                                                                                                                                                        14.293459, -19.037006,
                                                                                                                                                                        25.107689, -19.037006,
                                                                                                                                                                        14.621443, -19.037006,
                                                                                                                                                                        25.107689, -17.209639,
                                                                                                                                                                        14.293459, -32.914509,
                                                                                                                                                                        14.621443, -34.741875,
                                                                                                                                                                        15.02314, -32.914509,
                                                                                                                                                                        25.107689, -17.209639,
                                                                                                                                                                        53.205717, -19.037006,
                                                                                                                                                                        53.205717, -17.328418,
                                                                                                                                                                        54.747304, -18.918227,
                                                                                                                                                                        54.747304, -17.328418,
                                                                                                                                                                        54.747304, -19.037006,
                                                                                                                                                                        53.205717,
                                                                                                                                                                        34.69372,
                                                                                                                                                                        48.46342,
                                                                                                                                                                        33.725905,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        33.725905,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        33.725905,
                                                                                                                                                                        55.8147,
                                                                                                                                                                        33.725905,
                                                                                                                                                                        49.7247,
                                                                                                                                                                        33.117512,
                                                                                                                                                                        54.345908, -47.795475,
                                                                                                                                                                        18.107689, -54.392081,
                                                                                                                                                                        17.357689, -66.612606,
                                                                                                                                                                        18.857689, -54.392081,
                                                                                                                                                                        17.357689, -62.260957,
                                                                                                                                                                        15.857689, -66.612606,
                                                                                                                                                                        18.857689, -72.250764,
                                                                                                                                                                        18.857689, -72.250764,
                                                                                                                                                                        14.762562, -77.985235,
                                                                                                                                                                        14.664789, -66.612606,
                                                                                                                                                                        14.762562, -66.612606,
                                                                                                                                                                        18.857689, -62.260957,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        18.857689, -47.795475,
                                                                                                                                                                        18.107689, -66.612606,
                                                                                                                                                                        18.857689, -97.756683, -0.160349, -98.488344, -4.204117, -112.603512, -2.435699, -128.272387,
                                                                                                                                                                        56.37774, -128.272387,
                                                                                                                                                                        55.852368, -159.022387,
                                                                                                                                                                        56.37774, -193.696812,
                                                                                                                                                                        16.357689, -193.696812,
                                                                                                                                                                        17.107689, -172.949491,
                                                                                                                                                                        16.357689, -172.949491,
                                                                                                                                                                        17.107689, -172.949491,
                                                                                                                                                                        16.357689, -193.696812,
                                                                                                                                                                        17.107689,
                                                                                                                                                                        89.405241,
                                                                                                                                                                        151.35706,
                                                                                                                                                                        89.191022,
                                                                                                                                                                        150.959443,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        128.546883, -30.067029,
                                                                                                                                                                        128.546883, -29.927567,
                                                                                                                                                                        159.296883, -30.067029, -94.75,
                                                                                                                                                                        16.357689, -95.070637,
                                                                                                                                                                        15.74846, -96.902598,
                                                                                                                                                                        15.978016, -96.902598,
                                                                                                                                                                        15.978016, -95.070637,
                                                                                                                                                                        15.74846, -96.590327,
                                                                                                                                                                        15.602447, -96.923915,
                                                                                                                                                                        15.993085, -94.75,
                                                                                                                                                                        16.357689, -96.902598,
                                                                                                                                                                        15.978016,
                                                                                                                                                                        54.793366,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        20.247152,
                                                                                                                                                                        34.607116,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "indices": [
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        2,
                                                                                                                                                                        3,
                                                                                                                                                                        4,
                                                                                                                                                                        5,
                                                                                                                                                                        6,
                                                                                                                                                                        7,
                                                                                                                                                                        8,
                                                                                                                                                                        9,
                                                                                                                                                                        10,
                                                                                                                                                                        11,
                                                                                                                                                                        12,
                                                                                                                                                                        13,
                                                                                                                                                                        14,
                                                                                                                                                                        15,
                                                                                                                                                                        16,
                                                                                                                                                                        17,
                                                                                                                                                                        18,
                                                                                                                                                                        19,
                                                                                                                                                                        20,
                                                                                                                                                                        21,
                                                                                                                                                                        22,
                                                                                                                                                                        23,
                                                                                                                                                                        24,
                                                                                                                                                                        25,
                                                                                                                                                                        26,
                                                                                                                                                                        27,
                                                                                                                                                                        28,
                                                                                                                                                                        29,
                                                                                                                                                                        30,
                                                                                                                                                                        31,
                                                                                                                                                                        32,
                                                                                                                                                                        33,
                                                                                                                                                                        34,
                                                                                                                                                                        35,
                                                                                                                                                                        36,
                                                                                                                                                                        37,
                                                                                                                                                                        38,
                                                                                                                                                                        39,
                                                                                                                                                                        40,
                                                                                                                                                                        41,
                                                                                                                                                                        42,
                                                                                                                                                                        43,
                                                                                                                                                                        44,
                                                                                                                                                                        45,
                                                                                                                                                                        46,
                                                                                                                                                                        47,
                                                                                                                                                                        48,
                                                                                                                                                                        49,
                                                                                                                                                                        50,
                                                                                                                                                                        51,
                                                                                                                                                                        52,
                                                                                                                                                                        53,
                                                                                                                                                                        54,
                                                                                                                                                                        55,
                                                                                                                                                                        56,
                                                                                                                                                                        57,
                                                                                                                                                                        58,
                                                                                                                                                                        59,
                                                                                                                                                                        60,
                                                                                                                                                                        61,
                                                                                                                                                                        62,
                                                                                                                                                                        63,
                                                                                                                                                                        64,
                                                                                                                                                                        65,
                                                                                                                                                                        66,
                                                                                                                                                                        67,
                                                                                                                                                                        68,
                                                                                                                                                                        69,
                                                                                                                                                                        70,
                                                                                                                                                                        71,
                                                                                                                                                                        72,
                                                                                                                                                                        73,
                                                                                                                                                                        74,
                                                                                                                                                                        75,
                                                                                                                                                                        76,
                                                                                                                                                                        77,
                                                                                                                                                                        78,
                                                                                                                                                                        79,
                                                                                                                                                                        80,
                                                                                                                                                                        81,
                                                                                                                                                                        82,
                                                                                                                                                                        83,
                                                                                                                                                                        84,
                                                                                                                                                                        85,
                                                                                                                                                                        86,
                                                                                                                                                                        87,
                                                                                                                                                                        88,
                                                                                                                                                                        89,
                                                                                                                                                                        90,
                                                                                                                                                                        91,
                                                                                                                                                                        92,
                                                                                                                                                                        93,
                                                                                                                                                                        94,
                                                                                                                                                                        95,
                                                                                                                                                                        96,
                                                                                                                                                                        97,
                                                                                                                                                                        98,
                                                                                                                                                                        99,
                                                                                                                                                                        100,
                                                                                                                                                                        101,
                                                                                                                                                                        102,
                                                                                                                                                                        103,
                                                                                                                                                                        104,
                                                                                                                                                                        105,
                                                                                                                                                                        106,
                                                                                                                                                                        107,
                                                                                                                                                                        108,
                                                                                                                                                                        109,
                                                                                                                                                                        110,
                                                                                                                                                                        111,
                                                                                                                                                                        112,
                                                                                                                                                                        113,
                                                                                                                                                                        114,
                                                                                                                                                                        115,
                                                                                                                                                                        116,
                                                                                                                                                                        117,
                                                                                                                                                                        118,
                                                                                                                                                                        119,
                                                                                                                                                                        120,
                                                                                                                                                                        121,
                                                                                                                                                                        122,
                                                                                                                                                                        123,
                                                                                                                                                                        124,
                                                                                                                                                                        125,
                                                                                                                                                                        126,
                                                                                                                                                                        127,
                                                                                                                                                                        128,
                                                                                                                                                                        129,
                                                                                                                                                                        130,
                                                                                                                                                                        131,
                                                                                                                                                                        132,
                                                                                                                                                                        133,
                                                                                                                                                                        134,
                                                                                                                                                                        135,
                                                                                                                                                                        136,
                                                                                                                                                                        137,
                                                                                                                                                                        138,
                                                                                                                                                                        139,
                                                                                                                                                                        140,
                                                                                                                                                                        141,
                                                                                                                                                                        142,
                                                                                                                                                                        143,
                                                                                                                                                                        144,
                                                                                                                                                                        145,
                                                                                                                                                                        146,
                                                                                                                                                                        147,
                                                                                                                                                                        148,
                                                                                                                                                                        149,
                                                                                                                                                                        150,
                                                                                                                                                                        151,
                                                                                                                                                                        152,
                                                                                                                                                                        153,
                                                                                                                                                                        154,
                                                                                                                                                                        155,
                                                                                                                                                                        156,
                                                                                                                                                                        157,
                                                                                                                                                                        158,
                                                                                                                                                                        159,
                                                                                                                                                                        160,
                                                                                                                                                                        161,
                                                                                                                                                                        162,
                                                                                                                                                                        163,
                                                                                                                                                                        164,
                                                                                                                                                                        165,
                                                                                                                                                                        166,
                                                                                                                                                                        167,
                                                                                                                                                                        168,
                                                                                                                                                                        169,
                                                                                                                                                                        170,
                                                                                                                                                                        171,
                                                                                                                                                                        172,
                                                                                                                                                                        173,
                                                                                                                                                                        174,
                                                                                                                                                                        175,
                                                                                                                                                                        176,
                                                                                                                                                                        177,
                                                                                                                                                                        178,
                                                                                                                                                                        179,
                                                                                                                                                                        180,
                                                                                                                                                                        181,
                                                                                                                                                                        182,
                                                                                                                                                                        183,
                                                                                                                                                                        184,
                                                                                                                                                                        185,
                                                                                                                                                                        186,
                                                                                                                                                                        187,
                                                                                                                                                                        188,
                                                                                                                                                                        189,
                                                                                                                                                                        190,
                                                                                                                                                                        191,
                                                                                                                                                                        192,
                                                                                                                                                                        193,
                                                                                                                                                                        194,
                                                                                                                                                                        195,
                                                                                                                                                                        196,
                                                                                                                                                                        197,
                                                                                                                                                                        198,
                                                                                                                                                                        199,
                                                                                                                                                                        200,
                                                                                                                                                                        201,
                                                                                                                                                                        202,
                                                                                                                                                                        203,
                                                                                                                                                                        204,
                                                                                                                                                                        205,
                                                                                                                                                                        206,
                                                                                                                                                                        207,
                                                                                                                                                                        208,
                                                                                                                                                                        209,
                                                                                                                                                                        210,
                                                                                                                                                                        211,
                                                                                                                                                                        212,
                                                                                                                                                                        213,
                                                                                                                                                                        214,
                                                                                                                                                                        215,
                                                                                                                                                                        216,
                                                                                                                                                                        217,
                                                                                                                                                                        218,
                                                                                                                                                                        219,
                                                                                                                                                                        220,
                                                                                                                                                                        221,
                                                                                                                                                                        222,
                                                                                                                                                                        223,
                                                                                                                                                                        224,
                                                                                                                                                                        225,
                                                                                                                                                                        226,
                                                                                                                                                                        227,
                                                                                                                                                                        228,
                                                                                                                                                                        229,
                                                                                                                                                                        230,
                                                                                                                                                                        231,
                                                                                                                                                                        232,
                                                                                                                                                                        233,
                                                                                                                                                                        234,
                                                                                                                                                                        235,
                                                                                                                                                                        236,
                                                                                                                                                                        237,
                                                                                                                                                                        238,
                                                                                                                                                                        239,
                                                                                                                                                                        240,
                                                                                                                                                                        241,
                                                                                                                                                                        242,
                                                                                                                                                                        243,
                                                                                                                                                                        244,
                                                                                                                                                                        245,
                                                                                                                                                                        246,
                                                                                                                                                                        247,
                                                                                                                                                                        248,
                                                                                                                                                                        249,
                                                                                                                                                                        250,
                                                                                                                                                                        251,
                                                                                                                                                                        252,
                                                                                                                                                                        253,
                                                                                                                                                                        254,
                                                                                                                                                                        255,
                                                                                                                                                                        256,
                                                                                                                                                                        257,
                                                                                                                                                                        258,
                                                                                                                                                                        259,
                                                                                                                                                                        260,
                                                                                                                                                                        261,
                                                                                                                                                                        262,
                                                                                                                                                                        263,
                                                                                                                                                                        264,
                                                                                                                                                                        265,
                                                                                                                                                                        266,
                                                                                                                                                                        267,
                                                                                                                                                                        268,
                                                                                                                                                                        269,
                                                                                                                                                                        270,
                                                                                                                                                                        271,
                                                                                                                                                                        272,
                                                                                                                                                                        273,
                                                                                                                                                                        274,
                                                                                                                                                                        275,
                                                                                                                                                                        276,
                                                                                                                                                                        277,
                                                                                                                                                                        278,
                                                                                                                                                                        279,
                                                                                                                                                                        280,
                                                                                                                                                                        281,
                                                                                                                                                                        282,
                                                                                                                                                                        283,
                                                                                                                                                                        284,
                                                                                                                                                                        285,
                                                                                                                                                                        286,
                                                                                                                                                                        287,
                                                                                                                                                                        288,
                                                                                                                                                                        289,
                                                                                                                                                                        290,
                                                                                                                                                                        291,
                                                                                                                                                                        292,
                                                                                                                                                                        293,
                                                                                                                                                                        294,
                                                                                                                                                                        295,
                                                                                                                                                                        296,
                                                                                                                                                                        297,
                                                                                                                                                                        298,
                                                                                                                                                                        299,
                                                                                                                                                                        300,
                                                                                                                                                                        301,
                                                                                                                                                                        302,
                                                                                                                                                                        303,
                                                                                                                                                                        304,
                                                                                                                                                                        305,
                                                                                                                                                                        306,
                                                                                                                                                                        307,
                                                                                                                                                                        308,
                                                                                                                                                                        309,
                                                                                                                                                                        310,
                                                                                                                                                                        311,
                                                                                                                                                                        312,
                                                                                                                                                                        313,
                                                                                                                                                                        314,
                                                                                                                                                                        315,
                                                                                                                                                                        316,
                                                                                                                                                                        317,
                                                                                                                                                                        318,
                                                                                                                                                                        319,
                                                                                                                                                                        320,
                                                                                                                                                                        321,
                                                                                                                                                                        322,
                                                                                                                                                                        323,
                                                                                                                                                                        324,
                                                                                                                                                                        325,
                                                                                                                                                                        326,
                                                                                                                                                                        327,
                                                                                                                                                                        328,
                                                                                                                                                                        329,
                                                                                                                                                                        330,
                                                                                                                                                                        331,
                                                                                                                                                                        332,
                                                                                                                                                                        333,
                                                                                                                                                                        334,
                                                                                                                                                                        335,
                                                                                                                                                                        336,
                                                                                                                                                                        337,
                                                                                                                                                                        338,
                                                                                                                                                                        339,
                                                                                                                                                                        340,
                                                                                                                                                                        341,
                                                                                                                                                                        342,
                                                                                                                                                                        343,
                                                                                                                                                                        344,
                                                                                                                                                                        345,
                                                                                                                                                                        346,
                                                                                                                                                                        347,
                                                                                                                                                                        348,
                                                                                                                                                                        349,
                                                                                                                                                                        350,
                                                                                                                                                                        351,
                                                                                                                                                                        352,
                                                                                                                                                                        353,
                                                                                                                                                                        354,
                                                                                                                                                                        355,
                                                                                                                                                                        356,
                                                                                                                                                                        357,
                                                                                                                                                                        358,
                                                                                                                                                                        359,
                                                                                                                                                                        360,
                                                                                                                                                                        361,
                                                                                                                                                                        362,
                                                                                                                                                                        363,
                                                                                                                                                                        364,
                                                                                                                                                                        365,
                                                                                                                                                                        366,
                                                                                                                                                                        367,
                                                                                                                                                                        368,
                                                                                                                                                                        369,
                                                                                                                                                                        370,
                                                                                                                                                                        371,
                                                                                                                                                                        372,
                                                                                                                                                                        373,
                                                                                                                                                                        374,
                                                                                                                                                                        375,
                                                                                                                                                                        376,
                                                                                                                                                                        377,
                                                                                                                                                                        378,
                                                                                                                                                                        379,
                                                                                                                                                                        380,
                                                                                                                                                                        381,
                                                                                                                                                                        382,
                                                                                                                                                                        383,
                                                                                                                                                                        384,
                                                                                                                                                                        385,
                                                                                                                                                                        386,
                                                                                                                                                                        387,
                                                                                                                                                                        388,
                                                                                                                                                                        389,
                                                                                                                                                                        390,
                                                                                                                                                                        391,
                                                                                                                                                                        392,
                                                                                                                                                                        393,
                                                                                                                                                                        394,
                                                                                                                                                                        395,
                                                                                                                                                                        396,
                                                                                                                                                                        397,
                                                                                                                                                                        398,
                                                                                                                                                                        399,
                                                                                                                                                                        400,
                                                                                                                                                                        401,
                                                                                                                                                                        402,
                                                                                                                                                                        403,
                                                                                                                                                                        404,
                                                                                                                                                                        405,
                                                                                                                                                                        406,
                                                                                                                                                                        407,
                                                                                                                                                                        408,
                                                                                                                                                                        409,
                                                                                                                                                                        410,
                                                                                                                                                                        411,
                                                                                                                                                                        412,
                                                                                                                                                                        413,
                                                                                                                                                                        414,
                                                                                                                                                                        415,
                                                                                                                                                                        416,
                                                                                                                                                                        417,
                                                                                                                                                                        418,
                                                                                                                                                                        419,
                                                                                                                                                                        420,
                                                                                                                                                                        421,
                                                                                                                                                                        422,
                                                                                                                                                                        423,
                                                                                                                                                                        424,
                                                                                                                                                                        425,
                                                                                                                                                                        426,
                                                                                                                                                                        427,
                                                                                                                                                                        428,
                                                                                                                                                                        429,
                                                                                                                                                                        430,
                                                                                                                                                                        431,
                                                                                                                                                                        432,
                                                                                                                                                                        433,
                                                                                                                                                                        434,
                                                                                                                                                                        435,
                                                                                                                                                                        436,
                                                                                                                                                                        437,
                                                                                                                                                                        438,
                                                                                                                                                                        439,
                                                                                                                                                                        440,
                                                                                                                                                                        441,
                                                                                                                                                                        442,
                                                                                                                                                                        443,
                                                                                                                                                                        444,
                                                                                                                                                                        445,
                                                                                                                                                                        446,
                                                                                                                                                                        447,
                                                                                                                                                                        448,
                                                                                                                                                                        449,
                                                                                                                                                                        450,
                                                                                                                                                                        451,
                                                                                                                                                                        452,
                                                                                                                                                                        453,
                                                                                                                                                                        454,
                                                                                                                                                                        455,
                                                                                                                                                                        456,
                                                                                                                                                                        457,
                                                                                                                                                                        458,
                                                                                                                                                                        459,
                                                                                                                                                                        460,
                                                                                                                                                                        461,
                                                                                                                                                                        462,
                                                                                                                                                                        463,
                                                                                                                                                                        464,
                                                                                                                                                                        465,
                                                                                                                                                                        466,
                                                                                                                                                                        467,
                                                                                                                                                                        468,
                                                                                                                                                                        469,
                                                                                                                                                                        470,
                                                                                                                                                                        471,
                                                                                                                                                                        472,
                                                                                                                                                                        473,
                                                                                                                                                                        474,
                                                                                                                                                                        475,
                                                                                                                                                                        476,
                                                                                                                                                                        477,
                                                                                                                                                                        478,
                                                                                                                                                                        479,
                                                                                                                                                                        480,
                                                                                                                                                                        481,
                                                                                                                                                                        482,
                                                                                                                                                                        483,
                                                                                                                                                                        484,
                                                                                                                                                                        485,
                                                                                                                                                                        486,
                                                                                                                                                                        487,
                                                                                                                                                                        488,
                                                                                                                                                                        489,
                                                                                                                                                                        490,
                                                                                                                                                                        491,
                                                                                                                                                                        492,
                                                                                                                                                                        493,
                                                                                                                                                                        494,
                                                                                                                                                                        495,
                                                                                                                                                                        496,
                                                                                                                                                                        497,
                                                                                                                                                                        498,
                                                                                                                                                                        499,
                                                                                                                                                                        500,
                                                                                                                                                                        501,
                                                                                                                                                                        502,
                                                                                                                                                                        503,
                                                                                                                                                                        504,
                                                                                                                                                                        505,
                                                                                                                                                                        506,
                                                                                                                                                                        507,
                                                                                                                                                                        508,
                                                                                                                                                                        509,
                                                                                                                                                                        510,
                                                                                                                                                                        511,
                                                                                                                                                                        512,
                                                                                                                                                                        513,
                                                                                                                                                                        514,
                                                                                                                                                                        515,
                                                                                                                                                                        516,
                                                                                                                                                                        517,
                                                                                                                                                                        518,
                                                                                                                                                                        519,
                                                                                                                                                                        520,
                                                                                                                                                                        521,
                                                                                                                                                                        522,
                                                                                                                                                                        523,
                                                                                                                                                                        524,
                                                                                                                                                                        525,
                                                                                                                                                                        526,
                                                                                                                                                                        527,
                                                                                                                                                                        528,
                                                                                                                                                                        529,
                                                                                                                                                                        530,
                                                                                                                                                                        531,
                                                                                                                                                                        532,
                                                                                                                                                                        533,
                                                                                                                                                                        534,
                                                                                                                                                                        535,
                                                                                                                                                                        536,
                                                                                                                                                                        537,
                                                                                                                                                                        538,
                                                                                                                                                                        539,
                                                                                                                                                                        540,
                                                                                                                                                                        541,
                                                                                                                                                                        542,
                                                                                                                                                                        543,
                                                                                                                                                                        544,
                                                                                                                                                                        545,
                                                                                                                                                                        546,
                                                                                                                                                                        547,
                                                                                                                                                                        548,
                                                                                                                                                                        549,
                                                                                                                                                                        550,
                                                                                                                                                                        551,
                                                                                                                                                                        552,
                                                                                                                                                                        553,
                                                                                                                                                                        554,
                                                                                                                                                                        555,
                                                                                                                                                                        556,
                                                                                                                                                                        557,
                                                                                                                                                                        558,
                                                                                                                                                                        559,
                                                                                                                                                                        560,
                                                                                                                                                                        561,
                                                                                                                                                                        562,
                                                                                                                                                                        563,
                                                                                                                                                                        564,
                                                                                                                                                                        565,
                                                                                                                                                                        566,
                                                                                                                                                                        567,
                                                                                                                                                                        568,
                                                                                                                                                                        569,
                                                                                                                                                                        570,
                                                                                                                                                                        571,
                                                                                                                                                                        572,
                                                                                                                                                                        573,
                                                                                                                                                                        574,
                                                                                                                                                                        575,
                                                                                                                                                                        576,
                                                                                                                                                                        577,
                                                                                                                                                                        578,
                                                                                                                                                                        579,
                                                                                                                                                                        580,
                                                                                                                                                                        581,
                                                                                                                                                                        582,
                                                                                                                                                                        583,
                                                                                                                                                                        584,
                                                                                                                                                                        585,
                                                                                                                                                                        586,
                                                                                                                                                                        587,
                                                                                                                                                                        588,
                                                                                                                                                                        589,
                                                                                                                                                                        590,
                                                                                                                                                                        591,
                                                                                                                                                                        592,
                                                                                                                                                                        593,
                                                                                                                                                                        594,
                                                                                                                                                                        595,
                                                                                                                                                                        596,
                                                                                                                                                                        597,
                                                                                                                                                                        598,
                                                                                                                                                                        599,
                                                                                                                                                                        600,
                                                                                                                                                                        601,
                                                                                                                                                                        602,
                                                                                                                                                                        603,
                                                                                                                                                                        604,
                                                                                                                                                                        605,
                                                                                                                                                                        606,
                                                                                                                                                                        607,
                                                                                                                                                                        608,
                                                                                                                                                                        609,
                                                                                                                                                                        610,
                                                                                                                                                                        611,
                                                                                                                                                                        612,
                                                                                                                                                                        613,
                                                                                                                                                                        614,
                                                                                                                                                                        615,
                                                                                                                                                                        616,
                                                                                                                                                                        617,
                                                                                                                                                                        618,
                                                                                                                                                                        619,
                                                                                                                                                                        620,
                                                                                                                                                                        621,
                                                                                                                                                                        622,
                                                                                                                                                                        623,
                                                                                                                                                                        624,
                                                                                                                                                                        625,
                                                                                                                                                                        626,
                                                                                                                                                                        627,
                                                                                                                                                                        628,
                                                                                                                                                                        629,
                                                                                                                                                                        630,
                                                                                                                                                                        631,
                                                                                                                                                                        632,
                                                                                                                                                                        633,
                                                                                                                                                                        634,
                                                                                                                                                                        635,
                                                                                                                                                                        636,
                                                                                                                                                                        637,
                                                                                                                                                                        638,
                                                                                                                                                                        639,
                                                                                                                                                                        640,
                                                                                                                                                                        641,
                                                                                                                                                                        642,
                                                                                                                                                                        643,
                                                                                                                                                                        644,
                                                                                                                                                                        645,
                                                                                                                                                                        646,
                                                                                                                                                                        647,
                                                                                                                                                                        648,
                                                                                                                                                                        649,
                                                                                                                                                                        650,
                                                                                                                                                                        651,
                                                                                                                                                                        652,
                                                                                                                                                                        653,
                                                                                                                                                                        654,
                                                                                                                                                                        655,
                                                                                                                                                                        656,
                                                                                                                                                                        657,
                                                                                                                                                                        658,
                                                                                                                                                                        659,
                                                                                                                                                                        660,
                                                                                                                                                                        661,
                                                                                                                                                                        662,
                                                                                                                                                                        663,
                                                                                                                                                                        664,
                                                                                                                                                                        665,
                                                                                                                                                                        666,
                                                                                                                                                                        667,
                                                                                                                                                                        668,
                                                                                                                                                                        669,
                                                                                                                                                                        670,
                                                                                                                                                                        671,
                                                                                                                                                                        672,
                                                                                                                                                                        673,
                                                                                                                                                                        674,
                                                                                                                                                                        675,
                                                                                                                                                                        676,
                                                                                                                                                                        677,
                                                                                                                                                                        678,
                                                                                                                                                                        679,
                                                                                                                                                                        680,
                                                                                                                                                                        681,
                                                                                                                                                                        682,
                                                                                                                                                                        683,
                                                                                                                                                                        684,
                                                                                                                                                                        685,
                                                                                                                                                                        686,
                                                                                                                                                                        687,
                                                                                                                                                                        688,
                                                                                                                                                                        689,
                                                                                                                                                                        690,
                                                                                                                                                                        691,
                                                                                                                                                                        692,
                                                                                                                                                                        693,
                                                                                                                                                                        694,
                                                                                                                                                                        695,
                                                                                                                                                                        696,
                                                                                                                                                                        697,
                                                                                                                                                                        698,
                                                                                                                                                                        699,
                                                                                                                                                                        700,
                                                                                                                                                                        701,
                                                                                                                                                                        702,
                                                                                                                                                                        703,
                                                                                                                                                                        704,
                                                                                                                                                                        705,
                                                                                                                                                                        706,
                                                                                                                                                                        707,
                                                                                                                                                                        708,
                                                                                                                                                                        709,
                                                                                                                                                                        710,
                                                                                                                                                                        711,
                                                                                                                                                                        712,
                                                                                                                                                                        713,
                                                                                                                                                                        714,
                                                                                                                                                                        715,
                                                                                                                                                                        716,
                                                                                                                                                                        717,
                                                                                                                                                                        718,
                                                                                                                                                                        719,
                                                                                                                                                                        720,
                                                                                                                                                                        721,
                                                                                                                                                                        722,
                                                                                                                                                                        723,
                                                                                                                                                                        724,
                                                                                                                                                                        725,
                                                                                                                                                                        726,
                                                                                                                                                                        727,
                                                                                                                                                                        728,
                                                                                                                                                                        729,
                                                                                                                                                                        730,
                                                                                                                                                                        731,
                                                                                                                                                                        732,
                                                                                                                                                                        733,
                                                                                                                                                                        734,
                                                                                                                                                                        735,
                                                                                                                                                                        736,
                                                                                                                                                                        737,
                                                                                                                                                                        738,
                                                                                                                                                                        739,
                                                                                                                                                                        740,
                                                                                                                                                                        741,
                                                                                                                                                                        742,
                                                                                                                                                                        743,
                                                                                                                                                                        744,
                                                                                                                                                                        745,
                                                                                                                                                                        746,
                                                                                                                                                                        747,
                                                                                                                                                                        748,
                                                                                                                                                                        749,
                                                                                                                                                                        750,
                                                                                                                                                                        751,
                                                                                                                                                                        752,
                                                                                                                                                                        753,
                                                                                                                                                                        754,
                                                                                                                                                                        755,
                                                                                                                                                                        756,
                                                                                                                                                                        757,
                                                                                                                                                                        758,
                                                                                                                                                                        759,
                                                                                                                                                                        760,
                                                                                                                                                                        761,
                                                                                                                                                                        762,
                                                                                                                                                                        763,
                                                                                                                                                                        764,
                                                                                                                                                                        765,
                                                                                                                                                                        766,
                                                                                                                                                                        767,
                                                                                                                                                                        768,
                                                                                                                                                                        769,
                                                                                                                                                                        770,
                                                                                                                                                                        771,
                                                                                                                                                                        772,
                                                                                                                                                                        773,
                                                                                                                                                                        774,
                                                                                                                                                                        775,
                                                                                                                                                                        776,
                                                                                                                                                                        777,
                                                                                                                                                                        778,
                                                                                                                                                                        779,
                                                                                                                                                                        780,
                                                                                                                                                                        781,
                                                                                                                                                                        782,
                                                                                                                                                                        783,
                                                                                                                                                                        784,
                                                                                                                                                                        785,
                                                                                                                                                                        786,
                                                                                                                                                                        787,
                                                                                                                                                                        788,
                                                                                                                                                                        789,
                                                                                                                                                                        790,
                                                                                                                                                                        791,
                                                                                                                                                                        792,
                                                                                                                                                                        793,
                                                                                                                                                                        794,
                                                                                                                                                                        795,
                                                                                                                                                                        796,
                                                                                                                                                                        797,
                                                                                                                                                                        798,
                                                                                                                                                                        799,
                                                                                                                                                                        800,
                                                                                                                                                                        801,
                                                                                                                                                                        802,
                                                                                                                                                                        803,
                                                                                                                                                                        804,
                                                                                                                                                                        805,
                                                                                                                                                                        806,
                                                                                                                                                                        807,
                                                                                                                                                                        808,
                                                                                                                                                                        809,
                                                                                                                                                                        810,
                                                                                                                                                                        811,
                                                                                                                                                                        812,
                                                                                                                                                                        813,
                                                                                                                                                                        814,
                                                                                                                                                                        815,
                                                                                                                                                                        816,
                                                                                                                                                                        817,
                                                                                                                                                                        818,
                                                                                                                                                                        819,
                                                                                                                                                                        820,
                                                                                                                                                                        821,
                                                                                                                                                                        822,
                                                                                                                                                                        823,
                                                                                                                                                                        824,
                                                                                                                                                                        825,
                                                                                                                                                                        826,
                                                                                                                                                                        827,
                                                                                                                                                                        828,
                                                                                                                                                                        829,
                                                                                                                                                                        830,
                                                                                                                                                                        831,
                                                                                                                                                                        832,
                                                                                                                                                                        833,
                                                                                                                                                                        834,
                                                                                                                                                                        835,
                                                                                                                                                                        836,
                                                                                                                                                                        837,
                                                                                                                                                                        838,
                                                                                                                                                                        839,
                                                                                                                                                                        840,
                                                                                                                                                                        841,
                                                                                                                                                                        842,
                                                                                                                                                                        843,
                                                                                                                                                                        844,
                                                                                                                                                                        845,
                                                                                                                                                                        846,
                                                                                                                                                                        847,
                                                                                                                                                                        848,
                                                                                                                                                                        849,
                                                                                                                                                                        850,
                                                                                                                                                                        851,
                                                                                                                                                                        852,
                                                                                                                                                                        853,
                                                                                                                                                                        854,
                                                                                                                                                                        855,
                                                                                                                                                                        856,
                                                                                                                                                                        857,
                                                                                                                                                                        858,
                                                                                                                                                                        859,
                                                                                                                                                                        860,
                                                                                                                                                                        861,
                                                                                                                                                                        862,
                                                                                                                                                                        863,
                                                                                                                                                                        864,
                                                                                                                                                                        865,
                                                                                                                                                                        866,
                                                                                                                                                                        867,
                                                                                                                                                                        868,
                                                                                                                                                                        869,
                                                                                                                                                                        870,
                                                                                                                                                                        871,
                                                                                                                                                                        872,
                                                                                                                                                                        873,
                                                                                                                                                                        874,
                                                                                                                                                                        875,
                                                                                                                                                                        876,
                                                                                                                                                                        877,
                                                                                                                                                                        878,
                                                                                                                                                                        879,
                                                                                                                                                                        880,
                                                                                                                                                                        881,
                                                                                                                                                                        882,
                                                                                                                                                                        883,
                                                                                                                                                                        884,
                                                                                                                                                                        885,
                                                                                                                                                                        886,
                                                                                                                                                                        887,
                                                                                                                                                                        888,
                                                                                                                                                                        889,
                                                                                                                                                                        890,
                                                                                                                                                                        891,
                                                                                                                                                                        892,
                                                                                                                                                                        893,
                                                                                                                                                                        894,
                                                                                                                                                                        895,
                                                                                                                                                                        896,
                                                                                                                                                                        897,
                                                                                                                                                                        898,
                                                                                                                                                                        899,
                                                                                                                                                                        900,
                                                                                                                                                                        901,
                                                                                                                                                                        902,
                                                                                                                                                                        903,
                                                                                                                                                                        904,
                                                                                                                                                                        905,
                                                                                                                                                                        906,
                                                                                                                                                                        907,
                                                                                                                                                                        908,
                                                                                                                                                                        909,
                                                                                                                                                                        910,
                                                                                                                                                                        911,
                                                                                                                                                                        912,
                                                                                                                                                                        913,
                                                                                                                                                                        914,
                                                                                                                                                                        915,
                                                                                                                                                                        916,
                                                                                                                                                                        917,
                                                                                                                                                                        918,
                                                                                                                                                                        919,
                                                                                                                                                                        920,
                                                                                                                                                                        921,
                                                                                                                                                                        922,
                                                                                                                                                                        923,
                                                                                                                                                                        924,
                                                                                                                                                                        925,
                                                                                                                                                                        926,
                                                                                                                                                                        927,
                                                                                                                                                                        928,
                                                                                                                                                                        929,
                                                                                                                                                                        930,
                                                                                                                                                                        931,
                                                                                                                                                                        932,
                                                                                                                                                                        933,
                                                                                                                                                                        934,
                                                                                                                                                                        935,
                                                                                                                                                                        936,
                                                                                                                                                                        937,
                                                                                                                                                                        938,
                                                                                                                                                                        939,
                                                                                                                                                                        940,
                                                                                                                                                                        941,
                                                                                                                                                                        942,
                                                                                                                                                                        943,
                                                                                                                                                                        944,
                                                                                                                                                                        945,
                                                                                                                                                                        946,
                                                                                                                                                                        947,
                                                                                                                                                                        948,
                                                                                                                                                                        949,
                                                                                                                                                                        950,
                                                                                                                                                                        951,
                                                                                                                                                                        952,
                                                                                                                                                                        953,
                                                                                                                                                                        954,
                                                                                                                                                                        955,
                                                                                                                                                                        956,
                                                                                                                                                                        957,
                                                                                                                                                                        958,
                                                                                                                                                                        959,
                                                                                                                                                                        960,
                                                                                                                                                                        961,
                                                                                                                                                                        962,
                                                                                                                                                                        963,
                                                                                                                                                                        964,
                                                                                                                                                                        965,
                                                                                                                                                                        966,
                                                                                                                                                                        967,
                                                                                                                                                                        968,
                                                                                                                                                                        969,
                                                                                                                                                                        970,
                                                                                                                                                                        971,
                                                                                                                                                                        972,
                                                                                                                                                                        973,
                                                                                                                                                                        974,
                                                                                                                                                                        975,
                                                                                                                                                                        976,
                                                                                                                                                                        977,
                                                                                                                                                                        978,
                                                                                                                                                                        979,
                                                                                                                                                                        980,
                                                                                                                                                                        981,
                                                                                                                                                                        982,
                                                                                                                                                                        983,
                                                                                                                                                                        984,
                                                                                                                                                                        985,
                                                                                                                                                                        986,
                                                                                                                                                                        987,
                                                                                                                                                                        988,
                                                                                                                                                                        989,
                                                                                                                                                                        990,
                                                                                                                                                                        991,
                                                                                                                                                                        992,
                                                                                                                                                                        993,
                                                                                                                                                                        994,
                                                                                                                                                                        995,
                                                                                                                                                                        996,
                                                                                                                                                                        997,
                                                                                                                                                                        998,
                                                                                                                                                                        999,
                                                                                                                                                                        1000,
                                                                                                                                                                        1001,
                                                                                                                                                                        1002,
                                                                                                                                                                        1003,
                                                                                                                                                                        1004,
                                                                                                                                                                        1005,
                                                                                                                                                                        1006,
                                                                                                                                                                        1007,
                                                                                                                                                                        1008,
                                                                                                                                                                        1009,
                                                                                                                                                                        1010,
                                                                                                                                                                        1011,
                                                                                                                                                                        1012,
                                                                                                                                                                        1013,
                                                                                                                                                                        1014,
                                                                                                                                                                        1015,
                                                                                                                                                                        1016,
                                                                                                                                                                        1017,
                                                                                                                                                                        1018,
                                                                                                                                                                        1019,
                                                                                                                                                                        1020,
                                                                                                                                                                        1021,
                                                                                                                                                                        1022,
                                                                                                                                                                        1023,
                                                                                                                                                                        1024,
                                                                                                                                                                        1025,
                                                                                                                                                                        1026,
                                                                                                                                                                        1027,
                                                                                                                                                                        1028,
                                                                                                                                                                        1029,
                                                                                                                                                                        1030,
                                                                                                                                                                        1031,
                                                                                                                                                                        1032,
                                                                                                                                                                        1033,
                                                                                                                                                                        1034,
                                                                                                                                                                        1035,
                                                                                                                                                                        1036,
                                                                                                                                                                        1037,
                                                                                                                                                                        1038,
                                                                                                                                                                        1039,
                                                                                                                                                                        1040,
                                                                                                                                                                        1041,
                                                                                                                                                                        1042,
                                                                                                                                                                        1043,
                                                                                                                                                                        1044,
                                                                                                                                                                        1045,
                                                                                                                                                                        1046,
                                                                                                                                                                        1047,
                                                                                                                                                                        1048,
                                                                                                                                                                        1049,
                                                                                                                                                                        1050,
                                                                                                                                                                        1051,
                                                                                                                                                                        1052,
                                                                                                                                                                        1053,
                                                                                                                                                                        1054,
                                                                                                                                                                        1055,
                                                                                                                                                                        1056,
                                                                                                                                                                        1057,
                                                                                                                                                                        1058,
                                                                                                                                                                        1059,
                                                                                                                                                                        1060,
                                                                                                                                                                        1061,
                                                                                                                                                                        1062,
                                                                                                                                                                        1063,
                                                                                                                                                                        1064,
                                                                                                                                                                        1065,
                                                                                                                                                                        1066,
                                                                                                                                                                        1067,
                                                                                                                                                                        1068,
                                                                                                                                                                        1069,
                                                                                                                                                                        1070,
                                                                                                                                                                        1071,
                                                                                                                                                                        1072,
                                                                                                                                                                        1073,
                                                                                                                                                                        1074,
                                                                                                                                                                        1075,
                                                                                                                                                                        1076,
                                                                                                                                                                        1077,
                                                                                                                                                                        1078,
                                                                                                                                                                        1079,
                                                                                                                                                                        1080,
                                                                                                                                                                        1081,
                                                                                                                                                                        1082,
                                                                                                                                                                        1083,
                                                                                                                                                                        1084,
                                                                                                                                                                        1085,
                                                                                                                                                                        1086,
                                                                                                                                                                        1087,
                                                                                                                                                                        1088,
                                                                                                                                                                        1089,
                                                                                                                                                                        1090,
                                                                                                                                                                        1091,
                                                                                                                                                                        1092,
                                                                                                                                                                        1093,
                                                                                                                                                                        1094,
                                                                                                                                                                        1095,
                                                                                                                                                                        1096,
                                                                                                                                                                        1097,
                                                                                                                                                                        1098,
                                                                                                                                                                        1099,
                                                                                                                                                                        1100,
                                                                                                                                                                        1101,
                                                                                                                                                                        1102,
                                                                                                                                                                        1103,
                                                                                                                                                                        1104,
                                                                                                                                                                        1105,
                                                                                                                                                                        1106,
                                                                                                                                                                        1107,
                                                                                                                                                                        1108,
                                                                                                                                                                        1109,
                                                                                                                                                                        1110,
                                                                                                                                                                        1111,
                                                                                                                                                                        1112,
                                                                                                                                                                        1113,
                                                                                                                                                                        1114,
                                                                                                                                                                        1115,
                                                                                                                                                                        1116,
                                                                                                                                                                        1117,
                                                                                                                                                                        1118,
                                                                                                                                                                        1119,
                                                                                                                                                                        1120,
                                                                                                                                                                        1121,
                                                                                                                                                                        1122,
                                                                                                                                                                        1123,
                                                                                                                                                                        1124,
                                                                                                                                                                        1125,
                                                                                                                                                                        1126,
                                                                                                                                                                        1127,
                                                                                                                                                                        1128,
                                                                                                                                                                        1129,
                                                                                                                                                                        1130,
                                                                                                                                                                        1131,
                                                                                                                                                                        1132,
                                                                                                                                                                        1133,
                                                                                                                                                                        1134,
                                                                                                                                                                        1135,
                                                                                                                                                                        1136,
                                                                                                                                                                        1137,
                                                                                                                                                                        1138,
                                                                                                                                                                        1139,
                                                                                                                                                                        1140,
                                                                                                                                                                        1141,
                                                                                                                                                                        1142,
                                                                                                                                                                        1143,
                                                                                                                                                                        1144,
                                                                                                                                                                        1145,
                                                                                                                                                                        1146,
                                                                                                                                                                        1147,
                                                                                                                                                                        1148,
                                                                                                                                                                        1149,
                                                                                                                                                                        1150,
                                                                                                                                                                        1151,
                                                                                                                                                                        1152,
                                                                                                                                                                        1153,
                                                                                                                                                                        1154,
                                                                                                                                                                        1155,
                                                                                                                                                                        1156,
                                                                                                                                                                        1157,
                                                                                                                                                                        1158,
                                                                                                                                                                        1159,
                                                                                                                                                                        1160,
                                                                                                                                                                        1161,
                                                                                                                                                                        1162,
                                                                                                                                                                        1163,
                                                                                                                                                                        1164,
                                                                                                                                                                        1165,
                                                                                                                                                                        1166,
                                                                                                                                                                        1167,
                                                                                                                                                                        1168,
                                                                                                                                                                        1169,
                                                                                                                                                                        1170,
                                                                                                                                                                        1171,
                                                                                                                                                                        1172,
                                                                                                                                                                        1173,
                                                                                                                                                                        1174,
                                                                                                                                                                        1175,
                                                                                                                                                                        1176,
                                                                                                                                                                        1177,
                                                                                                                                                                        1178,
                                                                                                                                                                        1179,
                                                                                                                                                                        1180,
                                                                                                                                                                        1181,
                                                                                                                                                                        1182,
                                                                                                                                                                        1183,
                                                                                                                                                                        1184,
                                                                                                                                                                        1185,
                                                                                                                                                                        1186,
                                                                                                                                                                        1187,
                                                                                                                                                                        1188,
                                                                                                                                                                        1189,
                                                                                                                                                                        1190,
                                                                                                                                                                        1191,
                                                                                                                                                                        1192,
                                                                                                                                                                        1193,
                                                                                                                                                                        1194,
                                                                                                                                                                        1195,
                                                                                                                                                                        1196,
                                                                                                                                                                        1197,
                                                                                                                                                                        1198,
                                                                                                                                                                        1199,
                                                                                                                                                                        1200,
                                                                                                                                                                        1201,
                                                                                                                                                                        1202,
                                                                                                                                                                        1203,
                                                                                                                                                                        1204,
                                                                                                                                                                        1205,
                                                                                                                                                                        1206,
                                                                                                                                                                        1207,
                                                                                                                                                                        1208,
                                                                                                                                                                        1209,
                                                                                                                                                                        1210,
                                                                                                                                                                        1211,
                                                                                                                                                                        1212,
                                                                                                                                                                        1213,
                                                                                                                                                                        1214,
                                                                                                                                                                        1215,
                                                                                                                                                                        1216,
                                                                                                                                                                        1217,
                                                                                                                                                                        1218,
                                                                                                                                                                        1219,
                                                                                                                                                                        1220,
                                                                                                                                                                        1221,
                                                                                                                                                                        1222,
                                                                                                                                                                        1223,
                                                                                                                                                                        1224,
                                                                                                                                                                        1225,
                                                                                                                                                                        1226,
                                                                                                                                                                        1227,
                                                                                                                                                                        1228,
                                                                                                                                                                        1229,
                                                                                                                                                                        1230,
                                                                                                                                                                        1231,
                                                                                                                                                                        1232,
                                                                                                                                                                        1233,
                                                                                                                                                                        1234,
                                                                                                                                                                        1235,
                                                                                                                                                                        1236,
                                                                                                                                                                        1237,
                                                                                                                                                                        1238,
                                                                                                                                                                        1239,
                                                                                                                                                                        1240,
                                                                                                                                                                        1241,
                                                                                                                                                                        1242,
                                                                                                                                                                        1243,
                                                                                                                                                                        1244,
                                                                                                                                                                        1245,
                                                                                                                                                                        1246,
                                                                                                                                                                        1247,
                                                                                                                                                                        1248,
                                                                                                                                                                        1249,
                                                                                                                                                                        1250,
                                                                                                                                                                        1251,
                                                                                                                                                                        1252,
                                                                                                                                                                        1253,
                                                                                                                                                                        1254,
                                                                                                                                                                        1255,
                                                                                                                                                                        1256,
                                                                                                                                                                        1257,
                                                                                                                                                                        1258,
                                                                                                                                                                        1259,
                                                                                                                                                                        1260,
                                                                                                                                                                        1261,
                                                                                                                                                                        1262,
                                                                                                                                                                        1263,
                                                                                                                                                                        1264,
                                                                                                                                                                        1265,
                                                                                                                                                                        1266,
                                                                                                                                                                        1267,
                                                                                                                                                                        1268,
                                                                                                                                                                        1269,
                                                                                                                                                                        1270,
                                                                                                                                                                        1271,
                                                                                                                                                                        1272,
                                                                                                                                                                        1273,
                                                                                                                                                                        1274,
                                                                                                                                                                        1275,
                                                                                                                                                                        1276,
                                                                                                                                                                        1277,
                                                                                                                                                                        1278,
                                                                                                                                                                        1279,
                                                                                                                                                                        1280,
                                                                                                                                                                        1281,
                                                                                                                                                                        1282,
                                                                                                                                                                        1283,
                                                                                                                                                                        1284,
                                                                                                                                                                        1285,
                                                                                                                                                                        1286,
                                                                                                                                                                        1287,
                                                                                                                                                                        1288,
                                                                                                                                                                        1289,
                                                                                                                                                                        1290,
                                                                                                                                                                        1291,
                                                                                                                                                                        1292,
                                                                                                                                                                        1293,
                                                                                                                                                                        1294,
                                                                                                                                                                        1295,
                                                                                                                                                                        1296,
                                                                                                                                                                        1297,
                                                                                                                                                                        1298,
                                                                                                                                                                        1299,
                                                                                                                                                                        1300,
                                                                                                                                                                        1301,
                                                                                                                                                                        1302,
                                                                                                                                                                        1303,
                                                                                                                                                                        1304,
                                                                                                                                                                        1305,
                                                                                                                                                                        1306,
                                                                                                                                                                        1307,
                                                                                                                                                                        1308,
                                                                                                                                                                        1309,
                                                                                                                                                                        1310,
                                                                                                                                                                        1311,
                                                                                                                                                                        1312,
                                                                                                                                                                        1313,
                                                                                                                                                                        1314,
                                                                                                                                                                        1315,
                                                                                                                                                                        1316,
                                                                                                                                                                        1317,
                                                                                                                                                                        1318,
                                                                                                                                                                        1319,
                                                                                                                                                                        1320,
                                                                                                                                                                        1321,
                                                                                                                                                                        1322,
                                                                                                                                                                        1323,
                                                                                                                                                                        1324,
                                                                                                                                                                        1325,
                                                                                                                                                                        1326,
                                                                                                                                                                        1327,
                                                                                                                                                                        1328,
                                                                                                                                                                        1329,
                                                                                                                                                                        1330,
                                                                                                                                                                        1331,
                                                                                                                                                                        1332,
                                                                                                                                                                        1333,
                                                                                                                                                                        1334,
                                                                                                                                                                        1335,
                                                                                                                                                                        1336,
                                                                                                                                                                        1337,
                                                                                                                                                                        1338,
                                                                                                                                                                        1339,
                                                                                                                                                                        1340,
                                                                                                                                                                        1341,
                                                                                                                                                                        1342,
                                                                                                                                                                        1343,
                                                                                                                                                                        1344,
                                                                                                                                                                        1345,
                                                                                                                                                                        1346,
                                                                                                                                                                        1347,
                                                                                                                                                                        1348,
                                                                                                                                                                        1349,
                                                                                                                                                                        1350,
                                                                                                                                                                        1351,
                                                                                                                                                                        1352,
                                                                                                                                                                        1353,
                                                                                                                                                                        1354,
                                                                                                                                                                        1355,
                                                                                                                                                                        1356,
                                                                                                                                                                        1357,
                                                                                                                                                                        1358,
                                                                                                                                                                        1359,
                                                                                                                                                                        1360,
                                                                                                                                                                        1361,
                                                                                                                                                                        1362,
                                                                                                                                                                        1363,
                                                                                                                                                                        1364,
                                                                                                                                                                        1365,
                                                                                                                                                                        1366,
                                                                                                                                                                        1367,
                                                                                                                                                                        1368,
                                                                                                                                                                        1369,
                                                                                                                                                                        1370,
                                                                                                                                                                        1371,
                                                                                                                                                                        1372,
                                                                                                                                                                        1373,
                                                                                                                                                                        1374,
                                                                                                                                                                        1375,
                                                                                                                                                                        1376,
                                                                                                                                                                        1377,
                                                                                                                                                                        1378,
                                                                                                                                                                        1379,
                                                                                                                                                                        1380,
                                                                                                                                                                        1381,
                                                                                                                                                                        1382,
                                                                                                                                                                        1383,
                                                                                                                                                                        1384,
                                                                                                                                                                        1385,
                                                                                                                                                                        1386,
                                                                                                                                                                        1387,
                                                                                                                                                                        1388,
                                                                                                                                                                        1389,
                                                                                                                                                                        1390,
                                                                                                                                                                        1391,
                                                                                                                                                                        1392,
                                                                                                                                                                        1393,
                                                                                                                                                                        1394,
                                                                                                                                                                        1395,
                                                                                                                                                                        1396,
                                                                                                                                                                        1397,
                                                                                                                                                                        1398,
                                                                                                                                                                        1399,
                                                                                                                                                                        1400,
                                                                                                                                                                        1401,
                                                                                                                                                                        1402,
                                                                                                                                                                        1403,
                                                                                                                                                                        1404,
                                                                                                                                                                        1405,
                                                                                                                                                                        1406,
                                                                                                                                                                        1407,
                                                                                                                                                                        1408,
                                                                                                                                                                        1409,
                                                                                                                                                                        1410,
                                                                                                                                                                        1411,
                                                                                                                                                                        1412,
                                                                                                                                                                        1413,
                                                                                                                                                                        1414,
                                                                                                                                                                        1415,
                                                                                                                                                                        1416,
                                                                                                                                                                        1417,
                                                                                                                                                                        1418,
                                                                                                                                                                        1419,
                                                                                                                                                                        1420,
                                                                                                                                                                        1421,
                                                                                                                                                                        1422,
                                                                                                                                                                        1423,
                                                                                                                                                                        1424,
                                                                                                                                                                        1425,
                                                                                                                                                                        1426,
                                                                                                                                                                        1427,
                                                                                                                                                                        1428,
                                                                                                                                                                        1429,
                                                                                                                                                                        1430,
                                                                                                                                                                        1431,
                                                                                                                                                                        1432,
                                                                                                                                                                        1433,
                                                                                                                                                                        1434,
                                                                                                                                                                        1435,
                                                                                                                                                                        1436,
                                                                                                                                                                        1437,
                                                                                                                                                                        1438,
                                                                                                                                                                        1439,
                                                                                                                                                                        1440,
                                                                                                                                                                        1441,
                                                                                                                                                                        1442,
                                                                                                                                                                        1443,
                                                                                                                                                                        1444,
                                                                                                                                                                        1445,
                                                                                                                                                                        1446,
                                                                                                                                                                        1447,
                                                                                                                                                                        1448,
                                                                                                                                                                        1449,
                                                                                                                                                                        1450,
                                                                                                                                                                        1451,
                                                                                                                                                                        1452,
                                                                                                                                                                        1453,
                                                                                                                                                                        1454,
                                                                                                                                                                        1455,
                                                                                                                                                                        1456,
                                                                                                                                                                        1457,
                                                                                                                                                                        1458,
                                                                                                                                                                        1459,
                                                                                                                                                                        1460,
                                                                                                                                                                        1461,
                                                                                                                                                                        1462,
                                                                                                                                                                        1463,
                                                                                                                                                                        1464,
                                                                                                                                                                        1465,
                                                                                                                                                                        1466,
                                                                                                                                                                        1467,
                                                                                                                                                                        1468,
                                                                                                                                                                        1469,
                                                                                                                                                                        1470,
                                                                                                                                                                        1471,
                                                                                                                                                                        1472,
                                                                                                                                                                        1473,
                                                                                                                                                                        1474,
                                                                                                                                                                        1475,
                                                                                                                                                                        1476,
                                                                                                                                                                        1477,
                                                                                                                                                                        1478,
                                                                                                                                                                        1479,
                                                                                                                                                                        1480,
                                                                                                                                                                        1481,
                                                                                                                                                                        1482,
                                                                                                                                                                        1483,
                                                                                                                                                                        1484,
                                                                                                                                                                        1485,
                                                                                                                                                                        1486,
                                                                                                                                                                        1487,
                                                                                                                                                                        1488,
                                                                                                                                                                        1489,
                                                                                                                                                                        1490,
                                                                                                                                                                        1491,
                                                                                                                                                                        1492,
                                                                                                                                                                        1493,
                                                                                                                                                                        1494,
                                                                                                                                                                        1495,
                                                                                                                                                                        1496,
                                                                                                                                                                        1497,
                                                                                                                                                                        1498,
                                                                                                                                                                        1499,
                                                                                                                                                                        1500,
                                                                                                                                                                        1501,
                                                                                                                                                                        1502,
                                                                                                                                                                        1503,
                                                                                                                                                                        1504,
                                                                                                                                                                        1505,
                                                                                                                                                                        1506,
                                                                                                                                                                        1507,
                                                                                                                                                                        1508,
                                                                                                                                                                        1509,
                                                                                                                                                                        1510,
                                                                                                                                                                        1511,
                                                                                                                                                                        1512,
                                                                                                                                                                        1513,
                                                                                                                                                                        1514,
                                                                                                                                                                        1515,
                                                                                                                                                                        1516,
                                                                                                                                                                        1517,
                                                                                                                                                                        1518,
                                                                                                                                                                        1519,
                                                                                                                                                                        1520,
                                                                                                                                                                        1521,
                                                                                                                                                                        1522,
                                                                                                                                                                        1523,
                                                                                                                                                                        1524,
                                                                                                                                                                        1525,
                                                                                                                                                                        1526,
                                                                                                                                                                        1527,
                                                                                                                                                                        1528,
                                                                                                                                                                        1529,
                                                                                                                                                                        1530,
                                                                                                                                                                        1531,
                                                                                                                                                                        1532,
                                                                                                                                                                        1533,
                                                                                                                                                                        1534,
                                                                                                                                                                        1535,
                                                                                                                                                                        1536,
                                                                                                                                                                        1537,
                                                                                                                                                                        1538,
                                                                                                                                                                        1539,
                                                                                                                                                                        1540,
                                                                                                                                                                        1541,
                                                                                                                                                                        1542,
                                                                                                                                                                        1543,
                                                                                                                                                                        1544,
                                                                                                                                                                        1545,
                                                                                                                                                                        1546,
                                                                                                                                                                        1547,
                                                                                                                                                                        1548,
                                                                                                                                                                        1549,
                                                                                                                                                                        1550,
                                                                                                                                                                        1551,
                                                                                                                                                                        1552,
                                                                                                                                                                        1553,
                                                                                                                                                                        1554,
                                                                                                                                                                        1555,
                                                                                                                                                                        1556,
                                                                                                                                                                        1557,
                                                                                                                                                                        1558,
                                                                                                                                                                        1559,
                                                                                                                                                                        1560,
                                                                                                                                                                        1561,
                                                                                                                                                                        1562,
                                                                                                                                                                        1563,
                                                                                                                                                                        1564,
                                                                                                                                                                        1565,
                                                                                                                                                                        1566,
                                                                                                                                                                        1567,
                                                                                                                                                                        1568,
                                                                                                                                                                        1569,
                                                                                                                                                                        1570,
                                                                                                                                                                        1571,
                                                                                                                                                                        1572,
                                                                                                                                                                        1573,
                                                                                                                                                                        1574,
                                                                                                                                                                        1575,
                                                                                                                                                                        1576,
                                                                                                                                                                        1577,
                                                                                                                                                                        1578,
                                                                                                                                                                        1579,
                                                                                                                                                                        1580,
                                                                                                                                                                        1581,
                                                                                                                                                                        1582,
                                                                                                                                                                        1583,
                                                                                                                                                                        1584,
                                                                                                                                                                        1585,
                                                                                                                                                                        1586,
                                                                                                                                                                        1587,
                                                                                                                                                                        1588,
                                                                                                                                                                        1589,
                                                                                                                                                                        1590,
                                                                                                                                                                        1591,
                                                                                                                                                                        1592,
                                                                                                                                                                        1593,
                                                                                                                                                                        1594,
                                                                                                                                                                        1595,
                                                                                                                                                                        1596,
                                                                                                                                                                        1597,
                                                                                                                                                                        1598,
                                                                                                                                                                        1599,
                                                                                                                                                                        1600,
                                                                                                                                                                        1601,
                                                                                                                                                                        1602,
                                                                                                                                                                        1603,
                                                                                                                                                                        1604,
                                                                                                                                                                        1605,
                                                                                                                                                                        1606,
                                                                                                                                                                        1607,
                                                                                                                                                                        1608,
                                                                                                                                                                        1609,
                                                                                                                                                                        1610,
                                                                                                                                                                        1611,
                                                                                                                                                                        1612,
                                                                                                                                                                        1613,
                                                                                                                                                                        1614,
                                                                                                                                                                        1615,
                                                                                                                                                                        1616,
                                                                                                                                                                        1617,
                                                                                                                                                                        1618,
                                                                                                                                                                        1619,
                                                                                                                                                                        1620,
                                                                                                                                                                        1621,
                                                                                                                                                                        1622,
                                                                                                                                                                        1623,
                                                                                                                                                                        1624,
                                                                                                                                                                        1625,
                                                                                                                                                                        1626,
                                                                                                                                                                        1627,
                                                                                                                                                                        1628,
                                                                                                                                                                        1629,
                                                                                                                                                                        1630,
                                                                                                                                                                        1631,
                                                                                                                                                                        1632,
                                                                                                                                                                        1633,
                                                                                                                                                                        1634,
                                                                                                                                                                        1635,
                                                                                                                                                                        1636,
                                                                                                                                                                        1637,
                                                                                                                                                                        1638,
                                                                                                                                                                        1639,
                                                                                                                                                                        1640,
                                                                                                                                                                        1641,
                                                                                                                                                                        1642,
                                                                                                                                                                        1643,
                                                                                                                                                                        1644,
                                                                                                                                                                        1645,
                                                                                                                                                                        1646,
                                                                                                                                                                        1647,
                                                                                                                                                                        1648,
                                                                                                                                                                        1649,
                                                                                                                                                                        1650,
                                                                                                                                                                        1651,
                                                                                                                                                                        1652,
                                                                                                                                                                        1653,
                                                                                                                                                                        1654,
                                                                                                                                                                        1655,
                                                                                                                                                                        1656,
                                                                                                                                                                        1657,
                                                                                                                                                                        1658,
                                                                                                                                                                        1659,
                                                                                                                                                                        1660,
                                                                                                                                                                        1661,
                                                                                                                                                                        1662,
                                                                                                                                                                        1663,
                                                                                                                                                                        1664,
                                                                                                                                                                        1665,
                                                                                                                                                                        1666,
                                                                                                                                                                        1667,
                                                                                                                                                                        1668,
                                                                                                                                                                        1669,
                                                                                                                                                                        1670,
                                                                                                                                                                        1671,
                                                                                                                                                                        1672,
                                                                                                                                                                        1673,
                                                                                                                                                                        1674,
                                                                                                                                                                        1675,
                                                                                                                                                                        1676,
                                                                                                                                                                        1677,
                                                                                                                                                                        1678,
                                                                                                                                                                        1679,
                                                                                                                                                                        1680,
                                                                                                                                                                        1681,
                                                                                                                                                                        1682,
                                                                                                                                                                        1683,
                                                                                                                                                                        1684,
                                                                                                                                                                        1685,
                                                                                                                                                                        1686,
                                                                                                                                                                        1687,
                                                                                                                                                                        1688,
                                                                                                                                                                        1689,
                                                                                                                                                                        1690,
                                                                                                                                                                        1691,
                                                                                                                                                                        1692,
                                                                                                                                                                        1693,
                                                                                                                                                                        1694,
                                                                                                                                                                        1695,
                                                                                                                                                                        1696,
                                                                                                                                                                        1697,
                                                                                                                                                                        1698,
                                                                                                                                                                        1699,
                                                                                                                                                                        1700,
                                                                                                                                                                        1701,
                                                                                                                                                                        1702,
                                                                                                                                                                        1703,
                                                                                                                                                                        1704,
                                                                                                                                                                        1705,
                                                                                                                                                                        1706,
                                                                                                                                                                        1707,
                                                                                                                                                                        1708,
                                                                                                                                                                        1709,
                                                                                                                                                                        1710,
                                                                                                                                                                        1711,
                                                                                                                                                                        1712,
                                                                                                                                                                        1713,
                                                                                                                                                                        1714,
                                                                                                                                                                        1715,
                                                                                                                                                                        1716,
                                                                                                                                                                        1717,
                                                                                                                                                                        1718,
                                                                                                                                                                        1719,
                                                                                                                                                                        1720,
                                                                                                                                                                        1721,
                                                                                                                                                                        1722,
                                                                                                                                                                        1723,
                                                                                                                                                                        1724,
                                                                                                                                                                        1725,
                                                                                                                                                                        1726,
                                                                                                                                                                        1727,
                                                                                                                                                                        1728,
                                                                                                                                                                        1729,
                                                                                                                                                                        1730,
                                                                                                                                                                        1731,
                                                                                                                                                                        1732,
                                                                                                                                                                        1733,
                                                                                                                                                                        1734,
                                                                                                                                                                        1735,
                                                                                                                                                                        1736,
                                                                                                                                                                        1737,
                                                                                                                                                                        1738,
                                                                                                                                                                        1739,
                                                                                                                                                                        1740,
                                                                                                                                                                        1741,
                                                                                                                                                                        1742,
                                                                                                                                                                        1743,
                                                                                                                                                                        1744,
                                                                                                                                                                        1745,
                                                                                                                                                                        1746,
                                                                                                                                                                        1747,
                                                                                                                                                                        1748,
                                                                                                                                                                        1749,
                                                                                                                                                                        1750,
                                                                                                                                                                        1751,
                                                                                                                                                                        1752,
                                                                                                                                                                        1753,
                                                                                                                                                                        1754,
                                                                                                                                                                        1755,
                                                                                                                                                                        1756,
                                                                                                                                                                        1757,
                                                                                                                                                                        1758,
                                                                                                                                                                        1759,
                                                                                                                                                                        1760,
                                                                                                                                                                        1761,
                                                                                                                                                                        1762,
                                                                                                                                                                        1763,
                                                                                                                                                                        1764,
                                                                                                                                                                        1765,
                                                                                                                                                                        1766,
                                                                                                                                                                        1767,
                                                                                                                                                                        1768,
                                                                                                                                                                        1769,
                                                                                                                                                                        1770,
                                                                                                                                                                        1771,
                                                                                                                                                                        1772,
                                                                                                                                                                        1773,
                                                                                                                                                                        1774,
                                                                                                                                                                        1775,
                                                                                                                                                                        1776,
                                                                                                                                                                        1777,
                                                                                                                                                                        1778,
                                                                                                                                                                        1779,
                                                                                                                                                                        1780,
                                                                                                                                                                        1781,
                                                                                                                                                                        1782,
                                                                                                                                                                        1783,
                                                                                                                                                                        1784,
                                                                                                                                                                        1785,
                                                                                                                                                                        1786,
                                                                                                                                                                        1787,
                                                                                                                                                                        1788,
                                                                                                                                                                        1789,
                                                                                                                                                                        1790,
                                                                                                                                                                        1791,
                                                                                                                                                                        1792,
                                                                                                                                                                        1793,
                                                                                                                                                                        1794,
                                                                                                                                                                        1795,
                                                                                                                                                                        1796,
                                                                                                                                                                        1797,
                                                                                                                                                                        1798,
                                                                                                                                                                        1799,
                                                                                                                                                                        1800,
                                                                                                                                                                        1801,
                                                                                                                                                                        1802,
                                                                                                                                                                        1803,
                                                                                                                                                                        1804,
                                                                                                                                                                        1805,
                                                                                                                                                                        1806,
                                                                                                                                                                        1807,
                                                                                                                                                                        1808,
                                                                                                                                                                        1809,
                                                                                                                                                                        1810,
                                                                                                                                                                        1811,
                                                                                                                                                                        1812,
                                                                                                                                                                        1813,
                                                                                                                                                                        1814,
                                                                                                                                                                        1815,
                                                                                                                                                                        1816,
                                                                                                                                                                        1817,
                                                                                                                                                                        1818,
                                                                                                                                                                        1819,
                                                                                                                                                                        1820,
                                                                                                                                                                        1821,
                                                                                                                                                                        1822,
                                                                                                                                                                        1823,
                                                                                                                                                                        1824,
                                                                                                                                                                        1825,
                                                                                                                                                                        1826,
                                                                                                                                                                        1827,
                                                                                                                                                                        1828,
                                                                                                                                                                        1829,
                                                                                                                                                                        1830,
                                                                                                                                                                        1831,
                                                                                                                                                                        1832,
                                                                                                                                                                        1833,
                                                                                                                                                                        1834,
                                                                                                                                                                        1835,
                                                                                                                                                                        1836,
                                                                                                                                                                        1837,
                                                                                                                                                                        1838,
                                                                                                                                                                        1839,
                                                                                                                                                                        1840,
                                                                                                                                                                        1841,
                                                                                                                                                                        1842,
                                                                                                                                                                        1843,
                                                                                                                                                                        1844,
                                                                                                                                                                        1845,
                                                                                                                                                                        1846,
                                                                                                                                                                        1847,
                                                                                                                                                                        1848,
                                                                                                                                                                        1849,
                                                                                                                                                                        1850,
                                                                                                                                                                        1851,
                                                                                                                                                                        1852,
                                                                                                                                                                        1853,
                                                                                                                                                                        1854,
                                                                                                                                                                        1855,
                                                                                                                                                                        1856,
                                                                                                                                                                        1857,
                                                                                                                                                                        1858,
                                                                                                                                                                        1859,
                                                                                                                                                                        1860,
                                                                                                                                                                        1861,
                                                                                                                                                                        1862,
                                                                                                                                                                        1863,
                                                                                                                                                                        1864,
                                                                                                                                                                        1865,
                                                                                                                                                                        1866,
                                                                                                                                                                        1867,
                                                                                                                                                                        1868,
                                                                                                                                                                        1869,
                                                                                                                                                                        1870,
                                                                                                                                                                        1871,
                                                                                                                                                                        1872,
                                                                                                                                                                        1873,
                                                                                                                                                                        1874,
                                                                                                                                                                        1875,
                                                                                                                                                                        1876,
                                                                                                                                                                        1877,
                                                                                                                                                                        1878,
                                                                                                                                                                        1879,
                                                                                                                                                                        1880,
                                                                                                                                                                        1881,
                                                                                                                                                                        1882,
                                                                                                                                                                        1883,
                                                                                                                                                                        1884,
                                                                                                                                                                        1885,
                                                                                                                                                                        1886,
                                                                                                                                                                        1887,
                                                                                                                                                                        1888,
                                                                                                                                                                        1889,
                                                                                                                                                                        1890,
                                                                                                                                                                        1891,
                                                                                                                                                                        1892,
                                                                                                                                                                        1893,
                                                                                                                                                                        1894,
                                                                                                                                                                        1895,
                                                                                                                                                                        1896,
                                                                                                                                                                        1897,
                                                                                                                                                                        1898,
                                                                                                                                                                        1899,
                                                                                                                                                                        1900,
                                                                                                                                                                        1901,
                                                                                                                                                                        1902,
                                                                                                                                                                        1903,
                                                                                                                                                                        1904,
                                                                                                                                                                        1905,
                                                                                                                                                                        1906,
                                                                                                                                                                        1907,
                                                                                                                                                                        1908,
                                                                                                                                                                        1909,
                                                                                                                                                                        1910,
                                                                                                                                                                        1911,
                                                                                                                                                                        1912,
                                                                                                                                                                        1913,
                                                                                                                                                                        1914,
                                                                                                                                                                        1915,
                                                                                                                                                                        1916,
                                                                                                                                                                        1917,
                                                                                                                                                                        1918,
                                                                                                                                                                        1919,
                                                                                                                                                                        1920,
                                                                                                                                                                        1921,
                                                                                                                                                                        1922,
                                                                                                                                                                        1923,
                                                                                                                                                                        1924,
                                                                                                                                                                        1925,
                                                                                                                                                                        1926,
                                                                                                                                                                        1927,
                                                                                                                                                                        1928,
                                                                                                                                                                        1929,
                                                                                                                                                                        1930,
                                                                                                                                                                        1931,
                                                                                                                                                                        1932,
                                                                                                                                                                        1933,
                                                                                                                                                                        1934,
                                                                                                                                                                        1935,
                                                                                                                                                                        1936,
                                                                                                                                                                        1937,
                                                                                                                                                                        1938,
                                                                                                                                                                        1939,
                                                                                                                                                                        1940,
                                                                                                                                                                        1941,
                                                                                                                                                                        1942,
                                                                                                                                                                        1943,
                                                                                                                                                                        1944,
                                                                                                                                                                        1945,
                                                                                                                                                                        1946,
                                                                                                                                                                        1947,
                                                                                                                                                                        1948,
                                                                                                                                                                        1949,
                                                                                                                                                                        1950,
                                                                                                                                                                        1951,
                                                                                                                                                                        1952,
                                                                                                                                                                        1953,
                                                                                                                                                                        1954,
                                                                                                                                                                        1955,
                                                                                                                                                                        1956,
                                                                                                                                                                        1957,
                                                                                                                                                                        1958,
                                                                                                                                                                        1959,
                                                                                                                                                                        1960,
                                                                                                                                                                        1961,
                                                                                                                                                                        1962,
                                                                                                                                                                        1963,
                                                                                                                                                                        1964,
                                                                                                                                                                        1965,
                                                                                                                                                                        1966,
                                                                                                                                                                        1967,
                                                                                                                                                                        1968,
                                                                                                                                                                        1969,
                                                                                                                                                                        1970,
                                                                                                                                                                        1971,
                                                                                                                                                                        1972,
                                                                                                                                                                        1973,
                                                                                                                                                                        1974,
                                                                                                                                                                        1975,
                                                                                                                                                                        1976,
                                                                                                                                                                        1977,
                                                                                                                                                                        1978,
                                                                                                                                                                        1979,
                                                                                                                                                                        1980,
                                                                                                                                                                        1981,
                                                                                                                                                                        1982,
                                                                                                                                                                        1983,
                                                                                                                                                                        1984,
                                                                                                                                                                        1985,
                                                                                                                                                                        1986,
                                                                                                                                                                        1987,
                                                                                                                                                                        1988,
                                                                                                                                                                        1989,
                                                                                                                                                                        1990,
                                                                                                                                                                        1991,
                                                                                                                                                                        1992,
                                                                                                                                                                        1993,
                                                                                                                                                                        1994,
                                                                                                                                                                        1995,
                                                                                                                                                                        1996,
                                                                                                                                                                        1997,
                                                                                                                                                                        1998,
                                                                                                                                                                        1999,
                                                                                                                                                                        2000,
                                                                                                                                                                        2001,
                                                                                                                                                                        2002,
                                                                                                                                                                        2003,
                                                                                                                                                                        2004,
                                                                                                                                                                        2005,
                                                                                                                                                                        2006,
                                                                                                                                                                        2007,
                                                                                                                                                                        2008,
                                                                                                                                                                        2009,
                                                                                                                                                                        2010,
                                                                                                                                                                        2011,
                                                                                                                                                                        2012,
                                                                                                                                                                        2013,
                                                                                                                                                                        2014,
                                                                                                                                                                        2015,
                                                                                                                                                                        2016,
                                                                                                                                                                        2017,
                                                                                                                                                                        2018,
                                                                                                                                                                        2019,
                                                                                                                                                                        2020,
                                                                                                                                                                        2021,
                                                                                                                                                                        2022,
                                                                                                                                                                        2023,
                                                                                                                                                                        2024,
                                                                                                                                                                        2025,
                                                                                                                                                                        2026,
                                                                                                                                                                        2027,
                                                                                                                                                                        2028,
                                                                                                                                                                        2029,
                                                                                                                                                                        2030,
                                                                                                                                                                        2031,
                                                                                                                                                                        2032,
                                                                                                                                                                        2033,
                                                                                                                                                                        2034,
                                                                                                                                                                        2035,
                                                                                                                                                                        2036,
                                                                                                                                                                        2037,
                                                                                                                                                                        2038,
                                                                                                                                                                        2039,
                                                                                                                                                                        2040,
                                                                                                                                                                        2041,
                                                                                                                                                                        2042,
                                                                                                                                                                        2043,
                                                                                                                                                                        2044,
                                                                                                                                                                        2045,
                                                                                                                                                                        2046,
                                                                                                                                                                        2047,
                                                                                                                                                                        2048,
                                                                                                                                                                        2049,
                                                                                                                                                                        2050,
                                                                                                                                                                        2051,
                                                                                                                                                                        2052,
                                                                                                                                                                        2053,
                                                                                                                                                                        2054,
                                                                                                                                                                        2055,
                                                                                                                                                                        2056,
                                                                                                                                                                        2057,
                                                                                                                                                                        2058,
                                                                                                                                                                        2059,
                                                                                                                                                                        2060,
                                                                                                                                                                        2061,
                                                                                                                                                                        2062,
                                                                                                                                                                        2063,
                                                                                                                                                                        2064,
                                                                                                                                                                        2065,
                                                                                                                                                                        2066,
                                                                                                                                                                        2067,
                                                                                                                                                                        2068,
                                                                                                                                                                        2069,
                                                                                                                                                                        2070,
                                                                                                                                                                        2071,
                                                                                                                                                                        2072,
                                                                                                                                                                        2073,
                                                                                                                                                                        2074,
                                                                                                                                                                        2075,
                                                                                                                                                                        2076,
                                                                                                                                                                        2077,
                                                                                                                                                                        2078,
                                                                                                                                                                        2079,
                                                                                                                                                                        2080,
                                                                                                                                                                        2081,
                                                                                                                                                                        2082,
                                                                                                                                                                        2083,
                                                                                                                                                                        2084,
                                                                                                                                                                        2085,
                                                                                                                                                                        2086,
                                                                                                                                                                        2087,
                                                                                                                                                                        2088,
                                                                                                                                                                        2089,
                                                                                                                                                                        2090,
                                                                                                                                                                        2091,
                                                                                                                                                                        2092,
                                                                                                                                                                        2093,
                                                                                                                                                                        2094,
                                                                                                                                                                        2095,
                                                                                                                                                                        2096,
                                                                                                                                                                        2097,
                                                                                                                                                                        2098,
                                                                                                                                                                        2099,
                                                                                                                                                                        2100,
                                                                                                                                                                        2101,
                                                                                                                                                                        2102,
                                                                                                                                                                        2103,
                                                                                                                                                                        2104,
                                                                                                                                                                        2105,
                                                                                                                                                                        2106,
                                                                                                                                                                        2107,
                                                                                                                                                                        2108,
                                                                                                                                                                        2109,
                                                                                                                                                                        2110,
                                                                                                                                                                        2111,
                                                                                                                                                                        2112,
                                                                                                                                                                        2113,
                                                                                                                                                                        2114,
                                                                                                                                                                        2115,
                                                                                                                                                                        2116,
                                                                                                                                                                        2117,
                                                                                                                                                                        2118,
                                                                                                                                                                        2119,
                                                                                                                                                                        2120,
                                                                                                                                                                        2121,
                                                                                                                                                                        2122,
                                                                                                                                                                        2123,
                                                                                                                                                                        2124,
                                                                                                                                                                        2125,
                                                                                                                                                                        2126,
                                                                                                                                                                        2127,
                                                                                                                                                                        2128,
                                                                                                                                                                        2129,
                                                                                                                                                                        2130,
                                                                                                                                                                        2131,
                                                                                                                                                                        2132,
                                                                                                                                                                        2133,
                                                                                                                                                                        2134,
                                                                                                                                                                        2135,
                                                                                                                                                                        2136,
                                                                                                                                                                        2137,
                                                                                                                                                                        2138,
                                                                                                                                                                        2139,
                                                                                                                                                                        2140,
                                                                                                                                                                        2141,
                                                                                                                                                                        2142,
                                                                                                                                                                        2143,
                                                                                                                                                                        2144,
                                                                                                                                                                        2145,
                                                                                                                                                                        2146,
                                                                                                                                                                        2147,
                                                                                                                                                                        2148,
                                                                                                                                                                        2149,
                                                                                                                                                                        2150,
                                                                                                                                                                        2151,
                                                                                                                                                                        2152,
                                                                                                                                                                        2153,
                                                                                                                                                                        2154,
                                                                                                                                                                        2155,
                                                                                                                                                                        2156,
                                                                                                                                                                        2157,
                                                                                                                                                                        2158,
                                                                                                                                                                        2159,
                                                                                                                                                                        2160,
                                                                                                                                                                        2161,
                                                                                                                                                                        2162,
                                                                                                                                                                        2163,
                                                                                                                                                                        2164,
                                                                                                                                                                        2165,
                                                                                                                                                                        2166,
                                                                                                                                                                        2167,
                                                                                                                                                                        2168,
                                                                                                                                                                        2169,
                                                                                                                                                                        2170,
                                                                                                                                                                        2171,
                                                                                                                                                                        2172,
                                                                                                                                                                        2173,
                                                                                                                                                                        2174,
                                                                                                                                                                        2175,
                                                                                                                                                                        2176,
                                                                                                                                                                        2177,
                                                                                                                                                                        2178,
                                                                                                                                                                        2179,
                                                                                                                                                                        2180,
                                                                                                                                                                        2181,
                                                                                                                                                                        2182,
                                                                                                                                                                        2183,
                                                                                                                                                                        2184,
                                                                                                                                                                        2185,
                                                                                                                                                                        2186,
                                                                                                                                                                        2187,
                                                                                                                                                                        2188,
                                                                                                                                                                        2189,
                                                                                                                                                                        2190,
                                                                                                                                                                        2191,
                                                                                                                                                                        2192,
                                                                                                                                                                        2193,
                                                                                                                                                                        2194,
                                                                                                                                                                        2195,
                                                                                                                                                                        2196,
                                                                                                                                                                        2197,
                                                                                                                                                                        2198,
                                                                                                                                                                        2199,
                                                                                                                                                                        2200,
                                                                                                                                                                        2201,
                                                                                                                                                                        2202,
                                                                                                                                                                        2203,
                                                                                                                                                                        2204,
                                                                                                                                                                        2205,
                                                                                                                                                                        2206,
                                                                                                                                                                        2207,
                                                                                                                                                                        2208,
                                                                                                                                                                        2209,
                                                                                                                                                                        2210,
                                                                                                                                                                        2211,
                                                                                                                                                                        2212,
                                                                                                                                                                        2213,
                                                                                                                                                                        2214,
                                                                                                                                                                        2215,
                                                                                                                                                                        2216,
                                                                                                                                                                        2217,
                                                                                                                                                                        2218,
                                                                                                                                                                        2219,
                                                                                                                                                                        2220,
                                                                                                                                                                        2221,
                                                                                                                                                                        2222,
                                                                                                                                                                        2223,
                                                                                                                                                                        2224,
                                                                                                                                                                        2225,
                                                                                                                                                                        2226,
                                                                                                                                                                        2227,
                                                                                                                                                                        2228,
                                                                                                                                                                        2229,
                                                                                                                                                                        2230,
                                                                                                                                                                        2231,
                                                                                                                                                                        2232,
                                                                                                                                                                        2233,
                                                                                                                                                                        2234,
                                                                                                                                                                        2235,
                                                                                                                                                                        2236,
                                                                                                                                                                        2237,
                                                                                                                                                                        2238,
                                                                                                                                                                        2239,
                                                                                                                                                                        2240,
                                                                                                                                                                        2241,
                                                                                                                                                                        2242,
                                                                                                                                                                        2243,
                                                                                                                                                                        2244,
                                                                                                                                                                        2245,
                                                                                                                                                                        2246,
                                                                                                                                                                        2247,
                                                                                                                                                                        2248,
                                                                                                                                                                        2249,
                                                                                                                                                                        2250,
                                                                                                                                                                        2251,
                                                                                                                                                                        2252,
                                                                                                                                                                        2253,
                                                                                                                                                                        2254,
                                                                                                                                                                        2255,
                                                                                                                                                                        2256,
                                                                                                                                                                        2257,
                                                                                                                                                                        2258,
                                                                                                                                                                        2259,
                                                                                                                                                                        2260,
                                                                                                                                                                        2261,
                                                                                                                                                                        2262,
                                                                                                                                                                        2263,
                                                                                                                                                                        2264,
                                                                                                                                                                        2265,
                                                                                                                                                                        2266,
                                                                                                                                                                        2267,
                                                                                                                                                                        2268,
                                                                                                                                                                        2269,
                                                                                                                                                                        2270,
                                                                                                                                                                        2271,
                                                                                                                                                                        2272,
                                                                                                                                                                        2273,
                                                                                                                                                                        2274,
                                                                                                                                                                        2275,
                                                                                                                                                                        2276,
                                                                                                                                                                        2277,
                                                                                                                                                                        2278,
                                                                                                                                                                        2279,
                                                                                                                                                                        2280,
                                                                                                                                                                        2281,
                                                                                                                                                                        2282,
                                                                                                                                                                        2283,
                                                                                                                                                                        2284,
                                                                                                                                                                        2285,
                                                                                                                                                                        2286,
                                                                                                                                                                        2287,
                                                                                                                                                                        2288,
                                                                                                                                                                        2289,
                                                                                                                                                                        2290,
                                                                                                                                                                        2291,
                                                                                                                                                                        2292,
                                                                                                                                                                        2293,
                                                                                                                                                                        2294,
                                                                                                                                                                        2295,
                                                                                                                                                                        2296,
                                                                                                                                                                        2297,
                                                                                                                                                                        2298,
                                                                                                                                                                        2299,
                                                                                                                                                                        2300,
                                                                                                                                                                        2301,
                                                                                                                                                                        2302,
                                                                                                                                                                        2303,
                                                                                                                                                                        2304,
                                                                                                                                                                        2305,
                                                                                                                                                                        2306,
                                                                                                                                                                        2307,
                                                                                                                                                                        2308,
                                                                                                                                                                        2309,
                                                                                                                                                                        2310,
                                                                                                                                                                        2311,
                                                                                                                                                                        2312,
                                                                                                                                                                        2313,
                                                                                                                                                                        2314,
                                                                                                                                                                        2315,
                                                                                                                                                                        2316,
                                                                                                                                                                        2317,
                                                                                                                                                                        2318,
                                                                                                                                                                        2319,
                                                                                                                                                                        2320,
                                                                                                                                                                        2321,
                                                                                                                                                                        2322,
                                                                                                                                                                        2323,
                                                                                                                                                                        2324,
                                                                                                                                                                        2325,
                                                                                                                                                                        2326,
                                                                                                                                                                        2327,
                                                                                                                                                                        2328,
                                                                                                                                                                        2329,
                                                                                                                                                                        2330,
                                                                                                                                                                        2331,
                                                                                                                                                                        2332,
                                                                                                                                                                        2333,
                                                                                                                                                                        2334,
                                                                                                                                                                        2335,
                                                                                                                                                                        2336,
                                                                                                                                                                        2337,
                                                                                                                                                                        2338,
                                                                                                                                                                        2339,
                                                                                                                                                                        2340,
                                                                                                                                                                        2341,
                                                                                                                                                                        2342,
                                                                                                                                                                        2343,
                                                                                                                                                                        2344,
                                                                                                                                                                        2345,
                                                                                                                                                                        2346,
                                                                                                                                                                        2347,
                                                                                                                                                                        2348,
                                                                                                                                                                        2349,
                                                                                                                                                                        2350,
                                                                                                                                                                        2351,
                                                                                                                                                                        2352,
                                                                                                                                                                        2353,
                                                                                                                                                                        2354,
                                                                                                                                                                        2355,
                                                                                                                                                                        2356,
                                                                                                                                                                        2357,
                                                                                                                                                                        2358,
                                                                                                                                                                        2359,
                                                                                                                                                                        2360,
                                                                                                                                                                        2361,
                                                                                                                                                                        2362,
                                                                                                                                                                        2363,
                                                                                                                                                                        2364,
                                                                                                                                                                        2365,
                                                                                                                                                                        2366,
                                                                                                                                                                        2367,
                                                                                                                                                                        2368,
                                                                                                                                                                        2369,
                                                                                                                                                                        2370,
                                                                                                                                                                        2371,
                                                                                                                                                                        2372,
                                                                                                                                                                        2373,
                                                                                                                                                                        2374,
                                                                                                                                                                        2375,
                                                                                                                                                                        2376,
                                                                                                                                                                        2377,
                                                                                                                                                                        2378,
                                                                                                                                                                        2379,
                                                                                                                                                                        2380,
                                                                                                                                                                        2381,
                                                                                                                                                                        2382,
                                                                                                                                                                        2383,
                                                                                                                                                                        2384,
                                                                                                                                                                        2385,
                                                                                                                                                                        2386,
                                                                                                                                                                        2387,
                                                                                                                                                                        2388,
                                                                                                                                                                        2389,
                                                                                                                                                                        2390,
                                                                                                                                                                        2391,
                                                                                                                                                                        2392,
                                                                                                                                                                        2393,
                                                                                                                                                                        2394,
                                                                                                                                                                        2395,
                                                                                                                                                                        2396,
                                                                                                                                                                        2397,
                                                                                                                                                                        2398,
                                                                                                                                                                        2399,
                                                                                                                                                                        2400,
                                                                                                                                                                        2401,
                                                                                                                                                                        2402,
                                                                                                                                                                        2403,
                                                                                                                                                                        2404,
                                                                                                                                                                        2405,
                                                                                                                                                                        2406,
                                                                                                                                                                        2407,
                                                                                                                                                                        2408,
                                                                                                                                                                        2409,
                                                                                                                                                                        2410,
                                                                                                                                                                        2411,
                                                                                                                                                                        2412,
                                                                                                                                                                        2413,
                                                                                                                                                                        2414,
                                                                                                                                                                        2415,
                                                                                                                                                                        2416,
                                                                                                                                                                        2417,
                                                                                                                                                                        2418,
                                                                                                                                                                        2419,
                                                                                                                                                                        2420,
                                                                                                                                                                        2421,
                                                                                                                                                                        2422,
                                                                                                                                                                        2423,
                                                                                                                                                                        2424,
                                                                                                                                                                        2425,
                                                                                                                                                                        2426,
                                                                                                                                                                        2427,
                                                                                                                                                                        2428,
                                                                                                                                                                        2429,
                                                                                                                                                                        2430,
                                                                                                                                                                        2431,
                                                                                                                                                                        2432,
                                                                                                                                                                        2433,
                                                                                                                                                                        2434,
                                                                                                                                                                        2435,
                                                                                                                                                                        2436,
                                                                                                                                                                        2437,
                                                                                                                                                                        2438,
                                                                                                                                                                        2439,
                                                                                                                                                                        2440,
                                                                                                                                                                        2441,
                                                                                                                                                                        2442,
                                                                                                                                                                        2443,
                                                                                                                                                                        2444,
                                                                                                                                                                        2445,
                                                                                                                                                                        2446,
                                                                                                                                                                        2447,
                                                                                                                                                                        2448,
                                                                                                                                                                        2449,
                                                                                                                                                                        2450,
                                                                                                                                                                        2451,
                                                                                                                                                                        2452,
                                                                                                                                                                        2453,
                                                                                                                                                                        2454,
                                                                                                                                                                        2455,
                                                                                                                                                                        2456,
                                                                                                                                                                        2457,
                                                                                                                                                                        2458,
                                                                                                                                                                        2459,
                                                                                                                                                                        2460,
                                                                                                                                                                        2461,
                                                                                                                                                                        2462,
                                                                                                                                                                        2463,
                                                                                                                                                                        2464,
                                                                                                                                                                        2465,
                                                                                                                                                                        2466,
                                                                                                                                                                        2467,
                                                                                                                                                                        2468,
                                                                                                                                                                        2469,
                                                                                                                                                                        2470,
                                                                                                                                                                        2471,
                                                                                                                                                                        2472,
                                                                                                                                                                        2473,
                                                                                                                                                                        2474,
                                                                                                                                                                        2475,
                                                                                                                                                                        2476,
                                                                                                                                                                        2477,
                                                                                                                                                                        2478,
                                                                                                                                                                        2479,
                                                                                                                                                                        2480,
                                                                                                                                                                        2481,
                                                                                                                                                                        2482,
                                                                                                                                                                        2483,
                                                                                                                                                                        2484,
                                                                                                                                                                        2485,
                                                                                                                                                                        2486,
                                                                                                                                                                        2487,
                                                                                                                                                                        2488,
                                                                                                                                                                        2489,
                                                                                                                                                                        2490,
                                                                                                                                                                        2491,
                                                                                                                                                                        2492,
                                                                                                                                                                        2493,
                                                                                                                                                                        2494,
                                                                                                                                                                        2495,
                                                                                                                                                                        2496,
                                                                                                                                                                        2497,
                                                                                                                                                                        2498,
                                                                                                                                                                        2499,
                                                                                                                                                                        2500,
                                                                                                                                                                        2501,
                                                                                                                                                                        2502,
                                                                                                                                                                        2503,
                                                                                                                                                                        2504,
                                                                                                                                                                        2505,
                                                                                                                                                                        2506,
                                                                                                                                                                        2507,
                                                                                                                                                                        2508,
                                                                                                                                                                        2509,
                                                                                                                                                                        2510,
                                                                                                                                                                        2511,
                                                                                                                                                                        2512,
                                                                                                                                                                        2513,
                                                                                                                                                                        2514,
                                                                                                                                                                        2515,
                                                                                                                                                                        2516,
                                                                                                                                                                        2517,
                                                                                                                                                                        2518,
                                                                                                                                                                        2519,
                                                                                                                                                                        2520,
                                                                                                                                                                        2521,
                                                                                                                                                                        2522,
                                                                                                                                                                        2523,
                                                                                                                                                                        2524,
                                                                                                                                                                        2525,
                                                                                                                                                                        2526,
                                                                                                                                                                        2527,
                                                                                                                                                                        2528,
                                                                                                                                                                        2529,
                                                                                                                                                                        2530,
                                                                                                                                                                        2531,
                                                                                                                                                                        2532,
                                                                                                                                                                        2533,
                                                                                                                                                                        2534,
                                                                                                                                                                        2535,
                                                                                                                                                                        2536,
                                                                                                                                                                        2537,
                                                                                                                                                                        2538,
                                                                                                                                                                        2539,
                                                                                                                                                                        2540,
                                                                                                                                                                        2541,
                                                                                                                                                                        2542,
                                                                                                                                                                        2543,
                                                                                                                                                                        2544,
                                                                                                                                                                        2545,
                                                                                                                                                                        2546,
                                                                                                                                                                        2547,
                                                                                                                                                                        2548,
                                                                                                                                                                        2549,
                                                                                                                                                                        2550,
                                                                                                                                                                        2551,
                                                                                                                                                                        2552,
                                                                                                                                                                        2553,
                                                                                                                                                                        2554,
                                                                                                                                                                        2555,
                                                                                                                                                                        2556,
                                                                                                                                                                        2557,
                                                                                                                                                                        2558,
                                                                                                                                                                        2559,
                                                                                                                                                                        2560,
                                                                                                                                                                        2561,
                                                                                                                                                                        2562,
                                                                                                                                                                        2563,
                                                                                                                                                                        2564,
                                                                                                                                                                        2565,
                                                                                                                                                                        2566,
                                                                                                                                                                        2567,
                                                                                                                                                                        2568,
                                                                                                                                                                        2569,
                                                                                                                                                                        2570,
                                                                                                                                                                        2571,
                                                                                                                                                                        2572,
                                                                                                                                                                        2573,
                                                                                                                                                                        2574,
                                                                                                                                                                        2575,
                                                                                                                                                                        2576,
                                                                                                                                                                        2577,
                                                                                                                                                                        2578,
                                                                                                                                                                        2579,
                                                                                                                                                                        2580,
                                                                                                                                                                        2581,
                                                                                                                                                                        2582,
                                                                                                                                                                        2583,
                                                                                                                                                                        2584,
                                                                                                                                                                        2585,
                                                                                                                                                                        2586,
                                                                                                                                                                        2587,
                                                                                                                                                                        2588,
                                                                                                                                                                        2589,
                                                                                                                                                                        2590,
                                                                                                                                                                        2591,
                                                                                                                                                                        2592,
                                                                                                                                                                        2593,
                                                                                                                                                                        2594,
                                                                                                                                                                        2595,
                                                                                                                                                                        2596,
                                                                                                                                                                        2597,
                                                                                                                                                                        2598,
                                                                                                                                                                        2599,
                                                                                                                                                                        2600,
                                                                                                                                                                        2601,
                                                                                                                                                                        2602,
                                                                                                                                                                        2603,
                                                                                                                                                                        2604,
                                                                                                                                                                        2605,
                                                                                                                                                                        2606,
                                                                                                                                                                        2607,
                                                                                                                                                                        2608,
                                                                                                                                                                        2609,
                                                                                                                                                                        2610,
                                                                                                                                                                        2611,
                                                                                                                                                                        2612,
                                                                                                                                                                        2613,
                                                                                                                                                                        2614,
                                                                                                                                                                        2615,
                                                                                                                                                                        2616,
                                                                                                                                                                        2617,
                                                                                                                                                                        2618,
                                                                                                                                                                        2619,
                                                                                                                                                                        2620,
                                                                                                                                                                        2621,
                                                                                                                                                                        2622,
                                                                                                                                                                        2623,
                                                                                                                                                                        2624,
                                                                                                                                                                        2625,
                                                                                                                                                                        2626,
                                                                                                                                                                        2627,
                                                                                                                                                                        2628,
                                                                                                                                                                        2629,
                                                                                                                                                                        2630,
                                                                                                                                                                        2631,
                                                                                                                                                                        2632,
                                                                                                                                                                        2633,
                                                                                                                                                                        2634,
                                                                                                                                                                        2635,
                                                                                                                                                                        2636,
                                                                                                                                                                        2637,
                                                                                                                                                                        2638,
                                                                                                                                                                        2639,
                                                                                                                                                                        2640,
                                                                                                                                                                        2641,
                                                                                                                                                                        2642,
                                                                                                                                                                        2643,
                                                                                                                                                                        2644,
                                                                                                                                                                        2645,
                                                                                                                                                                        2646,
                                                                                                                                                                        2647,
                                                                                                                                                                        2648,
                                                                                                                                                                        2649,
                                                                                                                                                                        2650,
                                                                                                                                                                        2651,
                                                                                                                                                                        2652,
                                                                                                                                                                        2653,
                                                                                                                                                                        2654,
                                                                                                                                                                        2655,
                                                                                                                                                                        2656,
                                                                                                                                                                        2657,
                                                                                                                                                                        2658,
                                                                                                                                                                        2659,
                                                                                                                                                                        2660,
                                                                                                                                                                        2661,
                                                                                                                                                                        2662,
                                                                                                                                                                        2663,
                                                                                                                                                                        2664,
                                                                                                                                                                        2665,
                                                                                                                                                                        2666,
                                                                                                                                                                        2667,
                                                                                                                                                                        2668,
                                                                                                                                                                        2669,
                                                                                                                                                                        2670,
                                                                                                                                                                        2671,
                                                                                                                                                                        2672,
                                                                                                                                                                        2673,
                                                                                                                                                                        2674,
                                                                                                                                                                        2675,
                                                                                                                                                                        2676,
                                                                                                                                                                        2677,
                                                                                                                                                                        2678,
                                                                                                                                                                        2679,
                                                                                                                                                                        2680,
                                                                                                                                                                        2681,
                                                                                                                                                                        2682,
                                                                                                                                                                        2683,
                                                                                                                                                                        2684,
                                                                                                                                                                        2685,
                                                                                                                                                                        2686,
                                                                                                                                                                        2687,
                                                                                                                                                                        2688,
                                                                                                                                                                        2689,
                                                                                                                                                                        2690,
                                                                                                                                                                        2691,
                                                                                                                                                                        2692,
                                                                                                                                                                        2693,
                                                                                                                                                                        2694,
                                                                                                                                                                        2695,
                                                                                                                                                                        2696,
                                                                                                                                                                        2697,
                                                                                                                                                                        2698,
                                                                                                                                                                        2699,
                                                                                                                                                                        2700,
                                                                                                                                                                        2701,
                                                                                                                                                                        2702,
                                                                                                                                                                        2703,
                                                                                                                                                                        2704,
                                                                                                                                                                        2705,
                                                                                                                                                                        2706,
                                                                                                                                                                        2707,
                                                                                                                                                                        2708,
                                                                                                                                                                        2709,
                                                                                                                                                                        2710,
                                                                                                                                                                        2711,
                                                                                                                                                                        2712,
                                                                                                                                                                        2713,
                                                                                                                                                                        2714,
                                                                                                                                                                        2715,
                                                                                                                                                                        2716,
                                                                                                                                                                        2717,
                                                                                                                                                                        2718,
                                                                                                                                                                        2719,
                                                                                                                                                                        2720,
                                                                                                                                                                        2721,
                                                                                                                                                                        2722,
                                                                                                                                                                        2723,
                                                                                                                                                                        2724,
                                                                                                                                                                        2725,
                                                                                                                                                                        2726,
                                                                                                                                                                        2727,
                                                                                                                                                                        2728,
                                                                                                                                                                        2729,
                                                                                                                                                                        2730,
                                                                                                                                                                        2731,
                                                                                                                                                                        2732,
                                                                                                                                                                        2733,
                                                                                                                                                                        2734,
                                                                                                                                                                        2735,
                                                                                                                                                                        2736,
                                                                                                                                                                        2737,
                                                                                                                                                                        2738,
                                                                                                                                                                        2739,
                                                                                                                                                                        2740,
                                                                                                                                                                        2741,
                                                                                                                                                                        2742,
                                                                                                                                                                        2743,
                                                                                                                                                                        2744,
                                                                                                                                                                        2745,
                                                                                                                                                                        2746,
                                                                                                                                                                        2747,
                                                                                                                                                                        2748,
                                                                                                                                                                        2749,
                                                                                                                                                                        2750,
                                                                                                                                                                        2751,
                                                                                                                                                                        2752,
                                                                                                                                                                        2753,
                                                                                                                                                                        2754,
                                                                                                                                                                        2755,
                                                                                                                                                                        2756,
                                                                                                                                                                        2757,
                                                                                                                                                                        2758,
                                                                                                                                                                        2759,
                                                                                                                                                                        2760,
                                                                                                                                                                        2761,
                                                                                                                                                                        2762,
                                                                                                                                                                        2763,
                                                                                                                                                                        2764,
                                                                                                                                                                        2765,
                                                                                                                                                                        2766,
                                                                                                                                                                        2767,
                                                                                                                                                                        2768,
                                                                                                                                                                        2769,
                                                                                                                                                                        2770,
                                                                                                                                                                        2771,
                                                                                                                                                                        2772,
                                                                                                                                                                        2773,
                                                                                                                                                                        2774,
                                                                                                                                                                        2775,
                                                                                                                                                                        2776,
                                                                                                                                                                        2777,
                                                                                                                                                                        2778,
                                                                                                                                                                        2779,
                                                                                                                                                                        2780,
                                                                                                                                                                        2781,
                                                                                                                                                                        2782,
                                                                                                                                                                        2783,
                                                                                                                                                                        2784,
                                                                                                                                                                        2785,
                                                                                                                                                                        2786,
                                                                                                                                                                        2787,
                                                                                                                                                                        2788,
                                                                                                                                                                        2789,
                                                                                                                                                                        2790,
                                                                                                                                                                        2791,
                                                                                                                                                                        2792,
                                                                                                                                                                        2793,
                                                                                                                                                                        2794,
                                                                                                                                                                        2795,
                                                                                                                                                                        2796,
                                                                                                                                                                        2797,
                                                                                                                                                                        2798,
                                                                                                                                                                        2799,
                                                                                                                                                                        2800,
                                                                                                                                                                        2801,
                                                                                                                                                                        2802,
                                                                                                                                                                        2803,
                                                                                                                                                                        2804,
                                                                                                                                                                        2805,
                                                                                                                                                                        2806,
                                                                                                                                                                        2807,
                                                                                                                                                                        2808,
                                                                                                                                                                        2809,
                                                                                                                                                                        2810,
                                                                                                                                                                        2811,
                                                                                                                                                                        2812,
                                                                                                                                                                        2813,
                                                                                                                                                                        2814,
                                                                                                                                                                        2815,
                                                                                                                                                                        2816,
                                                                                                                                                                        2817,
                                                                                                                                                                        2818,
                                                                                                                                                                        2819,
                                                                                                                                                                        2820,
                                                                                                                                                                        2821,
                                                                                                                                                                        2822,
                                                                                                                                                                        2823,
                                                                                                                                                                        2824,
                                                                                                                                                                        2825,
                                                                                                                                                                        2826,
                                                                                                                                                                        2827,
                                                                                                                                                                        2828,
                                                                                                                                                                        2829,
                                                                                                                                                                        2830,
                                                                                                                                                                        2831,
                                                                                                                                                                        2832,
                                                                                                                                                                        2833,
                                                                                                                                                                        2834,
                                                                                                                                                                        2835,
                                                                                                                                                                        2836,
                                                                                                                                                                        2837,
                                                                                                                                                                        2838,
                                                                                                                                                                        2839,
                                                                                                                                                                        2840,
                                                                                                                                                                        2841,
                                                                                                                                                                        2842,
                                                                                                                                                                        2843,
                                                                                                                                                                        2844,
                                                                                                                                                                        2845,
                                                                                                                                                                        2846,
                                                                                                                                                                        2847,
                                                                                                                                                                        2848,
                                                                                                                                                                        2849,
                                                                                                                                                                        2850,
                                                                                                                                                                        2851,
                                                                                                                                                                        2852,
                                                                                                                                                                        2853,
                                                                                                                                                                        2854,
                                                                                                                                                                        2855,
                                                                                                                                                                        2856,
                                                                                                                                                                        2857,
                                                                                                                                                                        2858,
                                                                                                                                                                        2859,
                                                                                                                                                                        2860,
                                                                                                                                                                        2861,
                                                                                                                                                                        2862,
                                                                                                                                                                        2863,
                                                                                                                                                                        2864,
                                                                                                                                                                        2865,
                                                                                                                                                                        2866,
                                                                                                                                                                        2867,
                                                                                                                                                                        2868,
                                                                                                                                                                        2869,
                                                                                                                                                                        2870,
                                                                                                                                                                        2871,
                                                                                                                                                                        2872,
                                                                                                                                                                        2873,
                                                                                                                                                                        2874,
                                                                                                                                                                        2875,
                                                                                                                                                                        2876,
                                                                                                                                                                        2877,
                                                                                                                                                                        2878,
                                                                                                                                                                        2879,
                                                                                                                                                                        2880,
                                                                                                                                                                        2881,
                                                                                                                                                                        2882,
                                                                                                                                                                        2883,
                                                                                                                                                                        2884,
                                                                                                                                                                        2885,
                                                                                                                                                                        2886,
                                                                                                                                                                        2887,
                                                                                                                                                                        2888,
                                                                                                                                                                        2889,
                                                                                                                                                                        2890,
                                                                                                                                                                        2891,
                                                                                                                                                                        2892,
                                                                                                                                                                        2893,
                                                                                                                                                                        2894,
                                                                                                                                                                        2895,
                                                                                                                                                                        2896,
                                                                                                                                                                        2897,
                                                                                                                                                                        2898,
                                                                                                                                                                        2899,
                                                                                                                                                                        2900,
                                                                                                                                                                        2901,
                                                                                                                                                                        2902,
                                                                                                                                                                        2903,
                                                                                                                                                                        2904,
                                                                                                                                                                        2905,
                                                                                                                                                                        2906,
                                                                                                                                                                        2907,
                                                                                                                                                                        2908,
                                                                                                                                                                        2909,
                                                                                                                                                                        2910,
                                                                                                                                                                        2911,
                                                                                                                                                                        2912,
                                                                                                                                                                        2913,
                                                                                                                                                                        2914,
                                                                                                                                                                        2915,
                                                                                                                                                                        2916,
                                                                                                                                                                        2917,
                                                                                                                                                                        2918,
                                                                                                                                                                        2919,
                                                                                                                                                                        2920,
                                                                                                                                                                        2921,
                                                                                                                                                                        2922,
                                                                                                                                                                        2923,
                                                                                                                                                                        2924,
                                                                                                                                                                        2925,
                                                                                                                                                                        2926,
                                                                                                                                                                        2927,
                                                                                                                                                                        2928,
                                                                                                                                                                        2929,
                                                                                                                                                                        2930,
                                                                                                                                                                        2931,
                                                                                                                                                                        2932,
                                                                                                                                                                        2933,
                                                                                                                                                                        2934,
                                                                                                                                                                        2935,
                                                                                                                                                                        2936,
                                                                                                                                                                        2937,
                                                                                                                                                                        2938,
                                                                                                                                                                        2939,
                                                                                                                                                                        2940,
                                                                                                                                                                        2941,
                                                                                                                                                                        2942,
                                                                                                                                                                        2943,
                                                                                                                                                                        2944,
                                                                                                                                                                        2945,
                                                                                                                                                                        2946,
                                                                                                                                                                        2947,
                                                                                                                                                                        2948,
                                                                                                                                                                        2949,
                                                                                                                                                                        2950,
                                                                                                                                                                        2951,
                                                                                                                                                                        2952,
                                                                                                                                                                        2953,
                                                                                                                                                                        2954,
                                                                                                                                                                        2955,
                                                                                                                                                                        2956,
                                                                                                                                                                        2957,
                                                                                                                                                                        2958,
                                                                                                                                                                        2959,
                                                                                                                                                                        2960,
                                                                                                                                                                        2961,
                                                                                                                                                                        2962,
                                                                                                                                                                        2963,
                                                                                                                                                                        2964,
                                                                                                                                                                        2965,
                                                                                                                                                                        2966,
                                                                                                                                                                        2967,
                                                                                                                                                                        2968,
                                                                                                                                                                        2969,
                                                                                                                                                                        2970,
                                                                                                                                                                        2971,
                                                                                                                                                                        2972,
                                                                                                                                                                        2973,
                                                                                                                                                                        2974,
                                                                                                                                                                        2975,
                                                                                                                                                                        2976,
                                                                                                                                                                        2977,
                                                                                                                                                                        2978,
                                                                                                                                                                        2979,
                                                                                                                                                                        2980,
                                                                                                                                                                        2981,
                                                                                                                                                                        2982,
                                                                                                                                                                        2983,
                                                                                                                                                                        2984,
                                                                                                                                                                        2985,
                                                                                                                                                                        2986,
                                                                                                                                                                        2987,
                                                                                                                                                                        2988,
                                                                                                                                                                        2989,
                                                                                                                                                                        2990,
                                                                                                                                                                        2991,
                                                                                                                                                                        2992,
                                                                                                                                                                        2993,
                                                                                                                                                                        2994,
                                                                                                                                                                        2995,
                                                                                                                                                                        2996,
                                                                                                                                                                        2997,
                                                                                                                                                                        2998,
                                                                                                                                                                        2999,
                                                                                                                                                                        3000,
                                                                                                                                                                        3001,
                                                                                                                                                                        3002,
                                                                                                                                                                        3003,
                                                                                                                                                                        3004,
                                                                                                                                                                        3005,
                                                                                                                                                                        3006,
                                                                                                                                                                        3007,
                                                                                                                                                                        3008,
                                                                                                                                                                        3009,
                                                                                                                                                                        3010,
                                                                                                                                                                        3011,
                                                                                                                                                                        3012,
                                                                                                                                                                        3013,
                                                                                                                                                                        3014,
                                                                                                                                                                        3015,
                                                                                                                                                                        3016,
                                                                                                                                                                        3017,
                                                                                                                                                                        3018,
                                                                                                                                                                        3019,
                                                                                                                                                                        3020,
                                                                                                                                                                        3021,
                                                                                                                                                                        3022,
                                                                                                                                                                        3023,
                                                                                                                                                                        3024,
                                                                                                                                                                        3025,
                                                                                                                                                                        3026,
                                                                                                                                                                        3027,
                                                                                                                                                                        3028,
                                                                                                                                                                        3029,
                                                                                                                                                                        3030,
                                                                                                                                                                        3031,
                                                                                                                                                                        3032,
                                                                                                                                                                        3033,
                                                                                                                                                                        3034,
                                                                                                                                                                        3035,
                                                                                                                                                                        3036,
                                                                                                                                                                        3037,
                                                                                                                                                                        3038,
                                                                                                                                                                        3039,
                                                                                                                                                                        3040,
                                                                                                                                                                        3041,
                                                                                                                                                                        3042,
                                                                                                                                                                        3043,
                                                                                                                                                                        3044,
                                                                                                                                                                        3045,
                                                                                                                                                                        3046,
                                                                                                                                                                        3047,
                                                                                                                                                                        3048,
                                                                                                                                                                        3049,
                                                                                                                                                                        3050,
                                                                                                                                                                        3051,
                                                                                                                                                                        3052,
                                                                                                                                                                        3053,
                                                                                                                                                                        3054,
                                                                                                                                                                        3055,
                                                                                                                                                                        3056,
                                                                                                                                                                        3057,
                                                                                                                                                                        3058,
                                                                                                                                                                        3059,
                                                                                                                                                                        3060,
                                                                                                                                                                        3061,
                                                                                                                                                                        3062,
                                                                                                                                                                        3063,
                                                                                                                                                                        3064,
                                                                                                                                                                        3065,
                                                                                                                                                                        3066,
                                                                                                                                                                        3067,
                                                                                                                                                                        3068,
                                                                                                                                                                        3069,
                                                                                                                                                                        3070,
                                                                                                                                                                        3071,
                                                                                                                                                                        3072,
                                                                                                                                                                        3073,
                                                                                                                                                                        3074,
                                                                                                                                                                        3075,
                                                                                                                                                                        3076,
                                                                                                                                                                        3077,
                                                                                                                                                                        3078,
                                                                                                                                                                        3079,
                                                                                                                                                                        3080,
                                                                                                                                                                        3081,
                                                                                                                                                                        3082,
                                                                                                                                                                        3083,
                                                                                                                                                                        3084,
                                                                                                                                                                        3085,
                                                                                                                                                                        3086,
                                                                                                                                                                        3087,
                                                                                                                                                                        3088,
                                                                                                                                                                        3089,
                                                                                                                                                                        3090,
                                                                                                                                                                        3091,
                                                                                                                                                                        3092,
                                                                                                                                                                        3093,
                                                                                                                                                                        3094,
                                                                                                                                                                        3095,
                                                                                                                                                                        3096,
                                                                                                                                                                        3097,
                                                                                                                                                                        3098,
                                                                                                                                                                        3099,
                                                                                                                                                                        3100,
                                                                                                                                                                        3101,
                                                                                                                                                                        3102,
                                                                                                                                                                        3103,
                                                                                                                                                                        3104,
                                                                                                                                                                        3105,
                                                                                                                                                                        3106,
                                                                                                                                                                        3107,
                                                                                                                                                                        3108,
                                                                                                                                                                        3109,
                                                                                                                                                                        3110,
                                                                                                                                                                        3111,
                                                                                                                                                                        3112,
                                                                                                                                                                        3113,
                                                                                                                                                                        3114,
                                                                                                                                                                        3115,
                                                                                                                                                                        3116,
                                                                                                                                                                        3117,
                                                                                                                                                                        3118,
                                                                                                                                                                        3119,
                                                                                                                                                                        3120,
                                                                                                                                                                        3121,
                                                                                                                                                                        3122,
                                                                                                                                                                        3123,
                                                                                                                                                                        3124,
                                                                                                                                                                        3125,
                                                                                                                                                                        3126,
                                                                                                                                                                        3127,
                                                                                                                                                                        3128,
                                                                                                                                                                        3129,
                                                                                                                                                                        3130,
                                                                                                                                                                        3131,
                                                                                                                                                                        3132,
                                                                                                                                                                        3133,
                                                                                                                                                                        3134,
                                                                                                                                                                        3135,
                                                                                                                                                                        3136,
                                                                                                                                                                        3137,
                                                                                                                                                                        3138,
                                                                                                                                                                        3139,
                                                                                                                                                                        3140,
                                                                                                                                                                        3141,
                                                                                                                                                                        3142,
                                                                                                                                                                        3143,
                                                                                                                                                                        3144,
                                                                                                                                                                        3145,
                                                                                                                                                                        3146,
                                                                                                                                                                        3147,
                                                                                                                                                                        3148,
                                                                                                                                                                        3149,
                                                                                                                                                                        3150,
                                                                                                                                                                        3151,
                                                                                                                                                                        3152,
                                                                                                                                                                        3153,
                                                                                                                                                                        3154,
                                                                                                                                                                        3155,
                                                                                                                                                                        3156,
                                                                                                                                                                        3157,
                                                                                                                                                                        3158,
                                                                                                                                                                        3159,
                                                                                                                                                                        3160,
                                                                                                                                                                        3161,
                                                                                                                                                                        3162,
                                                                                                                                                                        3163,
                                                                                                                                                                        3164,
                                                                                                                                                                        3165,
                                                                                                                                                                        3166,
                                                                                                                                                                        3167,
                                                                                                                                                                        3168,
                                                                                                                                                                        3169,
                                                                                                                                                                        3170,
                                                                                                                                                                        3171,
                                                                                                                                                                        3172,
                                                                                                                                                                        3173,
                                                                                                                                                                        3174,
                                                                                                                                                                        3175,
                                                                                                                                                                        3176,
                                                                                                                                                                        3177,
                                                                                                                                                                        3178,
                                                                                                                                                                        3179,
                                                                                                                                                                        3180,
                                                                                                                                                                        3181,
                                                                                                                                                                        3182,
                                                                                                                                                                        3183,
                                                                                                                                                                        3184,
                                                                                                                                                                        3185,
                                                                                                                                                                        3186,
                                                                                                                                                                        3187,
                                                                                                                                                                        3188,
                                                                                                                                                                        3189,
                                                                                                                                                                        3190,
                                                                                                                                                                        3191,
                                                                                                                                                                        3192,
                                                                                                                                                                        3193,
                                                                                                                                                                        3194,
                                                                                                                                                                        3195,
                                                                                                                                                                        3196,
                                                                                                                                                                        3197,
                                                                                                                                                                        3198,
                                                                                                                                                                        3199,
                                                                                                                                                                        3200,
                                                                                                                                                                        3201,
                                                                                                                                                                        3202,
                                                                                                                                                                        3203,
                                                                                                                                                                        3204,
                                                                                                                                                                        3205,
                                                                                                                                                                        3206,
                                                                                                                                                                        3207,
                                                                                                                                                                        3208,
                                                                                                                                                                        3209,
                                                                                                                                                                        3210,
                                                                                                                                                                        3211,
                                                                                                                                                                        3212,
                                                                                                                                                                        3213,
                                                                                                                                                                        3214,
                                                                                                                                                                        3215,
                                                                                                                                                                        3216,
                                                                                                                                                                        3217,
                                                                                                                                                                        3218,
                                                                                                                                                                        3219,
                                                                                                                                                                        3220,
                                                                                                                                                                        3221,
                                                                                                                                                                        3222,
                                                                                                                                                                        3223,
                                                                                                                                                                        3224,
                                                                                                                                                                        3225,
                                                                                                                                                                        3226,
                                                                                                                                                                        3227,
                                                                                                                                                                        3228,
                                                                                                                                                                        3229,
                                                                                                                                                                        3230,
                                                                                                                                                                        3231,
                                                                                                                                                                        3232,
                                                                                                                                                                        3233,
                                                                                                                                                                        3234,
                                                                                                                                                                        3235,
                                                                                                                                                                        3236,
                                                                                                                                                                        3237,
                                                                                                                                                                        3238,
                                                                                                                                                                        3239,
                                                                                                                                                                        3240,
                                                                                                                                                                        3241,
                                                                                                                                                                        3242,
                                                                                                                                                                        3243,
                                                                                                                                                                        3244,
                                                                                                                                                                        3245,
                                                                                                                                                                        3246,
                                                                                                                                                                        3247,
                                                                                                                                                                        3248,
                                                                                                                                                                        3249,
                                                                                                                                                                        3250,
                                                                                                                                                                        3251,
                                                                                                                                                                        3252,
                                                                                                                                                                        3253,
                                                                                                                                                                        3254,
                                                                                                                                                                        3255,
                                                                                                                                                                        3256,
                                                                                                                                                                        3257,
                                                                                                                                                                        3258,
                                                                                                                                                                        3259,
                                                                                                                                                                        3260,
                                                                                                                                                                        3261,
                                                                                                                                                                        3262,
                                                                                                                                                                        3263,
                                                                                                                                                                        3264,
                                                                                                                                                                        3265,
                                                                                                                                                                        3266,
                                                                                                                                                                        3267,
                                                                                                                                                                        3268,
                                                                                                                                                                        3269,
                                                                                                                                                                        3270,
                                                                                                                                                                        3271,
                                                                                                                                                                        3272,
                                                                                                                                                                        3273,
                                                                                                                                                                        3274,
                                                                                                                                                                        3275,
                                                                                                                                                                        3276,
                                                                                                                                                                        3277,
                                                                                                                                                                        3278,
                                                                                                                                                                        3279,
                                                                                                                                                                        3280,
                                                                                                                                                                        3281,
                                                                                                                                                                        3282,
                                                                                                                                                                        3283,
                                                                                                                                                                        3284,
                                                                                                                                                                        3285,
                                                                                                                                                                        3286,
                                                                                                                                                                        3287,
                                                                                                                                                                        3288,
                                                                                                                                                                        3289,
                                                                                                                                                                        3290,
                                                                                                                                                                        3291,
                                                                                                                                                                        3292,
                                                                                                                                                                        3293,
                                                                                                                                                                        3294,
                                                                                                                                                                        3295,
                                                                                                                                                                        3296,
                                                                                                                                                                        3297,
                                                                                                                                                                        3298,
                                                                                                                                                                        3299,
                                                                                                                                                                        3300,
                                                                                                                                                                        3301,
                                                                                                                                                                        3302,
                                                                                                                                                                        3303,
                                                                                                                                                                        3304,
                                                                                                                                                                        3305,
                                                                                                                                                                        3306,
                                                                                                                                                                        3307,
                                                                                                                                                                        3308,
                                                                                                                                                                        3309,
                                                                                                                                                                        3310,
                                                                                                                                                                        3311,
                                                                                                                                                                        3312,
                                                                                                                                                                        3313,
                                                                                                                                                                        3314,
                                                                                                                                                                        3315,
                                                                                                                                                                        3316,
                                                                                                                                                                        3317,
                                                                                                                                                                        3318,
                                                                                                                                                                        3319,
                                                                                                                                                                        3320,
                                                                                                                                                                        3321,
                                                                                                                                                                        3322,
                                                                                                                                                                        3323,
                                                                                                                                                                        3324,
                                                                                                                                                                        3325,
                                                                                                                                                                        3326,
                                                                                                                                                                        3327,
                                                                                                                                                                        3328,
                                                                                                                                                                        3329,
                                                                                                                                                                        3330,
                                                                                                                                                                        3331,
                                                                                                                                                                        3332,
                                                                                                                                                                        3333,
                                                                                                                                                                        3334,
                                                                                                                                                                        3335,
                                                                                                                                                                        3336,
                                                                                                                                                                        3337,
                                                                                                                                                                        3338,
                                                                                                                                                                        3339,
                                                                                                                                                                        3340,
                                                                                                                                                                        3341,
                                                                                                                                                                        3342,
                                                                                                                                                                        3343,
                                                                                                                                                                        3344,
                                                                                                                                                                        3345,
                                                                                                                                                                        3346,
                                                                                                                                                                        3347,
                                                                                                                                                                        3348,
                                                                                                                                                                        3349,
                                                                                                                                                                        3350,
                                                                                                                                                                        3351,
                                                                                                                                                                        3352,
                                                                                                                                                                        3353,
                                                                                                                                                                        3354,
                                                                                                                                                                        3355,
                                                                                                                                                                        3356,
                                                                                                                                                                        3357,
                                                                                                                                                                        3358,
                                                                                                                                                                        3359,
                                                                                                                                                                        3360,
                                                                                                                                                                        3361,
                                                                                                                                                                        3362,
                                                                                                                                                                        3363,
                                                                                                                                                                        3364,
                                                                                                                                                                        3365,
                                                                                                                                                                        3366,
                                                                                                                                                                        3367,
                                                                                                                                                                        3368,
                                                                                                                                                                        3369,
                                                                                                                                                                        3370,
                                                                                                                                                                        3371,
                                                                                                                                                                        3372,
                                                                                                                                                                        3373,
                                                                                                                                                                        3374,
                                                                                                                                                                        3375,
                                                                                                                                                                        3376,
                                                                                                                                                                        3377,
                                                                                                                                                                        3378,
                                                                                                                                                                        3379,
                                                                                                                                                                        3380,
                                                                                                                                                                        3381,
                                                                                                                                                                        3382,
                                                                                                                                                                        3383,
                                                                                                                                                                        3384,
                                                                                                                                                                        3385,
                                                                                                                                                                        3386,
                                                                                                                                                                        3387,
                                                                                                                                                                        3388,
                                                                                                                                                                        3389,
                                                                                                                                                                        3390,
                                                                                                                                                                        3391,
                                                                                                                                                                        3392,
                                                                                                                                                                        3393,
                                                                                                                                                                        3394,
                                                                                                                                                                        3395,
                                                                                                                                                                        3396,
                                                                                                                                                                        3397,
                                                                                                                                                                        3398,
                                                                                                                                                                        3399,
                                                                                                                                                                        3400,
                                                                                                                                                                        3401,
                                                                                                                                                                        3402,
                                                                                                                                                                        3403,
                                                                                                                                                                        3404,
                                                                                                                                                                        3405,
                                                                                                                                                                        3406,
                                                                                                                                                                        3407,
                                                                                                                                                                        3408,
                                                                                                                                                                        3409,
                                                                                                                                                                        3410,
                                                                                                                                                                        3411,
                                                                                                                                                                        3412,
                                                                                                                                                                        3413,
                                                                                                                                                                        3414,
                                                                                                                                                                        3415,
                                                                                                                                                                        3416,
                                                                                                                                                                        3417,
                                                                                                                                                                        3418,
                                                                                                                                                                        3419,
                                                                                                                                                                        3420,
                                                                                                                                                                        3421,
                                                                                                                                                                        3422,
                                                                                                                                                                        3423,
                                                                                                                                                                        3424,
                                                                                                                                                                        3425,
                                                                                                                                                                        3426,
                                                                                                                                                                        3427,
                                                                                                                                                                        3428,
                                                                                                                                                                        3429,
                                                                                                                                                                        3430,
                                                                                                                                                                        3431,
                                                                                                                                                                        3432,
                                                                                                                                                                        3433,
                                                                                                                                                                        3434,
                                                                                                                                                                        3435,
                                                                                                                                                                        3436,
                                                                                                                                                                        3437,
                                                                                                                                                                        3438,
                                                                                                                                                                        3439,
                                                                                                                                                                        3440,
                                                                                                                                                                        3441,
                                                                                                                                                                        3442,
                                                                                                                                                                        3443,
                                                                                                                                                                        3444,
                                                                                                                                                                        3445,
                                                                                                                                                                        3446,
                                                                                                                                                                        3447,
                                                                                                                                                                        3448,
                                                                                                                                                                        3449,
                                                                                                                                                                        3450,
                                                                                                                                                                        3451,
                                                                                                                                                                        3452,
                                                                                                                                                                        3453,
                                                                                                                                                                        3454,
                                                                                                                                                                        3455,
                                                                                                                                                                        3456,
                                                                                                                                                                        3457,
                                                                                                                                                                        3458,
                                                                                                                                                                        3459,
                                                                                                                                                                        3460,
                                                                                                                                                                        3461,
                                                                                                                                                                        3462,
                                                                                                                                                                        3463,
                                                                                                                                                                        3464,
                                                                                                                                                                        3465,
                                                                                                                                                                        3466,
                                                                                                                                                                        3467,
                                                                                                                                                                        3468,
                                                                                                                                                                        3469,
                                                                                                                                                                        3470,
                                                                                                                                                                        3471,
                                                                                                                                                                        3472,
                                                                                                                                                                        3473,
                                                                                                                                                                        3474,
                                                                                                                                                                        3475,
                                                                                                                                                                        3476,
                                                                                                                                                                        3477,
                                                                                                                                                                        3478,
                                                                                                                                                                        3479,
                                                                                                                                                                        3480,
                                                                                                                                                                        3481,
                                                                                                                                                                        3482,
                                                                                                                                                                        3483,
                                                                                                                                                                        3484,
                                                                                                                                                                        3485,
                                                                                                                                                                        3486,
                                                                                                                                                                        3487,
                                                                                                                                                                        3488,
                                                                                                                                                                        3489,
                                                                                                                                                                        3490,
                                                                                                                                                                        3491,
                                                                                                                                                                        3492,
                                                                                                                                                                        3493,
                                                                                                                                                                        3494,
                                                                                                                                                                        3495,
                                                                                                                                                                        3496,
                                                                                                                                                                        3497,
                                                                                                                                                                        3498,
                                                                                                                                                                        3499,
                                                                                                                                                                        3500,
                                                                                                                                                                        3501,
                                                                                                                                                                        3502,
                                                                                                                                                                        3503,
                                                                                                                                                                        3504,
                                                                                                                                                                        3505,
                                                                                                                                                                        3506,
                                                                                                                                                                        3507,
                                                                                                                                                                        3508,
                                                                                                                                                                        3509,
                                                                                                                                                                        3510,
                                                                                                                                                                        3511,
                                                                                                                                                                        3512,
                                                                                                                                                                        3513,
                                                                                                                                                                        3514,
                                                                                                                                                                        3515,
                                                                                                                                                                        3516,
                                                                                                                                                                        3517,
                                                                                                                                                                        3518,
                                                                                                                                                                        3519,
                                                                                                                                                                        3520,
                                                                                                                                                                        3521,
                                                                                                                                                                        3522,
                                                                                                                                                                        3523,
                                                                                                                                                                        3524,
                                                                                                                                                                        3525,
                                                                                                                                                                        3526,
                                                                                                                                                                        3527,
                                                                                                                                                                        3528,
                                                                                                                                                                        3529,
                                                                                                                                                                        3530,
                                                                                                                                                                        3531,
                                                                                                                                                                        3532,
                                                                                                                                                                        3533,
                                                                                                                                                                        3534,
                                                                                                                                                                        3535,
                                                                                                                                                                        3536,
                                                                                                                                                                        3537,
                                                                                                                                                                        3538,
                                                                                                                                                                        3539,
                                                                                                                                                                        3540,
                                                                                                                                                                        3541,
                                                                                                                                                                        3542,
                                                                                                                                                                        3543,
                                                                                                                                                                        3544,
                                                                                                                                                                        3545,
                                                                                                                                                                        3546,
                                                                                                                                                                        3547,
                                                                                                                                                                        3548,
                                                                                                                                                                        3549,
                                                                                                                                                                        3550,
                                                                                                                                                                        3551,
                                                                                                                                                                        3552,
                                                                                                                                                                        3553,
                                                                                                                                                                        3554,
                                                                                                                                                                        3555,
                                                                                                                                                                        3556,
                                                                                                                                                                        3557,
                                                                                                                                                                        3558,
                                                                                                                                                                        3559,
                                                                                                                                                                        3560,
                                                                                                                                                                        3561,
                                                                                                                                                                        3562,
                                                                                                                                                                        3563,
                                                                                                                                                                        3564,
                                                                                                                                                                        3565,
                                                                                                                                                                        3566,
                                                                                                                                                                        3567,
                                                                                                                                                                        3568,
                                                                                                                                                                        3569,
                                                                                                                                                                        3570,
                                                                                                                                                                        3571,
                                                                                                                                                                        3572,
                                                                                                                                                                        3573,
                                                                                                                                                                        3574,
                                                                                                                                                                        3575,
                                                                                                                                                                        3576,
                                                                                                                                                                        3577,
                                                                                                                                                                        3578,
                                                                                                                                                                        3579,
                                                                                                                                                                        3580,
                                                                                                                                                                        3581,
                                                                                                                                                                        3582,
                                                                                                                                                                        3583,
                                                                                                                                                                        3584,
                                                                                                                                                                        3585,
                                                                                                                                                                        3586,
                                                                                                                                                                        3587,
                                                                                                                                                                        3588,
                                                                                                                                                                        3589,
                                                                                                                                                                        3590,
                                                                                                                                                                        3591,
                                                                                                                                                                        3592,
                                                                                                                                                                        3593,
                                                                                                                                                                        3594,
                                                                                                                                                                        3595,
                                                                                                                                                                        3596,
                                                                                                                                                                        3597,
                                                                                                                                                                        3598,
                                                                                                                                                                        3599,
                                                                                                                                                                        3600,
                                                                                                                                                                        3601,
                                                                                                                                                                        3602,
                                                                                                                                                                        3603,
                                                                                                                                                                        3604,
                                                                                                                                                                        3605,
                                                                                                                                                                        3606,
                                                                                                                                                                        3607,
                                                                                                                                                                        3608,
                                                                                                                                                                        3609,
                                                                                                                                                                        3610,
                                                                                                                                                                        3611,
                                                                                                                                                                        3612,
                                                                                                                                                                        3613,
                                                                                                                                                                        3614,
                                                                                                                                                                        3615,
                                                                                                                                                                        3616,
                                                                                                                                                                        3617,
                                                                                                                                                                        3618,
                                                                                                                                                                        3619,
                                                                                                                                                                        3620,
                                                                                                                                                                        3621,
                                                                                                                                                                        3622,
                                                                                                                                                                        3623,
                                                                                                                                                                        3624,
                                                                                                                                                                        3625,
                                                                                                                                                                        3626,
                                                                                                                                                                        3627,
                                                                                                                                                                        3628,
                                                                                                                                                                        3629,
                                                                                                                                                                        3630,
                                                                                                                                                                        3631,
                                                                                                                                                                        3632,
                                                                                                                                                                        3633,
                                                                                                                                                                        3634,
                                                                                                                                                                        3635,
                                                                                                                                                                        3636,
                                                                                                                                                                        3637,
                                                                                                                                                                        3638,
                                                                                                                                                                        3639,
                                                                                                                                                                        3640,
                                                                                                                                                                        3641,
                                                                                                                                                                        3642,
                                                                                                                                                                        3643,
                                                                                                                                                                        3644,
                                                                                                                                                                        3645,
                                                                                                                                                                        3646,
                                                                                                                                                                        3647,
                                                                                                                                                                        3648,
                                                                                                                                                                        3649,
                                                                                                                                                                        3650,
                                                                                                                                                                        3651,
                                                                                                                                                                        3652,
                                                                                                                                                                        3653,
                                                                                                                                                                        3654,
                                                                                                                                                                        3655,
                                                                                                                                                                        3656,
                                                                                                                                                                        3657,
                                                                                                                                                                        3658,
                                                                                                                                                                        3659,
                                                                                                                                                                        3660,
                                                                                                                                                                        3661,
                                                                                                                                                                        3662,
                                                                                                                                                                        3663,
                                                                                                                                                                        3664,
                                                                                                                                                                        3665,
                                                                                                                                                                        3666,
                                                                                                                                                                        3667,
                                                                                                                                                                        3668,
                                                                                                                                                                        3669,
                                                                                                                                                                        3670,
                                                                                                                                                                        3671,
                                                                                                                                                                        3672,
                                                                                                                                                                        3673,
                                                                                                                                                                        3674,
                                                                                                                                                                        3675,
                                                                                                                                                                        3676,
                                                                                                                                                                        3677,
                                                                                                                                                                        3678,
                                                                                                                                                                        3679,
                                                                                                                                                                        3680,
                                                                                                                                                                        3681,
                                                                                                                                                                        3682,
                                                                                                                                                                        3683,
                                                                                                                                                                        3684,
                                                                                                                                                                        3685,
                                                                                                                                                                        3686,
                                                                                                                                                                        3687,
                                                                                                                                                                        3688,
                                                                                                                                                                        3689,
                                                                                                                                                                        3690,
                                                                                                                                                                        3691,
                                                                                                                                                                        3692,
                                                                                                                                                                        3693,
                                                                                                                                                                        3694,
                                                                                                                                                                        3695,
                                                                                                                                                                        3696,
                                                                                                                                                                        3697,
                                                                                                                                                                        3698,
                                                                                                                                                                        3699,
                                                                                                                                                                        3700,
                                                                                                                                                                        3701,
                                                                                                                                                                        3702,
                                                                                                                                                                        3703,
                                                                                                                                                                        3704,
                                                                                                                                                                        3705,
                                                                                                                                                                        3706,
                                                                                                                                                                        3707,
                                                                                                                                                                        3708,
                                                                                                                                                                        3709,
                                                                                                                                                                        3710,
                                                                                                                                                                        3711,
                                                                                                                                                                        3712,
                                                                                                                                                                        3713,
                                                                                                                                                                        3714,
                                                                                                                                                                        3715,
                                                                                                                                                                        3716,
                                                                                                                                                                        3717,
                                                                                                                                                                        3718,
                                                                                                                                                                        3719,
                                                                                                                                                                        3720,
                                                                                                                                                                        3721,
                                                                                                                                                                        3722,
                                                                                                                                                                        3723,
                                                                                                                                                                        3724,
                                                                                                                                                                        3725,
                                                                                                                                                                        3726,
                                                                                                                                                                        3727,
                                                                                                                                                                        3728,
                                                                                                                                                                        3729,
                                                                                                                                                                        3730,
                                                                                                                                                                        3731,
                                                                                                                                                                        3732,
                                                                                                                                                                        3733,
                                                                                                                                                                        3734,
                                                                                                                                                                        3735,
                                                                                                                                                                        3736,
                                                                                                                                                                        3737,
                                                                                                                                                                        3738,
                                                                                                                                                                        3739,
                                                                                                                                                                        3740,
                                                                                                                                                                        3741,
                                                                                                                                                                        3742,
                                                                                                                                                                        3743,
                                                                                                                                                                        3744,
                                                                                                                                                                        3745,
                                                                                                                                                                        3746,
                                                                                                                                                                        3747,
                                                                                                                                                                        3748,
                                                                                                                                                                        3749,
                                                                                                                                                                        3750,
                                                                                                                                                                        3751,
                                                                                                                                                                        3752,
                                                                                                                                                                        3753,
                                                                                                                                                                        3754,
                                                                                                                                                                        3755,
                                                                                                                                                                        3756,
                                                                                                                                                                        3757,
                                                                                                                                                                        3758,
                                                                                                                                                                        3759,
                                                                                                                                                                        3760,
                                                                                                                                                                        3761,
                                                                                                                                                                        3762,
                                                                                                                                                                        3763,
                                                                                                                                                                        3764,
                                                                                                                                                                        3765,
                                                                                                                                                                        3766,
                                                                                                                                                                        3767,
                                                                                                                                                                        3768,
                                                                                                                                                                        3769,
                                                                                                                                                                        3770,
                                                                                                                                                                        3771,
                                                                                                                                                                        3772,
                                                                                                                                                                        3773,
                                                                                                                                                                        3774,
                                                                                                                                                                        3775,
                                                                                                                                                                        3776,
                                                                                                                                                                        3777,
                                                                                                                                                                        3778,
                                                                                                                                                                        3779,
                                                                                                                                                                        3780,
                                                                                                                                                                        3781,
                                                                                                                                                                        3782,
                                                                                                                                                                        3783,
                                                                                                                                                                        3784,
                                                                                                                                                                        3785,
                                                                                                                                                                        3786,
                                                                                                                                                                        3787,
                                                                                                                                                                        3788,
                                                                                                                                                                        3789,
                                                                                                                                                                        3790,
                                                                                                                                                                        3791,
                                                                                                                                                                        3792,
                                                                                                                                                                        3793,
                                                                                                                                                                        3794,
                                                                                                                                                                        3795,
                                                                                                                                                                        3796,
                                                                                                                                                                        3797,
                                                                                                                                                                        3798,
                                                                                                                                                                        3799,
                                                                                                                                                                        3800,
                                                                                                                                                                        3801,
                                                                                                                                                                        3802,
                                                                                                                                                                        3803,
                                                                                                                                                                        3804,
                                                                                                                                                                        3805,
                                                                                                                                                                        3806,
                                                                                                                                                                        3807,
                                                                                                                                                                        3808,
                                                                                                                                                                        3809,
                                                                                                                                                                        3810,
                                                                                                                                                                        3811,
                                                                                                                                                                        3812,
                                                                                                                                                                        3813,
                                                                                                                                                                        3814,
                                                                                                                                                                        3815,
                                                                                                                                                                        3816,
                                                                                                                                                                        3817,
                                                                                                                                                                        3818,
                                                                                                                                                                        3819,
                                                                                                                                                                        3820,
                                                                                                                                                                        3821,
                                                                                                                                                                        3822,
                                                                                                                                                                        3823,
                                                                                                                                                                        3824,
                                                                                                                                                                        3825,
                                                                                                                                                                        3826,
                                                                                                                                                                        3827,
                                                                                                                                                                        3828,
                                                                                                                                                                        3829,
                                                                                                                                                                        3830,
                                                                                                                                                                        3831,
                                                                                                                                                                        3832,
                                                                                                                                                                        3833,
                                                                                                                                                                        3834,
                                                                                                                                                                        3835,
                                                                                                                                                                        3836,
                                                                                                                                                                        3837,
                                                                                                                                                                        3838,
                                                                                                                                                                        3839,
                                                                                                                                                                        3840,
                                                                                                                                                                        3841,
                                                                                                                                                                        3842,
                                                                                                                                                                        3843,
                                                                                                                                                                        3844,
                                                                                                                                                                        3845,
                                                                                                                                                                        3846,
                                                                                                                                                                        3847,
                                                                                                                                                                        3848,
                                                                                                                                                                        3849,
                                                                                                                                                                        3850,
                                                                                                                                                                        3851,
                                                                                                                                                                        3852,
                                                                                                                                                                        3853,
                                                                                                                                                                        3854,
                                                                                                                                                                        3855,
                                                                                                                                                                        3856,
                                                                                                                                                                        3857,
                                                                                                                                                                        3858,
                                                                                                                                                                        3859,
                                                                                                                                                                        3860,
                                                                                                                                                                        3861,
                                                                                                                                                                        3862,
                                                                                                                                                                        3863,
                                                                                                                                                                        3864,
                                                                                                                                                                        3865,
                                                                                                                                                                        3866,
                                                                                                                                                                        3867,
                                                                                                                                                                        3868,
                                                                                                                                                                        3869,
                                                                                                                                                                        3870,
                                                                                                                                                                        3871,
                                                                                                                                                                        3872,
                                                                                                                                                                        3873,
                                                                                                                                                                        3874,
                                                                                                                                                                        3875,
                                                                                                                                                                        3876,
                                                                                                                                                                        3877,
                                                                                                                                                                        3878,
                                                                                                                                                                        3879,
                                                                                                                                                                        3880,
                                                                                                                                                                        3881,
                                                                                                                                                                        3882,
                                                                                                                                                                        3883,
                                                                                                                                                                        3884,
                                                                                                                                                                        3885,
                                                                                                                                                                        3886,
                                                                                                                                                                        3887,
                                                                                                                                                                        3888,
                                                                                                                                                                        3889,
                                                                                                                                                                        3890,
                                                                                                                                                                        3891,
                                                                                                                                                                        3892,
                                                                                                                                                                        3893,
                                                                                                                                                                        3894,
                                                                                                                                                                        3895,
                                                                                                                                                                        3896,
                                                                                                                                                                        3897,
                                                                                                                                                                        3898,
                                                                                                                                                                        3899,
                                                                                                                                                                        3900,
                                                                                                                                                                        3901,
                                                                                                                                                                        3902,
                                                                                                                                                                        3903,
                                                                                                                                                                        3904,
                                                                                                                                                                        3905,
                                                                                                                                                                        3906,
                                                                                                                                                                        3907,
                                                                                                                                                                        3908,
                                                                                                                                                                        3909,
                                                                                                                                                                        3910,
                                                                                                                                                                        3911,
                                                                                                                                                                        3912,
                                                                                                                                                                        3913,
                                                                                                                                                                        3914,
                                                                                                                                                                        3915,
                                                                                                                                                                        3916,
                                                                                                                                                                        3917,
                                                                                                                                                                        3918,
                                                                                                                                                                        3919,
                                                                                                                                                                        3920,
                                                                                                                                                                        3921,
                                                                                                                                                                        3922,
                                                                                                                                                                        3923,
                                                                                                                                                                        3924,
                                                                                                                                                                        3925,
                                                                                                                                                                        3926,
                                                                                                                                                                        3927,
                                                                                                                                                                        3928,
                                                                                                                                                                        3929,
                                                                                                                                                                        3930,
                                                                                                                                                                        3931,
                                                                                                                                                                        3932,
                                                                                                                                                                        3933,
                                                                                                                                                                        3934,
                                                                                                                                                                        3935,
                                                                                                                                                                        3936,
                                                                                                                                                                        3937,
                                                                                                                                                                        3938,
                                                                                                                                                                        3939,
                                                                                                                                                                        3940,
                                                                                                                                                                        3941,
                                                                                                                                                                        3942,
                                                                                                                                                                        3943,
                                                                                                                                                                        3944,
                                                                                                                                                                        3945,
                                                                                                                                                                        3946,
                                                                                                                                                                        3947,
                                                                                                                                                                        3948,
                                                                                                                                                                        3949,
                                                                                                                                                                        3950,
                                                                                                                                                                        3951,
                                                                                                                                                                        3952,
                                                                                                                                                                        3953,
                                                                                                                                                                        3954,
                                                                                                                                                                        3955,
                                                                                                                                                                        3956,
                                                                                                                                                                        3957,
                                                                                                                                                                        3958,
                                                                                                                                                                        3959,
                                                                                                                                                                        3960,
                                                                                                                                                                        3961,
                                                                                                                                                                        3962,
                                                                                                                                                                        3963,
                                                                                                                                                                        3964,
                                                                                                                                                                        3965,
                                                                                                                                                                        3966,
                                                                                                                                                                        3967,
                                                                                                                                                                        3968,
                                                                                                                                                                        3969,
                                                                                                                                                                        3970,
                                                                                                                                                                        3971,
                                                                                                                                                                        3972,
                                                                                                                                                                        3973,
                                                                                                                                                                        3974,
                                                                                                                                                                        3975,
                                                                                                                                                                        3976,
                                                                                                                                                                        3977,
                                                                                                                                                                        3978,
                                                                                                                                                                        3979,
                                                                                                                                                                        3980,
                                                                                                                                                                        3981,
                                                                                                                                                                        3982,
                                                                                                                                                                        3983,
                                                                                                                                                                        3984,
                                                                                                                                                                        3985,
                                                                                                                                                                        3986,
                                                                                                                                                                        3987,
                                                                                                                                                                        3988,
                                                                                                                                                                        3989,
                                                                                                                                                                        3990,
                                                                                                                                                                        3991,
                                                                                                                                                                        3992,
                                                                                                                                                                        3993,
                                                                                                                                                                        3994,
                                                                                                                                                                        3995,
                                                                                                                                                                        3996,
                                                                                                                                                                        3997,
                                                                                                                                                                        3998,
                                                                                                                                                                        3999,
                                                                                                                                                                        4000,
                                                                                                                                                                        4001,
                                                                                                                                                                        4002,
                                                                                                                                                                        4003,
                                                                                                                                                                        4004,
                                                                                                                                                                        4005,
                                                                                                                                                                        4006,
                                                                                                                                                                        4007,
                                                                                                                                                                        4008,
                                                                                                                                                                        4009,
                                                                                                                                                                        4010,
                                                                                                                                                                        4011,
                                                                                                                                                                        4012,
                                                                                                                                                                        4013,
                                                                                                                                                                        4014,
                                                                                                                                                                        4015,
                                                                                                                                                                        4016,
                                                                                                                                                                        4017,
                                                                                                                                                                        4018,
                                                                                                                                                                        4019,
                                                                                                                                                                        4020,
                                                                                                                                                                        4021,
                                                                                                                                                                        4022,
                                                                                                                                                                        4023,
                                                                                                                                                                        4024,
                                                                                                                                                                        4025,
                                                                                                                                                                        4026,
                                                                                                                                                                        4027,
                                                                                                                                                                        4028,
                                                                                                                                                                        4029,
                                                                                                                                                                        4030,
                                                                                                                                                                        4031,
                                                                                                                                                                        4032,
                                                                                                                                                                        4033,
                                                                                                                                                                        4034,
                                                                                                                                                                        4035,
                                                                                                                                                                        4036,
                                                                                                                                                                        4037,
                                                                                                                                                                        4038,
                                                                                                                                                                        4039,
                                                                                                                                                                        4040,
                                                                                                                                                                        4041,
                                                                                                                                                                        4042,
                                                                                                                                                                        4043,
                                                                                                                                                                        4044,
                                                                                                                                                                        4045,
                                                                                                                                                                        4046,
                                                                                                                                                                        4047,
                                                                                                                                                                        4048,
                                                                                                                                                                        4049,
                                                                                                                                                                        4050,
                                                                                                                                                                        4051,
                                                                                                                                                                        4052,
                                                                                                                                                                        4053,
                                                                                                                                                                        4054,
                                                                                                                                                                        4055,
                                                                                                                                                                        4056,
                                                                                                                                                                        4057,
                                                                                                                                                                        4058,
                                                                                                                                                                        4059,
                                                                                                                                                                        4060,
                                                                                                                                                                        4061,
                                                                                                                                                                        4062,
                                                                                                                                                                        4063,
                                                                                                                                                                        4064,
                                                                                                                                                                        4065,
                                                                                                                                                                        4066,
                                                                                                                                                                        4067,
                                                                                                                                                                        4068,
                                                                                                                                                                        4069,
                                                                                                                                                                        4070,
                                                                                                                                                                        4071,
                                                                                                                                                                        4072,
                                                                                                                                                                        4073,
                                                                                                                                                                        4074,
                                                                                                                                                                        4075,
                                                                                                                                                                        4076,
                                                                                                                                                                        4077,
                                                                                                                                                                        4078,
                                                                                                                                                                        4079,
                                                                                                                                                                        4080,
                                                                                                                                                                        4081,
                                                                                                                                                                        4082,
                                                                                                                                                                        4083,
                                                                                                                                                                        4084,
                                                                                                                                                                        4085,
                                                                                                                                                                        4086,
                                                                                                                                                                        4087,
                                                                                                                                                                        4088,
                                                                                                                                                                        4089,
                                                                                                                                                                        4090,
                                                                                                                                                                        4091,
                                                                                                                                                                        4092,
                                                                                                                                                                        4093,
                                                                                                                                                                        4094,
                                                                                                                                                                        4095,
                                                                                                                                                                        4096,
                                                                                                                                                                        4097,
                                                                                                                                                                        4098,
                                                                                                                                                                        4099,
                                                                                                                                                                        4100,
                                                                                                                                                                        4101,
                                                                                                                                                                        4102,
                                                                                                                                                                        4103,
                                                                                                                                                                        4104,
                                                                                                                                                                        4105,
                                                                                                                                                                        4106,
                                                                                                                                                                        4107,
                                                                                                                                                                        4108,
                                                                                                                                                                        4109,
                                                                                                                                                                        4110,
                                                                                                                                                                        4111,
                                                                                                                                                                        4112,
                                                                                                                                                                        4113,
                                                                                                                                                                        4114,
                                                                                                                                                                        4115,
                                                                                                                                                                        4116,
                                                                                                                                                                        4117,
                                                                                                                                                                        4118,
                                                                                                                                                                        4119,
                                                                                                                                                                        4120,
                                                                                                                                                                        4121,
                                                                                                                                                                        4122,
                                                                                                                                                                        4123,
                                                                                                                                                                        4124,
                                                                                                                                                                        4125,
                                                                                                                                                                        4126,
                                                                                                                                                                        4127,
                                                                                                                                                                        4128,
                                                                                                                                                                        4129,
                                                                                                                                                                        4130,
                                                                                                                                                                        4131,
                                                                                                                                                                        4132,
                                                                                                                                                                        4133,
                                                                                                                                                                        4134,
                                                                                                                                                                        4135,
                                                                                                                                                                        4136,
                                                                                                                                                                        4137,
                                                                                                                                                                        4138,
                                                                                                                                                                        4139,
                                                                                                                                                                        4140,
                                                                                                                                                                        4141,
                                                                                                                                                                        4142,
                                                                                                                                                                        4143,
                                                                                                                                                                        4144,
                                                                                                                                                                        4145,
                                                                                                                                                                        4146,
                                                                                                                                                                        4147,
                                                                                                                                                                        4148,
                                                                                                                                                                        4149,
                                                                                                                                                                        4150,
                                                                                                                                                                        4151,
                                                                                                                                                                        4152,
                                                                                                                                                                        4153,
                                                                                                                                                                        4154,
                                                                                                                                                                        4155,
                                                                                                                                                                        4156,
                                                                                                                                                                        4157,
                                                                                                                                                                        4158,
                                                                                                                                                                        4159,
                                                                                                                                                                        4160,
                                                                                                                                                                        4161,
                                                                                                                                                                        4162,
                                                                                                                                                                        4163,
                                                                                                                                                                        4164,
                                                                                                                                                                        4165,
                                                                                                                                                                        4166,
                                                                                                                                                                        4167,
                                                                                                                                                                        4168,
                                                                                                                                                                        4169,
                                                                                                                                                                        4170,
                                                                                                                                                                        4171,
                                                                                                                                                                        4172,
                                                                                                                                                                        4173,
                                                                                                                                                                        4174,
                                                                                                                                                                        4175,
                                                                                                                                                                        4176,
                                                                                                                                                                        4177,
                                                                                                                                                                        4178,
                                                                                                                                                                        4179,
                                                                                                                                                                        4180,
                                                                                                                                                                        4181,
                                                                                                                                                                        4182,
                                                                                                                                                                        4183,
                                                                                                                                                                        4184,
                                                                                                                                                                        4185,
                                                                                                                                                                        4186,
                                                                                                                                                                        4187,
                                                                                                                                                                        4188,
                                                                                                                                                                        4189,
                                                                                                                                                                        4190,
                                                                                                                                                                        4191,
                                                                                                                                                                        4192,
                                                                                                                                                                        4193,
                                                                                                                                                                        4194,
                                                                                                                                                                        4195,
                                                                                                                                                                        4196,
                                                                                                                                                                        4197,
                                                                                                                                                                        4198,
                                                                                                                                                                        4199,
                                                                                                                                                                        4200,
                                                                                                                                                                        4201,
                                                                                                                                                                        4202,
                                                                                                                                                                        4203,
                                                                                                                                                                        4204,
                                                                                                                                                                        4205,
                                                                                                                                                                        4206,
                                                                                                                                                                        4207,
                                                                                                                                                                        4208,
                                                                                                                                                                        4209,
                                                                                                                                                                        4210,
                                                                                                                                                                        4211,
                                                                                                                                                                        4212,
                                                                                                                                                                        4213,
                                                                                                                                                                        4214,
                                                                                                                                                                        4215,
                                                                                                                                                                        4216,
                                                                                                                                                                        4217,
                                                                                                                                                                        4218,
                                                                                                                                                                        4219,
                                                                                                                                                                        4220,
                                                                                                                                                                        4221,
                                                                                                                                                                        4222,
                                                                                                                                                                        4223,
                                                                                                                                                                        4224,
                                                                                                                                                                        4225,
                                                                                                                                                                        4226,
                                                                                                                                                                        4227,
                                                                                                                                                                        4228,
                                                                                                                                                                        4229,
                                                                                                                                                                        4230,
                                                                                                                                                                        4231,
                                                                                                                                                                        4232,
                                                                                                                                                                        4233,
                                                                                                                                                                        4234,
                                                                                                                                                                        4235,
                                                                                                                                                                        4236,
                                                                                                                                                                        4237,
                                                                                                                                                                        4238,
                                                                                                                                                                        4239,
                                                                                                                                                                        4240,
                                                                                                                                                                        4241,
                                                                                                                                                                        4242,
                                                                                                                                                                        4243,
                                                                                                                                                                        4244,
                                                                                                                                                                        4245,
                                                                                                                                                                        4246,
                                                                                                                                                                        4247,
                                                                                                                                                                        4248,
                                                                                                                                                                        4249,
                                                                                                                                                                        4250,
                                                                                                                                                                        4251,
                                                                                                                                                                        4252,
                                                                                                                                                                        4253,
                                                                                                                                                                        4254,
                                                                                                                                                                        4255,
                                                                                                                                                                        4256,
                                                                                                                                                                        4257,
                                                                                                                                                                        4258,
                                                                                                                                                                        4259,
                                                                                                                                                                        4260,
                                                                                                                                                                        4261,
                                                                                                                                                                        4262,
                                                                                                                                                                        4263,
                                                                                                                                                                        4264,
                                                                                                                                                                        4265,
                                                                                                                                                                        4266,
                                                                                                                                                                        4267,
                                                                                                                                                                        4268,
                                                                                                                                                                        4269,
                                                                                                                                                                        4270,
                                                                                                                                                                        4271,
                                                                                                                                                                        4272,
                                                                                                                                                                        4273,
                                                                                                                                                                        4274,
                                                                                                                                                                        4275,
                                                                                                                                                                        4276,
                                                                                                                                                                        4277,
                                                                                                                                                                        4278,
                                                                                                                                                                        4279,
                                                                                                                                                                        4280,
                                                                                                                                                                        4281,
                                                                                                                                                                        4282,
                                                                                                                                                                        4283,
                                                                                                                                                                        4284,
                                                                                                                                                                        4285,
                                                                                                                                                                        4286,
                                                                                                                                                                        4287,
                                                                                                                                                                        4288,
                                                                                                                                                                        4289,
                                                                                                                                                                        4290,
                                                                                                                                                                        4291,
                                                                                                                                                                        4292,
                                                                                                                                                                        4293,
                                                                                                                                                                        4294,
                                                                                                                                                                        4295,
                                                                                                                                                                        4296,
                                                                                                                                                                        4297,
                                                                                                                                                                        4298,
                                                                                                                                                                        4299,
                                                                                                                                                                        4300,
                                                                                                                                                                        4301,
                                                                                                                                                                        4302,
                                                                                                                                                                        4303,
                                                                                                                                                                        4304,
                                                                                                                                                                        4305,
                                                                                                                                                                        4306,
                                                                                                                                                                        4307,
                                                                                                                                                                        4308,
                                                                                                                                                                        4309,
                                                                                                                                                                        4310,
                                                                                                                                                                        4311,
                                                                                                                                                                        4312,
                                                                                                                                                                        4313,
                                                                                                                                                                        4314,
                                                                                                                                                                        4315,
                                                                                                                                                                        4316,
                                                                                                                                                                        4317,
                                                                                                                                                                        4318,
                                                                                                                                                                        4319,
                                                                                                                                                                        4320,
                                                                                                                                                                        4321,
                                                                                                                                                                        4322,
                                                                                                                                                                        4323,
                                                                                                                                                                        4324,
                                                                                                                                                                        4325,
                                                                                                                                                                        4326,
                                                                                                                                                                        4327,
                                                                                                                                                                        4328,
                                                                                                                                                                        4329,
                                                                                                                                                                        4330,
                                                                                                                                                                        4331,
                                                                                                                                                                        4332,
                                                                                                                                                                        4333,
                                                                                                                                                                        4334,
                                                                                                                                                                        4335,
                                                                                                                                                                        4336,
                                                                                                                                                                        4337,
                                                                                                                                                                        4338,
                                                                                                                                                                        4339,
                                                                                                                                                                        4340,
                                                                                                                                                                        4341,
                                                                                                                                                                        4342,
                                                                                                                                                                        4343,
                                                                                                                                                                        4344,
                                                                                                                                                                        4345,
                                                                                                                                                                        4346,
                                                                                                                                                                        4347,
                                                                                                                                                                        4348,
                                                                                                                                                                        4349,
                                                                                                                                                                        4350,
                                                                                                                                                                        4351,
                                                                                                                                                                        4352,
                                                                                                                                                                        4353,
                                                                                                                                                                        4354,
                                                                                                                                                                        4355,
                                                                                                                                                                        4356,
                                                                                                                                                                        4357,
                                                                                                                                                                        4358,
                                                                                                                                                                        4359,
                                                                                                                                                                        4360,
                                                                                                                                                                        4361,
                                                                                                                                                                        4362,
                                                                                                                                                                        4363,
                                                                                                                                                                        4364,
                                                                                                                                                                        4365,
                                                                                                                                                                        4366,
                                                                                                                                                                        4367,
                                                                                                                                                                        4368,
                                                                                                                                                                        4369,
                                                                                                                                                                        4370,
                                                                                                                                                                        4371,
                                                                                                                                                                        4372,
                                                                                                                                                                        4373,
                                                                                                                                                                        4374,
                                                                                                                                                                        4375,
                                                                                                                                                                        4376,
                                                                                                                                                                        4377,
                                                                                                                                                                        4378,
                                                                                                                                                                        4379,
                                                                                                                                                                        4380,
                                                                                                                                                                        4381,
                                                                                                                                                                        4382,
                                                                                                                                                                        4383,
                                                                                                                                                                        4384,
                                                                                                                                                                        4385,
                                                                                                                                                                        4386,
                                                                                                                                                                        4387,
                                                                                                                                                                        4388,
                                                                                                                                                                        4389,
                                                                                                                                                                        4390,
                                                                                                                                                                        4391,
                                                                                                                                                                        4392,
                                                                                                                                                                        4393,
                                                                                                                                                                        4394,
                                                                                                                                                                        4395,
                                                                                                                                                                        4396,
                                                                                                                                                                        4397,
                                                                                                                                                                        4398,
                                                                                                                                                                        4399,
                                                                                                                                                                        4400,
                                                                                                                                                                        4401,
                                                                                                                                                                        4402,
                                                                                                                                                                        4403,
                                                                                                                                                                        4404,
                                                                                                                                                                        4405,
                                                                                                                                                                        4406,
                                                                                                                                                                        4407,
                                                                                                                                                                        4408,
                                                                                                                                                                        4409,
                                                                                                                                                                        4410,
                                                                                                                                                                        4411,
                                                                                                                                                                        4412,
                                                                                                                                                                        4413,
                                                                                                                                                                        4414,
                                                                                                                                                                        4415,
                                                                                                                                                                        4416,
                                                                                                                                                                        4417,
                                                                                                                                                                        4418,
                                                                                                                                                                        4419,
                                                                                                                                                                        4420,
                                                                                                                                                                        4421,
                                                                                                                                                                        4422,
                                                                                                                                                                        4423,
                                                                                                                                                                        4424,
                                                                                                                                                                        4425,
                                                                                                                                                                        4426,
                                                                                                                                                                        4427,
                                                                                                                                                                        4428,
                                                                                                                                                                        4429,
                                                                                                                                                                        4430,
                                                                                                                                                                        4431,
                                                                                                                                                                        4432,
                                                                                                                                                                        4433,
                                                                                                                                                                        4434,
                                                                                                                                                                        4435,
                                                                                                                                                                        4436,
                                                                                                                                                                        4437,
                                                                                                                                                                        4438,
                                                                                                                                                                        4439,
                                                                                                                                                                        4440,
                                                                                                                                                                        4441,
                                                                                                                                                                        4442,
                                                                                                                                                                        4443,
                                                                                                                                                                        4444,
                                                                                                                                                                        4445,
                                                                                                                                                                        4446,
                                                                                                                                                                        4447,
                                                                                                                                                                        4448,
                                                                                                                                                                        4449,
                                                                                                                                                                        4450,
                                                                                                                                                                        4451,
                                                                                                                                                                        4452,
                                                                                                                                                                        4453,
                                                                                                                                                                        4454,
                                                                                                                                                                        4455,
                                                                                                                                                                        4456,
                                                                                                                                                                        4457,
                                                                                                                                                                        4458,
                                                                                                                                                                        4459,
                                                                                                                                                                        4460,
                                                                                                                                                                        4461,
                                                                                                                                                                        4462,
                                                                                                                                                                        4463,
                                                                                                                                                                        4464,
                                                                                                                                                                        4465,
                                                                                                                                                                        4466,
                                                                                                                                                                        4467,
                                                                                                                                                                        4468,
                                                                                                                                                                        4469,
                                                                                                                                                                        4470,
                                                                                                                                                                        4471,
                                                                                                                                                                        4472,
                                                                                                                                                                        4473,
                                                                                                                                                                        4474,
                                                                                                                                                                        4475,
                                                                                                                                                                        4476,
                                                                                                                                                                        4477,
                                                                                                                                                                        4478,
                                                                                                                                                                        4479,
                                                                                                                                                                        4480,
                                                                                                                                                                        4481,
                                                                                                                                                                        4482,
                                                                                                                                                                        4483,
                                                                                                                                                                        4484,
                                                                                                                                                                        4485,
                                                                                                                                                                        4486,
                                                                                                                                                                        4487,
                                                                                                                                                                        4488,
                                                                                                                                                                        4489,
                                                                                                                                                                        4490,
                                                                                                                                                                        4491,
                                                                                                                                                                        4492,
                                                                                                                                                                        4493,
                                                                                                                                                                        4494,
                                                                                                                                                                        4495,
                                                                                                                                                                        4496,
                                                                                                                                                                        4497,
                                                                                                                                                                        4498,
                                                                                                                                                                        4499,
                                                                                                                                                                        4500,
                                                                                                                                                                        4501,
                                                                                                                                                                        4502,
                                                                                                                                                                        4503,
                                                                                                                                                                        4504,
                                                                                                                                                                        4505,
                                                                                                                                                                        4506,
                                                                                                                                                                        4507,
                                                                                                                                                                        4508,
                                                                                                                                                                        4509,
                                                                                                                                                                        4510,
                                                                                                                                                                        4511,
                                                                                                                                                                        4512,
                                                                                                                                                                        4513,
                                                                                                                                                                        4514,
                                                                                                                                                                        4515,
                                                                                                                                                                        4516,
                                                                                                                                                                        4517,
                                                                                                                                                                        4518,
                                                                                                                                                                        4519,
                                                                                                                                                                        4520,
                                                                                                                                                                        4521,
                                                                                                                                                                        4522,
                                                                                                                                                                        4523,
                                                                                                                                                                        4524,
                                                                                                                                                                        4525,
                                                                                                                                                                        4526,
                                                                                                                                                                        4527,
                                                                                                                                                                        4528,
                                                                                                                                                                        4529,
                                                                                                                                                                        4530
                                                                                                                                                                    ]
                                                                                                                                                                }
                                                                                                                                                            ]
                                                                                                                                                        }, {
                                                                                                                                                            "type": "material",

                                                                                                                                                            "baseColor": {
                                                                                                                                                                "r": 0.878431,
                                                                                                                                                                "g": 0.258824,
                                                                                                                                                                "b": 0.133333
                                                                                                                                                            },
                                                                                                                                                            emit: 0.05,
                                                                                                                                                            "specularColor": {
                                                                                                                                                                "r": 0.33,
                                                                                                                                                                "g": 0.33,
                                                                                                                                                                "b": 0.33,
                                                                                                                                                                "a": 1
                                                                                                                                                            },
                                                                                                                                                            "shine": 10,
                                                                                                                                                            "specular": 1,
                                                                                                                                                            "nodes": [{
                                                                                                                                                                    "type": "geometry",
                                                                                                                                                                    "positions": [-82.203225,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -79.513362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -79.886618,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -79.513362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -82.203225,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        18.857689, -79.26625,
                                                                                                                                                                        88.652615,
                                                                                                                                                                        16.504782, -79.513362,
                                                                                                                                                                        88.876998,
                                                                                                                                                                        16.357689, -81.299099,
                                                                                                                                                                        88.626203,
                                                                                                                                                                        18.537632, -79.26625,
                                                                                                                                                                        88.652615,
                                                                                                                                                                        16.504782, -82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        18.857689, -81.299099,
                                                                                                                                                                        88.626203,
                                                                                                                                                                        18.537632, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        18.857689, -66.838759,
                                                                                                                                                                        80.465397,
                                                                                                                                                                        18.537632, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        18.857689, -81.299099,
                                                                                                                                                                        88.626203,
                                                                                                                                                                        18.537632, -82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        18.857689, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        19.857689, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        19.857689, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        19.857689, -39.566018,
                                                                                                                                                                        60.919782,
                                                                                                                                                                        17.941327, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -39.566018,
                                                                                                                                                                        60.919782,
                                                                                                                                                                        19.245435, -39.566018,
                                                                                                                                                                        60.919782,
                                                                                                                                                                        17.941327, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        19.857689, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        20.247152, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        17.208074, -84.029668,
                                                                                                                                                                        34.752953,
                                                                                                                                                                        21.45093, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        20.247152, -84.050312,
                                                                                                                                                                        34.740805,
                                                                                                                                                                        22.107689, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689, -84.029668,
                                                                                                                                                                        34.752953,
                                                                                                                                                                        21.45093, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689, -98.799325,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        20.195923, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689, -98.799325,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        20.195923, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249, -98.799325,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        17.311016, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249, -98.799325,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        20.195923, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689, -98.828898,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.357689, -98.610491,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.788489, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -97.618237,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.817342, -98.610491,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.788489, -98.828898,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.357689, -98.610491,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.788489, -97.618237,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.817342, -98.586,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.77945, -98.099624,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.734692, -98.586,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.77945, -97.618237,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.817342, -96.517126,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.732873, -96.799076,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.334038, -97.421294,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.412802, -97.421294,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.412802, -96.799076,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.334038, -97.755276,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.25889, -97.755276,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.25889, -96.799076,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.334038, -98.117712,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.196663, -97.174644,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.021768, -98.117712,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.196663, -96.799076,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.334038, -98.117712,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.196663, -97.174644,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.021768, -98.483905,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.230361, -97.174644,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.021768, -97.618237,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.817342, -98.483905,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.230361, -98.483905,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.230361, -97.618237,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.817342, -98.828898,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.357689, -97.516753,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.850843, -96.902598,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.978016, -97.21647,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.638563, -96.923915,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.993085, -96.902598,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.978016, -97.516753,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.850843, -96.876744,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -96.923915,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.993085, -97.25,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -97.25,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -96.923915,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.993085, -97.516753,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.850843, -94.560137,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -96.876744,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -97.25,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -94.560137,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -97.25,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -82.203225,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -94.560137,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -82.203225,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.39932, -94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -93.877859,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -93.877859,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        18.857689, -93.877859,
                                                                                                                                                                        96.541783,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        18.857689, -93.877859,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -93.877859,
                                                                                                                                                                        96.541783,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        18.857689, -94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        18.857689, -82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        18.857689, -97.282878,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -94.942794,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        15.991368, -94.942794,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        15.991368, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -94.942794,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        15.991368, -95.070637,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -95.070637,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -94.942794,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        15.991368, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -94.942794,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        15.991368, -95.070637,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -94.942794,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        15.991368, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -94.877842,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        16.114781, -94.75,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -94.877842,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        16.114781, -94.75,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -94.877842,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        16.114781, -94.877842,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        16.114781, -94.75,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -94.942794,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        15.991368, -97.41072,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        11.302162, -97.282878,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -97.41072,
                                                                                                                                                                        159.296883,
                                                                                                                                                                        11.302162, -97.41072,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        11.302162, -97.282878,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -94.877842,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        16.114781, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -97.779953,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        10.600598, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -94.877842,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        16.114781, -94.75,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -94.701709,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -94.701709,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -81.804968,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -82.013362,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -81.854982,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.056759, -81.692725,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -81.854982,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.056759, -82.013362,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        16.357689, -81.854982,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.056759, -81.692725,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -81.851105,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.049391, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -81.851105,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.049391, -81.692725,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        15.74846, -81.851105,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        16.049391, -81.851105,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.049391, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -79.322104,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        11.244139, -81.851105,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        16.049391, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -81.692725,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        15.74846, -79.480484,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -79.322104,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        11.244139, -79.886618,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -79.513362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.357689, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -79.886618,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        16.082713, -79.513362,
                                                                                                                                                                        88.876998,
                                                                                                                                                                        16.357689, -76.033713,
                                                                                                                                                                        90.374401,
                                                                                                                                                                        10.362769, -76.355567,
                                                                                                                                                                        90.558974,
                                                                                                                                                                        10.357689, -79.26625,
                                                                                                                                                                        88.652615,
                                                                                                                                                                        16.504782, -76.033713,
                                                                                                                                                                        90.374401,
                                                                                                                                                                        10.362769, -79.513362,
                                                                                                                                                                        88.876998,
                                                                                                                                                                        16.357689, -72.784134,
                                                                                                                                                                        86.945353,
                                                                                                                                                                        13.125602, -72.492396,
                                                                                                                                                                        86.935388,
                                                                                                                                                                        12.857689, -73.256302,
                                                                                                                                                                        88.687459,
                                                                                                                                                                        10.569728, -69.712025,
                                                                                                                                                                        84.874226,
                                                                                                                                                                        13.709922, -72.492396,
                                                                                                                                                                        86.935388,
                                                                                                                                                                        12.857689, -72.784134,
                                                                                                                                                                        86.945353,
                                                                                                                                                                        13.125602, -66.247696,
                                                                                                                                                                        82.367812,
                                                                                                                                                                        14.664789, -69.712025,
                                                                                                                                                                        84.874226,
                                                                                                                                                                        13.709922, -69.868303,
                                                                                                                                                                        84.783772,
                                                                                                                                                                        14.019355, -69.868303,
                                                                                                                                                                        84.783772,
                                                                                                                                                                        14.019355, -69.712025,
                                                                                                                                                                        84.874226,
                                                                                                                                                                        13.709922, -72.784134,
                                                                                                                                                                        86.945353,
                                                                                                                                                                        13.125602, -66.583144,
                                                                                                                                                                        82.406986,
                                                                                                                                                                        14.924838, -66.247696,
                                                                                                                                                                        82.367812,
                                                                                                                                                                        14.664789, -69.868303,
                                                                                                                                                                        84.783772,
                                                                                                                                                                        14.019355, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        18.857689, -66.247696,
                                                                                                                                                                        82.367812,
                                                                                                                                                                        14.664789, -66.583144,
                                                                                                                                                                        82.406986,
                                                                                                                                                                        14.924838, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        19.857689, -39,
                                                                                                                                                                        67.849489,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        67.849489,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        19.857689, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -43.972613,
                                                                                                                                                                        58.326503,
                                                                                                                                                                        17.336396, -43.896399,
                                                                                                                                                                        58.371356,
                                                                                                                                                                        16.685519, -39.566018,
                                                                                                                                                                        60.919782,
                                                                                                                                                                        17.941327, -43.972613,
                                                                                                                                                                        58.326503,
                                                                                                                                                                        17.336396, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -81.80311,
                                                                                                                                                                        36.063282,
                                                                                                                                                                        19.514448, -82.013362,
                                                                                                                                                                        35.939548,
                                                                                                                                                                        18.857689, -79.076577,
                                                                                                                                                                        37.667844,
                                                                                                                                                                        16.787915, -94.960252,
                                                                                                                                                                        28.320312,
                                                                                                                                                                        19.514448, -82.013362,
                                                                                                                                                                        35.939548,
                                                                                                                                                                        18.857689, -81.80311,
                                                                                                                                                                        36.063282,
                                                                                                                                                                        19.514448, -82.013362,
                                                                                                                                                                        35.939548,
                                                                                                                                                                        18.857689, -94.960252,
                                                                                                                                                                        28.320312,
                                                                                                                                                                        19.514448, -94.75,
                                                                                                                                                                        28.444045,
                                                                                                                                                                        18.857689, -94.960252,
                                                                                                                                                                        28.320312,
                                                                                                                                                                        19.514448, -97.41973,
                                                                                                                                                                        26.872911,
                                                                                                                                                                        17.054971, -94.75,
                                                                                                                                                                        28.444045,
                                                                                                                                                                        18.857689, -97.41973,
                                                                                                                                                                        26.872911,
                                                                                                                                                                        17.054971, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        17.208074, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        16.649249, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        16.649249, -98.233307,
                                                                                                                                                                        26.394122,
                                                                                                                                                                        17.208074, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        16.649249, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923, -98.799325,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        17.311016, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016, -98.799325,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        16.649249, -98.799325,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016, -98.799325,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        16.649249, -97.25,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        16.357689, -97.41973,
                                                                                                                                                                        26.872911,
                                                                                                                                                                        17.054971, -94.75,
                                                                                                                                                                        28.444045,
                                                                                                                                                                        18.857689, -97.41973,
                                                                                                                                                                        26.872911,
                                                                                                                                                                        17.054971, -97.25,
                                                                                                                                                                        26.972797,
                                                                                                                                                                        16.357689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -100.407795,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.695398, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -100.407795,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.695398, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.695398, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -97.282878,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -97.779953,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        10.600598, -97.907795,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -97.779953,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        10.600598, -97.282878,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -97.41072,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        11.302162, -97.282878,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -97.41072,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        11.302162, -97.282878,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -96.348009,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.191091, -96.517126,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.732873, -96.926249,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.948194, -96.926249,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.948194, -96.517126,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.732873, -97.138529,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.647911, -97.138529,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.647911, -96.517126,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.732873, -97.421294,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.412802, -96.765222,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.659379, -96.303251,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.677467, -96.798921,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.293187, -96.827449,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.021816, -96.303251,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.677467, -96.765222,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.659379, -96.385901,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.158854, -96.303251,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.677467, -96.827449,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.021816, -96.303251,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.677467, -96.348009,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.191091, -96.798921,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.293187, -96.798921,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.293187, -96.348009,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        14.191091, -96.926249,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        13.948194, -96.590327,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.602447, -96.385901,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.158854, -96.981362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.355797, -96.981362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.355797, -96.385901,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.158854, -96.827449,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.021816, -97.21647,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.638563, -96.590327,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.602447, -96.981362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.355797, -96.902598,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.978016, -96.590327,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.602447, -97.21647,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        15.638563, -98.610491,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        12.788489, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -97.779953,
                                                                                                                                                                        193.422316,
                                                                                                                                                                        10.600598, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -97.779953,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        10.600598, -97.907795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -97.907795,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -97.779953,
                                                                                                                                                                        128.546883,
                                                                                                                                                                        10.600598, -78.855567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -79.013946,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        10.65862, -78.855567,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -79.013946,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        10.65862, -79.013946,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        10.65862, -78.855567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -79.322104,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        11.244139, -78.855567,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -79.013946,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        10.65862, -78.855567,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        10.357689, -79.322104,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        11.244139, -79.480484,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -79.480484,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -79.480484,
                                                                                                                                                                        128.272387,
                                                                                                                                                                        11.54507, -79.322104,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        11.244139, -79.322104,
                                                                                                                                                                        159.362451,
                                                                                                                                                                        11.244139, -79.480484,
                                                                                                                                                                        159.022387,
                                                                                                                                                                        11.54507, -79.322104,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        11.244139, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -79.013946,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        10.65862, -78.855567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -79.013946,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        10.65862, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -81.854982,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        16.056759, -81.854982,
                                                                                                                                                                        193.356748,
                                                                                                                                                                        16.056759, -82.013362,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        16.357689, -81.854982,
                                                                                                                                                                        128.612451,
                                                                                                                                                                        16.056759, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -98.513345,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        10.621257, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -98.513345,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        10.621257, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -95.102845,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        16.844122, -94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -95.102845,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        16.844122, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -95.102845,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        16.844122, -95.102845,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        16.844122, -94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -96.380845,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        12.951746, -97.101763,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.636346, -96.380845,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        12.951746, -96.380845,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        12.951746, -97.101763,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.636346, -96.380845,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        12.951746, -96.380845,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        12.951746, -97.101763,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.636346, -96.380845,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        12.951746, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -95.102845,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        16.844122, -94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        17.107689, -91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -94.701709,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -94.701709,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -94.701709,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -94.701709,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -92.595242,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        17.107689, -92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        17.107689, -92.595242,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        17.107689, -92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        17.107689, -91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        17.107689, -91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        17.107689, -91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        17.107689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        17.107689, -85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        17.107689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        17.107689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        17.107689, -84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        17.107689, -84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        17.107689, -84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        17.107689, -81.804968,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -81.804968,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -81.703818,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        16.92313, -78.206716,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        10.542249, -81.703818,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        16.92313, -81.804968,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -79.920459,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.903895, -79.920459,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        11.588495, -79.920459,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.903895, -79.920459,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        12.903895, -79.920459,
                                                                                                                                                                        207.202139,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        210.452139,
                                                                                                                                                                        12.903895, -79.920459,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.903895, -79.920459,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        12.903895, -79.920459,
                                                                                                                                                                        202.141638,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        205.391638,
                                                                                                                                                                        12.903895, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.206716,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        10.542249, -78.206716,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        10.542249, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.105567,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -78.206716,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        10.542249, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -81.804968,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        17.107689, -78.105567,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -78.206716,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        10.542249, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -83.077628,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        207.652108,
                                                                                                                                                                        17.107689, -83.571263,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        207.082108,
                                                                                                                                                                        16.857689, -83.571263,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        207.652108,
                                                                                                                                                                        17.107689, -87.780146,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -87.780146,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -88.273781,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -88.273781,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -88.273781,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -87.780146,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -88.273781,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -87.780146,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        207.652108,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        207.082108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        207.652108,
                                                                                                                                                                        17.107689, -87.780146,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -87.780146,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -88.273781,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        202.222108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        202.222108,
                                                                                                                                                                        16.857689, -88.273781,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -85.675705,
                                                                                                                                                                        202.222108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        17.107689, -83.571263,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -83.077628,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -83.571263,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -85.675705,
                                                                                                                                                                        201.652108,
                                                                                                                                                                        17.107689, -83.077628,
                                                                                                                                                                        203.152108,
                                                                                                                                                                        17.107689, -83.077628,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -83.571263,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -83.571263,
                                                                                                                                                                        205.867108,
                                                                                                                                                                        16.857689, -83.571263,
                                                                                                                                                                        203.437108,
                                                                                                                                                                        16.857689, -83.077628,
                                                                                                                                                                        206.152108,
                                                                                                                                                                        17.107689, -90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        17.107689, -90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        17.107689, -90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        17.107689, -90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        17.107689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        17.107689, -91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        17.107689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        17.107689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        17.107689, -91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        17.107689, -91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        17.107689, -91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        17.107689, -83.159659,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -80.570267,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -81.545833,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -96.193095,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -81.545833,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -80.570267,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -81.545833,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -96.193095,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -95.217529,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -93.603703,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -95.217529,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -96.193095,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        10.897689, -93.248106,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -95.217529,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -93.603703,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -83.515256,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -83.159659,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -81.545833,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        11.486678, -93.248106,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -83.159659,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -83.515256,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -83.159659,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -93.248106,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.228701, -93.603703,
                                                                                                                                                                        218.696812,
                                                                                                                                                                        15.817689, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -98.657795,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        10.357689, -98.513345,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        10.621257, -98.513345,
                                                                                                                                                                        211.646256,
                                                                                                                                                                        10.621257, -98.657795,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        10.357689, -98.513345,
                                                                                                                                                                        193.997368,
                                                                                                                                                                        10.621257, -97.101763,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        11.636346, -96.380845,
                                                                                                                                                                        195.693209,
                                                                                                                                                                        12.951746, -97.101763,
                                                                                                                                                                        198.943209,
                                                                                                                                                                        11.636346, -97.101763,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        11.636346, -96.380845,
                                                                                                                                                                        206.767114,
                                                                                                                                                                        12.951746, -97.101763,
                                                                                                                                                                        210.017114,
                                                                                                                                                                        11.636346, -97.101763,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        11.636346, -96.380845,
                                                                                                                                                                        201.335011,
                                                                                                                                                                        12.951746, -97.101763,
                                                                                                                                                                        204.585011,
                                                                                                                                                                        11.636346, -81.703818,
                                                                                                                                                                        211.736351,
                                                                                                                                                                        16.92313, -81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        17.107689, -81.703818,
                                                                                                                                                                        193.907272,
                                                                                                                                                                        16.92313, -80.641376,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        12.903895, -79.920459,
                                                                                                                                                                        197.149134,
                                                                                                                                                                        11.588495, -80.641376,
                                                                                                                                                                        200.399134,
                                                                                                                                                                        12.903895, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.244433, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -76.355567,
                                                                                                                                                                        90.558974,
                                                                                                                                                                        10.357689, -76.033713,
                                                                                                                                                                        91.202911,
                                                                                                                                                                        8.927747, -76.355567,
                                                                                                                                                                        91.569337,
                                                                                                                                                                        8.607689, -76.033713,
                                                                                                                                                                        90.374401,
                                                                                                                                                                        10.362769, -76.033713,
                                                                                                                                                                        91.202911,
                                                                                                                                                                        8.927747, -76.355567,
                                                                                                                                                                        90.558974,
                                                                                                                                                                        10.357689, -75.16602,
                                                                                                                                                                        90.713221,
                                                                                                                                                                        8.927747, -76.355567,
                                                                                                                                                                        91.569337,
                                                                                                                                                                        8.607689, -76.033713,
                                                                                                                                                                        91.202911,
                                                                                                                                                                        8.927747, -76.355567,
                                                                                                                                                                        91.569337,
                                                                                                                                                                        8.607689, -75.16602,
                                                                                                                                                                        90.713221,
                                                                                                                                                                        8.927747, -74.989594,
                                                                                                                                                                        90.798439,
                                                                                                                                                                        8.607689, -72.954242,
                                                                                                                                                                        88.63941,
                                                                                                                                                                        10.357689, -74.989594,
                                                                                                                                                                        90.798439,
                                                                                                                                                                        8.607689, -75.16602,
                                                                                                                                                                        90.713221,
                                                                                                                                                                        8.927747, -43.896399,
                                                                                                                                                                        58.371356,
                                                                                                                                                                        16.685519, -48.643316,
                                                                                                                                                                        55.577798,
                                                                                                                                                                        16.504471, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -43.972613,
                                                                                                                                                                        58.326503,
                                                                                                                                                                        17.336396, -48.643316,
                                                                                                                                                                        55.577798,
                                                                                                                                                                        16.504471, -43.896399,
                                                                                                                                                                        58.371356,
                                                                                                                                                                        16.685519, -79.076577,
                                                                                                                                                                        37.667844,
                                                                                                                                                                        16.787915, -79.513362,
                                                                                                                                                                        37.410797,
                                                                                                                                                                        16.357689, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        10.542366, -82.013362,
                                                                                                                                                                        35.939548,
                                                                                                                                                                        18.857689, -79.513362,
                                                                                                                                                                        37.410797,
                                                                                                                                                                        16.357689, -79.076577,
                                                                                                                                                                        37.667844,
                                                                                                                                                                        16.787915, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398, -100.407795,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689, -100.407795,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -76.355567,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -76.813936,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -100.407795,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689, -99.949426,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        9.316059, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -20.595623,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        7.107689, -29.473194,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        39.836211,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -62.271903,
                                                                                                                                                                        48.502633,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -52.580957,
                                                                                                                                                                        53.260499,
                                                                                                                                                                        15.578558, -52.459894,
                                                                                                                                                                        53.331745,
                                                                                                                                                                        14.936916, -48.643316,
                                                                                                                                                                        55.577798,
                                                                                                                                                                        16.504471, -52.580957,
                                                                                                                                                                        53.260499,
                                                                                                                                                                        15.578558, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -52.580957,
                                                                                                                                                                        53.260499,
                                                                                                                                                                        15.578558, -60.472398,
                                                                                                                                                                        48.616391,
                                                                                                                                                                        13.423946, -52.459894,
                                                                                                                                                                        53.331745,
                                                                                                                                                                        14.936916, -52.459894,
                                                                                                                                                                        53.331745,
                                                                                                                                                                        14.936916, -60.472398,
                                                                                                                                                                        48.616391,
                                                                                                                                                                        13.423946, -60.075228,
                                                                                                                                                                        48.850125,
                                                                                                                                                                        12.857689, -60.472398,
                                                                                                                                                                        48.616391,
                                                                                                                                                                        13.423946, -61.518039,
                                                                                                                                                                        48.001032,
                                                                                                                                                                        10.817456, -60.075228,
                                                                                                                                                                        48.850125,
                                                                                                                                                                        12.857689, -60.075228,
                                                                                                                                                                        48.850125,
                                                                                                                                                                        12.857689, -61.518039,
                                                                                                                                                                        48.001032,
                                                                                                                                                                        10.817456, -61.078149,
                                                                                                                                                                        48.259907,
                                                                                                                                                                        10.357689, -61.518039,
                                                                                                                                                                        48.001032,
                                                                                                                                                                        10.817456, -63.751076,
                                                                                                                                                                        46.686891,
                                                                                                                                                                        9.264448, -61.078149,
                                                                                                                                                                        48.259907,
                                                                                                                                                                        10.357689, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        9.264448, -63.594438,
                                                                                                                                                                        46.779073,
                                                                                                                                                                        8.607689, -63.751076,
                                                                                                                                                                        46.686891,
                                                                                                                                                                        9.264448, -63.594438,
                                                                                                                                                                        46.779073,
                                                                                                                                                                        8.607689, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        9.264448, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        8.607689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        10.357689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        8.607689, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        9.264448, -79.513362,
                                                                                                                                                                        37.410797,
                                                                                                                                                                        16.357689, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        10.357689, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        10.542366, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        10.542366, -76.355567,
                                                                                                                                                                        39.269157,
                                                                                                                                                                        10.357689, -75.789549,
                                                                                                                                                                        39.602258,
                                                                                                                                                                        9.264448, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        8.607689, -72.982465,
                                                                                                                                                                        89.967059,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -74.554525,
                                                                                                                                                                        86.17177,
                                                                                                                                                                        7.107689, -72.982465,
                                                                                                                                                                        89.967059,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        102.672683,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        8.607689, -70.877315,
                                                                                                                                                                        95.049341,
                                                                                                                                                                        7.107689, -72.982465,
                                                                                                                                                                        89.967059,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -57.404377,
                                                                                                                                                                        108.522279,
                                                                                                                                                                        7.107689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -12.972281,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -7.122685,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -3.445475,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -2.191247,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        7.107689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        8.607689, -29.473194,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        7.107689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        8.607689, -39,
                                                                                                                                                                        113.453717,
                                                                                                                                                                        8.607689, -48.526806,
                                                                                                                                                                        112.199489,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        8.607689, -75.808753,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        7.107689, -70.877315,
                                                                                                                                                                        58.240588,
                                                                                                                                                                        8.607689, -74.554525,
                                                                                                                                                                        67.118158,
                                                                                                                                                                        7.107689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        7.107689, -62.271903,
                                                                                                                                                                        48.502633,
                                                                                                                                                                        7.107689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -62.271903,
                                                                                                                                                                        48.502633,
                                                                                                                                                                        7.107689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -65.027719,
                                                                                                                                                                        50.617245,
                                                                                                                                                                        8.607689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        7.107689, -48.526806,
                                                                                                                                                                        41.090439,
                                                                                                                                                                        7.107689, -57.404377,
                                                                                                                                                                        44.767649,
                                                                                                                                                                        8.607689, -61.078149,
                                                                                                                                                                        48.259907,
                                                                                                                                                                        10.357689, -63.751076,
                                                                                                                                                                        46.686891,
                                                                                                                                                                        9.264448, -63.594438,
                                                                                                                                                                        46.779073,
                                                                                                                                                                        8.607689, -72.492396,
                                                                                                                                                                        86.935388,
                                                                                                                                                                        12.857689, -72.954242,
                                                                                                                                                                        88.63941,
                                                                                                                                                                        10.357689, -73.256302,
                                                                                                                                                                        88.687459,
                                                                                                                                                                        10.569728, -73.256302,
                                                                                                                                                                        88.687459,
                                                                                                                                                                        10.569728, -72.954242,
                                                                                                                                                                        88.63941,
                                                                                                                                                                        10.357689, -75.16602,
                                                                                                                                                                        90.713221,
                                                                                                                                                                        8.927747, -66.838759,
                                                                                                                                                                        80.465397,
                                                                                                                                                                        18.537632, -66.544355,
                                                                                                                                                                        80.114462,
                                                                                                                                                                        18.857689, -66.583144,
                                                                                                                                                                        82.406986,
                                                                                                                                                                        14.924838, -66.632456,
                                                                                                                                                                        44.991201,
                                                                                                                                                                        21.45093, -84.050312,
                                                                                                                                                                        34.740805,
                                                                                                                                                                        22.107689, -84.029668,
                                                                                                                                                                        34.752953,
                                                                                                                                                                        21.45093, -84.050312,
                                                                                                                                                                        34.740805,
                                                                                                                                                                        22.107689, -66.632456,
                                                                                                                                                                        44.991201,
                                                                                                                                                                        21.45093, -66.612606,
                                                                                                                                                                        45.002883,
                                                                                                                                                                        22.107689, -66.612606,
                                                                                                                                                                        45.002883,
                                                                                                                                                                        22.107689, -66.632456,
                                                                                                                                                                        44.991201,
                                                                                                                                                                        21.45093, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        19.857689, -66.632456,
                                                                                                                                                                        44.991201,
                                                                                                                                                                        21.45093, -39.566018,
                                                                                                                                                                        60.919782,
                                                                                                                                                                        19.245435, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        19.857689,
                                                                                                                                                                        null,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "normals": [
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735,
                                                                                                                                                                        0.884924,
                                                                                                                                                                        0,
                                                                                                                                                                        0.465735, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1, -0.225905, -0.391278,
                                                                                                                                                                        0.892115, -0.225905, -0.391278,
                                                                                                                                                                        0.892115, -0.225905, -0.391278,
                                                                                                                                                                        0.892115, -0.225905, -0.391278,
                                                                                                                                                                        0.892115, -0.225905, -0.391278,
                                                                                                                                                                        0.892115, -0.225905, -0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905, -0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905, -0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905, -0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905, -0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905, -0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905, -0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115, -0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115, -0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115, -0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115, -0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115, -0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115, -0.225905,
                                                                                                                                                                        0.391278,
                                                                                                                                                                        0.892115, -0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115, -0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115, -0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115, -0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115, -0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115, -0.451809,
                                                                                                                                                                        0,
                                                                                                                                                                        0.892115,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612, -0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0.876934,
                                                                                                                                                                        0,
                                                                                                                                                                        0.480612,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.5, -0.866025,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.608761, -0.793353,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.92388,
                                                                                                                                                                        0.382683,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.965926,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0, -0.92388,
                                                                                                                                                                        0.382683,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.707107,
                                                                                                                                                                        0.707107,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.866025,
                                                                                                                                                                        0.5,
                                                                                                                                                                        0, -0.92388,
                                                                                                                                                                        0.382683,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.5,
                                                                                                                                                                        0.866025,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.707107, -0.707107,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.866025, -0.5,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        0.965926, -0.258819,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0, -0.258819,
                                                                                                                                                                        0.965926,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.866025, -0.5,
                                                                                                                                                                        0, -0.965926, -0.258819,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.608761, -0.793353,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.5, -0.866025,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.608761, -0.793353,
                                                                                                                                                                        0, -0.5, -0.866025,
                                                                                                                                                                        0, -0.707107, -0.707107,
                                                                                                                                                                        0, -0.5, -0.866025,
                                                                                                                                                                        0, -0.5, -0.866025,
                                                                                                                                                                        0, -0.258819, -0.965926,
                                                                                                                                                                        0, -0.5, -0.866025,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.439108,
                                                                                                                                                                        0.778067,
                                                                                                                                                                        0.449217,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        0.507189, -0.861835,
                                                                                                                                                                        0,
                                                                                                                                                                        null,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "uv": [-82.203225,
                                                                                                                                                                        18.39932, -79.513362,
                                                                                                                                                                        16.357689, -79.886618,
                                                                                                                                                                        16.082713, -82.013362,
                                                                                                                                                                        18.857689, -79.513362,
                                                                                                                                                                        16.357689, -82.203225,
                                                                                                                                                                        18.39932, -115.090244,
                                                                                                                                                                        0.197889, -112.603512, -2.435699, -112.929, -2.600339, -114.360906, -0.160349, -112.603512, -2.435699, -115.090244,
                                                                                                                                                                        0.197889, -114.360906, -0.160349, -97.327811,
                                                                                                                                                                        0.197889, -97.756683, -0.160349, -97.327811,
                                                                                                                                                                        0.197889, -114.360906, -0.160349, -115.090244,
                                                                                                                                                                        0.197889, -61.252883,
                                                                                                                                                                        19.857689, -61.252883,
                                                                                                                                                                        17.357689, -76.644964,
                                                                                                                                                                        19.857689,
                                                                                                                                                                        2.544756,
                                                                                                                                                                        19.857689,
                                                                                                                                                                        3.201515,
                                                                                                                                                                        17.941327,
                                                                                                                                                                        2.544756,
                                                                                                                                                                        17.357689,
                                                                                                                                                                        3.201515,
                                                                                                                                                                        19.245435,
                                                                                                                                                                        3.201515,
                                                                                                                                                                        17.941327,
                                                                                                                                                                        2.544756,
                                                                                                                                                                        19.857689,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        20.247152,
                                                                                                                                                                        71.930824,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        17.208074,
                                                                                                                                                                        54.793366,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        71.930824,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        20.247152,
                                                                                                                                                                        54.81732,
                                                                                                                                                                        22.107689,
                                                                                                                                                                        71.930824,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        54.793366,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        20.195923,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        20.195923,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        17.311016,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        20.195923,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        20.857689, -98.828898,
                                                                                                                                                                        13.357689, -98.610491,
                                                                                                                                                                        12.788489, -100.407795,
                                                                                                                                                                        10.357689, -97.618237,
                                                                                                                                                                        12.817342, -98.610491,
                                                                                                                                                                        12.788489, -98.828898,
                                                                                                                                                                        13.357689, -98.610491,
                                                                                                                                                                        12.788489, -97.618237,
                                                                                                                                                                        12.817342, -98.586,
                                                                                                                                                                        12.77945, -98.099624,
                                                                                                                                                                        12.734692, -98.586,
                                                                                                                                                                        12.77945, -97.618237,
                                                                                                                                                                        12.817342, -96.517126,
                                                                                                                                                                        13.732873, -96.799076,
                                                                                                                                                                        13.334038, -97.421294,
                                                                                                                                                                        13.412802, -97.421294,
                                                                                                                                                                        13.412802, -96.799076,
                                                                                                                                                                        13.334038, -97.755276,
                                                                                                                                                                        13.25889, -97.755276,
                                                                                                                                                                        13.25889, -96.799076,
                                                                                                                                                                        13.334038, -98.117712,
                                                                                                                                                                        13.196663, -97.174644,
                                                                                                                                                                        13.021768, -98.117712,
                                                                                                                                                                        13.196663, -96.799076,
                                                                                                                                                                        13.334038, -98.117712,
                                                                                                                                                                        13.196663, -97.174644,
                                                                                                                                                                        13.021768, -98.483905,
                                                                                                                                                                        13.230361, -97.174644,
                                                                                                                                                                        13.021768, -97.618237,
                                                                                                                                                                        12.817342, -98.483905,
                                                                                                                                                                        13.230361, -98.483905,
                                                                                                                                                                        13.230361, -97.618237,
                                                                                                                                                                        12.817342, -98.828898,
                                                                                                                                                                        13.357689, -97.516753,
                                                                                                                                                                        15.850843, -96.902598,
                                                                                                                                                                        15.978016, -97.21647,
                                                                                                                                                                        15.638563, -96.923915,
                                                                                                                                                                        15.993085, -96.902598,
                                                                                                                                                                        15.978016, -97.516753,
                                                                                                                                                                        15.850843, -96.876744,
                                                                                                                                                                        16.082713, -96.923915,
                                                                                                                                                                        15.993085, -97.25,
                                                                                                                                                                        16.357689, -97.25,
                                                                                                                                                                        16.357689, -96.923915,
                                                                                                                                                                        15.993085, -97.516753,
                                                                                                                                                                        15.850843, -94.560137,
                                                                                                                                                                        18.39932, -96.876744,
                                                                                                                                                                        16.082713, -97.25,
                                                                                                                                                                        16.357689, -94.75,
                                                                                                                                                                        18.857689, -94.560137,
                                                                                                                                                                        18.39932, -97.25,
                                                                                                                                                                        16.357689, -82.203225,
                                                                                                                                                                        18.39932, -94.560137,
                                                                                                                                                                        18.39932, -94.75,
                                                                                                                                                                        18.857689, -82.013362,
                                                                                                                                                                        18.857689, -82.203225,
                                                                                                                                                                        18.39932, -94.75,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        93.877859,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        93.877859,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        93.877859,
                                                                                                                                                                        96.541783,
                                                                                                                                                                        94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        93.877859,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        94.75,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        93.877859,
                                                                                                                                                                        96.541783,
                                                                                                                                                                        94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        94.75,
                                                                                                                                                                        96.032538,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        88.844517,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        90.33816,
                                                                                                                                                                        82.013362,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        82.885503,
                                                                                                                                                                        125.150246,
                                                                                                                                                                        159.022387, -35.091525,
                                                                                                                                                                        159.022387, -30.341525,
                                                                                                                                                                        159.296883, -30.067029,
                                                                                                                                                                        159.296883, -30.067029,
                                                                                                                                                                        159.022387, -30.341525,
                                                                                                                                                                        128.546883, -30.067029,
                                                                                                                                                                        159.022387, -30.341525,
                                                                                                                                                                        128.272387, -30.341525,
                                                                                                                                                                        128.546883, -30.067029,
                                                                                                                                                                        128.272387, -29.653071,
                                                                                                                                                                        128.546883, -30.067029,
                                                                                                                                                                        128.272387, -30.341525,
                                                                                                                                                                        128.546883, -30.067029,
                                                                                                                                                                        128.272387, -29.653071,
                                                                                                                                                                        128.546883, -29.927567,
                                                                                                                                                                        193.696812, -29.653071,
                                                                                                                                                                        128.546883, -29.927567,
                                                                                                                                                                        128.272387, -29.653071,
                                                                                                                                                                        193.422316, -29.927567,
                                                                                                                                                                        128.546883, -29.927567,
                                                                                                                                                                        193.696812, -29.653071,
                                                                                                                                                                        159.296883, -30.067029,
                                                                                                                                                                        159.296883, -35.366021,
                                                                                                                                                                        159.022387, -35.091525,
                                                                                                                                                                        159.296883, -35.366021,
                                                                                                                                                                        128.546883, -35.366021,
                                                                                                                                                                        159.022387, -35.091525,
                                                                                                                                                                        193.422316, -29.927567,
                                                                                                                                                                        193.696812, -36.433312,
                                                                                                                                                                        193.422316, -36.158816,
                                                                                                                                                                        193.696812, -36.433312,
                                                                                                                                                                        193.422316, -29.927567,
                                                                                                                                                                        193.696812, -29.653071,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        94.701709,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        94.701709,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        93.101604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        92.691526,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        83.851604,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        81.804968,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        193.953497, -193.696812,
                                                                                                                                                                        52.671806, -128.272387,
                                                                                                                                                                        52.671806, -128.612451,
                                                                                                                                                                        52.331742, -128.272387,
                                                                                                                                                                        51.983352, -128.612451,
                                                                                                                                                                        52.331742, -128.272387,
                                                                                                                                                                        52.671806, -128.612451,
                                                                                                                                                                        52.331742, -128.272387,
                                                                                                                                                                        51.983352, -128.612451,
                                                                                                                                                                        52.323416, -159.022387,
                                                                                                                                                                        51.983352, -128.612451,
                                                                                                                                                                        52.323416, -128.272387,
                                                                                                                                                                        51.983352, -159.362451,
                                                                                                                                                                        52.323416, -128.612451,
                                                                                                                                                                        52.323416, -159.022387,
                                                                                                                                                                        51.983352, -159.362451,
                                                                                                                                                                        46.893288, -159.362451,
                                                                                                                                                                        52.323416, -159.022387,
                                                                                                                                                                        51.983352, -159.022387,
                                                                                                                                                                        51.983352, -159.022387,
                                                                                                                                                                        47.233352, -159.362451,
                                                                                                                                                                        46.893288, -79.886618,
                                                                                                                                                                        16.082713, -76.355567,
                                                                                                                                                                        10.357689, -76.813936,
                                                                                                                                                                        10.244433, -79.513362,
                                                                                                                                                                        16.357689, -76.355567,
                                                                                                                                                                        10.357689, -79.886618,
                                                                                                                                                                        16.082713, -112.929, -2.600339, -110.63459, -9.3104, -111.005602, -9.316086, -112.603512, -2.435699, -110.63459, -9.3104, -112.929, -2.600339, -106.119243, -6.217986, -105.860276, -6.517858, -107.386674, -9.078753, -102.425857, -5.563961, -105.860276, -6.517858, -106.119243, -6.217986, -98.176954, -4.495187, -102.425857, -5.563961, -102.5175, -5.217616, -102.5175, -5.217616, -102.425857, -5.563961, -106.119243, -6.217986, -98.488344, -4.204117, -98.176954, -4.495187, -102.5175, -5.217616, -97.327811,
                                                                                                                                                                        0.197889, -98.176954, -4.495187, -98.488344, -4.204117, -76.644964,
                                                                                                                                                                        18.857689, -76.644964,
                                                                                                                                                                        19.857689, -67.849489,
                                                                                                                                                                        18.107689, -67.849489,
                                                                                                                                                                        18.107689, -76.644964,
                                                                                                                                                                        19.857689, -61.252883,
                                                                                                                                                                        17.357689,
                                                                                                                                                                        2.544756,
                                                                                                                                                                        17.357689,
                                                                                                                                                                        8.314555,
                                                                                                                                                                        17.336396,
                                                                                                                                                                        8.226122,
                                                                                                                                                                        16.685519,
                                                                                                                                                                        3.201515,
                                                                                                                                                                        17.941327,
                                                                                                                                                                        8.314555,
                                                                                                                                                                        17.336396,
                                                                                                                                                                        2.544756,
                                                                                                                                                                        17.357689,
                                                                                                                                                                        52.209857,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        52.453816,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        49.046219,
                                                                                                                                                                        16.787915,
                                                                                                                                                                        67.47629,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        52.453816,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        52.209857,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        52.453816,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        67.47629,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        67.232331,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        67.47629,
                                                                                                                                                                        19.514448,
                                                                                                                                                                        70.330059,
                                                                                                                                                                        17.054971,
                                                                                                                                                                        67.232331,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        70.330059,
                                                                                                                                                                        17.054971,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        17.208074,
                                                                                                                                                                        71.930824,
                                                                                                                                                                        16.649249,
                                                                                                                                                                        71.930824,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        71.930824,
                                                                                                                                                                        16.649249,
                                                                                                                                                                        71.274065,
                                                                                                                                                                        17.208074,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        16.649249,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        20.857689,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        20.195923,
                                                                                                                                                                        97.65604,
                                                                                                                                                                        17.311016,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016,
                                                                                                                                                                        98.317806,
                                                                                                                                                                        16.649249,
                                                                                                                                                                        26.061021,
                                                                                                                                                                        16.649249,
                                                                                                                                                                        26.722787,
                                                                                                                                                                        17.311016,
                                                                                                                                                                        71.930824,
                                                                                                                                                                        16.649249,
                                                                                                                                                                        70.133119,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        70.330059,
                                                                                                                                                                        17.054971,
                                                                                                                                                                        67.232331,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        70.330059,
                                                                                                                                                                        17.054971,
                                                                                                                                                                        70.133119,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.695398,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.695398,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.26998,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.695398,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        10.357689, -100.407795,
                                                                                                                                                                        10.357689, -99.949426,
                                                                                                                                                                        9.316059, -100.407795,
                                                                                                                                                                        8.607689, -99.949426,
                                                                                                                                                                        10.244433, -99.949426,
                                                                                                                                                                        9.316059, -100.407795,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        128.272387, -35.091525,
                                                                                                                                                                        128.546883, -36.158816,
                                                                                                                                                                        128.272387, -36.433312,
                                                                                                                                                                        128.546883, -36.158816,
                                                                                                                                                                        128.272387, -35.091525,
                                                                                                                                                                        128.546883, -35.366021,
                                                                                                                                                                        159.022387, -35.091525,
                                                                                                                                                                        128.546883, -35.366021,
                                                                                                                                                                        128.272387, -35.091525, -96.348009,
                                                                                                                                                                        14.191091, -96.517126,
                                                                                                                                                                        13.732873, -96.926249,
                                                                                                                                                                        13.948194, -96.926249,
                                                                                                                                                                        13.948194, -96.517126,
                                                                                                                                                                        13.732873, -97.138529,
                                                                                                                                                                        13.647911, -97.138529,
                                                                                                                                                                        13.647911, -96.517126,
                                                                                                                                                                        13.732873, -97.421294,
                                                                                                                                                                        13.412802, -96.765222,
                                                                                                                                                                        14.659379, -96.303251,
                                                                                                                                                                        14.677467, -96.798921,
                                                                                                                                                                        14.293187, -96.827449,
                                                                                                                                                                        15.021816, -96.303251,
                                                                                                                                                                        14.677467, -96.765222,
                                                                                                                                                                        14.659379, -96.385901,
                                                                                                                                                                        15.158854, -96.303251,
                                                                                                                                                                        14.677467, -96.827449,
                                                                                                                                                                        15.021816, -96.303251,
                                                                                                                                                                        14.677467, -96.348009,
                                                                                                                                                                        14.191091, -96.798921,
                                                                                                                                                                        14.293187, -96.798921,
                                                                                                                                                                        14.293187, -96.348009,
                                                                                                                                                                        14.191091, -96.926249,
                                                                                                                                                                        13.948194, -96.590327,
                                                                                                                                                                        15.602447, -96.385901,
                                                                                                                                                                        15.158854, -96.981362,
                                                                                                                                                                        15.355797, -96.981362,
                                                                                                                                                                        15.355797, -96.385901,
                                                                                                                                                                        15.158854, -96.827449,
                                                                                                                                                                        15.021816, -97.21647,
                                                                                                                                                                        15.638563, -96.590327,
                                                                                                                                                                        15.602447, -96.981362,
                                                                                                                                                                        15.355797, -96.902598,
                                                                                                                                                                        15.978016, -96.590327,
                                                                                                                                                                        15.602447, -97.21647,
                                                                                                                                                                        15.638563, -98.610491,
                                                                                                                                                                        12.788489, -99.949426,
                                                                                                                                                                        10.244433, -100.407795,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        193.422316, -36.158816,
                                                                                                                                                                        193.696812, -36.433312,
                                                                                                                                                                        128.546883, -36.158816,
                                                                                                                                                                        193.696812, -36.433312,
                                                                                                                                                                        128.272387, -36.433312,
                                                                                                                                                                        128.546883, -36.158816, -193.696812,
                                                                                                                                                                        45.891565, -128.612451,
                                                                                                                                                                        46.231629, -128.272387,
                                                                                                                                                                        45.891565, -193.356748,
                                                                                                                                                                        46.231629, -128.612451,
                                                                                                                                                                        46.231629, -193.696812,
                                                                                                                                                                        45.891565, -128.612451,
                                                                                                                                                                        46.893288, -128.272387,
                                                                                                                                                                        45.891565, -128.612451,
                                                                                                                                                                        46.231629, -128.272387,
                                                                                                                                                                        45.891565, -128.612451,
                                                                                                                                                                        46.893288, -128.272387,
                                                                                                                                                                        47.233352, -159.022387,
                                                                                                                                                                        47.233352, -128.272387,
                                                                                                                                                                        47.233352, -128.612451,
                                                                                                                                                                        46.893288, -159.362451,
                                                                                                                                                                        46.893288, -159.022387,
                                                                                                                                                                        47.233352, -128.612451,
                                                                                                                                                                        46.893288, -193.696812,
                                                                                                                                                                        52.671806, -193.356748,
                                                                                                                                                                        46.231629, -193.696812,
                                                                                                                                                                        45.891565, -193.356748,
                                                                                                                                                                        46.231629, -193.696812,
                                                                                                                                                                        52.671806, -193.356748,
                                                                                                                                                                        52.331742, -193.356748,
                                                                                                                                                                        52.331742, -193.696812,
                                                                                                                                                                        52.671806, -128.612451,
                                                                                                                                                                        52.331742,
                                                                                                                                                                        193.696812, -30.635808,
                                                                                                                                                                        193.997368, -38.032529,
                                                                                                                                                                        193.696812, -38.333085,
                                                                                                                                                                        193.997368, -38.032529,
                                                                                                                                                                        193.696812, -30.635808,
                                                                                                                                                                        193.997368, -30.936364,
                                                                                                                                                                        211.946812, -30.635808,
                                                                                                                                                                        193.997368, -30.936364,
                                                                                                                                                                        193.696812, -30.635808,
                                                                                                                                                                        211.646256, -30.936364,
                                                                                                                                                                        193.997368, -30.936364,
                                                                                                                                                                        211.946812, -30.635808,
                                                                                                                                                                        198.943209, -34.963941,
                                                                                                                                                                        198.943209, -36.463941,
                                                                                                                                                                        195.693209, -34.963941,
                                                                                                                                                                        204.585011, -34.963941,
                                                                                                                                                                        204.585011, -36.463941,
                                                                                                                                                                        201.335011, -34.963941,
                                                                                                                                                                        210.017114, -34.963941,
                                                                                                                                                                        210.017114, -36.463941,
                                                                                                                                                                        206.767114, -34.963941,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        211.646256, -30.936364,
                                                                                                                                                                        211.946812, -30.635808,
                                                                                                                                                                        211.946812, -30.635808,
                                                                                                                                                                        211.946812, -38.333085,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        92.844919,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        92.900977,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        94.701709,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        94.701709,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        193.696812,
                                                                                                                                                                        94.701709,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        94.701709,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        94.958394,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        92.595242,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        92.595242,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        92.668814,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        92.412129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        92.464148,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        92.356142,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        92.254671,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        92.281571,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        92.11335,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        92.05765,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        91.940029,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        91.744332,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        91.804823,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.446812,
                                                                                                                                                                        91.537129,
                                                                                                                                                                        201.188326,
                                                                                                                                                                        91.329925,
                                                                                                                                                                        201.471398,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.196812,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        92.185205,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        91.945354,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        88.476604,
                                                                                                                                                                        181.623336,
                                                                                                                                                                        85.007854,
                                                                                                                                                                        176.593534,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        84.768004,
                                                                                                                                                                        176.70176,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        84.261682,
                                                                                                                                                                        172.949491,
                                                                                                                                                                        84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        173.479942,
                                                                                                                                                                        84.052231,
                                                                                                                                                                        173.206176,
                                                                                                                                                                        84.108289,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        193.953497,
                                                                                                                                                                        81.804968,
                                                                                                                                                                        193.696812, -211.946812,
                                                                                                                                                                        54.31873, -193.696812,
                                                                                                                                                                        54.31873, -193.907272,
                                                                                                                                                                        54.10827, -193.907272,
                                                                                                                                                                        46.831914, -193.907272,
                                                                                                                                                                        54.10827, -193.696812,
                                                                                                                                                                        54.31873, -200.399134,
                                                                                                                                                                        48.573046, -200.399134,
                                                                                                                                                                        50.073046, -197.149134,
                                                                                                                                                                        48.573046, -210.452139,
                                                                                                                                                                        48.573046, -210.452139,
                                                                                                                                                                        50.073046, -207.202139,
                                                                                                                                                                        48.573046, -207.202139,
                                                                                                                                                                        50.073046, -207.202139,
                                                                                                                                                                        48.573046, -210.452139,
                                                                                                                                                                        50.073046, -205.391638,
                                                                                                                                                                        48.573046, -205.391638,
                                                                                                                                                                        50.073046, -202.141638,
                                                                                                                                                                        48.573046, -202.141638,
                                                                                                                                                                        50.073046, -202.141638,
                                                                                                                                                                        48.573046, -205.391638,
                                                                                                                                                                        50.073046, -211.736351,
                                                                                                                                                                        46.831914, -211.946812,
                                                                                                                                                                        54.31873, -211.736351,
                                                                                                                                                                        54.10827, -211.946812,
                                                                                                                                                                        54.31873, -211.736351,
                                                                                                                                                                        46.831914, -211.946812,
                                                                                                                                                                        46.621453, -211.736351,
                                                                                                                                                                        46.831914, -193.907272,
                                                                                                                                                                        46.831914, -211.946812,
                                                                                                                                                                        46.621453, -211.946812,
                                                                                                                                                                        46.621453, -193.907272,
                                                                                                                                                                        46.831914, -193.696812,
                                                                                                                                                                        46.621453, -193.696812,
                                                                                                                                                                        54.31873, -193.696812,
                                                                                                                                                                        46.621453, -193.907272,
                                                                                                                                                                        46.831914,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        81.804968,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        82.061653,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        175.023391,
                                                                                                                                                                        129.943887,
                                                                                                                                                                        178.023391,
                                                                                                                                                                        129.943887,
                                                                                                                                                                        175.308391,
                                                                                                                                                                        129.390556,
                                                                                                                                                                        177.738391,
                                                                                                                                                                        129.390556,
                                                                                                                                                                        175.308391,
                                                                                                                                                                        129.390556,
                                                                                                                                                                        178.023391,
                                                                                                                                                                        129.943887, -203.437108,
                                                                                                                                                                        85.926407, -205.867108,
                                                                                                                                                                        85.926407, -203.152108,
                                                                                                                                                                        86.479737, -206.152108,
                                                                                                                                                                        86.479737, -203.152108,
                                                                                                                                                                        86.479737, -205.867108,
                                                                                                                                                                        85.926407, -26.628717,
                                                                                                                                                                        206.37643, -26.913717,
                                                                                                                                                                        205.823099, -29.628717,
                                                                                                                                                                        206.37643, -29.343717,
                                                                                                                                                                        205.823099, -29.628717,
                                                                                                                                                                        206.37643, -26.913717,
                                                                                                                                                                        205.823099, -177.738391, -110.402829, -178.023391, -109.849498, -175.308391, -110.402829, -175.023391, -109.849498, -175.308391, -110.402829, -178.023391, -109.849498,
                                                                                                                                                                        26.913717, -186.835372,
                                                                                                                                                                        26.628717, -186.282041,
                                                                                                                                                                        29.343717, -186.835372,
                                                                                                                                                                        29.628717, -186.282041,
                                                                                                                                                                        29.343717, -186.835372,
                                                                                                                                                                        26.628717, -186.282041,
                                                                                                                                                                        203.152108, -66.385349,
                                                                                                                                                                        206.152108, -66.385349,
                                                                                                                                                                        203.437108, -66.938679,
                                                                                                                                                                        205.867108, -66.938679,
                                                                                                                                                                        203.437108, -66.938679,
                                                                                                                                                                        206.152108, -66.385349,
                                                                                                                                                                        90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        202.161732,
                                                                                                                                                                        90.405443,
                                                                                                                                                                        211.690127,
                                                                                                                                                                        90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        90.479015,
                                                                                                                                                                        201.897592,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        90.61011,
                                                                                                                                                                        201.662043,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        90.662129,
                                                                                                                                                                        202.196812,
                                                                                                                                                                        90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        90.718115,
                                                                                                                                                                        201.995806,
                                                                                                                                                                        91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        90.792687,
                                                                                                                                                                        201.463713,
                                                                                                                                                                        90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        90.819587,
                                                                                                                                                                        201.813484,
                                                                                                                                                                        91.134228,
                                                                                                                                                                        201.543791,
                                                                                                                                                                        91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        90.960907,
                                                                                                                                                                        201.65997,
                                                                                                                                                                        91.269434,
                                                                                                                                                                        201.22009,
                                                                                                                                                                        91.016607,
                                                                                                                                                                        201.313617,
                                                                                                                                                                        91.134228,
                                                                                                                                                                        201.543791, -83.159659,
                                                                                                                                                                        15.817689, -80.570267,
                                                                                                                                                                        10.897689, -81.545833,
                                                                                                                                                                        11.486678, -96.193095,
                                                                                                                                                                        10.897689, -81.545833,
                                                                                                                                                                        11.486678, -80.570267,
                                                                                                                                                                        10.897689, -81.545833,
                                                                                                                                                                        11.486678, -96.193095,
                                                                                                                                                                        10.897689, -95.217529,
                                                                                                                                                                        11.486678, -93.603703,
                                                                                                                                                                        15.817689, -95.217529,
                                                                                                                                                                        11.486678, -96.193095,
                                                                                                                                                                        10.897689, -93.248106,
                                                                                                                                                                        15.228701, -95.217529,
                                                                                                                                                                        11.486678, -93.603703,
                                                                                                                                                                        15.817689, -83.515256,
                                                                                                                                                                        15.228701, -83.159659,
                                                                                                                                                                        15.817689, -81.545833,
                                                                                                                                                                        11.486678, -93.248106,
                                                                                                                                                                        15.228701, -83.159659,
                                                                                                                                                                        15.817689, -83.515256,
                                                                                                                                                                        15.228701, -83.159659,
                                                                                                                                                                        15.817689, -93.248106,
                                                                                                                                                                        15.228701, -93.603703,
                                                                                                                                                                        15.817689,
                                                                                                                                                                        211.946812, -38.333085,
                                                                                                                                                                        193.696812, -38.333085,
                                                                                                                                                                        193.997368, -38.032529,
                                                                                                                                                                        211.646256, -38.032529,
                                                                                                                                                                        211.946812, -38.333085,
                                                                                                                                                                        193.997368, -38.032529,
                                                                                                                                                                        195.693209, -36.463941,
                                                                                                                                                                        195.693209, -34.963941,
                                                                                                                                                                        198.943209, -36.463941,
                                                                                                                                                                        206.767114, -36.463941,
                                                                                                                                                                        206.767114, -34.963941,
                                                                                                                                                                        210.017114, -36.463941,
                                                                                                                                                                        201.335011, -36.463941,
                                                                                                                                                                        201.335011, -34.963941,
                                                                                                                                                                        204.585011, -36.463941, -211.736351,
                                                                                                                                                                        54.10827, -211.946812,
                                                                                                                                                                        54.31873, -193.907272,
                                                                                                                                                                        54.10827, -197.149134,
                                                                                                                                                                        50.073046, -197.149134,
                                                                                                                                                                        48.573046, -200.399134,
                                                                                                                                                                        50.073046, -76.813936,
                                                                                                                                                                        10.244433, -76.355567,
                                                                                                                                                                        10.357689, -76.813936,
                                                                                                                                                                        9.316059, -76.355567,
                                                                                                                                                                        10.357689, -76.355567,
                                                                                                                                                                        8.607689, -76.813936,
                                                                                                                                                                        9.316059, -111.005602, -9.316086, -111.041794, -10.916607, -111.502185, -11.274845, -110.63459, -9.3104, -111.041794, -10.916607, -111.005602, -9.316086, -110.045457, -10.916607, -111.502185, -11.274845, -111.041794, -10.916607, -111.502185, -11.274845, -110.045457, -10.916607, -109.933694, -11.274845, -107.1, -9.316086, -109.933694, -11.274845, -110.045457, -10.916607,
                                                                                                                                                                        8.226122,
                                                                                                                                                                        16.685519,
                                                                                                                                                                        13.734043,
                                                                                                                                                                        16.504471,
                                                                                                                                                                        13.618931,
                                                                                                                                                                        15.857689,
                                                                                                                                                                        8.314555,
                                                                                                                                                                        17.336396,
                                                                                                                                                                        13.734043,
                                                                                                                                                                        16.504471,
                                                                                                                                                                        8.226122,
                                                                                                                                                                        16.685519,
                                                                                                                                                                        49.046219,
                                                                                                                                                                        16.787915,
                                                                                                                                                                        49.553028,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        10.542366,
                                                                                                                                                                        52.453816,
                                                                                                                                                                        18.857689,
                                                                                                                                                                        49.553028,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        49.046219,
                                                                                                                                                                        16.787915,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998,
                                                                                                                                                                        22.5,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.695398,
                                                                                                                                                                        125.360096,
                                                                                                                                                                        9.26998,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998,
                                                                                                                                                                        126.022387,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        22.5,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        23.162291,
                                                                                                                                                                        9.26998, -100.407795,
                                                                                                                                                                        8.607689, -76.813936,
                                                                                                                                                                        9.316059, -76.355567,
                                                                                                                                                                        8.607689, -76.813936,
                                                                                                                                                                        9.316059, -100.407795,
                                                                                                                                                                        8.607689, -99.949426,
                                                                                                                                                                        9.316059, -70.166566,
                                                                                                                                                                        8.607689, -60.557553,
                                                                                                                                                                        8.607689, -70.166566,
                                                                                                                                                                        7.107689, -60.557553,
                                                                                                                                                                        7.107689, -70.166566,
                                                                                                                                                                        7.107689, -60.557553,
                                                                                                                                                                        8.607689, -75.703241,
                                                                                                                                                                        7.107689, -75.703241,
                                                                                                                                                                        8.607689, -66.094228,
                                                                                                                                                                        7.107689, -76.275271,
                                                                                                                                                                        8.607689, -76.275271,
                                                                                                                                                                        7.107689, -85.884284,
                                                                                                                                                                        8.607689, -85.884284,
                                                                                                                                                                        7.107689, -85.884284,
                                                                                                                                                                        8.607689, -76.275271,
                                                                                                                                                                        7.107689, -80.930861,
                                                                                                                                                                        8.607689, -80.930861,
                                                                                                                                                                        7.107689, -90.539874,
                                                                                                                                                                        8.607689, -90.539874,
                                                                                                                                                                        7.107689, -90.539874,
                                                                                                                                                                        8.607689, -80.930861,
                                                                                                                                                                        7.107689, -79.743728,
                                                                                                                                                                        8.607689, -79.743728,
                                                                                                                                                                        7.107689, -89.35274,
                                                                                                                                                                        8.607689, -89.35274,
                                                                                                                                                                        7.107689, -89.35274,
                                                                                                                                                                        8.607689, -79.743728,
                                                                                                                                                                        7.107689, -72.794772,
                                                                                                                                                                        7.107689, -82.403785,
                                                                                                                                                                        7.107689, -72.794772,
                                                                                                                                                                        8.607689, -82.403785,
                                                                                                                                                                        8.607689, -72.794772,
                                                                                                                                                                        8.607689, -82.403785,
                                                                                                                                                                        7.107689, -51.081553,
                                                                                                                                                                        8.607689, -51.081553,
                                                                                                                                                                        7.107689, -60.690566,
                                                                                                                                                                        8.607689, -41.869349,
                                                                                                                                                                        8.607689, -32.260336,
                                                                                                                                                                        8.607689, -41.869349,
                                                                                                                                                                        7.107689, -20.522224,
                                                                                                                                                                        8.607689, -10.913211,
                                                                                                                                                                        8.607689, -20.522224,
                                                                                                                                                                        7.107689, -10.913211,
                                                                                                                                                                        7.107689, -20.522224,
                                                                                                                                                                        7.107689, -10.913211,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        11.50505,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        1.896037,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        11.50505,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        1.896037,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        11.50505,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        1.896037,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        23.857668,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        33.466681,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        23.857668,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        33.466681,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        23.857668,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        33.466681,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        43.866019,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        43.866019,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        53.475031,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        53.475031,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        53.475031,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        43.866019,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        60.557553,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        70.166566,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        60.557553,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        78.930155,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        82.403785,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        72.794772,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        13.618931,
                                                                                                                                                                        15.857689,
                                                                                                                                                                        18.302948,
                                                                                                                                                                        15.578558,
                                                                                                                                                                        18.162476,
                                                                                                                                                                        14.936916,
                                                                                                                                                                        13.734043,
                                                                                                                                                                        16.504471,
                                                                                                                                                                        18.302948,
                                                                                                                                                                        15.578558,
                                                                                                                                                                        13.618931,
                                                                                                                                                                        15.857689,
                                                                                                                                                                        18.302948,
                                                                                                                                                                        15.578558,
                                                                                                                                                                        27.459507,
                                                                                                                                                                        13.423946,
                                                                                                                                                                        18.162476,
                                                                                                                                                                        14.936916,
                                                                                                                                                                        18.162476,
                                                                                                                                                                        14.936916,
                                                                                                                                                                        27.459507,
                                                                                                                                                                        13.423946,
                                                                                                                                                                        26.998664,
                                                                                                                                                                        12.857689,
                                                                                                                                                                        27.459507,
                                                                                                                                                                        13.423946,
                                                                                                                                                                        28.67278,
                                                                                                                                                                        10.817456,
                                                                                                                                                                        26.998664,
                                                                                                                                                                        12.857689,
                                                                                                                                                                        26.998664,
                                                                                                                                                                        12.857689,
                                                                                                                                                                        28.67278,
                                                                                                                                                                        10.817456,
                                                                                                                                                                        28.162369,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        28.67278,
                                                                                                                                                                        10.817456,
                                                                                                                                                                        31.263807,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        28.162369,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        31.082057,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        31.263807,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        31.082057,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        45.88899,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        45.88899,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        45.88899,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        49.553028,
                                                                                                                                                                        16.357689,
                                                                                                                                                                        45.88899,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        10.542366,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        10.542366,
                                                                                                                                                                        45.88899,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        45.232231,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        85.884284,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        85.884284,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        76.275271,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        66.094228,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        66.094228,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        75.703241,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        75.703241,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        75.703241,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        66.094228,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        51.081553,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        55.189544,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        51.081553,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        60.690566,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        51.081553,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        55.189544,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        20.522224,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        10.913211,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        20.522224,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        10.913211,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        20.522224,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        10.913211,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        41.869349,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        41.869349,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        32.260336,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        32.260336,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        32.260336,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        41.869349,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        60.690566,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        60.690566,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        55.189544,
                                                                                                                                                                        8.607689, -11.50505,
                                                                                                                                                                        8.607689, -1.896037,
                                                                                                                                                                        8.607689, -11.50505,
                                                                                                                                                                        7.107689, -1.896037,
                                                                                                                                                                        7.107689, -11.50505,
                                                                                                                                                                        7.107689, -1.896037,
                                                                                                                                                                        8.607689, -32.260336,
                                                                                                                                                                        7.107689, -41.869349,
                                                                                                                                                                        7.107689, -32.260336,
                                                                                                                                                                        8.607689, -60.690566,
                                                                                                                                                                        7.107689, -60.690566,
                                                                                                                                                                        8.607689, -51.081553,
                                                                                                                                                                        7.107689, -66.094228,
                                                                                                                                                                        8.607689, -66.094228,
                                                                                                                                                                        7.107689, -75.703241,
                                                                                                                                                                        8.607689, -43.866019,
                                                                                                                                                                        7.107689, -53.475031,
                                                                                                                                                                        7.107689, -43.866019,
                                                                                                                                                                        8.607689, -53.475031,
                                                                                                                                                                        8.607689, -43.866019,
                                                                                                                                                                        8.607689, -53.475031,
                                                                                                                                                                        7.107689, -23.857668,
                                                                                                                                                                        7.107689, -33.466681,
                                                                                                                                                                        7.107689, -23.857668,
                                                                                                                                                                        8.607689, -33.466681,
                                                                                                                                                                        8.607689, -23.857668,
                                                                                                                                                                        8.607689, -33.466681,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        89.35274,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        79.743728,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        89.35274,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        79.743728,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        89.35274,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        79.743728,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        90.539874,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        90.539874,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        80.930861,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        76.275271,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        76.275271,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        85.884284,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        80.930861,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        80.930861,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        90.539874,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        82.403785,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        78.930155,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        82.403785,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        72.794772,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        82.403785,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        78.930155,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        72.794772,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        82.403785,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        72.794772,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        70.166566,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        60.557553,
                                                                                                                                                                        7.107689,
                                                                                                                                                                        70.166566,
                                                                                                                                                                        8.607689,
                                                                                                                                                                        28.162369,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        31.263807,
                                                                                                                                                                        9.264448,
                                                                                                                                                                        31.082057,
                                                                                                                                                                        8.607689, -105.860276, -6.517858, -107.1, -9.316086, -107.386674, -9.078753, -107.386674, -9.078753, -107.1, -9.316086, -110.045457, -10.916607, -97.756683, -0.160349, -97.327811,
                                                                                                                                                                        0.197889, -98.488344, -4.204117,
                                                                                                                                                                        34.607116,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        54.81732,
                                                                                                                                                                        22.107689,
                                                                                                                                                                        54.793366,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        54.81732,
                                                                                                                                                                        22.107689,
                                                                                                                                                                        34.607116,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        34.584084,
                                                                                                                                                                        22.107689,
                                                                                                                                                                        34.584084,
                                                                                                                                                                        22.107689,
                                                                                                                                                                        34.607116,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        2.544756,
                                                                                                                                                                        19.857689,
                                                                                                                                                                        34.607116,
                                                                                                                                                                        21.45093,
                                                                                                                                                                        3.201515,
                                                                                                                                                                        19.245435,
                                                                                                                                                                        2.544756,
                                                                                                                                                                        19.857689,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "indices": [
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        2,
                                                                                                                                                                        3,
                                                                                                                                                                        4,
                                                                                                                                                                        5,
                                                                                                                                                                        6,
                                                                                                                                                                        7,
                                                                                                                                                                        8,
                                                                                                                                                                        9,
                                                                                                                                                                        10,
                                                                                                                                                                        11,
                                                                                                                                                                        12,
                                                                                                                                                                        13,
                                                                                                                                                                        14,
                                                                                                                                                                        15,
                                                                                                                                                                        16,
                                                                                                                                                                        17,
                                                                                                                                                                        18,
                                                                                                                                                                        19,
                                                                                                                                                                        20,
                                                                                                                                                                        21,
                                                                                                                                                                        22,
                                                                                                                                                                        23,
                                                                                                                                                                        24,
                                                                                                                                                                        25,
                                                                                                                                                                        26,
                                                                                                                                                                        27,
                                                                                                                                                                        28,
                                                                                                                                                                        29,
                                                                                                                                                                        30,
                                                                                                                                                                        31,
                                                                                                                                                                        32,
                                                                                                                                                                        33,
                                                                                                                                                                        34,
                                                                                                                                                                        35,
                                                                                                                                                                        36,
                                                                                                                                                                        37,
                                                                                                                                                                        38,
                                                                                                                                                                        39,
                                                                                                                                                                        40,
                                                                                                                                                                        41,
                                                                                                                                                                        42,
                                                                                                                                                                        43,
                                                                                                                                                                        44,
                                                                                                                                                                        45,
                                                                                                                                                                        46,
                                                                                                                                                                        47,
                                                                                                                                                                        48,
                                                                                                                                                                        49,
                                                                                                                                                                        50,
                                                                                                                                                                        51,
                                                                                                                                                                        52,
                                                                                                                                                                        53,
                                                                                                                                                                        54,
                                                                                                                                                                        55,
                                                                                                                                                                        56,
                                                                                                                                                                        57,
                                                                                                                                                                        58,
                                                                                                                                                                        59,
                                                                                                                                                                        60,
                                                                                                                                                                        61,
                                                                                                                                                                        62,
                                                                                                                                                                        63,
                                                                                                                                                                        64,
                                                                                                                                                                        65,
                                                                                                                                                                        66,
                                                                                                                                                                        67,
                                                                                                                                                                        68,
                                                                                                                                                                        69,
                                                                                                                                                                        70,
                                                                                                                                                                        71,
                                                                                                                                                                        72,
                                                                                                                                                                        73,
                                                                                                                                                                        74,
                                                                                                                                                                        75,
                                                                                                                                                                        76,
                                                                                                                                                                        77,
                                                                                                                                                                        78,
                                                                                                                                                                        79,
                                                                                                                                                                        80,
                                                                                                                                                                        81,
                                                                                                                                                                        82,
                                                                                                                                                                        83,
                                                                                                                                                                        84,
                                                                                                                                                                        85,
                                                                                                                                                                        86,
                                                                                                                                                                        87,
                                                                                                                                                                        88,
                                                                                                                                                                        89,
                                                                                                                                                                        90,
                                                                                                                                                                        91,
                                                                                                                                                                        92,
                                                                                                                                                                        93,
                                                                                                                                                                        94,
                                                                                                                                                                        95,
                                                                                                                                                                        96,
                                                                                                                                                                        97,
                                                                                                                                                                        98,
                                                                                                                                                                        99,
                                                                                                                                                                        100,
                                                                                                                                                                        101,
                                                                                                                                                                        102,
                                                                                                                                                                        103,
                                                                                                                                                                        104,
                                                                                                                                                                        105,
                                                                                                                                                                        106,
                                                                                                                                                                        107,
                                                                                                                                                                        108,
                                                                                                                                                                        109,
                                                                                                                                                                        110,
                                                                                                                                                                        111,
                                                                                                                                                                        112,
                                                                                                                                                                        113,
                                                                                                                                                                        114,
                                                                                                                                                                        115,
                                                                                                                                                                        116,
                                                                                                                                                                        117,
                                                                                                                                                                        118,
                                                                                                                                                                        119,
                                                                                                                                                                        120,
                                                                                                                                                                        121,
                                                                                                                                                                        122,
                                                                                                                                                                        123,
                                                                                                                                                                        124,
                                                                                                                                                                        125,
                                                                                                                                                                        126,
                                                                                                                                                                        127,
                                                                                                                                                                        128,
                                                                                                                                                                        129,
                                                                                                                                                                        130,
                                                                                                                                                                        131,
                                                                                                                                                                        132,
                                                                                                                                                                        133,
                                                                                                                                                                        134,
                                                                                                                                                                        135,
                                                                                                                                                                        136,
                                                                                                                                                                        137,
                                                                                                                                                                        138,
                                                                                                                                                                        139,
                                                                                                                                                                        140,
                                                                                                                                                                        141,
                                                                                                                                                                        142,
                                                                                                                                                                        143,
                                                                                                                                                                        144,
                                                                                                                                                                        145,
                                                                                                                                                                        146,
                                                                                                                                                                        147,
                                                                                                                                                                        148,
                                                                                                                                                                        149,
                                                                                                                                                                        150,
                                                                                                                                                                        151,
                                                                                                                                                                        152,
                                                                                                                                                                        153,
                                                                                                                                                                        154,
                                                                                                                                                                        155,
                                                                                                                                                                        156,
                                                                                                                                                                        157,
                                                                                                                                                                        158,
                                                                                                                                                                        159,
                                                                                                                                                                        160,
                                                                                                                                                                        161,
                                                                                                                                                                        162,
                                                                                                                                                                        163,
                                                                                                                                                                        164,
                                                                                                                                                                        165,
                                                                                                                                                                        166,
                                                                                                                                                                        167,
                                                                                                                                                                        168,
                                                                                                                                                                        169,
                                                                                                                                                                        170,
                                                                                                                                                                        171,
                                                                                                                                                                        172,
                                                                                                                                                                        173,
                                                                                                                                                                        174,
                                                                                                                                                                        175,
                                                                                                                                                                        176,
                                                                                                                                                                        177,
                                                                                                                                                                        178,
                                                                                                                                                                        179,
                                                                                                                                                                        180,
                                                                                                                                                                        181,
                                                                                                                                                                        182,
                                                                                                                                                                        183,
                                                                                                                                                                        184,
                                                                                                                                                                        185,
                                                                                                                                                                        186,
                                                                                                                                                                        187,
                                                                                                                                                                        188,
                                                                                                                                                                        189,
                                                                                                                                                                        190,
                                                                                                                                                                        191,
                                                                                                                                                                        192,
                                                                                                                                                                        193,
                                                                                                                                                                        194,
                                                                                                                                                                        195,
                                                                                                                                                                        196,
                                                                                                                                                                        197,
                                                                                                                                                                        198,
                                                                                                                                                                        199,
                                                                                                                                                                        200,
                                                                                                                                                                        201,
                                                                                                                                                                        202,
                                                                                                                                                                        203,
                                                                                                                                                                        204,
                                                                                                                                                                        205,
                                                                                                                                                                        206,
                                                                                                                                                                        207,
                                                                                                                                                                        208,
                                                                                                                                                                        209,
                                                                                                                                                                        210,
                                                                                                                                                                        211,
                                                                                                                                                                        212,
                                                                                                                                                                        213,
                                                                                                                                                                        214,
                                                                                                                                                                        215,
                                                                                                                                                                        216,
                                                                                                                                                                        217,
                                                                                                                                                                        218,
                                                                                                                                                                        219,
                                                                                                                                                                        220,
                                                                                                                                                                        221,
                                                                                                                                                                        222,
                                                                                                                                                                        223,
                                                                                                                                                                        224,
                                                                                                                                                                        225,
                                                                                                                                                                        226,
                                                                                                                                                                        227,
                                                                                                                                                                        228,
                                                                                                                                                                        229,
                                                                                                                                                                        230,
                                                                                                                                                                        231,
                                                                                                                                                                        232,
                                                                                                                                                                        233,
                                                                                                                                                                        234,
                                                                                                                                                                        235,
                                                                                                                                                                        236,
                                                                                                                                                                        237,
                                                                                                                                                                        238,
                                                                                                                                                                        239,
                                                                                                                                                                        240,
                                                                                                                                                                        241,
                                                                                                                                                                        242,
                                                                                                                                                                        243,
                                                                                                                                                                        244,
                                                                                                                                                                        245,
                                                                                                                                                                        246,
                                                                                                                                                                        247,
                                                                                                                                                                        248,
                                                                                                                                                                        249,
                                                                                                                                                                        250,
                                                                                                                                                                        251,
                                                                                                                                                                        252,
                                                                                                                                                                        253,
                                                                                                                                                                        254,
                                                                                                                                                                        255,
                                                                                                                                                                        256,
                                                                                                                                                                        257,
                                                                                                                                                                        258,
                                                                                                                                                                        259,
                                                                                                                                                                        260,
                                                                                                                                                                        261,
                                                                                                                                                                        262,
                                                                                                                                                                        263,
                                                                                                                                                                        264,
                                                                                                                                                                        265,
                                                                                                                                                                        266,
                                                                                                                                                                        267,
                                                                                                                                                                        268,
                                                                                                                                                                        269,
                                                                                                                                                                        270,
                                                                                                                                                                        271,
                                                                                                                                                                        272,
                                                                                                                                                                        273,
                                                                                                                                                                        274,
                                                                                                                                                                        275,
                                                                                                                                                                        276,
                                                                                                                                                                        277,
                                                                                                                                                                        278,
                                                                                                                                                                        279,
                                                                                                                                                                        280,
                                                                                                                                                                        281,
                                                                                                                                                                        282,
                                                                                                                                                                        283,
                                                                                                                                                                        284,
                                                                                                                                                                        285,
                                                                                                                                                                        286,
                                                                                                                                                                        287,
                                                                                                                                                                        288,
                                                                                                                                                                        289,
                                                                                                                                                                        290,
                                                                                                                                                                        291,
                                                                                                                                                                        292,
                                                                                                                                                                        293,
                                                                                                                                                                        294,
                                                                                                                                                                        295,
                                                                                                                                                                        296,
                                                                                                                                                                        297,
                                                                                                                                                                        298,
                                                                                                                                                                        299,
                                                                                                                                                                        300,
                                                                                                                                                                        301,
                                                                                                                                                                        302,
                                                                                                                                                                        303,
                                                                                                                                                                        304,
                                                                                                                                                                        305,
                                                                                                                                                                        306,
                                                                                                                                                                        307,
                                                                                                                                                                        308,
                                                                                                                                                                        309,
                                                                                                                                                                        310,
                                                                                                                                                                        311,
                                                                                                                                                                        312,
                                                                                                                                                                        313,
                                                                                                                                                                        314,
                                                                                                                                                                        315,
                                                                                                                                                                        316,
                                                                                                                                                                        317,
                                                                                                                                                                        318,
                                                                                                                                                                        319,
                                                                                                                                                                        320,
                                                                                                                                                                        321,
                                                                                                                                                                        322,
                                                                                                                                                                        323,
                                                                                                                                                                        324,
                                                                                                                                                                        325,
                                                                                                                                                                        326,
                                                                                                                                                                        327,
                                                                                                                                                                        328,
                                                                                                                                                                        329,
                                                                                                                                                                        330,
                                                                                                                                                                        331,
                                                                                                                                                                        332,
                                                                                                                                                                        333,
                                                                                                                                                                        334,
                                                                                                                                                                        335,
                                                                                                                                                                        336,
                                                                                                                                                                        337,
                                                                                                                                                                        338,
                                                                                                                                                                        339,
                                                                                                                                                                        340,
                                                                                                                                                                        341,
                                                                                                                                                                        342,
                                                                                                                                                                        343,
                                                                                                                                                                        344,
                                                                                                                                                                        345,
                                                                                                                                                                        346,
                                                                                                                                                                        347,
                                                                                                                                                                        348,
                                                                                                                                                                        349,
                                                                                                                                                                        350,
                                                                                                                                                                        351,
                                                                                                                                                                        352,
                                                                                                                                                                        353,
                                                                                                                                                                        354,
                                                                                                                                                                        355,
                                                                                                                                                                        356,
                                                                                                                                                                        357,
                                                                                                                                                                        358,
                                                                                                                                                                        359,
                                                                                                                                                                        360,
                                                                                                                                                                        361,
                                                                                                                                                                        362,
                                                                                                                                                                        363,
                                                                                                                                                                        364,
                                                                                                                                                                        365,
                                                                                                                                                                        366,
                                                                                                                                                                        367,
                                                                                                                                                                        368,
                                                                                                                                                                        369,
                                                                                                                                                                        370,
                                                                                                                                                                        371,
                                                                                                                                                                        372,
                                                                                                                                                                        373,
                                                                                                                                                                        374,
                                                                                                                                                                        375,
                                                                                                                                                                        376,
                                                                                                                                                                        377,
                                                                                                                                                                        378,
                                                                                                                                                                        379,
                                                                                                                                                                        380,
                                                                                                                                                                        381,
                                                                                                                                                                        382,
                                                                                                                                                                        383,
                                                                                                                                                                        384,
                                                                                                                                                                        385,
                                                                                                                                                                        386,
                                                                                                                                                                        387,
                                                                                                                                                                        388,
                                                                                                                                                                        389,
                                                                                                                                                                        390,
                                                                                                                                                                        391,
                                                                                                                                                                        392,
                                                                                                                                                                        393,
                                                                                                                                                                        394,
                                                                                                                                                                        395,
                                                                                                                                                                        396,
                                                                                                                                                                        397,
                                                                                                                                                                        398,
                                                                                                                                                                        399,
                                                                                                                                                                        400,
                                                                                                                                                                        401,
                                                                                                                                                                        402,
                                                                                                                                                                        403,
                                                                                                                                                                        404,
                                                                                                                                                                        405,
                                                                                                                                                                        406,
                                                                                                                                                                        407,
                                                                                                                                                                        408,
                                                                                                                                                                        409,
                                                                                                                                                                        410,
                                                                                                                                                                        411,
                                                                                                                                                                        412,
                                                                                                                                                                        413,
                                                                                                                                                                        414,
                                                                                                                                                                        415,
                                                                                                                                                                        416,
                                                                                                                                                                        417,
                                                                                                                                                                        418,
                                                                                                                                                                        419,
                                                                                                                                                                        420,
                                                                                                                                                                        421,
                                                                                                                                                                        422,
                                                                                                                                                                        423,
                                                                                                                                                                        424,
                                                                                                                                                                        425,
                                                                                                                                                                        426,
                                                                                                                                                                        427,
                                                                                                                                                                        428,
                                                                                                                                                                        429,
                                                                                                                                                                        430,
                                                                                                                                                                        431,
                                                                                                                                                                        432,
                                                                                                                                                                        433,
                                                                                                                                                                        434,
                                                                                                                                                                        435,
                                                                                                                                                                        436,
                                                                                                                                                                        437,
                                                                                                                                                                        438,
                                                                                                                                                                        439,
                                                                                                                                                                        440,
                                                                                                                                                                        441,
                                                                                                                                                                        442,
                                                                                                                                                                        443,
                                                                                                                                                                        444,
                                                                                                                                                                        445,
                                                                                                                                                                        446,
                                                                                                                                                                        447,
                                                                                                                                                                        448,
                                                                                                                                                                        449,
                                                                                                                                                                        450,
                                                                                                                                                                        451,
                                                                                                                                                                        452,
                                                                                                                                                                        453,
                                                                                                                                                                        454,
                                                                                                                                                                        455,
                                                                                                                                                                        456,
                                                                                                                                                                        457,
                                                                                                                                                                        458,
                                                                                                                                                                        459,
                                                                                                                                                                        460,
                                                                                                                                                                        461,
                                                                                                                                                                        462,
                                                                                                                                                                        463,
                                                                                                                                                                        464,
                                                                                                                                                                        465,
                                                                                                                                                                        466,
                                                                                                                                                                        467,
                                                                                                                                                                        468,
                                                                                                                                                                        469,
                                                                                                                                                                        470,
                                                                                                                                                                        471,
                                                                                                                                                                        472,
                                                                                                                                                                        473,
                                                                                                                                                                        474,
                                                                                                                                                                        475,
                                                                                                                                                                        476,
                                                                                                                                                                        477,
                                                                                                                                                                        478,
                                                                                                                                                                        479,
                                                                                                                                                                        480,
                                                                                                                                                                        481,
                                                                                                                                                                        482,
                                                                                                                                                                        483,
                                                                                                                                                                        484,
                                                                                                                                                                        485,
                                                                                                                                                                        486,
                                                                                                                                                                        487,
                                                                                                                                                                        488,
                                                                                                                                                                        489,
                                                                                                                                                                        490,
                                                                                                                                                                        491,
                                                                                                                                                                        492,
                                                                                                                                                                        493,
                                                                                                                                                                        494,
                                                                                                                                                                        495,
                                                                                                                                                                        496,
                                                                                                                                                                        497,
                                                                                                                                                                        498,
                                                                                                                                                                        499,
                                                                                                                                                                        500,
                                                                                                                                                                        501,
                                                                                                                                                                        502,
                                                                                                                                                                        503,
                                                                                                                                                                        504,
                                                                                                                                                                        505,
                                                                                                                                                                        506,
                                                                                                                                                                        507,
                                                                                                                                                                        508,
                                                                                                                                                                        509,
                                                                                                                                                                        510,
                                                                                                                                                                        511,
                                                                                                                                                                        512,
                                                                                                                                                                        513,
                                                                                                                                                                        514,
                                                                                                                                                                        515,
                                                                                                                                                                        516,
                                                                                                                                                                        517,
                                                                                                                                                                        518,
                                                                                                                                                                        519,
                                                                                                                                                                        520,
                                                                                                                                                                        521,
                                                                                                                                                                        522,
                                                                                                                                                                        523,
                                                                                                                                                                        524,
                                                                                                                                                                        525,
                                                                                                                                                                        526,
                                                                                                                                                                        527,
                                                                                                                                                                        528,
                                                                                                                                                                        529,
                                                                                                                                                                        530,
                                                                                                                                                                        531,
                                                                                                                                                                        532,
                                                                                                                                                                        533,
                                                                                                                                                                        534,
                                                                                                                                                                        535,
                                                                                                                                                                        536,
                                                                                                                                                                        537,
                                                                                                                                                                        538,
                                                                                                                                                                        539,
                                                                                                                                                                        540,
                                                                                                                                                                        541,
                                                                                                                                                                        542,
                                                                                                                                                                        543,
                                                                                                                                                                        544,
                                                                                                                                                                        545,
                                                                                                                                                                        546,
                                                                                                                                                                        547,
                                                                                                                                                                        548,
                                                                                                                                                                        549,
                                                                                                                                                                        550,
                                                                                                                                                                        551,
                                                                                                                                                                        552,
                                                                                                                                                                        553,
                                                                                                                                                                        554,
                                                                                                                                                                        555,
                                                                                                                                                                        556,
                                                                                                                                                                        557,
                                                                                                                                                                        558,
                                                                                                                                                                        559,
                                                                                                                                                                        560,
                                                                                                                                                                        561,
                                                                                                                                                                        562,
                                                                                                                                                                        563,
                                                                                                                                                                        564,
                                                                                                                                                                        565,
                                                                                                                                                                        566,
                                                                                                                                                                        567,
                                                                                                                                                                        568,
                                                                                                                                                                        569,
                                                                                                                                                                        570,
                                                                                                                                                                        571,
                                                                                                                                                                        572,
                                                                                                                                                                        573,
                                                                                                                                                                        574,
                                                                                                                                                                        575,
                                                                                                                                                                        576,
                                                                                                                                                                        577,
                                                                                                                                                                        578,
                                                                                                                                                                        579,
                                                                                                                                                                        580,
                                                                                                                                                                        581,
                                                                                                                                                                        582,
                                                                                                                                                                        583,
                                                                                                                                                                        584,
                                                                                                                                                                        585,
                                                                                                                                                                        586,
                                                                                                                                                                        587,
                                                                                                                                                                        588,
                                                                                                                                                                        589,
                                                                                                                                                                        590,
                                                                                                                                                                        591,
                                                                                                                                                                        592,
                                                                                                                                                                        593,
                                                                                                                                                                        594,
                                                                                                                                                                        595,
                                                                                                                                                                        596,
                                                                                                                                                                        597,
                                                                                                                                                                        598,
                                                                                                                                                                        599,
                                                                                                                                                                        600,
                                                                                                                                                                        601,
                                                                                                                                                                        602,
                                                                                                                                                                        603,
                                                                                                                                                                        604,
                                                                                                                                                                        605,
                                                                                                                                                                        606,
                                                                                                                                                                        607,
                                                                                                                                                                        608,
                                                                                                                                                                        609,
                                                                                                                                                                        610,
                                                                                                                                                                        611,
                                                                                                                                                                        612,
                                                                                                                                                                        613,
                                                                                                                                                                        614,
                                                                                                                                                                        615,
                                                                                                                                                                        616,
                                                                                                                                                                        617,
                                                                                                                                                                        618,
                                                                                                                                                                        619,
                                                                                                                                                                        620,
                                                                                                                                                                        621,
                                                                                                                                                                        622,
                                                                                                                                                                        623,
                                                                                                                                                                        624,
                                                                                                                                                                        625,
                                                                                                                                                                        626,
                                                                                                                                                                        627,
                                                                                                                                                                        628,
                                                                                                                                                                        629,
                                                                                                                                                                        630,
                                                                                                                                                                        631,
                                                                                                                                                                        632,
                                                                                                                                                                        633,
                                                                                                                                                                        634,
                                                                                                                                                                        635,
                                                                                                                                                                        636,
                                                                                                                                                                        637,
                                                                                                                                                                        638,
                                                                                                                                                                        639,
                                                                                                                                                                        640,
                                                                                                                                                                        641,
                                                                                                                                                                        642,
                                                                                                                                                                        643,
                                                                                                                                                                        644,
                                                                                                                                                                        645,
                                                                                                                                                                        646,
                                                                                                                                                                        647,
                                                                                                                                                                        648,
                                                                                                                                                                        649,
                                                                                                                                                                        650,
                                                                                                                                                                        651,
                                                                                                                                                                        652,
                                                                                                                                                                        653,
                                                                                                                                                                        654,
                                                                                                                                                                        655,
                                                                                                                                                                        656,
                                                                                                                                                                        657,
                                                                                                                                                                        658,
                                                                                                                                                                        659,
                                                                                                                                                                        660,
                                                                                                                                                                        661,
                                                                                                                                                                        662,
                                                                                                                                                                        663,
                                                                                                                                                                        664,
                                                                                                                                                                        665,
                                                                                                                                                                        666,
                                                                                                                                                                        667,
                                                                                                                                                                        668,
                                                                                                                                                                        669,
                                                                                                                                                                        670,
                                                                                                                                                                        671,
                                                                                                                                                                        672,
                                                                                                                                                                        673,
                                                                                                                                                                        674,
                                                                                                                                                                        675,
                                                                                                                                                                        676,
                                                                                                                                                                        677,
                                                                                                                                                                        678,
                                                                                                                                                                        679,
                                                                                                                                                                        680,
                                                                                                                                                                        681,
                                                                                                                                                                        682,
                                                                                                                                                                        683,
                                                                                                                                                                        684,
                                                                                                                                                                        685,
                                                                                                                                                                        686,
                                                                                                                                                                        687,
                                                                                                                                                                        688,
                                                                                                                                                                        689,
                                                                                                                                                                        690,
                                                                                                                                                                        691,
                                                                                                                                                                        692,
                                                                                                                                                                        693,
                                                                                                                                                                        694,
                                                                                                                                                                        695,
                                                                                                                                                                        696,
                                                                                                                                                                        697,
                                                                                                                                                                        698,
                                                                                                                                                                        699,
                                                                                                                                                                        700,
                                                                                                                                                                        701,
                                                                                                                                                                        702,
                                                                                                                                                                        703,
                                                                                                                                                                        704,
                                                                                                                                                                        705,
                                                                                                                                                                        706,
                                                                                                                                                                        707,
                                                                                                                                                                        708,
                                                                                                                                                                        709,
                                                                                                                                                                        710,
                                                                                                                                                                        711,
                                                                                                                                                                        712,
                                                                                                                                                                        713,
                                                                                                                                                                        714,
                                                                                                                                                                        715,
                                                                                                                                                                        716,
                                                                                                                                                                        717,
                                                                                                                                                                        718,
                                                                                                                                                                        719,
                                                                                                                                                                        720,
                                                                                                                                                                        721,
                                                                                                                                                                        722,
                                                                                                                                                                        723,
                                                                                                                                                                        724,
                                                                                                                                                                        725,
                                                                                                                                                                        726,
                                                                                                                                                                        727,
                                                                                                                                                                        728,
                                                                                                                                                                        729,
                                                                                                                                                                        730,
                                                                                                                                                                        731,
                                                                                                                                                                        732,
                                                                                                                                                                        733,
                                                                                                                                                                        734,
                                                                                                                                                                        735,
                                                                                                                                                                        736,
                                                                                                                                                                        737,
                                                                                                                                                                        738,
                                                                                                                                                                        739,
                                                                                                                                                                        740,
                                                                                                                                                                        741,
                                                                                                                                                                        742,
                                                                                                                                                                        743,
                                                                                                                                                                        744,
                                                                                                                                                                        745,
                                                                                                                                                                        746,
                                                                                                                                                                        747,
                                                                                                                                                                        748,
                                                                                                                                                                        749,
                                                                                                                                                                        750,
                                                                                                                                                                        751,
                                                                                                                                                                        752,
                                                                                                                                                                        753,
                                                                                                                                                                        754,
                                                                                                                                                                        755,
                                                                                                                                                                        756,
                                                                                                                                                                        757,
                                                                                                                                                                        758,
                                                                                                                                                                        759,
                                                                                                                                                                        760,
                                                                                                                                                                        761,
                                                                                                                                                                        762,
                                                                                                                                                                        763,
                                                                                                                                                                        764,
                                                                                                                                                                        765,
                                                                                                                                                                        766,
                                                                                                                                                                        767,
                                                                                                                                                                        768,
                                                                                                                                                                        769,
                                                                                                                                                                        770,
                                                                                                                                                                        771,
                                                                                                                                                                        772,
                                                                                                                                                                        773,
                                                                                                                                                                        774,
                                                                                                                                                                        775,
                                                                                                                                                                        776,
                                                                                                                                                                        777,
                                                                                                                                                                        778,
                                                                                                                                                                        779,
                                                                                                                                                                        780,
                                                                                                                                                                        781,
                                                                                                                                                                        782,
                                                                                                                                                                        783,
                                                                                                                                                                        784,
                                                                                                                                                                        785,
                                                                                                                                                                        786,
                                                                                                                                                                        787,
                                                                                                                                                                        788,
                                                                                                                                                                        789,
                                                                                                                                                                        790,
                                                                                                                                                                        791,
                                                                                                                                                                        792,
                                                                                                                                                                        793,
                                                                                                                                                                        794,
                                                                                                                                                                        795,
                                                                                                                                                                        796,
                                                                                                                                                                        797,
                                                                                                                                                                        798,
                                                                                                                                                                        799,
                                                                                                                                                                        800,
                                                                                                                                                                        801,
                                                                                                                                                                        802,
                                                                                                                                                                        803,
                                                                                                                                                                        804,
                                                                                                                                                                        805,
                                                                                                                                                                        806,
                                                                                                                                                                        807,
                                                                                                                                                                        808,
                                                                                                                                                                        809,
                                                                                                                                                                        810,
                                                                                                                                                                        811,
                                                                                                                                                                        812,
                                                                                                                                                                        813,
                                                                                                                                                                        814,
                                                                                                                                                                        815,
                                                                                                                                                                        816,
                                                                                                                                                                        817,
                                                                                                                                                                        818,
                                                                                                                                                                        819,
                                                                                                                                                                        820,
                                                                                                                                                                        821,
                                                                                                                                                                        822,
                                                                                                                                                                        823,
                                                                                                                                                                        824,
                                                                                                                                                                        825,
                                                                                                                                                                        826,
                                                                                                                                                                        827,
                                                                                                                                                                        828,
                                                                                                                                                                        829,
                                                                                                                                                                        830,
                                                                                                                                                                        831,
                                                                                                                                                                        832,
                                                                                                                                                                        833,
                                                                                                                                                                        834,
                                                                                                                                                                        835,
                                                                                                                                                                        836,
                                                                                                                                                                        837,
                                                                                                                                                                        838,
                                                                                                                                                                        839,
                                                                                                                                                                        840,
                                                                                                                                                                        841,
                                                                                                                                                                        842,
                                                                                                                                                                        843,
                                                                                                                                                                        844,
                                                                                                                                                                        845,
                                                                                                                                                                        846,
                                                                                                                                                                        847,
                                                                                                                                                                        848,
                                                                                                                                                                        849,
                                                                                                                                                                        850,
                                                                                                                                                                        851,
                                                                                                                                                                        852,
                                                                                                                                                                        853,
                                                                                                                                                                        854,
                                                                                                                                                                        855,
                                                                                                                                                                        856,
                                                                                                                                                                        857,
                                                                                                                                                                        858,
                                                                                                                                                                        859,
                                                                                                                                                                        860,
                                                                                                                                                                        861,
                                                                                                                                                                        862,
                                                                                                                                                                        863,
                                                                                                                                                                        864,
                                                                                                                                                                        865,
                                                                                                                                                                        866,
                                                                                                                                                                        867,
                                                                                                                                                                        868,
                                                                                                                                                                        869,
                                                                                                                                                                        870,
                                                                                                                                                                        871,
                                                                                                                                                                        872,
                                                                                                                                                                        873,
                                                                                                                                                                        874,
                                                                                                                                                                        875,
                                                                                                                                                                        876,
                                                                                                                                                                        877,
                                                                                                                                                                        878,
                                                                                                                                                                        879,
                                                                                                                                                                        880,
                                                                                                                                                                        881,
                                                                                                                                                                        882,
                                                                                                                                                                        883,
                                                                                                                                                                        884,
                                                                                                                                                                        885,
                                                                                                                                                                        886,
                                                                                                                                                                        887,
                                                                                                                                                                        888,
                                                                                                                                                                        889,
                                                                                                                                                                        890,
                                                                                                                                                                        891,
                                                                                                                                                                        892,
                                                                                                                                                                        893,
                                                                                                                                                                        894,
                                                                                                                                                                        895,
                                                                                                                                                                        896,
                                                                                                                                                                        897,
                                                                                                                                                                        898,
                                                                                                                                                                        899,
                                                                                                                                                                        900,
                                                                                                                                                                        901,
                                                                                                                                                                        902,
                                                                                                                                                                        903,
                                                                                                                                                                        904,
                                                                                                                                                                        905,
                                                                                                                                                                        906,
                                                                                                                                                                        907,
                                                                                                                                                                        908,
                                                                                                                                                                        909,
                                                                                                                                                                        910,
                                                                                                                                                                        911,
                                                                                                                                                                        912,
                                                                                                                                                                        913,
                                                                                                                                                                        914,
                                                                                                                                                                        915,
                                                                                                                                                                        916,
                                                                                                                                                                        917,
                                                                                                                                                                        918,
                                                                                                                                                                        919,
                                                                                                                                                                        920,
                                                                                                                                                                        921,
                                                                                                                                                                        922,
                                                                                                                                                                        923,
                                                                                                                                                                        924,
                                                                                                                                                                        925,
                                                                                                                                                                        926,
                                                                                                                                                                        927,
                                                                                                                                                                        928,
                                                                                                                                                                        929,
                                                                                                                                                                        930,
                                                                                                                                                                        931,
                                                                                                                                                                        932,
                                                                                                                                                                        933,
                                                                                                                                                                        934,
                                                                                                                                                                        935,
                                                                                                                                                                        936,
                                                                                                                                                                        937,
                                                                                                                                                                        938,
                                                                                                                                                                        939,
                                                                                                                                                                        940,
                                                                                                                                                                        941,
                                                                                                                                                                        942,
                                                                                                                                                                        943,
                                                                                                                                                                        944,
                                                                                                                                                                        945,
                                                                                                                                                                        946,
                                                                                                                                                                        947,
                                                                                                                                                                        948,
                                                                                                                                                                        949,
                                                                                                                                                                        950,
                                                                                                                                                                        951,
                                                                                                                                                                        952,
                                                                                                                                                                        953,
                                                                                                                                                                        954
                                                                                                                                                                    ]
                                                                                                                                                                }
                                                                                                                                                            ]
                                                                                                                                                        }, {
                                                                                                                                                            "type": "material",
                                                                                                                                                            "baseColor": {
                                                                                                                                                                "r": 0.286275,
                                                                                                                                                                "g": 0.27451,
                                                                                                                                                                "b": 0.298039
                                                                                                                                                            },
                                                                                                                                                            "specularColor": {
                                                                                                                                                                "r": 0.33,
                                                                                                                                                                "g": 0.33,
                                                                                                                                                                "b": 0.33,
                                                                                                                                                                "a": 1
                                                                                                                                                            },
                                                                                                                                                            "shine": 10,
                                                                                                                                                            "specular": 1,
                                                                                                                                                            "nodes": [{
                                                                                                                                                                    "type": "geometry",
                                                                                                                                                                    "positions": [-72.492396,
                                                                                                                                                                        86.935388,
                                                                                                                                                                        12.857689, -69.712025,
                                                                                                                                                                        84.874226,
                                                                                                                                                                        13.709922, -69.468419,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -69.712025,
                                                                                                                                                                        84.874226,
                                                                                                                                                                        13.709922, -61.468359,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -69.468419,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -69.712025,
                                                                                                                                                                        84.874226,
                                                                                                                                                                        13.709922, -66.247696,
                                                                                                                                                                        82.367812,
                                                                                                                                                                        14.664789, -61.468359,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        67.849489,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -36.723564,
                                                                                                                                                                        68.149188,
                                                                                                                                                                        18.107689, -35.016236,
                                                                                                                                                                        61.777355,
                                                                                                                                                                        17.357689, -36.723564,
                                                                                                                                                                        68.149188,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -36.723564,
                                                                                                                                                                        68.149188,
                                                                                                                                                                        18.107689, -35.016236,
                                                                                                                                                                        61.777355,
                                                                                                                                                                        17.357689, -34.602262,
                                                                                                                                                                        69.027859,
                                                                                                                                                                        18.107689, -31.303959,
                                                                                                                                                                        63.315031,
                                                                                                                                                                        17.357689, -34.602262,
                                                                                                                                                                        69.027859,
                                                                                                                                                                        18.107689, -35.016236,
                                                                                                                                                                        61.777355,
                                                                                                                                                                        17.357689, -34.602262,
                                                                                                                                                                        69.027859,
                                                                                                                                                                        18.107689, -31.303959,
                                                                                                                                                                        63.315031,
                                                                                                                                                                        17.357689, -32.78066,
                                                                                                                                                                        70.425624,
                                                                                                                                                                        18.107689, -28.116155,
                                                                                                                                                                        65.761119,
                                                                                                                                                                        17.357689, -32.78066,
                                                                                                                                                                        70.425624,
                                                                                                                                                                        18.107689, -31.303959,
                                                                                                                                                                        63.315031,
                                                                                                                                                                        17.357689, -32.78066,
                                                                                                                                                                        70.425624,
                                                                                                                                                                        18.107689, -28.116155,
                                                                                                                                                                        65.761119,
                                                                                                                                                                        17.357689, -31.382895,
                                                                                                                                                                        72.247227,
                                                                                                                                                                        18.107689, -25.670067,
                                                                                                                                                                        68.948924,
                                                                                                                                                                        17.357689, -31.382895,
                                                                                                                                                                        72.247227,
                                                                                                                                                                        18.107689, -28.116155,
                                                                                                                                                                        65.761119,
                                                                                                                                                                        17.357689, -31.382895,
                                                                                                                                                                        72.247227,
                                                                                                                                                                        18.107689, -25.670067,
                                                                                                                                                                        68.948924,
                                                                                                                                                                        17.357689, -30.504224,
                                                                                                                                                                        74.368528,
                                                                                                                                                                        18.107689, -24.132391,
                                                                                                                                                                        72.6612,
                                                                                                                                                                        17.357689, -30.504224,
                                                                                                                                                                        74.368528,
                                                                                                                                                                        18.107689, -25.670067,
                                                                                                                                                                        68.948924,
                                                                                                                                                                        17.357689, -30.504224,
                                                                                                                                                                        74.368528,
                                                                                                                                                                        18.107689, -24.132391,
                                                                                                                                                                        72.6612,
                                                                                                                                                                        17.357689, -30.204525,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -23.607919,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -30.204525,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -24.132391,
                                                                                                                                                                        72.6612,
                                                                                                                                                                        17.357689, -23.607919,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -24.132391,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -30.204525,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -24.132391,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -23.607919,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -16.531641,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -15.739043,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -16.531641,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -23.607919,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -16.531641,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -15.739043,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -5.016894,
                                                                                                                                                                        85.75071,
                                                                                                                                                                        12.857689, -3.8181,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        12.857689, -5.016894,
                                                                                                                                                                        85.75071,
                                                                                                                                                                        12.857689, -15.739043,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -3.8181,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        12.857689, -15.739043,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -5.016894,
                                                                                                                                                                        67.539218,
                                                                                                                                                                        12.857689, -16.531641,
                                                                                                                                                                        70.624585,
                                                                                                                                                                        15.857689, -5.016894,
                                                                                                                                                                        67.539218,
                                                                                                                                                                        12.857689, -15.739043,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -5.016894,
                                                                                                                                                                        67.539218,
                                                                                                                                                                        12.857689, -16.531641,
                                                                                                                                                                        70.624585,
                                                                                                                                                                        15.857689, -8.531581,
                                                                                                                                                                        59.054014,
                                                                                                                                                                        12.857689, -18.85542,
                                                                                                                                                                        65.014485,
                                                                                                                                                                        15.857689, -8.531581,
                                                                                                                                                                        59.054014,
                                                                                                                                                                        12.857689, -16.531641,
                                                                                                                                                                        70.624585,
                                                                                                                                                                        15.857689, -8.531581,
                                                                                                                                                                        59.054014,
                                                                                                                                                                        12.857689, -18.85542,
                                                                                                                                                                        65.014485,
                                                                                                                                                                        15.857689, -14.12264,
                                                                                                                                                                        51.767604,
                                                                                                                                                                        12.857689, -22.552019,
                                                                                                                                                                        60.196983,
                                                                                                                                                                        15.857689, -14.12264,
                                                                                                                                                                        51.767604,
                                                                                                                                                                        12.857689, -18.85542,
                                                                                                                                                                        65.014485,
                                                                                                                                                                        15.857689, -14.12264,
                                                                                                                                                                        51.767604,
                                                                                                                                                                        12.857689, -22.552019,
                                                                                                                                                                        60.196983,
                                                                                                                                                                        15.857689, -21.40905,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -27.369521,
                                                                                                                                                                        56.500384,
                                                                                                                                                                        15.857689, -21.40905,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -22.552019,
                                                                                                                                                                        60.196983,
                                                                                                                                                                        15.857689, -21.40905,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -27.369521,
                                                                                                                                                                        56.500384,
                                                                                                                                                                        15.857689, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -32.226303,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -27.369521,
                                                                                                                                                                        56.500384,
                                                                                                                                                                        15.857689, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -32.226303,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -32,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -32.198546,
                                                                                                                                                                        51.261593,
                                                                                                                                                                        15.098225, -33.863822,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        16.226418, -35.016236,
                                                                                                                                                                        61.777355,
                                                                                                                                                                        17.357689, -32.937822,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        16.226418, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -35.016236,
                                                                                                                                                                        61.777355,
                                                                                                                                                                        17.357689, -35.016236,
                                                                                                                                                                        61.777355,
                                                                                                                                                                        17.357689, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -31.303959,
                                                                                                                                                                        63.315031,
                                                                                                                                                                        17.357689, -32.238519,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -32.226303,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -31.303959,
                                                                                                                                                                        63.315031,
                                                                                                                                                                        17.357689, -27.369521,
                                                                                                                                                                        56.500384,
                                                                                                                                                                        15.857689, -31.303959,
                                                                                                                                                                        63.315031,
                                                                                                                                                                        17.357689, -32.226303,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -31.303959,
                                                                                                                                                                        63.315031,
                                                                                                                                                                        17.357689, -27.369521,
                                                                                                                                                                        56.500384,
                                                                                                                                                                        15.857689, -28.116155,
                                                                                                                                                                        65.761119,
                                                                                                                                                                        17.357689, -22.552019,
                                                                                                                                                                        60.196983,
                                                                                                                                                                        15.857689, -28.116155,
                                                                                                                                                                        65.761119,
                                                                                                                                                                        17.357689, -27.369521,
                                                                                                                                                                        56.500384,
                                                                                                                                                                        15.857689, -28.116155,
                                                                                                                                                                        65.761119,
                                                                                                                                                                        17.357689, -22.552019,
                                                                                                                                                                        60.196983,
                                                                                                                                                                        15.857689, -25.670067,
                                                                                                                                                                        68.948924,
                                                                                                                                                                        17.357689, -18.85542,
                                                                                                                                                                        65.014485,
                                                                                                                                                                        15.857689, -25.670067,
                                                                                                                                                                        68.948924,
                                                                                                                                                                        17.357689, -22.552019,
                                                                                                                                                                        60.196983,
                                                                                                                                                                        15.857689, -25.670067,
                                                                                                                                                                        68.948924,
                                                                                                                                                                        17.357689, -18.85542,
                                                                                                                                                                        65.014485,
                                                                                                                                                                        15.857689, -24.132391,
                                                                                                                                                                        72.6612,
                                                                                                                                                                        17.357689, -16.531641,
                                                                                                                                                                        70.624585,
                                                                                                                                                                        15.857689, -24.132391,
                                                                                                                                                                        72.6612,
                                                                                                                                                                        17.357689, -18.85542,
                                                                                                                                                                        65.014485,
                                                                                                                                                                        15.857689, -24.132391,
                                                                                                                                                                        72.6612,
                                                                                                                                                                        17.357689, -16.531641,
                                                                                                                                                                        70.624585,
                                                                                                                                                                        15.857689, -23.607919,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -15.739043,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -23.607919,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -16.531641,
                                                                                                                                                                        70.624585,
                                                                                                                                                                        15.857689, -33.863822,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -35.016236,
                                                                                                                                                                        61.777355,
                                                                                                                                                                        17.357689, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        16.559911, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -34.050253,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        16.559911, -35.016236,
                                                                                                                                                                        61.777355,
                                                                                                                                                                        17.357689, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        13.941489, -39,
                                                                                                                                                                        41.463064,
                                                                                                                                                                        12.857689, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        13.941489, -39,
                                                                                                                                                                        41.463064,
                                                                                                                                                                        12.857689, -37.188267,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        13.941489, -39,
                                                                                                                                                                        41.463064,
                                                                                                                                                                        12.857689, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        13.941489, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        13.941489, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -39,
                                                                                                                                                                        45.7697,
                                                                                                                                                                        13.941489, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -40.811733,
                                                                                                                                                                        46.008219,
                                                                                                                                                                        13.941489, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -42.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        14.621443, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -43.949747,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -45.062178,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        14.621443, -45.801454,
                                                                                                                                                                        51.261593,
                                                                                                                                                                        15.098225, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -45.761481,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -45.801454,
                                                                                                                                                                        51.261593,
                                                                                                                                                                        15.098225, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -35.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -35.016236,
                                                                                                                                                                        61.777355,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        17.074959, -37.188267,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -44.136178,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        16.559911, -43.896399,
                                                                                                                                                                        58.371356,
                                                                                                                                                                        16.685519, -43.949747,
                                                                                                                                                                        57.719448,
                                                                                                                                                                        16.559911, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -43.896399,
                                                                                                                                                                        58.371356,
                                                                                                                                                                        16.685519, -42.5,
                                                                                                                                                                        58.831878,
                                                                                                                                                                        16.80835, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -43.896399,
                                                                                                                                                                        58.371356,
                                                                                                                                                                        16.685519, -43.896399,
                                                                                                                                                                        58.371356,
                                                                                                                                                                        16.685519, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        59.7697,
                                                                                                                                                                        17.074959, -39,
                                                                                                                                                                        61.252883,
                                                                                                                                                                        17.357689, -40.811733,
                                                                                                                                                                        59.531181,
                                                                                                                                                                        16.984023, -29.894254,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -39,
                                                                                                                                                                        111.826864,
                                                                                                                                                                        12.857689, -32.979621,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        99.905921,
                                                                                                                                                                        15.857689, -32.979621,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        111.826864,
                                                                                                                                                                        12.857689, -32.979621,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        99.905921,
                                                                                                                                                                        15.857689, -35.016236,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        92.037045,
                                                                                                                                                                        17.357689, -35.016236,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        99.905921,
                                                                                                                                                                        15.857689, -35.016236,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        92.037045,
                                                                                                                                                                        17.357689, -36.723564,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        85.440439,
                                                                                                                                                                        18.107689, -36.723564,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        92.037045,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -36.723564,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        85.440439,
                                                                                                                                                                        18.107689, -34.602262,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689, -36.723564,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -36.723564,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -34.602262,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689, -35.016236,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -31.303959,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -35.016236,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -34.602262,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689, -35.016236,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -31.303959,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -32.979621,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -27.369521,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -32.979621,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -31.303959,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -32.979621,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -27.369521,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -29.894254,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -21.40905,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -29.894254,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -27.369521,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -14.12264,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -21.40905,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -22.552019,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -27.369521,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -22.552019,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -21.40905,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -22.552019,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -27.369521,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -28.116155,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -31.303959,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -28.116155,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -27.369521,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -28.116155,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -31.303959,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -32.78066,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -34.602262,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689, -32.78066,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -31.303959,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -32.78066,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -34.602262,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -31.382895,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -32.78066,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -32.78066,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -31.382895,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -28.116155,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -25.670067,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -28.116155,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -31.382895,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -28.116155,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -25.670067,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -22.552019,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -18.85542,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -22.552019,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -25.670067,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -22.552019,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -18.85542,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -14.12264,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -8.531581,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -14.12264,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -18.85542,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -56.59095,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -45.773697,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -46,
                                                                                                                                                                        52.7697,
                                                                                                                                                                        15.432602, -45.773697,
                                                                                                                                                                        54.48864,
                                                                                                                                                                        15.857689, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -45.761481,
                                                                                                                                                                        54.581434,
                                                                                                                                                                        15.875072, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        16.226418, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -45.062178,
                                                                                                                                                                        56.2697,
                                                                                                                                                                        16.226418, -44.136178,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -43.896399,
                                                                                                                                                                        58.371356,
                                                                                                                                                                        16.685519, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -44.136178,
                                                                                                                                                                        57.476487,
                                                                                                                                                                        16.508918, -56.59095,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -52.459894,
                                                                                                                                                                        53.331745,
                                                                                                                                                                        14.936916, -60.075228,
                                                                                                                                                                        48.850125,
                                                                                                                                                                        12.857689, -52.459894,
                                                                                                                                                                        53.331745,
                                                                                                                                                                        14.936916, -56.59095,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -48.544109,
                                                                                                                                                                        55.636181,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        41.463064,
                                                                                                                                                                        12.857689, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        14.621443, -32.937822,
                                                                                                                                                                        49.2697,
                                                                                                                                                                        14.621443, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -32.198546,
                                                                                                                                                                        51.261593,
                                                                                                                                                                        15.098225, -32.238519,
                                                                                                                                                                        50.957967,
                                                                                                                                                                        15.02314, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -35.5,
                                                                                                                                                                        46.707522,
                                                                                                                                                                        14.061539, -39,
                                                                                                                                                                        41.463064,
                                                                                                                                                                        12.857689, -34.050253,
                                                                                                                                                                        47.819953,
                                                                                                                                                                        14.293459, -5.016894,
                                                                                                                                                                        85.75071,
                                                                                                                                                                        12.857689, -8.531581,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -16.531641,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -18.85542,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -16.531641,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -8.531581,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -16.531641,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -18.85542,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -24.132391,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -25.670067,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -24.132391,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -18.85542,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -24.132391,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -25.670067,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -30.504224,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -31.382895,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -30.504224,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -25.670067,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -30.504224,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -31.382895,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -30.204525,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -30.504224,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -30.504224,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -30.204525,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -24.132391,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -30.504224,
                                                                                                                                                                        74.368528,
                                                                                                                                                                        18.107689, -30.204525,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -31.382895,
                                                                                                                                                                        72.247227,
                                                                                                                                                                        18.107689, -30.504224,
                                                                                                                                                                        74.368528,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -32.78066,
                                                                                                                                                                        70.425624,
                                                                                                                                                                        18.107689, -31.382895,
                                                                                                                                                                        72.247227,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -34.602262,
                                                                                                                                                                        69.027859,
                                                                                                                                                                        18.107689, -32.78066,
                                                                                                                                                                        70.425624,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -36.723564,
                                                                                                                                                                        68.149188,
                                                                                                                                                                        18.107689, -34.602262,
                                                                                                                                                                        69.027859,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -36.723564,
                                                                                                                                                                        68.149188,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -39,
                                                                                                                                                                        67.849489,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -39,
                                                                                                                                                                        85.440439,
                                                                                                                                                                        18.107689, -41.276436,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        85.440439,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        92.037045,
                                                                                                                                                                        17.357689, -41.276436,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -42.983764,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -41.276436,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        92.037045,
                                                                                                                                                                        17.357689, -41.276436,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -42.983764,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -43.397738,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689, -46.696041,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -43.397738,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689, -42.983764,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -43.397738,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689, -46.696041,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -45.21934,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -49.883845,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -45.21934,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -46.696041,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -45.21934,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -49.883845,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -46.617105,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -52.329933,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -46.617105,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -49.883845,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -46.617105,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -52.329933,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -47.495776,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -53.867609,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -47.495776,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -52.329933,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -47.495776,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -53.867609,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -47.795475,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -54.392081,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -47.795475,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -53.867609,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -62.260957,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -54.392081,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -61.468359,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -53.867609,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -61.468359,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -54.392081,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        17.357689, -61.468359,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -53.867609,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -59.14458,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -52.329933,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -59.14458,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -53.867609,
                                                                                                                                                                        80.628728,
                                                                                                                                                                        17.357689, -59.14458,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -52.329933,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -55.447981,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -49.883845,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -55.447981,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -52.329933,
                                                                                                                                                                        84.341005,
                                                                                                                                                                        17.357689, -55.447981,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -49.883845,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -50.630479,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -46.696041,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -50.630479,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -49.883845,
                                                                                                                                                                        87.528809,
                                                                                                                                                                        17.357689, -50.630479,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -46.696041,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -45.020379,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -42.983764,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -45.020379,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -46.696041,
                                                                                                                                                                        89.974898,
                                                                                                                                                                        17.357689, -45.020379,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -42.983764,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        99.905921,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        92.037045,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        99.905921,
                                                                                                                                                                        15.857689, -42.983764,
                                                                                                                                                                        91.512573,
                                                                                                                                                                        17.357689, -39,
                                                                                                                                                                        99.905921,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        111.826864,
                                                                                                                                                                        12.857689, -45.020379,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -48.105746,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -45.020379,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -39,
                                                                                                                                                                        111.826864,
                                                                                                                                                                        12.857689, -45.020379,
                                                                                                                                                                        99.113324,
                                                                                                                                                                        15.857689, -48.105746,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -50.630479,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -56.59095,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -50.630479,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -48.105746,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -50.630479,
                                                                                                                                                                        96.789544,
                                                                                                                                                                        15.857689, -56.59095,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -55.447981,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -63.87736,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -55.447981,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -56.59095,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -55.447981,
                                                                                                                                                                        93.092945,
                                                                                                                                                                        15.857689, -63.87736,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -59.14458,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -69.468419,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -59.14458,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -63.87736,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -59.14458,
                                                                                                                                                                        88.275443,
                                                                                                                                                                        15.857689, -69.468419,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -61.468359,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -62.260957,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -61.468359,
                                                                                                                                                                        82.665343,
                                                                                                                                                                        15.857689, -66.247696,
                                                                                                                                                                        82.367812,
                                                                                                                                                                        14.664789, -62.260957,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        15.857689, -66.247696,
                                                                                                                                                                        82.367812,
                                                                                                                                                                        14.664789, -66.612606,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        14.762562, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -47.495776,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -47.795475,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -46.617105,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -47.495776,
                                                                                                                                                                        78.921401,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -45.21934,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -46.617105,
                                                                                                                                                                        81.042702,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -43.397738,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689, -45.21934,
                                                                                                                                                                        82.864304,
                                                                                                                                                                        18.107689, -39,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        18.857689, -41.276436,
                                                                                                                                                                        85.140741,
                                                                                                                                                                        18.107689, -43.397738,
                                                                                                                                                                        84.262069,
                                                                                                                                                                        18.107689,
                                                                                                                                                                        null,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "normals": [-0.2273,
                                                                                                                                                                        0.094151,
                                                                                                                                                                        0.969263, -0.235733,
                                                                                                                                                                        0.063164,
                                                                                                                                                                        0.969763, -0.211352,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.969763, -0.235733,
                                                                                                                                                                        0.063164,
                                                                                                                                                                        0.969763, -0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451, -0.211352,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.969763, -0.235733,
                                                                                                                                                                        0.063164,
                                                                                                                                                                        0.969763, -0.243923,
                                                                                                                                                                        0.032113,
                                                                                                                                                                        0.969263, -0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.013029, -0.098966,
                                                                                                                                                                        0.995006,
                                                                                                                                                                        0.004961, -0.162588,
                                                                                                                                                                        0.986682,
                                                                                                                                                                        0.025616, -0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.038878, -0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.025616, -0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.004961, -0.162588,
                                                                                                                                                                        0.986682,
                                                                                                                                                                        0.025616, -0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.038878, -0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.049487, -0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.075106, -0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.049487, -0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.038878, -0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.049487, -0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.075106, -0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.069985, -0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.106216, -0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.069985, -0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.075106, -0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.069985, -0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.106216, -0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.085714, -0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.130088, -0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.085714, -0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.106216, -0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.085714, -0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.130088, -0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.095602, -0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.145094, -0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.095602, -0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.130088, -0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.095602, -0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.145094, -0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.145094, -0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.235733,
                                                                                                                                                                        0.063164,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.244049,
                                                                                                                                                                        0,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.235733,
                                                                                                                                                                        0.063164,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.244049,
                                                                                                                                                                        0,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.235733, -0.063164,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.208388, -0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.235733, -0.063164,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.235733, -0.063164,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.208388, -0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.211352, -0.122024,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.186835, -0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.211352, -0.122024,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.208388, -0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.211352, -0.122024,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.186835, -0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.172568, -0.172568,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.15255, -0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.172568, -0.172568,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.186835, -0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.172568, -0.172568,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.15255, -0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.122024, -0.211352,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.107869, -0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.122024, -0.211352,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.15255, -0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.122024, -0.211352,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.107869, -0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.083239, -0.200956,
                                                                                                                                                                        0.976057,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.107869, -0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.094151, -0.2273,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.083239, -0.200956,
                                                                                                                                                                        0.976057,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.094151, -0.2273,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.048465, -0.180872,
                                                                                                                                                                        0.982312,
                                                                                                                                                                        0.072255, -0.174439,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.038878, -0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.072255, -0.174439,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.072255, -0.174439,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.038878, -0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.038878, -0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.072255, -0.174439,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.075106, -0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.072255, -0.174439,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.083239, -0.200956,
                                                                                                                                                                        0.976057,
                                                                                                                                                                        0.075106, -0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.107869, -0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.075106, -0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.083239, -0.200956,
                                                                                                                                                                        0.976057,
                                                                                                                                                                        0.075106, -0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.107869, -0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.106216, -0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.15255, -0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.106216, -0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.107869, -0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.106216, -0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.15255, -0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.130088, -0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.186835, -0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.130088, -0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.15255, -0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.130088, -0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.186835, -0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.145094, -0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.208388, -0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.145094, -0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.186835, -0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.145094, -0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.208388, -0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.208388, -0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.048465, -0.180872,
                                                                                                                                                                        0.982312,
                                                                                                                                                                        0.038878, -0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.024645, -0.187196,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.024645, -0.187196,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.024645, -0.187196,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.038878, -0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0, -0.244049,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0, -0.244049,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0, -0.244049,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0, -0.244049,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0, -0.244049,
                                                                                                                                                                        0.969763, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0, -0.244049,
                                                                                                                                                                        0.969763, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.032113, -0.243923,
                                                                                                                                                                        0.969263, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.094151, -0.2273,
                                                                                                                                                                        0.969263, -0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.024645, -0.187196,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.024645, -0.187196,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.004961, -0.162588,
                                                                                                                                                                        0.986682,
                                                                                                                                                                        0.004961, -0.162588,
                                                                                                                                                                        0.986682,
                                                                                                                                                                        0.024645, -0.187196,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.038878, -0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0, -0.187253,
                                                                                                                                                                        0.982312,
                                                                                                                                                                        0.024645, -0.187196,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.004961, -0.162588,
                                                                                                                                                                        0.986682, -0.048465, -0.180872,
                                                                                                                                                                        0.982312, -0.024645, -0.187196,
                                                                                                                                                                        0.982013, -0.048465, -0.180872,
                                                                                                                                                                        0.982312, -0.024645, -0.187196,
                                                                                                                                                                        0.982013, -0.024645, -0.187196,
                                                                                                                                                                        0.982013, -0.048465, -0.180872,
                                                                                                                                                                        0.982312, -0.024645, -0.187196,
                                                                                                                                                                        0.982013, -0.024645, -0.187196,
                                                                                                                                                                        0.982013, -0.048465, -0.180872,
                                                                                                                                                                        0.982312, -0.048465, -0.180872,
                                                                                                                                                                        0.982312, -0.024645, -0.187196,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.004961, -0.162588,
                                                                                                                                                                        0.986682,
                                                                                                                                                                        0, -0.187253,
                                                                                                                                                                        0.982312,
                                                                                                                                                                        0.004961, -0.162588,
                                                                                                                                                                        0.986682, -0.024645, -0.187196,
                                                                                                                                                                        0.982013,
                                                                                                                                                                        0.063164,
                                                                                                                                                                        0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0,
                                                                                                                                                                        0.244049,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0,
                                                                                                                                                                        0.244049,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.063164,
                                                                                                                                                                        0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.211352,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.063164,
                                                                                                                                                                        0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.172568,
                                                                                                                                                                        0.172568,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.211352,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.211352,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.172568,
                                                                                                                                                                        0.172568,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.211352,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.172568,
                                                                                                                                                                        0.172568,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451, -0.122024, -0.211352,
                                                                                                                                                                        0.969763, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.083239, -0.200956,
                                                                                                                                                                        0.976057, -0.063164, -0.235733,
                                                                                                                                                                        0.969763, -0.094151, -0.2273,
                                                                                                                                                                        0.969263, -0.083239, -0.200956,
                                                                                                                                                                        0.976057, -0.083239, -0.200956,
                                                                                                                                                                        0.976057, -0.083239, -0.200956,
                                                                                                                                                                        0.976057, -0.094151, -0.2273,
                                                                                                                                                                        0.969263, -0.083239, -0.200956,
                                                                                                                                                                        0.976057, -0.072255, -0.174439,
                                                                                                                                                                        0.982013, -0.083239, -0.200956,
                                                                                                                                                                        0.976057, -0.072255, -0.174439,
                                                                                                                                                                        0.982013, -0.072255, -0.174439,
                                                                                                                                                                        0.982013, -0.083239, -0.200956,
                                                                                                                                                                        0.976057, -0.072255, -0.174439,
                                                                                                                                                                        0.982013, -0.048465, -0.180872,
                                                                                                                                                                        0.982312, -0.083239, -0.200956,
                                                                                                                                                                        0.976057, -0.048465, -0.180872,
                                                                                                                                                                        0.982312, -0.083239, -0.200956,
                                                                                                                                                                        0.976057, -0.048465, -0.180872,
                                                                                                                                                                        0.982312, -0.122024, -0.211352,
                                                                                                                                                                        0.969763, -0.122024, -0.211352,
                                                                                                                                                                        0.969763, -0.149772, -0.195187,
                                                                                                                                                                        0.969263, -0.122024, -0.211352,
                                                                                                                                                                        0.969763, -0.122024, -0.211352,
                                                                                                                                                                        0.969763, -0.083239, -0.200956,
                                                                                                                                                                        0.976057,
                                                                                                                                                                        0, -0.244049,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.063164, -0.235733,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0, -0.244049,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.032113, -0.243923,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.235733,
                                                                                                                                                                        0.063164,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.211352,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.211352,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.969763,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0.095602, -0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.085714, -0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.095602, -0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.069985, -0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.085714, -0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.049487, -0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.069985, -0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.025616, -0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.049487, -0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.025616, -0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0.013029, -0.098966,
                                                                                                                                                                        0.995006,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665,
                                                                                                                                                                        0,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0.99509, -0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0,
                                                                                                                                                                        0.098974,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0.988654, -0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509, -0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654, -0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0.988654, -0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509, -0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654, -0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509, -0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654, -0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509, -0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654, -0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509, -0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654, -0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509, -0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654, -0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509, -0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654, -0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509, -0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654, -0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509, -0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654, -0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509, -0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654, -0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509, -0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654, -0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509, -0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654, -0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509, -0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654, -0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509, -0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654, -0.098966,
                                                                                                                                                                        0.013029,
                                                                                                                                                                        0.995006, -0.150183,
                                                                                                                                                                        0.019772,
                                                                                                                                                                        0.98846, -0.098966,
                                                                                                                                                                        0.013029,
                                                                                                                                                                        0.995006, -0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654, -0.215652,
                                                                                                                                                                        0.028391,
                                                                                                                                                                        0.976057, -0.150183,
                                                                                                                                                                        0.019772,
                                                                                                                                                                        0.98846, -0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451, -0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654, -0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451, -0.150183,
                                                                                                                                                                        0.019772,
                                                                                                                                                                        0.98846, -0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451, -0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654, -0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451, -0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654, -0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451, -0.145094,
                                                                                                                                                                        0.038878,
                                                                                                                                                                        0.988654, -0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451, -0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654, -0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451, -0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654, -0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451, -0.130088,
                                                                                                                                                                        0.075106,
                                                                                                                                                                        0.988654, -0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451, -0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654, -0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451, -0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654, -0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451, -0.106216,
                                                                                                                                                                        0.106216,
                                                                                                                                                                        0.988654, -0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451, -0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654, -0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451, -0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654, -0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451, -0.075106,
                                                                                                                                                                        0.130088,
                                                                                                                                                                        0.988654, -0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451, -0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0,
                                                                                                                                                                        0.150212,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0.976451, -0.038878,
                                                                                                                                                                        0.145094,
                                                                                                                                                                        0.988654,
                                                                                                                                                                        0,
                                                                                                                                                                        0.215739,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0,
                                                                                                                                                                        0.244049,
                                                                                                                                                                        0.969763, -0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451, -0.063164,
                                                                                                                                                                        0.235733,
                                                                                                                                                                        0.969763, -0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451,
                                                                                                                                                                        0,
                                                                                                                                                                        0.244049,
                                                                                                                                                                        0.969763, -0.055837,
                                                                                                                                                                        0.208388,
                                                                                                                                                                        0.976451, -0.063164,
                                                                                                                                                                        0.235733,
                                                                                                                                                                        0.969763, -0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451, -0.122024,
                                                                                                                                                                        0.211352,
                                                                                                                                                                        0.969763, -0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451, -0.063164,
                                                                                                                                                                        0.235733,
                                                                                                                                                                        0.969763, -0.107869,
                                                                                                                                                                        0.186835,
                                                                                                                                                                        0.976451, -0.122024,
                                                                                                                                                                        0.211352,
                                                                                                                                                                        0.969763, -0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451, -0.172568,
                                                                                                                                                                        0.172568,
                                                                                                                                                                        0.969763, -0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451, -0.122024,
                                                                                                                                                                        0.211352,
                                                                                                                                                                        0.969763, -0.15255,
                                                                                                                                                                        0.15255,
                                                                                                                                                                        0.976451, -0.172568,
                                                                                                                                                                        0.172568,
                                                                                                                                                                        0.969763, -0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451, -0.211352,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.969763, -0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451, -0.172568,
                                                                                                                                                                        0.172568,
                                                                                                                                                                        0.969763, -0.186835,
                                                                                                                                                                        0.107869,
                                                                                                                                                                        0.976451, -0.211352,
                                                                                                                                                                        0.122024,
                                                                                                                                                                        0.969763, -0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451, -0.215652,
                                                                                                                                                                        0.028391,
                                                                                                                                                                        0.976057, -0.208388,
                                                                                                                                                                        0.055837,
                                                                                                                                                                        0.976451, -0.243923,
                                                                                                                                                                        0.032113,
                                                                                                                                                                        0.969263, -0.215652,
                                                                                                                                                                        0.028391,
                                                                                                                                                                        0.976057, -0.243923,
                                                                                                                                                                        0.032113,
                                                                                                                                                                        0.969263, -0.243923,
                                                                                                                                                                        0.032113,
                                                                                                                                                                        0.969263,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665, -0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509, -0.098966,
                                                                                                                                                                        0.013029,
                                                                                                                                                                        0.995006,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665, -0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509, -0.095602,
                                                                                                                                                                        0.025616,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665, -0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509, -0.085714,
                                                                                                                                                                        0.049487,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665, -0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509, -0.069985,
                                                                                                                                                                        0.069985,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.018297,
                                                                                                                                                                        0.999665, -0.025616,
                                                                                                                                                                        0.095602,
                                                                                                                                                                        0.99509, -0.049487,
                                                                                                                                                                        0.085714,
                                                                                                                                                                        0.99509,
                                                                                                                                                                        null,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "uv": [
                                                                                                                                                                        52.576186, -93.998445,
                                                                                                                                                                        51.735924, -90.534472,
                                                                                                                                                                        60.478219, -93.998445,
                                                                                                                                                                        51.735924, -90.534472,
                                                                                                                                                                        52.849896, -81.804686,
                                                                                                                                                                        60.478219, -93.998445,
                                                                                                                                                                        75.04887, -74.355987,
                                                                                                                                                                        73.016085, -70.474848,
                                                                                                                                                                        73.934899, -65.626202,
                                                                                                                                                                        29.810214,
                                                                                                                                                                        73.951401,
                                                                                                                                                                        30.671244,
                                                                                                                                                                        67.368367,
                                                                                                                                                                        27.514134,
                                                                                                                                                                        73.951401,
                                                                                                                                                                        26.653105,
                                                                                                                                                                        67.368367,
                                                                                                                                                                        27.514134,
                                                                                                                                                                        73.951401,
                                                                                                                                                                        30.671244,
                                                                                                                                                                        67.368367,
                                                                                                                                                                        7.848584,
                                                                                                                                                                        78.576678,
                                                                                                                                                                        8.709614,
                                                                                                                                                                        71.993644,
                                                                                                                                                                        5.552504,
                                                                                                                                                                        78.576678,
                                                                                                                                                                        4.691474,
                                                                                                                                                                        71.993644,
                                                                                                                                                                        5.552504,
                                                                                                                                                                        78.576678,
                                                                                                                                                                        8.709614,
                                                                                                                                                                        71.993644, -14.569678,
                                                                                                                                                                        77.397274, -13.708648,
                                                                                                                                                                        70.81424, -16.865757,
                                                                                                                                                                        77.397274, -17.726787,
                                                                                                                                                                        70.81424, -16.865757,
                                                                                                                                                                        77.397274, -13.708648,
                                                                                                                                                                        70.81424, -35.916803,
                                                                                                                                                                        70.493564, -35.055773,
                                                                                                                                                                        63.91053, -38.212882,
                                                                                                                                                                        70.493564, -39.073912,
                                                                                                                                                                        63.91053, -38.212882,
                                                                                                                                                                        70.493564, -35.055773,
                                                                                                                                                                        63.91053, -54.73802,
                                                                                                                                                                        58.336024, -53.87699,
                                                                                                                                                                        51.752989, -57.0341,
                                                                                                                                                                        58.336024, -57.89513,
                                                                                                                                                                        51.752989, -57.0341,
                                                                                                                                                                        58.336024, -53.87699,
                                                                                                                                                                        51.752989, -69.750694,
                                                                                                                                                                        41.75317, -68.889665,
                                                                                                                                                                        35.170135, -72.046774,
                                                                                                                                                                        41.75317, -72.907804,
                                                                                                                                                                        35.170135, -72.046774,
                                                                                                                                                                        41.75317, -68.889665,
                                                                                                                                                                        35.170135, -79.070708,
                                                                                                                                                                        15.292062, -83.088847,
                                                                                                                                                                        15.292062, -79.931737,
                                                                                                                                                                        21.875096, -83.088847,
                                                                                                                                                                        16.438046, -79.070708,
                                                                                                                                                                        16.438046, -84.115942,
                                                                                                                                                                        8.493596, -78.043613,
                                                                                                                                                                        8.493596, -84.115942,
                                                                                                                                                                        8.493596, -79.070708,
                                                                                                                                                                        16.438046, -84.115942,
                                                                                                                                                                        9.329511, -78.043613,
                                                                                                                                                                        9.329511, -85.671937, -2.864248, -76.487618, -2.864248, -85.671937, -2.864248, -78.043613,
                                                                                                                                                                        9.329511, -75.490894,
                                                                                                                                                                        16.529103, -73.934899,
                                                                                                                                                                        28.722862, -66.306575,
                                                                                                                                                                        16.529103, -67.86257,
                                                                                                                                                                        28.722862, -66.306575,
                                                                                                                                                                        16.529103, -73.934899,
                                                                                                                                                                        28.722862, -60.478219,
                                                                                                                                                                        32.707587, -58.922224,
                                                                                                                                                                        44.901346, -51.2939,
                                                                                                                                                                        32.707587, -52.849896,
                                                                                                                                                                        44.901346, -51.2939,
                                                                                                                                                                        32.707587, -58.922224,
                                                                                                                                                                        44.901346, -41.657002,
                                                                                                                                                                        44.568669, -40.101007,
                                                                                                                                                                        56.762427, -32.472683,
                                                                                                                                                                        44.568669, -34.028678,
                                                                                                                                                                        56.762427, -32.472683,
                                                                                                                                                                        44.568669, -40.101007,
                                                                                                                                                                        56.762427, -20.309877,
                                                                                                                                                                        51.304033, -18.753882,
                                                                                                                                                                        63.497792, -11.125558,
                                                                                                                                                                        51.304033, -12.681553,
                                                                                                                                                                        63.497792, -11.125558,
                                                                                                                                                                        51.304033, -18.753882,
                                                                                                                                                                        63.497792,
                                                                                                                                                                        2.108384,
                                                                                                                                                                        52.454678,
                                                                                                                                                                        3.66438,
                                                                                                                                                                        64.648436,
                                                                                                                                                                        11.292703,
                                                                                                                                                                        52.454678,
                                                                                                                                                                        8.921322,
                                                                                                                                                                        64.648436,
                                                                                                                                                                        11.292703,
                                                                                                                                                                        52.454678,
                                                                                                                                                                        3.66438,
                                                                                                                                                                        64.648436,
                                                                                                                                                                        9.370055,
                                                                                                                                                                        62.920634,
                                                                                                                                                                        11.292703,
                                                                                                                                                                        52.454678,
                                                                                                                                                                        8.921322,
                                                                                                                                                                        64.648436,
                                                                                                                                                                        11.292703,
                                                                                                                                                                        52.454678,
                                                                                                                                                                        9.370055,
                                                                                                                                                                        62.920634,
                                                                                                                                                                        10.130615,
                                                                                                                                                                        61.561529,
                                                                                                                                                                        9.290793,
                                                                                                                                                                        67.989338,
                                                                                                                                                                        8.897098,
                                                                                                                                                                        66.493137,
                                                                                                                                                                        8.709614,
                                                                                                                                                                        72.484689,
                                                                                                                                                                        8.897098,
                                                                                                                                                                        66.493137,
                                                                                                                                                                        8.897098,
                                                                                                                                                                        64.6323,
                                                                                                                                                                        8.709614,
                                                                                                                                                                        72.484689,
                                                                                                                                                                        8.709614,
                                                                                                                                                                        72.484689,
                                                                                                                                                                        8.897098,
                                                                                                                                                                        64.6323,
                                                                                                                                                                        4.691474,
                                                                                                                                                                        72.484689,
                                                                                                                                                                        8.897098,
                                                                                                                                                                        64.6323,
                                                                                                                                                                        8.921322,
                                                                                                                                                                        64.540239,
                                                                                                                                                                        4.691474,
                                                                                                                                                                        72.484689,
                                                                                                                                                                        3.66438,
                                                                                                                                                                        64.540239,
                                                                                                                                                                        4.691474,
                                                                                                                                                                        72.484689,
                                                                                                                                                                        8.921322,
                                                                                                                                                                        64.540239, -13.708648,
                                                                                                                                                                        71.318908, -12.681553,
                                                                                                                                                                        63.374458, -17.726787,
                                                                                                                                                                        71.318908, -18.753882,
                                                                                                                                                                        63.374458, -17.726787,
                                                                                                                                                                        71.318908, -12.681553,
                                                                                                                                                                        63.374458, -35.055773,
                                                                                                                                                                        64.49494, -34.028678,
                                                                                                                                                                        56.55049, -39.073912,
                                                                                                                                                                        64.49494, -40.101007,
                                                                                                                                                                        56.55049, -39.073912,
                                                                                                                                                                        64.49494, -34.028678,
                                                                                                                                                                        56.55049, -53.87699,
                                                                                                                                                                        52.477827, -52.849896,
                                                                                                                                                                        44.533377, -57.89513,
                                                                                                                                                                        52.477827, -58.922224,
                                                                                                                                                                        44.533377, -57.89513,
                                                                                                                                                                        52.477827, -52.849896,
                                                                                                                                                                        44.533377, -68.889665,
                                                                                                                                                                        36.086515, -67.86257,
                                                                                                                                                                        28.142065, -72.907804,
                                                                                                                                                                        36.086515, -73.934899,
                                                                                                                                                                        28.142065, -72.907804,
                                                                                                                                                                        36.086515, -67.86257,
                                                                                                                                                                        28.142065,
                                                                                                                                                                        26.071925,
                                                                                                                                                                        63.417486,
                                                                                                                                                                        26.653105,
                                                                                                                                                                        67.912837,
                                                                                                                                                                        26.225048,
                                                                                                                                                                        63.687561,
                                                                                                                                                                        27.517192,
                                                                                                                                                                        65.003371,
                                                                                                                                                                        26.225048,
                                                                                                                                                                        63.687561,
                                                                                                                                                                        26.653105,
                                                                                                                                                                        67.912837,
                                                                                                                                                                        30.864838,
                                                                                                                                                                        52.347382,
                                                                                                                                                                        33.254334,
                                                                                                                                                                        47.942187,
                                                                                                                                                                        29.099738,
                                                                                                                                                                        52.835338,
                                                                                                                                                                        32.692205,
                                                                                                                                                                        52.347382,
                                                                                                                                                                        33.254334,
                                                                                                                                                                        47.942187,
                                                                                                                                                                        30.864838,
                                                                                                                                                                        52.347382,
                                                                                                                                                                        44.078365,
                                                                                                                                                                        38.07408,
                                                                                                                                                                        44.640494,
                                                                                                                                                                        42.479276,
                                                                                                                                                                        53.262684,
                                                                                                                                                                        38.07408,
                                                                                                                                                                        46.467861,
                                                                                                                                                                        42.479276,
                                                                                                                                                                        53.262684,
                                                                                                                                                                        38.07408,
                                                                                                                                                                        44.640494,
                                                                                                                                                                        42.479276,
                                                                                                                                                                        48.232962,
                                                                                                                                                                        42.967231,
                                                                                                                                                                        53.262684,
                                                                                                                                                                        38.07408,
                                                                                                                                                                        46.467861,
                                                                                                                                                                        42.479276,
                                                                                                                                                                        49.815508,
                                                                                                                                                                        43.909889,
                                                                                                                                                                        53.262684,
                                                                                                                                                                        38.07408,
                                                                                                                                                                        48.232962,
                                                                                                                                                                        42.967231,
                                                                                                                                                                        51.107651,
                                                                                                                                                                        45.243009,
                                                                                                                                                                        53.262684,
                                                                                                                                                                        38.07408,
                                                                                                                                                                        49.815508,
                                                                                                                                                                        43.909889,
                                                                                                                                                                        52.021334,
                                                                                                                                                                        46.875741,
                                                                                                                                                                        53.262684,
                                                                                                                                                                        38.07408,
                                                                                                                                                                        51.107651,
                                                                                                                                                                        45.243009,
                                                                                                                                                                        52.100597,
                                                                                                                                                                        47.180932,
                                                                                                                                                                        53.262684,
                                                                                                                                                                        38.07408,
                                                                                                                                                                        52.021334,
                                                                                                                                                                        46.875741,
                                                                                                                                                                        61.931988,
                                                                                                                                                                        32.629704,
                                                                                                                                                                        62.692549,
                                                                                                                                                                        33.988809,
                                                                                                                                                                        60.7699,
                                                                                                                                                                        23.522853,
                                                                                                                                                                        29.099738,
                                                                                                                                                                        65.933789,
                                                                                                                                                                        27.517192,
                                                                                                                                                                        65.003371,
                                                                                                                                                                        30.671244,
                                                                                                                                                                        67.912837,
                                                                                                                                                                        30.671244,
                                                                                                                                                                        67.912837,
                                                                                                                                                                        27.517192,
                                                                                                                                                                        65.003371,
                                                                                                                                                                        26.653105,
                                                                                                                                                                        67.912837,
                                                                                                                                                                        30.864838,
                                                                                                                                                                        66.415409,
                                                                                                                                                                        29.099738,
                                                                                                                                                                        65.933789,
                                                                                                                                                                        30.671244,
                                                                                                                                                                        67.912837,
                                                                                                                                                                        51.260774,
                                                                                                                                                                        53.419565,
                                                                                                                                                                        51.107651,
                                                                                                                                                                        53.68964,
                                                                                                                                                                        51.13985,
                                                                                                                                                                        54.354899,
                                                                                                                                                                        51.107651,
                                                                                                                                                                        53.68964,
                                                                                                                                                                        49.815508,
                                                                                                                                                                        55.00545,
                                                                                                                                                                        51.13985,
                                                                                                                                                                        54.354899,
                                                                                                                                                                        49.815508,
                                                                                                                                                                        55.00545,
                                                                                                                                                                        48.232962,
                                                                                                                                                                        55.935868,
                                                                                                                                                                        51.13985,
                                                                                                                                                                        54.354899,
                                                                                                                                                                        51.13985,
                                                                                                                                                                        54.354899,
                                                                                                                                                                        48.232962,
                                                                                                                                                                        55.935868,
                                                                                                                                                                        46.661455,
                                                                                                                                                                        57.914916,
                                                                                                                                                                        46.467861,
                                                                                                                                                                        56.417488,
                                                                                                                                                                        46.661455,
                                                                                                                                                                        57.914916,
                                                                                                                                                                        48.232962,
                                                                                                                                                                        55.935868, -44.078365, -99.364938, -53.262684, -99.364938, -45.634361, -87.171179, -51.706689, -87.171179, -45.634361, -87.171179, -53.262684, -99.364938, -45.634361, -89.276554, -51.706689, -89.276554, -46.661455, -81.332104, -50.679595, -81.332104, -46.661455, -81.332104, -51.706689, -89.276554, -46.661455, -83.620593, -50.679595, -83.620593, -47.522485, -77.037558, -49.818565, -77.037558, -47.522485, -77.037558, -50.679595, -83.620593, -48.670525, -69.022028, -47.522485, -77.77445, -49.818565, -77.77445, -64.21402, -62.816995, -66.5101, -62.816995, -65.36206, -54.064573, -66.5101, -62.122633, -64.21402, -62.122633, -67.371129, -68.705668, -63.35299, -68.705668, -67.371129, -68.705668, -64.21402, -62.122633, -67.371129, -66.589456, -63.35299, -66.589456, -68.398224, -74.533906, -62.325896, -74.533906, -68.398224, -74.533906, -63.35299, -66.589456, -68.398224, -72.619952, -62.325896, -72.619952, -69.954219, -84.81371, -60.7699, -84.81371, -69.954219, -84.81371, -62.325896, -72.619952, -73.007119, -66.571004, -82.191438, -66.571004, -74.563114, -54.377245, -80.635442, -54.377245, -74.563114, -54.377245, -82.191438, -66.571004, -74.563114, -56.051218, -80.635442, -56.051218, -75.590208, -48.106767, -79.608348, -48.106767, -75.590208, -48.106767, -80.635442, -56.051218, -75.590208, -50.006998, -79.608348, -50.006998, -76.451238, -43.423963, -78.747318, -43.423963, -76.451238, -43.423963, -79.608348, -50.006998, -76.451238, -44.065006, -78.747318, -44.065006, -77.599278, -35.312584, -83.400194, -22.7964, -85.696274, -22.7964, -84.548234, -14.043979, -85.696274, -22.215832, -83.400194, -22.215832, -86.557304, -28.798867, -82.539164, -28.798867, -86.557304, -28.798867, -83.400194, -22.215832, -86.557304, -27.143604, -82.539164, -27.143604, -87.584398, -35.088054, -81.51207, -35.088054, -87.584398, -35.088054, -82.539164, -27.143604, -87.584398, -33.68627, -81.51207, -33.68627, -89.140393, -45.880029, -79.956075, -45.880029, -89.140393, -45.880029, -81.51207, -33.68627,
                                                                                                                                                                        69.954219,
                                                                                                                                                                        23.522853,
                                                                                                                                                                        60.7699,
                                                                                                                                                                        23.522853,
                                                                                                                                                                        66.139953,
                                                                                                                                                                        35.716611,
                                                                                                                                                                        60.7699,
                                                                                                                                                                        23.522853,
                                                                                                                                                                        62.692549,
                                                                                                                                                                        33.988809,
                                                                                                                                                                        66.139953,
                                                                                                                                                                        35.716611,
                                                                                                                                                                        63.141282,
                                                                                                                                                                        35.716611,
                                                                                                                                                                        66.139953,
                                                                                                                                                                        35.716611,
                                                                                                                                                                        62.692549,
                                                                                                                                                                        33.988809,
                                                                                                                                                                        63.141282,
                                                                                                                                                                        35.227817,
                                                                                                                                                                        63.165506,
                                                                                                                                                                        35.319879,
                                                                                                                                                                        66.139953,
                                                                                                                                                                        35.227817,
                                                                                                                                                                        63.165506,
                                                                                                                                                                        35.319879,
                                                                                                                                                                        63.165506,
                                                                                                                                                                        37.180716,
                                                                                                                                                                        66.139953,
                                                                                                                                                                        35.227817,
                                                                                                                                                                        63.165506,
                                                                                                                                                                        37.180716,
                                                                                                                                                                        62.771811,
                                                                                                                                                                        38.676917,
                                                                                                                                                                        66.139953,
                                                                                                                                                                        35.227817,
                                                                                                                                                                        62.892735,
                                                                                                                                                                        39.612251,
                                                                                                                                                                        66.139953,
                                                                                                                                                                        35.227817,
                                                                                                                                                                        62.771811,
                                                                                                                                                                        38.676917,
                                                                                                                                                                        73.007119,
                                                                                                                                                                        5.280146,
                                                                                                                                                                        74.085541,
                                                                                                                                                                        13.731341,
                                                                                                                                                                        77.398955,
                                                                                                                                                                        5.280146,
                                                                                                                                                                        68.875797,
                                                                                                                                                                        31.974048,
                                                                                                                                                                        69.954219,
                                                                                                                                                                        23.522853,
                                                                                                                                                                        66.139953,
                                                                                                                                                                        35.716611,
                                                                                                                                                                        33.254334,
                                                                                                                                                                        47.942187,
                                                                                                                                                                        24.070015,
                                                                                                                                                                        47.942187,
                                                                                                                                                                        27.517192,
                                                                                                                                                                        53.777996,
                                                                                                                                                                        27.517192,
                                                                                                                                                                        53.777996,
                                                                                                                                                                        24.070015,
                                                                                                                                                                        47.942187,
                                                                                                                                                                        26.225048,
                                                                                                                                                                        55.111116,
                                                                                                                                                                        26.225048,
                                                                                                                                                                        55.111116,
                                                                                                                                                                        24.070015,
                                                                                                                                                                        47.942187,
                                                                                                                                                                        25.311365,
                                                                                                                                                                        56.743847,
                                                                                                                                                                        25.232103,
                                                                                                                                                                        57.049039,
                                                                                                                                                                        25.311365,
                                                                                                                                                                        56.743847,
                                                                                                                                                                        24.070015,
                                                                                                                                                                        47.942187,
                                                                                                                                                                        29.099738,
                                                                                                                                                                        52.835338,
                                                                                                                                                                        33.254334,
                                                                                                                                                                        47.942187,
                                                                                                                                                                        27.517192,
                                                                                                                                                                        53.777996, -81.143208, -24.150841, -90.327527, -24.150841, -82.699203, -11.957082, -88.771532, -11.957082, -82.699203, -11.957082, -90.327527, -24.150841, -82.699203, -13.07302, -88.771532, -13.07302, -83.726298, -5.12857, -87.744437, -5.12857, -83.726298, -5.12857, -88.771532, -13.07302, -83.726298, -6.526574, -87.744437, -6.526574, -84.587328,
                                                                                                                                                                        0.056461, -86.883407,
                                                                                                                                                                        0.056461, -84.587328,
                                                                                                                                                                        0.056461, -87.744437, -6.526574, -84.587328, -0.460598, -86.883407, -0.460598, -85.735368,
                                                                                                                                                                        8.291824, -79.931737,
                                                                                                                                                                        21.420254, -82.227817,
                                                                                                                                                                        21.420254, -81.079777,
                                                                                                                                                                        30.172675, -82.227817,
                                                                                                                                                                        21.875096, -79.931737,
                                                                                                                                                                        21.875096, -83.088847,
                                                                                                                                                                        15.292062, -69.750694,
                                                                                                                                                                        41.355009, -72.046774,
                                                                                                                                                                        41.355009, -70.898734,
                                                                                                                                                                        50.107431, -54.73802,
                                                                                                                                                                        57.985149, -57.0341,
                                                                                                                                                                        57.985149, -55.88606,
                                                                                                                                                                        66.737571, -35.916803,
                                                                                                                                                                        70.177357, -38.212882,
                                                                                                                                                                        70.177357, -37.064843,
                                                                                                                                                                        78.929779, -14.569678,
                                                                                                                                                                        77.100753, -16.865757,
                                                                                                                                                                        77.100753, -15.717718,
                                                                                                                                                                        85.853175,
                                                                                                                                                                        7.848584,
                                                                                                                                                                        78.28352,
                                                                                                                                                                        5.552504,
                                                                                                                                                                        78.28352,
                                                                                                                                                                        6.700544,
                                                                                                                                                                        87.035942,
                                                                                                                                                                        27.514134,
                                                                                                                                                                        73.645054,
                                                                                                                                                                        28.662174,
                                                                                                                                                                        82.397476,
                                                                                                                                                                        29.810214,
                                                                                                                                                                        73.645054, -28.662174, -79.165623, -27.514134, -87.918045, -29.810214, -87.918045, -27.514134, -87.152311, -26.653105, -93.735346, -29.810214, -87.152311, -30.671244, -93.735346, -29.810214, -87.152311, -26.653105, -93.735346, -5.552504, -91.777588, -4.691474, -98.360623, -7.848584, -91.777588, -8.709614, -98.360623, -7.848584, -91.777588, -4.691474, -98.360623,
                                                                                                                                                                        16.865757, -90.598184,
                                                                                                                                                                        17.726787, -97.181219,
                                                                                                                                                                        14.569678, -90.598184,
                                                                                                                                                                        13.708648, -97.181219,
                                                                                                                                                                        14.569678, -90.598184,
                                                                                                                                                                        17.726787, -97.181219,
                                                                                                                                                                        38.212882, -83.694474,
                                                                                                                                                                        39.073912, -90.277508,
                                                                                                                                                                        35.916803, -83.694474,
                                                                                                                                                                        35.055773, -90.277508,
                                                                                                                                                                        35.916803, -83.694474,
                                                                                                                                                                        39.073912, -90.277508,
                                                                                                                                                                        57.0341, -71.536934,
                                                                                                                                                                        57.89513, -78.119968,
                                                                                                                                                                        54.73802, -71.536934,
                                                                                                                                                                        53.87699, -78.119968,
                                                                                                                                                                        54.73802, -71.536934,
                                                                                                                                                                        57.89513, -78.119968,
                                                                                                                                                                        72.046774, -54.95408,
                                                                                                                                                                        72.907804, -61.537114,
                                                                                                                                                                        69.750694, -54.95408,
                                                                                                                                                                        68.889665, -61.537114,
                                                                                                                                                                        69.750694, -54.95408,
                                                                                                                                                                        72.907804, -61.537114,
                                                                                                                                                                        67.86257, -67.448154,
                                                                                                                                                                        68.889665, -59.503703,
                                                                                                                                                                        73.934899, -67.448154,
                                                                                                                                                                        72.907804, -59.503703,
                                                                                                                                                                        73.934899, -67.448154,
                                                                                                                                                                        68.889665, -59.503703,
                                                                                                                                                                        52.849896, -83.839465,
                                                                                                                                                                        53.87699, -75.895015,
                                                                                                                                                                        58.922224, -83.839465,
                                                                                                                                                                        57.89513, -75.895015,
                                                                                                                                                                        58.922224, -83.839465,
                                                                                                                                                                        53.87699, -75.895015,
                                                                                                                                                                        34.028678, -95.856578,
                                                                                                                                                                        35.055773, -87.912128,
                                                                                                                                                                        40.101007, -95.856578,
                                                                                                                                                                        39.073912, -87.912128,
                                                                                                                                                                        40.101007, -95.856578,
                                                                                                                                                                        35.055773, -87.912128,
                                                                                                                                                                        12.681553, -102.680546,
                                                                                                                                                                        13.708648, -94.736096,
                                                                                                                                                                        18.753882, -102.680546,
                                                                                                                                                                        17.726787, -94.736096,
                                                                                                                                                                        18.753882, -102.680546,
                                                                                                                                                                        13.708648, -94.736096, -9.736708, -103.846327, -8.709614, -95.901877, -3.66438, -103.846327, -4.691474, -95.901877, -3.66438, -103.846327, -8.709614, -95.901877, -31.698338, -99.274475, -30.671244, -91.330025, -25.62601, -99.274475, -26.653105, -91.330025, -25.62601, -99.274475, -30.671244, -91.330025, -25.62601, -97.039286, -24.070015, -109.233045, -31.698338, -97.039286, -33.254334, -109.233045, -31.698338, -97.039286, -24.070015, -109.233045, -3.66438, -101.551777, -2.108384, -113.745535, -9.736708, -101.551777, -11.292703, -113.745535, -9.736708, -101.551777, -2.108384, -113.745535,
                                                                                                                                                                        18.753882, -100.401132,
                                                                                                                                                                        20.309877, -112.594891,
                                                                                                                                                                        12.681553, -100.401132,
                                                                                                                                                                        11.125558, -112.594891,
                                                                                                                                                                        12.681553, -100.401132,
                                                                                                                                                                        20.309877, -112.594891,
                                                                                                                                                                        40.101007, -93.665767,
                                                                                                                                                                        41.657002, -105.859526,
                                                                                                                                                                        34.028678, -93.665767,
                                                                                                                                                                        32.472683, -105.859526,
                                                                                                                                                                        34.028678, -93.665767,
                                                                                                                                                                        41.657002, -105.859526,
                                                                                                                                                                        58.922224, -81.804686,
                                                                                                                                                                        60.478219, -93.998445,
                                                                                                                                                                        52.849896, -81.804686,
                                                                                                                                                                        67.86257, -65.626202,
                                                                                                                                                                        73.934899, -65.626202,
                                                                                                                                                                        73.016085, -70.474848,
                                                                                                                                                                        67.86257, -65.626202,
                                                                                                                                                                        73.016085, -70.474848,
                                                                                                                                                                        67.294566, -70.07744,
                                                                                                                                                                        70.898734, -46.875579,
                                                                                                                                                                        72.046774, -55.628,
                                                                                                                                                                        69.750694, -55.628,
                                                                                                                                                                        55.88606, -63.505719,
                                                                                                                                                                        57.0341, -72.25814,
                                                                                                                                                                        54.73802, -72.25814,
                                                                                                                                                                        37.064843, -75.697926,
                                                                                                                                                                        38.212882, -84.450348,
                                                                                                                                                                        35.916803, -84.450348,
                                                                                                                                                                        15.717718, -82.621322,
                                                                                                                                                                        16.865757, -91.373744,
                                                                                                                                                                        14.569678, -91.373744, -6.700544, -83.804089, -5.552504, -92.556511, -7.848584, -92.556511,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "indices": [
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        2,
                                                                                                                                                                        3,
                                                                                                                                                                        4,
                                                                                                                                                                        5,
                                                                                                                                                                        6,
                                                                                                                                                                        7,
                                                                                                                                                                        8,
                                                                                                                                                                        9,
                                                                                                                                                                        10,
                                                                                                                                                                        11,
                                                                                                                                                                        12,
                                                                                                                                                                        13,
                                                                                                                                                                        14,
                                                                                                                                                                        15,
                                                                                                                                                                        16,
                                                                                                                                                                        17,
                                                                                                                                                                        18,
                                                                                                                                                                        19,
                                                                                                                                                                        20,
                                                                                                                                                                        21,
                                                                                                                                                                        22,
                                                                                                                                                                        23,
                                                                                                                                                                        24,
                                                                                                                                                                        25,
                                                                                                                                                                        26,
                                                                                                                                                                        27,
                                                                                                                                                                        28,
                                                                                                                                                                        29,
                                                                                                                                                                        30,
                                                                                                                                                                        31,
                                                                                                                                                                        32,
                                                                                                                                                                        33,
                                                                                                                                                                        34,
                                                                                                                                                                        35,
                                                                                                                                                                        36,
                                                                                                                                                                        37,
                                                                                                                                                                        38,
                                                                                                                                                                        39,
                                                                                                                                                                        40,
                                                                                                                                                                        41,
                                                                                                                                                                        42,
                                                                                                                                                                        43,
                                                                                                                                                                        44,
                                                                                                                                                                        45,
                                                                                                                                                                        46,
                                                                                                                                                                        47,
                                                                                                                                                                        48,
                                                                                                                                                                        49,
                                                                                                                                                                        50,
                                                                                                                                                                        51,
                                                                                                                                                                        52,
                                                                                                                                                                        53,
                                                                                                                                                                        54,
                                                                                                                                                                        55,
                                                                                                                                                                        56,
                                                                                                                                                                        57,
                                                                                                                                                                        58,
                                                                                                                                                                        59,
                                                                                                                                                                        60,
                                                                                                                                                                        61,
                                                                                                                                                                        62,
                                                                                                                                                                        63,
                                                                                                                                                                        64,
                                                                                                                                                                        65,
                                                                                                                                                                        66,
                                                                                                                                                                        67,
                                                                                                                                                                        68,
                                                                                                                                                                        69,
                                                                                                                                                                        70,
                                                                                                                                                                        71,
                                                                                                                                                                        72,
                                                                                                                                                                        73,
                                                                                                                                                                        74,
                                                                                                                                                                        75,
                                                                                                                                                                        76,
                                                                                                                                                                        77,
                                                                                                                                                                        78,
                                                                                                                                                                        79,
                                                                                                                                                                        80,
                                                                                                                                                                        81,
                                                                                                                                                                        82,
                                                                                                                                                                        83,
                                                                                                                                                                        84,
                                                                                                                                                                        85,
                                                                                                                                                                        86,
                                                                                                                                                                        87,
                                                                                                                                                                        88,
                                                                                                                                                                        89,
                                                                                                                                                                        90,
                                                                                                                                                                        91,
                                                                                                                                                                        92,
                                                                                                                                                                        93,
                                                                                                                                                                        94,
                                                                                                                                                                        95,
                                                                                                                                                                        96,
                                                                                                                                                                        97,
                                                                                                                                                                        98,
                                                                                                                                                                        99,
                                                                                                                                                                        100,
                                                                                                                                                                        101,
                                                                                                                                                                        102,
                                                                                                                                                                        103,
                                                                                                                                                                        104,
                                                                                                                                                                        105,
                                                                                                                                                                        106,
                                                                                                                                                                        107,
                                                                                                                                                                        108,
                                                                                                                                                                        109,
                                                                                                                                                                        110,
                                                                                                                                                                        111,
                                                                                                                                                                        112,
                                                                                                                                                                        113,
                                                                                                                                                                        114,
                                                                                                                                                                        115,
                                                                                                                                                                        116,
                                                                                                                                                                        117,
                                                                                                                                                                        118,
                                                                                                                                                                        119,
                                                                                                                                                                        120,
                                                                                                                                                                        121,
                                                                                                                                                                        122,
                                                                                                                                                                        123,
                                                                                                                                                                        124,
                                                                                                                                                                        125,
                                                                                                                                                                        126,
                                                                                                                                                                        127,
                                                                                                                                                                        128,
                                                                                                                                                                        129,
                                                                                                                                                                        130,
                                                                                                                                                                        131,
                                                                                                                                                                        132,
                                                                                                                                                                        133,
                                                                                                                                                                        134,
                                                                                                                                                                        135,
                                                                                                                                                                        136,
                                                                                                                                                                        137,
                                                                                                                                                                        138,
                                                                                                                                                                        139,
                                                                                                                                                                        140,
                                                                                                                                                                        141,
                                                                                                                                                                        142,
                                                                                                                                                                        143,
                                                                                                                                                                        144,
                                                                                                                                                                        145,
                                                                                                                                                                        146,
                                                                                                                                                                        147,
                                                                                                                                                                        148,
                                                                                                                                                                        149,
                                                                                                                                                                        150,
                                                                                                                                                                        151,
                                                                                                                                                                        152,
                                                                                                                                                                        153,
                                                                                                                                                                        154,
                                                                                                                                                                        155,
                                                                                                                                                                        156,
                                                                                                                                                                        157,
                                                                                                                                                                        158,
                                                                                                                                                                        159,
                                                                                                                                                                        160,
                                                                                                                                                                        161,
                                                                                                                                                                        162,
                                                                                                                                                                        163,
                                                                                                                                                                        164,
                                                                                                                                                                        165,
                                                                                                                                                                        166,
                                                                                                                                                                        167,
                                                                                                                                                                        168,
                                                                                                                                                                        169,
                                                                                                                                                                        170,
                                                                                                                                                                        171,
                                                                                                                                                                        172,
                                                                                                                                                                        173,
                                                                                                                                                                        174,
                                                                                                                                                                        175,
                                                                                                                                                                        176,
                                                                                                                                                                        177,
                                                                                                                                                                        178,
                                                                                                                                                                        179,
                                                                                                                                                                        180,
                                                                                                                                                                        181,
                                                                                                                                                                        182,
                                                                                                                                                                        183,
                                                                                                                                                                        184,
                                                                                                                                                                        185,
                                                                                                                                                                        186,
                                                                                                                                                                        187,
                                                                                                                                                                        188,
                                                                                                                                                                        189,
                                                                                                                                                                        190,
                                                                                                                                                                        191,
                                                                                                                                                                        192,
                                                                                                                                                                        193,
                                                                                                                                                                        194,
                                                                                                                                                                        195,
                                                                                                                                                                        196,
                                                                                                                                                                        197,
                                                                                                                                                                        198,
                                                                                                                                                                        199,
                                                                                                                                                                        200,
                                                                                                                                                                        201,
                                                                                                                                                                        202,
                                                                                                                                                                        203,
                                                                                                                                                                        204,
                                                                                                                                                                        205,
                                                                                                                                                                        206,
                                                                                                                                                                        207,
                                                                                                                                                                        208,
                                                                                                                                                                        209,
                                                                                                                                                                        210,
                                                                                                                                                                        211,
                                                                                                                                                                        212,
                                                                                                                                                                        213,
                                                                                                                                                                        214,
                                                                                                                                                                        215,
                                                                                                                                                                        216,
                                                                                                                                                                        217,
                                                                                                                                                                        218,
                                                                                                                                                                        219,
                                                                                                                                                                        220,
                                                                                                                                                                        221,
                                                                                                                                                                        222,
                                                                                                                                                                        223,
                                                                                                                                                                        224,
                                                                                                                                                                        225,
                                                                                                                                                                        226,
                                                                                                                                                                        227,
                                                                                                                                                                        228,
                                                                                                                                                                        229,
                                                                                                                                                                        230,
                                                                                                                                                                        231,
                                                                                                                                                                        232,
                                                                                                                                                                        233,
                                                                                                                                                                        234,
                                                                                                                                                                        235,
                                                                                                                                                                        236,
                                                                                                                                                                        237,
                                                                                                                                                                        238,
                                                                                                                                                                        239,
                                                                                                                                                                        240,
                                                                                                                                                                        241,
                                                                                                                                                                        242,
                                                                                                                                                                        243,
                                                                                                                                                                        244,
                                                                                                                                                                        245,
                                                                                                                                                                        246,
                                                                                                                                                                        247,
                                                                                                                                                                        248,
                                                                                                                                                                        249,
                                                                                                                                                                        250,
                                                                                                                                                                        251,
                                                                                                                                                                        252,
                                                                                                                                                                        253,
                                                                                                                                                                        254,
                                                                                                                                                                        255,
                                                                                                                                                                        256,
                                                                                                                                                                        257,
                                                                                                                                                                        258,
                                                                                                                                                                        259,
                                                                                                                                                                        260,
                                                                                                                                                                        261,
                                                                                                                                                                        262,
                                                                                                                                                                        263,
                                                                                                                                                                        264,
                                                                                                                                                                        265,
                                                                                                                                                                        266,
                                                                                                                                                                        267,
                                                                                                                                                                        268,
                                                                                                                                                                        269,
                                                                                                                                                                        270,
                                                                                                                                                                        271,
                                                                                                                                                                        272,
                                                                                                                                                                        273,
                                                                                                                                                                        274,
                                                                                                                                                                        275,
                                                                                                                                                                        276,
                                                                                                                                                                        277,
                                                                                                                                                                        278,
                                                                                                                                                                        279,
                                                                                                                                                                        280,
                                                                                                                                                                        281,
                                                                                                                                                                        282,
                                                                                                                                                                        283,
                                                                                                                                                                        284,
                                                                                                                                                                        285,
                                                                                                                                                                        286,
                                                                                                                                                                        287,
                                                                                                                                                                        288,
                                                                                                                                                                        289,
                                                                                                                                                                        290,
                                                                                                                                                                        291,
                                                                                                                                                                        292,
                                                                                                                                                                        293,
                                                                                                                                                                        294,
                                                                                                                                                                        295,
                                                                                                                                                                        296,
                                                                                                                                                                        297,
                                                                                                                                                                        298,
                                                                                                                                                                        299,
                                                                                                                                                                        300,
                                                                                                                                                                        301,
                                                                                                                                                                        302,
                                                                                                                                                                        303,
                                                                                                                                                                        304,
                                                                                                                                                                        305,
                                                                                                                                                                        306,
                                                                                                                                                                        307,
                                                                                                                                                                        308,
                                                                                                                                                                        309,
                                                                                                                                                                        310,
                                                                                                                                                                        311,
                                                                                                                                                                        312,
                                                                                                                                                                        313,
                                                                                                                                                                        314,
                                                                                                                                                                        315,
                                                                                                                                                                        316,
                                                                                                                                                                        317,
                                                                                                                                                                        318,
                                                                                                                                                                        319,
                                                                                                                                                                        320,
                                                                                                                                                                        321,
                                                                                                                                                                        322,
                                                                                                                                                                        323,
                                                                                                                                                                        324,
                                                                                                                                                                        325,
                                                                                                                                                                        326,
                                                                                                                                                                        327,
                                                                                                                                                                        328,
                                                                                                                                                                        329,
                                                                                                                                                                        330,
                                                                                                                                                                        331,
                                                                                                                                                                        332,
                                                                                                                                                                        333,
                                                                                                                                                                        334,
                                                                                                                                                                        335,
                                                                                                                                                                        336,
                                                                                                                                                                        337,
                                                                                                                                                                        338,
                                                                                                                                                                        339,
                                                                                                                                                                        340,
                                                                                                                                                                        341,
                                                                                                                                                                        342,
                                                                                                                                                                        343,
                                                                                                                                                                        344,
                                                                                                                                                                        345,
                                                                                                                                                                        346,
                                                                                                                                                                        347,
                                                                                                                                                                        348,
                                                                                                                                                                        349,
                                                                                                                                                                        350,
                                                                                                                                                                        351,
                                                                                                                                                                        352,
                                                                                                                                                                        353,
                                                                                                                                                                        354,
                                                                                                                                                                        355,
                                                                                                                                                                        356,
                                                                                                                                                                        357,
                                                                                                                                                                        358,
                                                                                                                                                                        359,
                                                                                                                                                                        360,
                                                                                                                                                                        361,
                                                                                                                                                                        362,
                                                                                                                                                                        363,
                                                                                                                                                                        364,
                                                                                                                                                                        365,
                                                                                                                                                                        366,
                                                                                                                                                                        367,
                                                                                                                                                                        368,
                                                                                                                                                                        369,
                                                                                                                                                                        370,
                                                                                                                                                                        371,
                                                                                                                                                                        372,
                                                                                                                                                                        373,
                                                                                                                                                                        374,
                                                                                                                                                                        375,
                                                                                                                                                                        376,
                                                                                                                                                                        377,
                                                                                                                                                                        378,
                                                                                                                                                                        379,
                                                                                                                                                                        380,
                                                                                                                                                                        381,
                                                                                                                                                                        382,
                                                                                                                                                                        383,
                                                                                                                                                                        384,
                                                                                                                                                                        385,
                                                                                                                                                                        386,
                                                                                                                                                                        387,
                                                                                                                                                                        388,
                                                                                                                                                                        389,
                                                                                                                                                                        390,
                                                                                                                                                                        391,
                                                                                                                                                                        392,
                                                                                                                                                                        393,
                                                                                                                                                                        394,
                                                                                                                                                                        395,
                                                                                                                                                                        396,
                                                                                                                                                                        397,
                                                                                                                                                                        398,
                                                                                                                                                                        399,
                                                                                                                                                                        400,
                                                                                                                                                                        401,
                                                                                                                                                                        402,
                                                                                                                                                                        403,
                                                                                                                                                                        404,
                                                                                                                                                                        405,
                                                                                                                                                                        406,
                                                                                                                                                                        407,
                                                                                                                                                                        408,
                                                                                                                                                                        409,
                                                                                                                                                                        410,
                                                                                                                                                                        411,
                                                                                                                                                                        412,
                                                                                                                                                                        413,
                                                                                                                                                                        414,
                                                                                                                                                                        415,
                                                                                                                                                                        416,
                                                                                                                                                                        417,
                                                                                                                                                                        418,
                                                                                                                                                                        419,
                                                                                                                                                                        420,
                                                                                                                                                                        421,
                                                                                                                                                                        422,
                                                                                                                                                                        423,
                                                                                                                                                                        424,
                                                                                                                                                                        425,
                                                                                                                                                                        426,
                                                                                                                                                                        427,
                                                                                                                                                                        428,
                                                                                                                                                                        429,
                                                                                                                                                                        430,
                                                                                                                                                                        431,
                                                                                                                                                                        432,
                                                                                                                                                                        433,
                                                                                                                                                                        434,
                                                                                                                                                                        435,
                                                                                                                                                                        436,
                                                                                                                                                                        437,
                                                                                                                                                                        438,
                                                                                                                                                                        439,
                                                                                                                                                                        440,
                                                                                                                                                                        441,
                                                                                                                                                                        442,
                                                                                                                                                                        443,
                                                                                                                                                                        444,
                                                                                                                                                                        445,
                                                                                                                                                                        446,
                                                                                                                                                                        447,
                                                                                                                                                                        448,
                                                                                                                                                                        449,
                                                                                                                                                                        450,
                                                                                                                                                                        451,
                                                                                                                                                                        452,
                                                                                                                                                                        453,
                                                                                                                                                                        454,
                                                                                                                                                                        455,
                                                                                                                                                                        456,
                                                                                                                                                                        457,
                                                                                                                                                                        458,
                                                                                                                                                                        459,
                                                                                                                                                                        460,
                                                                                                                                                                        461,
                                                                                                                                                                        462,
                                                                                                                                                                        463,
                                                                                                                                                                        464,
                                                                                                                                                                        465,
                                                                                                                                                                        466,
                                                                                                                                                                        467,
                                                                                                                                                                        468,
                                                                                                                                                                        469,
                                                                                                                                                                        470,
                                                                                                                                                                        471,
                                                                                                                                                                        472,
                                                                                                                                                                        473,
                                                                                                                                                                        474,
                                                                                                                                                                        475,
                                                                                                                                                                        476,
                                                                                                                                                                        477,
                                                                                                                                                                        478,
                                                                                                                                                                        479,
                                                                                                                                                                        480,
                                                                                                                                                                        481,
                                                                                                                                                                        482,
                                                                                                                                                                        483,
                                                                                                                                                                        484,
                                                                                                                                                                        485,
                                                                                                                                                                        486,
                                                                                                                                                                        487,
                                                                                                                                                                        488,
                                                                                                                                                                        489
                                                                                                                                                                    ]
                                                                                                                                                                }
                                                                                                                                                            ]
                                                                                                                                                        }, {
                                                                                                                                                            "type": "material",
                                                                                                                                                            "baseColor": {
                                                                                                                                                                "r": 0,
                                                                                                                                                                "g": 0,
                                                                                                                                                                "b": 0
                                                                                                                                                            },
                                                                                                                                                            "specularColor": {
                                                                                                                                                                "r": 0.33,
                                                                                                                                                                "g": 0.33,
                                                                                                                                                                "b": 0.33,
                                                                                                                                                                "a": 1
                                                                                                                                                            },
                                                                                                                                                            "shine": 10,
                                                                                                                                                            "specular": 1,
                                                                                                                                                            "nodes": [{
                                                                                                                                                                    "type": "geometry",
                                                                                                                                                                    "positions": [-3.8181,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        12.857689, -2.73,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        10.357689, -5.016894,
                                                                                                                                                                        85.75071,
                                                                                                                                                                        12.857689, -3.8181,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        12.857689, -5.016894,
                                                                                                                                                                        67.539218,
                                                                                                                                                                        12.857689, -2.73,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        10.357689, -92.601962,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        14.529833, -84.1614,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        14.529833, -93.835758,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        12.185546, -82.927603,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        12.185546, -93.835758,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        12.185546, -84.1614,
                                                                                                                                                                        211.946812,
                                                                                                                                                                        14.529833, -29.612633,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        112.914964,
                                                                                                                                                                        10.357689, -29.894254,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -39,
                                                                                                                                                                        111.826864,
                                                                                                                                                                        12.857689, -29.894254,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -39,
                                                                                                                                                                        112.914964,
                                                                                                                                                                        10.357689, -29.894254,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -21.40905,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -29.612633,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -20.865,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -29.612633,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -21.40905,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -13.353237,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -20.865,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -14.12264,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -21.40905,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -14.12264,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -20.865,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -8.531581,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -7.589259,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -14.12264,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -7.589259,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -8.531581,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -3.96587,
                                                                                                                                                                        86.032331,
                                                                                                                                                                        10.357689, -5.016894,
                                                                                                                                                                        85.75071,
                                                                                                                                                                        12.857689, -3.96587,
                                                                                                                                                                        86.032331,
                                                                                                                                                                        10.357689, -8.531581,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -3.96587,
                                                                                                                                                                        86.032331,
                                                                                                                                                                        10.357689, -5.016894,
                                                                                                                                                                        85.75071,
                                                                                                                                                                        12.857689, -2.73,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        10.357689, -57.135,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -48.387367,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -56.59095,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -56.59095,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -48.387367,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -13.353237,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -14.12264,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -7.589259,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -61.078149,
                                                                                                                                                                        48.259907,
                                                                                                                                                                        10.357689, -57.135,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -60.075228,
                                                                                                                                                                        48.850125,
                                                                                                                                                                        12.857689, -56.59095,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -60.075228,
                                                                                                                                                                        48.850125,
                                                                                                                                                                        12.857689, -57.135,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -97.106617,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -74.656745,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -97.106617,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.891169, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -97.106617,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -74.656745,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -74.767533,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -96.995829,
                                                                                                                                                                        2.5,
                                                                                                                                                                        14.57421, -74.656745,
                                                                                                                                                                        2.5,
                                                                                                                                                                        13.732689, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        15.358382, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.031766, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.014854, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.014854, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        17.014854, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.873287, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        16.548472, -75.092348,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -96.671014,
                                                                                                                                                                        2.5,
                                                                                                                                                                        12.106996, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -96.154308,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -75.609054,
                                                                                                                                                                        2.5,
                                                                                                                                                                        11.433612, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.450525, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -76.282438,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -95.480924,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.916907, -77.06661,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -93.621443,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.450525, -78.141919,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.450525, -94.696752,
                                                                                                                                                                        2.5,
                                                                                                                                                                        10.592092, -48.387367,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        40.374964,
                                                                                                                                                                        10.357689, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -39,
                                                                                                                                                                        41.463064,
                                                                                                                                                                        12.857689, -48.105746,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -39,
                                                                                                                                                                        40.374964,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        40.374964,
                                                                                                                                                                        10.357689, -29.612633,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        41.463064,
                                                                                                                                                                        12.857689, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -39,
                                                                                                                                                                        41.463064,
                                                                                                                                                                        12.857689, -29.612633,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -29.612633,
                                                                                                                                                                        41.610834,
                                                                                                                                                                        10.357689, -20.865,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -21.40905,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -29.894254,
                                                                                                                                                                        42.661858,
                                                                                                                                                                        12.857689, -20.865,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -20.865,
                                                                                                                                                                        45.234223,
                                                                                                                                                                        10.357689, -13.353237,
                                                                                                                                                                        50.998201,
                                                                                                                                                                        10.357689, -21.40905,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -14.12264,
                                                                                                                                                                        51.767604,
                                                                                                                                                                        12.857689, -21.40905,
                                                                                                                                                                        46.176545,
                                                                                                                                                                        12.857689, -13.353237,
                                                                                                                                                                        50.998201,
                                                                                                                                                                        10.357689, -13.353237,
                                                                                                                                                                        50.998201,
                                                                                                                                                                        10.357689, -7.589259,
                                                                                                                                                                        58.509964,
                                                                                                                                                                        10.357689, -14.12264,
                                                                                                                                                                        51.767604,
                                                                                                                                                                        12.857689, -8.531581,
                                                                                                                                                                        59.054014,
                                                                                                                                                                        12.857689, -14.12264,
                                                                                                                                                                        51.767604,
                                                                                                                                                                        12.857689, -7.589259,
                                                                                                                                                                        58.509964,
                                                                                                                                                                        10.357689, -7.589259,
                                                                                                                                                                        58.509964,
                                                                                                                                                                        10.357689, -3.96587,
                                                                                                                                                                        67.257597,
                                                                                                                                                                        10.357689, -8.531581,
                                                                                                                                                                        59.054014,
                                                                                                                                                                        12.857689, -5.016894,
                                                                                                                                                                        67.539218,
                                                                                                                                                                        12.857689, -8.531581,
                                                                                                                                                                        59.054014,
                                                                                                                                                                        12.857689, -3.96587,
                                                                                                                                                                        67.257597,
                                                                                                                                                                        10.357689, -3.96587,
                                                                                                                                                                        67.257597,
                                                                                                                                                                        10.357689, -2.73,
                                                                                                                                                                        76.644964,
                                                                                                                                                                        10.357689, -5.016894,
                                                                                                                                                                        67.539218,
                                                                                                                                                                        12.857689, -69.468419,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -63.87736,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -70.410741,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -64.646763,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -70.410741,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -63.87736,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -63.87736,
                                                                                                                                                                        101.522324,
                                                                                                                                                                        12.857689, -56.59095,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -64.646763,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -57.135,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -64.646763,
                                                                                                                                                                        102.291727,
                                                                                                                                                                        10.357689, -56.59095,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -56.59095,
                                                                                                                                                                        107.113383,
                                                                                                                                                                        12.857689, -48.105746,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -57.135,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -48.387367,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -57.135,
                                                                                                                                                                        108.055706,
                                                                                                                                                                        10.357689, -48.105746,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -48.105746,
                                                                                                                                                                        110.62807,
                                                                                                                                                                        12.857689, -39,
                                                                                                                                                                        111.826864,
                                                                                                                                                                        12.857689, -48.387367,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        112.914964,
                                                                                                                                                                        10.357689, -48.387367,
                                                                                                                                                                        111.679094,
                                                                                                                                                                        10.357689, -39,
                                                                                                                                                                        111.826864,
                                                                                                                                                                        12.857689, -70.410741,
                                                                                                                                                                        94.779964,
                                                                                                                                                                        10.357689, -72.954242,
                                                                                                                                                                        88.63941,
                                                                                                                                                                        10.357689, -69.468419,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -72.492396,
                                                                                                                                                                        86.935388,
                                                                                                                                                                        12.857689, -69.468419,
                                                                                                                                                                        94.235914,
                                                                                                                                                                        12.857689, -72.954242,
                                                                                                                                                                        88.63941,
                                                                                                                                                                        10.357689,
                                                                                                                                                                        null,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "normals": [
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673, -0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        0,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0,
                                                                                                                                                                        0.399079, -0.458458, -0.794073,
                                                                                                                                                                        0.399079, -0.237315, -0.885673,
                                                                                                                                                                        0.399079, -0.458458, -0.794073,
                                                                                                                                                                        0.399079, -0.237315, -0.885673,
                                                                                                                                                                        0.399079, -0.458458, -0.794073,
                                                                                                                                                                        0.399079, -0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079, -0.558942, -0.728428,
                                                                                                                                                                        0.396203, -0.458458, -0.794073,
                                                                                                                                                                        0.399079, -0.558942, -0.728428,
                                                                                                                                                                        0.396203, -0.458458, -0.794073,
                                                                                                                                                                        0.399079, -0.558942, -0.728428,
                                                                                                                                                                        0.396203, -0.458458, -0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0,
                                                                                                                                                                        0, -1,
                                                                                                                                                                        0, -0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0, -0.916917,
                                                                                                                                                                        0.399079, -0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0, -0.916917,
                                                                                                                                                                        0.399079, -0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0, -0.916917,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0, -0.916917,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0, -0.916917,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0, -0.916917,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458, -0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458, -0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.237315, -0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458, -0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458, -0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358, -0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458, -0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358, -0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.458458, -0.794073,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358, -0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358, -0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073, -0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358, -0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073, -0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.648358, -0.648358,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073, -0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073, -0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673, -0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073, -0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673, -0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.794073, -0.458458,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673, -0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673, -0.237315,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0.885673, -0.237315,
                                                                                                                                                                        0.399079, -0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079, -0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079, -0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079, -0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079, -0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079, -0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079, -0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079, -0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079, -0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079, -0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079, -0.648358,
                                                                                                                                                                        0.648358,
                                                                                                                                                                        0.399079, -0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079, -0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079, -0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079, -0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079, -0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079, -0.458458,
                                                                                                                                                                        0.794073,
                                                                                                                                                                        0.399079, -0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079, -0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0.399079, -0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0.399079, -0.237315,
                                                                                                                                                                        0.885673,
                                                                                                                                                                        0.399079,
                                                                                                                                                                        0,
                                                                                                                                                                        0.916917,
                                                                                                                                                                        0.399079, -0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079, -0.848272,
                                                                                                                                                                        0.351366,
                                                                                                                                                                        0.396203, -0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079, -0.848272,
                                                                                                                                                                        0.351366,
                                                                                                                                                                        0.396203, -0.794073,
                                                                                                                                                                        0.458458,
                                                                                                                                                                        0.399079, -0.848272,
                                                                                                                                                                        0.351366,
                                                                                                                                                                        0.396203,
                                                                                                                                                                        null,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "uv": [-76.487618,
                                                                                                                                                                        9.341576, -76.345592,
                                                                                                                                                                        6.618749, -85.671937,
                                                                                                                                                                        9.341576, -75.490894,
                                                                                                                                                                        17.268935, -66.306575,
                                                                                                                                                                        17.268935, -75.632919,
                                                                                                                                                                        14.546107, -92.601962,
                                                                                                                                                                        14.529833, -84.1614,
                                                                                                                                                                        14.529833, -93.835758,
                                                                                                                                                                        12.185546, -82.927603,
                                                                                                                                                                        12.185546, -93.835758,
                                                                                                                                                                        12.185546, -84.1614,
                                                                                                                                                                        14.529833, -43.93634, -32.827534, -53.40471, -32.827534, -44.078365, -30.104706, -53.262684, -30.104706, -44.078365, -30.104706, -53.40471, -32.827534, -69.954219, -24.156647, -60.7699, -24.156647, -70.096245, -26.879474, -60.627875, -26.879474, -70.096245, -26.879474, -60.7699, -24.156647, -72.865093, -19.422461, -82.333463, -19.422461, -73.007119, -16.699633, -82.191438, -16.699633, -73.007119, -16.699633, -82.333463, -19.422461, -79.956075, -8.241848, -79.814049, -10.964676, -89.140393, -8.241848, -90.469552, -2.082505, -90.327527,
                                                                                                                                                                        0.640323, -81.001183, -2.082505, -81.143208,
                                                                                                                                                                        0.640323, -81.001183, -2.082505, -90.327527,
                                                                                                                                                                        0.640323, -85.813962,
                                                                                                                                                                        6.618749, -85.671937,
                                                                                                                                                                        9.341576, -76.345592,
                                                                                                                                                                        6.618749,
                                                                                                                                                                        70.096245,
                                                                                                                                                                        17.404921,
                                                                                                                                                                        60.627875,
                                                                                                                                                                        17.404921,
                                                                                                                                                                        69.954219,
                                                                                                                                                                        20.127748,
                                                                                                                                                                        60.7699,
                                                                                                                                                                        20.127748,
                                                                                                                                                                        69.954219,
                                                                                                                                                                        20.127748,
                                                                                                                                                                        60.627875,
                                                                                                                                                                        17.404921, -89.282419, -10.964676, -89.140393, -8.241848, -79.814049, -10.964676,
                                                                                                                                                                        77.835323,
                                                                                                                                                                        9.947907,
                                                                                                                                                                        72.865093,
                                                                                                                                                                        9.947907,
                                                                                                                                                                        77.398955,
                                                                                                                                                                        12.670735,
                                                                                                                                                                        73.007119,
                                                                                                                                                                        12.670735,
                                                                                                                                                                        77.398955,
                                                                                                                                                                        12.670735,
                                                                                                                                                                        72.865093,
                                                                                                                                                                        9.947907,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        97.106617,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        74.656745,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        97.106617,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        12.891169,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        97.106617,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        74.656745,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        74.767533,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        96.995829,
                                                                                                                                                                        14.57421,
                                                                                                                                                                        74.656745,
                                                                                                                                                                        13.732689,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        15.358382,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        16.031766,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        17.014854,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        17.014854,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        17.014854,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        16.873287,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        16.548472,
                                                                                                                                                                        75.092348,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        96.671014,
                                                                                                                                                                        12.106996,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        96.154308,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        75.609054,
                                                                                                                                                                        11.433612,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        76.282438,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        95.480924,
                                                                                                                                                                        10.916907,
                                                                                                                                                                        77.06661,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        93.621443,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        78.141919,
                                                                                                                                                                        10.450525,
                                                                                                                                                                        94.696752,
                                                                                                                                                                        10.592092,
                                                                                                                                                                        53.40471,
                                                                                                                                                                        23.35298,
                                                                                                                                                                        43.93634,
                                                                                                                                                                        23.35298,
                                                                                                                                                                        53.262684,
                                                                                                                                                                        26.075808,
                                                                                                                                                                        44.078365,
                                                                                                                                                                        26.075808,
                                                                                                                                                                        53.262684,
                                                                                                                                                                        26.075808,
                                                                                                                                                                        43.93634,
                                                                                                                                                                        23.35298,
                                                                                                                                                                        33.396359,
                                                                                                                                                                        27.386735,
                                                                                                                                                                        23.927989,
                                                                                                                                                                        27.386735,
                                                                                                                                                                        33.254334,
                                                                                                                                                                        30.109562,
                                                                                                                                                                        24.070015,
                                                                                                                                                                        30.109562,
                                                                                                                                                                        33.254334,
                                                                                                                                                                        30.109562,
                                                                                                                                                                        23.927989,
                                                                                                                                                                        27.386735,
                                                                                                                                                                        11.434729,
                                                                                                                                                                        29.231291,
                                                                                                                                                                        1.966359,
                                                                                                                                                                        29.231291,
                                                                                                                                                                        11.292703,
                                                                                                                                                                        31.954119,
                                                                                                                                                                        2.108384,
                                                                                                                                                                        31.954119,
                                                                                                                                                                        11.292703,
                                                                                                                                                                        31.954119,
                                                                                                                                                                        1.966359,
                                                                                                                                                                        29.231291, -10.983533,
                                                                                                                                                                        28.760946, -20.451903,
                                                                                                                                                                        28.760946, -11.125558,
                                                                                                                                                                        31.483774, -20.309877,
                                                                                                                                                                        31.483774, -11.125558,
                                                                                                                                                                        31.483774, -20.451903,
                                                                                                                                                                        28.760946, -32.330658,
                                                                                                                                                                        26.007752, -41.799028,
                                                                                                                                                                        26.007752, -32.472683,
                                                                                                                                                                        28.73058, -41.657002,
                                                                                                                                                                        28.73058, -32.472683,
                                                                                                                                                                        28.73058, -41.799028,
                                                                                                                                                                        26.007752, -51.151875,
                                                                                                                                                                        21.159335, -60.620245,
                                                                                                                                                                        21.159335, -51.2939,
                                                                                                                                                                        23.882163, -60.478219,
                                                                                                                                                                        23.882163, -51.2939,
                                                                                                                                                                        23.882163, -60.620245,
                                                                                                                                                                        21.159335, -66.164549,
                                                                                                                                                                        14.546107, -75.632919,
                                                                                                                                                                        14.546107, -66.306575,
                                                                                                                                                                        17.268935,
                                                                                                                                                                        32.472683, -32.759478,
                                                                                                                                                                        41.657002, -32.759478,
                                                                                                                                                                        32.330658, -35.482306,
                                                                                                                                                                        41.799028, -35.482306,
                                                                                                                                                                        32.330658, -35.482306,
                                                                                                                                                                        41.657002, -32.759478,
                                                                                                                                                                        11.125558, -35.512672,
                                                                                                                                                                        20.309877, -35.512672,
                                                                                                                                                                        10.983533, -38.2355,
                                                                                                                                                                        20.451903, -38.2355,
                                                                                                                                                                        10.983533, -38.2355,
                                                                                                                                                                        20.309877, -35.512672, -11.292703, -35.983017, -2.108384, -35.983017, -11.434729, -38.705845, -1.966359, -38.705845, -11.434729, -38.705845, -2.108384, -35.983017, -33.254334, -34.138461, -24.070015, -34.138461, -33.396359, -36.861288, -23.927989, -36.861288, -33.396359, -36.861288, -24.070015, -34.138461,
                                                                                                                                                                        60.620245, -30.633889,
                                                                                                                                                                        53.973757, -30.633889,
                                                                                                                                                                        60.478219, -27.911062,
                                                                                                                                                                        52.576186, -27.911062,
                                                                                                                                                                        60.478219, -27.911062,
                                                                                                                                                                        53.973757, -30.633889,
                                                                                                                                                                        null,
                                                                                                                                                                        null
                                                                                                                                                                    ],
                                                                                                                                                                    "indices": [
                                                                                                                                                                        0,
                                                                                                                                                                        1,
                                                                                                                                                                        2,
                                                                                                                                                                        3,
                                                                                                                                                                        4,
                                                                                                                                                                        5,
                                                                                                                                                                        6,
                                                                                                                                                                        7,
                                                                                                                                                                        8,
                                                                                                                                                                        9,
                                                                                                                                                                        10,
                                                                                                                                                                        11,
                                                                                                                                                                        12,
                                                                                                                                                                        13,
                                                                                                                                                                        14,
                                                                                                                                                                        15,
                                                                                                                                                                        16,
                                                                                                                                                                        17,
                                                                                                                                                                        18,
                                                                                                                                                                        19,
                                                                                                                                                                        20,
                                                                                                                                                                        21,
                                                                                                                                                                        22,
                                                                                                                                                                        23,
                                                                                                                                                                        24,
                                                                                                                                                                        25,
                                                                                                                                                                        26,
                                                                                                                                                                        27,
                                                                                                                                                                        28,
                                                                                                                                                                        29,
                                                                                                                                                                        30,
                                                                                                                                                                        31,
                                                                                                                                                                        32,
                                                                                                                                                                        33,
                                                                                                                                                                        34,
                                                                                                                                                                        35,
                                                                                                                                                                        36,
                                                                                                                                                                        37,
                                                                                                                                                                        38,
                                                                                                                                                                        39,
                                                                                                                                                                        40,
                                                                                                                                                                        41,
                                                                                                                                                                        42,
                                                                                                                                                                        43,
                                                                                                                                                                        44,
                                                                                                                                                                        45,
                                                                                                                                                                        46,
                                                                                                                                                                        47,
                                                                                                                                                                        48,
                                                                                                                                                                        49,
                                                                                                                                                                        50,
                                                                                                                                                                        51,
                                                                                                                                                                        52,
                                                                                                                                                                        53,
                                                                                                                                                                        54,
                                                                                                                                                                        55,
                                                                                                                                                                        56,
                                                                                                                                                                        57,
                                                                                                                                                                        58,
                                                                                                                                                                        59,
                                                                                                                                                                        60,
                                                                                                                                                                        61,
                                                                                                                                                                        62,
                                                                                                                                                                        63,
                                                                                                                                                                        64,
                                                                                                                                                                        65,
                                                                                                                                                                        66,
                                                                                                                                                                        67,
                                                                                                                                                                        68,
                                                                                                                                                                        69,
                                                                                                                                                                        70,
                                                                                                                                                                        71,
                                                                                                                                                                        72,
                                                                                                                                                                        73,
                                                                                                                                                                        74,
                                                                                                                                                                        75,
                                                                                                                                                                        76,
                                                                                                                                                                        77,
                                                                                                                                                                        78,
                                                                                                                                                                        79,
                                                                                                                                                                        80,
                                                                                                                                                                        81,
                                                                                                                                                                        82,
                                                                                                                                                                        83,
                                                                                                                                                                        84,
                                                                                                                                                                        85,
                                                                                                                                                                        86,
                                                                                                                                                                        87,
                                                                                                                                                                        88,
                                                                                                                                                                        89,
                                                                                                                                                                        90,
                                                                                                                                                                        91,
                                                                                                                                                                        92,
                                                                                                                                                                        93,
                                                                                                                                                                        94,
                                                                                                                                                                        95,
                                                                                                                                                                        96,
                                                                                                                                                                        97,
                                                                                                                                                                        98,
                                                                                                                                                                        99,
                                                                                                                                                                        100,
                                                                                                                                                                        101,
                                                                                                                                                                        102,
                                                                                                                                                                        103,
                                                                                                                                                                        104,
                                                                                                                                                                        105,
                                                                                                                                                                        106,
                                                                                                                                                                        107,
                                                                                                                                                                        108,
                                                                                                                                                                        109,
                                                                                                                                                                        110,
                                                                                                                                                                        111,
                                                                                                                                                                        112,
                                                                                                                                                                        113,
                                                                                                                                                                        114,
                                                                                                                                                                        115,
                                                                                                                                                                        116,
                                                                                                                                                                        117,
                                                                                                                                                                        118,
                                                                                                                                                                        119,
                                                                                                                                                                        120,
                                                                                                                                                                        121,
                                                                                                                                                                        122,
                                                                                                                                                                        123,
                                                                                                                                                                        124,
                                                                                                                                                                        125,
                                                                                                                                                                        126,
                                                                                                                                                                        127,
                                                                                                                                                                        128,
                                                                                                                                                                        129,
                                                                                                                                                                        130,
                                                                                                                                                                        131,
                                                                                                                                                                        132,
                                                                                                                                                                        133,
                                                                                                                                                                        134,
                                                                                                                                                                        135,
                                                                                                                                                                        136,
                                                                                                                                                                        137,
                                                                                                                                                                        138,
                                                                                                                                                                        139,
                                                                                                                                                                        140,
                                                                                                                                                                        141,
                                                                                                                                                                        142,
                                                                                                                                                                        143,
                                                                                                                                                                        144,
                                                                                                                                                                        145,
                                                                                                                                                                        146,
                                                                                                                                                                        147,
                                                                                                                                                                        148,
                                                                                                                                                                        149,
                                                                                                                                                                        150,
                                                                                                                                                                        151,
                                                                                                                                                                        152,
                                                                                                                                                                        153,
                                                                                                                                                                        154,
                                                                                                                                                                        155,
                                                                                                                                                                        156,
                                                                                                                                                                        157,
                                                                                                                                                                        158,
                                                                                                                                                                        159,
                                                                                                                                                                        160,
                                                                                                                                                                        161,
                                                                                                                                                                        162,
                                                                                                                                                                        163,
                                                                                                                                                                        164,
                                                                                                                                                                        165,
                                                                                                                                                                        166,
                                                                                                                                                                        167,
                                                                                                                                                                        168,
                                                                                                                                                                        169,
                                                                                                                                                                        170,
                                                                                                                                                                        171,
                                                                                                                                                                        172,
                                                                                                                                                                        173,
                                                                                                                                                                        174,
                                                                                                                                                                        175,
                                                                                                                                                                        176,
                                                                                                                                                                        177,
                                                                                                                                                                        178,
                                                                                                                                                                        179,
                                                                                                                                                                        180,
                                                                                                                                                                        181,
                                                                                                                                                                        182,
                                                                                                                                                                        183,
                                                                                                                                                                        184,
                                                                                                                                                                        185,
                                                                                                                                                                        186,
                                                                                                                                                                        187,
                                                                                                                                                                        188,
                                                                                                                                                                        189,
                                                                                                                                                                        190,
                                                                                                                                                                        191,
                                                                                                                                                                        192,
                                                                                                                                                                        193,
                                                                                                                                                                        194,
                                                                                                                                                                        195,
                                                                                                                                                                        196,
                                                                                                                                                                        197,
                                                                                                                                                                        198
                                                                                                                                                                    ]
                                                                                                                                                                }
                                                                                                                                                            ]
                                                                                                                                                        }
                                                                                                                                                    ]
                                                                                                                                                }
                                                                                                                                            ]
                                                                                                                                        }
                                                                                                                                    ]
                                                                                                                                }
                                                                                                                            ]
                                                                                                                        }
                                                                                                                    ]
                                                                                                                }
                                                                                                            ]
                                                                                                        }
                                                                                                    ]
                                                                                                }
                                                                                            ]
                                                                                        }
                                                                                    ]
                                                                                }
                                                                            ]
                                                                        }
                                                                    ]
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                };

            }
})();